"Main interface for mediaconvert type defs"
from __future__ import annotations

from datetime import datetime
from typing import Dict, List
from typing_extensions import TypedDict


__all__ = (
    "ClientCreateJobAccelerationSettingsTypeDef",
    "ClientCreateJobResponseJobAccelerationSettingsTypeDef",
    "ClientCreateJobResponseJobMessagesTypeDef",
    "ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef",
    "ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsTypeDef",
    "ClientCreateJobResponseJobOutputGroupDetailsTypeDef",
    "ClientCreateJobResponseJobSettingsAvailBlankingTypeDef",
    "ClientCreateJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ClientCreateJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef",
    "ClientCreateJobResponseJobSettingsEsamTypeDef",
    "ClientCreateJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsAudioSelectorsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsCaptionSelectorsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsCropTypeDef",
    "ClientCreateJobResponseJobSettingsInputsDecryptionSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef",
    "ClientCreateJobResponseJobSettingsInputsImageInserterTypeDef",
    "ClientCreateJobResponseJobSettingsInputsInputClippingsTypeDef",
    "ClientCreateJobResponseJobSettingsInputsPositionTypeDef",
    "ClientCreateJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ClientCreateJobResponseJobSettingsInputsVideoSelectorTypeDef",
    "ClientCreateJobResponseJobSettingsInputsTypeDef",
    "ClientCreateJobResponseJobSettingsMotionImageInserterFramerateTypeDef",
    "ClientCreateJobResponseJobSettingsMotionImageInserterOffsetTypeDef",
    "ClientCreateJobResponseJobSettingsMotionImageInserterTypeDef",
    "ClientCreateJobResponseJobSettingsNielsenConfigurationTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsOutputsTypeDef",
    "ClientCreateJobResponseJobSettingsOutputGroupsTypeDef",
    "ClientCreateJobResponseJobSettingsTimecodeConfigTypeDef",
    "ClientCreateJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ClientCreateJobResponseJobSettingsTimedMetadataInsertionTypeDef",
    "ClientCreateJobResponseJobSettingsTypeDef",
    "ClientCreateJobResponseJobTimingTypeDef",
    "ClientCreateJobResponseJobTypeDef",
    "ClientCreateJobResponseTypeDef",
    "ClientCreateJobSettingsAvailBlankingTypeDef",
    "ClientCreateJobSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ClientCreateJobSettingsEsamSignalProcessingNotificationTypeDef",
    "ClientCreateJobSettingsEsamTypeDef",
    "ClientCreateJobSettingsInputsAudioSelectorGroupsTypeDef",
    "ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ClientCreateJobSettingsInputsAudioSelectorsTypeDef",
    "ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ClientCreateJobSettingsInputsCaptionSelectorsTypeDef",
    "ClientCreateJobSettingsInputsCropTypeDef",
    "ClientCreateJobSettingsInputsDecryptionSettingsTypeDef",
    "ClientCreateJobSettingsInputsImageInserterInsertableImagesTypeDef",
    "ClientCreateJobSettingsInputsImageInserterTypeDef",
    "ClientCreateJobSettingsInputsInputClippingsTypeDef",
    "ClientCreateJobSettingsInputsPositionTypeDef",
    "ClientCreateJobSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ClientCreateJobSettingsInputsVideoSelectorTypeDef",
    "ClientCreateJobSettingsInputsTypeDef",
    "ClientCreateJobSettingsMotionImageInserterFramerateTypeDef",
    "ClientCreateJobSettingsMotionImageInserterOffsetTypeDef",
    "ClientCreateJobSettingsMotionImageInserterTypeDef",
    "ClientCreateJobSettingsNielsenConfigurationTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ClientCreateJobSettingsOutputGroupsOutputsTypeDef",
    "ClientCreateJobSettingsOutputGroupsTypeDef",
    "ClientCreateJobSettingsTimecodeConfigTypeDef",
    "ClientCreateJobSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ClientCreateJobSettingsTimedMetadataInsertionTypeDef",
    "ClientCreateJobSettingsTypeDef",
    "ClientCreateJobTemplateAccelerationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsEsamTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsInputsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateSettingsTypeDef",
    "ClientCreateJobTemplateResponseJobTemplateTypeDef",
    "ClientCreateJobTemplateResponseTypeDef",
    "ClientCreateJobTemplateSettingsAvailBlankingTypeDef",
    "ClientCreateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ClientCreateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef",
    "ClientCreateJobTemplateSettingsEsamTypeDef",
    "ClientCreateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef",
    "ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ClientCreateJobTemplateSettingsInputsAudioSelectorsTypeDef",
    "ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ClientCreateJobTemplateSettingsInputsCaptionSelectorsTypeDef",
    "ClientCreateJobTemplateSettingsInputsCropTypeDef",
    "ClientCreateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef",
    "ClientCreateJobTemplateSettingsInputsImageInserterTypeDef",
    "ClientCreateJobTemplateSettingsInputsInputClippingsTypeDef",
    "ClientCreateJobTemplateSettingsInputsPositionTypeDef",
    "ClientCreateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ClientCreateJobTemplateSettingsInputsVideoSelectorTypeDef",
    "ClientCreateJobTemplateSettingsInputsTypeDef",
    "ClientCreateJobTemplateSettingsMotionImageInserterFramerateTypeDef",
    "ClientCreateJobTemplateSettingsMotionImageInserterOffsetTypeDef",
    "ClientCreateJobTemplateSettingsMotionImageInserterTypeDef",
    "ClientCreateJobTemplateSettingsNielsenConfigurationTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsOutputsTypeDef",
    "ClientCreateJobTemplateSettingsOutputGroupsTypeDef",
    "ClientCreateJobTemplateSettingsTimecodeConfigTypeDef",
    "ClientCreateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ClientCreateJobTemplateSettingsTimedMetadataInsertionTypeDef",
    "ClientCreateJobTemplateSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsAudioDescriptionsTypeDef",
    "ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsCaptionDescriptionsTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsContainerSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionCropTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientCreatePresetResponsePresetSettingsVideoDescriptionTypeDef",
    "ClientCreatePresetResponsePresetSettingsTypeDef",
    "ClientCreatePresetResponsePresetTypeDef",
    "ClientCreatePresetResponseTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsCodecSettingsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsRemixSettingsTypeDef",
    "ClientCreatePresetSettingsAudioDescriptionsTypeDef",
    "ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientCreatePresetSettingsCaptionDescriptionsTypeDef",
    "ClientCreatePresetSettingsContainerSettingsF4vSettingsTypeDef",
    "ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientCreatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientCreatePresetSettingsContainerSettingsM2tsSettingsTypeDef",
    "ClientCreatePresetSettingsContainerSettingsM3u8SettingsTypeDef",
    "ClientCreatePresetSettingsContainerSettingsMovSettingsTypeDef",
    "ClientCreatePresetSettingsContainerSettingsMp4SettingsTypeDef",
    "ClientCreatePresetSettingsContainerSettingsMpdSettingsTypeDef",
    "ClientCreatePresetSettingsContainerSettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionCodecSettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionCropTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionPositionTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientCreatePresetSettingsVideoDescriptionTypeDef",
    "ClientCreatePresetSettingsTypeDef",
    "ClientCreateQueueReservationPlanSettingsTypeDef",
    "ClientCreateQueueResponseQueueReservationPlanTypeDef",
    "ClientCreateQueueResponseQueueTypeDef",
    "ClientCreateQueueResponseTypeDef",
    "ClientDescribeEndpointsResponseEndpointsTypeDef",
    "ClientDescribeEndpointsResponseTypeDef",
    "ClientGetJobResponseJobAccelerationSettingsTypeDef",
    "ClientGetJobResponseJobMessagesTypeDef",
    "ClientGetJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef",
    "ClientGetJobResponseJobOutputGroupDetailsOutputDetailsTypeDef",
    "ClientGetJobResponseJobOutputGroupDetailsTypeDef",
    "ClientGetJobResponseJobSettingsAvailBlankingTypeDef",
    "ClientGetJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ClientGetJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef",
    "ClientGetJobResponseJobSettingsEsamTypeDef",
    "ClientGetJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef",
    "ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ClientGetJobResponseJobSettingsInputsAudioSelectorsTypeDef",
    "ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ClientGetJobResponseJobSettingsInputsCaptionSelectorsTypeDef",
    "ClientGetJobResponseJobSettingsInputsCropTypeDef",
    "ClientGetJobResponseJobSettingsInputsDecryptionSettingsTypeDef",
    "ClientGetJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef",
    "ClientGetJobResponseJobSettingsInputsImageInserterTypeDef",
    "ClientGetJobResponseJobSettingsInputsInputClippingsTypeDef",
    "ClientGetJobResponseJobSettingsInputsPositionTypeDef",
    "ClientGetJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ClientGetJobResponseJobSettingsInputsVideoSelectorTypeDef",
    "ClientGetJobResponseJobSettingsInputsTypeDef",
    "ClientGetJobResponseJobSettingsMotionImageInserterFramerateTypeDef",
    "ClientGetJobResponseJobSettingsMotionImageInserterOffsetTypeDef",
    "ClientGetJobResponseJobSettingsMotionImageInserterTypeDef",
    "ClientGetJobResponseJobSettingsNielsenConfigurationTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsOutputsTypeDef",
    "ClientGetJobResponseJobSettingsOutputGroupsTypeDef",
    "ClientGetJobResponseJobSettingsTimecodeConfigTypeDef",
    "ClientGetJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ClientGetJobResponseJobSettingsTimedMetadataInsertionTypeDef",
    "ClientGetJobResponseJobSettingsTypeDef",
    "ClientGetJobResponseJobTimingTypeDef",
    "ClientGetJobResponseJobTypeDef",
    "ClientGetJobResponseTypeDef",
    "ClientGetJobTemplateResponseJobTemplateAccelerationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsEsamTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsCropTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsInputsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef",
    "ClientGetJobTemplateResponseJobTemplateSettingsTypeDef",
    "ClientGetJobTemplateResponseJobTemplateTypeDef",
    "ClientGetJobTemplateResponseTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsAudioDescriptionsTypeDef",
    "ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsCaptionDescriptionsTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsContainerSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionCropTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionPositionTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientGetPresetResponsePresetSettingsVideoDescriptionTypeDef",
    "ClientGetPresetResponsePresetSettingsTypeDef",
    "ClientGetPresetResponsePresetTypeDef",
    "ClientGetPresetResponseTypeDef",
    "ClientGetQueueResponseQueueReservationPlanTypeDef",
    "ClientGetQueueResponseQueueTypeDef",
    "ClientGetQueueResponseTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesAccelerationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsAvailBlankingTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsEsamTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsCropTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsInputClippingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsPositionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsInputsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsNielsenConfigurationTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsTimecodeConfigTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesSettingsTypeDef",
    "ClientListJobTemplatesResponseJobTemplatesTypeDef",
    "ClientListJobTemplatesResponseTypeDef",
    "ClientListJobsResponseJobsAccelerationSettingsTypeDef",
    "ClientListJobsResponseJobsMessagesTypeDef",
    "ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef",
    "ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsTypeDef",
    "ClientListJobsResponseJobsOutputGroupDetailsTypeDef",
    "ClientListJobsResponseJobsSettingsAvailBlankingTypeDef",
    "ClientListJobsResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ClientListJobsResponseJobsSettingsEsamSignalProcessingNotificationTypeDef",
    "ClientListJobsResponseJobsSettingsEsamTypeDef",
    "ClientListJobsResponseJobsSettingsInputsAudioSelectorGroupsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsAudioSelectorsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsCaptionSelectorsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsCropTypeDef",
    "ClientListJobsResponseJobsSettingsInputsDecryptionSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef",
    "ClientListJobsResponseJobsSettingsInputsImageInserterTypeDef",
    "ClientListJobsResponseJobsSettingsInputsInputClippingsTypeDef",
    "ClientListJobsResponseJobsSettingsInputsPositionTypeDef",
    "ClientListJobsResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ClientListJobsResponseJobsSettingsInputsVideoSelectorTypeDef",
    "ClientListJobsResponseJobsSettingsInputsTypeDef",
    "ClientListJobsResponseJobsSettingsMotionImageInserterFramerateTypeDef",
    "ClientListJobsResponseJobsSettingsMotionImageInserterOffsetTypeDef",
    "ClientListJobsResponseJobsSettingsMotionImageInserterTypeDef",
    "ClientListJobsResponseJobsSettingsNielsenConfigurationTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsOutputsTypeDef",
    "ClientListJobsResponseJobsSettingsOutputGroupsTypeDef",
    "ClientListJobsResponseJobsSettingsTimecodeConfigTypeDef",
    "ClientListJobsResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ClientListJobsResponseJobsSettingsTimedMetadataInsertionTypeDef",
    "ClientListJobsResponseJobsSettingsTypeDef",
    "ClientListJobsResponseJobsTimingTypeDef",
    "ClientListJobsResponseJobsTypeDef",
    "ClientListJobsResponseTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsAudioDescriptionsTypeDef",
    "ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsCaptionDescriptionsTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsMovSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsContainerSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionCropTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionPositionTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientListPresetsResponsePresetsSettingsVideoDescriptionTypeDef",
    "ClientListPresetsResponsePresetsSettingsTypeDef",
    "ClientListPresetsResponsePresetsTypeDef",
    "ClientListPresetsResponseTypeDef",
    "ClientListQueuesResponseQueuesReservationPlanTypeDef",
    "ClientListQueuesResponseQueuesTypeDef",
    "ClientListQueuesResponseTypeDef",
    "ClientListTagsForResourceResponseResourceTagsTypeDef",
    "ClientListTagsForResourceResponseTypeDef",
    "ClientUpdateJobTemplateAccelerationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsEsamTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsInputsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateSettingsTypeDef",
    "ClientUpdateJobTemplateResponseJobTemplateTypeDef",
    "ClientUpdateJobTemplateResponseTypeDef",
    "ClientUpdateJobTemplateSettingsAvailBlankingTypeDef",
    "ClientUpdateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ClientUpdateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef",
    "ClientUpdateJobTemplateSettingsEsamTypeDef",
    "ClientUpdateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsAudioSelectorsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsCaptionSelectorsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsCropTypeDef",
    "ClientUpdateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef",
    "ClientUpdateJobTemplateSettingsInputsImageInserterTypeDef",
    "ClientUpdateJobTemplateSettingsInputsInputClippingsTypeDef",
    "ClientUpdateJobTemplateSettingsInputsPositionTypeDef",
    "ClientUpdateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ClientUpdateJobTemplateSettingsInputsVideoSelectorTypeDef",
    "ClientUpdateJobTemplateSettingsInputsTypeDef",
    "ClientUpdateJobTemplateSettingsMotionImageInserterFramerateTypeDef",
    "ClientUpdateJobTemplateSettingsMotionImageInserterOffsetTypeDef",
    "ClientUpdateJobTemplateSettingsMotionImageInserterTypeDef",
    "ClientUpdateJobTemplateSettingsNielsenConfigurationTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsOutputsTypeDef",
    "ClientUpdateJobTemplateSettingsOutputGroupsTypeDef",
    "ClientUpdateJobTemplateSettingsTimecodeConfigTypeDef",
    "ClientUpdateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ClientUpdateJobTemplateSettingsTimedMetadataInsertionTypeDef",
    "ClientUpdateJobTemplateSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsAudioDescriptionsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsContainerSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionCropTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientUpdatePresetResponsePresetSettingsVideoDescriptionTypeDef",
    "ClientUpdatePresetResponsePresetSettingsTypeDef",
    "ClientUpdatePresetResponsePresetTypeDef",
    "ClientUpdatePresetResponseTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsTypeDef",
    "ClientUpdatePresetSettingsAudioDescriptionsTypeDef",
    "ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    "ClientUpdatePresetSettingsCaptionDescriptionsTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsF4vSettingsTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsM2tsSettingsTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsM3u8SettingsTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsMovSettingsTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsMp4SettingsTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsMpdSettingsTypeDef",
    "ClientUpdatePresetSettingsContainerSettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionCodecSettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionCropTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionPositionTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    "ClientUpdatePresetSettingsVideoDescriptionTypeDef",
    "ClientUpdatePresetSettingsTypeDef",
    "ClientUpdateQueueReservationPlanSettingsTypeDef",
    "ClientUpdateQueueResponseQueueReservationPlanTypeDef",
    "ClientUpdateQueueResponseQueueTypeDef",
    "ClientUpdateQueueResponseTypeDef",
    "DescribeEndpointsPaginatePaginationConfigTypeDef",
    "DescribeEndpointsPaginateResponseEndpointsTypeDef",
    "DescribeEndpointsPaginateResponseTypeDef",
    "ListJobTemplatesPaginatePaginationConfigTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesAccelerationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsAvailBlankingTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCropTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsInputClippingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsPositionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsNielsenConfigurationTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsTimecodeConfigTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesSettingsTypeDef",
    "ListJobTemplatesPaginateResponseJobTemplatesTypeDef",
    "ListJobTemplatesPaginateResponseTypeDef",
    "ListJobsPaginatePaginationConfigTypeDef",
    "ListJobsPaginateResponseJobsAccelerationSettingsTypeDef",
    "ListJobsPaginateResponseJobsMessagesTypeDef",
    "ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef",
    "ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsTypeDef",
    "ListJobsPaginateResponseJobsOutputGroupDetailsTypeDef",
    "ListJobsPaginateResponseJobsSettingsAvailBlankingTypeDef",
    "ListJobsPaginateResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef",
    "ListJobsPaginateResponseJobsSettingsEsamSignalProcessingNotificationTypeDef",
    "ListJobsPaginateResponseJobsSettingsEsamTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsAudioSelectorGroupsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsCropTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsDecryptionSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsImageInserterTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsInputClippingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsPositionTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsVideoSelectorTypeDef",
    "ListJobsPaginateResponseJobsSettingsInputsTypeDef",
    "ListJobsPaginateResponseJobsSettingsMotionImageInserterFramerateTypeDef",
    "ListJobsPaginateResponseJobsSettingsMotionImageInserterOffsetTypeDef",
    "ListJobsPaginateResponseJobsSettingsMotionImageInserterTypeDef",
    "ListJobsPaginateResponseJobsSettingsNielsenConfigurationTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsTypeDef",
    "ListJobsPaginateResponseJobsSettingsOutputGroupsTypeDef",
    "ListJobsPaginateResponseJobsSettingsTimecodeConfigTypeDef",
    "ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    "ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionTypeDef",
    "ListJobsPaginateResponseJobsSettingsTypeDef",
    "ListJobsPaginateResponseJobsTimingTypeDef",
    "ListJobsPaginateResponseJobsTypeDef",
    "ListJobsPaginateResponseTypeDef",
    "ListPresetsPaginatePaginationConfigTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsMovSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsContainerSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCropTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionPositionTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsVideoDescriptionTypeDef",
    "ListPresetsPaginateResponsePresetsSettingsTypeDef",
    "ListPresetsPaginateResponsePresetsTypeDef",
    "ListPresetsPaginateResponseTypeDef",
    "ListQueuesPaginatePaginationConfigTypeDef",
    "ListQueuesPaginateResponseQueuesReservationPlanTypeDef",
    "ListQueuesPaginateResponseQueuesTypeDef",
    "ListQueuesPaginateResponseTypeDef",
)


_ClientCreateJobAccelerationSettingsTypeDef = TypedDict(
    "_ClientCreateJobAccelerationSettingsTypeDef", {"Mode": str}
)


class ClientCreateJobAccelerationSettingsTypeDef(_ClientCreateJobAccelerationSettingsTypeDef):
    """
    Type definition for `ClientCreateJob` `AccelerationSettings`

    - **Mode** *(string) --* **[REQUIRED]** Specify the conditions when the service will run your
    job with accelerated transcoding.
    """


_ClientCreateJobResponseJobAccelerationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobAccelerationSettingsTypeDef", {"Mode": str}, total=False
)


class ClientCreateJobResponseJobAccelerationSettingsTypeDef(
    _ClientCreateJobResponseJobAccelerationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJob` `AccelerationSettings`

    - **Mode** *(string) --* Specify the conditions when the service will run your job with
    accelerated transcoding.
    """


_ClientCreateJobResponseJobMessagesTypeDef = TypedDict(
    "_ClientCreateJobResponseJobMessagesTypeDef",
    {"Info": List[str], "Warning": List[str]},
    total=False,
)


class ClientCreateJobResponseJobMessagesTypeDef(_ClientCreateJobResponseJobMessagesTypeDef):
    """
    Type definition for `ClientCreateJobResponseJob` `Messages`

    - **Info** *(list) --* List of messages that are informational only and don't indicate a problem
    with your job.

      - *(string) --*

    - **Warning** *(list) --* List of messages that warn about conditions that might cause your job
    not to run or to fail.

      - *(string) --*
    """


_ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef",
    {"HeightInPx": int, "WidthInPx": int},
    total=False,
)


class ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef(
    _ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobOutputGroupDetailsOutputDetails` `VideoDetails`

    - **HeightInPx** *(integer) --* Height in pixels for the output

    - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsTypeDef",
    {
        "DurationInMs": int,
        "VideoDetails": ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsTypeDef(
    _ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobOutputGroupDetails` `OutputDetails`

    - **DurationInMs** *(integer) --* Duration in milliseconds

    - **VideoDetails** *(dict) --* Contains details about the output's video stream

      - **HeightInPx** *(integer) --* Height in pixels for the output

      - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ClientCreateJobResponseJobOutputGroupDetailsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobOutputGroupDetailsTypeDef",
    {"OutputDetails": List[ClientCreateJobResponseJobOutputGroupDetailsOutputDetailsTypeDef]},
    total=False,
)


class ClientCreateJobResponseJobOutputGroupDetailsTypeDef(
    _ClientCreateJobResponseJobOutputGroupDetailsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJob` `OutputGroupDetails`

    - **OutputDetails** *(list) --* Details about the output

      - *(dict) --* Details regarding output

        - **DurationInMs** *(integer) --* Duration in milliseconds

        - **VideoDetails** *(dict) --* Contains details about the output's video stream

          - **HeightInPx** *(integer) --* Height in pixels for the output

          - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ClientCreateJobResponseJobSettingsAvailBlankingTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsAvailBlankingTypeDef",
    {"AvailBlankingImage": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsAvailBlankingTypeDef(
    _ClientCreateJobResponseJobSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ClientCreateJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ClientCreateJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsEsam`
    `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ClientCreateJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef(
    _ClientCreateJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsEsam` `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientCreateJobResponseJobSettingsEsamTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ClientCreateJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ClientCreateJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsEsamTypeDef(_ClientCreateJobResponseJobSettingsEsamTypeDef):
    """
    Type definition for `ClientCreateJobResponseJobSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientCreateJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputs` `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsAudioSelectors` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientCreateJobResponseJobSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ClientCreateJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsAudioSelectorsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsCaptionSelectors` `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ClientCreateJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsCaptionSelectorsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputs` `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ClientCreateJobResponseJobSettingsInputsCropTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsCropTypeDef(
    _ClientCreateJobResponseJobSettingsInputsCropTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobResponseJobSettingsInputsDecryptionSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsDecryptionSettingsTypeDef",
    {
        "DecryptionMode": str,
        "EncryptedDecryptionKey": str,
        "InitializationVector": str,
        "KmsKeyRegion": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsDecryptionSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsDecryptionSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputs` `DecryptionSettings`

    - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt your
    input files.

    - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
    plaintext. Your job settings could be intercepted, making your encrypted content vulnerable.
    Specify the encrypted version of the data key that you used to encrypt your content. The data
    key must be encrypted by AWS Key Management Service (KMS). The key can be 128, 192, or 256 bits.

    - **InitializationVector** *(string) --* Specify the initialization vector that you used when
    you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
    initialization vector with any encryption mode. Or, you can use a 12-byte initialization vector
    with GCM or CTR. MediaConvert accepts only initialization vectors that are base64-encoded.

    - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service (KMS)
    that you used to encrypt your data key, if that Region is different from the one you are using
    for AWS Elemental MediaConvert.
    """


_ClientCreateJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef(
    _ClientCreateJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsImageInserter` `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobResponseJobSettingsInputsImageInserterTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientCreateJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsImageInserterTypeDef(
    _ClientCreateJobResponseJobSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobResponseJobSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsInputClippingsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ClientCreateJobResponseJobSettingsInputsPositionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsPositionTypeDef(
    _ClientCreateJobResponseJobSettingsInputsPositionTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ClientCreateJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputsVideoSelector` `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientCreateJobResponseJobSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ClientCreateJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsVideoSelectorTypeDef(
    _ClientCreateJobResponseJobSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientCreateJobResponseJobSettingsInputsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str, ClientCreateJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef
        ],
        "AudioSelectors": Dict[str, ClientCreateJobResponseJobSettingsInputsAudioSelectorsTypeDef],
        "CaptionSelectors": Dict[
            str, ClientCreateJobResponseJobSettingsInputsCaptionSelectorsTypeDef
        ],
        "Crop": ClientCreateJobResponseJobSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DecryptionSettings": ClientCreateJobResponseJobSettingsInputsDecryptionSettingsTypeDef,
        "DenoiseFilter": str,
        "FileInput": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ClientCreateJobResponseJobSettingsInputsImageInserterTypeDef,
        "InputClippings": List[ClientCreateJobResponseJobSettingsInputsInputClippingsTypeDef],
        "Position": ClientCreateJobResponseJobSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "SupplementalImps": List[str],
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ClientCreateJobResponseJobSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsInputsTypeDef(
    _ClientCreateJobResponseJobSettingsInputsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you encrypt
    before you upload them to Amazon S3. MediaConvert can decrypt files only when you use AWS Key
    Management Service (KMS) to encrypt the data key that you use to encrypt your content.

      - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt your
      input files.

      - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
      plaintext. Your job settings could be intercepted, making your encrypted content vulnerable.
      Specify the encrypted version of the data key that you used to encrypt your content. The data
      key must be encrypted by AWS Key Management Service (KMS). The key can be 128, 192, or 256
      bits.

      - **InitializationVector** *(string) --* Specify the initialization vector that you used when
      you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
      initialization vector with any encryption mode. Or, you can use a 12-byte initialization
      vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
      base64-encoded.

      - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service (KMS)
      that you used to encrypt your data key, if that Region is different from the one you are using
      for AWS Elemental MediaConvert.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FileInput** *(string) --* Specify the source file for your transcoding job. You can use
    multiple inputs in a single job. The service concatenates these inputs, in the order that you
    specify them in the job, to create the outputs. If your input format is IMF, specify your input
    by providing the path to your CPL. For example, "s3://bucket/vf/cpl.xml". If the CPL is in an
    incomplete IMP, make sure to use *Supplemental IMPs* (SupplementalImps) to specify any
    supplemental IMPs that contain assets referenced by the CPL.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You need
    supplemental IMPs if the CPL that you're using for your input is in an incomplete IMP. Specify
    either the supplemental IMP directories with a trailing slash or the ASSETMAP.xml files. For
    example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to specify the IMP
    that contains your input CPL, because the service automatically detects it.

      - *(string) --*

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientCreateJobResponseJobSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsMotionImageInserterFramerateTypeDef(
    _ClientCreateJobResponseJobSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsMotionImageInserter` `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ClientCreateJobResponseJobSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsMotionImageInserterOffsetTypeDef(
    _ClientCreateJobResponseJobSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsMotionImageInserter` `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ClientCreateJobResponseJobSettingsMotionImageInserterTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ClientCreateJobResponseJobSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ClientCreateJobResponseJobSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsMotionImageInserterTypeDef(
    _ClientCreateJobResponseJobSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ClientCreateJobResponseJobSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsNielsenConfigurationTypeDef(
    _ClientCreateJobResponseJobSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings` `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroups` `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputs` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputs`
    `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputs` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettings`
    `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputs` `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescription`
    `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescription`
    `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroupsOutputs` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ClientCreateJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ClientCreateJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ClientCreateJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsOutputsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreateJobResponseJobSettingsOutputGroupsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ClientCreateJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[ClientCreateJobResponseJobSettingsOutputGroupsOutputsTypeDef],
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsOutputGroupsTypeDef(
    _ClientCreateJobResponseJobSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ClientCreateJobResponseJobSettingsTimecodeConfigTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsTimecodeConfigTypeDef(
    _ClientCreateJobResponseJobSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ClientCreateJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ClientCreateJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ClientCreateJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettingsTimedMetadataInsertion` `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ClientCreateJobResponseJobSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ClientCreateJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsTimedMetadataInsertionTypeDef(
    _ClientCreateJobResponseJobSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ClientCreateJobResponseJobSettings` `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ClientCreateJobResponseJobSettingsTypeDef = TypedDict(
    "_ClientCreateJobResponseJobSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ClientCreateJobResponseJobSettingsAvailBlankingTypeDef,
        "Esam": ClientCreateJobResponseJobSettingsEsamTypeDef,
        "Inputs": List[ClientCreateJobResponseJobSettingsInputsTypeDef],
        "MotionImageInserter": ClientCreateJobResponseJobSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ClientCreateJobResponseJobSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ClientCreateJobResponseJobSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ClientCreateJobResponseJobSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ClientCreateJobResponseJobSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ClientCreateJobResponseJobSettingsTypeDef(_ClientCreateJobResponseJobSettingsTypeDef):
    """
    Type definition for `ClientCreateJobResponseJob` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode job.
    There can be multiple inputs add in a job. These inputs will be concantenated together to create
    the output.

      - *(dict) --* Specifies media input

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
        encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when you
        use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt your
        content.

          - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt
          your input files.

          - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
          plaintext. Your job settings could be intercepted, making your encrypted content
          vulnerable. Specify the encrypted version of the data key that you used to encrypt your
          content. The data key must be encrypted by AWS Key Management Service (KMS). The key can
          be 128, 192, or 256 bits.

          - **InitializationVector** *(string) --* Specify the initialization vector that you used
          when you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
          initialization vector with any encryption mode. Or, you can use a 12-byte initialization
          vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
          base64-encoded.

          - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
          (KMS) that you used to encrypt your data key, if that Region is different from the one you
          are using for AWS Elemental MediaConvert.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FileInput** *(string) --* Specify the source file for your transcoding job. You can use
        multiple inputs in a single job. The service concatenates these inputs, in the order that
        you specify them in the job, to create the outputs. If your input format is IMF, specify
        your input by providing the path to your CPL. For example, "s3://bucket/vf/cpl.xml". If the
        CPL is in an incomplete IMP, make sure to use *Supplemental IMPs* (SupplementalImps) to
        specify any supplemental IMPs that contain assets referenced by the CPL.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You
        need supplemental IMPs if the CPL that you're using for your input is in an incomplete IMP.
        Specify either the supplemental IMP directories with a trailing slash or the ASSETMAP.xml
        files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to
        specify the IMP that contains your input CPL, because the service automatically detects it.

          - *(string) --*

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ClientCreateJobResponseJobTimingTypeDef = TypedDict(
    "_ClientCreateJobResponseJobTimingTypeDef",
    {"FinishTime": datetime, "StartTime": datetime, "SubmitTime": datetime},
    total=False,
)


class ClientCreateJobResponseJobTimingTypeDef(_ClientCreateJobResponseJobTimingTypeDef):
    """
    Type definition for `ClientCreateJobResponseJob` `Timing`

    - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
    finished

    - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the job
    began.

    - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the job.
    """


_ClientCreateJobResponseJobTypeDef = TypedDict(
    "_ClientCreateJobResponseJobTypeDef",
    {
        "AccelerationSettings": ClientCreateJobResponseJobAccelerationSettingsTypeDef,
        "AccelerationStatus": str,
        "Arn": str,
        "BillingTagsSource": str,
        "CreatedAt": datetime,
        "CurrentPhase": str,
        "ErrorCode": int,
        "ErrorMessage": str,
        "Id": str,
        "JobPercentComplete": int,
        "JobTemplate": str,
        "Messages": ClientCreateJobResponseJobMessagesTypeDef,
        "OutputGroupDetails": List[ClientCreateJobResponseJobOutputGroupDetailsTypeDef],
        "Priority": int,
        "Queue": str,
        "RetryCount": int,
        "Role": str,
        "Settings": ClientCreateJobResponseJobSettingsTypeDef,
        "SimulateReservedQueue": str,
        "Status": str,
        "StatusUpdateInterval": str,
        "Timing": ClientCreateJobResponseJobTimingTypeDef,
        "UserMetadata": Dict[str, str],
    },
    total=False,
)


class ClientCreateJobResponseJobTypeDef(_ClientCreateJobResponseJobTypeDef):
    """
    Type definition for `ClientCreateJobResponse` `Job`

    - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
    with long, visually complex content.

      - **Mode** *(string) --* Specify the conditions when the service will run your job with
      accelerated transcoding.

    - **AccelerationStatus** *(string) --* Describes whether the current job is running with
    accelerated transcoding. For jobs that have Acceleration (AccelerationMode) set to DISABLED,
    AccelerationStatus is always NOT_APPLICABLE. For jobs that have Acceleration (AccelerationMode)
    set to ENABLED or PREFERRED, AccelerationStatus is one of the other states. AccelerationStatus
    is IN_PROGRESS initially, while the service determines whether the input files and job settings
    are compatible with accelerated transcoding. If they are, AcclerationStatus is ACCELERATED. If
    your input files and job settings aren't compatible with accelerated transcoding, the service
    either fails your job or runs it without accelerated transcoding, depending on how you set
    Acceleration (AccelerationMode). When the service runs your job without accelerated transcoding,
    AccelerationStatus is NOT_ACCELERATED.

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **BillingTagsSource** *(string) --* Optional. Choose a tag type that AWS Billing and Cost
    Management will use to sort your AWS Elemental MediaConvert costs on any billing report that you
    set up. Any transcoding outputs that don't have an associated tag will appear in your billing
    report unsorted. If you don't choose a valid value for this field, your job outputs will appear
    on the billing report unsorted.

    - **CreatedAt** *(datetime) --* The time, in Unix epoch format in seconds, when the job got
    created.

    - **CurrentPhase** *(string) --* A job's phase can be PROBING, TRANSCODING OR UPLOADING

    - **ErrorCode** *(integer) --* Error code for the job

    - **ErrorMessage** *(string) --* Error message of Job

    - **Id** *(string) --* A portion of the job's ARN, unique within your AWS Elemental MediaConvert
    resources

    - **JobPercentComplete** *(integer) --* An estimate of how far your job has progressed. This
    estimate is shown as a percentage of the total time from when your job leaves its queue to when
    your output files appear in your output Amazon S3 bucket. AWS Elemental MediaConvert provides
    jobPercentComplete in CloudWatch STATUS_UPDATE events and in the response to GetJob and ListJobs
    requests. The jobPercentComplete estimate is reliable for the following input containers:
    Quicktime, Transport Stream, MP4, and MXF. For some jobs, the service can't provide information
    about job progress. In those cases, jobPercentComplete returns a null value.

    - **JobTemplate** *(string) --* The job template that the job is created from, if it is created
    from a job template.

    - **Messages** *(dict) --* Provides messages from the service about jobs that you have already
    successfully submitted.

      - **Info** *(list) --* List of messages that are informational only and don't indicate a
      problem with your job.

        - *(string) --*

      - **Warning** *(list) --* List of messages that warn about conditions that might cause your
      job not to run or to fail.

        - *(string) --*

    - **OutputGroupDetails** *(list) --* List of output group details

      - *(dict) --* Contains details about the output groups specified in the job settings.

        - **OutputDetails** *(list) --* Details about the output

          - *(dict) --* Details regarding output

            - **DurationInMs** *(integer) --* Duration in milliseconds

            - **VideoDetails** *(dict) --* Contains details about the output's video stream

              - **HeightInPx** *(integer) --* Height in pixels for the output

              - **WidthInPx** *(integer) --* Width in pixels for the output

    - **Priority** *(integer) --* Relative priority on the job.

    - **Queue** *(string) --* Optional. When you create a job, you can specify a queue to send it
    to. If you don't specify, the job will go to the default queue. For more about queues, see the
    User Guide topic at http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

    - **RetryCount** *(integer) --* The number of times that the service automatically attempted to
    process your job after encountering an error.

    - **Role** *(string) --* The IAM role you use for creating this job. For details about
    permissions, see the User Guide topic at the User Guide at
    http://docs.aws.amazon.com/mediaconvert/latest/ug/iam-role.html

    - **Settings** *(dict) --* JobSettings contains all the transcode settings for a job.

      - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
      the input Ad Avail PTS time.

      - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
      overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

        - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
        black. Only bmp and png images are supported.

      - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

        - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
        ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
        uses the manifest conditioning instructions that you provide in the setting MCC XML
        (mccXml).

          - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
          document inside your JSON job settings. Form the XML document as per
          OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions
          in the message that you supply.

        - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
        between the SCTE 35 messages that the transcoder places and the splice points that they
        refer to. If the time between the start of the asset and the SCTE-35 message is less than
        this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

        - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
        SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
        signal processing instructions that you provide in the setting SCC XML (sccXml).

          - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
          inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
          transcoder will use the signal processing instructions in the message that you supply.
          Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
          For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
          insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
          (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
          passthrough. You can't do both.

      - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode job.
      There can be multiple inputs add in a job. These inputs will be concantenated together to
      create the output.

        - *(dict) --* Specifies media input

          - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
          combine. An input may have multiple audio selector groups. See "Audio Selector
          Group":#inputs-audio_selector_group for more information.

            - *(string) --*

              - *(dict) --* Group of Audio Selectors

                - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
                to include in the group. Audio selector names are standardized, based on their order
                within the input (e.g., "Audio Selector 1"). The audio selector name parameter can
                be repeated to add any number of audio selectors to the group.

                  - *(string) --*

          - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
          or set of tracks from the input that you will use in your outputs. You can use mutiple
          Audio selectors per input.

            - *(string) --*

              - *(dict) --* Selector for Audio

                - **CustomLanguageCode** *(string) --* Selects a specific language code from within
                an audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                set it as the default for the job. The service uses this default for outputs where
                it can't find the specified input audio. If you don't set a default, those outputs
                have no audio.

                - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                file source.

                - **LanguageCode** *(string) --* Selects a specific language code from within an
                audio source.

                - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                audio from the input video.

                - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
                selects PID 0x101).

                  - *(integer) --*

                - **ProgramSelection** *(integer) --* Use this setting for input streams that
                contain Dolby E, to have the service extract specific program data from the track.
                To select multiple programs, create multiple selectors with the same Track and
                different Program numbers. In the console, this setting is visible when you set
                Selector type to Track. Choose the program number from the dropdown list. If you are
                sending a JSON file, provide the program ID, which is part of the audio metadata. If
                your input file has incorrect metadata, you can choose All channels instead of a
                program number to have the service ignore the program IDs and include all the
                programs in the track.

                - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
                one input to match those of another input. This allows you to combine the two files
                into a single output, one after the other.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **SelectorType** *(string) --* Specifies the type of the audio selector.

                - **Tracks** *(list) --* Identify a track from the input audio to include in this
                selector by entering the track index number. To include several tracks in a single
                audio selector, specify multiple tracks as follows. Using the console, enter a
                comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                Specifying directly in your JSON job file, provide the track numbers in an array.
                For example, "tracks": [1,2,3].

                  - *(integer) --*

          - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
          the captions data from the input that you will use in your outputs. You can use mutiple
          captions selectors per input.

            - *(string) --*

              - *(dict) --* Set up captions in your outputs by first selecting them from your input
              here.

                - **CustomLanguageCode** *(string) --* The specific language to extract from source,
                using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
                complete this field and/or PID to select the caption language to extract. If input
                is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
                select the caption language to extract. If input is DVB-Sub that is being passed
                through, omit this field (and PID field); there is no way to extract a specific
                language with pass-through captions.

                - **LanguageCode** *(string) --* The specific language to extract from source. If
                input is SCTE-27, complete this field and/or PID to select the caption language to
                extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
                and/or PID to select the caption language to extract. If input is DVB-Sub that is
                being passed through, omit this field (and PID field); there is no way to extract a
                specific language with pass-through captions.

                - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                    number in the ancillary data track from which to extract captions. Unused for
                    passthrough.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                    PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content
                    is passed through, regardless of selectors.

                  - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                    within the video track from which to extract captions. Unused for passthrough.

                    - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                    for extracting captions. The system only supports one input video track, so this
                    should always be set to '1'.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                  STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source
                  file. If your caption source is IMSC in an IMF package, use TrackSourceSettings
                  instead of FileSoureSettings.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceFile** *(string) --* External caption file used for loading captions.
                    Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                    'smi'.

                    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                    captions from the source file.

                  - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                  your input captions. The service cannot auto-detect caption format.

                  - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                  sources, including Page number.

                    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                    three-digit hexadecimal page number that will be used for Teletext captions. Do
                    not use this setting if you are passing through teletext from the input source
                    to output.

                  - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                  are specified by track number. Currently, this is only IMSC captions in an IMF
                  package. If your caption source is IMSC 1.1 in a separate xml file, use
                  FileSourceSettings instead of TrackSourceSettings.

                    - **TrackNumber** *(integer) --* Use this setting to select a single captions
                    track from a source. Track numbers correspond to the order in the captions
                    source file. For IMF sources, track numbering is based on the order that the
                    captions appear in the CPL. For example, use 1 to select the captions asset that
                    is listed first in the CPL. To include more than one captions track in your job
                    outputs, create multiple input captions selectors. Specify one track per
                    selector.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame. If you specify a value here, it will
          override any value that you specify in the output setting Cropping selection (crop).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
          motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
          uncompressed video inputs.

          - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
          encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when you
          use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt your
          content.

            - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt
            your input files.

            - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
            plaintext. Your job settings could be intercepted, making your encrypted content
            vulnerable. Specify the encrypted version of the data key that you used to encrypt your
            content. The data key must be encrypted by AWS Key Management Service (KMS). The key can
            be 128, 192, or 256 bits.

            - **InitializationVector** *(string) --* Specify the initialization vector that you used
            when you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
            initialization vector with any encryption mode. Or, you can use a 12-byte initialization
            vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
            base64-encoded.

            - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
            (KMS) that you used to encrypt your data key, if that Region is different from the one
            you are using for AWS Elemental MediaConvert.

          - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
          the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
          video inputs.

          - **FileInput** *(string) --* Specify the source file for your transcoding job. You can
          use multiple inputs in a single job. The service concatenates these inputs, in the order
          that you specify them in the job, to create the outputs. If your input format is IMF,
          specify your input by providing the path to your CPL. For example,
          "s3://bucket/vf/cpl.xml". If the CPL is in an incomplete IMP, make sure to use
          *Supplemental IMPs* (SupplementalImps) to specify any supplemental IMPs that contain
          assets referenced by the CPL.

          - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
          transcoding service applies the denoise and deblock filters. You must also enable the
          filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
          Auto - The transcoding service determines whether to apply filtering, depending on input
          type and quality. * Disable - The input is not filtered. This is true even if you use the
          API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put
          is filtered regardless of input type.

          - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
          magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
          is 0.

          - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
          overlay on your video. Enable or disable this feature for each input individually. This
          setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
          that together specify a portion of the input to be used in the outputs. If you provide
          only a start time, the clip will be the entire input from that point to the end. If you
          provide only an end time, it will be the entire input up to that point. When you specify
          more than one input clip, the transcoding service creates the job outputs by stringing the
          clips together in the order you specify them.

            - *(dict) --* To transcode only portions of your input (clips), include one Input
            clipping (one instance of InputClipping in the JSON job file) for each input clip. All
            input clips you specify will be included in every output of the job.

              - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
              portion of the input you are clipping. The frame corresponding to the End timecode
              value is included in the clip. Start timecode or End timecode may be left blank, but
              not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
              minute, SS is the second, and FF is the frame number. When choosing this value, take
              into account your setting for timecode source under input settings
              (InputTimecodeSource). For example, if you have embedded timecodes that start at
              01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

              - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning
              of the portion of the input you are clipping. The frame corresponding to the Start
              timecode value is included in the clip. Start timecode or End timecode may be left
              blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour,
              MM is the minute, SS is the second, and FF is the frame number. When choosing this
              value, take into account your setting for Input timecode source. For example, if you
              have embedded timecodes that start at 01:00:00:00 and you want your clip to begin five
              minutes into the video, use 01:05:00:00.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black. If
          you specify a value here, it will override any value that you specify in the output
          setting Selection placement (position). If you specify a value here, this will override
          any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
          (RESPOND). If you specify a value here, this will ignore anything that you specify for the
          setting Scaling Behavior (scalingBehavior).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
          program from within a multi-program transport stream. Note that Quad 4K is not currently
          supported. Default is the first program within the transport stream. If the program you
          specify doesn't exist, the transcoding service will use this default.

          - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
          inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for
          audio and video. * Use PSI - Scan only PSI data.

          - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You
          need supplemental IMPs if the CPL that you're using for your input is in an incomplete
          IMP. Specify either the supplemental IMP directories with a trailing slash or the
          ASSETMAP.xml files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You
          don't need to specify the IMP that contains your input CPL, because the service
          automatically detects it.

            - *(string) --*

          - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
          input settings (InputTimecodeSource), to specify how the service counts input video
          frames. This input frame count affects only the behavior of features that apply to a
          single input at a time, such as input clipping and synchronizing some captions formats.
          Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at zero
          (ZEROBASED) to start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to
          start the first frame at the timecode that you specify in the setting Start timecode
          (timecodeStart). If you don't specify a value for Timecode source, the service will use
          Embedded by default. For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
          for this input's initial frame. To use this setting, you must set the Timecode source
          setting, located under the input settings (InputTimecodeSource), to Specified start
          (SPECIFIEDSTART). For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **VideoSelector** *(dict) --* Selector for video.

            - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
            animation. Specify which part of this input MediaConvert uses for your outputs. Leave
            this setting set to DISCARD in order to delete the alpha channel and preserve the video.
            Use REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the
            luma channel of your outputs.

            - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
            if you don't know about color space, leave this set to the default value Follow
            (FOLLOW). The service will automatically detect your input color space. If your input
            video has metadata indicating the wrong color space, specify the accurate color space
            here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume
            static metadata isn't present in your video stream, or if that metadata is present but
            not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the
            input HDR 10 metadata (Hdr10Metadata) settings. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
            file and the job input settings Color space (ColorSpace) and HDR master display
            information settings(Hdr10Metadata). The Color space usage setting determines which
            takes precedence. Choose Force (FORCE) to use color metadata from the input job
            settings. If you don't specify values for those settings, the service defaults to using
            metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata
            from the source when it is present. If there's no color metadata in your input file, the
            service defaults to using values you specify in the input settings.

            - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
            missing or inaccurate in your input video. Appropriate values vary depending on the
            input video and must be provided by a color grader. The color grader generates these
            values during the HDR 10 mastering process. The valid range for each of these settings
            is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
            settings - When you specify these values, you must also set Color space (ColorSpace) to
            HDR 10 (HDR10). To specify whether the the values you specify here take precedence over
            the values in the metadata of your input file, set Color space usage (ColorSpaceUsage).
            To specify whether color metadata is included in an output, set Color metadata
            (ColorMetadata). For more information about MediaConvert HDR jobs, see
            https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
            Specify this value as an integer; the system automatically converts it to the
            hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
            an identifier for a set of data in an MPEG-2 transport stream container.

            - **ProgramNumber** *(integer) --* Selects a specific program from within a
            multi-program transport stream. Note that Quad 4K is not currently supported.

            - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
            your video. You can choose automatic rotation or specify a rotation. You can specify a
            clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov
            or .mp4 and your input has rotation metadata, you can choose Automatic to have the
            service rotate your video according to the rotation specified in the metadata. The
            rotation must be within one degree of 90, 180, or 270 degrees. If the rotation metadata
            specifies any other rotation, the service will default to no rotation. By default, the
            service does no rotation, even if your input video has rotation metadata. The service
            doesn't pass through rotation metadata.

      - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
      graphics that you specify here appear on all outputs in all output groups.

        - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
        unspecified. If your motion graphic asset is a series of .png files, specify the frame rate
        of the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1.
        Make sure that the number of images in your series matches the frame rate and your intended
        overlay duration. For example, if you want a 30-second overlay at 30 fps, you should have
        900 .png images. This overlay frame rate doesn't need to match the frame rate of the
        underlying video.

          - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

          - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

        - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
        overlay on your video. For .png files, provide the file name of the first file in the
        series. Make sure that the names of the .png files end with sequential numbers that specify
        the order that they are played in. For example, overlay_000.png, overlay_001.png,
        overlay_002.png, and so on. The sequence must start at zero, and each image file name must
        have the same number of digits. Pad your initial file names with enough zeros to complete
        the sequence. For example, if the first image is overlay_0.png, there can be only 10 images
        in the sequence, with the last image being overlay_9.png. But if the first image is
        overlay_00.png, there can be 100 images in the sequence.

        - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
        providing for your overlay. You can choose either a .mov file or a series of .png files.

        - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay
        on the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
        specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
        the service inserts the overlay at its native resolution and scales the size up or down with
        any video scaling.

          - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
          edge of the video frame.

          - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
          edge of the video frame.

        - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
        or plays only once.

        - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
        (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
        account how you have set up your timecode configuration under both job settings and input
        settings. The simplest way to do that is to set both to start at 0. If you need to set up
        your job to follow timecodes embedded in your source that don't start at zero, make sure
        that you specify a start time that is after the first embedded timecode. For more
        information, see https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html
        Find job-wide and input timecode configuration settings in your JSON job settings
        specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

      - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
      do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
      configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs
      in the job. To enable Nielsen configuration programmatically, include an instance of
      nielsenConfiguration in your JSON job specification. Even if you don't include any children of
      nielsenConfiguration, you still enable the setting.

        - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
        functionality. If you must include this property, set the value to zero.

        - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
        distributor ID that is assigned to your organization by Neilsen.

      - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
      outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
      MXF, and no container) are grouped in a single output group as well. Required in
      (OutputGroups) is a group of settings that apply to the whole group. This required object
      depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
      settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
      HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
      MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

        - *(dict) --* Group of outputs

          - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
          the output group. This value is displayed on the console and can make your job settings
          JSON more human-readable. It does not affect your outputs. Use up to twelve characters
          that are either letters, numbers, spaces, or underscores.

          - **Name** *(string) --* Name of the output group

          - **OutputGroupSettings** *(dict) --* Output Group settings, including type

            - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
            Output Group may only contain a single video, audio, or caption output.

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
              your job. These default manifests reference every output in the output group. To
              create additional top-level manifests that reference a subset of the outputs in the
              output group, specify a list of them here. For each additional manifest that you
              specify, the service creates one HLS manifest and one DASH manifest.

                - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
                that you want the service to generate for this CMAF output group. Each pair of
                manifests can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
              at the top level BaseURL element. Can be used if streams are delivered from a
              different URL than the manifest file.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
                service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                (SAMPLE-AES) or AES_CTR (AES-CTR).

                - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                outputs, choose whether the service writes the 128-bit encryption initialization
                vector in the HLS and DASH manifests.

                - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                  signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                  package. The DASH manifest can currently signal up to three system IDs. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                  signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                  package. The HLS manifest can currently signal only one system ID. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
              of each individual CMAF segment. This value applies to the whole package; that is, to
              every output in the output group. Note that segments end on the first keyframe after
              this number of seconds, so the actual segment length might be slightly longer. If you
              set Segment control (CmafSegmentControl) to single file, the service puts the content
              of each output in a single file that has metadata that marks these segments. If you
              set it to segmented files, the service creates multiple files for each output, each
              with the content of one segment.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
              generated for this output.

              - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
              be generated for this output.

            - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
              manifest for each DASH ISO output group in your job. This default manifest references
              every output in the output group. To create additional DASH manifests that reference a
              subset of the outputs in the output group, specify a list of them here.

                - *(dict) --* Specify the details for each additional DASH manifest that you want
                the service to generate for this output group. Each manifest can reference a
                different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.mpd.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
              (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
              from a different URL than the manifest file.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                compatibility of your output with video players on obsolete devices. It applies only
                to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
                only to correct problems with playback on older devices. Otherwise, keep the default
                setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the
                service will exclude the access unit delimiter and will leave the SEI NAL units
                unencrypted.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
              that segments will end on the next keyframe after this number of seconds, so actual
              segment length may be longer. When Emit Single File is checked, the segmentation is
              internal to a single output file and it does not cause the creation of many output
              files as in other output types.

              - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
              the 400 range when you play back your DASH output, enable this setting and run your
              transcoding job again. When you enable this setting, the service writes precise
              segment durations in the DASH manifest. The segment duration information appears
              inside the SegmentTimeline element, inside SegmentTemplate at the Representation
              level. When you don't enable this setting, the service writes approximate segment
              durations in your DASH manifest.

            - **FileGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

            - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

              - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
              HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
              outputs themselves.

                - *(string) --*

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest for each HLS output group in your job. This default manifest
              references every output in the output group. To create additional top-level manifests
              that reference a subset of the outputs in the output group, specify a list of them
              here.

                - *(dict) --* Specify the details for each additional HLS manifest that you want the
                service to generate for this output group. Each manifest can reference a different
                subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
              in the media .m3u8 file. Can be used if base manifest is delivered from a different
              URL than the main .m3u8 file.

              - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                - *(dict) --* Caption Language Mapping

                  - **CaptionChannel** *(integer) --* Caption channel.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                  - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                  three-letter code listed at
                  https://www.loc.gov/standards/iso639-2/php/code_list.php.

                  - **LanguageDescription** *(string) --* Caption language description.

              - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
              captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one
              language in the CC1 Language Code field. One CLOSED-CAPTION line is added for each
              Language Code you specify. Make sure to specify the languages in the order in which
              they appear in the original source (if the source is embedded format) or the order of
              the caption selectors (if the source is other than embedded). Otherwise, languages in
              the manifest will not match up properly with the output captions. None: Include
              CLOSED-CAPTIONS=
                  NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from
              the manifest.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
              subdirectories.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
                scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
                disables encryption.

                - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                128-bit number used in conjunction with the key for encrypting blocks. If set to
                INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                Vector is not in the manifest.

                - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                HLS FairPlay content protection.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
              looking ahead and back within the specified range for a nearby avail and extending the
              segment size if needed.

              - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
              be generated for this HLS output group.

              - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
              in .m3u8 manifest files. The value is calculated as follows: either the program date
              and time are initialized using the input timecode source, or the time is initialized
              using the input timecode source and the date is initialized using the
              timestamp_offset.

              - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
              EXT-X-PROGRAM-DATE-TIME entry, in seconds.

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
              media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

              - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
              create (in seconds). Note that segments will end on the next keyframe after this
              number of seconds, so actual segment length may be longer.

              - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
              subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
              for this setting to have an effect.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

              - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

              - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
              offset to fine tune the timestamps.

            - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .ism
              Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
              in your job. This default manifest references every output in the output group. To
              create additional manifests that reference a subset of the outputs in the output
              group, specify a list of them here.

                - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                manifest that you want the service to generate for this output group. Each manifest
                can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                  "-no-premium" for this setting, then the file name the service generates for this
                  top-level manifest is film-name-no-premium.ismv.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
              audio encoding settings across a Microsoft Smooth output group into a single audio
              stream.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* If you are using DRM, set DRM System
              (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
              the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
              and frame rate.

              - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding)
              to specify the encoding format for the server and client manifest. Valid options are
              utf8 and utf16.

            - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
            Microsoft Smooth Streaming, CMAF)

          - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
          settings per output.

            - *(dict) --* An output object describes the settings for a single output file or stream
            in an output group.

              - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
              encoding settings organized by audio codec. Include one instance of
              (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
              encoding settings.

                - *(dict) --* Description of audio output

                  - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                  settings. Ignore these settings unless you need to comply with a loudness
                  standard.

                    - **Algorithm** *(string) --* Choose one of the following audio normalization
                    algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                    loudness for an entire piece of content, suitable for measurement of short-form
                    content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-2: Gated loudness. A measurement of gated average loudness compliant
                    with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
                    with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
                    Allows for more audio channels than the other algorithms, including
                    configurations such as 7.1.

                    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                    using the chosen algorithm. If disabled, the audio will be measured but not
                    adjusted.

                    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                    be corrected to the target level. Content measuring below this level will not be
                    corrected. Gating only applies when not using real_time_correction.

                    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                    loudness to a CSV file.

                    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                    TruePeak for each output's audio track loudness.

                    - **TargetLkfs** *(float) --* When you use Audio normalization
                    (AudioNormalizationSettings), optionally use this setting to specify a target
                    loudness. If you don't specify a value here, the encoder chooses a value for
                    you, based on the algorithm that you choose for Algorithm (algorithm). If you
                    choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                    encoder will choose -23 LKFS.

                  - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                  input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                  name based on its order within each input. For example if you specify "Audio
                  Selector 3", then the third audio selector will be used from each input. If an
                  input does not have an "Audio Selector 3", then the audio selector marked as
                  "default" in that input will be used. If there is no audio selector marked as
                  "default", silence will be inserted for the duration of that input. Alternatively,
                  an "Audio Selector Group":#inputs-audio_selector_group name may be specified, with
                  similar default/silence behavior. If no audio_source_name is specified, then
                  "Audio Selector 1" will be chosen automatically.

                  - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                  unchecked (false). A number between 0 and 255. The following are defined in
                  ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                       Hearing Impaired, 3 =
                  Visually Impaired Commentary, 4-255 = Reserved.

                  - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                  contains an ISO 639 audio_type, then that value is passed through to the output.
                  If the input contains no ISO 639 audio_type, the value in Audio Type is included
                  in the output. Otherwise the value in Audio Type is included in the output. Note
                  that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                  is set to BROADCASTER_MIXED_AD.

                  - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                  (AudioDescriptions) contains the group of settings related to audio encoding. The
                  settings in this group vary depending on the value that you choose for Audio codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * AAC,
                  AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                  Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                    - **AacSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                    two mutually exclusive groups of AAC settings--VBR and CBR. To select one of
                    these modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or
                    "CBR". In VBR mode, you control the audio quality with the setting VBR quality
                    (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                    valid values depend on the rate control mode.

                      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                      when the input contains pre-mixed main audio + audio description (AD) as a
                      stereo pair. The value for AudioType will be set to 3, which signals to
                      downstream systems that this stream contains "broadcaster mixed AD". Note that
                      the input received by the encoder must contain pre-mixed audio; the encoder
                      does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                      ignores any values you provide in AudioType and FollowInputAudioType. Choose
                      NORMAL when the input does not contain pre-mixed audio + audio description
                      (AD). In this case, the encoder will use any values you provide for AudioType
                      and FollowInputAudioType.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      The set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000,
                      16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000,
                      112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000,
                      448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you set is
                      also constrained by the values that you choose for Profile (codecProfile),
                      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
                      values depend on Bitrate control mode and Profile.

                      - **CodecProfile** *(string) --* AAC Profile.

                      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                      channel layout. Valid values depend on rate control mode and profile. "1.0 -
                      Audio Description (Receiver Mix)" setting receives a stereo description plus
                      control track and emits a mono AAC encode of the description track, with
                      control data emitted in the PES header as per ETSI TS 101 154 Annex E.

                      - **RateControlMode** *(string) --* Rate Control Mode.

                      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                      use LATM/LOAS AAC in an output, you must choose "No container" for the output
                      container.

                      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                      control mode and profile.

                      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                      for raw or MPEG-2 Transport Stream containers.

                      - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                      rate_control_mode is VBR.

                    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AC3.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                      stream that the encoder emits. For more information about the AC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital, dialnorm will be passed through.

                      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                      adds dynamic range compression signaling to the output bitstream as defined in
                      the Dolby Digital specification.

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                    - **AiffSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AIFF.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **Codec** *(string) --* Type of Audio codec.

                    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid values: 384k, 448k, 640k, 768k

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                      (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                      adjust loudness based on dialogue analysis.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                      this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix
                      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                      value -60 mutes the channel.

                      - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                      your audio.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                      that must be speech before the encoder uses the measured speech loudness as
                      the overall program loudness.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing.

                      - **SurroundExMode** *(string) --* Specify whether your input audio has an
                      additional center rear surround channel matrix encoded into your left and
                      right surround channels.

                    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3.

                      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                      dB attenuation to the surround channels. Only used for 3/2 coding mode.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                      number of channels.

                      - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital Plus, dialnorm will be passed through.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                      LFE channel is enabled

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left only/Right only center (loRoCenterMixLevel).

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                      channel. This setting applies only if you keep the default value of 3/2 - L,
                      R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                      If you choose a different value for Coding mode, the service ignores Left
                      only/Right only surround (loRoSurroundMixLevel).

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total center (ltRtCenterMixLevel).

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                      surround). MediaConvert uses this value for downmixing. How the service uses
                      this value depends on the value that you choose for Stereo downmix
                      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
                      -60 mutes the channel. This setting applies only if you keep the default value
                      of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total surround (ltRtSurroundMixLevel).

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                      audio will be passed through if it is present on the input. this detection is
                      dynamic over the life of the transcode. Inputs that alternate between DD+ and
                      non-DD+ content will have a consistent DD+ output as the system alternates
                      between passthrough and encoding.

                      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                      the surround channels. Only used for 3/2 coding mode.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing. This setting only applies if you keep the default value of 3/2 -
                      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Stereo downmix (Eac3StereoDownmix).

                      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                      extra center back surround channel is matrix encoded into the left and right
                      surround channels.

                      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                      Surround is matrix encoded into the two channels.

                    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value MP2.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                      - **Channels** *(integer) --* Set Channels to specify the number of channels
                      in this output audio track. Choosing Mono in the console will give you 1
                      output channel; choosing Stereo will give you 2. In the API, valid values are
                      1 and 2.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **WavSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value WAV.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                      If your output audio is likely to exceed 4 GB in file size, or if you
                      otherwise need the extended support of the RF64 format, set your output WAV
                      file format to RF64.

                      - **SampleRate** *(integer) --* Sample rate in Hz.

                  - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                  track. The service puts this language code into your output audio track when you
                  set Language code control (AudioLanguageCodeControl) to Use configured
                  (USE_CONFIGURED). The service also uses your specified custom language code when
                  you set Language code control (AudioLanguageCodeControl) to Follow input
                  (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                  outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                  can also use any other code in the full RFC-5646 specification. Streaming outputs
                  are those that are in one of the following output groups: CMAF, DASH ISO, Apple
                  HLS, or Microsoft Smooth Streaming.

                  - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                  The ISO 639 language specified in the 'Language Code' drop down will be used when
                  'Follow Input Language Code' is not selected or when 'Follow Input Language Code'
                  is selected but there is no ISO 639 language code specified by the input.

                  - **LanguageCodeControl** *(string) --* Specify which source for language code
                  takes precedence for this audio track. When you choose Follow input
                  (FOLLOW_INPUT), the service uses the language code from the input track if it's
                  present. If there's no languge code on the input track, the service uses the code
                  that you specify in the setting Language code (languageCode or
                  customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service
                  uses the language code that you specify.

                  - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **StreamName** *(string) --* Specify a label for this output audio stream. For
                  example, "English", "Director commentary", or "track_2". For streaming outputs,
                  MediaConvert passes this information into destination manifests for display on the
                  end-viewer's player device. For outputs in other output groups, the service
                  ignores this setting.

              - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
              captions settings. For each output that has captions, include one instance of
              (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
              settings.

                - *(dict) --* Description of Caption output

                  - **CaptionSelectorName** *(string) --* Specifies which "Caption
                  Selector":#inputs-caption_selector to use from each input when generating
                  captions. The name should be of the format "Caption Selector ", which denotes that
                  the Nth Caption Selector will be used from each input.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  output track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information when automatically
                  selecting the font script for rendering the captions text. For all outputs, you
                  can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
                  any other code in the full RFC-5646 specification. Streaming outputs are those
                  that are in one of the following output groups: CMAF, DASH ISO, Apple HLS, or
                  Microsoft Smooth Streaming.

                  - **DestinationSettings** *(dict) --* Specific settings required by destination
                  type. Note that burnin_destination_settings are not available if the source of the
                  caption data is Embedded or Teletext.

                    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering burn-in captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **DestinationType** *(string) --* Specify the format for this set of captions
                    on this output. The default format is embedded without SCTE-20. Other options
                    are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                    web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                    (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec.
                    To create a non-compliant output where the embedded captions come first, choose
                    Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering DVB-Sub captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                      standard or for hearing impaired. Choose hearing impaired if your subtitles
                      include audio descriptions and dialogue. Choose standard if your subtitles
                      include only dialogue.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                    embedded/ancillary caption outputs, including 608/708 Channel destination
                    number.

                      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and your output captions are embedded in
                      the video stream. Specify a CC number for each captions channel in this
                      output. If you have two channels, choose CC numbers that aren't in the same
                      field. For example, choose 1 and 3. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and you want both 608 and 708 captions
                      embedded in your output stream. Optionally, specify the 708 service number for
                      each output captions channel. Choose a different number for each channel. To
                      use this setting, also set Force 608 to 708 upconvert (Convert608To708) to
                      Upconvert (UPCONVERT) in your input captions selector settings. If you choose
                      to upconvert but don't specify a 708 service number, MediaConvert uses the
                      number that you specify for CC channel number (destination608ChannelNumber)
                      for the 708 service number. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                    outputs.

                      - **StylePassthrough** *(string) --* Keep this setting enabled to have
                      MediaConvert use the font style and position information from the captions
                      source in the output. This option is available only when your input captions
                      are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                      output captions.

                    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                      sure that the captions and the video are synchronized in the output. Specify a
                      frame rate that matches the frame rate of the associated video. If the video
                      frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only
                      if the video has video_insertion=
                          true and drop_frame_timecode=true; otherwise,
                      choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                    output

                      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                      the destination captions for this output. This value must be a three-digit
                      hexadecimal string; strings ending in -FF are invalid. If you are passing
                      through the entire set of Teletext data, do not use this field.

                      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                      you don't specify a value here, the service sets the page type to the default
                      value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                      Teletext data, don't use this field. When you pass through a set of Teletext
                      pages, your output has the same page types as your input.

                        - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                        Table 94

                    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                    outputs, including Pass style information (TtmlStylePassthrough).

                      - **StylePassthrough** *(string) --* Pass through style and position
                      information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                      CFF-TT output or TTML output.

                  - **LanguageCode** *(string) --* Specify the language of this captions output
                  track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information to choose the font
                  language for rendering the captions text.

                  - **LanguageDescription** *(string) --* Specify a label for this set of output
                  captions. For example, "English", "Director commentary", or "track_2". For
                  streaming outputs, MediaConvert passes this information into destination manifests
                  for display on the end-viewer's player device. For outputs in other output groups,
                  the service ignores this setting.

              - **ContainerSettings** *(dict) --* Container specific settings.

                - **Container** *(string) --* Container for this output. Some containers require a
                container settings object. If not specified, the default object will be created.

                - **F4vSettings** *(dict) --* Settings for F4v container

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs
                in a File output group when the output's container (ContainerType) is MPEG-2
                Transport Stream (M2TS). In these assets, data is organized by the program map table
                (PMT). Each transport stream program contains subsets of data, including audio,
                video, and metadata. Each of these subsets of data has a numerical label called a
                packet identifier (PID). Each transport stream program corresponds to one
                MediaConvert output. The PMT lists the types of data in a program along with their
                PID. Downstream systems and players use the program map table to look up the PID for
                each type of data it accesses and then uses the PIDs to locate specific data within
                the asset.

                  - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                  models for Dolby Digital audio.

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                  elementary audio streams you include in this output. Specify multiple PIDs as a
                  JSON array. Default is the range 482-492.

                    - *(integer) --*

                  - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                  bits per second. Setting to 0 lets the muxer automatically determine the
                  appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                  - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                  interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                  this can lead to lower latency, but low-memory devices may not be able to play
                  back the stream without interruptions.

                  - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                  the specified table repetition interval.

                    - **NetworkId** *(integer) --* The numeric value placed in the Network
                    Information Table (NIT).

                    - **NetworkName** *(string) --* The network name text placed in the
                    network_name_descriptor inside the Network Information Table. Maximum length is
                    256 characters.

                    - **NitInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                  the specified table repetition interval.

                    - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                    output stream. "Follow input SDT" copies SDT information from input stream to
                    output stream. "Follow input SDT if present" copies SDT information from input
                    stream to output stream if SDT information is present in the input, otherwise it
                    will fall back on the user-defined values. Enter "SDT Manually" means user will
                    enter the SDT information. "No SDT" means output stream will not contain SDT
                    information.

                    - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **ServiceName** *(string) --* The service name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                    - **ServiceProviderName** *(string) --* The service provider name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                  - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                  subtitle data included in this output. Specify multiple PIDs as a JSON array.
                  Default is the range 460-479.

                    - *(integer) --*

                  - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                  specified table repetition interval.

                    - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                  teletext data you include in this output. Default is 499.

                  - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                  EBP markers will be added to partitions 3 and 4. The interval between these
                  additional markers will be fixed, and will be slightly shorter than the video EBP
                  marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                  inserted. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                  can either be placed only on the video PID, or on both the video PID and all audio
                  PIDs. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                  the PES header.

                  - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                  you know that your audio EBP markers are incorrectly appearing before your video
                  EBP markers. To correct this problem, set this value to Force (FORCE).

                  - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                  used with EBP markers.

                  - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                  between Program Clock References (PCRs) inserted into the transport stream.

                  - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                  Points do not come within the specified time interval of each other by looking
                  ahead at input video. If another EBP is going to come in within the specified time
                  interval, the current EBP is not emitted, and the segment is "stretched" to the
                  next marker. The lookahead value does not add latency to the system. The Live
                  Event must be configured elsewhere to create sufficient latency to make the
                  lookahead accurate.

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                  packets to insert into the transport stream. This can be used if a downstream
                  encryption system requires periodic null packets.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This is effective only when the PCR PID is the same as the video or audio
                  elementary stream.

                  - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                  clock reference (PCR) in this output. If you do not specify a value, the service
                  will use the value for Video PID (VideoPid).

                  - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                  instances of the program map table (PMT) in the output transport stream.

                  - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                  map table (PMT) itself. Default is 480.

                  - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                  private metadata stream. Default is 503.

                  - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                  the program number used in the program map table (PMT) for this output. Default is
                  1. Program numbers and program map tables are parts of MPEG-2 transport stream
                  containers, used for organizing data.

                  - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                  stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                  maximum bitrate, but the output will not be padded up to that bitrate.

                  - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                  markers in your HLS and transport stream outputs at the insertion points that you
                  specify in an ESAM XML document. Provide the document in the setting SCC XML
                  (sccXml).

                    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                    in the transport stream generated by ESAM.

                  - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                  stream in the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None
                  (NONE). Also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml). Also enable ESAM SCTE-35 (include the property
                  scte35Esam).

                  - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                  segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                  adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                  private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                  segments. ebp adds Encoder Boundary Point information to the adaptation field as
                  per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary
                  Point information to the adaptation field using a legacy proprietary format.

                  - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                  how segmentation markers are inserted into the transport stream. With avails, it
                  is possible that segments may be truncated, which can influence where future
                  segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                  selected and a segment is truncated due to an avail, we will reset the
                  segmentation cadence. This means the subsequent segment will have a duration of of
                  $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                  selected and a segment is truncated due to an avail, we will not reset the
                  segmentation cadence. This means the subsequent segment will likely be truncated
                  as well. However, all segments after that will have a duration of
                  $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
                  rule.

                  - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                  segment. Required unless markers is set to _none_.

                  - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                  timed metadata in this output. Default is 502.

                  - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                  itself in the program map table for this output. Transport stream IDs and program
                  map tables are parts of MPEG-2 transport stream containers, used for organizing
                  data.

                  - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                  elementary video stream in the transport stream.

                - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                  stream(s) in the transport stream. Multiple values are accepted, and can be
                  entered in ranges and/or by comma separation.

                    - *(integer) --*

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This parameter is effective only when the PCR PID is the same as the video or
                  audio elementary stream.

                  - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                  (PCR) in the transport stream. When no value is given, the encoder will assign the
                  same value as the Video PID.

                  - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                  (PMT) in the transport stream.

                  - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                  metadata stream in the transport stream.

                  - **ProgramNumber** *(integer) --* The value of the program number field in the
                  Program Map Table.

                  - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                  the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE)
                  if you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and
                  choose Ad markers (adMarkers) if you do want manifest conditioning. In both cases,
                  also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml).

                  - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                  specify whether the service inserts the ID3 timed metadata from the input in this
                  output.

                  - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                  metadata stream in the transport stream.

                  - **TransportStreamId** *(integer) --* The value of the transport stream ID field
                  in the Program Map Table.

                  - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                  stream in the transport stream.

                - **MovSettings** *(dict) --* Settings for MOV Container.

                  - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                  the video output settings.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                  streams into the QuickTime file using XDCAM fourcc codes. This increases
                  compatibility with Apple editors and players, but may decrease compatibility with
                  other players. Only applicable when the video codec is MPEG2.

                  - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                  padding

                  - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                  this setting.

                - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
                AAC outputs with this container.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                  moov box.

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                  - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                  file. Usually not necessary to specify.

                - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                  - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                  groups that include sidecar TTML or IMSC captions. You specify sidecar captions in
                  a separate output from your audio and video. Choose Raw (RAW) for captions in a
                  single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for
                  captions in XML format contained within fragmented MP4 files. This set of
                  fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                  - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                  markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                  insertion points that you specify in an ESAM XML document. Provide the document in
                  the setting SCC XML (sccXml).

                  - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                  markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                  SCTE-35 markers that appear in your input to also appear in this output. Choose
                  None (NONE) if you don't want those SCTE-35 markers in this output.

              - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
              for outputs in File output groups. If you do not specify a value, the service will use
              default extensions by container type as follows * MPEG-2 transport stream, m2ts *
              Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the
              service will use codec extensions (e.g. AAC, H265, H265, AC3)

              - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
              add a string to the end of each output filename. You specify the base filename as part
              of your destination URI. When you create multiple outputs in the same output group,
              Name modifier (NameModifier) is required. Name modifier also accepts format
              identifiers. For DASH ISO outputs, if you use the format identifiers $Number$ or
              $Time$ in one output, you must use them in the same way in all outputs of the output
              group.

              - **OutputSettings** *(dict) --* Specific settings for this type of output.

                - **HlsSettings** *(dict) --* Settings for HLS output groups

                  - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                  belongs.

                  - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                  outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                  container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                  file in a raw container. Regardless of the value that you specify here, if this
                  output has video, the service will place the output into an MPEG2-TS container.

                  - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                  with the video output stream. Input all the audio GROUP-IDs that are associated to
                  the video, separate by ','.

                  - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                  Audio-Only Variant Stream The client can play back this audio-only stream instead
                  of video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                  manifest. Alternate Audio, Auto Select, Default Alternate rendition that the
                  client should try to play back by default. Represented as an EXT-X-MEDIA in the
                  HLS manifest with DEFAULT=YES, AUTOSELECT=
                      YES Alternate Audio, Auto Select, Not
                  Default Alternate rendition that the client may try to play back by default.
                  Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                      NO, AUTOSELECT=YES
                  Alternate Audio, not Auto Select Alternate rendition that the client will not try
                  to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
                  DEFAULT=NO, AUTOSELECT=NO

                  - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                  Manifest in addition to the HLS manifest

                  - **SegmentModifier** *(string) --* String concatenated to end of segment
                  filenames. Accepts "Format Identifiers":#format_identifier_parameters.

              - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
              transcoding settings. Provide the system or custom preset name. You can specify either
              Preset (Preset) or Container settings (ContainerSettings), but not both.

              - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
              encoding settings. The specific video settings depend on the video codec that you
              choose when you specify a value for Video codec (codec). Include one instance of
              (VideoDescription) per output.

                - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                service includes AFD values in the output video data and what those values are. *
                Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                input AFD values and instead encode the value specified in the job. * Choose Auto to
                calculate output AFD values based on the input AFD scaler data.

                - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
                outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
                specify that in your job, the service will ignore the setting.

                - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                (VideoDescription), contains the group of settings related to video encoding. The
                settings in this group vary depending on the value that you choose for Video codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * H_264,
                H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
                FRAME_CAPTURE, FrameCaptureSettings

                  - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                  the enum values defined by the object VideoCodec.

                  - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                    - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.n.jpg where n is the 0-based sequence number of each Capture.

                    - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
                    to 7 decimal places.

                    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                    files).

                    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                    quality.

                  - **H264Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value H_264.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                    your output video settings. If you aren't sure what level to specify, choose
                    Auto (AUTO).

                    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                    are only available with the AVC-I License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                    Main or High profile) or CAVLC.

                    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                    for interlaced outputs.

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job specification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* When you use the API for transcode
                    jobs that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateDenominator to specify the
                    denominator of this fraction. In this example, use 1001 for the value of
                    FramerateDenominator. When you use the console for transcode jobs that use frame
                    rate conversion, provide the value as a decimal number for Framerate. In this
                    example, specify 23.976.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type, as follows. - If the source is interlaced, the output will be interlaced
                    with the same polarity as the source (it will follow the source). The output
                    could therefore be a mix of "top field first" and "bottom field first". - If the
                    source is progressive, the output will be interlaced with "top field first" or
                    "bottom field first" polarity, depending on which of the Follow options you
                    chose.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even
                    if repeated.

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                  - **H265Settings** *(dict) --* Settings for H265 codec

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                    Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                    Transfer Function (EOTF).

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* H.265 Level.

                    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                    (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                    "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                    available with the HEVC 4:2:2 License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                    Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                    the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field
                    First (BOTTOM_FIELD) to create an output that's interlaced with the same field
                    polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow,
                    Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the
                    same field polarity as the source. If the source is interlaced, the output will
                    be interlaced with the same polarity as the source (it will follow the source).
                    The output could therefore be a mix of "top field first" and "bottom field
                    first". If the source is progressive, your output will be interlaced with "top
                    field first" or "bottom field first" polarity, depending on which of the Follow
                    options you chose. If you don't choose a value, the service will default to
                    Progressive (PROGRESSIVE).

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                    Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                    based on content

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                    encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                    and P-frames form one layer, reference B-frames can form a second layer and
                    non-reference b-frames can form a third layer. Decoders can optionally decode
                    only the lower temporal layers to generate a lower frame rate output. For
                    example, given a bitstream with temporal IDs and with b-frames =
                         1 (i.e. IbPbPb
                    display order), a decoder could decode all the frames for full frame rate output
                    or only the I and P frames (lowest temporal layer) for a half frame rate output.

                    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                    vertical subdivision of the encoded pictures.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                    units doesn't matter in your workflow, ignore this setting. Use this setting
                    only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                    container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                    your output compliant with the following specification: ISO IECJTC1 SC29 N13798
                    Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
                    parameter set NAL units in the sample headers but not in the samples directly.
                    For MP4 outputs, when you choose HVC1, your output video might not work properly
                    with some downstream systems and video players. The service defaults to marking
                    your output as HEV1. For these outputs, the service writes parameter set NAL
                    units directly into the samples.

                  - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value MPEG2.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                    level for the video output.

                    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                    MPEG-2 profile for the video output.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **IntraDcPrecision** *(string) --* Use Intra DC precision
                    (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                    coefficients. If you choose the value auto, the service will automatically
                    select the precision based on the per-frame compression ratio.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                    video encoding.

                    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                    to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                    356M-2001).

                    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                  - **ProresSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value PRORES.

                    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                    the type of Apple ProRes codec to use for this output.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                    that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateNumerator to specify the
                    numerator of this fraction. In this example, use 24000 for the value of
                    FramerateNumerator.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                    determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                    to use the pixel aspect ratio from the input. To specify a different pixel
                    aspect ratio: Using the console, choose it from the dropdown menu. Using the
                    API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                    (ParDenominator).

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
                color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
                this output. If you don't specify a value, the service sets this to Insert by
                default.

                - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
                the service will include in the output video frame.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                feature is enabled, the service will use drop-frame timecode on outputs. If it is
                not possible to use drop-frame timecode, the system will fall back to
                non-drop-frame. This setting is enabled by default when Timecode insertion
                (TimecodeInsertion) is enabled.

                - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
                Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                service will write on all frames of this video output.

                - **Height** *(integer) --* Use the Height (Height) setting to define the video
                resolution height for this output. Specify in pixels. If you don't provide a value
                here, the service will use the input height.

                - **Position** *(dict) --* Use Selection placement (position) to define the video
                area in your output frame. The area outside of the rectangle that you specify here
                is black.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                the service changes the video itself in response to AFD values in the input. *
                Choose Respond to clip the input video frame according to the AFD value, input
                display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                include the input AFD values. Do not choose this when AfdSignaling is set to (NONE).
                A preferred implementation of this workflow is to set RespondToAfd to (NONE) and set
                AfdSignaling to (AUTO). * Choose None to remove all input AFD values from this
                output.

                - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                have a different aspect ratio from the input aspect ratio. Choose Stretch to output
                (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
                setting Default (DEFAULT) to have the service letterbox your video instead. This
                setting overrides any value that you specify for the setting Selection placement
                (position) in this output.

                - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                strength of anti-aliasing. This setting changes the width of the anti-alias filter
                kernel used for scaling. Sharpness only applies if your output resolution is
                different from your input resolution. 0 is the softest setting, 100 the sharpest,
                and 50 recommended for most content.

                - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                ProRes outputs. Only enable Timecode insertion when the input frame rate is
                identical to the output frame rate. To include timecodes in this output, set
                Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                output, by default, it uses any embedded timecodes from the input. If none are
                present, the service will set the timecode for the first output frame to zero. To
                change this default behavior, adjust the settings under Timecode configuration
                (TimecodeConfig). In the console, these settings are located under Job > Job
                settings > Timecode configuration. Note - Timecode source under input settings
                (InputTimecodeSource) does not affect the timecodes that are inserted in the output.
                Source under Job settings > Timecode configuration (TimecodeSource) does.

                - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                Preprocessors (VideoPreprocessors). Enable the features at each output individually.
                These features are disabled by default.

                  - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                  feature if necessary. Enable or disable this feature for each output individually.
                  This setting is disabled by default.

                    - **Brightness** *(integer) --* Brightness level.

                    - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                    this output. The service supports conversion between HDR formats, between SDR
                    formats, and from SDR to HDR. The service doesn't support conversion from HDR to
                    SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                    video has an HDR format, but visually appears the same as an unconverted output.

                    - **Contrast** *(integer) --* Contrast level.

                    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                    10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                    metadata that you want signaled in the output. These values don't affect the
                    pixel values that are encoded in the video stream. They are intended to help the
                    downstream video player display content in a way that reflects the intentions of
                    the the content creator. When you set Color space conversion
                    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                    must set values for Max frame average light level (maxFrameAverageLightLevel)
                    and Max content light level (maxContentLightLevel); these settings don't have a
                    default value. The default values for the other HDR 10 metadata settings are
                    defined by the P3D65 color space. For more information about MediaConvert HDR
                    jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                      samples in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                      any frame in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance
                      in units of of 0.0001 candelas per square meter.

                      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance
                      in units of of 0.0001 candelas per square meter

                      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                    - **Hue** *(integer) --* Hue in degrees.

                    - **Saturation** *(integer) --* Saturation level.

                  - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                  motion and a clearer picture.

                    - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                    (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                    adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                    (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if
                    your source file includes a ticker, such as a scrolling headline at the bottom
                    of the frame.

                    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                    does not convert frames that are tagged in metadata as progressive. It will only
                    convert those that are tagged as some other type. - When set to
                    FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                    those that are already tagged as progressive. Turn Force mode on only if there
                    is a good chance that the metadata has tagged frames as progressive when they
                    are not progressive. Do not turn on otherwise; processing frames that are
                    already progressive into progressive will probably result in lower quality
                    video.

                    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                    service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                    interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                    progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                  - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                  compatible video output.

                    - **L6Metadata** *(dict) --* Use these settings when you set
                    DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                    your input with new values.

                      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                      that corresponds to the brightest pixel in the entire stream. Measured in
                      nits.

                      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                      metadata that corresponds to the highest frame-average brightness in the
                      entire stream. Measured in nits.

                    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                    handle Dolby Vision MaxCLL and MaxFALL properies.

                    - **Profile** *(string) --* In the current MediaConvert implementation, the
                    Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must
                    contain Dolby Vision frame interleaved data.

                  - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature
                  to include a graphic overlay on your video. Enable or disable this feature for
                  each output individually. This setting is disabled by default.

                    - **InsertableImages** *(list) --* Specify the images that you want to overlay
                    on your video. The images must be PNG or TGA files.

                      - *(dict) --* Settings that specify how your still graphic overlay appears.

                        - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                        image to remain on the output video. This duration includes fade-in time but
                        not fade-out time.

                        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                        between the Start time that you specify for the image insertion and the time
                        that the image appears at full opacity. Full opacity is the level that you
                        specify for the opacity setting. If you don't specify a value for Fade-in,
                        the image will appear abruptly at the overlay start time.

                        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                        between the end of the time that you have specified for the image overlay
                        Duration and when the overlaid image has faded to total transparency. If you
                        don't specify a value for Fade-out, the image will disappear abruptly at the
                        end of the inserted image duration.

                        - **Height** *(integer) --* Specify the height of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        height, the service will crop your overlaid image to fit. To use the native
                        height of the image, keep this setting blank.

                        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                        location of the image that you want to overlay on the video. Use a PNG or
                        TGA file.

                        - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                        inserted image and the left edge of the video frame. Required for any image
                        overlay that you specify.

                        - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                        overlaid image and the top edge of the video frame. Required for any image
                        overlay that you specify.

                        - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                        Images with higher values for Layer appear on top of images with lower
                        values for Layer.

                        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                        the underlying video shows through the inserted image. 0 is transparent and
                        100 is fully opaque. Default is 50.

                        - **StartTime** *(string) --* Specify the timecode of the frame that you
                        want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                        or HH:MM:SS;FF) format. Remember to take into account your timecode source
                        settings.

                        - **Width** *(integer) --* Specify the width of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        width, the service will crop your overlaid image to fit. To use the native
                        width of the image, keep this setting blank.

                  - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                  remove noise from your video output if necessary. Enable or disable this feature
                  for each output individually. This setting is disabled by default.

                    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                    select one of the following spatial image filtering functions. To use this
                    setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                    preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                    Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                    reduction. * Spatial does frequency-domain filtering based on JND principles. *
                    Temporal optimizes video quality for complex motion.

                    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                    spatial filter.

                      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                      reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                      maximum strength.

                      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                      (higher speed), with 0 being the nominal value.

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                    temporal filter.

                      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                      complex motion. Higher values produce stronger temporal filtering. This
                      filters highly complex scenes more aggressively and creates better VQ for low
                      bitrate outputs.

                      - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                      Low setting reduces bit rate at the cost of transcode time, high setting
                      improves transcode time at the cost of bit rate.

                      - **Strength** *(integer) --* Specify the strength of the noise reducing
                      filter on this output. Higher values produce stronger filtering. We recommend
                      the following value ranges, depending on the result that you want: * 0-2 for
                      complexity reduction with minimal sharpness loss * 2-8 for complexity
                      reduction with image preservation * 8-16 for a high level of complexity
                      reduction

                  - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                  output timecode and specified prefix into the output.

                    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                    any burned-in timecode. Valid values are 10, 16, 32, 48.

                    - **Position** *(string) --* Use Position (Position) under under Timecode
                    burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                    output video.

                    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                    any burned-in timecode. For example, a prefix of "EZ-" will result in the
                    timecode "EZ-00:00:00:00". Provide either the characters themselves or the ASCII
                    code equivalents. The supported range of characters is 0x20 through 0x7e. This
                    includes letters, numbers, and all special characters represented on a standard
                    English keyboard.

                - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                in pixels, for this output. If you don't provide a value here, the service will use
                the input width.

      - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
      information from inputs.

        - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
        use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
        the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or
        (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
        Timecode varies depending on your setting for Source (TimecodeSource). * If Source
        (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
        specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
        (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start at
        0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
        Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
        input.

        - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
        within this job. To make sure that your video, audio, captions, and markers are synchronized
        and that time-based features, such as image inserter, work correctly, choose the Timecode
        source option that matches your assets. All timecodes are in a 24-hour format with frame
        number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video.
        If no embedded timecode is in the source, the service will use Start at 0 (ZEROBASED)
        instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. *
        Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other
        than zero. You use Start timecode (Start) to provide this value.

        - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
        (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
        Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

        - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
        stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
        affecting the time and frame number. Provide the new date as a string in the format
        "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
        (InsertProgramDateTime) in the output settings. For example, if the date part of your
        timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
        (TimestampOffset) to 2003-1-25.

      - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
      (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
      enable it here, enable it in each output container, and specify tags and timecodes in ID3
      insertion (Id3Insertion) objects.

        - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

          - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
          specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when
          the tag should be inserted. To insert multiple ID3 tags in your output, create multiple
          instances of ID3 insertion (Id3Insertion).

            - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
            format.

            - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
            format.

    - **SimulateReservedQueue** *(string) --* Enable this setting when you run a test job to
    estimate how many reserved transcoding slots (RTS) you need. When this is enabled, MediaConvert
    runs your job from an on-demand queue with similar performance to what you will see with one RTS
    in a reserved queue. This setting is disabled by default.

    - **Status** *(string) --* A job's status can be SUBMITTED, PROGRESSING, COMPLETE, CANCELED, or
    ERROR.

    - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
    events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
    MediaConvert sends an update at this interval from the time the service begins processing your
    job to the time it completes the transcode or encounters an error.

    - **Timing** *(dict) --* Information about when jobs are submitted, started, and finished is
    specified in Unix epoch format in seconds.

      - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
      finished

      - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the job
      began.

      - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the job.

    - **UserMetadata** *(dict) --* User-defined metadata that you want to associate with an
    MediaConvert job. You specify metadata in key/value pairs.

      - *(string) --*

        - *(string) --*
    """


_ClientCreateJobResponseTypeDef = TypedDict(
    "_ClientCreateJobResponseTypeDef", {"Job": ClientCreateJobResponseJobTypeDef}, total=False
)


class ClientCreateJobResponseTypeDef(_ClientCreateJobResponseTypeDef):
    """
    Type definition for `ClientCreateJob` `Response`

    - **Job** *(dict) --* Each job converts an input file into an output file or files. For more
    information, see the User Guide at
    http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

      - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
      with long, visually complex content.

        - **Mode** *(string) --* Specify the conditions when the service will run your job with
        accelerated transcoding.

      - **AccelerationStatus** *(string) --* Describes whether the current job is running with
      accelerated transcoding. For jobs that have Acceleration (AccelerationMode) set to DISABLED,
      AccelerationStatus is always NOT_APPLICABLE. For jobs that have Acceleration
      (AccelerationMode) set to ENABLED or PREFERRED, AccelerationStatus is one of the other states.
      AccelerationStatus is IN_PROGRESS initially, while the service determines whether the input
      files and job settings are compatible with accelerated transcoding. If they are,
      AcclerationStatus is ACCELERATED. If your input files and job settings aren't compatible with
      accelerated transcoding, the service either fails your job or runs it without accelerated
      transcoding, depending on how you set Acceleration (AccelerationMode). When the service runs
      your job without accelerated transcoding, AccelerationStatus is NOT_ACCELERATED.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **BillingTagsSource** *(string) --* Optional. Choose a tag type that AWS Billing and Cost
      Management will use to sort your AWS Elemental MediaConvert costs on any billing report that
      you set up. Any transcoding outputs that don't have an associated tag will appear in your
      billing report unsorted. If you don't choose a valid value for this field, your job outputs
      will appear on the billing report unsorted.

      - **CreatedAt** *(datetime) --* The time, in Unix epoch format in seconds, when the job got
      created.

      - **CurrentPhase** *(string) --* A job's phase can be PROBING, TRANSCODING OR UPLOADING

      - **ErrorCode** *(integer) --* Error code for the job

      - **ErrorMessage** *(string) --* Error message of Job

      - **Id** *(string) --* A portion of the job's ARN, unique within your AWS Elemental
      MediaConvert resources

      - **JobPercentComplete** *(integer) --* An estimate of how far your job has progressed. This
      estimate is shown as a percentage of the total time from when your job leaves its queue to
      when your output files appear in your output Amazon S3 bucket. AWS Elemental MediaConvert
      provides jobPercentComplete in CloudWatch STATUS_UPDATE events and in the response to GetJob
      and ListJobs requests. The jobPercentComplete estimate is reliable for the following input
      containers: Quicktime, Transport Stream, MP4, and MXF. For some jobs, the service can't
      provide information about job progress. In those cases, jobPercentComplete returns a null
      value.

      - **JobTemplate** *(string) --* The job template that the job is created from, if it is
      created from a job template.

      - **Messages** *(dict) --* Provides messages from the service about jobs that you have already
      successfully submitted.

        - **Info** *(list) --* List of messages that are informational only and don't indicate a
        problem with your job.

          - *(string) --*

        - **Warning** *(list) --* List of messages that warn about conditions that might cause your
        job not to run or to fail.

          - *(string) --*

      - **OutputGroupDetails** *(list) --* List of output group details

        - *(dict) --* Contains details about the output groups specified in the job settings.

          - **OutputDetails** *(list) --* Details about the output

            - *(dict) --* Details regarding output

              - **DurationInMs** *(integer) --* Duration in milliseconds

              - **VideoDetails** *(dict) --* Contains details about the output's video stream

                - **HeightInPx** *(integer) --* Height in pixels for the output

                - **WidthInPx** *(integer) --* Width in pixels for the output

      - **Priority** *(integer) --* Relative priority on the job.

      - **Queue** *(string) --* Optional. When you create a job, you can specify a queue to send it
      to. If you don't specify, the job will go to the default queue. For more about queues, see the
      User Guide topic at http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

      - **RetryCount** *(integer) --* The number of times that the service automatically attempted
      to process your job after encountering an error.

      - **Role** *(string) --* The IAM role you use for creating this job. For details about
      permissions, see the User Guide topic at the User Guide at
      http://docs.aws.amazon.com/mediaconvert/latest/ug/iam-role.html

      - **Settings** *(dict) --* JobSettings contains all the transcode settings for a job.

        - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
        the input Ad Avail PTS time.

        - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
        overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

          - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
          black. Only bmp and png images are supported.

        - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

          - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
          ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
          uses the manifest conditioning instructions that you provide in the setting MCC XML
          (mccXml).

            - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
            document inside your JSON job settings. Form the XML document as per
            OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning
            instructions in the message that you supply.

          - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
          between the SCTE 35 messages that the transcoder places and the splice points that they
          refer to. If the time between the start of the asset and the SCTE-35 message is less than
          this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

          - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
          SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
          signal processing instructions that you provide in the setting SCC XML (sccXml).

            - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
            inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025.
            The transcoder will use the signal processing instructions in the message that you
            supply. Provide your ESAM SignalProcessingNotification XML document inside your JSON job
            settings. For your MPEG2-TS file outputs, if you want the service to place SCTE-35
            markers at the insertion points you specify in the XML document, you must also enable
            SCTE-35 ESAM (scte35Esam). Note that you can either specify an ESAM XML document or
            enable SCTE-35 passthrough. You can't do both.

        - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode
        job. There can be multiple inputs add in a job. These inputs will be concantenated together
        to create the output.

          - *(dict) --* Specifies media input

            - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input
            to combine. An input may have multiple audio selector groups. See "Audio Selector
            Group":#inputs-audio_selector_group for more information.

              - *(string) --*

                - *(dict) --* Group of Audio Selectors

                  - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same
                  input to include in the group. Audio selector names are standardized, based on
                  their order within the input (e.g., "Audio Selector 1"). The audio selector name
                  parameter can be repeated to add any number of audio selectors to the group.

                    - *(string) --*

            - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
            or set of tracks from the input that you will use in your outputs. You can use mutiple
            Audio selectors per input.

              - *(string) --*

                - *(dict) --* Selector for Audio

                  - **CustomLanguageCode** *(string) --* Selects a specific language code from
                  within an audio source, using the ISO 639-2 or ISO 639-3 three-letter language
                  code

                  - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                  set it as the default for the job. The service uses this default for outputs where
                  it can't find the specified input audio. If you don't set a default, those outputs
                  have no audio.

                  - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                  file source.

                  - **LanguageCode** *(string) --* Selects a specific language code from within an
                  audio source.

                  - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                  audio from the input video.

                  - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g.
                  257 selects PID 0x101).

                    - *(integer) --*

                  - **ProgramSelection** *(integer) --* Use this setting for input streams that
                  contain Dolby E, to have the service extract specific program data from the track.
                  To select multiple programs, create multiple selectors with the same Track and
                  different Program numbers. In the console, this setting is visible when you set
                  Selector type to Track. Choose the program number from the dropdown list. If you
                  are sending a JSON file, provide the program ID, which is part of the audio
                  metadata. If your input file has incorrect metadata, you can choose All channels
                  instead of a program number to have the service ignore the program IDs and include
                  all the programs in the track.

                  - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels
                  of one input to match those of another input. This allows you to combine the two
                  files into a single output, one after the other.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **SelectorType** *(string) --* Specifies the type of the audio selector.

                  - **Tracks** *(list) --* Identify a track from the input audio to include in this
                  selector by entering the track index number. To include several tracks in a single
                  audio selector, specify multiple tracks as follows. Using the console, enter a
                  comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                  Specifying directly in your JSON job file, provide the track numbers in an array.
                  For example, "tracks": [1,2,3].

                    - *(integer) --*

            - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
            the captions data from the input that you will use in your outputs. You can use mutiple
            captions selectors per input.

              - *(string) --*

                - *(dict) --* Set up captions in your outputs by first selecting them from your
                input here.

                  - **CustomLanguageCode** *(string) --* The specific language to extract from
                  source, using the ISO 639-2 or ISO 639-3 three-letter language code. If input is
                  SCTE-27, complete this field and/or PID to select the caption language to extract.
                  If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or
                  PID to select the caption language to extract. If input is DVB-Sub that is being
                  passed through, omit this field (and PID field); there is no way to extract a
                  specific language with pass-through captions.

                  - **LanguageCode** *(string) --* The specific language to extract from source. If
                  input is SCTE-27, complete this field and/or PID to select the caption language to
                  extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this
                  field and/or PID to select the caption language to extract. If input is DVB-Sub
                  that is being passed through, omit this field (and PID field); there is no way to
                  extract a specific language with pass-through captions.

                  - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                  SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                  your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                  FileSoureSettings.

                    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions
                    source.

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                      number in the ancillary data track from which to extract captions. Unused for
                      passthrough.

                      - **TerminateCaptions** *(string) --* By default, the service terminates any
                      unterminated captions at the end of each input. If you want the caption to
                      continue onto your next input, disable this setting.

                    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                      PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub
                      content is passed through, regardless of selectors.

                    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel
                      number within the video track from which to extract captions. Unused for
                      passthrough.

                      - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                      for extracting captions. The system only supports one input video track, so
                      this should always be set to '1'.

                      - **TerminateCaptions** *(string) --* By default, the service terminates any
                      unterminated captions at the end of each input. If you want the caption to
                      continue onto your next input, disable this setting.

                    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                    STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption
                    source file. If your caption source is IMSC in an IMF package, use
                    TrackSourceSettings instead of FileSoureSettings.

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **SourceFile** *(string) --* External caption file used for loading
                      captions. Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt',
                      'xml', and 'smi'.

                      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                      captions from the source file.

                    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                    your input captions. The service cannot auto-detect caption format.

                    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                    sources, including Page number.

                      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                      three-digit hexadecimal page number that will be used for Teletext captions.
                      Do not use this setting if you are passing through teletext from the input
                      source to output.

                    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                    are specified by track number. Currently, this is only IMSC captions in an IMF
                    package. If your caption source is IMSC 1.1 in a separate xml file, use
                    FileSourceSettings instead of TrackSourceSettings.

                      - **TrackNumber** *(integer) --* Use this setting to select a single captions
                      track from a source. Track numbers correspond to the order in the captions
                      source file. For IMF sources, track numbering is based on the order that the
                      captions appear in the CPL. For example, use 1 to select the captions asset
                      that is listed first in the CPL. To include more than one captions track in
                      your job outputs, create multiple input captions selectors. Specify one track
                      per selector.

            - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
            service will include in the output video frame. If you specify a value here, it will
            override any value that you specify in the output setting Cropping selection (crop).

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce
            smoother motion in the output. Default is disabled. Only manaully controllable for MPEG2
            and uncompressed video inputs.

            - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
            encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when
            you use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt
            your content.

              - **DecryptionMode** *(string) --* Specify the encryption mode that you used to
              encrypt your input files.

              - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key
              in plaintext. Your job settings could be intercepted, making your encrypted content
              vulnerable. Specify the encrypted version of the data key that you used to encrypt
              your content. The data key must be encrypted by AWS Key Management Service (KMS). The
              key can be 128, 192, or 256 bits.

              - **InitializationVector** *(string) --* Specify the initialization vector that you
              used when you encrypted your content before uploading it to Amazon S3. You can use a
              16-byte initialization vector with any encryption mode. Or, you can use a 12-byte
              initialization vector with GCM or CTR. MediaConvert accepts only initialization
              vectors that are base64-encoded.

              - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
              (KMS) that you used to encrypt your data key, if that Region is different from the one
              you are using for AWS Elemental MediaConvert.

            - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise
            from the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and
            uncompressed video inputs.

            - **FileInput** *(string) --* Specify the source file for your transcoding job. You can
            use multiple inputs in a single job. The service concatenates these inputs, in the order
            that you specify them in the job, to create the outputs. If your input format is IMF,
            specify your input by providing the path to your CPL. For example,
            "s3://bucket/vf/cpl.xml". If the CPL is in an incomplete IMP, make sure to use
            *Supplemental IMPs* (SupplementalImps) to specify any supplemental IMPs that contain
            assets referenced by the CPL.

            - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how
            the transcoding service applies the denoise and deblock filters. You must also enable
            the filters separately, with Denoise (InputDenoiseFilter) and Deblock
            (InputDeblockFilter). * Auto - The transcoding service determines whether to apply
            filtering, depending on input type and quality. * Disable - The input is not filtered.
            This is true even if you use the API to enable them in (InputDeblockFilter) and
            (InputDeblockFilter). * Force - The in put is filtered regardless of input type.

            - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
            magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
            is 0.

            - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
            overlay on your video. Enable or disable this feature for each input individually. This
            setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
            that together specify a portion of the input to be used in the outputs. If you provide
            only a start time, the clip will be the entire input from that point to the end. If you
            provide only an end time, it will be the entire input up to that point. When you specify
            more than one input clip, the transcoding service creates the job outputs by stringing
            the clips together in the order you specify them.

              - *(dict) --* To transcode only portions of your input (clips), include one Input
              clipping (one instance of InputClipping in the JSON job file) for each input clip. All
              input clips you specify will be included in every output of the job.

                - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
                portion of the input you are clipping. The frame corresponding to the End timecode
                value is included in the clip. Start timecode or End timecode may be left blank, but
                not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
                minute, SS is the second, and FF is the frame number. When choosing this value, take
                into account your setting for timecode source under input settings
                (InputTimecodeSource). For example, if you have embedded timecodes that start at
                01:00:00:00 and you want your clip to end six minutes into the video, use
                01:06:00:00.

                - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the
                beginning of the portion of the input you are clipping. The frame corresponding to
                the Start timecode value is included in the clip. Start timecode or End timecode may
                be left blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is
                the hour, MM is the minute, SS is the second, and FF is the frame number. When
                choosing this value, take into account your setting for Input timecode source. For
                example, if you have embedded timecodes that start at 01:00:00:00 and you want your
                clip to begin five minutes into the video, use 01:05:00:00.

            - **Position** *(dict) --* Use Selection placement (position) to define the video area
            in your output frame. The area outside of the rectangle that you specify here is black.
            If you specify a value here, it will override any value that you specify in the output
            setting Selection placement (position). If you specify a value here, this will override
            any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
            (RESPOND). If you specify a value here, this will ignore anything that you specify for
            the setting Scaling Behavior (scalingBehavior).

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
            program from within a multi-program transport stream. Note that Quad 4K is not currently
            supported. Default is the first program within the transport stream. If the program you
            specify doesn't exist, the transcoding service will use this default.

            - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
            inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs
            for audio and video. * Use PSI - Scan only PSI data.

            - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs.
            You need supplemental IMPs if the CPL that you're using for your input is in an
            incomplete IMP. Specify either the supplemental IMP directories with a trailing slash or
            the ASSETMAP.xml files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"].
            You don't need to specify the IMP that contains your input CPL, because the service
            automatically detects it.

              - *(string) --*

            - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
            input settings (InputTimecodeSource), to specify how the service counts input video
            frames. This input frame count affects only the behavior of features that apply to a
            single input at a time, such as input clipping and synchronizing some captions formats.
            Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at
            zero (ZEROBASED) to start the first frame at zero. Choose Specified start
            (SPECIFIEDSTART) to start the first frame at the timecode that you specify in the
            setting Start timecode (timecodeStart). If you don't specify a value for Timecode
            source, the service will use Embedded by default. For more information about timecodes,
            see https://docs.aws.amazon.com/console/mediaconvert/timecode.

            - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
            for this input's initial frame. To use this setting, you must set the Timecode source
            setting, located under the input settings (InputTimecodeSource), to Specified start
            (SPECIFIEDSTART). For more information about timecodes, see
            https://docs.aws.amazon.com/console/mediaconvert/timecode.

            - **VideoSelector** *(dict) --* Selector for video.

              - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
              animation. Specify which part of this input MediaConvert uses for your outputs. Leave
              this setting set to DISCARD in order to delete the alpha channel and preserve the
              video. Use REMAP_TO_LUMA for this setting to delete the video and map the alpha
              channel to the luma channel of your outputs.

              - **ColorSpace** *(string) --* If your input video has accurate color space metadata,
              or if you don't know about color space, leave this set to the default value Follow
              (FOLLOW). The service will automatically detect your input color space. If your input
              video has metadata indicating the wrong color space, specify the accurate color space
              here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color
              Volume static metadata isn't present in your video stream, or if that metadata is
              present but not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct
              values in the input HDR 10 metadata (Hdr10Metadata) settings. For more information
              about MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the
              input file and the job input settings Color space (ColorSpace) and HDR master display
              information settings(Hdr10Metadata). The Color space usage setting determines which
              takes precedence. Choose Force (FORCE) to use color metadata from the input job
              settings. If you don't specify values for those settings, the service defaults to
              using metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color
              metadata from the source when it is present. If there's no color metadata in your
              input file, the service defaults to using values you specify in the input settings.

              - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
              missing or inaccurate in your input video. Appropriate values vary depending on the
              input video and must be provided by a color grader. The color grader generates these
              values during the HDR 10 mastering process. The valid range for each of these settings
              is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
              settings - When you specify these values, you must also set Color space (ColorSpace)
              to HDR 10 (HDR10). To specify whether the the values you specify here take precedence
              over the values in the metadata of your input file, set Color space usage
              (ColorSpaceUsage). To specify whether color metadata is included in an output, set
              Color metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
              https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input
              file. Specify this value as an integer; the system automatically converts it to the
              hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
              an identifier for a set of data in an MPEG-2 transport stream container.

              - **ProgramNumber** *(integer) --* Selects a specific program from within a
              multi-program transport stream. Note that Quad 4K is not currently supported.

              - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
              your video. You can choose automatic rotation or specify a rotation. You can specify a
              clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is
              .mov or .mp4 and your input has rotation metadata, you can choose Automatic to have
              the service rotate your video according to the rotation specified in the metadata. The
              rotation must be within one degree of 90, 180, or 270 degrees. If the rotation
              metadata specifies any other rotation, the service will default to no rotation. By
              default, the service does no rotation, even if your input video has rotation metadata.
              The service doesn't pass through rotation metadata.

        - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The
        motion graphics that you specify here appear on all outputs in all output groups.

          - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
          unspecified. If your motion graphic asset is a series of .png files, specify the frame
          rate of the overlay in frames per second, as a fraction. For example, specify 24 fps as
          24/1. Make sure that the number of images in your series matches the frame rate and your
          intended overlay duration. For example, if you want a 30-second overlay at 30 fps, you
          should have 900 .png images. This overlay frame rate doesn't need to match the frame rate
          of the underlying video.

            - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
            overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

            - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
            overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

          - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
          overlay on your video. For .png files, provide the file name of the first file in the
          series. Make sure that the names of the .png files end with sequential numbers that
          specify the order that they are played in. For example, overlay_000.png, overlay_001.png,
          overlay_002.png, and so on. The sequence must start at zero, and each image file name must
          have the same number of digits. Pad your initial file names with enough zeros to complete
          the sequence. For example, if the first image is overlay_0.png, there can be only 10
          images in the sequence, with the last image being overlay_9.png. But if the first image is
          overlay_00.png, there can be 100 images in the sequence.

          - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
          providing for your overlay. You can choose either a .mov file or a series of .png files.

          - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic
          overlay on the video frame. Specify in pixels, from the upper-left corner of the frame. If
          you don't specify an offset, the service scales your overlay to the full size of the
          frame. Otherwise, the service inserts the overlay at its native resolution and scales the
          size up or down with any video scaling.

            - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the
            left edge of the video frame.

            - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
            edge of the video frame.

          - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
          or plays only once.

          - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
          (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
          account how you have set up your timecode configuration under both job settings and input
          settings. The simplest way to do that is to set both to start at 0. If you need to set up
          your job to follow timecodes embedded in your source that don't start at zero, make sure
          that you specify a start time that is after the first embedded timecode. For more
          information, see
          https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide
          and input timecode configuration settings in your JSON job settings specification at
          settings>timecodeConfig>source and settings>inputs>timecodeSource.

        - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
        do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
        configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all
        outputs in the job. To enable Nielsen configuration programmatically, include an instance of
        nielsenConfiguration in your JSON job specification. Even if you don't include any children
        of nielsenConfiguration, you still enable the setting.

          - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
          functionality. If you must include this property, set the value to zero.

          - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
          distributor ID that is assigned to your organization by Neilsen.

        - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
        outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS,
        Quicktime, MXF, and no container) are grouped in a single output group as well. Required in
        (OutputGroups) is a group of settings that apply to the whole group. This required object
        depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
        settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
        HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
        MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

          - *(dict) --* Group of outputs

            - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
            the output group. This value is displayed on the console and can make your job settings
            JSON more human-readable. It does not affect your outputs. Use up to twelve characters
            that are either letters, numbers, spaces, or underscores.

            - **Name** *(string) --* Name of the output group

            - **OutputGroupSettings** *(dict) --* Output Group settings, including type

              - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
              Output Group may only contain a single video, audio, or caption output.

                - **AdditionalManifests** *(list) --* By default, the service creates one top-level
                .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group
                in your job. These default manifests reference every output in the output group. To
                create additional top-level manifests that reference a subset of the outputs in the
                output group, specify a list of them here. For each additional manifest that you
                specify, the service creates one HLS manifest and one DASH manifest.

                  - *(dict) --* Specify the details for each pair of HLS and DASH additional
                  manifests that you want the service to generate for this CMAF output group. Each
                  pair of manifests can reference a different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your HLS group is film-name.m3u8. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                    specify a manifestNameModifier that is different from the nameModifier of the
                    output. The service uses the output name modifier to create unique names for the
                    individual variant manifests.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                file at the top level BaseURL element. Can be used if streams are delivered from a
                different URL than the manifest file.

                - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
                which prevents client from saving media segments for later replay.

                - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
                RFC-4281) during m3u8 playlist generation.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* DRM settings.

                  - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                  value represented by a 32-character text string. If this parameter is not set then
                  the Initialization Vector will follow the segment number by default.

                  - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want
                  the service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                  (SAMPLE-AES) or AES_CTR (AES-CTR).

                  - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                  outputs, choose whether the service writes the 128-bit encryption initialization
                  vector in the HLS and DASH manifests.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                  settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                  output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                  settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                    signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                    package. The DASH manifest can currently signal up to three system IDs. For more
                    information, see https://dashif.org/identifiers/content_protection/.

                      - *(string) --*

                    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                    signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                    package. The HLS manifest can currently signal only one system ID. For more
                    information, see https://dashif.org/identifiers/content_protection/.

                      - *(string) --*

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                  - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                  static key provider.

                    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                    the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                    omitted to indicate an implicit value of 'identity'.

                    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                    single positive integer version value or a slash delimited list of version
                    values (1/2/3).

                    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                    32-character hexidecimal string to specify Key Value (StaticKeyValue).

                    - **Url** *(string) --* Relates to DRM implementation. The location of the
                    license server used for protecting content.

                  - **Type** *(string) --* Specify whether your DRM encryption key is static or from
                  a key provider that follows the SPEKE standard. For more information about SPEKE,
                  see https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                Fragment length must be compatible with GOP size and Framerate. Note that fragments
                will end on the next keyframe after this number of seconds, so actual fragment
                length may be longer. When Emit Single File is checked, the fragmentation is
                internal to a single output file and it does not cause the creation of many output
                files as in other output types.

                - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                should use floating point values for segment duration.

                - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
                needed to ensure smooth playout.

                - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                0, unless you are troubleshooting a problem with how devices play back the end of
                your video asset. If you know that player devices are hanging on the final segment
                of your video because the length of your final segment is too short, use this
                setting to specify a minimum final segment length, in seconds. Choose a value that
                is greater than or equal to 1 and less than your segment length. When you specify a
                value for this setting, the encoder will combine any final segment that is shorter
                than the length that you specify with the previous segment. For example, your
                segment length is 3 seconds and your final segment is .5 seconds without a minimum
                final segment length; when you set the minimum final segment length to 1, your final
                segment is 3.5 seconds.

                - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                main. When you choose Main profile (MAIN_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                On-demand (ON_DEMAND_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
                you must also set the output group setting Segment control (SegmentControl) to
                Single file (SINGLE_FILE).

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
                generated, which is internally segmented using the Fragment Length and Segment
                Length. When set to SEGMENTED_FILES, separate segment files will be created.

                - **SegmentLength** *(integer) --* Use this setting to specify the length, in
                seconds, of each individual CMAF segment. This value applies to the whole package;
                that is, to every output in the output group. Note that segments end on the first
                keyframe after this number of seconds, so the actual segment length might be
                slightly longer. If you set Segment control (CmafSegmentControl) to single file, the
                service puts the content of each output in a single file that has metadata that
                marks these segments. If you set it to segmented files, the service creates multiple
                files for each output, each with the content of one segment.

                - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
                video in EXT-X-STREAM-INF tag of variant manifest.

                - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will
                be generated for this output.

                - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
                be generated for this output.

              - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

                - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
                manifest for each DASH ISO output group in your job. This default manifest
                references every output in the output group. To create additional DASH manifests
                that reference a subset of the outputs in the output group, specify a list of them
                here.

                  - *(dict) --* Specify the details for each additional DASH manifest that you want
                  the service to generate for this output group. Each manifest can reference a
                  different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your DASH group is film-name.mpd. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.mpd.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
                from a different URL than the manifest file.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* DRM settings.

                  - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                  compatibility of your output with video players on obsolete devices. It applies
                  only to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI
                  (UNENCRYPTED_SEI) only to correct problems with playback on older devices.
                  Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose Unencrypted
                  SEI, for that output, the service will exclude the access unit delimiter and will
                  leave the SEI NAL units unencrypted.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                Fragment length must be compatible with GOP size and Framerate. Note that fragments
                will end on the next keyframe after this number of seconds, so actual fragment
                length may be longer. When Emit Single File is checked, the fragmentation is
                internal to a single output file and it does not cause the creation of many output
                files as in other output types.

                - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

                - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
                needed to ensure smooth playout.

                - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                main. When you choose Main profile (MAIN_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                On-demand (ON_DEMAND_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
                you must also set the output group setting Segment control (SegmentControl) to
                Single file (SINGLE_FILE).

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
                generated, which is internally segmented using the Fragment Length and Segment
                Length. When set to SEGMENTED_FILES, separate segment files will be created.

                - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds).
                Note that segments will end on the next keyframe after this number of seconds, so
                actual segment length may be longer. When Emit Single File is checked, the
                segmentation is internal to a single output file and it does not cause the creation
                of many output files as in other output types.

                - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
                the 400 range when you play back your DASH output, enable this setting and run your
                transcoding job again. When you enable this setting, the service writes precise
                segment durations in the DASH manifest. The segment duration information appears
                inside the SegmentTimeline element, inside SegmentTemplate at the Representation
                level. When you don't enable this setting, the service writes approximate segment
                durations in your DASH manifest.

              - **FileGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

              - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

                - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your
                Apple HLS manifest. This setting does not determine whether SCTE-35 markers appear
                in the outputs themselves.

                  - *(string) --*

                - **AdditionalManifests** *(list) --* By default, the service creates one top-level
                .m3u8 HLS manifest for each HLS output group in your job. This default manifest
                references every output in the output group. To create additional top-level
                manifests that reference a subset of the outputs in the output group, specify a list
                of them here.

                  - *(dict) --* Specify the details for each additional HLS manifest that you want
                  the service to generate for this output group. Each manifest can reference a
                  different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your HLS group is film-name.m3u8. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                    specify a manifestNameModifier that is different from the nameModifier of the
                    output. The service uses the output name modifier to create unique names for the
                    individual variant manifests.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each
                output in the media .m3u8 file. Can be used if base manifest is delivered from a
                different URL than the main .m3u8 file.

                - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                  - *(dict) --* Caption Language Mapping

                    - **CaptionChannel** *(integer) --* Caption channel.

                    - **CustomLanguageCode** *(string) --* Specify the language for this captions
                    channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                    three-letter code listed at
                    https://www.loc.gov/standards/iso639-2/php/code_list.php.

                    - **LanguageDescription** *(string) --* Caption language description.

                - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
                captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least
                one language in the CC1 Language Code field. One CLOSED-CAPTION line is added for
                each Language Code you specify. Make sure to specify the languages in the order in
                which they appear in the original source (if the source is embedded format) or the
                order of the caption selectors (if the source is other than embedded). Otherwise,
                languages in the manifest will not match up properly with the output captions. None:
                Include CLOSED-CAPTIONS=
                    NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS
                line from the manifest.

                - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
                which prevents client from saving media segments for later replay.

                - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
                RFC-4281) during m3u8 playlist generation.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **DirectoryStructure** *(string) --* Indicates whether segments should be placed
                in subdirectories.

                - **Encryption** *(dict) --* DRM settings.

                  - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                  value represented by a 32-character text string. If this parameter is not set then
                  the Initialization Vector will follow the segment number by default.

                  - **EncryptionMethod** *(string) --* Encrypts the segments with the given
                  encryption scheme. Leave blank to disable. Selecting 'Disabled' in the web
                  interface also disables encryption.

                  - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                  128-bit number used in conjunction with the key for encrypting blocks. If set to
                  INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                  Vector is not in the manifest.

                  - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                  EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                  HLS FairPlay content protection.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                  - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                  static key provider.

                    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                    the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                    omitted to indicate an implicit value of 'identity'.

                    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                    single positive integer version value or a slash delimited list of version
                    values (1/2/3).

                    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                    32-character hexidecimal string to specify Key Value (StaticKeyValue).

                    - **Url** *(string) --* Relates to DRM implementation. The location of the
                    license server used for protecting content.

                  - **Type** *(string) --* Specify whether your DRM encryption key is static or from
                  a key provider that follows the SPEKE standard. For more information about SPEKE,
                  see https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                should use floating point values for segment duration.

                - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                0, unless you are troubleshooting a problem with how devices play back the end of
                your video asset. If you know that player devices are hanging on the final segment
                of your video because the length of your final segment is too short, use this
                setting to specify a minimum final segment length, in seconds. Choose a value that
                is greater than or equal to 1 and less than your segment length. When you specify a
                value for this setting, the encoder will combine any final segment that is shorter
                than the length that you specify with the previous segment. For example, your
                segment length is 3 seconds and your final segment is .5 seconds without a minimum
                final segment length; when you set the minimum final segment length to 1, your final
                segment is 3.5 seconds.

                - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
                looking ahead and back within the specified range for a nearby avail and extending
                the segment size if needed.

                - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
                be generated for this HLS output group.

                - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
                in .m3u8 manifest files. The value is calculated as follows: either the program date
                and time are initialized using the input timecode source, or the time is initialized
                using the input timecode source and the date is initialized using the
                timestamp_offset.

                - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
                EXT-X-PROGRAM-DATE-TIME entry, in seconds.

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a
                single media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for
                playback.

                - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
                create (in seconds). Note that segments will end on the next keyframe after this
                number of seconds, so actual segment length may be longer.

                - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
                subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
                for this setting to have an effect.

                - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
                video in EXT-X-STREAM-INF tag of variant manifest.

                - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

                - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

                - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
                offset to fine tune the timestamps.

              - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

                - **AdditionalManifests** *(list) --* By default, the service creates one .ism
                Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
                in your job. This default manifest references every output in the output group. To
                create additional manifests that reference a subset of the outputs in the output
                group, specify a list of them here.

                  - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                  manifest that you want the service to generate for this output group. Each
                  manifest can reference a different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your Microsoft Smooth group is film-name.ismv. If you
                    enter "-no-premium" for this setting, then the file name the service generates
                    for this top-level manifest is film-name-no-premium.ismv.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
                audio encoding settings across a Microsoft Smooth output group into a single audio
                stream.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* If you are using DRM, set DRM System
                (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
                the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
                and frame rate.

                - **ManifestEncoding** *(string) --* Use Manifest encoding
                (MsSmoothManifestEncoding) to specify the encoding format for the server and client
                manifest. Valid options are utf8 and utf16.

              - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
              Microsoft Smooth Streaming, CMAF)

            - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
            settings per output.

              - *(dict) --* An output object describes the settings for a single output file or
              stream in an output group.

                - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
                encoding settings organized by audio codec. Include one instance of
                (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
                encoding settings.

                  - *(dict) --* Description of audio output

                    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                    settings. Ignore these settings unless you need to comply with a loudness
                    standard.

                      - **Algorithm** *(string) --* Choose one of the following audio normalization
                      algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated
                      average loudness for an entire piece of content, suitable for measurement of
                      short-form content under ATSC recommendation A/85. Supports up to 5.1 audio
                      channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
                      loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
                      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement
                      algorithm as 1770-2, with an updated true peak measurement. ITU-R BS.1770-4:
                      Higher channel count. Allows for more audio channels than the other
                      algorithms, including configurations such as 7.1.

                      - **AlgorithmControl** *(string) --* When enabled the output audio is
                      corrected using the chosen algorithm. If disabled, the audio will be measured
                      but not adjusted.

                      - **CorrectionGateLevel** *(integer) --* Content measuring above this level
                      will be corrected to the target level. Content measuring below this level will
                      not be corrected. Gating only applies when not using real_time_correction.

                      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio
                      track loudness to a CSV file.

                      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                      TruePeak for each output's audio track loudness.

                      - **TargetLkfs** *(float) --* When you use Audio normalization
                      (AudioNormalizationSettings), optionally use this setting to specify a target
                      loudness. If you don't specify a value here, the encoder chooses a value for
                      you, based on the algorithm that you choose for Algorithm (algorithm). If you
                      choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                      encoder will choose -23 LKFS.

                    - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                    input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector
                    by name based on its order within each input. For example if you specify "Audio
                    Selector 3", then the third audio selector will be used from each input. If an
                    input does not have an "Audio Selector 3", then the audio selector marked as
                    "default" in that input will be used. If there is no audio selector marked as
                    "default", silence will be inserted for the duration of that input.
                    Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may
                    be specified, with similar default/silence behavior. If no audio_source_name is
                    specified, then "Audio Selector 1" will be chosen automatically.

                    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                    unchecked (false). A number between 0 and 255. The following are defined in
                    ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                         Hearing Impaired, 3 =
                    Visually Impaired Commentary, 4-255 = Reserved.

                    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                    contains an ISO 639 audio_type, then that value is passed through to the output.
                    If the input contains no ISO 639 audio_type, the value in Audio Type is included
                    in the output. Otherwise the value in Audio Type is included in the output. Note
                    that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                    is set to BROADCASTER_MIXED_AD.

                    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                    (AudioDescriptions) contains the group of settings related to audio encoding.
                    The settings in this group vary depending on the value that you choose for Audio
                    codec (Codec). For each codec enum that you choose, define the corresponding
                    settings object. The following lists the codec enum, settings object pairs. *
                    AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
                    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                      - **AacSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one
                      of two mutually exclusive groups of AAC settings--VBR and CBR. To select one
                      of these modes, set the value of Bitrate control mode (rateControlMode) to
                      "VBR" or "CBR". In VBR mode, you control the audio quality with the setting
                      VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate).
                      Defaults and valid values depend on the rate control mode.

                        - **AudioDescriptionBroadcasterMix** *(string) --* Choose
                        BROADCASTER_MIXED_AD when the input contains pre-mixed main audio + audio
                        description (AD) as a stereo pair. The value for AudioType will be set to 3,
                        which signals to downstream systems that this stream contains "broadcaster
                        mixed AD". Note that the input received by the encoder must contain
                        pre-mixed audio; the encoder does not perform the mixing. When you choose
                        BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                        AudioType and FollowInputAudioType. Choose NORMAL when the input does not
                        contain pre-mixed audio + audio description (AD). In this case, the encoder
                        will use any values you provide for AudioType and FollowInputAudioType.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        The set of valid values for this setting is: 6000, 8000, 10000, 12000,
                        14000, 16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000,
                        96000, 112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000,
                        384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value
                        you set is also constrained by the values that you choose for Profile
                        (codecProfile), Bitrate control mode (codingMode), and Sample rate
                        (sampleRate). Default values depend on Bitrate control mode and Profile.

                        - **CodecProfile** *(string) --* AAC Profile.

                        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or
                        5.1 channel layout. Valid values depend on rate control mode and profile.
                        "1.0 - Audio Description (Receiver Mix)" setting receives a stereo
                        description plus control track and emits a mono AAC encode of the
                        description track, with control data emitted in the PES header as per ETSI
                        TS 101 154 Annex E.

                        - **RateControlMode** *(string) --* Rate Control Mode.

                        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                        use LATM/LOAS AAC in an output, you must choose "No container" for the
                        output container.

                        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on
                        rate control mode and profile.

                        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                        for raw or MPEG-2 Transport Stream containers.

                        - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                        rate_control_mode is VBR.

                      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AC3.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid bitrates depend on the coding mode.

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                        stream that the encoder emits. For more information about the AC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number
                        of channels.

                        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                        input audio is Dolby Digital, dialnorm will be passed through.

                        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                        adds dynamic range compression signaling to the output bitstream as defined
                        in the Dolby Digital specification.

                        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                        channel prior to encoding. Only valid with 3_2_LFE coding mode.

                        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                        metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                        this audio data. If audio was not supplied from one of these streams, then
                        the static metadata settings will be used.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                      - **AiffSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AIFF.

                        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                        sample, to choose the encoding quality for this audio track.

                        - **Channels** *(integer) --* Specify the number of channels in this output
                        audio track. Valid values are 1 and even numbers up to 64. For example, 1,
                        2, 4, 6, and so on, up to 64.

                        - **SampleRate** *(integer) --* Sample rate in hz.

                      - **Codec** *(string) --* Type of Audio codec.

                      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid values: 384k, 448k, 640k, 768k

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                        stream that the encoder emits. For more information about the EAC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                        (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence
                        to adjust loudness based on dialogue analysis.

                        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                        level for a signal with dynamic range compression.

                        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                        the audio dynamic range when compressing the audio.

                        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left only/Right only center mix (Lo/Ro center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and
                        -6.0.

                        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert
                        uses this value for downmixing. How the service uses this value depends on
                        the value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                        values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left total/Right total center mix (Lt/Rt center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and
                        -6.0.

                        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                        value -60 mutes the channel.

                        - **MeteringMode** *(string) --* Choose how the service meters the loudness
                        of your audio.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                        that must be speech before the encoder uses the measured speech loudness as
                        the overall program loudness.

                        - **StereoDownmix** *(string) --* Choose how the service does stereo
                        downmixing.

                        - **SurroundExMode** *(string) --* Specify whether your input audio has an
                        additional center rear surround channel matrix encoded into your left and
                        right surround channels.

                      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value EAC3.

                        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                        dB attenuation to the surround channels. Only used for 3/2 coding mode.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid bitrates depend on the coding mode.

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                        stream that the encoder emits. For more information about the EAC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                        number of channels.

                        - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                        channels.

                        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                        input audio is Dolby Digital Plus, dialnorm will be passed through.

                        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                        level for a signal with dynamic range compression.

                        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                        the audio dynamic range when compressing the audio.

                        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                        LFE channel is enabled

                        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                        channel prior to encoding. Only valid with 3_2_LFE coding mode.

                        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                        Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                        mutes the channel. This setting applies only if you keep the default value
                        of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                        (Eac3CodingMode). If you choose a different value for Coding mode, the
                        service ignores Left only/Right only center (loRoCenterMixLevel).

                        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                        Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                        channel. This setting applies only if you keep the default value of 3/2 - L,
                        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                        If you choose a different value for Coding mode, the service ignores Left
                        only/Right only surround (loRoSurroundMixLevel).

                        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left total/Right total center mix (Lt/Rt
                        center). MediaConvert uses this value for downmixing. How the service uses
                        this value depends on the value that you choose for Stereo downmix
                        (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                        and -60. The value -60 mutes the channel. This setting applies only if you
                        keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                        setting Coding mode (Eac3CodingMode). If you choose a different value for
                        Coding mode, the service ignores Left total/Right total center
                        (ltRtCenterMixLevel).

                        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                        surround). MediaConvert uses this value for downmixing. How the service uses
                        this value depends on the value that you choose for Stereo downmix
                        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                        value -60 mutes the channel. This setting applies only if you keep the
                        default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                        Coding mode (Eac3CodingMode). If you choose a different value for Coding
                        mode, the service ignores Left total/Right total surround
                        (ltRtSurroundMixLevel).

                        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                        metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                        this audio data. If audio was not supplied from one of these streams, then
                        the static metadata settings will be used.

                        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                        audio will be passed through if it is present on the input. this detection
                        is dynamic over the life of the transcode. Inputs that alternate between DD+
                        and non-DD+ content will have a consistent DD+ output as the system
                        alternates between passthrough and encoding.

                        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied
                        to the surround channels. Only used for 3/2 coding mode.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                        - **StereoDownmix** *(string) --* Choose how the service does stereo
                        downmixing. This setting only applies if you keep the default value of 3/2 -
                        L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                        (Eac3CodingMode). If you choose a different value for Coding mode, the
                        service ignores Stereo downmix (Eac3StereoDownmix).

                        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                        extra center back surround channel is matrix encoded into the left and right
                        surround channels.

                        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                        Surround is matrix encoded into the two channels.

                      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value MP2.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                        - **Channels** *(integer) --* Set Channels to specify the number of channels
                        in this output audio track. Choosing Mono in the console will give you 1
                        output channel; choosing Stereo will give you 2. In the API, valid values
                        are 1 and 2.

                        - **SampleRate** *(integer) --* Sample rate in hz.

                      - **WavSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value WAV.

                        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                        sample, to choose the encoding quality for this audio track.

                        - **Channels** *(integer) --* Specify the number of channels in this output
                        audio track. Valid values are 1 and even numbers up to 64. For example, 1,
                        2, 4, 6, and so on, up to 64.

                        - **Format** *(string) --* The service defaults to using RIFF for WAV
                        outputs. If your output audio is likely to exceed 4 GB in file size, or if
                        you otherwise need the extended support of the RF64 format, set your output
                        WAV file format to RF64.

                        - **SampleRate** *(integer) --* Sample rate in Hz.

                    - **CustomLanguageCode** *(string) --* Specify the language for this audio
                    output track. The service puts this language code into your output audio track
                    when you set Language code control (AudioLanguageCodeControl) to Use configured
                    (USE_CONFIGURED). The service also uses your specified custom language code when
                    you set Language code control (AudioLanguageCodeControl) to Follow input
                    (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                    can also use any other code in the full RFC-5646 specification. Streaming
                    outputs are those that are in one of the following output groups: CMAF, DASH
                    ISO, Apple HLS, or Microsoft Smooth Streaming.

                    - **LanguageCode** *(string) --* Indicates the language of the audio output
                    track. The ISO 639 language specified in the 'Language Code' drop down will be
                    used when 'Follow Input Language Code' is not selected or when 'Follow Input
                    Language Code' is selected but there is no ISO 639 language code specified by
                    the input.

                    - **LanguageCodeControl** *(string) --* Specify which source for language code
                    takes precedence for this audio track. When you choose Follow input
                    (FOLLOW_INPUT), the service uses the language code from the input track if it's
                    present. If there's no languge code on the input track, the service uses the
                    code that you specify in the setting Language code (languageCode or
                    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
                    service uses the language code that you specify.

                    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                      group of fields that hold the remixing value for each channel. Units are in
                      dB. Acceptable values are within the range from -60 (mute) through 6. A
                      setting of 0 passes the input channel unchanged to the output channel (no
                      attenuation or amplification).

                        - **OutputChannels** *(list) --* List of output channels

                          - *(dict) --* OutputChannel mapping settings.

                            - **InputChannels** *(list) --* List of input channels

                              - *(integer) --*

                      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                      input that you want to use in your output. With remixing, you might combine or
                      split the data in these channels, so the number of channels in your final
                      output might be different.

                      - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                      after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                    - **StreamName** *(string) --* Specify a label for this output audio stream. For
                    example, "English", "Director commentary", or "track_2". For streaming outputs,
                    MediaConvert passes this information into destination manifests for display on
                    the end-viewer's player device. For outputs in other output groups, the service
                    ignores this setting.

                - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
                captions settings. For each output that has captions, include one instance of
                (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
                settings.

                  - *(dict) --* Description of Caption output

                    - **CaptionSelectorName** *(string) --* Specifies which "Caption
                    Selector":#inputs-caption_selector to use from each input when generating
                    captions. The name should be of the format "Caption Selector ", which denotes
                    that the Nth Caption Selector will be used from each input.

                    - **CustomLanguageCode** *(string) --* Specify the language for this captions
                    output track. For most captions output formats, the encoder puts this language
                    information in the output captions metadata. If your output captions format is
                    DVB-Sub or Burn in, the encoder uses this language information when
                    automatically selecting the font script for rendering the captions text. For all
                    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                    can also use any other code in the full RFC-5646 specification. Streaming
                    outputs are those that are in one of the following output groups: CMAF, DASH
                    ISO, Apple HLS, or Microsoft Smooth Streaming.

                    - **DestinationSettings** *(dict) --* Specific settings required by destination
                    type. Note that burnin_destination_settings are not available if the source of
                    the caption data is Embedded or Teletext.

                      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                        - **Alignment** *(string) --* If no explicit x_position or y_position is
                        provided, setting alignment to centered will place the captions at the
                        bottom center of the output. Similarly, setting a left alignment will align
                        captions to the bottom left of the output. If x and y positions are given in
                        conjunction with the alignment parameter, the font will be justified (either
                        left or centered) relative to those coordinates. This option is not valid
                        for source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                        behind the captions. All burn-in and DVB-Sub font settings must match.

                        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                        background rectangle. 255 is opaque; 0 is transparent. Leaving this
                        parameter blank is equivalent to setting it to 0 (transparent). All burn-in
                        and DVB-Sub font settings must match.

                        - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                        This option is not valid for source captions that are STL, 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                        captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                        settings must match.

                        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                        default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                        - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                        script code, if the LanguageCode is not sufficient for determining the
                        script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                        "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                        font for rendering burn-in captions.

                        - **FontSize** *(integer) --* A positive integer indicates the exact font
                        size in points. Set to 0 for automatic font size selection. All burn-in and
                        DVB-Sub font settings must match.

                        - **OutlineColor** *(string) --* Specifies font outline color. This option
                        is not valid for source captions that are either 608/embedded or teletext.
                        These source settings are already pre-defined by the caption stream. All
                        burn-in and DVB-Sub font settings must match.

                        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                        option is not valid for source captions that are either 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                        the captions. All burn-in and DVB-Sub font settings must match.

                        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255
                        is opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                        setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                        match.

                        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                        must match.

                        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels above the text. All burn-in and DVB-Sub font settings
                        must match.

                        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                        in Teletext or STL formats. Specify whether the spacing between letters in
                        your captions is set by the captions grid or varies depending on letter
                        width. Choose fixed grid to conform to the spacing specified in the captions
                        file more accurately. Choose proportional to make the text easier to read if
                        the captions are closed caption.

                        - **XPosition** *(integer) --* Specifies the horizontal position of the
                        caption relative to the left side of the output in pixels. A value of 10
                        would result in the captions starting 10 pixels from the left of the output.
                        If no explicit x_position is provided, the horizontal caption position will
                        be determined by the alignment parameter. This option is not valid for
                        source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **YPosition** *(integer) --* Specifies the vertical position of the
                        caption relative to the top of the output in pixels. A value of 10 would
                        result in the captions starting 10 pixels from the top of the output. If no
                        explicit y_position is provided, the caption will be positioned towards the
                        bottom of the output. This option is not valid for source captions that are
                        STL, 608/embedded or teletext. These source settings are already pre-defined
                        by the caption stream. All burn-in and DVB-Sub font settings must match.

                      - **DestinationType** *(string) --* Specify the format for this set of
                      captions on this output. The default format is embedded without SCTE-20. Other
                      options are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext,
                      TTML, and web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                      (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
                      spec. To create a non-compliant output where the embedded captions come first,
                      choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                        - **Alignment** *(string) --* If no explicit x_position or y_position is
                        provided, setting alignment to centered will place the captions at the
                        bottom center of the output. Similarly, setting a left alignment will align
                        captions to the bottom left of the output. If x and y positions are given in
                        conjunction with the alignment parameter, the font will be justified (either
                        left or centered) relative to those coordinates. This option is not valid
                        for source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                        behind the captions. All burn-in and DVB-Sub font settings must match.

                        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                        background rectangle. 255 is opaque; 0 is transparent. Leaving this
                        parameter blank is equivalent to setting it to 0 (transparent). All burn-in
                        and DVB-Sub font settings must match.

                        - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                        This option is not valid for source captions that are STL, 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                        captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                        settings must match.

                        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                        default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                        - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                        script code, if the LanguageCode is not sufficient for determining the
                        script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                        "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                        font for rendering DVB-Sub captions.

                        - **FontSize** *(integer) --* A positive integer indicates the exact font
                        size in points. Set to 0 for automatic font size selection. All burn-in and
                        DVB-Sub font settings must match.

                        - **OutlineColor** *(string) --* Specifies font outline color. This option
                        is not valid for source captions that are either 608/embedded or teletext.
                        These source settings are already pre-defined by the caption stream. All
                        burn-in and DVB-Sub font settings must match.

                        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                        option is not valid for source captions that are either 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                        the captions. All burn-in and DVB-Sub font settings must match.

                        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255
                        is opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                        setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                        match.

                        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                        must match.

                        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels above the text. All burn-in and DVB-Sub font settings
                        must match.

                        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                        standard or for hearing impaired. Choose hearing impaired if your subtitles
                        include audio descriptions and dialogue. Choose standard if your subtitles
                        include only dialogue.

                        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                        in Teletext or STL formats. Specify whether the spacing between letters in
                        your captions is set by the captions grid or varies depending on letter
                        width. Choose fixed grid to conform to the spacing specified in the captions
                        file more accurately. Choose proportional to make the text easier to read if
                        the captions are closed caption.

                        - **XPosition** *(integer) --* Specifies the horizontal position of the
                        caption relative to the left side of the output in pixels. A value of 10
                        would result in the captions starting 10 pixels from the left of the output.
                        If no explicit x_position is provided, the horizontal caption position will
                        be determined by the alignment parameter. This option is not valid for
                        source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **YPosition** *(integer) --* Specifies the vertical position of the
                        caption relative to the top of the output in pixels. A value of 10 would
                        result in the captions starting 10 pixels from the top of the output. If no
                        explicit y_position is provided, the caption will be positioned towards the
                        bottom of the output. This option is not valid for source captions that are
                        STL, 608/embedded or teletext. These source settings are already pre-defined
                        by the caption stream. All burn-in and DVB-Sub font settings must match.

                      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                      embedded/ancillary caption outputs, including 608/708 Channel destination
                      number.

                        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                        your input captions are SCC format and your output captions are embedded in
                        the video stream. Specify a CC number for each captions channel in this
                        output. If you have two channels, choose CC numbers that aren't in the same
                        field. For example, choose 1 and 3. For more information, see
                        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                        your input captions are SCC format and you want both 608 and 708 captions
                        embedded in your output stream. Optionally, specify the 708 service number
                        for each output captions channel. Choose a different number for each
                        channel. To use this setting, also set Force 608 to 708 upconvert
                        (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
                        settings. If you choose to upconvert but don't specify a 708 service number,
                        MediaConvert uses the number that you specify for CC channel number
                        (destination608ChannelNumber) for the 708 service number. For more
                        information, see
                        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                      outputs.

                        - **StylePassthrough** *(string) --* Keep this setting enabled to have
                        MediaConvert use the font style and position information from the captions
                        source in the output. This option is available only when your input captions
                        are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                        output captions.

                      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to
                        make sure that the captions and the video are synchronized in the output.
                        Specify a frame rate that matches the frame rate of the associated video. If
                        the video frame rate is 29.97, choose 29.97 dropframe
                        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
                        drop_frame_timecode=
                            true; otherwise, choose 29.97 non-dropframe
                        (FRAMERATE_29_97_NON_DROPFRAME).

                      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                      output

                        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number
                        for the destination captions for this output. This value must be a
                        three-digit hexadecimal string; strings ending in -FF are invalid. If you
                        are passing through the entire set of Teletext data, do not use this field.

                        - **PageTypes** *(list) --* Specify the page types for this Teletext page.
                        If you don't specify a value here, the service sets the page type to the
                        default value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire
                        set of Teletext data, don't use this field. When you pass through a set of
                        Teletext pages, your output has the same page types as your input.

                          - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                          Table 94

                      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                      outputs, including Pass style information (TtmlStylePassthrough).

                        - **StylePassthrough** *(string) --* Pass through style and position
                        information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                        CFF-TT output or TTML output.

                    - **LanguageCode** *(string) --* Specify the language of this captions output
                    track. For most captions output formats, the encoder puts this language
                    information in the output captions metadata. If your output captions format is
                    DVB-Sub or Burn in, the encoder uses this language information to choose the
                    font language for rendering the captions text.

                    - **LanguageDescription** *(string) --* Specify a label for this set of output
                    captions. For example, "English", "Director commentary", or "track_2". For
                    streaming outputs, MediaConvert passes this information into destination
                    manifests for display on the end-viewer's player device. For outputs in other
                    output groups, the service ignores this setting.

                - **ContainerSettings** *(dict) --* Container specific settings.

                  - **Container** *(string) --* Container for this output. Some containers require a
                  container settings object. If not specified, the default object will be created.

                  - **F4vSettings** *(dict) --* Settings for F4v container

                    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom
                    is relocated to the beginning of the archive as required for progressive
                    downloading. Otherwise it is placed normally at the end.

                  - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to
                  outputs in a File output group when the output's container (ContainerType) is
                  MPEG-2 Transport Stream (M2TS). In these assets, data is organized by the program
                  map table (PMT). Each transport stream program contains subsets of data, including
                  audio, video, and metadata. Each of these subsets of data has a numerical label
                  called a packet identifier (PID). Each transport stream program corresponds to one
                  MediaConvert output. The PMT lists the types of data in a program along with their
                  PID. Downstream systems and players use the program map table to look up the PID
                  for each type of data it accesses and then uses the PIDs to locate specific data
                  within the asset.

                    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                    models for Dolby Digital audio.

                    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                    each PES packet.

                    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                    elementary audio streams you include in this output. Specify multiple PIDs as a
                    JSON array. Default is the range 482-492.

                      - *(integer) --*

                    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream
                    in bits per second. Setting to 0 lets the muxer automatically determine the
                    appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                    - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                    interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                    this can lead to lower latency, but low-memory devices may not be able to play
                    back the stream without interruptions.

                    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                    the specified table repetition interval.

                      - **NetworkId** *(integer) --* The numeric value placed in the Network
                      Information Table (NIT).

                      - **NetworkName** *(string) --* The network name text placed in the
                      network_name_descriptor inside the Network Information Table. Maximum length
                      is 256 characters.

                      - **NitInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                    the specified table repetition interval.

                      - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                      output stream. "Follow input SDT" copies SDT information from input stream to
                      output stream. "Follow input SDT if present" copies SDT information from input
                      stream to output stream if SDT information is present in the input, otherwise
                      it will fall back on the user-defined values. Enter "SDT Manually" means user
                      will enter the SDT information. "No SDT" means output stream will not contain
                      SDT information.

                      - **SdtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **ServiceName** *(string) --* The service name placed in the
                      service_descriptor in the Service Description Table. Maximum length is 256
                      characters.

                      - **ServiceProviderName** *(string) --* The service provider name placed in
                      the service_descriptor in the Service Description Table. Maximum length is 256
                      characters.

                    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                    subtitle data included in this output. Specify multiple PIDs as a JSON array.
                    Default is the range 460-479.

                      - *(integer) --*

                    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                    specified table repetition interval.

                      - **TdtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                    teletext data you include in this output. Default is 499.

                    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS,
                    audio EBP markers will be added to partitions 3 and 4. The interval between
                    these additional markers will be fixed, and will be slightly shorter than the
                    video EBP marker interval. When set to VIDEO_INTERVAL, these additional markers
                    will not be inserted. Only applicable when EBP segmentation markers are is
                    selected (segmentationMarkers is EBP or EBP_LEGACY).

                    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on.
                    They can either be placed only on the video PID, or on both the video PID and
                    all audio PIDs. Only applicable when EBP segmentation markers are is selected
                    (segmentationMarkers is EBP or EBP_LEGACY).

                    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                    the PES header.

                    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                    you know that your audio EBP markers are incorrectly appearing before your video
                    EBP markers. To correct this problem, set this value to Force (FORCE).

                    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                    used with EBP markers.

                    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                    between Program Clock References (PCRs) inserted into the transport stream.

                    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                    Points do not come within the specified time interval of each other by looking
                    ahead at input video. If another EBP is going to come in within the specified
                    time interval, the current EBP is not emitted, and the segment is "stretched" to
                    the next marker. The lookahead value does not add latency to the system. The
                    Live Event must be configured elsewhere to create sufficient latency to make the
                    lookahead accurate.

                    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                    tracking will be detected in the input audio and an equivalent ID3 tag will be
                    inserted in the output.

                    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                    packets to insert into the transport stream. This can be used if a downstream
                    encryption system requires periodic null packets.

                    - **PatInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                    Reference value is inserted for every Packetized Elementary Stream (PES) header.
                    This is effective only when the PCR PID is the same as the video or audio
                    elementary stream.

                    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                    clock reference (PCR) in this output. If you do not specify a value, the service
                    will use the value for Video PID (VideoPid).

                    - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                    instances of the program map table (PMT) in the output transport stream.

                    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                    map table (PMT) itself. Default is 480.

                    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of
                    the private metadata stream. Default is 503.

                    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                    the program number used in the program map table (PMT) for this output. Default
                    is 1. Program numbers and program map tables are parts of MPEG-2 transport
                    stream containers, used for organizing data.

                    - **RateMode** *(string) --* When set to CBR, inserts null packets into
                    transport stream to fill specified bitrate. When set to VBR, the bitrate setting
                    acts as the maximum bitrate, but the output will not be padded up to that
                    bitrate.

                    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                    markers in your HLS and transport stream outputs at the insertion points that
                    you specify in an ESAM XML document. Provide the document in the setting SCC XML
                    (sccXml).

                      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35
                      stream in the transport stream generated by ESAM.

                    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the
                    SCTE-35 stream in the transport stream.

                    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                    Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input
                    to also appear in this output. Choose None (NONE) if you don't want SCTE-35
                    markers in this output. For SCTE-35 markers from an ESAM XML document-- Choose
                    None (NONE). Also provide the ESAM XML as a string in the setting Signal
                    processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
                    property scte35Esam).

                    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                    segmentation_time period. rai_segstart sets the Random Access Indicator bit in
                    the adaptation field. rai_adapt sets the RAI bit and adds the current timecode
                    in the private data bytes. psi_segstart inserts PAT and PMT tables at the start
                    of segments. ebp adds Encoder Boundary Point information to the adaptation field
                    as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
                    Boundary Point information to the adaptation field using a legacy proprietary
                    format.

                    - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                    how segmentation markers are inserted into the transport stream. With avails, it
                    is possible that segments may be truncated, which can influence where future
                    segmentation markers are inserted. When a segmentation style of "reset_cadence"
                    is selected and a segment is truncated due to an avail, we will reset the
                    segmentation cadence. This means the subsequent segment will have a duration of
                    of $segmentation_time seconds. When a segmentation style of "maintain_cadence"
                    is selected and a segment is truncated due to an avail, we will not reset the
                    segmentation cadence. This means the subsequent segment will likely be truncated
                    as well. However, all segments after that will have a duration of
                    $segmentation_time seconds. Note that EBP lookahead is a slight exception to
                    this rule.

                    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                    segment. Required unless markers is set to _none_.

                    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                    timed metadata in this output. Default is 502.

                    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                    itself in the program map table for this output. Transport stream IDs and
                    program map tables are parts of MPEG-2 transport stream containers, used for
                    organizing data.

                    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                    elementary video stream in the transport stream.

                  - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                    each PES packet.

                    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                    stream(s) in the transport stream. Multiple values are accepted, and can be
                    entered in ranges and/or by comma separation.

                      - *(integer) --*

                    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                    tracking will be detected in the input audio and an equivalent ID3 tag will be
                    inserted in the output.

                    - **PatInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                    Reference value is inserted for every Packetized Elementary Stream (PES) header.
                    This parameter is effective only when the PCR PID is the same as the video or
                    audio elementary stream.

                    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock
                    Reference (PCR) in the transport stream. When no value is given, the encoder
                    will assign the same value as the Video PID.

                    - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                    (PMT) in the transport stream.

                    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                    metadata stream in the transport stream.

                    - **ProgramNumber** *(integer) --* The value of the program number field in the
                    Program Map Table.

                    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                    the transport stream.

                    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                    Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input
                    to also appear in this output. Choose None (NONE) if you don't want SCTE-35
                    markers in this output. For SCTE-35 markers from an ESAM XML document-- Choose
                    None (NONE) if you don't want manifest conditioning. Choose Passthrough
                    (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
                    conditioning. In both cases, also provide the ESAM XML as a string in the
                    setting Signal processing notification XML (sccXml).

                    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting
                    to specify whether the service inserts the ID3 timed metadata from the input in
                    this output.

                    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                    metadata stream in the transport stream.

                    - **TransportStreamId** *(integer) --* The value of the transport stream ID
                    field in the Program Map Table.

                    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                    stream in the transport stream.

                  - **MovSettings** *(dict) --* Settings for MOV Container.

                    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate
                    for the video output settings.

                    - **CslgAtom** *(string) --* When enabled, file composition times will start at
                    zero, composition times in the 'ctts' (composition time to sample) box for
                    B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                    will be included per 14496-1 amendment 1. This improves compatibility with Apple
                    players and tools.

                    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                    streams into the QuickTime file using XDCAM fourcc codes. This increases
                    compatibility with Apple editors and players, but may decrease compatibility
                    with other players. Only applicable when the video codec is MPEG2.

                    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                    padding

                    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                    this setting.

                  - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create
                  audio-only AAC outputs with this container.

                    - **CslgAtom** *(string) --* When enabled, file composition times will start at
                    zero, composition times in the 'ctts' (composition time to sample) box for
                    B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                    will be included per 14496-1 amendment 1. This improves compatibility with Apple
                    players and tools.

                    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                    moov box.

                    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom
                    is relocated to the beginning of the archive as required for progressive
                    downloading. Otherwise it is placed normally at the end.

                    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the
                    output file. Usually not necessary to specify.

                  - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                    - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                    groups that include sidecar TTML or IMSC captions. You specify sidecar captions
                    in a separate output from your audio and video. Choose Raw (RAW) for captions in
                    a single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4)
                    for captions in XML format contained within fragmented MP4 files. This set of
                    fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                    markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                    insertion points that you specify in an ESAM XML document. Provide the document
                    in the setting SCC XML (sccXml).

                    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                    markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                    SCTE-35 markers that appear in your input to also appear in this output. Choose
                    None (NONE) if you don't want those SCTE-35 markers in this output.

                - **Extension** *(string) --* Use Extension (Extension) to specify the file
                extension for outputs in File output groups. If you do not specify a value, the
                service will use default extensions by container type as follows * MPEG-2 transport
                stream, m2ts * Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No
                Container, the service will use codec extensions (e.g. AAC, H265, H265, AC3)

                - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the
                service add a string to the end of each output filename. You specify the base
                filename as part of your destination URI. When you create multiple outputs in the
                same output group, Name modifier (NameModifier) is required. Name modifier also
                accepts format identifiers. For DASH ISO outputs, if you use the format identifiers
                $Number$ or $Time$ in one output, you must use them in the same way in all outputs
                of the output group.

                - **OutputSettings** *(dict) --* Specific settings for this type of output.

                  - **HlsSettings** *(dict) --* Settings for HLS output groups

                    - **AudioGroupId** *(string) --* Specifies the group to which the audio
                    Rendition belongs.

                    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                    outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                    container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                    file in a raw container. Regardless of the value that you specify here, if this
                    output has video, the service will place the output into an MPEG2-TS container.

                    - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                    with the video output stream. Input all the audio GROUP-IDs that are associated
                    to the video, separate by ','.

                    - **AudioTrackType** *(string) --* Four types of audio-only tracks are
                    supported: Audio-Only Variant Stream The client can play back this audio-only
                    stream instead of video in low-bandwidth scenarios. Represented as an
                    EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select, Default
                    Alternate rendition that the client should try to play back by default.
                    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                        YES,
                    AUTOSELECT=
                        YES Alternate Audio, Auto Select, Not Default Alternate rendition
                    that the client may try to play back by default. Represented as an EXT-X-MEDIA
                    in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                        YES Alternate Audio, not Auto
                    Select Alternate rendition that the client will not try to play back by default.
                    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                        NO, AUTOSELECT=NO

                    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                    Manifest in addition to the HLS manifest

                    - **SegmentModifier** *(string) --* String concatenated to end of segment
                    filenames. Accepts "Format Identifiers":#format_identifier_parameters.

                - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
                transcoding settings. Provide the system or custom preset name. You can specify
                either Preset (Preset) or Container settings (ContainerSettings), but not both.

                - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
                encoding settings. The specific video settings depend on the video codec that you
                choose when you specify a value for Video codec (codec). Include one instance of
                (VideoDescription) per output.

                  - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                  MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                  service includes AFD values in the output video data and what those values are. *
                  Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                  input AFD values and instead encode the value specified in the job. * Choose Auto
                  to calculate output AFD values based on the input AFD scaler data.

                  - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to
                  all outputs. The service no longer accepts the value DISABLED for AntiAlias. If
                  you specify that in your job, the service will ignore the setting.

                  - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                  (VideoDescription), contains the group of settings related to video encoding. The
                  settings in this group vary depending on the value that you choose for Video codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * H_264,
                  H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings
                  * FRAME_CAPTURE, FrameCaptureSettings

                    - **Codec** *(string) --* Specifies the video codec. This must be equal to one
                    of the enum values defined by the object VideoCodec.

                    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                      - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                      frame of the output stream, then one frame every
                      framerateDenominator/framerateNumerator seconds. For example, settings of
                      framerateNumerator = 1 and framerateDenominator =
                           3 (a rate of 1/3 frame per
                      second) will capture the first frame, then 1 frame every 3s. Files will be
                      named as filename.n.jpg where n is the 0-based sequence number of each
                      Capture.

                      - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                      frame of the output stream, then one frame every
                      framerateDenominator/framerateNumerator seconds. For example, settings of
                      framerateNumerator = 1 and framerateDenominator =
                           3 (a rate of 1/3 frame per
                      second) will capture the first frame, then 1 frame every 3s. Files will be
                      named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number
                      zero padded to 7 decimal places.

                      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg
                      output files).

                      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                      quality.

                    - **H264Settings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value H_264.

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                      your output video settings. If you aren't sure what level to specify, choose
                      Auto (AUTO).

                      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                      are only available with the AVC-I License.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be
                      in Main or High profile) or CAVLC.

                      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                      for interlaced outputs.

                      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame to reduce flicker or 'pop' on I-frames.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job specification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* When you use the API for transcode
                      jobs that use frame rate conversion, specify the frame rate as a fraction. For
                      example, 24000 / 1001 =
                           23.976 fps. Use FramerateDenominator to specify the
                      denominator of this fraction. In this example, use 1001 for the value of
                      FramerateDenominator. When you use the console for transcode jobs that use
                      frame rate conversion, provide the value as a decimal number for Framerate. In
                      this example, specify 23.976.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                      structures that have B frames > 1.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type, as follows. - If the source is interlaced, the output will be
                      interlaced with the same polarity as the source (it will follow the source).
                      The output could therefore be a mix of "top field first" and "bottom field
                      first". - If the source is progressive, the output will be interlaced with
                      "top field first" or "bottom field first" polarity, depending on which of the
                      Follow options you chose.

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000. Required when Rate control mode is
                      QVBR.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                      The encoder may use more than requested if using B-frames and/or interlaced
                      encoding.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                      high-quality singlepass, or high-quality multipass video encoding.

                      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                      encoding with the H.264 codec. Required when you set Rate control mode to
                      QVBR. Not valid when you set Rate control mode to a value other than QVBR, or
                      when you don't define Rate control mode.

                        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                        control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                        average bitrate values suited to the complexity of your input video, the
                        service limits the average bitrate of the video part of this output to the
                        value that you choose. That is, the total size of the video element is less
                        than or equal to the value you set multiplied by the number of seconds of
                        encoded output.

                        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                        control mode. That is, when you specify qvbrSettings within h264Settings.
                        Specify the target quality level for this output, from 1 to 10. Use higher
                        numbers for greater quality. Level 10 results in nearly lossless
                        compression. The quality level for most broadcast-quality transcodes is
                        between 6 and 9.

                      - **RateControlMode** *(string) --* Use this setting to specify whether this
                      output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                      variable bitrate (QVBR).

                      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture,
                      even if repeated.

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default. If this output uses QVBR, choose Transition
                      detection (TRANSITION_DETECTION) for further video quality improvement. For
                      more information about QVBR, see
                      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                      - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                      equal to the number of macroblock rows for progressive pictures, and less than
                      or equal to half the number of macroblock rows for interlaced pictures.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                      values reduce high-frequency content in the encoded image.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                      - **Telecine** *(string) --* This field applies only if the Streams > Advanced
                      > Framerate (framerate) field is set to 29.970. This field works with the
                      Streams > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and
                      the Streams > Advanced > Interlaced Mode field (interlace_mode) to identify
                      the scan type for the output: Progressive, Interlaced, Hard Telecine or Soft
                      Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
                      23.976; the player converts this output to 29.97i.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as
                      4 bytes of an unregistered SEI message.

                    - **H265Settings** *(dict) --* Settings for H265 codec

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                      Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                      Transfer Function (EOTF).

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* H.265 Level.

                      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                      (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                      "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                      available with the HEVC 4:2:2 License.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame to reduce flicker or 'pop' on I-frames.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                      structures that have B frames > 1.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                      Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                      the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom
                      Field First (BOTTOM_FIELD) to create an output that's interlaced with the same
                      field polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or
                      Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output
                      with the same field polarity as the source. If the source is interlaced, the
                      output will be interlaced with the same polarity as the source (it will follow
                      the source). The output could therefore be a mix of "top field first" and
                      "bottom field first". If the source is progressive, your output will be
                      interlaced with "top field first" or "bottom field first" polarity, depending
                      on which of the Follow options you chose. If you don't choose a value, the
                      service will default to Progressive (PROGRESSIVE).

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000. Required when Rate control mode is
                      QVBR.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                      The encoder may use more than requested if using B-frames and/or interlaced
                      encoding.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                      high-quality singlepass, or high-quality multipass video encoding.

                      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                      encoding with the H.265 codec. Required when you set Rate control mode to
                      QVBR. Not valid when you set Rate control mode to a value other than QVBR, or
                      when you don't define Rate control mode.

                        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                        control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                        average bitrate values suited to the complexity of your input video, the
                        service limits the average bitrate of the video part of this output to the
                        value that you choose. That is, the total size of the video element is less
                        than or equal to the value you set multiplied by the number of seconds of
                        encoded output.

                        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                        control mode. That is, when you specify qvbrSettings within h265Settings.
                        Specify the target quality level for this output, from 1 to 10. Use higher
                        numbers for greater quality. Level 10 results in nearly lossless
                        compression. The quality level for most broadcast-quality transcodes is
                        between 6 and 9.

                      - **RateControlMode** *(string) --* Use this setting to specify whether this
                      output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                      variable bitrate (QVBR).

                      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                      Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                      based on content

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default. If this output uses QVBR, choose Transition
                      detection (TRANSITION_DETECTION) for further video quality improvement. For
                      more information about QVBR, see
                      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                      - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                      equal to the number of macroblock rows for progressive pictures, and less than
                      or equal to half the number of macroblock rows for interlaced pictures.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Telecine** *(string) --* This field applies only if the Streams > Advanced
                      > Framerate (framerate) field is set to 29.970. This field works with the
                      Streams > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and
                      the Streams > Advanced > Interlaced Mode field (interlace_mode) to identify
                      the scan type for the output: Progressive, Interlaced, Hard Telecine or Soft
                      Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
                      23.976; the player converts this output to 29.97i.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                      encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                      and P-frames form one layer, reference B-frames can form a second layer and
                      non-reference b-frames can form a third layer. Decoders can optionally decode
                      only the lower temporal layers to generate a lower frame rate output. For
                      example, given a bitstream with temporal IDs and with b-frames = 1 (i.e.
                      IbPbPb display order), a decoder could decode all the frames for full frame
                      rate output or only the I and P frames (lowest temporal layer) for a half
                      frame rate output.

                      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                      vertical subdivision of the encoded pictures.

                      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as
                      4 bytes of an unregistered SEI message.

                      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                      units doesn't matter in your workflow, ignore this setting. Use this setting
                      only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                      container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                      your output compliant with the following specification: ISO IECJTC1 SC29
                      N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service
                      stores parameter set NAL units in the sample headers but not in the samples
                      directly. For MP4 outputs, when you choose HVC1, your output video might not
                      work properly with some downstream systems and video players. The service
                      defaults to marking your output as HEV1. For these outputs, the service writes
                      parameter set NAL units directly into the samples.

                    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value MPEG2.

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                      level for the video output.

                      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                      MPEG-2 profile for the video output.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type. - If the source is interlaced, the output will be interlaced with
                      the same polarity as the source (it will follow the source). The output could
                      therefore be a mix of "top field first" and "bottom field first". - If the
                      source is progressive, the output will be interlaced with "top field first" or
                      "bottom field first" polarity, depending on which of the Follow options you
                      chose.

                      - **IntraDcPrecision** *(string) --* Use Intra DC precision
                      (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                      coefficients. If you choose the value auto, the service will automatically
                      select the precision based on the per-frame compression ratio.

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                      video encoding.

                      - **RateControlMode** *(string) --* Use Rate control mode
                      (Mpeg2RateControlMode) to specifiy whether the bitrate is variable (vbr) or
                      constant (cbr).

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                      values reduce high-frequency content in the encoded image.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                      356M-2001).

                      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                      Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard)
                      to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                      produce 23.976 output and leave converstion to the player.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                    - **ProresSettings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value PRORES.

                      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                      the type of Apple ProRes codec to use for this output.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* When you use the API for transcode
                      jobs that use frame rate conversion, specify the frame rate as a fraction. For
                      example, 24000 / 1001 =
                           23.976 fps. Use FramerateNumerator to specify the
                      numerator of this fraction. In this example, use 24000 for the value of
                      FramerateNumerator.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type. - If the source is interlaced, the output will be interlaced with
                      the same polarity as the source (it will follow the source). The output could
                      therefore be a mix of "top field first" and "bottom field first". - If the
                      source is progressive, the output will be interlaced with "top field first" or
                      "bottom field first" polarity, depending on which of the Follow options you
                      chose.

                      - **ParControl** *(string) --* Use (ProresParControl) to specify how the
                      service determines the pixel aspect ratio. Set to Follow source
                      (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio from the input. To
                      specify a different pixel aspect ratio: Using the console, choose it from the
                      dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide
                      for (ParNumerator) and (ParDenominator).

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                      Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard)
                      to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                      produce 23.976 output and leave converstion to the player.

                  - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to
                  include color metadata in this output. Choose Ignore (IGNORE) to exclude color
                  metadata from this output. If you don't specify a value, the service sets this to
                  Insert by default.

                  - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area
                  that the service will include in the output video frame.

                    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                    numbers.

                    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                    numbers.

                    - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                    left edge of the video frame. Specify only even numbers.

                    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                    top edge of the video frame. Specify only even numbers.

                  - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                  feature is enabled, the service will use drop-frame timecode on outputs. If it is
                  not possible to use drop-frame timecode, the system will fall back to
                  non-drop-frame. This setting is enabled by default when Timecode insertion
                  (TimecodeInsertion) is enabled.

                  - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling)
                  to Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                  service will write on all frames of this video output.

                  - **Height** *(integer) --* Use the Height (Height) setting to define the video
                  resolution height for this output. Specify in pixels. If you don't provide a value
                  here, the service will use the input height.

                  - **Position** *(dict) --* Use Selection placement (position) to define the video
                  area in your output frame. The area outside of the rectangle that you specify here
                  is black.

                    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                    numbers.

                    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                    numbers.

                    - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                    left edge of the video frame. Specify only even numbers.

                    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                    top edge of the video frame. Specify only even numbers.

                  - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                  the service changes the video itself in response to AFD values in the input. *
                  Choose Respond to clip the input video frame according to the AFD value, input
                  display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                  include the input AFD values. Do not choose this when AfdSignaling is set to
                  (NONE). A preferred implementation of this workflow is to set RespondToAfd to
                  (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
                  values from this output.

                  - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                  have a different aspect ratio from the input aspect ratio. Choose Stretch to
                  output (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit.
                  Keep the setting Default (DEFAULT) to have the service letterbox your video
                  instead. This setting overrides any value that you specify for the setting
                  Selection placement (position) in this output.

                  - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                  strength of anti-aliasing. This setting changes the width of the anti-alias filter
                  kernel used for scaling. Sharpness only applies if your output resolution is
                  different from your input resolution. 0 is the softest setting, 100 the sharpest,
                  and 50 recommended for most content.

                  - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                  ProRes outputs. Only enable Timecode insertion when the input frame rate is
                  identical to the output frame rate. To include timecodes in this output, set
                  Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                  set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                  output, by default, it uses any embedded timecodes from the input. If none are
                  present, the service will set the timecode for the first output frame to zero. To
                  change this default behavior, adjust the settings under Timecode configuration
                  (TimecodeConfig). In the console, these settings are located under Job > Job
                  settings > Timecode configuration. Note - Timecode source under input settings
                  (InputTimecodeSource) does not affect the timecodes that are inserted in the
                  output. Source under Job settings > Timecode configuration (TimecodeSource) does.

                  - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                  Preprocessors (VideoPreprocessors). Enable the features at each output
                  individually. These features are disabled by default.

                    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                    feature if necessary. Enable or disable this feature for each output
                    individually. This setting is disabled by default.

                      - **Brightness** *(integer) --* Brightness level.

                      - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                      this output. The service supports conversion between HDR formats, between SDR
                      formats, and from SDR to HDR. The service doesn't support conversion from HDR
                      to SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                      video has an HDR format, but visually appears the same as an unconverted
                      output.

                      - **Contrast** *(integer) --* Contrast level.

                      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                      10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume
                      static metadata that you want signaled in the output. These values don't
                      affect the pixel values that are encoded in the video stream. They are
                      intended to help the downstream video player display content in a way that
                      reflects the intentions of the the content creator. When you set Color space
                      conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are
                      required. You must set values for Max frame average light level
                      (maxFrameAverageLightLevel) and Max content light level
                      (maxContentLightLevel); these settings don't have a default value. The default
                      values for the other HDR 10 metadata settings are defined by the P3D65 color
                      space. For more information about MediaConvert HDR jobs, see
                      https://docs.aws.amazon.com/console/mediaconvert/hdr.

                        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                        samples in the coded video sequence, in units of candelas per square meter.
                        This setting doesn't have a default value; you must specify a value that is
                        suitable for the content.

                        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level
                        of any frame in the coded video sequence, in units of candelas per square
                        meter. This setting doesn't have a default value; you must specify a value
                        that is suitable for the content.

                        - **MaxLuminance** *(integer) --* Nominal maximum mastering display
                        luminance in units of of 0.0001 candelas per square meter.

                        - **MinLuminance** *(integer) --* Nominal minimum mastering display
                        luminance in units of of 0.0001 candelas per square meter

                        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **WhitePointX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **WhitePointY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                      - **Hue** *(integer) --* Hue in degrees.

                      - **Saturation** *(integer) --* Saturation level.

                    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce
                    smoother motion and a clearer picture.

                      - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                      (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                      adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                      (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER)
                      if your source file includes a ticker, such as a scrolling headline at the
                      bottom of the frame.

                      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                      does not convert frames that are tagged in metadata as progressive. It will
                      only convert those that are tagged as some other type. - When set to
                      FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                      those that are already tagged as progressive. Turn Force mode on only if there
                      is a good chance that the metadata has tagged frames as progressive when they
                      are not progressive. Do not turn on otherwise; processing frames that are
                      already progressive into progressive will probably result in lower quality
                      video.

                      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                      service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                      interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                      progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby
                    Vision compatible video output.

                      - **L6Metadata** *(dict) --* Use these settings when you set
                      DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                      your input with new values.

                        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                        that corresponds to the brightest pixel in the entire stream. Measured in
                        nits.

                        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                        metadata that corresponds to the highest frame-average brightness in the
                        entire stream. Measured in nits.

                      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service
                      will handle Dolby Vision MaxCLL and MaxFALL properies.

                      - **Profile** *(string) --* In the current MediaConvert implementation, the
                      Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs
                      must contain Dolby Vision frame interleaved data.

                    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter)
                    feature to include a graphic overlay on your video. Enable or disable this
                    feature for each output individually. This setting is disabled by default.

                      - **InsertableImages** *(list) --* Specify the images that you want to overlay
                      on your video. The images must be PNG or TGA files.

                        - *(dict) --* Settings that specify how your still graphic overlay appears.

                          - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                          image to remain on the output video. This duration includes fade-in time
                          but not fade-out time.

                          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                          between the Start time that you specify for the image insertion and the
                          time that the image appears at full opacity. Full opacity is the level
                          that you specify for the opacity setting. If you don't specify a value for
                          Fade-in, the image will appear abruptly at the overlay start time.

                          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                          between the end of the time that you have specified for the image overlay
                          Duration and when the overlaid image has faded to total transparency. If
                          you don't specify a value for Fade-out, the image will disappear abruptly
                          at the end of the inserted image duration.

                          - **Height** *(integer) --* Specify the height of the inserted image in
                          pixels. If you specify a value that's larger than the video resolution
                          height, the service will crop your overlaid image to fit. To use the
                          native height of the image, keep this setting blank.

                          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon
                          S3 location of the image that you want to overlay on the video. Use a PNG
                          or TGA file.

                          - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                          inserted image and the left edge of the video frame. Required for any
                          image overlay that you specify.

                          - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                          overlaid image and the top edge of the video frame. Required for any image
                          overlay that you specify.

                          - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                          Images with higher values for Layer appear on top of images with lower
                          values for Layer.

                          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                          the underlying video shows through the inserted image. 0 is transparent
                          and 100 is fully opaque. Default is 50.

                          - **StartTime** *(string) --* Specify the timecode of the frame that you
                          want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                          or HH:MM:SS;FF) format. Remember to take into account your timecode source
                          settings.

                          - **Width** *(integer) --* Specify the width of the inserted image in
                          pixels. If you specify a value that's larger than the video resolution
                          width, the service will crop your overlaid image to fit. To use the native
                          width of the image, keep this setting blank.

                    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature
                    to remove noise from your video output if necessary. Enable or disable this
                    feature for each output individually. This setting is disabled by default.

                      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                      select one of the following spatial image filtering functions. To use this
                      setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                      preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                      Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                      reduction. * Spatial does frequency-domain filtering based on JND principles.
                      * Temporal optimizes video quality for complex motion.

                      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                        - **Strength** *(integer) --* Relative strength of noise reducing filter.
                        Higher values produce stronger filtering.

                      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                      spatial filter.

                        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post
                        noise reduction sharpening filter, with 0 disabling the filter and 3
                        enabling it at maximum strength.

                        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to
                        3 (higher speed), with 0 being the nominal value.

                        - **Strength** *(integer) --* Relative strength of noise reducing filter.
                        Higher values produce stronger filtering.

                      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                      temporal filter.

                        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                        complex motion. Higher values produce stronger temporal filtering. This
                        filters highly complex scenes more aggressively and creates better VQ for
                        low bitrate outputs.

                        - **Speed** *(integer) --* The speed of the filter (higher number is
                        faster). Low setting reduces bit rate at the cost of transcode time, high
                        setting improves transcode time at the cost of bit rate.

                        - **Strength** *(integer) --* Specify the strength of the noise reducing
                        filter on this output. Higher values produce stronger filtering. We
                        recommend the following value ranges, depending on the result that you want:
                        * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
                        complexity reduction with image preservation * 8-16 for a high level of
                        complexity reduction

                    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                    output timecode and specified prefix into the output.

                      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                      any burned-in timecode. Valid values are 10, 16, 32, 48.

                      - **Position** *(string) --* Use Position (Position) under under Timecode
                      burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                      output video.

                      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters
                      before any burned-in timecode. For example, a prefix of "EZ-" will result in
                      the timecode "EZ-00:00:00:00". Provide either the characters themselves or the
                      ASCII code equivalents. The supported range of characters is 0x20 through
                      0x7e. This includes letters, numbers, and all special characters represented
                      on a standard English keyboard.

                  - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                  in pixels, for this output. If you don't provide a value here, the service will
                  use the input width.

        - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
        information from inputs.

          - **Anchor** *(string) --* If you use an editing platform that relies on an anchor
          timecode, use Anchor Timecode (Anchor) to specify a timecode that will match the input
          video frame to the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF)
          or (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
          Timecode varies depending on your setting for Source (TimecodeSource). * If Source
          (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
          specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
          (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start
          at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
          Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
          input.

          - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
          within this job. To make sure that your video, audio, captions, and markers are
          synchronized and that time-based features, such as image inserter, work correctly, choose
          the Timecode source option that matches your assets. All timecodes are in a 24-hour format
          with frame number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the
          input video. If no embedded timecode is in the source, the service will use Start at 0
          (ZEROBASED) instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to
          00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to
          a value other than zero. You use Start timecode (Start) to provide this value.

          - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
          (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial
          frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

          - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
          stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
          affecting the time and frame number. Provide the new date as a string in the format
          "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
          (InsertProgramDateTime) in the output settings. For example, if the date part of your
          timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
          (TimestampOffset) to 2003-1-25.

        - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
        (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you
        must enable it here, enable it in each output container, and specify tags and timecodes in
        ID3 insertion (Id3Insertion) objects.

          - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion
          instances.

            - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3)
            to specify the base 64 encoded string and use Timecode (TimeCode) to specify the time
            when the tag should be inserted. To insert multiple ID3 tags in your output, create
            multiple instances of ID3 insertion (Id3Insertion).

              - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
              format.

              - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or
              HH:MM:SS;FF format.

      - **SimulateReservedQueue** *(string) --* Enable this setting when you run a test job to
      estimate how many reserved transcoding slots (RTS) you need. When this is enabled,
      MediaConvert runs your job from an on-demand queue with similar performance to what you will
      see with one RTS in a reserved queue. This setting is disabled by default.

      - **Status** *(string) --* A job's status can be SUBMITTED, PROGRESSING, COMPLETE, CANCELED,
      or ERROR.

      - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
      events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
      MediaConvert sends an update at this interval from the time the service begins processing your
      job to the time it completes the transcode or encounters an error.

      - **Timing** *(dict) --* Information about when jobs are submitted, started, and finished is
      specified in Unix epoch format in seconds.

        - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
        finished

        - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the job
        began.

        - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the job.

      - **UserMetadata** *(dict) --* User-defined metadata that you want to associate with an
      MediaConvert job. You specify metadata in key/value pairs.

        - *(string) --*

          - *(string) --*
    """


_ClientCreateJobSettingsAvailBlankingTypeDef = TypedDict(
    "_ClientCreateJobSettingsAvailBlankingTypeDef", {"AvailBlankingImage": str}, total=False
)


class ClientCreateJobSettingsAvailBlankingTypeDef(_ClientCreateJobSettingsAvailBlankingTypeDef):
    """
    Type definition for `ClientCreateJobSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ClientCreateJobSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ClientCreateJobSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ClientCreateJobSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ClientCreateJobSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsEsam` `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ClientCreateJobSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ClientCreateJobSettingsEsamSignalProcessingNotificationTypeDef", {"SccXml": str}, total=False
)


class ClientCreateJobSettingsEsamSignalProcessingNotificationTypeDef(
    _ClientCreateJobSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsEsam` `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientCreateJobSettingsEsamTypeDef = TypedDict(
    "_ClientCreateJobSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ClientCreateJobSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ClientCreateJobSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsEsamTypeDef(_ClientCreateJobSettingsEsamTypeDef):
    """
    Type definition for `ClientCreateJobSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientCreateJobSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ClientCreateJobSettingsInputsAudioSelectorGroupsTypeDef(
    _ClientCreateJobSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputs` `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsAudioSelectorsRemixSettings` `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsAudioSelectors` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientCreateJobSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ClientCreateJobSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ClientCreateJobSettingsInputsAudioSelectorsTypeDef(
    _ClientCreateJobSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsCaptionSelectors` `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ClientCreateJobSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ClientCreateJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsInputsCaptionSelectorsTypeDef(
    _ClientCreateJobSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputs` `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ClientCreateJobSettingsInputsCropTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobSettingsInputsCropTypeDef(_ClientCreateJobSettingsInputsCropTypeDef):
    """
    Type definition for `ClientCreateJobSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobSettingsInputsDecryptionSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsDecryptionSettingsTypeDef",
    {
        "DecryptionMode": str,
        "EncryptedDecryptionKey": str,
        "InitializationVector": str,
        "KmsKeyRegion": str,
    },
    total=False,
)


class ClientCreateJobSettingsInputsDecryptionSettingsTypeDef(
    _ClientCreateJobSettingsInputsDecryptionSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputs` `DecryptionSettings`

    - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt your
    input files.

    - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
    plaintext. Your job settings could be intercepted, making your encrypted content vulnerable.
    Specify the encrypted version of the data key that you used to encrypt your content. The data
    key must be encrypted by AWS Key Management Service (KMS). The key can be 128, 192, or 256 bits.

    - **InitializationVector** *(string) --* Specify the initialization vector that you used when
    you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
    initialization vector with any encryption mode. Or, you can use a 12-byte initialization vector
    with GCM or CTR. MediaConvert accepts only initialization vectors that are base64-encoded.

    - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service (KMS)
    that you used to encrypt your data key, if that Region is different from the one you are using
    for AWS Elemental MediaConvert.
    """


_ClientCreateJobSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobSettingsInputsImageInserterInsertableImagesTypeDef(
    _ClientCreateJobSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsImageInserter` `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobSettingsInputsImageInserterTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsImageInserterTypeDef",
    {"InsertableImages": List[ClientCreateJobSettingsInputsImageInserterInsertableImagesTypeDef]},
    total=False,
)


class ClientCreateJobSettingsInputsImageInserterTypeDef(
    _ClientCreateJobSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ClientCreateJobSettingsInputsInputClippingsTypeDef(
    _ClientCreateJobSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ClientCreateJobSettingsInputsPositionTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobSettingsInputsPositionTypeDef(_ClientCreateJobSettingsInputsPositionTypeDef):
    """
    Type definition for `ClientCreateJobSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientCreateJobSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ClientCreateJobSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputsVideoSelector` `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientCreateJobSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ClientCreateJobSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ClientCreateJobSettingsInputsVideoSelectorTypeDef(
    _ClientCreateJobSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientCreateJobSettingsInputsTypeDef = TypedDict(
    "_ClientCreateJobSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[str, ClientCreateJobSettingsInputsAudioSelectorGroupsTypeDef],
        "AudioSelectors": Dict[str, ClientCreateJobSettingsInputsAudioSelectorsTypeDef],
        "CaptionSelectors": Dict[str, ClientCreateJobSettingsInputsCaptionSelectorsTypeDef],
        "Crop": ClientCreateJobSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DecryptionSettings": ClientCreateJobSettingsInputsDecryptionSettingsTypeDef,
        "DenoiseFilter": str,
        "FileInput": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ClientCreateJobSettingsInputsImageInserterTypeDef,
        "InputClippings": List[ClientCreateJobSettingsInputsInputClippingsTypeDef],
        "Position": ClientCreateJobSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "SupplementalImps": List[str],
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ClientCreateJobSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsInputsTypeDef(_ClientCreateJobSettingsInputsTypeDef):
    """
    Type definition for `ClientCreateJobSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you encrypt
    before you upload them to Amazon S3. MediaConvert can decrypt files only when you use AWS Key
    Management Service (KMS) to encrypt the data key that you use to encrypt your content.

      - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt your
      input files.

      - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
      plaintext. Your job settings could be intercepted, making your encrypted content vulnerable.
      Specify the encrypted version of the data key that you used to encrypt your content. The data
      key must be encrypted by AWS Key Management Service (KMS). The key can be 128, 192, or 256
      bits.

      - **InitializationVector** *(string) --* Specify the initialization vector that you used when
      you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
      initialization vector with any encryption mode. Or, you can use a 12-byte initialization
      vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
      base64-encoded.

      - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service (KMS)
      that you used to encrypt your data key, if that Region is different from the one you are using
      for AWS Elemental MediaConvert.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FileInput** *(string) --* Specify the source file for your transcoding job. You can use
    multiple inputs in a single job. The service concatenates these inputs, in the order that you
    specify them in the job, to create the outputs. If your input format is IMF, specify your input
    by providing the path to your CPL. For example, "s3://bucket/vf/cpl.xml". If the CPL is in an
    incomplete IMP, make sure to use *Supplemental IMPs* (SupplementalImps) to specify any
    supplemental IMPs that contain assets referenced by the CPL.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You need
    supplemental IMPs if the CPL that you're using for your input is in an incomplete IMP. Specify
    either the supplemental IMP directories with a trailing slash or the ASSETMAP.xml files. For
    example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to specify the IMP
    that contains your input CPL, because the service automatically detects it.

      - *(string) --*

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientCreateJobSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ClientCreateJobSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ClientCreateJobSettingsMotionImageInserterFramerateTypeDef(
    _ClientCreateJobSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsMotionImageInserter` `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ClientCreateJobSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ClientCreateJobSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ClientCreateJobSettingsMotionImageInserterOffsetTypeDef(
    _ClientCreateJobSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsMotionImageInserter` `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ClientCreateJobSettingsMotionImageInserterTypeDef = TypedDict(
    "_ClientCreateJobSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ClientCreateJobSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ClientCreateJobSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ClientCreateJobSettingsMotionImageInserterTypeDef(
    _ClientCreateJobSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ClientCreateJobSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ClientCreateJobSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ClientCreateJobSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ClientCreateJobSettingsNielsenConfigurationTypeDef(
    _ClientCreateJobSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ClientCreateJobSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettings` `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettings` `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettings` `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings` `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroups` `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputs` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputs` `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsContainerSettings` `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsContainerSettings` `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsContainerSettings` `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsContainerSettings` `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsContainerSettings` `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsContainerSettings` `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputs` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsOutputSettings` `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {"HlsSettings": ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputs` `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsVideoDescription` `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsVideoDescription` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors` `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors` `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors` `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors` `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors` `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroupsOutputs` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreateJobSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ClientCreateJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ClientCreateJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientCreateJobSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ClientCreateJobSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ClientCreateJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsOutputsTypeDef(
    _ClientCreateJobSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreateJobSettingsOutputGroupsTypeDef = TypedDict(
    "_ClientCreateJobSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ClientCreateJobSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[ClientCreateJobSettingsOutputGroupsOutputsTypeDef],
    },
    total=False,
)


class ClientCreateJobSettingsOutputGroupsTypeDef(_ClientCreateJobSettingsOutputGroupsTypeDef):
    """
    Type definition for `ClientCreateJobSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ClientCreateJobSettingsTimecodeConfigTypeDef = TypedDict(
    "_ClientCreateJobSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ClientCreateJobSettingsTimecodeConfigTypeDef(_ClientCreateJobSettingsTimecodeConfigTypeDef):
    """
    Type definition for `ClientCreateJobSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ClientCreateJobSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ClientCreateJobSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ClientCreateJobSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ClientCreateJobSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ClientCreateJobSettingsTimedMetadataInsertion` `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ClientCreateJobSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ClientCreateJobSettingsTimedMetadataInsertionTypeDef",
    {"Id3Insertions": List[ClientCreateJobSettingsTimedMetadataInsertionId3InsertionsTypeDef]},
    total=False,
)


class ClientCreateJobSettingsTimedMetadataInsertionTypeDef(
    _ClientCreateJobSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ClientCreateJobSettings` `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ClientCreateJobSettingsTypeDef = TypedDict(
    "_ClientCreateJobSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ClientCreateJobSettingsAvailBlankingTypeDef,
        "Esam": ClientCreateJobSettingsEsamTypeDef,
        "Inputs": List[ClientCreateJobSettingsInputsTypeDef],
        "MotionImageInserter": ClientCreateJobSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ClientCreateJobSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ClientCreateJobSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ClientCreateJobSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ClientCreateJobSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ClientCreateJobSettingsTypeDef(_ClientCreateJobSettingsTypeDef):
    """
    Type definition for `ClientCreateJob` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode job.
    There can be multiple inputs add in a job. These inputs will be concantenated together to create
    the output.

      - *(dict) --* Specifies media input

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
        encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when you
        use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt your
        content.

          - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt
          your input files.

          - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
          plaintext. Your job settings could be intercepted, making your encrypted content
          vulnerable. Specify the encrypted version of the data key that you used to encrypt your
          content. The data key must be encrypted by AWS Key Management Service (KMS). The key can
          be 128, 192, or 256 bits.

          - **InitializationVector** *(string) --* Specify the initialization vector that you used
          when you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
          initialization vector with any encryption mode. Or, you can use a 12-byte initialization
          vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
          base64-encoded.

          - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
          (KMS) that you used to encrypt your data key, if that Region is different from the one you
          are using for AWS Elemental MediaConvert.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FileInput** *(string) --* Specify the source file for your transcoding job. You can use
        multiple inputs in a single job. The service concatenates these inputs, in the order that
        you specify them in the job, to create the outputs. If your input format is IMF, specify
        your input by providing the path to your CPL. For example, "s3://bucket/vf/cpl.xml". If the
        CPL is in an incomplete IMP, make sure to use *Supplemental IMPs* (SupplementalImps) to
        specify any supplemental IMPs that contain assets referenced by the CPL.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You
        need supplemental IMPs if the CPL that you're using for your input is in an incomplete IMP.
        Specify either the supplemental IMP directories with a trailing slash or the ASSETMAP.xml
        files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to
        specify the IMP that contains your input CPL, because the service automatically detects it.

          - *(string) --*

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ClientCreateJobTemplateAccelerationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateAccelerationSettingsTypeDef", {"Mode": str}
)


class ClientCreateJobTemplateAccelerationSettingsTypeDef(
    _ClientCreateJobTemplateAccelerationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplate` `AccelerationSettings`

    - **Mode** *(string) --* **[REQUIRED]** Specify the conditions when the service will run your
    job with accelerated transcoding.
    """


_ClientCreateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef",
    {"Mode": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplate` `AccelerationSettings`

    - **Mode** *(string) --* Specify the conditions when the service will run your job with
    accelerated transcoding.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef",
    {"AvailBlankingImage": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsEsam`
    `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsEsam`
    `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsEsamTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ClientCreateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ClientCreateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsEsamTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsEsamTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputs`
    `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectors`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectors`
    `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputs`
    `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsInputsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str, ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef
        ],
        "AudioSelectors": Dict[
            str, ClientCreateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef
        ],
        "CaptionSelectors": Dict[
            str, ClientCreateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef
        ],
        "Crop": ClientCreateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DenoiseFilter": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ClientCreateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef,
        "InputClippings": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef
        ],
        "Position": ClientCreateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ClientCreateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsInputsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsInputsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserter`
    `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserter`
    `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroups`
    `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettings`
    `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef
        ],
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertion`
    `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplateSettings`
    `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ClientCreateJobTemplateResponseJobTemplateSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ClientCreateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef,
        "Esam": ClientCreateJobTemplateResponseJobTemplateSettingsEsamTypeDef,
        "Inputs": List[ClientCreateJobTemplateResponseJobTemplateSettingsInputsTypeDef],
        "MotionImageInserter": ClientCreateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ClientCreateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ClientCreateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ClientCreateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ClientCreateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateSettingsTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponseJobTemplate` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
    job. There can only be one input in a job template. Using the API, you can include multiple
    inputs when referencing a job template.

      - *(dict) --* Specified video input in a template.

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ClientCreateJobTemplateResponseJobTemplateTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseJobTemplateTypeDef",
    {
        "AccelerationSettings": ClientCreateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef,
        "Arn": str,
        "Category": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "Priority": int,
        "Queue": str,
        "Settings": ClientCreateJobTemplateResponseJobTemplateSettingsTypeDef,
        "StatusUpdateInterval": str,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobTemplateResponseJobTemplateTypeDef(
    _ClientCreateJobTemplateResponseJobTemplateTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateResponse` `JobTemplate`

    - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
    with long, visually complex content.

      - **Mode** *(string) --* Specify the conditions when the service will run your job with
      accelerated transcoding.

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **Category** *(string) --* An optional category you create to organize your job templates.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for Job template creation.

    - **Description** *(string) --* An optional description you create for each job template.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the Job template was last
    updated.

    - **Name** *(string) --* A name you create for each job template. Each name must be unique
    within your account.

    - **Priority** *(integer) --* Relative priority on the job.

    - **Queue** *(string) --* Optional. The queue that jobs created from this template are assigned
    to. If you don't specify this, jobs will go to the default queue.

    - **Settings** *(dict) --* JobTemplateSettings contains all the transcode settings saved in the
    template that will be applied to jobs created from it.

      - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
      the input Ad Avail PTS time.

      - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
      overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

        - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
        black. Only bmp and png images are supported.

      - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

        - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
        ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
        uses the manifest conditioning instructions that you provide in the setting MCC XML
        (mccXml).

          - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
          document inside your JSON job settings. Form the XML document as per
          OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions
          in the message that you supply.

        - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
        between the SCTE 35 messages that the transcoder places and the splice points that they
        refer to. If the time between the start of the asset and the SCTE-35 message is less than
        this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

        - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
        SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
        signal processing instructions that you provide in the setting SCC XML (sccXml).

          - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
          inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
          transcoder will use the signal processing instructions in the message that you supply.
          Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
          For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
          insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
          (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
          passthrough. You can't do both.

      - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
      job. There can only be one input in a job template. Using the API, you can include multiple
      inputs when referencing a job template.

        - *(dict) --* Specified video input in a template.

          - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
          combine. An input may have multiple audio selector groups. See "Audio Selector
          Group":#inputs-audio_selector_group for more information.

            - *(string) --*

              - *(dict) --* Group of Audio Selectors

                - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
                to include in the group. Audio selector names are standardized, based on their order
                within the input (e.g., "Audio Selector 1"). The audio selector name parameter can
                be repeated to add any number of audio selectors to the group.

                  - *(string) --*

          - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
          or set of tracks from the input that you will use in your outputs. You can use mutiple
          Audio selectors per input.

            - *(string) --*

              - *(dict) --* Selector for Audio

                - **CustomLanguageCode** *(string) --* Selects a specific language code from within
                an audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                set it as the default for the job. The service uses this default for outputs where
                it can't find the specified input audio. If you don't set a default, those outputs
                have no audio.

                - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                file source.

                - **LanguageCode** *(string) --* Selects a specific language code from within an
                audio source.

                - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                audio from the input video.

                - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
                selects PID 0x101).

                  - *(integer) --*

                - **ProgramSelection** *(integer) --* Use this setting for input streams that
                contain Dolby E, to have the service extract specific program data from the track.
                To select multiple programs, create multiple selectors with the same Track and
                different Program numbers. In the console, this setting is visible when you set
                Selector type to Track. Choose the program number from the dropdown list. If you are
                sending a JSON file, provide the program ID, which is part of the audio metadata. If
                your input file has incorrect metadata, you can choose All channels instead of a
                program number to have the service ignore the program IDs and include all the
                programs in the track.

                - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
                one input to match those of another input. This allows you to combine the two files
                into a single output, one after the other.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **SelectorType** *(string) --* Specifies the type of the audio selector.

                - **Tracks** *(list) --* Identify a track from the input audio to include in this
                selector by entering the track index number. To include several tracks in a single
                audio selector, specify multiple tracks as follows. Using the console, enter a
                comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                Specifying directly in your JSON job file, provide the track numbers in an array.
                For example, "tracks": [1,2,3].

                  - *(integer) --*

          - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
          the captions data from the input that you will use in your outputs. You can use mutiple
          captions selectors per input.

            - *(string) --*

              - *(dict) --* Set up captions in your outputs by first selecting them from your input
              here.

                - **CustomLanguageCode** *(string) --* The specific language to extract from source,
                using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
                complete this field and/or PID to select the caption language to extract. If input
                is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
                select the caption language to extract. If input is DVB-Sub that is being passed
                through, omit this field (and PID field); there is no way to extract a specific
                language with pass-through captions.

                - **LanguageCode** *(string) --* The specific language to extract from source. If
                input is SCTE-27, complete this field and/or PID to select the caption language to
                extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
                and/or PID to select the caption language to extract. If input is DVB-Sub that is
                being passed through, omit this field (and PID field); there is no way to extract a
                specific language with pass-through captions.

                - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                    number in the ancillary data track from which to extract captions. Unused for
                    passthrough.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                    PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content
                    is passed through, regardless of selectors.

                  - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                    within the video track from which to extract captions. Unused for passthrough.

                    - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                    for extracting captions. The system only supports one input video track, so this
                    should always be set to '1'.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                  STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source
                  file. If your caption source is IMSC in an IMF package, use TrackSourceSettings
                  instead of FileSoureSettings.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceFile** *(string) --* External caption file used for loading captions.
                    Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                    'smi'.

                    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                    captions from the source file.

                  - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                  your input captions. The service cannot auto-detect caption format.

                  - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                  sources, including Page number.

                    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                    three-digit hexadecimal page number that will be used for Teletext captions. Do
                    not use this setting if you are passing through teletext from the input source
                    to output.

                  - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                  are specified by track number. Currently, this is only IMSC captions in an IMF
                  package. If your caption source is IMSC 1.1 in a separate xml file, use
                  FileSourceSettings instead of TrackSourceSettings.

                    - **TrackNumber** *(integer) --* Use this setting to select a single captions
                    track from a source. Track numbers correspond to the order in the captions
                    source file. For IMF sources, track numbering is based on the order that the
                    captions appear in the CPL. For example, use 1 to select the captions asset that
                    is listed first in the CPL. To include more than one captions track in your job
                    outputs, create multiple input captions selectors. Specify one track per
                    selector.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame. If you specify a value here, it will
          override any value that you specify in the output setting Cropping selection (crop).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
          motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
          uncompressed video inputs.

          - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
          the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
          video inputs.

          - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
          transcoding service applies the denoise and deblock filters. You must also enable the
          filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
          Auto - The transcoding service determines whether to apply filtering, depending on input
          type and quality. * Disable - The input is not filtered. This is true even if you use the
          API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put
          is filtered regardless of input type.

          - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
          magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
          is 0.

          - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
          overlay on your video. Enable or disable this feature for each input individually. This
          setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
          that together specify a portion of the input to be used in the outputs. If you provide
          only a start time, the clip will be the entire input from that point to the end. If you
          provide only an end time, it will be the entire input up to that point. When you specify
          more than one input clip, the transcoding service creates the job outputs by stringing the
          clips together in the order you specify them.

            - *(dict) --* To transcode only portions of your input (clips), include one Input
            clipping (one instance of InputClipping in the JSON job file) for each input clip. All
            input clips you specify will be included in every output of the job.

              - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
              portion of the input you are clipping. The frame corresponding to the End timecode
              value is included in the clip. Start timecode or End timecode may be left blank, but
              not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
              minute, SS is the second, and FF is the frame number. When choosing this value, take
              into account your setting for timecode source under input settings
              (InputTimecodeSource). For example, if you have embedded timecodes that start at
              01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

              - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning
              of the portion of the input you are clipping. The frame corresponding to the Start
              timecode value is included in the clip. Start timecode or End timecode may be left
              blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour,
              MM is the minute, SS is the second, and FF is the frame number. When choosing this
              value, take into account your setting for Input timecode source. For example, if you
              have embedded timecodes that start at 01:00:00:00 and you want your clip to begin five
              minutes into the video, use 01:05:00:00.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black. If
          you specify a value here, it will override any value that you specify in the output
          setting Selection placement (position). If you specify a value here, this will override
          any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
          (RESPOND). If you specify a value here, this will ignore anything that you specify for the
          setting Scaling Behavior (scalingBehavior).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
          program from within a multi-program transport stream. Note that Quad 4K is not currently
          supported. Default is the first program within the transport stream. If the program you
          specify doesn't exist, the transcoding service will use this default.

          - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
          inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for
          audio and video. * Use PSI - Scan only PSI data.

          - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
          input settings (InputTimecodeSource), to specify how the service counts input video
          frames. This input frame count affects only the behavior of features that apply to a
          single input at a time, such as input clipping and synchronizing some captions formats.
          Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at zero
          (ZEROBASED) to start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to
          start the first frame at the timecode that you specify in the setting Start timecode
          (timecodeStart). If you don't specify a value for Timecode source, the service will use
          Embedded by default. For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
          for this input's initial frame. To use this setting, you must set the Timecode source
          setting, located under the input settings (InputTimecodeSource), to Specified start
          (SPECIFIEDSTART). For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **VideoSelector** *(dict) --* Selector for video.

            - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
            animation. Specify which part of this input MediaConvert uses for your outputs. Leave
            this setting set to DISCARD in order to delete the alpha channel and preserve the video.
            Use REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the
            luma channel of your outputs.

            - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
            if you don't know about color space, leave this set to the default value Follow
            (FOLLOW). The service will automatically detect your input color space. If your input
            video has metadata indicating the wrong color space, specify the accurate color space
            here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume
            static metadata isn't present in your video stream, or if that metadata is present but
            not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the
            input HDR 10 metadata (Hdr10Metadata) settings. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
            file and the job input settings Color space (ColorSpace) and HDR master display
            information settings(Hdr10Metadata). The Color space usage setting determines which
            takes precedence. Choose Force (FORCE) to use color metadata from the input job
            settings. If you don't specify values for those settings, the service defaults to using
            metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata
            from the source when it is present. If there's no color metadata in your input file, the
            service defaults to using values you specify in the input settings.

            - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
            missing or inaccurate in your input video. Appropriate values vary depending on the
            input video and must be provided by a color grader. The color grader generates these
            values during the HDR 10 mastering process. The valid range for each of these settings
            is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
            settings - When you specify these values, you must also set Color space (ColorSpace) to
            HDR 10 (HDR10). To specify whether the the values you specify here take precedence over
            the values in the metadata of your input file, set Color space usage (ColorSpaceUsage).
            To specify whether color metadata is included in an output, set Color metadata
            (ColorMetadata). For more information about MediaConvert HDR jobs, see
            https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
            Specify this value as an integer; the system automatically converts it to the
            hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
            an identifier for a set of data in an MPEG-2 transport stream container.

            - **ProgramNumber** *(integer) --* Selects a specific program from within a
            multi-program transport stream. Note that Quad 4K is not currently supported.

            - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
            your video. You can choose automatic rotation or specify a rotation. You can specify a
            clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov
            or .mp4 and your input has rotation metadata, you can choose Automatic to have the
            service rotate your video according to the rotation specified in the metadata. The
            rotation must be within one degree of 90, 180, or 270 degrees. If the rotation metadata
            specifies any other rotation, the service will default to no rotation. By default, the
            service does no rotation, even if your input video has rotation metadata. The service
            doesn't pass through rotation metadata.

      - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
      graphics that you specify here appear on all outputs in all output groups.

        - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
        unspecified. If your motion graphic asset is a series of .png files, specify the frame rate
        of the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1.
        Make sure that the number of images in your series matches the frame rate and your intended
        overlay duration. For example, if you want a 30-second overlay at 30 fps, you should have
        900 .png images. This overlay frame rate doesn't need to match the frame rate of the
        underlying video.

          - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

          - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

        - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
        overlay on your video. For .png files, provide the file name of the first file in the
        series. Make sure that the names of the .png files end with sequential numbers that specify
        the order that they are played in. For example, overlay_000.png, overlay_001.png,
        overlay_002.png, and so on. The sequence must start at zero, and each image file name must
        have the same number of digits. Pad your initial file names with enough zeros to complete
        the sequence. For example, if the first image is overlay_0.png, there can be only 10 images
        in the sequence, with the last image being overlay_9.png. But if the first image is
        overlay_00.png, there can be 100 images in the sequence.

        - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
        providing for your overlay. You can choose either a .mov file or a series of .png files.

        - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay
        on the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
        specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
        the service inserts the overlay at its native resolution and scales the size up or down with
        any video scaling.

          - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
          edge of the video frame.

          - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
          edge of the video frame.

        - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
        or plays only once.

        - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
        (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
        account how you have set up your timecode configuration under both job settings and input
        settings. The simplest way to do that is to set both to start at 0. If you need to set up
        your job to follow timecodes embedded in your source that don't start at zero, make sure
        that you specify a start time that is after the first embedded timecode. For more
        information, see https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html
        Find job-wide and input timecode configuration settings in your JSON job settings
        specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

      - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
      do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
      configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs
      in the job. To enable Nielsen configuration programmatically, include an instance of
      nielsenConfiguration in your JSON job specification. Even if you don't include any children of
      nielsenConfiguration, you still enable the setting.

        - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
        functionality. If you must include this property, set the value to zero.

        - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
        distributor ID that is assigned to your organization by Neilsen.

      - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
      outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
      MXF, and no container) are grouped in a single output group as well. Required in
      (OutputGroups) is a group of settings that apply to the whole group. This required object
      depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
      settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
      HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
      MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

        - *(dict) --* Group of outputs

          - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
          the output group. This value is displayed on the console and can make your job settings
          JSON more human-readable. It does not affect your outputs. Use up to twelve characters
          that are either letters, numbers, spaces, or underscores.

          - **Name** *(string) --* Name of the output group

          - **OutputGroupSettings** *(dict) --* Output Group settings, including type

            - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
            Output Group may only contain a single video, audio, or caption output.

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
              your job. These default manifests reference every output in the output group. To
              create additional top-level manifests that reference a subset of the outputs in the
              output group, specify a list of them here. For each additional manifest that you
              specify, the service creates one HLS manifest and one DASH manifest.

                - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
                that you want the service to generate for this CMAF output group. Each pair of
                manifests can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
              at the top level BaseURL element. Can be used if streams are delivered from a
              different URL than the manifest file.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
                service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                (SAMPLE-AES) or AES_CTR (AES-CTR).

                - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                outputs, choose whether the service writes the 128-bit encryption initialization
                vector in the HLS and DASH manifests.

                - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                  signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                  package. The DASH manifest can currently signal up to three system IDs. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                  signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                  package. The HLS manifest can currently signal only one system ID. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
              of each individual CMAF segment. This value applies to the whole package; that is, to
              every output in the output group. Note that segments end on the first keyframe after
              this number of seconds, so the actual segment length might be slightly longer. If you
              set Segment control (CmafSegmentControl) to single file, the service puts the content
              of each output in a single file that has metadata that marks these segments. If you
              set it to segmented files, the service creates multiple files for each output, each
              with the content of one segment.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
              generated for this output.

              - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
              be generated for this output.

            - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
              manifest for each DASH ISO output group in your job. This default manifest references
              every output in the output group. To create additional DASH manifests that reference a
              subset of the outputs in the output group, specify a list of them here.

                - *(dict) --* Specify the details for each additional DASH manifest that you want
                the service to generate for this output group. Each manifest can reference a
                different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.mpd.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
              (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
              from a different URL than the manifest file.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                compatibility of your output with video players on obsolete devices. It applies only
                to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
                only to correct problems with playback on older devices. Otherwise, keep the default
                setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the
                service will exclude the access unit delimiter and will leave the SEI NAL units
                unencrypted.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
              that segments will end on the next keyframe after this number of seconds, so actual
              segment length may be longer. When Emit Single File is checked, the segmentation is
              internal to a single output file and it does not cause the creation of many output
              files as in other output types.

              - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
              the 400 range when you play back your DASH output, enable this setting and run your
              transcoding job again. When you enable this setting, the service writes precise
              segment durations in the DASH manifest. The segment duration information appears
              inside the SegmentTimeline element, inside SegmentTemplate at the Representation
              level. When you don't enable this setting, the service writes approximate segment
              durations in your DASH manifest.

            - **FileGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

            - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

              - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
              HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
              outputs themselves.

                - *(string) --*

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest for each HLS output group in your job. This default manifest
              references every output in the output group. To create additional top-level manifests
              that reference a subset of the outputs in the output group, specify a list of them
              here.

                - *(dict) --* Specify the details for each additional HLS manifest that you want the
                service to generate for this output group. Each manifest can reference a different
                subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
              in the media .m3u8 file. Can be used if base manifest is delivered from a different
              URL than the main .m3u8 file.

              - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                - *(dict) --* Caption Language Mapping

                  - **CaptionChannel** *(integer) --* Caption channel.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                  - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                  three-letter code listed at
                  https://www.loc.gov/standards/iso639-2/php/code_list.php.

                  - **LanguageDescription** *(string) --* Caption language description.

              - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
              captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one
              language in the CC1 Language Code field. One CLOSED-CAPTION line is added for each
              Language Code you specify. Make sure to specify the languages in the order in which
              they appear in the original source (if the source is embedded format) or the order of
              the caption selectors (if the source is other than embedded). Otherwise, languages in
              the manifest will not match up properly with the output captions. None: Include
              CLOSED-CAPTIONS=
                  NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from
              the manifest.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
              subdirectories.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
                scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
                disables encryption.

                - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                128-bit number used in conjunction with the key for encrypting blocks. If set to
                INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                Vector is not in the manifest.

                - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                HLS FairPlay content protection.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
              looking ahead and back within the specified range for a nearby avail and extending the
              segment size if needed.

              - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
              be generated for this HLS output group.

              - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
              in .m3u8 manifest files. The value is calculated as follows: either the program date
              and time are initialized using the input timecode source, or the time is initialized
              using the input timecode source and the date is initialized using the
              timestamp_offset.

              - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
              EXT-X-PROGRAM-DATE-TIME entry, in seconds.

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
              media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

              - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
              create (in seconds). Note that segments will end on the next keyframe after this
              number of seconds, so actual segment length may be longer.

              - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
              subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
              for this setting to have an effect.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

              - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

              - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
              offset to fine tune the timestamps.

            - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .ism
              Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
              in your job. This default manifest references every output in the output group. To
              create additional manifests that reference a subset of the outputs in the output
              group, specify a list of them here.

                - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                manifest that you want the service to generate for this output group. Each manifest
                can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                  "-no-premium" for this setting, then the file name the service generates for this
                  top-level manifest is film-name-no-premium.ismv.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
              audio encoding settings across a Microsoft Smooth output group into a single audio
              stream.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* If you are using DRM, set DRM System
              (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
              the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
              and frame rate.

              - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding)
              to specify the encoding format for the server and client manifest. Valid options are
              utf8 and utf16.

            - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
            Microsoft Smooth Streaming, CMAF)

          - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
          settings per output.

            - *(dict) --* An output object describes the settings for a single output file or stream
            in an output group.

              - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
              encoding settings organized by audio codec. Include one instance of
              (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
              encoding settings.

                - *(dict) --* Description of audio output

                  - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                  settings. Ignore these settings unless you need to comply with a loudness
                  standard.

                    - **Algorithm** *(string) --* Choose one of the following audio normalization
                    algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                    loudness for an entire piece of content, suitable for measurement of short-form
                    content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-2: Gated loudness. A measurement of gated average loudness compliant
                    with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
                    with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
                    Allows for more audio channels than the other algorithms, including
                    configurations such as 7.1.

                    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                    using the chosen algorithm. If disabled, the audio will be measured but not
                    adjusted.

                    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                    be corrected to the target level. Content measuring below this level will not be
                    corrected. Gating only applies when not using real_time_correction.

                    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                    loudness to a CSV file.

                    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                    TruePeak for each output's audio track loudness.

                    - **TargetLkfs** *(float) --* When you use Audio normalization
                    (AudioNormalizationSettings), optionally use this setting to specify a target
                    loudness. If you don't specify a value here, the encoder chooses a value for
                    you, based on the algorithm that you choose for Algorithm (algorithm). If you
                    choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                    encoder will choose -23 LKFS.

                  - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                  input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                  name based on its order within each input. For example if you specify "Audio
                  Selector 3", then the third audio selector will be used from each input. If an
                  input does not have an "Audio Selector 3", then the audio selector marked as
                  "default" in that input will be used. If there is no audio selector marked as
                  "default", silence will be inserted for the duration of that input. Alternatively,
                  an "Audio Selector Group":#inputs-audio_selector_group name may be specified, with
                  similar default/silence behavior. If no audio_source_name is specified, then
                  "Audio Selector 1" will be chosen automatically.

                  - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                  unchecked (false). A number between 0 and 255. The following are defined in
                  ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                       Hearing Impaired, 3 =
                  Visually Impaired Commentary, 4-255 = Reserved.

                  - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                  contains an ISO 639 audio_type, then that value is passed through to the output.
                  If the input contains no ISO 639 audio_type, the value in Audio Type is included
                  in the output. Otherwise the value in Audio Type is included in the output. Note
                  that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                  is set to BROADCASTER_MIXED_AD.

                  - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                  (AudioDescriptions) contains the group of settings related to audio encoding. The
                  settings in this group vary depending on the value that you choose for Audio codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * AAC,
                  AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                  Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                    - **AacSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                    two mutually exclusive groups of AAC settings--VBR and CBR. To select one of
                    these modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or
                    "CBR". In VBR mode, you control the audio quality with the setting VBR quality
                    (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                    valid values depend on the rate control mode.

                      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                      when the input contains pre-mixed main audio + audio description (AD) as a
                      stereo pair. The value for AudioType will be set to 3, which signals to
                      downstream systems that this stream contains "broadcaster mixed AD". Note that
                      the input received by the encoder must contain pre-mixed audio; the encoder
                      does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                      ignores any values you provide in AudioType and FollowInputAudioType. Choose
                      NORMAL when the input does not contain pre-mixed audio + audio description
                      (AD). In this case, the encoder will use any values you provide for AudioType
                      and FollowInputAudioType.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      The set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000,
                      16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000,
                      112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000,
                      448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you set is
                      also constrained by the values that you choose for Profile (codecProfile),
                      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
                      values depend on Bitrate control mode and Profile.

                      - **CodecProfile** *(string) --* AAC Profile.

                      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                      channel layout. Valid values depend on rate control mode and profile. "1.0 -
                      Audio Description (Receiver Mix)" setting receives a stereo description plus
                      control track and emits a mono AAC encode of the description track, with
                      control data emitted in the PES header as per ETSI TS 101 154 Annex E.

                      - **RateControlMode** *(string) --* Rate Control Mode.

                      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                      use LATM/LOAS AAC in an output, you must choose "No container" for the output
                      container.

                      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                      control mode and profile.

                      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                      for raw or MPEG-2 Transport Stream containers.

                      - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                      rate_control_mode is VBR.

                    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AC3.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                      stream that the encoder emits. For more information about the AC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital, dialnorm will be passed through.

                      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                      adds dynamic range compression signaling to the output bitstream as defined in
                      the Dolby Digital specification.

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                    - **AiffSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AIFF.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **Codec** *(string) --* Type of Audio codec.

                    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid values: 384k, 448k, 640k, 768k

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                      (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                      adjust loudness based on dialogue analysis.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                      this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix
                      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                      value -60 mutes the channel.

                      - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                      your audio.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                      that must be speech before the encoder uses the measured speech loudness as
                      the overall program loudness.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing.

                      - **SurroundExMode** *(string) --* Specify whether your input audio has an
                      additional center rear surround channel matrix encoded into your left and
                      right surround channels.

                    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3.

                      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                      dB attenuation to the surround channels. Only used for 3/2 coding mode.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                      number of channels.

                      - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital Plus, dialnorm will be passed through.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                      LFE channel is enabled

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left only/Right only center (loRoCenterMixLevel).

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                      channel. This setting applies only if you keep the default value of 3/2 - L,
                      R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                      If you choose a different value for Coding mode, the service ignores Left
                      only/Right only surround (loRoSurroundMixLevel).

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total center (ltRtCenterMixLevel).

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                      surround). MediaConvert uses this value for downmixing. How the service uses
                      this value depends on the value that you choose for Stereo downmix
                      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
                      -60 mutes the channel. This setting applies only if you keep the default value
                      of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total surround (ltRtSurroundMixLevel).

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                      audio will be passed through if it is present on the input. this detection is
                      dynamic over the life of the transcode. Inputs that alternate between DD+ and
                      non-DD+ content will have a consistent DD+ output as the system alternates
                      between passthrough and encoding.

                      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                      the surround channels. Only used for 3/2 coding mode.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing. This setting only applies if you keep the default value of 3/2 -
                      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Stereo downmix (Eac3StereoDownmix).

                      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                      extra center back surround channel is matrix encoded into the left and right
                      surround channels.

                      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                      Surround is matrix encoded into the two channels.

                    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value MP2.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                      - **Channels** *(integer) --* Set Channels to specify the number of channels
                      in this output audio track. Choosing Mono in the console will give you 1
                      output channel; choosing Stereo will give you 2. In the API, valid values are
                      1 and 2.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **WavSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value WAV.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                      If your output audio is likely to exceed 4 GB in file size, or if you
                      otherwise need the extended support of the RF64 format, set your output WAV
                      file format to RF64.

                      - **SampleRate** *(integer) --* Sample rate in Hz.

                  - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                  track. The service puts this language code into your output audio track when you
                  set Language code control (AudioLanguageCodeControl) to Use configured
                  (USE_CONFIGURED). The service also uses your specified custom language code when
                  you set Language code control (AudioLanguageCodeControl) to Follow input
                  (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                  outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                  can also use any other code in the full RFC-5646 specification. Streaming outputs
                  are those that are in one of the following output groups: CMAF, DASH ISO, Apple
                  HLS, or Microsoft Smooth Streaming.

                  - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                  The ISO 639 language specified in the 'Language Code' drop down will be used when
                  'Follow Input Language Code' is not selected or when 'Follow Input Language Code'
                  is selected but there is no ISO 639 language code specified by the input.

                  - **LanguageCodeControl** *(string) --* Specify which source for language code
                  takes precedence for this audio track. When you choose Follow input
                  (FOLLOW_INPUT), the service uses the language code from the input track if it's
                  present. If there's no languge code on the input track, the service uses the code
                  that you specify in the setting Language code (languageCode or
                  customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service
                  uses the language code that you specify.

                  - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **StreamName** *(string) --* Specify a label for this output audio stream. For
                  example, "English", "Director commentary", or "track_2". For streaming outputs,
                  MediaConvert passes this information into destination manifests for display on the
                  end-viewer's player device. For outputs in other output groups, the service
                  ignores this setting.

              - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
              captions settings. For each output that has captions, include one instance of
              (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
              settings.

                - *(dict) --* Description of Caption output

                  - **CaptionSelectorName** *(string) --* Specifies which "Caption
                  Selector":#inputs-caption_selector to use from each input when generating
                  captions. The name should be of the format "Caption Selector ", which denotes that
                  the Nth Caption Selector will be used from each input.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  output track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information when automatically
                  selecting the font script for rendering the captions text. For all outputs, you
                  can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
                  any other code in the full RFC-5646 specification. Streaming outputs are those
                  that are in one of the following output groups: CMAF, DASH ISO, Apple HLS, or
                  Microsoft Smooth Streaming.

                  - **DestinationSettings** *(dict) --* Specific settings required by destination
                  type. Note that burnin_destination_settings are not available if the source of the
                  caption data is Embedded or Teletext.

                    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering burn-in captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **DestinationType** *(string) --* Specify the format for this set of captions
                    on this output. The default format is embedded without SCTE-20. Other options
                    are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                    web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                    (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec.
                    To create a non-compliant output where the embedded captions come first, choose
                    Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering DVB-Sub captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                      standard or for hearing impaired. Choose hearing impaired if your subtitles
                      include audio descriptions and dialogue. Choose standard if your subtitles
                      include only dialogue.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                    embedded/ancillary caption outputs, including 608/708 Channel destination
                    number.

                      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and your output captions are embedded in
                      the video stream. Specify a CC number for each captions channel in this
                      output. If you have two channels, choose CC numbers that aren't in the same
                      field. For example, choose 1 and 3. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and you want both 608 and 708 captions
                      embedded in your output stream. Optionally, specify the 708 service number for
                      each output captions channel. Choose a different number for each channel. To
                      use this setting, also set Force 608 to 708 upconvert (Convert608To708) to
                      Upconvert (UPCONVERT) in your input captions selector settings. If you choose
                      to upconvert but don't specify a 708 service number, MediaConvert uses the
                      number that you specify for CC channel number (destination608ChannelNumber)
                      for the 708 service number. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                    outputs.

                      - **StylePassthrough** *(string) --* Keep this setting enabled to have
                      MediaConvert use the font style and position information from the captions
                      source in the output. This option is available only when your input captions
                      are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                      output captions.

                    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                      sure that the captions and the video are synchronized in the output. Specify a
                      frame rate that matches the frame rate of the associated video. If the video
                      frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only
                      if the video has video_insertion=
                          true and drop_frame_timecode=true; otherwise,
                      choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                    output

                      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                      the destination captions for this output. This value must be a three-digit
                      hexadecimal string; strings ending in -FF are invalid. If you are passing
                      through the entire set of Teletext data, do not use this field.

                      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                      you don't specify a value here, the service sets the page type to the default
                      value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                      Teletext data, don't use this field. When you pass through a set of Teletext
                      pages, your output has the same page types as your input.

                        - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                        Table 94

                    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                    outputs, including Pass style information (TtmlStylePassthrough).

                      - **StylePassthrough** *(string) --* Pass through style and position
                      information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                      CFF-TT output or TTML output.

                  - **LanguageCode** *(string) --* Specify the language of this captions output
                  track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information to choose the font
                  language for rendering the captions text.

                  - **LanguageDescription** *(string) --* Specify a label for this set of output
                  captions. For example, "English", "Director commentary", or "track_2". For
                  streaming outputs, MediaConvert passes this information into destination manifests
                  for display on the end-viewer's player device. For outputs in other output groups,
                  the service ignores this setting.

              - **ContainerSettings** *(dict) --* Container specific settings.

                - **Container** *(string) --* Container for this output. Some containers require a
                container settings object. If not specified, the default object will be created.

                - **F4vSettings** *(dict) --* Settings for F4v container

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs
                in a File output group when the output's container (ContainerType) is MPEG-2
                Transport Stream (M2TS). In these assets, data is organized by the program map table
                (PMT). Each transport stream program contains subsets of data, including audio,
                video, and metadata. Each of these subsets of data has a numerical label called a
                packet identifier (PID). Each transport stream program corresponds to one
                MediaConvert output. The PMT lists the types of data in a program along with their
                PID. Downstream systems and players use the program map table to look up the PID for
                each type of data it accesses and then uses the PIDs to locate specific data within
                the asset.

                  - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                  models for Dolby Digital audio.

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                  elementary audio streams you include in this output. Specify multiple PIDs as a
                  JSON array. Default is the range 482-492.

                    - *(integer) --*

                  - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                  bits per second. Setting to 0 lets the muxer automatically determine the
                  appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                  - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                  interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                  this can lead to lower latency, but low-memory devices may not be able to play
                  back the stream without interruptions.

                  - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                  the specified table repetition interval.

                    - **NetworkId** *(integer) --* The numeric value placed in the Network
                    Information Table (NIT).

                    - **NetworkName** *(string) --* The network name text placed in the
                    network_name_descriptor inside the Network Information Table. Maximum length is
                    256 characters.

                    - **NitInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                  the specified table repetition interval.

                    - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                    output stream. "Follow input SDT" copies SDT information from input stream to
                    output stream. "Follow input SDT if present" copies SDT information from input
                    stream to output stream if SDT information is present in the input, otherwise it
                    will fall back on the user-defined values. Enter "SDT Manually" means user will
                    enter the SDT information. "No SDT" means output stream will not contain SDT
                    information.

                    - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **ServiceName** *(string) --* The service name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                    - **ServiceProviderName** *(string) --* The service provider name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                  - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                  subtitle data included in this output. Specify multiple PIDs as a JSON array.
                  Default is the range 460-479.

                    - *(integer) --*

                  - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                  specified table repetition interval.

                    - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                  teletext data you include in this output. Default is 499.

                  - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                  EBP markers will be added to partitions 3 and 4. The interval between these
                  additional markers will be fixed, and will be slightly shorter than the video EBP
                  marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                  inserted. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                  can either be placed only on the video PID, or on both the video PID and all audio
                  PIDs. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                  the PES header.

                  - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                  you know that your audio EBP markers are incorrectly appearing before your video
                  EBP markers. To correct this problem, set this value to Force (FORCE).

                  - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                  used with EBP markers.

                  - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                  between Program Clock References (PCRs) inserted into the transport stream.

                  - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                  Points do not come within the specified time interval of each other by looking
                  ahead at input video. If another EBP is going to come in within the specified time
                  interval, the current EBP is not emitted, and the segment is "stretched" to the
                  next marker. The lookahead value does not add latency to the system. The Live
                  Event must be configured elsewhere to create sufficient latency to make the
                  lookahead accurate.

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                  packets to insert into the transport stream. This can be used if a downstream
                  encryption system requires periodic null packets.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This is effective only when the PCR PID is the same as the video or audio
                  elementary stream.

                  - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                  clock reference (PCR) in this output. If you do not specify a value, the service
                  will use the value for Video PID (VideoPid).

                  - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                  instances of the program map table (PMT) in the output transport stream.

                  - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                  map table (PMT) itself. Default is 480.

                  - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                  private metadata stream. Default is 503.

                  - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                  the program number used in the program map table (PMT) for this output. Default is
                  1. Program numbers and program map tables are parts of MPEG-2 transport stream
                  containers, used for organizing data.

                  - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                  stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                  maximum bitrate, but the output will not be padded up to that bitrate.

                  - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                  markers in your HLS and transport stream outputs at the insertion points that you
                  specify in an ESAM XML document. Provide the document in the setting SCC XML
                  (sccXml).

                    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                    in the transport stream generated by ESAM.

                  - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                  stream in the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None
                  (NONE). Also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml). Also enable ESAM SCTE-35 (include the property
                  scte35Esam).

                  - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                  segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                  adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                  private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                  segments. ebp adds Encoder Boundary Point information to the adaptation field as
                  per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary
                  Point information to the adaptation field using a legacy proprietary format.

                  - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                  how segmentation markers are inserted into the transport stream. With avails, it
                  is possible that segments may be truncated, which can influence where future
                  segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                  selected and a segment is truncated due to an avail, we will reset the
                  segmentation cadence. This means the subsequent segment will have a duration of of
                  $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                  selected and a segment is truncated due to an avail, we will not reset the
                  segmentation cadence. This means the subsequent segment will likely be truncated
                  as well. However, all segments after that will have a duration of
                  $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
                  rule.

                  - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                  segment. Required unless markers is set to _none_.

                  - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                  timed metadata in this output. Default is 502.

                  - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                  itself in the program map table for this output. Transport stream IDs and program
                  map tables are parts of MPEG-2 transport stream containers, used for organizing
                  data.

                  - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                  elementary video stream in the transport stream.

                - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                  stream(s) in the transport stream. Multiple values are accepted, and can be
                  entered in ranges and/or by comma separation.

                    - *(integer) --*

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This parameter is effective only when the PCR PID is the same as the video or
                  audio elementary stream.

                  - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                  (PCR) in the transport stream. When no value is given, the encoder will assign the
                  same value as the Video PID.

                  - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                  (PMT) in the transport stream.

                  - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                  metadata stream in the transport stream.

                  - **ProgramNumber** *(integer) --* The value of the program number field in the
                  Program Map Table.

                  - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                  the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE)
                  if you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and
                  choose Ad markers (adMarkers) if you do want manifest conditioning. In both cases,
                  also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml).

                  - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                  specify whether the service inserts the ID3 timed metadata from the input in this
                  output.

                  - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                  metadata stream in the transport stream.

                  - **TransportStreamId** *(integer) --* The value of the transport stream ID field
                  in the Program Map Table.

                  - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                  stream in the transport stream.

                - **MovSettings** *(dict) --* Settings for MOV Container.

                  - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                  the video output settings.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                  streams into the QuickTime file using XDCAM fourcc codes. This increases
                  compatibility with Apple editors and players, but may decrease compatibility with
                  other players. Only applicable when the video codec is MPEG2.

                  - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                  padding

                  - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                  this setting.

                - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
                AAC outputs with this container.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                  moov box.

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                  - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                  file. Usually not necessary to specify.

                - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                  - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                  groups that include sidecar TTML or IMSC captions. You specify sidecar captions in
                  a separate output from your audio and video. Choose Raw (RAW) for captions in a
                  single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for
                  captions in XML format contained within fragmented MP4 files. This set of
                  fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                  - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                  markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                  insertion points that you specify in an ESAM XML document. Provide the document in
                  the setting SCC XML (sccXml).

                  - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                  markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                  SCTE-35 markers that appear in your input to also appear in this output. Choose
                  None (NONE) if you don't want those SCTE-35 markers in this output.

              - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
              for outputs in File output groups. If you do not specify a value, the service will use
              default extensions by container type as follows * MPEG-2 transport stream, m2ts *
              Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the
              service will use codec extensions (e.g. AAC, H265, H265, AC3)

              - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
              add a string to the end of each output filename. You specify the base filename as part
              of your destination URI. When you create multiple outputs in the same output group,
              Name modifier (NameModifier) is required. Name modifier also accepts format
              identifiers. For DASH ISO outputs, if you use the format identifiers $Number$ or
              $Time$ in one output, you must use them in the same way in all outputs of the output
              group.

              - **OutputSettings** *(dict) --* Specific settings for this type of output.

                - **HlsSettings** *(dict) --* Settings for HLS output groups

                  - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                  belongs.

                  - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                  outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                  container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                  file in a raw container. Regardless of the value that you specify here, if this
                  output has video, the service will place the output into an MPEG2-TS container.

                  - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                  with the video output stream. Input all the audio GROUP-IDs that are associated to
                  the video, separate by ','.

                  - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                  Audio-Only Variant Stream The client can play back this audio-only stream instead
                  of video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                  manifest. Alternate Audio, Auto Select, Default Alternate rendition that the
                  client should try to play back by default. Represented as an EXT-X-MEDIA in the
                  HLS manifest with DEFAULT=YES, AUTOSELECT=
                      YES Alternate Audio, Auto Select, Not
                  Default Alternate rendition that the client may try to play back by default.
                  Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                      NO, AUTOSELECT=YES
                  Alternate Audio, not Auto Select Alternate rendition that the client will not try
                  to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
                  DEFAULT=NO, AUTOSELECT=NO

                  - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                  Manifest in addition to the HLS manifest

                  - **SegmentModifier** *(string) --* String concatenated to end of segment
                  filenames. Accepts "Format Identifiers":#format_identifier_parameters.

              - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
              transcoding settings. Provide the system or custom preset name. You can specify either
              Preset (Preset) or Container settings (ContainerSettings), but not both.

              - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
              encoding settings. The specific video settings depend on the video codec that you
              choose when you specify a value for Video codec (codec). Include one instance of
              (VideoDescription) per output.

                - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                service includes AFD values in the output video data and what those values are. *
                Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                input AFD values and instead encode the value specified in the job. * Choose Auto to
                calculate output AFD values based on the input AFD scaler data.

                - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
                outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
                specify that in your job, the service will ignore the setting.

                - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                (VideoDescription), contains the group of settings related to video encoding. The
                settings in this group vary depending on the value that you choose for Video codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * H_264,
                H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
                FRAME_CAPTURE, FrameCaptureSettings

                  - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                  the enum values defined by the object VideoCodec.

                  - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                    - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.n.jpg where n is the 0-based sequence number of each Capture.

                    - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
                    to 7 decimal places.

                    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                    files).

                    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                    quality.

                  - **H264Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value H_264.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                    your output video settings. If you aren't sure what level to specify, choose
                    Auto (AUTO).

                    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                    are only available with the AVC-I License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                    Main or High profile) or CAVLC.

                    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                    for interlaced outputs.

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job specification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* When you use the API for transcode
                    jobs that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateDenominator to specify the
                    denominator of this fraction. In this example, use 1001 for the value of
                    FramerateDenominator. When you use the console for transcode jobs that use frame
                    rate conversion, provide the value as a decimal number for Framerate. In this
                    example, specify 23.976.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type, as follows. - If the source is interlaced, the output will be interlaced
                    with the same polarity as the source (it will follow the source). The output
                    could therefore be a mix of "top field first" and "bottom field first". - If the
                    source is progressive, the output will be interlaced with "top field first" or
                    "bottom field first" polarity, depending on which of the Follow options you
                    chose.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even
                    if repeated.

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                  - **H265Settings** *(dict) --* Settings for H265 codec

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                    Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                    Transfer Function (EOTF).

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* H.265 Level.

                    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                    (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                    "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                    available with the HEVC 4:2:2 License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                    Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                    the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field
                    First (BOTTOM_FIELD) to create an output that's interlaced with the same field
                    polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow,
                    Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the
                    same field polarity as the source. If the source is interlaced, the output will
                    be interlaced with the same polarity as the source (it will follow the source).
                    The output could therefore be a mix of "top field first" and "bottom field
                    first". If the source is progressive, your output will be interlaced with "top
                    field first" or "bottom field first" polarity, depending on which of the Follow
                    options you chose. If you don't choose a value, the service will default to
                    Progressive (PROGRESSIVE).

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                    Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                    based on content

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                    encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                    and P-frames form one layer, reference B-frames can form a second layer and
                    non-reference b-frames can form a third layer. Decoders can optionally decode
                    only the lower temporal layers to generate a lower frame rate output. For
                    example, given a bitstream with temporal IDs and with b-frames =
                         1 (i.e. IbPbPb
                    display order), a decoder could decode all the frames for full frame rate output
                    or only the I and P frames (lowest temporal layer) for a half frame rate output.

                    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                    vertical subdivision of the encoded pictures.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                    units doesn't matter in your workflow, ignore this setting. Use this setting
                    only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                    container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                    your output compliant with the following specification: ISO IECJTC1 SC29 N13798
                    Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
                    parameter set NAL units in the sample headers but not in the samples directly.
                    For MP4 outputs, when you choose HVC1, your output video might not work properly
                    with some downstream systems and video players. The service defaults to marking
                    your output as HEV1. For these outputs, the service writes parameter set NAL
                    units directly into the samples.

                  - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value MPEG2.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                    level for the video output.

                    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                    MPEG-2 profile for the video output.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **IntraDcPrecision** *(string) --* Use Intra DC precision
                    (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                    coefficients. If you choose the value auto, the service will automatically
                    select the precision based on the per-frame compression ratio.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                    video encoding.

                    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                    to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                    356M-2001).

                    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                  - **ProresSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value PRORES.

                    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                    the type of Apple ProRes codec to use for this output.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                    that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateNumerator to specify the
                    numerator of this fraction. In this example, use 24000 for the value of
                    FramerateNumerator.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                    determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                    to use the pixel aspect ratio from the input. To specify a different pixel
                    aspect ratio: Using the console, choose it from the dropdown menu. Using the
                    API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                    (ParDenominator).

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
                color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
                this output. If you don't specify a value, the service sets this to Insert by
                default.

                - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
                the service will include in the output video frame.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                feature is enabled, the service will use drop-frame timecode on outputs. If it is
                not possible to use drop-frame timecode, the system will fall back to
                non-drop-frame. This setting is enabled by default when Timecode insertion
                (TimecodeInsertion) is enabled.

                - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
                Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                service will write on all frames of this video output.

                - **Height** *(integer) --* Use the Height (Height) setting to define the video
                resolution height for this output. Specify in pixels. If you don't provide a value
                here, the service will use the input height.

                - **Position** *(dict) --* Use Selection placement (position) to define the video
                area in your output frame. The area outside of the rectangle that you specify here
                is black.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                the service changes the video itself in response to AFD values in the input. *
                Choose Respond to clip the input video frame according to the AFD value, input
                display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                include the input AFD values. Do not choose this when AfdSignaling is set to (NONE).
                A preferred implementation of this workflow is to set RespondToAfd to (NONE) and set
                AfdSignaling to (AUTO). * Choose None to remove all input AFD values from this
                output.

                - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                have a different aspect ratio from the input aspect ratio. Choose Stretch to output
                (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
                setting Default (DEFAULT) to have the service letterbox your video instead. This
                setting overrides any value that you specify for the setting Selection placement
                (position) in this output.

                - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                strength of anti-aliasing. This setting changes the width of the anti-alias filter
                kernel used for scaling. Sharpness only applies if your output resolution is
                different from your input resolution. 0 is the softest setting, 100 the sharpest,
                and 50 recommended for most content.

                - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                ProRes outputs. Only enable Timecode insertion when the input frame rate is
                identical to the output frame rate. To include timecodes in this output, set
                Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                output, by default, it uses any embedded timecodes from the input. If none are
                present, the service will set the timecode for the first output frame to zero. To
                change this default behavior, adjust the settings under Timecode configuration
                (TimecodeConfig). In the console, these settings are located under Job > Job
                settings > Timecode configuration. Note - Timecode source under input settings
                (InputTimecodeSource) does not affect the timecodes that are inserted in the output.
                Source under Job settings > Timecode configuration (TimecodeSource) does.

                - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                Preprocessors (VideoPreprocessors). Enable the features at each output individually.
                These features are disabled by default.

                  - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                  feature if necessary. Enable or disable this feature for each output individually.
                  This setting is disabled by default.

                    - **Brightness** *(integer) --* Brightness level.

                    - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                    this output. The service supports conversion between HDR formats, between SDR
                    formats, and from SDR to HDR. The service doesn't support conversion from HDR to
                    SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                    video has an HDR format, but visually appears the same as an unconverted output.

                    - **Contrast** *(integer) --* Contrast level.

                    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                    10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                    metadata that you want signaled in the output. These values don't affect the
                    pixel values that are encoded in the video stream. They are intended to help the
                    downstream video player display content in a way that reflects the intentions of
                    the the content creator. When you set Color space conversion
                    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                    must set values for Max frame average light level (maxFrameAverageLightLevel)
                    and Max content light level (maxContentLightLevel); these settings don't have a
                    default value. The default values for the other HDR 10 metadata settings are
                    defined by the P3D65 color space. For more information about MediaConvert HDR
                    jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                      samples in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                      any frame in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance
                      in units of of 0.0001 candelas per square meter.

                      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance
                      in units of of 0.0001 candelas per square meter

                      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                    - **Hue** *(integer) --* Hue in degrees.

                    - **Saturation** *(integer) --* Saturation level.

                  - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                  motion and a clearer picture.

                    - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                    (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                    adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                    (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if
                    your source file includes a ticker, such as a scrolling headline at the bottom
                    of the frame.

                    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                    does not convert frames that are tagged in metadata as progressive. It will only
                    convert those that are tagged as some other type. - When set to
                    FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                    those that are already tagged as progressive. Turn Force mode on only if there
                    is a good chance that the metadata has tagged frames as progressive when they
                    are not progressive. Do not turn on otherwise; processing frames that are
                    already progressive into progressive will probably result in lower quality
                    video.

                    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                    service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                    interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                    progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                  - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                  compatible video output.

                    - **L6Metadata** *(dict) --* Use these settings when you set
                    DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                    your input with new values.

                      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                      that corresponds to the brightest pixel in the entire stream. Measured in
                      nits.

                      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                      metadata that corresponds to the highest frame-average brightness in the
                      entire stream. Measured in nits.

                    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                    handle Dolby Vision MaxCLL and MaxFALL properies.

                    - **Profile** *(string) --* In the current MediaConvert implementation, the
                    Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must
                    contain Dolby Vision frame interleaved data.

                  - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature
                  to include a graphic overlay on your video. Enable or disable this feature for
                  each output individually. This setting is disabled by default.

                    - **InsertableImages** *(list) --* Specify the images that you want to overlay
                    on your video. The images must be PNG or TGA files.

                      - *(dict) --* Settings that specify how your still graphic overlay appears.

                        - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                        image to remain on the output video. This duration includes fade-in time but
                        not fade-out time.

                        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                        between the Start time that you specify for the image insertion and the time
                        that the image appears at full opacity. Full opacity is the level that you
                        specify for the opacity setting. If you don't specify a value for Fade-in,
                        the image will appear abruptly at the overlay start time.

                        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                        between the end of the time that you have specified for the image overlay
                        Duration and when the overlaid image has faded to total transparency. If you
                        don't specify a value for Fade-out, the image will disappear abruptly at the
                        end of the inserted image duration.

                        - **Height** *(integer) --* Specify the height of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        height, the service will crop your overlaid image to fit. To use the native
                        height of the image, keep this setting blank.

                        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                        location of the image that you want to overlay on the video. Use a PNG or
                        TGA file.

                        - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                        inserted image and the left edge of the video frame. Required for any image
                        overlay that you specify.

                        - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                        overlaid image and the top edge of the video frame. Required for any image
                        overlay that you specify.

                        - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                        Images with higher values for Layer appear on top of images with lower
                        values for Layer.

                        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                        the underlying video shows through the inserted image. 0 is transparent and
                        100 is fully opaque. Default is 50.

                        - **StartTime** *(string) --* Specify the timecode of the frame that you
                        want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                        or HH:MM:SS;FF) format. Remember to take into account your timecode source
                        settings.

                        - **Width** *(integer) --* Specify the width of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        width, the service will crop your overlaid image to fit. To use the native
                        width of the image, keep this setting blank.

                  - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                  remove noise from your video output if necessary. Enable or disable this feature
                  for each output individually. This setting is disabled by default.

                    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                    select one of the following spatial image filtering functions. To use this
                    setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                    preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                    Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                    reduction. * Spatial does frequency-domain filtering based on JND principles. *
                    Temporal optimizes video quality for complex motion.

                    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                    spatial filter.

                      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                      reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                      maximum strength.

                      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                      (higher speed), with 0 being the nominal value.

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                    temporal filter.

                      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                      complex motion. Higher values produce stronger temporal filtering. This
                      filters highly complex scenes more aggressively and creates better VQ for low
                      bitrate outputs.

                      - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                      Low setting reduces bit rate at the cost of transcode time, high setting
                      improves transcode time at the cost of bit rate.

                      - **Strength** *(integer) --* Specify the strength of the noise reducing
                      filter on this output. Higher values produce stronger filtering. We recommend
                      the following value ranges, depending on the result that you want: * 0-2 for
                      complexity reduction with minimal sharpness loss * 2-8 for complexity
                      reduction with image preservation * 8-16 for a high level of complexity
                      reduction

                  - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                  output timecode and specified prefix into the output.

                    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                    any burned-in timecode. Valid values are 10, 16, 32, 48.

                    - **Position** *(string) --* Use Position (Position) under under Timecode
                    burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                    output video.

                    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                    any burned-in timecode. For example, a prefix of "EZ-" will result in the
                    timecode "EZ-00:00:00:00". Provide either the characters themselves or the ASCII
                    code equivalents. The supported range of characters is 0x20 through 0x7e. This
                    includes letters, numbers, and all special characters represented on a standard
                    English keyboard.

                - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                in pixels, for this output. If you don't provide a value here, the service will use
                the input width.

      - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
      information from inputs.

        - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
        use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
        the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or
        (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
        Timecode varies depending on your setting for Source (TimecodeSource). * If Source
        (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
        specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
        (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start at
        0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
        Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
        input.

        - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
        within this job. To make sure that your video, audio, captions, and markers are synchronized
        and that time-based features, such as image inserter, work correctly, choose the Timecode
        source option that matches your assets. All timecodes are in a 24-hour format with frame
        number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video.
        If no embedded timecode is in the source, the service will use Start at 0 (ZEROBASED)
        instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. *
        Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other
        than zero. You use Start timecode (Start) to provide this value.

        - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
        (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
        Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

        - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
        stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
        affecting the time and frame number. Provide the new date as a string in the format
        "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
        (InsertProgramDateTime) in the output settings. For example, if the date part of your
        timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
        (TimestampOffset) to 2003-1-25.

      - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
      (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
      enable it here, enable it in each output container, and specify tags and timecodes in ID3
      insertion (Id3Insertion) objects.

        - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

          - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
          specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when
          the tag should be inserted. To insert multiple ID3 tags in your output, create multiple
          instances of ID3 insertion (Id3Insertion).

            - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
            format.

            - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
            format.

    - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
    events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
    MediaConvert sends an update at this interval from the time the service begins processing your
    job to the time it completes the transcode or encounters an error.

    - **Type** *(string) --* A job template can be of two types: system or custom. System or
    built-in job templates can't be modified or deleted by the user.
    """


_ClientCreateJobTemplateResponseTypeDef = TypedDict(
    "_ClientCreateJobTemplateResponseTypeDef",
    {"JobTemplate": ClientCreateJobTemplateResponseJobTemplateTypeDef},
    total=False,
)


class ClientCreateJobTemplateResponseTypeDef(_ClientCreateJobTemplateResponseTypeDef):
    """
    Type definition for `ClientCreateJobTemplate` `Response`

    - **JobTemplate** *(dict) --* A job template is a pre-made set of encoding instructions that you
    can use to quickly create a job.

      - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
      with long, visually complex content.

        - **Mode** *(string) --* Specify the conditions when the service will run your job with
        accelerated transcoding.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **Category** *(string) --* An optional category you create to organize your job templates.

      - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for Job template creation.

      - **Description** *(string) --* An optional description you create for each job template.

      - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the Job template was
      last updated.

      - **Name** *(string) --* A name you create for each job template. Each name must be unique
      within your account.

      - **Priority** *(integer) --* Relative priority on the job.

      - **Queue** *(string) --* Optional. The queue that jobs created from this template are
      assigned to. If you don't specify this, jobs will go to the default queue.

      - **Settings** *(dict) --* JobTemplateSettings contains all the transcode settings saved in
      the template that will be applied to jobs created from it.

        - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
        the input Ad Avail PTS time.

        - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
        overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

          - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
          black. Only bmp and png images are supported.

        - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

          - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
          ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
          uses the manifest conditioning instructions that you provide in the setting MCC XML
          (mccXml).

            - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
            document inside your JSON job settings. Form the XML document as per
            OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning
            instructions in the message that you supply.

          - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
          between the SCTE 35 messages that the transcoder places and the splice points that they
          refer to. If the time between the start of the asset and the SCTE-35 message is less than
          this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

          - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
          SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
          signal processing instructions that you provide in the setting SCC XML (sccXml).

            - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
            inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025.
            The transcoder will use the signal processing instructions in the message that you
            supply. Provide your ESAM SignalProcessingNotification XML document inside your JSON job
            settings. For your MPEG2-TS file outputs, if you want the service to place SCTE-35
            markers at the insertion points you specify in the XML document, you must also enable
            SCTE-35 ESAM (scte35Esam). Note that you can either specify an ESAM XML document or
            enable SCTE-35 passthrough. You can't do both.

        - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
        job. There can only be one input in a job template. Using the API, you can include multiple
        inputs when referencing a job template.

          - *(dict) --* Specified video input in a template.

            - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input
            to combine. An input may have multiple audio selector groups. See "Audio Selector
            Group":#inputs-audio_selector_group for more information.

              - *(string) --*

                - *(dict) --* Group of Audio Selectors

                  - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same
                  input to include in the group. Audio selector names are standardized, based on
                  their order within the input (e.g., "Audio Selector 1"). The audio selector name
                  parameter can be repeated to add any number of audio selectors to the group.

                    - *(string) --*

            - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
            or set of tracks from the input that you will use in your outputs. You can use mutiple
            Audio selectors per input.

              - *(string) --*

                - *(dict) --* Selector for Audio

                  - **CustomLanguageCode** *(string) --* Selects a specific language code from
                  within an audio source, using the ISO 639-2 or ISO 639-3 three-letter language
                  code

                  - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                  set it as the default for the job. The service uses this default for outputs where
                  it can't find the specified input audio. If you don't set a default, those outputs
                  have no audio.

                  - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                  file source.

                  - **LanguageCode** *(string) --* Selects a specific language code from within an
                  audio source.

                  - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                  audio from the input video.

                  - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g.
                  257 selects PID 0x101).

                    - *(integer) --*

                  - **ProgramSelection** *(integer) --* Use this setting for input streams that
                  contain Dolby E, to have the service extract specific program data from the track.
                  To select multiple programs, create multiple selectors with the same Track and
                  different Program numbers. In the console, this setting is visible when you set
                  Selector type to Track. Choose the program number from the dropdown list. If you
                  are sending a JSON file, provide the program ID, which is part of the audio
                  metadata. If your input file has incorrect metadata, you can choose All channels
                  instead of a program number to have the service ignore the program IDs and include
                  all the programs in the track.

                  - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels
                  of one input to match those of another input. This allows you to combine the two
                  files into a single output, one after the other.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **SelectorType** *(string) --* Specifies the type of the audio selector.

                  - **Tracks** *(list) --* Identify a track from the input audio to include in this
                  selector by entering the track index number. To include several tracks in a single
                  audio selector, specify multiple tracks as follows. Using the console, enter a
                  comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                  Specifying directly in your JSON job file, provide the track numbers in an array.
                  For example, "tracks": [1,2,3].

                    - *(integer) --*

            - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
            the captions data from the input that you will use in your outputs. You can use mutiple
            captions selectors per input.

              - *(string) --*

                - *(dict) --* Set up captions in your outputs by first selecting them from your
                input here.

                  - **CustomLanguageCode** *(string) --* The specific language to extract from
                  source, using the ISO 639-2 or ISO 639-3 three-letter language code. If input is
                  SCTE-27, complete this field and/or PID to select the caption language to extract.
                  If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or
                  PID to select the caption language to extract. If input is DVB-Sub that is being
                  passed through, omit this field (and PID field); there is no way to extract a
                  specific language with pass-through captions.

                  - **LanguageCode** *(string) --* The specific language to extract from source. If
                  input is SCTE-27, complete this field and/or PID to select the caption language to
                  extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this
                  field and/or PID to select the caption language to extract. If input is DVB-Sub
                  that is being passed through, omit this field (and PID field); there is no way to
                  extract a specific language with pass-through captions.

                  - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                  SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                  your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                  FileSoureSettings.

                    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions
                    source.

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                      number in the ancillary data track from which to extract captions. Unused for
                      passthrough.

                      - **TerminateCaptions** *(string) --* By default, the service terminates any
                      unterminated captions at the end of each input. If you want the caption to
                      continue onto your next input, disable this setting.

                    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                      PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub
                      content is passed through, regardless of selectors.

                    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel
                      number within the video track from which to extract captions. Unused for
                      passthrough.

                      - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                      for extracting captions. The system only supports one input video track, so
                      this should always be set to '1'.

                      - **TerminateCaptions** *(string) --* By default, the service terminates any
                      unterminated captions at the end of each input. If you want the caption to
                      continue onto your next input, disable this setting.

                    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                    STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption
                    source file. If your caption source is IMSC in an IMF package, use
                    TrackSourceSettings instead of FileSoureSettings.

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **SourceFile** *(string) --* External caption file used for loading
                      captions. Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt',
                      'xml', and 'smi'.

                      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                      captions from the source file.

                    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                    your input captions. The service cannot auto-detect caption format.

                    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                    sources, including Page number.

                      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                      three-digit hexadecimal page number that will be used for Teletext captions.
                      Do not use this setting if you are passing through teletext from the input
                      source to output.

                    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                    are specified by track number. Currently, this is only IMSC captions in an IMF
                    package. If your caption source is IMSC 1.1 in a separate xml file, use
                    FileSourceSettings instead of TrackSourceSettings.

                      - **TrackNumber** *(integer) --* Use this setting to select a single captions
                      track from a source. Track numbers correspond to the order in the captions
                      source file. For IMF sources, track numbering is based on the order that the
                      captions appear in the CPL. For example, use 1 to select the captions asset
                      that is listed first in the CPL. To include more than one captions track in
                      your job outputs, create multiple input captions selectors. Specify one track
                      per selector.

            - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
            service will include in the output video frame. If you specify a value here, it will
            override any value that you specify in the output setting Cropping selection (crop).

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce
            smoother motion in the output. Default is disabled. Only manaully controllable for MPEG2
            and uncompressed video inputs.

            - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise
            from the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and
            uncompressed video inputs.

            - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how
            the transcoding service applies the denoise and deblock filters. You must also enable
            the filters separately, with Denoise (InputDenoiseFilter) and Deblock
            (InputDeblockFilter). * Auto - The transcoding service determines whether to apply
            filtering, depending on input type and quality. * Disable - The input is not filtered.
            This is true even if you use the API to enable them in (InputDeblockFilter) and
            (InputDeblockFilter). * Force - The in put is filtered regardless of input type.

            - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
            magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
            is 0.

            - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
            overlay on your video. Enable or disable this feature for each input individually. This
            setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
            that together specify a portion of the input to be used in the outputs. If you provide
            only a start time, the clip will be the entire input from that point to the end. If you
            provide only an end time, it will be the entire input up to that point. When you specify
            more than one input clip, the transcoding service creates the job outputs by stringing
            the clips together in the order you specify them.

              - *(dict) --* To transcode only portions of your input (clips), include one Input
              clipping (one instance of InputClipping in the JSON job file) for each input clip. All
              input clips you specify will be included in every output of the job.

                - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
                portion of the input you are clipping. The frame corresponding to the End timecode
                value is included in the clip. Start timecode or End timecode may be left blank, but
                not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
                minute, SS is the second, and FF is the frame number. When choosing this value, take
                into account your setting for timecode source under input settings
                (InputTimecodeSource). For example, if you have embedded timecodes that start at
                01:00:00:00 and you want your clip to end six minutes into the video, use
                01:06:00:00.

                - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the
                beginning of the portion of the input you are clipping. The frame corresponding to
                the Start timecode value is included in the clip. Start timecode or End timecode may
                be left blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is
                the hour, MM is the minute, SS is the second, and FF is the frame number. When
                choosing this value, take into account your setting for Input timecode source. For
                example, if you have embedded timecodes that start at 01:00:00:00 and you want your
                clip to begin five minutes into the video, use 01:05:00:00.

            - **Position** *(dict) --* Use Selection placement (position) to define the video area
            in your output frame. The area outside of the rectangle that you specify here is black.
            If you specify a value here, it will override any value that you specify in the output
            setting Selection placement (position). If you specify a value here, this will override
            any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
            (RESPOND). If you specify a value here, this will ignore anything that you specify for
            the setting Scaling Behavior (scalingBehavior).

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
            program from within a multi-program transport stream. Note that Quad 4K is not currently
            supported. Default is the first program within the transport stream. If the program you
            specify doesn't exist, the transcoding service will use this default.

            - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
            inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs
            for audio and video. * Use PSI - Scan only PSI data.

            - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
            input settings (InputTimecodeSource), to specify how the service counts input video
            frames. This input frame count affects only the behavior of features that apply to a
            single input at a time, such as input clipping and synchronizing some captions formats.
            Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at
            zero (ZEROBASED) to start the first frame at zero. Choose Specified start
            (SPECIFIEDSTART) to start the first frame at the timecode that you specify in the
            setting Start timecode (timecodeStart). If you don't specify a value for Timecode
            source, the service will use Embedded by default. For more information about timecodes,
            see https://docs.aws.amazon.com/console/mediaconvert/timecode.

            - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
            for this input's initial frame. To use this setting, you must set the Timecode source
            setting, located under the input settings (InputTimecodeSource), to Specified start
            (SPECIFIEDSTART). For more information about timecodes, see
            https://docs.aws.amazon.com/console/mediaconvert/timecode.

            - **VideoSelector** *(dict) --* Selector for video.

              - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
              animation. Specify which part of this input MediaConvert uses for your outputs. Leave
              this setting set to DISCARD in order to delete the alpha channel and preserve the
              video. Use REMAP_TO_LUMA for this setting to delete the video and map the alpha
              channel to the luma channel of your outputs.

              - **ColorSpace** *(string) --* If your input video has accurate color space metadata,
              or if you don't know about color space, leave this set to the default value Follow
              (FOLLOW). The service will automatically detect your input color space. If your input
              video has metadata indicating the wrong color space, specify the accurate color space
              here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color
              Volume static metadata isn't present in your video stream, or if that metadata is
              present but not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct
              values in the input HDR 10 metadata (Hdr10Metadata) settings. For more information
              about MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the
              input file and the job input settings Color space (ColorSpace) and HDR master display
              information settings(Hdr10Metadata). The Color space usage setting determines which
              takes precedence. Choose Force (FORCE) to use color metadata from the input job
              settings. If you don't specify values for those settings, the service defaults to
              using metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color
              metadata from the source when it is present. If there's no color metadata in your
              input file, the service defaults to using values you specify in the input settings.

              - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
              missing or inaccurate in your input video. Appropriate values vary depending on the
              input video and must be provided by a color grader. The color grader generates these
              values during the HDR 10 mastering process. The valid range for each of these settings
              is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
              settings - When you specify these values, you must also set Color space (ColorSpace)
              to HDR 10 (HDR10). To specify whether the the values you specify here take precedence
              over the values in the metadata of your input file, set Color space usage
              (ColorSpaceUsage). To specify whether color metadata is included in an output, set
              Color metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
              https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input
              file. Specify this value as an integer; the system automatically converts it to the
              hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
              an identifier for a set of data in an MPEG-2 transport stream container.

              - **ProgramNumber** *(integer) --* Selects a specific program from within a
              multi-program transport stream. Note that Quad 4K is not currently supported.

              - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
              your video. You can choose automatic rotation or specify a rotation. You can specify a
              clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is
              .mov or .mp4 and your input has rotation metadata, you can choose Automatic to have
              the service rotate your video according to the rotation specified in the metadata. The
              rotation must be within one degree of 90, 180, or 270 degrees. If the rotation
              metadata specifies any other rotation, the service will default to no rotation. By
              default, the service does no rotation, even if your input video has rotation metadata.
              The service doesn't pass through rotation metadata.

        - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The
        motion graphics that you specify here appear on all outputs in all output groups.

          - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
          unspecified. If your motion graphic asset is a series of .png files, specify the frame
          rate of the overlay in frames per second, as a fraction. For example, specify 24 fps as
          24/1. Make sure that the number of images in your series matches the frame rate and your
          intended overlay duration. For example, if you want a 30-second overlay at 30 fps, you
          should have 900 .png images. This overlay frame rate doesn't need to match the frame rate
          of the underlying video.

            - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
            overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

            - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
            overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

          - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
          overlay on your video. For .png files, provide the file name of the first file in the
          series. Make sure that the names of the .png files end with sequential numbers that
          specify the order that they are played in. For example, overlay_000.png, overlay_001.png,
          overlay_002.png, and so on. The sequence must start at zero, and each image file name must
          have the same number of digits. Pad your initial file names with enough zeros to complete
          the sequence. For example, if the first image is overlay_0.png, there can be only 10
          images in the sequence, with the last image being overlay_9.png. But if the first image is
          overlay_00.png, there can be 100 images in the sequence.

          - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
          providing for your overlay. You can choose either a .mov file or a series of .png files.

          - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic
          overlay on the video frame. Specify in pixels, from the upper-left corner of the frame. If
          you don't specify an offset, the service scales your overlay to the full size of the
          frame. Otherwise, the service inserts the overlay at its native resolution and scales the
          size up or down with any video scaling.

            - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the
            left edge of the video frame.

            - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
            edge of the video frame.

          - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
          or plays only once.

          - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
          (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
          account how you have set up your timecode configuration under both job settings and input
          settings. The simplest way to do that is to set both to start at 0. If you need to set up
          your job to follow timecodes embedded in your source that don't start at zero, make sure
          that you specify a start time that is after the first embedded timecode. For more
          information, see
          https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide
          and input timecode configuration settings in your JSON job settings specification at
          settings>timecodeConfig>source and settings>inputs>timecodeSource.

        - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
        do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
        configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all
        outputs in the job. To enable Nielsen configuration programmatically, include an instance of
        nielsenConfiguration in your JSON job specification. Even if you don't include any children
        of nielsenConfiguration, you still enable the setting.

          - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
          functionality. If you must include this property, set the value to zero.

          - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
          distributor ID that is assigned to your organization by Neilsen.

        - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
        outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS,
        Quicktime, MXF, and no container) are grouped in a single output group as well. Required in
        (OutputGroups) is a group of settings that apply to the whole group. This required object
        depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
        settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
        HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
        MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

          - *(dict) --* Group of outputs

            - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
            the output group. This value is displayed on the console and can make your job settings
            JSON more human-readable. It does not affect your outputs. Use up to twelve characters
            that are either letters, numbers, spaces, or underscores.

            - **Name** *(string) --* Name of the output group

            - **OutputGroupSettings** *(dict) --* Output Group settings, including type

              - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
              Output Group may only contain a single video, audio, or caption output.

                - **AdditionalManifests** *(list) --* By default, the service creates one top-level
                .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group
                in your job. These default manifests reference every output in the output group. To
                create additional top-level manifests that reference a subset of the outputs in the
                output group, specify a list of them here. For each additional manifest that you
                specify, the service creates one HLS manifest and one DASH manifest.

                  - *(dict) --* Specify the details for each pair of HLS and DASH additional
                  manifests that you want the service to generate for this CMAF output group. Each
                  pair of manifests can reference a different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your HLS group is film-name.m3u8. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                    specify a manifestNameModifier that is different from the nameModifier of the
                    output. The service uses the output name modifier to create unique names for the
                    individual variant manifests.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                file at the top level BaseURL element. Can be used if streams are delivered from a
                different URL than the manifest file.

                - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
                which prevents client from saving media segments for later replay.

                - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
                RFC-4281) during m3u8 playlist generation.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* DRM settings.

                  - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                  value represented by a 32-character text string. If this parameter is not set then
                  the Initialization Vector will follow the segment number by default.

                  - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want
                  the service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                  (SAMPLE-AES) or AES_CTR (AES-CTR).

                  - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                  outputs, choose whether the service writes the 128-bit encryption initialization
                  vector in the HLS and DASH manifests.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                  settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                  output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                  settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                    signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                    package. The DASH manifest can currently signal up to three system IDs. For more
                    information, see https://dashif.org/identifiers/content_protection/.

                      - *(string) --*

                    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                    signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                    package. The HLS manifest can currently signal only one system ID. For more
                    information, see https://dashif.org/identifiers/content_protection/.

                      - *(string) --*

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                  - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                  static key provider.

                    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                    the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                    omitted to indicate an implicit value of 'identity'.

                    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                    single positive integer version value or a slash delimited list of version
                    values (1/2/3).

                    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                    32-character hexidecimal string to specify Key Value (StaticKeyValue).

                    - **Url** *(string) --* Relates to DRM implementation. The location of the
                    license server used for protecting content.

                  - **Type** *(string) --* Specify whether your DRM encryption key is static or from
                  a key provider that follows the SPEKE standard. For more information about SPEKE,
                  see https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                Fragment length must be compatible with GOP size and Framerate. Note that fragments
                will end on the next keyframe after this number of seconds, so actual fragment
                length may be longer. When Emit Single File is checked, the fragmentation is
                internal to a single output file and it does not cause the creation of many output
                files as in other output types.

                - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                should use floating point values for segment duration.

                - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
                needed to ensure smooth playout.

                - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                0, unless you are troubleshooting a problem with how devices play back the end of
                your video asset. If you know that player devices are hanging on the final segment
                of your video because the length of your final segment is too short, use this
                setting to specify a minimum final segment length, in seconds. Choose a value that
                is greater than or equal to 1 and less than your segment length. When you specify a
                value for this setting, the encoder will combine any final segment that is shorter
                than the length that you specify with the previous segment. For example, your
                segment length is 3 seconds and your final segment is .5 seconds without a minimum
                final segment length; when you set the minimum final segment length to 1, your final
                segment is 3.5 seconds.

                - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                main. When you choose Main profile (MAIN_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                On-demand (ON_DEMAND_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
                you must also set the output group setting Segment control (SegmentControl) to
                Single file (SINGLE_FILE).

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
                generated, which is internally segmented using the Fragment Length and Segment
                Length. When set to SEGMENTED_FILES, separate segment files will be created.

                - **SegmentLength** *(integer) --* Use this setting to specify the length, in
                seconds, of each individual CMAF segment. This value applies to the whole package;
                that is, to every output in the output group. Note that segments end on the first
                keyframe after this number of seconds, so the actual segment length might be
                slightly longer. If you set Segment control (CmafSegmentControl) to single file, the
                service puts the content of each output in a single file that has metadata that
                marks these segments. If you set it to segmented files, the service creates multiple
                files for each output, each with the content of one segment.

                - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
                video in EXT-X-STREAM-INF tag of variant manifest.

                - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will
                be generated for this output.

                - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
                be generated for this output.

              - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

                - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
                manifest for each DASH ISO output group in your job. This default manifest
                references every output in the output group. To create additional DASH manifests
                that reference a subset of the outputs in the output group, specify a list of them
                here.

                  - *(dict) --* Specify the details for each additional DASH manifest that you want
                  the service to generate for this output group. Each manifest can reference a
                  different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your DASH group is film-name.mpd. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.mpd.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
                from a different URL than the manifest file.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* DRM settings.

                  - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                  compatibility of your output with video players on obsolete devices. It applies
                  only to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI
                  (UNENCRYPTED_SEI) only to correct problems with playback on older devices.
                  Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose Unencrypted
                  SEI, for that output, the service will exclude the access unit delimiter and will
                  leave the SEI NAL units unencrypted.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                Fragment length must be compatible with GOP size and Framerate. Note that fragments
                will end on the next keyframe after this number of seconds, so actual fragment
                length may be longer. When Emit Single File is checked, the fragmentation is
                internal to a single output file and it does not cause the creation of many output
                files as in other output types.

                - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

                - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
                needed to ensure smooth playout.

                - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                main. When you choose Main profile (MAIN_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                On-demand (ON_DEMAND_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
                you must also set the output group setting Segment control (SegmentControl) to
                Single file (SINGLE_FILE).

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
                generated, which is internally segmented using the Fragment Length and Segment
                Length. When set to SEGMENTED_FILES, separate segment files will be created.

                - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds).
                Note that segments will end on the next keyframe after this number of seconds, so
                actual segment length may be longer. When Emit Single File is checked, the
                segmentation is internal to a single output file and it does not cause the creation
                of many output files as in other output types.

                - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
                the 400 range when you play back your DASH output, enable this setting and run your
                transcoding job again. When you enable this setting, the service writes precise
                segment durations in the DASH manifest. The segment duration information appears
                inside the SegmentTimeline element, inside SegmentTemplate at the Representation
                level. When you don't enable this setting, the service writes approximate segment
                durations in your DASH manifest.

              - **FileGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

              - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

                - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your
                Apple HLS manifest. This setting does not determine whether SCTE-35 markers appear
                in the outputs themselves.

                  - *(string) --*

                - **AdditionalManifests** *(list) --* By default, the service creates one top-level
                .m3u8 HLS manifest for each HLS output group in your job. This default manifest
                references every output in the output group. To create additional top-level
                manifests that reference a subset of the outputs in the output group, specify a list
                of them here.

                  - *(dict) --* Specify the details for each additional HLS manifest that you want
                  the service to generate for this output group. Each manifest can reference a
                  different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your HLS group is film-name.m3u8. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                    specify a manifestNameModifier that is different from the nameModifier of the
                    output. The service uses the output name modifier to create unique names for the
                    individual variant manifests.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each
                output in the media .m3u8 file. Can be used if base manifest is delivered from a
                different URL than the main .m3u8 file.

                - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                  - *(dict) --* Caption Language Mapping

                    - **CaptionChannel** *(integer) --* Caption channel.

                    - **CustomLanguageCode** *(string) --* Specify the language for this captions
                    channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                    three-letter code listed at
                    https://www.loc.gov/standards/iso639-2/php/code_list.php.

                    - **LanguageDescription** *(string) --* Caption language description.

                - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
                captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least
                one language in the CC1 Language Code field. One CLOSED-CAPTION line is added for
                each Language Code you specify. Make sure to specify the languages in the order in
                which they appear in the original source (if the source is embedded format) or the
                order of the caption selectors (if the source is other than embedded). Otherwise,
                languages in the manifest will not match up properly with the output captions. None:
                Include CLOSED-CAPTIONS=
                    NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS
                line from the manifest.

                - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
                which prevents client from saving media segments for later replay.

                - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
                RFC-4281) during m3u8 playlist generation.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **DirectoryStructure** *(string) --* Indicates whether segments should be placed
                in subdirectories.

                - **Encryption** *(dict) --* DRM settings.

                  - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                  value represented by a 32-character text string. If this parameter is not set then
                  the Initialization Vector will follow the segment number by default.

                  - **EncryptionMethod** *(string) --* Encrypts the segments with the given
                  encryption scheme. Leave blank to disable. Selecting 'Disabled' in the web
                  interface also disables encryption.

                  - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                  128-bit number used in conjunction with the key for encrypting blocks. If set to
                  INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                  Vector is not in the manifest.

                  - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                  EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                  HLS FairPlay content protection.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                  - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                  static key provider.

                    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                    the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                    omitted to indicate an implicit value of 'identity'.

                    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                    single positive integer version value or a slash delimited list of version
                    values (1/2/3).

                    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                    32-character hexidecimal string to specify Key Value (StaticKeyValue).

                    - **Url** *(string) --* Relates to DRM implementation. The location of the
                    license server used for protecting content.

                  - **Type** *(string) --* Specify whether your DRM encryption key is static or from
                  a key provider that follows the SPEKE standard. For more information about SPEKE,
                  see https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                should use floating point values for segment duration.

                - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                0, unless you are troubleshooting a problem with how devices play back the end of
                your video asset. If you know that player devices are hanging on the final segment
                of your video because the length of your final segment is too short, use this
                setting to specify a minimum final segment length, in seconds. Choose a value that
                is greater than or equal to 1 and less than your segment length. When you specify a
                value for this setting, the encoder will combine any final segment that is shorter
                than the length that you specify with the previous segment. For example, your
                segment length is 3 seconds and your final segment is .5 seconds without a minimum
                final segment length; when you set the minimum final segment length to 1, your final
                segment is 3.5 seconds.

                - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
                looking ahead and back within the specified range for a nearby avail and extending
                the segment size if needed.

                - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
                be generated for this HLS output group.

                - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
                in .m3u8 manifest files. The value is calculated as follows: either the program date
                and time are initialized using the input timecode source, or the time is initialized
                using the input timecode source and the date is initialized using the
                timestamp_offset.

                - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
                EXT-X-PROGRAM-DATE-TIME entry, in seconds.

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a
                single media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for
                playback.

                - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
                create (in seconds). Note that segments will end on the next keyframe after this
                number of seconds, so actual segment length may be longer.

                - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
                subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
                for this setting to have an effect.

                - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
                video in EXT-X-STREAM-INF tag of variant manifest.

                - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

                - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

                - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
                offset to fine tune the timestamps.

              - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

                - **AdditionalManifests** *(list) --* By default, the service creates one .ism
                Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
                in your job. This default manifest references every output in the output group. To
                create additional manifests that reference a subset of the outputs in the output
                group, specify a list of them here.

                  - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                  manifest that you want the service to generate for this output group. Each
                  manifest can reference a different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your Microsoft Smooth group is film-name.ismv. If you
                    enter "-no-premium" for this setting, then the file name the service generates
                    for this top-level manifest is film-name-no-premium.ismv.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
                audio encoding settings across a Microsoft Smooth output group into a single audio
                stream.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* If you are using DRM, set DRM System
                (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
                the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
                and frame rate.

                - **ManifestEncoding** *(string) --* Use Manifest encoding
                (MsSmoothManifestEncoding) to specify the encoding format for the server and client
                manifest. Valid options are utf8 and utf16.

              - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
              Microsoft Smooth Streaming, CMAF)

            - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
            settings per output.

              - *(dict) --* An output object describes the settings for a single output file or
              stream in an output group.

                - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
                encoding settings organized by audio codec. Include one instance of
                (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
                encoding settings.

                  - *(dict) --* Description of audio output

                    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                    settings. Ignore these settings unless you need to comply with a loudness
                    standard.

                      - **Algorithm** *(string) --* Choose one of the following audio normalization
                      algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated
                      average loudness for an entire piece of content, suitable for measurement of
                      short-form content under ATSC recommendation A/85. Supports up to 5.1 audio
                      channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
                      loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
                      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement
                      algorithm as 1770-2, with an updated true peak measurement. ITU-R BS.1770-4:
                      Higher channel count. Allows for more audio channels than the other
                      algorithms, including configurations such as 7.1.

                      - **AlgorithmControl** *(string) --* When enabled the output audio is
                      corrected using the chosen algorithm. If disabled, the audio will be measured
                      but not adjusted.

                      - **CorrectionGateLevel** *(integer) --* Content measuring above this level
                      will be corrected to the target level. Content measuring below this level will
                      not be corrected. Gating only applies when not using real_time_correction.

                      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio
                      track loudness to a CSV file.

                      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                      TruePeak for each output's audio track loudness.

                      - **TargetLkfs** *(float) --* When you use Audio normalization
                      (AudioNormalizationSettings), optionally use this setting to specify a target
                      loudness. If you don't specify a value here, the encoder chooses a value for
                      you, based on the algorithm that you choose for Algorithm (algorithm). If you
                      choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                      encoder will choose -23 LKFS.

                    - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                    input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector
                    by name based on its order within each input. For example if you specify "Audio
                    Selector 3", then the third audio selector will be used from each input. If an
                    input does not have an "Audio Selector 3", then the audio selector marked as
                    "default" in that input will be used. If there is no audio selector marked as
                    "default", silence will be inserted for the duration of that input.
                    Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may
                    be specified, with similar default/silence behavior. If no audio_source_name is
                    specified, then "Audio Selector 1" will be chosen automatically.

                    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                    unchecked (false). A number between 0 and 255. The following are defined in
                    ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                         Hearing Impaired, 3 =
                    Visually Impaired Commentary, 4-255 = Reserved.

                    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                    contains an ISO 639 audio_type, then that value is passed through to the output.
                    If the input contains no ISO 639 audio_type, the value in Audio Type is included
                    in the output. Otherwise the value in Audio Type is included in the output. Note
                    that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                    is set to BROADCASTER_MIXED_AD.

                    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                    (AudioDescriptions) contains the group of settings related to audio encoding.
                    The settings in this group vary depending on the value that you choose for Audio
                    codec (Codec). For each codec enum that you choose, define the corresponding
                    settings object. The following lists the codec enum, settings object pairs. *
                    AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
                    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                      - **AacSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one
                      of two mutually exclusive groups of AAC settings--VBR and CBR. To select one
                      of these modes, set the value of Bitrate control mode (rateControlMode) to
                      "VBR" or "CBR". In VBR mode, you control the audio quality with the setting
                      VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate).
                      Defaults and valid values depend on the rate control mode.

                        - **AudioDescriptionBroadcasterMix** *(string) --* Choose
                        BROADCASTER_MIXED_AD when the input contains pre-mixed main audio + audio
                        description (AD) as a stereo pair. The value for AudioType will be set to 3,
                        which signals to downstream systems that this stream contains "broadcaster
                        mixed AD". Note that the input received by the encoder must contain
                        pre-mixed audio; the encoder does not perform the mixing. When you choose
                        BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                        AudioType and FollowInputAudioType. Choose NORMAL when the input does not
                        contain pre-mixed audio + audio description (AD). In this case, the encoder
                        will use any values you provide for AudioType and FollowInputAudioType.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        The set of valid values for this setting is: 6000, 8000, 10000, 12000,
                        14000, 16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000,
                        96000, 112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000,
                        384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value
                        you set is also constrained by the values that you choose for Profile
                        (codecProfile), Bitrate control mode (codingMode), and Sample rate
                        (sampleRate). Default values depend on Bitrate control mode and Profile.

                        - **CodecProfile** *(string) --* AAC Profile.

                        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or
                        5.1 channel layout. Valid values depend on rate control mode and profile.
                        "1.0 - Audio Description (Receiver Mix)" setting receives a stereo
                        description plus control track and emits a mono AAC encode of the
                        description track, with control data emitted in the PES header as per ETSI
                        TS 101 154 Annex E.

                        - **RateControlMode** *(string) --* Rate Control Mode.

                        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                        use LATM/LOAS AAC in an output, you must choose "No container" for the
                        output container.

                        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on
                        rate control mode and profile.

                        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                        for raw or MPEG-2 Transport Stream containers.

                        - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                        rate_control_mode is VBR.

                      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AC3.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid bitrates depend on the coding mode.

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                        stream that the encoder emits. For more information about the AC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number
                        of channels.

                        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                        input audio is Dolby Digital, dialnorm will be passed through.

                        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                        adds dynamic range compression signaling to the output bitstream as defined
                        in the Dolby Digital specification.

                        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                        channel prior to encoding. Only valid with 3_2_LFE coding mode.

                        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                        metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                        this audio data. If audio was not supplied from one of these streams, then
                        the static metadata settings will be used.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                      - **AiffSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AIFF.

                        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                        sample, to choose the encoding quality for this audio track.

                        - **Channels** *(integer) --* Specify the number of channels in this output
                        audio track. Valid values are 1 and even numbers up to 64. For example, 1,
                        2, 4, 6, and so on, up to 64.

                        - **SampleRate** *(integer) --* Sample rate in hz.

                      - **Codec** *(string) --* Type of Audio codec.

                      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid values: 384k, 448k, 640k, 768k

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                        stream that the encoder emits. For more information about the EAC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                        (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence
                        to adjust loudness based on dialogue analysis.

                        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                        level for a signal with dynamic range compression.

                        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                        the audio dynamic range when compressing the audio.

                        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left only/Right only center mix (Lo/Ro center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and
                        -6.0.

                        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert
                        uses this value for downmixing. How the service uses this value depends on
                        the value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                        values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left total/Right total center mix (Lt/Rt center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and
                        -6.0.

                        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                        value -60 mutes the channel.

                        - **MeteringMode** *(string) --* Choose how the service meters the loudness
                        of your audio.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                        that must be speech before the encoder uses the measured speech loudness as
                        the overall program loudness.

                        - **StereoDownmix** *(string) --* Choose how the service does stereo
                        downmixing.

                        - **SurroundExMode** *(string) --* Specify whether your input audio has an
                        additional center rear surround channel matrix encoded into your left and
                        right surround channels.

                      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value EAC3.

                        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                        dB attenuation to the surround channels. Only used for 3/2 coding mode.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid bitrates depend on the coding mode.

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                        stream that the encoder emits. For more information about the EAC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                        number of channels.

                        - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                        channels.

                        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                        input audio is Dolby Digital Plus, dialnorm will be passed through.

                        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                        level for a signal with dynamic range compression.

                        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                        the audio dynamic range when compressing the audio.

                        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                        LFE channel is enabled

                        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                        channel prior to encoding. Only valid with 3_2_LFE coding mode.

                        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                        Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                        mutes the channel. This setting applies only if you keep the default value
                        of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                        (Eac3CodingMode). If you choose a different value for Coding mode, the
                        service ignores Left only/Right only center (loRoCenterMixLevel).

                        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                        Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                        channel. This setting applies only if you keep the default value of 3/2 - L,
                        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                        If you choose a different value for Coding mode, the service ignores Left
                        only/Right only surround (loRoSurroundMixLevel).

                        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left total/Right total center mix (Lt/Rt
                        center). MediaConvert uses this value for downmixing. How the service uses
                        this value depends on the value that you choose for Stereo downmix
                        (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                        and -60. The value -60 mutes the channel. This setting applies only if you
                        keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                        setting Coding mode (Eac3CodingMode). If you choose a different value for
                        Coding mode, the service ignores Left total/Right total center
                        (ltRtCenterMixLevel).

                        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                        surround). MediaConvert uses this value for downmixing. How the service uses
                        this value depends on the value that you choose for Stereo downmix
                        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                        value -60 mutes the channel. This setting applies only if you keep the
                        default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                        Coding mode (Eac3CodingMode). If you choose a different value for Coding
                        mode, the service ignores Left total/Right total surround
                        (ltRtSurroundMixLevel).

                        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                        metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                        this audio data. If audio was not supplied from one of these streams, then
                        the static metadata settings will be used.

                        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                        audio will be passed through if it is present on the input. this detection
                        is dynamic over the life of the transcode. Inputs that alternate between DD+
                        and non-DD+ content will have a consistent DD+ output as the system
                        alternates between passthrough and encoding.

                        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied
                        to the surround channels. Only used for 3/2 coding mode.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                        - **StereoDownmix** *(string) --* Choose how the service does stereo
                        downmixing. This setting only applies if you keep the default value of 3/2 -
                        L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                        (Eac3CodingMode). If you choose a different value for Coding mode, the
                        service ignores Stereo downmix (Eac3StereoDownmix).

                        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                        extra center back surround channel is matrix encoded into the left and right
                        surround channels.

                        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                        Surround is matrix encoded into the two channels.

                      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value MP2.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                        - **Channels** *(integer) --* Set Channels to specify the number of channels
                        in this output audio track. Choosing Mono in the console will give you 1
                        output channel; choosing Stereo will give you 2. In the API, valid values
                        are 1 and 2.

                        - **SampleRate** *(integer) --* Sample rate in hz.

                      - **WavSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value WAV.

                        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                        sample, to choose the encoding quality for this audio track.

                        - **Channels** *(integer) --* Specify the number of channels in this output
                        audio track. Valid values are 1 and even numbers up to 64. For example, 1,
                        2, 4, 6, and so on, up to 64.

                        - **Format** *(string) --* The service defaults to using RIFF for WAV
                        outputs. If your output audio is likely to exceed 4 GB in file size, or if
                        you otherwise need the extended support of the RF64 format, set your output
                        WAV file format to RF64.

                        - **SampleRate** *(integer) --* Sample rate in Hz.

                    - **CustomLanguageCode** *(string) --* Specify the language for this audio
                    output track. The service puts this language code into your output audio track
                    when you set Language code control (AudioLanguageCodeControl) to Use configured
                    (USE_CONFIGURED). The service also uses your specified custom language code when
                    you set Language code control (AudioLanguageCodeControl) to Follow input
                    (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                    can also use any other code in the full RFC-5646 specification. Streaming
                    outputs are those that are in one of the following output groups: CMAF, DASH
                    ISO, Apple HLS, or Microsoft Smooth Streaming.

                    - **LanguageCode** *(string) --* Indicates the language of the audio output
                    track. The ISO 639 language specified in the 'Language Code' drop down will be
                    used when 'Follow Input Language Code' is not selected or when 'Follow Input
                    Language Code' is selected but there is no ISO 639 language code specified by
                    the input.

                    - **LanguageCodeControl** *(string) --* Specify which source for language code
                    takes precedence for this audio track. When you choose Follow input
                    (FOLLOW_INPUT), the service uses the language code from the input track if it's
                    present. If there's no languge code on the input track, the service uses the
                    code that you specify in the setting Language code (languageCode or
                    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
                    service uses the language code that you specify.

                    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                      group of fields that hold the remixing value for each channel. Units are in
                      dB. Acceptable values are within the range from -60 (mute) through 6. A
                      setting of 0 passes the input channel unchanged to the output channel (no
                      attenuation or amplification).

                        - **OutputChannels** *(list) --* List of output channels

                          - *(dict) --* OutputChannel mapping settings.

                            - **InputChannels** *(list) --* List of input channels

                              - *(integer) --*

                      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                      input that you want to use in your output. With remixing, you might combine or
                      split the data in these channels, so the number of channels in your final
                      output might be different.

                      - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                      after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                    - **StreamName** *(string) --* Specify a label for this output audio stream. For
                    example, "English", "Director commentary", or "track_2". For streaming outputs,
                    MediaConvert passes this information into destination manifests for display on
                    the end-viewer's player device. For outputs in other output groups, the service
                    ignores this setting.

                - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
                captions settings. For each output that has captions, include one instance of
                (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
                settings.

                  - *(dict) --* Description of Caption output

                    - **CaptionSelectorName** *(string) --* Specifies which "Caption
                    Selector":#inputs-caption_selector to use from each input when generating
                    captions. The name should be of the format "Caption Selector ", which denotes
                    that the Nth Caption Selector will be used from each input.

                    - **CustomLanguageCode** *(string) --* Specify the language for this captions
                    output track. For most captions output formats, the encoder puts this language
                    information in the output captions metadata. If your output captions format is
                    DVB-Sub or Burn in, the encoder uses this language information when
                    automatically selecting the font script for rendering the captions text. For all
                    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                    can also use any other code in the full RFC-5646 specification. Streaming
                    outputs are those that are in one of the following output groups: CMAF, DASH
                    ISO, Apple HLS, or Microsoft Smooth Streaming.

                    - **DestinationSettings** *(dict) --* Specific settings required by destination
                    type. Note that burnin_destination_settings are not available if the source of
                    the caption data is Embedded or Teletext.

                      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                        - **Alignment** *(string) --* If no explicit x_position or y_position is
                        provided, setting alignment to centered will place the captions at the
                        bottom center of the output. Similarly, setting a left alignment will align
                        captions to the bottom left of the output. If x and y positions are given in
                        conjunction with the alignment parameter, the font will be justified (either
                        left or centered) relative to those coordinates. This option is not valid
                        for source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                        behind the captions. All burn-in and DVB-Sub font settings must match.

                        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                        background rectangle. 255 is opaque; 0 is transparent. Leaving this
                        parameter blank is equivalent to setting it to 0 (transparent). All burn-in
                        and DVB-Sub font settings must match.

                        - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                        This option is not valid for source captions that are STL, 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                        captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                        settings must match.

                        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                        default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                        - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                        script code, if the LanguageCode is not sufficient for determining the
                        script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                        "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                        font for rendering burn-in captions.

                        - **FontSize** *(integer) --* A positive integer indicates the exact font
                        size in points. Set to 0 for automatic font size selection. All burn-in and
                        DVB-Sub font settings must match.

                        - **OutlineColor** *(string) --* Specifies font outline color. This option
                        is not valid for source captions that are either 608/embedded or teletext.
                        These source settings are already pre-defined by the caption stream. All
                        burn-in and DVB-Sub font settings must match.

                        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                        option is not valid for source captions that are either 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                        the captions. All burn-in and DVB-Sub font settings must match.

                        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255
                        is opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                        setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                        match.

                        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                        must match.

                        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels above the text. All burn-in and DVB-Sub font settings
                        must match.

                        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                        in Teletext or STL formats. Specify whether the spacing between letters in
                        your captions is set by the captions grid or varies depending on letter
                        width. Choose fixed grid to conform to the spacing specified in the captions
                        file more accurately. Choose proportional to make the text easier to read if
                        the captions are closed caption.

                        - **XPosition** *(integer) --* Specifies the horizontal position of the
                        caption relative to the left side of the output in pixels. A value of 10
                        would result in the captions starting 10 pixels from the left of the output.
                        If no explicit x_position is provided, the horizontal caption position will
                        be determined by the alignment parameter. This option is not valid for
                        source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **YPosition** *(integer) --* Specifies the vertical position of the
                        caption relative to the top of the output in pixels. A value of 10 would
                        result in the captions starting 10 pixels from the top of the output. If no
                        explicit y_position is provided, the caption will be positioned towards the
                        bottom of the output. This option is not valid for source captions that are
                        STL, 608/embedded or teletext. These source settings are already pre-defined
                        by the caption stream. All burn-in and DVB-Sub font settings must match.

                      - **DestinationType** *(string) --* Specify the format for this set of
                      captions on this output. The default format is embedded without SCTE-20. Other
                      options are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext,
                      TTML, and web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                      (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
                      spec. To create a non-compliant output where the embedded captions come first,
                      choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                        - **Alignment** *(string) --* If no explicit x_position or y_position is
                        provided, setting alignment to centered will place the captions at the
                        bottom center of the output. Similarly, setting a left alignment will align
                        captions to the bottom left of the output. If x and y positions are given in
                        conjunction with the alignment parameter, the font will be justified (either
                        left or centered) relative to those coordinates. This option is not valid
                        for source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                        behind the captions. All burn-in and DVB-Sub font settings must match.

                        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                        background rectangle. 255 is opaque; 0 is transparent. Leaving this
                        parameter blank is equivalent to setting it to 0 (transparent). All burn-in
                        and DVB-Sub font settings must match.

                        - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                        This option is not valid for source captions that are STL, 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                        captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                        settings must match.

                        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                        default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                        - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                        script code, if the LanguageCode is not sufficient for determining the
                        script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                        "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                        font for rendering DVB-Sub captions.

                        - **FontSize** *(integer) --* A positive integer indicates the exact font
                        size in points. Set to 0 for automatic font size selection. All burn-in and
                        DVB-Sub font settings must match.

                        - **OutlineColor** *(string) --* Specifies font outline color. This option
                        is not valid for source captions that are either 608/embedded or teletext.
                        These source settings are already pre-defined by the caption stream. All
                        burn-in and DVB-Sub font settings must match.

                        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                        option is not valid for source captions that are either 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                        the captions. All burn-in and DVB-Sub font settings must match.

                        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255
                        is opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                        setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                        match.

                        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                        must match.

                        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels above the text. All burn-in and DVB-Sub font settings
                        must match.

                        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                        standard or for hearing impaired. Choose hearing impaired if your subtitles
                        include audio descriptions and dialogue. Choose standard if your subtitles
                        include only dialogue.

                        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                        in Teletext or STL formats. Specify whether the spacing between letters in
                        your captions is set by the captions grid or varies depending on letter
                        width. Choose fixed grid to conform to the spacing specified in the captions
                        file more accurately. Choose proportional to make the text easier to read if
                        the captions are closed caption.

                        - **XPosition** *(integer) --* Specifies the horizontal position of the
                        caption relative to the left side of the output in pixels. A value of 10
                        would result in the captions starting 10 pixels from the left of the output.
                        If no explicit x_position is provided, the horizontal caption position will
                        be determined by the alignment parameter. This option is not valid for
                        source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **YPosition** *(integer) --* Specifies the vertical position of the
                        caption relative to the top of the output in pixels. A value of 10 would
                        result in the captions starting 10 pixels from the top of the output. If no
                        explicit y_position is provided, the caption will be positioned towards the
                        bottom of the output. This option is not valid for source captions that are
                        STL, 608/embedded or teletext. These source settings are already pre-defined
                        by the caption stream. All burn-in and DVB-Sub font settings must match.

                      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                      embedded/ancillary caption outputs, including 608/708 Channel destination
                      number.

                        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                        your input captions are SCC format and your output captions are embedded in
                        the video stream. Specify a CC number for each captions channel in this
                        output. If you have two channels, choose CC numbers that aren't in the same
                        field. For example, choose 1 and 3. For more information, see
                        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                        your input captions are SCC format and you want both 608 and 708 captions
                        embedded in your output stream. Optionally, specify the 708 service number
                        for each output captions channel. Choose a different number for each
                        channel. To use this setting, also set Force 608 to 708 upconvert
                        (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
                        settings. If you choose to upconvert but don't specify a 708 service number,
                        MediaConvert uses the number that you specify for CC channel number
                        (destination608ChannelNumber) for the 708 service number. For more
                        information, see
                        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                      outputs.

                        - **StylePassthrough** *(string) --* Keep this setting enabled to have
                        MediaConvert use the font style and position information from the captions
                        source in the output. This option is available only when your input captions
                        are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                        output captions.

                      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to
                        make sure that the captions and the video are synchronized in the output.
                        Specify a frame rate that matches the frame rate of the associated video. If
                        the video frame rate is 29.97, choose 29.97 dropframe
                        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
                        drop_frame_timecode=
                            true; otherwise, choose 29.97 non-dropframe
                        (FRAMERATE_29_97_NON_DROPFRAME).

                      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                      output

                        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number
                        for the destination captions for this output. This value must be a
                        three-digit hexadecimal string; strings ending in -FF are invalid. If you
                        are passing through the entire set of Teletext data, do not use this field.

                        - **PageTypes** *(list) --* Specify the page types for this Teletext page.
                        If you don't specify a value here, the service sets the page type to the
                        default value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire
                        set of Teletext data, don't use this field. When you pass through a set of
                        Teletext pages, your output has the same page types as your input.

                          - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                          Table 94

                      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                      outputs, including Pass style information (TtmlStylePassthrough).

                        - **StylePassthrough** *(string) --* Pass through style and position
                        information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                        CFF-TT output or TTML output.

                    - **LanguageCode** *(string) --* Specify the language of this captions output
                    track. For most captions output formats, the encoder puts this language
                    information in the output captions metadata. If your output captions format is
                    DVB-Sub or Burn in, the encoder uses this language information to choose the
                    font language for rendering the captions text.

                    - **LanguageDescription** *(string) --* Specify a label for this set of output
                    captions. For example, "English", "Director commentary", or "track_2". For
                    streaming outputs, MediaConvert passes this information into destination
                    manifests for display on the end-viewer's player device. For outputs in other
                    output groups, the service ignores this setting.

                - **ContainerSettings** *(dict) --* Container specific settings.

                  - **Container** *(string) --* Container for this output. Some containers require a
                  container settings object. If not specified, the default object will be created.

                  - **F4vSettings** *(dict) --* Settings for F4v container

                    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom
                    is relocated to the beginning of the archive as required for progressive
                    downloading. Otherwise it is placed normally at the end.

                  - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to
                  outputs in a File output group when the output's container (ContainerType) is
                  MPEG-2 Transport Stream (M2TS). In these assets, data is organized by the program
                  map table (PMT). Each transport stream program contains subsets of data, including
                  audio, video, and metadata. Each of these subsets of data has a numerical label
                  called a packet identifier (PID). Each transport stream program corresponds to one
                  MediaConvert output. The PMT lists the types of data in a program along with their
                  PID. Downstream systems and players use the program map table to look up the PID
                  for each type of data it accesses and then uses the PIDs to locate specific data
                  within the asset.

                    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                    models for Dolby Digital audio.

                    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                    each PES packet.

                    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                    elementary audio streams you include in this output. Specify multiple PIDs as a
                    JSON array. Default is the range 482-492.

                      - *(integer) --*

                    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream
                    in bits per second. Setting to 0 lets the muxer automatically determine the
                    appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                    - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                    interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                    this can lead to lower latency, but low-memory devices may not be able to play
                    back the stream without interruptions.

                    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                    the specified table repetition interval.

                      - **NetworkId** *(integer) --* The numeric value placed in the Network
                      Information Table (NIT).

                      - **NetworkName** *(string) --* The network name text placed in the
                      network_name_descriptor inside the Network Information Table. Maximum length
                      is 256 characters.

                      - **NitInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                    the specified table repetition interval.

                      - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                      output stream. "Follow input SDT" copies SDT information from input stream to
                      output stream. "Follow input SDT if present" copies SDT information from input
                      stream to output stream if SDT information is present in the input, otherwise
                      it will fall back on the user-defined values. Enter "SDT Manually" means user
                      will enter the SDT information. "No SDT" means output stream will not contain
                      SDT information.

                      - **SdtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **ServiceName** *(string) --* The service name placed in the
                      service_descriptor in the Service Description Table. Maximum length is 256
                      characters.

                      - **ServiceProviderName** *(string) --* The service provider name placed in
                      the service_descriptor in the Service Description Table. Maximum length is 256
                      characters.

                    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                    subtitle data included in this output. Specify multiple PIDs as a JSON array.
                    Default is the range 460-479.

                      - *(integer) --*

                    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                    specified table repetition interval.

                      - **TdtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                    teletext data you include in this output. Default is 499.

                    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS,
                    audio EBP markers will be added to partitions 3 and 4. The interval between
                    these additional markers will be fixed, and will be slightly shorter than the
                    video EBP marker interval. When set to VIDEO_INTERVAL, these additional markers
                    will not be inserted. Only applicable when EBP segmentation markers are is
                    selected (segmentationMarkers is EBP or EBP_LEGACY).

                    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on.
                    They can either be placed only on the video PID, or on both the video PID and
                    all audio PIDs. Only applicable when EBP segmentation markers are is selected
                    (segmentationMarkers is EBP or EBP_LEGACY).

                    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                    the PES header.

                    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                    you know that your audio EBP markers are incorrectly appearing before your video
                    EBP markers. To correct this problem, set this value to Force (FORCE).

                    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                    used with EBP markers.

                    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                    between Program Clock References (PCRs) inserted into the transport stream.

                    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                    Points do not come within the specified time interval of each other by looking
                    ahead at input video. If another EBP is going to come in within the specified
                    time interval, the current EBP is not emitted, and the segment is "stretched" to
                    the next marker. The lookahead value does not add latency to the system. The
                    Live Event must be configured elsewhere to create sufficient latency to make the
                    lookahead accurate.

                    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                    tracking will be detected in the input audio and an equivalent ID3 tag will be
                    inserted in the output.

                    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                    packets to insert into the transport stream. This can be used if a downstream
                    encryption system requires periodic null packets.

                    - **PatInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                    Reference value is inserted for every Packetized Elementary Stream (PES) header.
                    This is effective only when the PCR PID is the same as the video or audio
                    elementary stream.

                    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                    clock reference (PCR) in this output. If you do not specify a value, the service
                    will use the value for Video PID (VideoPid).

                    - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                    instances of the program map table (PMT) in the output transport stream.

                    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                    map table (PMT) itself. Default is 480.

                    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of
                    the private metadata stream. Default is 503.

                    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                    the program number used in the program map table (PMT) for this output. Default
                    is 1. Program numbers and program map tables are parts of MPEG-2 transport
                    stream containers, used for organizing data.

                    - **RateMode** *(string) --* When set to CBR, inserts null packets into
                    transport stream to fill specified bitrate. When set to VBR, the bitrate setting
                    acts as the maximum bitrate, but the output will not be padded up to that
                    bitrate.

                    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                    markers in your HLS and transport stream outputs at the insertion points that
                    you specify in an ESAM XML document. Provide the document in the setting SCC XML
                    (sccXml).

                      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35
                      stream in the transport stream generated by ESAM.

                    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the
                    SCTE-35 stream in the transport stream.

                    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                    Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input
                    to also appear in this output. Choose None (NONE) if you don't want SCTE-35
                    markers in this output. For SCTE-35 markers from an ESAM XML document-- Choose
                    None (NONE). Also provide the ESAM XML as a string in the setting Signal
                    processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
                    property scte35Esam).

                    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                    segmentation_time period. rai_segstart sets the Random Access Indicator bit in
                    the adaptation field. rai_adapt sets the RAI bit and adds the current timecode
                    in the private data bytes. psi_segstart inserts PAT and PMT tables at the start
                    of segments. ebp adds Encoder Boundary Point information to the adaptation field
                    as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
                    Boundary Point information to the adaptation field using a legacy proprietary
                    format.

                    - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                    how segmentation markers are inserted into the transport stream. With avails, it
                    is possible that segments may be truncated, which can influence where future
                    segmentation markers are inserted. When a segmentation style of "reset_cadence"
                    is selected and a segment is truncated due to an avail, we will reset the
                    segmentation cadence. This means the subsequent segment will have a duration of
                    of $segmentation_time seconds. When a segmentation style of "maintain_cadence"
                    is selected and a segment is truncated due to an avail, we will not reset the
                    segmentation cadence. This means the subsequent segment will likely be truncated
                    as well. However, all segments after that will have a duration of
                    $segmentation_time seconds. Note that EBP lookahead is a slight exception to
                    this rule.

                    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                    segment. Required unless markers is set to _none_.

                    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                    timed metadata in this output. Default is 502.

                    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                    itself in the program map table for this output. Transport stream IDs and
                    program map tables are parts of MPEG-2 transport stream containers, used for
                    organizing data.

                    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                    elementary video stream in the transport stream.

                  - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                    each PES packet.

                    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                    stream(s) in the transport stream. Multiple values are accepted, and can be
                    entered in ranges and/or by comma separation.

                      - *(integer) --*

                    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                    tracking will be detected in the input audio and an equivalent ID3 tag will be
                    inserted in the output.

                    - **PatInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                    Reference value is inserted for every Packetized Elementary Stream (PES) header.
                    This parameter is effective only when the PCR PID is the same as the video or
                    audio elementary stream.

                    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock
                    Reference (PCR) in the transport stream. When no value is given, the encoder
                    will assign the same value as the Video PID.

                    - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                    (PMT) in the transport stream.

                    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                    metadata stream in the transport stream.

                    - **ProgramNumber** *(integer) --* The value of the program number field in the
                    Program Map Table.

                    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                    the transport stream.

                    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                    Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input
                    to also appear in this output. Choose None (NONE) if you don't want SCTE-35
                    markers in this output. For SCTE-35 markers from an ESAM XML document-- Choose
                    None (NONE) if you don't want manifest conditioning. Choose Passthrough
                    (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
                    conditioning. In both cases, also provide the ESAM XML as a string in the
                    setting Signal processing notification XML (sccXml).

                    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting
                    to specify whether the service inserts the ID3 timed metadata from the input in
                    this output.

                    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                    metadata stream in the transport stream.

                    - **TransportStreamId** *(integer) --* The value of the transport stream ID
                    field in the Program Map Table.

                    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                    stream in the transport stream.

                  - **MovSettings** *(dict) --* Settings for MOV Container.

                    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate
                    for the video output settings.

                    - **CslgAtom** *(string) --* When enabled, file composition times will start at
                    zero, composition times in the 'ctts' (composition time to sample) box for
                    B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                    will be included per 14496-1 amendment 1. This improves compatibility with Apple
                    players and tools.

                    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                    streams into the QuickTime file using XDCAM fourcc codes. This increases
                    compatibility with Apple editors and players, but may decrease compatibility
                    with other players. Only applicable when the video codec is MPEG2.

                    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                    padding

                    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                    this setting.

                  - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create
                  audio-only AAC outputs with this container.

                    - **CslgAtom** *(string) --* When enabled, file composition times will start at
                    zero, composition times in the 'ctts' (composition time to sample) box for
                    B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                    will be included per 14496-1 amendment 1. This improves compatibility with Apple
                    players and tools.

                    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                    moov box.

                    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom
                    is relocated to the beginning of the archive as required for progressive
                    downloading. Otherwise it is placed normally at the end.

                    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the
                    output file. Usually not necessary to specify.

                  - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                    - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                    groups that include sidecar TTML or IMSC captions. You specify sidecar captions
                    in a separate output from your audio and video. Choose Raw (RAW) for captions in
                    a single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4)
                    for captions in XML format contained within fragmented MP4 files. This set of
                    fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                    markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                    insertion points that you specify in an ESAM XML document. Provide the document
                    in the setting SCC XML (sccXml).

                    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                    markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                    SCTE-35 markers that appear in your input to also appear in this output. Choose
                    None (NONE) if you don't want those SCTE-35 markers in this output.

                - **Extension** *(string) --* Use Extension (Extension) to specify the file
                extension for outputs in File output groups. If you do not specify a value, the
                service will use default extensions by container type as follows * MPEG-2 transport
                stream, m2ts * Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No
                Container, the service will use codec extensions (e.g. AAC, H265, H265, AC3)

                - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the
                service add a string to the end of each output filename. You specify the base
                filename as part of your destination URI. When you create multiple outputs in the
                same output group, Name modifier (NameModifier) is required. Name modifier also
                accepts format identifiers. For DASH ISO outputs, if you use the format identifiers
                $Number$ or $Time$ in one output, you must use them in the same way in all outputs
                of the output group.

                - **OutputSettings** *(dict) --* Specific settings for this type of output.

                  - **HlsSettings** *(dict) --* Settings for HLS output groups

                    - **AudioGroupId** *(string) --* Specifies the group to which the audio
                    Rendition belongs.

                    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                    outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                    container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                    file in a raw container. Regardless of the value that you specify here, if this
                    output has video, the service will place the output into an MPEG2-TS container.

                    - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                    with the video output stream. Input all the audio GROUP-IDs that are associated
                    to the video, separate by ','.

                    - **AudioTrackType** *(string) --* Four types of audio-only tracks are
                    supported: Audio-Only Variant Stream The client can play back this audio-only
                    stream instead of video in low-bandwidth scenarios. Represented as an
                    EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select, Default
                    Alternate rendition that the client should try to play back by default.
                    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                        YES,
                    AUTOSELECT=
                        YES Alternate Audio, Auto Select, Not Default Alternate rendition
                    that the client may try to play back by default. Represented as an EXT-X-MEDIA
                    in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                        YES Alternate Audio, not Auto
                    Select Alternate rendition that the client will not try to play back by default.
                    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                        NO, AUTOSELECT=NO

                    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                    Manifest in addition to the HLS manifest

                    - **SegmentModifier** *(string) --* String concatenated to end of segment
                    filenames. Accepts "Format Identifiers":#format_identifier_parameters.

                - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
                transcoding settings. Provide the system or custom preset name. You can specify
                either Preset (Preset) or Container settings (ContainerSettings), but not both.

                - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
                encoding settings. The specific video settings depend on the video codec that you
                choose when you specify a value for Video codec (codec). Include one instance of
                (VideoDescription) per output.

                  - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                  MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                  service includes AFD values in the output video data and what those values are. *
                  Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                  input AFD values and instead encode the value specified in the job. * Choose Auto
                  to calculate output AFD values based on the input AFD scaler data.

                  - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to
                  all outputs. The service no longer accepts the value DISABLED for AntiAlias. If
                  you specify that in your job, the service will ignore the setting.

                  - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                  (VideoDescription), contains the group of settings related to video encoding. The
                  settings in this group vary depending on the value that you choose for Video codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * H_264,
                  H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings
                  * FRAME_CAPTURE, FrameCaptureSettings

                    - **Codec** *(string) --* Specifies the video codec. This must be equal to one
                    of the enum values defined by the object VideoCodec.

                    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                      - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                      frame of the output stream, then one frame every
                      framerateDenominator/framerateNumerator seconds. For example, settings of
                      framerateNumerator = 1 and framerateDenominator =
                           3 (a rate of 1/3 frame per
                      second) will capture the first frame, then 1 frame every 3s. Files will be
                      named as filename.n.jpg where n is the 0-based sequence number of each
                      Capture.

                      - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                      frame of the output stream, then one frame every
                      framerateDenominator/framerateNumerator seconds. For example, settings of
                      framerateNumerator = 1 and framerateDenominator =
                           3 (a rate of 1/3 frame per
                      second) will capture the first frame, then 1 frame every 3s. Files will be
                      named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number
                      zero padded to 7 decimal places.

                      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg
                      output files).

                      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                      quality.

                    - **H264Settings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value H_264.

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                      your output video settings. If you aren't sure what level to specify, choose
                      Auto (AUTO).

                      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                      are only available with the AVC-I License.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be
                      in Main or High profile) or CAVLC.

                      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                      for interlaced outputs.

                      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame to reduce flicker or 'pop' on I-frames.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job specification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* When you use the API for transcode
                      jobs that use frame rate conversion, specify the frame rate as a fraction. For
                      example, 24000 / 1001 =
                           23.976 fps. Use FramerateDenominator to specify the
                      denominator of this fraction. In this example, use 1001 for the value of
                      FramerateDenominator. When you use the console for transcode jobs that use
                      frame rate conversion, provide the value as a decimal number for Framerate. In
                      this example, specify 23.976.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                      structures that have B frames > 1.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type, as follows. - If the source is interlaced, the output will be
                      interlaced with the same polarity as the source (it will follow the source).
                      The output could therefore be a mix of "top field first" and "bottom field
                      first". - If the source is progressive, the output will be interlaced with
                      "top field first" or "bottom field first" polarity, depending on which of the
                      Follow options you chose.

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000. Required when Rate control mode is
                      QVBR.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                      The encoder may use more than requested if using B-frames and/or interlaced
                      encoding.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                      high-quality singlepass, or high-quality multipass video encoding.

                      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                      encoding with the H.264 codec. Required when you set Rate control mode to
                      QVBR. Not valid when you set Rate control mode to a value other than QVBR, or
                      when you don't define Rate control mode.

                        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                        control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                        average bitrate values suited to the complexity of your input video, the
                        service limits the average bitrate of the video part of this output to the
                        value that you choose. That is, the total size of the video element is less
                        than or equal to the value you set multiplied by the number of seconds of
                        encoded output.

                        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                        control mode. That is, when you specify qvbrSettings within h264Settings.
                        Specify the target quality level for this output, from 1 to 10. Use higher
                        numbers for greater quality. Level 10 results in nearly lossless
                        compression. The quality level for most broadcast-quality transcodes is
                        between 6 and 9.

                      - **RateControlMode** *(string) --* Use this setting to specify whether this
                      output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                      variable bitrate (QVBR).

                      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture,
                      even if repeated.

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default. If this output uses QVBR, choose Transition
                      detection (TRANSITION_DETECTION) for further video quality improvement. For
                      more information about QVBR, see
                      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                      - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                      equal to the number of macroblock rows for progressive pictures, and less than
                      or equal to half the number of macroblock rows for interlaced pictures.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                      values reduce high-frequency content in the encoded image.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                      - **Telecine** *(string) --* This field applies only if the Streams > Advanced
                      > Framerate (framerate) field is set to 29.970. This field works with the
                      Streams > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and
                      the Streams > Advanced > Interlaced Mode field (interlace_mode) to identify
                      the scan type for the output: Progressive, Interlaced, Hard Telecine or Soft
                      Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
                      23.976; the player converts this output to 29.97i.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as
                      4 bytes of an unregistered SEI message.

                    - **H265Settings** *(dict) --* Settings for H265 codec

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                      Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                      Transfer Function (EOTF).

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* H.265 Level.

                      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                      (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                      "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                      available with the HEVC 4:2:2 License.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame to reduce flicker or 'pop' on I-frames.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                      structures that have B frames > 1.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                      Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                      the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom
                      Field First (BOTTOM_FIELD) to create an output that's interlaced with the same
                      field polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or
                      Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output
                      with the same field polarity as the source. If the source is interlaced, the
                      output will be interlaced with the same polarity as the source (it will follow
                      the source). The output could therefore be a mix of "top field first" and
                      "bottom field first". If the source is progressive, your output will be
                      interlaced with "top field first" or "bottom field first" polarity, depending
                      on which of the Follow options you chose. If you don't choose a value, the
                      service will default to Progressive (PROGRESSIVE).

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000. Required when Rate control mode is
                      QVBR.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                      The encoder may use more than requested if using B-frames and/or interlaced
                      encoding.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                      high-quality singlepass, or high-quality multipass video encoding.

                      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                      encoding with the H.265 codec. Required when you set Rate control mode to
                      QVBR. Not valid when you set Rate control mode to a value other than QVBR, or
                      when you don't define Rate control mode.

                        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                        control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                        average bitrate values suited to the complexity of your input video, the
                        service limits the average bitrate of the video part of this output to the
                        value that you choose. That is, the total size of the video element is less
                        than or equal to the value you set multiplied by the number of seconds of
                        encoded output.

                        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                        control mode. That is, when you specify qvbrSettings within h265Settings.
                        Specify the target quality level for this output, from 1 to 10. Use higher
                        numbers for greater quality. Level 10 results in nearly lossless
                        compression. The quality level for most broadcast-quality transcodes is
                        between 6 and 9.

                      - **RateControlMode** *(string) --* Use this setting to specify whether this
                      output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                      variable bitrate (QVBR).

                      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                      Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                      based on content

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default. If this output uses QVBR, choose Transition
                      detection (TRANSITION_DETECTION) for further video quality improvement. For
                      more information about QVBR, see
                      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                      - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                      equal to the number of macroblock rows for progressive pictures, and less than
                      or equal to half the number of macroblock rows for interlaced pictures.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Telecine** *(string) --* This field applies only if the Streams > Advanced
                      > Framerate (framerate) field is set to 29.970. This field works with the
                      Streams > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and
                      the Streams > Advanced > Interlaced Mode field (interlace_mode) to identify
                      the scan type for the output: Progressive, Interlaced, Hard Telecine or Soft
                      Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
                      23.976; the player converts this output to 29.97i.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                      encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                      and P-frames form one layer, reference B-frames can form a second layer and
                      non-reference b-frames can form a third layer. Decoders can optionally decode
                      only the lower temporal layers to generate a lower frame rate output. For
                      example, given a bitstream with temporal IDs and with b-frames = 1 (i.e.
                      IbPbPb display order), a decoder could decode all the frames for full frame
                      rate output or only the I and P frames (lowest temporal layer) for a half
                      frame rate output.

                      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                      vertical subdivision of the encoded pictures.

                      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as
                      4 bytes of an unregistered SEI message.

                      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                      units doesn't matter in your workflow, ignore this setting. Use this setting
                      only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                      container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                      your output compliant with the following specification: ISO IECJTC1 SC29
                      N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service
                      stores parameter set NAL units in the sample headers but not in the samples
                      directly. For MP4 outputs, when you choose HVC1, your output video might not
                      work properly with some downstream systems and video players. The service
                      defaults to marking your output as HEV1. For these outputs, the service writes
                      parameter set NAL units directly into the samples.

                    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value MPEG2.

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                      level for the video output.

                      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                      MPEG-2 profile for the video output.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type. - If the source is interlaced, the output will be interlaced with
                      the same polarity as the source (it will follow the source). The output could
                      therefore be a mix of "top field first" and "bottom field first". - If the
                      source is progressive, the output will be interlaced with "top field first" or
                      "bottom field first" polarity, depending on which of the Follow options you
                      chose.

                      - **IntraDcPrecision** *(string) --* Use Intra DC precision
                      (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                      coefficients. If you choose the value auto, the service will automatically
                      select the precision based on the per-frame compression ratio.

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                      video encoding.

                      - **RateControlMode** *(string) --* Use Rate control mode
                      (Mpeg2RateControlMode) to specifiy whether the bitrate is variable (vbr) or
                      constant (cbr).

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                      values reduce high-frequency content in the encoded image.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                      356M-2001).

                      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                      Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard)
                      to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                      produce 23.976 output and leave converstion to the player.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                    - **ProresSettings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value PRORES.

                      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                      the type of Apple ProRes codec to use for this output.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* When you use the API for transcode
                      jobs that use frame rate conversion, specify the frame rate as a fraction. For
                      example, 24000 / 1001 =
                           23.976 fps. Use FramerateNumerator to specify the
                      numerator of this fraction. In this example, use 24000 for the value of
                      FramerateNumerator.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type. - If the source is interlaced, the output will be interlaced with
                      the same polarity as the source (it will follow the source). The output could
                      therefore be a mix of "top field first" and "bottom field first". - If the
                      source is progressive, the output will be interlaced with "top field first" or
                      "bottom field first" polarity, depending on which of the Follow options you
                      chose.

                      - **ParControl** *(string) --* Use (ProresParControl) to specify how the
                      service determines the pixel aspect ratio. Set to Follow source
                      (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio from the input. To
                      specify a different pixel aspect ratio: Using the console, choose it from the
                      dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide
                      for (ParNumerator) and (ParDenominator).

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                      Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard)
                      to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                      produce 23.976 output and leave converstion to the player.

                  - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to
                  include color metadata in this output. Choose Ignore (IGNORE) to exclude color
                  metadata from this output. If you don't specify a value, the service sets this to
                  Insert by default.

                  - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area
                  that the service will include in the output video frame.

                    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                    numbers.

                    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                    numbers.

                    - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                    left edge of the video frame. Specify only even numbers.

                    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                    top edge of the video frame. Specify only even numbers.

                  - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                  feature is enabled, the service will use drop-frame timecode on outputs. If it is
                  not possible to use drop-frame timecode, the system will fall back to
                  non-drop-frame. This setting is enabled by default when Timecode insertion
                  (TimecodeInsertion) is enabled.

                  - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling)
                  to Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                  service will write on all frames of this video output.

                  - **Height** *(integer) --* Use the Height (Height) setting to define the video
                  resolution height for this output. Specify in pixels. If you don't provide a value
                  here, the service will use the input height.

                  - **Position** *(dict) --* Use Selection placement (position) to define the video
                  area in your output frame. The area outside of the rectangle that you specify here
                  is black.

                    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                    numbers.

                    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                    numbers.

                    - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                    left edge of the video frame. Specify only even numbers.

                    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                    top edge of the video frame. Specify only even numbers.

                  - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                  the service changes the video itself in response to AFD values in the input. *
                  Choose Respond to clip the input video frame according to the AFD value, input
                  display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                  include the input AFD values. Do not choose this when AfdSignaling is set to
                  (NONE). A preferred implementation of this workflow is to set RespondToAfd to
                  (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
                  values from this output.

                  - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                  have a different aspect ratio from the input aspect ratio. Choose Stretch to
                  output (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit.
                  Keep the setting Default (DEFAULT) to have the service letterbox your video
                  instead. This setting overrides any value that you specify for the setting
                  Selection placement (position) in this output.

                  - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                  strength of anti-aliasing. This setting changes the width of the anti-alias filter
                  kernel used for scaling. Sharpness only applies if your output resolution is
                  different from your input resolution. 0 is the softest setting, 100 the sharpest,
                  and 50 recommended for most content.

                  - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                  ProRes outputs. Only enable Timecode insertion when the input frame rate is
                  identical to the output frame rate. To include timecodes in this output, set
                  Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                  set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                  output, by default, it uses any embedded timecodes from the input. If none are
                  present, the service will set the timecode for the first output frame to zero. To
                  change this default behavior, adjust the settings under Timecode configuration
                  (TimecodeConfig). In the console, these settings are located under Job > Job
                  settings > Timecode configuration. Note - Timecode source under input settings
                  (InputTimecodeSource) does not affect the timecodes that are inserted in the
                  output. Source under Job settings > Timecode configuration (TimecodeSource) does.

                  - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                  Preprocessors (VideoPreprocessors). Enable the features at each output
                  individually. These features are disabled by default.

                    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                    feature if necessary. Enable or disable this feature for each output
                    individually. This setting is disabled by default.

                      - **Brightness** *(integer) --* Brightness level.

                      - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                      this output. The service supports conversion between HDR formats, between SDR
                      formats, and from SDR to HDR. The service doesn't support conversion from HDR
                      to SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                      video has an HDR format, but visually appears the same as an unconverted
                      output.

                      - **Contrast** *(integer) --* Contrast level.

                      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                      10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume
                      static metadata that you want signaled in the output. These values don't
                      affect the pixel values that are encoded in the video stream. They are
                      intended to help the downstream video player display content in a way that
                      reflects the intentions of the the content creator. When you set Color space
                      conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are
                      required. You must set values for Max frame average light level
                      (maxFrameAverageLightLevel) and Max content light level
                      (maxContentLightLevel); these settings don't have a default value. The default
                      values for the other HDR 10 metadata settings are defined by the P3D65 color
                      space. For more information about MediaConvert HDR jobs, see
                      https://docs.aws.amazon.com/console/mediaconvert/hdr.

                        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                        samples in the coded video sequence, in units of candelas per square meter.
                        This setting doesn't have a default value; you must specify a value that is
                        suitable for the content.

                        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level
                        of any frame in the coded video sequence, in units of candelas per square
                        meter. This setting doesn't have a default value; you must specify a value
                        that is suitable for the content.

                        - **MaxLuminance** *(integer) --* Nominal maximum mastering display
                        luminance in units of of 0.0001 candelas per square meter.

                        - **MinLuminance** *(integer) --* Nominal minimum mastering display
                        luminance in units of of 0.0001 candelas per square meter

                        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **WhitePointX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **WhitePointY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                      - **Hue** *(integer) --* Hue in degrees.

                      - **Saturation** *(integer) --* Saturation level.

                    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce
                    smoother motion and a clearer picture.

                      - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                      (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                      adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                      (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER)
                      if your source file includes a ticker, such as a scrolling headline at the
                      bottom of the frame.

                      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                      does not convert frames that are tagged in metadata as progressive. It will
                      only convert those that are tagged as some other type. - When set to
                      FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                      those that are already tagged as progressive. Turn Force mode on only if there
                      is a good chance that the metadata has tagged frames as progressive when they
                      are not progressive. Do not turn on otherwise; processing frames that are
                      already progressive into progressive will probably result in lower quality
                      video.

                      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                      service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                      interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                      progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby
                    Vision compatible video output.

                      - **L6Metadata** *(dict) --* Use these settings when you set
                      DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                      your input with new values.

                        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                        that corresponds to the brightest pixel in the entire stream. Measured in
                        nits.

                        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                        metadata that corresponds to the highest frame-average brightness in the
                        entire stream. Measured in nits.

                      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service
                      will handle Dolby Vision MaxCLL and MaxFALL properies.

                      - **Profile** *(string) --* In the current MediaConvert implementation, the
                      Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs
                      must contain Dolby Vision frame interleaved data.

                    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter)
                    feature to include a graphic overlay on your video. Enable or disable this
                    feature for each output individually. This setting is disabled by default.

                      - **InsertableImages** *(list) --* Specify the images that you want to overlay
                      on your video. The images must be PNG or TGA files.

                        - *(dict) --* Settings that specify how your still graphic overlay appears.

                          - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                          image to remain on the output video. This duration includes fade-in time
                          but not fade-out time.

                          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                          between the Start time that you specify for the image insertion and the
                          time that the image appears at full opacity. Full opacity is the level
                          that you specify for the opacity setting. If you don't specify a value for
                          Fade-in, the image will appear abruptly at the overlay start time.

                          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                          between the end of the time that you have specified for the image overlay
                          Duration and when the overlaid image has faded to total transparency. If
                          you don't specify a value for Fade-out, the image will disappear abruptly
                          at the end of the inserted image duration.

                          - **Height** *(integer) --* Specify the height of the inserted image in
                          pixels. If you specify a value that's larger than the video resolution
                          height, the service will crop your overlaid image to fit. To use the
                          native height of the image, keep this setting blank.

                          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon
                          S3 location of the image that you want to overlay on the video. Use a PNG
                          or TGA file.

                          - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                          inserted image and the left edge of the video frame. Required for any
                          image overlay that you specify.

                          - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                          overlaid image and the top edge of the video frame. Required for any image
                          overlay that you specify.

                          - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                          Images with higher values for Layer appear on top of images with lower
                          values for Layer.

                          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                          the underlying video shows through the inserted image. 0 is transparent
                          and 100 is fully opaque. Default is 50.

                          - **StartTime** *(string) --* Specify the timecode of the frame that you
                          want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                          or HH:MM:SS;FF) format. Remember to take into account your timecode source
                          settings.

                          - **Width** *(integer) --* Specify the width of the inserted image in
                          pixels. If you specify a value that's larger than the video resolution
                          width, the service will crop your overlaid image to fit. To use the native
                          width of the image, keep this setting blank.

                    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature
                    to remove noise from your video output if necessary. Enable or disable this
                    feature for each output individually. This setting is disabled by default.

                      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                      select one of the following spatial image filtering functions. To use this
                      setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                      preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                      Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                      reduction. * Spatial does frequency-domain filtering based on JND principles.
                      * Temporal optimizes video quality for complex motion.

                      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                        - **Strength** *(integer) --* Relative strength of noise reducing filter.
                        Higher values produce stronger filtering.

                      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                      spatial filter.

                        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post
                        noise reduction sharpening filter, with 0 disabling the filter and 3
                        enabling it at maximum strength.

                        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to
                        3 (higher speed), with 0 being the nominal value.

                        - **Strength** *(integer) --* Relative strength of noise reducing filter.
                        Higher values produce stronger filtering.

                      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                      temporal filter.

                        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                        complex motion. Higher values produce stronger temporal filtering. This
                        filters highly complex scenes more aggressively and creates better VQ for
                        low bitrate outputs.

                        - **Speed** *(integer) --* The speed of the filter (higher number is
                        faster). Low setting reduces bit rate at the cost of transcode time, high
                        setting improves transcode time at the cost of bit rate.

                        - **Strength** *(integer) --* Specify the strength of the noise reducing
                        filter on this output. Higher values produce stronger filtering. We
                        recommend the following value ranges, depending on the result that you want:
                        * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
                        complexity reduction with image preservation * 8-16 for a high level of
                        complexity reduction

                    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                    output timecode and specified prefix into the output.

                      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                      any burned-in timecode. Valid values are 10, 16, 32, 48.

                      - **Position** *(string) --* Use Position (Position) under under Timecode
                      burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                      output video.

                      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters
                      before any burned-in timecode. For example, a prefix of "EZ-" will result in
                      the timecode "EZ-00:00:00:00". Provide either the characters themselves or the
                      ASCII code equivalents. The supported range of characters is 0x20 through
                      0x7e. This includes letters, numbers, and all special characters represented
                      on a standard English keyboard.

                  - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                  in pixels, for this output. If you don't provide a value here, the service will
                  use the input width.

        - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
        information from inputs.

          - **Anchor** *(string) --* If you use an editing platform that relies on an anchor
          timecode, use Anchor Timecode (Anchor) to specify a timecode that will match the input
          video frame to the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF)
          or (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
          Timecode varies depending on your setting for Source (TimecodeSource). * If Source
          (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
          specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
          (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start
          at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
          Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
          input.

          - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
          within this job. To make sure that your video, audio, captions, and markers are
          synchronized and that time-based features, such as image inserter, work correctly, choose
          the Timecode source option that matches your assets. All timecodes are in a 24-hour format
          with frame number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the
          input video. If no embedded timecode is in the source, the service will use Start at 0
          (ZEROBASED) instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to
          00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to
          a value other than zero. You use Start timecode (Start) to provide this value.

          - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
          (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial
          frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

          - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
          stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
          affecting the time and frame number. Provide the new date as a string in the format
          "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
          (InsertProgramDateTime) in the output settings. For example, if the date part of your
          timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
          (TimestampOffset) to 2003-1-25.

        - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
        (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you
        must enable it here, enable it in each output container, and specify tags and timecodes in
        ID3 insertion (Id3Insertion) objects.

          - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion
          instances.

            - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3)
            to specify the base 64 encoded string and use Timecode (TimeCode) to specify the time
            when the tag should be inserted. To insert multiple ID3 tags in your output, create
            multiple instances of ID3 insertion (Id3Insertion).

              - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
              format.

              - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or
              HH:MM:SS;FF format.

      - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
      events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
      MediaConvert sends an update at this interval from the time the service begins processing your
      job to the time it completes the transcode or encounters an error.

      - **Type** *(string) --* A job template can be of two types: system or custom. System or
      built-in job templates can't be modified or deleted by the user.
    """


_ClientCreateJobTemplateSettingsAvailBlankingTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsAvailBlankingTypeDef", {"AvailBlankingImage": str}, total=False
)


class ClientCreateJobTemplateSettingsAvailBlankingTypeDef(
    _ClientCreateJobTemplateSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ClientCreateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ClientCreateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ClientCreateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsEsam` `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ClientCreateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ClientCreateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef(
    _ClientCreateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsEsam` `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientCreateJobTemplateSettingsEsamTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ClientCreateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ClientCreateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsEsamTypeDef(_ClientCreateJobTemplateSettingsEsamTypeDef):
    """
    Type definition for `ClientCreateJobTemplateSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientCreateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ClientCreateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef(
    _ClientCreateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputs` `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsAudioSelectors` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientCreateJobTemplateSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ClientCreateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsAudioSelectorsTypeDef(
    _ClientCreateJobTemplateSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsCaptionSelectors` `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ClientCreateJobTemplateSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ClientCreateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsCaptionSelectorsTypeDef(
    _ClientCreateJobTemplateSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputs` `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ClientCreateJobTemplateSettingsInputsCropTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobTemplateSettingsInputsCropTypeDef(
    _ClientCreateJobTemplateSettingsInputsCropTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef(
    _ClientCreateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsImageInserter` `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobTemplateSettingsInputsImageInserterTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientCreateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsImageInserterTypeDef(
    _ClientCreateJobTemplateSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobTemplateSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ClientCreateJobTemplateSettingsInputsInputClippingsTypeDef(
    _ClientCreateJobTemplateSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ClientCreateJobTemplateSettingsInputsPositionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobTemplateSettingsInputsPositionTypeDef(
    _ClientCreateJobTemplateSettingsInputsPositionTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ClientCreateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputsVideoSelector` `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientCreateJobTemplateSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ClientCreateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsVideoSelectorTypeDef(
    _ClientCreateJobTemplateSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientCreateJobTemplateSettingsInputsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str, ClientCreateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef
        ],
        "AudioSelectors": Dict[str, ClientCreateJobTemplateSettingsInputsAudioSelectorsTypeDef],
        "CaptionSelectors": Dict[str, ClientCreateJobTemplateSettingsInputsCaptionSelectorsTypeDef],
        "Crop": ClientCreateJobTemplateSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DenoiseFilter": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ClientCreateJobTemplateSettingsInputsImageInserterTypeDef,
        "InputClippings": List[ClientCreateJobTemplateSettingsInputsInputClippingsTypeDef],
        "Position": ClientCreateJobTemplateSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ClientCreateJobTemplateSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsInputsTypeDef(_ClientCreateJobTemplateSettingsInputsTypeDef):
    """
    Type definition for `ClientCreateJobTemplateSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientCreateJobTemplateSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ClientCreateJobTemplateSettingsMotionImageInserterFramerateTypeDef(
    _ClientCreateJobTemplateSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsMotionImageInserter` `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ClientCreateJobTemplateSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ClientCreateJobTemplateSettingsMotionImageInserterOffsetTypeDef(
    _ClientCreateJobTemplateSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsMotionImageInserter` `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ClientCreateJobTemplateSettingsMotionImageInserterTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ClientCreateJobTemplateSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ClientCreateJobTemplateSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsMotionImageInserterTypeDef(
    _ClientCreateJobTemplateSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ClientCreateJobTemplateSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ClientCreateJobTemplateSettingsNielsenConfigurationTypeDef(
    _ClientCreateJobTemplateSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings` `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings` `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroups` `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputs` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputs` `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings` `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputs` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettings`
    `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputs` `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings` `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings` `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroupsOutputs` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreateJobTemplateSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ClientCreateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ClientCreateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ClientCreateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsOutputsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreateJobTemplateSettingsOutputGroupsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ClientCreateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[ClientCreateJobTemplateSettingsOutputGroupsOutputsTypeDef],
    },
    total=False,
)


class ClientCreateJobTemplateSettingsOutputGroupsTypeDef(
    _ClientCreateJobTemplateSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ClientCreateJobTemplateSettingsTimecodeConfigTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ClientCreateJobTemplateSettingsTimecodeConfigTypeDef(
    _ClientCreateJobTemplateSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ClientCreateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ClientCreateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ClientCreateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettingsTimedMetadataInsertion` `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ClientCreateJobTemplateSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ClientCreateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ClientCreateJobTemplateSettingsTimedMetadataInsertionTypeDef(
    _ClientCreateJobTemplateSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ClientCreateJobTemplateSettings` `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ClientCreateJobTemplateSettingsTypeDef = TypedDict(
    "_ClientCreateJobTemplateSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ClientCreateJobTemplateSettingsAvailBlankingTypeDef,
        "Esam": ClientCreateJobTemplateSettingsEsamTypeDef,
        "Inputs": List[ClientCreateJobTemplateSettingsInputsTypeDef],
        "MotionImageInserter": ClientCreateJobTemplateSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ClientCreateJobTemplateSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ClientCreateJobTemplateSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ClientCreateJobTemplateSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ClientCreateJobTemplateSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ClientCreateJobTemplateSettingsTypeDef(_ClientCreateJobTemplateSettingsTypeDef):
    """
    Type definition for `ClientCreateJobTemplate` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
    job. There can only be one input in a job template. Using the API, you can include multiple
    inputs when referencing a job template.

      - *(dict) --* Specified video input in a template.

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptions` `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsAudioDescriptions` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientCreatePresetResponsePresetSettingsAudioDescriptionsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientCreatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientCreatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientCreatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsAudioDescriptionsTypeDef(
    _ClientCreatePresetResponsePresetSettingsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettings` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsCaptionDescriptionsTypeDef",
    {
        "CustomLanguageCode": str,
        "DestinationSettings": ClientCreatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsCaptionDescriptionsTypeDef(
    _ClientCreatePresetResponsePresetSettingsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettings` `CaptionDescriptions`

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsContainerSettings` `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsContainerSettings` `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsContainerSettings` `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsContainerSettings` `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsContainerSettings` `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsContainerSettings` `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientCreatePresetResponsePresetSettingsContainerSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientCreatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientCreatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientCreatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientCreatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientCreatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientCreatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsContainerSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsContainerSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettings` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescription` `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionCropTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescription` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettingsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientCreatePresetResponsePresetSettingsVideoDescriptionTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientCreatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientCreatePresetResponsePresetSettingsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientCreatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientCreatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsVideoDescriptionTypeDef(
    _ClientCreatePresetResponsePresetSettingsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePresetSettings` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreatePresetResponsePresetSettingsTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetSettingsTypeDef",
    {
        "AudioDescriptions": List[ClientCreatePresetResponsePresetSettingsAudioDescriptionsTypeDef],
        "CaptionDescriptions": List[
            ClientCreatePresetResponsePresetSettingsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientCreatePresetResponsePresetSettingsContainerSettingsTypeDef,
        "VideoDescription": ClientCreatePresetResponsePresetSettingsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientCreatePresetResponsePresetSettingsTypeDef(
    _ClientCreatePresetResponsePresetSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetResponsePreset` `Settings`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
    caption settings in a single output.

      - *(dict) --* Caption Description for preset

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreatePresetResponsePresetTypeDef = TypedDict(
    "_ClientCreatePresetResponsePresetTypeDef",
    {
        "Arn": str,
        "Category": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "Settings": ClientCreatePresetResponsePresetSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientCreatePresetResponsePresetTypeDef(_ClientCreatePresetResponsePresetTypeDef):
    """
    Type definition for `ClientCreatePresetResponse` `Preset`

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **Category** *(string) --* An optional category you create to organize your presets.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for preset creation.

    - **Description** *(string) --* An optional description you create for each preset.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the preset was last
    updated.

    - **Name** *(string) --* A name you create for each preset. Each name must be unique within your
    account.

    - **Settings** *(dict) --* Settings for preset

      - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
      settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
      (AudioDescriptions) can contain multiple groups of encoding settings.

        - *(dict) --* Description of audio output

          - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
          these settings unless you need to comply with a loudness standard.

            - **Algorithm** *(string) --* Choose one of the following audio normalization
            algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness
            for an entire piece of content, suitable for measurement of short-form content under
            ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated
            loudness. A measurement of gated average loudness compliant with the requirements of
            EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified peak. The same
            loudness measurement algorithm as 1770-2, with an updated true peak measurement. ITU-R
            BS.1770-4: Higher channel count. Allows for more audio channels than the other
            algorithms, including configurations such as 7.1.

            - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
            the chosen algorithm. If disabled, the audio will be measured but not adjusted.

            - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
            corrected to the target level. Content measuring below this level will not be corrected.
            Gating only applies when not using real_time_correction.

            - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
            loudness to a CSV file.

            - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
            for each output's audio track loudness.

            - **TargetLkfs** *(float) --* When you use Audio normalization
            (AudioNormalizationSettings), optionally use this setting to specify a target loudness.
            If you don't specify a value here, the encoder chooses a value for you, based on the
            algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
            encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

          - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
          the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
          order within each input. For example if you specify "Audio Selector 3", then the third
          audio selector will be used from each input. If an input does not have an "Audio Selector
          3", then the audio selector marked as "default" in that input will be used. If there is no
          audio selector marked as "default", silence will be inserted for the duration of that
          input. Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be
          specified, with similar default/silence behavior. If no audio_source_name is specified,
          then "Audio Selector 1" will be chosen automatically.

          - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
          (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
          Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
               Visually Impaired Commentary,
          4-255 = Reserved.

          - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
          ISO 639 audio_type, then that value is passed through to the output. If the input contains
          no ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the
          value in Audio Type is included in the output. Note that this field and audioType are both
          ignored if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

          - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
          (AudioDescriptions) contains the group of settings related to audio encoding. The settings
          in this group vary depending on the value that you choose for Audio codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
          WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
          Eac3AtmosSettings

            - **AacSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
            mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
            set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode,
            you control the audio quality with the setting VBR quality (vbrQuality). In CBR mode,
            you use the setting Bitrate (bitrate). Defaults and valid values depend on the rate
            control mode.

              - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
              the input contains pre-mixed main audio + audio description (AD) as a stereo pair. The
              value for AudioType will be set to 3, which signals to downstream systems that this
              stream contains "broadcaster mixed AD". Note that the input received by the encoder
              must contain pre-mixed audio; the encoder does not perform the mixing. When you choose
              BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
              FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
              audio description (AD). In this case, the encoder will use any values you provide for
              AudioType and FollowInputAudioType.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
              of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
              24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000,
              192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000,
              768000, 896000, 1024000. The value you set is also constrained by the values that you
              choose for Profile (codecProfile), Bitrate control mode (codingMode), and Sample rate
              (sampleRate). Default values depend on Bitrate control mode and Profile.

              - **CodecProfile** *(string) --* AAC Profile.

              - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
              layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
              (Receiver Mix)" setting receives a stereo description plus control track and emits a
              mono AAC encode of the description track, with control data emitted in the PES header
              as per ETSI TS 101 154 Annex E.

              - **RateControlMode** *(string) --* Rate Control Mode.

              - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
              LATM/LOAS AAC in an output, you must choose "No container" for the output container.

              - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
              mode and profile.

              - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
              or MPEG-2 Transport Stream containers.

              - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
              VBR.

            - **Ac3Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AC3.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              bitrates depend on the coding mode.

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
              the encoder emits. For more information about the AC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
              channels.

              - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
              audio is Dolby Digital, dialnorm will be passed through.

              - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
              dynamic range compression signaling to the output bitstream as defined in the Dolby
              Digital specification.

              - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior
              to encoding. Only valid with 3_2_LFE coding mode.

              - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
              sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio
              was not supplied from one of these streams, then the static metadata settings will be
              used.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

            - **AiffSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AIFF.

              - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
              choose the encoding quality for this audio track.

              - **Channels** *(integer) --* Specify the number of channels in this output audio
              track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
              on, up to 64.

              - **SampleRate** *(integer) --* Sample rate in hz.

            - **Codec** *(string) --* Type of Audio codec.

            - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              values: 384k, 448k, 640k, 768k

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
              that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
              always 9.1.6 (CODING_MODE_9_1_6).

              - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
              loudness based on dialogue analysis.

              - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
              signal with dynamic range compression.

              - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
              dynamic range when compressing the audio.

              - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
              for downmixing. How the service uses this value depends on the value that you choose
              for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
              -4.5, and -6.0.

              - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
              downmixing. How the service uses this value depends on the value that you choose for
              Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
              -60. The value -60 mutes the channel.

              - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, and -6.0.

              - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
              -6.0, and -60. The value -60 mutes the channel.

              - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
              audio.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

              - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
              be speech before the encoder uses the measured speech loudness as the overall program
              loudness.

              - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

              - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
              center rear surround channel matrix encoded into your left and right surround
              channels.

            - **Eac3Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value EAC3.

              - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
              attenuation to the surround channels. Only used for 3/2 coding mode.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              bitrates depend on the coding mode.

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
              that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
              channels.

              - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

              - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
              audio is Dolby Digital Plus, dialnorm will be passed through.

              - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
              signal with dynamic range compression.

              - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
              dynamic range when compressing the audio.

              - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
              channel is enabled

              - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior
              to encoding. Only valid with 3_2_LFE coding mode.

              - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
              Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only
              if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left only/Right only center (loRoCenterMixLevel).

              - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
              Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
              and -60. The value -60 mutes the channel. This setting applies only if you keep the
              default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
              (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
              Left only/Right only surround (loRoSurroundMixLevel).

              - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
              Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only
              if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left total/Right total center (ltRtCenterMixLevel).

              - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
              Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
              MediaConvert uses this value for downmixing. How the service uses this value depends
              on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
              -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
              only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

              - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
              sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio
              was not supplied from one of these streams, then the static metadata settings will be
              used.

              - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
              be passed through if it is present on the input. this detection is dynamic over the
              life of the transcode. Inputs that alternate between DD+ and non-DD+ content will have
              a consistent DD+ output as the system alternates between passthrough and encoding.

              - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
              surround channels. Only used for 3/2 coding mode.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

              - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
              setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
              (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
              different value for Coding mode, the service ignores Stereo downmix
              (Eac3StereoDownmix).

              - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
              center back surround channel is matrix encoded into the left and right surround
              channels.

              - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround
              is matrix encoded into the two channels.

            - **Mp2Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value MP2.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

              - **Channels** *(integer) --* Set Channels to specify the number of channels in this
              output audio track. Choosing Mono in the console will give you 1 output channel;
              choosing Stereo will give you 2. In the API, valid values are 1 and 2.

              - **SampleRate** *(integer) --* Sample rate in hz.

            - **WavSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value WAV.

              - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
              choose the encoding quality for this audio track.

              - **Channels** *(integer) --* Specify the number of channels in this output audio
              track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
              on, up to 64.

              - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
              output audio is likely to exceed 4 GB in file size, or if you otherwise need the
              extended support of the RF64 format, set your output WAV file format to RF64.

              - **SampleRate** *(integer) --* Sample rate in Hz.

          - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
          The service puts this language code into your output audio track when you set Language
          code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
          also uses your specified custom language code when you set Language code control
          (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
          specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
          streaming outputs, you can also use any other code in the full RFC-5646 specification.
          Streaming outputs are those that are in one of the following output groups: CMAF, DASH
          ISO, Apple HLS, or Microsoft Smooth Streaming.

          - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
          639 language specified in the 'Language Code' drop down will be used when 'Follow Input
          Language Code' is not selected or when 'Follow Input Language Code' is selected but there
          is no ISO 639 language code specified by the input.

          - **LanguageCodeControl** *(string) --* Specify which source for language code takes
          precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
          uses the language code from the input track if it's present. If there's no languge code on
          the input track, the service uses the code that you specify in the setting Language code
          (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
          service uses the language code that you specify.

          - **RemixSettings** *(dict) --* Advanced audio remixing settings.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
          "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
          this information into destination manifests for display on the end-viewer's player device.
          For outputs in other output groups, the service ignores this setting.

      - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
      caption settings in a single output.

        - *(dict) --* Caption Description for preset

          - **CustomLanguageCode** *(string) --* Specify the language for this captions output
          track. For most captions output formats, the encoder puts this language information in the
          output captions metadata. If your output captions format is DVB-Sub or Burn in, the
          encoder uses this language information when automatically selecting the font script for
          rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
          For streaming outputs, you can also use any other code in the full RFC-5646 specification.
          Streaming outputs are those that are in one of the following output groups: CMAF, DASH
          ISO, Apple HLS, or Microsoft Smooth Streaming.

          - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
          that burnin_destination_settings are not available if the source of the caption data is
          Embedded or Teletext.

            - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

              - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
              setting alignment to centered will place the captions at the bottom center of the
              output. Similarly, setting a left alignment will align captions to the bottom left of
              the output. If x and y positions are given in conjunction with the alignment
              parameter, the font will be justified (either left or centered) relative to those
              coordinates. This option is not valid for source captions that are STL, 608/embedded
              or teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
              captions. All burn-in and DVB-Sub font settings must match.

              - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
              rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
              to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

              - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
              option is not valid for source captions that are STL, 608/embedded or teletext. These
              source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
              font settings must match.

              - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255
              is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

              - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
              96 dpi. All burn-in and DVB-Sub font settings must match.

              - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
              code, if the LanguageCode is not sufficient for determining the script type. Where
              LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
              is used to help determine the appropriate font for rendering burn-in captions.

              - **FontSize** *(integer) --* A positive integer indicates the exact font size in
              points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineColor** *(string) --* Specifies font outline color. This option is not
              valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
              not valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
              captions. All burn-in and DVB-Sub font settings must match.

              - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque;
              0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
              (transparent). All burn-in and DVB-Sub font settings must match.

              - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels to the left. All burn-in and DVB-Sub font settings must match.

              - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels above the text. All burn-in and DVB-Sub font settings must match.

              - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
              Teletext or STL formats. Specify whether the spacing between letters in your captions
              is set by the captions grid or varies depending on letter width. Choose fixed grid to
              conform to the spacing specified in the captions file more accurately. Choose
              proportional to make the text easier to read if the captions are closed caption.

              - **XPosition** *(integer) --* Specifies the horizontal position of the caption
              relative to the left side of the output in pixels. A value of 10 would result in the
              captions starting 10 pixels from the left of the output. If no explicit x_position is
              provided, the horizontal caption position will be determined by the alignment
              parameter. This option is not valid for source captions that are STL, 608/embedded or
              teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
              to the top of the output in pixels. A value of 10 would result in the captions
              starting 10 pixels from the top of the output. If no explicit y_position is provided,
              the caption will be positioned towards the bottom of the output. This option is not
              valid for source captions that are STL, 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

            - **DestinationType** *(string) --* Specify the format for this set of captions on this
            output. The default format is embedded without SCTE-20. Other options are embedded with
            SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
            SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
            complies with the SCTE-43 spec. To create a non-compliant output where the embedded
            captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

            - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

              - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
              setting alignment to centered will place the captions at the bottom center of the
              output. Similarly, setting a left alignment will align captions to the bottom left of
              the output. If x and y positions are given in conjunction with the alignment
              parameter, the font will be justified (either left or centered) relative to those
              coordinates. This option is not valid for source captions that are STL, 608/embedded
              or teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
              captions. All burn-in and DVB-Sub font settings must match.

              - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
              rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
              to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

              - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
              option is not valid for source captions that are STL, 608/embedded or teletext. These
              source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
              font settings must match.

              - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255
              is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

              - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
              96 dpi. All burn-in and DVB-Sub font settings must match.

              - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
              code, if the LanguageCode is not sufficient for determining the script type. Where
              LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
              is used to help determine the appropriate font for rendering DVB-Sub captions.

              - **FontSize** *(integer) --* A positive integer indicates the exact font size in
              points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineColor** *(string) --* Specifies font outline color. This option is not
              valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
              not valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
              captions. All burn-in and DVB-Sub font settings must match.

              - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque;
              0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
              (transparent). All burn-in and DVB-Sub font settings must match.

              - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels to the left. All burn-in and DVB-Sub font settings must match.

              - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels above the text. All burn-in and DVB-Sub font settings must match.

              - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
              for hearing impaired. Choose hearing impaired if your subtitles include audio
              descriptions and dialogue. Choose standard if your subtitles include only dialogue.

              - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
              Teletext or STL formats. Specify whether the spacing between letters in your captions
              is set by the captions grid or varies depending on letter width. Choose fixed grid to
              conform to the spacing specified in the captions file more accurately. Choose
              proportional to make the text easier to read if the captions are closed caption.

              - **XPosition** *(integer) --* Specifies the horizontal position of the caption
              relative to the left side of the output in pixels. A value of 10 would result in the
              captions starting 10 pixels from the left of the output. If no explicit x_position is
              provided, the horizontal caption position will be determined by the alignment
              parameter. This option is not valid for source captions that are STL, 608/embedded or
              teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
              to the top of the output in pixels. A value of 10 would result in the captions
              starting 10 pixels from the top of the output. If no explicit y_position is provided,
              the caption will be positioned towards the bottom of the output. This option is not
              valid for source captions that are STL, 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

            - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
            caption outputs, including 608/708 Channel destination number.

              - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
              captions are SCC format and your output captions are embedded in the video stream.
              Specify a CC number for each captions channel in this output. If you have two
              channels, choose CC numbers that aren't in the same field. For example, choose 1 and
              3. For more information, see
              https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
              captions are SCC format and you want both 608 and 708 captions embedded in your output
              stream. Optionally, specify the 708 service number for each output captions channel.
              Choose a different number for each channel. To use this setting, also set Force 608 to
              708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions
              selector settings. If you choose to upconvert but don't specify a 708 service number,
              MediaConvert uses the number that you specify for CC channel number
              (destination608ChannelNumber) for the 708 service number. For more information, see
              https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

              - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
              use the font style and position information from the captions source in the output.
              This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or
              TTML. Disable this setting for simplified output captions.

            - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

              - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
              that the captions and the video are synchronized in the output. Specify a frame rate
              that matches the frame rate of the associated video. If the video frame rate is 29.97,
              choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
              video_insertion=true and drop_frame_timecode=true; otherwise, choose 29.97
              non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

            - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

              - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
              destination captions for this output. This value must be a three-digit hexadecimal
              string; strings ending in -FF are invalid. If you are passing through the entire set
              of Teletext data, do not use this field.

              - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
              don't specify a value here, the service sets the page type to the default value
              Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
              don't use this field. When you pass through a set of Teletext pages, your output has
              the same page types as your input.

                - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

            - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
            including Pass style information (TtmlStylePassthrough).

              - **StylePassthrough** *(string) --* Pass through style and position information from
              a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

          - **LanguageCode** *(string) --* Specify the language of this captions output track. For
          most captions output formats, the encoder puts this language information in the output
          captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
          this language information to choose the font language for rendering the captions text.

          - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
          For example, "English", "Director commentary", or "track_2". For streaming outputs,
          MediaConvert passes this information into destination manifests for display on the
          end-viewer's player device. For outputs in other output groups, the service ignores this
          setting.

      - **ContainerSettings** *(dict) --* Container specific settings.

        - **Container** *(string) --* Container for this output. Some containers require a container
        settings object. If not specified, the default object will be created.

        - **F4vSettings** *(dict) --* Settings for F4v container

          - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
          relocated to the beginning of the archive as required for progressive downloading.
          Otherwise it is placed normally at the end.

        - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
        File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
        (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
        stream program contains subsets of data, including audio, video, and metadata. Each of these
        subsets of data has a numerical label called a packet identifier (PID). Each transport
        stream program corresponds to one MediaConvert output. The PMT lists the types of data in a
        program along with their PID. Downstream systems and players use the program map table to
        look up the PID for each type of data it accesses and then uses the PIDs to locate specific
        data within the asset.

          - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
          Dolby Digital audio.

          - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
          packet.

          - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
          streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
          range 482-492.

            - *(integer) --*

          - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
          per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
          Other common values are 3750000, 7500000, and 15000000.

          - **BufferModel** *(string) --* Controls what buffer model to use for accurate
          interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
          lead to lower latency, but low-memory devices may not be able to play back the stream
          without interruptions.

          - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
          specified table repetition interval.

            - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
            (NIT).

            - **NetworkName** *(string) --* The network name text placed in the
            network_name_descriptor inside the Network Information Table. Maximum length is 256
            characters.

            - **NitInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

          - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
          specified table repetition interval.

            - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
            stream. "Follow input SDT" copies SDT information from input stream to output stream.
            "Follow input SDT if present" copies SDT information from input stream to output stream
            if SDT information is present in the input, otherwise it will fall back on the
            user-defined values. Enter "SDT Manually" means user will enter the SDT information. "No
            SDT" means output stream will not contain SDT information.

            - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
            Service Description Table. Maximum length is 256 characters.

            - **ServiceProviderName** *(string) --* The service provider name placed in the
            service_descriptor in the Service Description Table. Maximum length is 256 characters.

          - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
          included in this output. Specify multiple PIDs as a JSON array. Default is the range
          460-479.

            - *(integer) --*

          - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
          table repetition interval.

            - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

          - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
          data you include in this output. Default is 499.

          - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
          markers will be added to partitions 3 and 4. The interval between these additional markers
          will be fixed, and will be slightly shorter than the video EBP marker interval. When set
          to VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
          segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

          - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
          either be placed only on the video PID, or on both the video PID and all audio PIDs. Only
          applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
          EBP_LEGACY).

          - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
          header.

          - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
          that your audio EBP markers are incorrectly appearing before your video EBP markers. To
          correct this problem, set this value to Force (FORCE).

          - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
          EBP markers.

          - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
          Program Clock References (PCRs) inserted into the transport stream.

          - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
          come within the specified time interval of each other by looking ahead at input video. If
          another EBP is going to come in within the specified time interval, the current EBP is not
          emitted, and the segment is "stretched" to the next marker. The lookahead value does not
          add latency to the system. The Live Event must be configured elsewhere to create
          sufficient latency to make the lookahead accurate.

          - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will
          be detected in the input audio and an equivalent ID3 tag will be inserted in the output.

          - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
          insert into the transport stream. This can be used if a downstream encryption system
          requires periodic null packets.

          - **PatInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
          value is inserted for every Packetized Elementary Stream (PES) header. This is effective
          only when the PCR PID is the same as the video or audio elementary stream.

          - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
          reference (PCR) in this output. If you do not specify a value, the service will use the
          value for Video PID (VideoPid).

          - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
          the program map table (PMT) in the output transport stream.

          - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
          (PMT) itself. Default is 480.

          - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
          metadata stream. Default is 503.

          - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
          program number used in the program map table (PMT) for this output. Default is 1. Program
          numbers and program map tables are parts of MPEG-2 transport stream containers, used for
          organizing data.

          - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
          to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
          bitrate, but the output will not be padded up to that bitrate.

          - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
          your HLS and transport stream outputs at the insertion points that you specify in an ESAM
          XML document. Provide the document in the setting SCC XML (sccXml).

            - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream generated by ESAM.

          - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
          in the transport stream.

          - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
          (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
          output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
          markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
          string in the setting Signal processing notification XML (sccXml). Also enable ESAM
          SCTE-35 (include the property scte35Esam).

          - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
          segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
          adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
          data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
          Encoder Boundary Point information to the adaptation field as per OpenCable specification
          OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
          field using a legacy proprietary format.

          - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
          segmentation markers are inserted into the transport stream. With avails, it is possible
          that segments may be truncated, which can influence where future segmentation markers are
          inserted. When a segmentation style of "reset_cadence" is selected and a segment is
          truncated due to an avail, we will reset the segmentation cadence. This means the
          subsequent segment will have a duration of of $segmentation_time seconds. When a
          segmentation style of "maintain_cadence" is selected and a segment is truncated due to an
          avail, we will not reset the segmentation cadence. This means the subsequent segment will
          likely be truncated as well. However, all segments after that will have a duration of
          $segmentation_time seconds. Note that EBP lookahead is a slight exception to this rule.

          - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
          Required unless markers is set to _none_.

          - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
          metadata in this output. Default is 502.

          - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
          the program map table for this output. Transport stream IDs and program map tables are
          parts of MPEG-2 transport stream containers, used for organizing data.

          - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
          stream in the transport stream.

        - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

          - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
          packet.

          - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
          the transport stream. Multiple values are accepted, and can be entered in ranges and/or by
          comma separation.

            - *(integer) --*

          - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will
          be detected in the input audio and an equivalent ID3 tag will be inserted in the output.

          - **PatInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
          value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
          effective only when the PCR PID is the same as the video or audio elementary stream.

          - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
          in the transport stream. When no value is given, the encoder will assign the same value as
          the Video PID.

          - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
          transport stream.

          - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
          stream in the transport stream.

          - **ProgramNumber** *(integer) --* The value of the program number field in the Program
          Map Table.

          - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream.

          - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
          (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
          output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
          markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
          conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
          want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
          setting Signal processing notification XML (sccXml).

          - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
          whether the service inserts the ID3 timed metadata from the input in this output.

          - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
          in the transport stream.

          - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
          Program Map Table.

          - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
          the transport stream.

        - **MovSettings** *(dict) --* Settings for MOV Container.

          - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
          video output settings.

          - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
          composition times in the 'ctts' (composition time to sample) box for B-frames will be
          negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
          amendment 1. This improves compatibility with Apple players and tools.

          - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
          the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple
          editors and players, but may decrease compatibility with other players. Only applicable
          when the video codec is MPEG2.

          - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

          - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
          setting.

        - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
        outputs with this container.

          - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
          composition times in the 'ctts' (composition time to sample) box for B-frames will be
          negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
          amendment 1. This improves compatibility with Apple players and tools.

          - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

          - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
          relocated to the beginning of the archive as required for progressive downloading.
          Otherwise it is placed normally at the end.

          - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
          Usually not necessary to specify.

        - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

          - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
          include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
          from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
          container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
          within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
          and audio fragmented MP4 files.

          - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
          ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
          specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
          your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
          appear in your input to also appear in this output. Choose None (NONE) if you don't want
          those SCTE-35 markers in this output.

      - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
      settings. The specific video settings depend on the video codec that you choose when you
      specify a value for Video codec (codec). Include one instance of (VideoDescription) per
      output.

        - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
        outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD
        values in the output video data and what those values are. * Choose None to remove all AFD
        values from this output. * Choose Fixed to ignore input AFD values and instead encode the
        value specified in the job. * Choose Auto to calculate output AFD values based on the input
        AFD scaler data.

        - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
        The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
        job, the service will ignore the setting.

        - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
        (VideoDescription), contains the group of settings related to video encoding. The settings
        in this group vary depending on the value that you choose for Video codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
        Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

          - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
          values defined by the object VideoCodec.

          - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

            - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
            the output stream, then one frame every framerateDenominator/framerateNumerator seconds.
            For example, settings of framerateNumerator = 1 and framerateDenominator =
                 3 (a rate of
            1/3 frame per second) will capture the first frame, then 1 frame every 3s. Files will be
            named as filename.n.jpg where n is the 0-based sequence number of each Capture.

            - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
            output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
            example, settings of framerateNumerator = 1 and framerateDenominator =
                 3 (a rate of 1/3
            frame per second) will capture the first frame, then 1 frame every 3s. Files will be
            named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
            to 7 decimal places.

            - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

            - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

          - **H264Settings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value H_264.

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
            output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

            - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
            available with the AVC-I License.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
            High profile) or CAVLC.

            - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
            interlaced outputs.

            - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
            reduce flicker or 'pop' on I-frames.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job specification as
            a JSON file without the console, use FramerateControl to specify which value the service
            uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
            service to use the frame rate from the input. Choose SPECIFIED if you want the service
            to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
            use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
            1001 =
                 23.976 fps. Use FramerateDenominator to specify the denominator of this fraction.
            In this example, use 1001 for the value of FramerateDenominator. When you use the
            console for transcode jobs that use frame rate conversion, provide the value as a
            decimal number for Framerate. In this example, specify 23.976.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
            that have B frames > 1.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type, as follows. - If the source is
            interlaced, the output will be interlaced with the same polarity as the source (it will
            follow the source). The output could therefore be a mix of "top field first" and "bottom
            field first". - If the source is progressive, the output will be interlaced with "top
            field first" or "bottom field first" polarity, depending on which of the Follow options
            you chose.

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000. Required when Rate control mode is QVBR.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
            encoder may use more than requested if using B-frames and/or interlaced encoding.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
            to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
            multipass video encoding.

            - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
            with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
            you set Rate control mode to a value other than QVBR, or when you don't define Rate
            control mode.

              - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
              QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited
              to the complexity of your input video, the service limits the average bitrate of the
              video part of this output to the value that you choose. That is, the total size of the
              video element is less than or equal to the value you set multiplied by the number of
              seconds of encoded output.

              - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
              That is, when you specify qvbrSettings within h264Settings. Specify the target quality
              level for this output, from 1 to 10. Use higher numbers for greater quality. Level 10
              results in nearly lossless compression. The quality level for most broadcast-quality
              transcodes is between 6 and 9.

            - **RateControlMode** *(string) --* Use this setting to specify whether this output has
            a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate
            (QVBR).

            - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
            repeated.

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default. If this output uses QVBR, choose Transition detection
            (TRANSITION_DETECTION) for further video quality improvement. For more information about
            QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

            - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
            the number of macroblock rows for progressive pictures, and less than or equal to half
            the number of macroblock rows for interlaced pictures.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
            high-frequency content in the encoded image.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

            - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
            Framerate (framerate) field is set to 29.970. This field works with the Streams >
            Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
            Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
            output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i
            output from 23.976 input. - Soft: produces 23.976; the player converts this output to
            29.97i.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

            - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
            of an unregistered SEI message.

          - **H265Settings** *(dict) --* Settings for H265 codec

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
            message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
            (EOTF).

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* H.265 Level.

            - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
            specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
            Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
            License.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
            reduce flicker or 'pop' on I-frames.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
            that have B frames > 1.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
            Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
            your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
            create an output that's interlaced with the same field polarity throughout. Choose
            Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
            to create an interlaced output with the same field polarity as the source. If the source
            is interlaced, the output will be interlaced with the same polarity as the source (it
            will follow the source). The output could therefore be a mix of "top field first" and
            "bottom field first". If the source is progressive, your output will be interlaced with
            "top field first" or "bottom field first" polarity, depending on which of the Follow
            options you chose. If you don't choose a value, the service will default to Progressive
            (PROGRESSIVE).

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000. Required when Rate control mode is QVBR.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
            encoder may use more than requested if using B-frames and/or interlaced encoding.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
            to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
            multipass video encoding.

            - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
            with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
            you set Rate control mode to a value other than QVBR, or when you don't define Rate
            control mode.

              - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
              QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited
              to the complexity of your input video, the service limits the average bitrate of the
              video part of this output to the value that you choose. That is, the total size of the
              video element is less than or equal to the value you set multiplied by the number of
              seconds of encoded output.

              - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
              That is, when you specify qvbrSettings within h265Settings. Specify the target quality
              level for this output, from 1 to 10. Use higher numbers for greater quality. Level 10
              results in nearly lossless compression. The quality level for most broadcast-quality
              transcodes is between 6 and 9.

            - **RateControlMode** *(string) --* Use this setting to specify whether this output has
            a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate
            (QVBR).

            - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
            filter strength. Adaptive mode dynamically selects best strength based on content

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default. If this output uses QVBR, choose Transition detection
            (TRANSITION_DETECTION) for further video quality improvement. For more information about
            QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

            - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
            the number of macroblock rows for progressive pictures, and less than or equal to half
            the number of macroblock rows for interlaced pictures.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
            Framerate (framerate) field is set to 29.970. This field works with the Streams >
            Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
            Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
            output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i
            output from 23.976 input. - Soft: produces 23.976; the player converts this output to
            29.97i.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

            - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
            bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
            one layer, reference B-frames can form a second layer and non-reference b-frames can
            form a third layer. Decoders can optionally decode only the lower temporal layers to
            generate a lower frame rate output. For example, given a bitstream with temporal IDs and
            with b-frames =
                 1 (i.e. IbPbPb display order), a decoder could decode all the frames for
            full frame rate output or only the I and P frames (lowest temporal layer) for a half
            frame rate output.

            - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
            subdivision of the encoded pictures.

            - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
            of an unregistered SEI message.

            - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
            doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
            DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
            Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
            following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition.
            For these outputs, the service stores parameter set NAL units in the sample headers but
            not in the samples directly. For MP4 outputs, when you choose HVC1, your output video
            might not work properly with some downstream systems and video players. The service
            defaults to marking your output as HEV1. For these outputs, the service writes parameter
            set NAL units directly into the samples.

          - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value MPEG2.

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
            the video output.

            - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
            profile for the video output.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type. - If the source is interlaced, the
            output will be interlaced with the same polarity as the source (it will follow the
            source). The output could therefore be a mix of "top field first" and "bottom field
            first". - If the source is progressive, the output will be interlaced with "top field
            first" or "bottom field first" polarity, depending on which of the Follow options you
            chose.

            - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
            set quantization precision for intra-block DC coefficients. If you choose the value
            auto, the service will automatically select the precision based on the per-frame
            compression ratio.

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level
            (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
            encoding.

            - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
            specifiy whether the bitrate is variable (vbr) or constant (cbr).

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
            high-frequency content in the encoded image.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

            - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
            (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
            output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
            converstion to the player.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

          - **ProresSettings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value PRORES.

            - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
            of Apple ProRes codec to use for this output.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
            frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
            23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
            example, use 24000 for the value of FramerateNumerator.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type. - If the source is interlaced, the
            output will be interlaced with the same polarity as the source (it will follow the
            source). The output could therefore be a mix of "top field first" and "bottom field
            first". - If the source is progressive, the output will be interlaced with "top field
            first" or "bottom field first" polarity, depending on which of the Follow options you
            chose.

            - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
            determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
            the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
            the console, choose it from the dropdown menu. Using the API, set ProresParControl to
            (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
            (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
            output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
            converstion to the player.

        - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
        metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output.
        If you don't specify a value, the service sets this to Insert by default.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame.

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
        is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
        use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
        enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

        - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
        (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
        on all frames of this video output.

        - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
        height for this output. Specify in pixels. If you don't provide a value here, the service
        will use the input height.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black.

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
        service changes the video itself in response to AFD values in the input. * Choose Respond to
        clip the input video frame according to the AFD value, input display aspect ratio, and
        output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
        choose this when AfdSignaling is set to (NONE). A preferred implementation of this workflow
        is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all
        input AFD values from this output.

        - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
        different aspect ratio from the input aspect ratio. Choose Stretch to output
        (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
        Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
        any value that you specify for the setting Selection placement (position) in this output.

        - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
        anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
        scaling. Sharpness only applies if your output resolution is different from your input
        resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

        - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
        outputs. Only enable Timecode insertion when the input frame rate is identical to the output
        frame rate. To include timecodes in this output, set Timecode insertion
        (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
        is DISABLED. When the service inserts timecodes in an output, by default, it uses any
        embedded timecodes from the input. If none are present, the service will set the timecode
        for the first output frame to zero. To change this default behavior, adjust the settings
        under Timecode configuration (TimecodeConfig). In the console, these settings are located
        under Job > Job settings > Timecode configuration. Note - Timecode source under input
        settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
        output. Source under Job settings > Timecode configuration (TimecodeSource) does.

        - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
        Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
        features are disabled by default.

          - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
          necessary. Enable or disable this feature for each output individually. This setting is
          disabled by default.

            - **Brightness** *(integer) --* Brightness level.

            - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
            output. The service supports conversion between HDR formats, between SDR formats, and
            from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
            conversion doesn't upgrade the dynamic range. The converted video has an HDR format, but
            visually appears the same as an unconverted output.

            - **Contrast** *(integer) --* Contrast level.

            - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
            space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
            want signaled in the output. These values don't affect the pixel values that are encoded
            in the video stream. They are intended to help the downstream video player display
            content in a way that reflects the intentions of the the content creator. When you set
            Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings
            are required. You must set values for Max frame average light level
            (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
            settings don't have a default value. The default values for the other HDR 10 metadata
            settings are defined by the P3D65 color space. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Hue** *(integer) --* Hue in degrees.

            - **Saturation** *(integer) --* Saturation level.

          - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
          and a clearer picture.

            - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
            to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
            (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
            Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
            as a scrolling headline at the bottom of the frame.

            - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
            convert frames that are tagged in metadata as progressive. It will only convert those
            that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
            converts every frame to progressive - even those that are already tagged as progressive.
            Turn Force mode on only if there is a good chance that the metadata has tagged frames as
            progressive when they are not progressive. Do not turn on otherwise; processing frames
            that are already progressive into progressive will probably result in lower quality
            video.

            - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
            will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
            progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
            Adaptive auto-detects and converts to progressive.

          - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
          compatible video output.

            - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
            SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

              - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
              corresponds to the brightest pixel in the entire stream. Measured in nits.

              - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
              that corresponds to the highest frame-average brightness in the entire stream.
              Measured in nits.

            - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
            Dolby Vision MaxCLL and MaxFALL properies.

            - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
            profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
            frame interleaved data.

          - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
          include a graphic overlay on your video. Enable or disable this feature for each output
          individually. This setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
          noise from your video output if necessary. Enable or disable this feature for each output
          individually. This setting is disabled by default.

            - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
            of the following spatial image filtering functions. To use this setting, you must also
            enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. *
            Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. *
            Conserve does min/max noise reduction. * Spatial does frequency-domain filtering based
            on JND principles. * Temporal optimizes video quality for complex motion.

            - **FilterSettings** *(dict) --* Settings for a noise reducer filter

              - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
              values produce stronger filtering.

            - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
            filter.

              - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
              reduction sharpening filter, with 0 disabling the filter and 3 enabling it at maximum
              strength.

              - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
              speed), with 0 being the nominal value.

              - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
              values produce stronger filtering.

            - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
            filter.

              - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
              motion. Higher values produce stronger temporal filtering. This filters highly complex
              scenes more aggressively and creates better VQ for low bitrate outputs.

              - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
              setting reduces bit rate at the cost of transcode time, high setting improves
              transcode time at the cost of bit rate.

              - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
              this output. Higher values produce stronger filtering. We recommend the following
              value ranges, depending on the result that you want: * 0-2 for complexity reduction
              with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
              8-16 for a high level of complexity reduction

          - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
          timecode and specified prefix into the output.

            - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
            burned-in timecode. Valid values are 10, 16, 32, 48.

            - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
            (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

            - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
            burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
            "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
            equivalents. The supported range of characters is 0x20 through 0x7e. This includes
            letters, numbers, and all special characters represented on a standard English keyboard.

        - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
        pixels, for this output. If you don't provide a value here, the service will use the input
        width.

    - **Type** *(string) --* A preset can be of two types: system or custom. System or built-in
    preset can't be modified or deleted by the user.
    """


_ClientCreatePresetResponseTypeDef = TypedDict(
    "_ClientCreatePresetResponseTypeDef",
    {"Preset": ClientCreatePresetResponsePresetTypeDef},
    total=False,
)


class ClientCreatePresetResponseTypeDef(_ClientCreatePresetResponseTypeDef):
    """
    Type definition for `ClientCreatePreset` `Response`

    - **Preset** *(dict) --* A preset is a collection of preconfigured media conversion settings
    that you want MediaConvert to apply to the output during the conversion process.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **Category** *(string) --* An optional category you create to organize your presets.

      - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for preset creation.

      - **Description** *(string) --* An optional description you create for each preset.

      - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the preset was last
      updated.

      - **Name** *(string) --* A name you create for each preset. Each name must be unique within
      your account.

      - **Settings** *(dict) --* Settings for preset

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be
        multiple caption settings in a single output.

          - *(dict) --* Caption Description for preset

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.

      - **Type** *(string) --* A preset can be of two types: system or custom. System or built-in
      preset can't be modified or deleted by the user.
    """


_ClientCreatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptions` `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptionsCodecSettings` `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptionsCodecSettings` `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptionsCodecSettings` `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptionsCodecSettings` `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptionsCodecSettings` `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptionsCodecSettings` `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientCreatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientCreatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientCreatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientCreatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsCodecSettingsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptions` `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptionsRemixSettings` `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientCreatePresetSettingsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientCreatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsRemixSettingsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsAudioDescriptions` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientCreatePresetSettingsAudioDescriptionsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientCreatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientCreatePresetSettingsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientCreatePresetSettingsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientCreatePresetSettingsAudioDescriptionsTypeDef(
    _ClientCreatePresetSettingsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettings` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsCaptionDescriptions` `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientCreatePresetSettingsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsCaptionDescriptionsTypeDef",
    {
        "CustomLanguageCode": str,
        "DestinationSettings": ClientCreatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientCreatePresetSettingsCaptionDescriptionsTypeDef(
    _ClientCreatePresetSettingsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettings` `CaptionDescriptions`

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientCreatePresetSettingsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsF4vSettingsTypeDef(
    _ClientCreatePresetSettingsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsContainerSettings` `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsContainerSettingsM2tsSettings` `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsContainerSettingsM2tsSettings` `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsContainerSettingsM2tsSettings` `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientCreatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientCreatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsContainerSettingsM2tsSettings` `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientCreatePresetSettingsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientCreatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientCreatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsM2tsSettingsTypeDef(
    _ClientCreatePresetSettingsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsContainerSettings` `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientCreatePresetSettingsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsM3u8SettingsTypeDef(
    _ClientCreatePresetSettingsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsContainerSettings` `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientCreatePresetSettingsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsMovSettingsTypeDef(
    _ClientCreatePresetSettingsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsContainerSettings` `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientCreatePresetSettingsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsMp4SettingsTypeDef(
    _ClientCreatePresetSettingsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsContainerSettings` `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientCreatePresetSettingsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsMpdSettingsTypeDef(
    _ClientCreatePresetSettingsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsContainerSettings` `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientCreatePresetSettingsContainerSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientCreatePresetSettingsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientCreatePresetSettingsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientCreatePresetSettingsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientCreatePresetSettingsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientCreatePresetSettingsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientCreatePresetSettingsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientCreatePresetSettingsContainerSettingsTypeDef(
    _ClientCreatePresetSettingsContainerSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettings` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientCreatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionCodecSettings` `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionCodecSettings` `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientCreatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionCodecSettings` `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientCreatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionCodecSettings` `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientCreatePresetSettingsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientCreatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientCreatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientCreatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientCreatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientCreatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionCodecSettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescription` `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientCreatePresetSettingsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionCropTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreatePresetSettingsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionPositionTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescription` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessors` `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientCreatePresetSettingsVideoDescription` `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientCreatePresetSettingsVideoDescriptionTypeDef = TypedDict(
    "_ClientCreatePresetSettingsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientCreatePresetSettingsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientCreatePresetSettingsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientCreatePresetSettingsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientCreatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientCreatePresetSettingsVideoDescriptionTypeDef(
    _ClientCreatePresetSettingsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientCreatePresetSettings` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreatePresetSettingsTypeDef = TypedDict(
    "_ClientCreatePresetSettingsTypeDef",
    {
        "AudioDescriptions": List[ClientCreatePresetSettingsAudioDescriptionsTypeDef],
        "CaptionDescriptions": List[ClientCreatePresetSettingsCaptionDescriptionsTypeDef],
        "ContainerSettings": ClientCreatePresetSettingsContainerSettingsTypeDef,
        "VideoDescription": ClientCreatePresetSettingsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientCreatePresetSettingsTypeDef(_ClientCreatePresetSettingsTypeDef):
    """
    Type definition for `ClientCreatePreset` `Settings`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
    caption settings in a single output.

      - *(dict) --* Caption Description for preset

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientCreateQueueReservationPlanSettingsTypeDef = TypedDict(
    "_ClientCreateQueueReservationPlanSettingsTypeDef",
    {"Commitment": str, "RenewalType": str, "ReservedSlots": int},
)


class ClientCreateQueueReservationPlanSettingsTypeDef(
    _ClientCreateQueueReservationPlanSettingsTypeDef
):
    """
    Type definition for `ClientCreateQueue` `ReservationPlanSettings`

    - **Commitment** *(string) --* **[REQUIRED]** The length of the term of your reserved queue
    pricing plan commitment.

    - **RenewalType** *(string) --* **[REQUIRED]** Specifies whether the term of your reserved queue
    pricing plan is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.
    When your term is auto renewed, you extend your commitment by 12 months from the auto renew
    date. You can cancel this commitment.

    - **ReservedSlots** *(integer) --* **[REQUIRED]** Specifies the number of reserved transcode
    slots (RTS) for this queue. The number of RTS determines how many jobs the queue can process in
    parallel; each RTS can process one job at a time. You can't decrease the number of RTS in your
    reserved queue. You can increase the number of RTS by extending your existing commitment with a
    new 12-month commitment for the larger number. The new commitment begins when you purchase the
    additional capacity. You can't cancel your commitment or revert to your original commitment
    after you increase the capacity.
    """


_ClientCreateQueueResponseQueueReservationPlanTypeDef = TypedDict(
    "_ClientCreateQueueResponseQueueReservationPlanTypeDef",
    {
        "Commitment": str,
        "ExpiresAt": datetime,
        "PurchasedAt": datetime,
        "RenewalType": str,
        "ReservedSlots": int,
        "Status": str,
    },
    total=False,
)


class ClientCreateQueueResponseQueueReservationPlanTypeDef(
    _ClientCreateQueueResponseQueueReservationPlanTypeDef
):
    """
    Type definition for `ClientCreateQueueResponseQueue` `ReservationPlan`

    - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
    commitment.

    - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing plan
    term for this reserved queue expires.

    - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the current
    pricing plan for this reserved queue.

    - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing plan
    is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

    - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS) for
    this queue. The number of RTS determines how many jobs the queue can process in parallel; each
    RTS can process one job at a time. When you increase this number, you extend your existing
    commitment with a new 12-month commitment for a larger number of RTS. The new commitment begins
    when you purchase the additional capacity. You can't decrease the number of RTS in your reserved
    queue.

    - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is ACTIVE
    or EXPIRED.
    """


_ClientCreateQueueResponseQueueTypeDef = TypedDict(
    "_ClientCreateQueueResponseQueueTypeDef",
    {
        "Arn": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "PricingPlan": str,
        "ProgressingJobsCount": int,
        "ReservationPlan": ClientCreateQueueResponseQueueReservationPlanTypeDef,
        "Status": str,
        "SubmittedJobsCount": int,
        "Type": str,
    },
    total=False,
)


class ClientCreateQueueResponseQueueTypeDef(_ClientCreateQueueResponseQueueTypeDef):
    """
    Type definition for `ClientCreateQueueResponse` `Queue`

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for when you created the queue.

    - **Description** *(string) --* An optional description that you create for each queue.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds for when you most recently
    updated the queue.

    - **Name** *(string) --* A name that you create for each queue. Each name must be unique within
    your account.

    - **PricingPlan** *(string) --* Specifies whether the pricing plan for the queue is on-demand or
    reserved. For on-demand, you pay per minute, billed in increments of .01 minute. For reserved,
    you pay for the transcoding capacity of the entire queue, regardless of how much or how little
    you use it. Reserved pricing requires a 12-month commitment.

    - **ProgressingJobsCount** *(integer) --* The estimated number of jobs with a PROGRESSING
    status.

    - **ReservationPlan** *(dict) --* Details about the pricing plan for your reserved queue.
    Required for reserved queues and not applicable to on-demand queues.

      - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
      commitment.

      - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing
      plan term for this reserved queue expires.

      - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the
      current pricing plan for this reserved queue.

      - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing plan
      is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

      - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS) for
      this queue. The number of RTS determines how many jobs the queue can process in parallel; each
      RTS can process one job at a time. When you increase this number, you extend your existing
      commitment with a new 12-month commitment for a larger number of RTS. The new commitment
      begins when you purchase the additional capacity. You can't decrease the number of RTS in your
      reserved queue.

      - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is
      ACTIVE or EXPIRED.

    - **Status** *(string) --* Queues can be ACTIVE or PAUSED. If you pause a queue, the service
    won't begin processing jobs in that queue. Jobs that are running when you pause the queue
    continue to run until they finish or result in an error.

    - **SubmittedJobsCount** *(integer) --* The estimated number of jobs with a SUBMITTED status.

    - **Type** *(string) --* Specifies whether this on-demand queue is system or custom. System
    queues are built in. You can't modify or delete system queues. You can create and modify custom
    queues.
    """


_ClientCreateQueueResponseTypeDef = TypedDict(
    "_ClientCreateQueueResponseTypeDef",
    {"Queue": ClientCreateQueueResponseQueueTypeDef},
    total=False,
)


class ClientCreateQueueResponseTypeDef(_ClientCreateQueueResponseTypeDef):
    """
    Type definition for `ClientCreateQueue` `Response`

    - **Queue** *(dict) --* You can use queues to manage the resources that are available to your
    AWS account for running multiple transcoding jobs at the same time. If you don't specify a
    queue, the service sends all jobs through the default queue. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/working-with-queues.html.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for when you created the queue.

      - **Description** *(string) --* An optional description that you create for each queue.

      - **LastUpdated** *(datetime) --* The timestamp in epoch seconds for when you most recently
      updated the queue.

      - **Name** *(string) --* A name that you create for each queue. Each name must be unique
      within your account.

      - **PricingPlan** *(string) --* Specifies whether the pricing plan for the queue is on-demand
      or reserved. For on-demand, you pay per minute, billed in increments of .01 minute. For
      reserved, you pay for the transcoding capacity of the entire queue, regardless of how much or
      how little you use it. Reserved pricing requires a 12-month commitment.

      - **ProgressingJobsCount** *(integer) --* The estimated number of jobs with a PROGRESSING
      status.

      - **ReservationPlan** *(dict) --* Details about the pricing plan for your reserved queue.
      Required for reserved queues and not applicable to on-demand queues.

        - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
        commitment.

        - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing
        plan term for this reserved queue expires.

        - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the
        current pricing plan for this reserved queue.

        - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing
        plan is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

        - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS)
        for this queue. The number of RTS determines how many jobs the queue can process in
        parallel; each RTS can process one job at a time. When you increase this number, you extend
        your existing commitment with a new 12-month commitment for a larger number of RTS. The new
        commitment begins when you purchase the additional capacity. You can't decrease the number
        of RTS in your reserved queue.

        - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is
        ACTIVE or EXPIRED.

      - **Status** *(string) --* Queues can be ACTIVE or PAUSED. If you pause a queue, the service
      won't begin processing jobs in that queue. Jobs that are running when you pause the queue
      continue to run until they finish or result in an error.

      - **SubmittedJobsCount** *(integer) --* The estimated number of jobs with a SUBMITTED status.

      - **Type** *(string) --* Specifies whether this on-demand queue is system or custom. System
      queues are built in. You can't modify or delete system queues. You can create and modify
      custom queues.
    """


_ClientDescribeEndpointsResponseEndpointsTypeDef = TypedDict(
    "_ClientDescribeEndpointsResponseEndpointsTypeDef", {"Url": str}, total=False
)


class ClientDescribeEndpointsResponseEndpointsTypeDef(
    _ClientDescribeEndpointsResponseEndpointsTypeDef
):
    """
    Type definition for `ClientDescribeEndpointsResponse` `Endpoints`

    - **Url** *(string) --* URL of endpoint
    """


_ClientDescribeEndpointsResponseTypeDef = TypedDict(
    "_ClientDescribeEndpointsResponseTypeDef",
    {"Endpoints": List[ClientDescribeEndpointsResponseEndpointsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeEndpointsResponseTypeDef(_ClientDescribeEndpointsResponseTypeDef):
    """
    Type definition for `ClientDescribeEndpoints` `Response`

    - **Endpoints** *(list) --* List of endpoints

      - *(dict) --* Describes an account-specific API endpoint.

        - **Url** *(string) --* URL of endpoint

    - **NextToken** *(string) --* Use this string to request the next batch of endpoints.
    """


_ClientGetJobResponseJobAccelerationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobAccelerationSettingsTypeDef", {"Mode": str}, total=False
)


class ClientGetJobResponseJobAccelerationSettingsTypeDef(
    _ClientGetJobResponseJobAccelerationSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJob` `AccelerationSettings`

    - **Mode** *(string) --* Specify the conditions when the service will run your job with
    accelerated transcoding.
    """


_ClientGetJobResponseJobMessagesTypeDef = TypedDict(
    "_ClientGetJobResponseJobMessagesTypeDef",
    {"Info": List[str], "Warning": List[str]},
    total=False,
)


class ClientGetJobResponseJobMessagesTypeDef(_ClientGetJobResponseJobMessagesTypeDef):
    """
    Type definition for `ClientGetJobResponseJob` `Messages`

    - **Info** *(list) --* List of messages that are informational only and don't indicate a problem
    with your job.

      - *(string) --*

    - **Warning** *(list) --* List of messages that warn about conditions that might cause your job
    not to run or to fail.

      - *(string) --*
    """


_ClientGetJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef = TypedDict(
    "_ClientGetJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef",
    {"HeightInPx": int, "WidthInPx": int},
    total=False,
)


class ClientGetJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef(
    _ClientGetJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobOutputGroupDetailsOutputDetails` `VideoDetails`

    - **HeightInPx** *(integer) --* Height in pixels for the output

    - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ClientGetJobResponseJobOutputGroupDetailsOutputDetailsTypeDef = TypedDict(
    "_ClientGetJobResponseJobOutputGroupDetailsOutputDetailsTypeDef",
    {
        "DurationInMs": int,
        "VideoDetails": ClientGetJobResponseJobOutputGroupDetailsOutputDetailsVideoDetailsTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobOutputGroupDetailsOutputDetailsTypeDef(
    _ClientGetJobResponseJobOutputGroupDetailsOutputDetailsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobOutputGroupDetails` `OutputDetails`

    - **DurationInMs** *(integer) --* Duration in milliseconds

    - **VideoDetails** *(dict) --* Contains details about the output's video stream

      - **HeightInPx** *(integer) --* Height in pixels for the output

      - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ClientGetJobResponseJobOutputGroupDetailsTypeDef = TypedDict(
    "_ClientGetJobResponseJobOutputGroupDetailsTypeDef",
    {"OutputDetails": List[ClientGetJobResponseJobOutputGroupDetailsOutputDetailsTypeDef]},
    total=False,
)


class ClientGetJobResponseJobOutputGroupDetailsTypeDef(
    _ClientGetJobResponseJobOutputGroupDetailsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJob` `OutputGroupDetails`

    - **OutputDetails** *(list) --* Details about the output

      - *(dict) --* Details regarding output

        - **DurationInMs** *(integer) --* Duration in milliseconds

        - **VideoDetails** *(dict) --* Contains details about the output's video stream

          - **HeightInPx** *(integer) --* Height in pixels for the output

          - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ClientGetJobResponseJobSettingsAvailBlankingTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsAvailBlankingTypeDef", {"AvailBlankingImage": str}, total=False
)


class ClientGetJobResponseJobSettingsAvailBlankingTypeDef(
    _ClientGetJobResponseJobSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ClientGetJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ClientGetJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ClientGetJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsEsam` `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ClientGetJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ClientGetJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef(
    _ClientGetJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsEsam` `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientGetJobResponseJobSettingsEsamTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ClientGetJobResponseJobSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ClientGetJobResponseJobSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsEsamTypeDef(_ClientGetJobResponseJobSettingsEsamTypeDef):
    """
    Type definition for `ClientGetJobResponseJobSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientGetJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ClientGetJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef(
    _ClientGetJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputs` `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsAudioSelectors` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientGetJobResponseJobSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ClientGetJobResponseJobSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsAudioSelectorsTypeDef(
    _ClientGetJobResponseJobSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsCaptionSelectors` `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ClientGetJobResponseJobSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ClientGetJobResponseJobSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsCaptionSelectorsTypeDef(
    _ClientGetJobResponseJobSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputs` `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ClientGetJobResponseJobSettingsInputsCropTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientGetJobResponseJobSettingsInputsCropTypeDef(
    _ClientGetJobResponseJobSettingsInputsCropTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientGetJobResponseJobSettingsInputsDecryptionSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsDecryptionSettingsTypeDef",
    {
        "DecryptionMode": str,
        "EncryptedDecryptionKey": str,
        "InitializationVector": str,
        "KmsKeyRegion": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsDecryptionSettingsTypeDef(
    _ClientGetJobResponseJobSettingsInputsDecryptionSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputs` `DecryptionSettings`

    - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt your
    input files.

    - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
    plaintext. Your job settings could be intercepted, making your encrypted content vulnerable.
    Specify the encrypted version of the data key that you used to encrypt your content. The data
    key must be encrypted by AWS Key Management Service (KMS). The key can be 128, 192, or 256 bits.

    - **InitializationVector** *(string) --* Specify the initialization vector that you used when
    you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
    initialization vector with any encryption mode. Or, you can use a 12-byte initialization vector
    with GCM or CTR. MediaConvert accepts only initialization vectors that are base64-encoded.

    - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service (KMS)
    that you used to encrypt your data key, if that Region is different from the one you are using
    for AWS Elemental MediaConvert.
    """


_ClientGetJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef(
    _ClientGetJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsImageInserter` `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientGetJobResponseJobSettingsInputsImageInserterTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientGetJobResponseJobSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsImageInserterTypeDef(
    _ClientGetJobResponseJobSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientGetJobResponseJobSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ClientGetJobResponseJobSettingsInputsInputClippingsTypeDef(
    _ClientGetJobResponseJobSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ClientGetJobResponseJobSettingsInputsPositionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientGetJobResponseJobSettingsInputsPositionTypeDef(
    _ClientGetJobResponseJobSettingsInputsPositionTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientGetJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ClientGetJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputsVideoSelector` `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientGetJobResponseJobSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ClientGetJobResponseJobSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsVideoSelectorTypeDef(
    _ClientGetJobResponseJobSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientGetJobResponseJobSettingsInputsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str, ClientGetJobResponseJobSettingsInputsAudioSelectorGroupsTypeDef
        ],
        "AudioSelectors": Dict[str, ClientGetJobResponseJobSettingsInputsAudioSelectorsTypeDef],
        "CaptionSelectors": Dict[str, ClientGetJobResponseJobSettingsInputsCaptionSelectorsTypeDef],
        "Crop": ClientGetJobResponseJobSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DecryptionSettings": ClientGetJobResponseJobSettingsInputsDecryptionSettingsTypeDef,
        "DenoiseFilter": str,
        "FileInput": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ClientGetJobResponseJobSettingsInputsImageInserterTypeDef,
        "InputClippings": List[ClientGetJobResponseJobSettingsInputsInputClippingsTypeDef],
        "Position": ClientGetJobResponseJobSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "SupplementalImps": List[str],
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ClientGetJobResponseJobSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsInputsTypeDef(_ClientGetJobResponseJobSettingsInputsTypeDef):
    """
    Type definition for `ClientGetJobResponseJobSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you encrypt
    before you upload them to Amazon S3. MediaConvert can decrypt files only when you use AWS Key
    Management Service (KMS) to encrypt the data key that you use to encrypt your content.

      - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt your
      input files.

      - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
      plaintext. Your job settings could be intercepted, making your encrypted content vulnerable.
      Specify the encrypted version of the data key that you used to encrypt your content. The data
      key must be encrypted by AWS Key Management Service (KMS). The key can be 128, 192, or 256
      bits.

      - **InitializationVector** *(string) --* Specify the initialization vector that you used when
      you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
      initialization vector with any encryption mode. Or, you can use a 12-byte initialization
      vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
      base64-encoded.

      - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service (KMS)
      that you used to encrypt your data key, if that Region is different from the one you are using
      for AWS Elemental MediaConvert.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FileInput** *(string) --* Specify the source file for your transcoding job. You can use
    multiple inputs in a single job. The service concatenates these inputs, in the order that you
    specify them in the job, to create the outputs. If your input format is IMF, specify your input
    by providing the path to your CPL. For example, "s3://bucket/vf/cpl.xml". If the CPL is in an
    incomplete IMP, make sure to use *Supplemental IMPs* (SupplementalImps) to specify any
    supplemental IMPs that contain assets referenced by the CPL.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You need
    supplemental IMPs if the CPL that you're using for your input is in an incomplete IMP. Specify
    either the supplemental IMP directories with a trailing slash or the ASSETMAP.xml files. For
    example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to specify the IMP
    that contains your input CPL, because the service automatically detects it.

      - *(string) --*

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientGetJobResponseJobSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ClientGetJobResponseJobSettingsMotionImageInserterFramerateTypeDef(
    _ClientGetJobResponseJobSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsMotionImageInserter` `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ClientGetJobResponseJobSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ClientGetJobResponseJobSettingsMotionImageInserterOffsetTypeDef(
    _ClientGetJobResponseJobSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsMotionImageInserter` `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ClientGetJobResponseJobSettingsMotionImageInserterTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ClientGetJobResponseJobSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ClientGetJobResponseJobSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsMotionImageInserterTypeDef(
    _ClientGetJobResponseJobSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ClientGetJobResponseJobSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ClientGetJobResponseJobSettingsNielsenConfigurationTypeDef(
    _ClientGetJobResponseJobSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings` `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings` `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroups` `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputs` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputs` `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettings` `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputs` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettings`
    `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputs` `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings` `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings` `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescription`
    `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroupsOutputs` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientGetJobResponseJobSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ClientGetJobResponseJobSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ClientGetJobResponseJobSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ClientGetJobResponseJobSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsOutputsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientGetJobResponseJobSettingsOutputGroupsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ClientGetJobResponseJobSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[ClientGetJobResponseJobSettingsOutputGroupsOutputsTypeDef],
    },
    total=False,
)


class ClientGetJobResponseJobSettingsOutputGroupsTypeDef(
    _ClientGetJobResponseJobSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ClientGetJobResponseJobSettingsTimecodeConfigTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ClientGetJobResponseJobSettingsTimecodeConfigTypeDef(
    _ClientGetJobResponseJobSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ClientGetJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ClientGetJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ClientGetJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettingsTimedMetadataInsertion` `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ClientGetJobResponseJobSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ClientGetJobResponseJobSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ClientGetJobResponseJobSettingsTimedMetadataInsertionTypeDef(
    _ClientGetJobResponseJobSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ClientGetJobResponseJobSettings` `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ClientGetJobResponseJobSettingsTypeDef = TypedDict(
    "_ClientGetJobResponseJobSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ClientGetJobResponseJobSettingsAvailBlankingTypeDef,
        "Esam": ClientGetJobResponseJobSettingsEsamTypeDef,
        "Inputs": List[ClientGetJobResponseJobSettingsInputsTypeDef],
        "MotionImageInserter": ClientGetJobResponseJobSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ClientGetJobResponseJobSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ClientGetJobResponseJobSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ClientGetJobResponseJobSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ClientGetJobResponseJobSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ClientGetJobResponseJobSettingsTypeDef(_ClientGetJobResponseJobSettingsTypeDef):
    """
    Type definition for `ClientGetJobResponseJob` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode job.
    There can be multiple inputs add in a job. These inputs will be concantenated together to create
    the output.

      - *(dict) --* Specifies media input

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
        encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when you
        use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt your
        content.

          - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt
          your input files.

          - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
          plaintext. Your job settings could be intercepted, making your encrypted content
          vulnerable. Specify the encrypted version of the data key that you used to encrypt your
          content. The data key must be encrypted by AWS Key Management Service (KMS). The key can
          be 128, 192, or 256 bits.

          - **InitializationVector** *(string) --* Specify the initialization vector that you used
          when you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
          initialization vector with any encryption mode. Or, you can use a 12-byte initialization
          vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
          base64-encoded.

          - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
          (KMS) that you used to encrypt your data key, if that Region is different from the one you
          are using for AWS Elemental MediaConvert.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FileInput** *(string) --* Specify the source file for your transcoding job. You can use
        multiple inputs in a single job. The service concatenates these inputs, in the order that
        you specify them in the job, to create the outputs. If your input format is IMF, specify
        your input by providing the path to your CPL. For example, "s3://bucket/vf/cpl.xml". If the
        CPL is in an incomplete IMP, make sure to use *Supplemental IMPs* (SupplementalImps) to
        specify any supplemental IMPs that contain assets referenced by the CPL.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You
        need supplemental IMPs if the CPL that you're using for your input is in an incomplete IMP.
        Specify either the supplemental IMP directories with a trailing slash or the ASSETMAP.xml
        files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to
        specify the IMP that contains your input CPL, because the service automatically detects it.

          - *(string) --*

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ClientGetJobResponseJobTimingTypeDef = TypedDict(
    "_ClientGetJobResponseJobTimingTypeDef",
    {"FinishTime": datetime, "StartTime": datetime, "SubmitTime": datetime},
    total=False,
)


class ClientGetJobResponseJobTimingTypeDef(_ClientGetJobResponseJobTimingTypeDef):
    """
    Type definition for `ClientGetJobResponseJob` `Timing`

    - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
    finished

    - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the job
    began.

    - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the job.
    """


_ClientGetJobResponseJobTypeDef = TypedDict(
    "_ClientGetJobResponseJobTypeDef",
    {
        "AccelerationSettings": ClientGetJobResponseJobAccelerationSettingsTypeDef,
        "AccelerationStatus": str,
        "Arn": str,
        "BillingTagsSource": str,
        "CreatedAt": datetime,
        "CurrentPhase": str,
        "ErrorCode": int,
        "ErrorMessage": str,
        "Id": str,
        "JobPercentComplete": int,
        "JobTemplate": str,
        "Messages": ClientGetJobResponseJobMessagesTypeDef,
        "OutputGroupDetails": List[ClientGetJobResponseJobOutputGroupDetailsTypeDef],
        "Priority": int,
        "Queue": str,
        "RetryCount": int,
        "Role": str,
        "Settings": ClientGetJobResponseJobSettingsTypeDef,
        "SimulateReservedQueue": str,
        "Status": str,
        "StatusUpdateInterval": str,
        "Timing": ClientGetJobResponseJobTimingTypeDef,
        "UserMetadata": Dict[str, str],
    },
    total=False,
)


class ClientGetJobResponseJobTypeDef(_ClientGetJobResponseJobTypeDef):
    """
    Type definition for `ClientGetJobResponse` `Job`

    - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
    with long, visually complex content.

      - **Mode** *(string) --* Specify the conditions when the service will run your job with
      accelerated transcoding.

    - **AccelerationStatus** *(string) --* Describes whether the current job is running with
    accelerated transcoding. For jobs that have Acceleration (AccelerationMode) set to DISABLED,
    AccelerationStatus is always NOT_APPLICABLE. For jobs that have Acceleration (AccelerationMode)
    set to ENABLED or PREFERRED, AccelerationStatus is one of the other states. AccelerationStatus
    is IN_PROGRESS initially, while the service determines whether the input files and job settings
    are compatible with accelerated transcoding. If they are, AcclerationStatus is ACCELERATED. If
    your input files and job settings aren't compatible with accelerated transcoding, the service
    either fails your job or runs it without accelerated transcoding, depending on how you set
    Acceleration (AccelerationMode). When the service runs your job without accelerated transcoding,
    AccelerationStatus is NOT_ACCELERATED.

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **BillingTagsSource** *(string) --* Optional. Choose a tag type that AWS Billing and Cost
    Management will use to sort your AWS Elemental MediaConvert costs on any billing report that you
    set up. Any transcoding outputs that don't have an associated tag will appear in your billing
    report unsorted. If you don't choose a valid value for this field, your job outputs will appear
    on the billing report unsorted.

    - **CreatedAt** *(datetime) --* The time, in Unix epoch format in seconds, when the job got
    created.

    - **CurrentPhase** *(string) --* A job's phase can be PROBING, TRANSCODING OR UPLOADING

    - **ErrorCode** *(integer) --* Error code for the job

    - **ErrorMessage** *(string) --* Error message of Job

    - **Id** *(string) --* A portion of the job's ARN, unique within your AWS Elemental MediaConvert
    resources

    - **JobPercentComplete** *(integer) --* An estimate of how far your job has progressed. This
    estimate is shown as a percentage of the total time from when your job leaves its queue to when
    your output files appear in your output Amazon S3 bucket. AWS Elemental MediaConvert provides
    jobPercentComplete in CloudWatch STATUS_UPDATE events and in the response to GetJob and ListJobs
    requests. The jobPercentComplete estimate is reliable for the following input containers:
    Quicktime, Transport Stream, MP4, and MXF. For some jobs, the service can't provide information
    about job progress. In those cases, jobPercentComplete returns a null value.

    - **JobTemplate** *(string) --* The job template that the job is created from, if it is created
    from a job template.

    - **Messages** *(dict) --* Provides messages from the service about jobs that you have already
    successfully submitted.

      - **Info** *(list) --* List of messages that are informational only and don't indicate a
      problem with your job.

        - *(string) --*

      - **Warning** *(list) --* List of messages that warn about conditions that might cause your
      job not to run or to fail.

        - *(string) --*

    - **OutputGroupDetails** *(list) --* List of output group details

      - *(dict) --* Contains details about the output groups specified in the job settings.

        - **OutputDetails** *(list) --* Details about the output

          - *(dict) --* Details regarding output

            - **DurationInMs** *(integer) --* Duration in milliseconds

            - **VideoDetails** *(dict) --* Contains details about the output's video stream

              - **HeightInPx** *(integer) --* Height in pixels for the output

              - **WidthInPx** *(integer) --* Width in pixels for the output

    - **Priority** *(integer) --* Relative priority on the job.

    - **Queue** *(string) --* Optional. When you create a job, you can specify a queue to send it
    to. If you don't specify, the job will go to the default queue. For more about queues, see the
    User Guide topic at http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

    - **RetryCount** *(integer) --* The number of times that the service automatically attempted to
    process your job after encountering an error.

    - **Role** *(string) --* The IAM role you use for creating this job. For details about
    permissions, see the User Guide topic at the User Guide at
    http://docs.aws.amazon.com/mediaconvert/latest/ug/iam-role.html

    - **Settings** *(dict) --* JobSettings contains all the transcode settings for a job.

      - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
      the input Ad Avail PTS time.

      - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
      overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

        - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
        black. Only bmp and png images are supported.

      - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

        - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
        ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
        uses the manifest conditioning instructions that you provide in the setting MCC XML
        (mccXml).

          - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
          document inside your JSON job settings. Form the XML document as per
          OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions
          in the message that you supply.

        - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
        between the SCTE 35 messages that the transcoder places and the splice points that they
        refer to. If the time between the start of the asset and the SCTE-35 message is less than
        this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

        - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
        SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
        signal processing instructions that you provide in the setting SCC XML (sccXml).

          - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
          inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
          transcoder will use the signal processing instructions in the message that you supply.
          Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
          For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
          insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
          (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
          passthrough. You can't do both.

      - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode job.
      There can be multiple inputs add in a job. These inputs will be concantenated together to
      create the output.

        - *(dict) --* Specifies media input

          - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
          combine. An input may have multiple audio selector groups. See "Audio Selector
          Group":#inputs-audio_selector_group for more information.

            - *(string) --*

              - *(dict) --* Group of Audio Selectors

                - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
                to include in the group. Audio selector names are standardized, based on their order
                within the input (e.g., "Audio Selector 1"). The audio selector name parameter can
                be repeated to add any number of audio selectors to the group.

                  - *(string) --*

          - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
          or set of tracks from the input that you will use in your outputs. You can use mutiple
          Audio selectors per input.

            - *(string) --*

              - *(dict) --* Selector for Audio

                - **CustomLanguageCode** *(string) --* Selects a specific language code from within
                an audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                set it as the default for the job. The service uses this default for outputs where
                it can't find the specified input audio. If you don't set a default, those outputs
                have no audio.

                - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                file source.

                - **LanguageCode** *(string) --* Selects a specific language code from within an
                audio source.

                - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                audio from the input video.

                - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
                selects PID 0x101).

                  - *(integer) --*

                - **ProgramSelection** *(integer) --* Use this setting for input streams that
                contain Dolby E, to have the service extract specific program data from the track.
                To select multiple programs, create multiple selectors with the same Track and
                different Program numbers. In the console, this setting is visible when you set
                Selector type to Track. Choose the program number from the dropdown list. If you are
                sending a JSON file, provide the program ID, which is part of the audio metadata. If
                your input file has incorrect metadata, you can choose All channels instead of a
                program number to have the service ignore the program IDs and include all the
                programs in the track.

                - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
                one input to match those of another input. This allows you to combine the two files
                into a single output, one after the other.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **SelectorType** *(string) --* Specifies the type of the audio selector.

                - **Tracks** *(list) --* Identify a track from the input audio to include in this
                selector by entering the track index number. To include several tracks in a single
                audio selector, specify multiple tracks as follows. Using the console, enter a
                comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                Specifying directly in your JSON job file, provide the track numbers in an array.
                For example, "tracks": [1,2,3].

                  - *(integer) --*

          - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
          the captions data from the input that you will use in your outputs. You can use mutiple
          captions selectors per input.

            - *(string) --*

              - *(dict) --* Set up captions in your outputs by first selecting them from your input
              here.

                - **CustomLanguageCode** *(string) --* The specific language to extract from source,
                using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
                complete this field and/or PID to select the caption language to extract. If input
                is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
                select the caption language to extract. If input is DVB-Sub that is being passed
                through, omit this field (and PID field); there is no way to extract a specific
                language with pass-through captions.

                - **LanguageCode** *(string) --* The specific language to extract from source. If
                input is SCTE-27, complete this field and/or PID to select the caption language to
                extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
                and/or PID to select the caption language to extract. If input is DVB-Sub that is
                being passed through, omit this field (and PID field); there is no way to extract a
                specific language with pass-through captions.

                - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                    number in the ancillary data track from which to extract captions. Unused for
                    passthrough.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                    PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content
                    is passed through, regardless of selectors.

                  - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                    within the video track from which to extract captions. Unused for passthrough.

                    - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                    for extracting captions. The system only supports one input video track, so this
                    should always be set to '1'.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                  STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source
                  file. If your caption source is IMSC in an IMF package, use TrackSourceSettings
                  instead of FileSoureSettings.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceFile** *(string) --* External caption file used for loading captions.
                    Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                    'smi'.

                    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                    captions from the source file.

                  - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                  your input captions. The service cannot auto-detect caption format.

                  - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                  sources, including Page number.

                    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                    three-digit hexadecimal page number that will be used for Teletext captions. Do
                    not use this setting if you are passing through teletext from the input source
                    to output.

                  - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                  are specified by track number. Currently, this is only IMSC captions in an IMF
                  package. If your caption source is IMSC 1.1 in a separate xml file, use
                  FileSourceSettings instead of TrackSourceSettings.

                    - **TrackNumber** *(integer) --* Use this setting to select a single captions
                    track from a source. Track numbers correspond to the order in the captions
                    source file. For IMF sources, track numbering is based on the order that the
                    captions appear in the CPL. For example, use 1 to select the captions asset that
                    is listed first in the CPL. To include more than one captions track in your job
                    outputs, create multiple input captions selectors. Specify one track per
                    selector.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame. If you specify a value here, it will
          override any value that you specify in the output setting Cropping selection (crop).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
          motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
          uncompressed video inputs.

          - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
          encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when you
          use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt your
          content.

            - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt
            your input files.

            - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
            plaintext. Your job settings could be intercepted, making your encrypted content
            vulnerable. Specify the encrypted version of the data key that you used to encrypt your
            content. The data key must be encrypted by AWS Key Management Service (KMS). The key can
            be 128, 192, or 256 bits.

            - **InitializationVector** *(string) --* Specify the initialization vector that you used
            when you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
            initialization vector with any encryption mode. Or, you can use a 12-byte initialization
            vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
            base64-encoded.

            - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
            (KMS) that you used to encrypt your data key, if that Region is different from the one
            you are using for AWS Elemental MediaConvert.

          - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
          the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
          video inputs.

          - **FileInput** *(string) --* Specify the source file for your transcoding job. You can
          use multiple inputs in a single job. The service concatenates these inputs, in the order
          that you specify them in the job, to create the outputs. If your input format is IMF,
          specify your input by providing the path to your CPL. For example,
          "s3://bucket/vf/cpl.xml". If the CPL is in an incomplete IMP, make sure to use
          *Supplemental IMPs* (SupplementalImps) to specify any supplemental IMPs that contain
          assets referenced by the CPL.

          - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
          transcoding service applies the denoise and deblock filters. You must also enable the
          filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
          Auto - The transcoding service determines whether to apply filtering, depending on input
          type and quality. * Disable - The input is not filtered. This is true even if you use the
          API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put
          is filtered regardless of input type.

          - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
          magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
          is 0.

          - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
          overlay on your video. Enable or disable this feature for each input individually. This
          setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
          that together specify a portion of the input to be used in the outputs. If you provide
          only a start time, the clip will be the entire input from that point to the end. If you
          provide only an end time, it will be the entire input up to that point. When you specify
          more than one input clip, the transcoding service creates the job outputs by stringing the
          clips together in the order you specify them.

            - *(dict) --* To transcode only portions of your input (clips), include one Input
            clipping (one instance of InputClipping in the JSON job file) for each input clip. All
            input clips you specify will be included in every output of the job.

              - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
              portion of the input you are clipping. The frame corresponding to the End timecode
              value is included in the clip. Start timecode or End timecode may be left blank, but
              not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
              minute, SS is the second, and FF is the frame number. When choosing this value, take
              into account your setting for timecode source under input settings
              (InputTimecodeSource). For example, if you have embedded timecodes that start at
              01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

              - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning
              of the portion of the input you are clipping. The frame corresponding to the Start
              timecode value is included in the clip. Start timecode or End timecode may be left
              blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour,
              MM is the minute, SS is the second, and FF is the frame number. When choosing this
              value, take into account your setting for Input timecode source. For example, if you
              have embedded timecodes that start at 01:00:00:00 and you want your clip to begin five
              minutes into the video, use 01:05:00:00.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black. If
          you specify a value here, it will override any value that you specify in the output
          setting Selection placement (position). If you specify a value here, this will override
          any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
          (RESPOND). If you specify a value here, this will ignore anything that you specify for the
          setting Scaling Behavior (scalingBehavior).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
          program from within a multi-program transport stream. Note that Quad 4K is not currently
          supported. Default is the first program within the transport stream. If the program you
          specify doesn't exist, the transcoding service will use this default.

          - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
          inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for
          audio and video. * Use PSI - Scan only PSI data.

          - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You
          need supplemental IMPs if the CPL that you're using for your input is in an incomplete
          IMP. Specify either the supplemental IMP directories with a trailing slash or the
          ASSETMAP.xml files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You
          don't need to specify the IMP that contains your input CPL, because the service
          automatically detects it.

            - *(string) --*

          - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
          input settings (InputTimecodeSource), to specify how the service counts input video
          frames. This input frame count affects only the behavior of features that apply to a
          single input at a time, such as input clipping and synchronizing some captions formats.
          Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at zero
          (ZEROBASED) to start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to
          start the first frame at the timecode that you specify in the setting Start timecode
          (timecodeStart). If you don't specify a value for Timecode source, the service will use
          Embedded by default. For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
          for this input's initial frame. To use this setting, you must set the Timecode source
          setting, located under the input settings (InputTimecodeSource), to Specified start
          (SPECIFIEDSTART). For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **VideoSelector** *(dict) --* Selector for video.

            - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
            animation. Specify which part of this input MediaConvert uses for your outputs. Leave
            this setting set to DISCARD in order to delete the alpha channel and preserve the video.
            Use REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the
            luma channel of your outputs.

            - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
            if you don't know about color space, leave this set to the default value Follow
            (FOLLOW). The service will automatically detect your input color space. If your input
            video has metadata indicating the wrong color space, specify the accurate color space
            here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume
            static metadata isn't present in your video stream, or if that metadata is present but
            not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the
            input HDR 10 metadata (Hdr10Metadata) settings. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
            file and the job input settings Color space (ColorSpace) and HDR master display
            information settings(Hdr10Metadata). The Color space usage setting determines which
            takes precedence. Choose Force (FORCE) to use color metadata from the input job
            settings. If you don't specify values for those settings, the service defaults to using
            metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata
            from the source when it is present. If there's no color metadata in your input file, the
            service defaults to using values you specify in the input settings.

            - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
            missing or inaccurate in your input video. Appropriate values vary depending on the
            input video and must be provided by a color grader. The color grader generates these
            values during the HDR 10 mastering process. The valid range for each of these settings
            is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
            settings - When you specify these values, you must also set Color space (ColorSpace) to
            HDR 10 (HDR10). To specify whether the the values you specify here take precedence over
            the values in the metadata of your input file, set Color space usage (ColorSpaceUsage).
            To specify whether color metadata is included in an output, set Color metadata
            (ColorMetadata). For more information about MediaConvert HDR jobs, see
            https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
            Specify this value as an integer; the system automatically converts it to the
            hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
            an identifier for a set of data in an MPEG-2 transport stream container.

            - **ProgramNumber** *(integer) --* Selects a specific program from within a
            multi-program transport stream. Note that Quad 4K is not currently supported.

            - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
            your video. You can choose automatic rotation or specify a rotation. You can specify a
            clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov
            or .mp4 and your input has rotation metadata, you can choose Automatic to have the
            service rotate your video according to the rotation specified in the metadata. The
            rotation must be within one degree of 90, 180, or 270 degrees. If the rotation metadata
            specifies any other rotation, the service will default to no rotation. By default, the
            service does no rotation, even if your input video has rotation metadata. The service
            doesn't pass through rotation metadata.

      - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
      graphics that you specify here appear on all outputs in all output groups.

        - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
        unspecified. If your motion graphic asset is a series of .png files, specify the frame rate
        of the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1.
        Make sure that the number of images in your series matches the frame rate and your intended
        overlay duration. For example, if you want a 30-second overlay at 30 fps, you should have
        900 .png images. This overlay frame rate doesn't need to match the frame rate of the
        underlying video.

          - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

          - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

        - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
        overlay on your video. For .png files, provide the file name of the first file in the
        series. Make sure that the names of the .png files end with sequential numbers that specify
        the order that they are played in. For example, overlay_000.png, overlay_001.png,
        overlay_002.png, and so on. The sequence must start at zero, and each image file name must
        have the same number of digits. Pad your initial file names with enough zeros to complete
        the sequence. For example, if the first image is overlay_0.png, there can be only 10 images
        in the sequence, with the last image being overlay_9.png. But if the first image is
        overlay_00.png, there can be 100 images in the sequence.

        - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
        providing for your overlay. You can choose either a .mov file or a series of .png files.

        - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay
        on the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
        specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
        the service inserts the overlay at its native resolution and scales the size up or down with
        any video scaling.

          - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
          edge of the video frame.

          - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
          edge of the video frame.

        - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
        or plays only once.

        - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
        (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
        account how you have set up your timecode configuration under both job settings and input
        settings. The simplest way to do that is to set both to start at 0. If you need to set up
        your job to follow timecodes embedded in your source that don't start at zero, make sure
        that you specify a start time that is after the first embedded timecode. For more
        information, see https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html
        Find job-wide and input timecode configuration settings in your JSON job settings
        specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

      - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
      do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
      configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs
      in the job. To enable Nielsen configuration programmatically, include an instance of
      nielsenConfiguration in your JSON job specification. Even if you don't include any children of
      nielsenConfiguration, you still enable the setting.

        - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
        functionality. If you must include this property, set the value to zero.

        - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
        distributor ID that is assigned to your organization by Neilsen.

      - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
      outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
      MXF, and no container) are grouped in a single output group as well. Required in
      (OutputGroups) is a group of settings that apply to the whole group. This required object
      depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
      settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
      HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
      MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

        - *(dict) --* Group of outputs

          - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
          the output group. This value is displayed on the console and can make your job settings
          JSON more human-readable. It does not affect your outputs. Use up to twelve characters
          that are either letters, numbers, spaces, or underscores.

          - **Name** *(string) --* Name of the output group

          - **OutputGroupSettings** *(dict) --* Output Group settings, including type

            - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
            Output Group may only contain a single video, audio, or caption output.

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
              your job. These default manifests reference every output in the output group. To
              create additional top-level manifests that reference a subset of the outputs in the
              output group, specify a list of them here. For each additional manifest that you
              specify, the service creates one HLS manifest and one DASH manifest.

                - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
                that you want the service to generate for this CMAF output group. Each pair of
                manifests can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
              at the top level BaseURL element. Can be used if streams are delivered from a
              different URL than the manifest file.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
                service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                (SAMPLE-AES) or AES_CTR (AES-CTR).

                - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                outputs, choose whether the service writes the 128-bit encryption initialization
                vector in the HLS and DASH manifests.

                - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                  signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                  package. The DASH manifest can currently signal up to three system IDs. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                  signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                  package. The HLS manifest can currently signal only one system ID. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
              of each individual CMAF segment. This value applies to the whole package; that is, to
              every output in the output group. Note that segments end on the first keyframe after
              this number of seconds, so the actual segment length might be slightly longer. If you
              set Segment control (CmafSegmentControl) to single file, the service puts the content
              of each output in a single file that has metadata that marks these segments. If you
              set it to segmented files, the service creates multiple files for each output, each
              with the content of one segment.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
              generated for this output.

              - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
              be generated for this output.

            - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
              manifest for each DASH ISO output group in your job. This default manifest references
              every output in the output group. To create additional DASH manifests that reference a
              subset of the outputs in the output group, specify a list of them here.

                - *(dict) --* Specify the details for each additional DASH manifest that you want
                the service to generate for this output group. Each manifest can reference a
                different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.mpd.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
              (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
              from a different URL than the manifest file.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                compatibility of your output with video players on obsolete devices. It applies only
                to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
                only to correct problems with playback on older devices. Otherwise, keep the default
                setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the
                service will exclude the access unit delimiter and will leave the SEI NAL units
                unencrypted.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
              that segments will end on the next keyframe after this number of seconds, so actual
              segment length may be longer. When Emit Single File is checked, the segmentation is
              internal to a single output file and it does not cause the creation of many output
              files as in other output types.

              - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
              the 400 range when you play back your DASH output, enable this setting and run your
              transcoding job again. When you enable this setting, the service writes precise
              segment durations in the DASH manifest. The segment duration information appears
              inside the SegmentTimeline element, inside SegmentTemplate at the Representation
              level. When you don't enable this setting, the service writes approximate segment
              durations in your DASH manifest.

            - **FileGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

            - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

              - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
              HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
              outputs themselves.

                - *(string) --*

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest for each HLS output group in your job. This default manifest
              references every output in the output group. To create additional top-level manifests
              that reference a subset of the outputs in the output group, specify a list of them
              here.

                - *(dict) --* Specify the details for each additional HLS manifest that you want the
                service to generate for this output group. Each manifest can reference a different
                subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
              in the media .m3u8 file. Can be used if base manifest is delivered from a different
              URL than the main .m3u8 file.

              - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                - *(dict) --* Caption Language Mapping

                  - **CaptionChannel** *(integer) --* Caption channel.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                  - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                  three-letter code listed at
                  https://www.loc.gov/standards/iso639-2/php/code_list.php.

                  - **LanguageDescription** *(string) --* Caption language description.

              - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
              captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one
              language in the CC1 Language Code field. One CLOSED-CAPTION line is added for each
              Language Code you specify. Make sure to specify the languages in the order in which
              they appear in the original source (if the source is embedded format) or the order of
              the caption selectors (if the source is other than embedded). Otherwise, languages in
              the manifest will not match up properly with the output captions. None: Include
              CLOSED-CAPTIONS=
                  NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from
              the manifest.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
              subdirectories.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
                scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
                disables encryption.

                - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                128-bit number used in conjunction with the key for encrypting blocks. If set to
                INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                Vector is not in the manifest.

                - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                HLS FairPlay content protection.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
              looking ahead and back within the specified range for a nearby avail and extending the
              segment size if needed.

              - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
              be generated for this HLS output group.

              - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
              in .m3u8 manifest files. The value is calculated as follows: either the program date
              and time are initialized using the input timecode source, or the time is initialized
              using the input timecode source and the date is initialized using the
              timestamp_offset.

              - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
              EXT-X-PROGRAM-DATE-TIME entry, in seconds.

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
              media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

              - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
              create (in seconds). Note that segments will end on the next keyframe after this
              number of seconds, so actual segment length may be longer.

              - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
              subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
              for this setting to have an effect.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

              - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

              - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
              offset to fine tune the timestamps.

            - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .ism
              Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
              in your job. This default manifest references every output in the output group. To
              create additional manifests that reference a subset of the outputs in the output
              group, specify a list of them here.

                - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                manifest that you want the service to generate for this output group. Each manifest
                can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                  "-no-premium" for this setting, then the file name the service generates for this
                  top-level manifest is film-name-no-premium.ismv.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
              audio encoding settings across a Microsoft Smooth output group into a single audio
              stream.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* If you are using DRM, set DRM System
              (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
              the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
              and frame rate.

              - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding)
              to specify the encoding format for the server and client manifest. Valid options are
              utf8 and utf16.

            - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
            Microsoft Smooth Streaming, CMAF)

          - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
          settings per output.

            - *(dict) --* An output object describes the settings for a single output file or stream
            in an output group.

              - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
              encoding settings organized by audio codec. Include one instance of
              (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
              encoding settings.

                - *(dict) --* Description of audio output

                  - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                  settings. Ignore these settings unless you need to comply with a loudness
                  standard.

                    - **Algorithm** *(string) --* Choose one of the following audio normalization
                    algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                    loudness for an entire piece of content, suitable for measurement of short-form
                    content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-2: Gated loudness. A measurement of gated average loudness compliant
                    with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
                    with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
                    Allows for more audio channels than the other algorithms, including
                    configurations such as 7.1.

                    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                    using the chosen algorithm. If disabled, the audio will be measured but not
                    adjusted.

                    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                    be corrected to the target level. Content measuring below this level will not be
                    corrected. Gating only applies when not using real_time_correction.

                    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                    loudness to a CSV file.

                    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                    TruePeak for each output's audio track loudness.

                    - **TargetLkfs** *(float) --* When you use Audio normalization
                    (AudioNormalizationSettings), optionally use this setting to specify a target
                    loudness. If you don't specify a value here, the encoder chooses a value for
                    you, based on the algorithm that you choose for Algorithm (algorithm). If you
                    choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                    encoder will choose -23 LKFS.

                  - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                  input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                  name based on its order within each input. For example if you specify "Audio
                  Selector 3", then the third audio selector will be used from each input. If an
                  input does not have an "Audio Selector 3", then the audio selector marked as
                  "default" in that input will be used. If there is no audio selector marked as
                  "default", silence will be inserted for the duration of that input. Alternatively,
                  an "Audio Selector Group":#inputs-audio_selector_group name may be specified, with
                  similar default/silence behavior. If no audio_source_name is specified, then
                  "Audio Selector 1" will be chosen automatically.

                  - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                  unchecked (false). A number between 0 and 255. The following are defined in
                  ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                       Hearing Impaired, 3 =
                  Visually Impaired Commentary, 4-255 = Reserved.

                  - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                  contains an ISO 639 audio_type, then that value is passed through to the output.
                  If the input contains no ISO 639 audio_type, the value in Audio Type is included
                  in the output. Otherwise the value in Audio Type is included in the output. Note
                  that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                  is set to BROADCASTER_MIXED_AD.

                  - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                  (AudioDescriptions) contains the group of settings related to audio encoding. The
                  settings in this group vary depending on the value that you choose for Audio codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * AAC,
                  AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                  Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                    - **AacSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                    two mutually exclusive groups of AAC settings--VBR and CBR. To select one of
                    these modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or
                    "CBR". In VBR mode, you control the audio quality with the setting VBR quality
                    (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                    valid values depend on the rate control mode.

                      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                      when the input contains pre-mixed main audio + audio description (AD) as a
                      stereo pair. The value for AudioType will be set to 3, which signals to
                      downstream systems that this stream contains "broadcaster mixed AD". Note that
                      the input received by the encoder must contain pre-mixed audio; the encoder
                      does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                      ignores any values you provide in AudioType and FollowInputAudioType. Choose
                      NORMAL when the input does not contain pre-mixed audio + audio description
                      (AD). In this case, the encoder will use any values you provide for AudioType
                      and FollowInputAudioType.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      The set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000,
                      16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000,
                      112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000,
                      448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you set is
                      also constrained by the values that you choose for Profile (codecProfile),
                      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
                      values depend on Bitrate control mode and Profile.

                      - **CodecProfile** *(string) --* AAC Profile.

                      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                      channel layout. Valid values depend on rate control mode and profile. "1.0 -
                      Audio Description (Receiver Mix)" setting receives a stereo description plus
                      control track and emits a mono AAC encode of the description track, with
                      control data emitted in the PES header as per ETSI TS 101 154 Annex E.

                      - **RateControlMode** *(string) --* Rate Control Mode.

                      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                      use LATM/LOAS AAC in an output, you must choose "No container" for the output
                      container.

                      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                      control mode and profile.

                      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                      for raw or MPEG-2 Transport Stream containers.

                      - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                      rate_control_mode is VBR.

                    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AC3.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                      stream that the encoder emits. For more information about the AC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital, dialnorm will be passed through.

                      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                      adds dynamic range compression signaling to the output bitstream as defined in
                      the Dolby Digital specification.

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                    - **AiffSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AIFF.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **Codec** *(string) --* Type of Audio codec.

                    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid values: 384k, 448k, 640k, 768k

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                      (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                      adjust loudness based on dialogue analysis.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                      this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix
                      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                      value -60 mutes the channel.

                      - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                      your audio.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                      that must be speech before the encoder uses the measured speech loudness as
                      the overall program loudness.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing.

                      - **SurroundExMode** *(string) --* Specify whether your input audio has an
                      additional center rear surround channel matrix encoded into your left and
                      right surround channels.

                    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3.

                      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                      dB attenuation to the surround channels. Only used for 3/2 coding mode.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                      number of channels.

                      - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital Plus, dialnorm will be passed through.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                      LFE channel is enabled

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left only/Right only center (loRoCenterMixLevel).

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                      channel. This setting applies only if you keep the default value of 3/2 - L,
                      R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                      If you choose a different value for Coding mode, the service ignores Left
                      only/Right only surround (loRoSurroundMixLevel).

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total center (ltRtCenterMixLevel).

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                      surround). MediaConvert uses this value for downmixing. How the service uses
                      this value depends on the value that you choose for Stereo downmix
                      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
                      -60 mutes the channel. This setting applies only if you keep the default value
                      of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total surround (ltRtSurroundMixLevel).

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                      audio will be passed through if it is present on the input. this detection is
                      dynamic over the life of the transcode. Inputs that alternate between DD+ and
                      non-DD+ content will have a consistent DD+ output as the system alternates
                      between passthrough and encoding.

                      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                      the surround channels. Only used for 3/2 coding mode.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing. This setting only applies if you keep the default value of 3/2 -
                      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Stereo downmix (Eac3StereoDownmix).

                      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                      extra center back surround channel is matrix encoded into the left and right
                      surround channels.

                      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                      Surround is matrix encoded into the two channels.

                    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value MP2.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                      - **Channels** *(integer) --* Set Channels to specify the number of channels
                      in this output audio track. Choosing Mono in the console will give you 1
                      output channel; choosing Stereo will give you 2. In the API, valid values are
                      1 and 2.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **WavSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value WAV.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                      If your output audio is likely to exceed 4 GB in file size, or if you
                      otherwise need the extended support of the RF64 format, set your output WAV
                      file format to RF64.

                      - **SampleRate** *(integer) --* Sample rate in Hz.

                  - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                  track. The service puts this language code into your output audio track when you
                  set Language code control (AudioLanguageCodeControl) to Use configured
                  (USE_CONFIGURED). The service also uses your specified custom language code when
                  you set Language code control (AudioLanguageCodeControl) to Follow input
                  (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                  outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                  can also use any other code in the full RFC-5646 specification. Streaming outputs
                  are those that are in one of the following output groups: CMAF, DASH ISO, Apple
                  HLS, or Microsoft Smooth Streaming.

                  - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                  The ISO 639 language specified in the 'Language Code' drop down will be used when
                  'Follow Input Language Code' is not selected or when 'Follow Input Language Code'
                  is selected but there is no ISO 639 language code specified by the input.

                  - **LanguageCodeControl** *(string) --* Specify which source for language code
                  takes precedence for this audio track. When you choose Follow input
                  (FOLLOW_INPUT), the service uses the language code from the input track if it's
                  present. If there's no languge code on the input track, the service uses the code
                  that you specify in the setting Language code (languageCode or
                  customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service
                  uses the language code that you specify.

                  - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **StreamName** *(string) --* Specify a label for this output audio stream. For
                  example, "English", "Director commentary", or "track_2". For streaming outputs,
                  MediaConvert passes this information into destination manifests for display on the
                  end-viewer's player device. For outputs in other output groups, the service
                  ignores this setting.

              - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
              captions settings. For each output that has captions, include one instance of
              (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
              settings.

                - *(dict) --* Description of Caption output

                  - **CaptionSelectorName** *(string) --* Specifies which "Caption
                  Selector":#inputs-caption_selector to use from each input when generating
                  captions. The name should be of the format "Caption Selector ", which denotes that
                  the Nth Caption Selector will be used from each input.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  output track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information when automatically
                  selecting the font script for rendering the captions text. For all outputs, you
                  can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
                  any other code in the full RFC-5646 specification. Streaming outputs are those
                  that are in one of the following output groups: CMAF, DASH ISO, Apple HLS, or
                  Microsoft Smooth Streaming.

                  - **DestinationSettings** *(dict) --* Specific settings required by destination
                  type. Note that burnin_destination_settings are not available if the source of the
                  caption data is Embedded or Teletext.

                    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering burn-in captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **DestinationType** *(string) --* Specify the format for this set of captions
                    on this output. The default format is embedded without SCTE-20. Other options
                    are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                    web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                    (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec.
                    To create a non-compliant output where the embedded captions come first, choose
                    Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering DVB-Sub captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                      standard or for hearing impaired. Choose hearing impaired if your subtitles
                      include audio descriptions and dialogue. Choose standard if your subtitles
                      include only dialogue.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                    embedded/ancillary caption outputs, including 608/708 Channel destination
                    number.

                      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and your output captions are embedded in
                      the video stream. Specify a CC number for each captions channel in this
                      output. If you have two channels, choose CC numbers that aren't in the same
                      field. For example, choose 1 and 3. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and you want both 608 and 708 captions
                      embedded in your output stream. Optionally, specify the 708 service number for
                      each output captions channel. Choose a different number for each channel. To
                      use this setting, also set Force 608 to 708 upconvert (Convert608To708) to
                      Upconvert (UPCONVERT) in your input captions selector settings. If you choose
                      to upconvert but don't specify a 708 service number, MediaConvert uses the
                      number that you specify for CC channel number (destination608ChannelNumber)
                      for the 708 service number. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                    outputs.

                      - **StylePassthrough** *(string) --* Keep this setting enabled to have
                      MediaConvert use the font style and position information from the captions
                      source in the output. This option is available only when your input captions
                      are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                      output captions.

                    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                      sure that the captions and the video are synchronized in the output. Specify a
                      frame rate that matches the frame rate of the associated video. If the video
                      frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only
                      if the video has video_insertion=
                          true and drop_frame_timecode=true; otherwise,
                      choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                    output

                      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                      the destination captions for this output. This value must be a three-digit
                      hexadecimal string; strings ending in -FF are invalid. If you are passing
                      through the entire set of Teletext data, do not use this field.

                      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                      you don't specify a value here, the service sets the page type to the default
                      value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                      Teletext data, don't use this field. When you pass through a set of Teletext
                      pages, your output has the same page types as your input.

                        - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                        Table 94

                    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                    outputs, including Pass style information (TtmlStylePassthrough).

                      - **StylePassthrough** *(string) --* Pass through style and position
                      information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                      CFF-TT output or TTML output.

                  - **LanguageCode** *(string) --* Specify the language of this captions output
                  track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information to choose the font
                  language for rendering the captions text.

                  - **LanguageDescription** *(string) --* Specify a label for this set of output
                  captions. For example, "English", "Director commentary", or "track_2". For
                  streaming outputs, MediaConvert passes this information into destination manifests
                  for display on the end-viewer's player device. For outputs in other output groups,
                  the service ignores this setting.

              - **ContainerSettings** *(dict) --* Container specific settings.

                - **Container** *(string) --* Container for this output. Some containers require a
                container settings object. If not specified, the default object will be created.

                - **F4vSettings** *(dict) --* Settings for F4v container

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs
                in a File output group when the output's container (ContainerType) is MPEG-2
                Transport Stream (M2TS). In these assets, data is organized by the program map table
                (PMT). Each transport stream program contains subsets of data, including audio,
                video, and metadata. Each of these subsets of data has a numerical label called a
                packet identifier (PID). Each transport stream program corresponds to one
                MediaConvert output. The PMT lists the types of data in a program along with their
                PID. Downstream systems and players use the program map table to look up the PID for
                each type of data it accesses and then uses the PIDs to locate specific data within
                the asset.

                  - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                  models for Dolby Digital audio.

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                  elementary audio streams you include in this output. Specify multiple PIDs as a
                  JSON array. Default is the range 482-492.

                    - *(integer) --*

                  - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                  bits per second. Setting to 0 lets the muxer automatically determine the
                  appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                  - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                  interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                  this can lead to lower latency, but low-memory devices may not be able to play
                  back the stream without interruptions.

                  - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                  the specified table repetition interval.

                    - **NetworkId** *(integer) --* The numeric value placed in the Network
                    Information Table (NIT).

                    - **NetworkName** *(string) --* The network name text placed in the
                    network_name_descriptor inside the Network Information Table. Maximum length is
                    256 characters.

                    - **NitInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                  the specified table repetition interval.

                    - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                    output stream. "Follow input SDT" copies SDT information from input stream to
                    output stream. "Follow input SDT if present" copies SDT information from input
                    stream to output stream if SDT information is present in the input, otherwise it
                    will fall back on the user-defined values. Enter "SDT Manually" means user will
                    enter the SDT information. "No SDT" means output stream will not contain SDT
                    information.

                    - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **ServiceName** *(string) --* The service name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                    - **ServiceProviderName** *(string) --* The service provider name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                  - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                  subtitle data included in this output. Specify multiple PIDs as a JSON array.
                  Default is the range 460-479.

                    - *(integer) --*

                  - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                  specified table repetition interval.

                    - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                  teletext data you include in this output. Default is 499.

                  - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                  EBP markers will be added to partitions 3 and 4. The interval between these
                  additional markers will be fixed, and will be slightly shorter than the video EBP
                  marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                  inserted. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                  can either be placed only on the video PID, or on both the video PID and all audio
                  PIDs. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                  the PES header.

                  - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                  you know that your audio EBP markers are incorrectly appearing before your video
                  EBP markers. To correct this problem, set this value to Force (FORCE).

                  - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                  used with EBP markers.

                  - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                  between Program Clock References (PCRs) inserted into the transport stream.

                  - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                  Points do not come within the specified time interval of each other by looking
                  ahead at input video. If another EBP is going to come in within the specified time
                  interval, the current EBP is not emitted, and the segment is "stretched" to the
                  next marker. The lookahead value does not add latency to the system. The Live
                  Event must be configured elsewhere to create sufficient latency to make the
                  lookahead accurate.

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                  packets to insert into the transport stream. This can be used if a downstream
                  encryption system requires periodic null packets.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This is effective only when the PCR PID is the same as the video or audio
                  elementary stream.

                  - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                  clock reference (PCR) in this output. If you do not specify a value, the service
                  will use the value for Video PID (VideoPid).

                  - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                  instances of the program map table (PMT) in the output transport stream.

                  - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                  map table (PMT) itself. Default is 480.

                  - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                  private metadata stream. Default is 503.

                  - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                  the program number used in the program map table (PMT) for this output. Default is
                  1. Program numbers and program map tables are parts of MPEG-2 transport stream
                  containers, used for organizing data.

                  - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                  stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                  maximum bitrate, but the output will not be padded up to that bitrate.

                  - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                  markers in your HLS and transport stream outputs at the insertion points that you
                  specify in an ESAM XML document. Provide the document in the setting SCC XML
                  (sccXml).

                    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                    in the transport stream generated by ESAM.

                  - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                  stream in the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None
                  (NONE). Also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml). Also enable ESAM SCTE-35 (include the property
                  scte35Esam).

                  - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                  segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                  adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                  private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                  segments. ebp adds Encoder Boundary Point information to the adaptation field as
                  per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary
                  Point information to the adaptation field using a legacy proprietary format.

                  - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                  how segmentation markers are inserted into the transport stream. With avails, it
                  is possible that segments may be truncated, which can influence where future
                  segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                  selected and a segment is truncated due to an avail, we will reset the
                  segmentation cadence. This means the subsequent segment will have a duration of of
                  $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                  selected and a segment is truncated due to an avail, we will not reset the
                  segmentation cadence. This means the subsequent segment will likely be truncated
                  as well. However, all segments after that will have a duration of
                  $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
                  rule.

                  - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                  segment. Required unless markers is set to _none_.

                  - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                  timed metadata in this output. Default is 502.

                  - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                  itself in the program map table for this output. Transport stream IDs and program
                  map tables are parts of MPEG-2 transport stream containers, used for organizing
                  data.

                  - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                  elementary video stream in the transport stream.

                - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                  stream(s) in the transport stream. Multiple values are accepted, and can be
                  entered in ranges and/or by comma separation.

                    - *(integer) --*

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This parameter is effective only when the PCR PID is the same as the video or
                  audio elementary stream.

                  - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                  (PCR) in the transport stream. When no value is given, the encoder will assign the
                  same value as the Video PID.

                  - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                  (PMT) in the transport stream.

                  - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                  metadata stream in the transport stream.

                  - **ProgramNumber** *(integer) --* The value of the program number field in the
                  Program Map Table.

                  - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                  the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE)
                  if you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and
                  choose Ad markers (adMarkers) if you do want manifest conditioning. In both cases,
                  also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml).

                  - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                  specify whether the service inserts the ID3 timed metadata from the input in this
                  output.

                  - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                  metadata stream in the transport stream.

                  - **TransportStreamId** *(integer) --* The value of the transport stream ID field
                  in the Program Map Table.

                  - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                  stream in the transport stream.

                - **MovSettings** *(dict) --* Settings for MOV Container.

                  - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                  the video output settings.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                  streams into the QuickTime file using XDCAM fourcc codes. This increases
                  compatibility with Apple editors and players, but may decrease compatibility with
                  other players. Only applicable when the video codec is MPEG2.

                  - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                  padding

                  - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                  this setting.

                - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
                AAC outputs with this container.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                  moov box.

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                  - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                  file. Usually not necessary to specify.

                - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                  - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                  groups that include sidecar TTML or IMSC captions. You specify sidecar captions in
                  a separate output from your audio and video. Choose Raw (RAW) for captions in a
                  single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for
                  captions in XML format contained within fragmented MP4 files. This set of
                  fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                  - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                  markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                  insertion points that you specify in an ESAM XML document. Provide the document in
                  the setting SCC XML (sccXml).

                  - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                  markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                  SCTE-35 markers that appear in your input to also appear in this output. Choose
                  None (NONE) if you don't want those SCTE-35 markers in this output.

              - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
              for outputs in File output groups. If you do not specify a value, the service will use
              default extensions by container type as follows * MPEG-2 transport stream, m2ts *
              Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the
              service will use codec extensions (e.g. AAC, H265, H265, AC3)

              - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
              add a string to the end of each output filename. You specify the base filename as part
              of your destination URI. When you create multiple outputs in the same output group,
              Name modifier (NameModifier) is required. Name modifier also accepts format
              identifiers. For DASH ISO outputs, if you use the format identifiers $Number$ or
              $Time$ in one output, you must use them in the same way in all outputs of the output
              group.

              - **OutputSettings** *(dict) --* Specific settings for this type of output.

                - **HlsSettings** *(dict) --* Settings for HLS output groups

                  - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                  belongs.

                  - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                  outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                  container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                  file in a raw container. Regardless of the value that you specify here, if this
                  output has video, the service will place the output into an MPEG2-TS container.

                  - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                  with the video output stream. Input all the audio GROUP-IDs that are associated to
                  the video, separate by ','.

                  - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                  Audio-Only Variant Stream The client can play back this audio-only stream instead
                  of video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                  manifest. Alternate Audio, Auto Select, Default Alternate rendition that the
                  client should try to play back by default. Represented as an EXT-X-MEDIA in the
                  HLS manifest with DEFAULT=YES, AUTOSELECT=
                      YES Alternate Audio, Auto Select, Not
                  Default Alternate rendition that the client may try to play back by default.
                  Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                      NO, AUTOSELECT=YES
                  Alternate Audio, not Auto Select Alternate rendition that the client will not try
                  to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
                  DEFAULT=NO, AUTOSELECT=NO

                  - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                  Manifest in addition to the HLS manifest

                  - **SegmentModifier** *(string) --* String concatenated to end of segment
                  filenames. Accepts "Format Identifiers":#format_identifier_parameters.

              - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
              transcoding settings. Provide the system or custom preset name. You can specify either
              Preset (Preset) or Container settings (ContainerSettings), but not both.

              - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
              encoding settings. The specific video settings depend on the video codec that you
              choose when you specify a value for Video codec (codec). Include one instance of
              (VideoDescription) per output.

                - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                service includes AFD values in the output video data and what those values are. *
                Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                input AFD values and instead encode the value specified in the job. * Choose Auto to
                calculate output AFD values based on the input AFD scaler data.

                - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
                outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
                specify that in your job, the service will ignore the setting.

                - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                (VideoDescription), contains the group of settings related to video encoding. The
                settings in this group vary depending on the value that you choose for Video codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * H_264,
                H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
                FRAME_CAPTURE, FrameCaptureSettings

                  - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                  the enum values defined by the object VideoCodec.

                  - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                    - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.n.jpg where n is the 0-based sequence number of each Capture.

                    - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
                    to 7 decimal places.

                    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                    files).

                    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                    quality.

                  - **H264Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value H_264.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                    your output video settings. If you aren't sure what level to specify, choose
                    Auto (AUTO).

                    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                    are only available with the AVC-I License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                    Main or High profile) or CAVLC.

                    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                    for interlaced outputs.

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job specification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* When you use the API for transcode
                    jobs that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateDenominator to specify the
                    denominator of this fraction. In this example, use 1001 for the value of
                    FramerateDenominator. When you use the console for transcode jobs that use frame
                    rate conversion, provide the value as a decimal number for Framerate. In this
                    example, specify 23.976.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type, as follows. - If the source is interlaced, the output will be interlaced
                    with the same polarity as the source (it will follow the source). The output
                    could therefore be a mix of "top field first" and "bottom field first". - If the
                    source is progressive, the output will be interlaced with "top field first" or
                    "bottom field first" polarity, depending on which of the Follow options you
                    chose.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even
                    if repeated.

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                  - **H265Settings** *(dict) --* Settings for H265 codec

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                    Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                    Transfer Function (EOTF).

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* H.265 Level.

                    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                    (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                    "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                    available with the HEVC 4:2:2 License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                    Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                    the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field
                    First (BOTTOM_FIELD) to create an output that's interlaced with the same field
                    polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow,
                    Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the
                    same field polarity as the source. If the source is interlaced, the output will
                    be interlaced with the same polarity as the source (it will follow the source).
                    The output could therefore be a mix of "top field first" and "bottom field
                    first". If the source is progressive, your output will be interlaced with "top
                    field first" or "bottom field first" polarity, depending on which of the Follow
                    options you chose. If you don't choose a value, the service will default to
                    Progressive (PROGRESSIVE).

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                    Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                    based on content

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                    encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                    and P-frames form one layer, reference B-frames can form a second layer and
                    non-reference b-frames can form a third layer. Decoders can optionally decode
                    only the lower temporal layers to generate a lower frame rate output. For
                    example, given a bitstream with temporal IDs and with b-frames =
                         1 (i.e. IbPbPb
                    display order), a decoder could decode all the frames for full frame rate output
                    or only the I and P frames (lowest temporal layer) for a half frame rate output.

                    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                    vertical subdivision of the encoded pictures.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                    units doesn't matter in your workflow, ignore this setting. Use this setting
                    only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                    container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                    your output compliant with the following specification: ISO IECJTC1 SC29 N13798
                    Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
                    parameter set NAL units in the sample headers but not in the samples directly.
                    For MP4 outputs, when you choose HVC1, your output video might not work properly
                    with some downstream systems and video players. The service defaults to marking
                    your output as HEV1. For these outputs, the service writes parameter set NAL
                    units directly into the samples.

                  - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value MPEG2.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                    level for the video output.

                    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                    MPEG-2 profile for the video output.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **IntraDcPrecision** *(string) --* Use Intra DC precision
                    (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                    coefficients. If you choose the value auto, the service will automatically
                    select the precision based on the per-frame compression ratio.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                    video encoding.

                    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                    to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                    356M-2001).

                    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                  - **ProresSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value PRORES.

                    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                    the type of Apple ProRes codec to use for this output.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                    that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateNumerator to specify the
                    numerator of this fraction. In this example, use 24000 for the value of
                    FramerateNumerator.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                    determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                    to use the pixel aspect ratio from the input. To specify a different pixel
                    aspect ratio: Using the console, choose it from the dropdown menu. Using the
                    API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                    (ParDenominator).

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
                color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
                this output. If you don't specify a value, the service sets this to Insert by
                default.

                - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
                the service will include in the output video frame.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                feature is enabled, the service will use drop-frame timecode on outputs. If it is
                not possible to use drop-frame timecode, the system will fall back to
                non-drop-frame. This setting is enabled by default when Timecode insertion
                (TimecodeInsertion) is enabled.

                - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
                Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                service will write on all frames of this video output.

                - **Height** *(integer) --* Use the Height (Height) setting to define the video
                resolution height for this output. Specify in pixels. If you don't provide a value
                here, the service will use the input height.

                - **Position** *(dict) --* Use Selection placement (position) to define the video
                area in your output frame. The area outside of the rectangle that you specify here
                is black.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                the service changes the video itself in response to AFD values in the input. *
                Choose Respond to clip the input video frame according to the AFD value, input
                display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                include the input AFD values. Do not choose this when AfdSignaling is set to (NONE).
                A preferred implementation of this workflow is to set RespondToAfd to (NONE) and set
                AfdSignaling to (AUTO). * Choose None to remove all input AFD values from this
                output.

                - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                have a different aspect ratio from the input aspect ratio. Choose Stretch to output
                (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
                setting Default (DEFAULT) to have the service letterbox your video instead. This
                setting overrides any value that you specify for the setting Selection placement
                (position) in this output.

                - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                strength of anti-aliasing. This setting changes the width of the anti-alias filter
                kernel used for scaling. Sharpness only applies if your output resolution is
                different from your input resolution. 0 is the softest setting, 100 the sharpest,
                and 50 recommended for most content.

                - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                ProRes outputs. Only enable Timecode insertion when the input frame rate is
                identical to the output frame rate. To include timecodes in this output, set
                Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                output, by default, it uses any embedded timecodes from the input. If none are
                present, the service will set the timecode for the first output frame to zero. To
                change this default behavior, adjust the settings under Timecode configuration
                (TimecodeConfig). In the console, these settings are located under Job > Job
                settings > Timecode configuration. Note - Timecode source under input settings
                (InputTimecodeSource) does not affect the timecodes that are inserted in the output.
                Source under Job settings > Timecode configuration (TimecodeSource) does.

                - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                Preprocessors (VideoPreprocessors). Enable the features at each output individually.
                These features are disabled by default.

                  - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                  feature if necessary. Enable or disable this feature for each output individually.
                  This setting is disabled by default.

                    - **Brightness** *(integer) --* Brightness level.

                    - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                    this output. The service supports conversion between HDR formats, between SDR
                    formats, and from SDR to HDR. The service doesn't support conversion from HDR to
                    SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                    video has an HDR format, but visually appears the same as an unconverted output.

                    - **Contrast** *(integer) --* Contrast level.

                    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                    10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                    metadata that you want signaled in the output. These values don't affect the
                    pixel values that are encoded in the video stream. They are intended to help the
                    downstream video player display content in a way that reflects the intentions of
                    the the content creator. When you set Color space conversion
                    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                    must set values for Max frame average light level (maxFrameAverageLightLevel)
                    and Max content light level (maxContentLightLevel); these settings don't have a
                    default value. The default values for the other HDR 10 metadata settings are
                    defined by the P3D65 color space. For more information about MediaConvert HDR
                    jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                      samples in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                      any frame in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance
                      in units of of 0.0001 candelas per square meter.

                      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance
                      in units of of 0.0001 candelas per square meter

                      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                    - **Hue** *(integer) --* Hue in degrees.

                    - **Saturation** *(integer) --* Saturation level.

                  - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                  motion and a clearer picture.

                    - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                    (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                    adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                    (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if
                    your source file includes a ticker, such as a scrolling headline at the bottom
                    of the frame.

                    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                    does not convert frames that are tagged in metadata as progressive. It will only
                    convert those that are tagged as some other type. - When set to
                    FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                    those that are already tagged as progressive. Turn Force mode on only if there
                    is a good chance that the metadata has tagged frames as progressive when they
                    are not progressive. Do not turn on otherwise; processing frames that are
                    already progressive into progressive will probably result in lower quality
                    video.

                    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                    service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                    interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                    progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                  - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                  compatible video output.

                    - **L6Metadata** *(dict) --* Use these settings when you set
                    DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                    your input with new values.

                      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                      that corresponds to the brightest pixel in the entire stream. Measured in
                      nits.

                      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                      metadata that corresponds to the highest frame-average brightness in the
                      entire stream. Measured in nits.

                    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                    handle Dolby Vision MaxCLL and MaxFALL properies.

                    - **Profile** *(string) --* In the current MediaConvert implementation, the
                    Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must
                    contain Dolby Vision frame interleaved data.

                  - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature
                  to include a graphic overlay on your video. Enable or disable this feature for
                  each output individually. This setting is disabled by default.

                    - **InsertableImages** *(list) --* Specify the images that you want to overlay
                    on your video. The images must be PNG or TGA files.

                      - *(dict) --* Settings that specify how your still graphic overlay appears.

                        - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                        image to remain on the output video. This duration includes fade-in time but
                        not fade-out time.

                        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                        between the Start time that you specify for the image insertion and the time
                        that the image appears at full opacity. Full opacity is the level that you
                        specify for the opacity setting. If you don't specify a value for Fade-in,
                        the image will appear abruptly at the overlay start time.

                        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                        between the end of the time that you have specified for the image overlay
                        Duration and when the overlaid image has faded to total transparency. If you
                        don't specify a value for Fade-out, the image will disappear abruptly at the
                        end of the inserted image duration.

                        - **Height** *(integer) --* Specify the height of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        height, the service will crop your overlaid image to fit. To use the native
                        height of the image, keep this setting blank.

                        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                        location of the image that you want to overlay on the video. Use a PNG or
                        TGA file.

                        - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                        inserted image and the left edge of the video frame. Required for any image
                        overlay that you specify.

                        - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                        overlaid image and the top edge of the video frame. Required for any image
                        overlay that you specify.

                        - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                        Images with higher values for Layer appear on top of images with lower
                        values for Layer.

                        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                        the underlying video shows through the inserted image. 0 is transparent and
                        100 is fully opaque. Default is 50.

                        - **StartTime** *(string) --* Specify the timecode of the frame that you
                        want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                        or HH:MM:SS;FF) format. Remember to take into account your timecode source
                        settings.

                        - **Width** *(integer) --* Specify the width of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        width, the service will crop your overlaid image to fit. To use the native
                        width of the image, keep this setting blank.

                  - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                  remove noise from your video output if necessary. Enable or disable this feature
                  for each output individually. This setting is disabled by default.

                    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                    select one of the following spatial image filtering functions. To use this
                    setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                    preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                    Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                    reduction. * Spatial does frequency-domain filtering based on JND principles. *
                    Temporal optimizes video quality for complex motion.

                    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                    spatial filter.

                      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                      reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                      maximum strength.

                      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                      (higher speed), with 0 being the nominal value.

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                    temporal filter.

                      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                      complex motion. Higher values produce stronger temporal filtering. This
                      filters highly complex scenes more aggressively and creates better VQ for low
                      bitrate outputs.

                      - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                      Low setting reduces bit rate at the cost of transcode time, high setting
                      improves transcode time at the cost of bit rate.

                      - **Strength** *(integer) --* Specify the strength of the noise reducing
                      filter on this output. Higher values produce stronger filtering. We recommend
                      the following value ranges, depending on the result that you want: * 0-2 for
                      complexity reduction with minimal sharpness loss * 2-8 for complexity
                      reduction with image preservation * 8-16 for a high level of complexity
                      reduction

                  - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                  output timecode and specified prefix into the output.

                    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                    any burned-in timecode. Valid values are 10, 16, 32, 48.

                    - **Position** *(string) --* Use Position (Position) under under Timecode
                    burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                    output video.

                    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                    any burned-in timecode. For example, a prefix of "EZ-" will result in the
                    timecode "EZ-00:00:00:00". Provide either the characters themselves or the ASCII
                    code equivalents. The supported range of characters is 0x20 through 0x7e. This
                    includes letters, numbers, and all special characters represented on a standard
                    English keyboard.

                - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                in pixels, for this output. If you don't provide a value here, the service will use
                the input width.

      - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
      information from inputs.

        - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
        use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
        the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or
        (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
        Timecode varies depending on your setting for Source (TimecodeSource). * If Source
        (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
        specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
        (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start at
        0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
        Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
        input.

        - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
        within this job. To make sure that your video, audio, captions, and markers are synchronized
        and that time-based features, such as image inserter, work correctly, choose the Timecode
        source option that matches your assets. All timecodes are in a 24-hour format with frame
        number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video.
        If no embedded timecode is in the source, the service will use Start at 0 (ZEROBASED)
        instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. *
        Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other
        than zero. You use Start timecode (Start) to provide this value.

        - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
        (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
        Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

        - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
        stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
        affecting the time and frame number. Provide the new date as a string in the format
        "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
        (InsertProgramDateTime) in the output settings. For example, if the date part of your
        timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
        (TimestampOffset) to 2003-1-25.

      - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
      (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
      enable it here, enable it in each output container, and specify tags and timecodes in ID3
      insertion (Id3Insertion) objects.

        - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

          - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
          specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when
          the tag should be inserted. To insert multiple ID3 tags in your output, create multiple
          instances of ID3 insertion (Id3Insertion).

            - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
            format.

            - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
            format.

    - **SimulateReservedQueue** *(string) --* Enable this setting when you run a test job to
    estimate how many reserved transcoding slots (RTS) you need. When this is enabled, MediaConvert
    runs your job from an on-demand queue with similar performance to what you will see with one RTS
    in a reserved queue. This setting is disabled by default.

    - **Status** *(string) --* A job's status can be SUBMITTED, PROGRESSING, COMPLETE, CANCELED, or
    ERROR.

    - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
    events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
    MediaConvert sends an update at this interval from the time the service begins processing your
    job to the time it completes the transcode or encounters an error.

    - **Timing** *(dict) --* Information about when jobs are submitted, started, and finished is
    specified in Unix epoch format in seconds.

      - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
      finished

      - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the job
      began.

      - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the job.

    - **UserMetadata** *(dict) --* User-defined metadata that you want to associate with an
    MediaConvert job. You specify metadata in key/value pairs.

      - *(string) --*

        - *(string) --*
    """


_ClientGetJobResponseTypeDef = TypedDict(
    "_ClientGetJobResponseTypeDef", {"Job": ClientGetJobResponseJobTypeDef}, total=False
)


class ClientGetJobResponseTypeDef(_ClientGetJobResponseTypeDef):
    """
    Type definition for `ClientGetJob` `Response`

    - **Job** *(dict) --* Each job converts an input file into an output file or files. For more
    information, see the User Guide at
    http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

      - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
      with long, visually complex content.

        - **Mode** *(string) --* Specify the conditions when the service will run your job with
        accelerated transcoding.

      - **AccelerationStatus** *(string) --* Describes whether the current job is running with
      accelerated transcoding. For jobs that have Acceleration (AccelerationMode) set to DISABLED,
      AccelerationStatus is always NOT_APPLICABLE. For jobs that have Acceleration
      (AccelerationMode) set to ENABLED or PREFERRED, AccelerationStatus is one of the other states.
      AccelerationStatus is IN_PROGRESS initially, while the service determines whether the input
      files and job settings are compatible with accelerated transcoding. If they are,
      AcclerationStatus is ACCELERATED. If your input files and job settings aren't compatible with
      accelerated transcoding, the service either fails your job or runs it without accelerated
      transcoding, depending on how you set Acceleration (AccelerationMode). When the service runs
      your job without accelerated transcoding, AccelerationStatus is NOT_ACCELERATED.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **BillingTagsSource** *(string) --* Optional. Choose a tag type that AWS Billing and Cost
      Management will use to sort your AWS Elemental MediaConvert costs on any billing report that
      you set up. Any transcoding outputs that don't have an associated tag will appear in your
      billing report unsorted. If you don't choose a valid value for this field, your job outputs
      will appear on the billing report unsorted.

      - **CreatedAt** *(datetime) --* The time, in Unix epoch format in seconds, when the job got
      created.

      - **CurrentPhase** *(string) --* A job's phase can be PROBING, TRANSCODING OR UPLOADING

      - **ErrorCode** *(integer) --* Error code for the job

      - **ErrorMessage** *(string) --* Error message of Job

      - **Id** *(string) --* A portion of the job's ARN, unique within your AWS Elemental
      MediaConvert resources

      - **JobPercentComplete** *(integer) --* An estimate of how far your job has progressed. This
      estimate is shown as a percentage of the total time from when your job leaves its queue to
      when your output files appear in your output Amazon S3 bucket. AWS Elemental MediaConvert
      provides jobPercentComplete in CloudWatch STATUS_UPDATE events and in the response to GetJob
      and ListJobs requests. The jobPercentComplete estimate is reliable for the following input
      containers: Quicktime, Transport Stream, MP4, and MXF. For some jobs, the service can't
      provide information about job progress. In those cases, jobPercentComplete returns a null
      value.

      - **JobTemplate** *(string) --* The job template that the job is created from, if it is
      created from a job template.

      - **Messages** *(dict) --* Provides messages from the service about jobs that you have already
      successfully submitted.

        - **Info** *(list) --* List of messages that are informational only and don't indicate a
        problem with your job.

          - *(string) --*

        - **Warning** *(list) --* List of messages that warn about conditions that might cause your
        job not to run or to fail.

          - *(string) --*

      - **OutputGroupDetails** *(list) --* List of output group details

        - *(dict) --* Contains details about the output groups specified in the job settings.

          - **OutputDetails** *(list) --* Details about the output

            - *(dict) --* Details regarding output

              - **DurationInMs** *(integer) --* Duration in milliseconds

              - **VideoDetails** *(dict) --* Contains details about the output's video stream

                - **HeightInPx** *(integer) --* Height in pixels for the output

                - **WidthInPx** *(integer) --* Width in pixels for the output

      - **Priority** *(integer) --* Relative priority on the job.

      - **Queue** *(string) --* Optional. When you create a job, you can specify a queue to send it
      to. If you don't specify, the job will go to the default queue. For more about queues, see the
      User Guide topic at http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

      - **RetryCount** *(integer) --* The number of times that the service automatically attempted
      to process your job after encountering an error.

      - **Role** *(string) --* The IAM role you use for creating this job. For details about
      permissions, see the User Guide topic at the User Guide at
      http://docs.aws.amazon.com/mediaconvert/latest/ug/iam-role.html

      - **Settings** *(dict) --* JobSettings contains all the transcode settings for a job.

        - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
        the input Ad Avail PTS time.

        - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
        overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

          - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
          black. Only bmp and png images are supported.

        - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

          - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
          ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
          uses the manifest conditioning instructions that you provide in the setting MCC XML
          (mccXml).

            - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
            document inside your JSON job settings. Form the XML document as per
            OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning
            instructions in the message that you supply.

          - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
          between the SCTE 35 messages that the transcoder places and the splice points that they
          refer to. If the time between the start of the asset and the SCTE-35 message is less than
          this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

          - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
          SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
          signal processing instructions that you provide in the setting SCC XML (sccXml).

            - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
            inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025.
            The transcoder will use the signal processing instructions in the message that you
            supply. Provide your ESAM SignalProcessingNotification XML document inside your JSON job
            settings. For your MPEG2-TS file outputs, if you want the service to place SCTE-35
            markers at the insertion points you specify in the XML document, you must also enable
            SCTE-35 ESAM (scte35Esam). Note that you can either specify an ESAM XML document or
            enable SCTE-35 passthrough. You can't do both.

        - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode
        job. There can be multiple inputs add in a job. These inputs will be concantenated together
        to create the output.

          - *(dict) --* Specifies media input

            - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input
            to combine. An input may have multiple audio selector groups. See "Audio Selector
            Group":#inputs-audio_selector_group for more information.

              - *(string) --*

                - *(dict) --* Group of Audio Selectors

                  - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same
                  input to include in the group. Audio selector names are standardized, based on
                  their order within the input (e.g., "Audio Selector 1"). The audio selector name
                  parameter can be repeated to add any number of audio selectors to the group.

                    - *(string) --*

            - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
            or set of tracks from the input that you will use in your outputs. You can use mutiple
            Audio selectors per input.

              - *(string) --*

                - *(dict) --* Selector for Audio

                  - **CustomLanguageCode** *(string) --* Selects a specific language code from
                  within an audio source, using the ISO 639-2 or ISO 639-3 three-letter language
                  code

                  - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                  set it as the default for the job. The service uses this default for outputs where
                  it can't find the specified input audio. If you don't set a default, those outputs
                  have no audio.

                  - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                  file source.

                  - **LanguageCode** *(string) --* Selects a specific language code from within an
                  audio source.

                  - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                  audio from the input video.

                  - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g.
                  257 selects PID 0x101).

                    - *(integer) --*

                  - **ProgramSelection** *(integer) --* Use this setting for input streams that
                  contain Dolby E, to have the service extract specific program data from the track.
                  To select multiple programs, create multiple selectors with the same Track and
                  different Program numbers. In the console, this setting is visible when you set
                  Selector type to Track. Choose the program number from the dropdown list. If you
                  are sending a JSON file, provide the program ID, which is part of the audio
                  metadata. If your input file has incorrect metadata, you can choose All channels
                  instead of a program number to have the service ignore the program IDs and include
                  all the programs in the track.

                  - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels
                  of one input to match those of another input. This allows you to combine the two
                  files into a single output, one after the other.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **SelectorType** *(string) --* Specifies the type of the audio selector.

                  - **Tracks** *(list) --* Identify a track from the input audio to include in this
                  selector by entering the track index number. To include several tracks in a single
                  audio selector, specify multiple tracks as follows. Using the console, enter a
                  comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                  Specifying directly in your JSON job file, provide the track numbers in an array.
                  For example, "tracks": [1,2,3].

                    - *(integer) --*

            - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
            the captions data from the input that you will use in your outputs. You can use mutiple
            captions selectors per input.

              - *(string) --*

                - *(dict) --* Set up captions in your outputs by first selecting them from your
                input here.

                  - **CustomLanguageCode** *(string) --* The specific language to extract from
                  source, using the ISO 639-2 or ISO 639-3 three-letter language code. If input is
                  SCTE-27, complete this field and/or PID to select the caption language to extract.
                  If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or
                  PID to select the caption language to extract. If input is DVB-Sub that is being
                  passed through, omit this field (and PID field); there is no way to extract a
                  specific language with pass-through captions.

                  - **LanguageCode** *(string) --* The specific language to extract from source. If
                  input is SCTE-27, complete this field and/or PID to select the caption language to
                  extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this
                  field and/or PID to select the caption language to extract. If input is DVB-Sub
                  that is being passed through, omit this field (and PID field); there is no way to
                  extract a specific language with pass-through captions.

                  - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                  SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                  your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                  FileSoureSettings.

                    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions
                    source.

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                      number in the ancillary data track from which to extract captions. Unused for
                      passthrough.

                      - **TerminateCaptions** *(string) --* By default, the service terminates any
                      unterminated captions at the end of each input. If you want the caption to
                      continue onto your next input, disable this setting.

                    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                      PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub
                      content is passed through, regardless of selectors.

                    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel
                      number within the video track from which to extract captions. Unused for
                      passthrough.

                      - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                      for extracting captions. The system only supports one input video track, so
                      this should always be set to '1'.

                      - **TerminateCaptions** *(string) --* By default, the service terminates any
                      unterminated captions at the end of each input. If you want the caption to
                      continue onto your next input, disable this setting.

                    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                    STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption
                    source file. If your caption source is IMSC in an IMF package, use
                    TrackSourceSettings instead of FileSoureSettings.

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **SourceFile** *(string) --* External caption file used for loading
                      captions. Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt',
                      'xml', and 'smi'.

                      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                      captions from the source file.

                    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                    your input captions. The service cannot auto-detect caption format.

                    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                    sources, including Page number.

                      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                      three-digit hexadecimal page number that will be used for Teletext captions.
                      Do not use this setting if you are passing through teletext from the input
                      source to output.

                    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                    are specified by track number. Currently, this is only IMSC captions in an IMF
                    package. If your caption source is IMSC 1.1 in a separate xml file, use
                    FileSourceSettings instead of TrackSourceSettings.

                      - **TrackNumber** *(integer) --* Use this setting to select a single captions
                      track from a source. Track numbers correspond to the order in the captions
                      source file. For IMF sources, track numbering is based on the order that the
                      captions appear in the CPL. For example, use 1 to select the captions asset
                      that is listed first in the CPL. To include more than one captions track in
                      your job outputs, create multiple input captions selectors. Specify one track
                      per selector.

            - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
            service will include in the output video frame. If you specify a value here, it will
            override any value that you specify in the output setting Cropping selection (crop).

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce
            smoother motion in the output. Default is disabled. Only manaully controllable for MPEG2
            and uncompressed video inputs.

            - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
            encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when
            you use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt
            your content.

              - **DecryptionMode** *(string) --* Specify the encryption mode that you used to
              encrypt your input files.

              - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key
              in plaintext. Your job settings could be intercepted, making your encrypted content
              vulnerable. Specify the encrypted version of the data key that you used to encrypt
              your content. The data key must be encrypted by AWS Key Management Service (KMS). The
              key can be 128, 192, or 256 bits.

              - **InitializationVector** *(string) --* Specify the initialization vector that you
              used when you encrypted your content before uploading it to Amazon S3. You can use a
              16-byte initialization vector with any encryption mode. Or, you can use a 12-byte
              initialization vector with GCM or CTR. MediaConvert accepts only initialization
              vectors that are base64-encoded.

              - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
              (KMS) that you used to encrypt your data key, if that Region is different from the one
              you are using for AWS Elemental MediaConvert.

            - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise
            from the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and
            uncompressed video inputs.

            - **FileInput** *(string) --* Specify the source file for your transcoding job. You can
            use multiple inputs in a single job. The service concatenates these inputs, in the order
            that you specify them in the job, to create the outputs. If your input format is IMF,
            specify your input by providing the path to your CPL. For example,
            "s3://bucket/vf/cpl.xml". If the CPL is in an incomplete IMP, make sure to use
            *Supplemental IMPs* (SupplementalImps) to specify any supplemental IMPs that contain
            assets referenced by the CPL.

            - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how
            the transcoding service applies the denoise and deblock filters. You must also enable
            the filters separately, with Denoise (InputDenoiseFilter) and Deblock
            (InputDeblockFilter). * Auto - The transcoding service determines whether to apply
            filtering, depending on input type and quality. * Disable - The input is not filtered.
            This is true even if you use the API to enable them in (InputDeblockFilter) and
            (InputDeblockFilter). * Force - The in put is filtered regardless of input type.

            - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
            magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
            is 0.

            - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
            overlay on your video. Enable or disable this feature for each input individually. This
            setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
            that together specify a portion of the input to be used in the outputs. If you provide
            only a start time, the clip will be the entire input from that point to the end. If you
            provide only an end time, it will be the entire input up to that point. When you specify
            more than one input clip, the transcoding service creates the job outputs by stringing
            the clips together in the order you specify them.

              - *(dict) --* To transcode only portions of your input (clips), include one Input
              clipping (one instance of InputClipping in the JSON job file) for each input clip. All
              input clips you specify will be included in every output of the job.

                - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
                portion of the input you are clipping. The frame corresponding to the End timecode
                value is included in the clip. Start timecode or End timecode may be left blank, but
                not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
                minute, SS is the second, and FF is the frame number. When choosing this value, take
                into account your setting for timecode source under input settings
                (InputTimecodeSource). For example, if you have embedded timecodes that start at
                01:00:00:00 and you want your clip to end six minutes into the video, use
                01:06:00:00.

                - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the
                beginning of the portion of the input you are clipping. The frame corresponding to
                the Start timecode value is included in the clip. Start timecode or End timecode may
                be left blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is
                the hour, MM is the minute, SS is the second, and FF is the frame number. When
                choosing this value, take into account your setting for Input timecode source. For
                example, if you have embedded timecodes that start at 01:00:00:00 and you want your
                clip to begin five minutes into the video, use 01:05:00:00.

            - **Position** *(dict) --* Use Selection placement (position) to define the video area
            in your output frame. The area outside of the rectangle that you specify here is black.
            If you specify a value here, it will override any value that you specify in the output
            setting Selection placement (position). If you specify a value here, this will override
            any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
            (RESPOND). If you specify a value here, this will ignore anything that you specify for
            the setting Scaling Behavior (scalingBehavior).

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
            program from within a multi-program transport stream. Note that Quad 4K is not currently
            supported. Default is the first program within the transport stream. If the program you
            specify doesn't exist, the transcoding service will use this default.

            - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
            inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs
            for audio and video. * Use PSI - Scan only PSI data.

            - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs.
            You need supplemental IMPs if the CPL that you're using for your input is in an
            incomplete IMP. Specify either the supplemental IMP directories with a trailing slash or
            the ASSETMAP.xml files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"].
            You don't need to specify the IMP that contains your input CPL, because the service
            automatically detects it.

              - *(string) --*

            - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
            input settings (InputTimecodeSource), to specify how the service counts input video
            frames. This input frame count affects only the behavior of features that apply to a
            single input at a time, such as input clipping and synchronizing some captions formats.
            Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at
            zero (ZEROBASED) to start the first frame at zero. Choose Specified start
            (SPECIFIEDSTART) to start the first frame at the timecode that you specify in the
            setting Start timecode (timecodeStart). If you don't specify a value for Timecode
            source, the service will use Embedded by default. For more information about timecodes,
            see https://docs.aws.amazon.com/console/mediaconvert/timecode.

            - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
            for this input's initial frame. To use this setting, you must set the Timecode source
            setting, located under the input settings (InputTimecodeSource), to Specified start
            (SPECIFIEDSTART). For more information about timecodes, see
            https://docs.aws.amazon.com/console/mediaconvert/timecode.

            - **VideoSelector** *(dict) --* Selector for video.

              - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
              animation. Specify which part of this input MediaConvert uses for your outputs. Leave
              this setting set to DISCARD in order to delete the alpha channel and preserve the
              video. Use REMAP_TO_LUMA for this setting to delete the video and map the alpha
              channel to the luma channel of your outputs.

              - **ColorSpace** *(string) --* If your input video has accurate color space metadata,
              or if you don't know about color space, leave this set to the default value Follow
              (FOLLOW). The service will automatically detect your input color space. If your input
              video has metadata indicating the wrong color space, specify the accurate color space
              here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color
              Volume static metadata isn't present in your video stream, or if that metadata is
              present but not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct
              values in the input HDR 10 metadata (Hdr10Metadata) settings. For more information
              about MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the
              input file and the job input settings Color space (ColorSpace) and HDR master display
              information settings(Hdr10Metadata). The Color space usage setting determines which
              takes precedence. Choose Force (FORCE) to use color metadata from the input job
              settings. If you don't specify values for those settings, the service defaults to
              using metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color
              metadata from the source when it is present. If there's no color metadata in your
              input file, the service defaults to using values you specify in the input settings.

              - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
              missing or inaccurate in your input video. Appropriate values vary depending on the
              input video and must be provided by a color grader. The color grader generates these
              values during the HDR 10 mastering process. The valid range for each of these settings
              is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
              settings - When you specify these values, you must also set Color space (ColorSpace)
              to HDR 10 (HDR10). To specify whether the the values you specify here take precedence
              over the values in the metadata of your input file, set Color space usage
              (ColorSpaceUsage). To specify whether color metadata is included in an output, set
              Color metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
              https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input
              file. Specify this value as an integer; the system automatically converts it to the
              hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
              an identifier for a set of data in an MPEG-2 transport stream container.

              - **ProgramNumber** *(integer) --* Selects a specific program from within a
              multi-program transport stream. Note that Quad 4K is not currently supported.

              - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
              your video. You can choose automatic rotation or specify a rotation. You can specify a
              clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is
              .mov or .mp4 and your input has rotation metadata, you can choose Automatic to have
              the service rotate your video according to the rotation specified in the metadata. The
              rotation must be within one degree of 90, 180, or 270 degrees. If the rotation
              metadata specifies any other rotation, the service will default to no rotation. By
              default, the service does no rotation, even if your input video has rotation metadata.
              The service doesn't pass through rotation metadata.

        - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The
        motion graphics that you specify here appear on all outputs in all output groups.

          - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
          unspecified. If your motion graphic asset is a series of .png files, specify the frame
          rate of the overlay in frames per second, as a fraction. For example, specify 24 fps as
          24/1. Make sure that the number of images in your series matches the frame rate and your
          intended overlay duration. For example, if you want a 30-second overlay at 30 fps, you
          should have 900 .png images. This overlay frame rate doesn't need to match the frame rate
          of the underlying video.

            - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
            overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

            - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
            overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

          - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
          overlay on your video. For .png files, provide the file name of the first file in the
          series. Make sure that the names of the .png files end with sequential numbers that
          specify the order that they are played in. For example, overlay_000.png, overlay_001.png,
          overlay_002.png, and so on. The sequence must start at zero, and each image file name must
          have the same number of digits. Pad your initial file names with enough zeros to complete
          the sequence. For example, if the first image is overlay_0.png, there can be only 10
          images in the sequence, with the last image being overlay_9.png. But if the first image is
          overlay_00.png, there can be 100 images in the sequence.

          - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
          providing for your overlay. You can choose either a .mov file or a series of .png files.

          - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic
          overlay on the video frame. Specify in pixels, from the upper-left corner of the frame. If
          you don't specify an offset, the service scales your overlay to the full size of the
          frame. Otherwise, the service inserts the overlay at its native resolution and scales the
          size up or down with any video scaling.

            - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the
            left edge of the video frame.

            - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
            edge of the video frame.

          - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
          or plays only once.

          - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
          (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
          account how you have set up your timecode configuration under both job settings and input
          settings. The simplest way to do that is to set both to start at 0. If you need to set up
          your job to follow timecodes embedded in your source that don't start at zero, make sure
          that you specify a start time that is after the first embedded timecode. For more
          information, see
          https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide
          and input timecode configuration settings in your JSON job settings specification at
          settings>timecodeConfig>source and settings>inputs>timecodeSource.

        - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
        do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
        configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all
        outputs in the job. To enable Nielsen configuration programmatically, include an instance of
        nielsenConfiguration in your JSON job specification. Even if you don't include any children
        of nielsenConfiguration, you still enable the setting.

          - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
          functionality. If you must include this property, set the value to zero.

          - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
          distributor ID that is assigned to your organization by Neilsen.

        - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
        outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS,
        Quicktime, MXF, and no container) are grouped in a single output group as well. Required in
        (OutputGroups) is a group of settings that apply to the whole group. This required object
        depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
        settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
        HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
        MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

          - *(dict) --* Group of outputs

            - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
            the output group. This value is displayed on the console and can make your job settings
            JSON more human-readable. It does not affect your outputs. Use up to twelve characters
            that are either letters, numbers, spaces, or underscores.

            - **Name** *(string) --* Name of the output group

            - **OutputGroupSettings** *(dict) --* Output Group settings, including type

              - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
              Output Group may only contain a single video, audio, or caption output.

                - **AdditionalManifests** *(list) --* By default, the service creates one top-level
                .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group
                in your job. These default manifests reference every output in the output group. To
                create additional top-level manifests that reference a subset of the outputs in the
                output group, specify a list of them here. For each additional manifest that you
                specify, the service creates one HLS manifest and one DASH manifest.

                  - *(dict) --* Specify the details for each pair of HLS and DASH additional
                  manifests that you want the service to generate for this CMAF output group. Each
                  pair of manifests can reference a different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your HLS group is film-name.m3u8. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                    specify a manifestNameModifier that is different from the nameModifier of the
                    output. The service uses the output name modifier to create unique names for the
                    individual variant manifests.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                file at the top level BaseURL element. Can be used if streams are delivered from a
                different URL than the manifest file.

                - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
                which prevents client from saving media segments for later replay.

                - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
                RFC-4281) during m3u8 playlist generation.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* DRM settings.

                  - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                  value represented by a 32-character text string. If this parameter is not set then
                  the Initialization Vector will follow the segment number by default.

                  - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want
                  the service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                  (SAMPLE-AES) or AES_CTR (AES-CTR).

                  - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                  outputs, choose whether the service writes the 128-bit encryption initialization
                  vector in the HLS and DASH manifests.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                  settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                  output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                  settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                    signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                    package. The DASH manifest can currently signal up to three system IDs. For more
                    information, see https://dashif.org/identifiers/content_protection/.

                      - *(string) --*

                    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                    signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                    package. The HLS manifest can currently signal only one system ID. For more
                    information, see https://dashif.org/identifiers/content_protection/.

                      - *(string) --*

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                  - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                  static key provider.

                    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                    the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                    omitted to indicate an implicit value of 'identity'.

                    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                    single positive integer version value or a slash delimited list of version
                    values (1/2/3).

                    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                    32-character hexidecimal string to specify Key Value (StaticKeyValue).

                    - **Url** *(string) --* Relates to DRM implementation. The location of the
                    license server used for protecting content.

                  - **Type** *(string) --* Specify whether your DRM encryption key is static or from
                  a key provider that follows the SPEKE standard. For more information about SPEKE,
                  see https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                Fragment length must be compatible with GOP size and Framerate. Note that fragments
                will end on the next keyframe after this number of seconds, so actual fragment
                length may be longer. When Emit Single File is checked, the fragmentation is
                internal to a single output file and it does not cause the creation of many output
                files as in other output types.

                - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                should use floating point values for segment duration.

                - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
                needed to ensure smooth playout.

                - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                0, unless you are troubleshooting a problem with how devices play back the end of
                your video asset. If you know that player devices are hanging on the final segment
                of your video because the length of your final segment is too short, use this
                setting to specify a minimum final segment length, in seconds. Choose a value that
                is greater than or equal to 1 and less than your segment length. When you specify a
                value for this setting, the encoder will combine any final segment that is shorter
                than the length that you specify with the previous segment. For example, your
                segment length is 3 seconds and your final segment is .5 seconds without a minimum
                final segment length; when you set the minimum final segment length to 1, your final
                segment is 3.5 seconds.

                - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                main. When you choose Main profile (MAIN_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                On-demand (ON_DEMAND_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
                you must also set the output group setting Segment control (SegmentControl) to
                Single file (SINGLE_FILE).

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
                generated, which is internally segmented using the Fragment Length and Segment
                Length. When set to SEGMENTED_FILES, separate segment files will be created.

                - **SegmentLength** *(integer) --* Use this setting to specify the length, in
                seconds, of each individual CMAF segment. This value applies to the whole package;
                that is, to every output in the output group. Note that segments end on the first
                keyframe after this number of seconds, so the actual segment length might be
                slightly longer. If you set Segment control (CmafSegmentControl) to single file, the
                service puts the content of each output in a single file that has metadata that
                marks these segments. If you set it to segmented files, the service creates multiple
                files for each output, each with the content of one segment.

                - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
                video in EXT-X-STREAM-INF tag of variant manifest.

                - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will
                be generated for this output.

                - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
                be generated for this output.

              - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

                - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
                manifest for each DASH ISO output group in your job. This default manifest
                references every output in the output group. To create additional DASH manifests
                that reference a subset of the outputs in the output group, specify a list of them
                here.

                  - *(dict) --* Specify the details for each additional DASH manifest that you want
                  the service to generate for this output group. Each manifest can reference a
                  different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your DASH group is film-name.mpd. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.mpd.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
                from a different URL than the manifest file.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* DRM settings.

                  - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                  compatibility of your output with video players on obsolete devices. It applies
                  only to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI
                  (UNENCRYPTED_SEI) only to correct problems with playback on older devices.
                  Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose Unencrypted
                  SEI, for that output, the service will exclude the access unit delimiter and will
                  leave the SEI NAL units unencrypted.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                Fragment length must be compatible with GOP size and Framerate. Note that fragments
                will end on the next keyframe after this number of seconds, so actual fragment
                length may be longer. When Emit Single File is checked, the fragmentation is
                internal to a single output file and it does not cause the creation of many output
                files as in other output types.

                - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

                - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
                needed to ensure smooth playout.

                - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                main. When you choose Main profile (MAIN_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                On-demand (ON_DEMAND_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
                you must also set the output group setting Segment control (SegmentControl) to
                Single file (SINGLE_FILE).

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
                generated, which is internally segmented using the Fragment Length and Segment
                Length. When set to SEGMENTED_FILES, separate segment files will be created.

                - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds).
                Note that segments will end on the next keyframe after this number of seconds, so
                actual segment length may be longer. When Emit Single File is checked, the
                segmentation is internal to a single output file and it does not cause the creation
                of many output files as in other output types.

                - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
                the 400 range when you play back your DASH output, enable this setting and run your
                transcoding job again. When you enable this setting, the service writes precise
                segment durations in the DASH manifest. The segment duration information appears
                inside the SegmentTimeline element, inside SegmentTemplate at the Representation
                level. When you don't enable this setting, the service writes approximate segment
                durations in your DASH manifest.

              - **FileGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

              - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

                - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your
                Apple HLS manifest. This setting does not determine whether SCTE-35 markers appear
                in the outputs themselves.

                  - *(string) --*

                - **AdditionalManifests** *(list) --* By default, the service creates one top-level
                .m3u8 HLS manifest for each HLS output group in your job. This default manifest
                references every output in the output group. To create additional top-level
                manifests that reference a subset of the outputs in the output group, specify a list
                of them here.

                  - *(dict) --* Specify the details for each additional HLS manifest that you want
                  the service to generate for this output group. Each manifest can reference a
                  different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your HLS group is film-name.m3u8. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                    specify a manifestNameModifier that is different from the nameModifier of the
                    output. The service uses the output name modifier to create unique names for the
                    individual variant manifests.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each
                output in the media .m3u8 file. Can be used if base manifest is delivered from a
                different URL than the main .m3u8 file.

                - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                  - *(dict) --* Caption Language Mapping

                    - **CaptionChannel** *(integer) --* Caption channel.

                    - **CustomLanguageCode** *(string) --* Specify the language for this captions
                    channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                    three-letter code listed at
                    https://www.loc.gov/standards/iso639-2/php/code_list.php.

                    - **LanguageDescription** *(string) --* Caption language description.

                - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
                captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least
                one language in the CC1 Language Code field. One CLOSED-CAPTION line is added for
                each Language Code you specify. Make sure to specify the languages in the order in
                which they appear in the original source (if the source is embedded format) or the
                order of the caption selectors (if the source is other than embedded). Otherwise,
                languages in the manifest will not match up properly with the output captions. None:
                Include CLOSED-CAPTIONS=
                    NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS
                line from the manifest.

                - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
                which prevents client from saving media segments for later replay.

                - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
                RFC-4281) during m3u8 playlist generation.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **DirectoryStructure** *(string) --* Indicates whether segments should be placed
                in subdirectories.

                - **Encryption** *(dict) --* DRM settings.

                  - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                  value represented by a 32-character text string. If this parameter is not set then
                  the Initialization Vector will follow the segment number by default.

                  - **EncryptionMethod** *(string) --* Encrypts the segments with the given
                  encryption scheme. Leave blank to disable. Selecting 'Disabled' in the web
                  interface also disables encryption.

                  - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                  128-bit number used in conjunction with the key for encrypting blocks. If set to
                  INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                  Vector is not in the manifest.

                  - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                  EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                  HLS FairPlay content protection.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                  - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                  static key provider.

                    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                    the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                    omitted to indicate an implicit value of 'identity'.

                    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                    single positive integer version value or a slash delimited list of version
                    values (1/2/3).

                    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                    32-character hexidecimal string to specify Key Value (StaticKeyValue).

                    - **Url** *(string) --* Relates to DRM implementation. The location of the
                    license server used for protecting content.

                  - **Type** *(string) --* Specify whether your DRM encryption key is static or from
                  a key provider that follows the SPEKE standard. For more information about SPEKE,
                  see https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                should use floating point values for segment duration.

                - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                0, unless you are troubleshooting a problem with how devices play back the end of
                your video asset. If you know that player devices are hanging on the final segment
                of your video because the length of your final segment is too short, use this
                setting to specify a minimum final segment length, in seconds. Choose a value that
                is greater than or equal to 1 and less than your segment length. When you specify a
                value for this setting, the encoder will combine any final segment that is shorter
                than the length that you specify with the previous segment. For example, your
                segment length is 3 seconds and your final segment is .5 seconds without a minimum
                final segment length; when you set the minimum final segment length to 1, your final
                segment is 3.5 seconds.

                - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
                looking ahead and back within the specified range for a nearby avail and extending
                the segment size if needed.

                - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
                be generated for this HLS output group.

                - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
                in .m3u8 manifest files. The value is calculated as follows: either the program date
                and time are initialized using the input timecode source, or the time is initialized
                using the input timecode source and the date is initialized using the
                timestamp_offset.

                - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
                EXT-X-PROGRAM-DATE-TIME entry, in seconds.

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a
                single media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for
                playback.

                - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
                create (in seconds). Note that segments will end on the next keyframe after this
                number of seconds, so actual segment length may be longer.

                - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
                subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
                for this setting to have an effect.

                - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
                video in EXT-X-STREAM-INF tag of variant manifest.

                - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

                - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

                - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
                offset to fine tune the timestamps.

              - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

                - **AdditionalManifests** *(list) --* By default, the service creates one .ism
                Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
                in your job. This default manifest references every output in the output group. To
                create additional manifests that reference a subset of the outputs in the output
                group, specify a list of them here.

                  - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                  manifest that you want the service to generate for this output group. Each
                  manifest can reference a different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your Microsoft Smooth group is film-name.ismv. If you
                    enter "-no-premium" for this setting, then the file name the service generates
                    for this top-level manifest is film-name-no-premium.ismv.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
                audio encoding settings across a Microsoft Smooth output group into a single audio
                stream.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* If you are using DRM, set DRM System
                (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
                the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
                and frame rate.

                - **ManifestEncoding** *(string) --* Use Manifest encoding
                (MsSmoothManifestEncoding) to specify the encoding format for the server and client
                manifest. Valid options are utf8 and utf16.

              - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
              Microsoft Smooth Streaming, CMAF)

            - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
            settings per output.

              - *(dict) --* An output object describes the settings for a single output file or
              stream in an output group.

                - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
                encoding settings organized by audio codec. Include one instance of
                (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
                encoding settings.

                  - *(dict) --* Description of audio output

                    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                    settings. Ignore these settings unless you need to comply with a loudness
                    standard.

                      - **Algorithm** *(string) --* Choose one of the following audio normalization
                      algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated
                      average loudness for an entire piece of content, suitable for measurement of
                      short-form content under ATSC recommendation A/85. Supports up to 5.1 audio
                      channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
                      loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
                      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement
                      algorithm as 1770-2, with an updated true peak measurement. ITU-R BS.1770-4:
                      Higher channel count. Allows for more audio channels than the other
                      algorithms, including configurations such as 7.1.

                      - **AlgorithmControl** *(string) --* When enabled the output audio is
                      corrected using the chosen algorithm. If disabled, the audio will be measured
                      but not adjusted.

                      - **CorrectionGateLevel** *(integer) --* Content measuring above this level
                      will be corrected to the target level. Content measuring below this level will
                      not be corrected. Gating only applies when not using real_time_correction.

                      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio
                      track loudness to a CSV file.

                      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                      TruePeak for each output's audio track loudness.

                      - **TargetLkfs** *(float) --* When you use Audio normalization
                      (AudioNormalizationSettings), optionally use this setting to specify a target
                      loudness. If you don't specify a value here, the encoder chooses a value for
                      you, based on the algorithm that you choose for Algorithm (algorithm). If you
                      choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                      encoder will choose -23 LKFS.

                    - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                    input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector
                    by name based on its order within each input. For example if you specify "Audio
                    Selector 3", then the third audio selector will be used from each input. If an
                    input does not have an "Audio Selector 3", then the audio selector marked as
                    "default" in that input will be used. If there is no audio selector marked as
                    "default", silence will be inserted for the duration of that input.
                    Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may
                    be specified, with similar default/silence behavior. If no audio_source_name is
                    specified, then "Audio Selector 1" will be chosen automatically.

                    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                    unchecked (false). A number between 0 and 255. The following are defined in
                    ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                         Hearing Impaired, 3 =
                    Visually Impaired Commentary, 4-255 = Reserved.

                    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                    contains an ISO 639 audio_type, then that value is passed through to the output.
                    If the input contains no ISO 639 audio_type, the value in Audio Type is included
                    in the output. Otherwise the value in Audio Type is included in the output. Note
                    that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                    is set to BROADCASTER_MIXED_AD.

                    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                    (AudioDescriptions) contains the group of settings related to audio encoding.
                    The settings in this group vary depending on the value that you choose for Audio
                    codec (Codec). For each codec enum that you choose, define the corresponding
                    settings object. The following lists the codec enum, settings object pairs. *
                    AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
                    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                      - **AacSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one
                      of two mutually exclusive groups of AAC settings--VBR and CBR. To select one
                      of these modes, set the value of Bitrate control mode (rateControlMode) to
                      "VBR" or "CBR". In VBR mode, you control the audio quality with the setting
                      VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate).
                      Defaults and valid values depend on the rate control mode.

                        - **AudioDescriptionBroadcasterMix** *(string) --* Choose
                        BROADCASTER_MIXED_AD when the input contains pre-mixed main audio + audio
                        description (AD) as a stereo pair. The value for AudioType will be set to 3,
                        which signals to downstream systems that this stream contains "broadcaster
                        mixed AD". Note that the input received by the encoder must contain
                        pre-mixed audio; the encoder does not perform the mixing. When you choose
                        BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                        AudioType and FollowInputAudioType. Choose NORMAL when the input does not
                        contain pre-mixed audio + audio description (AD). In this case, the encoder
                        will use any values you provide for AudioType and FollowInputAudioType.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        The set of valid values for this setting is: 6000, 8000, 10000, 12000,
                        14000, 16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000,
                        96000, 112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000,
                        384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value
                        you set is also constrained by the values that you choose for Profile
                        (codecProfile), Bitrate control mode (codingMode), and Sample rate
                        (sampleRate). Default values depend on Bitrate control mode and Profile.

                        - **CodecProfile** *(string) --* AAC Profile.

                        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or
                        5.1 channel layout. Valid values depend on rate control mode and profile.
                        "1.0 - Audio Description (Receiver Mix)" setting receives a stereo
                        description plus control track and emits a mono AAC encode of the
                        description track, with control data emitted in the PES header as per ETSI
                        TS 101 154 Annex E.

                        - **RateControlMode** *(string) --* Rate Control Mode.

                        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                        use LATM/LOAS AAC in an output, you must choose "No container" for the
                        output container.

                        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on
                        rate control mode and profile.

                        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                        for raw or MPEG-2 Transport Stream containers.

                        - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                        rate_control_mode is VBR.

                      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AC3.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid bitrates depend on the coding mode.

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                        stream that the encoder emits. For more information about the AC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number
                        of channels.

                        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                        input audio is Dolby Digital, dialnorm will be passed through.

                        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                        adds dynamic range compression signaling to the output bitstream as defined
                        in the Dolby Digital specification.

                        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                        channel prior to encoding. Only valid with 3_2_LFE coding mode.

                        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                        metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                        this audio data. If audio was not supplied from one of these streams, then
                        the static metadata settings will be used.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                      - **AiffSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AIFF.

                        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                        sample, to choose the encoding quality for this audio track.

                        - **Channels** *(integer) --* Specify the number of channels in this output
                        audio track. Valid values are 1 and even numbers up to 64. For example, 1,
                        2, 4, 6, and so on, up to 64.

                        - **SampleRate** *(integer) --* Sample rate in hz.

                      - **Codec** *(string) --* Type of Audio codec.

                      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid values: 384k, 448k, 640k, 768k

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                        stream that the encoder emits. For more information about the EAC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                        (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence
                        to adjust loudness based on dialogue analysis.

                        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                        level for a signal with dynamic range compression.

                        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                        the audio dynamic range when compressing the audio.

                        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left only/Right only center mix (Lo/Ro center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and
                        -6.0.

                        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert
                        uses this value for downmixing. How the service uses this value depends on
                        the value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                        values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left total/Right total center mix (Lt/Rt center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and
                        -6.0.

                        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                        value -60 mutes the channel.

                        - **MeteringMode** *(string) --* Choose how the service meters the loudness
                        of your audio.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                        that must be speech before the encoder uses the measured speech loudness as
                        the overall program loudness.

                        - **StereoDownmix** *(string) --* Choose how the service does stereo
                        downmixing.

                        - **SurroundExMode** *(string) --* Specify whether your input audio has an
                        additional center rear surround channel matrix encoded into your left and
                        right surround channels.

                      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value EAC3.

                        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                        dB attenuation to the surround channels. Only used for 3/2 coding mode.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid bitrates depend on the coding mode.

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                        stream that the encoder emits. For more information about the EAC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                        number of channels.

                        - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                        channels.

                        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                        input audio is Dolby Digital Plus, dialnorm will be passed through.

                        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                        level for a signal with dynamic range compression.

                        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                        the audio dynamic range when compressing the audio.

                        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                        LFE channel is enabled

                        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                        channel prior to encoding. Only valid with 3_2_LFE coding mode.

                        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                        Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                        mutes the channel. This setting applies only if you keep the default value
                        of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                        (Eac3CodingMode). If you choose a different value for Coding mode, the
                        service ignores Left only/Right only center (loRoCenterMixLevel).

                        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                        Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                        channel. This setting applies only if you keep the default value of 3/2 - L,
                        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                        If you choose a different value for Coding mode, the service ignores Left
                        only/Right only surround (loRoSurroundMixLevel).

                        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left total/Right total center mix (Lt/Rt
                        center). MediaConvert uses this value for downmixing. How the service uses
                        this value depends on the value that you choose for Stereo downmix
                        (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                        and -60. The value -60 mutes the channel. This setting applies only if you
                        keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                        setting Coding mode (Eac3CodingMode). If you choose a different value for
                        Coding mode, the service ignores Left total/Right total center
                        (ltRtCenterMixLevel).

                        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                        surround). MediaConvert uses this value for downmixing. How the service uses
                        this value depends on the value that you choose for Stereo downmix
                        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                        value -60 mutes the channel. This setting applies only if you keep the
                        default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                        Coding mode (Eac3CodingMode). If you choose a different value for Coding
                        mode, the service ignores Left total/Right total surround
                        (ltRtSurroundMixLevel).

                        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                        metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                        this audio data. If audio was not supplied from one of these streams, then
                        the static metadata settings will be used.

                        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                        audio will be passed through if it is present on the input. this detection
                        is dynamic over the life of the transcode. Inputs that alternate between DD+
                        and non-DD+ content will have a consistent DD+ output as the system
                        alternates between passthrough and encoding.

                        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied
                        to the surround channels. Only used for 3/2 coding mode.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                        - **StereoDownmix** *(string) --* Choose how the service does stereo
                        downmixing. This setting only applies if you keep the default value of 3/2 -
                        L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                        (Eac3CodingMode). If you choose a different value for Coding mode, the
                        service ignores Stereo downmix (Eac3StereoDownmix).

                        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                        extra center back surround channel is matrix encoded into the left and right
                        surround channels.

                        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                        Surround is matrix encoded into the two channels.

                      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value MP2.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                        - **Channels** *(integer) --* Set Channels to specify the number of channels
                        in this output audio track. Choosing Mono in the console will give you 1
                        output channel; choosing Stereo will give you 2. In the API, valid values
                        are 1 and 2.

                        - **SampleRate** *(integer) --* Sample rate in hz.

                      - **WavSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value WAV.

                        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                        sample, to choose the encoding quality for this audio track.

                        - **Channels** *(integer) --* Specify the number of channels in this output
                        audio track. Valid values are 1 and even numbers up to 64. For example, 1,
                        2, 4, 6, and so on, up to 64.

                        - **Format** *(string) --* The service defaults to using RIFF for WAV
                        outputs. If your output audio is likely to exceed 4 GB in file size, or if
                        you otherwise need the extended support of the RF64 format, set your output
                        WAV file format to RF64.

                        - **SampleRate** *(integer) --* Sample rate in Hz.

                    - **CustomLanguageCode** *(string) --* Specify the language for this audio
                    output track. The service puts this language code into your output audio track
                    when you set Language code control (AudioLanguageCodeControl) to Use configured
                    (USE_CONFIGURED). The service also uses your specified custom language code when
                    you set Language code control (AudioLanguageCodeControl) to Follow input
                    (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                    can also use any other code in the full RFC-5646 specification. Streaming
                    outputs are those that are in one of the following output groups: CMAF, DASH
                    ISO, Apple HLS, or Microsoft Smooth Streaming.

                    - **LanguageCode** *(string) --* Indicates the language of the audio output
                    track. The ISO 639 language specified in the 'Language Code' drop down will be
                    used when 'Follow Input Language Code' is not selected or when 'Follow Input
                    Language Code' is selected but there is no ISO 639 language code specified by
                    the input.

                    - **LanguageCodeControl** *(string) --* Specify which source for language code
                    takes precedence for this audio track. When you choose Follow input
                    (FOLLOW_INPUT), the service uses the language code from the input track if it's
                    present. If there's no languge code on the input track, the service uses the
                    code that you specify in the setting Language code (languageCode or
                    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
                    service uses the language code that you specify.

                    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                      group of fields that hold the remixing value for each channel. Units are in
                      dB. Acceptable values are within the range from -60 (mute) through 6. A
                      setting of 0 passes the input channel unchanged to the output channel (no
                      attenuation or amplification).

                        - **OutputChannels** *(list) --* List of output channels

                          - *(dict) --* OutputChannel mapping settings.

                            - **InputChannels** *(list) --* List of input channels

                              - *(integer) --*

                      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                      input that you want to use in your output. With remixing, you might combine or
                      split the data in these channels, so the number of channels in your final
                      output might be different.

                      - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                      after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                    - **StreamName** *(string) --* Specify a label for this output audio stream. For
                    example, "English", "Director commentary", or "track_2". For streaming outputs,
                    MediaConvert passes this information into destination manifests for display on
                    the end-viewer's player device. For outputs in other output groups, the service
                    ignores this setting.

                - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
                captions settings. For each output that has captions, include one instance of
                (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
                settings.

                  - *(dict) --* Description of Caption output

                    - **CaptionSelectorName** *(string) --* Specifies which "Caption
                    Selector":#inputs-caption_selector to use from each input when generating
                    captions. The name should be of the format "Caption Selector ", which denotes
                    that the Nth Caption Selector will be used from each input.

                    - **CustomLanguageCode** *(string) --* Specify the language for this captions
                    output track. For most captions output formats, the encoder puts this language
                    information in the output captions metadata. If your output captions format is
                    DVB-Sub or Burn in, the encoder uses this language information when
                    automatically selecting the font script for rendering the captions text. For all
                    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                    can also use any other code in the full RFC-5646 specification. Streaming
                    outputs are those that are in one of the following output groups: CMAF, DASH
                    ISO, Apple HLS, or Microsoft Smooth Streaming.

                    - **DestinationSettings** *(dict) --* Specific settings required by destination
                    type. Note that burnin_destination_settings are not available if the source of
                    the caption data is Embedded or Teletext.

                      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                        - **Alignment** *(string) --* If no explicit x_position or y_position is
                        provided, setting alignment to centered will place the captions at the
                        bottom center of the output. Similarly, setting a left alignment will align
                        captions to the bottom left of the output. If x and y positions are given in
                        conjunction with the alignment parameter, the font will be justified (either
                        left or centered) relative to those coordinates. This option is not valid
                        for source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                        behind the captions. All burn-in and DVB-Sub font settings must match.

                        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                        background rectangle. 255 is opaque; 0 is transparent. Leaving this
                        parameter blank is equivalent to setting it to 0 (transparent). All burn-in
                        and DVB-Sub font settings must match.

                        - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                        This option is not valid for source captions that are STL, 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                        captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                        settings must match.

                        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                        default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                        - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                        script code, if the LanguageCode is not sufficient for determining the
                        script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                        "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                        font for rendering burn-in captions.

                        - **FontSize** *(integer) --* A positive integer indicates the exact font
                        size in points. Set to 0 for automatic font size selection. All burn-in and
                        DVB-Sub font settings must match.

                        - **OutlineColor** *(string) --* Specifies font outline color. This option
                        is not valid for source captions that are either 608/embedded or teletext.
                        These source settings are already pre-defined by the caption stream. All
                        burn-in and DVB-Sub font settings must match.

                        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                        option is not valid for source captions that are either 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                        the captions. All burn-in and DVB-Sub font settings must match.

                        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255
                        is opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                        setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                        match.

                        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                        must match.

                        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels above the text. All burn-in and DVB-Sub font settings
                        must match.

                        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                        in Teletext or STL formats. Specify whether the spacing between letters in
                        your captions is set by the captions grid or varies depending on letter
                        width. Choose fixed grid to conform to the spacing specified in the captions
                        file more accurately. Choose proportional to make the text easier to read if
                        the captions are closed caption.

                        - **XPosition** *(integer) --* Specifies the horizontal position of the
                        caption relative to the left side of the output in pixels. A value of 10
                        would result in the captions starting 10 pixels from the left of the output.
                        If no explicit x_position is provided, the horizontal caption position will
                        be determined by the alignment parameter. This option is not valid for
                        source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **YPosition** *(integer) --* Specifies the vertical position of the
                        caption relative to the top of the output in pixels. A value of 10 would
                        result in the captions starting 10 pixels from the top of the output. If no
                        explicit y_position is provided, the caption will be positioned towards the
                        bottom of the output. This option is not valid for source captions that are
                        STL, 608/embedded or teletext. These source settings are already pre-defined
                        by the caption stream. All burn-in and DVB-Sub font settings must match.

                      - **DestinationType** *(string) --* Specify the format for this set of
                      captions on this output. The default format is embedded without SCTE-20. Other
                      options are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext,
                      TTML, and web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                      (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
                      spec. To create a non-compliant output where the embedded captions come first,
                      choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                        - **Alignment** *(string) --* If no explicit x_position or y_position is
                        provided, setting alignment to centered will place the captions at the
                        bottom center of the output. Similarly, setting a left alignment will align
                        captions to the bottom left of the output. If x and y positions are given in
                        conjunction with the alignment parameter, the font will be justified (either
                        left or centered) relative to those coordinates. This option is not valid
                        for source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                        behind the captions. All burn-in and DVB-Sub font settings must match.

                        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                        background rectangle. 255 is opaque; 0 is transparent. Leaving this
                        parameter blank is equivalent to setting it to 0 (transparent). All burn-in
                        and DVB-Sub font settings must match.

                        - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                        This option is not valid for source captions that are STL, 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                        captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                        settings must match.

                        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                        default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                        - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                        script code, if the LanguageCode is not sufficient for determining the
                        script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                        "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                        font for rendering DVB-Sub captions.

                        - **FontSize** *(integer) --* A positive integer indicates the exact font
                        size in points. Set to 0 for automatic font size selection. All burn-in and
                        DVB-Sub font settings must match.

                        - **OutlineColor** *(string) --* Specifies font outline color. This option
                        is not valid for source captions that are either 608/embedded or teletext.
                        These source settings are already pre-defined by the caption stream. All
                        burn-in and DVB-Sub font settings must match.

                        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                        option is not valid for source captions that are either 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                        the captions. All burn-in and DVB-Sub font settings must match.

                        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255
                        is opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                        setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                        match.

                        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                        must match.

                        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels above the text. All burn-in and DVB-Sub font settings
                        must match.

                        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                        standard or for hearing impaired. Choose hearing impaired if your subtitles
                        include audio descriptions and dialogue. Choose standard if your subtitles
                        include only dialogue.

                        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                        in Teletext or STL formats. Specify whether the spacing between letters in
                        your captions is set by the captions grid or varies depending on letter
                        width. Choose fixed grid to conform to the spacing specified in the captions
                        file more accurately. Choose proportional to make the text easier to read if
                        the captions are closed caption.

                        - **XPosition** *(integer) --* Specifies the horizontal position of the
                        caption relative to the left side of the output in pixels. A value of 10
                        would result in the captions starting 10 pixels from the left of the output.
                        If no explicit x_position is provided, the horizontal caption position will
                        be determined by the alignment parameter. This option is not valid for
                        source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **YPosition** *(integer) --* Specifies the vertical position of the
                        caption relative to the top of the output in pixels. A value of 10 would
                        result in the captions starting 10 pixels from the top of the output. If no
                        explicit y_position is provided, the caption will be positioned towards the
                        bottom of the output. This option is not valid for source captions that are
                        STL, 608/embedded or teletext. These source settings are already pre-defined
                        by the caption stream. All burn-in and DVB-Sub font settings must match.

                      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                      embedded/ancillary caption outputs, including 608/708 Channel destination
                      number.

                        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                        your input captions are SCC format and your output captions are embedded in
                        the video stream. Specify a CC number for each captions channel in this
                        output. If you have two channels, choose CC numbers that aren't in the same
                        field. For example, choose 1 and 3. For more information, see
                        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                        your input captions are SCC format and you want both 608 and 708 captions
                        embedded in your output stream. Optionally, specify the 708 service number
                        for each output captions channel. Choose a different number for each
                        channel. To use this setting, also set Force 608 to 708 upconvert
                        (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
                        settings. If you choose to upconvert but don't specify a 708 service number,
                        MediaConvert uses the number that you specify for CC channel number
                        (destination608ChannelNumber) for the 708 service number. For more
                        information, see
                        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                      outputs.

                        - **StylePassthrough** *(string) --* Keep this setting enabled to have
                        MediaConvert use the font style and position information from the captions
                        source in the output. This option is available only when your input captions
                        are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                        output captions.

                      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to
                        make sure that the captions and the video are synchronized in the output.
                        Specify a frame rate that matches the frame rate of the associated video. If
                        the video frame rate is 29.97, choose 29.97 dropframe
                        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
                        drop_frame_timecode=
                            true; otherwise, choose 29.97 non-dropframe
                        (FRAMERATE_29_97_NON_DROPFRAME).

                      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                      output

                        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number
                        for the destination captions for this output. This value must be a
                        three-digit hexadecimal string; strings ending in -FF are invalid. If you
                        are passing through the entire set of Teletext data, do not use this field.

                        - **PageTypes** *(list) --* Specify the page types for this Teletext page.
                        If you don't specify a value here, the service sets the page type to the
                        default value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire
                        set of Teletext data, don't use this field. When you pass through a set of
                        Teletext pages, your output has the same page types as your input.

                          - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                          Table 94

                      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                      outputs, including Pass style information (TtmlStylePassthrough).

                        - **StylePassthrough** *(string) --* Pass through style and position
                        information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                        CFF-TT output or TTML output.

                    - **LanguageCode** *(string) --* Specify the language of this captions output
                    track. For most captions output formats, the encoder puts this language
                    information in the output captions metadata. If your output captions format is
                    DVB-Sub or Burn in, the encoder uses this language information to choose the
                    font language for rendering the captions text.

                    - **LanguageDescription** *(string) --* Specify a label for this set of output
                    captions. For example, "English", "Director commentary", or "track_2". For
                    streaming outputs, MediaConvert passes this information into destination
                    manifests for display on the end-viewer's player device. For outputs in other
                    output groups, the service ignores this setting.

                - **ContainerSettings** *(dict) --* Container specific settings.

                  - **Container** *(string) --* Container for this output. Some containers require a
                  container settings object. If not specified, the default object will be created.

                  - **F4vSettings** *(dict) --* Settings for F4v container

                    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom
                    is relocated to the beginning of the archive as required for progressive
                    downloading. Otherwise it is placed normally at the end.

                  - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to
                  outputs in a File output group when the output's container (ContainerType) is
                  MPEG-2 Transport Stream (M2TS). In these assets, data is organized by the program
                  map table (PMT). Each transport stream program contains subsets of data, including
                  audio, video, and metadata. Each of these subsets of data has a numerical label
                  called a packet identifier (PID). Each transport stream program corresponds to one
                  MediaConvert output. The PMT lists the types of data in a program along with their
                  PID. Downstream systems and players use the program map table to look up the PID
                  for each type of data it accesses and then uses the PIDs to locate specific data
                  within the asset.

                    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                    models for Dolby Digital audio.

                    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                    each PES packet.

                    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                    elementary audio streams you include in this output. Specify multiple PIDs as a
                    JSON array. Default is the range 482-492.

                      - *(integer) --*

                    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream
                    in bits per second. Setting to 0 lets the muxer automatically determine the
                    appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                    - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                    interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                    this can lead to lower latency, but low-memory devices may not be able to play
                    back the stream without interruptions.

                    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                    the specified table repetition interval.

                      - **NetworkId** *(integer) --* The numeric value placed in the Network
                      Information Table (NIT).

                      - **NetworkName** *(string) --* The network name text placed in the
                      network_name_descriptor inside the Network Information Table. Maximum length
                      is 256 characters.

                      - **NitInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                    the specified table repetition interval.

                      - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                      output stream. "Follow input SDT" copies SDT information from input stream to
                      output stream. "Follow input SDT if present" copies SDT information from input
                      stream to output stream if SDT information is present in the input, otherwise
                      it will fall back on the user-defined values. Enter "SDT Manually" means user
                      will enter the SDT information. "No SDT" means output stream will not contain
                      SDT information.

                      - **SdtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **ServiceName** *(string) --* The service name placed in the
                      service_descriptor in the Service Description Table. Maximum length is 256
                      characters.

                      - **ServiceProviderName** *(string) --* The service provider name placed in
                      the service_descriptor in the Service Description Table. Maximum length is 256
                      characters.

                    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                    subtitle data included in this output. Specify multiple PIDs as a JSON array.
                    Default is the range 460-479.

                      - *(integer) --*

                    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                    specified table repetition interval.

                      - **TdtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                    teletext data you include in this output. Default is 499.

                    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS,
                    audio EBP markers will be added to partitions 3 and 4. The interval between
                    these additional markers will be fixed, and will be slightly shorter than the
                    video EBP marker interval. When set to VIDEO_INTERVAL, these additional markers
                    will not be inserted. Only applicable when EBP segmentation markers are is
                    selected (segmentationMarkers is EBP or EBP_LEGACY).

                    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on.
                    They can either be placed only on the video PID, or on both the video PID and
                    all audio PIDs. Only applicable when EBP segmentation markers are is selected
                    (segmentationMarkers is EBP or EBP_LEGACY).

                    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                    the PES header.

                    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                    you know that your audio EBP markers are incorrectly appearing before your video
                    EBP markers. To correct this problem, set this value to Force (FORCE).

                    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                    used with EBP markers.

                    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                    between Program Clock References (PCRs) inserted into the transport stream.

                    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                    Points do not come within the specified time interval of each other by looking
                    ahead at input video. If another EBP is going to come in within the specified
                    time interval, the current EBP is not emitted, and the segment is "stretched" to
                    the next marker. The lookahead value does not add latency to the system. The
                    Live Event must be configured elsewhere to create sufficient latency to make the
                    lookahead accurate.

                    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                    tracking will be detected in the input audio and an equivalent ID3 tag will be
                    inserted in the output.

                    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                    packets to insert into the transport stream. This can be used if a downstream
                    encryption system requires periodic null packets.

                    - **PatInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                    Reference value is inserted for every Packetized Elementary Stream (PES) header.
                    This is effective only when the PCR PID is the same as the video or audio
                    elementary stream.

                    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                    clock reference (PCR) in this output. If you do not specify a value, the service
                    will use the value for Video PID (VideoPid).

                    - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                    instances of the program map table (PMT) in the output transport stream.

                    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                    map table (PMT) itself. Default is 480.

                    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of
                    the private metadata stream. Default is 503.

                    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                    the program number used in the program map table (PMT) for this output. Default
                    is 1. Program numbers and program map tables are parts of MPEG-2 transport
                    stream containers, used for organizing data.

                    - **RateMode** *(string) --* When set to CBR, inserts null packets into
                    transport stream to fill specified bitrate. When set to VBR, the bitrate setting
                    acts as the maximum bitrate, but the output will not be padded up to that
                    bitrate.

                    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                    markers in your HLS and transport stream outputs at the insertion points that
                    you specify in an ESAM XML document. Provide the document in the setting SCC XML
                    (sccXml).

                      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35
                      stream in the transport stream generated by ESAM.

                    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the
                    SCTE-35 stream in the transport stream.

                    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                    Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input
                    to also appear in this output. Choose None (NONE) if you don't want SCTE-35
                    markers in this output. For SCTE-35 markers from an ESAM XML document-- Choose
                    None (NONE). Also provide the ESAM XML as a string in the setting Signal
                    processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
                    property scte35Esam).

                    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                    segmentation_time period. rai_segstart sets the Random Access Indicator bit in
                    the adaptation field. rai_adapt sets the RAI bit and adds the current timecode
                    in the private data bytes. psi_segstart inserts PAT and PMT tables at the start
                    of segments. ebp adds Encoder Boundary Point information to the adaptation field
                    as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
                    Boundary Point information to the adaptation field using a legacy proprietary
                    format.

                    - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                    how segmentation markers are inserted into the transport stream. With avails, it
                    is possible that segments may be truncated, which can influence where future
                    segmentation markers are inserted. When a segmentation style of "reset_cadence"
                    is selected and a segment is truncated due to an avail, we will reset the
                    segmentation cadence. This means the subsequent segment will have a duration of
                    of $segmentation_time seconds. When a segmentation style of "maintain_cadence"
                    is selected and a segment is truncated due to an avail, we will not reset the
                    segmentation cadence. This means the subsequent segment will likely be truncated
                    as well. However, all segments after that will have a duration of
                    $segmentation_time seconds. Note that EBP lookahead is a slight exception to
                    this rule.

                    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                    segment. Required unless markers is set to _none_.

                    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                    timed metadata in this output. Default is 502.

                    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                    itself in the program map table for this output. Transport stream IDs and
                    program map tables are parts of MPEG-2 transport stream containers, used for
                    organizing data.

                    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                    elementary video stream in the transport stream.

                  - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                    each PES packet.

                    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                    stream(s) in the transport stream. Multiple values are accepted, and can be
                    entered in ranges and/or by comma separation.

                      - *(integer) --*

                    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                    tracking will be detected in the input audio and an equivalent ID3 tag will be
                    inserted in the output.

                    - **PatInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                    Reference value is inserted for every Packetized Elementary Stream (PES) header.
                    This parameter is effective only when the PCR PID is the same as the video or
                    audio elementary stream.

                    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock
                    Reference (PCR) in the transport stream. When no value is given, the encoder
                    will assign the same value as the Video PID.

                    - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                    (PMT) in the transport stream.

                    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                    metadata stream in the transport stream.

                    - **ProgramNumber** *(integer) --* The value of the program number field in the
                    Program Map Table.

                    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                    the transport stream.

                    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                    Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input
                    to also appear in this output. Choose None (NONE) if you don't want SCTE-35
                    markers in this output. For SCTE-35 markers from an ESAM XML document-- Choose
                    None (NONE) if you don't want manifest conditioning. Choose Passthrough
                    (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
                    conditioning. In both cases, also provide the ESAM XML as a string in the
                    setting Signal processing notification XML (sccXml).

                    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting
                    to specify whether the service inserts the ID3 timed metadata from the input in
                    this output.

                    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                    metadata stream in the transport stream.

                    - **TransportStreamId** *(integer) --* The value of the transport stream ID
                    field in the Program Map Table.

                    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                    stream in the transport stream.

                  - **MovSettings** *(dict) --* Settings for MOV Container.

                    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate
                    for the video output settings.

                    - **CslgAtom** *(string) --* When enabled, file composition times will start at
                    zero, composition times in the 'ctts' (composition time to sample) box for
                    B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                    will be included per 14496-1 amendment 1. This improves compatibility with Apple
                    players and tools.

                    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                    streams into the QuickTime file using XDCAM fourcc codes. This increases
                    compatibility with Apple editors and players, but may decrease compatibility
                    with other players. Only applicable when the video codec is MPEG2.

                    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                    padding

                    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                    this setting.

                  - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create
                  audio-only AAC outputs with this container.

                    - **CslgAtom** *(string) --* When enabled, file composition times will start at
                    zero, composition times in the 'ctts' (composition time to sample) box for
                    B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                    will be included per 14496-1 amendment 1. This improves compatibility with Apple
                    players and tools.

                    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                    moov box.

                    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom
                    is relocated to the beginning of the archive as required for progressive
                    downloading. Otherwise it is placed normally at the end.

                    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the
                    output file. Usually not necessary to specify.

                  - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                    - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                    groups that include sidecar TTML or IMSC captions. You specify sidecar captions
                    in a separate output from your audio and video. Choose Raw (RAW) for captions in
                    a single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4)
                    for captions in XML format contained within fragmented MP4 files. This set of
                    fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                    markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                    insertion points that you specify in an ESAM XML document. Provide the document
                    in the setting SCC XML (sccXml).

                    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                    markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                    SCTE-35 markers that appear in your input to also appear in this output. Choose
                    None (NONE) if you don't want those SCTE-35 markers in this output.

                - **Extension** *(string) --* Use Extension (Extension) to specify the file
                extension for outputs in File output groups. If you do not specify a value, the
                service will use default extensions by container type as follows * MPEG-2 transport
                stream, m2ts * Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No
                Container, the service will use codec extensions (e.g. AAC, H265, H265, AC3)

                - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the
                service add a string to the end of each output filename. You specify the base
                filename as part of your destination URI. When you create multiple outputs in the
                same output group, Name modifier (NameModifier) is required. Name modifier also
                accepts format identifiers. For DASH ISO outputs, if you use the format identifiers
                $Number$ or $Time$ in one output, you must use them in the same way in all outputs
                of the output group.

                - **OutputSettings** *(dict) --* Specific settings for this type of output.

                  - **HlsSettings** *(dict) --* Settings for HLS output groups

                    - **AudioGroupId** *(string) --* Specifies the group to which the audio
                    Rendition belongs.

                    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                    outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                    container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                    file in a raw container. Regardless of the value that you specify here, if this
                    output has video, the service will place the output into an MPEG2-TS container.

                    - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                    with the video output stream. Input all the audio GROUP-IDs that are associated
                    to the video, separate by ','.

                    - **AudioTrackType** *(string) --* Four types of audio-only tracks are
                    supported: Audio-Only Variant Stream The client can play back this audio-only
                    stream instead of video in low-bandwidth scenarios. Represented as an
                    EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select, Default
                    Alternate rendition that the client should try to play back by default.
                    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                        YES,
                    AUTOSELECT=
                        YES Alternate Audio, Auto Select, Not Default Alternate rendition
                    that the client may try to play back by default. Represented as an EXT-X-MEDIA
                    in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                        YES Alternate Audio, not Auto
                    Select Alternate rendition that the client will not try to play back by default.
                    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                        NO, AUTOSELECT=NO

                    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                    Manifest in addition to the HLS manifest

                    - **SegmentModifier** *(string) --* String concatenated to end of segment
                    filenames. Accepts "Format Identifiers":#format_identifier_parameters.

                - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
                transcoding settings. Provide the system or custom preset name. You can specify
                either Preset (Preset) or Container settings (ContainerSettings), but not both.

                - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
                encoding settings. The specific video settings depend on the video codec that you
                choose when you specify a value for Video codec (codec). Include one instance of
                (VideoDescription) per output.

                  - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                  MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                  service includes AFD values in the output video data and what those values are. *
                  Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                  input AFD values and instead encode the value specified in the job. * Choose Auto
                  to calculate output AFD values based on the input AFD scaler data.

                  - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to
                  all outputs. The service no longer accepts the value DISABLED for AntiAlias. If
                  you specify that in your job, the service will ignore the setting.

                  - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                  (VideoDescription), contains the group of settings related to video encoding. The
                  settings in this group vary depending on the value that you choose for Video codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * H_264,
                  H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings
                  * FRAME_CAPTURE, FrameCaptureSettings

                    - **Codec** *(string) --* Specifies the video codec. This must be equal to one
                    of the enum values defined by the object VideoCodec.

                    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                      - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                      frame of the output stream, then one frame every
                      framerateDenominator/framerateNumerator seconds. For example, settings of
                      framerateNumerator = 1 and framerateDenominator =
                           3 (a rate of 1/3 frame per
                      second) will capture the first frame, then 1 frame every 3s. Files will be
                      named as filename.n.jpg where n is the 0-based sequence number of each
                      Capture.

                      - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                      frame of the output stream, then one frame every
                      framerateDenominator/framerateNumerator seconds. For example, settings of
                      framerateNumerator = 1 and framerateDenominator =
                           3 (a rate of 1/3 frame per
                      second) will capture the first frame, then 1 frame every 3s. Files will be
                      named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number
                      zero padded to 7 decimal places.

                      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg
                      output files).

                      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                      quality.

                    - **H264Settings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value H_264.

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                      your output video settings. If you aren't sure what level to specify, choose
                      Auto (AUTO).

                      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                      are only available with the AVC-I License.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be
                      in Main or High profile) or CAVLC.

                      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                      for interlaced outputs.

                      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame to reduce flicker or 'pop' on I-frames.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job specification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* When you use the API for transcode
                      jobs that use frame rate conversion, specify the frame rate as a fraction. For
                      example, 24000 / 1001 =
                           23.976 fps. Use FramerateDenominator to specify the
                      denominator of this fraction. In this example, use 1001 for the value of
                      FramerateDenominator. When you use the console for transcode jobs that use
                      frame rate conversion, provide the value as a decimal number for Framerate. In
                      this example, specify 23.976.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                      structures that have B frames > 1.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type, as follows. - If the source is interlaced, the output will be
                      interlaced with the same polarity as the source (it will follow the source).
                      The output could therefore be a mix of "top field first" and "bottom field
                      first". - If the source is progressive, the output will be interlaced with
                      "top field first" or "bottom field first" polarity, depending on which of the
                      Follow options you chose.

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000. Required when Rate control mode is
                      QVBR.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                      The encoder may use more than requested if using B-frames and/or interlaced
                      encoding.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                      high-quality singlepass, or high-quality multipass video encoding.

                      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                      encoding with the H.264 codec. Required when you set Rate control mode to
                      QVBR. Not valid when you set Rate control mode to a value other than QVBR, or
                      when you don't define Rate control mode.

                        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                        control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                        average bitrate values suited to the complexity of your input video, the
                        service limits the average bitrate of the video part of this output to the
                        value that you choose. That is, the total size of the video element is less
                        than or equal to the value you set multiplied by the number of seconds of
                        encoded output.

                        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                        control mode. That is, when you specify qvbrSettings within h264Settings.
                        Specify the target quality level for this output, from 1 to 10. Use higher
                        numbers for greater quality. Level 10 results in nearly lossless
                        compression. The quality level for most broadcast-quality transcodes is
                        between 6 and 9.

                      - **RateControlMode** *(string) --* Use this setting to specify whether this
                      output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                      variable bitrate (QVBR).

                      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture,
                      even if repeated.

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default. If this output uses QVBR, choose Transition
                      detection (TRANSITION_DETECTION) for further video quality improvement. For
                      more information about QVBR, see
                      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                      - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                      equal to the number of macroblock rows for progressive pictures, and less than
                      or equal to half the number of macroblock rows for interlaced pictures.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                      values reduce high-frequency content in the encoded image.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                      - **Telecine** *(string) --* This field applies only if the Streams > Advanced
                      > Framerate (framerate) field is set to 29.970. This field works with the
                      Streams > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and
                      the Streams > Advanced > Interlaced Mode field (interlace_mode) to identify
                      the scan type for the output: Progressive, Interlaced, Hard Telecine or Soft
                      Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
                      23.976; the player converts this output to 29.97i.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as
                      4 bytes of an unregistered SEI message.

                    - **H265Settings** *(dict) --* Settings for H265 codec

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                      Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                      Transfer Function (EOTF).

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* H.265 Level.

                      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                      (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                      "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                      available with the HEVC 4:2:2 License.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame to reduce flicker or 'pop' on I-frames.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                      structures that have B frames > 1.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                      Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                      the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom
                      Field First (BOTTOM_FIELD) to create an output that's interlaced with the same
                      field polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or
                      Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output
                      with the same field polarity as the source. If the source is interlaced, the
                      output will be interlaced with the same polarity as the source (it will follow
                      the source). The output could therefore be a mix of "top field first" and
                      "bottom field first". If the source is progressive, your output will be
                      interlaced with "top field first" or "bottom field first" polarity, depending
                      on which of the Follow options you chose. If you don't choose a value, the
                      service will default to Progressive (PROGRESSIVE).

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000. Required when Rate control mode is
                      QVBR.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                      The encoder may use more than requested if using B-frames and/or interlaced
                      encoding.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                      high-quality singlepass, or high-quality multipass video encoding.

                      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                      encoding with the H.265 codec. Required when you set Rate control mode to
                      QVBR. Not valid when you set Rate control mode to a value other than QVBR, or
                      when you don't define Rate control mode.

                        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                        control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                        average bitrate values suited to the complexity of your input video, the
                        service limits the average bitrate of the video part of this output to the
                        value that you choose. That is, the total size of the video element is less
                        than or equal to the value you set multiplied by the number of seconds of
                        encoded output.

                        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                        control mode. That is, when you specify qvbrSettings within h265Settings.
                        Specify the target quality level for this output, from 1 to 10. Use higher
                        numbers for greater quality. Level 10 results in nearly lossless
                        compression. The quality level for most broadcast-quality transcodes is
                        between 6 and 9.

                      - **RateControlMode** *(string) --* Use this setting to specify whether this
                      output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                      variable bitrate (QVBR).

                      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                      Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                      based on content

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default. If this output uses QVBR, choose Transition
                      detection (TRANSITION_DETECTION) for further video quality improvement. For
                      more information about QVBR, see
                      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                      - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                      equal to the number of macroblock rows for progressive pictures, and less than
                      or equal to half the number of macroblock rows for interlaced pictures.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Telecine** *(string) --* This field applies only if the Streams > Advanced
                      > Framerate (framerate) field is set to 29.970. This field works with the
                      Streams > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and
                      the Streams > Advanced > Interlaced Mode field (interlace_mode) to identify
                      the scan type for the output: Progressive, Interlaced, Hard Telecine or Soft
                      Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
                      23.976; the player converts this output to 29.97i.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                      encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                      and P-frames form one layer, reference B-frames can form a second layer and
                      non-reference b-frames can form a third layer. Decoders can optionally decode
                      only the lower temporal layers to generate a lower frame rate output. For
                      example, given a bitstream with temporal IDs and with b-frames = 1 (i.e.
                      IbPbPb display order), a decoder could decode all the frames for full frame
                      rate output or only the I and P frames (lowest temporal layer) for a half
                      frame rate output.

                      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                      vertical subdivision of the encoded pictures.

                      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as
                      4 bytes of an unregistered SEI message.

                      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                      units doesn't matter in your workflow, ignore this setting. Use this setting
                      only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                      container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                      your output compliant with the following specification: ISO IECJTC1 SC29
                      N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service
                      stores parameter set NAL units in the sample headers but not in the samples
                      directly. For MP4 outputs, when you choose HVC1, your output video might not
                      work properly with some downstream systems and video players. The service
                      defaults to marking your output as HEV1. For these outputs, the service writes
                      parameter set NAL units directly into the samples.

                    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value MPEG2.

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                      level for the video output.

                      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                      MPEG-2 profile for the video output.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type. - If the source is interlaced, the output will be interlaced with
                      the same polarity as the source (it will follow the source). The output could
                      therefore be a mix of "top field first" and "bottom field first". - If the
                      source is progressive, the output will be interlaced with "top field first" or
                      "bottom field first" polarity, depending on which of the Follow options you
                      chose.

                      - **IntraDcPrecision** *(string) --* Use Intra DC precision
                      (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                      coefficients. If you choose the value auto, the service will automatically
                      select the precision based on the per-frame compression ratio.

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                      video encoding.

                      - **RateControlMode** *(string) --* Use Rate control mode
                      (Mpeg2RateControlMode) to specifiy whether the bitrate is variable (vbr) or
                      constant (cbr).

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                      values reduce high-frequency content in the encoded image.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                      356M-2001).

                      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                      Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard)
                      to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                      produce 23.976 output and leave converstion to the player.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                    - **ProresSettings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value PRORES.

                      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                      the type of Apple ProRes codec to use for this output.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* When you use the API for transcode
                      jobs that use frame rate conversion, specify the frame rate as a fraction. For
                      example, 24000 / 1001 =
                           23.976 fps. Use FramerateNumerator to specify the
                      numerator of this fraction. In this example, use 24000 for the value of
                      FramerateNumerator.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type. - If the source is interlaced, the output will be interlaced with
                      the same polarity as the source (it will follow the source). The output could
                      therefore be a mix of "top field first" and "bottom field first". - If the
                      source is progressive, the output will be interlaced with "top field first" or
                      "bottom field first" polarity, depending on which of the Follow options you
                      chose.

                      - **ParControl** *(string) --* Use (ProresParControl) to specify how the
                      service determines the pixel aspect ratio. Set to Follow source
                      (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio from the input. To
                      specify a different pixel aspect ratio: Using the console, choose it from the
                      dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide
                      for (ParNumerator) and (ParDenominator).

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                      Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard)
                      to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                      produce 23.976 output and leave converstion to the player.

                  - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to
                  include color metadata in this output. Choose Ignore (IGNORE) to exclude color
                  metadata from this output. If you don't specify a value, the service sets this to
                  Insert by default.

                  - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area
                  that the service will include in the output video frame.

                    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                    numbers.

                    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                    numbers.

                    - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                    left edge of the video frame. Specify only even numbers.

                    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                    top edge of the video frame. Specify only even numbers.

                  - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                  feature is enabled, the service will use drop-frame timecode on outputs. If it is
                  not possible to use drop-frame timecode, the system will fall back to
                  non-drop-frame. This setting is enabled by default when Timecode insertion
                  (TimecodeInsertion) is enabled.

                  - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling)
                  to Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                  service will write on all frames of this video output.

                  - **Height** *(integer) --* Use the Height (Height) setting to define the video
                  resolution height for this output. Specify in pixels. If you don't provide a value
                  here, the service will use the input height.

                  - **Position** *(dict) --* Use Selection placement (position) to define the video
                  area in your output frame. The area outside of the rectangle that you specify here
                  is black.

                    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                    numbers.

                    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                    numbers.

                    - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                    left edge of the video frame. Specify only even numbers.

                    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                    top edge of the video frame. Specify only even numbers.

                  - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                  the service changes the video itself in response to AFD values in the input. *
                  Choose Respond to clip the input video frame according to the AFD value, input
                  display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                  include the input AFD values. Do not choose this when AfdSignaling is set to
                  (NONE). A preferred implementation of this workflow is to set RespondToAfd to
                  (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
                  values from this output.

                  - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                  have a different aspect ratio from the input aspect ratio. Choose Stretch to
                  output (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit.
                  Keep the setting Default (DEFAULT) to have the service letterbox your video
                  instead. This setting overrides any value that you specify for the setting
                  Selection placement (position) in this output.

                  - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                  strength of anti-aliasing. This setting changes the width of the anti-alias filter
                  kernel used for scaling. Sharpness only applies if your output resolution is
                  different from your input resolution. 0 is the softest setting, 100 the sharpest,
                  and 50 recommended for most content.

                  - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                  ProRes outputs. Only enable Timecode insertion when the input frame rate is
                  identical to the output frame rate. To include timecodes in this output, set
                  Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                  set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                  output, by default, it uses any embedded timecodes from the input. If none are
                  present, the service will set the timecode for the first output frame to zero. To
                  change this default behavior, adjust the settings under Timecode configuration
                  (TimecodeConfig). In the console, these settings are located under Job > Job
                  settings > Timecode configuration. Note - Timecode source under input settings
                  (InputTimecodeSource) does not affect the timecodes that are inserted in the
                  output. Source under Job settings > Timecode configuration (TimecodeSource) does.

                  - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                  Preprocessors (VideoPreprocessors). Enable the features at each output
                  individually. These features are disabled by default.

                    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                    feature if necessary. Enable or disable this feature for each output
                    individually. This setting is disabled by default.

                      - **Brightness** *(integer) --* Brightness level.

                      - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                      this output. The service supports conversion between HDR formats, between SDR
                      formats, and from SDR to HDR. The service doesn't support conversion from HDR
                      to SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                      video has an HDR format, but visually appears the same as an unconverted
                      output.

                      - **Contrast** *(integer) --* Contrast level.

                      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                      10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume
                      static metadata that you want signaled in the output. These values don't
                      affect the pixel values that are encoded in the video stream. They are
                      intended to help the downstream video player display content in a way that
                      reflects the intentions of the the content creator. When you set Color space
                      conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are
                      required. You must set values for Max frame average light level
                      (maxFrameAverageLightLevel) and Max content light level
                      (maxContentLightLevel); these settings don't have a default value. The default
                      values for the other HDR 10 metadata settings are defined by the P3D65 color
                      space. For more information about MediaConvert HDR jobs, see
                      https://docs.aws.amazon.com/console/mediaconvert/hdr.

                        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                        samples in the coded video sequence, in units of candelas per square meter.
                        This setting doesn't have a default value; you must specify a value that is
                        suitable for the content.

                        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level
                        of any frame in the coded video sequence, in units of candelas per square
                        meter. This setting doesn't have a default value; you must specify a value
                        that is suitable for the content.

                        - **MaxLuminance** *(integer) --* Nominal maximum mastering display
                        luminance in units of of 0.0001 candelas per square meter.

                        - **MinLuminance** *(integer) --* Nominal minimum mastering display
                        luminance in units of of 0.0001 candelas per square meter

                        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **WhitePointX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **WhitePointY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                      - **Hue** *(integer) --* Hue in degrees.

                      - **Saturation** *(integer) --* Saturation level.

                    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce
                    smoother motion and a clearer picture.

                      - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                      (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                      adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                      (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER)
                      if your source file includes a ticker, such as a scrolling headline at the
                      bottom of the frame.

                      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                      does not convert frames that are tagged in metadata as progressive. It will
                      only convert those that are tagged as some other type. - When set to
                      FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                      those that are already tagged as progressive. Turn Force mode on only if there
                      is a good chance that the metadata has tagged frames as progressive when they
                      are not progressive. Do not turn on otherwise; processing frames that are
                      already progressive into progressive will probably result in lower quality
                      video.

                      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                      service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                      interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                      progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby
                    Vision compatible video output.

                      - **L6Metadata** *(dict) --* Use these settings when you set
                      DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                      your input with new values.

                        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                        that corresponds to the brightest pixel in the entire stream. Measured in
                        nits.

                        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                        metadata that corresponds to the highest frame-average brightness in the
                        entire stream. Measured in nits.

                      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service
                      will handle Dolby Vision MaxCLL and MaxFALL properies.

                      - **Profile** *(string) --* In the current MediaConvert implementation, the
                      Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs
                      must contain Dolby Vision frame interleaved data.

                    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter)
                    feature to include a graphic overlay on your video. Enable or disable this
                    feature for each output individually. This setting is disabled by default.

                      - **InsertableImages** *(list) --* Specify the images that you want to overlay
                      on your video. The images must be PNG or TGA files.

                        - *(dict) --* Settings that specify how your still graphic overlay appears.

                          - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                          image to remain on the output video. This duration includes fade-in time
                          but not fade-out time.

                          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                          between the Start time that you specify for the image insertion and the
                          time that the image appears at full opacity. Full opacity is the level
                          that you specify for the opacity setting. If you don't specify a value for
                          Fade-in, the image will appear abruptly at the overlay start time.

                          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                          between the end of the time that you have specified for the image overlay
                          Duration and when the overlaid image has faded to total transparency. If
                          you don't specify a value for Fade-out, the image will disappear abruptly
                          at the end of the inserted image duration.

                          - **Height** *(integer) --* Specify the height of the inserted image in
                          pixels. If you specify a value that's larger than the video resolution
                          height, the service will crop your overlaid image to fit. To use the
                          native height of the image, keep this setting blank.

                          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon
                          S3 location of the image that you want to overlay on the video. Use a PNG
                          or TGA file.

                          - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                          inserted image and the left edge of the video frame. Required for any
                          image overlay that you specify.

                          - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                          overlaid image and the top edge of the video frame. Required for any image
                          overlay that you specify.

                          - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                          Images with higher values for Layer appear on top of images with lower
                          values for Layer.

                          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                          the underlying video shows through the inserted image. 0 is transparent
                          and 100 is fully opaque. Default is 50.

                          - **StartTime** *(string) --* Specify the timecode of the frame that you
                          want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                          or HH:MM:SS;FF) format. Remember to take into account your timecode source
                          settings.

                          - **Width** *(integer) --* Specify the width of the inserted image in
                          pixels. If you specify a value that's larger than the video resolution
                          width, the service will crop your overlaid image to fit. To use the native
                          width of the image, keep this setting blank.

                    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature
                    to remove noise from your video output if necessary. Enable or disable this
                    feature for each output individually. This setting is disabled by default.

                      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                      select one of the following spatial image filtering functions. To use this
                      setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                      preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                      Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                      reduction. * Spatial does frequency-domain filtering based on JND principles.
                      * Temporal optimizes video quality for complex motion.

                      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                        - **Strength** *(integer) --* Relative strength of noise reducing filter.
                        Higher values produce stronger filtering.

                      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                      spatial filter.

                        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post
                        noise reduction sharpening filter, with 0 disabling the filter and 3
                        enabling it at maximum strength.

                        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to
                        3 (higher speed), with 0 being the nominal value.

                        - **Strength** *(integer) --* Relative strength of noise reducing filter.
                        Higher values produce stronger filtering.

                      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                      temporal filter.

                        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                        complex motion. Higher values produce stronger temporal filtering. This
                        filters highly complex scenes more aggressively and creates better VQ for
                        low bitrate outputs.

                        - **Speed** *(integer) --* The speed of the filter (higher number is
                        faster). Low setting reduces bit rate at the cost of transcode time, high
                        setting improves transcode time at the cost of bit rate.

                        - **Strength** *(integer) --* Specify the strength of the noise reducing
                        filter on this output. Higher values produce stronger filtering. We
                        recommend the following value ranges, depending on the result that you want:
                        * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
                        complexity reduction with image preservation * 8-16 for a high level of
                        complexity reduction

                    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                    output timecode and specified prefix into the output.

                      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                      any burned-in timecode. Valid values are 10, 16, 32, 48.

                      - **Position** *(string) --* Use Position (Position) under under Timecode
                      burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                      output video.

                      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters
                      before any burned-in timecode. For example, a prefix of "EZ-" will result in
                      the timecode "EZ-00:00:00:00". Provide either the characters themselves or the
                      ASCII code equivalents. The supported range of characters is 0x20 through
                      0x7e. This includes letters, numbers, and all special characters represented
                      on a standard English keyboard.

                  - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                  in pixels, for this output. If you don't provide a value here, the service will
                  use the input width.

        - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
        information from inputs.

          - **Anchor** *(string) --* If you use an editing platform that relies on an anchor
          timecode, use Anchor Timecode (Anchor) to specify a timecode that will match the input
          video frame to the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF)
          or (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
          Timecode varies depending on your setting for Source (TimecodeSource). * If Source
          (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
          specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
          (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start
          at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
          Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
          input.

          - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
          within this job. To make sure that your video, audio, captions, and markers are
          synchronized and that time-based features, such as image inserter, work correctly, choose
          the Timecode source option that matches your assets. All timecodes are in a 24-hour format
          with frame number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the
          input video. If no embedded timecode is in the source, the service will use Start at 0
          (ZEROBASED) instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to
          00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to
          a value other than zero. You use Start timecode (Start) to provide this value.

          - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
          (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial
          frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

          - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
          stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
          affecting the time and frame number. Provide the new date as a string in the format
          "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
          (InsertProgramDateTime) in the output settings. For example, if the date part of your
          timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
          (TimestampOffset) to 2003-1-25.

        - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
        (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you
        must enable it here, enable it in each output container, and specify tags and timecodes in
        ID3 insertion (Id3Insertion) objects.

          - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion
          instances.

            - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3)
            to specify the base 64 encoded string and use Timecode (TimeCode) to specify the time
            when the tag should be inserted. To insert multiple ID3 tags in your output, create
            multiple instances of ID3 insertion (Id3Insertion).

              - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
              format.

              - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or
              HH:MM:SS;FF format.

      - **SimulateReservedQueue** *(string) --* Enable this setting when you run a test job to
      estimate how many reserved transcoding slots (RTS) you need. When this is enabled,
      MediaConvert runs your job from an on-demand queue with similar performance to what you will
      see with one RTS in a reserved queue. This setting is disabled by default.

      - **Status** *(string) --* A job's status can be SUBMITTED, PROGRESSING, COMPLETE, CANCELED,
      or ERROR.

      - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
      events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
      MediaConvert sends an update at this interval from the time the service begins processing your
      job to the time it completes the transcode or encounters an error.

      - **Timing** *(dict) --* Information about when jobs are submitted, started, and finished is
      specified in Unix epoch format in seconds.

        - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
        finished

        - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the job
        began.

        - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the job.

      - **UserMetadata** *(dict) --* User-defined metadata that you want to associate with an
      MediaConvert job. You specify metadata in key/value pairs.

        - *(string) --*

          - *(string) --*
    """


_ClientGetJobTemplateResponseJobTemplateAccelerationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateAccelerationSettingsTypeDef",
    {"Mode": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateAccelerationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateAccelerationSettingsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplate` `AccelerationSettings`

    - **Mode** *(string) --* Specify the conditions when the service will run your job with
    accelerated transcoding.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef",
    {"AvailBlankingImage": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsEsam`
    `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsEsam`
    `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsEsamTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ClientGetJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ClientGetJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsEsamTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsEsamTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputs`
    `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectors`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectors`
    `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputs` `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsCropTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsCropTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsCropTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsInputsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str, ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef
        ],
        "AudioSelectors": Dict[
            str, ClientGetJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef
        ],
        "CaptionSelectors": Dict[
            str, ClientGetJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef
        ],
        "Crop": ClientGetJobTemplateResponseJobTemplateSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DenoiseFilter": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ClientGetJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef,
        "InputClippings": List[
            ClientGetJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef
        ],
        "Position": ClientGetJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ClientGetJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsInputsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsInputsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserter`
    `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserter`
    `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroups`
    `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettings` `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for
    `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef],
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertion`
    `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplateSettings` `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ClientGetJobTemplateResponseJobTemplateSettingsTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ClientGetJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef,
        "Esam": ClientGetJobTemplateResponseJobTemplateSettingsEsamTypeDef,
        "Inputs": List[ClientGetJobTemplateResponseJobTemplateSettingsInputsTypeDef],
        "MotionImageInserter": ClientGetJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ClientGetJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ClientGetJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ClientGetJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ClientGetJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateSettingsTypeDef(
    _ClientGetJobTemplateResponseJobTemplateSettingsTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponseJobTemplate` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
    job. There can only be one input in a job template. Using the API, you can include multiple
    inputs when referencing a job template.

      - *(dict) --* Specified video input in a template.

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ClientGetJobTemplateResponseJobTemplateTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseJobTemplateTypeDef",
    {
        "AccelerationSettings": ClientGetJobTemplateResponseJobTemplateAccelerationSettingsTypeDef,
        "Arn": str,
        "Category": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "Priority": int,
        "Queue": str,
        "Settings": ClientGetJobTemplateResponseJobTemplateSettingsTypeDef,
        "StatusUpdateInterval": str,
        "Type": str,
    },
    total=False,
)


class ClientGetJobTemplateResponseJobTemplateTypeDef(
    _ClientGetJobTemplateResponseJobTemplateTypeDef
):
    """
    Type definition for `ClientGetJobTemplateResponse` `JobTemplate`

    - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
    with long, visually complex content.

      - **Mode** *(string) --* Specify the conditions when the service will run your job with
      accelerated transcoding.

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **Category** *(string) --* An optional category you create to organize your job templates.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for Job template creation.

    - **Description** *(string) --* An optional description you create for each job template.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the Job template was last
    updated.

    - **Name** *(string) --* A name you create for each job template. Each name must be unique
    within your account.

    - **Priority** *(integer) --* Relative priority on the job.

    - **Queue** *(string) --* Optional. The queue that jobs created from this template are assigned
    to. If you don't specify this, jobs will go to the default queue.

    - **Settings** *(dict) --* JobTemplateSettings contains all the transcode settings saved in the
    template that will be applied to jobs created from it.

      - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
      the input Ad Avail PTS time.

      - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
      overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

        - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
        black. Only bmp and png images are supported.

      - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

        - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
        ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
        uses the manifest conditioning instructions that you provide in the setting MCC XML
        (mccXml).

          - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
          document inside your JSON job settings. Form the XML document as per
          OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions
          in the message that you supply.

        - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
        between the SCTE 35 messages that the transcoder places and the splice points that they
        refer to. If the time between the start of the asset and the SCTE-35 message is less than
        this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

        - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
        SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
        signal processing instructions that you provide in the setting SCC XML (sccXml).

          - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
          inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
          transcoder will use the signal processing instructions in the message that you supply.
          Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
          For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
          insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
          (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
          passthrough. You can't do both.

      - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
      job. There can only be one input in a job template. Using the API, you can include multiple
      inputs when referencing a job template.

        - *(dict) --* Specified video input in a template.

          - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
          combine. An input may have multiple audio selector groups. See "Audio Selector
          Group":#inputs-audio_selector_group for more information.

            - *(string) --*

              - *(dict) --* Group of Audio Selectors

                - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
                to include in the group. Audio selector names are standardized, based on their order
                within the input (e.g., "Audio Selector 1"). The audio selector name parameter can
                be repeated to add any number of audio selectors to the group.

                  - *(string) --*

          - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
          or set of tracks from the input that you will use in your outputs. You can use mutiple
          Audio selectors per input.

            - *(string) --*

              - *(dict) --* Selector for Audio

                - **CustomLanguageCode** *(string) --* Selects a specific language code from within
                an audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                set it as the default for the job. The service uses this default for outputs where
                it can't find the specified input audio. If you don't set a default, those outputs
                have no audio.

                - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                file source.

                - **LanguageCode** *(string) --* Selects a specific language code from within an
                audio source.

                - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                audio from the input video.

                - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
                selects PID 0x101).

                  - *(integer) --*

                - **ProgramSelection** *(integer) --* Use this setting for input streams that
                contain Dolby E, to have the service extract specific program data from the track.
                To select multiple programs, create multiple selectors with the same Track and
                different Program numbers. In the console, this setting is visible when you set
                Selector type to Track. Choose the program number from the dropdown list. If you are
                sending a JSON file, provide the program ID, which is part of the audio metadata. If
                your input file has incorrect metadata, you can choose All channels instead of a
                program number to have the service ignore the program IDs and include all the
                programs in the track.

                - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
                one input to match those of another input. This allows you to combine the two files
                into a single output, one after the other.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **SelectorType** *(string) --* Specifies the type of the audio selector.

                - **Tracks** *(list) --* Identify a track from the input audio to include in this
                selector by entering the track index number. To include several tracks in a single
                audio selector, specify multiple tracks as follows. Using the console, enter a
                comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                Specifying directly in your JSON job file, provide the track numbers in an array.
                For example, "tracks": [1,2,3].

                  - *(integer) --*

          - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
          the captions data from the input that you will use in your outputs. You can use mutiple
          captions selectors per input.

            - *(string) --*

              - *(dict) --* Set up captions in your outputs by first selecting them from your input
              here.

                - **CustomLanguageCode** *(string) --* The specific language to extract from source,
                using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
                complete this field and/or PID to select the caption language to extract. If input
                is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
                select the caption language to extract. If input is DVB-Sub that is being passed
                through, omit this field (and PID field); there is no way to extract a specific
                language with pass-through captions.

                - **LanguageCode** *(string) --* The specific language to extract from source. If
                input is SCTE-27, complete this field and/or PID to select the caption language to
                extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
                and/or PID to select the caption language to extract. If input is DVB-Sub that is
                being passed through, omit this field (and PID field); there is no way to extract a
                specific language with pass-through captions.

                - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                    number in the ancillary data track from which to extract captions. Unused for
                    passthrough.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                    PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content
                    is passed through, regardless of selectors.

                  - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                    within the video track from which to extract captions. Unused for passthrough.

                    - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                    for extracting captions. The system only supports one input video track, so this
                    should always be set to '1'.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                  STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source
                  file. If your caption source is IMSC in an IMF package, use TrackSourceSettings
                  instead of FileSoureSettings.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceFile** *(string) --* External caption file used for loading captions.
                    Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                    'smi'.

                    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                    captions from the source file.

                  - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                  your input captions. The service cannot auto-detect caption format.

                  - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                  sources, including Page number.

                    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                    three-digit hexadecimal page number that will be used for Teletext captions. Do
                    not use this setting if you are passing through teletext from the input source
                    to output.

                  - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                  are specified by track number. Currently, this is only IMSC captions in an IMF
                  package. If your caption source is IMSC 1.1 in a separate xml file, use
                  FileSourceSettings instead of TrackSourceSettings.

                    - **TrackNumber** *(integer) --* Use this setting to select a single captions
                    track from a source. Track numbers correspond to the order in the captions
                    source file. For IMF sources, track numbering is based on the order that the
                    captions appear in the CPL. For example, use 1 to select the captions asset that
                    is listed first in the CPL. To include more than one captions track in your job
                    outputs, create multiple input captions selectors. Specify one track per
                    selector.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame. If you specify a value here, it will
          override any value that you specify in the output setting Cropping selection (crop).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
          motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
          uncompressed video inputs.

          - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
          the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
          video inputs.

          - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
          transcoding service applies the denoise and deblock filters. You must also enable the
          filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
          Auto - The transcoding service determines whether to apply filtering, depending on input
          type and quality. * Disable - The input is not filtered. This is true even if you use the
          API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put
          is filtered regardless of input type.

          - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
          magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
          is 0.

          - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
          overlay on your video. Enable or disable this feature for each input individually. This
          setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
          that together specify a portion of the input to be used in the outputs. If you provide
          only a start time, the clip will be the entire input from that point to the end. If you
          provide only an end time, it will be the entire input up to that point. When you specify
          more than one input clip, the transcoding service creates the job outputs by stringing the
          clips together in the order you specify them.

            - *(dict) --* To transcode only portions of your input (clips), include one Input
            clipping (one instance of InputClipping in the JSON job file) for each input clip. All
            input clips you specify will be included in every output of the job.

              - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
              portion of the input you are clipping. The frame corresponding to the End timecode
              value is included in the clip. Start timecode or End timecode may be left blank, but
              not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
              minute, SS is the second, and FF is the frame number. When choosing this value, take
              into account your setting for timecode source under input settings
              (InputTimecodeSource). For example, if you have embedded timecodes that start at
              01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

              - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning
              of the portion of the input you are clipping. The frame corresponding to the Start
              timecode value is included in the clip. Start timecode or End timecode may be left
              blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour,
              MM is the minute, SS is the second, and FF is the frame number. When choosing this
              value, take into account your setting for Input timecode source. For example, if you
              have embedded timecodes that start at 01:00:00:00 and you want your clip to begin five
              minutes into the video, use 01:05:00:00.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black. If
          you specify a value here, it will override any value that you specify in the output
          setting Selection placement (position). If you specify a value here, this will override
          any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
          (RESPOND). If you specify a value here, this will ignore anything that you specify for the
          setting Scaling Behavior (scalingBehavior).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
          program from within a multi-program transport stream. Note that Quad 4K is not currently
          supported. Default is the first program within the transport stream. If the program you
          specify doesn't exist, the transcoding service will use this default.

          - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
          inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for
          audio and video. * Use PSI - Scan only PSI data.

          - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
          input settings (InputTimecodeSource), to specify how the service counts input video
          frames. This input frame count affects only the behavior of features that apply to a
          single input at a time, such as input clipping and synchronizing some captions formats.
          Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at zero
          (ZEROBASED) to start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to
          start the first frame at the timecode that you specify in the setting Start timecode
          (timecodeStart). If you don't specify a value for Timecode source, the service will use
          Embedded by default. For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
          for this input's initial frame. To use this setting, you must set the Timecode source
          setting, located under the input settings (InputTimecodeSource), to Specified start
          (SPECIFIEDSTART). For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **VideoSelector** *(dict) --* Selector for video.

            - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
            animation. Specify which part of this input MediaConvert uses for your outputs. Leave
            this setting set to DISCARD in order to delete the alpha channel and preserve the video.
            Use REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the
            luma channel of your outputs.

            - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
            if you don't know about color space, leave this set to the default value Follow
            (FOLLOW). The service will automatically detect your input color space. If your input
            video has metadata indicating the wrong color space, specify the accurate color space
            here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume
            static metadata isn't present in your video stream, or if that metadata is present but
            not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the
            input HDR 10 metadata (Hdr10Metadata) settings. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
            file and the job input settings Color space (ColorSpace) and HDR master display
            information settings(Hdr10Metadata). The Color space usage setting determines which
            takes precedence. Choose Force (FORCE) to use color metadata from the input job
            settings. If you don't specify values for those settings, the service defaults to using
            metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata
            from the source when it is present. If there's no color metadata in your input file, the
            service defaults to using values you specify in the input settings.

            - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
            missing or inaccurate in your input video. Appropriate values vary depending on the
            input video and must be provided by a color grader. The color grader generates these
            values during the HDR 10 mastering process. The valid range for each of these settings
            is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
            settings - When you specify these values, you must also set Color space (ColorSpace) to
            HDR 10 (HDR10). To specify whether the the values you specify here take precedence over
            the values in the metadata of your input file, set Color space usage (ColorSpaceUsage).
            To specify whether color metadata is included in an output, set Color metadata
            (ColorMetadata). For more information about MediaConvert HDR jobs, see
            https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
            Specify this value as an integer; the system automatically converts it to the
            hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
            an identifier for a set of data in an MPEG-2 transport stream container.

            - **ProgramNumber** *(integer) --* Selects a specific program from within a
            multi-program transport stream. Note that Quad 4K is not currently supported.

            - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
            your video. You can choose automatic rotation or specify a rotation. You can specify a
            clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov
            or .mp4 and your input has rotation metadata, you can choose Automatic to have the
            service rotate your video according to the rotation specified in the metadata. The
            rotation must be within one degree of 90, 180, or 270 degrees. If the rotation metadata
            specifies any other rotation, the service will default to no rotation. By default, the
            service does no rotation, even if your input video has rotation metadata. The service
            doesn't pass through rotation metadata.

      - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
      graphics that you specify here appear on all outputs in all output groups.

        - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
        unspecified. If your motion graphic asset is a series of .png files, specify the frame rate
        of the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1.
        Make sure that the number of images in your series matches the frame rate and your intended
        overlay duration. For example, if you want a 30-second overlay at 30 fps, you should have
        900 .png images. This overlay frame rate doesn't need to match the frame rate of the
        underlying video.

          - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

          - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

        - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
        overlay on your video. For .png files, provide the file name of the first file in the
        series. Make sure that the names of the .png files end with sequential numbers that specify
        the order that they are played in. For example, overlay_000.png, overlay_001.png,
        overlay_002.png, and so on. The sequence must start at zero, and each image file name must
        have the same number of digits. Pad your initial file names with enough zeros to complete
        the sequence. For example, if the first image is overlay_0.png, there can be only 10 images
        in the sequence, with the last image being overlay_9.png. But if the first image is
        overlay_00.png, there can be 100 images in the sequence.

        - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
        providing for your overlay. You can choose either a .mov file or a series of .png files.

        - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay
        on the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
        specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
        the service inserts the overlay at its native resolution and scales the size up or down with
        any video scaling.

          - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
          edge of the video frame.

          - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
          edge of the video frame.

        - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
        or plays only once.

        - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
        (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
        account how you have set up your timecode configuration under both job settings and input
        settings. The simplest way to do that is to set both to start at 0. If you need to set up
        your job to follow timecodes embedded in your source that don't start at zero, make sure
        that you specify a start time that is after the first embedded timecode. For more
        information, see https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html
        Find job-wide and input timecode configuration settings in your JSON job settings
        specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

      - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
      do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
      configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs
      in the job. To enable Nielsen configuration programmatically, include an instance of
      nielsenConfiguration in your JSON job specification. Even if you don't include any children of
      nielsenConfiguration, you still enable the setting.

        - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
        functionality. If you must include this property, set the value to zero.

        - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
        distributor ID that is assigned to your organization by Neilsen.

      - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
      outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
      MXF, and no container) are grouped in a single output group as well. Required in
      (OutputGroups) is a group of settings that apply to the whole group. This required object
      depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
      settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
      HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
      MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

        - *(dict) --* Group of outputs

          - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
          the output group. This value is displayed on the console and can make your job settings
          JSON more human-readable. It does not affect your outputs. Use up to twelve characters
          that are either letters, numbers, spaces, or underscores.

          - **Name** *(string) --* Name of the output group

          - **OutputGroupSettings** *(dict) --* Output Group settings, including type

            - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
            Output Group may only contain a single video, audio, or caption output.

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
              your job. These default manifests reference every output in the output group. To
              create additional top-level manifests that reference a subset of the outputs in the
              output group, specify a list of them here. For each additional manifest that you
              specify, the service creates one HLS manifest and one DASH manifest.

                - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
                that you want the service to generate for this CMAF output group. Each pair of
                manifests can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
              at the top level BaseURL element. Can be used if streams are delivered from a
              different URL than the manifest file.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
                service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                (SAMPLE-AES) or AES_CTR (AES-CTR).

                - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                outputs, choose whether the service writes the 128-bit encryption initialization
                vector in the HLS and DASH manifests.

                - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                  signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                  package. The DASH manifest can currently signal up to three system IDs. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                  signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                  package. The HLS manifest can currently signal only one system ID. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
              of each individual CMAF segment. This value applies to the whole package; that is, to
              every output in the output group. Note that segments end on the first keyframe after
              this number of seconds, so the actual segment length might be slightly longer. If you
              set Segment control (CmafSegmentControl) to single file, the service puts the content
              of each output in a single file that has metadata that marks these segments. If you
              set it to segmented files, the service creates multiple files for each output, each
              with the content of one segment.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
              generated for this output.

              - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
              be generated for this output.

            - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
              manifest for each DASH ISO output group in your job. This default manifest references
              every output in the output group. To create additional DASH manifests that reference a
              subset of the outputs in the output group, specify a list of them here.

                - *(dict) --* Specify the details for each additional DASH manifest that you want
                the service to generate for this output group. Each manifest can reference a
                different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.mpd.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
              (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
              from a different URL than the manifest file.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                compatibility of your output with video players on obsolete devices. It applies only
                to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
                only to correct problems with playback on older devices. Otherwise, keep the default
                setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the
                service will exclude the access unit delimiter and will leave the SEI NAL units
                unencrypted.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
              that segments will end on the next keyframe after this number of seconds, so actual
              segment length may be longer. When Emit Single File is checked, the segmentation is
              internal to a single output file and it does not cause the creation of many output
              files as in other output types.

              - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
              the 400 range when you play back your DASH output, enable this setting and run your
              transcoding job again. When you enable this setting, the service writes precise
              segment durations in the DASH manifest. The segment duration information appears
              inside the SegmentTimeline element, inside SegmentTemplate at the Representation
              level. When you don't enable this setting, the service writes approximate segment
              durations in your DASH manifest.

            - **FileGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

            - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

              - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
              HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
              outputs themselves.

                - *(string) --*

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest for each HLS output group in your job. This default manifest
              references every output in the output group. To create additional top-level manifests
              that reference a subset of the outputs in the output group, specify a list of them
              here.

                - *(dict) --* Specify the details for each additional HLS manifest that you want the
                service to generate for this output group. Each manifest can reference a different
                subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
              in the media .m3u8 file. Can be used if base manifest is delivered from a different
              URL than the main .m3u8 file.

              - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                - *(dict) --* Caption Language Mapping

                  - **CaptionChannel** *(integer) --* Caption channel.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                  - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                  three-letter code listed at
                  https://www.loc.gov/standards/iso639-2/php/code_list.php.

                  - **LanguageDescription** *(string) --* Caption language description.

              - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
              captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one
              language in the CC1 Language Code field. One CLOSED-CAPTION line is added for each
              Language Code you specify. Make sure to specify the languages in the order in which
              they appear in the original source (if the source is embedded format) or the order of
              the caption selectors (if the source is other than embedded). Otherwise, languages in
              the manifest will not match up properly with the output captions. None: Include
              CLOSED-CAPTIONS=
                  NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from
              the manifest.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
              subdirectories.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
                scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
                disables encryption.

                - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                128-bit number used in conjunction with the key for encrypting blocks. If set to
                INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                Vector is not in the manifest.

                - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                HLS FairPlay content protection.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
              looking ahead and back within the specified range for a nearby avail and extending the
              segment size if needed.

              - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
              be generated for this HLS output group.

              - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
              in .m3u8 manifest files. The value is calculated as follows: either the program date
              and time are initialized using the input timecode source, or the time is initialized
              using the input timecode source and the date is initialized using the
              timestamp_offset.

              - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
              EXT-X-PROGRAM-DATE-TIME entry, in seconds.

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
              media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

              - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
              create (in seconds). Note that segments will end on the next keyframe after this
              number of seconds, so actual segment length may be longer.

              - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
              subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
              for this setting to have an effect.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

              - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

              - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
              offset to fine tune the timestamps.

            - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .ism
              Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
              in your job. This default manifest references every output in the output group. To
              create additional manifests that reference a subset of the outputs in the output
              group, specify a list of them here.

                - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                manifest that you want the service to generate for this output group. Each manifest
                can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                  "-no-premium" for this setting, then the file name the service generates for this
                  top-level manifest is film-name-no-premium.ismv.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
              audio encoding settings across a Microsoft Smooth output group into a single audio
              stream.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* If you are using DRM, set DRM System
              (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
              the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
              and frame rate.

              - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding)
              to specify the encoding format for the server and client manifest. Valid options are
              utf8 and utf16.

            - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
            Microsoft Smooth Streaming, CMAF)

          - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
          settings per output.

            - *(dict) --* An output object describes the settings for a single output file or stream
            in an output group.

              - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
              encoding settings organized by audio codec. Include one instance of
              (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
              encoding settings.

                - *(dict) --* Description of audio output

                  - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                  settings. Ignore these settings unless you need to comply with a loudness
                  standard.

                    - **Algorithm** *(string) --* Choose one of the following audio normalization
                    algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                    loudness for an entire piece of content, suitable for measurement of short-form
                    content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-2: Gated loudness. A measurement of gated average loudness compliant
                    with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
                    with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
                    Allows for more audio channels than the other algorithms, including
                    configurations such as 7.1.

                    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                    using the chosen algorithm. If disabled, the audio will be measured but not
                    adjusted.

                    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                    be corrected to the target level. Content measuring below this level will not be
                    corrected. Gating only applies when not using real_time_correction.

                    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                    loudness to a CSV file.

                    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                    TruePeak for each output's audio track loudness.

                    - **TargetLkfs** *(float) --* When you use Audio normalization
                    (AudioNormalizationSettings), optionally use this setting to specify a target
                    loudness. If you don't specify a value here, the encoder chooses a value for
                    you, based on the algorithm that you choose for Algorithm (algorithm). If you
                    choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                    encoder will choose -23 LKFS.

                  - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                  input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                  name based on its order within each input. For example if you specify "Audio
                  Selector 3", then the third audio selector will be used from each input. If an
                  input does not have an "Audio Selector 3", then the audio selector marked as
                  "default" in that input will be used. If there is no audio selector marked as
                  "default", silence will be inserted for the duration of that input. Alternatively,
                  an "Audio Selector Group":#inputs-audio_selector_group name may be specified, with
                  similar default/silence behavior. If no audio_source_name is specified, then
                  "Audio Selector 1" will be chosen automatically.

                  - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                  unchecked (false). A number between 0 and 255. The following are defined in
                  ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                       Hearing Impaired, 3 =
                  Visually Impaired Commentary, 4-255 = Reserved.

                  - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                  contains an ISO 639 audio_type, then that value is passed through to the output.
                  If the input contains no ISO 639 audio_type, the value in Audio Type is included
                  in the output. Otherwise the value in Audio Type is included in the output. Note
                  that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                  is set to BROADCASTER_MIXED_AD.

                  - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                  (AudioDescriptions) contains the group of settings related to audio encoding. The
                  settings in this group vary depending on the value that you choose for Audio codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * AAC,
                  AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                  Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                    - **AacSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                    two mutually exclusive groups of AAC settings--VBR and CBR. To select one of
                    these modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or
                    "CBR". In VBR mode, you control the audio quality with the setting VBR quality
                    (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                    valid values depend on the rate control mode.

                      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                      when the input contains pre-mixed main audio + audio description (AD) as a
                      stereo pair. The value for AudioType will be set to 3, which signals to
                      downstream systems that this stream contains "broadcaster mixed AD". Note that
                      the input received by the encoder must contain pre-mixed audio; the encoder
                      does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                      ignores any values you provide in AudioType and FollowInputAudioType. Choose
                      NORMAL when the input does not contain pre-mixed audio + audio description
                      (AD). In this case, the encoder will use any values you provide for AudioType
                      and FollowInputAudioType.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      The set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000,
                      16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000,
                      112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000,
                      448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you set is
                      also constrained by the values that you choose for Profile (codecProfile),
                      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
                      values depend on Bitrate control mode and Profile.

                      - **CodecProfile** *(string) --* AAC Profile.

                      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                      channel layout. Valid values depend on rate control mode and profile. "1.0 -
                      Audio Description (Receiver Mix)" setting receives a stereo description plus
                      control track and emits a mono AAC encode of the description track, with
                      control data emitted in the PES header as per ETSI TS 101 154 Annex E.

                      - **RateControlMode** *(string) --* Rate Control Mode.

                      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                      use LATM/LOAS AAC in an output, you must choose "No container" for the output
                      container.

                      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                      control mode and profile.

                      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                      for raw or MPEG-2 Transport Stream containers.

                      - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                      rate_control_mode is VBR.

                    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AC3.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                      stream that the encoder emits. For more information about the AC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital, dialnorm will be passed through.

                      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                      adds dynamic range compression signaling to the output bitstream as defined in
                      the Dolby Digital specification.

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                    - **AiffSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AIFF.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **Codec** *(string) --* Type of Audio codec.

                    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid values: 384k, 448k, 640k, 768k

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                      (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                      adjust loudness based on dialogue analysis.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                      this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix
                      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                      value -60 mutes the channel.

                      - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                      your audio.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                      that must be speech before the encoder uses the measured speech loudness as
                      the overall program loudness.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing.

                      - **SurroundExMode** *(string) --* Specify whether your input audio has an
                      additional center rear surround channel matrix encoded into your left and
                      right surround channels.

                    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3.

                      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                      dB attenuation to the surround channels. Only used for 3/2 coding mode.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                      number of channels.

                      - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital Plus, dialnorm will be passed through.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                      LFE channel is enabled

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left only/Right only center (loRoCenterMixLevel).

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                      channel. This setting applies only if you keep the default value of 3/2 - L,
                      R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                      If you choose a different value for Coding mode, the service ignores Left
                      only/Right only surround (loRoSurroundMixLevel).

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total center (ltRtCenterMixLevel).

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                      surround). MediaConvert uses this value for downmixing. How the service uses
                      this value depends on the value that you choose for Stereo downmix
                      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
                      -60 mutes the channel. This setting applies only if you keep the default value
                      of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total surround (ltRtSurroundMixLevel).

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                      audio will be passed through if it is present on the input. this detection is
                      dynamic over the life of the transcode. Inputs that alternate between DD+ and
                      non-DD+ content will have a consistent DD+ output as the system alternates
                      between passthrough and encoding.

                      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                      the surround channels. Only used for 3/2 coding mode.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing. This setting only applies if you keep the default value of 3/2 -
                      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Stereo downmix (Eac3StereoDownmix).

                      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                      extra center back surround channel is matrix encoded into the left and right
                      surround channels.

                      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                      Surround is matrix encoded into the two channels.

                    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value MP2.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                      - **Channels** *(integer) --* Set Channels to specify the number of channels
                      in this output audio track. Choosing Mono in the console will give you 1
                      output channel; choosing Stereo will give you 2. In the API, valid values are
                      1 and 2.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **WavSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value WAV.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                      If your output audio is likely to exceed 4 GB in file size, or if you
                      otherwise need the extended support of the RF64 format, set your output WAV
                      file format to RF64.

                      - **SampleRate** *(integer) --* Sample rate in Hz.

                  - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                  track. The service puts this language code into your output audio track when you
                  set Language code control (AudioLanguageCodeControl) to Use configured
                  (USE_CONFIGURED). The service also uses your specified custom language code when
                  you set Language code control (AudioLanguageCodeControl) to Follow input
                  (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                  outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                  can also use any other code in the full RFC-5646 specification. Streaming outputs
                  are those that are in one of the following output groups: CMAF, DASH ISO, Apple
                  HLS, or Microsoft Smooth Streaming.

                  - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                  The ISO 639 language specified in the 'Language Code' drop down will be used when
                  'Follow Input Language Code' is not selected or when 'Follow Input Language Code'
                  is selected but there is no ISO 639 language code specified by the input.

                  - **LanguageCodeControl** *(string) --* Specify which source for language code
                  takes precedence for this audio track. When you choose Follow input
                  (FOLLOW_INPUT), the service uses the language code from the input track if it's
                  present. If there's no languge code on the input track, the service uses the code
                  that you specify in the setting Language code (languageCode or
                  customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service
                  uses the language code that you specify.

                  - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **StreamName** *(string) --* Specify a label for this output audio stream. For
                  example, "English", "Director commentary", or "track_2". For streaming outputs,
                  MediaConvert passes this information into destination manifests for display on the
                  end-viewer's player device. For outputs in other output groups, the service
                  ignores this setting.

              - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
              captions settings. For each output that has captions, include one instance of
              (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
              settings.

                - *(dict) --* Description of Caption output

                  - **CaptionSelectorName** *(string) --* Specifies which "Caption
                  Selector":#inputs-caption_selector to use from each input when generating
                  captions. The name should be of the format "Caption Selector ", which denotes that
                  the Nth Caption Selector will be used from each input.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  output track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information when automatically
                  selecting the font script for rendering the captions text. For all outputs, you
                  can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
                  any other code in the full RFC-5646 specification. Streaming outputs are those
                  that are in one of the following output groups: CMAF, DASH ISO, Apple HLS, or
                  Microsoft Smooth Streaming.

                  - **DestinationSettings** *(dict) --* Specific settings required by destination
                  type. Note that burnin_destination_settings are not available if the source of the
                  caption data is Embedded or Teletext.

                    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering burn-in captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **DestinationType** *(string) --* Specify the format for this set of captions
                    on this output. The default format is embedded without SCTE-20. Other options
                    are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                    web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                    (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec.
                    To create a non-compliant output where the embedded captions come first, choose
                    Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering DVB-Sub captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                      standard or for hearing impaired. Choose hearing impaired if your subtitles
                      include audio descriptions and dialogue. Choose standard if your subtitles
                      include only dialogue.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                    embedded/ancillary caption outputs, including 608/708 Channel destination
                    number.

                      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and your output captions are embedded in
                      the video stream. Specify a CC number for each captions channel in this
                      output. If you have two channels, choose CC numbers that aren't in the same
                      field. For example, choose 1 and 3. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and you want both 608 and 708 captions
                      embedded in your output stream. Optionally, specify the 708 service number for
                      each output captions channel. Choose a different number for each channel. To
                      use this setting, also set Force 608 to 708 upconvert (Convert608To708) to
                      Upconvert (UPCONVERT) in your input captions selector settings. If you choose
                      to upconvert but don't specify a 708 service number, MediaConvert uses the
                      number that you specify for CC channel number (destination608ChannelNumber)
                      for the 708 service number. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                    outputs.

                      - **StylePassthrough** *(string) --* Keep this setting enabled to have
                      MediaConvert use the font style and position information from the captions
                      source in the output. This option is available only when your input captions
                      are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                      output captions.

                    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                      sure that the captions and the video are synchronized in the output. Specify a
                      frame rate that matches the frame rate of the associated video. If the video
                      frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only
                      if the video has video_insertion=
                          true and drop_frame_timecode=true; otherwise,
                      choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                    output

                      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                      the destination captions for this output. This value must be a three-digit
                      hexadecimal string; strings ending in -FF are invalid. If you are passing
                      through the entire set of Teletext data, do not use this field.

                      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                      you don't specify a value here, the service sets the page type to the default
                      value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                      Teletext data, don't use this field. When you pass through a set of Teletext
                      pages, your output has the same page types as your input.

                        - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                        Table 94

                    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                    outputs, including Pass style information (TtmlStylePassthrough).

                      - **StylePassthrough** *(string) --* Pass through style and position
                      information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                      CFF-TT output or TTML output.

                  - **LanguageCode** *(string) --* Specify the language of this captions output
                  track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information to choose the font
                  language for rendering the captions text.

                  - **LanguageDescription** *(string) --* Specify a label for this set of output
                  captions. For example, "English", "Director commentary", or "track_2". For
                  streaming outputs, MediaConvert passes this information into destination manifests
                  for display on the end-viewer's player device. For outputs in other output groups,
                  the service ignores this setting.

              - **ContainerSettings** *(dict) --* Container specific settings.

                - **Container** *(string) --* Container for this output. Some containers require a
                container settings object. If not specified, the default object will be created.

                - **F4vSettings** *(dict) --* Settings for F4v container

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs
                in a File output group when the output's container (ContainerType) is MPEG-2
                Transport Stream (M2TS). In these assets, data is organized by the program map table
                (PMT). Each transport stream program contains subsets of data, including audio,
                video, and metadata. Each of these subsets of data has a numerical label called a
                packet identifier (PID). Each transport stream program corresponds to one
                MediaConvert output. The PMT lists the types of data in a program along with their
                PID. Downstream systems and players use the program map table to look up the PID for
                each type of data it accesses and then uses the PIDs to locate specific data within
                the asset.

                  - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                  models for Dolby Digital audio.

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                  elementary audio streams you include in this output. Specify multiple PIDs as a
                  JSON array. Default is the range 482-492.

                    - *(integer) --*

                  - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                  bits per second. Setting to 0 lets the muxer automatically determine the
                  appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                  - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                  interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                  this can lead to lower latency, but low-memory devices may not be able to play
                  back the stream without interruptions.

                  - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                  the specified table repetition interval.

                    - **NetworkId** *(integer) --* The numeric value placed in the Network
                    Information Table (NIT).

                    - **NetworkName** *(string) --* The network name text placed in the
                    network_name_descriptor inside the Network Information Table. Maximum length is
                    256 characters.

                    - **NitInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                  the specified table repetition interval.

                    - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                    output stream. "Follow input SDT" copies SDT information from input stream to
                    output stream. "Follow input SDT if present" copies SDT information from input
                    stream to output stream if SDT information is present in the input, otherwise it
                    will fall back on the user-defined values. Enter "SDT Manually" means user will
                    enter the SDT information. "No SDT" means output stream will not contain SDT
                    information.

                    - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **ServiceName** *(string) --* The service name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                    - **ServiceProviderName** *(string) --* The service provider name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                  - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                  subtitle data included in this output. Specify multiple PIDs as a JSON array.
                  Default is the range 460-479.

                    - *(integer) --*

                  - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                  specified table repetition interval.

                    - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                  teletext data you include in this output. Default is 499.

                  - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                  EBP markers will be added to partitions 3 and 4. The interval between these
                  additional markers will be fixed, and will be slightly shorter than the video EBP
                  marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                  inserted. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                  can either be placed only on the video PID, or on both the video PID and all audio
                  PIDs. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                  the PES header.

                  - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                  you know that your audio EBP markers are incorrectly appearing before your video
                  EBP markers. To correct this problem, set this value to Force (FORCE).

                  - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                  used with EBP markers.

                  - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                  between Program Clock References (PCRs) inserted into the transport stream.

                  - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                  Points do not come within the specified time interval of each other by looking
                  ahead at input video. If another EBP is going to come in within the specified time
                  interval, the current EBP is not emitted, and the segment is "stretched" to the
                  next marker. The lookahead value does not add latency to the system. The Live
                  Event must be configured elsewhere to create sufficient latency to make the
                  lookahead accurate.

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                  packets to insert into the transport stream. This can be used if a downstream
                  encryption system requires periodic null packets.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This is effective only when the PCR PID is the same as the video or audio
                  elementary stream.

                  - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                  clock reference (PCR) in this output. If you do not specify a value, the service
                  will use the value for Video PID (VideoPid).

                  - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                  instances of the program map table (PMT) in the output transport stream.

                  - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                  map table (PMT) itself. Default is 480.

                  - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                  private metadata stream. Default is 503.

                  - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                  the program number used in the program map table (PMT) for this output. Default is
                  1. Program numbers and program map tables are parts of MPEG-2 transport stream
                  containers, used for organizing data.

                  - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                  stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                  maximum bitrate, but the output will not be padded up to that bitrate.

                  - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                  markers in your HLS and transport stream outputs at the insertion points that you
                  specify in an ESAM XML document. Provide the document in the setting SCC XML
                  (sccXml).

                    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                    in the transport stream generated by ESAM.

                  - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                  stream in the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None
                  (NONE). Also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml). Also enable ESAM SCTE-35 (include the property
                  scte35Esam).

                  - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                  segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                  adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                  private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                  segments. ebp adds Encoder Boundary Point information to the adaptation field as
                  per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary
                  Point information to the adaptation field using a legacy proprietary format.

                  - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                  how segmentation markers are inserted into the transport stream. With avails, it
                  is possible that segments may be truncated, which can influence where future
                  segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                  selected and a segment is truncated due to an avail, we will reset the
                  segmentation cadence. This means the subsequent segment will have a duration of of
                  $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                  selected and a segment is truncated due to an avail, we will not reset the
                  segmentation cadence. This means the subsequent segment will likely be truncated
                  as well. However, all segments after that will have a duration of
                  $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
                  rule.

                  - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                  segment. Required unless markers is set to _none_.

                  - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                  timed metadata in this output. Default is 502.

                  - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                  itself in the program map table for this output. Transport stream IDs and program
                  map tables are parts of MPEG-2 transport stream containers, used for organizing
                  data.

                  - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                  elementary video stream in the transport stream.

                - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                  stream(s) in the transport stream. Multiple values are accepted, and can be
                  entered in ranges and/or by comma separation.

                    - *(integer) --*

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This parameter is effective only when the PCR PID is the same as the video or
                  audio elementary stream.

                  - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                  (PCR) in the transport stream. When no value is given, the encoder will assign the
                  same value as the Video PID.

                  - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                  (PMT) in the transport stream.

                  - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                  metadata stream in the transport stream.

                  - **ProgramNumber** *(integer) --* The value of the program number field in the
                  Program Map Table.

                  - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                  the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE)
                  if you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and
                  choose Ad markers (adMarkers) if you do want manifest conditioning. In both cases,
                  also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml).

                  - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                  specify whether the service inserts the ID3 timed metadata from the input in this
                  output.

                  - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                  metadata stream in the transport stream.

                  - **TransportStreamId** *(integer) --* The value of the transport stream ID field
                  in the Program Map Table.

                  - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                  stream in the transport stream.

                - **MovSettings** *(dict) --* Settings for MOV Container.

                  - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                  the video output settings.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                  streams into the QuickTime file using XDCAM fourcc codes. This increases
                  compatibility with Apple editors and players, but may decrease compatibility with
                  other players. Only applicable when the video codec is MPEG2.

                  - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                  padding

                  - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                  this setting.

                - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
                AAC outputs with this container.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                  moov box.

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                  - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                  file. Usually not necessary to specify.

                - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                  - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                  groups that include sidecar TTML or IMSC captions. You specify sidecar captions in
                  a separate output from your audio and video. Choose Raw (RAW) for captions in a
                  single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for
                  captions in XML format contained within fragmented MP4 files. This set of
                  fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                  - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                  markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                  insertion points that you specify in an ESAM XML document. Provide the document in
                  the setting SCC XML (sccXml).

                  - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                  markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                  SCTE-35 markers that appear in your input to also appear in this output. Choose
                  None (NONE) if you don't want those SCTE-35 markers in this output.

              - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
              for outputs in File output groups. If you do not specify a value, the service will use
              default extensions by container type as follows * MPEG-2 transport stream, m2ts *
              Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the
              service will use codec extensions (e.g. AAC, H265, H265, AC3)

              - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
              add a string to the end of each output filename. You specify the base filename as part
              of your destination URI. When you create multiple outputs in the same output group,
              Name modifier (NameModifier) is required. Name modifier also accepts format
              identifiers. For DASH ISO outputs, if you use the format identifiers $Number$ or
              $Time$ in one output, you must use them in the same way in all outputs of the output
              group.

              - **OutputSettings** *(dict) --* Specific settings for this type of output.

                - **HlsSettings** *(dict) --* Settings for HLS output groups

                  - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                  belongs.

                  - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                  outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                  container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                  file in a raw container. Regardless of the value that you specify here, if this
                  output has video, the service will place the output into an MPEG2-TS container.

                  - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                  with the video output stream. Input all the audio GROUP-IDs that are associated to
                  the video, separate by ','.

                  - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                  Audio-Only Variant Stream The client can play back this audio-only stream instead
                  of video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                  manifest. Alternate Audio, Auto Select, Default Alternate rendition that the
                  client should try to play back by default. Represented as an EXT-X-MEDIA in the
                  HLS manifest with DEFAULT=YES, AUTOSELECT=
                      YES Alternate Audio, Auto Select, Not
                  Default Alternate rendition that the client may try to play back by default.
                  Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                      NO, AUTOSELECT=YES
                  Alternate Audio, not Auto Select Alternate rendition that the client will not try
                  to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
                  DEFAULT=NO, AUTOSELECT=NO

                  - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                  Manifest in addition to the HLS manifest

                  - **SegmentModifier** *(string) --* String concatenated to end of segment
                  filenames. Accepts "Format Identifiers":#format_identifier_parameters.

              - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
              transcoding settings. Provide the system or custom preset name. You can specify either
              Preset (Preset) or Container settings (ContainerSettings), but not both.

              - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
              encoding settings. The specific video settings depend on the video codec that you
              choose when you specify a value for Video codec (codec). Include one instance of
              (VideoDescription) per output.

                - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                service includes AFD values in the output video data and what those values are. *
                Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                input AFD values and instead encode the value specified in the job. * Choose Auto to
                calculate output AFD values based on the input AFD scaler data.

                - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
                outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
                specify that in your job, the service will ignore the setting.

                - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                (VideoDescription), contains the group of settings related to video encoding. The
                settings in this group vary depending on the value that you choose for Video codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * H_264,
                H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
                FRAME_CAPTURE, FrameCaptureSettings

                  - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                  the enum values defined by the object VideoCodec.

                  - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                    - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.n.jpg where n is the 0-based sequence number of each Capture.

                    - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
                    to 7 decimal places.

                    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                    files).

                    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                    quality.

                  - **H264Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value H_264.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                    your output video settings. If you aren't sure what level to specify, choose
                    Auto (AUTO).

                    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                    are only available with the AVC-I License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                    Main or High profile) or CAVLC.

                    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                    for interlaced outputs.

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job specification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* When you use the API for transcode
                    jobs that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateDenominator to specify the
                    denominator of this fraction. In this example, use 1001 for the value of
                    FramerateDenominator. When you use the console for transcode jobs that use frame
                    rate conversion, provide the value as a decimal number for Framerate. In this
                    example, specify 23.976.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type, as follows. - If the source is interlaced, the output will be interlaced
                    with the same polarity as the source (it will follow the source). The output
                    could therefore be a mix of "top field first" and "bottom field first". - If the
                    source is progressive, the output will be interlaced with "top field first" or
                    "bottom field first" polarity, depending on which of the Follow options you
                    chose.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even
                    if repeated.

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                  - **H265Settings** *(dict) --* Settings for H265 codec

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                    Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                    Transfer Function (EOTF).

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* H.265 Level.

                    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                    (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                    "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                    available with the HEVC 4:2:2 License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                    Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                    the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field
                    First (BOTTOM_FIELD) to create an output that's interlaced with the same field
                    polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow,
                    Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the
                    same field polarity as the source. If the source is interlaced, the output will
                    be interlaced with the same polarity as the source (it will follow the source).
                    The output could therefore be a mix of "top field first" and "bottom field
                    first". If the source is progressive, your output will be interlaced with "top
                    field first" or "bottom field first" polarity, depending on which of the Follow
                    options you chose. If you don't choose a value, the service will default to
                    Progressive (PROGRESSIVE).

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                    Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                    based on content

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                    encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                    and P-frames form one layer, reference B-frames can form a second layer and
                    non-reference b-frames can form a third layer. Decoders can optionally decode
                    only the lower temporal layers to generate a lower frame rate output. For
                    example, given a bitstream with temporal IDs and with b-frames =
                         1 (i.e. IbPbPb
                    display order), a decoder could decode all the frames for full frame rate output
                    or only the I and P frames (lowest temporal layer) for a half frame rate output.

                    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                    vertical subdivision of the encoded pictures.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                    units doesn't matter in your workflow, ignore this setting. Use this setting
                    only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                    container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                    your output compliant with the following specification: ISO IECJTC1 SC29 N13798
                    Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
                    parameter set NAL units in the sample headers but not in the samples directly.
                    For MP4 outputs, when you choose HVC1, your output video might not work properly
                    with some downstream systems and video players. The service defaults to marking
                    your output as HEV1. For these outputs, the service writes parameter set NAL
                    units directly into the samples.

                  - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value MPEG2.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                    level for the video output.

                    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                    MPEG-2 profile for the video output.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **IntraDcPrecision** *(string) --* Use Intra DC precision
                    (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                    coefficients. If you choose the value auto, the service will automatically
                    select the precision based on the per-frame compression ratio.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                    video encoding.

                    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                    to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                    356M-2001).

                    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                  - **ProresSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value PRORES.

                    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                    the type of Apple ProRes codec to use for this output.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                    that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateNumerator to specify the
                    numerator of this fraction. In this example, use 24000 for the value of
                    FramerateNumerator.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                    determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                    to use the pixel aspect ratio from the input. To specify a different pixel
                    aspect ratio: Using the console, choose it from the dropdown menu. Using the
                    API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                    (ParDenominator).

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
                color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
                this output. If you don't specify a value, the service sets this to Insert by
                default.

                - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
                the service will include in the output video frame.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                feature is enabled, the service will use drop-frame timecode on outputs. If it is
                not possible to use drop-frame timecode, the system will fall back to
                non-drop-frame. This setting is enabled by default when Timecode insertion
                (TimecodeInsertion) is enabled.

                - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
                Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                service will write on all frames of this video output.

                - **Height** *(integer) --* Use the Height (Height) setting to define the video
                resolution height for this output. Specify in pixels. If you don't provide a value
                here, the service will use the input height.

                - **Position** *(dict) --* Use Selection placement (position) to define the video
                area in your output frame. The area outside of the rectangle that you specify here
                is black.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                the service changes the video itself in response to AFD values in the input. *
                Choose Respond to clip the input video frame according to the AFD value, input
                display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                include the input AFD values. Do not choose this when AfdSignaling is set to (NONE).
                A preferred implementation of this workflow is to set RespondToAfd to (NONE) and set
                AfdSignaling to (AUTO). * Choose None to remove all input AFD values from this
                output.

                - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                have a different aspect ratio from the input aspect ratio. Choose Stretch to output
                (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
                setting Default (DEFAULT) to have the service letterbox your video instead. This
                setting overrides any value that you specify for the setting Selection placement
                (position) in this output.

                - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                strength of anti-aliasing. This setting changes the width of the anti-alias filter
                kernel used for scaling. Sharpness only applies if your output resolution is
                different from your input resolution. 0 is the softest setting, 100 the sharpest,
                and 50 recommended for most content.

                - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                ProRes outputs. Only enable Timecode insertion when the input frame rate is
                identical to the output frame rate. To include timecodes in this output, set
                Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                output, by default, it uses any embedded timecodes from the input. If none are
                present, the service will set the timecode for the first output frame to zero. To
                change this default behavior, adjust the settings under Timecode configuration
                (TimecodeConfig). In the console, these settings are located under Job > Job
                settings > Timecode configuration. Note - Timecode source under input settings
                (InputTimecodeSource) does not affect the timecodes that are inserted in the output.
                Source under Job settings > Timecode configuration (TimecodeSource) does.

                - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                Preprocessors (VideoPreprocessors). Enable the features at each output individually.
                These features are disabled by default.

                  - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                  feature if necessary. Enable or disable this feature for each output individually.
                  This setting is disabled by default.

                    - **Brightness** *(integer) --* Brightness level.

                    - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                    this output. The service supports conversion between HDR formats, between SDR
                    formats, and from SDR to HDR. The service doesn't support conversion from HDR to
                    SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                    video has an HDR format, but visually appears the same as an unconverted output.

                    - **Contrast** *(integer) --* Contrast level.

                    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                    10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                    metadata that you want signaled in the output. These values don't affect the
                    pixel values that are encoded in the video stream. They are intended to help the
                    downstream video player display content in a way that reflects the intentions of
                    the the content creator. When you set Color space conversion
                    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                    must set values for Max frame average light level (maxFrameAverageLightLevel)
                    and Max content light level (maxContentLightLevel); these settings don't have a
                    default value. The default values for the other HDR 10 metadata settings are
                    defined by the P3D65 color space. For more information about MediaConvert HDR
                    jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                      samples in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                      any frame in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance
                      in units of of 0.0001 candelas per square meter.

                      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance
                      in units of of 0.0001 candelas per square meter

                      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                    - **Hue** *(integer) --* Hue in degrees.

                    - **Saturation** *(integer) --* Saturation level.

                  - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                  motion and a clearer picture.

                    - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                    (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                    adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                    (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if
                    your source file includes a ticker, such as a scrolling headline at the bottom
                    of the frame.

                    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                    does not convert frames that are tagged in metadata as progressive. It will only
                    convert those that are tagged as some other type. - When set to
                    FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                    those that are already tagged as progressive. Turn Force mode on only if there
                    is a good chance that the metadata has tagged frames as progressive when they
                    are not progressive. Do not turn on otherwise; processing frames that are
                    already progressive into progressive will probably result in lower quality
                    video.

                    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                    service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                    interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                    progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                  - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                  compatible video output.

                    - **L6Metadata** *(dict) --* Use these settings when you set
                    DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                    your input with new values.

                      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                      that corresponds to the brightest pixel in the entire stream. Measured in
                      nits.

                      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                      metadata that corresponds to the highest frame-average brightness in the
                      entire stream. Measured in nits.

                    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                    handle Dolby Vision MaxCLL and MaxFALL properies.

                    - **Profile** *(string) --* In the current MediaConvert implementation, the
                    Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must
                    contain Dolby Vision frame interleaved data.

                  - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature
                  to include a graphic overlay on your video. Enable or disable this feature for
                  each output individually. This setting is disabled by default.

                    - **InsertableImages** *(list) --* Specify the images that you want to overlay
                    on your video. The images must be PNG or TGA files.

                      - *(dict) --* Settings that specify how your still graphic overlay appears.

                        - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                        image to remain on the output video. This duration includes fade-in time but
                        not fade-out time.

                        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                        between the Start time that you specify for the image insertion and the time
                        that the image appears at full opacity. Full opacity is the level that you
                        specify for the opacity setting. If you don't specify a value for Fade-in,
                        the image will appear abruptly at the overlay start time.

                        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                        between the end of the time that you have specified for the image overlay
                        Duration and when the overlaid image has faded to total transparency. If you
                        don't specify a value for Fade-out, the image will disappear abruptly at the
                        end of the inserted image duration.

                        - **Height** *(integer) --* Specify the height of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        height, the service will crop your overlaid image to fit. To use the native
                        height of the image, keep this setting blank.

                        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                        location of the image that you want to overlay on the video. Use a PNG or
                        TGA file.

                        - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                        inserted image and the left edge of the video frame. Required for any image
                        overlay that you specify.

                        - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                        overlaid image and the top edge of the video frame. Required for any image
                        overlay that you specify.

                        - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                        Images with higher values for Layer appear on top of images with lower
                        values for Layer.

                        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                        the underlying video shows through the inserted image. 0 is transparent and
                        100 is fully opaque. Default is 50.

                        - **StartTime** *(string) --* Specify the timecode of the frame that you
                        want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                        or HH:MM:SS;FF) format. Remember to take into account your timecode source
                        settings.

                        - **Width** *(integer) --* Specify the width of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        width, the service will crop your overlaid image to fit. To use the native
                        width of the image, keep this setting blank.

                  - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                  remove noise from your video output if necessary. Enable or disable this feature
                  for each output individually. This setting is disabled by default.

                    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                    select one of the following spatial image filtering functions. To use this
                    setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                    preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                    Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                    reduction. * Spatial does frequency-domain filtering based on JND principles. *
                    Temporal optimizes video quality for complex motion.

                    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                    spatial filter.

                      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                      reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                      maximum strength.

                      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                      (higher speed), with 0 being the nominal value.

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                    temporal filter.

                      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                      complex motion. Higher values produce stronger temporal filtering. This
                      filters highly complex scenes more aggressively and creates better VQ for low
                      bitrate outputs.

                      - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                      Low setting reduces bit rate at the cost of transcode time, high setting
                      improves transcode time at the cost of bit rate.

                      - **Strength** *(integer) --* Specify the strength of the noise reducing
                      filter on this output. Higher values produce stronger filtering. We recommend
                      the following value ranges, depending on the result that you want: * 0-2 for
                      complexity reduction with minimal sharpness loss * 2-8 for complexity
                      reduction with image preservation * 8-16 for a high level of complexity
                      reduction

                  - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                  output timecode and specified prefix into the output.

                    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                    any burned-in timecode. Valid values are 10, 16, 32, 48.

                    - **Position** *(string) --* Use Position (Position) under under Timecode
                    burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                    output video.

                    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                    any burned-in timecode. For example, a prefix of "EZ-" will result in the
                    timecode "EZ-00:00:00:00". Provide either the characters themselves or the ASCII
                    code equivalents. The supported range of characters is 0x20 through 0x7e. This
                    includes letters, numbers, and all special characters represented on a standard
                    English keyboard.

                - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                in pixels, for this output. If you don't provide a value here, the service will use
                the input width.

      - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
      information from inputs.

        - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
        use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
        the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or
        (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
        Timecode varies depending on your setting for Source (TimecodeSource). * If Source
        (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
        specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
        (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start at
        0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
        Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
        input.

        - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
        within this job. To make sure that your video, audio, captions, and markers are synchronized
        and that time-based features, such as image inserter, work correctly, choose the Timecode
        source option that matches your assets. All timecodes are in a 24-hour format with frame
        number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video.
        If no embedded timecode is in the source, the service will use Start at 0 (ZEROBASED)
        instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. *
        Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other
        than zero. You use Start timecode (Start) to provide this value.

        - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
        (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
        Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

        - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
        stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
        affecting the time and frame number. Provide the new date as a string in the format
        "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
        (InsertProgramDateTime) in the output settings. For example, if the date part of your
        timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
        (TimestampOffset) to 2003-1-25.

      - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
      (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
      enable it here, enable it in each output container, and specify tags and timecodes in ID3
      insertion (Id3Insertion) objects.

        - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

          - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
          specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when
          the tag should be inserted. To insert multiple ID3 tags in your output, create multiple
          instances of ID3 insertion (Id3Insertion).

            - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
            format.

            - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
            format.

    - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
    events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
    MediaConvert sends an update at this interval from the time the service begins processing your
    job to the time it completes the transcode or encounters an error.

    - **Type** *(string) --* A job template can be of two types: system or custom. System or
    built-in job templates can't be modified or deleted by the user.
    """


_ClientGetJobTemplateResponseTypeDef = TypedDict(
    "_ClientGetJobTemplateResponseTypeDef",
    {"JobTemplate": ClientGetJobTemplateResponseJobTemplateTypeDef},
    total=False,
)


class ClientGetJobTemplateResponseTypeDef(_ClientGetJobTemplateResponseTypeDef):
    """
    Type definition for `ClientGetJobTemplate` `Response`

    - **JobTemplate** *(dict) --* A job template is a pre-made set of encoding instructions that you
    can use to quickly create a job.

      - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
      with long, visually complex content.

        - **Mode** *(string) --* Specify the conditions when the service will run your job with
        accelerated transcoding.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **Category** *(string) --* An optional category you create to organize your job templates.

      - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for Job template creation.

      - **Description** *(string) --* An optional description you create for each job template.

      - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the Job template was
      last updated.

      - **Name** *(string) --* A name you create for each job template. Each name must be unique
      within your account.

      - **Priority** *(integer) --* Relative priority on the job.

      - **Queue** *(string) --* Optional. The queue that jobs created from this template are
      assigned to. If you don't specify this, jobs will go to the default queue.

      - **Settings** *(dict) --* JobTemplateSettings contains all the transcode settings saved in
      the template that will be applied to jobs created from it.

        - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
        the input Ad Avail PTS time.

        - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
        overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

          - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
          black. Only bmp and png images are supported.

        - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

          - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
          ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
          uses the manifest conditioning instructions that you provide in the setting MCC XML
          (mccXml).

            - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
            document inside your JSON job settings. Form the XML document as per
            OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning
            instructions in the message that you supply.

          - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
          between the SCTE 35 messages that the transcoder places and the splice points that they
          refer to. If the time between the start of the asset and the SCTE-35 message is less than
          this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

          - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
          SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
          signal processing instructions that you provide in the setting SCC XML (sccXml).

            - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
            inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025.
            The transcoder will use the signal processing instructions in the message that you
            supply. Provide your ESAM SignalProcessingNotification XML document inside your JSON job
            settings. For your MPEG2-TS file outputs, if you want the service to place SCTE-35
            markers at the insertion points you specify in the XML document, you must also enable
            SCTE-35 ESAM (scte35Esam). Note that you can either specify an ESAM XML document or
            enable SCTE-35 passthrough. You can't do both.

        - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
        job. There can only be one input in a job template. Using the API, you can include multiple
        inputs when referencing a job template.

          - *(dict) --* Specified video input in a template.

            - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input
            to combine. An input may have multiple audio selector groups. See "Audio Selector
            Group":#inputs-audio_selector_group for more information.

              - *(string) --*

                - *(dict) --* Group of Audio Selectors

                  - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same
                  input to include in the group. Audio selector names are standardized, based on
                  their order within the input (e.g., "Audio Selector 1"). The audio selector name
                  parameter can be repeated to add any number of audio selectors to the group.

                    - *(string) --*

            - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
            or set of tracks from the input that you will use in your outputs. You can use mutiple
            Audio selectors per input.

              - *(string) --*

                - *(dict) --* Selector for Audio

                  - **CustomLanguageCode** *(string) --* Selects a specific language code from
                  within an audio source, using the ISO 639-2 or ISO 639-3 three-letter language
                  code

                  - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                  set it as the default for the job. The service uses this default for outputs where
                  it can't find the specified input audio. If you don't set a default, those outputs
                  have no audio.

                  - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                  file source.

                  - **LanguageCode** *(string) --* Selects a specific language code from within an
                  audio source.

                  - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                  audio from the input video.

                  - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g.
                  257 selects PID 0x101).

                    - *(integer) --*

                  - **ProgramSelection** *(integer) --* Use this setting for input streams that
                  contain Dolby E, to have the service extract specific program data from the track.
                  To select multiple programs, create multiple selectors with the same Track and
                  different Program numbers. In the console, this setting is visible when you set
                  Selector type to Track. Choose the program number from the dropdown list. If you
                  are sending a JSON file, provide the program ID, which is part of the audio
                  metadata. If your input file has incorrect metadata, you can choose All channels
                  instead of a program number to have the service ignore the program IDs and include
                  all the programs in the track.

                  - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels
                  of one input to match those of another input. This allows you to combine the two
                  files into a single output, one after the other.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **SelectorType** *(string) --* Specifies the type of the audio selector.

                  - **Tracks** *(list) --* Identify a track from the input audio to include in this
                  selector by entering the track index number. To include several tracks in a single
                  audio selector, specify multiple tracks as follows. Using the console, enter a
                  comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                  Specifying directly in your JSON job file, provide the track numbers in an array.
                  For example, "tracks": [1,2,3].

                    - *(integer) --*

            - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
            the captions data from the input that you will use in your outputs. You can use mutiple
            captions selectors per input.

              - *(string) --*

                - *(dict) --* Set up captions in your outputs by first selecting them from your
                input here.

                  - **CustomLanguageCode** *(string) --* The specific language to extract from
                  source, using the ISO 639-2 or ISO 639-3 three-letter language code. If input is
                  SCTE-27, complete this field and/or PID to select the caption language to extract.
                  If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or
                  PID to select the caption language to extract. If input is DVB-Sub that is being
                  passed through, omit this field (and PID field); there is no way to extract a
                  specific language with pass-through captions.

                  - **LanguageCode** *(string) --* The specific language to extract from source. If
                  input is SCTE-27, complete this field and/or PID to select the caption language to
                  extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this
                  field and/or PID to select the caption language to extract. If input is DVB-Sub
                  that is being passed through, omit this field (and PID field); there is no way to
                  extract a specific language with pass-through captions.

                  - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                  SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                  your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                  FileSoureSettings.

                    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions
                    source.

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                      number in the ancillary data track from which to extract captions. Unused for
                      passthrough.

                      - **TerminateCaptions** *(string) --* By default, the service terminates any
                      unterminated captions at the end of each input. If you want the caption to
                      continue onto your next input, disable this setting.

                    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                      PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub
                      content is passed through, regardless of selectors.

                    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel
                      number within the video track from which to extract captions. Unused for
                      passthrough.

                      - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                      for extracting captions. The system only supports one input video track, so
                      this should always be set to '1'.

                      - **TerminateCaptions** *(string) --* By default, the service terminates any
                      unterminated captions at the end of each input. If you want the caption to
                      continue onto your next input, disable this setting.

                    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                    STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption
                    source file. If your caption source is IMSC in an IMF package, use
                    TrackSourceSettings instead of FileSoureSettings.

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **SourceFile** *(string) --* External caption file used for loading
                      captions. Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt',
                      'xml', and 'smi'.

                      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                      captions from the source file.

                    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                    your input captions. The service cannot auto-detect caption format.

                    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                    sources, including Page number.

                      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                      three-digit hexadecimal page number that will be used for Teletext captions.
                      Do not use this setting if you are passing through teletext from the input
                      source to output.

                    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                    are specified by track number. Currently, this is only IMSC captions in an IMF
                    package. If your caption source is IMSC 1.1 in a separate xml file, use
                    FileSourceSettings instead of TrackSourceSettings.

                      - **TrackNumber** *(integer) --* Use this setting to select a single captions
                      track from a source. Track numbers correspond to the order in the captions
                      source file. For IMF sources, track numbering is based on the order that the
                      captions appear in the CPL. For example, use 1 to select the captions asset
                      that is listed first in the CPL. To include more than one captions track in
                      your job outputs, create multiple input captions selectors. Specify one track
                      per selector.

            - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
            service will include in the output video frame. If you specify a value here, it will
            override any value that you specify in the output setting Cropping selection (crop).

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce
            smoother motion in the output. Default is disabled. Only manaully controllable for MPEG2
            and uncompressed video inputs.

            - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise
            from the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and
            uncompressed video inputs.

            - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how
            the transcoding service applies the denoise and deblock filters. You must also enable
            the filters separately, with Denoise (InputDenoiseFilter) and Deblock
            (InputDeblockFilter). * Auto - The transcoding service determines whether to apply
            filtering, depending on input type and quality. * Disable - The input is not filtered.
            This is true even if you use the API to enable them in (InputDeblockFilter) and
            (InputDeblockFilter). * Force - The in put is filtered regardless of input type.

            - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
            magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
            is 0.

            - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
            overlay on your video. Enable or disable this feature for each input individually. This
            setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
            that together specify a portion of the input to be used in the outputs. If you provide
            only a start time, the clip will be the entire input from that point to the end. If you
            provide only an end time, it will be the entire input up to that point. When you specify
            more than one input clip, the transcoding service creates the job outputs by stringing
            the clips together in the order you specify them.

              - *(dict) --* To transcode only portions of your input (clips), include one Input
              clipping (one instance of InputClipping in the JSON job file) for each input clip. All
              input clips you specify will be included in every output of the job.

                - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
                portion of the input you are clipping. The frame corresponding to the End timecode
                value is included in the clip. Start timecode or End timecode may be left blank, but
                not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
                minute, SS is the second, and FF is the frame number. When choosing this value, take
                into account your setting for timecode source under input settings
                (InputTimecodeSource). For example, if you have embedded timecodes that start at
                01:00:00:00 and you want your clip to end six minutes into the video, use
                01:06:00:00.

                - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the
                beginning of the portion of the input you are clipping. The frame corresponding to
                the Start timecode value is included in the clip. Start timecode or End timecode may
                be left blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is
                the hour, MM is the minute, SS is the second, and FF is the frame number. When
                choosing this value, take into account your setting for Input timecode source. For
                example, if you have embedded timecodes that start at 01:00:00:00 and you want your
                clip to begin five minutes into the video, use 01:05:00:00.

            - **Position** *(dict) --* Use Selection placement (position) to define the video area
            in your output frame. The area outside of the rectangle that you specify here is black.
            If you specify a value here, it will override any value that you specify in the output
            setting Selection placement (position). If you specify a value here, this will override
            any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
            (RESPOND). If you specify a value here, this will ignore anything that you specify for
            the setting Scaling Behavior (scalingBehavior).

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
            program from within a multi-program transport stream. Note that Quad 4K is not currently
            supported. Default is the first program within the transport stream. If the program you
            specify doesn't exist, the transcoding service will use this default.

            - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
            inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs
            for audio and video. * Use PSI - Scan only PSI data.

            - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
            input settings (InputTimecodeSource), to specify how the service counts input video
            frames. This input frame count affects only the behavior of features that apply to a
            single input at a time, such as input clipping and synchronizing some captions formats.
            Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at
            zero (ZEROBASED) to start the first frame at zero. Choose Specified start
            (SPECIFIEDSTART) to start the first frame at the timecode that you specify in the
            setting Start timecode (timecodeStart). If you don't specify a value for Timecode
            source, the service will use Embedded by default. For more information about timecodes,
            see https://docs.aws.amazon.com/console/mediaconvert/timecode.

            - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
            for this input's initial frame. To use this setting, you must set the Timecode source
            setting, located under the input settings (InputTimecodeSource), to Specified start
            (SPECIFIEDSTART). For more information about timecodes, see
            https://docs.aws.amazon.com/console/mediaconvert/timecode.

            - **VideoSelector** *(dict) --* Selector for video.

              - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
              animation. Specify which part of this input MediaConvert uses for your outputs. Leave
              this setting set to DISCARD in order to delete the alpha channel and preserve the
              video. Use REMAP_TO_LUMA for this setting to delete the video and map the alpha
              channel to the luma channel of your outputs.

              - **ColorSpace** *(string) --* If your input video has accurate color space metadata,
              or if you don't know about color space, leave this set to the default value Follow
              (FOLLOW). The service will automatically detect your input color space. If your input
              video has metadata indicating the wrong color space, specify the accurate color space
              here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color
              Volume static metadata isn't present in your video stream, or if that metadata is
              present but not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct
              values in the input HDR 10 metadata (Hdr10Metadata) settings. For more information
              about MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the
              input file and the job input settings Color space (ColorSpace) and HDR master display
              information settings(Hdr10Metadata). The Color space usage setting determines which
              takes precedence. Choose Force (FORCE) to use color metadata from the input job
              settings. If you don't specify values for those settings, the service defaults to
              using metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color
              metadata from the source when it is present. If there's no color metadata in your
              input file, the service defaults to using values you specify in the input settings.

              - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
              missing or inaccurate in your input video. Appropriate values vary depending on the
              input video and must be provided by a color grader. The color grader generates these
              values during the HDR 10 mastering process. The valid range for each of these settings
              is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
              settings - When you specify these values, you must also set Color space (ColorSpace)
              to HDR 10 (HDR10). To specify whether the the values you specify here take precedence
              over the values in the metadata of your input file, set Color space usage
              (ColorSpaceUsage). To specify whether color metadata is included in an output, set
              Color metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
              https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input
              file. Specify this value as an integer; the system automatically converts it to the
              hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
              an identifier for a set of data in an MPEG-2 transport stream container.

              - **ProgramNumber** *(integer) --* Selects a specific program from within a
              multi-program transport stream. Note that Quad 4K is not currently supported.

              - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
              your video. You can choose automatic rotation or specify a rotation. You can specify a
              clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is
              .mov or .mp4 and your input has rotation metadata, you can choose Automatic to have
              the service rotate your video according to the rotation specified in the metadata. The
              rotation must be within one degree of 90, 180, or 270 degrees. If the rotation
              metadata specifies any other rotation, the service will default to no rotation. By
              default, the service does no rotation, even if your input video has rotation metadata.
              The service doesn't pass through rotation metadata.

        - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The
        motion graphics that you specify here appear on all outputs in all output groups.

          - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
          unspecified. If your motion graphic asset is a series of .png files, specify the frame
          rate of the overlay in frames per second, as a fraction. For example, specify 24 fps as
          24/1. Make sure that the number of images in your series matches the frame rate and your
          intended overlay duration. For example, if you want a 30-second overlay at 30 fps, you
          should have 900 .png images. This overlay frame rate doesn't need to match the frame rate
          of the underlying video.

            - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
            overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

            - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
            overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

          - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
          overlay on your video. For .png files, provide the file name of the first file in the
          series. Make sure that the names of the .png files end with sequential numbers that
          specify the order that they are played in. For example, overlay_000.png, overlay_001.png,
          overlay_002.png, and so on. The sequence must start at zero, and each image file name must
          have the same number of digits. Pad your initial file names with enough zeros to complete
          the sequence. For example, if the first image is overlay_0.png, there can be only 10
          images in the sequence, with the last image being overlay_9.png. But if the first image is
          overlay_00.png, there can be 100 images in the sequence.

          - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
          providing for your overlay. You can choose either a .mov file or a series of .png files.

          - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic
          overlay on the video frame. Specify in pixels, from the upper-left corner of the frame. If
          you don't specify an offset, the service scales your overlay to the full size of the
          frame. Otherwise, the service inserts the overlay at its native resolution and scales the
          size up or down with any video scaling.

            - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the
            left edge of the video frame.

            - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
            edge of the video frame.

          - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
          or plays only once.

          - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
          (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
          account how you have set up your timecode configuration under both job settings and input
          settings. The simplest way to do that is to set both to start at 0. If you need to set up
          your job to follow timecodes embedded in your source that don't start at zero, make sure
          that you specify a start time that is after the first embedded timecode. For more
          information, see
          https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide
          and input timecode configuration settings in your JSON job settings specification at
          settings>timecodeConfig>source and settings>inputs>timecodeSource.

        - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
        do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
        configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all
        outputs in the job. To enable Nielsen configuration programmatically, include an instance of
        nielsenConfiguration in your JSON job specification. Even if you don't include any children
        of nielsenConfiguration, you still enable the setting.

          - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
          functionality. If you must include this property, set the value to zero.

          - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
          distributor ID that is assigned to your organization by Neilsen.

        - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
        outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS,
        Quicktime, MXF, and no container) are grouped in a single output group as well. Required in
        (OutputGroups) is a group of settings that apply to the whole group. This required object
        depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
        settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
        HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
        MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

          - *(dict) --* Group of outputs

            - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
            the output group. This value is displayed on the console and can make your job settings
            JSON more human-readable. It does not affect your outputs. Use up to twelve characters
            that are either letters, numbers, spaces, or underscores.

            - **Name** *(string) --* Name of the output group

            - **OutputGroupSettings** *(dict) --* Output Group settings, including type

              - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
              Output Group may only contain a single video, audio, or caption output.

                - **AdditionalManifests** *(list) --* By default, the service creates one top-level
                .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group
                in your job. These default manifests reference every output in the output group. To
                create additional top-level manifests that reference a subset of the outputs in the
                output group, specify a list of them here. For each additional manifest that you
                specify, the service creates one HLS manifest and one DASH manifest.

                  - *(dict) --* Specify the details for each pair of HLS and DASH additional
                  manifests that you want the service to generate for this CMAF output group. Each
                  pair of manifests can reference a different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your HLS group is film-name.m3u8. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                    specify a manifestNameModifier that is different from the nameModifier of the
                    output. The service uses the output name modifier to create unique names for the
                    individual variant manifests.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                file at the top level BaseURL element. Can be used if streams are delivered from a
                different URL than the manifest file.

                - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
                which prevents client from saving media segments for later replay.

                - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
                RFC-4281) during m3u8 playlist generation.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* DRM settings.

                  - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                  value represented by a 32-character text string. If this parameter is not set then
                  the Initialization Vector will follow the segment number by default.

                  - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want
                  the service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                  (SAMPLE-AES) or AES_CTR (AES-CTR).

                  - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                  outputs, choose whether the service writes the 128-bit encryption initialization
                  vector in the HLS and DASH manifests.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                  settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                  output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                  settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                    signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                    package. The DASH manifest can currently signal up to three system IDs. For more
                    information, see https://dashif.org/identifiers/content_protection/.

                      - *(string) --*

                    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                    signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                    package. The HLS manifest can currently signal only one system ID. For more
                    information, see https://dashif.org/identifiers/content_protection/.

                      - *(string) --*

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                  - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                  static key provider.

                    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                    the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                    omitted to indicate an implicit value of 'identity'.

                    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                    single positive integer version value or a slash delimited list of version
                    values (1/2/3).

                    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                    32-character hexidecimal string to specify Key Value (StaticKeyValue).

                    - **Url** *(string) --* Relates to DRM implementation. The location of the
                    license server used for protecting content.

                  - **Type** *(string) --* Specify whether your DRM encryption key is static or from
                  a key provider that follows the SPEKE standard. For more information about SPEKE,
                  see https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                Fragment length must be compatible with GOP size and Framerate. Note that fragments
                will end on the next keyframe after this number of seconds, so actual fragment
                length may be longer. When Emit Single File is checked, the fragmentation is
                internal to a single output file and it does not cause the creation of many output
                files as in other output types.

                - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                should use floating point values for segment duration.

                - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
                needed to ensure smooth playout.

                - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                0, unless you are troubleshooting a problem with how devices play back the end of
                your video asset. If you know that player devices are hanging on the final segment
                of your video because the length of your final segment is too short, use this
                setting to specify a minimum final segment length, in seconds. Choose a value that
                is greater than or equal to 1 and less than your segment length. When you specify a
                value for this setting, the encoder will combine any final segment that is shorter
                than the length that you specify with the previous segment. For example, your
                segment length is 3 seconds and your final segment is .5 seconds without a minimum
                final segment length; when you set the minimum final segment length to 1, your final
                segment is 3.5 seconds.

                - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                main. When you choose Main profile (MAIN_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                On-demand (ON_DEMAND_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
                you must also set the output group setting Segment control (SegmentControl) to
                Single file (SINGLE_FILE).

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
                generated, which is internally segmented using the Fragment Length and Segment
                Length. When set to SEGMENTED_FILES, separate segment files will be created.

                - **SegmentLength** *(integer) --* Use this setting to specify the length, in
                seconds, of each individual CMAF segment. This value applies to the whole package;
                that is, to every output in the output group. Note that segments end on the first
                keyframe after this number of seconds, so the actual segment length might be
                slightly longer. If you set Segment control (CmafSegmentControl) to single file, the
                service puts the content of each output in a single file that has metadata that
                marks these segments. If you set it to segmented files, the service creates multiple
                files for each output, each with the content of one segment.

                - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
                video in EXT-X-STREAM-INF tag of variant manifest.

                - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will
                be generated for this output.

                - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
                be generated for this output.

              - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

                - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
                manifest for each DASH ISO output group in your job. This default manifest
                references every output in the output group. To create additional DASH manifests
                that reference a subset of the outputs in the output group, specify a list of them
                here.

                  - *(dict) --* Specify the details for each additional DASH manifest that you want
                  the service to generate for this output group. Each manifest can reference a
                  different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your DASH group is film-name.mpd. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.mpd.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
                from a different URL than the manifest file.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* DRM settings.

                  - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                  compatibility of your output with video players on obsolete devices. It applies
                  only to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI
                  (UNENCRYPTED_SEI) only to correct problems with playback on older devices.
                  Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose Unencrypted
                  SEI, for that output, the service will exclude the access unit delimiter and will
                  leave the SEI NAL units unencrypted.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                Fragment length must be compatible with GOP size and Framerate. Note that fragments
                will end on the next keyframe after this number of seconds, so actual fragment
                length may be longer. When Emit Single File is checked, the fragmentation is
                internal to a single output file and it does not cause the creation of many output
                files as in other output types.

                - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

                - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
                needed to ensure smooth playout.

                - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                main. When you choose Main profile (MAIN_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                On-demand (ON_DEMAND_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
                you must also set the output group setting Segment control (SegmentControl) to
                Single file (SINGLE_FILE).

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
                generated, which is internally segmented using the Fragment Length and Segment
                Length. When set to SEGMENTED_FILES, separate segment files will be created.

                - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds).
                Note that segments will end on the next keyframe after this number of seconds, so
                actual segment length may be longer. When Emit Single File is checked, the
                segmentation is internal to a single output file and it does not cause the creation
                of many output files as in other output types.

                - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
                the 400 range when you play back your DASH output, enable this setting and run your
                transcoding job again. When you enable this setting, the service writes precise
                segment durations in the DASH manifest. The segment duration information appears
                inside the SegmentTimeline element, inside SegmentTemplate at the Representation
                level. When you don't enable this setting, the service writes approximate segment
                durations in your DASH manifest.

              - **FileGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

              - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

                - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your
                Apple HLS manifest. This setting does not determine whether SCTE-35 markers appear
                in the outputs themselves.

                  - *(string) --*

                - **AdditionalManifests** *(list) --* By default, the service creates one top-level
                .m3u8 HLS manifest for each HLS output group in your job. This default manifest
                references every output in the output group. To create additional top-level
                manifests that reference a subset of the outputs in the output group, specify a list
                of them here.

                  - *(dict) --* Specify the details for each additional HLS manifest that you want
                  the service to generate for this output group. Each manifest can reference a
                  different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your HLS group is film-name.m3u8. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                    specify a manifestNameModifier that is different from the nameModifier of the
                    output. The service uses the output name modifier to create unique names for the
                    individual variant manifests.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each
                output in the media .m3u8 file. Can be used if base manifest is delivered from a
                different URL than the main .m3u8 file.

                - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                  - *(dict) --* Caption Language Mapping

                    - **CaptionChannel** *(integer) --* Caption channel.

                    - **CustomLanguageCode** *(string) --* Specify the language for this captions
                    channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                    three-letter code listed at
                    https://www.loc.gov/standards/iso639-2/php/code_list.php.

                    - **LanguageDescription** *(string) --* Caption language description.

                - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
                captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least
                one language in the CC1 Language Code field. One CLOSED-CAPTION line is added for
                each Language Code you specify. Make sure to specify the languages in the order in
                which they appear in the original source (if the source is embedded format) or the
                order of the caption selectors (if the source is other than embedded). Otherwise,
                languages in the manifest will not match up properly with the output captions. None:
                Include CLOSED-CAPTIONS=
                    NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS
                line from the manifest.

                - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
                which prevents client from saving media segments for later replay.

                - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
                RFC-4281) during m3u8 playlist generation.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **DirectoryStructure** *(string) --* Indicates whether segments should be placed
                in subdirectories.

                - **Encryption** *(dict) --* DRM settings.

                  - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                  value represented by a 32-character text string. If this parameter is not set then
                  the Initialization Vector will follow the segment number by default.

                  - **EncryptionMethod** *(string) --* Encrypts the segments with the given
                  encryption scheme. Leave blank to disable. Selecting 'Disabled' in the web
                  interface also disables encryption.

                  - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                  128-bit number used in conjunction with the key for encrypting blocks. If set to
                  INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                  Vector is not in the manifest.

                  - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                  EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                  HLS FairPlay content protection.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                  - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                  static key provider.

                    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                    the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                    omitted to indicate an implicit value of 'identity'.

                    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                    single positive integer version value or a slash delimited list of version
                    values (1/2/3).

                    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                    32-character hexidecimal string to specify Key Value (StaticKeyValue).

                    - **Url** *(string) --* Relates to DRM implementation. The location of the
                    license server used for protecting content.

                  - **Type** *(string) --* Specify whether your DRM encryption key is static or from
                  a key provider that follows the SPEKE standard. For more information about SPEKE,
                  see https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                should use floating point values for segment duration.

                - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                0, unless you are troubleshooting a problem with how devices play back the end of
                your video asset. If you know that player devices are hanging on the final segment
                of your video because the length of your final segment is too short, use this
                setting to specify a minimum final segment length, in seconds. Choose a value that
                is greater than or equal to 1 and less than your segment length. When you specify a
                value for this setting, the encoder will combine any final segment that is shorter
                than the length that you specify with the previous segment. For example, your
                segment length is 3 seconds and your final segment is .5 seconds without a minimum
                final segment length; when you set the minimum final segment length to 1, your final
                segment is 3.5 seconds.

                - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
                looking ahead and back within the specified range for a nearby avail and extending
                the segment size if needed.

                - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
                be generated for this HLS output group.

                - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
                in .m3u8 manifest files. The value is calculated as follows: either the program date
                and time are initialized using the input timecode source, or the time is initialized
                using the input timecode source and the date is initialized using the
                timestamp_offset.

                - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
                EXT-X-PROGRAM-DATE-TIME entry, in seconds.

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a
                single media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for
                playback.

                - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
                create (in seconds). Note that segments will end on the next keyframe after this
                number of seconds, so actual segment length may be longer.

                - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
                subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
                for this setting to have an effect.

                - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
                video in EXT-X-STREAM-INF tag of variant manifest.

                - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

                - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

                - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
                offset to fine tune the timestamps.

              - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

                - **AdditionalManifests** *(list) --* By default, the service creates one .ism
                Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
                in your job. This default manifest references every output in the output group. To
                create additional manifests that reference a subset of the outputs in the output
                group, specify a list of them here.

                  - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                  manifest that you want the service to generate for this output group. Each
                  manifest can reference a different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your Microsoft Smooth group is film-name.ismv. If you
                    enter "-no-premium" for this setting, then the file name the service generates
                    for this top-level manifest is film-name-no-premium.ismv.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
                audio encoding settings across a Microsoft Smooth output group into a single audio
                stream.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* If you are using DRM, set DRM System
                (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
                the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
                and frame rate.

                - **ManifestEncoding** *(string) --* Use Manifest encoding
                (MsSmoothManifestEncoding) to specify the encoding format for the server and client
                manifest. Valid options are utf8 and utf16.

              - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
              Microsoft Smooth Streaming, CMAF)

            - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
            settings per output.

              - *(dict) --* An output object describes the settings for a single output file or
              stream in an output group.

                - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
                encoding settings organized by audio codec. Include one instance of
                (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
                encoding settings.

                  - *(dict) --* Description of audio output

                    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                    settings. Ignore these settings unless you need to comply with a loudness
                    standard.

                      - **Algorithm** *(string) --* Choose one of the following audio normalization
                      algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated
                      average loudness for an entire piece of content, suitable for measurement of
                      short-form content under ATSC recommendation A/85. Supports up to 5.1 audio
                      channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
                      loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
                      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement
                      algorithm as 1770-2, with an updated true peak measurement. ITU-R BS.1770-4:
                      Higher channel count. Allows for more audio channels than the other
                      algorithms, including configurations such as 7.1.

                      - **AlgorithmControl** *(string) --* When enabled the output audio is
                      corrected using the chosen algorithm. If disabled, the audio will be measured
                      but not adjusted.

                      - **CorrectionGateLevel** *(integer) --* Content measuring above this level
                      will be corrected to the target level. Content measuring below this level will
                      not be corrected. Gating only applies when not using real_time_correction.

                      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio
                      track loudness to a CSV file.

                      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                      TruePeak for each output's audio track loudness.

                      - **TargetLkfs** *(float) --* When you use Audio normalization
                      (AudioNormalizationSettings), optionally use this setting to specify a target
                      loudness. If you don't specify a value here, the encoder chooses a value for
                      you, based on the algorithm that you choose for Algorithm (algorithm). If you
                      choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                      encoder will choose -23 LKFS.

                    - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                    input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector
                    by name based on its order within each input. For example if you specify "Audio
                    Selector 3", then the third audio selector will be used from each input. If an
                    input does not have an "Audio Selector 3", then the audio selector marked as
                    "default" in that input will be used. If there is no audio selector marked as
                    "default", silence will be inserted for the duration of that input.
                    Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may
                    be specified, with similar default/silence behavior. If no audio_source_name is
                    specified, then "Audio Selector 1" will be chosen automatically.

                    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                    unchecked (false). A number between 0 and 255. The following are defined in
                    ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                         Hearing Impaired, 3 =
                    Visually Impaired Commentary, 4-255 = Reserved.

                    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                    contains an ISO 639 audio_type, then that value is passed through to the output.
                    If the input contains no ISO 639 audio_type, the value in Audio Type is included
                    in the output. Otherwise the value in Audio Type is included in the output. Note
                    that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                    is set to BROADCASTER_MIXED_AD.

                    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                    (AudioDescriptions) contains the group of settings related to audio encoding.
                    The settings in this group vary depending on the value that you choose for Audio
                    codec (Codec). For each codec enum that you choose, define the corresponding
                    settings object. The following lists the codec enum, settings object pairs. *
                    AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
                    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                      - **AacSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one
                      of two mutually exclusive groups of AAC settings--VBR and CBR. To select one
                      of these modes, set the value of Bitrate control mode (rateControlMode) to
                      "VBR" or "CBR". In VBR mode, you control the audio quality with the setting
                      VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate).
                      Defaults and valid values depend on the rate control mode.

                        - **AudioDescriptionBroadcasterMix** *(string) --* Choose
                        BROADCASTER_MIXED_AD when the input contains pre-mixed main audio + audio
                        description (AD) as a stereo pair. The value for AudioType will be set to 3,
                        which signals to downstream systems that this stream contains "broadcaster
                        mixed AD". Note that the input received by the encoder must contain
                        pre-mixed audio; the encoder does not perform the mixing. When you choose
                        BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                        AudioType and FollowInputAudioType. Choose NORMAL when the input does not
                        contain pre-mixed audio + audio description (AD). In this case, the encoder
                        will use any values you provide for AudioType and FollowInputAudioType.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        The set of valid values for this setting is: 6000, 8000, 10000, 12000,
                        14000, 16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000,
                        96000, 112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000,
                        384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value
                        you set is also constrained by the values that you choose for Profile
                        (codecProfile), Bitrate control mode (codingMode), and Sample rate
                        (sampleRate). Default values depend on Bitrate control mode and Profile.

                        - **CodecProfile** *(string) --* AAC Profile.

                        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or
                        5.1 channel layout. Valid values depend on rate control mode and profile.
                        "1.0 - Audio Description (Receiver Mix)" setting receives a stereo
                        description plus control track and emits a mono AAC encode of the
                        description track, with control data emitted in the PES header as per ETSI
                        TS 101 154 Annex E.

                        - **RateControlMode** *(string) --* Rate Control Mode.

                        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                        use LATM/LOAS AAC in an output, you must choose "No container" for the
                        output container.

                        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on
                        rate control mode and profile.

                        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                        for raw or MPEG-2 Transport Stream containers.

                        - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                        rate_control_mode is VBR.

                      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AC3.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid bitrates depend on the coding mode.

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                        stream that the encoder emits. For more information about the AC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number
                        of channels.

                        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                        input audio is Dolby Digital, dialnorm will be passed through.

                        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                        adds dynamic range compression signaling to the output bitstream as defined
                        in the Dolby Digital specification.

                        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                        channel prior to encoding. Only valid with 3_2_LFE coding mode.

                        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                        metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                        this audio data. If audio was not supplied from one of these streams, then
                        the static metadata settings will be used.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                      - **AiffSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AIFF.

                        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                        sample, to choose the encoding quality for this audio track.

                        - **Channels** *(integer) --* Specify the number of channels in this output
                        audio track. Valid values are 1 and even numbers up to 64. For example, 1,
                        2, 4, 6, and so on, up to 64.

                        - **SampleRate** *(integer) --* Sample rate in hz.

                      - **Codec** *(string) --* Type of Audio codec.

                      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid values: 384k, 448k, 640k, 768k

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                        stream that the encoder emits. For more information about the EAC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                        (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence
                        to adjust loudness based on dialogue analysis.

                        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                        level for a signal with dynamic range compression.

                        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                        the audio dynamic range when compressing the audio.

                        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left only/Right only center mix (Lo/Ro center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and
                        -6.0.

                        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert
                        uses this value for downmixing. How the service uses this value depends on
                        the value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                        values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left total/Right total center mix (Lt/Rt center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and
                        -6.0.

                        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                        value -60 mutes the channel.

                        - **MeteringMode** *(string) --* Choose how the service meters the loudness
                        of your audio.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                        that must be speech before the encoder uses the measured speech loudness as
                        the overall program loudness.

                        - **StereoDownmix** *(string) --* Choose how the service does stereo
                        downmixing.

                        - **SurroundExMode** *(string) --* Specify whether your input audio has an
                        additional center rear surround channel matrix encoded into your left and
                        right surround channels.

                      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value EAC3.

                        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                        dB attenuation to the surround channels. Only used for 3/2 coding mode.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid bitrates depend on the coding mode.

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                        stream that the encoder emits. For more information about the EAC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                        number of channels.

                        - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                        channels.

                        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                        input audio is Dolby Digital Plus, dialnorm will be passed through.

                        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                        level for a signal with dynamic range compression.

                        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                        the audio dynamic range when compressing the audio.

                        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                        LFE channel is enabled

                        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                        channel prior to encoding. Only valid with 3_2_LFE coding mode.

                        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                        Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                        mutes the channel. This setting applies only if you keep the default value
                        of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                        (Eac3CodingMode). If you choose a different value for Coding mode, the
                        service ignores Left only/Right only center (loRoCenterMixLevel).

                        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                        Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                        channel. This setting applies only if you keep the default value of 3/2 - L,
                        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                        If you choose a different value for Coding mode, the service ignores Left
                        only/Right only surround (loRoSurroundMixLevel).

                        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left total/Right total center mix (Lt/Rt
                        center). MediaConvert uses this value for downmixing. How the service uses
                        this value depends on the value that you choose for Stereo downmix
                        (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                        and -60. The value -60 mutes the channel. This setting applies only if you
                        keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                        setting Coding mode (Eac3CodingMode). If you choose a different value for
                        Coding mode, the service ignores Left total/Right total center
                        (ltRtCenterMixLevel).

                        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                        surround). MediaConvert uses this value for downmixing. How the service uses
                        this value depends on the value that you choose for Stereo downmix
                        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                        value -60 mutes the channel. This setting applies only if you keep the
                        default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                        Coding mode (Eac3CodingMode). If you choose a different value for Coding
                        mode, the service ignores Left total/Right total surround
                        (ltRtSurroundMixLevel).

                        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                        metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                        this audio data. If audio was not supplied from one of these streams, then
                        the static metadata settings will be used.

                        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                        audio will be passed through if it is present on the input. this detection
                        is dynamic over the life of the transcode. Inputs that alternate between DD+
                        and non-DD+ content will have a consistent DD+ output as the system
                        alternates between passthrough and encoding.

                        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied
                        to the surround channels. Only used for 3/2 coding mode.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                        - **StereoDownmix** *(string) --* Choose how the service does stereo
                        downmixing. This setting only applies if you keep the default value of 3/2 -
                        L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                        (Eac3CodingMode). If you choose a different value for Coding mode, the
                        service ignores Stereo downmix (Eac3StereoDownmix).

                        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                        extra center back surround channel is matrix encoded into the left and right
                        surround channels.

                        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                        Surround is matrix encoded into the two channels.

                      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value MP2.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                        - **Channels** *(integer) --* Set Channels to specify the number of channels
                        in this output audio track. Choosing Mono in the console will give you 1
                        output channel; choosing Stereo will give you 2. In the API, valid values
                        are 1 and 2.

                        - **SampleRate** *(integer) --* Sample rate in hz.

                      - **WavSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value WAV.

                        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                        sample, to choose the encoding quality for this audio track.

                        - **Channels** *(integer) --* Specify the number of channels in this output
                        audio track. Valid values are 1 and even numbers up to 64. For example, 1,
                        2, 4, 6, and so on, up to 64.

                        - **Format** *(string) --* The service defaults to using RIFF for WAV
                        outputs. If your output audio is likely to exceed 4 GB in file size, or if
                        you otherwise need the extended support of the RF64 format, set your output
                        WAV file format to RF64.

                        - **SampleRate** *(integer) --* Sample rate in Hz.

                    - **CustomLanguageCode** *(string) --* Specify the language for this audio
                    output track. The service puts this language code into your output audio track
                    when you set Language code control (AudioLanguageCodeControl) to Use configured
                    (USE_CONFIGURED). The service also uses your specified custom language code when
                    you set Language code control (AudioLanguageCodeControl) to Follow input
                    (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                    can also use any other code in the full RFC-5646 specification. Streaming
                    outputs are those that are in one of the following output groups: CMAF, DASH
                    ISO, Apple HLS, or Microsoft Smooth Streaming.

                    - **LanguageCode** *(string) --* Indicates the language of the audio output
                    track. The ISO 639 language specified in the 'Language Code' drop down will be
                    used when 'Follow Input Language Code' is not selected or when 'Follow Input
                    Language Code' is selected but there is no ISO 639 language code specified by
                    the input.

                    - **LanguageCodeControl** *(string) --* Specify which source for language code
                    takes precedence for this audio track. When you choose Follow input
                    (FOLLOW_INPUT), the service uses the language code from the input track if it's
                    present. If there's no languge code on the input track, the service uses the
                    code that you specify in the setting Language code (languageCode or
                    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
                    service uses the language code that you specify.

                    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                      group of fields that hold the remixing value for each channel. Units are in
                      dB. Acceptable values are within the range from -60 (mute) through 6. A
                      setting of 0 passes the input channel unchanged to the output channel (no
                      attenuation or amplification).

                        - **OutputChannels** *(list) --* List of output channels

                          - *(dict) --* OutputChannel mapping settings.

                            - **InputChannels** *(list) --* List of input channels

                              - *(integer) --*

                      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                      input that you want to use in your output. With remixing, you might combine or
                      split the data in these channels, so the number of channels in your final
                      output might be different.

                      - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                      after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                    - **StreamName** *(string) --* Specify a label for this output audio stream. For
                    example, "English", "Director commentary", or "track_2". For streaming outputs,
                    MediaConvert passes this information into destination manifests for display on
                    the end-viewer's player device. For outputs in other output groups, the service
                    ignores this setting.

                - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
                captions settings. For each output that has captions, include one instance of
                (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
                settings.

                  - *(dict) --* Description of Caption output

                    - **CaptionSelectorName** *(string) --* Specifies which "Caption
                    Selector":#inputs-caption_selector to use from each input when generating
                    captions. The name should be of the format "Caption Selector ", which denotes
                    that the Nth Caption Selector will be used from each input.

                    - **CustomLanguageCode** *(string) --* Specify the language for this captions
                    output track. For most captions output formats, the encoder puts this language
                    information in the output captions metadata. If your output captions format is
                    DVB-Sub or Burn in, the encoder uses this language information when
                    automatically selecting the font script for rendering the captions text. For all
                    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                    can also use any other code in the full RFC-5646 specification. Streaming
                    outputs are those that are in one of the following output groups: CMAF, DASH
                    ISO, Apple HLS, or Microsoft Smooth Streaming.

                    - **DestinationSettings** *(dict) --* Specific settings required by destination
                    type. Note that burnin_destination_settings are not available if the source of
                    the caption data is Embedded or Teletext.

                      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                        - **Alignment** *(string) --* If no explicit x_position or y_position is
                        provided, setting alignment to centered will place the captions at the
                        bottom center of the output. Similarly, setting a left alignment will align
                        captions to the bottom left of the output. If x and y positions are given in
                        conjunction with the alignment parameter, the font will be justified (either
                        left or centered) relative to those coordinates. This option is not valid
                        for source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                        behind the captions. All burn-in and DVB-Sub font settings must match.

                        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                        background rectangle. 255 is opaque; 0 is transparent. Leaving this
                        parameter blank is equivalent to setting it to 0 (transparent). All burn-in
                        and DVB-Sub font settings must match.

                        - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                        This option is not valid for source captions that are STL, 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                        captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                        settings must match.

                        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                        default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                        - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                        script code, if the LanguageCode is not sufficient for determining the
                        script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                        "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                        font for rendering burn-in captions.

                        - **FontSize** *(integer) --* A positive integer indicates the exact font
                        size in points. Set to 0 for automatic font size selection. All burn-in and
                        DVB-Sub font settings must match.

                        - **OutlineColor** *(string) --* Specifies font outline color. This option
                        is not valid for source captions that are either 608/embedded or teletext.
                        These source settings are already pre-defined by the caption stream. All
                        burn-in and DVB-Sub font settings must match.

                        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                        option is not valid for source captions that are either 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                        the captions. All burn-in and DVB-Sub font settings must match.

                        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255
                        is opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                        setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                        match.

                        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                        must match.

                        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels above the text. All burn-in and DVB-Sub font settings
                        must match.

                        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                        in Teletext or STL formats. Specify whether the spacing between letters in
                        your captions is set by the captions grid or varies depending on letter
                        width. Choose fixed grid to conform to the spacing specified in the captions
                        file more accurately. Choose proportional to make the text easier to read if
                        the captions are closed caption.

                        - **XPosition** *(integer) --* Specifies the horizontal position of the
                        caption relative to the left side of the output in pixels. A value of 10
                        would result in the captions starting 10 pixels from the left of the output.
                        If no explicit x_position is provided, the horizontal caption position will
                        be determined by the alignment parameter. This option is not valid for
                        source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **YPosition** *(integer) --* Specifies the vertical position of the
                        caption relative to the top of the output in pixels. A value of 10 would
                        result in the captions starting 10 pixels from the top of the output. If no
                        explicit y_position is provided, the caption will be positioned towards the
                        bottom of the output. This option is not valid for source captions that are
                        STL, 608/embedded or teletext. These source settings are already pre-defined
                        by the caption stream. All burn-in and DVB-Sub font settings must match.

                      - **DestinationType** *(string) --* Specify the format for this set of
                      captions on this output. The default format is embedded without SCTE-20. Other
                      options are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext,
                      TTML, and web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                      (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
                      spec. To create a non-compliant output where the embedded captions come first,
                      choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                        - **Alignment** *(string) --* If no explicit x_position or y_position is
                        provided, setting alignment to centered will place the captions at the
                        bottom center of the output. Similarly, setting a left alignment will align
                        captions to the bottom left of the output. If x and y positions are given in
                        conjunction with the alignment parameter, the font will be justified (either
                        left or centered) relative to those coordinates. This option is not valid
                        for source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                        behind the captions. All burn-in and DVB-Sub font settings must match.

                        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                        background rectangle. 255 is opaque; 0 is transparent. Leaving this
                        parameter blank is equivalent to setting it to 0 (transparent). All burn-in
                        and DVB-Sub font settings must match.

                        - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                        This option is not valid for source captions that are STL, 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                        captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                        settings must match.

                        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                        default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                        - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                        script code, if the LanguageCode is not sufficient for determining the
                        script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                        "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                        font for rendering DVB-Sub captions.

                        - **FontSize** *(integer) --* A positive integer indicates the exact font
                        size in points. Set to 0 for automatic font size selection. All burn-in and
                        DVB-Sub font settings must match.

                        - **OutlineColor** *(string) --* Specifies font outline color. This option
                        is not valid for source captions that are either 608/embedded or teletext.
                        These source settings are already pre-defined by the caption stream. All
                        burn-in and DVB-Sub font settings must match.

                        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                        option is not valid for source captions that are either 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                        the captions. All burn-in and DVB-Sub font settings must match.

                        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255
                        is opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                        setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                        match.

                        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                        must match.

                        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels above the text. All burn-in and DVB-Sub font settings
                        must match.

                        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                        standard or for hearing impaired. Choose hearing impaired if your subtitles
                        include audio descriptions and dialogue. Choose standard if your subtitles
                        include only dialogue.

                        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                        in Teletext or STL formats. Specify whether the spacing between letters in
                        your captions is set by the captions grid or varies depending on letter
                        width. Choose fixed grid to conform to the spacing specified in the captions
                        file more accurately. Choose proportional to make the text easier to read if
                        the captions are closed caption.

                        - **XPosition** *(integer) --* Specifies the horizontal position of the
                        caption relative to the left side of the output in pixels. A value of 10
                        would result in the captions starting 10 pixels from the left of the output.
                        If no explicit x_position is provided, the horizontal caption position will
                        be determined by the alignment parameter. This option is not valid for
                        source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **YPosition** *(integer) --* Specifies the vertical position of the
                        caption relative to the top of the output in pixels. A value of 10 would
                        result in the captions starting 10 pixels from the top of the output. If no
                        explicit y_position is provided, the caption will be positioned towards the
                        bottom of the output. This option is not valid for source captions that are
                        STL, 608/embedded or teletext. These source settings are already pre-defined
                        by the caption stream. All burn-in and DVB-Sub font settings must match.

                      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                      embedded/ancillary caption outputs, including 608/708 Channel destination
                      number.

                        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                        your input captions are SCC format and your output captions are embedded in
                        the video stream. Specify a CC number for each captions channel in this
                        output. If you have two channels, choose CC numbers that aren't in the same
                        field. For example, choose 1 and 3. For more information, see
                        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                        your input captions are SCC format and you want both 608 and 708 captions
                        embedded in your output stream. Optionally, specify the 708 service number
                        for each output captions channel. Choose a different number for each
                        channel. To use this setting, also set Force 608 to 708 upconvert
                        (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
                        settings. If you choose to upconvert but don't specify a 708 service number,
                        MediaConvert uses the number that you specify for CC channel number
                        (destination608ChannelNumber) for the 708 service number. For more
                        information, see
                        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                      outputs.

                        - **StylePassthrough** *(string) --* Keep this setting enabled to have
                        MediaConvert use the font style and position information from the captions
                        source in the output. This option is available only when your input captions
                        are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                        output captions.

                      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to
                        make sure that the captions and the video are synchronized in the output.
                        Specify a frame rate that matches the frame rate of the associated video. If
                        the video frame rate is 29.97, choose 29.97 dropframe
                        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
                        drop_frame_timecode=
                            true; otherwise, choose 29.97 non-dropframe
                        (FRAMERATE_29_97_NON_DROPFRAME).

                      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                      output

                        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number
                        for the destination captions for this output. This value must be a
                        three-digit hexadecimal string; strings ending in -FF are invalid. If you
                        are passing through the entire set of Teletext data, do not use this field.

                        - **PageTypes** *(list) --* Specify the page types for this Teletext page.
                        If you don't specify a value here, the service sets the page type to the
                        default value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire
                        set of Teletext data, don't use this field. When you pass through a set of
                        Teletext pages, your output has the same page types as your input.

                          - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                          Table 94

                      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                      outputs, including Pass style information (TtmlStylePassthrough).

                        - **StylePassthrough** *(string) --* Pass through style and position
                        information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                        CFF-TT output or TTML output.

                    - **LanguageCode** *(string) --* Specify the language of this captions output
                    track. For most captions output formats, the encoder puts this language
                    information in the output captions metadata. If your output captions format is
                    DVB-Sub or Burn in, the encoder uses this language information to choose the
                    font language for rendering the captions text.

                    - **LanguageDescription** *(string) --* Specify a label for this set of output
                    captions. For example, "English", "Director commentary", or "track_2". For
                    streaming outputs, MediaConvert passes this information into destination
                    manifests for display on the end-viewer's player device. For outputs in other
                    output groups, the service ignores this setting.

                - **ContainerSettings** *(dict) --* Container specific settings.

                  - **Container** *(string) --* Container for this output. Some containers require a
                  container settings object. If not specified, the default object will be created.

                  - **F4vSettings** *(dict) --* Settings for F4v container

                    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom
                    is relocated to the beginning of the archive as required for progressive
                    downloading. Otherwise it is placed normally at the end.

                  - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to
                  outputs in a File output group when the output's container (ContainerType) is
                  MPEG-2 Transport Stream (M2TS). In these assets, data is organized by the program
                  map table (PMT). Each transport stream program contains subsets of data, including
                  audio, video, and metadata. Each of these subsets of data has a numerical label
                  called a packet identifier (PID). Each transport stream program corresponds to one
                  MediaConvert output. The PMT lists the types of data in a program along with their
                  PID. Downstream systems and players use the program map table to look up the PID
                  for each type of data it accesses and then uses the PIDs to locate specific data
                  within the asset.

                    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                    models for Dolby Digital audio.

                    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                    each PES packet.

                    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                    elementary audio streams you include in this output. Specify multiple PIDs as a
                    JSON array. Default is the range 482-492.

                      - *(integer) --*

                    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream
                    in bits per second. Setting to 0 lets the muxer automatically determine the
                    appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                    - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                    interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                    this can lead to lower latency, but low-memory devices may not be able to play
                    back the stream without interruptions.

                    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                    the specified table repetition interval.

                      - **NetworkId** *(integer) --* The numeric value placed in the Network
                      Information Table (NIT).

                      - **NetworkName** *(string) --* The network name text placed in the
                      network_name_descriptor inside the Network Information Table. Maximum length
                      is 256 characters.

                      - **NitInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                    the specified table repetition interval.

                      - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                      output stream. "Follow input SDT" copies SDT information from input stream to
                      output stream. "Follow input SDT if present" copies SDT information from input
                      stream to output stream if SDT information is present in the input, otherwise
                      it will fall back on the user-defined values. Enter "SDT Manually" means user
                      will enter the SDT information. "No SDT" means output stream will not contain
                      SDT information.

                      - **SdtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **ServiceName** *(string) --* The service name placed in the
                      service_descriptor in the Service Description Table. Maximum length is 256
                      characters.

                      - **ServiceProviderName** *(string) --* The service provider name placed in
                      the service_descriptor in the Service Description Table. Maximum length is 256
                      characters.

                    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                    subtitle data included in this output. Specify multiple PIDs as a JSON array.
                    Default is the range 460-479.

                      - *(integer) --*

                    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                    specified table repetition interval.

                      - **TdtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                    teletext data you include in this output. Default is 499.

                    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS,
                    audio EBP markers will be added to partitions 3 and 4. The interval between
                    these additional markers will be fixed, and will be slightly shorter than the
                    video EBP marker interval. When set to VIDEO_INTERVAL, these additional markers
                    will not be inserted. Only applicable when EBP segmentation markers are is
                    selected (segmentationMarkers is EBP or EBP_LEGACY).

                    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on.
                    They can either be placed only on the video PID, or on both the video PID and
                    all audio PIDs. Only applicable when EBP segmentation markers are is selected
                    (segmentationMarkers is EBP or EBP_LEGACY).

                    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                    the PES header.

                    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                    you know that your audio EBP markers are incorrectly appearing before your video
                    EBP markers. To correct this problem, set this value to Force (FORCE).

                    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                    used with EBP markers.

                    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                    between Program Clock References (PCRs) inserted into the transport stream.

                    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                    Points do not come within the specified time interval of each other by looking
                    ahead at input video. If another EBP is going to come in within the specified
                    time interval, the current EBP is not emitted, and the segment is "stretched" to
                    the next marker. The lookahead value does not add latency to the system. The
                    Live Event must be configured elsewhere to create sufficient latency to make the
                    lookahead accurate.

                    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                    tracking will be detected in the input audio and an equivalent ID3 tag will be
                    inserted in the output.

                    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                    packets to insert into the transport stream. This can be used if a downstream
                    encryption system requires periodic null packets.

                    - **PatInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                    Reference value is inserted for every Packetized Elementary Stream (PES) header.
                    This is effective only when the PCR PID is the same as the video or audio
                    elementary stream.

                    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                    clock reference (PCR) in this output. If you do not specify a value, the service
                    will use the value for Video PID (VideoPid).

                    - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                    instances of the program map table (PMT) in the output transport stream.

                    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                    map table (PMT) itself. Default is 480.

                    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of
                    the private metadata stream. Default is 503.

                    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                    the program number used in the program map table (PMT) for this output. Default
                    is 1. Program numbers and program map tables are parts of MPEG-2 transport
                    stream containers, used for organizing data.

                    - **RateMode** *(string) --* When set to CBR, inserts null packets into
                    transport stream to fill specified bitrate. When set to VBR, the bitrate setting
                    acts as the maximum bitrate, but the output will not be padded up to that
                    bitrate.

                    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                    markers in your HLS and transport stream outputs at the insertion points that
                    you specify in an ESAM XML document. Provide the document in the setting SCC XML
                    (sccXml).

                      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35
                      stream in the transport stream generated by ESAM.

                    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the
                    SCTE-35 stream in the transport stream.

                    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                    Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input
                    to also appear in this output. Choose None (NONE) if you don't want SCTE-35
                    markers in this output. For SCTE-35 markers from an ESAM XML document-- Choose
                    None (NONE). Also provide the ESAM XML as a string in the setting Signal
                    processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
                    property scte35Esam).

                    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                    segmentation_time period. rai_segstart sets the Random Access Indicator bit in
                    the adaptation field. rai_adapt sets the RAI bit and adds the current timecode
                    in the private data bytes. psi_segstart inserts PAT and PMT tables at the start
                    of segments. ebp adds Encoder Boundary Point information to the adaptation field
                    as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
                    Boundary Point information to the adaptation field using a legacy proprietary
                    format.

                    - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                    how segmentation markers are inserted into the transport stream. With avails, it
                    is possible that segments may be truncated, which can influence where future
                    segmentation markers are inserted. When a segmentation style of "reset_cadence"
                    is selected and a segment is truncated due to an avail, we will reset the
                    segmentation cadence. This means the subsequent segment will have a duration of
                    of $segmentation_time seconds. When a segmentation style of "maintain_cadence"
                    is selected and a segment is truncated due to an avail, we will not reset the
                    segmentation cadence. This means the subsequent segment will likely be truncated
                    as well. However, all segments after that will have a duration of
                    $segmentation_time seconds. Note that EBP lookahead is a slight exception to
                    this rule.

                    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                    segment. Required unless markers is set to _none_.

                    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                    timed metadata in this output. Default is 502.

                    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                    itself in the program map table for this output. Transport stream IDs and
                    program map tables are parts of MPEG-2 transport stream containers, used for
                    organizing data.

                    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                    elementary video stream in the transport stream.

                  - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                    each PES packet.

                    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                    stream(s) in the transport stream. Multiple values are accepted, and can be
                    entered in ranges and/or by comma separation.

                      - *(integer) --*

                    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                    tracking will be detected in the input audio and an equivalent ID3 tag will be
                    inserted in the output.

                    - **PatInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                    Reference value is inserted for every Packetized Elementary Stream (PES) header.
                    This parameter is effective only when the PCR PID is the same as the video or
                    audio elementary stream.

                    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock
                    Reference (PCR) in the transport stream. When no value is given, the encoder
                    will assign the same value as the Video PID.

                    - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                    (PMT) in the transport stream.

                    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                    metadata stream in the transport stream.

                    - **ProgramNumber** *(integer) --* The value of the program number field in the
                    Program Map Table.

                    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                    the transport stream.

                    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                    Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input
                    to also appear in this output. Choose None (NONE) if you don't want SCTE-35
                    markers in this output. For SCTE-35 markers from an ESAM XML document-- Choose
                    None (NONE) if you don't want manifest conditioning. Choose Passthrough
                    (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
                    conditioning. In both cases, also provide the ESAM XML as a string in the
                    setting Signal processing notification XML (sccXml).

                    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting
                    to specify whether the service inserts the ID3 timed metadata from the input in
                    this output.

                    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                    metadata stream in the transport stream.

                    - **TransportStreamId** *(integer) --* The value of the transport stream ID
                    field in the Program Map Table.

                    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                    stream in the transport stream.

                  - **MovSettings** *(dict) --* Settings for MOV Container.

                    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate
                    for the video output settings.

                    - **CslgAtom** *(string) --* When enabled, file composition times will start at
                    zero, composition times in the 'ctts' (composition time to sample) box for
                    B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                    will be included per 14496-1 amendment 1. This improves compatibility with Apple
                    players and tools.

                    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                    streams into the QuickTime file using XDCAM fourcc codes. This increases
                    compatibility with Apple editors and players, but may decrease compatibility
                    with other players. Only applicable when the video codec is MPEG2.

                    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                    padding

                    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                    this setting.

                  - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create
                  audio-only AAC outputs with this container.

                    - **CslgAtom** *(string) --* When enabled, file composition times will start at
                    zero, composition times in the 'ctts' (composition time to sample) box for
                    B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                    will be included per 14496-1 amendment 1. This improves compatibility with Apple
                    players and tools.

                    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                    moov box.

                    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom
                    is relocated to the beginning of the archive as required for progressive
                    downloading. Otherwise it is placed normally at the end.

                    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the
                    output file. Usually not necessary to specify.

                  - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                    - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                    groups that include sidecar TTML or IMSC captions. You specify sidecar captions
                    in a separate output from your audio and video. Choose Raw (RAW) for captions in
                    a single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4)
                    for captions in XML format contained within fragmented MP4 files. This set of
                    fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                    markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                    insertion points that you specify in an ESAM XML document. Provide the document
                    in the setting SCC XML (sccXml).

                    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                    markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                    SCTE-35 markers that appear in your input to also appear in this output. Choose
                    None (NONE) if you don't want those SCTE-35 markers in this output.

                - **Extension** *(string) --* Use Extension (Extension) to specify the file
                extension for outputs in File output groups. If you do not specify a value, the
                service will use default extensions by container type as follows * MPEG-2 transport
                stream, m2ts * Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No
                Container, the service will use codec extensions (e.g. AAC, H265, H265, AC3)

                - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the
                service add a string to the end of each output filename. You specify the base
                filename as part of your destination URI. When you create multiple outputs in the
                same output group, Name modifier (NameModifier) is required. Name modifier also
                accepts format identifiers. For DASH ISO outputs, if you use the format identifiers
                $Number$ or $Time$ in one output, you must use them in the same way in all outputs
                of the output group.

                - **OutputSettings** *(dict) --* Specific settings for this type of output.

                  - **HlsSettings** *(dict) --* Settings for HLS output groups

                    - **AudioGroupId** *(string) --* Specifies the group to which the audio
                    Rendition belongs.

                    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                    outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                    container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                    file in a raw container. Regardless of the value that you specify here, if this
                    output has video, the service will place the output into an MPEG2-TS container.

                    - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                    with the video output stream. Input all the audio GROUP-IDs that are associated
                    to the video, separate by ','.

                    - **AudioTrackType** *(string) --* Four types of audio-only tracks are
                    supported: Audio-Only Variant Stream The client can play back this audio-only
                    stream instead of video in low-bandwidth scenarios. Represented as an
                    EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select, Default
                    Alternate rendition that the client should try to play back by default.
                    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                        YES,
                    AUTOSELECT=
                        YES Alternate Audio, Auto Select, Not Default Alternate rendition
                    that the client may try to play back by default. Represented as an EXT-X-MEDIA
                    in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                        YES Alternate Audio, not Auto
                    Select Alternate rendition that the client will not try to play back by default.
                    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                        NO, AUTOSELECT=NO

                    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                    Manifest in addition to the HLS manifest

                    - **SegmentModifier** *(string) --* String concatenated to end of segment
                    filenames. Accepts "Format Identifiers":#format_identifier_parameters.

                - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
                transcoding settings. Provide the system or custom preset name. You can specify
                either Preset (Preset) or Container settings (ContainerSettings), but not both.

                - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
                encoding settings. The specific video settings depend on the video codec that you
                choose when you specify a value for Video codec (codec). Include one instance of
                (VideoDescription) per output.

                  - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                  MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                  service includes AFD values in the output video data and what those values are. *
                  Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                  input AFD values and instead encode the value specified in the job. * Choose Auto
                  to calculate output AFD values based on the input AFD scaler data.

                  - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to
                  all outputs. The service no longer accepts the value DISABLED for AntiAlias. If
                  you specify that in your job, the service will ignore the setting.

                  - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                  (VideoDescription), contains the group of settings related to video encoding. The
                  settings in this group vary depending on the value that you choose for Video codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * H_264,
                  H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings
                  * FRAME_CAPTURE, FrameCaptureSettings

                    - **Codec** *(string) --* Specifies the video codec. This must be equal to one
                    of the enum values defined by the object VideoCodec.

                    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                      - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                      frame of the output stream, then one frame every
                      framerateDenominator/framerateNumerator seconds. For example, settings of
                      framerateNumerator = 1 and framerateDenominator =
                           3 (a rate of 1/3 frame per
                      second) will capture the first frame, then 1 frame every 3s. Files will be
                      named as filename.n.jpg where n is the 0-based sequence number of each
                      Capture.

                      - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                      frame of the output stream, then one frame every
                      framerateDenominator/framerateNumerator seconds. For example, settings of
                      framerateNumerator = 1 and framerateDenominator =
                           3 (a rate of 1/3 frame per
                      second) will capture the first frame, then 1 frame every 3s. Files will be
                      named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number
                      zero padded to 7 decimal places.

                      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg
                      output files).

                      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                      quality.

                    - **H264Settings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value H_264.

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                      your output video settings. If you aren't sure what level to specify, choose
                      Auto (AUTO).

                      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                      are only available with the AVC-I License.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be
                      in Main or High profile) or CAVLC.

                      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                      for interlaced outputs.

                      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame to reduce flicker or 'pop' on I-frames.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job specification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* When you use the API for transcode
                      jobs that use frame rate conversion, specify the frame rate as a fraction. For
                      example, 24000 / 1001 =
                           23.976 fps. Use FramerateDenominator to specify the
                      denominator of this fraction. In this example, use 1001 for the value of
                      FramerateDenominator. When you use the console for transcode jobs that use
                      frame rate conversion, provide the value as a decimal number for Framerate. In
                      this example, specify 23.976.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                      structures that have B frames > 1.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type, as follows. - If the source is interlaced, the output will be
                      interlaced with the same polarity as the source (it will follow the source).
                      The output could therefore be a mix of "top field first" and "bottom field
                      first". - If the source is progressive, the output will be interlaced with
                      "top field first" or "bottom field first" polarity, depending on which of the
                      Follow options you chose.

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000. Required when Rate control mode is
                      QVBR.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                      The encoder may use more than requested if using B-frames and/or interlaced
                      encoding.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                      high-quality singlepass, or high-quality multipass video encoding.

                      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                      encoding with the H.264 codec. Required when you set Rate control mode to
                      QVBR. Not valid when you set Rate control mode to a value other than QVBR, or
                      when you don't define Rate control mode.

                        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                        control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                        average bitrate values suited to the complexity of your input video, the
                        service limits the average bitrate of the video part of this output to the
                        value that you choose. That is, the total size of the video element is less
                        than or equal to the value you set multiplied by the number of seconds of
                        encoded output.

                        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                        control mode. That is, when you specify qvbrSettings within h264Settings.
                        Specify the target quality level for this output, from 1 to 10. Use higher
                        numbers for greater quality. Level 10 results in nearly lossless
                        compression. The quality level for most broadcast-quality transcodes is
                        between 6 and 9.

                      - **RateControlMode** *(string) --* Use this setting to specify whether this
                      output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                      variable bitrate (QVBR).

                      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture,
                      even if repeated.

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default. If this output uses QVBR, choose Transition
                      detection (TRANSITION_DETECTION) for further video quality improvement. For
                      more information about QVBR, see
                      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                      - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                      equal to the number of macroblock rows for progressive pictures, and less than
                      or equal to half the number of macroblock rows for interlaced pictures.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                      values reduce high-frequency content in the encoded image.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                      - **Telecine** *(string) --* This field applies only if the Streams > Advanced
                      > Framerate (framerate) field is set to 29.970. This field works with the
                      Streams > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and
                      the Streams > Advanced > Interlaced Mode field (interlace_mode) to identify
                      the scan type for the output: Progressive, Interlaced, Hard Telecine or Soft
                      Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
                      23.976; the player converts this output to 29.97i.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as
                      4 bytes of an unregistered SEI message.

                    - **H265Settings** *(dict) --* Settings for H265 codec

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                      Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                      Transfer Function (EOTF).

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* H.265 Level.

                      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                      (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                      "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                      available with the HEVC 4:2:2 License.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame to reduce flicker or 'pop' on I-frames.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                      structures that have B frames > 1.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                      Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                      the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom
                      Field First (BOTTOM_FIELD) to create an output that's interlaced with the same
                      field polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or
                      Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output
                      with the same field polarity as the source. If the source is interlaced, the
                      output will be interlaced with the same polarity as the source (it will follow
                      the source). The output could therefore be a mix of "top field first" and
                      "bottom field first". If the source is progressive, your output will be
                      interlaced with "top field first" or "bottom field first" polarity, depending
                      on which of the Follow options you chose. If you don't choose a value, the
                      service will default to Progressive (PROGRESSIVE).

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000. Required when Rate control mode is
                      QVBR.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                      The encoder may use more than requested if using B-frames and/or interlaced
                      encoding.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                      high-quality singlepass, or high-quality multipass video encoding.

                      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                      encoding with the H.265 codec. Required when you set Rate control mode to
                      QVBR. Not valid when you set Rate control mode to a value other than QVBR, or
                      when you don't define Rate control mode.

                        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                        control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                        average bitrate values suited to the complexity of your input video, the
                        service limits the average bitrate of the video part of this output to the
                        value that you choose. That is, the total size of the video element is less
                        than or equal to the value you set multiplied by the number of seconds of
                        encoded output.

                        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                        control mode. That is, when you specify qvbrSettings within h265Settings.
                        Specify the target quality level for this output, from 1 to 10. Use higher
                        numbers for greater quality. Level 10 results in nearly lossless
                        compression. The quality level for most broadcast-quality transcodes is
                        between 6 and 9.

                      - **RateControlMode** *(string) --* Use this setting to specify whether this
                      output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                      variable bitrate (QVBR).

                      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                      Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                      based on content

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default. If this output uses QVBR, choose Transition
                      detection (TRANSITION_DETECTION) for further video quality improvement. For
                      more information about QVBR, see
                      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                      - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                      equal to the number of macroblock rows for progressive pictures, and less than
                      or equal to half the number of macroblock rows for interlaced pictures.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Telecine** *(string) --* This field applies only if the Streams > Advanced
                      > Framerate (framerate) field is set to 29.970. This field works with the
                      Streams > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and
                      the Streams > Advanced > Interlaced Mode field (interlace_mode) to identify
                      the scan type for the output: Progressive, Interlaced, Hard Telecine or Soft
                      Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
                      23.976; the player converts this output to 29.97i.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                      encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                      and P-frames form one layer, reference B-frames can form a second layer and
                      non-reference b-frames can form a third layer. Decoders can optionally decode
                      only the lower temporal layers to generate a lower frame rate output. For
                      example, given a bitstream with temporal IDs and with b-frames = 1 (i.e.
                      IbPbPb display order), a decoder could decode all the frames for full frame
                      rate output or only the I and P frames (lowest temporal layer) for a half
                      frame rate output.

                      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                      vertical subdivision of the encoded pictures.

                      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as
                      4 bytes of an unregistered SEI message.

                      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                      units doesn't matter in your workflow, ignore this setting. Use this setting
                      only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                      container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                      your output compliant with the following specification: ISO IECJTC1 SC29
                      N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service
                      stores parameter set NAL units in the sample headers but not in the samples
                      directly. For MP4 outputs, when you choose HVC1, your output video might not
                      work properly with some downstream systems and video players. The service
                      defaults to marking your output as HEV1. For these outputs, the service writes
                      parameter set NAL units directly into the samples.

                    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value MPEG2.

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                      level for the video output.

                      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                      MPEG-2 profile for the video output.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type. - If the source is interlaced, the output will be interlaced with
                      the same polarity as the source (it will follow the source). The output could
                      therefore be a mix of "top field first" and "bottom field first". - If the
                      source is progressive, the output will be interlaced with "top field first" or
                      "bottom field first" polarity, depending on which of the Follow options you
                      chose.

                      - **IntraDcPrecision** *(string) --* Use Intra DC precision
                      (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                      coefficients. If you choose the value auto, the service will automatically
                      select the precision based on the per-frame compression ratio.

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                      video encoding.

                      - **RateControlMode** *(string) --* Use Rate control mode
                      (Mpeg2RateControlMode) to specifiy whether the bitrate is variable (vbr) or
                      constant (cbr).

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                      values reduce high-frequency content in the encoded image.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                      356M-2001).

                      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                      Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard)
                      to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                      produce 23.976 output and leave converstion to the player.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                    - **ProresSettings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value PRORES.

                      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                      the type of Apple ProRes codec to use for this output.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* When you use the API for transcode
                      jobs that use frame rate conversion, specify the frame rate as a fraction. For
                      example, 24000 / 1001 =
                           23.976 fps. Use FramerateNumerator to specify the
                      numerator of this fraction. In this example, use 24000 for the value of
                      FramerateNumerator.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type. - If the source is interlaced, the output will be interlaced with
                      the same polarity as the source (it will follow the source). The output could
                      therefore be a mix of "top field first" and "bottom field first". - If the
                      source is progressive, the output will be interlaced with "top field first" or
                      "bottom field first" polarity, depending on which of the Follow options you
                      chose.

                      - **ParControl** *(string) --* Use (ProresParControl) to specify how the
                      service determines the pixel aspect ratio. Set to Follow source
                      (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio from the input. To
                      specify a different pixel aspect ratio: Using the console, choose it from the
                      dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide
                      for (ParNumerator) and (ParDenominator).

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                      Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard)
                      to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                      produce 23.976 output and leave converstion to the player.

                  - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to
                  include color metadata in this output. Choose Ignore (IGNORE) to exclude color
                  metadata from this output. If you don't specify a value, the service sets this to
                  Insert by default.

                  - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area
                  that the service will include in the output video frame.

                    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                    numbers.

                    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                    numbers.

                    - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                    left edge of the video frame. Specify only even numbers.

                    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                    top edge of the video frame. Specify only even numbers.

                  - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                  feature is enabled, the service will use drop-frame timecode on outputs. If it is
                  not possible to use drop-frame timecode, the system will fall back to
                  non-drop-frame. This setting is enabled by default when Timecode insertion
                  (TimecodeInsertion) is enabled.

                  - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling)
                  to Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                  service will write on all frames of this video output.

                  - **Height** *(integer) --* Use the Height (Height) setting to define the video
                  resolution height for this output. Specify in pixels. If you don't provide a value
                  here, the service will use the input height.

                  - **Position** *(dict) --* Use Selection placement (position) to define the video
                  area in your output frame. The area outside of the rectangle that you specify here
                  is black.

                    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                    numbers.

                    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                    numbers.

                    - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                    left edge of the video frame. Specify only even numbers.

                    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                    top edge of the video frame. Specify only even numbers.

                  - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                  the service changes the video itself in response to AFD values in the input. *
                  Choose Respond to clip the input video frame according to the AFD value, input
                  display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                  include the input AFD values. Do not choose this when AfdSignaling is set to
                  (NONE). A preferred implementation of this workflow is to set RespondToAfd to
                  (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
                  values from this output.

                  - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                  have a different aspect ratio from the input aspect ratio. Choose Stretch to
                  output (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit.
                  Keep the setting Default (DEFAULT) to have the service letterbox your video
                  instead. This setting overrides any value that you specify for the setting
                  Selection placement (position) in this output.

                  - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                  strength of anti-aliasing. This setting changes the width of the anti-alias filter
                  kernel used for scaling. Sharpness only applies if your output resolution is
                  different from your input resolution. 0 is the softest setting, 100 the sharpest,
                  and 50 recommended for most content.

                  - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                  ProRes outputs. Only enable Timecode insertion when the input frame rate is
                  identical to the output frame rate. To include timecodes in this output, set
                  Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                  set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                  output, by default, it uses any embedded timecodes from the input. If none are
                  present, the service will set the timecode for the first output frame to zero. To
                  change this default behavior, adjust the settings under Timecode configuration
                  (TimecodeConfig). In the console, these settings are located under Job > Job
                  settings > Timecode configuration. Note - Timecode source under input settings
                  (InputTimecodeSource) does not affect the timecodes that are inserted in the
                  output. Source under Job settings > Timecode configuration (TimecodeSource) does.

                  - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                  Preprocessors (VideoPreprocessors). Enable the features at each output
                  individually. These features are disabled by default.

                    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                    feature if necessary. Enable or disable this feature for each output
                    individually. This setting is disabled by default.

                      - **Brightness** *(integer) --* Brightness level.

                      - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                      this output. The service supports conversion between HDR formats, between SDR
                      formats, and from SDR to HDR. The service doesn't support conversion from HDR
                      to SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                      video has an HDR format, but visually appears the same as an unconverted
                      output.

                      - **Contrast** *(integer) --* Contrast level.

                      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                      10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume
                      static metadata that you want signaled in the output. These values don't
                      affect the pixel values that are encoded in the video stream. They are
                      intended to help the downstream video player display content in a way that
                      reflects the intentions of the the content creator. When you set Color space
                      conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are
                      required. You must set values for Max frame average light level
                      (maxFrameAverageLightLevel) and Max content light level
                      (maxContentLightLevel); these settings don't have a default value. The default
                      values for the other HDR 10 metadata settings are defined by the P3D65 color
                      space. For more information about MediaConvert HDR jobs, see
                      https://docs.aws.amazon.com/console/mediaconvert/hdr.

                        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                        samples in the coded video sequence, in units of candelas per square meter.
                        This setting doesn't have a default value; you must specify a value that is
                        suitable for the content.

                        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level
                        of any frame in the coded video sequence, in units of candelas per square
                        meter. This setting doesn't have a default value; you must specify a value
                        that is suitable for the content.

                        - **MaxLuminance** *(integer) --* Nominal maximum mastering display
                        luminance in units of of 0.0001 candelas per square meter.

                        - **MinLuminance** *(integer) --* Nominal minimum mastering display
                        luminance in units of of 0.0001 candelas per square meter

                        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **WhitePointX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **WhitePointY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                      - **Hue** *(integer) --* Hue in degrees.

                      - **Saturation** *(integer) --* Saturation level.

                    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce
                    smoother motion and a clearer picture.

                      - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                      (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                      adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                      (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER)
                      if your source file includes a ticker, such as a scrolling headline at the
                      bottom of the frame.

                      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                      does not convert frames that are tagged in metadata as progressive. It will
                      only convert those that are tagged as some other type. - When set to
                      FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                      those that are already tagged as progressive. Turn Force mode on only if there
                      is a good chance that the metadata has tagged frames as progressive when they
                      are not progressive. Do not turn on otherwise; processing frames that are
                      already progressive into progressive will probably result in lower quality
                      video.

                      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                      service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                      interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                      progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby
                    Vision compatible video output.

                      - **L6Metadata** *(dict) --* Use these settings when you set
                      DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                      your input with new values.

                        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                        that corresponds to the brightest pixel in the entire stream. Measured in
                        nits.

                        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                        metadata that corresponds to the highest frame-average brightness in the
                        entire stream. Measured in nits.

                      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service
                      will handle Dolby Vision MaxCLL and MaxFALL properies.

                      - **Profile** *(string) --* In the current MediaConvert implementation, the
                      Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs
                      must contain Dolby Vision frame interleaved data.

                    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter)
                    feature to include a graphic overlay on your video. Enable or disable this
                    feature for each output individually. This setting is disabled by default.

                      - **InsertableImages** *(list) --* Specify the images that you want to overlay
                      on your video. The images must be PNG or TGA files.

                        - *(dict) --* Settings that specify how your still graphic overlay appears.

                          - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                          image to remain on the output video. This duration includes fade-in time
                          but not fade-out time.

                          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                          between the Start time that you specify for the image insertion and the
                          time that the image appears at full opacity. Full opacity is the level
                          that you specify for the opacity setting. If you don't specify a value for
                          Fade-in, the image will appear abruptly at the overlay start time.

                          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                          between the end of the time that you have specified for the image overlay
                          Duration and when the overlaid image has faded to total transparency. If
                          you don't specify a value for Fade-out, the image will disappear abruptly
                          at the end of the inserted image duration.

                          - **Height** *(integer) --* Specify the height of the inserted image in
                          pixels. If you specify a value that's larger than the video resolution
                          height, the service will crop your overlaid image to fit. To use the
                          native height of the image, keep this setting blank.

                          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon
                          S3 location of the image that you want to overlay on the video. Use a PNG
                          or TGA file.

                          - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                          inserted image and the left edge of the video frame. Required for any
                          image overlay that you specify.

                          - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                          overlaid image and the top edge of the video frame. Required for any image
                          overlay that you specify.

                          - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                          Images with higher values for Layer appear on top of images with lower
                          values for Layer.

                          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                          the underlying video shows through the inserted image. 0 is transparent
                          and 100 is fully opaque. Default is 50.

                          - **StartTime** *(string) --* Specify the timecode of the frame that you
                          want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                          or HH:MM:SS;FF) format. Remember to take into account your timecode source
                          settings.

                          - **Width** *(integer) --* Specify the width of the inserted image in
                          pixels. If you specify a value that's larger than the video resolution
                          width, the service will crop your overlaid image to fit. To use the native
                          width of the image, keep this setting blank.

                    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature
                    to remove noise from your video output if necessary. Enable or disable this
                    feature for each output individually. This setting is disabled by default.

                      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                      select one of the following spatial image filtering functions. To use this
                      setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                      preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                      Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                      reduction. * Spatial does frequency-domain filtering based on JND principles.
                      * Temporal optimizes video quality for complex motion.

                      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                        - **Strength** *(integer) --* Relative strength of noise reducing filter.
                        Higher values produce stronger filtering.

                      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                      spatial filter.

                        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post
                        noise reduction sharpening filter, with 0 disabling the filter and 3
                        enabling it at maximum strength.

                        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to
                        3 (higher speed), with 0 being the nominal value.

                        - **Strength** *(integer) --* Relative strength of noise reducing filter.
                        Higher values produce stronger filtering.

                      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                      temporal filter.

                        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                        complex motion. Higher values produce stronger temporal filtering. This
                        filters highly complex scenes more aggressively and creates better VQ for
                        low bitrate outputs.

                        - **Speed** *(integer) --* The speed of the filter (higher number is
                        faster). Low setting reduces bit rate at the cost of transcode time, high
                        setting improves transcode time at the cost of bit rate.

                        - **Strength** *(integer) --* Specify the strength of the noise reducing
                        filter on this output. Higher values produce stronger filtering. We
                        recommend the following value ranges, depending on the result that you want:
                        * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
                        complexity reduction with image preservation * 8-16 for a high level of
                        complexity reduction

                    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                    output timecode and specified prefix into the output.

                      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                      any burned-in timecode. Valid values are 10, 16, 32, 48.

                      - **Position** *(string) --* Use Position (Position) under under Timecode
                      burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                      output video.

                      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters
                      before any burned-in timecode. For example, a prefix of "EZ-" will result in
                      the timecode "EZ-00:00:00:00". Provide either the characters themselves or the
                      ASCII code equivalents. The supported range of characters is 0x20 through
                      0x7e. This includes letters, numbers, and all special characters represented
                      on a standard English keyboard.

                  - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                  in pixels, for this output. If you don't provide a value here, the service will
                  use the input width.

        - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
        information from inputs.

          - **Anchor** *(string) --* If you use an editing platform that relies on an anchor
          timecode, use Anchor Timecode (Anchor) to specify a timecode that will match the input
          video frame to the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF)
          or (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
          Timecode varies depending on your setting for Source (TimecodeSource). * If Source
          (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
          specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
          (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start
          at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
          Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
          input.

          - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
          within this job. To make sure that your video, audio, captions, and markers are
          synchronized and that time-based features, such as image inserter, work correctly, choose
          the Timecode source option that matches your assets. All timecodes are in a 24-hour format
          with frame number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the
          input video. If no embedded timecode is in the source, the service will use Start at 0
          (ZEROBASED) instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to
          00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to
          a value other than zero. You use Start timecode (Start) to provide this value.

          - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
          (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial
          frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

          - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
          stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
          affecting the time and frame number. Provide the new date as a string in the format
          "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
          (InsertProgramDateTime) in the output settings. For example, if the date part of your
          timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
          (TimestampOffset) to 2003-1-25.

        - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
        (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you
        must enable it here, enable it in each output container, and specify tags and timecodes in
        ID3 insertion (Id3Insertion) objects.

          - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion
          instances.

            - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3)
            to specify the base 64 encoded string and use Timecode (TimeCode) to specify the time
            when the tag should be inserted. To insert multiple ID3 tags in your output, create
            multiple instances of ID3 insertion (Id3Insertion).

              - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
              format.

              - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or
              HH:MM:SS;FF format.

      - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
      events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
      MediaConvert sends an update at this interval from the time the service begins processing your
      job to the time it completes the transcode or encounters an error.

      - **Type** *(string) --* A job template can be of two types: system or custom. System or
      built-in job templates can't be modified or deleted by the user.
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptions` `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsAudioDescriptions` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientGetPresetResponsePresetSettingsAudioDescriptionsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientGetPresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientGetPresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientGetPresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsAudioDescriptionsTypeDef(
    _ClientGetPresetResponsePresetSettingsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettings` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientGetPresetResponsePresetSettingsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsCaptionDescriptionsTypeDef",
    {
        "CustomLanguageCode": str,
        "DestinationSettings": ClientGetPresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsCaptionDescriptionsTypeDef(
    _ClientGetPresetResponsePresetSettingsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettings` `CaptionDescriptions`

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsContainerSettings` `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsContainerSettings` `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsContainerSettings` `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsContainerSettings` `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsContainerSettings` `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsContainerSettings` `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientGetPresetResponsePresetSettingsContainerSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientGetPresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientGetPresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientGetPresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientGetPresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientGetPresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientGetPresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsContainerSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsContainerSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettings` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264Settings` `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265Settings` `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescription` `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionCropTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionPositionTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescription` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettingsVideoDescription` `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientGetPresetResponsePresetSettingsVideoDescriptionTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientGetPresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientGetPresetResponsePresetSettingsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientGetPresetResponsePresetSettingsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientGetPresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsVideoDescriptionTypeDef(
    _ClientGetPresetResponsePresetSettingsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientGetPresetResponsePresetSettings` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientGetPresetResponsePresetSettingsTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetSettingsTypeDef",
    {
        "AudioDescriptions": List[ClientGetPresetResponsePresetSettingsAudioDescriptionsTypeDef],
        "CaptionDescriptions": List[
            ClientGetPresetResponsePresetSettingsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientGetPresetResponsePresetSettingsContainerSettingsTypeDef,
        "VideoDescription": ClientGetPresetResponsePresetSettingsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientGetPresetResponsePresetSettingsTypeDef(_ClientGetPresetResponsePresetSettingsTypeDef):
    """
    Type definition for `ClientGetPresetResponsePreset` `Settings`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
    caption settings in a single output.

      - *(dict) --* Caption Description for preset

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientGetPresetResponsePresetTypeDef = TypedDict(
    "_ClientGetPresetResponsePresetTypeDef",
    {
        "Arn": str,
        "Category": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "Settings": ClientGetPresetResponsePresetSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientGetPresetResponsePresetTypeDef(_ClientGetPresetResponsePresetTypeDef):
    """
    Type definition for `ClientGetPresetResponse` `Preset`

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **Category** *(string) --* An optional category you create to organize your presets.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for preset creation.

    - **Description** *(string) --* An optional description you create for each preset.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the preset was last
    updated.

    - **Name** *(string) --* A name you create for each preset. Each name must be unique within your
    account.

    - **Settings** *(dict) --* Settings for preset

      - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
      settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
      (AudioDescriptions) can contain multiple groups of encoding settings.

        - *(dict) --* Description of audio output

          - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
          these settings unless you need to comply with a loudness standard.

            - **Algorithm** *(string) --* Choose one of the following audio normalization
            algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness
            for an entire piece of content, suitable for measurement of short-form content under
            ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated
            loudness. A measurement of gated average loudness compliant with the requirements of
            EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified peak. The same
            loudness measurement algorithm as 1770-2, with an updated true peak measurement. ITU-R
            BS.1770-4: Higher channel count. Allows for more audio channels than the other
            algorithms, including configurations such as 7.1.

            - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
            the chosen algorithm. If disabled, the audio will be measured but not adjusted.

            - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
            corrected to the target level. Content measuring below this level will not be corrected.
            Gating only applies when not using real_time_correction.

            - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
            loudness to a CSV file.

            - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
            for each output's audio track loudness.

            - **TargetLkfs** *(float) --* When you use Audio normalization
            (AudioNormalizationSettings), optionally use this setting to specify a target loudness.
            If you don't specify a value here, the encoder chooses a value for you, based on the
            algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
            encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

          - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
          the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
          order within each input. For example if you specify "Audio Selector 3", then the third
          audio selector will be used from each input. If an input does not have an "Audio Selector
          3", then the audio selector marked as "default" in that input will be used. If there is no
          audio selector marked as "default", silence will be inserted for the duration of that
          input. Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be
          specified, with similar default/silence behavior. If no audio_source_name is specified,
          then "Audio Selector 1" will be chosen automatically.

          - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
          (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
          Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
               Visually Impaired Commentary,
          4-255 = Reserved.

          - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
          ISO 639 audio_type, then that value is passed through to the output. If the input contains
          no ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the
          value in Audio Type is included in the output. Note that this field and audioType are both
          ignored if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

          - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
          (AudioDescriptions) contains the group of settings related to audio encoding. The settings
          in this group vary depending on the value that you choose for Audio codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
          WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
          Eac3AtmosSettings

            - **AacSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
            mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
            set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode,
            you control the audio quality with the setting VBR quality (vbrQuality). In CBR mode,
            you use the setting Bitrate (bitrate). Defaults and valid values depend on the rate
            control mode.

              - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
              the input contains pre-mixed main audio + audio description (AD) as a stereo pair. The
              value for AudioType will be set to 3, which signals to downstream systems that this
              stream contains "broadcaster mixed AD". Note that the input received by the encoder
              must contain pre-mixed audio; the encoder does not perform the mixing. When you choose
              BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
              FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
              audio description (AD). In this case, the encoder will use any values you provide for
              AudioType and FollowInputAudioType.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
              of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
              24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000,
              192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000,
              768000, 896000, 1024000. The value you set is also constrained by the values that you
              choose for Profile (codecProfile), Bitrate control mode (codingMode), and Sample rate
              (sampleRate). Default values depend on Bitrate control mode and Profile.

              - **CodecProfile** *(string) --* AAC Profile.

              - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
              layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
              (Receiver Mix)" setting receives a stereo description plus control track and emits a
              mono AAC encode of the description track, with control data emitted in the PES header
              as per ETSI TS 101 154 Annex E.

              - **RateControlMode** *(string) --* Rate Control Mode.

              - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
              LATM/LOAS AAC in an output, you must choose "No container" for the output container.

              - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
              mode and profile.

              - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
              or MPEG-2 Transport Stream containers.

              - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
              VBR.

            - **Ac3Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AC3.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              bitrates depend on the coding mode.

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
              the encoder emits. For more information about the AC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
              channels.

              - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
              audio is Dolby Digital, dialnorm will be passed through.

              - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
              dynamic range compression signaling to the output bitstream as defined in the Dolby
              Digital specification.

              - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior
              to encoding. Only valid with 3_2_LFE coding mode.

              - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
              sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio
              was not supplied from one of these streams, then the static metadata settings will be
              used.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

            - **AiffSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AIFF.

              - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
              choose the encoding quality for this audio track.

              - **Channels** *(integer) --* Specify the number of channels in this output audio
              track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
              on, up to 64.

              - **SampleRate** *(integer) --* Sample rate in hz.

            - **Codec** *(string) --* Type of Audio codec.

            - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              values: 384k, 448k, 640k, 768k

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
              that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
              always 9.1.6 (CODING_MODE_9_1_6).

              - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
              loudness based on dialogue analysis.

              - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
              signal with dynamic range compression.

              - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
              dynamic range when compressing the audio.

              - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
              for downmixing. How the service uses this value depends on the value that you choose
              for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
              -4.5, and -6.0.

              - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
              downmixing. How the service uses this value depends on the value that you choose for
              Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
              -60. The value -60 mutes the channel.

              - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, and -6.0.

              - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
              -6.0, and -60. The value -60 mutes the channel.

              - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
              audio.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

              - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
              be speech before the encoder uses the measured speech loudness as the overall program
              loudness.

              - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

              - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
              center rear surround channel matrix encoded into your left and right surround
              channels.

            - **Eac3Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value EAC3.

              - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
              attenuation to the surround channels. Only used for 3/2 coding mode.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              bitrates depend on the coding mode.

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
              that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
              channels.

              - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

              - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
              audio is Dolby Digital Plus, dialnorm will be passed through.

              - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
              signal with dynamic range compression.

              - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
              dynamic range when compressing the audio.

              - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
              channel is enabled

              - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior
              to encoding. Only valid with 3_2_LFE coding mode.

              - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
              Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only
              if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left only/Right only center (loRoCenterMixLevel).

              - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
              Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
              and -60. The value -60 mutes the channel. This setting applies only if you keep the
              default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
              (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
              Left only/Right only surround (loRoSurroundMixLevel).

              - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
              Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only
              if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left total/Right total center (ltRtCenterMixLevel).

              - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
              Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
              MediaConvert uses this value for downmixing. How the service uses this value depends
              on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
              -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
              only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

              - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
              sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio
              was not supplied from one of these streams, then the static metadata settings will be
              used.

              - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
              be passed through if it is present on the input. this detection is dynamic over the
              life of the transcode. Inputs that alternate between DD+ and non-DD+ content will have
              a consistent DD+ output as the system alternates between passthrough and encoding.

              - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
              surround channels. Only used for 3/2 coding mode.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

              - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
              setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
              (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
              different value for Coding mode, the service ignores Stereo downmix
              (Eac3StereoDownmix).

              - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
              center back surround channel is matrix encoded into the left and right surround
              channels.

              - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround
              is matrix encoded into the two channels.

            - **Mp2Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value MP2.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

              - **Channels** *(integer) --* Set Channels to specify the number of channels in this
              output audio track. Choosing Mono in the console will give you 1 output channel;
              choosing Stereo will give you 2. In the API, valid values are 1 and 2.

              - **SampleRate** *(integer) --* Sample rate in hz.

            - **WavSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value WAV.

              - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
              choose the encoding quality for this audio track.

              - **Channels** *(integer) --* Specify the number of channels in this output audio
              track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
              on, up to 64.

              - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
              output audio is likely to exceed 4 GB in file size, or if you otherwise need the
              extended support of the RF64 format, set your output WAV file format to RF64.

              - **SampleRate** *(integer) --* Sample rate in Hz.

          - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
          The service puts this language code into your output audio track when you set Language
          code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
          also uses your specified custom language code when you set Language code control
          (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
          specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
          streaming outputs, you can also use any other code in the full RFC-5646 specification.
          Streaming outputs are those that are in one of the following output groups: CMAF, DASH
          ISO, Apple HLS, or Microsoft Smooth Streaming.

          - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
          639 language specified in the 'Language Code' drop down will be used when 'Follow Input
          Language Code' is not selected or when 'Follow Input Language Code' is selected but there
          is no ISO 639 language code specified by the input.

          - **LanguageCodeControl** *(string) --* Specify which source for language code takes
          precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
          uses the language code from the input track if it's present. If there's no languge code on
          the input track, the service uses the code that you specify in the setting Language code
          (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
          service uses the language code that you specify.

          - **RemixSettings** *(dict) --* Advanced audio remixing settings.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
          "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
          this information into destination manifests for display on the end-viewer's player device.
          For outputs in other output groups, the service ignores this setting.

      - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
      caption settings in a single output.

        - *(dict) --* Caption Description for preset

          - **CustomLanguageCode** *(string) --* Specify the language for this captions output
          track. For most captions output formats, the encoder puts this language information in the
          output captions metadata. If your output captions format is DVB-Sub or Burn in, the
          encoder uses this language information when automatically selecting the font script for
          rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
          For streaming outputs, you can also use any other code in the full RFC-5646 specification.
          Streaming outputs are those that are in one of the following output groups: CMAF, DASH
          ISO, Apple HLS, or Microsoft Smooth Streaming.

          - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
          that burnin_destination_settings are not available if the source of the caption data is
          Embedded or Teletext.

            - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

              - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
              setting alignment to centered will place the captions at the bottom center of the
              output. Similarly, setting a left alignment will align captions to the bottom left of
              the output. If x and y positions are given in conjunction with the alignment
              parameter, the font will be justified (either left or centered) relative to those
              coordinates. This option is not valid for source captions that are STL, 608/embedded
              or teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
              captions. All burn-in and DVB-Sub font settings must match.

              - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
              rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
              to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

              - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
              option is not valid for source captions that are STL, 608/embedded or teletext. These
              source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
              font settings must match.

              - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255
              is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

              - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
              96 dpi. All burn-in and DVB-Sub font settings must match.

              - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
              code, if the LanguageCode is not sufficient for determining the script type. Where
              LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
              is used to help determine the appropriate font for rendering burn-in captions.

              - **FontSize** *(integer) --* A positive integer indicates the exact font size in
              points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineColor** *(string) --* Specifies font outline color. This option is not
              valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
              not valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
              captions. All burn-in and DVB-Sub font settings must match.

              - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque;
              0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
              (transparent). All burn-in and DVB-Sub font settings must match.

              - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels to the left. All burn-in and DVB-Sub font settings must match.

              - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels above the text. All burn-in and DVB-Sub font settings must match.

              - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
              Teletext or STL formats. Specify whether the spacing between letters in your captions
              is set by the captions grid or varies depending on letter width. Choose fixed grid to
              conform to the spacing specified in the captions file more accurately. Choose
              proportional to make the text easier to read if the captions are closed caption.

              - **XPosition** *(integer) --* Specifies the horizontal position of the caption
              relative to the left side of the output in pixels. A value of 10 would result in the
              captions starting 10 pixels from the left of the output. If no explicit x_position is
              provided, the horizontal caption position will be determined by the alignment
              parameter. This option is not valid for source captions that are STL, 608/embedded or
              teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
              to the top of the output in pixels. A value of 10 would result in the captions
              starting 10 pixels from the top of the output. If no explicit y_position is provided,
              the caption will be positioned towards the bottom of the output. This option is not
              valid for source captions that are STL, 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

            - **DestinationType** *(string) --* Specify the format for this set of captions on this
            output. The default format is embedded without SCTE-20. Other options are embedded with
            SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
            SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
            complies with the SCTE-43 spec. To create a non-compliant output where the embedded
            captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

            - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

              - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
              setting alignment to centered will place the captions at the bottom center of the
              output. Similarly, setting a left alignment will align captions to the bottom left of
              the output. If x and y positions are given in conjunction with the alignment
              parameter, the font will be justified (either left or centered) relative to those
              coordinates. This option is not valid for source captions that are STL, 608/embedded
              or teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
              captions. All burn-in and DVB-Sub font settings must match.

              - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
              rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
              to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

              - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
              option is not valid for source captions that are STL, 608/embedded or teletext. These
              source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
              font settings must match.

              - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255
              is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

              - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
              96 dpi. All burn-in and DVB-Sub font settings must match.

              - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
              code, if the LanguageCode is not sufficient for determining the script type. Where
              LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
              is used to help determine the appropriate font for rendering DVB-Sub captions.

              - **FontSize** *(integer) --* A positive integer indicates the exact font size in
              points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineColor** *(string) --* Specifies font outline color. This option is not
              valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
              not valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
              captions. All burn-in and DVB-Sub font settings must match.

              - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque;
              0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
              (transparent). All burn-in and DVB-Sub font settings must match.

              - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels to the left. All burn-in and DVB-Sub font settings must match.

              - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels above the text. All burn-in and DVB-Sub font settings must match.

              - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
              for hearing impaired. Choose hearing impaired if your subtitles include audio
              descriptions and dialogue. Choose standard if your subtitles include only dialogue.

              - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
              Teletext or STL formats. Specify whether the spacing between letters in your captions
              is set by the captions grid or varies depending on letter width. Choose fixed grid to
              conform to the spacing specified in the captions file more accurately. Choose
              proportional to make the text easier to read if the captions are closed caption.

              - **XPosition** *(integer) --* Specifies the horizontal position of the caption
              relative to the left side of the output in pixels. A value of 10 would result in the
              captions starting 10 pixels from the left of the output. If no explicit x_position is
              provided, the horizontal caption position will be determined by the alignment
              parameter. This option is not valid for source captions that are STL, 608/embedded or
              teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
              to the top of the output in pixels. A value of 10 would result in the captions
              starting 10 pixels from the top of the output. If no explicit y_position is provided,
              the caption will be positioned towards the bottom of the output. This option is not
              valid for source captions that are STL, 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

            - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
            caption outputs, including 608/708 Channel destination number.

              - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
              captions are SCC format and your output captions are embedded in the video stream.
              Specify a CC number for each captions channel in this output. If you have two
              channels, choose CC numbers that aren't in the same field. For example, choose 1 and
              3. For more information, see
              https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
              captions are SCC format and you want both 608 and 708 captions embedded in your output
              stream. Optionally, specify the 708 service number for each output captions channel.
              Choose a different number for each channel. To use this setting, also set Force 608 to
              708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions
              selector settings. If you choose to upconvert but don't specify a 708 service number,
              MediaConvert uses the number that you specify for CC channel number
              (destination608ChannelNumber) for the 708 service number. For more information, see
              https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

              - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
              use the font style and position information from the captions source in the output.
              This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or
              TTML. Disable this setting for simplified output captions.

            - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

              - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
              that the captions and the video are synchronized in the output. Specify a frame rate
              that matches the frame rate of the associated video. If the video frame rate is 29.97,
              choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
              video_insertion=true and drop_frame_timecode=true; otherwise, choose 29.97
              non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

            - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

              - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
              destination captions for this output. This value must be a three-digit hexadecimal
              string; strings ending in -FF are invalid. If you are passing through the entire set
              of Teletext data, do not use this field.

              - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
              don't specify a value here, the service sets the page type to the default value
              Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
              don't use this field. When you pass through a set of Teletext pages, your output has
              the same page types as your input.

                - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

            - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
            including Pass style information (TtmlStylePassthrough).

              - **StylePassthrough** *(string) --* Pass through style and position information from
              a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

          - **LanguageCode** *(string) --* Specify the language of this captions output track. For
          most captions output formats, the encoder puts this language information in the output
          captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
          this language information to choose the font language for rendering the captions text.

          - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
          For example, "English", "Director commentary", or "track_2". For streaming outputs,
          MediaConvert passes this information into destination manifests for display on the
          end-viewer's player device. For outputs in other output groups, the service ignores this
          setting.

      - **ContainerSettings** *(dict) --* Container specific settings.

        - **Container** *(string) --* Container for this output. Some containers require a container
        settings object. If not specified, the default object will be created.

        - **F4vSettings** *(dict) --* Settings for F4v container

          - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
          relocated to the beginning of the archive as required for progressive downloading.
          Otherwise it is placed normally at the end.

        - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
        File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
        (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
        stream program contains subsets of data, including audio, video, and metadata. Each of these
        subsets of data has a numerical label called a packet identifier (PID). Each transport
        stream program corresponds to one MediaConvert output. The PMT lists the types of data in a
        program along with their PID. Downstream systems and players use the program map table to
        look up the PID for each type of data it accesses and then uses the PIDs to locate specific
        data within the asset.

          - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
          Dolby Digital audio.

          - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
          packet.

          - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
          streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
          range 482-492.

            - *(integer) --*

          - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
          per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
          Other common values are 3750000, 7500000, and 15000000.

          - **BufferModel** *(string) --* Controls what buffer model to use for accurate
          interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
          lead to lower latency, but low-memory devices may not be able to play back the stream
          without interruptions.

          - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
          specified table repetition interval.

            - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
            (NIT).

            - **NetworkName** *(string) --* The network name text placed in the
            network_name_descriptor inside the Network Information Table. Maximum length is 256
            characters.

            - **NitInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

          - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
          specified table repetition interval.

            - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
            stream. "Follow input SDT" copies SDT information from input stream to output stream.
            "Follow input SDT if present" copies SDT information from input stream to output stream
            if SDT information is present in the input, otherwise it will fall back on the
            user-defined values. Enter "SDT Manually" means user will enter the SDT information. "No
            SDT" means output stream will not contain SDT information.

            - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
            Service Description Table. Maximum length is 256 characters.

            - **ServiceProviderName** *(string) --* The service provider name placed in the
            service_descriptor in the Service Description Table. Maximum length is 256 characters.

          - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
          included in this output. Specify multiple PIDs as a JSON array. Default is the range
          460-479.

            - *(integer) --*

          - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
          table repetition interval.

            - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

          - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
          data you include in this output. Default is 499.

          - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
          markers will be added to partitions 3 and 4. The interval between these additional markers
          will be fixed, and will be slightly shorter than the video EBP marker interval. When set
          to VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
          segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

          - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
          either be placed only on the video PID, or on both the video PID and all audio PIDs. Only
          applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
          EBP_LEGACY).

          - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
          header.

          - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
          that your audio EBP markers are incorrectly appearing before your video EBP markers. To
          correct this problem, set this value to Force (FORCE).

          - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
          EBP markers.

          - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
          Program Clock References (PCRs) inserted into the transport stream.

          - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
          come within the specified time interval of each other by looking ahead at input video. If
          another EBP is going to come in within the specified time interval, the current EBP is not
          emitted, and the segment is "stretched" to the next marker. The lookahead value does not
          add latency to the system. The Live Event must be configured elsewhere to create
          sufficient latency to make the lookahead accurate.

          - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will
          be detected in the input audio and an equivalent ID3 tag will be inserted in the output.

          - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
          insert into the transport stream. This can be used if a downstream encryption system
          requires periodic null packets.

          - **PatInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
          value is inserted for every Packetized Elementary Stream (PES) header. This is effective
          only when the PCR PID is the same as the video or audio elementary stream.

          - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
          reference (PCR) in this output. If you do not specify a value, the service will use the
          value for Video PID (VideoPid).

          - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
          the program map table (PMT) in the output transport stream.

          - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
          (PMT) itself. Default is 480.

          - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
          metadata stream. Default is 503.

          - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
          program number used in the program map table (PMT) for this output. Default is 1. Program
          numbers and program map tables are parts of MPEG-2 transport stream containers, used for
          organizing data.

          - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
          to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
          bitrate, but the output will not be padded up to that bitrate.

          - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
          your HLS and transport stream outputs at the insertion points that you specify in an ESAM
          XML document. Provide the document in the setting SCC XML (sccXml).

            - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream generated by ESAM.

          - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
          in the transport stream.

          - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
          (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
          output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
          markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
          string in the setting Signal processing notification XML (sccXml). Also enable ESAM
          SCTE-35 (include the property scte35Esam).

          - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
          segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
          adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
          data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
          Encoder Boundary Point information to the adaptation field as per OpenCable specification
          OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
          field using a legacy proprietary format.

          - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
          segmentation markers are inserted into the transport stream. With avails, it is possible
          that segments may be truncated, which can influence where future segmentation markers are
          inserted. When a segmentation style of "reset_cadence" is selected and a segment is
          truncated due to an avail, we will reset the segmentation cadence. This means the
          subsequent segment will have a duration of of $segmentation_time seconds. When a
          segmentation style of "maintain_cadence" is selected and a segment is truncated due to an
          avail, we will not reset the segmentation cadence. This means the subsequent segment will
          likely be truncated as well. However, all segments after that will have a duration of
          $segmentation_time seconds. Note that EBP lookahead is a slight exception to this rule.

          - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
          Required unless markers is set to _none_.

          - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
          metadata in this output. Default is 502.

          - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
          the program map table for this output. Transport stream IDs and program map tables are
          parts of MPEG-2 transport stream containers, used for organizing data.

          - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
          stream in the transport stream.

        - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

          - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
          packet.

          - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
          the transport stream. Multiple values are accepted, and can be entered in ranges and/or by
          comma separation.

            - *(integer) --*

          - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will
          be detected in the input audio and an equivalent ID3 tag will be inserted in the output.

          - **PatInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
          value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
          effective only when the PCR PID is the same as the video or audio elementary stream.

          - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
          in the transport stream. When no value is given, the encoder will assign the same value as
          the Video PID.

          - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
          transport stream.

          - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
          stream in the transport stream.

          - **ProgramNumber** *(integer) --* The value of the program number field in the Program
          Map Table.

          - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream.

          - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
          (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
          output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
          markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
          conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
          want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
          setting Signal processing notification XML (sccXml).

          - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
          whether the service inserts the ID3 timed metadata from the input in this output.

          - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
          in the transport stream.

          - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
          Program Map Table.

          - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
          the transport stream.

        - **MovSettings** *(dict) --* Settings for MOV Container.

          - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
          video output settings.

          - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
          composition times in the 'ctts' (composition time to sample) box for B-frames will be
          negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
          amendment 1. This improves compatibility with Apple players and tools.

          - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
          the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple
          editors and players, but may decrease compatibility with other players. Only applicable
          when the video codec is MPEG2.

          - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

          - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
          setting.

        - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
        outputs with this container.

          - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
          composition times in the 'ctts' (composition time to sample) box for B-frames will be
          negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
          amendment 1. This improves compatibility with Apple players and tools.

          - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

          - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
          relocated to the beginning of the archive as required for progressive downloading.
          Otherwise it is placed normally at the end.

          - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
          Usually not necessary to specify.

        - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

          - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
          include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
          from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
          container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
          within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
          and audio fragmented MP4 files.

          - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
          ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
          specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
          your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
          appear in your input to also appear in this output. Choose None (NONE) if you don't want
          those SCTE-35 markers in this output.

      - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
      settings. The specific video settings depend on the video codec that you choose when you
      specify a value for Video codec (codec). Include one instance of (VideoDescription) per
      output.

        - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
        outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD
        values in the output video data and what those values are. * Choose None to remove all AFD
        values from this output. * Choose Fixed to ignore input AFD values and instead encode the
        value specified in the job. * Choose Auto to calculate output AFD values based on the input
        AFD scaler data.

        - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
        The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
        job, the service will ignore the setting.

        - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
        (VideoDescription), contains the group of settings related to video encoding. The settings
        in this group vary depending on the value that you choose for Video codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
        Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

          - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
          values defined by the object VideoCodec.

          - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

            - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
            the output stream, then one frame every framerateDenominator/framerateNumerator seconds.
            For example, settings of framerateNumerator = 1 and framerateDenominator =
                 3 (a rate of
            1/3 frame per second) will capture the first frame, then 1 frame every 3s. Files will be
            named as filename.n.jpg where n is the 0-based sequence number of each Capture.

            - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
            output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
            example, settings of framerateNumerator = 1 and framerateDenominator =
                 3 (a rate of 1/3
            frame per second) will capture the first frame, then 1 frame every 3s. Files will be
            named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
            to 7 decimal places.

            - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

            - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

          - **H264Settings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value H_264.

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
            output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

            - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
            available with the AVC-I License.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
            High profile) or CAVLC.

            - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
            interlaced outputs.

            - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
            reduce flicker or 'pop' on I-frames.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job specification as
            a JSON file without the console, use FramerateControl to specify which value the service
            uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
            service to use the frame rate from the input. Choose SPECIFIED if you want the service
            to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
            use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
            1001 =
                 23.976 fps. Use FramerateDenominator to specify the denominator of this fraction.
            In this example, use 1001 for the value of FramerateDenominator. When you use the
            console for transcode jobs that use frame rate conversion, provide the value as a
            decimal number for Framerate. In this example, specify 23.976.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
            that have B frames > 1.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type, as follows. - If the source is
            interlaced, the output will be interlaced with the same polarity as the source (it will
            follow the source). The output could therefore be a mix of "top field first" and "bottom
            field first". - If the source is progressive, the output will be interlaced with "top
            field first" or "bottom field first" polarity, depending on which of the Follow options
            you chose.

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000. Required when Rate control mode is QVBR.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
            encoder may use more than requested if using B-frames and/or interlaced encoding.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
            to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
            multipass video encoding.

            - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
            with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
            you set Rate control mode to a value other than QVBR, or when you don't define Rate
            control mode.

              - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
              QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited
              to the complexity of your input video, the service limits the average bitrate of the
              video part of this output to the value that you choose. That is, the total size of the
              video element is less than or equal to the value you set multiplied by the number of
              seconds of encoded output.

              - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
              That is, when you specify qvbrSettings within h264Settings. Specify the target quality
              level for this output, from 1 to 10. Use higher numbers for greater quality. Level 10
              results in nearly lossless compression. The quality level for most broadcast-quality
              transcodes is between 6 and 9.

            - **RateControlMode** *(string) --* Use this setting to specify whether this output has
            a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate
            (QVBR).

            - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
            repeated.

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default. If this output uses QVBR, choose Transition detection
            (TRANSITION_DETECTION) for further video quality improvement. For more information about
            QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

            - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
            the number of macroblock rows for progressive pictures, and less than or equal to half
            the number of macroblock rows for interlaced pictures.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
            high-frequency content in the encoded image.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

            - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
            Framerate (framerate) field is set to 29.970. This field works with the Streams >
            Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
            Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
            output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i
            output from 23.976 input. - Soft: produces 23.976; the player converts this output to
            29.97i.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

            - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
            of an unregistered SEI message.

          - **H265Settings** *(dict) --* Settings for H265 codec

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
            message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
            (EOTF).

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* H.265 Level.

            - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
            specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
            Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
            License.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
            reduce flicker or 'pop' on I-frames.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
            that have B frames > 1.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
            Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
            your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
            create an output that's interlaced with the same field polarity throughout. Choose
            Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
            to create an interlaced output with the same field polarity as the source. If the source
            is interlaced, the output will be interlaced with the same polarity as the source (it
            will follow the source). The output could therefore be a mix of "top field first" and
            "bottom field first". If the source is progressive, your output will be interlaced with
            "top field first" or "bottom field first" polarity, depending on which of the Follow
            options you chose. If you don't choose a value, the service will default to Progressive
            (PROGRESSIVE).

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000. Required when Rate control mode is QVBR.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
            encoder may use more than requested if using B-frames and/or interlaced encoding.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
            to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
            multipass video encoding.

            - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
            with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
            you set Rate control mode to a value other than QVBR, or when you don't define Rate
            control mode.

              - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
              QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited
              to the complexity of your input video, the service limits the average bitrate of the
              video part of this output to the value that you choose. That is, the total size of the
              video element is less than or equal to the value you set multiplied by the number of
              seconds of encoded output.

              - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
              That is, when you specify qvbrSettings within h265Settings. Specify the target quality
              level for this output, from 1 to 10. Use higher numbers for greater quality. Level 10
              results in nearly lossless compression. The quality level for most broadcast-quality
              transcodes is between 6 and 9.

            - **RateControlMode** *(string) --* Use this setting to specify whether this output has
            a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate
            (QVBR).

            - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
            filter strength. Adaptive mode dynamically selects best strength based on content

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default. If this output uses QVBR, choose Transition detection
            (TRANSITION_DETECTION) for further video quality improvement. For more information about
            QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

            - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
            the number of macroblock rows for progressive pictures, and less than or equal to half
            the number of macroblock rows for interlaced pictures.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
            Framerate (framerate) field is set to 29.970. This field works with the Streams >
            Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
            Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
            output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i
            output from 23.976 input. - Soft: produces 23.976; the player converts this output to
            29.97i.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

            - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
            bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
            one layer, reference B-frames can form a second layer and non-reference b-frames can
            form a third layer. Decoders can optionally decode only the lower temporal layers to
            generate a lower frame rate output. For example, given a bitstream with temporal IDs and
            with b-frames =
                 1 (i.e. IbPbPb display order), a decoder could decode all the frames for
            full frame rate output or only the I and P frames (lowest temporal layer) for a half
            frame rate output.

            - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
            subdivision of the encoded pictures.

            - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
            of an unregistered SEI message.

            - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
            doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
            DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
            Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
            following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition.
            For these outputs, the service stores parameter set NAL units in the sample headers but
            not in the samples directly. For MP4 outputs, when you choose HVC1, your output video
            might not work properly with some downstream systems and video players. The service
            defaults to marking your output as HEV1. For these outputs, the service writes parameter
            set NAL units directly into the samples.

          - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value MPEG2.

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
            the video output.

            - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
            profile for the video output.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type. - If the source is interlaced, the
            output will be interlaced with the same polarity as the source (it will follow the
            source). The output could therefore be a mix of "top field first" and "bottom field
            first". - If the source is progressive, the output will be interlaced with "top field
            first" or "bottom field first" polarity, depending on which of the Follow options you
            chose.

            - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
            set quantization precision for intra-block DC coefficients. If you choose the value
            auto, the service will automatically select the precision based on the per-frame
            compression ratio.

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level
            (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
            encoding.

            - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
            specifiy whether the bitrate is variable (vbr) or constant (cbr).

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
            high-frequency content in the encoded image.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

            - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
            (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
            output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
            converstion to the player.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

          - **ProresSettings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value PRORES.

            - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
            of Apple ProRes codec to use for this output.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
            frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
            23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
            example, use 24000 for the value of FramerateNumerator.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type. - If the source is interlaced, the
            output will be interlaced with the same polarity as the source (it will follow the
            source). The output could therefore be a mix of "top field first" and "bottom field
            first". - If the source is progressive, the output will be interlaced with "top field
            first" or "bottom field first" polarity, depending on which of the Follow options you
            chose.

            - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
            determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
            the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
            the console, choose it from the dropdown menu. Using the API, set ProresParControl to
            (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
            (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
            output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
            converstion to the player.

        - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
        metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output.
        If you don't specify a value, the service sets this to Insert by default.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame.

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
        is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
        use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
        enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

        - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
        (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
        on all frames of this video output.

        - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
        height for this output. Specify in pixels. If you don't provide a value here, the service
        will use the input height.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black.

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
        service changes the video itself in response to AFD values in the input. * Choose Respond to
        clip the input video frame according to the AFD value, input display aspect ratio, and
        output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
        choose this when AfdSignaling is set to (NONE). A preferred implementation of this workflow
        is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all
        input AFD values from this output.

        - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
        different aspect ratio from the input aspect ratio. Choose Stretch to output
        (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
        Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
        any value that you specify for the setting Selection placement (position) in this output.

        - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
        anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
        scaling. Sharpness only applies if your output resolution is different from your input
        resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

        - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
        outputs. Only enable Timecode insertion when the input frame rate is identical to the output
        frame rate. To include timecodes in this output, set Timecode insertion
        (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
        is DISABLED. When the service inserts timecodes in an output, by default, it uses any
        embedded timecodes from the input. If none are present, the service will set the timecode
        for the first output frame to zero. To change this default behavior, adjust the settings
        under Timecode configuration (TimecodeConfig). In the console, these settings are located
        under Job > Job settings > Timecode configuration. Note - Timecode source under input
        settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
        output. Source under Job settings > Timecode configuration (TimecodeSource) does.

        - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
        Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
        features are disabled by default.

          - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
          necessary. Enable or disable this feature for each output individually. This setting is
          disabled by default.

            - **Brightness** *(integer) --* Brightness level.

            - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
            output. The service supports conversion between HDR formats, between SDR formats, and
            from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
            conversion doesn't upgrade the dynamic range. The converted video has an HDR format, but
            visually appears the same as an unconverted output.

            - **Contrast** *(integer) --* Contrast level.

            - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
            space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
            want signaled in the output. These values don't affect the pixel values that are encoded
            in the video stream. They are intended to help the downstream video player display
            content in a way that reflects the intentions of the the content creator. When you set
            Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings
            are required. You must set values for Max frame average light level
            (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
            settings don't have a default value. The default values for the other HDR 10 metadata
            settings are defined by the P3D65 color space. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Hue** *(integer) --* Hue in degrees.

            - **Saturation** *(integer) --* Saturation level.

          - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
          and a clearer picture.

            - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
            to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
            (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
            Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
            as a scrolling headline at the bottom of the frame.

            - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
            convert frames that are tagged in metadata as progressive. It will only convert those
            that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
            converts every frame to progressive - even those that are already tagged as progressive.
            Turn Force mode on only if there is a good chance that the metadata has tagged frames as
            progressive when they are not progressive. Do not turn on otherwise; processing frames
            that are already progressive into progressive will probably result in lower quality
            video.

            - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
            will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
            progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
            Adaptive auto-detects and converts to progressive.

          - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
          compatible video output.

            - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
            SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

              - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
              corresponds to the brightest pixel in the entire stream. Measured in nits.

              - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
              that corresponds to the highest frame-average brightness in the entire stream.
              Measured in nits.

            - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
            Dolby Vision MaxCLL and MaxFALL properies.

            - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
            profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
            frame interleaved data.

          - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
          include a graphic overlay on your video. Enable or disable this feature for each output
          individually. This setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
          noise from your video output if necessary. Enable or disable this feature for each output
          individually. This setting is disabled by default.

            - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
            of the following spatial image filtering functions. To use this setting, you must also
            enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. *
            Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. *
            Conserve does min/max noise reduction. * Spatial does frequency-domain filtering based
            on JND principles. * Temporal optimizes video quality for complex motion.

            - **FilterSettings** *(dict) --* Settings for a noise reducer filter

              - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
              values produce stronger filtering.

            - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
            filter.

              - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
              reduction sharpening filter, with 0 disabling the filter and 3 enabling it at maximum
              strength.

              - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
              speed), with 0 being the nominal value.

              - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
              values produce stronger filtering.

            - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
            filter.

              - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
              motion. Higher values produce stronger temporal filtering. This filters highly complex
              scenes more aggressively and creates better VQ for low bitrate outputs.

              - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
              setting reduces bit rate at the cost of transcode time, high setting improves
              transcode time at the cost of bit rate.

              - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
              this output. Higher values produce stronger filtering. We recommend the following
              value ranges, depending on the result that you want: * 0-2 for complexity reduction
              with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
              8-16 for a high level of complexity reduction

          - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
          timecode and specified prefix into the output.

            - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
            burned-in timecode. Valid values are 10, 16, 32, 48.

            - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
            (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

            - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
            burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
            "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
            equivalents. The supported range of characters is 0x20 through 0x7e. This includes
            letters, numbers, and all special characters represented on a standard English keyboard.

        - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
        pixels, for this output. If you don't provide a value here, the service will use the input
        width.

    - **Type** *(string) --* A preset can be of two types: system or custom. System or built-in
    preset can't be modified or deleted by the user.
    """


_ClientGetPresetResponseTypeDef = TypedDict(
    "_ClientGetPresetResponseTypeDef", {"Preset": ClientGetPresetResponsePresetTypeDef}, total=False
)


class ClientGetPresetResponseTypeDef(_ClientGetPresetResponseTypeDef):
    """
    Type definition for `ClientGetPreset` `Response`

    - **Preset** *(dict) --* A preset is a collection of preconfigured media conversion settings
    that you want MediaConvert to apply to the output during the conversion process.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **Category** *(string) --* An optional category you create to organize your presets.

      - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for preset creation.

      - **Description** *(string) --* An optional description you create for each preset.

      - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the preset was last
      updated.

      - **Name** *(string) --* A name you create for each preset. Each name must be unique within
      your account.

      - **Settings** *(dict) --* Settings for preset

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be
        multiple caption settings in a single output.

          - *(dict) --* Caption Description for preset

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.

      - **Type** *(string) --* A preset can be of two types: system or custom. System or built-in
      preset can't be modified or deleted by the user.
    """


_ClientGetQueueResponseQueueReservationPlanTypeDef = TypedDict(
    "_ClientGetQueueResponseQueueReservationPlanTypeDef",
    {
        "Commitment": str,
        "ExpiresAt": datetime,
        "PurchasedAt": datetime,
        "RenewalType": str,
        "ReservedSlots": int,
        "Status": str,
    },
    total=False,
)


class ClientGetQueueResponseQueueReservationPlanTypeDef(
    _ClientGetQueueResponseQueueReservationPlanTypeDef
):
    """
    Type definition for `ClientGetQueueResponseQueue` `ReservationPlan`

    - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
    commitment.

    - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing plan
    term for this reserved queue expires.

    - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the current
    pricing plan for this reserved queue.

    - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing plan
    is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

    - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS) for
    this queue. The number of RTS determines how many jobs the queue can process in parallel; each
    RTS can process one job at a time. When you increase this number, you extend your existing
    commitment with a new 12-month commitment for a larger number of RTS. The new commitment begins
    when you purchase the additional capacity. You can't decrease the number of RTS in your reserved
    queue.

    - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is ACTIVE
    or EXPIRED.
    """


_ClientGetQueueResponseQueueTypeDef = TypedDict(
    "_ClientGetQueueResponseQueueTypeDef",
    {
        "Arn": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "PricingPlan": str,
        "ProgressingJobsCount": int,
        "ReservationPlan": ClientGetQueueResponseQueueReservationPlanTypeDef,
        "Status": str,
        "SubmittedJobsCount": int,
        "Type": str,
    },
    total=False,
)


class ClientGetQueueResponseQueueTypeDef(_ClientGetQueueResponseQueueTypeDef):
    """
    Type definition for `ClientGetQueueResponse` `Queue`

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for when you created the queue.

    - **Description** *(string) --* An optional description that you create for each queue.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds for when you most recently
    updated the queue.

    - **Name** *(string) --* A name that you create for each queue. Each name must be unique within
    your account.

    - **PricingPlan** *(string) --* Specifies whether the pricing plan for the queue is on-demand or
    reserved. For on-demand, you pay per minute, billed in increments of .01 minute. For reserved,
    you pay for the transcoding capacity of the entire queue, regardless of how much or how little
    you use it. Reserved pricing requires a 12-month commitment.

    - **ProgressingJobsCount** *(integer) --* The estimated number of jobs with a PROGRESSING
    status.

    - **ReservationPlan** *(dict) --* Details about the pricing plan for your reserved queue.
    Required for reserved queues and not applicable to on-demand queues.

      - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
      commitment.

      - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing
      plan term for this reserved queue expires.

      - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the
      current pricing plan for this reserved queue.

      - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing plan
      is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

      - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS) for
      this queue. The number of RTS determines how many jobs the queue can process in parallel; each
      RTS can process one job at a time. When you increase this number, you extend your existing
      commitment with a new 12-month commitment for a larger number of RTS. The new commitment
      begins when you purchase the additional capacity. You can't decrease the number of RTS in your
      reserved queue.

      - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is
      ACTIVE or EXPIRED.

    - **Status** *(string) --* Queues can be ACTIVE or PAUSED. If you pause a queue, the service
    won't begin processing jobs in that queue. Jobs that are running when you pause the queue
    continue to run until they finish or result in an error.

    - **SubmittedJobsCount** *(integer) --* The estimated number of jobs with a SUBMITTED status.

    - **Type** *(string) --* Specifies whether this on-demand queue is system or custom. System
    queues are built in. You can't modify or delete system queues. You can create and modify custom
    queues.
    """


_ClientGetQueueResponseTypeDef = TypedDict(
    "_ClientGetQueueResponseTypeDef", {"Queue": ClientGetQueueResponseQueueTypeDef}, total=False
)


class ClientGetQueueResponseTypeDef(_ClientGetQueueResponseTypeDef):
    """
    Type definition for `ClientGetQueue` `Response`

    - **Queue** *(dict) --* You can use queues to manage the resources that are available to your
    AWS account for running multiple transcoding jobs at the same time. If you don't specify a
    queue, the service sends all jobs through the default queue. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/working-with-queues.html.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for when you created the queue.

      - **Description** *(string) --* An optional description that you create for each queue.

      - **LastUpdated** *(datetime) --* The timestamp in epoch seconds for when you most recently
      updated the queue.

      - **Name** *(string) --* A name that you create for each queue. Each name must be unique
      within your account.

      - **PricingPlan** *(string) --* Specifies whether the pricing plan for the queue is on-demand
      or reserved. For on-demand, you pay per minute, billed in increments of .01 minute. For
      reserved, you pay for the transcoding capacity of the entire queue, regardless of how much or
      how little you use it. Reserved pricing requires a 12-month commitment.

      - **ProgressingJobsCount** *(integer) --* The estimated number of jobs with a PROGRESSING
      status.

      - **ReservationPlan** *(dict) --* Details about the pricing plan for your reserved queue.
      Required for reserved queues and not applicable to on-demand queues.

        - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
        commitment.

        - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing
        plan term for this reserved queue expires.

        - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the
        current pricing plan for this reserved queue.

        - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing
        plan is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

        - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS)
        for this queue. The number of RTS determines how many jobs the queue can process in
        parallel; each RTS can process one job at a time. When you increase this number, you extend
        your existing commitment with a new 12-month commitment for a larger number of RTS. The new
        commitment begins when you purchase the additional capacity. You can't decrease the number
        of RTS in your reserved queue.

        - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is
        ACTIVE or EXPIRED.

      - **Status** *(string) --* Queues can be ACTIVE or PAUSED. If you pause a queue, the service
      won't begin processing jobs in that queue. Jobs that are running when you pause the queue
      continue to run until they finish or result in an error.

      - **SubmittedJobsCount** *(integer) --* The estimated number of jobs with a SUBMITTED status.

      - **Type** *(string) --* Specifies whether this on-demand queue is system or custom. System
      queues are built in. You can't modify or delete system queues. You can create and modify
      custom queues.
    """


_ClientListJobTemplatesResponseJobTemplatesAccelerationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesAccelerationSettingsTypeDef",
    {"Mode": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesAccelerationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesAccelerationSettingsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplates` `AccelerationSettings`

    - **Mode** *(string) --* Specify the conditions when the service will run your job with
    accelerated transcoding.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsAvailBlankingTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsAvailBlankingTypeDef",
    {"AvailBlankingImage": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsAvailBlankingTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsEsam`
    `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsEsam`
    `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsEsamTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ClientListJobTemplatesResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ClientListJobTemplatesResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsEsamTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsEsamTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputs`
    `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectors`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectors`
    `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputs`
    `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCropTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsCropTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsCropTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsInputClippingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsPositionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsPositionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsPositionTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsInputsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str, ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef
        ],
        "AudioSelectors": Dict[
            str, ClientListJobTemplatesResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef
        ],
        "CaptionSelectors": Dict[
            str, ClientListJobTemplatesResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef
        ],
        "Crop": ClientListJobTemplatesResponseJobTemplatesSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DenoiseFilter": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ClientListJobTemplatesResponseJobTemplatesSettingsInputsImageInserterTypeDef,
        "InputClippings": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsInputsInputClippingsTypeDef
        ],
        "Position": ClientListJobTemplatesResponseJobTemplatesSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ClientListJobTemplatesResponseJobTemplatesSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsInputsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsInputsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserter`
    `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserter`
    `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsNielsenConfigurationTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroups`
    `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputs`
    `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputs`
    `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputs`
    `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettings`
    `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputs`
    `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescription`
    `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for
    `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputs`
    `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef
        ],
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsTimecodeConfigTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsTimecodeConfigTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertion`
    `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplatesSettings`
    `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ClientListJobTemplatesResponseJobTemplatesSettingsTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ClientListJobTemplatesResponseJobTemplatesSettingsAvailBlankingTypeDef,
        "Esam": ClientListJobTemplatesResponseJobTemplatesSettingsEsamTypeDef,
        "Inputs": List[ClientListJobTemplatesResponseJobTemplatesSettingsInputsTypeDef],
        "MotionImageInserter": ClientListJobTemplatesResponseJobTemplatesSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ClientListJobTemplatesResponseJobTemplatesSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ClientListJobTemplatesResponseJobTemplatesSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ClientListJobTemplatesResponseJobTemplatesSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ClientListJobTemplatesResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesSettingsTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesSettingsTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponseJobTemplates` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
    job. There can only be one input in a job template. Using the API, you can include multiple
    inputs when referencing a job template.

      - *(dict) --* Specified video input in a template.

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ClientListJobTemplatesResponseJobTemplatesTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseJobTemplatesTypeDef",
    {
        "AccelerationSettings": ClientListJobTemplatesResponseJobTemplatesAccelerationSettingsTypeDef,
        "Arn": str,
        "Category": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "Priority": int,
        "Queue": str,
        "Settings": ClientListJobTemplatesResponseJobTemplatesSettingsTypeDef,
        "StatusUpdateInterval": str,
        "Type": str,
    },
    total=False,
)


class ClientListJobTemplatesResponseJobTemplatesTypeDef(
    _ClientListJobTemplatesResponseJobTemplatesTypeDef
):
    """
    Type definition for `ClientListJobTemplatesResponse` `JobTemplates`

    - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
    with long, visually complex content.

      - **Mode** *(string) --* Specify the conditions when the service will run your job with
      accelerated transcoding.

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **Category** *(string) --* An optional category you create to organize your job templates.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for Job template creation.

    - **Description** *(string) --* An optional description you create for each job template.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the Job template was last
    updated.

    - **Name** *(string) --* A name you create for each job template. Each name must be unique
    within your account.

    - **Priority** *(integer) --* Relative priority on the job.

    - **Queue** *(string) --* Optional. The queue that jobs created from this template are assigned
    to. If you don't specify this, jobs will go to the default queue.

    - **Settings** *(dict) --* JobTemplateSettings contains all the transcode settings saved in the
    template that will be applied to jobs created from it.

      - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
      the input Ad Avail PTS time.

      - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
      overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

        - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
        black. Only bmp and png images are supported.

      - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

        - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
        ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
        uses the manifest conditioning instructions that you provide in the setting MCC XML
        (mccXml).

          - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
          document inside your JSON job settings. Form the XML document as per
          OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions
          in the message that you supply.

        - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
        between the SCTE 35 messages that the transcoder places and the splice points that they
        refer to. If the time between the start of the asset and the SCTE-35 message is less than
        this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

        - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
        SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
        signal processing instructions that you provide in the setting SCC XML (sccXml).

          - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
          inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
          transcoder will use the signal processing instructions in the message that you supply.
          Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
          For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
          insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
          (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
          passthrough. You can't do both.

      - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
      job. There can only be one input in a job template. Using the API, you can include multiple
      inputs when referencing a job template.

        - *(dict) --* Specified video input in a template.

          - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
          combine. An input may have multiple audio selector groups. See "Audio Selector
          Group":#inputs-audio_selector_group for more information.

            - *(string) --*

              - *(dict) --* Group of Audio Selectors

                - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
                to include in the group. Audio selector names are standardized, based on their order
                within the input (e.g., "Audio Selector 1"). The audio selector name parameter can
                be repeated to add any number of audio selectors to the group.

                  - *(string) --*

          - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
          or set of tracks from the input that you will use in your outputs. You can use mutiple
          Audio selectors per input.

            - *(string) --*

              - *(dict) --* Selector for Audio

                - **CustomLanguageCode** *(string) --* Selects a specific language code from within
                an audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                set it as the default for the job. The service uses this default for outputs where
                it can't find the specified input audio. If you don't set a default, those outputs
                have no audio.

                - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                file source.

                - **LanguageCode** *(string) --* Selects a specific language code from within an
                audio source.

                - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                audio from the input video.

                - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
                selects PID 0x101).

                  - *(integer) --*

                - **ProgramSelection** *(integer) --* Use this setting for input streams that
                contain Dolby E, to have the service extract specific program data from the track.
                To select multiple programs, create multiple selectors with the same Track and
                different Program numbers. In the console, this setting is visible when you set
                Selector type to Track. Choose the program number from the dropdown list. If you are
                sending a JSON file, provide the program ID, which is part of the audio metadata. If
                your input file has incorrect metadata, you can choose All channels instead of a
                program number to have the service ignore the program IDs and include all the
                programs in the track.

                - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
                one input to match those of another input. This allows you to combine the two files
                into a single output, one after the other.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **SelectorType** *(string) --* Specifies the type of the audio selector.

                - **Tracks** *(list) --* Identify a track from the input audio to include in this
                selector by entering the track index number. To include several tracks in a single
                audio selector, specify multiple tracks as follows. Using the console, enter a
                comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                Specifying directly in your JSON job file, provide the track numbers in an array.
                For example, "tracks": [1,2,3].

                  - *(integer) --*

          - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
          the captions data from the input that you will use in your outputs. You can use mutiple
          captions selectors per input.

            - *(string) --*

              - *(dict) --* Set up captions in your outputs by first selecting them from your input
              here.

                - **CustomLanguageCode** *(string) --* The specific language to extract from source,
                using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
                complete this field and/or PID to select the caption language to extract. If input
                is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
                select the caption language to extract. If input is DVB-Sub that is being passed
                through, omit this field (and PID field); there is no way to extract a specific
                language with pass-through captions.

                - **LanguageCode** *(string) --* The specific language to extract from source. If
                input is SCTE-27, complete this field and/or PID to select the caption language to
                extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
                and/or PID to select the caption language to extract. If input is DVB-Sub that is
                being passed through, omit this field (and PID field); there is no way to extract a
                specific language with pass-through captions.

                - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                    number in the ancillary data track from which to extract captions. Unused for
                    passthrough.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                    PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content
                    is passed through, regardless of selectors.

                  - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                    within the video track from which to extract captions. Unused for passthrough.

                    - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                    for extracting captions. The system only supports one input video track, so this
                    should always be set to '1'.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                  STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source
                  file. If your caption source is IMSC in an IMF package, use TrackSourceSettings
                  instead of FileSoureSettings.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceFile** *(string) --* External caption file used for loading captions.
                    Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                    'smi'.

                    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                    captions from the source file.

                  - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                  your input captions. The service cannot auto-detect caption format.

                  - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                  sources, including Page number.

                    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                    three-digit hexadecimal page number that will be used for Teletext captions. Do
                    not use this setting if you are passing through teletext from the input source
                    to output.

                  - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                  are specified by track number. Currently, this is only IMSC captions in an IMF
                  package. If your caption source is IMSC 1.1 in a separate xml file, use
                  FileSourceSettings instead of TrackSourceSettings.

                    - **TrackNumber** *(integer) --* Use this setting to select a single captions
                    track from a source. Track numbers correspond to the order in the captions
                    source file. For IMF sources, track numbering is based on the order that the
                    captions appear in the CPL. For example, use 1 to select the captions asset that
                    is listed first in the CPL. To include more than one captions track in your job
                    outputs, create multiple input captions selectors. Specify one track per
                    selector.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame. If you specify a value here, it will
          override any value that you specify in the output setting Cropping selection (crop).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
          motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
          uncompressed video inputs.

          - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
          the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
          video inputs.

          - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
          transcoding service applies the denoise and deblock filters. You must also enable the
          filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
          Auto - The transcoding service determines whether to apply filtering, depending on input
          type and quality. * Disable - The input is not filtered. This is true even if you use the
          API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put
          is filtered regardless of input type.

          - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
          magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
          is 0.

          - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
          overlay on your video. Enable or disable this feature for each input individually. This
          setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
          that together specify a portion of the input to be used in the outputs. If you provide
          only a start time, the clip will be the entire input from that point to the end. If you
          provide only an end time, it will be the entire input up to that point. When you specify
          more than one input clip, the transcoding service creates the job outputs by stringing the
          clips together in the order you specify them.

            - *(dict) --* To transcode only portions of your input (clips), include one Input
            clipping (one instance of InputClipping in the JSON job file) for each input clip. All
            input clips you specify will be included in every output of the job.

              - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
              portion of the input you are clipping. The frame corresponding to the End timecode
              value is included in the clip. Start timecode or End timecode may be left blank, but
              not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
              minute, SS is the second, and FF is the frame number. When choosing this value, take
              into account your setting for timecode source under input settings
              (InputTimecodeSource). For example, if you have embedded timecodes that start at
              01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

              - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning
              of the portion of the input you are clipping. The frame corresponding to the Start
              timecode value is included in the clip. Start timecode or End timecode may be left
              blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour,
              MM is the minute, SS is the second, and FF is the frame number. When choosing this
              value, take into account your setting for Input timecode source. For example, if you
              have embedded timecodes that start at 01:00:00:00 and you want your clip to begin five
              minutes into the video, use 01:05:00:00.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black. If
          you specify a value here, it will override any value that you specify in the output
          setting Selection placement (position). If you specify a value here, this will override
          any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
          (RESPOND). If you specify a value here, this will ignore anything that you specify for the
          setting Scaling Behavior (scalingBehavior).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
          program from within a multi-program transport stream. Note that Quad 4K is not currently
          supported. Default is the first program within the transport stream. If the program you
          specify doesn't exist, the transcoding service will use this default.

          - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
          inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for
          audio and video. * Use PSI - Scan only PSI data.

          - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
          input settings (InputTimecodeSource), to specify how the service counts input video
          frames. This input frame count affects only the behavior of features that apply to a
          single input at a time, such as input clipping and synchronizing some captions formats.
          Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at zero
          (ZEROBASED) to start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to
          start the first frame at the timecode that you specify in the setting Start timecode
          (timecodeStart). If you don't specify a value for Timecode source, the service will use
          Embedded by default. For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
          for this input's initial frame. To use this setting, you must set the Timecode source
          setting, located under the input settings (InputTimecodeSource), to Specified start
          (SPECIFIEDSTART). For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **VideoSelector** *(dict) --* Selector for video.

            - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
            animation. Specify which part of this input MediaConvert uses for your outputs. Leave
            this setting set to DISCARD in order to delete the alpha channel and preserve the video.
            Use REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the
            luma channel of your outputs.

            - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
            if you don't know about color space, leave this set to the default value Follow
            (FOLLOW). The service will automatically detect your input color space. If your input
            video has metadata indicating the wrong color space, specify the accurate color space
            here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume
            static metadata isn't present in your video stream, or if that metadata is present but
            not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the
            input HDR 10 metadata (Hdr10Metadata) settings. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
            file and the job input settings Color space (ColorSpace) and HDR master display
            information settings(Hdr10Metadata). The Color space usage setting determines which
            takes precedence. Choose Force (FORCE) to use color metadata from the input job
            settings. If you don't specify values for those settings, the service defaults to using
            metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata
            from the source when it is present. If there's no color metadata in your input file, the
            service defaults to using values you specify in the input settings.

            - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
            missing or inaccurate in your input video. Appropriate values vary depending on the
            input video and must be provided by a color grader. The color grader generates these
            values during the HDR 10 mastering process. The valid range for each of these settings
            is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
            settings - When you specify these values, you must also set Color space (ColorSpace) to
            HDR 10 (HDR10). To specify whether the the values you specify here take precedence over
            the values in the metadata of your input file, set Color space usage (ColorSpaceUsage).
            To specify whether color metadata is included in an output, set Color metadata
            (ColorMetadata). For more information about MediaConvert HDR jobs, see
            https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
            Specify this value as an integer; the system automatically converts it to the
            hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
            an identifier for a set of data in an MPEG-2 transport stream container.

            - **ProgramNumber** *(integer) --* Selects a specific program from within a
            multi-program transport stream. Note that Quad 4K is not currently supported.

            - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
            your video. You can choose automatic rotation or specify a rotation. You can specify a
            clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov
            or .mp4 and your input has rotation metadata, you can choose Automatic to have the
            service rotate your video according to the rotation specified in the metadata. The
            rotation must be within one degree of 90, 180, or 270 degrees. If the rotation metadata
            specifies any other rotation, the service will default to no rotation. By default, the
            service does no rotation, even if your input video has rotation metadata. The service
            doesn't pass through rotation metadata.

      - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
      graphics that you specify here appear on all outputs in all output groups.

        - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
        unspecified. If your motion graphic asset is a series of .png files, specify the frame rate
        of the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1.
        Make sure that the number of images in your series matches the frame rate and your intended
        overlay duration. For example, if you want a 30-second overlay at 30 fps, you should have
        900 .png images. This overlay frame rate doesn't need to match the frame rate of the
        underlying video.

          - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

          - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

        - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
        overlay on your video. For .png files, provide the file name of the first file in the
        series. Make sure that the names of the .png files end with sequential numbers that specify
        the order that they are played in. For example, overlay_000.png, overlay_001.png,
        overlay_002.png, and so on. The sequence must start at zero, and each image file name must
        have the same number of digits. Pad your initial file names with enough zeros to complete
        the sequence. For example, if the first image is overlay_0.png, there can be only 10 images
        in the sequence, with the last image being overlay_9.png. But if the first image is
        overlay_00.png, there can be 100 images in the sequence.

        - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
        providing for your overlay. You can choose either a .mov file or a series of .png files.

        - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay
        on the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
        specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
        the service inserts the overlay at its native resolution and scales the size up or down with
        any video scaling.

          - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
          edge of the video frame.

          - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
          edge of the video frame.

        - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
        or plays only once.

        - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
        (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
        account how you have set up your timecode configuration under both job settings and input
        settings. The simplest way to do that is to set both to start at 0. If you need to set up
        your job to follow timecodes embedded in your source that don't start at zero, make sure
        that you specify a start time that is after the first embedded timecode. For more
        information, see https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html
        Find job-wide and input timecode configuration settings in your JSON job settings
        specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

      - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
      do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
      configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs
      in the job. To enable Nielsen configuration programmatically, include an instance of
      nielsenConfiguration in your JSON job specification. Even if you don't include any children of
      nielsenConfiguration, you still enable the setting.

        - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
        functionality. If you must include this property, set the value to zero.

        - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
        distributor ID that is assigned to your organization by Neilsen.

      - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
      outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
      MXF, and no container) are grouped in a single output group as well. Required in
      (OutputGroups) is a group of settings that apply to the whole group. This required object
      depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
      settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
      HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
      MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

        - *(dict) --* Group of outputs

          - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
          the output group. This value is displayed on the console and can make your job settings
          JSON more human-readable. It does not affect your outputs. Use up to twelve characters
          that are either letters, numbers, spaces, or underscores.

          - **Name** *(string) --* Name of the output group

          - **OutputGroupSettings** *(dict) --* Output Group settings, including type

            - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
            Output Group may only contain a single video, audio, or caption output.

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
              your job. These default manifests reference every output in the output group. To
              create additional top-level manifests that reference a subset of the outputs in the
              output group, specify a list of them here. For each additional manifest that you
              specify, the service creates one HLS manifest and one DASH manifest.

                - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
                that you want the service to generate for this CMAF output group. Each pair of
                manifests can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
              at the top level BaseURL element. Can be used if streams are delivered from a
              different URL than the manifest file.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
                service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                (SAMPLE-AES) or AES_CTR (AES-CTR).

                - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                outputs, choose whether the service writes the 128-bit encryption initialization
                vector in the HLS and DASH manifests.

                - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                  signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                  package. The DASH manifest can currently signal up to three system IDs. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                  signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                  package. The HLS manifest can currently signal only one system ID. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
              of each individual CMAF segment. This value applies to the whole package; that is, to
              every output in the output group. Note that segments end on the first keyframe after
              this number of seconds, so the actual segment length might be slightly longer. If you
              set Segment control (CmafSegmentControl) to single file, the service puts the content
              of each output in a single file that has metadata that marks these segments. If you
              set it to segmented files, the service creates multiple files for each output, each
              with the content of one segment.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
              generated for this output.

              - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
              be generated for this output.

            - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
              manifest for each DASH ISO output group in your job. This default manifest references
              every output in the output group. To create additional DASH manifests that reference a
              subset of the outputs in the output group, specify a list of them here.

                - *(dict) --* Specify the details for each additional DASH manifest that you want
                the service to generate for this output group. Each manifest can reference a
                different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.mpd.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
              (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
              from a different URL than the manifest file.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                compatibility of your output with video players on obsolete devices. It applies only
                to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
                only to correct problems with playback on older devices. Otherwise, keep the default
                setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the
                service will exclude the access unit delimiter and will leave the SEI NAL units
                unencrypted.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
              that segments will end on the next keyframe after this number of seconds, so actual
              segment length may be longer. When Emit Single File is checked, the segmentation is
              internal to a single output file and it does not cause the creation of many output
              files as in other output types.

              - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
              the 400 range when you play back your DASH output, enable this setting and run your
              transcoding job again. When you enable this setting, the service writes precise
              segment durations in the DASH manifest. The segment duration information appears
              inside the SegmentTimeline element, inside SegmentTemplate at the Representation
              level. When you don't enable this setting, the service writes approximate segment
              durations in your DASH manifest.

            - **FileGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

            - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

              - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
              HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
              outputs themselves.

                - *(string) --*

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest for each HLS output group in your job. This default manifest
              references every output in the output group. To create additional top-level manifests
              that reference a subset of the outputs in the output group, specify a list of them
              here.

                - *(dict) --* Specify the details for each additional HLS manifest that you want the
                service to generate for this output group. Each manifest can reference a different
                subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
              in the media .m3u8 file. Can be used if base manifest is delivered from a different
              URL than the main .m3u8 file.

              - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                - *(dict) --* Caption Language Mapping

                  - **CaptionChannel** *(integer) --* Caption channel.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                  - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                  three-letter code listed at
                  https://www.loc.gov/standards/iso639-2/php/code_list.php.

                  - **LanguageDescription** *(string) --* Caption language description.

              - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
              captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one
              language in the CC1 Language Code field. One CLOSED-CAPTION line is added for each
              Language Code you specify. Make sure to specify the languages in the order in which
              they appear in the original source (if the source is embedded format) or the order of
              the caption selectors (if the source is other than embedded). Otherwise, languages in
              the manifest will not match up properly with the output captions. None: Include
              CLOSED-CAPTIONS=
                  NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from
              the manifest.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
              subdirectories.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
                scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
                disables encryption.

                - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                128-bit number used in conjunction with the key for encrypting blocks. If set to
                INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                Vector is not in the manifest.

                - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                HLS FairPlay content protection.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
              looking ahead and back within the specified range for a nearby avail and extending the
              segment size if needed.

              - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
              be generated for this HLS output group.

              - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
              in .m3u8 manifest files. The value is calculated as follows: either the program date
              and time are initialized using the input timecode source, or the time is initialized
              using the input timecode source and the date is initialized using the
              timestamp_offset.

              - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
              EXT-X-PROGRAM-DATE-TIME entry, in seconds.

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
              media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

              - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
              create (in seconds). Note that segments will end on the next keyframe after this
              number of seconds, so actual segment length may be longer.

              - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
              subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
              for this setting to have an effect.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

              - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

              - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
              offset to fine tune the timestamps.

            - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .ism
              Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
              in your job. This default manifest references every output in the output group. To
              create additional manifests that reference a subset of the outputs in the output
              group, specify a list of them here.

                - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                manifest that you want the service to generate for this output group. Each manifest
                can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                  "-no-premium" for this setting, then the file name the service generates for this
                  top-level manifest is film-name-no-premium.ismv.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
              audio encoding settings across a Microsoft Smooth output group into a single audio
              stream.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* If you are using DRM, set DRM System
              (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
              the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
              and frame rate.

              - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding)
              to specify the encoding format for the server and client manifest. Valid options are
              utf8 and utf16.

            - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
            Microsoft Smooth Streaming, CMAF)

          - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
          settings per output.

            - *(dict) --* An output object describes the settings for a single output file or stream
            in an output group.

              - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
              encoding settings organized by audio codec. Include one instance of
              (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
              encoding settings.

                - *(dict) --* Description of audio output

                  - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                  settings. Ignore these settings unless you need to comply with a loudness
                  standard.

                    - **Algorithm** *(string) --* Choose one of the following audio normalization
                    algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                    loudness for an entire piece of content, suitable for measurement of short-form
                    content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-2: Gated loudness. A measurement of gated average loudness compliant
                    with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
                    with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
                    Allows for more audio channels than the other algorithms, including
                    configurations such as 7.1.

                    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                    using the chosen algorithm. If disabled, the audio will be measured but not
                    adjusted.

                    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                    be corrected to the target level. Content measuring below this level will not be
                    corrected. Gating only applies when not using real_time_correction.

                    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                    loudness to a CSV file.

                    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                    TruePeak for each output's audio track loudness.

                    - **TargetLkfs** *(float) --* When you use Audio normalization
                    (AudioNormalizationSettings), optionally use this setting to specify a target
                    loudness. If you don't specify a value here, the encoder chooses a value for
                    you, based on the algorithm that you choose for Algorithm (algorithm). If you
                    choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                    encoder will choose -23 LKFS.

                  - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                  input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                  name based on its order within each input. For example if you specify "Audio
                  Selector 3", then the third audio selector will be used from each input. If an
                  input does not have an "Audio Selector 3", then the audio selector marked as
                  "default" in that input will be used. If there is no audio selector marked as
                  "default", silence will be inserted for the duration of that input. Alternatively,
                  an "Audio Selector Group":#inputs-audio_selector_group name may be specified, with
                  similar default/silence behavior. If no audio_source_name is specified, then
                  "Audio Selector 1" will be chosen automatically.

                  - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                  unchecked (false). A number between 0 and 255. The following are defined in
                  ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                       Hearing Impaired, 3 =
                  Visually Impaired Commentary, 4-255 = Reserved.

                  - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                  contains an ISO 639 audio_type, then that value is passed through to the output.
                  If the input contains no ISO 639 audio_type, the value in Audio Type is included
                  in the output. Otherwise the value in Audio Type is included in the output. Note
                  that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                  is set to BROADCASTER_MIXED_AD.

                  - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                  (AudioDescriptions) contains the group of settings related to audio encoding. The
                  settings in this group vary depending on the value that you choose for Audio codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * AAC,
                  AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                  Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                    - **AacSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                    two mutually exclusive groups of AAC settings--VBR and CBR. To select one of
                    these modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or
                    "CBR". In VBR mode, you control the audio quality with the setting VBR quality
                    (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                    valid values depend on the rate control mode.

                      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                      when the input contains pre-mixed main audio + audio description (AD) as a
                      stereo pair. The value for AudioType will be set to 3, which signals to
                      downstream systems that this stream contains "broadcaster mixed AD". Note that
                      the input received by the encoder must contain pre-mixed audio; the encoder
                      does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                      ignores any values you provide in AudioType and FollowInputAudioType. Choose
                      NORMAL when the input does not contain pre-mixed audio + audio description
                      (AD). In this case, the encoder will use any values you provide for AudioType
                      and FollowInputAudioType.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      The set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000,
                      16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000,
                      112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000,
                      448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you set is
                      also constrained by the values that you choose for Profile (codecProfile),
                      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
                      values depend on Bitrate control mode and Profile.

                      - **CodecProfile** *(string) --* AAC Profile.

                      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                      channel layout. Valid values depend on rate control mode and profile. "1.0 -
                      Audio Description (Receiver Mix)" setting receives a stereo description plus
                      control track and emits a mono AAC encode of the description track, with
                      control data emitted in the PES header as per ETSI TS 101 154 Annex E.

                      - **RateControlMode** *(string) --* Rate Control Mode.

                      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                      use LATM/LOAS AAC in an output, you must choose "No container" for the output
                      container.

                      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                      control mode and profile.

                      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                      for raw or MPEG-2 Transport Stream containers.

                      - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                      rate_control_mode is VBR.

                    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AC3.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                      stream that the encoder emits. For more information about the AC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital, dialnorm will be passed through.

                      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                      adds dynamic range compression signaling to the output bitstream as defined in
                      the Dolby Digital specification.

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                    - **AiffSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AIFF.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **Codec** *(string) --* Type of Audio codec.

                    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid values: 384k, 448k, 640k, 768k

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                      (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                      adjust loudness based on dialogue analysis.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                      this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix
                      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                      value -60 mutes the channel.

                      - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                      your audio.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                      that must be speech before the encoder uses the measured speech loudness as
                      the overall program loudness.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing.

                      - **SurroundExMode** *(string) --* Specify whether your input audio has an
                      additional center rear surround channel matrix encoded into your left and
                      right surround channels.

                    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3.

                      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                      dB attenuation to the surround channels. Only used for 3/2 coding mode.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                      number of channels.

                      - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital Plus, dialnorm will be passed through.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                      LFE channel is enabled

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left only/Right only center (loRoCenterMixLevel).

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                      channel. This setting applies only if you keep the default value of 3/2 - L,
                      R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                      If you choose a different value for Coding mode, the service ignores Left
                      only/Right only surround (loRoSurroundMixLevel).

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total center (ltRtCenterMixLevel).

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                      surround). MediaConvert uses this value for downmixing. How the service uses
                      this value depends on the value that you choose for Stereo downmix
                      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
                      -60 mutes the channel. This setting applies only if you keep the default value
                      of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total surround (ltRtSurroundMixLevel).

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                      audio will be passed through if it is present on the input. this detection is
                      dynamic over the life of the transcode. Inputs that alternate between DD+ and
                      non-DD+ content will have a consistent DD+ output as the system alternates
                      between passthrough and encoding.

                      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                      the surround channels. Only used for 3/2 coding mode.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing. This setting only applies if you keep the default value of 3/2 -
                      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Stereo downmix (Eac3StereoDownmix).

                      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                      extra center back surround channel is matrix encoded into the left and right
                      surround channels.

                      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                      Surround is matrix encoded into the two channels.

                    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value MP2.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                      - **Channels** *(integer) --* Set Channels to specify the number of channels
                      in this output audio track. Choosing Mono in the console will give you 1
                      output channel; choosing Stereo will give you 2. In the API, valid values are
                      1 and 2.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **WavSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value WAV.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                      If your output audio is likely to exceed 4 GB in file size, or if you
                      otherwise need the extended support of the RF64 format, set your output WAV
                      file format to RF64.

                      - **SampleRate** *(integer) --* Sample rate in Hz.

                  - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                  track. The service puts this language code into your output audio track when you
                  set Language code control (AudioLanguageCodeControl) to Use configured
                  (USE_CONFIGURED). The service also uses your specified custom language code when
                  you set Language code control (AudioLanguageCodeControl) to Follow input
                  (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                  outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                  can also use any other code in the full RFC-5646 specification. Streaming outputs
                  are those that are in one of the following output groups: CMAF, DASH ISO, Apple
                  HLS, or Microsoft Smooth Streaming.

                  - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                  The ISO 639 language specified in the 'Language Code' drop down will be used when
                  'Follow Input Language Code' is not selected or when 'Follow Input Language Code'
                  is selected but there is no ISO 639 language code specified by the input.

                  - **LanguageCodeControl** *(string) --* Specify which source for language code
                  takes precedence for this audio track. When you choose Follow input
                  (FOLLOW_INPUT), the service uses the language code from the input track if it's
                  present. If there's no languge code on the input track, the service uses the code
                  that you specify in the setting Language code (languageCode or
                  customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service
                  uses the language code that you specify.

                  - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **StreamName** *(string) --* Specify a label for this output audio stream. For
                  example, "English", "Director commentary", or "track_2". For streaming outputs,
                  MediaConvert passes this information into destination manifests for display on the
                  end-viewer's player device. For outputs in other output groups, the service
                  ignores this setting.

              - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
              captions settings. For each output that has captions, include one instance of
              (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
              settings.

                - *(dict) --* Description of Caption output

                  - **CaptionSelectorName** *(string) --* Specifies which "Caption
                  Selector":#inputs-caption_selector to use from each input when generating
                  captions. The name should be of the format "Caption Selector ", which denotes that
                  the Nth Caption Selector will be used from each input.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  output track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information when automatically
                  selecting the font script for rendering the captions text. For all outputs, you
                  can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
                  any other code in the full RFC-5646 specification. Streaming outputs are those
                  that are in one of the following output groups: CMAF, DASH ISO, Apple HLS, or
                  Microsoft Smooth Streaming.

                  - **DestinationSettings** *(dict) --* Specific settings required by destination
                  type. Note that burnin_destination_settings are not available if the source of the
                  caption data is Embedded or Teletext.

                    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering burn-in captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **DestinationType** *(string) --* Specify the format for this set of captions
                    on this output. The default format is embedded without SCTE-20. Other options
                    are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                    web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                    (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec.
                    To create a non-compliant output where the embedded captions come first, choose
                    Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering DVB-Sub captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                      standard or for hearing impaired. Choose hearing impaired if your subtitles
                      include audio descriptions and dialogue. Choose standard if your subtitles
                      include only dialogue.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                    embedded/ancillary caption outputs, including 608/708 Channel destination
                    number.

                      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and your output captions are embedded in
                      the video stream. Specify a CC number for each captions channel in this
                      output. If you have two channels, choose CC numbers that aren't in the same
                      field. For example, choose 1 and 3. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and you want both 608 and 708 captions
                      embedded in your output stream. Optionally, specify the 708 service number for
                      each output captions channel. Choose a different number for each channel. To
                      use this setting, also set Force 608 to 708 upconvert (Convert608To708) to
                      Upconvert (UPCONVERT) in your input captions selector settings. If you choose
                      to upconvert but don't specify a 708 service number, MediaConvert uses the
                      number that you specify for CC channel number (destination608ChannelNumber)
                      for the 708 service number. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                    outputs.

                      - **StylePassthrough** *(string) --* Keep this setting enabled to have
                      MediaConvert use the font style and position information from the captions
                      source in the output. This option is available only when your input captions
                      are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                      output captions.

                    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                      sure that the captions and the video are synchronized in the output. Specify a
                      frame rate that matches the frame rate of the associated video. If the video
                      frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only
                      if the video has video_insertion=
                          true and drop_frame_timecode=true; otherwise,
                      choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                    output

                      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                      the destination captions for this output. This value must be a three-digit
                      hexadecimal string; strings ending in -FF are invalid. If you are passing
                      through the entire set of Teletext data, do not use this field.

                      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                      you don't specify a value here, the service sets the page type to the default
                      value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                      Teletext data, don't use this field. When you pass through a set of Teletext
                      pages, your output has the same page types as your input.

                        - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                        Table 94

                    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                    outputs, including Pass style information (TtmlStylePassthrough).

                      - **StylePassthrough** *(string) --* Pass through style and position
                      information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                      CFF-TT output or TTML output.

                  - **LanguageCode** *(string) --* Specify the language of this captions output
                  track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information to choose the font
                  language for rendering the captions text.

                  - **LanguageDescription** *(string) --* Specify a label for this set of output
                  captions. For example, "English", "Director commentary", or "track_2". For
                  streaming outputs, MediaConvert passes this information into destination manifests
                  for display on the end-viewer's player device. For outputs in other output groups,
                  the service ignores this setting.

              - **ContainerSettings** *(dict) --* Container specific settings.

                - **Container** *(string) --* Container for this output. Some containers require a
                container settings object. If not specified, the default object will be created.

                - **F4vSettings** *(dict) --* Settings for F4v container

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs
                in a File output group when the output's container (ContainerType) is MPEG-2
                Transport Stream (M2TS). In these assets, data is organized by the program map table
                (PMT). Each transport stream program contains subsets of data, including audio,
                video, and metadata. Each of these subsets of data has a numerical label called a
                packet identifier (PID). Each transport stream program corresponds to one
                MediaConvert output. The PMT lists the types of data in a program along with their
                PID. Downstream systems and players use the program map table to look up the PID for
                each type of data it accesses and then uses the PIDs to locate specific data within
                the asset.

                  - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                  models for Dolby Digital audio.

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                  elementary audio streams you include in this output. Specify multiple PIDs as a
                  JSON array. Default is the range 482-492.

                    - *(integer) --*

                  - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                  bits per second. Setting to 0 lets the muxer automatically determine the
                  appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                  - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                  interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                  this can lead to lower latency, but low-memory devices may not be able to play
                  back the stream without interruptions.

                  - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                  the specified table repetition interval.

                    - **NetworkId** *(integer) --* The numeric value placed in the Network
                    Information Table (NIT).

                    - **NetworkName** *(string) --* The network name text placed in the
                    network_name_descriptor inside the Network Information Table. Maximum length is
                    256 characters.

                    - **NitInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                  the specified table repetition interval.

                    - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                    output stream. "Follow input SDT" copies SDT information from input stream to
                    output stream. "Follow input SDT if present" copies SDT information from input
                    stream to output stream if SDT information is present in the input, otherwise it
                    will fall back on the user-defined values. Enter "SDT Manually" means user will
                    enter the SDT information. "No SDT" means output stream will not contain SDT
                    information.

                    - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **ServiceName** *(string) --* The service name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                    - **ServiceProviderName** *(string) --* The service provider name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                  - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                  subtitle data included in this output. Specify multiple PIDs as a JSON array.
                  Default is the range 460-479.

                    - *(integer) --*

                  - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                  specified table repetition interval.

                    - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                  teletext data you include in this output. Default is 499.

                  - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                  EBP markers will be added to partitions 3 and 4. The interval between these
                  additional markers will be fixed, and will be slightly shorter than the video EBP
                  marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                  inserted. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                  can either be placed only on the video PID, or on both the video PID and all audio
                  PIDs. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                  the PES header.

                  - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                  you know that your audio EBP markers are incorrectly appearing before your video
                  EBP markers. To correct this problem, set this value to Force (FORCE).

                  - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                  used with EBP markers.

                  - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                  between Program Clock References (PCRs) inserted into the transport stream.

                  - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                  Points do not come within the specified time interval of each other by looking
                  ahead at input video. If another EBP is going to come in within the specified time
                  interval, the current EBP is not emitted, and the segment is "stretched" to the
                  next marker. The lookahead value does not add latency to the system. The Live
                  Event must be configured elsewhere to create sufficient latency to make the
                  lookahead accurate.

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                  packets to insert into the transport stream. This can be used if a downstream
                  encryption system requires periodic null packets.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This is effective only when the PCR PID is the same as the video or audio
                  elementary stream.

                  - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                  clock reference (PCR) in this output. If you do not specify a value, the service
                  will use the value for Video PID (VideoPid).

                  - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                  instances of the program map table (PMT) in the output transport stream.

                  - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                  map table (PMT) itself. Default is 480.

                  - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                  private metadata stream. Default is 503.

                  - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                  the program number used in the program map table (PMT) for this output. Default is
                  1. Program numbers and program map tables are parts of MPEG-2 transport stream
                  containers, used for organizing data.

                  - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                  stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                  maximum bitrate, but the output will not be padded up to that bitrate.

                  - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                  markers in your HLS and transport stream outputs at the insertion points that you
                  specify in an ESAM XML document. Provide the document in the setting SCC XML
                  (sccXml).

                    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                    in the transport stream generated by ESAM.

                  - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                  stream in the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None
                  (NONE). Also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml). Also enable ESAM SCTE-35 (include the property
                  scte35Esam).

                  - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                  segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                  adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                  private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                  segments. ebp adds Encoder Boundary Point information to the adaptation field as
                  per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary
                  Point information to the adaptation field using a legacy proprietary format.

                  - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                  how segmentation markers are inserted into the transport stream. With avails, it
                  is possible that segments may be truncated, which can influence where future
                  segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                  selected and a segment is truncated due to an avail, we will reset the
                  segmentation cadence. This means the subsequent segment will have a duration of of
                  $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                  selected and a segment is truncated due to an avail, we will not reset the
                  segmentation cadence. This means the subsequent segment will likely be truncated
                  as well. However, all segments after that will have a duration of
                  $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
                  rule.

                  - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                  segment. Required unless markers is set to _none_.

                  - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                  timed metadata in this output. Default is 502.

                  - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                  itself in the program map table for this output. Transport stream IDs and program
                  map tables are parts of MPEG-2 transport stream containers, used for organizing
                  data.

                  - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                  elementary video stream in the transport stream.

                - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                  stream(s) in the transport stream. Multiple values are accepted, and can be
                  entered in ranges and/or by comma separation.

                    - *(integer) --*

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This parameter is effective only when the PCR PID is the same as the video or
                  audio elementary stream.

                  - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                  (PCR) in the transport stream. When no value is given, the encoder will assign the
                  same value as the Video PID.

                  - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                  (PMT) in the transport stream.

                  - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                  metadata stream in the transport stream.

                  - **ProgramNumber** *(integer) --* The value of the program number field in the
                  Program Map Table.

                  - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                  the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE)
                  if you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and
                  choose Ad markers (adMarkers) if you do want manifest conditioning. In both cases,
                  also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml).

                  - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                  specify whether the service inserts the ID3 timed metadata from the input in this
                  output.

                  - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                  metadata stream in the transport stream.

                  - **TransportStreamId** *(integer) --* The value of the transport stream ID field
                  in the Program Map Table.

                  - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                  stream in the transport stream.

                - **MovSettings** *(dict) --* Settings for MOV Container.

                  - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                  the video output settings.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                  streams into the QuickTime file using XDCAM fourcc codes. This increases
                  compatibility with Apple editors and players, but may decrease compatibility with
                  other players. Only applicable when the video codec is MPEG2.

                  - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                  padding

                  - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                  this setting.

                - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
                AAC outputs with this container.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                  moov box.

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                  - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                  file. Usually not necessary to specify.

                - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                  - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                  groups that include sidecar TTML or IMSC captions. You specify sidecar captions in
                  a separate output from your audio and video. Choose Raw (RAW) for captions in a
                  single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for
                  captions in XML format contained within fragmented MP4 files. This set of
                  fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                  - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                  markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                  insertion points that you specify in an ESAM XML document. Provide the document in
                  the setting SCC XML (sccXml).

                  - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                  markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                  SCTE-35 markers that appear in your input to also appear in this output. Choose
                  None (NONE) if you don't want those SCTE-35 markers in this output.

              - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
              for outputs in File output groups. If you do not specify a value, the service will use
              default extensions by container type as follows * MPEG-2 transport stream, m2ts *
              Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the
              service will use codec extensions (e.g. AAC, H265, H265, AC3)

              - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
              add a string to the end of each output filename. You specify the base filename as part
              of your destination URI. When you create multiple outputs in the same output group,
              Name modifier (NameModifier) is required. Name modifier also accepts format
              identifiers. For DASH ISO outputs, if you use the format identifiers $Number$ or
              $Time$ in one output, you must use them in the same way in all outputs of the output
              group.

              - **OutputSettings** *(dict) --* Specific settings for this type of output.

                - **HlsSettings** *(dict) --* Settings for HLS output groups

                  - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                  belongs.

                  - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                  outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                  container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                  file in a raw container. Regardless of the value that you specify here, if this
                  output has video, the service will place the output into an MPEG2-TS container.

                  - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                  with the video output stream. Input all the audio GROUP-IDs that are associated to
                  the video, separate by ','.

                  - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                  Audio-Only Variant Stream The client can play back this audio-only stream instead
                  of video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                  manifest. Alternate Audio, Auto Select, Default Alternate rendition that the
                  client should try to play back by default. Represented as an EXT-X-MEDIA in the
                  HLS manifest with DEFAULT=YES, AUTOSELECT=
                      YES Alternate Audio, Auto Select, Not
                  Default Alternate rendition that the client may try to play back by default.
                  Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                      NO, AUTOSELECT=YES
                  Alternate Audio, not Auto Select Alternate rendition that the client will not try
                  to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
                  DEFAULT=NO, AUTOSELECT=NO

                  - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                  Manifest in addition to the HLS manifest

                  - **SegmentModifier** *(string) --* String concatenated to end of segment
                  filenames. Accepts "Format Identifiers":#format_identifier_parameters.

              - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
              transcoding settings. Provide the system or custom preset name. You can specify either
              Preset (Preset) or Container settings (ContainerSettings), but not both.

              - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
              encoding settings. The specific video settings depend on the video codec that you
              choose when you specify a value for Video codec (codec). Include one instance of
              (VideoDescription) per output.

                - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                service includes AFD values in the output video data and what those values are. *
                Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                input AFD values and instead encode the value specified in the job. * Choose Auto to
                calculate output AFD values based on the input AFD scaler data.

                - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
                outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
                specify that in your job, the service will ignore the setting.

                - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                (VideoDescription), contains the group of settings related to video encoding. The
                settings in this group vary depending on the value that you choose for Video codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * H_264,
                H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
                FRAME_CAPTURE, FrameCaptureSettings

                  - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                  the enum values defined by the object VideoCodec.

                  - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                    - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.n.jpg where n is the 0-based sequence number of each Capture.

                    - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
                    to 7 decimal places.

                    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                    files).

                    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                    quality.

                  - **H264Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value H_264.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                    your output video settings. If you aren't sure what level to specify, choose
                    Auto (AUTO).

                    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                    are only available with the AVC-I License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                    Main or High profile) or CAVLC.

                    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                    for interlaced outputs.

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job specification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* When you use the API for transcode
                    jobs that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateDenominator to specify the
                    denominator of this fraction. In this example, use 1001 for the value of
                    FramerateDenominator. When you use the console for transcode jobs that use frame
                    rate conversion, provide the value as a decimal number for Framerate. In this
                    example, specify 23.976.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type, as follows. - If the source is interlaced, the output will be interlaced
                    with the same polarity as the source (it will follow the source). The output
                    could therefore be a mix of "top field first" and "bottom field first". - If the
                    source is progressive, the output will be interlaced with "top field first" or
                    "bottom field first" polarity, depending on which of the Follow options you
                    chose.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even
                    if repeated.

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                  - **H265Settings** *(dict) --* Settings for H265 codec

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                    Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                    Transfer Function (EOTF).

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* H.265 Level.

                    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                    (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                    "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                    available with the HEVC 4:2:2 License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                    Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                    the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field
                    First (BOTTOM_FIELD) to create an output that's interlaced with the same field
                    polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow,
                    Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the
                    same field polarity as the source. If the source is interlaced, the output will
                    be interlaced with the same polarity as the source (it will follow the source).
                    The output could therefore be a mix of "top field first" and "bottom field
                    first". If the source is progressive, your output will be interlaced with "top
                    field first" or "bottom field first" polarity, depending on which of the Follow
                    options you chose. If you don't choose a value, the service will default to
                    Progressive (PROGRESSIVE).

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                    Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                    based on content

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                    encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                    and P-frames form one layer, reference B-frames can form a second layer and
                    non-reference b-frames can form a third layer. Decoders can optionally decode
                    only the lower temporal layers to generate a lower frame rate output. For
                    example, given a bitstream with temporal IDs and with b-frames =
                         1 (i.e. IbPbPb
                    display order), a decoder could decode all the frames for full frame rate output
                    or only the I and P frames (lowest temporal layer) for a half frame rate output.

                    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                    vertical subdivision of the encoded pictures.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                    units doesn't matter in your workflow, ignore this setting. Use this setting
                    only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                    container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                    your output compliant with the following specification: ISO IECJTC1 SC29 N13798
                    Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
                    parameter set NAL units in the sample headers but not in the samples directly.
                    For MP4 outputs, when you choose HVC1, your output video might not work properly
                    with some downstream systems and video players. The service defaults to marking
                    your output as HEV1. For these outputs, the service writes parameter set NAL
                    units directly into the samples.

                  - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value MPEG2.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                    level for the video output.

                    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                    MPEG-2 profile for the video output.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **IntraDcPrecision** *(string) --* Use Intra DC precision
                    (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                    coefficients. If you choose the value auto, the service will automatically
                    select the precision based on the per-frame compression ratio.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                    video encoding.

                    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                    to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                    356M-2001).

                    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                  - **ProresSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value PRORES.

                    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                    the type of Apple ProRes codec to use for this output.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                    that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateNumerator to specify the
                    numerator of this fraction. In this example, use 24000 for the value of
                    FramerateNumerator.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                    determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                    to use the pixel aspect ratio from the input. To specify a different pixel
                    aspect ratio: Using the console, choose it from the dropdown menu. Using the
                    API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                    (ParDenominator).

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
                color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
                this output. If you don't specify a value, the service sets this to Insert by
                default.

                - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
                the service will include in the output video frame.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                feature is enabled, the service will use drop-frame timecode on outputs. If it is
                not possible to use drop-frame timecode, the system will fall back to
                non-drop-frame. This setting is enabled by default when Timecode insertion
                (TimecodeInsertion) is enabled.

                - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
                Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                service will write on all frames of this video output.

                - **Height** *(integer) --* Use the Height (Height) setting to define the video
                resolution height for this output. Specify in pixels. If you don't provide a value
                here, the service will use the input height.

                - **Position** *(dict) --* Use Selection placement (position) to define the video
                area in your output frame. The area outside of the rectangle that you specify here
                is black.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                the service changes the video itself in response to AFD values in the input. *
                Choose Respond to clip the input video frame according to the AFD value, input
                display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                include the input AFD values. Do not choose this when AfdSignaling is set to (NONE).
                A preferred implementation of this workflow is to set RespondToAfd to (NONE) and set
                AfdSignaling to (AUTO). * Choose None to remove all input AFD values from this
                output.

                - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                have a different aspect ratio from the input aspect ratio. Choose Stretch to output
                (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
                setting Default (DEFAULT) to have the service letterbox your video instead. This
                setting overrides any value that you specify for the setting Selection placement
                (position) in this output.

                - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                strength of anti-aliasing. This setting changes the width of the anti-alias filter
                kernel used for scaling. Sharpness only applies if your output resolution is
                different from your input resolution. 0 is the softest setting, 100 the sharpest,
                and 50 recommended for most content.

                - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                ProRes outputs. Only enable Timecode insertion when the input frame rate is
                identical to the output frame rate. To include timecodes in this output, set
                Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                output, by default, it uses any embedded timecodes from the input. If none are
                present, the service will set the timecode for the first output frame to zero. To
                change this default behavior, adjust the settings under Timecode configuration
                (TimecodeConfig). In the console, these settings are located under Job > Job
                settings > Timecode configuration. Note - Timecode source under input settings
                (InputTimecodeSource) does not affect the timecodes that are inserted in the output.
                Source under Job settings > Timecode configuration (TimecodeSource) does.

                - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                Preprocessors (VideoPreprocessors). Enable the features at each output individually.
                These features are disabled by default.

                  - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                  feature if necessary. Enable or disable this feature for each output individually.
                  This setting is disabled by default.

                    - **Brightness** *(integer) --* Brightness level.

                    - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                    this output. The service supports conversion between HDR formats, between SDR
                    formats, and from SDR to HDR. The service doesn't support conversion from HDR to
                    SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                    video has an HDR format, but visually appears the same as an unconverted output.

                    - **Contrast** *(integer) --* Contrast level.

                    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                    10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                    metadata that you want signaled in the output. These values don't affect the
                    pixel values that are encoded in the video stream. They are intended to help the
                    downstream video player display content in a way that reflects the intentions of
                    the the content creator. When you set Color space conversion
                    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                    must set values for Max frame average light level (maxFrameAverageLightLevel)
                    and Max content light level (maxContentLightLevel); these settings don't have a
                    default value. The default values for the other HDR 10 metadata settings are
                    defined by the P3D65 color space. For more information about MediaConvert HDR
                    jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                      samples in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                      any frame in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance
                      in units of of 0.0001 candelas per square meter.

                      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance
                      in units of of 0.0001 candelas per square meter

                      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                    - **Hue** *(integer) --* Hue in degrees.

                    - **Saturation** *(integer) --* Saturation level.

                  - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                  motion and a clearer picture.

                    - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                    (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                    adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                    (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if
                    your source file includes a ticker, such as a scrolling headline at the bottom
                    of the frame.

                    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                    does not convert frames that are tagged in metadata as progressive. It will only
                    convert those that are tagged as some other type. - When set to
                    FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                    those that are already tagged as progressive. Turn Force mode on only if there
                    is a good chance that the metadata has tagged frames as progressive when they
                    are not progressive. Do not turn on otherwise; processing frames that are
                    already progressive into progressive will probably result in lower quality
                    video.

                    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                    service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                    interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                    progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                  - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                  compatible video output.

                    - **L6Metadata** *(dict) --* Use these settings when you set
                    DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                    your input with new values.

                      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                      that corresponds to the brightest pixel in the entire stream. Measured in
                      nits.

                      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                      metadata that corresponds to the highest frame-average brightness in the
                      entire stream. Measured in nits.

                    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                    handle Dolby Vision MaxCLL and MaxFALL properies.

                    - **Profile** *(string) --* In the current MediaConvert implementation, the
                    Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must
                    contain Dolby Vision frame interleaved data.

                  - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature
                  to include a graphic overlay on your video. Enable or disable this feature for
                  each output individually. This setting is disabled by default.

                    - **InsertableImages** *(list) --* Specify the images that you want to overlay
                    on your video. The images must be PNG or TGA files.

                      - *(dict) --* Settings that specify how your still graphic overlay appears.

                        - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                        image to remain on the output video. This duration includes fade-in time but
                        not fade-out time.

                        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                        between the Start time that you specify for the image insertion and the time
                        that the image appears at full opacity. Full opacity is the level that you
                        specify for the opacity setting. If you don't specify a value for Fade-in,
                        the image will appear abruptly at the overlay start time.

                        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                        between the end of the time that you have specified for the image overlay
                        Duration and when the overlaid image has faded to total transparency. If you
                        don't specify a value for Fade-out, the image will disappear abruptly at the
                        end of the inserted image duration.

                        - **Height** *(integer) --* Specify the height of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        height, the service will crop your overlaid image to fit. To use the native
                        height of the image, keep this setting blank.

                        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                        location of the image that you want to overlay on the video. Use a PNG or
                        TGA file.

                        - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                        inserted image and the left edge of the video frame. Required for any image
                        overlay that you specify.

                        - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                        overlaid image and the top edge of the video frame. Required for any image
                        overlay that you specify.

                        - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                        Images with higher values for Layer appear on top of images with lower
                        values for Layer.

                        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                        the underlying video shows through the inserted image. 0 is transparent and
                        100 is fully opaque. Default is 50.

                        - **StartTime** *(string) --* Specify the timecode of the frame that you
                        want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                        or HH:MM:SS;FF) format. Remember to take into account your timecode source
                        settings.

                        - **Width** *(integer) --* Specify the width of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        width, the service will crop your overlaid image to fit. To use the native
                        width of the image, keep this setting blank.

                  - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                  remove noise from your video output if necessary. Enable or disable this feature
                  for each output individually. This setting is disabled by default.

                    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                    select one of the following spatial image filtering functions. To use this
                    setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                    preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                    Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                    reduction. * Spatial does frequency-domain filtering based on JND principles. *
                    Temporal optimizes video quality for complex motion.

                    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                    spatial filter.

                      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                      reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                      maximum strength.

                      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                      (higher speed), with 0 being the nominal value.

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                    temporal filter.

                      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                      complex motion. Higher values produce stronger temporal filtering. This
                      filters highly complex scenes more aggressively and creates better VQ for low
                      bitrate outputs.

                      - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                      Low setting reduces bit rate at the cost of transcode time, high setting
                      improves transcode time at the cost of bit rate.

                      - **Strength** *(integer) --* Specify the strength of the noise reducing
                      filter on this output. Higher values produce stronger filtering. We recommend
                      the following value ranges, depending on the result that you want: * 0-2 for
                      complexity reduction with minimal sharpness loss * 2-8 for complexity
                      reduction with image preservation * 8-16 for a high level of complexity
                      reduction

                  - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                  output timecode and specified prefix into the output.

                    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                    any burned-in timecode. Valid values are 10, 16, 32, 48.

                    - **Position** *(string) --* Use Position (Position) under under Timecode
                    burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                    output video.

                    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                    any burned-in timecode. For example, a prefix of "EZ-" will result in the
                    timecode "EZ-00:00:00:00". Provide either the characters themselves or the ASCII
                    code equivalents. The supported range of characters is 0x20 through 0x7e. This
                    includes letters, numbers, and all special characters represented on a standard
                    English keyboard.

                - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                in pixels, for this output. If you don't provide a value here, the service will use
                the input width.

      - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
      information from inputs.

        - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
        use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
        the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or
        (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
        Timecode varies depending on your setting for Source (TimecodeSource). * If Source
        (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
        specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
        (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start at
        0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
        Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
        input.

        - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
        within this job. To make sure that your video, audio, captions, and markers are synchronized
        and that time-based features, such as image inserter, work correctly, choose the Timecode
        source option that matches your assets. All timecodes are in a 24-hour format with frame
        number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video.
        If no embedded timecode is in the source, the service will use Start at 0 (ZEROBASED)
        instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. *
        Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other
        than zero. You use Start timecode (Start) to provide this value.

        - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
        (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
        Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

        - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
        stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
        affecting the time and frame number. Provide the new date as a string in the format
        "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
        (InsertProgramDateTime) in the output settings. For example, if the date part of your
        timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
        (TimestampOffset) to 2003-1-25.

      - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
      (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
      enable it here, enable it in each output container, and specify tags and timecodes in ID3
      insertion (Id3Insertion) objects.

        - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

          - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
          specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when
          the tag should be inserted. To insert multiple ID3 tags in your output, create multiple
          instances of ID3 insertion (Id3Insertion).

            - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
            format.

            - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
            format.

    - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
    events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
    MediaConvert sends an update at this interval from the time the service begins processing your
    job to the time it completes the transcode or encounters an error.

    - **Type** *(string) --* A job template can be of two types: system or custom. System or
    built-in job templates can't be modified or deleted by the user.
    """


_ClientListJobTemplatesResponseTypeDef = TypedDict(
    "_ClientListJobTemplatesResponseTypeDef",
    {"JobTemplates": List[ClientListJobTemplatesResponseJobTemplatesTypeDef], "NextToken": str},
    total=False,
)


class ClientListJobTemplatesResponseTypeDef(_ClientListJobTemplatesResponseTypeDef):
    """
    Type definition for `ClientListJobTemplates` `Response`

    - **JobTemplates** *(list) --* List of Job templates.

      - *(dict) --* A job template is a pre-made set of encoding instructions that you can use to
      quickly create a job.

        - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up
        jobs with long, visually complex content.

          - **Mode** *(string) --* Specify the conditions when the service will run your job with
          accelerated transcoding.

        - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

        - **Category** *(string) --* An optional category you create to organize your job templates.

        - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for Job template creation.

        - **Description** *(string) --* An optional description you create for each job template.

        - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the Job template was
        last updated.

        - **Name** *(string) --* A name you create for each job template. Each name must be unique
        within your account.

        - **Priority** *(integer) --* Relative priority on the job.

        - **Queue** *(string) --* Optional. The queue that jobs created from this template are
        assigned to. If you don't specify this, jobs will go to the default queue.

        - **Settings** *(dict) --* JobTemplateSettings contains all the transcode settings saved in
        the template that will be applied to jobs created from it.

          - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added
          to the input Ad Avail PTS time.

          - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
          overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

            - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
            black. Only bmp and png images are supported.

          - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

            - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
            ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The
            transcoder uses the manifest conditioning instructions that you provide in the setting
            MCC XML (mccXml).

              - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
              document inside your JSON job settings. Form the XML document as per
              OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning
              instructions in the message that you supply.

            - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in
            milliseconds, between the SCTE 35 messages that the transcoder places and the splice
            points that they refer to. If the time between the start of the asset and the SCTE-35
            message is less than this value, then the transcoder places the SCTE-35 marker at the
            beginning of the stream.

            - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
            SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
            the signal processing instructions that you provide in the setting SCC XML (sccXml).

              - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
              inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025.
              The transcoder will use the signal processing instructions in the message that you
              supply. Provide your ESAM SignalProcessingNotification XML document inside your JSON
              job settings. For your MPEG2-TS file outputs, if you want the service to place SCTE-35
              markers at the insertion points you specify in the XML document, you must also enable
              SCTE-35 ESAM (scte35Esam). Note that you can either specify an ESAM XML document or
              enable SCTE-35 passthrough. You can't do both.

          - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the
          transcode job. There can only be one input in a job template. Using the API, you can
          include multiple inputs when referencing a job template.

            - *(dict) --* Specified video input in a template.

              - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input
              to combine. An input may have multiple audio selector groups. See "Audio Selector
              Group":#inputs-audio_selector_group for more information.

                - *(string) --*

                  - *(dict) --* Group of Audio Selectors

                    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same
                    input to include in the group. Audio selector names are standardized, based on
                    their order within the input (e.g., "Audio Selector 1"). The audio selector name
                    parameter can be repeated to add any number of audio selectors to the group.

                      - *(string) --*

              - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a
              track or set of tracks from the input that you will use in your outputs. You can use
              mutiple Audio selectors per input.

                - *(string) --*

                  - *(dict) --* Selector for Audio

                    - **CustomLanguageCode** *(string) --* Selects a specific language code from
                    within an audio source, using the ISO 639-2 or ISO 639-3 three-letter language
                    code

                    - **DefaultSelection** *(string) --* Enable this setting on one audio selector
                    to set it as the default for the job. The service uses this default for outputs
                    where it can't find the specified input audio. If you don't set a default, those
                    outputs have no audio.

                    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                    file source.

                    - **LanguageCode** *(string) --* Selects a specific language code from within an
                    audio source.

                    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                    audio from the input video.

                    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g.
                    257 selects PID 0x101).

                      - *(integer) --*

                    - **ProgramSelection** *(integer) --* Use this setting for input streams that
                    contain Dolby E, to have the service extract specific program data from the
                    track. To select multiple programs, create multiple selectors with the same
                    Track and different Program numbers. In the console, this setting is visible
                    when you set Selector type to Track. Choose the program number from the dropdown
                    list. If you are sending a JSON file, provide the program ID, which is part of
                    the audio metadata. If your input file has incorrect metadata, you can choose
                    All channels instead of a program number to have the service ignore the program
                    IDs and include all the programs in the track.

                    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels
                    of one input to match those of another input. This allows you to combine the two
                    files into a single output, one after the other.

                      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                      group of fields that hold the remixing value for each channel. Units are in
                      dB. Acceptable values are within the range from -60 (mute) through 6. A
                      setting of 0 passes the input channel unchanged to the output channel (no
                      attenuation or amplification).

                        - **OutputChannels** *(list) --* List of output channels

                          - *(dict) --* OutputChannel mapping settings.

                            - **InputChannels** *(list) --* List of input channels

                              - *(integer) --*

                      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                      input that you want to use in your output. With remixing, you might combine or
                      split the data in these channels, so the number of channels in your final
                      output might be different.

                      - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                      after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                    - **SelectorType** *(string) --* Specifies the type of the audio selector.

                    - **Tracks** *(list) --* Identify a track from the input audio to include in
                    this selector by entering the track index number. To include several tracks in a
                    single audio selector, specify multiple tracks as follows. Using the console,
                    enter a comma-separated list. For examle, type "1,2,3" to include tracks 1
                    through 3. Specifying directly in your JSON job file, provide the track numbers
                    in an array. For example, "tracks": [1,2,3].

                      - *(integer) --*

              - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to
              specify the captions data from the input that you will use in your outputs. You can
              use mutiple captions selectors per input.

                - *(string) --*

                  - *(dict) --* Set up captions in your outputs by first selecting them from your
                  input here.

                    - **CustomLanguageCode** *(string) --* The specific language to extract from
                    source, using the ISO 639-2 or ISO 639-3 three-letter language code. If input is
                    SCTE-27, complete this field and/or PID to select the caption language to
                    extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this
                    field and/or PID to select the caption language to extract. If input is DVB-Sub
                    that is being passed through, omit this field (and PID field); there is no way
                    to extract a specific language with pass-through captions.

                    - **LanguageCode** *(string) --* The specific language to extract from source.
                    If input is SCTE-27, complete this field and/or PID to select the caption
                    language to extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT,
                    complete this field and/or PID to select the caption language to extract. If
                    input is DVB-Sub that is being passed through, omit this field (and PID field);
                    there is no way to extract a specific language with pass-through captions.

                    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                    SRT, or IMSC in an xml file, specify the URI of the input captions source file.
                    If your input captions are IMSC in an IMF package, use TrackSourceSettings
                    instead of FileSoureSettings.

                      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions
                      source.

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                        number in the ancillary data track from which to extract captions. Unused
                        for passthrough.

                        - **TerminateCaptions** *(string) --* By default, the service terminates any
                        unterminated captions at the end of each input. If you want the caption to
                        continue onto your next input, disable this setting.

                      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use
                        this PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub
                        content is passed through, regardless of selectors.

                      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel
                        number within the video track from which to extract captions. Unused for
                        passthrough.

                        - **Source608TrackNumber** *(integer) --* Specifies the video track index
                        used for extracting captions. The system only supports one input video
                        track, so this should always be set to '1'.

                        - **TerminateCaptions** *(string) --* By default, the service terminates any
                        unterminated captions at the end of each input. If you want the caption to
                        continue onto your next input, disable this setting.

                      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                      STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption
                      source file. If your caption source is IMSC in an IMF package, use
                      TrackSourceSettings instead of FileSoureSettings.

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **SourceFile** *(string) --* External caption file used for loading
                        captions. Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt',
                        'xml', and 'smi'.

                        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset
                        the captions from the source file.

                      - **SourceType** *(string) --* Use Source (SourceType) to identify the format
                      of your input captions. The service cannot auto-detect caption format.

                      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                      sources, including Page number.

                        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                        three-digit hexadecimal page number that will be used for Teletext captions.
                        Do not use this setting if you are passing through teletext from the input
                        source to output.

                      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources
                      that are specified by track number. Currently, this is only IMSC captions in
                      an IMF package. If your caption source is IMSC 1.1 in a separate xml file, use
                      FileSourceSettings instead of TrackSourceSettings.

                        - **TrackNumber** *(integer) --* Use this setting to select a single
                        captions track from a source. Track numbers correspond to the order in the
                        captions source file. For IMF sources, track numbering is based on the order
                        that the captions appear in the CPL. For example, use 1 to select the
                        captions asset that is listed first in the CPL. To include more than one
                        captions track in your job outputs, create multiple input captions
                        selectors. Specify one track per selector.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame. If you specify a value here, it
              will override any value that you specify in the output setting Cropping selection
              (crop).

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce
              smoother motion in the output. Default is disabled. Only manaully controllable for
              MPEG2 and uncompressed video inputs.

              - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise
              from the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and
              uncompressed video inputs.

              - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how
              the transcoding service applies the denoise and deblock filters. You must also enable
              the filters separately, with Denoise (InputDenoiseFilter) and Deblock
              (InputDeblockFilter). * Auto - The transcoding service determines whether to apply
              filtering, depending on input type and quality. * Disable - The input is not filtered.
              This is true even if you use the API to enable them in (InputDeblockFilter) and
              (InputDeblockFilter). * Force - The in put is filtered regardless of input type.

              - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
              magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5.
              Default is 0.

              - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
              overlay on your video. Enable or disable this feature for each input individually.
              This setting is disabled by default.

                - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                your video. The images must be PNG or TGA files.

                  - *(dict) --* Settings that specify how your still graphic overlay appears.

                    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                    to remain on the output video. This duration includes fade-in time but not
                    fade-out time.

                    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                    the Start time that you specify for the image insertion and the time that the
                    image appears at full opacity. Full opacity is the level that you specify for
                    the opacity setting. If you don't specify a value for Fade-in, the image will
                    appear abruptly at the overlay start time.

                    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                    between the end of the time that you have specified for the image overlay
                    Duration and when the overlaid image has faded to total transparency. If you
                    don't specify a value for Fade-out, the image will disappear abruptly at the end
                    of the inserted image duration.

                    - **Height** *(integer) --* Specify the height of the inserted image in pixels.
                    If you specify a value that's larger than the video resolution height, the
                    service will crop your overlaid image to fit. To use the native height of the
                    image, keep this setting blank.

                    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                    location of the image that you want to overlay on the video. Use a PNG or TGA
                    file.

                    - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                    inserted image and the left edge of the video frame. Required for any image
                    overlay that you specify.

                    - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                    overlaid image and the top edge of the video frame. Required for any image
                    overlay that you specify.

                    - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                    Images with higher values for Layer appear on top of images with lower values
                    for Layer.

                    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                    underlying video shows through the inserted image. 0 is transparent and 100 is
                    fully opaque. Default is 50.

                    - **StartTime** *(string) --* Specify the timecode of the frame that you want
                    the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                    HH:MM:SS;FF) format. Remember to take into account your timecode source
                    settings.

                    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                    you specify a value that's larger than the video resolution width, the service
                    will crop your overlaid image to fit. To use the native width of the image, keep
                    this setting blank.

              - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
              that together specify a portion of the input to be used in the outputs. If you provide
              only a start time, the clip will be the entire input from that point to the end. If
              you provide only an end time, it will be the entire input up to that point. When you
              specify more than one input clip, the transcoding service creates the job outputs by
              stringing the clips together in the order you specify them.

                - *(dict) --* To transcode only portions of your input (clips), include one Input
                clipping (one instance of InputClipping in the JSON job file) for each input clip.
                All input clips you specify will be included in every output of the job.

                  - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
                  portion of the input you are clipping. The frame corresponding to the End timecode
                  value is included in the clip. Start timecode or End timecode may be left blank,
                  but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM
                  is the minute, SS is the second, and FF is the frame number. When choosing this
                  value, take into account your setting for timecode source under input settings
                  (InputTimecodeSource). For example, if you have embedded timecodes that start at
                  01:00:00:00 and you want your clip to end six minutes into the video, use
                  01:06:00:00.

                  - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the
                  beginning of the portion of the input you are clipping. The frame corresponding to
                  the Start timecode value is included in the clip. Start timecode or End timecode
                  may be left blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where
                  HH is the hour, MM is the minute, SS is the second, and FF is the frame number.
                  When choosing this value, take into account your setting for Input timecode
                  source. For example, if you have embedded timecodes that start at 01:00:00:00 and
                  you want your clip to begin five minutes into the video, use 01:05:00:00.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black. If you specify a value here, it will override any value that you specify in the
              output setting Selection placement (position). If you specify a value here, this will
              override any AFD values in your input, even if you set Respond to AFD (RespondToAfd)
              to Respond (RESPOND). If you specify a value here, this will ignore anything that you
              specify for the setting Scaling Behavior (scalingBehavior).

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
              program from within a multi-program transport stream. Note that Quad 4K is not
              currently supported. Default is the first program within the transport stream. If the
              program you specify doesn't exist, the transcoding service will use this default.

              - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
              inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs
              for audio and video. * Use PSI - Scan only PSI data.

              - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
              input settings (InputTimecodeSource), to specify how the service counts input video
              frames. This input frame count affects only the behavior of features that apply to a
              single input at a time, such as input clipping and synchronizing some captions
              formats. Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose
              Start at zero (ZEROBASED) to start the first frame at zero. Choose Specified start
              (SPECIFIEDSTART) to start the first frame at the timecode that you specify in the
              setting Start timecode (timecodeStart). If you don't specify a value for Timecode
              source, the service will use Embedded by default. For more information about
              timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

              - **TimecodeStart** *(string) --* Specify the timecode that you want the service to
              use for this input's initial frame. To use this setting, you must set the Timecode
              source setting, located under the input settings (InputTimecodeSource), to Specified
              start (SPECIFIEDSTART). For more information about timecodes, see
              https://docs.aws.amazon.com/console/mediaconvert/timecode.

              - **VideoSelector** *(dict) --* Selector for video.

                - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a
                QuickTime animation. Specify which part of this input MediaConvert uses for your
                outputs. Leave this setting set to DISCARD in order to delete the alpha channel and
                preserve the video. Use REMAP_TO_LUMA for this setting to delete the video and map
                the alpha channel to the luma channel of your outputs.

                - **ColorSpace** *(string) --* If your input video has accurate color space
                metadata, or if you don't know about color space, leave this set to the default
                value Follow (FOLLOW). The service will automatically detect your input color space.
                If your input video has metadata indicating the wrong color space, specify the
                accurate color space here. If your input video is HDR 10 and the SMPTE ST 2086
                Mastering Display Color Volume static metadata isn't present in your video stream,
                or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10)
                here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
                settings. For more information about MediaConvert HDR jobs, see
                https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the
                input file and the job input settings Color space (ColorSpace) and HDR master
                display information settings(Hdr10Metadata). The Color space usage setting
                determines which takes precedence. Choose Force (FORCE) to use color metadata from
                the input job settings. If you don't specify values for those settings, the service
                defaults to using metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to
                use color metadata from the source when it is present. If there's no color metadata
                in your input file, the service defaults to using values you specify in the input
                settings.

                - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that
                is missing or inaccurate in your input video. Appropriate values vary depending on
                the input video and must be provided by a color grader. The color grader generates
                these values during the HDR 10 mastering process. The valid range for each of these
                settings is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color
                coordinate. Related settings - When you specify these values, you must also set
                Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
                specify here take precedence over the values in the metadata of your input file, set
                Color space usage (ColorSpaceUsage). To specify whether color metadata is included
                in an output, set Color metadata (ColorMetadata). For more information about
                MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                  - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                  the coded video sequence, in units of candelas per square meter. This setting
                  doesn't have a default value; you must specify a value that is suitable for the
                  content.

                  - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                  frame in the coded video sequence, in units of candelas per square meter. This
                  setting doesn't have a default value; you must specify a value that is suitable
                  for the content.

                  - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                  units of of 0.0001 candelas per square meter.

                  - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                  units of of 0.0001 candelas per square meter

                  - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input
                file. Specify this value as an integer; the system automatically converts it to the
                hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier,
                is an identifier for a set of data in an MPEG-2 transport stream container.

                - **ProgramNumber** *(integer) --* Selects a specific program from within a
                multi-program transport stream. Note that Quad 4K is not currently supported.

                - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service
                rotates your video. You can choose automatic rotation or specify a rotation. You can
                specify a clockwise rotation of 0, 90, 180, or 270 degrees. If your input video
                container is .mov or .mp4 and your input has rotation metadata, you can choose
                Automatic to have the service rotate your video according to the rotation specified
                in the metadata. The rotation must be within one degree of 90, 180, or 270 degrees.
                If the rotation metadata specifies any other rotation, the service will default to
                no rotation. By default, the service does no rotation, even if your input video has
                rotation metadata. The service doesn't pass through rotation metadata.

          - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The
          motion graphics that you specify here appear on all outputs in all output groups.

            - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this
            setting unspecified. If your motion graphic asset is a series of .png files, specify the
            frame rate of the overlay in frames per second, as a fraction. For example, specify 24
            fps as 24/1. Make sure that the number of images in your series matches the frame rate
            and your intended overlay duration. For example, if you want a 30-second overlay at 30
            fps, you should have 900 .png images. This overlay frame rate doesn't need to match the
            frame rate of the underlying video.

              - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses
              your overlay frame rate. For example, if your frame rate is 24 fps, set this value to
              1.

              - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
              overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

            - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
            overlay on your video. For .png files, provide the file name of the first file in the
            series. Make sure that the names of the .png files end with sequential numbers that
            specify the order that they are played in. For example, overlay_000.png,
            overlay_001.png, overlay_002.png, and so on. The sequence must start at zero, and each
            image file name must have the same number of digits. Pad your initial file names with
            enough zeros to complete the sequence. For example, if the first image is overlay_0.png,
            there can be only 10 images in the sequence, with the last image being overlay_9.png.
            But if the first image is overlay_00.png, there can be 100 images in the sequence.

            - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
            providing for your overlay. You can choose either a .mov file or a series of .png files.

            - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic
            overlay on the video frame. Specify in pixels, from the upper-left corner of the frame.
            If you don't specify an offset, the service scales your overlay to the full size of the
            frame. Otherwise, the service inserts the overlay at its native resolution and scales
            the size up or down with any video scaling.

              - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the
              left edge of the video frame.

              - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the
              top edge of the video frame.

            - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a
            loop or plays only once.

            - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode
            format (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes
            into account how you have set up your timecode configuration under both job settings and
            input settings. The simplest way to do that is to set both to start at 0. If you need to
            set up your job to follow timecodes embedded in your source that don't start at zero,
            make sure that you specify a start time that is after the first embedded timecode. For
            more information, see
            https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find
            job-wide and input timecode configuration settings in your JSON job settings
            specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

          - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you
          don't do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
          configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all
          outputs in the job. To enable Nielsen configuration programmatically, include an instance
          of nielsenConfiguration in your JSON job specification. Even if you don't include any
          children of nielsenConfiguration, you still enable the setting.

            - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
            functionality. If you must include this property, set the value to zero.

            - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
            distributor ID that is assigned to your organization by Neilsen.

          - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set
          of outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS,
          Quicktime, MXF, and no container) are grouped in a single output group as well. Required
          in (OutputGroups) is a group of settings that apply to the whole group. This required
          object depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings).
          Type, settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
          HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
          MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

            - *(dict) --* Group of outputs

              - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name
              for the output group. This value is displayed on the console and can make your job
              settings JSON more human-readable. It does not affect your outputs. Use up to twelve
              characters that are either letters, numbers, spaces, or underscores.

              - **Name** *(string) --* Name of the output group

              - **OutputGroupSettings** *(dict) --* Output Group settings, including type

                - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
                Output Group may only contain a single video, audio, or caption output.

                  - **AdditionalManifests** *(list) --* By default, the service creates one
                  top-level .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF
                  output group in your job. These default manifests reference every output in the
                  output group. To create additional top-level manifests that reference a subset of
                  the outputs in the output group, specify a list of them here. For each additional
                  manifest that you specify, the service creates one HLS manifest and one DASH
                  manifest.

                    - *(dict) --* Specify the details for each pair of HLS and DASH additional
                    manifests that you want the service to generate for this CMAF output group. Each
                    pair of manifests can reference a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your HLS group is film-name.m3u8. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                      specify a manifestNameModifier that is different from the nameModifier of the
                      output. The service uses the output name modifier to create unique names for
                      the individual variant manifests.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                  file at the top level BaseURL element. Can be used if streams are delivered from a
                  different URL than the manifest file.

                  - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no
                  tag, which prevents client from saving media segments for later replay.

                  - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the
                  default RFC-4281) during m3u8 playlist generation.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* DRM settings.

                    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                    value represented by a 32-character text string. If this parameter is not set
                    then the Initialization Vector will follow the segment number by default.

                    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want
                    the service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                    (SAMPLE-AES) or AES_CTR (AES-CTR).

                    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                    outputs, choose whether the service writes the 128-bit encryption initialization
                    vector in the HLS and DASH manifests.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                    settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                    output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                    settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you
                      want signaled in the DASH manifest that MediaConvert creates as part of this
                      CMAF package. The DASH manifest can currently signal up to three system IDs.
                      For more information, see https://dashif.org/identifiers/content_protection/.

                        - *(string) --*

                      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                      signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                      package. The HLS manifest can currently signal only one system ID. For more
                      information, see https://dashif.org/identifiers/content_protection/.

                        - *(string) --*

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with
                    a static key provider.

                      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                      the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                      omitted to indicate an implicit value of 'identity'.

                      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                      single positive integer version value or a slash delimited list of version
                      values (1/2/3).

                      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                      32-character hexidecimal string to specify Key Value (StaticKeyValue).

                      - **Url** *(string) --* Relates to DRM implementation. The location of the
                      license server used for protecting content.

                    - **Type** *(string) --* Specify whether your DRM encryption key is static or
                    from a key provider that follows the SPEKE standard. For more information about
                    SPEKE, see
                    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                  - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                  Fragment length must be compatible with GOP size and Framerate. Note that
                  fragments will end on the next keyframe after this number of seconds, so actual
                  fragment length may be longer. When Emit Single File is checked, the fragmentation
                  is internal to a single output file and it does not cause the creation of many
                  output files as in other output types.

                  - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                  - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                  should use floating point values for segment duration.

                  - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that
                  is needed to ensure smooth playout.

                  - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                  0, unless you are troubleshooting a problem with how devices play back the end of
                  your video asset. If you know that player devices are hanging on the final segment
                  of your video because the length of your final segment is too short, use this
                  setting to specify a minimum final segment length, in seconds. Choose a value that
                  is greater than or equal to 1 and less than your segment length. When you specify
                  a value for this setting, the encoder will combine any final segment that is
                  shorter than the length that you specify with the previous segment. For example,
                  your segment length is 3 seconds and your final segment is .5 seconds without a
                  minimum final segment length; when you set the minimum final segment length to 1,
                  your final segment is 3.5 seconds.

                  - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                  main. When you choose Main profile (MAIN_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                  On-demand (ON_DEMAND_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose
                  On-demand, you must also set the output group setting Segment control
                  (SegmentControl) to Single file (SINGLE_FILE).

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file
                  is generated, which is internally segmented using the Fragment Length and Segment
                  Length. When set to SEGMENTED_FILES, separate segment files will be created.

                  - **SegmentLength** *(integer) --* Use this setting to specify the length, in
                  seconds, of each individual CMAF segment. This value applies to the whole package;
                  that is, to every output in the output group. Note that segments end on the first
                  keyframe after this number of seconds, so the actual segment length might be
                  slightly longer. If you set Segment control (CmafSegmentControl) to single file,
                  the service puts the content of each output in a single file that has metadata
                  that marks these segments. If you set it to segmented files, the service creates
                  multiple files for each output, each with the content of one segment.

                  - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute
                  for video in EXT-X-STREAM-INF tag of variant manifest.

                  - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest
                  will be generated for this output.

                  - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest
                  will be generated for this output.

                - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

                  - **AdditionalManifests** *(list) --* By default, the service creates one .mpd
                  DASH manifest for each DASH ISO output group in your job. This default manifest
                  references every output in the output group. To create additional DASH manifests
                  that reference a subset of the outputs in the output group, specify a list of them
                  here.

                    - *(dict) --* Specify the details for each additional DASH manifest that you
                    want the service to generate for this output group. Each manifest can reference
                    a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your DASH group is film-name.mpd. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.mpd.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                  (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
                  from a different URL than the manifest file.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* DRM settings.

                    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                    compatibility of your output with video players on obsolete devices. It applies
                    only to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI
                    (UNENCRYPTED_SEI) only to correct problems with playback on older devices.
                    Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose Unencrypted
                    SEI, for that output, the service will exclude the access unit delimiter and
                    will leave the SEI NAL units unencrypted.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                  - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                  Fragment length must be compatible with GOP size and Framerate. Note that
                  fragments will end on the next keyframe after this number of seconds, so actual
                  fragment length may be longer. When Emit Single File is checked, the fragmentation
                  is internal to a single output file and it does not cause the creation of many
                  output files as in other output types.

                  - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

                  - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that
                  is needed to ensure smooth playout.

                  - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                  main. When you choose Main profile (MAIN_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                  On-demand (ON_DEMAND_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose
                  On-demand, you must also set the output group setting Segment control
                  (SegmentControl) to Single file (SINGLE_FILE).

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file
                  is generated, which is internally segmented using the Fragment Length and Segment
                  Length. When set to SEGMENTED_FILES, separate segment files will be created.

                  - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds).
                  Note that segments will end on the next keyframe after this number of seconds, so
                  actual segment length may be longer. When Emit Single File is checked, the
                  segmentation is internal to a single output file and it does not cause the
                  creation of many output files as in other output types.

                  - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error
                  in the 400 range when you play back your DASH output, enable this setting and run
                  your transcoding job again. When you enable this setting, the service writes
                  precise segment durations in the DASH manifest. The segment duration information
                  appears inside the SegmentTimeline element, inside SegmentTemplate at the
                  Representation level. When you don't enable this setting, the service writes
                  approximate segment durations in your DASH manifest.

                - **FileGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

                  - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your
                  Apple HLS manifest. This setting does not determine whether SCTE-35 markers appear
                  in the outputs themselves.

                    - *(string) --*

                  - **AdditionalManifests** *(list) --* By default, the service creates one
                  top-level .m3u8 HLS manifest for each HLS output group in your job. This default
                  manifest references every output in the output group. To create additional
                  top-level manifests that reference a subset of the outputs in the output group,
                  specify a list of them here.

                    - *(dict) --* Specify the details for each additional HLS manifest that you want
                    the service to generate for this output group. Each manifest can reference a
                    different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your HLS group is film-name.m3u8. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                      specify a manifestNameModifier that is different from the nameModifier of the
                      output. The service uses the output name modifier to create unique names for
                      the individual variant manifests.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each
                  output in the media .m3u8 file. Can be used if base manifest is delivered from a
                  different URL than the main .m3u8 file.

                  - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                    - *(dict) --* Caption Language Mapping

                      - **CaptionChannel** *(integer) --* Caption channel.

                      - **CustomLanguageCode** *(string) --* Specify the language for this captions
                      channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                      - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                      three-letter code listed at
                      https://www.loc.gov/standards/iso639-2/php/code_list.php.

                      - **LanguageDescription** *(string) --* Caption language description.

                  - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
                  captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least
                  one language in the CC1 Language Code field. One CLOSED-CAPTION line is added for
                  each Language Code you specify. Make sure to specify the languages in the order in
                  which they appear in the original source (if the source is embedded format) or the
                  order of the caption selectors (if the source is other than embedded). Otherwise,
                  languages in the manifest will not match up properly with the output captions.
                  None: Include CLOSED-CAPTIONS=
                      NONE line in the manifest. Omit: Omit any
                  CLOSED-CAPTIONS line from the manifest.

                  - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no
                  tag, which prevents client from saving media segments for later replay.

                  - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the
                  default RFC-4281) during m3u8 playlist generation.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **DirectoryStructure** *(string) --* Indicates whether segments should be placed
                  in subdirectories.

                  - **Encryption** *(dict) --* DRM settings.

                    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                    value represented by a 32-character text string. If this parameter is not set
                    then the Initialization Vector will follow the segment number by default.

                    - **EncryptionMethod** *(string) --* Encrypts the segments with the given
                    encryption scheme. Leave blank to disable. Selecting 'Disabled' in the web
                    interface also disables encryption.

                    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is
                    a 128-bit number used in conjunction with the key for encrypting blocks. If set
                    to INCLUDE, Initialization Vector is listed in the manifest. Otherwise
                    Initialization Vector is not in the manifest.

                    - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                    EXT-X-SESSION-KEY element into the master playlist. This allows for offline
                    Apple HLS FairPlay content protection.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with
                    a static key provider.

                      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                      the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                      omitted to indicate an implicit value of 'identity'.

                      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                      single positive integer version value or a slash delimited list of version
                      values (1/2/3).

                      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                      32-character hexidecimal string to specify Key Value (StaticKeyValue).

                      - **Url** *(string) --* Relates to DRM implementation. The location of the
                      license server used for protecting content.

                    - **Type** *(string) --* Specify whether your DRM encryption key is static or
                    from a key provider that follows the SPEKE standard. For more information about
                    SPEKE, see
                    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                  - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                  - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                  should use floating point values for segment duration.

                  - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                  0, unless you are troubleshooting a problem with how devices play back the end of
                  your video asset. If you know that player devices are hanging on the final segment
                  of your video because the length of your final segment is too short, use this
                  setting to specify a minimum final segment length, in seconds. Choose a value that
                  is greater than or equal to 1 and less than your segment length. When you specify
                  a value for this setting, the encoder will combine any final segment that is
                  shorter than the length that you specify with the previous segment. For example,
                  your segment length is 3 seconds and your final segment is .5 seconds without a
                  minimum final segment length; when you set the minimum final segment length to 1,
                  your final segment is 3.5 seconds.

                  - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced
                  by looking ahead and back within the specified range for a nearby avail and
                  extending the segment size if needed.

                  - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file
                  should be generated for this HLS output group.

                  - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME
                  tag in .m3u8 manifest files. The value is calculated as follows: either the
                  program date and time are initialized using the input timecode source, or the time
                  is initialized using the input timecode source and the date is initialized using
                  the timestamp_offset.

                  - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
                  EXT-X-PROGRAM-DATE-TIME entry, in seconds.

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a
                  single media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for
                  playback.

                  - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
                  create (in seconds). Note that segments will end on the next keyframe after this
                  number of seconds, so actual segment length may be longer.

                  - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
                  subdirectory before starting a new one. directoryStructure must be
                  SINGLE_DIRECTORY for this setting to have an effect.

                  - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute
                  for video in EXT-X-STREAM-INF tag of variant manifest.

                  - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the
                  timecode.

                  - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

                  - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond
                  delta offset to fine tune the timestamps.

                - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

                  - **AdditionalManifests** *(list) --* By default, the service creates one .ism
                  Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output
                  group in your job. This default manifest references every output in the output
                  group. To create additional manifests that reference a subset of the outputs in
                  the output group, specify a list of them here.

                    - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                    manifest that you want the service to generate for this output group. Each
                    manifest can reference a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your Microsoft Smooth group is film-name.ismv.
                      If you enter "-no-premium" for this setting, then the file name the service
                      generates for this top-level manifest is film-name-no-premium.ismv.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines
                  identical audio encoding settings across a Microsoft Smooth output group into a
                  single audio stream.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* If you are using DRM, set DRM System
                  (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                  - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to
                  specify the mp4 fragment sizes in seconds. Fragment length must be compatible with
                  GOP size and frame rate.

                  - **ManifestEncoding** *(string) --* Use Manifest encoding
                  (MsSmoothManifestEncoding) to specify the encoding format for the server and
                  client manifest. Valid options are utf8 and utf16.

                - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
                Microsoft Smooth Streaming, CMAF)

              - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
              settings per output.

                - *(dict) --* An output object describes the settings for a single output file or
                stream in an output group.

                  - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
                  encoding settings organized by audio codec. Include one instance of
                  (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
                  encoding settings.

                    - *(dict) --* Description of audio output

                      - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                      settings. Ignore these settings unless you need to comply with a loudness
                      standard.

                        - **Algorithm** *(string) --* Choose one of the following audio
                        normalization algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement
                        of ungated average loudness for an entire piece of content, suitable for
                        measurement of short-form content under ATSC recommendation A/85. Supports
                        up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
                        gated average loudness compliant with the requirements of EBU-R128. Supports
                        up to 5.1 audio channels. ITU-R BS.1770-3: Modified peak. The same loudness
                        measurement algorithm as 1770-2, with an updated true peak measurement.
                        ITU-R BS.1770-4: Higher channel count. Allows for more audio channels than
                        the other algorithms, including configurations such as 7.1.

                        - **AlgorithmControl** *(string) --* When enabled the output audio is
                        corrected using the chosen algorithm. If disabled, the audio will be
                        measured but not adjusted.

                        - **CorrectionGateLevel** *(integer) --* Content measuring above this level
                        will be corrected to the target level. Content measuring below this level
                        will not be corrected. Gating only applies when not using
                        real_time_correction.

                        - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio
                        track loudness to a CSV file.

                        - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log
                        the TruePeak for each output's audio track loudness.

                        - **TargetLkfs** *(float) --* When you use Audio normalization
                        (AudioNormalizationSettings), optionally use this setting to specify a
                        target loudness. If you don't specify a value here, the encoder chooses a
                        value for you, based on the algorithm that you choose for Algorithm
                        (algorithm). If you choose algorithm 1770-1, the encoder will choose -24
                        LKFS; otherwise, the encoder will choose -23 LKFS.

                      - **AudioSourceName** *(string) --* Specifies which audio data to use from
                      each input. In the simplest case, specify an "Audio
                      Selector":#inputs-audio_selector by name based on its order within each input.
                      For example if you specify "Audio Selector 3", then the third audio selector
                      will be used from each input. If an input does not have an "Audio Selector 3",
                      then the audio selector marked as "default" in that input will be used. If
                      there is no audio selector marked as "default", silence will be inserted for
                      the duration of that input. Alternatively, an "Audio Selector
                      Group":#inputs-audio_selector_group name may be specified, with similar
                      default/silence behavior. If no audio_source_name is specified, then "Audio
                      Selector 1" will be chosen automatically.

                      - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                      unchecked (false). A number between 0 and 255. The following are defined in
                      ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                           Hearing Impaired, 3 =
                      Visually Impaired Commentary, 4-255 = Reserved.

                      - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                      contains an ISO 639 audio_type, then that value is passed through to the
                      output. If the input contains no ISO 639 audio_type, the value in Audio Type
                      is included in the output. Otherwise the value in Audio Type is included in
                      the output. Note that this field and audioType are both ignored if
                      audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

                      - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                      (AudioDescriptions) contains the group of settings related to audio encoding.
                      The settings in this group vary depending on the value that you choose for
                      Audio codec (Codec). For each codec enum that you choose, define the
                      corresponding settings object. The following lists the codec enum, settings
                      object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF,
                      AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
                      Eac3AtmosSettings

                        - **AacSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts
                        one of two mutually exclusive groups of AAC settings--VBR and CBR. To select
                        one of these modes, set the value of Bitrate control mode (rateControlMode)
                        to "VBR" or "CBR". In VBR mode, you control the audio quality with the
                        setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
                        (bitrate). Defaults and valid values depend on the rate control mode.

                          - **AudioDescriptionBroadcasterMix** *(string) --* Choose
                          BROADCASTER_MIXED_AD when the input contains pre-mixed main audio + audio
                          description (AD) as a stereo pair. The value for AudioType will be set to
                          3, which signals to downstream systems that this stream contains
                          "broadcaster mixed AD". Note that the input received by the encoder must
                          contain pre-mixed audio; the encoder does not perform the mixing. When you
                          choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                          AudioType and FollowInputAudioType. Choose NORMAL when the input does not
                          contain pre-mixed audio + audio description (AD). In this case, the
                          encoder will use any values you provide for AudioType and
                          FollowInputAudioType.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. The set of valid values for this setting is: 6000, 8000, 10000,
                          12000, 14000, 16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000,
                          64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
                          288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
                          1024000. The value you set is also constrained by the values that you
                          choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                          Sample rate (sampleRate). Default values depend on Bitrate control mode
                          and Profile.

                          - **CodecProfile** *(string) --* AAC Profile.

                          - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or
                          5.1 channel layout. Valid values depend on rate control mode and profile.
                          "1.0 - Audio Description (Receiver Mix)" setting receives a stereo
                          description plus control track and emits a mono AAC encode of the
                          description track, with control data emitted in the PES header as per ETSI
                          TS 101 154 Annex E.

                          - **RateControlMode** *(string) --* Rate Control Mode.

                          - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if
                          you use LATM/LOAS AAC in an output, you must choose "No container" for the
                          output container.

                          - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on
                          rate control mode and profile.

                          - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC
                          audio for raw or MPEG-2 Transport Stream containers.

                          - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                          rate_control_mode is VBR.

                        - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AC3.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid bitrates depend on the coding mode.

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                          stream that the encoder emits. For more information about the AC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* Dolby Digital coding mode. Determines
                          number of channels.

                          - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank
                          and input audio is Dolby Digital, dialnorm will be passed through.

                          - **DynamicRangeCompressionProfile** *(string) --* If set to
                          FILM_STANDARD, adds dynamic range compression signaling to the output
                          bitstream as defined in the Dolby Digital specification.

                          - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                          channel prior to encoding. Only valid with 3_2_LFE coding mode.

                          - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                          metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                          this audio data. If audio was not supplied from one of these streams, then
                          the static metadata settings will be used.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                        - **AiffSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AIFF.

                          - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                          sample, to choose the encoding quality for this audio track.

                          - **Channels** *(integer) --* Specify the number of channels in this
                          output audio track. Valid values are 1 and even numbers up to 64. For
                          example, 1, 2, 4, 6, and so on, up to 64.

                          - **SampleRate** *(integer) --* Sample rate in hz.

                        - **Codec** *(string) --* Type of Audio codec.

                        - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid values: 384k, 448k, 640k, 768k

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the
                          E-AC-3 stream that the encoder emits. For more information about the EAC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                          (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                          - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue
                          Intelligence to adjust loudness based on dialogue analysis.

                          - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                          level for a signal with dynamic range compression.

                          - **DynamicRangeCompressionRf** *(string) --* Specify how the service
                          limits the audio dynamic range when compressing the audio.

                          - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left only/Right only center mix (Lo/Ro center).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
                          and -6.0.

                          - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert
                          uses this value for downmixing. How the service uses this value depends on
                          the value that you choose for Stereo downmix (Eac3AtmosStereoDownmix).
                          Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                          channel.

                          - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left total/Right total center mix (Lt/Rt center).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
                          and -6.0.

                          - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
                          The value -60 mutes the channel.

                          - **MeteringMode** *(string) --* Choose how the service meters the
                          loudness of your audio.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                          - **SpeechThreshold** *(integer) --* Specify the percentage of audio
                          content that must be speech before the encoder uses the measured speech
                          loudness as the overall program loudness.

                          - **StereoDownmix** *(string) --* Choose how the service does stereo
                          downmixing.

                          - **SurroundExMode** *(string) --* Specify whether your input audio has an
                          additional center rear surround channel matrix encoded into your left and
                          right surround channels.

                        - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value EAC3.

                          - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a
                          3 dB attenuation to the surround channels. Only used for 3/2 coding mode.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid bitrates depend on the coding mode.

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the
                          E-AC-3 stream that the encoder emits. For more information about the EAC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                          number of channels.

                          - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                          channels.

                          - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank
                          and input audio is Dolby Digital Plus, dialnorm will be passed through.

                          - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                          level for a signal with dynamic range compression.

                          - **DynamicRangeCompressionRf** *(string) --* Specify how the service
                          limits the audio dynamic range when compressing the audio.

                          - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether
                          the LFE channel is enabled

                          - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                          channel prior to encoding. Only valid with 3_2_LFE coding mode.

                          - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left only/Right only center mix (Lo/Ro
                          center). MediaConvert uses this value for downmixing. How the service uses
                          this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                          and -60. The value -60 mutes the channel. This setting applies only if you
                          keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                          setting Coding mode (Eac3CodingMode). If you choose a different value for
                          Coding mode, the service ignores Left only/Right only center
                          (loRoCenterMixLevel).

                          - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                          value -60 mutes the channel. This setting applies only if you keep the
                          default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                          Coding mode (Eac3CodingMode). If you choose a different value for Coding
                          mode, the service ignores Left only/Right only surround
                          (loRoSurroundMixLevel).

                          - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left total/Right total center mix (Lt/Rt
                          center). MediaConvert uses this value for downmixing. How the service uses
                          this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                          and -60. The value -60 mutes the channel. This setting applies only if you
                          keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                          setting Coding mode (Eac3CodingMode). If you choose a different value for
                          Coding mode, the service ignores Left total/Right total center
                          (ltRtCenterMixLevel).

                          - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                          surround). MediaConvert uses this value for downmixing. How the service
                          uses this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                          value -60 mutes the channel. This setting applies only if you keep the
                          default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                          Coding mode (Eac3CodingMode). If you choose a different value for Coding
                          mode, the service ignores Left total/Right total surround
                          (ltRtSurroundMixLevel).

                          - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                          metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                          this audio data. If audio was not supplied from one of these streams, then
                          the static metadata settings will be used.

                          - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input
                          DD+ audio will be passed through if it is present on the input. this
                          detection is dynamic over the life of the transcode. Inputs that alternate
                          between DD+ and non-DD+ content will have a consistent DD+ output as the
                          system alternates between passthrough and encoding.

                          - **PhaseControl** *(string) --* Controls the amount of phase-shift
                          applied to the surround channels. Only used for 3/2 coding mode.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                          - **StereoDownmix** *(string) --* Choose how the service does stereo
                          downmixing. This setting only applies if you keep the default value of 3/2
                          - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                          (Eac3CodingMode). If you choose a different value for Coding mode, the
                          service ignores Stereo downmix (Eac3StereoDownmix).

                          - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether
                          an extra center back surround channel is matrix encoded into the left and
                          right surround channels.

                          - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether
                          Dolby Surround is matrix encoded into the two channels.

                        - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value MP2.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second.

                          - **Channels** *(integer) --* Set Channels to specify the number of
                          channels in this output audio track. Choosing Mono in the console will
                          give you 1 output channel; choosing Stereo will give you 2. In the API,
                          valid values are 1 and 2.

                          - **SampleRate** *(integer) --* Sample rate in hz.

                        - **WavSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value WAV.

                          - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                          sample, to choose the encoding quality for this audio track.

                          - **Channels** *(integer) --* Specify the number of channels in this
                          output audio track. Valid values are 1 and even numbers up to 64. For
                          example, 1, 2, 4, 6, and so on, up to 64.

                          - **Format** *(string) --* The service defaults to using RIFF for WAV
                          outputs. If your output audio is likely to exceed 4 GB in file size, or if
                          you otherwise need the extended support of the RF64 format, set your
                          output WAV file format to RF64.

                          - **SampleRate** *(integer) --* Sample rate in Hz.

                      - **CustomLanguageCode** *(string) --* Specify the language for this audio
                      output track. The service puts this language code into your output audio track
                      when you set Language code control (AudioLanguageCodeControl) to Use
                      configured (USE_CONFIGURED). The service also uses your specified custom
                      language code when you set Language code control (AudioLanguageCodeControl) to
                      Follow input (FOLLOW_INPUT), but your input file doesn't specify a language
                      code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
                      streaming outputs, you can also use any other code in the full RFC-5646
                      specification. Streaming outputs are those that are in one of the following
                      output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                      - **LanguageCode** *(string) --* Indicates the language of the audio output
                      track. The ISO 639 language specified in the 'Language Code' drop down will be
                      used when 'Follow Input Language Code' is not selected or when 'Follow Input
                      Language Code' is selected but there is no ISO 639 language code specified by
                      the input.

                      - **LanguageCodeControl** *(string) --* Specify which source for language code
                      takes precedence for this audio track. When you choose Follow input
                      (FOLLOW_INPUT), the service uses the language code from the input track if
                      it's present. If there's no languge code on the input track, the service uses
                      the code that you specify in the setting Language code (languageCode or
                      customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
                      service uses the language code that you specify.

                      - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                        - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains
                        the group of fields that hold the remixing value for each channel. Units are
                        in dB. Acceptable values are within the range from -60 (mute) through 6. A
                        setting of 0 passes the input channel unchanged to the output channel (no
                        attenuation or amplification).

                          - **OutputChannels** *(list) --* List of output channels

                            - *(dict) --* OutputChannel mapping settings.

                              - **InputChannels** *(list) --* List of input channels

                                - *(integer) --*

                        - **ChannelsIn** *(integer) --* Specify the number of audio channels from
                        your input that you want to use in your output. With remixing, you might
                        combine or split the data in these channels, so the number of channels in
                        your final output might be different.

                        - **ChannelsOut** *(integer) --* Specify the number of channels in this
                        output after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even
                        numbers to 64.)

                      - **StreamName** *(string) --* Specify a label for this output audio stream.
                      For example, "English", "Director commentary", or "track_2". For streaming
                      outputs, MediaConvert passes this information into destination manifests for
                      display on the end-viewer's player device. For outputs in other output groups,
                      the service ignores this setting.

                  - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
                  captions settings. For each output that has captions, include one instance of
                  (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of
                  captions settings.

                    - *(dict) --* Description of Caption output

                      - **CaptionSelectorName** *(string) --* Specifies which "Caption
                      Selector":#inputs-caption_selector to use from each input when generating
                      captions. The name should be of the format "Caption Selector ", which denotes
                      that the Nth Caption Selector will be used from each input.

                      - **CustomLanguageCode** *(string) --* Specify the language for this captions
                      output track. For most captions output formats, the encoder puts this language
                      information in the output captions metadata. If your output captions format is
                      DVB-Sub or Burn in, the encoder uses this language information when
                      automatically selecting the font script for rendering the captions text. For
                      all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
                      outputs, you can also use any other code in the full RFC-5646 specification.
                      Streaming outputs are those that are in one of the following output groups:
                      CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                      - **DestinationSettings** *(dict) --* Specific settings required by
                      destination type. Note that burnin_destination_settings are not available if
                      the source of the caption data is Embedded or Teletext.

                        - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                          - **Alignment** *(string) --* If no explicit x_position or y_position is
                          provided, setting alignment to centered will place the captions at the
                          bottom center of the output. Similarly, setting a left alignment will
                          align captions to the bottom left of the output. If x and y positions are
                          given in conjunction with the alignment parameter, the font will be
                          justified (either left or centered) relative to those coordinates. This
                          option is not valid for source captions that are STL, 608/embedded or
                          teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                          behind the captions. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                          background rectangle. 255 is opaque; 0 is transparent. Leaving this
                          parameter blank is equivalent to setting it to 0 (transparent). All
                          burn-in and DVB-Sub font settings must match.

                          - **FontColor** *(string) --* Specifies the color of the burned-in
                          captions. This option is not valid for source captions that are STL,
                          608/embedded or teletext. These source settings are already pre-defined by
                          the caption stream. All burn-in and DVB-Sub font settings must match.

                          - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                          captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                          settings must match.

                          - **FontResolution** *(integer) --* Font resolution in DPI (dots per
                          inch); default is 96 dpi. All burn-in and DVB-Sub font settings must
                          match.

                          - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                          script code, if the LanguageCode is not sufficient for determining the
                          script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                          "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                          font for rendering burn-in captions.

                          - **FontSize** *(integer) --* A positive integer indicates the exact font
                          size in points. Set to 0 for automatic font size selection. All burn-in
                          and DVB-Sub font settings must match.

                          - **OutlineColor** *(string) --* Specifies font outline color. This option
                          is not valid for source captions that are either 608/embedded or teletext.
                          These source settings are already pre-defined by the caption stream. All
                          burn-in and DVB-Sub font settings must match.

                          - **OutlineSize** *(integer) --* Specifies font outline size in pixels.
                          This option is not valid for source captions that are either 608/embedded
                          or teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                          the captions. All burn-in and DVB-Sub font settings must match.

                          - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow.
                          255 is opaque; 0 is transparent. Leaving this parameter blank is
                          equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                          settings must match.

                          - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                          must match.

                          - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels above the text. All burn-in and DVB-Sub font
                          settings must match.

                          - **TeletextSpacing** *(string) --* Only applies to jobs with input
                          captions in Teletext or STL formats. Specify whether the spacing between
                          letters in your captions is set by the captions grid or varies depending
                          on letter width. Choose fixed grid to conform to the spacing specified in
                          the captions file more accurately. Choose proportional to make the text
                          easier to read if the captions are closed caption.

                          - **XPosition** *(integer) --* Specifies the horizontal position of the
                          caption relative to the left side of the output in pixels. A value of 10
                          would result in the captions starting 10 pixels from the left of the
                          output. If no explicit x_position is provided, the horizontal caption
                          position will be determined by the alignment parameter. This option is not
                          valid for source captions that are STL, 608/embedded or teletext. These
                          source settings are already pre-defined by the caption stream. All burn-in
                          and DVB-Sub font settings must match.

                          - **YPosition** *(integer) --* Specifies the vertical position of the
                          caption relative to the top of the output in pixels. A value of 10 would
                          result in the captions starting 10 pixels from the top of the output. If
                          no explicit y_position is provided, the caption will be positioned towards
                          the bottom of the output. This option is not valid for source captions
                          that are STL, 608/embedded or teletext. These source settings are already
                          pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                          must match.

                        - **DestinationType** *(string) --* Specify the format for this set of
                        captions on this output. The default format is embedded without SCTE-20.
                        Other options are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT,
                        teletext, TTML, and web-VTT. If you are using SCTE-20, choose SCTE-20 plus
                        embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the
                        SCTE-43 spec. To create a non-compliant output where the embedded captions
                        come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                        - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                          - **Alignment** *(string) --* If no explicit x_position or y_position is
                          provided, setting alignment to centered will place the captions at the
                          bottom center of the output. Similarly, setting a left alignment will
                          align captions to the bottom left of the output. If x and y positions are
                          given in conjunction with the alignment parameter, the font will be
                          justified (either left or centered) relative to those coordinates. This
                          option is not valid for source captions that are STL, 608/embedded or
                          teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                          behind the captions. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                          background rectangle. 255 is opaque; 0 is transparent. Leaving this
                          parameter blank is equivalent to setting it to 0 (transparent). All
                          burn-in and DVB-Sub font settings must match.

                          - **FontColor** *(string) --* Specifies the color of the burned-in
                          captions. This option is not valid for source captions that are STL,
                          608/embedded or teletext. These source settings are already pre-defined by
                          the caption stream. All burn-in and DVB-Sub font settings must match.

                          - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                          captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                          settings must match.

                          - **FontResolution** *(integer) --* Font resolution in DPI (dots per
                          inch); default is 96 dpi. All burn-in and DVB-Sub font settings must
                          match.

                          - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                          script code, if the LanguageCode is not sufficient for determining the
                          script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                          "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                          font for rendering DVB-Sub captions.

                          - **FontSize** *(integer) --* A positive integer indicates the exact font
                          size in points. Set to 0 for automatic font size selection. All burn-in
                          and DVB-Sub font settings must match.

                          - **OutlineColor** *(string) --* Specifies font outline color. This option
                          is not valid for source captions that are either 608/embedded or teletext.
                          These source settings are already pre-defined by the caption stream. All
                          burn-in and DVB-Sub font settings must match.

                          - **OutlineSize** *(integer) --* Specifies font outline size in pixels.
                          This option is not valid for source captions that are either 608/embedded
                          or teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                          the captions. All burn-in and DVB-Sub font settings must match.

                          - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow.
                          255 is opaque; 0 is transparent. Leaving this parameter blank is
                          equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                          settings must match.

                          - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                          must match.

                          - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels above the text. All burn-in and DVB-Sub font
                          settings must match.

                          - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                          standard or for hearing impaired. Choose hearing impaired if your
                          subtitles include audio descriptions and dialogue. Choose standard if your
                          subtitles include only dialogue.

                          - **TeletextSpacing** *(string) --* Only applies to jobs with input
                          captions in Teletext or STL formats. Specify whether the spacing between
                          letters in your captions is set by the captions grid or varies depending
                          on letter width. Choose fixed grid to conform to the spacing specified in
                          the captions file more accurately. Choose proportional to make the text
                          easier to read if the captions are closed caption.

                          - **XPosition** *(integer) --* Specifies the horizontal position of the
                          caption relative to the left side of the output in pixels. A value of 10
                          would result in the captions starting 10 pixels from the left of the
                          output. If no explicit x_position is provided, the horizontal caption
                          position will be determined by the alignment parameter. This option is not
                          valid for source captions that are STL, 608/embedded or teletext. These
                          source settings are already pre-defined by the caption stream. All burn-in
                          and DVB-Sub font settings must match.

                          - **YPosition** *(integer) --* Specifies the vertical position of the
                          caption relative to the top of the output in pixels. A value of 10 would
                          result in the captions starting 10 pixels from the top of the output. If
                          no explicit y_position is provided, the caption will be positioned towards
                          the bottom of the output. This option is not valid for source captions
                          that are STL, 608/embedded or teletext. These source settings are already
                          pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                          must match.

                        - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                        embedded/ancillary caption outputs, including 608/708 Channel destination
                        number.

                          - **Destination608ChannelNumber** *(integer) --* Ignore this setting
                          unless your input captions are SCC format and your output captions are
                          embedded in the video stream. Specify a CC number for each captions
                          channel in this output. If you have two channels, choose CC numbers that
                          aren't in the same field. For example, choose 1 and 3. For more
                          information, see
                          https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                          - **Destination708ServiceNumber** *(integer) --* Ignore this setting
                          unless your input captions are SCC format and you want both 608 and 708
                          captions embedded in your output stream. Optionally, specify the 708
                          service number for each output captions channel. Choose a different number
                          for each channel. To use this setting, also set Force 608 to 708 upconvert
                          (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
                          settings. If you choose to upconvert but don't specify a 708 service
                          number, MediaConvert uses the number that you specify for CC channel
                          number (destination608ChannelNumber) for the 708 service number. For more
                          information, see
                          https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                        - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                        outputs.

                          - **StylePassthrough** *(string) --* Keep this setting enabled to have
                          MediaConvert use the font style and position information from the captions
                          source in the output. This option is available only when your input
                          captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
                          simplified output captions.

                        - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                          - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to
                          make sure that the captions and the video are synchronized in the output.
                          Specify a frame rate that matches the frame rate of the associated video.
                          If the video frame rate is 29.97, choose 29.97 dropframe
                          (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
                          drop_frame_timecode=
                              true; otherwise, choose 29.97 non-dropframe
                          (FRAMERATE_29_97_NON_DROPFRAME).

                        - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                        output

                          - **PageNumber** *(string) --* Set pageNumber to the Teletext page number
                          for the destination captions for this output. This value must be a
                          three-digit hexadecimal string; strings ending in -FF are invalid. If you
                          are passing through the entire set of Teletext data, do not use this
                          field.

                          - **PageTypes** *(list) --* Specify the page types for this Teletext page.
                          If you don't specify a value here, the service sets the page type to the
                          default value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the
                          entire set of Teletext data, don't use this field. When you pass through a
                          set of Teletext pages, your output has the same page types as your input.

                            - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                            Table 94

                        - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                        outputs, including Pass style information (TtmlStylePassthrough).

                          - **StylePassthrough** *(string) --* Pass through style and position
                          information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                          CFF-TT output or TTML output.

                      - **LanguageCode** *(string) --* Specify the language of this captions output
                      track. For most captions output formats, the encoder puts this language
                      information in the output captions metadata. If your output captions format is
                      DVB-Sub or Burn in, the encoder uses this language information to choose the
                      font language for rendering the captions text.

                      - **LanguageDescription** *(string) --* Specify a label for this set of output
                      captions. For example, "English", "Director commentary", or "track_2". For
                      streaming outputs, MediaConvert passes this information into destination
                      manifests for display on the end-viewer's player device. For outputs in other
                      output groups, the service ignores this setting.

                  - **ContainerSettings** *(dict) --* Container specific settings.

                    - **Container** *(string) --* Container for this output. Some containers require
                    a container settings object. If not specified, the default object will be
                    created.

                    - **F4vSettings** *(dict) --* Settings for F4v container

                      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV
                      atom is relocated to the beginning of the archive as required for progressive
                      downloading. Otherwise it is placed normally at the end.

                    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to
                    outputs in a File output group when the output's container (ContainerType) is
                    MPEG-2 Transport Stream (M2TS). In these assets, data is organized by the
                    program map table (PMT). Each transport stream program contains subsets of data,
                    including audio, video, and metadata. Each of these subsets of data has a
                    numerical label called a packet identifier (PID). Each transport stream program
                    corresponds to one MediaConvert output. The PMT lists the types of data in a
                    program along with their PID. Downstream systems and players use the program map
                    table to look up the PID for each type of data it accesses and then uses the
                    PIDs to locate specific data within the asset.

                      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                      models for Dolby Digital audio.

                      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert
                      for each PES packet.

                      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                      elementary audio streams you include in this output. Specify multiple PIDs as
                      a JSON array. Default is the range 482-492.

                        - *(integer) --*

                      - **Bitrate** *(integer) --* Specify the output bitrate of the transport
                      stream in bits per second. Setting to 0 lets the muxer automatically determine
                      the appropriate bitrate. Other common values are 3750000, 7500000, and
                      15000000.

                      - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                      interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                      this can lead to lower latency, but low-memory devices may not be able to play
                      back the stream without interruptions.

                      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT)
                      at the specified table repetition interval.

                        - **NetworkId** *(integer) --* The numeric value placed in the Network
                        Information Table (NIT).

                        - **NetworkName** *(string) --* The network name text placed in the
                        network_name_descriptor inside the Network Information Table. Maximum length
                        is 256 characters.

                        - **NitInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT)
                      at the specified table repetition interval.

                        - **OutputSdt** *(string) --* Selects method of inserting SDT information
                        into output stream. "Follow input SDT" copies SDT information from input
                        stream to output stream. "Follow input SDT if present" copies SDT
                        information from input stream to output stream if SDT information is present
                        in the input, otherwise it will fall back on the user-defined values. Enter
                        "SDT Manually" means user will enter the SDT information. "No SDT" means
                        output stream will not contain SDT information.

                        - **SdtInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                        - **ServiceName** *(string) --* The service name placed in the
                        service_descriptor in the Service Description Table. Maximum length is 256
                        characters.

                        - **ServiceProviderName** *(string) --* The service provider name placed in
                        the service_descriptor in the Service Description Table. Maximum length is
                        256 characters.

                      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                      subtitle data included in this output. Specify multiple PIDs as a JSON array.
                      Default is the range 460-479.

                        - *(integer) --*

                      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                      specified table repetition interval.

                        - **TdtInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for
                      DVB teletext data you include in this output. Default is 499.

                      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS,
                      audio EBP markers will be added to partitions 3 and 4. The interval between
                      these additional markers will be fixed, and will be slightly shorter than the
                      video EBP marker interval. When set to VIDEO_INTERVAL, these additional
                      markers will not be inserted. Only applicable when EBP segmentation markers
                      are is selected (segmentationMarkers is EBP or EBP_LEGACY).

                      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on.
                      They can either be placed only on the video PID, or on both the video PID and
                      all audio PIDs. Only applicable when EBP segmentation markers are is selected
                      (segmentationMarkers is EBP or EBP_LEGACY).

                      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field
                      in the PES header.

                      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT)
                      unless you know that your audio EBP markers are incorrectly appearing before
                      your video EBP markers. To correct this problem, set this value to Force
                      (FORCE).

                      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                      used with EBP markers.

                      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                      between Program Clock References (PCRs) inserted into the transport stream.

                      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                      Points do not come within the specified time interval of each other by looking
                      ahead at input video. If another EBP is going to come in within the specified
                      time interval, the current EBP is not emitted, and the segment is "stretched"
                      to the next marker. The lookahead value does not add latency to the system.
                      The Live Event must be configured elsewhere to create sufficient latency to
                      make the lookahead accurate.

                      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                      tracking will be detected in the input audio and an equivalent ID3 tag will be
                      inserted in the output.

                      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                      packets to insert into the transport stream. This can be used if a downstream
                      encryption system requires periodic null packets.

                      - **PatInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program
                      Clock Reference value is inserted for every Packetized Elementary Stream (PES)
                      header. This is effective only when the PCR PID is the same as the video or
                      audio elementary stream.

                      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the
                      program clock reference (PCR) in this output. If you do not specify a value,
                      the service will use the value for Video PID (VideoPid).

                      - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                      instances of the program map table (PMT) in the output transport stream.

                      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the
                      program map table (PMT) itself. Default is 480.

                      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of
                      the private metadata stream. Default is 503.

                      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to
                      specify the program number used in the program map table (PMT) for this
                      output. Default is 1. Program numbers and program map tables are parts of
                      MPEG-2 transport stream containers, used for organizing data.

                      - **RateMode** *(string) --* When set to CBR, inserts null packets into
                      transport stream to fill specified bitrate. When set to VBR, the bitrate
                      setting acts as the maximum bitrate, but the output will not be padded up to
                      that bitrate.

                      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                      markers in your HLS and transport stream outputs at the insertion points that
                      you specify in an ESAM XML document. Provide the document in the setting SCC
                      XML (sccXml).

                        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35
                        stream in the transport stream generated by ESAM.

                      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the
                      SCTE-35 stream in the transport stream.

                      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                      Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your
                      input to also appear in this output. Choose None (NONE) if you don't want
                      SCTE-35 markers in this output. For SCTE-35 markers from an ESAM XML
                      document-- Choose None (NONE). Also provide the ESAM XML as a string in the
                      setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
                      (include the property scte35Esam).

                      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                      segmentation_time period. rai_segstart sets the Random Access Indicator bit in
                      the adaptation field. rai_adapt sets the RAI bit and adds the current timecode
                      in the private data bytes. psi_segstart inserts PAT and PMT tables at the
                      start of segments. ebp adds Encoder Boundary Point information to the
                      adaptation field as per OpenCable specification OC-SP-EBP-I01-130118.
                      ebp_legacy adds Encoder Boundary Point information to the adaptation field
                      using a legacy proprietary format.

                      - **SegmentationStyle** *(string) --* The segmentation style parameter
                      controls how segmentation markers are inserted into the transport stream. With
                      avails, it is possible that segments may be truncated, which can influence
                      where future segmentation markers are inserted. When a segmentation style of
                      "reset_cadence" is selected and a segment is truncated due to an avail, we
                      will reset the segmentation cadence. This means the subsequent segment will
                      have a duration of of $segmentation_time seconds. When a segmentation style of
                      "maintain_cadence" is selected and a segment is truncated due to an avail, we
                      will not reset the segmentation cadence. This means the subsequent segment
                      will likely be truncated as well. However, all segments after that will have a
                      duration of $segmentation_time seconds. Note that EBP lookahead is a slight
                      exception to this rule.

                      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                      segment. Required unless markers is set to _none_.

                      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                      timed metadata in this output. Default is 502.

                      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                      itself in the program map table for this output. Transport stream IDs and
                      program map tables are parts of MPEG-2 transport stream containers, used for
                      organizing data.

                      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                      elementary video stream in the transport stream.

                    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert
                      for each PES packet.

                      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                      stream(s) in the transport stream. Multiple values are accepted, and can be
                      entered in ranges and/or by comma separation.

                        - *(integer) --*

                      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                      tracking will be detected in the input audio and an equivalent ID3 tag will be
                      inserted in the output.

                      - **PatInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program
                      Clock Reference value is inserted for every Packetized Elementary Stream (PES)
                      header. This parameter is effective only when the PCR PID is the same as the
                      video or audio elementary stream.

                      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock
                      Reference (PCR) in the transport stream. When no value is given, the encoder
                      will assign the same value as the Video PID.

                      - **PmtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                      (PMT) in the transport stream.

                      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                      metadata stream in the transport stream.

                      - **ProgramNumber** *(integer) --* The value of the program number field in
                      the Program Map Table.

                      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                      in the transport stream.

                      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                      Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your
                      input to also appear in this output. Choose None (NONE) if you don't want
                      SCTE-35 markers in this output. For SCTE-35 markers from an ESAM XML
                      document-- Choose None (NONE) if you don't want manifest conditioning. Choose
                      Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want
                      manifest conditioning. In both cases, also provide the ESAM XML as a string in
                      the setting Signal processing notification XML (sccXml).

                      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this
                      setting to specify whether the service inserts the ID3 timed metadata from the
                      input in this output.

                      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                      metadata stream in the transport stream.

                      - **TransportStreamId** *(integer) --* The value of the transport stream ID
                      field in the Program Map Table.

                      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                      stream in the transport stream.

                    - **MovSettings** *(dict) --* Settings for MOV Container.

                      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate
                      for the video output settings.

                      - **CslgAtom** *(string) --* When enabled, file composition times will start
                      at zero, composition times in the 'ctts' (composition time to sample) box for
                      B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                      will be included per 14496-1 amendment 1. This improves compatibility with
                      Apple players and tools.

                      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                      streams into the QuickTime file using XDCAM fourcc codes. This increases
                      compatibility with Apple editors and players, but may decrease compatibility
                      with other players. Only applicable when the video codec is MPEG2.

                      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                      padding

                      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED)
                      for this setting.

                    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create
                    audio-only AAC outputs with this container.

                      - **CslgAtom** *(string) --* When enabled, file composition times will start
                      at zero, composition times in the 'ctts' (composition time to sample) box for
                      B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                      will be included per 14496-1 amendment 1. This improves compatibility with
                      Apple players and tools.

                      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after
                      the moov box.

                      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV
                      atom is relocated to the beginning of the archive as required for progressive
                      downloading. Otherwise it is placed normally at the end.

                      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the
                      output file. Usually not necessary to specify.

                    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                      - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                      groups that include sidecar TTML or IMSC captions. You specify sidecar
                      captions in a separate output from your audio and video. Choose Raw (RAW) for
                      captions in a single XML file in a raw container. Choose Fragmented MPEG-4
                      (FRAGMENTED_MP4) for captions in XML format contained within fragmented MP4
                      files. This set of fragmented MP4 files is separate from your video and audio
                      fragmented MP4 files.

                      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                      markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                      insertion points that you specify in an ESAM XML document. Provide the
                      document in the setting SCC XML (sccXml).

                      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                      markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                      SCTE-35 markers that appear in your input to also appear in this output.
                      Choose None (NONE) if you don't want those SCTE-35 markers in this output.

                  - **Extension** *(string) --* Use Extension (Extension) to specify the file
                  extension for outputs in File output groups. If you do not specify a value, the
                  service will use default extensions by container type as follows * MPEG-2
                  transport stream, m2ts * Quicktime, mov * MXF container, mxf * MPEG-4 container,
                  mp4 * No Container, the service will use codec extensions (e.g. AAC, H265, H265,
                  AC3)

                  - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the
                  service add a string to the end of each output filename. You specify the base
                  filename as part of your destination URI. When you create multiple outputs in the
                  same output group, Name modifier (NameModifier) is required. Name modifier also
                  accepts format identifiers. For DASH ISO outputs, if you use the format
                  identifiers $Number$ or $Time$ in one output, you must use them in the same way in
                  all outputs of the output group.

                  - **OutputSettings** *(dict) --* Specific settings for this type of output.

                    - **HlsSettings** *(dict) --* Settings for HLS output groups

                      - **AudioGroupId** *(string) --* Specifies the group to which the audio
                      Rendition belongs.

                      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                      outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                      container. Keep the default value Automatic (AUTOMATIC) to create an
                      audio-only file in a raw container. Regardless of the value that you specify
                      here, if this output has video, the service will place the output into an
                      MPEG2-TS container.

                      - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                      with the video output stream. Input all the audio GROUP-IDs that are
                      associated to the video, separate by ','.

                      - **AudioTrackType** *(string) --* Four types of audio-only tracks are
                      supported: Audio-Only Variant Stream The client can play back this audio-only
                      stream instead of video in low-bandwidth scenarios. Represented as an
                      EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select, Default
                      Alternate rendition that the client should try to play back by default.
                      Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES,
                      AUTOSELECT=
                          YES Alternate Audio, Auto Select, Not Default Alternate rendition
                      that the client may try to play back by default. Represented as an EXT-X-MEDIA
                      in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                          YES Alternate Audio, not Auto
                      Select Alternate rendition that the client will not try to play back by
                      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
                      AUTOSELECT=NO

                      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame
                      Only Manifest in addition to the HLS manifest

                      - **SegmentModifier** *(string) --* String concatenated to end of segment
                      filenames. Accepts "Format Identifiers":#format_identifier_parameters.

                  - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
                  transcoding settings. Provide the system or custom preset name. You can specify
                  either Preset (Preset) or Container settings (ContainerSettings), but not both.

                  - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
                  encoding settings. The specific video settings depend on the video codec that you
                  choose when you specify a value for Video codec (codec). Include one instance of
                  (VideoDescription) per output.

                    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                    MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                    service includes AFD values in the output video data and what those values are.
                    * Choose None to remove all AFD values from this output. * Choose Fixed to
                    ignore input AFD values and instead encode the value specified in the job. *
                    Choose Auto to calculate output AFD values based on the input AFD scaler data.

                    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to
                    all outputs. The service no longer accepts the value DISABLED for AntiAlias. If
                    you specify that in your job, the service will ignore the setting.

                    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                    (VideoDescription), contains the group of settings related to video encoding.
                    The settings in this group vary depending on the value that you choose for Video
                    codec (Codec). For each codec enum that you choose, define the corresponding
                    settings object. The following lists the codec enum, settings object pairs. *
                    H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
                    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

                      - **Codec** *(string) --* Specifies the video codec. This must be equal to one
                      of the enum values defined by the object VideoCodec.

                      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                        - **FramerateDenominator** *(integer) --* Frame capture will encode the
                        first frame of the output stream, then one frame every
                        framerateDenominator/framerateNumerator seconds. For example, settings of
                        framerateNumerator = 1 and framerateDenominator =
                             3 (a rate of 1/3 frame per
                        second) will capture the first frame, then 1 frame every 3s. Files will be
                        named as filename.n.jpg where n is the 0-based sequence number of each
                        Capture.

                        - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                        frame of the output stream, then one frame every
                        framerateDenominator/framerateNumerator seconds. For example, settings of
                        framerateNumerator = 1 and framerateDenominator =
                             3 (a rate of 1/3 frame per
                        second) will capture the first frame, then 1 frame every 3s. Files will be
                        named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number
                        zero padded to 7 decimal places.

                        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg
                        output files).

                        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                        quality.

                      - **H264Settings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value H_264.

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent
                        with your output video settings. If you aren't sure what level to specify,
                        choose Auto (AUTO).

                        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit
                        profiles are only available with the AVC-I License.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must
                        be in Main or High profile) or CAVLC.

                        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF
                        encoding for interlaced outputs.

                        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame to reduce flicker or 'pop' on I-frames.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job specification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* When you use the API for transcode
                        jobs that use frame rate conversion, specify the frame rate as a fraction.
                        For example, 24000 / 1001 =
                             23.976 fps. Use FramerateDenominator to specify
                        the denominator of this fraction. In this example, use 1001 for the value of
                        FramerateDenominator. When you use the console for transcode jobs that use
                        frame rate conversion, provide the value as a decimal number for Framerate.
                        In this example, specify 23.976.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                        structures that have B frames > 1.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type, as follows. - If the source is
                        interlaced, the output will be interlaced with the same polarity as the
                        source (it will follow the source). The output could therefore be a mix of
                        "top field first" and "bottom field first". - If the source is progressive,
                        the output will be interlaced with "top field first" or "bottom field first"
                        polarity, depending on which of the Follow options you chose.

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000. Required when Rate control mode
                        is QVBR.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **NumberReferenceFrames** *(integer) --* Number of reference frames to
                        use. The encoder may use more than requested if using B-frames and/or
                        interlaced encoding.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                        high-quality singlepass, or high-quality multipass video encoding.

                        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                        encoding with the H.264 codec. Required when you set Rate control mode to
                        QVBR. Not valid when you set Rate control mode to a value other than QVBR,
                        or when you don't define Rate control mode.

                          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                          control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                          average bitrate values suited to the complexity of your input video, the
                          service limits the average bitrate of the video part of this output to the
                          value that you choose. That is, the total size of the video element is
                          less than or equal to the value you set multiplied by the number of
                          seconds of encoded output.

                          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                          control mode. That is, when you specify qvbrSettings within h264Settings.
                          Specify the target quality level for this output, from 1 to 10. Use higher
                          numbers for greater quality. Level 10 results in nearly lossless
                          compression. The quality level for most broadcast-quality transcodes is
                          between 6 and 9.

                        - **RateControlMode** *(string) --* Use this setting to specify whether this
                        output has a variable bitrate (VBR), constant bitrate (CBR) or
                        quality-defined variable bitrate (QVBR).

                        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture,
                        even if repeated.

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default. If this output uses QVBR, choose
                        Transition detection (TRANSITION_DETECTION) for further video quality
                        improvement. For more information about QVBR, see
                        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                        - **Slices** *(integer) --* Number of slices per picture. Must be less than
                        or equal to the number of macroblock rows for progressive pictures, and less
                        than or equal to half the number of macroblock rows for interlaced pictures.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                        values reduce high-frequency content in the encoded image.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE
                        RP-2027.

                        - **Telecine** *(string) --* This field applies only if the Streams >
                        Advanced > Framerate (framerate) field is set to 29.970. This field works
                        with the Streams > Advanced > Preprocessors > Deinterlacer field
                        (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
                        (interlace_mode) to identify the scan type for the output: Progressive,
                        Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
                        from 23.976 input. - Soft: produces 23.976; the player converts this output
                        to 29.97i.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame
                        as 4 bytes of an unregistered SEI message.

                      - **H265Settings** *(dict) --* Settings for H265 codec

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                        Function SEI message for outputs using Hybrid Log Gamma (HLG)
                        Electro-Optical Transfer Function (EOTF).

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* H.265 Level.

                        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the
                        HEVC (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                        "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                        available with the HEVC 4:2:2 License.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame to reduce flicker or 'pop' on I-frames.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                        structures that have B frames > 1.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                        Choose Progressive (PROGRESSIVE) to create a progressive output, regardless
                        of the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom
                        Field First (BOTTOM_FIELD) to create an output that's interlaced with the
                        same field polarity throughout. Choose Follow, Default Top
                        (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
                        an interlaced output with the same field polarity as the source. If the
                        source is interlaced, the output will be interlaced with the same polarity
                        as the source (it will follow the source). The output could therefore be a
                        mix of "top field first" and "bottom field first". If the source is
                        progressive, your output will be interlaced with "top field first" or
                        "bottom field first" polarity, depending on which of the Follow options you
                        chose. If you don't choose a value, the service will default to Progressive
                        (PROGRESSIVE).

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000. Required when Rate control mode
                        is QVBR.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **NumberReferenceFrames** *(integer) --* Number of reference frames to
                        use. The encoder may use more than requested if using B-frames and/or
                        interlaced encoding.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                        high-quality singlepass, or high-quality multipass video encoding.

                        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                        encoding with the H.265 codec. Required when you set Rate control mode to
                        QVBR. Not valid when you set Rate control mode to a value other than QVBR,
                        or when you don't define Rate control mode.

                          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                          control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                          average bitrate values suited to the complexity of your input video, the
                          service limits the average bitrate of the video part of this output to the
                          value that you choose. That is, the total size of the video element is
                          less than or equal to the value you set multiplied by the number of
                          seconds of encoded output.

                          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                          control mode. That is, when you specify qvbrSettings within h265Settings.
                          Specify the target quality level for this output, from 1 to 10. Use higher
                          numbers for greater quality. Level 10 results in nearly lossless
                          compression. The quality level for most broadcast-quality transcodes is
                          between 6 and 9.

                        - **RateControlMode** *(string) --* Use this setting to specify whether this
                        output has a variable bitrate (VBR), constant bitrate (CBR) or
                        quality-defined variable bitrate (QVBR).

                        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                        Offset (SAO) filter strength. Adaptive mode dynamically selects best
                        strength based on content

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default. If this output uses QVBR, choose
                        Transition detection (TRANSITION_DETECTION) for further video quality
                        improvement. For more information about QVBR, see
                        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                        - **Slices** *(integer) --* Number of slices per picture. Must be less than
                        or equal to the number of macroblock rows for progressive pictures, and less
                        than or equal to half the number of macroblock rows for interlaced pictures.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Telecine** *(string) --* This field applies only if the Streams >
                        Advanced > Framerate (framerate) field is set to 29.970. This field works
                        with the Streams > Advanced > Preprocessors > Deinterlacer field
                        (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
                        (interlace_mode) to identify the scan type for the output: Progressive,
                        Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
                        from 23.976 input. - Soft: produces 23.976; the player converts this output
                        to 29.97i.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                        encoded bitstream. Up to 3 layers are supported depending on GOP structure:
                        I- and P-frames form one layer, reference B-frames can form a second layer
                        and non-reference b-frames can form a third layer. Decoders can optionally
                        decode only the lower temporal layers to generate a lower frame rate output.
                        For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e.
                        IbPbPb display order), a decoder could decode all the frames for full frame
                        rate output or only the I and P frames (lowest temporal layer) for a half
                        frame rate output.

                        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well
                        as vertical subdivision of the encoded pictures.

                        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame
                        as 4 bytes of an unregistered SEI message.

                        - **WriteMp4PackagingType** *(string) --* If the location of parameter set
                        NAL units doesn't matter in your workflow, ignore this setting. Use this
                        setting only with CMAF or DASH outputs, or with standalone file outputs in
                        an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your output as HVC1.
                        This makes your output compliant with the following specification: ISO
                        IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
                        outputs, the service stores parameter set NAL units in the sample headers
                        but not in the samples directly. For MP4 outputs, when you choose HVC1, your
                        output video might not work properly with some downstream systems and video
                        players. The service defaults to marking your output as HEV1. For these
                        outputs, the service writes parameter set NAL units directly into the
                        samples.

                      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value MPEG2.

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                        level for the video output.

                        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                        MPEG-2 profile for the video output.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type. - If the source is interlaced, the
                        output will be interlaced with the same polarity as the source (it will
                        follow the source). The output could therefore be a mix of "top field first"
                        and "bottom field first". - If the source is progressive, the output will be
                        interlaced with "top field first" or "bottom field first" polarity,
                        depending on which of the Follow options you chose.

                        - **IntraDcPrecision** *(string) --* Use Intra DC precision
                        (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                        coefficients. If you choose the value auto, the service will automatically
                        select the precision based on the per-frame compression ratio.

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or
                        multipass video encoding.

                        - **RateControlMode** *(string) --* Use Rate control mode
                        (Mpeg2RateControlMode) to specifiy whether the bitrate is variable (vbr) or
                        constant (cbr).

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                        values reduce high-frequency content in the encoded image.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                        356M-2001).

                        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                        Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard)
                        to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                        produce 23.976 output and leave converstion to the player.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                      - **ProresSettings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value PRORES.

                        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to
                        specifiy the type of Apple ProRes codec to use for this output.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* When you use the API for transcode
                        jobs that use frame rate conversion, specify the frame rate as a fraction.
                        For example, 24000 / 1001 =
                             23.976 fps. Use FramerateNumerator to specify
                        the numerator of this fraction. In this example, use 24000 for the value of
                        FramerateNumerator.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type. - If the source is interlaced, the
                        output will be interlaced with the same polarity as the source (it will
                        follow the source). The output could therefore be a mix of "top field first"
                        and "bottom field first". - If the source is progressive, the output will be
                        interlaced with "top field first" or "bottom field first" polarity,
                        depending on which of the Follow options you chose.

                        - **ParControl** *(string) --* Use (ProresParControl) to specify how the
                        service determines the pixel aspect ratio. Set to Follow source
                        (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio from the input. To
                        specify a different pixel aspect ratio: Using the console, choose it from
                        the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
                        provide for (ParNumerator) and (ParDenominator).

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                        Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard
                        (hard) to produce a 29.97i output from a 23.976 input. Set it to Soft (soft)
                        to produce 23.976 output and leave converstion to the player.

                    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to
                    include color metadata in this output. Choose Ignore (IGNORE) to exclude color
                    metadata from this output. If you don't specify a value, the service sets this
                    to Insert by default.

                    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area
                    that the service will include in the output video frame.

                      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                      numbers.

                      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                      numbers.

                      - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                      left edge of the video frame. Specify only even numbers.

                      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                      top edge of the video frame. Specify only even numbers.

                    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When
                    this feature is enabled, the service will use drop-frame timecode on outputs. If
                    it is not possible to use drop-frame timecode, the system will fall back to
                    non-drop-frame. This setting is enabled by default when Timecode insertion
                    (TimecodeInsertion) is enabled.

                    - **FixedAfd** *(integer) --* Applies only if you set AFD
                    Signaling(AfdSignaling) to Fixed (FIXED). Use Fixed (FixedAfd) to specify a
                    four-bit AFD value which the service will write on all frames of this video
                    output.

                    - **Height** *(integer) --* Use the Height (Height) setting to define the video
                    resolution height for this output. Specify in pixels. If you don't provide a
                    value here, the service will use the input height.

                    - **Position** *(dict) --* Use Selection placement (position) to define the
                    video area in your output frame. The area outside of the rectangle that you
                    specify here is black.

                      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                      numbers.

                      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                      numbers.

                      - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                      left edge of the video frame. Specify only even numbers.

                      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                      top edge of the video frame. Specify only even numbers.

                    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify
                    how the service changes the video itself in response to AFD values in the input.
                    * Choose Respond to clip the input video frame according to the AFD value, input
                    display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                    include the input AFD values. Do not choose this when AfdSignaling is set to
                    (NONE). A preferred implementation of this workflow is to set RespondToAfd to
                    (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
                    values from this output.

                    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                    have a different aspect ratio from the input aspect ratio. Choose Stretch to
                    output (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit.
                    Keep the setting Default (DEFAULT) to have the service letterbox your video
                    instead. This setting overrides any value that you specify for the setting
                    Selection placement (position) in this output.

                    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                    strength of anti-aliasing. This setting changes the width of the anti-alias
                    filter kernel used for scaling. Sharpness only applies if your output resolution
                    is different from your input resolution. 0 is the softest setting, 100 the
                    sharpest, and 50 recommended for most content.

                    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                    ProRes outputs. Only enable Timecode insertion when the input frame rate is
                    identical to the output frame rate. To include timecodes in this output, set
                    Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them
                    out, set it to DISABLED. Default is DISABLED. When the service inserts timecodes
                    in an output, by default, it uses any embedded timecodes from the input. If none
                    are present, the service will set the timecode for the first output frame to
                    zero. To change this default behavior, adjust the settings under Timecode
                    configuration (TimecodeConfig). In the console, these settings are located under
                    Job > Job settings > Timecode configuration. Note - Timecode source under input
                    settings (InputTimecodeSource) does not affect the timecodes that are inserted
                    in the output. Source under Job settings > Timecode configuration
                    (TimecodeSource) does.

                    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                    Preprocessors (VideoPreprocessors). Enable the features at each output
                    individually. These features are disabled by default.

                      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                      feature if necessary. Enable or disable this feature for each output
                      individually. This setting is disabled by default.

                        - **Brightness** *(integer) --* Brightness level.

                        - **ColorSpaceConversion** *(string) --* Specify the color space you want
                        for this output. The service supports conversion between HDR formats,
                        between SDR formats, and from SDR to HDR. The service doesn't support
                        conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
                        dynamic range. The converted video has an HDR format, but visually appears
                        the same as an unconverted output.

                        - **Contrast** *(integer) --* Contrast level.

                        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the
                        HDR 10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume
                        static metadata that you want signaled in the output. These values don't
                        affect the pixel values that are encoded in the video stream. They are
                        intended to help the downstream video player display content in a way that
                        reflects the intentions of the the content creator. When you set Color space
                        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings
                        are required. You must set values for Max frame average light level
                        (maxFrameAverageLightLevel) and Max content light level
                        (maxContentLightLevel); these settings don't have a default value. The
                        default values for the other HDR 10 metadata settings are defined by the
                        P3D65 color space. For more information about MediaConvert HDR jobs, see
                        https://docs.aws.amazon.com/console/mediaconvert/hdr.

                          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                          samples in the coded video sequence, in units of candelas per square
                          meter. This setting doesn't have a default value; you must specify a value
                          that is suitable for the content.

                          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level
                          of any frame in the coded video sequence, in units of candelas per square
                          meter. This setting doesn't have a default value; you must specify a value
                          that is suitable for the content.

                          - **MaxLuminance** *(integer) --* Nominal maximum mastering display
                          luminance in units of of 0.0001 candelas per square meter.

                          - **MinLuminance** *(integer) --* Nominal minimum mastering display
                          luminance in units of of 0.0001 candelas per square meter

                          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **WhitePointX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **WhitePointY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                        - **Hue** *(integer) --* Hue in degrees.

                        - **Saturation** *(integer) --* Saturation level.

                      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce
                      smoother motion and a clearer picture.

                        - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                        (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE).
                        Motion adaptive interpolate (INTERPOLATE) produces sharper pictures, while
                        blend (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR
                        (BLEND_TICKER) if your source file includes a ticker, such as a scrolling
                        headline at the bottom of the frame.

                        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                        does not convert frames that are tagged in metadata as progressive. It will
                        only convert those that are tagged as some other type. - When set to
                        FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive -
                        even those that are already tagged as progressive. Turn Force mode on only
                        if there is a good chance that the metadata has tagged frames as progressive
                        when they are not progressive. Do not turn on otherwise; processing frames
                        that are already progressive into progressive will probably result in lower
                        quality video.

                        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how
                        the service will do deinterlacing. Default is Deinterlace. - Deinterlace
                        converts interlaced to progressive. - Inverse telecine converts Hard
                        Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects and converts
                        to progressive.

                      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby
                      Vision compatible video output.

                        - **L6Metadata** *(dict) --* Use these settings when you set
                        DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values
                        in your input with new values.

                          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR
                          metadata that corresponds to the brightest pixel in the entire stream.
                          Measured in nits.

                          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                          metadata that corresponds to the highest frame-average brightness in the
                          entire stream. Measured in nits.

                        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service
                        will handle Dolby Vision MaxCLL and MaxFALL properies.

                        - **Profile** *(string) --* In the current MediaConvert implementation, the
                        Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs
                        must contain Dolby Vision frame interleaved data.

                      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter)
                      feature to include a graphic overlay on your video. Enable or disable this
                      feature for each output individually. This setting is disabled by default.

                        - **InsertableImages** *(list) --* Specify the images that you want to
                        overlay on your video. The images must be PNG or TGA files.

                          - *(dict) --* Settings that specify how your still graphic overlay
                          appears.

                            - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                            image to remain on the output video. This duration includes fade-in time
                            but not fade-out time.

                            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                            between the Start time that you specify for the image insertion and the
                            time that the image appears at full opacity. Full opacity is the level
                            that you specify for the opacity setting. If you don't specify a value
                            for Fade-in, the image will appear abruptly at the overlay start time.

                            - **FadeOut** *(integer) --* Specify the length of time, in
                            milliseconds, between the end of the time that you have specified for
                            the image overlay Duration and when the overlaid image has faded to
                            total transparency. If you don't specify a value for Fade-out, the image
                            will disappear abruptly at the end of the inserted image duration.

                            - **Height** *(integer) --* Specify the height of the inserted image in
                            pixels. If you specify a value that's larger than the video resolution
                            height, the service will crop your overlaid image to fit. To use the
                            native height of the image, keep this setting blank.

                            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or
                            Amazon S3 location of the image that you want to overlay on the video.
                            Use a PNG or TGA file.

                            - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                            inserted image and the left edge of the video frame. Required for any
                            image overlay that you specify.

                            - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                            overlaid image and the top edge of the video frame. Required for any
                            image overlay that you specify.

                            - **Layer** *(integer) --* Specify how overlapping inserted images
                            appear. Images with higher values for Layer appear on top of images with
                            lower values for Layer.

                            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much
                            of the underlying video shows through the inserted image. 0 is
                            transparent and 100 is fully opaque. Default is 50.

                            - **StartTime** *(string) --* Specify the timecode of the frame that you
                            want the overlay to first appear on. This must be in timecode
                            (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take into account your
                            timecode source settings.

                            - **Width** *(integer) --* Specify the width of the inserted image in
                            pixels. If you specify a value that's larger than the video resolution
                            width, the service will crop your overlaid image to fit. To use the
                            native width of the image, keep this setting blank.

                      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature
                      to remove noise from your video output if necessary. Enable or disable this
                      feature for each output individually. This setting is disabled by default.

                        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                        select one of the following spatial image filtering functions. To use this
                        setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                        preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos,
                        and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
                        noise reduction. * Spatial does frequency-domain filtering based on JND
                        principles. * Temporal optimizes video quality for complex motion.

                        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                          - **Strength** *(integer) --* Relative strength of noise reducing filter.
                          Higher values produce stronger filtering.

                        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                        spatial filter.

                          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post
                          noise reduction sharpening filter, with 0 disabling the filter and 3
                          enabling it at maximum strength.

                          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed)
                          to 3 (higher speed), with 0 being the nominal value.

                          - **Strength** *(integer) --* Relative strength of noise reducing filter.
                          Higher values produce stronger filtering.

                        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                        temporal filter.

                          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that
                          has complex motion. Higher values produce stronger temporal filtering.
                          This filters highly complex scenes more aggressively and creates better VQ
                          for low bitrate outputs.

                          - **Speed** *(integer) --* The speed of the filter (higher number is
                          faster). Low setting reduces bit rate at the cost of transcode time, high
                          setting improves transcode time at the cost of bit rate.

                          - **Strength** *(integer) --* Specify the strength of the noise reducing
                          filter on this output. Higher values produce stronger filtering. We
                          recommend the following value ranges, depending on the result that you
                          want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
                          complexity reduction with image preservation * 8-16 for a high level of
                          complexity reduction

                      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                      output timecode and specified prefix into the output.

                        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size
                        of any burned-in timecode. Valid values are 10, 16, 32, 48.

                        - **Position** *(string) --* Use Position (Position) under under Timecode
                        burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                        output video.

                        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters
                        before any burned-in timecode. For example, a prefix of "EZ-" will result in
                        the timecode "EZ-00:00:00:00". Provide either the characters themselves or
                        the ASCII code equivalents. The supported range of characters is 0x20
                        through 0x7e. This includes letters, numbers, and all special characters
                        represented on a standard English keyboard.

                    - **Width** *(integer) --* Use Width (Width) to define the video resolution
                    width, in pixels, for this output. If you don't provide a value here, the
                    service will use the input width.

          - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
          information from inputs.

            - **Anchor** *(string) --* If you use an editing platform that relies on an anchor
            timecode, use Anchor Timecode (Anchor) to specify a timecode that will match the input
            video frame to the output video frame. Use 24-hour format with frame number,
            (HH:MM:SS:FF) or (HH:MM:SS;FF). This setting ignores frame rate conversion. System
            behavior for Anchor Timecode varies depending on your setting for Source
            (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
            (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode
            (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate output
            timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
            is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first
            frame is the timecode value on the first input frame of the input.

            - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
            within this job. To make sure that your video, audio, captions, and markers are
            synchronized and that time-based features, such as image inserter, work correctly,
            choose the Timecode source option that matches your assets. All timecodes are in a
            24-hour format with frame number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode
            that is in the input video. If no embedded timecode is in the source, the service will
            use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) - Set the timecode of the
            initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set the timecode of
            the initial frame to a value other than zero. You use Start timecode (Start) to provide
            this value.

            - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified
            start (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the
            initial frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

            - **TimestampOffset** *(string) --* Only applies to outputs that support
            program-date-time stamp. Use Timestamp offset (TimestampOffset) to overwrite the
            timecode date without affecting the time and frame number. Provide the new date as a
            string in the format "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert
            program-date-time (InsertProgramDateTime) in the output settings. For example, if the
            date part of your timecodes is 2002-1-25 and you want to change it to one year later,
            set Timestamp offset (TimestampOffset) to 2003-1-25.

          - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
          (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you
          must enable it here, enable it in each output container, and specify tags and timecodes in
          ID3 insertion (Id3Insertion) objects.

            - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion
            instances.

              - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3)
              to specify the base 64 encoded string and use Timecode (TimeCode) to specify the time
              when the tag should be inserted. To insert multiple ID3 tags in your output, create
              multiple instances of ID3 insertion (Id3Insertion).

                - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
                format.

                - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or
                HH:MM:SS;FF format.

        - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
        events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
        MediaConvert sends an update at this interval from the time the service begins processing
        your job to the time it completes the transcode or encounters an error.

        - **Type** *(string) --* A job template can be of two types: system or custom. System or
        built-in job templates can't be modified or deleted by the user.

    - **NextToken** *(string) --* Use this string to request the next batch of job templates.
    """


_ClientListJobsResponseJobsAccelerationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsAccelerationSettingsTypeDef", {"Mode": str}, total=False
)


class ClientListJobsResponseJobsAccelerationSettingsTypeDef(
    _ClientListJobsResponseJobsAccelerationSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobs` `AccelerationSettings`

    - **Mode** *(string) --* Specify the conditions when the service will run your job with
    accelerated transcoding.
    """


_ClientListJobsResponseJobsMessagesTypeDef = TypedDict(
    "_ClientListJobsResponseJobsMessagesTypeDef",
    {"Info": List[str], "Warning": List[str]},
    total=False,
)


class ClientListJobsResponseJobsMessagesTypeDef(_ClientListJobsResponseJobsMessagesTypeDef):
    """
    Type definition for `ClientListJobsResponseJobs` `Messages`

    - **Info** *(list) --* List of messages that are informational only and don't indicate a problem
    with your job.

      - *(string) --*

    - **Warning** *(list) --* List of messages that warn about conditions that might cause your job
    not to run or to fail.

      - *(string) --*
    """


_ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef",
    {"HeightInPx": int, "WidthInPx": int},
    total=False,
)


class ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef(
    _ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsOutputGroupDetailsOutputDetails` `VideoDetails`

    - **HeightInPx** *(integer) --* Height in pixels for the output

    - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsTypeDef",
    {
        "DurationInMs": int,
        "VideoDetails": ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsTypeDef(
    _ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsOutputGroupDetails` `OutputDetails`

    - **DurationInMs** *(integer) --* Duration in milliseconds

    - **VideoDetails** *(dict) --* Contains details about the output's video stream

      - **HeightInPx** *(integer) --* Height in pixels for the output

      - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ClientListJobsResponseJobsOutputGroupDetailsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsOutputGroupDetailsTypeDef",
    {"OutputDetails": List[ClientListJobsResponseJobsOutputGroupDetailsOutputDetailsTypeDef]},
    total=False,
)


class ClientListJobsResponseJobsOutputGroupDetailsTypeDef(
    _ClientListJobsResponseJobsOutputGroupDetailsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobs` `OutputGroupDetails`

    - **OutputDetails** *(list) --* Details about the output

      - *(dict) --* Details regarding output

        - **DurationInMs** *(integer) --* Duration in milliseconds

        - **VideoDetails** *(dict) --* Contains details about the output's video stream

          - **HeightInPx** *(integer) --* Height in pixels for the output

          - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ClientListJobsResponseJobsSettingsAvailBlankingTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsAvailBlankingTypeDef",
    {"AvailBlankingImage": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsAvailBlankingTypeDef(
    _ClientListJobsResponseJobsSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ClientListJobsResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ClientListJobsResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsEsam`
    `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ClientListJobsResponseJobsSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsEsamSignalProcessingNotificationTypeDef(
    _ClientListJobsResponseJobsSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsEsam` `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientListJobsResponseJobsSettingsEsamTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ClientListJobsResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ClientListJobsResponseJobsSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsEsamTypeDef(_ClientListJobsResponseJobsSettingsEsamTypeDef):
    """
    Type definition for `ClientListJobsResponseJobsSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientListJobsResponseJobsSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsAudioSelectorGroupsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputs` `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsAudioSelectors` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientListJobsResponseJobsSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ClientListJobsResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsAudioSelectorsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsCaptionSelectors` `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ClientListJobsResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsCaptionSelectorsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputs` `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ClientListJobsResponseJobsSettingsInputsCropTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsCropTypeDef(
    _ClientListJobsResponseJobsSettingsInputsCropTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientListJobsResponseJobsSettingsInputsDecryptionSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsDecryptionSettingsTypeDef",
    {
        "DecryptionMode": str,
        "EncryptedDecryptionKey": str,
        "InitializationVector": str,
        "KmsKeyRegion": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsDecryptionSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsDecryptionSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputs` `DecryptionSettings`

    - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt your
    input files.

    - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
    plaintext. Your job settings could be intercepted, making your encrypted content vulnerable.
    Specify the encrypted version of the data key that you used to encrypt your content. The data
    key must be encrypted by AWS Key Management Service (KMS). The key can be 128, 192, or 256 bits.

    - **InitializationVector** *(string) --* Specify the initialization vector that you used when
    you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
    initialization vector with any encryption mode. Or, you can use a 12-byte initialization vector
    with GCM or CTR. MediaConvert accepts only initialization vectors that are base64-encoded.

    - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service (KMS)
    that you used to encrypt your data key, if that Region is different from the one you are using
    for AWS Elemental MediaConvert.
    """


_ClientListJobsResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef(
    _ClientListJobsResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsImageInserter` `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientListJobsResponseJobsSettingsInputsImageInserterTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientListJobsResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsImageInserterTypeDef(
    _ClientListJobsResponseJobsSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientListJobsResponseJobsSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsInputClippingsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ClientListJobsResponseJobsSettingsInputsPositionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsPositionTypeDef(
    _ClientListJobsResponseJobsSettingsInputsPositionTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientListJobsResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ClientListJobsResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputsVideoSelector` `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientListJobsResponseJobsSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ClientListJobsResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsVideoSelectorTypeDef(
    _ClientListJobsResponseJobsSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientListJobsResponseJobsSettingsInputsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str, ClientListJobsResponseJobsSettingsInputsAudioSelectorGroupsTypeDef
        ],
        "AudioSelectors": Dict[str, ClientListJobsResponseJobsSettingsInputsAudioSelectorsTypeDef],
        "CaptionSelectors": Dict[
            str, ClientListJobsResponseJobsSettingsInputsCaptionSelectorsTypeDef
        ],
        "Crop": ClientListJobsResponseJobsSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DecryptionSettings": ClientListJobsResponseJobsSettingsInputsDecryptionSettingsTypeDef,
        "DenoiseFilter": str,
        "FileInput": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ClientListJobsResponseJobsSettingsInputsImageInserterTypeDef,
        "InputClippings": List[ClientListJobsResponseJobsSettingsInputsInputClippingsTypeDef],
        "Position": ClientListJobsResponseJobsSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "SupplementalImps": List[str],
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ClientListJobsResponseJobsSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsInputsTypeDef(
    _ClientListJobsResponseJobsSettingsInputsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you encrypt
    before you upload them to Amazon S3. MediaConvert can decrypt files only when you use AWS Key
    Management Service (KMS) to encrypt the data key that you use to encrypt your content.

      - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt your
      input files.

      - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
      plaintext. Your job settings could be intercepted, making your encrypted content vulnerable.
      Specify the encrypted version of the data key that you used to encrypt your content. The data
      key must be encrypted by AWS Key Management Service (KMS). The key can be 128, 192, or 256
      bits.

      - **InitializationVector** *(string) --* Specify the initialization vector that you used when
      you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
      initialization vector with any encryption mode. Or, you can use a 12-byte initialization
      vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
      base64-encoded.

      - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service (KMS)
      that you used to encrypt your data key, if that Region is different from the one you are using
      for AWS Elemental MediaConvert.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FileInput** *(string) --* Specify the source file for your transcoding job. You can use
    multiple inputs in a single job. The service concatenates these inputs, in the order that you
    specify them in the job, to create the outputs. If your input format is IMF, specify your input
    by providing the path to your CPL. For example, "s3://bucket/vf/cpl.xml". If the CPL is in an
    incomplete IMP, make sure to use *Supplemental IMPs* (SupplementalImps) to specify any
    supplemental IMPs that contain assets referenced by the CPL.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You need
    supplemental IMPs if the CPL that you're using for your input is in an incomplete IMP. Specify
    either the supplemental IMP directories with a trailing slash or the ASSETMAP.xml files. For
    example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to specify the IMP
    that contains your input CPL, because the service automatically detects it.

      - *(string) --*

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientListJobsResponseJobsSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsMotionImageInserterFramerateTypeDef(
    _ClientListJobsResponseJobsSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsMotionImageInserter` `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ClientListJobsResponseJobsSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsMotionImageInserterOffsetTypeDef(
    _ClientListJobsResponseJobsSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsMotionImageInserter` `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ClientListJobsResponseJobsSettingsMotionImageInserterTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ClientListJobsResponseJobsSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ClientListJobsResponseJobsSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsMotionImageInserterTypeDef(
    _ClientListJobsResponseJobsSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ClientListJobsResponseJobsSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsNielsenConfigurationTypeDef(
    _ClientListJobsResponseJobsSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings` `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroups` `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputs` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputs`
    `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputs` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettings`
    `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputs` `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescription`
    `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescription`
    `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroupsOutputs` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ClientListJobsResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ClientListJobsResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ClientListJobsResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsOutputsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientListJobsResponseJobsSettingsOutputGroupsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ClientListJobsResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[ClientListJobsResponseJobsSettingsOutputGroupsOutputsTypeDef],
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsOutputGroupsTypeDef(
    _ClientListJobsResponseJobsSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ClientListJobsResponseJobsSettingsTimecodeConfigTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsTimecodeConfigTypeDef(
    _ClientListJobsResponseJobsSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ClientListJobsResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ClientListJobsResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ClientListJobsResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettingsTimedMetadataInsertion` `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ClientListJobsResponseJobsSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ClientListJobsResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsTimedMetadataInsertionTypeDef(
    _ClientListJobsResponseJobsSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ClientListJobsResponseJobsSettings` `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ClientListJobsResponseJobsSettingsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ClientListJobsResponseJobsSettingsAvailBlankingTypeDef,
        "Esam": ClientListJobsResponseJobsSettingsEsamTypeDef,
        "Inputs": List[ClientListJobsResponseJobsSettingsInputsTypeDef],
        "MotionImageInserter": ClientListJobsResponseJobsSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ClientListJobsResponseJobsSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ClientListJobsResponseJobsSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ClientListJobsResponseJobsSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ClientListJobsResponseJobsSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ClientListJobsResponseJobsSettingsTypeDef(_ClientListJobsResponseJobsSettingsTypeDef):
    """
    Type definition for `ClientListJobsResponseJobs` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode job.
    There can be multiple inputs add in a job. These inputs will be concantenated together to create
    the output.

      - *(dict) --* Specifies media input

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
        encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when you
        use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt your
        content.

          - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt
          your input files.

          - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
          plaintext. Your job settings could be intercepted, making your encrypted content
          vulnerable. Specify the encrypted version of the data key that you used to encrypt your
          content. The data key must be encrypted by AWS Key Management Service (KMS). The key can
          be 128, 192, or 256 bits.

          - **InitializationVector** *(string) --* Specify the initialization vector that you used
          when you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
          initialization vector with any encryption mode. Or, you can use a 12-byte initialization
          vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
          base64-encoded.

          - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
          (KMS) that you used to encrypt your data key, if that Region is different from the one you
          are using for AWS Elemental MediaConvert.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FileInput** *(string) --* Specify the source file for your transcoding job. You can use
        multiple inputs in a single job. The service concatenates these inputs, in the order that
        you specify them in the job, to create the outputs. If your input format is IMF, specify
        your input by providing the path to your CPL. For example, "s3://bucket/vf/cpl.xml". If the
        CPL is in an incomplete IMP, make sure to use *Supplemental IMPs* (SupplementalImps) to
        specify any supplemental IMPs that contain assets referenced by the CPL.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You
        need supplemental IMPs if the CPL that you're using for your input is in an incomplete IMP.
        Specify either the supplemental IMP directories with a trailing slash or the ASSETMAP.xml
        files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to
        specify the IMP that contains your input CPL, because the service automatically detects it.

          - *(string) --*

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ClientListJobsResponseJobsTimingTypeDef = TypedDict(
    "_ClientListJobsResponseJobsTimingTypeDef",
    {"FinishTime": datetime, "StartTime": datetime, "SubmitTime": datetime},
    total=False,
)


class ClientListJobsResponseJobsTimingTypeDef(_ClientListJobsResponseJobsTimingTypeDef):
    """
    Type definition for `ClientListJobsResponseJobs` `Timing`

    - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
    finished

    - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the job
    began.

    - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the job.
    """


_ClientListJobsResponseJobsTypeDef = TypedDict(
    "_ClientListJobsResponseJobsTypeDef",
    {
        "AccelerationSettings": ClientListJobsResponseJobsAccelerationSettingsTypeDef,
        "AccelerationStatus": str,
        "Arn": str,
        "BillingTagsSource": str,
        "CreatedAt": datetime,
        "CurrentPhase": str,
        "ErrorCode": int,
        "ErrorMessage": str,
        "Id": str,
        "JobPercentComplete": int,
        "JobTemplate": str,
        "Messages": ClientListJobsResponseJobsMessagesTypeDef,
        "OutputGroupDetails": List[ClientListJobsResponseJobsOutputGroupDetailsTypeDef],
        "Priority": int,
        "Queue": str,
        "RetryCount": int,
        "Role": str,
        "Settings": ClientListJobsResponseJobsSettingsTypeDef,
        "SimulateReservedQueue": str,
        "Status": str,
        "StatusUpdateInterval": str,
        "Timing": ClientListJobsResponseJobsTimingTypeDef,
        "UserMetadata": Dict[str, str],
    },
    total=False,
)


class ClientListJobsResponseJobsTypeDef(_ClientListJobsResponseJobsTypeDef):
    """
    Type definition for `ClientListJobsResponse` `Jobs`

    - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
    with long, visually complex content.

      - **Mode** *(string) --* Specify the conditions when the service will run your job with
      accelerated transcoding.

    - **AccelerationStatus** *(string) --* Describes whether the current job is running with
    accelerated transcoding. For jobs that have Acceleration (AccelerationMode) set to DISABLED,
    AccelerationStatus is always NOT_APPLICABLE. For jobs that have Acceleration (AccelerationMode)
    set to ENABLED or PREFERRED, AccelerationStatus is one of the other states. AccelerationStatus
    is IN_PROGRESS initially, while the service determines whether the input files and job settings
    are compatible with accelerated transcoding. If they are, AcclerationStatus is ACCELERATED. If
    your input files and job settings aren't compatible with accelerated transcoding, the service
    either fails your job or runs it without accelerated transcoding, depending on how you set
    Acceleration (AccelerationMode). When the service runs your job without accelerated transcoding,
    AccelerationStatus is NOT_ACCELERATED.

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **BillingTagsSource** *(string) --* Optional. Choose a tag type that AWS Billing and Cost
    Management will use to sort your AWS Elemental MediaConvert costs on any billing report that you
    set up. Any transcoding outputs that don't have an associated tag will appear in your billing
    report unsorted. If you don't choose a valid value for this field, your job outputs will appear
    on the billing report unsorted.

    - **CreatedAt** *(datetime) --* The time, in Unix epoch format in seconds, when the job got
    created.

    - **CurrentPhase** *(string) --* A job's phase can be PROBING, TRANSCODING OR UPLOADING

    - **ErrorCode** *(integer) --* Error code for the job

    - **ErrorMessage** *(string) --* Error message of Job

    - **Id** *(string) --* A portion of the job's ARN, unique within your AWS Elemental MediaConvert
    resources

    - **JobPercentComplete** *(integer) --* An estimate of how far your job has progressed. This
    estimate is shown as a percentage of the total time from when your job leaves its queue to when
    your output files appear in your output Amazon S3 bucket. AWS Elemental MediaConvert provides
    jobPercentComplete in CloudWatch STATUS_UPDATE events and in the response to GetJob and ListJobs
    requests. The jobPercentComplete estimate is reliable for the following input containers:
    Quicktime, Transport Stream, MP4, and MXF. For some jobs, the service can't provide information
    about job progress. In those cases, jobPercentComplete returns a null value.

    - **JobTemplate** *(string) --* The job template that the job is created from, if it is created
    from a job template.

    - **Messages** *(dict) --* Provides messages from the service about jobs that you have already
    successfully submitted.

      - **Info** *(list) --* List of messages that are informational only and don't indicate a
      problem with your job.

        - *(string) --*

      - **Warning** *(list) --* List of messages that warn about conditions that might cause your
      job not to run or to fail.

        - *(string) --*

    - **OutputGroupDetails** *(list) --* List of output group details

      - *(dict) --* Contains details about the output groups specified in the job settings.

        - **OutputDetails** *(list) --* Details about the output

          - *(dict) --* Details regarding output

            - **DurationInMs** *(integer) --* Duration in milliseconds

            - **VideoDetails** *(dict) --* Contains details about the output's video stream

              - **HeightInPx** *(integer) --* Height in pixels for the output

              - **WidthInPx** *(integer) --* Width in pixels for the output

    - **Priority** *(integer) --* Relative priority on the job.

    - **Queue** *(string) --* Optional. When you create a job, you can specify a queue to send it
    to. If you don't specify, the job will go to the default queue. For more about queues, see the
    User Guide topic at http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

    - **RetryCount** *(integer) --* The number of times that the service automatically attempted to
    process your job after encountering an error.

    - **Role** *(string) --* The IAM role you use for creating this job. For details about
    permissions, see the User Guide topic at the User Guide at
    http://docs.aws.amazon.com/mediaconvert/latest/ug/iam-role.html

    - **Settings** *(dict) --* JobSettings contains all the transcode settings for a job.

      - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
      the input Ad Avail PTS time.

      - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
      overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

        - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
        black. Only bmp and png images are supported.

      - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

        - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
        ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
        uses the manifest conditioning instructions that you provide in the setting MCC XML
        (mccXml).

          - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
          document inside your JSON job settings. Form the XML document as per
          OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions
          in the message that you supply.

        - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
        between the SCTE 35 messages that the transcoder places and the splice points that they
        refer to. If the time between the start of the asset and the SCTE-35 message is less than
        this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

        - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
        SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
        signal processing instructions that you provide in the setting SCC XML (sccXml).

          - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
          inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
          transcoder will use the signal processing instructions in the message that you supply.
          Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
          For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
          insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
          (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
          passthrough. You can't do both.

      - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode job.
      There can be multiple inputs add in a job. These inputs will be concantenated together to
      create the output.

        - *(dict) --* Specifies media input

          - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
          combine. An input may have multiple audio selector groups. See "Audio Selector
          Group":#inputs-audio_selector_group for more information.

            - *(string) --*

              - *(dict) --* Group of Audio Selectors

                - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
                to include in the group. Audio selector names are standardized, based on their order
                within the input (e.g., "Audio Selector 1"). The audio selector name parameter can
                be repeated to add any number of audio selectors to the group.

                  - *(string) --*

          - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
          or set of tracks from the input that you will use in your outputs. You can use mutiple
          Audio selectors per input.

            - *(string) --*

              - *(dict) --* Selector for Audio

                - **CustomLanguageCode** *(string) --* Selects a specific language code from within
                an audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                set it as the default for the job. The service uses this default for outputs where
                it can't find the specified input audio. If you don't set a default, those outputs
                have no audio.

                - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                file source.

                - **LanguageCode** *(string) --* Selects a specific language code from within an
                audio source.

                - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                audio from the input video.

                - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
                selects PID 0x101).

                  - *(integer) --*

                - **ProgramSelection** *(integer) --* Use this setting for input streams that
                contain Dolby E, to have the service extract specific program data from the track.
                To select multiple programs, create multiple selectors with the same Track and
                different Program numbers. In the console, this setting is visible when you set
                Selector type to Track. Choose the program number from the dropdown list. If you are
                sending a JSON file, provide the program ID, which is part of the audio metadata. If
                your input file has incorrect metadata, you can choose All channels instead of a
                program number to have the service ignore the program IDs and include all the
                programs in the track.

                - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
                one input to match those of another input. This allows you to combine the two files
                into a single output, one after the other.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **SelectorType** *(string) --* Specifies the type of the audio selector.

                - **Tracks** *(list) --* Identify a track from the input audio to include in this
                selector by entering the track index number. To include several tracks in a single
                audio selector, specify multiple tracks as follows. Using the console, enter a
                comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                Specifying directly in your JSON job file, provide the track numbers in an array.
                For example, "tracks": [1,2,3].

                  - *(integer) --*

          - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
          the captions data from the input that you will use in your outputs. You can use mutiple
          captions selectors per input.

            - *(string) --*

              - *(dict) --* Set up captions in your outputs by first selecting them from your input
              here.

                - **CustomLanguageCode** *(string) --* The specific language to extract from source,
                using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
                complete this field and/or PID to select the caption language to extract. If input
                is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
                select the caption language to extract. If input is DVB-Sub that is being passed
                through, omit this field (and PID field); there is no way to extract a specific
                language with pass-through captions.

                - **LanguageCode** *(string) --* The specific language to extract from source. If
                input is SCTE-27, complete this field and/or PID to select the caption language to
                extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
                and/or PID to select the caption language to extract. If input is DVB-Sub that is
                being passed through, omit this field (and PID field); there is no way to extract a
                specific language with pass-through captions.

                - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                    number in the ancillary data track from which to extract captions. Unused for
                    passthrough.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                    PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content
                    is passed through, regardless of selectors.

                  - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                    within the video track from which to extract captions. Unused for passthrough.

                    - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                    for extracting captions. The system only supports one input video track, so this
                    should always be set to '1'.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                  STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source
                  file. If your caption source is IMSC in an IMF package, use TrackSourceSettings
                  instead of FileSoureSettings.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceFile** *(string) --* External caption file used for loading captions.
                    Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                    'smi'.

                    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                    captions from the source file.

                  - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                  your input captions. The service cannot auto-detect caption format.

                  - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                  sources, including Page number.

                    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                    three-digit hexadecimal page number that will be used for Teletext captions. Do
                    not use this setting if you are passing through teletext from the input source
                    to output.

                  - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                  are specified by track number. Currently, this is only IMSC captions in an IMF
                  package. If your caption source is IMSC 1.1 in a separate xml file, use
                  FileSourceSettings instead of TrackSourceSettings.

                    - **TrackNumber** *(integer) --* Use this setting to select a single captions
                    track from a source. Track numbers correspond to the order in the captions
                    source file. For IMF sources, track numbering is based on the order that the
                    captions appear in the CPL. For example, use 1 to select the captions asset that
                    is listed first in the CPL. To include more than one captions track in your job
                    outputs, create multiple input captions selectors. Specify one track per
                    selector.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame. If you specify a value here, it will
          override any value that you specify in the output setting Cropping selection (crop).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
          motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
          uncompressed video inputs.

          - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
          encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when you
          use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt your
          content.

            - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt
            your input files.

            - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
            plaintext. Your job settings could be intercepted, making your encrypted content
            vulnerable. Specify the encrypted version of the data key that you used to encrypt your
            content. The data key must be encrypted by AWS Key Management Service (KMS). The key can
            be 128, 192, or 256 bits.

            - **InitializationVector** *(string) --* Specify the initialization vector that you used
            when you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
            initialization vector with any encryption mode. Or, you can use a 12-byte initialization
            vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
            base64-encoded.

            - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
            (KMS) that you used to encrypt your data key, if that Region is different from the one
            you are using for AWS Elemental MediaConvert.

          - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
          the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
          video inputs.

          - **FileInput** *(string) --* Specify the source file for your transcoding job. You can
          use multiple inputs in a single job. The service concatenates these inputs, in the order
          that you specify them in the job, to create the outputs. If your input format is IMF,
          specify your input by providing the path to your CPL. For example,
          "s3://bucket/vf/cpl.xml". If the CPL is in an incomplete IMP, make sure to use
          *Supplemental IMPs* (SupplementalImps) to specify any supplemental IMPs that contain
          assets referenced by the CPL.

          - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
          transcoding service applies the denoise and deblock filters. You must also enable the
          filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
          Auto - The transcoding service determines whether to apply filtering, depending on input
          type and quality. * Disable - The input is not filtered. This is true even if you use the
          API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put
          is filtered regardless of input type.

          - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
          magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
          is 0.

          - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
          overlay on your video. Enable or disable this feature for each input individually. This
          setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
          that together specify a portion of the input to be used in the outputs. If you provide
          only a start time, the clip will be the entire input from that point to the end. If you
          provide only an end time, it will be the entire input up to that point. When you specify
          more than one input clip, the transcoding service creates the job outputs by stringing the
          clips together in the order you specify them.

            - *(dict) --* To transcode only portions of your input (clips), include one Input
            clipping (one instance of InputClipping in the JSON job file) for each input clip. All
            input clips you specify will be included in every output of the job.

              - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
              portion of the input you are clipping. The frame corresponding to the End timecode
              value is included in the clip. Start timecode or End timecode may be left blank, but
              not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
              minute, SS is the second, and FF is the frame number. When choosing this value, take
              into account your setting for timecode source under input settings
              (InputTimecodeSource). For example, if you have embedded timecodes that start at
              01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

              - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning
              of the portion of the input you are clipping. The frame corresponding to the Start
              timecode value is included in the clip. Start timecode or End timecode may be left
              blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour,
              MM is the minute, SS is the second, and FF is the frame number. When choosing this
              value, take into account your setting for Input timecode source. For example, if you
              have embedded timecodes that start at 01:00:00:00 and you want your clip to begin five
              minutes into the video, use 01:05:00:00.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black. If
          you specify a value here, it will override any value that you specify in the output
          setting Selection placement (position). If you specify a value here, this will override
          any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
          (RESPOND). If you specify a value here, this will ignore anything that you specify for the
          setting Scaling Behavior (scalingBehavior).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
          program from within a multi-program transport stream. Note that Quad 4K is not currently
          supported. Default is the first program within the transport stream. If the program you
          specify doesn't exist, the transcoding service will use this default.

          - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
          inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for
          audio and video. * Use PSI - Scan only PSI data.

          - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You
          need supplemental IMPs if the CPL that you're using for your input is in an incomplete
          IMP. Specify either the supplemental IMP directories with a trailing slash or the
          ASSETMAP.xml files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You
          don't need to specify the IMP that contains your input CPL, because the service
          automatically detects it.

            - *(string) --*

          - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
          input settings (InputTimecodeSource), to specify how the service counts input video
          frames. This input frame count affects only the behavior of features that apply to a
          single input at a time, such as input clipping and synchronizing some captions formats.
          Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at zero
          (ZEROBASED) to start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to
          start the first frame at the timecode that you specify in the setting Start timecode
          (timecodeStart). If you don't specify a value for Timecode source, the service will use
          Embedded by default. For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
          for this input's initial frame. To use this setting, you must set the Timecode source
          setting, located under the input settings (InputTimecodeSource), to Specified start
          (SPECIFIEDSTART). For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **VideoSelector** *(dict) --* Selector for video.

            - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
            animation. Specify which part of this input MediaConvert uses for your outputs. Leave
            this setting set to DISCARD in order to delete the alpha channel and preserve the video.
            Use REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the
            luma channel of your outputs.

            - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
            if you don't know about color space, leave this set to the default value Follow
            (FOLLOW). The service will automatically detect your input color space. If your input
            video has metadata indicating the wrong color space, specify the accurate color space
            here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume
            static metadata isn't present in your video stream, or if that metadata is present but
            not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the
            input HDR 10 metadata (Hdr10Metadata) settings. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
            file and the job input settings Color space (ColorSpace) and HDR master display
            information settings(Hdr10Metadata). The Color space usage setting determines which
            takes precedence. Choose Force (FORCE) to use color metadata from the input job
            settings. If you don't specify values for those settings, the service defaults to using
            metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata
            from the source when it is present. If there's no color metadata in your input file, the
            service defaults to using values you specify in the input settings.

            - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
            missing or inaccurate in your input video. Appropriate values vary depending on the
            input video and must be provided by a color grader. The color grader generates these
            values during the HDR 10 mastering process. The valid range for each of these settings
            is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
            settings - When you specify these values, you must also set Color space (ColorSpace) to
            HDR 10 (HDR10). To specify whether the the values you specify here take precedence over
            the values in the metadata of your input file, set Color space usage (ColorSpaceUsage).
            To specify whether color metadata is included in an output, set Color metadata
            (ColorMetadata). For more information about MediaConvert HDR jobs, see
            https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
            Specify this value as an integer; the system automatically converts it to the
            hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
            an identifier for a set of data in an MPEG-2 transport stream container.

            - **ProgramNumber** *(integer) --* Selects a specific program from within a
            multi-program transport stream. Note that Quad 4K is not currently supported.

            - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
            your video. You can choose automatic rotation or specify a rotation. You can specify a
            clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov
            or .mp4 and your input has rotation metadata, you can choose Automatic to have the
            service rotate your video according to the rotation specified in the metadata. The
            rotation must be within one degree of 90, 180, or 270 degrees. If the rotation metadata
            specifies any other rotation, the service will default to no rotation. By default, the
            service does no rotation, even if your input video has rotation metadata. The service
            doesn't pass through rotation metadata.

      - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
      graphics that you specify here appear on all outputs in all output groups.

        - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
        unspecified. If your motion graphic asset is a series of .png files, specify the frame rate
        of the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1.
        Make sure that the number of images in your series matches the frame rate and your intended
        overlay duration. For example, if you want a 30-second overlay at 30 fps, you should have
        900 .png images. This overlay frame rate doesn't need to match the frame rate of the
        underlying video.

          - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

          - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

        - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
        overlay on your video. For .png files, provide the file name of the first file in the
        series. Make sure that the names of the .png files end with sequential numbers that specify
        the order that they are played in. For example, overlay_000.png, overlay_001.png,
        overlay_002.png, and so on. The sequence must start at zero, and each image file name must
        have the same number of digits. Pad your initial file names with enough zeros to complete
        the sequence. For example, if the first image is overlay_0.png, there can be only 10 images
        in the sequence, with the last image being overlay_9.png. But if the first image is
        overlay_00.png, there can be 100 images in the sequence.

        - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
        providing for your overlay. You can choose either a .mov file or a series of .png files.

        - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay
        on the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
        specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
        the service inserts the overlay at its native resolution and scales the size up or down with
        any video scaling.

          - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
          edge of the video frame.

          - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
          edge of the video frame.

        - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
        or plays only once.

        - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
        (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
        account how you have set up your timecode configuration under both job settings and input
        settings. The simplest way to do that is to set both to start at 0. If you need to set up
        your job to follow timecodes embedded in your source that don't start at zero, make sure
        that you specify a start time that is after the first embedded timecode. For more
        information, see https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html
        Find job-wide and input timecode configuration settings in your JSON job settings
        specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

      - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
      do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
      configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs
      in the job. To enable Nielsen configuration programmatically, include an instance of
      nielsenConfiguration in your JSON job specification. Even if you don't include any children of
      nielsenConfiguration, you still enable the setting.

        - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
        functionality. If you must include this property, set the value to zero.

        - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
        distributor ID that is assigned to your organization by Neilsen.

      - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
      outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
      MXF, and no container) are grouped in a single output group as well. Required in
      (OutputGroups) is a group of settings that apply to the whole group. This required object
      depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
      settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
      HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
      MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

        - *(dict) --* Group of outputs

          - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
          the output group. This value is displayed on the console and can make your job settings
          JSON more human-readable. It does not affect your outputs. Use up to twelve characters
          that are either letters, numbers, spaces, or underscores.

          - **Name** *(string) --* Name of the output group

          - **OutputGroupSettings** *(dict) --* Output Group settings, including type

            - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
            Output Group may only contain a single video, audio, or caption output.

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
              your job. These default manifests reference every output in the output group. To
              create additional top-level manifests that reference a subset of the outputs in the
              output group, specify a list of them here. For each additional manifest that you
              specify, the service creates one HLS manifest and one DASH manifest.

                - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
                that you want the service to generate for this CMAF output group. Each pair of
                manifests can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
              at the top level BaseURL element. Can be used if streams are delivered from a
              different URL than the manifest file.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
                service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                (SAMPLE-AES) or AES_CTR (AES-CTR).

                - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                outputs, choose whether the service writes the 128-bit encryption initialization
                vector in the HLS and DASH manifests.

                - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                  signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                  package. The DASH manifest can currently signal up to three system IDs. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                  signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                  package. The HLS manifest can currently signal only one system ID. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
              of each individual CMAF segment. This value applies to the whole package; that is, to
              every output in the output group. Note that segments end on the first keyframe after
              this number of seconds, so the actual segment length might be slightly longer. If you
              set Segment control (CmafSegmentControl) to single file, the service puts the content
              of each output in a single file that has metadata that marks these segments. If you
              set it to segmented files, the service creates multiple files for each output, each
              with the content of one segment.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
              generated for this output.

              - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
              be generated for this output.

            - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
              manifest for each DASH ISO output group in your job. This default manifest references
              every output in the output group. To create additional DASH manifests that reference a
              subset of the outputs in the output group, specify a list of them here.

                - *(dict) --* Specify the details for each additional DASH manifest that you want
                the service to generate for this output group. Each manifest can reference a
                different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.mpd.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
              (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
              from a different URL than the manifest file.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                compatibility of your output with video players on obsolete devices. It applies only
                to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
                only to correct problems with playback on older devices. Otherwise, keep the default
                setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the
                service will exclude the access unit delimiter and will leave the SEI NAL units
                unencrypted.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
              that segments will end on the next keyframe after this number of seconds, so actual
              segment length may be longer. When Emit Single File is checked, the segmentation is
              internal to a single output file and it does not cause the creation of many output
              files as in other output types.

              - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
              the 400 range when you play back your DASH output, enable this setting and run your
              transcoding job again. When you enable this setting, the service writes precise
              segment durations in the DASH manifest. The segment duration information appears
              inside the SegmentTimeline element, inside SegmentTemplate at the Representation
              level. When you don't enable this setting, the service writes approximate segment
              durations in your DASH manifest.

            - **FileGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

            - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

              - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
              HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
              outputs themselves.

                - *(string) --*

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest for each HLS output group in your job. This default manifest
              references every output in the output group. To create additional top-level manifests
              that reference a subset of the outputs in the output group, specify a list of them
              here.

                - *(dict) --* Specify the details for each additional HLS manifest that you want the
                service to generate for this output group. Each manifest can reference a different
                subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
              in the media .m3u8 file. Can be used if base manifest is delivered from a different
              URL than the main .m3u8 file.

              - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                - *(dict) --* Caption Language Mapping

                  - **CaptionChannel** *(integer) --* Caption channel.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                  - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                  three-letter code listed at
                  https://www.loc.gov/standards/iso639-2/php/code_list.php.

                  - **LanguageDescription** *(string) --* Caption language description.

              - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
              captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one
              language in the CC1 Language Code field. One CLOSED-CAPTION line is added for each
              Language Code you specify. Make sure to specify the languages in the order in which
              they appear in the original source (if the source is embedded format) or the order of
              the caption selectors (if the source is other than embedded). Otherwise, languages in
              the manifest will not match up properly with the output captions. None: Include
              CLOSED-CAPTIONS=
                  NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from
              the manifest.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
              subdirectories.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
                scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
                disables encryption.

                - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                128-bit number used in conjunction with the key for encrypting blocks. If set to
                INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                Vector is not in the manifest.

                - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                HLS FairPlay content protection.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
              looking ahead and back within the specified range for a nearby avail and extending the
              segment size if needed.

              - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
              be generated for this HLS output group.

              - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
              in .m3u8 manifest files. The value is calculated as follows: either the program date
              and time are initialized using the input timecode source, or the time is initialized
              using the input timecode source and the date is initialized using the
              timestamp_offset.

              - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
              EXT-X-PROGRAM-DATE-TIME entry, in seconds.

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
              media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

              - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
              create (in seconds). Note that segments will end on the next keyframe after this
              number of seconds, so actual segment length may be longer.

              - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
              subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
              for this setting to have an effect.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

              - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

              - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
              offset to fine tune the timestamps.

            - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .ism
              Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
              in your job. This default manifest references every output in the output group. To
              create additional manifests that reference a subset of the outputs in the output
              group, specify a list of them here.

                - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                manifest that you want the service to generate for this output group. Each manifest
                can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                  "-no-premium" for this setting, then the file name the service generates for this
                  top-level manifest is film-name-no-premium.ismv.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
              audio encoding settings across a Microsoft Smooth output group into a single audio
              stream.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* If you are using DRM, set DRM System
              (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
              the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
              and frame rate.

              - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding)
              to specify the encoding format for the server and client manifest. Valid options are
              utf8 and utf16.

            - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
            Microsoft Smooth Streaming, CMAF)

          - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
          settings per output.

            - *(dict) --* An output object describes the settings for a single output file or stream
            in an output group.

              - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
              encoding settings organized by audio codec. Include one instance of
              (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
              encoding settings.

                - *(dict) --* Description of audio output

                  - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                  settings. Ignore these settings unless you need to comply with a loudness
                  standard.

                    - **Algorithm** *(string) --* Choose one of the following audio normalization
                    algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                    loudness for an entire piece of content, suitable for measurement of short-form
                    content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-2: Gated loudness. A measurement of gated average loudness compliant
                    with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
                    with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
                    Allows for more audio channels than the other algorithms, including
                    configurations such as 7.1.

                    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                    using the chosen algorithm. If disabled, the audio will be measured but not
                    adjusted.

                    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                    be corrected to the target level. Content measuring below this level will not be
                    corrected. Gating only applies when not using real_time_correction.

                    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                    loudness to a CSV file.

                    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                    TruePeak for each output's audio track loudness.

                    - **TargetLkfs** *(float) --* When you use Audio normalization
                    (AudioNormalizationSettings), optionally use this setting to specify a target
                    loudness. If you don't specify a value here, the encoder chooses a value for
                    you, based on the algorithm that you choose for Algorithm (algorithm). If you
                    choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                    encoder will choose -23 LKFS.

                  - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                  input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                  name based on its order within each input. For example if you specify "Audio
                  Selector 3", then the third audio selector will be used from each input. If an
                  input does not have an "Audio Selector 3", then the audio selector marked as
                  "default" in that input will be used. If there is no audio selector marked as
                  "default", silence will be inserted for the duration of that input. Alternatively,
                  an "Audio Selector Group":#inputs-audio_selector_group name may be specified, with
                  similar default/silence behavior. If no audio_source_name is specified, then
                  "Audio Selector 1" will be chosen automatically.

                  - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                  unchecked (false). A number between 0 and 255. The following are defined in
                  ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                       Hearing Impaired, 3 =
                  Visually Impaired Commentary, 4-255 = Reserved.

                  - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                  contains an ISO 639 audio_type, then that value is passed through to the output.
                  If the input contains no ISO 639 audio_type, the value in Audio Type is included
                  in the output. Otherwise the value in Audio Type is included in the output. Note
                  that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                  is set to BROADCASTER_MIXED_AD.

                  - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                  (AudioDescriptions) contains the group of settings related to audio encoding. The
                  settings in this group vary depending on the value that you choose for Audio codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * AAC,
                  AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                  Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                    - **AacSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                    two mutually exclusive groups of AAC settings--VBR and CBR. To select one of
                    these modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or
                    "CBR". In VBR mode, you control the audio quality with the setting VBR quality
                    (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                    valid values depend on the rate control mode.

                      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                      when the input contains pre-mixed main audio + audio description (AD) as a
                      stereo pair. The value for AudioType will be set to 3, which signals to
                      downstream systems that this stream contains "broadcaster mixed AD". Note that
                      the input received by the encoder must contain pre-mixed audio; the encoder
                      does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                      ignores any values you provide in AudioType and FollowInputAudioType. Choose
                      NORMAL when the input does not contain pre-mixed audio + audio description
                      (AD). In this case, the encoder will use any values you provide for AudioType
                      and FollowInputAudioType.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      The set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000,
                      16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000,
                      112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000,
                      448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you set is
                      also constrained by the values that you choose for Profile (codecProfile),
                      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
                      values depend on Bitrate control mode and Profile.

                      - **CodecProfile** *(string) --* AAC Profile.

                      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                      channel layout. Valid values depend on rate control mode and profile. "1.0 -
                      Audio Description (Receiver Mix)" setting receives a stereo description plus
                      control track and emits a mono AAC encode of the description track, with
                      control data emitted in the PES header as per ETSI TS 101 154 Annex E.

                      - **RateControlMode** *(string) --* Rate Control Mode.

                      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                      use LATM/LOAS AAC in an output, you must choose "No container" for the output
                      container.

                      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                      control mode and profile.

                      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                      for raw or MPEG-2 Transport Stream containers.

                      - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                      rate_control_mode is VBR.

                    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AC3.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                      stream that the encoder emits. For more information about the AC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital, dialnorm will be passed through.

                      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                      adds dynamic range compression signaling to the output bitstream as defined in
                      the Dolby Digital specification.

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                    - **AiffSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AIFF.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **Codec** *(string) --* Type of Audio codec.

                    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid values: 384k, 448k, 640k, 768k

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                      (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                      adjust loudness based on dialogue analysis.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                      this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix
                      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                      value -60 mutes the channel.

                      - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                      your audio.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                      that must be speech before the encoder uses the measured speech loudness as
                      the overall program loudness.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing.

                      - **SurroundExMode** *(string) --* Specify whether your input audio has an
                      additional center rear surround channel matrix encoded into your left and
                      right surround channels.

                    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3.

                      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                      dB attenuation to the surround channels. Only used for 3/2 coding mode.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                      number of channels.

                      - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital Plus, dialnorm will be passed through.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                      LFE channel is enabled

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left only/Right only center (loRoCenterMixLevel).

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                      channel. This setting applies only if you keep the default value of 3/2 - L,
                      R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                      If you choose a different value for Coding mode, the service ignores Left
                      only/Right only surround (loRoSurroundMixLevel).

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total center (ltRtCenterMixLevel).

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                      surround). MediaConvert uses this value for downmixing. How the service uses
                      this value depends on the value that you choose for Stereo downmix
                      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
                      -60 mutes the channel. This setting applies only if you keep the default value
                      of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total surround (ltRtSurroundMixLevel).

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                      audio will be passed through if it is present on the input. this detection is
                      dynamic over the life of the transcode. Inputs that alternate between DD+ and
                      non-DD+ content will have a consistent DD+ output as the system alternates
                      between passthrough and encoding.

                      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                      the surround channels. Only used for 3/2 coding mode.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing. This setting only applies if you keep the default value of 3/2 -
                      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Stereo downmix (Eac3StereoDownmix).

                      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                      extra center back surround channel is matrix encoded into the left and right
                      surround channels.

                      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                      Surround is matrix encoded into the two channels.

                    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value MP2.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                      - **Channels** *(integer) --* Set Channels to specify the number of channels
                      in this output audio track. Choosing Mono in the console will give you 1
                      output channel; choosing Stereo will give you 2. In the API, valid values are
                      1 and 2.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **WavSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value WAV.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                      If your output audio is likely to exceed 4 GB in file size, or if you
                      otherwise need the extended support of the RF64 format, set your output WAV
                      file format to RF64.

                      - **SampleRate** *(integer) --* Sample rate in Hz.

                  - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                  track. The service puts this language code into your output audio track when you
                  set Language code control (AudioLanguageCodeControl) to Use configured
                  (USE_CONFIGURED). The service also uses your specified custom language code when
                  you set Language code control (AudioLanguageCodeControl) to Follow input
                  (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                  outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                  can also use any other code in the full RFC-5646 specification. Streaming outputs
                  are those that are in one of the following output groups: CMAF, DASH ISO, Apple
                  HLS, or Microsoft Smooth Streaming.

                  - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                  The ISO 639 language specified in the 'Language Code' drop down will be used when
                  'Follow Input Language Code' is not selected or when 'Follow Input Language Code'
                  is selected but there is no ISO 639 language code specified by the input.

                  - **LanguageCodeControl** *(string) --* Specify which source for language code
                  takes precedence for this audio track. When you choose Follow input
                  (FOLLOW_INPUT), the service uses the language code from the input track if it's
                  present. If there's no languge code on the input track, the service uses the code
                  that you specify in the setting Language code (languageCode or
                  customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service
                  uses the language code that you specify.

                  - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **StreamName** *(string) --* Specify a label for this output audio stream. For
                  example, "English", "Director commentary", or "track_2". For streaming outputs,
                  MediaConvert passes this information into destination manifests for display on the
                  end-viewer's player device. For outputs in other output groups, the service
                  ignores this setting.

              - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
              captions settings. For each output that has captions, include one instance of
              (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
              settings.

                - *(dict) --* Description of Caption output

                  - **CaptionSelectorName** *(string) --* Specifies which "Caption
                  Selector":#inputs-caption_selector to use from each input when generating
                  captions. The name should be of the format "Caption Selector ", which denotes that
                  the Nth Caption Selector will be used from each input.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  output track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information when automatically
                  selecting the font script for rendering the captions text. For all outputs, you
                  can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
                  any other code in the full RFC-5646 specification. Streaming outputs are those
                  that are in one of the following output groups: CMAF, DASH ISO, Apple HLS, or
                  Microsoft Smooth Streaming.

                  - **DestinationSettings** *(dict) --* Specific settings required by destination
                  type. Note that burnin_destination_settings are not available if the source of the
                  caption data is Embedded or Teletext.

                    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering burn-in captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **DestinationType** *(string) --* Specify the format for this set of captions
                    on this output. The default format is embedded without SCTE-20. Other options
                    are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                    web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                    (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec.
                    To create a non-compliant output where the embedded captions come first, choose
                    Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering DVB-Sub captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                      standard or for hearing impaired. Choose hearing impaired if your subtitles
                      include audio descriptions and dialogue. Choose standard if your subtitles
                      include only dialogue.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                    embedded/ancillary caption outputs, including 608/708 Channel destination
                    number.

                      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and your output captions are embedded in
                      the video stream. Specify a CC number for each captions channel in this
                      output. If you have two channels, choose CC numbers that aren't in the same
                      field. For example, choose 1 and 3. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and you want both 608 and 708 captions
                      embedded in your output stream. Optionally, specify the 708 service number for
                      each output captions channel. Choose a different number for each channel. To
                      use this setting, also set Force 608 to 708 upconvert (Convert608To708) to
                      Upconvert (UPCONVERT) in your input captions selector settings. If you choose
                      to upconvert but don't specify a 708 service number, MediaConvert uses the
                      number that you specify for CC channel number (destination608ChannelNumber)
                      for the 708 service number. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                    outputs.

                      - **StylePassthrough** *(string) --* Keep this setting enabled to have
                      MediaConvert use the font style and position information from the captions
                      source in the output. This option is available only when your input captions
                      are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                      output captions.

                    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                      sure that the captions and the video are synchronized in the output. Specify a
                      frame rate that matches the frame rate of the associated video. If the video
                      frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only
                      if the video has video_insertion=
                          true and drop_frame_timecode=true; otherwise,
                      choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                    output

                      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                      the destination captions for this output. This value must be a three-digit
                      hexadecimal string; strings ending in -FF are invalid. If you are passing
                      through the entire set of Teletext data, do not use this field.

                      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                      you don't specify a value here, the service sets the page type to the default
                      value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                      Teletext data, don't use this field. When you pass through a set of Teletext
                      pages, your output has the same page types as your input.

                        - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                        Table 94

                    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                    outputs, including Pass style information (TtmlStylePassthrough).

                      - **StylePassthrough** *(string) --* Pass through style and position
                      information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                      CFF-TT output or TTML output.

                  - **LanguageCode** *(string) --* Specify the language of this captions output
                  track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information to choose the font
                  language for rendering the captions text.

                  - **LanguageDescription** *(string) --* Specify a label for this set of output
                  captions. For example, "English", "Director commentary", or "track_2". For
                  streaming outputs, MediaConvert passes this information into destination manifests
                  for display on the end-viewer's player device. For outputs in other output groups,
                  the service ignores this setting.

              - **ContainerSettings** *(dict) --* Container specific settings.

                - **Container** *(string) --* Container for this output. Some containers require a
                container settings object. If not specified, the default object will be created.

                - **F4vSettings** *(dict) --* Settings for F4v container

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs
                in a File output group when the output's container (ContainerType) is MPEG-2
                Transport Stream (M2TS). In these assets, data is organized by the program map table
                (PMT). Each transport stream program contains subsets of data, including audio,
                video, and metadata. Each of these subsets of data has a numerical label called a
                packet identifier (PID). Each transport stream program corresponds to one
                MediaConvert output. The PMT lists the types of data in a program along with their
                PID. Downstream systems and players use the program map table to look up the PID for
                each type of data it accesses and then uses the PIDs to locate specific data within
                the asset.

                  - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                  models for Dolby Digital audio.

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                  elementary audio streams you include in this output. Specify multiple PIDs as a
                  JSON array. Default is the range 482-492.

                    - *(integer) --*

                  - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                  bits per second. Setting to 0 lets the muxer automatically determine the
                  appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                  - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                  interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                  this can lead to lower latency, but low-memory devices may not be able to play
                  back the stream without interruptions.

                  - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                  the specified table repetition interval.

                    - **NetworkId** *(integer) --* The numeric value placed in the Network
                    Information Table (NIT).

                    - **NetworkName** *(string) --* The network name text placed in the
                    network_name_descriptor inside the Network Information Table. Maximum length is
                    256 characters.

                    - **NitInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                  the specified table repetition interval.

                    - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                    output stream. "Follow input SDT" copies SDT information from input stream to
                    output stream. "Follow input SDT if present" copies SDT information from input
                    stream to output stream if SDT information is present in the input, otherwise it
                    will fall back on the user-defined values. Enter "SDT Manually" means user will
                    enter the SDT information. "No SDT" means output stream will not contain SDT
                    information.

                    - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **ServiceName** *(string) --* The service name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                    - **ServiceProviderName** *(string) --* The service provider name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                  - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                  subtitle data included in this output. Specify multiple PIDs as a JSON array.
                  Default is the range 460-479.

                    - *(integer) --*

                  - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                  specified table repetition interval.

                    - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                  teletext data you include in this output. Default is 499.

                  - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                  EBP markers will be added to partitions 3 and 4. The interval between these
                  additional markers will be fixed, and will be slightly shorter than the video EBP
                  marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                  inserted. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                  can either be placed only on the video PID, or on both the video PID and all audio
                  PIDs. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                  the PES header.

                  - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                  you know that your audio EBP markers are incorrectly appearing before your video
                  EBP markers. To correct this problem, set this value to Force (FORCE).

                  - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                  used with EBP markers.

                  - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                  between Program Clock References (PCRs) inserted into the transport stream.

                  - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                  Points do not come within the specified time interval of each other by looking
                  ahead at input video. If another EBP is going to come in within the specified time
                  interval, the current EBP is not emitted, and the segment is "stretched" to the
                  next marker. The lookahead value does not add latency to the system. The Live
                  Event must be configured elsewhere to create sufficient latency to make the
                  lookahead accurate.

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                  packets to insert into the transport stream. This can be used if a downstream
                  encryption system requires periodic null packets.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This is effective only when the PCR PID is the same as the video or audio
                  elementary stream.

                  - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                  clock reference (PCR) in this output. If you do not specify a value, the service
                  will use the value for Video PID (VideoPid).

                  - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                  instances of the program map table (PMT) in the output transport stream.

                  - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                  map table (PMT) itself. Default is 480.

                  - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                  private metadata stream. Default is 503.

                  - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                  the program number used in the program map table (PMT) for this output. Default is
                  1. Program numbers and program map tables are parts of MPEG-2 transport stream
                  containers, used for organizing data.

                  - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                  stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                  maximum bitrate, but the output will not be padded up to that bitrate.

                  - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                  markers in your HLS and transport stream outputs at the insertion points that you
                  specify in an ESAM XML document. Provide the document in the setting SCC XML
                  (sccXml).

                    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                    in the transport stream generated by ESAM.

                  - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                  stream in the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None
                  (NONE). Also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml). Also enable ESAM SCTE-35 (include the property
                  scte35Esam).

                  - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                  segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                  adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                  private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                  segments. ebp adds Encoder Boundary Point information to the adaptation field as
                  per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary
                  Point information to the adaptation field using a legacy proprietary format.

                  - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                  how segmentation markers are inserted into the transport stream. With avails, it
                  is possible that segments may be truncated, which can influence where future
                  segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                  selected and a segment is truncated due to an avail, we will reset the
                  segmentation cadence. This means the subsequent segment will have a duration of of
                  $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                  selected and a segment is truncated due to an avail, we will not reset the
                  segmentation cadence. This means the subsequent segment will likely be truncated
                  as well. However, all segments after that will have a duration of
                  $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
                  rule.

                  - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                  segment. Required unless markers is set to _none_.

                  - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                  timed metadata in this output. Default is 502.

                  - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                  itself in the program map table for this output. Transport stream IDs and program
                  map tables are parts of MPEG-2 transport stream containers, used for organizing
                  data.

                  - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                  elementary video stream in the transport stream.

                - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                  stream(s) in the transport stream. Multiple values are accepted, and can be
                  entered in ranges and/or by comma separation.

                    - *(integer) --*

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This parameter is effective only when the PCR PID is the same as the video or
                  audio elementary stream.

                  - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                  (PCR) in the transport stream. When no value is given, the encoder will assign the
                  same value as the Video PID.

                  - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                  (PMT) in the transport stream.

                  - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                  metadata stream in the transport stream.

                  - **ProgramNumber** *(integer) --* The value of the program number field in the
                  Program Map Table.

                  - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                  the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE)
                  if you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and
                  choose Ad markers (adMarkers) if you do want manifest conditioning. In both cases,
                  also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml).

                  - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                  specify whether the service inserts the ID3 timed metadata from the input in this
                  output.

                  - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                  metadata stream in the transport stream.

                  - **TransportStreamId** *(integer) --* The value of the transport stream ID field
                  in the Program Map Table.

                  - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                  stream in the transport stream.

                - **MovSettings** *(dict) --* Settings for MOV Container.

                  - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                  the video output settings.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                  streams into the QuickTime file using XDCAM fourcc codes. This increases
                  compatibility with Apple editors and players, but may decrease compatibility with
                  other players. Only applicable when the video codec is MPEG2.

                  - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                  padding

                  - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                  this setting.

                - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
                AAC outputs with this container.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                  moov box.

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                  - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                  file. Usually not necessary to specify.

                - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                  - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                  groups that include sidecar TTML or IMSC captions. You specify sidecar captions in
                  a separate output from your audio and video. Choose Raw (RAW) for captions in a
                  single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for
                  captions in XML format contained within fragmented MP4 files. This set of
                  fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                  - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                  markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                  insertion points that you specify in an ESAM XML document. Provide the document in
                  the setting SCC XML (sccXml).

                  - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                  markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                  SCTE-35 markers that appear in your input to also appear in this output. Choose
                  None (NONE) if you don't want those SCTE-35 markers in this output.

              - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
              for outputs in File output groups. If you do not specify a value, the service will use
              default extensions by container type as follows * MPEG-2 transport stream, m2ts *
              Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the
              service will use codec extensions (e.g. AAC, H265, H265, AC3)

              - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
              add a string to the end of each output filename. You specify the base filename as part
              of your destination URI. When you create multiple outputs in the same output group,
              Name modifier (NameModifier) is required. Name modifier also accepts format
              identifiers. For DASH ISO outputs, if you use the format identifiers $Number$ or
              $Time$ in one output, you must use them in the same way in all outputs of the output
              group.

              - **OutputSettings** *(dict) --* Specific settings for this type of output.

                - **HlsSettings** *(dict) --* Settings for HLS output groups

                  - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                  belongs.

                  - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                  outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                  container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                  file in a raw container. Regardless of the value that you specify here, if this
                  output has video, the service will place the output into an MPEG2-TS container.

                  - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                  with the video output stream. Input all the audio GROUP-IDs that are associated to
                  the video, separate by ','.

                  - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                  Audio-Only Variant Stream The client can play back this audio-only stream instead
                  of video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                  manifest. Alternate Audio, Auto Select, Default Alternate rendition that the
                  client should try to play back by default. Represented as an EXT-X-MEDIA in the
                  HLS manifest with DEFAULT=YES, AUTOSELECT=
                      YES Alternate Audio, Auto Select, Not
                  Default Alternate rendition that the client may try to play back by default.
                  Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                      NO, AUTOSELECT=YES
                  Alternate Audio, not Auto Select Alternate rendition that the client will not try
                  to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
                  DEFAULT=NO, AUTOSELECT=NO

                  - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                  Manifest in addition to the HLS manifest

                  - **SegmentModifier** *(string) --* String concatenated to end of segment
                  filenames. Accepts "Format Identifiers":#format_identifier_parameters.

              - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
              transcoding settings. Provide the system or custom preset name. You can specify either
              Preset (Preset) or Container settings (ContainerSettings), but not both.

              - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
              encoding settings. The specific video settings depend on the video codec that you
              choose when you specify a value for Video codec (codec). Include one instance of
              (VideoDescription) per output.

                - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                service includes AFD values in the output video data and what those values are. *
                Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                input AFD values and instead encode the value specified in the job. * Choose Auto to
                calculate output AFD values based on the input AFD scaler data.

                - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
                outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
                specify that in your job, the service will ignore the setting.

                - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                (VideoDescription), contains the group of settings related to video encoding. The
                settings in this group vary depending on the value that you choose for Video codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * H_264,
                H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
                FRAME_CAPTURE, FrameCaptureSettings

                  - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                  the enum values defined by the object VideoCodec.

                  - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                    - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.n.jpg where n is the 0-based sequence number of each Capture.

                    - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
                    to 7 decimal places.

                    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                    files).

                    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                    quality.

                  - **H264Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value H_264.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                    your output video settings. If you aren't sure what level to specify, choose
                    Auto (AUTO).

                    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                    are only available with the AVC-I License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                    Main or High profile) or CAVLC.

                    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                    for interlaced outputs.

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job specification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* When you use the API for transcode
                    jobs that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateDenominator to specify the
                    denominator of this fraction. In this example, use 1001 for the value of
                    FramerateDenominator. When you use the console for transcode jobs that use frame
                    rate conversion, provide the value as a decimal number for Framerate. In this
                    example, specify 23.976.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type, as follows. - If the source is interlaced, the output will be interlaced
                    with the same polarity as the source (it will follow the source). The output
                    could therefore be a mix of "top field first" and "bottom field first". - If the
                    source is progressive, the output will be interlaced with "top field first" or
                    "bottom field first" polarity, depending on which of the Follow options you
                    chose.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even
                    if repeated.

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                  - **H265Settings** *(dict) --* Settings for H265 codec

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                    Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                    Transfer Function (EOTF).

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* H.265 Level.

                    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                    (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                    "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                    available with the HEVC 4:2:2 License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                    Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                    the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field
                    First (BOTTOM_FIELD) to create an output that's interlaced with the same field
                    polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow,
                    Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the
                    same field polarity as the source. If the source is interlaced, the output will
                    be interlaced with the same polarity as the source (it will follow the source).
                    The output could therefore be a mix of "top field first" and "bottom field
                    first". If the source is progressive, your output will be interlaced with "top
                    field first" or "bottom field first" polarity, depending on which of the Follow
                    options you chose. If you don't choose a value, the service will default to
                    Progressive (PROGRESSIVE).

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                    Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                    based on content

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                    encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                    and P-frames form one layer, reference B-frames can form a second layer and
                    non-reference b-frames can form a third layer. Decoders can optionally decode
                    only the lower temporal layers to generate a lower frame rate output. For
                    example, given a bitstream with temporal IDs and with b-frames =
                         1 (i.e. IbPbPb
                    display order), a decoder could decode all the frames for full frame rate output
                    or only the I and P frames (lowest temporal layer) for a half frame rate output.

                    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                    vertical subdivision of the encoded pictures.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                    units doesn't matter in your workflow, ignore this setting. Use this setting
                    only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                    container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                    your output compliant with the following specification: ISO IECJTC1 SC29 N13798
                    Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
                    parameter set NAL units in the sample headers but not in the samples directly.
                    For MP4 outputs, when you choose HVC1, your output video might not work properly
                    with some downstream systems and video players. The service defaults to marking
                    your output as HEV1. For these outputs, the service writes parameter set NAL
                    units directly into the samples.

                  - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value MPEG2.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                    level for the video output.

                    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                    MPEG-2 profile for the video output.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **IntraDcPrecision** *(string) --* Use Intra DC precision
                    (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                    coefficients. If you choose the value auto, the service will automatically
                    select the precision based on the per-frame compression ratio.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                    video encoding.

                    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                    to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                    356M-2001).

                    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                  - **ProresSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value PRORES.

                    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                    the type of Apple ProRes codec to use for this output.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                    that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateNumerator to specify the
                    numerator of this fraction. In this example, use 24000 for the value of
                    FramerateNumerator.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                    determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                    to use the pixel aspect ratio from the input. To specify a different pixel
                    aspect ratio: Using the console, choose it from the dropdown menu. Using the
                    API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                    (ParDenominator).

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
                color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
                this output. If you don't specify a value, the service sets this to Insert by
                default.

                - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
                the service will include in the output video frame.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                feature is enabled, the service will use drop-frame timecode on outputs. If it is
                not possible to use drop-frame timecode, the system will fall back to
                non-drop-frame. This setting is enabled by default when Timecode insertion
                (TimecodeInsertion) is enabled.

                - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
                Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                service will write on all frames of this video output.

                - **Height** *(integer) --* Use the Height (Height) setting to define the video
                resolution height for this output. Specify in pixels. If you don't provide a value
                here, the service will use the input height.

                - **Position** *(dict) --* Use Selection placement (position) to define the video
                area in your output frame. The area outside of the rectangle that you specify here
                is black.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                the service changes the video itself in response to AFD values in the input. *
                Choose Respond to clip the input video frame according to the AFD value, input
                display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                include the input AFD values. Do not choose this when AfdSignaling is set to (NONE).
                A preferred implementation of this workflow is to set RespondToAfd to (NONE) and set
                AfdSignaling to (AUTO). * Choose None to remove all input AFD values from this
                output.

                - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                have a different aspect ratio from the input aspect ratio. Choose Stretch to output
                (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
                setting Default (DEFAULT) to have the service letterbox your video instead. This
                setting overrides any value that you specify for the setting Selection placement
                (position) in this output.

                - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                strength of anti-aliasing. This setting changes the width of the anti-alias filter
                kernel used for scaling. Sharpness only applies if your output resolution is
                different from your input resolution. 0 is the softest setting, 100 the sharpest,
                and 50 recommended for most content.

                - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                ProRes outputs. Only enable Timecode insertion when the input frame rate is
                identical to the output frame rate. To include timecodes in this output, set
                Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                output, by default, it uses any embedded timecodes from the input. If none are
                present, the service will set the timecode for the first output frame to zero. To
                change this default behavior, adjust the settings under Timecode configuration
                (TimecodeConfig). In the console, these settings are located under Job > Job
                settings > Timecode configuration. Note - Timecode source under input settings
                (InputTimecodeSource) does not affect the timecodes that are inserted in the output.
                Source under Job settings > Timecode configuration (TimecodeSource) does.

                - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                Preprocessors (VideoPreprocessors). Enable the features at each output individually.
                These features are disabled by default.

                  - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                  feature if necessary. Enable or disable this feature for each output individually.
                  This setting is disabled by default.

                    - **Brightness** *(integer) --* Brightness level.

                    - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                    this output. The service supports conversion between HDR formats, between SDR
                    formats, and from SDR to HDR. The service doesn't support conversion from HDR to
                    SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                    video has an HDR format, but visually appears the same as an unconverted output.

                    - **Contrast** *(integer) --* Contrast level.

                    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                    10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                    metadata that you want signaled in the output. These values don't affect the
                    pixel values that are encoded in the video stream. They are intended to help the
                    downstream video player display content in a way that reflects the intentions of
                    the the content creator. When you set Color space conversion
                    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                    must set values for Max frame average light level (maxFrameAverageLightLevel)
                    and Max content light level (maxContentLightLevel); these settings don't have a
                    default value. The default values for the other HDR 10 metadata settings are
                    defined by the P3D65 color space. For more information about MediaConvert HDR
                    jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                      samples in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                      any frame in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance
                      in units of of 0.0001 candelas per square meter.

                      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance
                      in units of of 0.0001 candelas per square meter

                      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                    - **Hue** *(integer) --* Hue in degrees.

                    - **Saturation** *(integer) --* Saturation level.

                  - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                  motion and a clearer picture.

                    - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                    (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                    adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                    (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if
                    your source file includes a ticker, such as a scrolling headline at the bottom
                    of the frame.

                    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                    does not convert frames that are tagged in metadata as progressive. It will only
                    convert those that are tagged as some other type. - When set to
                    FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                    those that are already tagged as progressive. Turn Force mode on only if there
                    is a good chance that the metadata has tagged frames as progressive when they
                    are not progressive. Do not turn on otherwise; processing frames that are
                    already progressive into progressive will probably result in lower quality
                    video.

                    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                    service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                    interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                    progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                  - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                  compatible video output.

                    - **L6Metadata** *(dict) --* Use these settings when you set
                    DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                    your input with new values.

                      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                      that corresponds to the brightest pixel in the entire stream. Measured in
                      nits.

                      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                      metadata that corresponds to the highest frame-average brightness in the
                      entire stream. Measured in nits.

                    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                    handle Dolby Vision MaxCLL and MaxFALL properies.

                    - **Profile** *(string) --* In the current MediaConvert implementation, the
                    Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must
                    contain Dolby Vision frame interleaved data.

                  - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature
                  to include a graphic overlay on your video. Enable or disable this feature for
                  each output individually. This setting is disabled by default.

                    - **InsertableImages** *(list) --* Specify the images that you want to overlay
                    on your video. The images must be PNG or TGA files.

                      - *(dict) --* Settings that specify how your still graphic overlay appears.

                        - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                        image to remain on the output video. This duration includes fade-in time but
                        not fade-out time.

                        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                        between the Start time that you specify for the image insertion and the time
                        that the image appears at full opacity. Full opacity is the level that you
                        specify for the opacity setting. If you don't specify a value for Fade-in,
                        the image will appear abruptly at the overlay start time.

                        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                        between the end of the time that you have specified for the image overlay
                        Duration and when the overlaid image has faded to total transparency. If you
                        don't specify a value for Fade-out, the image will disappear abruptly at the
                        end of the inserted image duration.

                        - **Height** *(integer) --* Specify the height of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        height, the service will crop your overlaid image to fit. To use the native
                        height of the image, keep this setting blank.

                        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                        location of the image that you want to overlay on the video. Use a PNG or
                        TGA file.

                        - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                        inserted image and the left edge of the video frame. Required for any image
                        overlay that you specify.

                        - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                        overlaid image and the top edge of the video frame. Required for any image
                        overlay that you specify.

                        - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                        Images with higher values for Layer appear on top of images with lower
                        values for Layer.

                        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                        the underlying video shows through the inserted image. 0 is transparent and
                        100 is fully opaque. Default is 50.

                        - **StartTime** *(string) --* Specify the timecode of the frame that you
                        want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                        or HH:MM:SS;FF) format. Remember to take into account your timecode source
                        settings.

                        - **Width** *(integer) --* Specify the width of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        width, the service will crop your overlaid image to fit. To use the native
                        width of the image, keep this setting blank.

                  - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                  remove noise from your video output if necessary. Enable or disable this feature
                  for each output individually. This setting is disabled by default.

                    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                    select one of the following spatial image filtering functions. To use this
                    setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                    preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                    Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                    reduction. * Spatial does frequency-domain filtering based on JND principles. *
                    Temporal optimizes video quality for complex motion.

                    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                    spatial filter.

                      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                      reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                      maximum strength.

                      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                      (higher speed), with 0 being the nominal value.

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                    temporal filter.

                      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                      complex motion. Higher values produce stronger temporal filtering. This
                      filters highly complex scenes more aggressively and creates better VQ for low
                      bitrate outputs.

                      - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                      Low setting reduces bit rate at the cost of transcode time, high setting
                      improves transcode time at the cost of bit rate.

                      - **Strength** *(integer) --* Specify the strength of the noise reducing
                      filter on this output. Higher values produce stronger filtering. We recommend
                      the following value ranges, depending on the result that you want: * 0-2 for
                      complexity reduction with minimal sharpness loss * 2-8 for complexity
                      reduction with image preservation * 8-16 for a high level of complexity
                      reduction

                  - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                  output timecode and specified prefix into the output.

                    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                    any burned-in timecode. Valid values are 10, 16, 32, 48.

                    - **Position** *(string) --* Use Position (Position) under under Timecode
                    burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                    output video.

                    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                    any burned-in timecode. For example, a prefix of "EZ-" will result in the
                    timecode "EZ-00:00:00:00". Provide either the characters themselves or the ASCII
                    code equivalents. The supported range of characters is 0x20 through 0x7e. This
                    includes letters, numbers, and all special characters represented on a standard
                    English keyboard.

                - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                in pixels, for this output. If you don't provide a value here, the service will use
                the input width.

      - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
      information from inputs.

        - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
        use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
        the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or
        (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
        Timecode varies depending on your setting for Source (TimecodeSource). * If Source
        (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
        specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
        (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start at
        0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
        Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
        input.

        - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
        within this job. To make sure that your video, audio, captions, and markers are synchronized
        and that time-based features, such as image inserter, work correctly, choose the Timecode
        source option that matches your assets. All timecodes are in a 24-hour format with frame
        number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video.
        If no embedded timecode is in the source, the service will use Start at 0 (ZEROBASED)
        instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. *
        Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other
        than zero. You use Start timecode (Start) to provide this value.

        - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
        (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
        Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

        - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
        stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
        affecting the time and frame number. Provide the new date as a string in the format
        "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
        (InsertProgramDateTime) in the output settings. For example, if the date part of your
        timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
        (TimestampOffset) to 2003-1-25.

      - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
      (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
      enable it here, enable it in each output container, and specify tags and timecodes in ID3
      insertion (Id3Insertion) objects.

        - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

          - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
          specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when
          the tag should be inserted. To insert multiple ID3 tags in your output, create multiple
          instances of ID3 insertion (Id3Insertion).

            - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
            format.

            - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
            format.

    - **SimulateReservedQueue** *(string) --* Enable this setting when you run a test job to
    estimate how many reserved transcoding slots (RTS) you need. When this is enabled, MediaConvert
    runs your job from an on-demand queue with similar performance to what you will see with one RTS
    in a reserved queue. This setting is disabled by default.

    - **Status** *(string) --* A job's status can be SUBMITTED, PROGRESSING, COMPLETE, CANCELED, or
    ERROR.

    - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
    events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
    MediaConvert sends an update at this interval from the time the service begins processing your
    job to the time it completes the transcode or encounters an error.

    - **Timing** *(dict) --* Information about when jobs are submitted, started, and finished is
    specified in Unix epoch format in seconds.

      - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
      finished

      - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the job
      began.

      - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the job.

    - **UserMetadata** *(dict) --* User-defined metadata that you want to associate with an
    MediaConvert job. You specify metadata in key/value pairs.

      - *(string) --*

        - *(string) --*
    """


_ClientListJobsResponseTypeDef = TypedDict(
    "_ClientListJobsResponseTypeDef",
    {"Jobs": List[ClientListJobsResponseJobsTypeDef], "NextToken": str},
    total=False,
)


class ClientListJobsResponseTypeDef(_ClientListJobsResponseTypeDef):
    """
    Type definition for `ClientListJobs` `Response`

    - **Jobs** *(list) --* List of jobs

      - *(dict) --* Each job converts an input file into an output file or files. For more
      information, see the User Guide at
      http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

        - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up
        jobs with long, visually complex content.

          - **Mode** *(string) --* Specify the conditions when the service will run your job with
          accelerated transcoding.

        - **AccelerationStatus** *(string) --* Describes whether the current job is running with
        accelerated transcoding. For jobs that have Acceleration (AccelerationMode) set to DISABLED,
        AccelerationStatus is always NOT_APPLICABLE. For jobs that have Acceleration
        (AccelerationMode) set to ENABLED or PREFERRED, AccelerationStatus is one of the other
        states. AccelerationStatus is IN_PROGRESS initially, while the service determines whether
        the input files and job settings are compatible with accelerated transcoding. If they are,
        AcclerationStatus is ACCELERATED. If your input files and job settings aren't compatible
        with accelerated transcoding, the service either fails your job or runs it without
        accelerated transcoding, depending on how you set Acceleration (AccelerationMode). When the
        service runs your job without accelerated transcoding, AccelerationStatus is
        NOT_ACCELERATED.

        - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

        - **BillingTagsSource** *(string) --* Optional. Choose a tag type that AWS Billing and Cost
        Management will use to sort your AWS Elemental MediaConvert costs on any billing report that
        you set up. Any transcoding outputs that don't have an associated tag will appear in your
        billing report unsorted. If you don't choose a valid value for this field, your job outputs
        will appear on the billing report unsorted.

        - **CreatedAt** *(datetime) --* The time, in Unix epoch format in seconds, when the job got
        created.

        - **CurrentPhase** *(string) --* A job's phase can be PROBING, TRANSCODING OR UPLOADING

        - **ErrorCode** *(integer) --* Error code for the job

        - **ErrorMessage** *(string) --* Error message of Job

        - **Id** *(string) --* A portion of the job's ARN, unique within your AWS Elemental
        MediaConvert resources

        - **JobPercentComplete** *(integer) --* An estimate of how far your job has progressed. This
        estimate is shown as a percentage of the total time from when your job leaves its queue to
        when your output files appear in your output Amazon S3 bucket. AWS Elemental MediaConvert
        provides jobPercentComplete in CloudWatch STATUS_UPDATE events and in the response to GetJob
        and ListJobs requests. The jobPercentComplete estimate is reliable for the following input
        containers: Quicktime, Transport Stream, MP4, and MXF. For some jobs, the service can't
        provide information about job progress. In those cases, jobPercentComplete returns a null
        value.

        - **JobTemplate** *(string) --* The job template that the job is created from, if it is
        created from a job template.

        - **Messages** *(dict) --* Provides messages from the service about jobs that you have
        already successfully submitted.

          - **Info** *(list) --* List of messages that are informational only and don't indicate a
          problem with your job.

            - *(string) --*

          - **Warning** *(list) --* List of messages that warn about conditions that might cause
          your job not to run or to fail.

            - *(string) --*

        - **OutputGroupDetails** *(list) --* List of output group details

          - *(dict) --* Contains details about the output groups specified in the job settings.

            - **OutputDetails** *(list) --* Details about the output

              - *(dict) --* Details regarding output

                - **DurationInMs** *(integer) --* Duration in milliseconds

                - **VideoDetails** *(dict) --* Contains details about the output's video stream

                  - **HeightInPx** *(integer) --* Height in pixels for the output

                  - **WidthInPx** *(integer) --* Width in pixels for the output

        - **Priority** *(integer) --* Relative priority on the job.

        - **Queue** *(string) --* Optional. When you create a job, you can specify a queue to send
        it to. If you don't specify, the job will go to the default queue. For more about queues,
        see the User Guide topic at http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

        - **RetryCount** *(integer) --* The number of times that the service automatically attempted
        to process your job after encountering an error.

        - **Role** *(string) --* The IAM role you use for creating this job. For details about
        permissions, see the User Guide topic at the User Guide at
        http://docs.aws.amazon.com/mediaconvert/latest/ug/iam-role.html

        - **Settings** *(dict) --* JobSettings contains all the transcode settings for a job.

          - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added
          to the input Ad Avail PTS time.

          - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
          overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

            - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
            black. Only bmp and png images are supported.

          - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

            - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
            ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The
            transcoder uses the manifest conditioning instructions that you provide in the setting
            MCC XML (mccXml).

              - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
              document inside your JSON job settings. Form the XML document as per
              OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning
              instructions in the message that you supply.

            - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in
            milliseconds, between the SCTE 35 messages that the transcoder places and the splice
            points that they refer to. If the time between the start of the asset and the SCTE-35
            message is less than this value, then the transcoder places the SCTE-35 marker at the
            beginning of the stream.

            - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
            SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
            the signal processing instructions that you provide in the setting SCC XML (sccXml).

              - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
              inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025.
              The transcoder will use the signal processing instructions in the message that you
              supply. Provide your ESAM SignalProcessingNotification XML document inside your JSON
              job settings. For your MPEG2-TS file outputs, if you want the service to place SCTE-35
              markers at the insertion points you specify in the XML document, you must also enable
              SCTE-35 ESAM (scte35Esam). Note that you can either specify an ESAM XML document or
              enable SCTE-35 passthrough. You can't do both.

          - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode
          job. There can be multiple inputs add in a job. These inputs will be concantenated
          together to create the output.

            - *(dict) --* Specifies media input

              - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input
              to combine. An input may have multiple audio selector groups. See "Audio Selector
              Group":#inputs-audio_selector_group for more information.

                - *(string) --*

                  - *(dict) --* Group of Audio Selectors

                    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same
                    input to include in the group. Audio selector names are standardized, based on
                    their order within the input (e.g., "Audio Selector 1"). The audio selector name
                    parameter can be repeated to add any number of audio selectors to the group.

                      - *(string) --*

              - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a
              track or set of tracks from the input that you will use in your outputs. You can use
              mutiple Audio selectors per input.

                - *(string) --*

                  - *(dict) --* Selector for Audio

                    - **CustomLanguageCode** *(string) --* Selects a specific language code from
                    within an audio source, using the ISO 639-2 or ISO 639-3 three-letter language
                    code

                    - **DefaultSelection** *(string) --* Enable this setting on one audio selector
                    to set it as the default for the job. The service uses this default for outputs
                    where it can't find the specified input audio. If you don't set a default, those
                    outputs have no audio.

                    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                    file source.

                    - **LanguageCode** *(string) --* Selects a specific language code from within an
                    audio source.

                    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                    audio from the input video.

                    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g.
                    257 selects PID 0x101).

                      - *(integer) --*

                    - **ProgramSelection** *(integer) --* Use this setting for input streams that
                    contain Dolby E, to have the service extract specific program data from the
                    track. To select multiple programs, create multiple selectors with the same
                    Track and different Program numbers. In the console, this setting is visible
                    when you set Selector type to Track. Choose the program number from the dropdown
                    list. If you are sending a JSON file, provide the program ID, which is part of
                    the audio metadata. If your input file has incorrect metadata, you can choose
                    All channels instead of a program number to have the service ignore the program
                    IDs and include all the programs in the track.

                    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels
                    of one input to match those of another input. This allows you to combine the two
                    files into a single output, one after the other.

                      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                      group of fields that hold the remixing value for each channel. Units are in
                      dB. Acceptable values are within the range from -60 (mute) through 6. A
                      setting of 0 passes the input channel unchanged to the output channel (no
                      attenuation or amplification).

                        - **OutputChannels** *(list) --* List of output channels

                          - *(dict) --* OutputChannel mapping settings.

                            - **InputChannels** *(list) --* List of input channels

                              - *(integer) --*

                      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                      input that you want to use in your output. With remixing, you might combine or
                      split the data in these channels, so the number of channels in your final
                      output might be different.

                      - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                      after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                    - **SelectorType** *(string) --* Specifies the type of the audio selector.

                    - **Tracks** *(list) --* Identify a track from the input audio to include in
                    this selector by entering the track index number. To include several tracks in a
                    single audio selector, specify multiple tracks as follows. Using the console,
                    enter a comma-separated list. For examle, type "1,2,3" to include tracks 1
                    through 3. Specifying directly in your JSON job file, provide the track numbers
                    in an array. For example, "tracks": [1,2,3].

                      - *(integer) --*

              - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to
              specify the captions data from the input that you will use in your outputs. You can
              use mutiple captions selectors per input.

                - *(string) --*

                  - *(dict) --* Set up captions in your outputs by first selecting them from your
                  input here.

                    - **CustomLanguageCode** *(string) --* The specific language to extract from
                    source, using the ISO 639-2 or ISO 639-3 three-letter language code. If input is
                    SCTE-27, complete this field and/or PID to select the caption language to
                    extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this
                    field and/or PID to select the caption language to extract. If input is DVB-Sub
                    that is being passed through, omit this field (and PID field); there is no way
                    to extract a specific language with pass-through captions.

                    - **LanguageCode** *(string) --* The specific language to extract from source.
                    If input is SCTE-27, complete this field and/or PID to select the caption
                    language to extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT,
                    complete this field and/or PID to select the caption language to extract. If
                    input is DVB-Sub that is being passed through, omit this field (and PID field);
                    there is no way to extract a specific language with pass-through captions.

                    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                    SRT, or IMSC in an xml file, specify the URI of the input captions source file.
                    If your input captions are IMSC in an IMF package, use TrackSourceSettings
                    instead of FileSoureSettings.

                      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions
                      source.

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                        number in the ancillary data track from which to extract captions. Unused
                        for passthrough.

                        - **TerminateCaptions** *(string) --* By default, the service terminates any
                        unterminated captions at the end of each input. If you want the caption to
                        continue onto your next input, disable this setting.

                      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use
                        this PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub
                        content is passed through, regardless of selectors.

                      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel
                        number within the video track from which to extract captions. Unused for
                        passthrough.

                        - **Source608TrackNumber** *(integer) --* Specifies the video track index
                        used for extracting captions. The system only supports one input video
                        track, so this should always be set to '1'.

                        - **TerminateCaptions** *(string) --* By default, the service terminates any
                        unterminated captions at the end of each input. If you want the caption to
                        continue onto your next input, disable this setting.

                      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                      STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption
                      source file. If your caption source is IMSC in an IMF package, use
                      TrackSourceSettings instead of FileSoureSettings.

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **SourceFile** *(string) --* External caption file used for loading
                        captions. Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt',
                        'xml', and 'smi'.

                        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset
                        the captions from the source file.

                      - **SourceType** *(string) --* Use Source (SourceType) to identify the format
                      of your input captions. The service cannot auto-detect caption format.

                      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                      sources, including Page number.

                        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                        three-digit hexadecimal page number that will be used for Teletext captions.
                        Do not use this setting if you are passing through teletext from the input
                        source to output.

                      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources
                      that are specified by track number. Currently, this is only IMSC captions in
                      an IMF package. If your caption source is IMSC 1.1 in a separate xml file, use
                      FileSourceSettings instead of TrackSourceSettings.

                        - **TrackNumber** *(integer) --* Use this setting to select a single
                        captions track from a source. Track numbers correspond to the order in the
                        captions source file. For IMF sources, track numbering is based on the order
                        that the captions appear in the CPL. For example, use 1 to select the
                        captions asset that is listed first in the CPL. To include more than one
                        captions track in your job outputs, create multiple input captions
                        selectors. Specify one track per selector.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame. If you specify a value here, it
              will override any value that you specify in the output setting Cropping selection
              (crop).

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce
              smoother motion in the output. Default is disabled. Only manaully controllable for
              MPEG2 and uncompressed video inputs.

              - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
              encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when
              you use AWS Key Management Service (KMS) to encrypt the data key that you use to
              encrypt your content.

                - **DecryptionMode** *(string) --* Specify the encryption mode that you used to
                encrypt your input files.

                - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption
                key in plaintext. Your job settings could be intercepted, making your encrypted
                content vulnerable. Specify the encrypted version of the data key that you used to
                encrypt your content. The data key must be encrypted by AWS Key Management Service
                (KMS). The key can be 128, 192, or 256 bits.

                - **InitializationVector** *(string) --* Specify the initialization vector that you
                used when you encrypted your content before uploading it to Amazon S3. You can use a
                16-byte initialization vector with any encryption mode. Or, you can use a 12-byte
                initialization vector with GCM or CTR. MediaConvert accepts only initialization
                vectors that are base64-encoded.

                - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management
                Service (KMS) that you used to encrypt your data key, if that Region is different
                from the one you are using for AWS Elemental MediaConvert.

              - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise
              from the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and
              uncompressed video inputs.

              - **FileInput** *(string) --* Specify the source file for your transcoding job. You
              can use multiple inputs in a single job. The service concatenates these inputs, in the
              order that you specify them in the job, to create the outputs. If your input format is
              IMF, specify your input by providing the path to your CPL. For example,
              "s3://bucket/vf/cpl.xml". If the CPL is in an incomplete IMP, make sure to use
              *Supplemental IMPs* (SupplementalImps) to specify any supplemental IMPs that contain
              assets referenced by the CPL.

              - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how
              the transcoding service applies the denoise and deblock filters. You must also enable
              the filters separately, with Denoise (InputDenoiseFilter) and Deblock
              (InputDeblockFilter). * Auto - The transcoding service determines whether to apply
              filtering, depending on input type and quality. * Disable - The input is not filtered.
              This is true even if you use the API to enable them in (InputDeblockFilter) and
              (InputDeblockFilter). * Force - The in put is filtered regardless of input type.

              - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
              magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5.
              Default is 0.

              - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
              overlay on your video. Enable or disable this feature for each input individually.
              This setting is disabled by default.

                - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                your video. The images must be PNG or TGA files.

                  - *(dict) --* Settings that specify how your still graphic overlay appears.

                    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                    to remain on the output video. This duration includes fade-in time but not
                    fade-out time.

                    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                    the Start time that you specify for the image insertion and the time that the
                    image appears at full opacity. Full opacity is the level that you specify for
                    the opacity setting. If you don't specify a value for Fade-in, the image will
                    appear abruptly at the overlay start time.

                    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                    between the end of the time that you have specified for the image overlay
                    Duration and when the overlaid image has faded to total transparency. If you
                    don't specify a value for Fade-out, the image will disappear abruptly at the end
                    of the inserted image duration.

                    - **Height** *(integer) --* Specify the height of the inserted image in pixels.
                    If you specify a value that's larger than the video resolution height, the
                    service will crop your overlaid image to fit. To use the native height of the
                    image, keep this setting blank.

                    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                    location of the image that you want to overlay on the video. Use a PNG or TGA
                    file.

                    - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                    inserted image and the left edge of the video frame. Required for any image
                    overlay that you specify.

                    - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                    overlaid image and the top edge of the video frame. Required for any image
                    overlay that you specify.

                    - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                    Images with higher values for Layer appear on top of images with lower values
                    for Layer.

                    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                    underlying video shows through the inserted image. 0 is transparent and 100 is
                    fully opaque. Default is 50.

                    - **StartTime** *(string) --* Specify the timecode of the frame that you want
                    the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                    HH:MM:SS;FF) format. Remember to take into account your timecode source
                    settings.

                    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                    you specify a value that's larger than the video resolution width, the service
                    will crop your overlaid image to fit. To use the native width of the image, keep
                    this setting blank.

              - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
              that together specify a portion of the input to be used in the outputs. If you provide
              only a start time, the clip will be the entire input from that point to the end. If
              you provide only an end time, it will be the entire input up to that point. When you
              specify more than one input clip, the transcoding service creates the job outputs by
              stringing the clips together in the order you specify them.

                - *(dict) --* To transcode only portions of your input (clips), include one Input
                clipping (one instance of InputClipping in the JSON job file) for each input clip.
                All input clips you specify will be included in every output of the job.

                  - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
                  portion of the input you are clipping. The frame corresponding to the End timecode
                  value is included in the clip. Start timecode or End timecode may be left blank,
                  but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM
                  is the minute, SS is the second, and FF is the frame number. When choosing this
                  value, take into account your setting for timecode source under input settings
                  (InputTimecodeSource). For example, if you have embedded timecodes that start at
                  01:00:00:00 and you want your clip to end six minutes into the video, use
                  01:06:00:00.

                  - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the
                  beginning of the portion of the input you are clipping. The frame corresponding to
                  the Start timecode value is included in the clip. Start timecode or End timecode
                  may be left blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where
                  HH is the hour, MM is the minute, SS is the second, and FF is the frame number.
                  When choosing this value, take into account your setting for Input timecode
                  source. For example, if you have embedded timecodes that start at 01:00:00:00 and
                  you want your clip to begin five minutes into the video, use 01:05:00:00.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black. If you specify a value here, it will override any value that you specify in the
              output setting Selection placement (position). If you specify a value here, this will
              override any AFD values in your input, even if you set Respond to AFD (RespondToAfd)
              to Respond (RESPOND). If you specify a value here, this will ignore anything that you
              specify for the setting Scaling Behavior (scalingBehavior).

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
              program from within a multi-program transport stream. Note that Quad 4K is not
              currently supported. Default is the first program within the transport stream. If the
              program you specify doesn't exist, the transcoding service will use this default.

              - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
              inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs
              for audio and video. * Use PSI - Scan only PSI data.

              - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs.
              You need supplemental IMPs if the CPL that you're using for your input is in an
              incomplete IMP. Specify either the supplemental IMP directories with a trailing slash
              or the ASSETMAP.xml files. For example ["s3://bucket/ov/",
              "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to specify the IMP that contains your
              input CPL, because the service automatically detects it.

                - *(string) --*

              - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
              input settings (InputTimecodeSource), to specify how the service counts input video
              frames. This input frame count affects only the behavior of features that apply to a
              single input at a time, such as input clipping and synchronizing some captions
              formats. Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose
              Start at zero (ZEROBASED) to start the first frame at zero. Choose Specified start
              (SPECIFIEDSTART) to start the first frame at the timecode that you specify in the
              setting Start timecode (timecodeStart). If you don't specify a value for Timecode
              source, the service will use Embedded by default. For more information about
              timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

              - **TimecodeStart** *(string) --* Specify the timecode that you want the service to
              use for this input's initial frame. To use this setting, you must set the Timecode
              source setting, located under the input settings (InputTimecodeSource), to Specified
              start (SPECIFIEDSTART). For more information about timecodes, see
              https://docs.aws.amazon.com/console/mediaconvert/timecode.

              - **VideoSelector** *(dict) --* Selector for video.

                - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a
                QuickTime animation. Specify which part of this input MediaConvert uses for your
                outputs. Leave this setting set to DISCARD in order to delete the alpha channel and
                preserve the video. Use REMAP_TO_LUMA for this setting to delete the video and map
                the alpha channel to the luma channel of your outputs.

                - **ColorSpace** *(string) --* If your input video has accurate color space
                metadata, or if you don't know about color space, leave this set to the default
                value Follow (FOLLOW). The service will automatically detect your input color space.
                If your input video has metadata indicating the wrong color space, specify the
                accurate color space here. If your input video is HDR 10 and the SMPTE ST 2086
                Mastering Display Color Volume static metadata isn't present in your video stream,
                or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10)
                here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
                settings. For more information about MediaConvert HDR jobs, see
                https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the
                input file and the job input settings Color space (ColorSpace) and HDR master
                display information settings(Hdr10Metadata). The Color space usage setting
                determines which takes precedence. Choose Force (FORCE) to use color metadata from
                the input job settings. If you don't specify values for those settings, the service
                defaults to using metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to
                use color metadata from the source when it is present. If there's no color metadata
                in your input file, the service defaults to using values you specify in the input
                settings.

                - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that
                is missing or inaccurate in your input video. Appropriate values vary depending on
                the input video and must be provided by a color grader. The color grader generates
                these values during the HDR 10 mastering process. The valid range for each of these
                settings is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color
                coordinate. Related settings - When you specify these values, you must also set
                Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
                specify here take precedence over the values in the metadata of your input file, set
                Color space usage (ColorSpaceUsage). To specify whether color metadata is included
                in an output, set Color metadata (ColorMetadata). For more information about
                MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                  - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                  the coded video sequence, in units of candelas per square meter. This setting
                  doesn't have a default value; you must specify a value that is suitable for the
                  content.

                  - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                  frame in the coded video sequence, in units of candelas per square meter. This
                  setting doesn't have a default value; you must specify a value that is suitable
                  for the content.

                  - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                  units of of 0.0001 candelas per square meter.

                  - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                  units of of 0.0001 candelas per square meter

                  - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input
                file. Specify this value as an integer; the system automatically converts it to the
                hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier,
                is an identifier for a set of data in an MPEG-2 transport stream container.

                - **ProgramNumber** *(integer) --* Selects a specific program from within a
                multi-program transport stream. Note that Quad 4K is not currently supported.

                - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service
                rotates your video. You can choose automatic rotation or specify a rotation. You can
                specify a clockwise rotation of 0, 90, 180, or 270 degrees. If your input video
                container is .mov or .mp4 and your input has rotation metadata, you can choose
                Automatic to have the service rotate your video according to the rotation specified
                in the metadata. The rotation must be within one degree of 90, 180, or 270 degrees.
                If the rotation metadata specifies any other rotation, the service will default to
                no rotation. By default, the service does no rotation, even if your input video has
                rotation metadata. The service doesn't pass through rotation metadata.

          - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The
          motion graphics that you specify here appear on all outputs in all output groups.

            - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this
            setting unspecified. If your motion graphic asset is a series of .png files, specify the
            frame rate of the overlay in frames per second, as a fraction. For example, specify 24
            fps as 24/1. Make sure that the number of images in your series matches the frame rate
            and your intended overlay duration. For example, if you want a 30-second overlay at 30
            fps, you should have 900 .png images. This overlay frame rate doesn't need to match the
            frame rate of the underlying video.

              - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses
              your overlay frame rate. For example, if your frame rate is 24 fps, set this value to
              1.

              - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
              overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

            - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
            overlay on your video. For .png files, provide the file name of the first file in the
            series. Make sure that the names of the .png files end with sequential numbers that
            specify the order that they are played in. For example, overlay_000.png,
            overlay_001.png, overlay_002.png, and so on. The sequence must start at zero, and each
            image file name must have the same number of digits. Pad your initial file names with
            enough zeros to complete the sequence. For example, if the first image is overlay_0.png,
            there can be only 10 images in the sequence, with the last image being overlay_9.png.
            But if the first image is overlay_00.png, there can be 100 images in the sequence.

            - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
            providing for your overlay. You can choose either a .mov file or a series of .png files.

            - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic
            overlay on the video frame. Specify in pixels, from the upper-left corner of the frame.
            If you don't specify an offset, the service scales your overlay to the full size of the
            frame. Otherwise, the service inserts the overlay at its native resolution and scales
            the size up or down with any video scaling.

              - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the
              left edge of the video frame.

              - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the
              top edge of the video frame.

            - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a
            loop or plays only once.

            - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode
            format (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes
            into account how you have set up your timecode configuration under both job settings and
            input settings. The simplest way to do that is to set both to start at 0. If you need to
            set up your job to follow timecodes embedded in your source that don't start at zero,
            make sure that you specify a start time that is after the first embedded timecode. For
            more information, see
            https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find
            job-wide and input timecode configuration settings in your JSON job settings
            specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

          - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you
          don't do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
          configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all
          outputs in the job. To enable Nielsen configuration programmatically, include an instance
          of nielsenConfiguration in your JSON job specification. Even if you don't include any
          children of nielsenConfiguration, you still enable the setting.

            - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
            functionality. If you must include this property, set the value to zero.

            - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
            distributor ID that is assigned to your organization by Neilsen.

          - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set
          of outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS,
          Quicktime, MXF, and no container) are grouped in a single output group as well. Required
          in (OutputGroups) is a group of settings that apply to the whole group. This required
          object depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings).
          Type, settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
          HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
          MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

            - *(dict) --* Group of outputs

              - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name
              for the output group. This value is displayed on the console and can make your job
              settings JSON more human-readable. It does not affect your outputs. Use up to twelve
              characters that are either letters, numbers, spaces, or underscores.

              - **Name** *(string) --* Name of the output group

              - **OutputGroupSettings** *(dict) --* Output Group settings, including type

                - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
                Output Group may only contain a single video, audio, or caption output.

                  - **AdditionalManifests** *(list) --* By default, the service creates one
                  top-level .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF
                  output group in your job. These default manifests reference every output in the
                  output group. To create additional top-level manifests that reference a subset of
                  the outputs in the output group, specify a list of them here. For each additional
                  manifest that you specify, the service creates one HLS manifest and one DASH
                  manifest.

                    - *(dict) --* Specify the details for each pair of HLS and DASH additional
                    manifests that you want the service to generate for this CMAF output group. Each
                    pair of manifests can reference a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your HLS group is film-name.m3u8. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                      specify a manifestNameModifier that is different from the nameModifier of the
                      output. The service uses the output name modifier to create unique names for
                      the individual variant manifests.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                  file at the top level BaseURL element. Can be used if streams are delivered from a
                  different URL than the manifest file.

                  - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no
                  tag, which prevents client from saving media segments for later replay.

                  - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the
                  default RFC-4281) during m3u8 playlist generation.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* DRM settings.

                    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                    value represented by a 32-character text string. If this parameter is not set
                    then the Initialization Vector will follow the segment number by default.

                    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want
                    the service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                    (SAMPLE-AES) or AES_CTR (AES-CTR).

                    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                    outputs, choose whether the service writes the 128-bit encryption initialization
                    vector in the HLS and DASH manifests.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                    settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                    output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                    settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you
                      want signaled in the DASH manifest that MediaConvert creates as part of this
                      CMAF package. The DASH manifest can currently signal up to three system IDs.
                      For more information, see https://dashif.org/identifiers/content_protection/.

                        - *(string) --*

                      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                      signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                      package. The HLS manifest can currently signal only one system ID. For more
                      information, see https://dashif.org/identifiers/content_protection/.

                        - *(string) --*

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with
                    a static key provider.

                      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                      the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                      omitted to indicate an implicit value of 'identity'.

                      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                      single positive integer version value or a slash delimited list of version
                      values (1/2/3).

                      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                      32-character hexidecimal string to specify Key Value (StaticKeyValue).

                      - **Url** *(string) --* Relates to DRM implementation. The location of the
                      license server used for protecting content.

                    - **Type** *(string) --* Specify whether your DRM encryption key is static or
                    from a key provider that follows the SPEKE standard. For more information about
                    SPEKE, see
                    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                  - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                  Fragment length must be compatible with GOP size and Framerate. Note that
                  fragments will end on the next keyframe after this number of seconds, so actual
                  fragment length may be longer. When Emit Single File is checked, the fragmentation
                  is internal to a single output file and it does not cause the creation of many
                  output files as in other output types.

                  - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                  - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                  should use floating point values for segment duration.

                  - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that
                  is needed to ensure smooth playout.

                  - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                  0, unless you are troubleshooting a problem with how devices play back the end of
                  your video asset. If you know that player devices are hanging on the final segment
                  of your video because the length of your final segment is too short, use this
                  setting to specify a minimum final segment length, in seconds. Choose a value that
                  is greater than or equal to 1 and less than your segment length. When you specify
                  a value for this setting, the encoder will combine any final segment that is
                  shorter than the length that you specify with the previous segment. For example,
                  your segment length is 3 seconds and your final segment is .5 seconds without a
                  minimum final segment length; when you set the minimum final segment length to 1,
                  your final segment is 3.5 seconds.

                  - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                  main. When you choose Main profile (MAIN_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                  On-demand (ON_DEMAND_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose
                  On-demand, you must also set the output group setting Segment control
                  (SegmentControl) to Single file (SINGLE_FILE).

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file
                  is generated, which is internally segmented using the Fragment Length and Segment
                  Length. When set to SEGMENTED_FILES, separate segment files will be created.

                  - **SegmentLength** *(integer) --* Use this setting to specify the length, in
                  seconds, of each individual CMAF segment. This value applies to the whole package;
                  that is, to every output in the output group. Note that segments end on the first
                  keyframe after this number of seconds, so the actual segment length might be
                  slightly longer. If you set Segment control (CmafSegmentControl) to single file,
                  the service puts the content of each output in a single file that has metadata
                  that marks these segments. If you set it to segmented files, the service creates
                  multiple files for each output, each with the content of one segment.

                  - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute
                  for video in EXT-X-STREAM-INF tag of variant manifest.

                  - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest
                  will be generated for this output.

                  - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest
                  will be generated for this output.

                - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

                  - **AdditionalManifests** *(list) --* By default, the service creates one .mpd
                  DASH manifest for each DASH ISO output group in your job. This default manifest
                  references every output in the output group. To create additional DASH manifests
                  that reference a subset of the outputs in the output group, specify a list of them
                  here.

                    - *(dict) --* Specify the details for each additional DASH manifest that you
                    want the service to generate for this output group. Each manifest can reference
                    a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your DASH group is film-name.mpd. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.mpd.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                  (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
                  from a different URL than the manifest file.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* DRM settings.

                    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                    compatibility of your output with video players on obsolete devices. It applies
                    only to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI
                    (UNENCRYPTED_SEI) only to correct problems with playback on older devices.
                    Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose Unencrypted
                    SEI, for that output, the service will exclude the access unit delimiter and
                    will leave the SEI NAL units unencrypted.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                  - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                  Fragment length must be compatible with GOP size and Framerate. Note that
                  fragments will end on the next keyframe after this number of seconds, so actual
                  fragment length may be longer. When Emit Single File is checked, the fragmentation
                  is internal to a single output file and it does not cause the creation of many
                  output files as in other output types.

                  - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

                  - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that
                  is needed to ensure smooth playout.

                  - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                  main. When you choose Main profile (MAIN_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                  On-demand (ON_DEMAND_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose
                  On-demand, you must also set the output group setting Segment control
                  (SegmentControl) to Single file (SINGLE_FILE).

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file
                  is generated, which is internally segmented using the Fragment Length and Segment
                  Length. When set to SEGMENTED_FILES, separate segment files will be created.

                  - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds).
                  Note that segments will end on the next keyframe after this number of seconds, so
                  actual segment length may be longer. When Emit Single File is checked, the
                  segmentation is internal to a single output file and it does not cause the
                  creation of many output files as in other output types.

                  - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error
                  in the 400 range when you play back your DASH output, enable this setting and run
                  your transcoding job again. When you enable this setting, the service writes
                  precise segment durations in the DASH manifest. The segment duration information
                  appears inside the SegmentTimeline element, inside SegmentTemplate at the
                  Representation level. When you don't enable this setting, the service writes
                  approximate segment durations in your DASH manifest.

                - **FileGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

                  - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your
                  Apple HLS manifest. This setting does not determine whether SCTE-35 markers appear
                  in the outputs themselves.

                    - *(string) --*

                  - **AdditionalManifests** *(list) --* By default, the service creates one
                  top-level .m3u8 HLS manifest for each HLS output group in your job. This default
                  manifest references every output in the output group. To create additional
                  top-level manifests that reference a subset of the outputs in the output group,
                  specify a list of them here.

                    - *(dict) --* Specify the details for each additional HLS manifest that you want
                    the service to generate for this output group. Each manifest can reference a
                    different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your HLS group is film-name.m3u8. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                      specify a manifestNameModifier that is different from the nameModifier of the
                      output. The service uses the output name modifier to create unique names for
                      the individual variant manifests.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each
                  output in the media .m3u8 file. Can be used if base manifest is delivered from a
                  different URL than the main .m3u8 file.

                  - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                    - *(dict) --* Caption Language Mapping

                      - **CaptionChannel** *(integer) --* Caption channel.

                      - **CustomLanguageCode** *(string) --* Specify the language for this captions
                      channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                      - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                      three-letter code listed at
                      https://www.loc.gov/standards/iso639-2/php/code_list.php.

                      - **LanguageDescription** *(string) --* Caption language description.

                  - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
                  captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least
                  one language in the CC1 Language Code field. One CLOSED-CAPTION line is added for
                  each Language Code you specify. Make sure to specify the languages in the order in
                  which they appear in the original source (if the source is embedded format) or the
                  order of the caption selectors (if the source is other than embedded). Otherwise,
                  languages in the manifest will not match up properly with the output captions.
                  None: Include CLOSED-CAPTIONS=
                      NONE line in the manifest. Omit: Omit any
                  CLOSED-CAPTIONS line from the manifest.

                  - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no
                  tag, which prevents client from saving media segments for later replay.

                  - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the
                  default RFC-4281) during m3u8 playlist generation.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **DirectoryStructure** *(string) --* Indicates whether segments should be placed
                  in subdirectories.

                  - **Encryption** *(dict) --* DRM settings.

                    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                    value represented by a 32-character text string. If this parameter is not set
                    then the Initialization Vector will follow the segment number by default.

                    - **EncryptionMethod** *(string) --* Encrypts the segments with the given
                    encryption scheme. Leave blank to disable. Selecting 'Disabled' in the web
                    interface also disables encryption.

                    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is
                    a 128-bit number used in conjunction with the key for encrypting blocks. If set
                    to INCLUDE, Initialization Vector is listed in the manifest. Otherwise
                    Initialization Vector is not in the manifest.

                    - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                    EXT-X-SESSION-KEY element into the master playlist. This allows for offline
                    Apple HLS FairPlay content protection.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with
                    a static key provider.

                      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                      the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                      omitted to indicate an implicit value of 'identity'.

                      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                      single positive integer version value or a slash delimited list of version
                      values (1/2/3).

                      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                      32-character hexidecimal string to specify Key Value (StaticKeyValue).

                      - **Url** *(string) --* Relates to DRM implementation. The location of the
                      license server used for protecting content.

                    - **Type** *(string) --* Specify whether your DRM encryption key is static or
                    from a key provider that follows the SPEKE standard. For more information about
                    SPEKE, see
                    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                  - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                  - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                  should use floating point values for segment duration.

                  - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                  0, unless you are troubleshooting a problem with how devices play back the end of
                  your video asset. If you know that player devices are hanging on the final segment
                  of your video because the length of your final segment is too short, use this
                  setting to specify a minimum final segment length, in seconds. Choose a value that
                  is greater than or equal to 1 and less than your segment length. When you specify
                  a value for this setting, the encoder will combine any final segment that is
                  shorter than the length that you specify with the previous segment. For example,
                  your segment length is 3 seconds and your final segment is .5 seconds without a
                  minimum final segment length; when you set the minimum final segment length to 1,
                  your final segment is 3.5 seconds.

                  - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced
                  by looking ahead and back within the specified range for a nearby avail and
                  extending the segment size if needed.

                  - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file
                  should be generated for this HLS output group.

                  - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME
                  tag in .m3u8 manifest files. The value is calculated as follows: either the
                  program date and time are initialized using the input timecode source, or the time
                  is initialized using the input timecode source and the date is initialized using
                  the timestamp_offset.

                  - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
                  EXT-X-PROGRAM-DATE-TIME entry, in seconds.

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a
                  single media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for
                  playback.

                  - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
                  create (in seconds). Note that segments will end on the next keyframe after this
                  number of seconds, so actual segment length may be longer.

                  - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
                  subdirectory before starting a new one. directoryStructure must be
                  SINGLE_DIRECTORY for this setting to have an effect.

                  - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute
                  for video in EXT-X-STREAM-INF tag of variant manifest.

                  - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the
                  timecode.

                  - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

                  - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond
                  delta offset to fine tune the timestamps.

                - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

                  - **AdditionalManifests** *(list) --* By default, the service creates one .ism
                  Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output
                  group in your job. This default manifest references every output in the output
                  group. To create additional manifests that reference a subset of the outputs in
                  the output group, specify a list of them here.

                    - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                    manifest that you want the service to generate for this output group. Each
                    manifest can reference a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your Microsoft Smooth group is film-name.ismv.
                      If you enter "-no-premium" for this setting, then the file name the service
                      generates for this top-level manifest is film-name-no-premium.ismv.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines
                  identical audio encoding settings across a Microsoft Smooth output group into a
                  single audio stream.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* If you are using DRM, set DRM System
                  (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                  - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to
                  specify the mp4 fragment sizes in seconds. Fragment length must be compatible with
                  GOP size and frame rate.

                  - **ManifestEncoding** *(string) --* Use Manifest encoding
                  (MsSmoothManifestEncoding) to specify the encoding format for the server and
                  client manifest. Valid options are utf8 and utf16.

                - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
                Microsoft Smooth Streaming, CMAF)

              - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
              settings per output.

                - *(dict) --* An output object describes the settings for a single output file or
                stream in an output group.

                  - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
                  encoding settings organized by audio codec. Include one instance of
                  (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
                  encoding settings.

                    - *(dict) --* Description of audio output

                      - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                      settings. Ignore these settings unless you need to comply with a loudness
                      standard.

                        - **Algorithm** *(string) --* Choose one of the following audio
                        normalization algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement
                        of ungated average loudness for an entire piece of content, suitable for
                        measurement of short-form content under ATSC recommendation A/85. Supports
                        up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
                        gated average loudness compliant with the requirements of EBU-R128. Supports
                        up to 5.1 audio channels. ITU-R BS.1770-3: Modified peak. The same loudness
                        measurement algorithm as 1770-2, with an updated true peak measurement.
                        ITU-R BS.1770-4: Higher channel count. Allows for more audio channels than
                        the other algorithms, including configurations such as 7.1.

                        - **AlgorithmControl** *(string) --* When enabled the output audio is
                        corrected using the chosen algorithm. If disabled, the audio will be
                        measured but not adjusted.

                        - **CorrectionGateLevel** *(integer) --* Content measuring above this level
                        will be corrected to the target level. Content measuring below this level
                        will not be corrected. Gating only applies when not using
                        real_time_correction.

                        - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio
                        track loudness to a CSV file.

                        - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log
                        the TruePeak for each output's audio track loudness.

                        - **TargetLkfs** *(float) --* When you use Audio normalization
                        (AudioNormalizationSettings), optionally use this setting to specify a
                        target loudness. If you don't specify a value here, the encoder chooses a
                        value for you, based on the algorithm that you choose for Algorithm
                        (algorithm). If you choose algorithm 1770-1, the encoder will choose -24
                        LKFS; otherwise, the encoder will choose -23 LKFS.

                      - **AudioSourceName** *(string) --* Specifies which audio data to use from
                      each input. In the simplest case, specify an "Audio
                      Selector":#inputs-audio_selector by name based on its order within each input.
                      For example if you specify "Audio Selector 3", then the third audio selector
                      will be used from each input. If an input does not have an "Audio Selector 3",
                      then the audio selector marked as "default" in that input will be used. If
                      there is no audio selector marked as "default", silence will be inserted for
                      the duration of that input. Alternatively, an "Audio Selector
                      Group":#inputs-audio_selector_group name may be specified, with similar
                      default/silence behavior. If no audio_source_name is specified, then "Audio
                      Selector 1" will be chosen automatically.

                      - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                      unchecked (false). A number between 0 and 255. The following are defined in
                      ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                           Hearing Impaired, 3 =
                      Visually Impaired Commentary, 4-255 = Reserved.

                      - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                      contains an ISO 639 audio_type, then that value is passed through to the
                      output. If the input contains no ISO 639 audio_type, the value in Audio Type
                      is included in the output. Otherwise the value in Audio Type is included in
                      the output. Note that this field and audioType are both ignored if
                      audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

                      - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                      (AudioDescriptions) contains the group of settings related to audio encoding.
                      The settings in this group vary depending on the value that you choose for
                      Audio codec (Codec). For each codec enum that you choose, define the
                      corresponding settings object. The following lists the codec enum, settings
                      object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF,
                      AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
                      Eac3AtmosSettings

                        - **AacSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts
                        one of two mutually exclusive groups of AAC settings--VBR and CBR. To select
                        one of these modes, set the value of Bitrate control mode (rateControlMode)
                        to "VBR" or "CBR". In VBR mode, you control the audio quality with the
                        setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
                        (bitrate). Defaults and valid values depend on the rate control mode.

                          - **AudioDescriptionBroadcasterMix** *(string) --* Choose
                          BROADCASTER_MIXED_AD when the input contains pre-mixed main audio + audio
                          description (AD) as a stereo pair. The value for AudioType will be set to
                          3, which signals to downstream systems that this stream contains
                          "broadcaster mixed AD". Note that the input received by the encoder must
                          contain pre-mixed audio; the encoder does not perform the mixing. When you
                          choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                          AudioType and FollowInputAudioType. Choose NORMAL when the input does not
                          contain pre-mixed audio + audio description (AD). In this case, the
                          encoder will use any values you provide for AudioType and
                          FollowInputAudioType.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. The set of valid values for this setting is: 6000, 8000, 10000,
                          12000, 14000, 16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000,
                          64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
                          288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
                          1024000. The value you set is also constrained by the values that you
                          choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                          Sample rate (sampleRate). Default values depend on Bitrate control mode
                          and Profile.

                          - **CodecProfile** *(string) --* AAC Profile.

                          - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or
                          5.1 channel layout. Valid values depend on rate control mode and profile.
                          "1.0 - Audio Description (Receiver Mix)" setting receives a stereo
                          description plus control track and emits a mono AAC encode of the
                          description track, with control data emitted in the PES header as per ETSI
                          TS 101 154 Annex E.

                          - **RateControlMode** *(string) --* Rate Control Mode.

                          - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if
                          you use LATM/LOAS AAC in an output, you must choose "No container" for the
                          output container.

                          - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on
                          rate control mode and profile.

                          - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC
                          audio for raw or MPEG-2 Transport Stream containers.

                          - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                          rate_control_mode is VBR.

                        - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AC3.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid bitrates depend on the coding mode.

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                          stream that the encoder emits. For more information about the AC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* Dolby Digital coding mode. Determines
                          number of channels.

                          - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank
                          and input audio is Dolby Digital, dialnorm will be passed through.

                          - **DynamicRangeCompressionProfile** *(string) --* If set to
                          FILM_STANDARD, adds dynamic range compression signaling to the output
                          bitstream as defined in the Dolby Digital specification.

                          - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                          channel prior to encoding. Only valid with 3_2_LFE coding mode.

                          - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                          metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                          this audio data. If audio was not supplied from one of these streams, then
                          the static metadata settings will be used.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                        - **AiffSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AIFF.

                          - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                          sample, to choose the encoding quality for this audio track.

                          - **Channels** *(integer) --* Specify the number of channels in this
                          output audio track. Valid values are 1 and even numbers up to 64. For
                          example, 1, 2, 4, 6, and so on, up to 64.

                          - **SampleRate** *(integer) --* Sample rate in hz.

                        - **Codec** *(string) --* Type of Audio codec.

                        - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid values: 384k, 448k, 640k, 768k

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the
                          E-AC-3 stream that the encoder emits. For more information about the EAC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                          (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                          - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue
                          Intelligence to adjust loudness based on dialogue analysis.

                          - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                          level for a signal with dynamic range compression.

                          - **DynamicRangeCompressionRf** *(string) --* Specify how the service
                          limits the audio dynamic range when compressing the audio.

                          - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left only/Right only center mix (Lo/Ro center).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
                          and -6.0.

                          - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert
                          uses this value for downmixing. How the service uses this value depends on
                          the value that you choose for Stereo downmix (Eac3AtmosStereoDownmix).
                          Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                          channel.

                          - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left total/Right total center mix (Lt/Rt center).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
                          and -6.0.

                          - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
                          The value -60 mutes the channel.

                          - **MeteringMode** *(string) --* Choose how the service meters the
                          loudness of your audio.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                          - **SpeechThreshold** *(integer) --* Specify the percentage of audio
                          content that must be speech before the encoder uses the measured speech
                          loudness as the overall program loudness.

                          - **StereoDownmix** *(string) --* Choose how the service does stereo
                          downmixing.

                          - **SurroundExMode** *(string) --* Specify whether your input audio has an
                          additional center rear surround channel matrix encoded into your left and
                          right surround channels.

                        - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value EAC3.

                          - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a
                          3 dB attenuation to the surround channels. Only used for 3/2 coding mode.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid bitrates depend on the coding mode.

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the
                          E-AC-3 stream that the encoder emits. For more information about the EAC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                          number of channels.

                          - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                          channels.

                          - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank
                          and input audio is Dolby Digital Plus, dialnorm will be passed through.

                          - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                          level for a signal with dynamic range compression.

                          - **DynamicRangeCompressionRf** *(string) --* Specify how the service
                          limits the audio dynamic range when compressing the audio.

                          - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether
                          the LFE channel is enabled

                          - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                          channel prior to encoding. Only valid with 3_2_LFE coding mode.

                          - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left only/Right only center mix (Lo/Ro
                          center). MediaConvert uses this value for downmixing. How the service uses
                          this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                          and -60. The value -60 mutes the channel. This setting applies only if you
                          keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                          setting Coding mode (Eac3CodingMode). If you choose a different value for
                          Coding mode, the service ignores Left only/Right only center
                          (loRoCenterMixLevel).

                          - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                          value -60 mutes the channel. This setting applies only if you keep the
                          default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                          Coding mode (Eac3CodingMode). If you choose a different value for Coding
                          mode, the service ignores Left only/Right only surround
                          (loRoSurroundMixLevel).

                          - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left total/Right total center mix (Lt/Rt
                          center). MediaConvert uses this value for downmixing. How the service uses
                          this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                          and -60. The value -60 mutes the channel. This setting applies only if you
                          keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                          setting Coding mode (Eac3CodingMode). If you choose a different value for
                          Coding mode, the service ignores Left total/Right total center
                          (ltRtCenterMixLevel).

                          - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                          surround). MediaConvert uses this value for downmixing. How the service
                          uses this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                          value -60 mutes the channel. This setting applies only if you keep the
                          default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                          Coding mode (Eac3CodingMode). If you choose a different value for Coding
                          mode, the service ignores Left total/Right total surround
                          (ltRtSurroundMixLevel).

                          - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                          metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                          this audio data. If audio was not supplied from one of these streams, then
                          the static metadata settings will be used.

                          - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input
                          DD+ audio will be passed through if it is present on the input. this
                          detection is dynamic over the life of the transcode. Inputs that alternate
                          between DD+ and non-DD+ content will have a consistent DD+ output as the
                          system alternates between passthrough and encoding.

                          - **PhaseControl** *(string) --* Controls the amount of phase-shift
                          applied to the surround channels. Only used for 3/2 coding mode.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                          - **StereoDownmix** *(string) --* Choose how the service does stereo
                          downmixing. This setting only applies if you keep the default value of 3/2
                          - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                          (Eac3CodingMode). If you choose a different value for Coding mode, the
                          service ignores Stereo downmix (Eac3StereoDownmix).

                          - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether
                          an extra center back surround channel is matrix encoded into the left and
                          right surround channels.

                          - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether
                          Dolby Surround is matrix encoded into the two channels.

                        - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value MP2.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second.

                          - **Channels** *(integer) --* Set Channels to specify the number of
                          channels in this output audio track. Choosing Mono in the console will
                          give you 1 output channel; choosing Stereo will give you 2. In the API,
                          valid values are 1 and 2.

                          - **SampleRate** *(integer) --* Sample rate in hz.

                        - **WavSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value WAV.

                          - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                          sample, to choose the encoding quality for this audio track.

                          - **Channels** *(integer) --* Specify the number of channels in this
                          output audio track. Valid values are 1 and even numbers up to 64. For
                          example, 1, 2, 4, 6, and so on, up to 64.

                          - **Format** *(string) --* The service defaults to using RIFF for WAV
                          outputs. If your output audio is likely to exceed 4 GB in file size, or if
                          you otherwise need the extended support of the RF64 format, set your
                          output WAV file format to RF64.

                          - **SampleRate** *(integer) --* Sample rate in Hz.

                      - **CustomLanguageCode** *(string) --* Specify the language for this audio
                      output track. The service puts this language code into your output audio track
                      when you set Language code control (AudioLanguageCodeControl) to Use
                      configured (USE_CONFIGURED). The service also uses your specified custom
                      language code when you set Language code control (AudioLanguageCodeControl) to
                      Follow input (FOLLOW_INPUT), but your input file doesn't specify a language
                      code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
                      streaming outputs, you can also use any other code in the full RFC-5646
                      specification. Streaming outputs are those that are in one of the following
                      output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                      - **LanguageCode** *(string) --* Indicates the language of the audio output
                      track. The ISO 639 language specified in the 'Language Code' drop down will be
                      used when 'Follow Input Language Code' is not selected or when 'Follow Input
                      Language Code' is selected but there is no ISO 639 language code specified by
                      the input.

                      - **LanguageCodeControl** *(string) --* Specify which source for language code
                      takes precedence for this audio track. When you choose Follow input
                      (FOLLOW_INPUT), the service uses the language code from the input track if
                      it's present. If there's no languge code on the input track, the service uses
                      the code that you specify in the setting Language code (languageCode or
                      customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
                      service uses the language code that you specify.

                      - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                        - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains
                        the group of fields that hold the remixing value for each channel. Units are
                        in dB. Acceptable values are within the range from -60 (mute) through 6. A
                        setting of 0 passes the input channel unchanged to the output channel (no
                        attenuation or amplification).

                          - **OutputChannels** *(list) --* List of output channels

                            - *(dict) --* OutputChannel mapping settings.

                              - **InputChannels** *(list) --* List of input channels

                                - *(integer) --*

                        - **ChannelsIn** *(integer) --* Specify the number of audio channels from
                        your input that you want to use in your output. With remixing, you might
                        combine or split the data in these channels, so the number of channels in
                        your final output might be different.

                        - **ChannelsOut** *(integer) --* Specify the number of channels in this
                        output after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even
                        numbers to 64.)

                      - **StreamName** *(string) --* Specify a label for this output audio stream.
                      For example, "English", "Director commentary", or "track_2". For streaming
                      outputs, MediaConvert passes this information into destination manifests for
                      display on the end-viewer's player device. For outputs in other output groups,
                      the service ignores this setting.

                  - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
                  captions settings. For each output that has captions, include one instance of
                  (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of
                  captions settings.

                    - *(dict) --* Description of Caption output

                      - **CaptionSelectorName** *(string) --* Specifies which "Caption
                      Selector":#inputs-caption_selector to use from each input when generating
                      captions. The name should be of the format "Caption Selector ", which denotes
                      that the Nth Caption Selector will be used from each input.

                      - **CustomLanguageCode** *(string) --* Specify the language for this captions
                      output track. For most captions output formats, the encoder puts this language
                      information in the output captions metadata. If your output captions format is
                      DVB-Sub or Burn in, the encoder uses this language information when
                      automatically selecting the font script for rendering the captions text. For
                      all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
                      outputs, you can also use any other code in the full RFC-5646 specification.
                      Streaming outputs are those that are in one of the following output groups:
                      CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                      - **DestinationSettings** *(dict) --* Specific settings required by
                      destination type. Note that burnin_destination_settings are not available if
                      the source of the caption data is Embedded or Teletext.

                        - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                          - **Alignment** *(string) --* If no explicit x_position or y_position is
                          provided, setting alignment to centered will place the captions at the
                          bottom center of the output. Similarly, setting a left alignment will
                          align captions to the bottom left of the output. If x and y positions are
                          given in conjunction with the alignment parameter, the font will be
                          justified (either left or centered) relative to those coordinates. This
                          option is not valid for source captions that are STL, 608/embedded or
                          teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                          behind the captions. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                          background rectangle. 255 is opaque; 0 is transparent. Leaving this
                          parameter blank is equivalent to setting it to 0 (transparent). All
                          burn-in and DVB-Sub font settings must match.

                          - **FontColor** *(string) --* Specifies the color of the burned-in
                          captions. This option is not valid for source captions that are STL,
                          608/embedded or teletext. These source settings are already pre-defined by
                          the caption stream. All burn-in and DVB-Sub font settings must match.

                          - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                          captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                          settings must match.

                          - **FontResolution** *(integer) --* Font resolution in DPI (dots per
                          inch); default is 96 dpi. All burn-in and DVB-Sub font settings must
                          match.

                          - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                          script code, if the LanguageCode is not sufficient for determining the
                          script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                          "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                          font for rendering burn-in captions.

                          - **FontSize** *(integer) --* A positive integer indicates the exact font
                          size in points. Set to 0 for automatic font size selection. All burn-in
                          and DVB-Sub font settings must match.

                          - **OutlineColor** *(string) --* Specifies font outline color. This option
                          is not valid for source captions that are either 608/embedded or teletext.
                          These source settings are already pre-defined by the caption stream. All
                          burn-in and DVB-Sub font settings must match.

                          - **OutlineSize** *(integer) --* Specifies font outline size in pixels.
                          This option is not valid for source captions that are either 608/embedded
                          or teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                          the captions. All burn-in and DVB-Sub font settings must match.

                          - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow.
                          255 is opaque; 0 is transparent. Leaving this parameter blank is
                          equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                          settings must match.

                          - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                          must match.

                          - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels above the text. All burn-in and DVB-Sub font
                          settings must match.

                          - **TeletextSpacing** *(string) --* Only applies to jobs with input
                          captions in Teletext or STL formats. Specify whether the spacing between
                          letters in your captions is set by the captions grid or varies depending
                          on letter width. Choose fixed grid to conform to the spacing specified in
                          the captions file more accurately. Choose proportional to make the text
                          easier to read if the captions are closed caption.

                          - **XPosition** *(integer) --* Specifies the horizontal position of the
                          caption relative to the left side of the output in pixels. A value of 10
                          would result in the captions starting 10 pixels from the left of the
                          output. If no explicit x_position is provided, the horizontal caption
                          position will be determined by the alignment parameter. This option is not
                          valid for source captions that are STL, 608/embedded or teletext. These
                          source settings are already pre-defined by the caption stream. All burn-in
                          and DVB-Sub font settings must match.

                          - **YPosition** *(integer) --* Specifies the vertical position of the
                          caption relative to the top of the output in pixels. A value of 10 would
                          result in the captions starting 10 pixels from the top of the output. If
                          no explicit y_position is provided, the caption will be positioned towards
                          the bottom of the output. This option is not valid for source captions
                          that are STL, 608/embedded or teletext. These source settings are already
                          pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                          must match.

                        - **DestinationType** *(string) --* Specify the format for this set of
                        captions on this output. The default format is embedded without SCTE-20.
                        Other options are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT,
                        teletext, TTML, and web-VTT. If you are using SCTE-20, choose SCTE-20 plus
                        embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the
                        SCTE-43 spec. To create a non-compliant output where the embedded captions
                        come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                        - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                          - **Alignment** *(string) --* If no explicit x_position or y_position is
                          provided, setting alignment to centered will place the captions at the
                          bottom center of the output. Similarly, setting a left alignment will
                          align captions to the bottom left of the output. If x and y positions are
                          given in conjunction with the alignment parameter, the font will be
                          justified (either left or centered) relative to those coordinates. This
                          option is not valid for source captions that are STL, 608/embedded or
                          teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                          behind the captions. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                          background rectangle. 255 is opaque; 0 is transparent. Leaving this
                          parameter blank is equivalent to setting it to 0 (transparent). All
                          burn-in and DVB-Sub font settings must match.

                          - **FontColor** *(string) --* Specifies the color of the burned-in
                          captions. This option is not valid for source captions that are STL,
                          608/embedded or teletext. These source settings are already pre-defined by
                          the caption stream. All burn-in and DVB-Sub font settings must match.

                          - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                          captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                          settings must match.

                          - **FontResolution** *(integer) --* Font resolution in DPI (dots per
                          inch); default is 96 dpi. All burn-in and DVB-Sub font settings must
                          match.

                          - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                          script code, if the LanguageCode is not sufficient for determining the
                          script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                          "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                          font for rendering DVB-Sub captions.

                          - **FontSize** *(integer) --* A positive integer indicates the exact font
                          size in points. Set to 0 for automatic font size selection. All burn-in
                          and DVB-Sub font settings must match.

                          - **OutlineColor** *(string) --* Specifies font outline color. This option
                          is not valid for source captions that are either 608/embedded or teletext.
                          These source settings are already pre-defined by the caption stream. All
                          burn-in and DVB-Sub font settings must match.

                          - **OutlineSize** *(integer) --* Specifies font outline size in pixels.
                          This option is not valid for source captions that are either 608/embedded
                          or teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                          the captions. All burn-in and DVB-Sub font settings must match.

                          - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow.
                          255 is opaque; 0 is transparent. Leaving this parameter blank is
                          equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                          settings must match.

                          - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                          must match.

                          - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels above the text. All burn-in and DVB-Sub font
                          settings must match.

                          - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                          standard or for hearing impaired. Choose hearing impaired if your
                          subtitles include audio descriptions and dialogue. Choose standard if your
                          subtitles include only dialogue.

                          - **TeletextSpacing** *(string) --* Only applies to jobs with input
                          captions in Teletext or STL formats. Specify whether the spacing between
                          letters in your captions is set by the captions grid or varies depending
                          on letter width. Choose fixed grid to conform to the spacing specified in
                          the captions file more accurately. Choose proportional to make the text
                          easier to read if the captions are closed caption.

                          - **XPosition** *(integer) --* Specifies the horizontal position of the
                          caption relative to the left side of the output in pixels. A value of 10
                          would result in the captions starting 10 pixels from the left of the
                          output. If no explicit x_position is provided, the horizontal caption
                          position will be determined by the alignment parameter. This option is not
                          valid for source captions that are STL, 608/embedded or teletext. These
                          source settings are already pre-defined by the caption stream. All burn-in
                          and DVB-Sub font settings must match.

                          - **YPosition** *(integer) --* Specifies the vertical position of the
                          caption relative to the top of the output in pixels. A value of 10 would
                          result in the captions starting 10 pixels from the top of the output. If
                          no explicit y_position is provided, the caption will be positioned towards
                          the bottom of the output. This option is not valid for source captions
                          that are STL, 608/embedded or teletext. These source settings are already
                          pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                          must match.

                        - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                        embedded/ancillary caption outputs, including 608/708 Channel destination
                        number.

                          - **Destination608ChannelNumber** *(integer) --* Ignore this setting
                          unless your input captions are SCC format and your output captions are
                          embedded in the video stream. Specify a CC number for each captions
                          channel in this output. If you have two channels, choose CC numbers that
                          aren't in the same field. For example, choose 1 and 3. For more
                          information, see
                          https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                          - **Destination708ServiceNumber** *(integer) --* Ignore this setting
                          unless your input captions are SCC format and you want both 608 and 708
                          captions embedded in your output stream. Optionally, specify the 708
                          service number for each output captions channel. Choose a different number
                          for each channel. To use this setting, also set Force 608 to 708 upconvert
                          (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
                          settings. If you choose to upconvert but don't specify a 708 service
                          number, MediaConvert uses the number that you specify for CC channel
                          number (destination608ChannelNumber) for the 708 service number. For more
                          information, see
                          https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                        - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                        outputs.

                          - **StylePassthrough** *(string) --* Keep this setting enabled to have
                          MediaConvert use the font style and position information from the captions
                          source in the output. This option is available only when your input
                          captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
                          simplified output captions.

                        - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                          - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to
                          make sure that the captions and the video are synchronized in the output.
                          Specify a frame rate that matches the frame rate of the associated video.
                          If the video frame rate is 29.97, choose 29.97 dropframe
                          (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
                          drop_frame_timecode=
                              true; otherwise, choose 29.97 non-dropframe
                          (FRAMERATE_29_97_NON_DROPFRAME).

                        - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                        output

                          - **PageNumber** *(string) --* Set pageNumber to the Teletext page number
                          for the destination captions for this output. This value must be a
                          three-digit hexadecimal string; strings ending in -FF are invalid. If you
                          are passing through the entire set of Teletext data, do not use this
                          field.

                          - **PageTypes** *(list) --* Specify the page types for this Teletext page.
                          If you don't specify a value here, the service sets the page type to the
                          default value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the
                          entire set of Teletext data, don't use this field. When you pass through a
                          set of Teletext pages, your output has the same page types as your input.

                            - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                            Table 94

                        - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                        outputs, including Pass style information (TtmlStylePassthrough).

                          - **StylePassthrough** *(string) --* Pass through style and position
                          information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                          CFF-TT output or TTML output.

                      - **LanguageCode** *(string) --* Specify the language of this captions output
                      track. For most captions output formats, the encoder puts this language
                      information in the output captions metadata. If your output captions format is
                      DVB-Sub or Burn in, the encoder uses this language information to choose the
                      font language for rendering the captions text.

                      - **LanguageDescription** *(string) --* Specify a label for this set of output
                      captions. For example, "English", "Director commentary", or "track_2". For
                      streaming outputs, MediaConvert passes this information into destination
                      manifests for display on the end-viewer's player device. For outputs in other
                      output groups, the service ignores this setting.

                  - **ContainerSettings** *(dict) --* Container specific settings.

                    - **Container** *(string) --* Container for this output. Some containers require
                    a container settings object. If not specified, the default object will be
                    created.

                    - **F4vSettings** *(dict) --* Settings for F4v container

                      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV
                      atom is relocated to the beginning of the archive as required for progressive
                      downloading. Otherwise it is placed normally at the end.

                    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to
                    outputs in a File output group when the output's container (ContainerType) is
                    MPEG-2 Transport Stream (M2TS). In these assets, data is organized by the
                    program map table (PMT). Each transport stream program contains subsets of data,
                    including audio, video, and metadata. Each of these subsets of data has a
                    numerical label called a packet identifier (PID). Each transport stream program
                    corresponds to one MediaConvert output. The PMT lists the types of data in a
                    program along with their PID. Downstream systems and players use the program map
                    table to look up the PID for each type of data it accesses and then uses the
                    PIDs to locate specific data within the asset.

                      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                      models for Dolby Digital audio.

                      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert
                      for each PES packet.

                      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                      elementary audio streams you include in this output. Specify multiple PIDs as
                      a JSON array. Default is the range 482-492.

                        - *(integer) --*

                      - **Bitrate** *(integer) --* Specify the output bitrate of the transport
                      stream in bits per second. Setting to 0 lets the muxer automatically determine
                      the appropriate bitrate. Other common values are 3750000, 7500000, and
                      15000000.

                      - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                      interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                      this can lead to lower latency, but low-memory devices may not be able to play
                      back the stream without interruptions.

                      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT)
                      at the specified table repetition interval.

                        - **NetworkId** *(integer) --* The numeric value placed in the Network
                        Information Table (NIT).

                        - **NetworkName** *(string) --* The network name text placed in the
                        network_name_descriptor inside the Network Information Table. Maximum length
                        is 256 characters.

                        - **NitInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT)
                      at the specified table repetition interval.

                        - **OutputSdt** *(string) --* Selects method of inserting SDT information
                        into output stream. "Follow input SDT" copies SDT information from input
                        stream to output stream. "Follow input SDT if present" copies SDT
                        information from input stream to output stream if SDT information is present
                        in the input, otherwise it will fall back on the user-defined values. Enter
                        "SDT Manually" means user will enter the SDT information. "No SDT" means
                        output stream will not contain SDT information.

                        - **SdtInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                        - **ServiceName** *(string) --* The service name placed in the
                        service_descriptor in the Service Description Table. Maximum length is 256
                        characters.

                        - **ServiceProviderName** *(string) --* The service provider name placed in
                        the service_descriptor in the Service Description Table. Maximum length is
                        256 characters.

                      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                      subtitle data included in this output. Specify multiple PIDs as a JSON array.
                      Default is the range 460-479.

                        - *(integer) --*

                      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                      specified table repetition interval.

                        - **TdtInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for
                      DVB teletext data you include in this output. Default is 499.

                      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS,
                      audio EBP markers will be added to partitions 3 and 4. The interval between
                      these additional markers will be fixed, and will be slightly shorter than the
                      video EBP marker interval. When set to VIDEO_INTERVAL, these additional
                      markers will not be inserted. Only applicable when EBP segmentation markers
                      are is selected (segmentationMarkers is EBP or EBP_LEGACY).

                      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on.
                      They can either be placed only on the video PID, or on both the video PID and
                      all audio PIDs. Only applicable when EBP segmentation markers are is selected
                      (segmentationMarkers is EBP or EBP_LEGACY).

                      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field
                      in the PES header.

                      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT)
                      unless you know that your audio EBP markers are incorrectly appearing before
                      your video EBP markers. To correct this problem, set this value to Force
                      (FORCE).

                      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                      used with EBP markers.

                      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                      between Program Clock References (PCRs) inserted into the transport stream.

                      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                      Points do not come within the specified time interval of each other by looking
                      ahead at input video. If another EBP is going to come in within the specified
                      time interval, the current EBP is not emitted, and the segment is "stretched"
                      to the next marker. The lookahead value does not add latency to the system.
                      The Live Event must be configured elsewhere to create sufficient latency to
                      make the lookahead accurate.

                      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                      tracking will be detected in the input audio and an equivalent ID3 tag will be
                      inserted in the output.

                      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                      packets to insert into the transport stream. This can be used if a downstream
                      encryption system requires periodic null packets.

                      - **PatInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program
                      Clock Reference value is inserted for every Packetized Elementary Stream (PES)
                      header. This is effective only when the PCR PID is the same as the video or
                      audio elementary stream.

                      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the
                      program clock reference (PCR) in this output. If you do not specify a value,
                      the service will use the value for Video PID (VideoPid).

                      - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                      instances of the program map table (PMT) in the output transport stream.

                      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the
                      program map table (PMT) itself. Default is 480.

                      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of
                      the private metadata stream. Default is 503.

                      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to
                      specify the program number used in the program map table (PMT) for this
                      output. Default is 1. Program numbers and program map tables are parts of
                      MPEG-2 transport stream containers, used for organizing data.

                      - **RateMode** *(string) --* When set to CBR, inserts null packets into
                      transport stream to fill specified bitrate. When set to VBR, the bitrate
                      setting acts as the maximum bitrate, but the output will not be padded up to
                      that bitrate.

                      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                      markers in your HLS and transport stream outputs at the insertion points that
                      you specify in an ESAM XML document. Provide the document in the setting SCC
                      XML (sccXml).

                        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35
                        stream in the transport stream generated by ESAM.

                      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the
                      SCTE-35 stream in the transport stream.

                      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                      Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your
                      input to also appear in this output. Choose None (NONE) if you don't want
                      SCTE-35 markers in this output. For SCTE-35 markers from an ESAM XML
                      document-- Choose None (NONE). Also provide the ESAM XML as a string in the
                      setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
                      (include the property scte35Esam).

                      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                      segmentation_time period. rai_segstart sets the Random Access Indicator bit in
                      the adaptation field. rai_adapt sets the RAI bit and adds the current timecode
                      in the private data bytes. psi_segstart inserts PAT and PMT tables at the
                      start of segments. ebp adds Encoder Boundary Point information to the
                      adaptation field as per OpenCable specification OC-SP-EBP-I01-130118.
                      ebp_legacy adds Encoder Boundary Point information to the adaptation field
                      using a legacy proprietary format.

                      - **SegmentationStyle** *(string) --* The segmentation style parameter
                      controls how segmentation markers are inserted into the transport stream. With
                      avails, it is possible that segments may be truncated, which can influence
                      where future segmentation markers are inserted. When a segmentation style of
                      "reset_cadence" is selected and a segment is truncated due to an avail, we
                      will reset the segmentation cadence. This means the subsequent segment will
                      have a duration of of $segmentation_time seconds. When a segmentation style of
                      "maintain_cadence" is selected and a segment is truncated due to an avail, we
                      will not reset the segmentation cadence. This means the subsequent segment
                      will likely be truncated as well. However, all segments after that will have a
                      duration of $segmentation_time seconds. Note that EBP lookahead is a slight
                      exception to this rule.

                      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                      segment. Required unless markers is set to _none_.

                      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                      timed metadata in this output. Default is 502.

                      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                      itself in the program map table for this output. Transport stream IDs and
                      program map tables are parts of MPEG-2 transport stream containers, used for
                      organizing data.

                      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                      elementary video stream in the transport stream.

                    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert
                      for each PES packet.

                      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                      stream(s) in the transport stream. Multiple values are accepted, and can be
                      entered in ranges and/or by comma separation.

                        - *(integer) --*

                      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                      tracking will be detected in the input audio and an equivalent ID3 tag will be
                      inserted in the output.

                      - **PatInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program
                      Clock Reference value is inserted for every Packetized Elementary Stream (PES)
                      header. This parameter is effective only when the PCR PID is the same as the
                      video or audio elementary stream.

                      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock
                      Reference (PCR) in the transport stream. When no value is given, the encoder
                      will assign the same value as the Video PID.

                      - **PmtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                      (PMT) in the transport stream.

                      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                      metadata stream in the transport stream.

                      - **ProgramNumber** *(integer) --* The value of the program number field in
                      the Program Map Table.

                      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                      in the transport stream.

                      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                      Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your
                      input to also appear in this output. Choose None (NONE) if you don't want
                      SCTE-35 markers in this output. For SCTE-35 markers from an ESAM XML
                      document-- Choose None (NONE) if you don't want manifest conditioning. Choose
                      Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want
                      manifest conditioning. In both cases, also provide the ESAM XML as a string in
                      the setting Signal processing notification XML (sccXml).

                      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this
                      setting to specify whether the service inserts the ID3 timed metadata from the
                      input in this output.

                      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                      metadata stream in the transport stream.

                      - **TransportStreamId** *(integer) --* The value of the transport stream ID
                      field in the Program Map Table.

                      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                      stream in the transport stream.

                    - **MovSettings** *(dict) --* Settings for MOV Container.

                      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate
                      for the video output settings.

                      - **CslgAtom** *(string) --* When enabled, file composition times will start
                      at zero, composition times in the 'ctts' (composition time to sample) box for
                      B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                      will be included per 14496-1 amendment 1. This improves compatibility with
                      Apple players and tools.

                      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                      streams into the QuickTime file using XDCAM fourcc codes. This increases
                      compatibility with Apple editors and players, but may decrease compatibility
                      with other players. Only applicable when the video codec is MPEG2.

                      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                      padding

                      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED)
                      for this setting.

                    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create
                    audio-only AAC outputs with this container.

                      - **CslgAtom** *(string) --* When enabled, file composition times will start
                      at zero, composition times in the 'ctts' (composition time to sample) box for
                      B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                      will be included per 14496-1 amendment 1. This improves compatibility with
                      Apple players and tools.

                      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after
                      the moov box.

                      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV
                      atom is relocated to the beginning of the archive as required for progressive
                      downloading. Otherwise it is placed normally at the end.

                      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the
                      output file. Usually not necessary to specify.

                    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                      - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                      groups that include sidecar TTML or IMSC captions. You specify sidecar
                      captions in a separate output from your audio and video. Choose Raw (RAW) for
                      captions in a single XML file in a raw container. Choose Fragmented MPEG-4
                      (FRAGMENTED_MP4) for captions in XML format contained within fragmented MP4
                      files. This set of fragmented MP4 files is separate from your video and audio
                      fragmented MP4 files.

                      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                      markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                      insertion points that you specify in an ESAM XML document. Provide the
                      document in the setting SCC XML (sccXml).

                      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                      markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                      SCTE-35 markers that appear in your input to also appear in this output.
                      Choose None (NONE) if you don't want those SCTE-35 markers in this output.

                  - **Extension** *(string) --* Use Extension (Extension) to specify the file
                  extension for outputs in File output groups. If you do not specify a value, the
                  service will use default extensions by container type as follows * MPEG-2
                  transport stream, m2ts * Quicktime, mov * MXF container, mxf * MPEG-4 container,
                  mp4 * No Container, the service will use codec extensions (e.g. AAC, H265, H265,
                  AC3)

                  - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the
                  service add a string to the end of each output filename. You specify the base
                  filename as part of your destination URI. When you create multiple outputs in the
                  same output group, Name modifier (NameModifier) is required. Name modifier also
                  accepts format identifiers. For DASH ISO outputs, if you use the format
                  identifiers $Number$ or $Time$ in one output, you must use them in the same way in
                  all outputs of the output group.

                  - **OutputSettings** *(dict) --* Specific settings for this type of output.

                    - **HlsSettings** *(dict) --* Settings for HLS output groups

                      - **AudioGroupId** *(string) --* Specifies the group to which the audio
                      Rendition belongs.

                      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                      outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                      container. Keep the default value Automatic (AUTOMATIC) to create an
                      audio-only file in a raw container. Regardless of the value that you specify
                      here, if this output has video, the service will place the output into an
                      MPEG2-TS container.

                      - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                      with the video output stream. Input all the audio GROUP-IDs that are
                      associated to the video, separate by ','.

                      - **AudioTrackType** *(string) --* Four types of audio-only tracks are
                      supported: Audio-Only Variant Stream The client can play back this audio-only
                      stream instead of video in low-bandwidth scenarios. Represented as an
                      EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select, Default
                      Alternate rendition that the client should try to play back by default.
                      Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES,
                      AUTOSELECT=
                          YES Alternate Audio, Auto Select, Not Default Alternate rendition
                      that the client may try to play back by default. Represented as an EXT-X-MEDIA
                      in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                          YES Alternate Audio, not Auto
                      Select Alternate rendition that the client will not try to play back by
                      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
                      AUTOSELECT=NO

                      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame
                      Only Manifest in addition to the HLS manifest

                      - **SegmentModifier** *(string) --* String concatenated to end of segment
                      filenames. Accepts "Format Identifiers":#format_identifier_parameters.

                  - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
                  transcoding settings. Provide the system or custom preset name. You can specify
                  either Preset (Preset) or Container settings (ContainerSettings), but not both.

                  - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
                  encoding settings. The specific video settings depend on the video codec that you
                  choose when you specify a value for Video codec (codec). Include one instance of
                  (VideoDescription) per output.

                    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                    MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                    service includes AFD values in the output video data and what those values are.
                    * Choose None to remove all AFD values from this output. * Choose Fixed to
                    ignore input AFD values and instead encode the value specified in the job. *
                    Choose Auto to calculate output AFD values based on the input AFD scaler data.

                    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to
                    all outputs. The service no longer accepts the value DISABLED for AntiAlias. If
                    you specify that in your job, the service will ignore the setting.

                    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                    (VideoDescription), contains the group of settings related to video encoding.
                    The settings in this group vary depending on the value that you choose for Video
                    codec (Codec). For each codec enum that you choose, define the corresponding
                    settings object. The following lists the codec enum, settings object pairs. *
                    H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
                    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

                      - **Codec** *(string) --* Specifies the video codec. This must be equal to one
                      of the enum values defined by the object VideoCodec.

                      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                        - **FramerateDenominator** *(integer) --* Frame capture will encode the
                        first frame of the output stream, then one frame every
                        framerateDenominator/framerateNumerator seconds. For example, settings of
                        framerateNumerator = 1 and framerateDenominator =
                             3 (a rate of 1/3 frame per
                        second) will capture the first frame, then 1 frame every 3s. Files will be
                        named as filename.n.jpg where n is the 0-based sequence number of each
                        Capture.

                        - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                        frame of the output stream, then one frame every
                        framerateDenominator/framerateNumerator seconds. For example, settings of
                        framerateNumerator = 1 and framerateDenominator =
                             3 (a rate of 1/3 frame per
                        second) will capture the first frame, then 1 frame every 3s. Files will be
                        named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number
                        zero padded to 7 decimal places.

                        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg
                        output files).

                        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                        quality.

                      - **H264Settings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value H_264.

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent
                        with your output video settings. If you aren't sure what level to specify,
                        choose Auto (AUTO).

                        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit
                        profiles are only available with the AVC-I License.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must
                        be in Main or High profile) or CAVLC.

                        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF
                        encoding for interlaced outputs.

                        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame to reduce flicker or 'pop' on I-frames.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job specification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* When you use the API for transcode
                        jobs that use frame rate conversion, specify the frame rate as a fraction.
                        For example, 24000 / 1001 =
                             23.976 fps. Use FramerateDenominator to specify
                        the denominator of this fraction. In this example, use 1001 for the value of
                        FramerateDenominator. When you use the console for transcode jobs that use
                        frame rate conversion, provide the value as a decimal number for Framerate.
                        In this example, specify 23.976.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                        structures that have B frames > 1.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type, as follows. - If the source is
                        interlaced, the output will be interlaced with the same polarity as the
                        source (it will follow the source). The output could therefore be a mix of
                        "top field first" and "bottom field first". - If the source is progressive,
                        the output will be interlaced with "top field first" or "bottom field first"
                        polarity, depending on which of the Follow options you chose.

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000. Required when Rate control mode
                        is QVBR.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **NumberReferenceFrames** *(integer) --* Number of reference frames to
                        use. The encoder may use more than requested if using B-frames and/or
                        interlaced encoding.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                        high-quality singlepass, or high-quality multipass video encoding.

                        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                        encoding with the H.264 codec. Required when you set Rate control mode to
                        QVBR. Not valid when you set Rate control mode to a value other than QVBR,
                        or when you don't define Rate control mode.

                          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                          control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                          average bitrate values suited to the complexity of your input video, the
                          service limits the average bitrate of the video part of this output to the
                          value that you choose. That is, the total size of the video element is
                          less than or equal to the value you set multiplied by the number of
                          seconds of encoded output.

                          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                          control mode. That is, when you specify qvbrSettings within h264Settings.
                          Specify the target quality level for this output, from 1 to 10. Use higher
                          numbers for greater quality. Level 10 results in nearly lossless
                          compression. The quality level for most broadcast-quality transcodes is
                          between 6 and 9.

                        - **RateControlMode** *(string) --* Use this setting to specify whether this
                        output has a variable bitrate (VBR), constant bitrate (CBR) or
                        quality-defined variable bitrate (QVBR).

                        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture,
                        even if repeated.

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default. If this output uses QVBR, choose
                        Transition detection (TRANSITION_DETECTION) for further video quality
                        improvement. For more information about QVBR, see
                        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                        - **Slices** *(integer) --* Number of slices per picture. Must be less than
                        or equal to the number of macroblock rows for progressive pictures, and less
                        than or equal to half the number of macroblock rows for interlaced pictures.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                        values reduce high-frequency content in the encoded image.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE
                        RP-2027.

                        - **Telecine** *(string) --* This field applies only if the Streams >
                        Advanced > Framerate (framerate) field is set to 29.970. This field works
                        with the Streams > Advanced > Preprocessors > Deinterlacer field
                        (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
                        (interlace_mode) to identify the scan type for the output: Progressive,
                        Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
                        from 23.976 input. - Soft: produces 23.976; the player converts this output
                        to 29.97i.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame
                        as 4 bytes of an unregistered SEI message.

                      - **H265Settings** *(dict) --* Settings for H265 codec

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                        Function SEI message for outputs using Hybrid Log Gamma (HLG)
                        Electro-Optical Transfer Function (EOTF).

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* H.265 Level.

                        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the
                        HEVC (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                        "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                        available with the HEVC 4:2:2 License.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame to reduce flicker or 'pop' on I-frames.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                        structures that have B frames > 1.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                        Choose Progressive (PROGRESSIVE) to create a progressive output, regardless
                        of the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom
                        Field First (BOTTOM_FIELD) to create an output that's interlaced with the
                        same field polarity throughout. Choose Follow, Default Top
                        (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
                        an interlaced output with the same field polarity as the source. If the
                        source is interlaced, the output will be interlaced with the same polarity
                        as the source (it will follow the source). The output could therefore be a
                        mix of "top field first" and "bottom field first". If the source is
                        progressive, your output will be interlaced with "top field first" or
                        "bottom field first" polarity, depending on which of the Follow options you
                        chose. If you don't choose a value, the service will default to Progressive
                        (PROGRESSIVE).

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000. Required when Rate control mode
                        is QVBR.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **NumberReferenceFrames** *(integer) --* Number of reference frames to
                        use. The encoder may use more than requested if using B-frames and/or
                        interlaced encoding.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                        high-quality singlepass, or high-quality multipass video encoding.

                        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                        encoding with the H.265 codec. Required when you set Rate control mode to
                        QVBR. Not valid when you set Rate control mode to a value other than QVBR,
                        or when you don't define Rate control mode.

                          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                          control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                          average bitrate values suited to the complexity of your input video, the
                          service limits the average bitrate of the video part of this output to the
                          value that you choose. That is, the total size of the video element is
                          less than or equal to the value you set multiplied by the number of
                          seconds of encoded output.

                          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                          control mode. That is, when you specify qvbrSettings within h265Settings.
                          Specify the target quality level for this output, from 1 to 10. Use higher
                          numbers for greater quality. Level 10 results in nearly lossless
                          compression. The quality level for most broadcast-quality transcodes is
                          between 6 and 9.

                        - **RateControlMode** *(string) --* Use this setting to specify whether this
                        output has a variable bitrate (VBR), constant bitrate (CBR) or
                        quality-defined variable bitrate (QVBR).

                        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                        Offset (SAO) filter strength. Adaptive mode dynamically selects best
                        strength based on content

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default. If this output uses QVBR, choose
                        Transition detection (TRANSITION_DETECTION) for further video quality
                        improvement. For more information about QVBR, see
                        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                        - **Slices** *(integer) --* Number of slices per picture. Must be less than
                        or equal to the number of macroblock rows for progressive pictures, and less
                        than or equal to half the number of macroblock rows for interlaced pictures.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Telecine** *(string) --* This field applies only if the Streams >
                        Advanced > Framerate (framerate) field is set to 29.970. This field works
                        with the Streams > Advanced > Preprocessors > Deinterlacer field
                        (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
                        (interlace_mode) to identify the scan type for the output: Progressive,
                        Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
                        from 23.976 input. - Soft: produces 23.976; the player converts this output
                        to 29.97i.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                        encoded bitstream. Up to 3 layers are supported depending on GOP structure:
                        I- and P-frames form one layer, reference B-frames can form a second layer
                        and non-reference b-frames can form a third layer. Decoders can optionally
                        decode only the lower temporal layers to generate a lower frame rate output.
                        For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e.
                        IbPbPb display order), a decoder could decode all the frames for full frame
                        rate output or only the I and P frames (lowest temporal layer) for a half
                        frame rate output.

                        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well
                        as vertical subdivision of the encoded pictures.

                        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame
                        as 4 bytes of an unregistered SEI message.

                        - **WriteMp4PackagingType** *(string) --* If the location of parameter set
                        NAL units doesn't matter in your workflow, ignore this setting. Use this
                        setting only with CMAF or DASH outputs, or with standalone file outputs in
                        an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your output as HVC1.
                        This makes your output compliant with the following specification: ISO
                        IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
                        outputs, the service stores parameter set NAL units in the sample headers
                        but not in the samples directly. For MP4 outputs, when you choose HVC1, your
                        output video might not work properly with some downstream systems and video
                        players. The service defaults to marking your output as HEV1. For these
                        outputs, the service writes parameter set NAL units directly into the
                        samples.

                      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value MPEG2.

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                        level for the video output.

                        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                        MPEG-2 profile for the video output.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type. - If the source is interlaced, the
                        output will be interlaced with the same polarity as the source (it will
                        follow the source). The output could therefore be a mix of "top field first"
                        and "bottom field first". - If the source is progressive, the output will be
                        interlaced with "top field first" or "bottom field first" polarity,
                        depending on which of the Follow options you chose.

                        - **IntraDcPrecision** *(string) --* Use Intra DC precision
                        (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                        coefficients. If you choose the value auto, the service will automatically
                        select the precision based on the per-frame compression ratio.

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or
                        multipass video encoding.

                        - **RateControlMode** *(string) --* Use Rate control mode
                        (Mpeg2RateControlMode) to specifiy whether the bitrate is variable (vbr) or
                        constant (cbr).

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                        values reduce high-frequency content in the encoded image.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                        356M-2001).

                        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                        Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard)
                        to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                        produce 23.976 output and leave converstion to the player.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                      - **ProresSettings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value PRORES.

                        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to
                        specifiy the type of Apple ProRes codec to use for this output.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* When you use the API for transcode
                        jobs that use frame rate conversion, specify the frame rate as a fraction.
                        For example, 24000 / 1001 =
                             23.976 fps. Use FramerateNumerator to specify
                        the numerator of this fraction. In this example, use 24000 for the value of
                        FramerateNumerator.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type. - If the source is interlaced, the
                        output will be interlaced with the same polarity as the source (it will
                        follow the source). The output could therefore be a mix of "top field first"
                        and "bottom field first". - If the source is progressive, the output will be
                        interlaced with "top field first" or "bottom field first" polarity,
                        depending on which of the Follow options you chose.

                        - **ParControl** *(string) --* Use (ProresParControl) to specify how the
                        service determines the pixel aspect ratio. Set to Follow source
                        (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio from the input. To
                        specify a different pixel aspect ratio: Using the console, choose it from
                        the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
                        provide for (ParNumerator) and (ParDenominator).

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                        Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard
                        (hard) to produce a 29.97i output from a 23.976 input. Set it to Soft (soft)
                        to produce 23.976 output and leave converstion to the player.

                    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to
                    include color metadata in this output. Choose Ignore (IGNORE) to exclude color
                    metadata from this output. If you don't specify a value, the service sets this
                    to Insert by default.

                    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area
                    that the service will include in the output video frame.

                      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                      numbers.

                      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                      numbers.

                      - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                      left edge of the video frame. Specify only even numbers.

                      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                      top edge of the video frame. Specify only even numbers.

                    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When
                    this feature is enabled, the service will use drop-frame timecode on outputs. If
                    it is not possible to use drop-frame timecode, the system will fall back to
                    non-drop-frame. This setting is enabled by default when Timecode insertion
                    (TimecodeInsertion) is enabled.

                    - **FixedAfd** *(integer) --* Applies only if you set AFD
                    Signaling(AfdSignaling) to Fixed (FIXED). Use Fixed (FixedAfd) to specify a
                    four-bit AFD value which the service will write on all frames of this video
                    output.

                    - **Height** *(integer) --* Use the Height (Height) setting to define the video
                    resolution height for this output. Specify in pixels. If you don't provide a
                    value here, the service will use the input height.

                    - **Position** *(dict) --* Use Selection placement (position) to define the
                    video area in your output frame. The area outside of the rectangle that you
                    specify here is black.

                      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                      numbers.

                      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                      numbers.

                      - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                      left edge of the video frame. Specify only even numbers.

                      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                      top edge of the video frame. Specify only even numbers.

                    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify
                    how the service changes the video itself in response to AFD values in the input.
                    * Choose Respond to clip the input video frame according to the AFD value, input
                    display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                    include the input AFD values. Do not choose this when AfdSignaling is set to
                    (NONE). A preferred implementation of this workflow is to set RespondToAfd to
                    (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
                    values from this output.

                    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                    have a different aspect ratio from the input aspect ratio. Choose Stretch to
                    output (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit.
                    Keep the setting Default (DEFAULT) to have the service letterbox your video
                    instead. This setting overrides any value that you specify for the setting
                    Selection placement (position) in this output.

                    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                    strength of anti-aliasing. This setting changes the width of the anti-alias
                    filter kernel used for scaling. Sharpness only applies if your output resolution
                    is different from your input resolution. 0 is the softest setting, 100 the
                    sharpest, and 50 recommended for most content.

                    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                    ProRes outputs. Only enable Timecode insertion when the input frame rate is
                    identical to the output frame rate. To include timecodes in this output, set
                    Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them
                    out, set it to DISABLED. Default is DISABLED. When the service inserts timecodes
                    in an output, by default, it uses any embedded timecodes from the input. If none
                    are present, the service will set the timecode for the first output frame to
                    zero. To change this default behavior, adjust the settings under Timecode
                    configuration (TimecodeConfig). In the console, these settings are located under
                    Job > Job settings > Timecode configuration. Note - Timecode source under input
                    settings (InputTimecodeSource) does not affect the timecodes that are inserted
                    in the output. Source under Job settings > Timecode configuration
                    (TimecodeSource) does.

                    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                    Preprocessors (VideoPreprocessors). Enable the features at each output
                    individually. These features are disabled by default.

                      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                      feature if necessary. Enable or disable this feature for each output
                      individually. This setting is disabled by default.

                        - **Brightness** *(integer) --* Brightness level.

                        - **ColorSpaceConversion** *(string) --* Specify the color space you want
                        for this output. The service supports conversion between HDR formats,
                        between SDR formats, and from SDR to HDR. The service doesn't support
                        conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
                        dynamic range. The converted video has an HDR format, but visually appears
                        the same as an unconverted output.

                        - **Contrast** *(integer) --* Contrast level.

                        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the
                        HDR 10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume
                        static metadata that you want signaled in the output. These values don't
                        affect the pixel values that are encoded in the video stream. They are
                        intended to help the downstream video player display content in a way that
                        reflects the intentions of the the content creator. When you set Color space
                        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings
                        are required. You must set values for Max frame average light level
                        (maxFrameAverageLightLevel) and Max content light level
                        (maxContentLightLevel); these settings don't have a default value. The
                        default values for the other HDR 10 metadata settings are defined by the
                        P3D65 color space. For more information about MediaConvert HDR jobs, see
                        https://docs.aws.amazon.com/console/mediaconvert/hdr.

                          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                          samples in the coded video sequence, in units of candelas per square
                          meter. This setting doesn't have a default value; you must specify a value
                          that is suitable for the content.

                          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level
                          of any frame in the coded video sequence, in units of candelas per square
                          meter. This setting doesn't have a default value; you must specify a value
                          that is suitable for the content.

                          - **MaxLuminance** *(integer) --* Nominal maximum mastering display
                          luminance in units of of 0.0001 candelas per square meter.

                          - **MinLuminance** *(integer) --* Nominal minimum mastering display
                          luminance in units of of 0.0001 candelas per square meter

                          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **WhitePointX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **WhitePointY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                        - **Hue** *(integer) --* Hue in degrees.

                        - **Saturation** *(integer) --* Saturation level.

                      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce
                      smoother motion and a clearer picture.

                        - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                        (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE).
                        Motion adaptive interpolate (INTERPOLATE) produces sharper pictures, while
                        blend (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR
                        (BLEND_TICKER) if your source file includes a ticker, such as a scrolling
                        headline at the bottom of the frame.

                        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                        does not convert frames that are tagged in metadata as progressive. It will
                        only convert those that are tagged as some other type. - When set to
                        FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive -
                        even those that are already tagged as progressive. Turn Force mode on only
                        if there is a good chance that the metadata has tagged frames as progressive
                        when they are not progressive. Do not turn on otherwise; processing frames
                        that are already progressive into progressive will probably result in lower
                        quality video.

                        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how
                        the service will do deinterlacing. Default is Deinterlace. - Deinterlace
                        converts interlaced to progressive. - Inverse telecine converts Hard
                        Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects and converts
                        to progressive.

                      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby
                      Vision compatible video output.

                        - **L6Metadata** *(dict) --* Use these settings when you set
                        DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values
                        in your input with new values.

                          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR
                          metadata that corresponds to the brightest pixel in the entire stream.
                          Measured in nits.

                          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                          metadata that corresponds to the highest frame-average brightness in the
                          entire stream. Measured in nits.

                        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service
                        will handle Dolby Vision MaxCLL and MaxFALL properies.

                        - **Profile** *(string) --* In the current MediaConvert implementation, the
                        Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs
                        must contain Dolby Vision frame interleaved data.

                      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter)
                      feature to include a graphic overlay on your video. Enable or disable this
                      feature for each output individually. This setting is disabled by default.

                        - **InsertableImages** *(list) --* Specify the images that you want to
                        overlay on your video. The images must be PNG or TGA files.

                          - *(dict) --* Settings that specify how your still graphic overlay
                          appears.

                            - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                            image to remain on the output video. This duration includes fade-in time
                            but not fade-out time.

                            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                            between the Start time that you specify for the image insertion and the
                            time that the image appears at full opacity. Full opacity is the level
                            that you specify for the opacity setting. If you don't specify a value
                            for Fade-in, the image will appear abruptly at the overlay start time.

                            - **FadeOut** *(integer) --* Specify the length of time, in
                            milliseconds, between the end of the time that you have specified for
                            the image overlay Duration and when the overlaid image has faded to
                            total transparency. If you don't specify a value for Fade-out, the image
                            will disappear abruptly at the end of the inserted image duration.

                            - **Height** *(integer) --* Specify the height of the inserted image in
                            pixels. If you specify a value that's larger than the video resolution
                            height, the service will crop your overlaid image to fit. To use the
                            native height of the image, keep this setting blank.

                            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or
                            Amazon S3 location of the image that you want to overlay on the video.
                            Use a PNG or TGA file.

                            - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                            inserted image and the left edge of the video frame. Required for any
                            image overlay that you specify.

                            - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                            overlaid image and the top edge of the video frame. Required for any
                            image overlay that you specify.

                            - **Layer** *(integer) --* Specify how overlapping inserted images
                            appear. Images with higher values for Layer appear on top of images with
                            lower values for Layer.

                            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much
                            of the underlying video shows through the inserted image. 0 is
                            transparent and 100 is fully opaque. Default is 50.

                            - **StartTime** *(string) --* Specify the timecode of the frame that you
                            want the overlay to first appear on. This must be in timecode
                            (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take into account your
                            timecode source settings.

                            - **Width** *(integer) --* Specify the width of the inserted image in
                            pixels. If you specify a value that's larger than the video resolution
                            width, the service will crop your overlaid image to fit. To use the
                            native width of the image, keep this setting blank.

                      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature
                      to remove noise from your video output if necessary. Enable or disable this
                      feature for each output individually. This setting is disabled by default.

                        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                        select one of the following spatial image filtering functions. To use this
                        setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                        preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos,
                        and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
                        noise reduction. * Spatial does frequency-domain filtering based on JND
                        principles. * Temporal optimizes video quality for complex motion.

                        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                          - **Strength** *(integer) --* Relative strength of noise reducing filter.
                          Higher values produce stronger filtering.

                        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                        spatial filter.

                          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post
                          noise reduction sharpening filter, with 0 disabling the filter and 3
                          enabling it at maximum strength.

                          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed)
                          to 3 (higher speed), with 0 being the nominal value.

                          - **Strength** *(integer) --* Relative strength of noise reducing filter.
                          Higher values produce stronger filtering.

                        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                        temporal filter.

                          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that
                          has complex motion. Higher values produce stronger temporal filtering.
                          This filters highly complex scenes more aggressively and creates better VQ
                          for low bitrate outputs.

                          - **Speed** *(integer) --* The speed of the filter (higher number is
                          faster). Low setting reduces bit rate at the cost of transcode time, high
                          setting improves transcode time at the cost of bit rate.

                          - **Strength** *(integer) --* Specify the strength of the noise reducing
                          filter on this output. Higher values produce stronger filtering. We
                          recommend the following value ranges, depending on the result that you
                          want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
                          complexity reduction with image preservation * 8-16 for a high level of
                          complexity reduction

                      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                      output timecode and specified prefix into the output.

                        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size
                        of any burned-in timecode. Valid values are 10, 16, 32, 48.

                        - **Position** *(string) --* Use Position (Position) under under Timecode
                        burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                        output video.

                        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters
                        before any burned-in timecode. For example, a prefix of "EZ-" will result in
                        the timecode "EZ-00:00:00:00". Provide either the characters themselves or
                        the ASCII code equivalents. The supported range of characters is 0x20
                        through 0x7e. This includes letters, numbers, and all special characters
                        represented on a standard English keyboard.

                    - **Width** *(integer) --* Use Width (Width) to define the video resolution
                    width, in pixels, for this output. If you don't provide a value here, the
                    service will use the input width.

          - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
          information from inputs.

            - **Anchor** *(string) --* If you use an editing platform that relies on an anchor
            timecode, use Anchor Timecode (Anchor) to specify a timecode that will match the input
            video frame to the output video frame. Use 24-hour format with frame number,
            (HH:MM:SS:FF) or (HH:MM:SS;FF). This setting ignores frame rate conversion. System
            behavior for Anchor Timecode varies depending on your setting for Source
            (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
            (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode
            (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate output
            timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
            is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first
            frame is the timecode value on the first input frame of the input.

            - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
            within this job. To make sure that your video, audio, captions, and markers are
            synchronized and that time-based features, such as image inserter, work correctly,
            choose the Timecode source option that matches your assets. All timecodes are in a
            24-hour format with frame number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode
            that is in the input video. If no embedded timecode is in the source, the service will
            use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) - Set the timecode of the
            initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set the timecode of
            the initial frame to a value other than zero. You use Start timecode (Start) to provide
            this value.

            - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified
            start (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the
            initial frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

            - **TimestampOffset** *(string) --* Only applies to outputs that support
            program-date-time stamp. Use Timestamp offset (TimestampOffset) to overwrite the
            timecode date without affecting the time and frame number. Provide the new date as a
            string in the format "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert
            program-date-time (InsertProgramDateTime) in the output settings. For example, if the
            date part of your timecodes is 2002-1-25 and you want to change it to one year later,
            set Timestamp offset (TimestampOffset) to 2003-1-25.

          - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
          (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you
          must enable it here, enable it in each output container, and specify tags and timecodes in
          ID3 insertion (Id3Insertion) objects.

            - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion
            instances.

              - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3)
              to specify the base 64 encoded string and use Timecode (TimeCode) to specify the time
              when the tag should be inserted. To insert multiple ID3 tags in your output, create
              multiple instances of ID3 insertion (Id3Insertion).

                - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
                format.

                - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or
                HH:MM:SS;FF format.

        - **SimulateReservedQueue** *(string) --* Enable this setting when you run a test job to
        estimate how many reserved transcoding slots (RTS) you need. When this is enabled,
        MediaConvert runs your job from an on-demand queue with similar performance to what you will
        see with one RTS in a reserved queue. This setting is disabled by default.

        - **Status** *(string) --* A job's status can be SUBMITTED, PROGRESSING, COMPLETE, CANCELED,
        or ERROR.

        - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
        events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
        MediaConvert sends an update at this interval from the time the service begins processing
        your job to the time it completes the transcode or encounters an error.

        - **Timing** *(dict) --* Information about when jobs are submitted, started, and finished is
        specified in Unix epoch format in seconds.

          - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
          finished

          - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the
          job began.

          - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the
          job.

        - **UserMetadata** *(dict) --* User-defined metadata that you want to associate with an
        MediaConvert job. You specify metadata in key/value pairs.

          - *(string) --*

            - *(string) --*

    - **NextToken** *(string) --* Use this string to request the next batch of jobs.
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptions` `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsAudioDescriptions` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientListPresetsResponsePresetsSettingsAudioDescriptionsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientListPresetsResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientListPresetsResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientListPresetsResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsAudioDescriptionsTypeDef(
    _ClientListPresetsResponsePresetsSettingsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettings` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsCaptionDescriptionsTypeDef",
    {
        "CustomLanguageCode": str,
        "DestinationSettings": ClientListPresetsResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsCaptionDescriptionsTypeDef(
    _ClientListPresetsResponsePresetsSettingsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettings` `CaptionDescriptions`

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsContainerSettings` `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsContainerSettings` `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsContainerSettings` `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsMovSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsContainerSettings` `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsContainerSettings` `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsContainerSettings` `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientListPresetsResponsePresetsSettingsContainerSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientListPresetsResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientListPresetsResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientListPresetsResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientListPresetsResponsePresetsSettingsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientListPresetsResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientListPresetsResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsContainerSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsContainerSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettings` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescription` `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionCropTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionPositionTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescription` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettingsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientListPresetsResponsePresetsSettingsVideoDescriptionTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientListPresetsResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientListPresetsResponsePresetsSettingsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientListPresetsResponsePresetsSettingsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientListPresetsResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsVideoDescriptionTypeDef(
    _ClientListPresetsResponsePresetsSettingsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresetsSettings` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientListPresetsResponsePresetsSettingsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsSettingsTypeDef",
    {
        "AudioDescriptions": List[ClientListPresetsResponsePresetsSettingsAudioDescriptionsTypeDef],
        "CaptionDescriptions": List[
            ClientListPresetsResponsePresetsSettingsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientListPresetsResponsePresetsSettingsContainerSettingsTypeDef,
        "VideoDescription": ClientListPresetsResponsePresetsSettingsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientListPresetsResponsePresetsSettingsTypeDef(
    _ClientListPresetsResponsePresetsSettingsTypeDef
):
    """
    Type definition for `ClientListPresetsResponsePresets` `Settings`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
    caption settings in a single output.

      - *(dict) --* Caption Description for preset

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientListPresetsResponsePresetsTypeDef = TypedDict(
    "_ClientListPresetsResponsePresetsTypeDef",
    {
        "Arn": str,
        "Category": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "Settings": ClientListPresetsResponsePresetsSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientListPresetsResponsePresetsTypeDef(_ClientListPresetsResponsePresetsTypeDef):
    """
    Type definition for `ClientListPresetsResponse` `Presets`

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **Category** *(string) --* An optional category you create to organize your presets.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for preset creation.

    - **Description** *(string) --* An optional description you create for each preset.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the preset was last
    updated.

    - **Name** *(string) --* A name you create for each preset. Each name must be unique within your
    account.

    - **Settings** *(dict) --* Settings for preset

      - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
      settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
      (AudioDescriptions) can contain multiple groups of encoding settings.

        - *(dict) --* Description of audio output

          - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
          these settings unless you need to comply with a loudness standard.

            - **Algorithm** *(string) --* Choose one of the following audio normalization
            algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness
            for an entire piece of content, suitable for measurement of short-form content under
            ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated
            loudness. A measurement of gated average loudness compliant with the requirements of
            EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified peak. The same
            loudness measurement algorithm as 1770-2, with an updated true peak measurement. ITU-R
            BS.1770-4: Higher channel count. Allows for more audio channels than the other
            algorithms, including configurations such as 7.1.

            - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
            the chosen algorithm. If disabled, the audio will be measured but not adjusted.

            - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
            corrected to the target level. Content measuring below this level will not be corrected.
            Gating only applies when not using real_time_correction.

            - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
            loudness to a CSV file.

            - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
            for each output's audio track loudness.

            - **TargetLkfs** *(float) --* When you use Audio normalization
            (AudioNormalizationSettings), optionally use this setting to specify a target loudness.
            If you don't specify a value here, the encoder chooses a value for you, based on the
            algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
            encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

          - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
          the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
          order within each input. For example if you specify "Audio Selector 3", then the third
          audio selector will be used from each input. If an input does not have an "Audio Selector
          3", then the audio selector marked as "default" in that input will be used. If there is no
          audio selector marked as "default", silence will be inserted for the duration of that
          input. Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be
          specified, with similar default/silence behavior. If no audio_source_name is specified,
          then "Audio Selector 1" will be chosen automatically.

          - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
          (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
          Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
               Visually Impaired Commentary,
          4-255 = Reserved.

          - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
          ISO 639 audio_type, then that value is passed through to the output. If the input contains
          no ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the
          value in Audio Type is included in the output. Note that this field and audioType are both
          ignored if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

          - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
          (AudioDescriptions) contains the group of settings related to audio encoding. The settings
          in this group vary depending on the value that you choose for Audio codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
          WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
          Eac3AtmosSettings

            - **AacSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
            mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
            set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode,
            you control the audio quality with the setting VBR quality (vbrQuality). In CBR mode,
            you use the setting Bitrate (bitrate). Defaults and valid values depend on the rate
            control mode.

              - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
              the input contains pre-mixed main audio + audio description (AD) as a stereo pair. The
              value for AudioType will be set to 3, which signals to downstream systems that this
              stream contains "broadcaster mixed AD". Note that the input received by the encoder
              must contain pre-mixed audio; the encoder does not perform the mixing. When you choose
              BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
              FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
              audio description (AD). In this case, the encoder will use any values you provide for
              AudioType and FollowInputAudioType.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
              of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
              24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000,
              192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000,
              768000, 896000, 1024000. The value you set is also constrained by the values that you
              choose for Profile (codecProfile), Bitrate control mode (codingMode), and Sample rate
              (sampleRate). Default values depend on Bitrate control mode and Profile.

              - **CodecProfile** *(string) --* AAC Profile.

              - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
              layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
              (Receiver Mix)" setting receives a stereo description plus control track and emits a
              mono AAC encode of the description track, with control data emitted in the PES header
              as per ETSI TS 101 154 Annex E.

              - **RateControlMode** *(string) --* Rate Control Mode.

              - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
              LATM/LOAS AAC in an output, you must choose "No container" for the output container.

              - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
              mode and profile.

              - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
              or MPEG-2 Transport Stream containers.

              - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
              VBR.

            - **Ac3Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AC3.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              bitrates depend on the coding mode.

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
              the encoder emits. For more information about the AC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
              channels.

              - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
              audio is Dolby Digital, dialnorm will be passed through.

              - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
              dynamic range compression signaling to the output bitstream as defined in the Dolby
              Digital specification.

              - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior
              to encoding. Only valid with 3_2_LFE coding mode.

              - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
              sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio
              was not supplied from one of these streams, then the static metadata settings will be
              used.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

            - **AiffSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AIFF.

              - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
              choose the encoding quality for this audio track.

              - **Channels** *(integer) --* Specify the number of channels in this output audio
              track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
              on, up to 64.

              - **SampleRate** *(integer) --* Sample rate in hz.

            - **Codec** *(string) --* Type of Audio codec.

            - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              values: 384k, 448k, 640k, 768k

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
              that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
              always 9.1.6 (CODING_MODE_9_1_6).

              - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
              loudness based on dialogue analysis.

              - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
              signal with dynamic range compression.

              - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
              dynamic range when compressing the audio.

              - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
              for downmixing. How the service uses this value depends on the value that you choose
              for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
              -4.5, and -6.0.

              - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
              downmixing. How the service uses this value depends on the value that you choose for
              Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
              -60. The value -60 mutes the channel.

              - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, and -6.0.

              - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
              -6.0, and -60. The value -60 mutes the channel.

              - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
              audio.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

              - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
              be speech before the encoder uses the measured speech loudness as the overall program
              loudness.

              - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

              - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
              center rear surround channel matrix encoded into your left and right surround
              channels.

            - **Eac3Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value EAC3.

              - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
              attenuation to the surround channels. Only used for 3/2 coding mode.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              bitrates depend on the coding mode.

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
              that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
              channels.

              - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

              - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
              audio is Dolby Digital Plus, dialnorm will be passed through.

              - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
              signal with dynamic range compression.

              - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
              dynamic range when compressing the audio.

              - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
              channel is enabled

              - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior
              to encoding. Only valid with 3_2_LFE coding mode.

              - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
              Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only
              if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left only/Right only center (loRoCenterMixLevel).

              - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
              Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
              and -60. The value -60 mutes the channel. This setting applies only if you keep the
              default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
              (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
              Left only/Right only surround (loRoSurroundMixLevel).

              - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
              Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only
              if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left total/Right total center (ltRtCenterMixLevel).

              - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
              Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
              MediaConvert uses this value for downmixing. How the service uses this value depends
              on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
              -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
              only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

              - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
              sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio
              was not supplied from one of these streams, then the static metadata settings will be
              used.

              - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
              be passed through if it is present on the input. this detection is dynamic over the
              life of the transcode. Inputs that alternate between DD+ and non-DD+ content will have
              a consistent DD+ output as the system alternates between passthrough and encoding.

              - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
              surround channels. Only used for 3/2 coding mode.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

              - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
              setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
              (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
              different value for Coding mode, the service ignores Stereo downmix
              (Eac3StereoDownmix).

              - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
              center back surround channel is matrix encoded into the left and right surround
              channels.

              - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround
              is matrix encoded into the two channels.

            - **Mp2Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value MP2.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

              - **Channels** *(integer) --* Set Channels to specify the number of channels in this
              output audio track. Choosing Mono in the console will give you 1 output channel;
              choosing Stereo will give you 2. In the API, valid values are 1 and 2.

              - **SampleRate** *(integer) --* Sample rate in hz.

            - **WavSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value WAV.

              - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
              choose the encoding quality for this audio track.

              - **Channels** *(integer) --* Specify the number of channels in this output audio
              track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
              on, up to 64.

              - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
              output audio is likely to exceed 4 GB in file size, or if you otherwise need the
              extended support of the RF64 format, set your output WAV file format to RF64.

              - **SampleRate** *(integer) --* Sample rate in Hz.

          - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
          The service puts this language code into your output audio track when you set Language
          code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
          also uses your specified custom language code when you set Language code control
          (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
          specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
          streaming outputs, you can also use any other code in the full RFC-5646 specification.
          Streaming outputs are those that are in one of the following output groups: CMAF, DASH
          ISO, Apple HLS, or Microsoft Smooth Streaming.

          - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
          639 language specified in the 'Language Code' drop down will be used when 'Follow Input
          Language Code' is not selected or when 'Follow Input Language Code' is selected but there
          is no ISO 639 language code specified by the input.

          - **LanguageCodeControl** *(string) --* Specify which source for language code takes
          precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
          uses the language code from the input track if it's present. If there's no languge code on
          the input track, the service uses the code that you specify in the setting Language code
          (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
          service uses the language code that you specify.

          - **RemixSettings** *(dict) --* Advanced audio remixing settings.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
          "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
          this information into destination manifests for display on the end-viewer's player device.
          For outputs in other output groups, the service ignores this setting.

      - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
      caption settings in a single output.

        - *(dict) --* Caption Description for preset

          - **CustomLanguageCode** *(string) --* Specify the language for this captions output
          track. For most captions output formats, the encoder puts this language information in the
          output captions metadata. If your output captions format is DVB-Sub or Burn in, the
          encoder uses this language information when automatically selecting the font script for
          rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
          For streaming outputs, you can also use any other code in the full RFC-5646 specification.
          Streaming outputs are those that are in one of the following output groups: CMAF, DASH
          ISO, Apple HLS, or Microsoft Smooth Streaming.

          - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
          that burnin_destination_settings are not available if the source of the caption data is
          Embedded or Teletext.

            - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

              - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
              setting alignment to centered will place the captions at the bottom center of the
              output. Similarly, setting a left alignment will align captions to the bottom left of
              the output. If x and y positions are given in conjunction with the alignment
              parameter, the font will be justified (either left or centered) relative to those
              coordinates. This option is not valid for source captions that are STL, 608/embedded
              or teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
              captions. All burn-in and DVB-Sub font settings must match.

              - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
              rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
              to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

              - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
              option is not valid for source captions that are STL, 608/embedded or teletext. These
              source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
              font settings must match.

              - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255
              is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

              - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
              96 dpi. All burn-in and DVB-Sub font settings must match.

              - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
              code, if the LanguageCode is not sufficient for determining the script type. Where
              LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
              is used to help determine the appropriate font for rendering burn-in captions.

              - **FontSize** *(integer) --* A positive integer indicates the exact font size in
              points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineColor** *(string) --* Specifies font outline color. This option is not
              valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
              not valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
              captions. All burn-in and DVB-Sub font settings must match.

              - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque;
              0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
              (transparent). All burn-in and DVB-Sub font settings must match.

              - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels to the left. All burn-in and DVB-Sub font settings must match.

              - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels above the text. All burn-in and DVB-Sub font settings must match.

              - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
              Teletext or STL formats. Specify whether the spacing between letters in your captions
              is set by the captions grid or varies depending on letter width. Choose fixed grid to
              conform to the spacing specified in the captions file more accurately. Choose
              proportional to make the text easier to read if the captions are closed caption.

              - **XPosition** *(integer) --* Specifies the horizontal position of the caption
              relative to the left side of the output in pixels. A value of 10 would result in the
              captions starting 10 pixels from the left of the output. If no explicit x_position is
              provided, the horizontal caption position will be determined by the alignment
              parameter. This option is not valid for source captions that are STL, 608/embedded or
              teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
              to the top of the output in pixels. A value of 10 would result in the captions
              starting 10 pixels from the top of the output. If no explicit y_position is provided,
              the caption will be positioned towards the bottom of the output. This option is not
              valid for source captions that are STL, 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

            - **DestinationType** *(string) --* Specify the format for this set of captions on this
            output. The default format is embedded without SCTE-20. Other options are embedded with
            SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
            SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
            complies with the SCTE-43 spec. To create a non-compliant output where the embedded
            captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

            - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

              - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
              setting alignment to centered will place the captions at the bottom center of the
              output. Similarly, setting a left alignment will align captions to the bottom left of
              the output. If x and y positions are given in conjunction with the alignment
              parameter, the font will be justified (either left or centered) relative to those
              coordinates. This option is not valid for source captions that are STL, 608/embedded
              or teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
              captions. All burn-in and DVB-Sub font settings must match.

              - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
              rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
              to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

              - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
              option is not valid for source captions that are STL, 608/embedded or teletext. These
              source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
              font settings must match.

              - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255
              is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

              - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
              96 dpi. All burn-in and DVB-Sub font settings must match.

              - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
              code, if the LanguageCode is not sufficient for determining the script type. Where
              LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
              is used to help determine the appropriate font for rendering DVB-Sub captions.

              - **FontSize** *(integer) --* A positive integer indicates the exact font size in
              points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineColor** *(string) --* Specifies font outline color. This option is not
              valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
              not valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
              captions. All burn-in and DVB-Sub font settings must match.

              - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque;
              0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
              (transparent). All burn-in and DVB-Sub font settings must match.

              - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels to the left. All burn-in and DVB-Sub font settings must match.

              - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels above the text. All burn-in and DVB-Sub font settings must match.

              - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
              for hearing impaired. Choose hearing impaired if your subtitles include audio
              descriptions and dialogue. Choose standard if your subtitles include only dialogue.

              - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
              Teletext or STL formats. Specify whether the spacing between letters in your captions
              is set by the captions grid or varies depending on letter width. Choose fixed grid to
              conform to the spacing specified in the captions file more accurately. Choose
              proportional to make the text easier to read if the captions are closed caption.

              - **XPosition** *(integer) --* Specifies the horizontal position of the caption
              relative to the left side of the output in pixels. A value of 10 would result in the
              captions starting 10 pixels from the left of the output. If no explicit x_position is
              provided, the horizontal caption position will be determined by the alignment
              parameter. This option is not valid for source captions that are STL, 608/embedded or
              teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
              to the top of the output in pixels. A value of 10 would result in the captions
              starting 10 pixels from the top of the output. If no explicit y_position is provided,
              the caption will be positioned towards the bottom of the output. This option is not
              valid for source captions that are STL, 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

            - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
            caption outputs, including 608/708 Channel destination number.

              - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
              captions are SCC format and your output captions are embedded in the video stream.
              Specify a CC number for each captions channel in this output. If you have two
              channels, choose CC numbers that aren't in the same field. For example, choose 1 and
              3. For more information, see
              https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
              captions are SCC format and you want both 608 and 708 captions embedded in your output
              stream. Optionally, specify the 708 service number for each output captions channel.
              Choose a different number for each channel. To use this setting, also set Force 608 to
              708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions
              selector settings. If you choose to upconvert but don't specify a 708 service number,
              MediaConvert uses the number that you specify for CC channel number
              (destination608ChannelNumber) for the 708 service number. For more information, see
              https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

              - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
              use the font style and position information from the captions source in the output.
              This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or
              TTML. Disable this setting for simplified output captions.

            - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

              - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
              that the captions and the video are synchronized in the output. Specify a frame rate
              that matches the frame rate of the associated video. If the video frame rate is 29.97,
              choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
              video_insertion=true and drop_frame_timecode=true; otherwise, choose 29.97
              non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

            - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

              - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
              destination captions for this output. This value must be a three-digit hexadecimal
              string; strings ending in -FF are invalid. If you are passing through the entire set
              of Teletext data, do not use this field.

              - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
              don't specify a value here, the service sets the page type to the default value
              Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
              don't use this field. When you pass through a set of Teletext pages, your output has
              the same page types as your input.

                - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

            - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
            including Pass style information (TtmlStylePassthrough).

              - **StylePassthrough** *(string) --* Pass through style and position information from
              a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

          - **LanguageCode** *(string) --* Specify the language of this captions output track. For
          most captions output formats, the encoder puts this language information in the output
          captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
          this language information to choose the font language for rendering the captions text.

          - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
          For example, "English", "Director commentary", or "track_2". For streaming outputs,
          MediaConvert passes this information into destination manifests for display on the
          end-viewer's player device. For outputs in other output groups, the service ignores this
          setting.

      - **ContainerSettings** *(dict) --* Container specific settings.

        - **Container** *(string) --* Container for this output. Some containers require a container
        settings object. If not specified, the default object will be created.

        - **F4vSettings** *(dict) --* Settings for F4v container

          - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
          relocated to the beginning of the archive as required for progressive downloading.
          Otherwise it is placed normally at the end.

        - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
        File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
        (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
        stream program contains subsets of data, including audio, video, and metadata. Each of these
        subsets of data has a numerical label called a packet identifier (PID). Each transport
        stream program corresponds to one MediaConvert output. The PMT lists the types of data in a
        program along with their PID. Downstream systems and players use the program map table to
        look up the PID for each type of data it accesses and then uses the PIDs to locate specific
        data within the asset.

          - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
          Dolby Digital audio.

          - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
          packet.

          - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
          streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
          range 482-492.

            - *(integer) --*

          - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
          per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
          Other common values are 3750000, 7500000, and 15000000.

          - **BufferModel** *(string) --* Controls what buffer model to use for accurate
          interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
          lead to lower latency, but low-memory devices may not be able to play back the stream
          without interruptions.

          - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
          specified table repetition interval.

            - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
            (NIT).

            - **NetworkName** *(string) --* The network name text placed in the
            network_name_descriptor inside the Network Information Table. Maximum length is 256
            characters.

            - **NitInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

          - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
          specified table repetition interval.

            - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
            stream. "Follow input SDT" copies SDT information from input stream to output stream.
            "Follow input SDT if present" copies SDT information from input stream to output stream
            if SDT information is present in the input, otherwise it will fall back on the
            user-defined values. Enter "SDT Manually" means user will enter the SDT information. "No
            SDT" means output stream will not contain SDT information.

            - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
            Service Description Table. Maximum length is 256 characters.

            - **ServiceProviderName** *(string) --* The service provider name placed in the
            service_descriptor in the Service Description Table. Maximum length is 256 characters.

          - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
          included in this output. Specify multiple PIDs as a JSON array. Default is the range
          460-479.

            - *(integer) --*

          - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
          table repetition interval.

            - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

          - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
          data you include in this output. Default is 499.

          - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
          markers will be added to partitions 3 and 4. The interval between these additional markers
          will be fixed, and will be slightly shorter than the video EBP marker interval. When set
          to VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
          segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

          - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
          either be placed only on the video PID, or on both the video PID and all audio PIDs. Only
          applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
          EBP_LEGACY).

          - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
          header.

          - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
          that your audio EBP markers are incorrectly appearing before your video EBP markers. To
          correct this problem, set this value to Force (FORCE).

          - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
          EBP markers.

          - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
          Program Clock References (PCRs) inserted into the transport stream.

          - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
          come within the specified time interval of each other by looking ahead at input video. If
          another EBP is going to come in within the specified time interval, the current EBP is not
          emitted, and the segment is "stretched" to the next marker. The lookahead value does not
          add latency to the system. The Live Event must be configured elsewhere to create
          sufficient latency to make the lookahead accurate.

          - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will
          be detected in the input audio and an equivalent ID3 tag will be inserted in the output.

          - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
          insert into the transport stream. This can be used if a downstream encryption system
          requires periodic null packets.

          - **PatInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
          value is inserted for every Packetized Elementary Stream (PES) header. This is effective
          only when the PCR PID is the same as the video or audio elementary stream.

          - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
          reference (PCR) in this output. If you do not specify a value, the service will use the
          value for Video PID (VideoPid).

          - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
          the program map table (PMT) in the output transport stream.

          - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
          (PMT) itself. Default is 480.

          - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
          metadata stream. Default is 503.

          - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
          program number used in the program map table (PMT) for this output. Default is 1. Program
          numbers and program map tables are parts of MPEG-2 transport stream containers, used for
          organizing data.

          - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
          to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
          bitrate, but the output will not be padded up to that bitrate.

          - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
          your HLS and transport stream outputs at the insertion points that you specify in an ESAM
          XML document. Provide the document in the setting SCC XML (sccXml).

            - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream generated by ESAM.

          - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
          in the transport stream.

          - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
          (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
          output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
          markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
          string in the setting Signal processing notification XML (sccXml). Also enable ESAM
          SCTE-35 (include the property scte35Esam).

          - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
          segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
          adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
          data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
          Encoder Boundary Point information to the adaptation field as per OpenCable specification
          OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
          field using a legacy proprietary format.

          - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
          segmentation markers are inserted into the transport stream. With avails, it is possible
          that segments may be truncated, which can influence where future segmentation markers are
          inserted. When a segmentation style of "reset_cadence" is selected and a segment is
          truncated due to an avail, we will reset the segmentation cadence. This means the
          subsequent segment will have a duration of of $segmentation_time seconds. When a
          segmentation style of "maintain_cadence" is selected and a segment is truncated due to an
          avail, we will not reset the segmentation cadence. This means the subsequent segment will
          likely be truncated as well. However, all segments after that will have a duration of
          $segmentation_time seconds. Note that EBP lookahead is a slight exception to this rule.

          - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
          Required unless markers is set to _none_.

          - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
          metadata in this output. Default is 502.

          - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
          the program map table for this output. Transport stream IDs and program map tables are
          parts of MPEG-2 transport stream containers, used for organizing data.

          - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
          stream in the transport stream.

        - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

          - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
          packet.

          - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
          the transport stream. Multiple values are accepted, and can be entered in ranges and/or by
          comma separation.

            - *(integer) --*

          - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will
          be detected in the input audio and an equivalent ID3 tag will be inserted in the output.

          - **PatInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
          value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
          effective only when the PCR PID is the same as the video or audio elementary stream.

          - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
          in the transport stream. When no value is given, the encoder will assign the same value as
          the Video PID.

          - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
          transport stream.

          - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
          stream in the transport stream.

          - **ProgramNumber** *(integer) --* The value of the program number field in the Program
          Map Table.

          - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream.

          - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
          (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
          output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
          markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
          conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
          want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
          setting Signal processing notification XML (sccXml).

          - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
          whether the service inserts the ID3 timed metadata from the input in this output.

          - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
          in the transport stream.

          - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
          Program Map Table.

          - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
          the transport stream.

        - **MovSettings** *(dict) --* Settings for MOV Container.

          - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
          video output settings.

          - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
          composition times in the 'ctts' (composition time to sample) box for B-frames will be
          negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
          amendment 1. This improves compatibility with Apple players and tools.

          - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
          the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple
          editors and players, but may decrease compatibility with other players. Only applicable
          when the video codec is MPEG2.

          - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

          - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
          setting.

        - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
        outputs with this container.

          - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
          composition times in the 'ctts' (composition time to sample) box for B-frames will be
          negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
          amendment 1. This improves compatibility with Apple players and tools.

          - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

          - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
          relocated to the beginning of the archive as required for progressive downloading.
          Otherwise it is placed normally at the end.

          - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
          Usually not necessary to specify.

        - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

          - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
          include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
          from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
          container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
          within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
          and audio fragmented MP4 files.

          - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
          ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
          specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
          your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
          appear in your input to also appear in this output. Choose None (NONE) if you don't want
          those SCTE-35 markers in this output.

      - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
      settings. The specific video settings depend on the video codec that you choose when you
      specify a value for Video codec (codec). Include one instance of (VideoDescription) per
      output.

        - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
        outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD
        values in the output video data and what those values are. * Choose None to remove all AFD
        values from this output. * Choose Fixed to ignore input AFD values and instead encode the
        value specified in the job. * Choose Auto to calculate output AFD values based on the input
        AFD scaler data.

        - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
        The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
        job, the service will ignore the setting.

        - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
        (VideoDescription), contains the group of settings related to video encoding. The settings
        in this group vary depending on the value that you choose for Video codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
        Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

          - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
          values defined by the object VideoCodec.

          - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

            - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
            the output stream, then one frame every framerateDenominator/framerateNumerator seconds.
            For example, settings of framerateNumerator = 1 and framerateDenominator =
                 3 (a rate of
            1/3 frame per second) will capture the first frame, then 1 frame every 3s. Files will be
            named as filename.n.jpg where n is the 0-based sequence number of each Capture.

            - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
            output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
            example, settings of framerateNumerator = 1 and framerateDenominator =
                 3 (a rate of 1/3
            frame per second) will capture the first frame, then 1 frame every 3s. Files will be
            named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
            to 7 decimal places.

            - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

            - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

          - **H264Settings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value H_264.

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
            output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

            - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
            available with the AVC-I License.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
            High profile) or CAVLC.

            - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
            interlaced outputs.

            - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
            reduce flicker or 'pop' on I-frames.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job specification as
            a JSON file without the console, use FramerateControl to specify which value the service
            uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
            service to use the frame rate from the input. Choose SPECIFIED if you want the service
            to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
            use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
            1001 =
                 23.976 fps. Use FramerateDenominator to specify the denominator of this fraction.
            In this example, use 1001 for the value of FramerateDenominator. When you use the
            console for transcode jobs that use frame rate conversion, provide the value as a
            decimal number for Framerate. In this example, specify 23.976.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
            that have B frames > 1.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type, as follows. - If the source is
            interlaced, the output will be interlaced with the same polarity as the source (it will
            follow the source). The output could therefore be a mix of "top field first" and "bottom
            field first". - If the source is progressive, the output will be interlaced with "top
            field first" or "bottom field first" polarity, depending on which of the Follow options
            you chose.

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000. Required when Rate control mode is QVBR.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
            encoder may use more than requested if using B-frames and/or interlaced encoding.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
            to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
            multipass video encoding.

            - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
            with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
            you set Rate control mode to a value other than QVBR, or when you don't define Rate
            control mode.

              - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
              QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited
              to the complexity of your input video, the service limits the average bitrate of the
              video part of this output to the value that you choose. That is, the total size of the
              video element is less than or equal to the value you set multiplied by the number of
              seconds of encoded output.

              - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
              That is, when you specify qvbrSettings within h264Settings. Specify the target quality
              level for this output, from 1 to 10. Use higher numbers for greater quality. Level 10
              results in nearly lossless compression. The quality level for most broadcast-quality
              transcodes is between 6 and 9.

            - **RateControlMode** *(string) --* Use this setting to specify whether this output has
            a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate
            (QVBR).

            - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
            repeated.

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default. If this output uses QVBR, choose Transition detection
            (TRANSITION_DETECTION) for further video quality improvement. For more information about
            QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

            - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
            the number of macroblock rows for progressive pictures, and less than or equal to half
            the number of macroblock rows for interlaced pictures.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
            high-frequency content in the encoded image.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

            - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
            Framerate (framerate) field is set to 29.970. This field works with the Streams >
            Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
            Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
            output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i
            output from 23.976 input. - Soft: produces 23.976; the player converts this output to
            29.97i.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

            - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
            of an unregistered SEI message.

          - **H265Settings** *(dict) --* Settings for H265 codec

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
            message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
            (EOTF).

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* H.265 Level.

            - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
            specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
            Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
            License.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
            reduce flicker or 'pop' on I-frames.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
            that have B frames > 1.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
            Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
            your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
            create an output that's interlaced with the same field polarity throughout. Choose
            Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
            to create an interlaced output with the same field polarity as the source. If the source
            is interlaced, the output will be interlaced with the same polarity as the source (it
            will follow the source). The output could therefore be a mix of "top field first" and
            "bottom field first". If the source is progressive, your output will be interlaced with
            "top field first" or "bottom field first" polarity, depending on which of the Follow
            options you chose. If you don't choose a value, the service will default to Progressive
            (PROGRESSIVE).

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000. Required when Rate control mode is QVBR.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
            encoder may use more than requested if using B-frames and/or interlaced encoding.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
            to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
            multipass video encoding.

            - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
            with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
            you set Rate control mode to a value other than QVBR, or when you don't define Rate
            control mode.

              - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
              QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited
              to the complexity of your input video, the service limits the average bitrate of the
              video part of this output to the value that you choose. That is, the total size of the
              video element is less than or equal to the value you set multiplied by the number of
              seconds of encoded output.

              - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
              That is, when you specify qvbrSettings within h265Settings. Specify the target quality
              level for this output, from 1 to 10. Use higher numbers for greater quality. Level 10
              results in nearly lossless compression. The quality level for most broadcast-quality
              transcodes is between 6 and 9.

            - **RateControlMode** *(string) --* Use this setting to specify whether this output has
            a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate
            (QVBR).

            - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
            filter strength. Adaptive mode dynamically selects best strength based on content

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default. If this output uses QVBR, choose Transition detection
            (TRANSITION_DETECTION) for further video quality improvement. For more information about
            QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

            - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
            the number of macroblock rows for progressive pictures, and less than or equal to half
            the number of macroblock rows for interlaced pictures.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
            Framerate (framerate) field is set to 29.970. This field works with the Streams >
            Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
            Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
            output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i
            output from 23.976 input. - Soft: produces 23.976; the player converts this output to
            29.97i.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

            - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
            bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
            one layer, reference B-frames can form a second layer and non-reference b-frames can
            form a third layer. Decoders can optionally decode only the lower temporal layers to
            generate a lower frame rate output. For example, given a bitstream with temporal IDs and
            with b-frames =
                 1 (i.e. IbPbPb display order), a decoder could decode all the frames for
            full frame rate output or only the I and P frames (lowest temporal layer) for a half
            frame rate output.

            - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
            subdivision of the encoded pictures.

            - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
            of an unregistered SEI message.

            - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
            doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
            DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
            Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
            following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition.
            For these outputs, the service stores parameter set NAL units in the sample headers but
            not in the samples directly. For MP4 outputs, when you choose HVC1, your output video
            might not work properly with some downstream systems and video players. The service
            defaults to marking your output as HEV1. For these outputs, the service writes parameter
            set NAL units directly into the samples.

          - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value MPEG2.

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
            the video output.

            - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
            profile for the video output.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type. - If the source is interlaced, the
            output will be interlaced with the same polarity as the source (it will follow the
            source). The output could therefore be a mix of "top field first" and "bottom field
            first". - If the source is progressive, the output will be interlaced with "top field
            first" or "bottom field first" polarity, depending on which of the Follow options you
            chose.

            - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
            set quantization precision for intra-block DC coefficients. If you choose the value
            auto, the service will automatically select the precision based on the per-frame
            compression ratio.

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level
            (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
            encoding.

            - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
            specifiy whether the bitrate is variable (vbr) or constant (cbr).

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
            high-frequency content in the encoded image.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

            - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
            (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
            output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
            converstion to the player.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

          - **ProresSettings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value PRORES.

            - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
            of Apple ProRes codec to use for this output.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
            frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
            23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
            example, use 24000 for the value of FramerateNumerator.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type. - If the source is interlaced, the
            output will be interlaced with the same polarity as the source (it will follow the
            source). The output could therefore be a mix of "top field first" and "bottom field
            first". - If the source is progressive, the output will be interlaced with "top field
            first" or "bottom field first" polarity, depending on which of the Follow options you
            chose.

            - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
            determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
            the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
            the console, choose it from the dropdown menu. Using the API, set ProresParControl to
            (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
            (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
            output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
            converstion to the player.

        - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
        metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output.
        If you don't specify a value, the service sets this to Insert by default.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame.

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
        is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
        use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
        enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

        - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
        (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
        on all frames of this video output.

        - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
        height for this output. Specify in pixels. If you don't provide a value here, the service
        will use the input height.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black.

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
        service changes the video itself in response to AFD values in the input. * Choose Respond to
        clip the input video frame according to the AFD value, input display aspect ratio, and
        output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
        choose this when AfdSignaling is set to (NONE). A preferred implementation of this workflow
        is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all
        input AFD values from this output.

        - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
        different aspect ratio from the input aspect ratio. Choose Stretch to output
        (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
        Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
        any value that you specify for the setting Selection placement (position) in this output.

        - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
        anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
        scaling. Sharpness only applies if your output resolution is different from your input
        resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

        - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
        outputs. Only enable Timecode insertion when the input frame rate is identical to the output
        frame rate. To include timecodes in this output, set Timecode insertion
        (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
        is DISABLED. When the service inserts timecodes in an output, by default, it uses any
        embedded timecodes from the input. If none are present, the service will set the timecode
        for the first output frame to zero. To change this default behavior, adjust the settings
        under Timecode configuration (TimecodeConfig). In the console, these settings are located
        under Job > Job settings > Timecode configuration. Note - Timecode source under input
        settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
        output. Source under Job settings > Timecode configuration (TimecodeSource) does.

        - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
        Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
        features are disabled by default.

          - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
          necessary. Enable or disable this feature for each output individually. This setting is
          disabled by default.

            - **Brightness** *(integer) --* Brightness level.

            - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
            output. The service supports conversion between HDR formats, between SDR formats, and
            from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
            conversion doesn't upgrade the dynamic range. The converted video has an HDR format, but
            visually appears the same as an unconverted output.

            - **Contrast** *(integer) --* Contrast level.

            - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
            space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
            want signaled in the output. These values don't affect the pixel values that are encoded
            in the video stream. They are intended to help the downstream video player display
            content in a way that reflects the intentions of the the content creator. When you set
            Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings
            are required. You must set values for Max frame average light level
            (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
            settings don't have a default value. The default values for the other HDR 10 metadata
            settings are defined by the P3D65 color space. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Hue** *(integer) --* Hue in degrees.

            - **Saturation** *(integer) --* Saturation level.

          - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
          and a clearer picture.

            - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
            to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
            (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
            Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
            as a scrolling headline at the bottom of the frame.

            - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
            convert frames that are tagged in metadata as progressive. It will only convert those
            that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
            converts every frame to progressive - even those that are already tagged as progressive.
            Turn Force mode on only if there is a good chance that the metadata has tagged frames as
            progressive when they are not progressive. Do not turn on otherwise; processing frames
            that are already progressive into progressive will probably result in lower quality
            video.

            - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
            will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
            progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
            Adaptive auto-detects and converts to progressive.

          - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
          compatible video output.

            - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
            SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

              - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
              corresponds to the brightest pixel in the entire stream. Measured in nits.

              - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
              that corresponds to the highest frame-average brightness in the entire stream.
              Measured in nits.

            - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
            Dolby Vision MaxCLL and MaxFALL properies.

            - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
            profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
            frame interleaved data.

          - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
          include a graphic overlay on your video. Enable or disable this feature for each output
          individually. This setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
          noise from your video output if necessary. Enable or disable this feature for each output
          individually. This setting is disabled by default.

            - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
            of the following spatial image filtering functions. To use this setting, you must also
            enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. *
            Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. *
            Conserve does min/max noise reduction. * Spatial does frequency-domain filtering based
            on JND principles. * Temporal optimizes video quality for complex motion.

            - **FilterSettings** *(dict) --* Settings for a noise reducer filter

              - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
              values produce stronger filtering.

            - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
            filter.

              - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
              reduction sharpening filter, with 0 disabling the filter and 3 enabling it at maximum
              strength.

              - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
              speed), with 0 being the nominal value.

              - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
              values produce stronger filtering.

            - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
            filter.

              - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
              motion. Higher values produce stronger temporal filtering. This filters highly complex
              scenes more aggressively and creates better VQ for low bitrate outputs.

              - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
              setting reduces bit rate at the cost of transcode time, high setting improves
              transcode time at the cost of bit rate.

              - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
              this output. Higher values produce stronger filtering. We recommend the following
              value ranges, depending on the result that you want: * 0-2 for complexity reduction
              with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
              8-16 for a high level of complexity reduction

          - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
          timecode and specified prefix into the output.

            - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
            burned-in timecode. Valid values are 10, 16, 32, 48.

            - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
            (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

            - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
            burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
            "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
            equivalents. The supported range of characters is 0x20 through 0x7e. This includes
            letters, numbers, and all special characters represented on a standard English keyboard.

        - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
        pixels, for this output. If you don't provide a value here, the service will use the input
        width.

    - **Type** *(string) --* A preset can be of two types: system or custom. System or built-in
    preset can't be modified or deleted by the user.
    """


_ClientListPresetsResponseTypeDef = TypedDict(
    "_ClientListPresetsResponseTypeDef",
    {"NextToken": str, "Presets": List[ClientListPresetsResponsePresetsTypeDef]},
    total=False,
)


class ClientListPresetsResponseTypeDef(_ClientListPresetsResponseTypeDef):
    """
    Type definition for `ClientListPresets` `Response`

    - **NextToken** *(string) --* Use this string to request the next batch of presets.

    - **Presets** *(list) --* List of presets

      - *(dict) --* A preset is a collection of preconfigured media conversion settings that you
      want MediaConvert to apply to the output during the conversion process.

        - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

        - **Category** *(string) --* An optional category you create to organize your presets.

        - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for preset creation.

        - **Description** *(string) --* An optional description you create for each preset.

        - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the preset was last
        updated.

        - **Name** *(string) --* A name you create for each preset. Each name must be unique within
        your account.

        - **Settings** *(dict) --* Settings for preset

          - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
          settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
          (AudioDescriptions) can contain multiple groups of encoding settings.

            - *(dict) --* Description of audio output

              - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
              Ignore these settings unless you need to comply with a loudness standard.

                - **Algorithm** *(string) --* Choose one of the following audio normalization
                algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                loudness for an entire piece of content, suitable for measurement of short-form
                content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio
                channels than the other algorithms, including configurations such as 7.1.

                - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                using the chosen algorithm. If disabled, the audio will be measured but not
                adjusted.

                - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
                corrected to the target level. Content measuring below this level will not be
                corrected. Gating only applies when not using real_time_correction.

                - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                loudness to a CSV file.

                - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                TruePeak for each output's audio track loudness.

                - **TargetLkfs** *(float) --* When you use Audio normalization
                (AudioNormalizationSettings), optionally use this setting to specify a target
                loudness. If you don't specify a value here, the encoder chooses a value for you,
                based on the algorithm that you choose for Algorithm (algorithm). If you choose
                algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                choose -23 LKFS.

              - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
              In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
              on its order within each input. For example if you specify "Audio Selector 3", then
              the third audio selector will be used from each input. If an input does not have an
              "Audio Selector 3", then the audio selector marked as "default" in that input will be
              used. If there is no audio selector marked as "default", silence will be inserted for
              the duration of that input. Alternatively, an "Audio Selector
              Group":#inputs-audio_selector_group name may be specified, with similar
              default/silence behavior. If no audio_source_name is specified, then "Audio Selector
              1" will be chosen automatically.

              - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
              (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
              Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                   Visually Impaired Commentary,
              4-255 = Reserved.

              - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
              an ISO 639 audio_type, then that value is passed through to the output. If the input
              contains no ISO 639 audio_type, the value in Audio Type is included in the output.
              Otherwise the value in Audio Type is included in the output. Note that this field and
              audioType are both ignored if audioDescriptionBroadcasterMix is set to
              BROADCASTER_MIXED_AD.

              - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
              (AudioDescriptions) contains the group of settings related to audio encoding. The
              settings in this group vary depending on the value that you choose for Audio codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * AAC, AacSettings
              * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
              Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                - **AacSettings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
                mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In
                VBR mode, you control the audio quality with the setting VBR quality (vbrQuality).
                In CBR mode, you use the setting Bitrate (bitrate). Defaults and valid values depend
                on the rate control mode.

                  - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                  when the input contains pre-mixed main audio + audio description (AD) as a stereo
                  pair. The value for AudioType will be set to 3, which signals to downstream
                  systems that this stream contains "broadcaster mixed AD". Note that the input
                  received by the encoder must contain pre-mixed audio; the encoder does not perform
                  the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any values
                  you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input
                  does not contain pre-mixed audio + audio description (AD). In this case, the
                  encoder will use any values you provide for AudioType and FollowInputAudioType.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                  set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                  20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                  128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                  576000, 640000, 768000, 896000, 1024000. The value you set is also constrained by
                  the values that you choose for Profile (codecProfile), Bitrate control mode
                  (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                  control mode and Profile.

                  - **CodecProfile** *(string) --* AAC Profile.

                  - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                  channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                  Description (Receiver Mix)" setting receives a stereo description plus control
                  track and emits a mono AAC encode of the description track, with control data
                  emitted in the PES header as per ETSI TS 101 154 Annex E.

                  - **RateControlMode** *(string) --* Rate Control Mode.

                  - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                  LATM/LOAS AAC in an output, you must choose "No container" for the output
                  container.

                  - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                  control mode and profile.

                  - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                  raw or MPEG-2 Transport Stream containers.

                  - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode
                  is VBR.

                - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value AC3.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                  bitrates depend on the coding mode.

                  - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                  that the encoder emits. For more information about the AC3 bitstream mode, see
                  ATSC A/52-2012 (Annex E).

                  - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                  channels.

                  - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                  audio is Dolby Digital, dialnorm will be passed through.

                  - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                  dynamic range compression signaling to the output bitstream as defined in the
                  Dolby Digital specification.

                  - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                  prior to encoding. Only valid with 3_2_LFE coding mode.

                  - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                  will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data.
                  If audio was not supplied from one of these streams, then the static metadata
                  settings will be used.

                  - **SampleRate** *(integer) --* This value is always 48000. It represents the
                  sample rate in Hz.

                - **AiffSettings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value AIFF.

                  - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                  choose the encoding quality for this audio track.

                  - **Channels** *(integer) --* Specify the number of channels in this output audio
                  track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and
                  so on, up to 64.

                  - **SampleRate** *(integer) --* Sample rate in hz.

                - **Codec** *(string) --* Type of Audio codec.

                - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                  values: 384k, 448k, 640k, 768k

                  - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                  that the encoder emits. For more information about the EAC3 bitstream mode, see
                  ATSC A/52-2012 (Annex E).

                  - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos)
                  is always 9.1.6 (CODING_MODE_9_1_6).

                  - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                  adjust loudness based on dialogue analysis.

                  - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                  for a signal with dynamic range compression.

                  - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                  audio dynamic range when compressing the audio.

                  - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                  Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                  this value for downmixing. How the service uses this value depends on the value
                  that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                  1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                  - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                  Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                  for downmixing. How the service uses this value depends on the value that you
                  choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0,
                  -4.5, -6.0, and -60. The value -60 mutes the channel.

                  - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                  Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses
                  this value for downmixing. How the service uses this value depends on the value
                  that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                  1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                  - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                  Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                  uses this value for downmixing. How the service uses this value depends on the
                  value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                  -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                  - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                  your audio.

                  - **SampleRate** *(integer) --* This value is always 48000. It represents the
                  sample rate in Hz.

                  - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                  must be speech before the encoder uses the measured speech loudness as the overall
                  program loudness.

                  - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                  - **SurroundExMode** *(string) --* Specify whether your input audio has an
                  additional center rear surround channel matrix encoded into your left and right
                  surround channels.

                - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value EAC3.

                  - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                  attenuation to the surround channels. Only used for 3/2 coding mode.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                  bitrates depend on the coding mode.

                  - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                  that the encoder emits. For more information about the EAC3 bitstream mode, see
                  ATSC A/52-2012 (Annex E).

                  - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                  of channels.

                  - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                  channels.

                  - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                  audio is Dolby Digital Plus, dialnorm will be passed through.

                  - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                  for a signal with dynamic range compression.

                  - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                  audio dynamic range when compressing the audio.

                  - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                  channel is enabled

                  - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                  prior to encoding. Only valid with 3_2_LFE coding mode.

                  - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                  Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                  uses this value for downmixing. How the service uses this value depends on the
                  value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0,
                  1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This
                  setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                  (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                  different value for Coding mode, the service ignores Left only/Right only center
                  (loRoCenterMixLevel).

                  - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                  Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                  this value for downmixing. How the service uses this value depends on the value
                  that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0,
                  -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if
                  you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                  setting Coding mode (Eac3CodingMode). If you choose a different value for Coding
                  mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

                  - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                  Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                  MediaConvert uses this value for downmixing. How the service uses this value
                  depends on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid
                  values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                  channel. This setting applies only if you keep the default value of 3/2 - L, R, C,
                  Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
                  choose a different value for Coding mode, the service ignores Left total/Right
                  total center (ltRtCenterMixLevel).

                  - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                  Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                  MediaConvert uses this value for downmixing. How the service uses this value
                  depends on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid
                  values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This
                  setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                  (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                  different value for Coding mode, the service ignores Left total/Right total
                  surround (ltRtSurroundMixLevel).

                  - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                  will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data.
                  If audio was not supplied from one of these streams, then the static metadata
                  settings will be used.

                  - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                  will be passed through if it is present on the input. this detection is dynamic
                  over the life of the transcode. Inputs that alternate between DD+ and non-DD+
                  content will have a consistent DD+ output as the system alternates between
                  passthrough and encoding.

                  - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                  surround channels. Only used for 3/2 coding mode.

                  - **SampleRate** *(integer) --* This value is always 48000. It represents the
                  sample rate in Hz.

                  - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                  This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                  (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                  different value for Coding mode, the service ignores Stereo downmix
                  (Eac3StereoDownmix).

                  - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                  center back surround channel is matrix encoded into the left and right surround
                  channels.

                  - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                  Surround is matrix encoded into the two channels.

                - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value MP2.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                  - **Channels** *(integer) --* Set Channels to specify the number of channels in
                  this output audio track. Choosing Mono in the console will give you 1 output
                  channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                  - **SampleRate** *(integer) --* Sample rate in hz.

                - **WavSettings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value WAV.

                  - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                  choose the encoding quality for this audio track.

                  - **Channels** *(integer) --* Specify the number of channels in this output audio
                  track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and
                  so on, up to 64.

                  - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                  your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                  the extended support of the RF64 format, set your output WAV file format to RF64.

                  - **SampleRate** *(integer) --* Sample rate in Hz.

              - **CustomLanguageCode** *(string) --* Specify the language for this audio output
              track. The service puts this language code into your output audio track when you set
              Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
              The service also uses your specified custom language code when you set Language code
              control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file
              doesn't specify a language code. For all outputs, you can use an ISO 639-2 or ISO
              639-3 code. For streaming outputs, you can also use any other code in the full
              RFC-5646 specification. Streaming outputs are those that are in one of the following
              output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

              - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
              ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
              Input Language Code' is not selected or when 'Follow Input Language Code' is selected
              but there is no ISO 639 language code specified by the input.

              - **LanguageCodeControl** *(string) --* Specify which source for language code takes
              precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
              service uses the language code from the input track if it's present. If there's no
              languge code on the input track, the service uses the code that you specify in the
              setting Language code (languageCode or customLanguageCode). When you choose Use
              configured (USE_CONFIGURED), the service uses the language code that you specify.

              - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **StreamName** *(string) --* Specify a label for this output audio stream. For
              example, "English", "Director commentary", or "track_2". For streaming outputs,
              MediaConvert passes this information into destination manifests for display on the
              end-viewer's player device. For outputs in other output groups, the service ignores
              this setting.

          - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be
          multiple caption settings in a single output.

            - *(dict) --* Caption Description for preset

              - **CustomLanguageCode** *(string) --* Specify the language for this captions output
              track. For most captions output formats, the encoder puts this language information in
              the output captions metadata. If your output captions format is DVB-Sub or Burn in,
              the encoder uses this language information when automatically selecting the font
              script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
              ISO 639-3 code. For streaming outputs, you can also use any other code in the full
              RFC-5646 specification. Streaming outputs are those that are in one of the following
              output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

              - **DestinationSettings** *(dict) --* Specific settings required by destination type.
              Note that burnin_destination_settings are not available if the source of the caption
              data is Embedded or Teletext.

                - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                  - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                  setting alignment to centered will place the captions at the bottom center of the
                  output. Similarly, setting a left alignment will align captions to the bottom left
                  of the output. If x and y positions are given in conjunction with the alignment
                  parameter, the font will be justified (either left or centered) relative to those
                  coordinates. This option is not valid for source captions that are STL,
                  608/embedded or teletext. These source settings are already pre-defined by the
                  caption stream. All burn-in and DVB-Sub font settings must match.

                  - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                  the captions. All burn-in and DVB-Sub font settings must match.

                  - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                  rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                  equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                  must match.

                  - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                  option is not valid for source captions that are STL, 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                  - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                  255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                  - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                  default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                  - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                  code, if the LanguageCode is not sufficient for determining the script type. Where
                  LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                  This is used to help determine the appropriate font for rendering burn-in
                  captions.

                  - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                  points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                  settings must match.

                  - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                  valid for source captions that are either 608/embedded or teletext. These source
                  settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
                  font settings must match.

                  - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                  option is not valid for source captions that are either 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                  - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                  captions. All burn-in and DVB-Sub font settings must match.

                  - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                  opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                  to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                  - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                  relative to the captions in pixels. A value of -2 would result in a shadow offset
                  2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                  - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                  relative to the captions in pixels. A value of -2 would result in a shadow offset
                  2 pixels above the text. All burn-in and DVB-Sub font settings must match.

                  - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                  Teletext or STL formats. Specify whether the spacing between letters in your
                  captions is set by the captions grid or varies depending on letter width. Choose
                  fixed grid to conform to the spacing specified in the captions file more
                  accurately. Choose proportional to make the text easier to read if the captions
                  are closed caption.

                  - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                  relative to the left side of the output in pixels. A value of 10 would result in
                  the captions starting 10 pixels from the left of the output. If no explicit
                  x_position is provided, the horizontal caption position will be determined by the
                  alignment parameter. This option is not valid for source captions that are STL,
                  608/embedded or teletext. These source settings are already pre-defined by the
                  caption stream. All burn-in and DVB-Sub font settings must match.

                  - **YPosition** *(integer) --* Specifies the vertical position of the caption
                  relative to the top of the output in pixels. A value of 10 would result in the
                  captions starting 10 pixels from the top of the output. If no explicit y_position
                  is provided, the caption will be positioned towards the bottom of the output. This
                  option is not valid for source captions that are STL, 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                - **DestinationType** *(string) --* Specify the format for this set of captions on
                this output. The default format is embedded without SCTE-20. Other options are
                embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                create a non-compliant output where the embedded captions come first, choose
                Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                  - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                  setting alignment to centered will place the captions at the bottom center of the
                  output. Similarly, setting a left alignment will align captions to the bottom left
                  of the output. If x and y positions are given in conjunction with the alignment
                  parameter, the font will be justified (either left or centered) relative to those
                  coordinates. This option is not valid for source captions that are STL,
                  608/embedded or teletext. These source settings are already pre-defined by the
                  caption stream. All burn-in and DVB-Sub font settings must match.

                  - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                  the captions. All burn-in and DVB-Sub font settings must match.

                  - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                  rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                  equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                  must match.

                  - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                  option is not valid for source captions that are STL, 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                  - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                  255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                  - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                  default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                  - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                  code, if the LanguageCode is not sufficient for determining the script type. Where
                  LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                  This is used to help determine the appropriate font for rendering DVB-Sub
                  captions.

                  - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                  points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                  settings must match.

                  - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                  valid for source captions that are either 608/embedded or teletext. These source
                  settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
                  font settings must match.

                  - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                  option is not valid for source captions that are either 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                  - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                  captions. All burn-in and DVB-Sub font settings must match.

                  - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                  opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                  to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                  - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                  relative to the captions in pixels. A value of -2 would result in a shadow offset
                  2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                  - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                  relative to the captions in pixels. A value of -2 would result in a shadow offset
                  2 pixels above the text. All burn-in and DVB-Sub font settings must match.

                  - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                  or for hearing impaired. Choose hearing impaired if your subtitles include audio
                  descriptions and dialogue. Choose standard if your subtitles include only
                  dialogue.

                  - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                  Teletext or STL formats. Specify whether the spacing between letters in your
                  captions is set by the captions grid or varies depending on letter width. Choose
                  fixed grid to conform to the spacing specified in the captions file more
                  accurately. Choose proportional to make the text easier to read if the captions
                  are closed caption.

                  - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                  relative to the left side of the output in pixels. A value of 10 would result in
                  the captions starting 10 pixels from the left of the output. If no explicit
                  x_position is provided, the horizontal caption position will be determined by the
                  alignment parameter. This option is not valid for source captions that are STL,
                  608/embedded or teletext. These source settings are already pre-defined by the
                  caption stream. All burn-in and DVB-Sub font settings must match.

                  - **YPosition** *(integer) --* Specifies the vertical position of the caption
                  relative to the top of the output in pixels. A value of 10 would result in the
                  captions starting 10 pixels from the top of the output. If no explicit y_position
                  is provided, the caption will be positioned towards the bottom of the output. This
                  option is not valid for source captions that are STL, 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                embedded/ancillary caption outputs, including 608/708 Channel destination number.

                  - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                  input captions are SCC format and your output captions are embedded in the video
                  stream. Specify a CC number for each captions channel in this output. If you have
                  two channels, choose CC numbers that aren't in the same field. For example, choose
                  1 and 3. For more information, see
                  https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                  input captions are SCC format and you want both 608 and 708 captions embedded in
                  your output stream. Optionally, specify the 708 service number for each output
                  captions channel. Choose a different number for each channel. To use this setting,
                  also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                  your input captions selector settings. If you choose to upconvert but don't
                  specify a 708 service number, MediaConvert uses the number that you specify for CC
                  channel number (destination608ChannelNumber) for the 708 service number. For more
                  information, see
                  https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                  - **StylePassthrough** *(string) --* Keep this setting enabled to have
                  MediaConvert use the font style and position information from the captions source
                  in the output. This option is available only when your input captions are CFF-TT,
                  IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output captions.

                - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                  - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                  that the captions and the video are synchronized in the output. Specify a frame
                  rate that matches the frame rate of the associated video. If the video frame rate
                  is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                  video_insertion=true and drop_frame_timecode=
                      true; otherwise, choose 29.97
                  non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                  - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                  destination captions for this output. This value must be a three-digit hexadecimal
                  string; strings ending in -FF are invalid. If you are passing through the entire
                  set of Teletext data, do not use this field.

                  - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                  don't specify a value here, the service sets the page type to the default value
                  Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext
                  data, don't use this field. When you pass through a set of Teletext pages, your
                  output has the same page types as your input.

                    - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

                - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
                including Pass style information (TtmlStylePassthrough).

                  - **StylePassthrough** *(string) --* Pass through style and position information
                  from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                  TTML output.

              - **LanguageCode** *(string) --* Specify the language of this captions output track.
              For most captions output formats, the encoder puts this language information in the
              output captions metadata. If your output captions format is DVB-Sub or Burn in, the
              encoder uses this language information to choose the font language for rendering the
              captions text.

              - **LanguageDescription** *(string) --* Specify a label for this set of output
              captions. For example, "English", "Director commentary", or "track_2". For streaming
              outputs, MediaConvert passes this information into destination manifests for display
              on the end-viewer's player device. For outputs in other output groups, the service
              ignores this setting.

          - **ContainerSettings** *(dict) --* Container specific settings.

            - **Container** *(string) --* Container for this output. Some containers require a
            container settings object. If not specified, the default object will be created.

            - **F4vSettings** *(dict) --* Settings for F4v container

              - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
              relocated to the beginning of the archive as required for progressive downloading.
              Otherwise it is placed normally at the end.

            - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
            File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
            (M2TS). In these assets, data is organized by the program map table (PMT). Each
            transport stream program contains subsets of data, including audio, video, and metadata.
            Each of these subsets of data has a numerical label called a packet identifier (PID).
            Each transport stream program corresponds to one MediaConvert output. The PMT lists the
            types of data in a program along with their PID. Downstream systems and players use the
            program map table to look up the PID for each type of data it accesses and then uses the
            PIDs to locate specific data within the asset.

              - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
              for Dolby Digital audio.

              - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
              PES packet.

              - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
              audio streams you include in this output. Specify multiple PIDs as a JSON array.
              Default is the range 482-492.

                - *(integer) --*

              - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
              bits per second. Setting to 0 lets the muxer automatically determine the appropriate
              bitrate. Other common values are 3750000, 7500000, and 15000000.

              - **BufferModel** *(string) --* Controls what buffer model to use for accurate
              interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
              can lead to lower latency, but low-memory devices may not be able to play back the
              stream without interruptions.

              - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
              specified table repetition interval.

                - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                Table (NIT).

                - **NetworkName** *(string) --* The network name text placed in the
                network_name_descriptor inside the Network Information Table. Maximum length is 256
                characters.

                - **NitInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

              - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
              specified table repetition interval.

                - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                output stream. "Follow input SDT" copies SDT information from input stream to output
                stream. "Follow input SDT if present" copies SDT information from input stream to
                output stream if SDT information is present in the input, otherwise it will fall
                back on the user-defined values. Enter "SDT Manually" means user will enter the SDT
                information. "No SDT" means output stream will not contain SDT information.

                - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **ServiceName** *(string) --* The service name placed in the service_descriptor in
                the Service Description Table. Maximum length is 256 characters.

                - **ServiceProviderName** *(string) --* The service provider name placed in the
                service_descriptor in the Service Description Table. Maximum length is 256
                characters.

              - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
              data included in this output. Specify multiple PIDs as a JSON array. Default is the
              range 460-479.

                - *(integer) --*

              - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
              specified table repetition interval.

                - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

              - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
              teletext data you include in this output. Default is 499.

              - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
              markers will be added to partitions 3 and 4. The interval between these additional
              markers will be fixed, and will be slightly shorter than the video EBP marker
              interval. When set to VIDEO_INTERVAL, these additional markers will not be inserted.
              Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
              EBP or EBP_LEGACY).

              - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
              either be placed only on the video PID, or on both the video PID and all audio PIDs.
              Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
              EBP or EBP_LEGACY).

              - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
              PES header.

              - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
              know that your audio EBP markers are incorrectly appearing before your video EBP
              markers. To correct this problem, set this value to Force (FORCE).

              - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
              with EBP markers.

              - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
              Program Clock References (PCRs) inserted into the transport stream.

              - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
              not come within the specified time interval of each other by looking ahead at input
              video. If another EBP is going to come in within the specified time interval, the
              current EBP is not emitted, and the segment is "stretched" to the next marker. The
              lookahead value does not add latency to the system. The Live Event must be configured
              elsewhere to create sufficient latency to make the lookahead accurate.

              - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
              will be detected in the input audio and an equivalent ID3 tag will be inserted in the
              output.

              - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
              insert into the transport stream. This can be used if a downstream encryption system
              requires periodic null packets.

              - **PatInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
              Reference value is inserted for every Packetized Elementary Stream (PES) header. This
              is effective only when the PCR PID is the same as the video or audio elementary
              stream.

              - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
              reference (PCR) in this output. If you do not specify a value, the service will use
              the value for Video PID (VideoPid).

              - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances
              of the program map table (PMT) in the output transport stream.

              - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
              table (PMT) itself. Default is 480.

              - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
              private metadata stream. Default is 503.

              - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
              program number used in the program map table (PMT) for this output. Default is 1.
              Program numbers and program map tables are parts of MPEG-2 transport stream
              containers, used for organizing data.

              - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
              stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
              maximum bitrate, but the output will not be padded up to that bitrate.

              - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers
              in your HLS and transport stream outputs at the insertion points that you specify in
              an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

                - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                the transport stream generated by ESAM.

              - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
              stream in the transport stream.

              - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
              Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
              also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
              this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also
              provide the ESAM XML as a string in the setting Signal processing notification XML
              (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

              - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
              segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
              adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
              private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
              ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
              specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
              to the adaptation field using a legacy proprietary format.

              - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
              segmentation markers are inserted into the transport stream. With avails, it is
              possible that segments may be truncated, which can influence where future segmentation
              markers are inserted. When a segmentation style of "reset_cadence" is selected and a
              segment is truncated due to an avail, we will reset the segmentation cadence. This
              means the subsequent segment will have a duration of of $segmentation_time seconds.
              When a segmentation style of "maintain_cadence" is selected and a segment is truncated
              due to an avail, we will not reset the segmentation cadence. This means the subsequent
              segment will likely be truncated as well. However, all segments after that will have a
              duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception
              to this rule.

              - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
              Required unless markers is set to _none_.

              - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
              metadata in this output. Default is 502.

              - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself
              in the program map table for this output. Transport stream IDs and program map tables
              are parts of MPEG-2 transport stream containers, used for organizing data.

              - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
              video stream in the transport stream.

            - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

              - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
              PES packet.

              - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s)
              in the transport stream. Multiple values are accepted, and can be entered in ranges
              and/or by comma separation.

                - *(integer) --*

              - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
              will be detected in the input audio and an equivalent ID3 tag will be inserted in the
              output.

              - **PatInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
              Reference value is inserted for every Packetized Elementary Stream (PES) header. This
              parameter is effective only when the PCR PID is the same as the video or audio
              elementary stream.

              - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
              (PCR) in the transport stream. When no value is given, the encoder will assign the
              same value as the Video PID.

              - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
              the transport stream.

              - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
              metadata stream in the transport stream.

              - **ProgramNumber** *(integer) --* The value of the program number field in the
              Program Map Table.

              - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
              transport stream.

              - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
              Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
              also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
              this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you
              don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
              markers (adMarkers) if you do want manifest conditioning. In both cases, also provide
              the ESAM XML as a string in the setting Signal processing notification XML (sccXml).

              - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
              specify whether the service inserts the ID3 timed metadata from the input in this
              output.

              - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
              stream in the transport stream.

              - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
              the Program Map Table.

              - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
              in the transport stream.

            - **MovSettings** *(dict) --* Settings for MOV Container.

              - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
              video output settings.

              - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
              composition times in the 'ctts' (composition time to sample) box for B-frames will be
              negative, and a 'cslg' (composition shift least greatest) box will be included per
              14496-1 amendment 1. This improves compatibility with Apple players and tools.

              - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
              into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
              Apple editors and players, but may decrease compatibility with other players. Only
              applicable when the video codec is MPEG2.

              - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

              - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
              setting.

            - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
            outputs with this container.

              - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
              composition times in the 'ctts' (composition time to sample) box for B-frames will be
              negative, and a 'cslg' (composition shift least greatest) box will be included per
              14496-1 amendment 1. This improves compatibility with Apple players and tools.

              - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
              box.

              - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
              relocated to the beginning of the archive as required for progressive downloading.
              Otherwise it is placed normally at the end.

              - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
              file. Usually not necessary to specify.

            - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

              - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
              that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
              output from your audio and video. Choose Raw (RAW) for captions in a single XML file
              in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML
              format contained within fragmented MP4 files. This set of fragmented MP4 files is
              separate from your video and audio fragmented MP4 files.

              - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
              from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
              that you specify in an ESAM XML document. Provide the document in the setting SCC XML
              (sccXml).

              - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
              in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers
              that appear in your input to also appear in this output. Choose None (NONE) if you
              don't want those SCTE-35 markers in this output.

          - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
          settings. The specific video settings depend on the video codec that you choose when you
          specify a value for Video codec (codec). Include one instance of (VideoDescription) per
          output.

            - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
            outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
            AFD values in the output video data and what those values are. * Choose None to remove
            all AFD values from this output. * Choose Fixed to ignore input AFD values and instead
            encode the value specified in the job. * Choose Auto to calculate output AFD values
            based on the input AFD scaler data.

            - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
            outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
            that in your job, the service will ignore the setting.

            - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
            (VideoDescription), contains the group of settings related to video encoding. The
            settings in this group vary depending on the value that you choose for Video codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * H_264, H264Settings *
            H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE,
            FrameCaptureSettings

              - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
              enum values defined by the object VideoCodec.

              - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
              (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame
                of the output stream, then one frame every framerateDenominator/framerateNumerator
                seconds. For example, settings of framerateNumerator =
                     1 and framerateDenominator =
                3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every
                3s. Files will be named as filename.n.jpg where n is the 0-based sequence number of
                each Capture.

                - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
                the output stream, then one frame every framerateDenominator/framerateNumerator
                seconds. For example, settings of framerateNumerator =
                     1 and framerateDenominator =
                3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every
                3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                sequence number zero padded to 7 decimal places.

                - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                files).

                - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

              - **H264Settings** *(dict) --* Required when you set (Codec) under
              (VideoDescription)>(CodecSettings) to the value H_264.

                - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                quantizers to vary to improve visual quality.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                rounded down to the nearest multiple of 1000.

                - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

                - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                only available with the AVC-I License.

                - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                quality for high-motion content. This will cause the service to use fewer B-frames
                (which infer information based on other frames) for high-motion portions of the
                video and more B-frames for low-motion portions. The maximum number of B-frames is
                limited by the value you provide for the setting B frames between reference frames
                (numberBFramesBetweenReferenceFrames).

                - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                Main or High profile) or CAVLC.

                - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                interlaced outputs.

                - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame to reduce flicker or 'pop' on I-frames.

                - **FramerateControl** *(string) --* If you are using the console, use the Framerate
                setting to specify the frame rate for this output. If you want to keep the same
                frame rate as the input video, choose Follow source. If you want to do frame rate
                conversion, choose a frame rate from the dropdown list or choose Custom. The
                framerates shown in the dropdown list are decimal approximations of fractions. If
                you choose Custom, specify your frame rate as a fraction. If you are creating your
                transcoding job specification as a JSON file without the console, use
                FramerateControl to specify which value the service uses for the frame rate for this
                output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
                from the input. Choose SPECIFIED if you want the service to use the frame rate you
                specify in the settings FramerateNumerator and FramerateDenominator.

                - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                smoother motion during frame rate conversion.

                - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                that use frame rate conversion, specify the frame rate as a fraction. For example,
                24000 / 1001 =
                     23.976 fps. Use FramerateDenominator to specify the denominator of
                this fraction. In this example, use 1001 for the value of FramerateDenominator. When
                you use the console for transcode jobs that use frame rate conversion, provide the
                value as a decimal number for Framerate. In this example, specify 23.976.

                - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                fraction, e.g. 24000 / 1001 = 23.976 fps.

                - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                structures that have B frames > 1.

                - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                applications, it is recommended that this be set to 1 so a decoder joining
                mid-stream will receive an IDR frame as quickly as possible. Setting this value to 0
                will break output segmenting.

                - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
                be greater than zero.

                - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                frames or seconds. If seconds the system will convert the GOP Size into a frame
                count at run time.

                - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                should initially be filled (HRD buffer model).

                - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                example, enter five megabits as 5000000.

                - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
                (BOTTOM_FIELD) produce interlaced output with the entire output having the same
                field polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and
                Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the
                source. Therefore, behavior depends on the input scan type, as follows. - If the
                source is interlaced, the output will be interlaced with the same polarity as the
                source (it will follow the source). The output could therefore be a mix of "top
                field first" and "bottom field first". - If the source is progressive, the output
                will be interlaced with "top field first" or "bottom field first" polarity,
                depending on which of the Follow options you chose.

                - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                five megabits per second as 5000000. Required when Rate control mode is QVBR.

                - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame
                is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched
                to the scene change I-frame. GOP stretch requires enabling lookahead as well as
                setting I-interval. The normal cadence resumes for the next GOP. This setting is
                only used when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size
                + Min-I-interval - 1

                - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
                reference frames.

                - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                encoder may use more than requested if using B-frames and/or interlaced encoding.

                - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
                service to use the pixel aspect ratio from the input. Using the console, do this by
                choosing Follow source for Pixel aspect ratio.

                - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                - **QualityTuningLevel** *(string) --* Use Quality tuning level
                (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                singlepass, or high-quality multipass video encoding.

                - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                encoding with the H.264 codec. Required when you set Rate control mode to QVBR. Not
                valid when you set Rate control mode to a value other than QVBR, or when you don't
                define Rate control mode.

                  - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                  mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                  values suited to the complexity of your input video, the service limits the
                  average bitrate of the video part of this output to the value that you choose.
                  That is, the total size of the video element is less than or equal to the value
                  you set multiplied by the number of seconds of encoded output.

                  - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                  mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                  target quality level for this output, from 1 to 10. Use higher numbers for greater
                  quality. Level 10 results in nearly lossless compression. The quality level for
                  most broadcast-quality transcodes is between 6 and 9.

                - **RateControlMode** *(string) --* Use this setting to specify whether this output
                has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
                bitrate (QVBR).

                - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                repeated.

                - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                scene changes that the service automatically detects. This improves video quality
                and is enabled by default. If this output uses QVBR, choose Transition detection
                (TRANSITION_DETECTION) for further video quality improvement. For more information
                about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
                to the number of macroblock rows for progressive pictures, and less than or equal to
                half the number of macroblock rows for interlaced pictures.

                - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                input is relabeled as 25fps, and audio is sped up correspondingly.

                - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                reduce high-frequency content in the encoded image.

                - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on spatial variation of content complexity.

                - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                Framerate (framerate) field is set to 29.970. This field works with the Streams >
                Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
                output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
                29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
                output to 29.97i.

                - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on temporal variation of content complexity.

                - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                bytes of an unregistered SEI message.

              - **H265Settings** *(dict) --* Settings for H265 codec

                - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                quantizers to vary to improve visual quality.

                - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
                SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer
                Function (EOTF).

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                rounded down to the nearest multiple of 1000.

                - **CodecLevel** *(string) --* H.265 Level.

                - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                (H.265) specification. Selections are grouped as [Profile] / [Tier], so "Main/High"
                represents Main Profile with High Tier. 4:2:2 profiles are only available with the
                HEVC 4:2:2 License.

                - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                quality for high-motion content. This will cause the service to use fewer B-frames
                (which infer information based on other frames) for high-motion portions of the
                video and more B-frames for low-motion portions. The maximum number of B-frames is
                limited by the value you provide for the setting B frames between reference frames
                (numberBFramesBetweenReferenceFrames).

                - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame to reduce flicker or 'pop' on I-frames.

                - **FramerateControl** *(string) --* If you are using the console, use the Framerate
                setting to specify the frame rate for this output. If you want to keep the same
                frame rate as the input video, choose Follow source. If you want to do frame rate
                conversion, choose a frame rate from the dropdown list or choose Custom. The
                framerates shown in the dropdown list are decimal approximations of fractions. If
                you choose Custom, specify your frame rate as a fraction. If you are creating your
                transcoding job sepecification as a JSON file without the console, use
                FramerateControl to specify which value the service uses for the frame rate for this
                output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
                from the input. Choose SPECIFIED if you want the service to use the frame rate you
                specify in the settings FramerateNumerator and FramerateDenominator.

                - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                smoother motion during frame rate conversion.

                - **FramerateDenominator** *(integer) --* Frame rate denominator.

                - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                fraction, e.g. 24000 / 1001 = 23.976 fps.

                - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                structures that have B frames > 1.

                - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                applications, it is recommended that this be set to 1 so a decoder joining
                mid-stream will receive an IDR frame as quickly as possible. Setting this value to 0
                will break output segmenting.

                - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
                be greater than zero.

                - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                frames or seconds. If seconds the system will convert the GOP Size into a frame
                count at run time.

                - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                should initially be filled (HRD buffer model).

                - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                example, enter five megabits as 5000000.

                - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom
                (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field polarity as
                the source. If the source is interlaced, the output will be interlaced with the same
                polarity as the source (it will follow the source). The output could therefore be a
                mix of "top field first" and "bottom field first". If the source is progressive,
                your output will be interlaced with "top field first" or "bottom field first"
                polarity, depending on which of the Follow options you chose. If you don't choose a
                value, the service will default to Progressive (PROGRESSIVE).

                - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                five megabits per second as 5000000. Required when Rate control mode is QVBR.

                - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame
                is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched
                to the scene change I-frame. GOP stretch requires enabling lookahead as well as
                setting I-interval. The normal cadence resumes for the next GOP. This setting is
                only used when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size
                + Min-I-interval - 1

                - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
                reference frames.

                - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                encoder may use more than requested if using B-frames and/or interlaced encoding.

                - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
                service to use the pixel aspect ratio from the input. Using the console, do this by
                choosing Follow source for Pixel aspect ratio.

                - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                - **QualityTuningLevel** *(string) --* Use Quality tuning level
                (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                singlepass, or high-quality multipass video encoding.

                - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                encoding with the H.265 codec. Required when you set Rate control mode to QVBR. Not
                valid when you set Rate control mode to a value other than QVBR, or when you don't
                define Rate control mode.

                  - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                  mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                  values suited to the complexity of your input video, the service limits the
                  average bitrate of the video part of this output to the value that you choose.
                  That is, the total size of the video element is less than or equal to the value
                  you set multiplied by the number of seconds of encoded output.

                  - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                  mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                  target quality level for this output, from 1 to 10. Use higher numbers for greater
                  quality. Level 10 results in nearly lossless compression. The quality level for
                  most broadcast-quality transcodes is between 6 and 9.

                - **RateControlMode** *(string) --* Use this setting to specify whether this output
                has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
                bitrate (QVBR).

                - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                content

                - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                scene changes that the service automatically detects. This improves video quality
                and is enabled by default. If this output uses QVBR, choose Transition detection
                (TRANSITION_DETECTION) for further video quality improvement. For more information
                about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
                to the number of macroblock rows for progressive pictures, and less than or equal to
                half the number of macroblock rows for interlaced pictures.

                - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                input is relabeled as 25fps, and audio is sped up correspondingly.

                - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on spatial variation of content complexity.

                - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                Framerate (framerate) field is set to 29.970. This field works with the Streams >
                Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
                output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
                29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
                output to 29.97i.

                - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on temporal variation of content complexity.

                - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
                form one layer, reference B-frames can form a second layer and non-reference
                b-frames can form a third layer. Decoders can optionally decode only the lower
                temporal layers to generate a lower frame rate output. For example, given a
                bitstream with temporal IDs and with b-frames =
                     1 (i.e. IbPbPb display order), a
                decoder could decode all the frames for full frame rate output or only the I and P
                frames (lowest temporal layer) for a half frame rate output.

                - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                vertical subdivision of the encoded pictures.

                - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                bytes of an unregistered SEI message.

                - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
                doesn't matter in your workflow, ignore this setting. Use this setting only with
                CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4
                outputs). Choose HVC1 to mark your output as HVC1. This makes your output compliant
                with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15
                3rd Edition. For these outputs, the service stores parameter set NAL units in the
                sample headers but not in the samples directly. For MP4 outputs, when you choose
                HVC1, your output video might not work properly with some downstream systems and
                video players. The service defaults to marking your output as HEV1. For these
                outputs, the service writes parameter set NAL units directly into the samples.

              - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
              (VideoDescription)>(CodecSettings) to the value MPEG2.

                - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                quantizers to vary to improve visual quality.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                rounded down to the nearest multiple of 1000.

                - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                for the video output.

                - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                profile for the video output.

                - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                quality for high-motion content. This will cause the service to use fewer B-frames
                (which infer information based on other frames) for high-motion portions of the
                video and more B-frames for low-motion portions. The maximum number of B-frames is
                limited by the value you provide for the setting B frames between reference frames
                (numberBFramesBetweenReferenceFrames).

                - **FramerateControl** *(string) --* If you are using the console, use the Framerate
                setting to specify the frame rate for this output. If you want to keep the same
                frame rate as the input video, choose Follow source. If you want to do frame rate
                conversion, choose a frame rate from the dropdown list or choose Custom. The
                framerates shown in the dropdown list are decimal approximations of fractions. If
                you choose Custom, specify your frame rate as a fraction. If you are creating your
                transcoding job sepecification as a JSON file without the console, use
                FramerateControl to specify which value the service uses for the frame rate for this
                output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
                from the input. Choose SPECIFIED if you want the service to use the frame rate you
                specify in the settings FramerateNumerator and FramerateDenominator.

                - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                smoother motion during frame rate conversion.

                - **FramerateDenominator** *(integer) --* Frame rate denominator.

                - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                fraction, e.g. 24000 / 1001 = 23.976 fps.

                - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                applications, it is recommended that this be set to 1 so a decoder joining
                mid-stream will receive an IDR frame as quickly as possible. Setting this value to 0
                will break output segmenting.

                - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
                be greater than zero.

                - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
                frames or seconds. If seconds the system will convert the GOP Size into a frame
                count at run time.

                - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                should initially be filled (HRD buffer model).

                - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                example, enter five megabits as 5000000.

                - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
                (BOTTOM_FIELD) produce interlaced output with the entire output having the same
                field polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and
                Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the
                source. Therefore, behavior depends on the input scan type. - If the source is
                interlaced, the output will be interlaced with the same polarity as the source (it
                will follow the source). The output could therefore be a mix of "top field first"
                and "bottom field first". - If the source is progressive, the output will be
                interlaced with "top field first" or "bottom field first" polarity, depending on
                which of the Follow options you chose.

                - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision)
                to set quantization precision for intra-block DC coefficients. If you choose the
                value auto, the service will automatically select the precision based on the
                per-frame compression ratio.

                - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                five megabits per second as 5000000.

                - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame
                is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched
                to the scene change I-frame. GOP stretch requires enabling lookahead as well as
                setting I-interval. The normal cadence resumes for the next GOP. This setting is
                only used when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size
                + Min-I-interval - 1

                - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
                reference frames.

                - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
                service to use the pixel aspect ratio from the input. Using the console, do this by
                choosing Follow source for Pixel aspect ratio.

                - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                - **QualityTuningLevel** *(string) --* Use Quality tuning level
                (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
                encoding.

                - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
                specifiy whether the bitrate is variable (vbr) or constant (cbr).

                - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                scene changes that the service automatically detects. This improves video quality
                and is enabled by default.

                - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                input is relabeled as 25fps, and audio is sped up correspondingly.

                - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                reduce high-frequency content in the encoded image.

                - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on spatial variation of content complexity.

                - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                356M-2001).

                - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976
                output and leave converstion to the player.

                - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on temporal variation of content complexity.

              - **ProresSettings** *(dict) --* Required when you set (Codec) under
              (VideoDescription)>(CodecSettings) to the value PRORES.

                - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                type of Apple ProRes codec to use for this output.

                - **FramerateControl** *(string) --* If you are using the console, use the Framerate
                setting to specify the frame rate for this output. If you want to keep the same
                frame rate as the input video, choose Follow source. If you want to do frame rate
                conversion, choose a frame rate from the dropdown list or choose Custom. The
                framerates shown in the dropdown list are decimal approximations of fractions. If
                you choose Custom, specify your frame rate as a fraction. If you are creating your
                transcoding job sepecification as a JSON file without the console, use
                FramerateControl to specify which value the service uses for the frame rate for this
                output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
                from the input. Choose SPECIFIED if you want the service to use the frame rate you
                specify in the settings FramerateNumerator and FramerateDenominator.

                - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                smoother motion during frame rate conversion.

                - **FramerateDenominator** *(integer) --* Frame rate denominator.

                - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
                use frame rate conversion, specify the frame rate as a fraction. For example, 24000
                / 1001 =
                     23.976 fps. Use FramerateNumerator to specify the numerator of this
                fraction. In this example, use 24000 for the value of FramerateNumerator.

                - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
                (BOTTOM_FIELD) produce interlaced output with the entire output having the same
                field polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and
                Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the
                source. Therefore, behavior depends on the input scan type. - If the source is
                interlaced, the output will be interlaced with the same polarity as the source (it
                will follow the source). The output could therefore be a mix of "top field first"
                and "bottom field first". - If the source is progressive, the output will be
                interlaced with "top field first" or "bottom field first" polarity, depending on
                which of the Follow options you chose.

                - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
                use the pixel aspect ratio from the input. To specify a different pixel aspect
                ratio: Using the console, choose it from the dropdown menu. Using the API, set
                ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

                - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                input is relabeled as 25fps, and audio is sped up correspondingly.

                - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976
                output and leave converstion to the player.

            - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
            color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
            this output. If you don't specify a value, the service sets this to Insert by default.

            - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
            service will include in the output video frame.

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
            feature is enabled, the service will use drop-frame timecode on outputs. If it is not
            possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
            setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

            - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
            Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
            will write on all frames of this video output.

            - **Height** *(integer) --* Use the Height (Height) setting to define the video
            resolution height for this output. Specify in pixels. If you don't provide a value here,
            the service will use the input height.

            - **Position** *(dict) --* Use Selection placement (position) to define the video area
            in your output frame. The area outside of the rectangle that you specify here is black.

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
            service changes the video itself in response to AFD values in the input. * Choose
            Respond to clip the input video frame according to the AFD value, input display aspect
            ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
            values. Do not choose this when AfdSignaling is set to (NONE). A preferred
            implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling to
            (AUTO). * Choose None to remove all input AFD values from this output.

            - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
            different aspect ratio from the input aspect ratio. Choose Stretch to output
            (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
            setting Default (DEFAULT) to have the service letterbox your video instead. This setting
            overrides any value that you specify for the setting Selection placement (position) in
            this output.

            - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
            of anti-aliasing. This setting changes the width of the anti-alias filter kernel used
            for scaling. Sharpness only applies if your output resolution is different from your
            input resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for
            most content.

            - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
            outputs. Only enable Timecode insertion when the input frame rate is identical to the
            output frame rate. To include timecodes in this output, set Timecode insertion
            (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
            Default is DISABLED. When the service inserts timecodes in an output, by default, it
            uses any embedded timecodes from the input. If none are present, the service will set
            the timecode for the first output frame to zero. To change this default behavior, adjust
            the settings under Timecode configuration (TimecodeConfig). In the console, these
            settings are located under Job > Job settings > Timecode configuration. Note - Timecode
            source under input settings (InputTimecodeSource) does not affect the timecodes that are
            inserted in the output. Source under Job settings > Timecode configuration
            (TimecodeSource) does.

            - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
            Preprocessors (VideoPreprocessors). Enable the features at each output individually.
            These features are disabled by default.

              - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
              if necessary. Enable or disable this feature for each output individually. This
              setting is disabled by default.

                - **Brightness** *(integer) --* Brightness level.

                - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                output. The service supports conversion between HDR formats, between SDR formats,
                and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to
                HDR conversion doesn't upgrade the dynamic range. The converted video has an HDR
                format, but visually appears the same as an unconverted output.

                - **Contrast** *(integer) --* Contrast level.

                - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                metadata that you want signaled in the output. These values don't affect the pixel
                values that are encoded in the video stream. They are intended to help the
                downstream video player display content in a way that reflects the intentions of the
                the content creator. When you set Color space conversion (ColorSpaceConversion) to
                HDR 10 (FORCE_HDR10), these settings are required. You must set values for Max frame
                average light level (maxFrameAverageLightLevel) and Max content light level
                (maxContentLightLevel); these settings don't have a default value. The default
                values for the other HDR 10 metadata settings are defined by the P3D65 color space.
                For more information about MediaConvert HDR jobs, see
                https://docs.aws.amazon.com/console/mediaconvert/hdr.

                  - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                  the coded video sequence, in units of candelas per square meter. This setting
                  doesn't have a default value; you must specify a value that is suitable for the
                  content.

                  - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                  frame in the coded video sequence, in units of candelas per square meter. This
                  setting doesn't have a default value; you must specify a value that is suitable
                  for the content.

                  - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                  units of of 0.0001 candelas per square meter.

                  - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                  units of of 0.0001 candelas per square meter

                  - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                - **Hue** *(integer) --* Hue in degrees.

                - **Saturation** *(integer) --* Saturation level.

              - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
              motion and a clearer picture.

                - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source
                file includes a ticker, such as a scrolling headline at the bottom of the frame.

                - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                not convert frames that are tagged in metadata as progressive. It will only convert
                those that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the
                deinterlacer converts every frame to progressive - even those that are already
                tagged as progressive. Turn Force mode on only if there is a good chance that the
                metadata has tagged frames as progressive when they are not progressive. Do not turn
                on otherwise; processing frames that are already progressive into progressive will
                probably result in lower quality video.

                - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                progressive 23.976p. - Adaptive auto-detects and converts to progressive.

              - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
              compatible video output.

                - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                to SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                  - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                  corresponds to the brightest pixel in the entire stream. Measured in nits.

                  - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                  metadata that corresponds to the highest frame-average brightness in the entire
                  stream. Measured in nits.

                - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                handle Dolby Vision MaxCLL and MaxFALL properies.

                - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                Dolby Vision frame interleaved data.

              - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
              include a graphic overlay on your video. Enable or disable this feature for each
              output individually. This setting is disabled by default.

                - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                your video. The images must be PNG or TGA files.

                  - *(dict) --* Settings that specify how your still graphic overlay appears.

                    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                    to remain on the output video. This duration includes fade-in time but not
                    fade-out time.

                    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                    the Start time that you specify for the image insertion and the time that the
                    image appears at full opacity. Full opacity is the level that you specify for
                    the opacity setting. If you don't specify a value for Fade-in, the image will
                    appear abruptly at the overlay start time.

                    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                    between the end of the time that you have specified for the image overlay
                    Duration and when the overlaid image has faded to total transparency. If you
                    don't specify a value for Fade-out, the image will disappear abruptly at the end
                    of the inserted image duration.

                    - **Height** *(integer) --* Specify the height of the inserted image in pixels.
                    If you specify a value that's larger than the video resolution height, the
                    service will crop your overlaid image to fit. To use the native height of the
                    image, keep this setting blank.

                    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                    location of the image that you want to overlay on the video. Use a PNG or TGA
                    file.

                    - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                    inserted image and the left edge of the video frame. Required for any image
                    overlay that you specify.

                    - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                    overlaid image and the top edge of the video frame. Required for any image
                    overlay that you specify.

                    - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                    Images with higher values for Layer appear on top of images with lower values
                    for Layer.

                    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                    underlying video shows through the inserted image. 0 is transparent and 100 is
                    fully opaque. Default is 50.

                    - **StartTime** *(string) --* Specify the timecode of the frame that you want
                    the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                    HH:MM:SS;FF) format. Remember to take into account your timecode source
                    settings.

                    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                    you specify a value that's larger than the video resolution width, the service
                    will crop your overlaid image to fit. To use the native width of the image, keep
                    this setting blank.

              - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
              remove noise from your video output if necessary. Enable or disable this feature for
              each output individually. This setting is disabled by default.

                - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                one of the following spatial image filtering functions. To use this setting, you
                must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                frequency-domain filtering based on JND principles. * Temporal optimizes video
                quality for complex motion.

                - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                  - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                  values produce stronger filtering.

                - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                filter.

                  - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                  reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                  maximum strength.

                  - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                  (higher speed), with 0 being the nominal value.

                  - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                  values produce stronger filtering.

                - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
                filter.

                  - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                  complex motion. Higher values produce stronger temporal filtering. This filters
                  highly complex scenes more aggressively and creates better VQ for low bitrate
                  outputs.

                  - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                  setting reduces bit rate at the cost of transcode time, high setting improves
                  transcode time at the cost of bit rate.

                  - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                  this output. Higher values produce stronger filtering. We recommend the following
                  value ranges, depending on the result that you want: * 0-2 for complexity
                  reduction with minimal sharpness loss * 2-8 for complexity reduction with image
                  preservation * 8-16 for a high level of complexity reduction

              - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
              timecode and specified prefix into the output.

                - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                burned-in timecode. Valid values are 10, 16, 32, 48.

                - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
                burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                letters, numbers, and all special characters represented on a standard English
                keyboard.

            - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
            pixels, for this output. If you don't provide a value here, the service will use the
            input width.

        - **Type** *(string) --* A preset can be of two types: system or custom. System or built-in
        preset can't be modified or deleted by the user.
    """


_ClientListQueuesResponseQueuesReservationPlanTypeDef = TypedDict(
    "_ClientListQueuesResponseQueuesReservationPlanTypeDef",
    {
        "Commitment": str,
        "ExpiresAt": datetime,
        "PurchasedAt": datetime,
        "RenewalType": str,
        "ReservedSlots": int,
        "Status": str,
    },
    total=False,
)


class ClientListQueuesResponseQueuesReservationPlanTypeDef(
    _ClientListQueuesResponseQueuesReservationPlanTypeDef
):
    """
    Type definition for `ClientListQueuesResponseQueues` `ReservationPlan`

    - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
    commitment.

    - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing plan
    term for this reserved queue expires.

    - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the current
    pricing plan for this reserved queue.

    - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing plan
    is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

    - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS) for
    this queue. The number of RTS determines how many jobs the queue can process in parallel; each
    RTS can process one job at a time. When you increase this number, you extend your existing
    commitment with a new 12-month commitment for a larger number of RTS. The new commitment begins
    when you purchase the additional capacity. You can't decrease the number of RTS in your reserved
    queue.

    - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is ACTIVE
    or EXPIRED.
    """


_ClientListQueuesResponseQueuesTypeDef = TypedDict(
    "_ClientListQueuesResponseQueuesTypeDef",
    {
        "Arn": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "PricingPlan": str,
        "ProgressingJobsCount": int,
        "ReservationPlan": ClientListQueuesResponseQueuesReservationPlanTypeDef,
        "Status": str,
        "SubmittedJobsCount": int,
        "Type": str,
    },
    total=False,
)


class ClientListQueuesResponseQueuesTypeDef(_ClientListQueuesResponseQueuesTypeDef):
    """
    Type definition for `ClientListQueuesResponse` `Queues`

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for when you created the queue.

    - **Description** *(string) --* An optional description that you create for each queue.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds for when you most recently
    updated the queue.

    - **Name** *(string) --* A name that you create for each queue. Each name must be unique within
    your account.

    - **PricingPlan** *(string) --* Specifies whether the pricing plan for the queue is on-demand or
    reserved. For on-demand, you pay per minute, billed in increments of .01 minute. For reserved,
    you pay for the transcoding capacity of the entire queue, regardless of how much or how little
    you use it. Reserved pricing requires a 12-month commitment.

    - **ProgressingJobsCount** *(integer) --* The estimated number of jobs with a PROGRESSING
    status.

    - **ReservationPlan** *(dict) --* Details about the pricing plan for your reserved queue.
    Required for reserved queues and not applicable to on-demand queues.

      - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
      commitment.

      - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing
      plan term for this reserved queue expires.

      - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the
      current pricing plan for this reserved queue.

      - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing plan
      is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

      - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS) for
      this queue. The number of RTS determines how many jobs the queue can process in parallel; each
      RTS can process one job at a time. When you increase this number, you extend your existing
      commitment with a new 12-month commitment for a larger number of RTS. The new commitment
      begins when you purchase the additional capacity. You can't decrease the number of RTS in your
      reserved queue.

      - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is
      ACTIVE or EXPIRED.

    - **Status** *(string) --* Queues can be ACTIVE or PAUSED. If you pause a queue, the service
    won't begin processing jobs in that queue. Jobs that are running when you pause the queue
    continue to run until they finish or result in an error.

    - **SubmittedJobsCount** *(integer) --* The estimated number of jobs with a SUBMITTED status.

    - **Type** *(string) --* Specifies whether this on-demand queue is system or custom. System
    queues are built in. You can't modify or delete system queues. You can create and modify custom
    queues.
    """


_ClientListQueuesResponseTypeDef = TypedDict(
    "_ClientListQueuesResponseTypeDef",
    {"NextToken": str, "Queues": List[ClientListQueuesResponseQueuesTypeDef]},
    total=False,
)


class ClientListQueuesResponseTypeDef(_ClientListQueuesResponseTypeDef):
    """
    Type definition for `ClientListQueues` `Response`

    - **NextToken** *(string) --* Use this string to request the next batch of queues.

    - **Queues** *(list) --* List of queues.

      - *(dict) --* You can use queues to manage the resources that are available to your AWS
      account for running multiple transcoding jobs at the same time. If you don't specify a queue,
      the service sends all jobs through the default queue. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/working-with-queues.html.

        - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

        - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for when you created the
        queue.

        - **Description** *(string) --* An optional description that you create for each queue.

        - **LastUpdated** *(datetime) --* The timestamp in epoch seconds for when you most recently
        updated the queue.

        - **Name** *(string) --* A name that you create for each queue. Each name must be unique
        within your account.

        - **PricingPlan** *(string) --* Specifies whether the pricing plan for the queue is
        on-demand or reserved. For on-demand, you pay per minute, billed in increments of .01
        minute. For reserved, you pay for the transcoding capacity of the entire queue, regardless
        of how much or how little you use it. Reserved pricing requires a 12-month commitment.

        - **ProgressingJobsCount** *(integer) --* The estimated number of jobs with a PROGRESSING
        status.

        - **ReservationPlan** *(dict) --* Details about the pricing plan for your reserved queue.
        Required for reserved queues and not applicable to on-demand queues.

          - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
          commitment.

          - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current
          pricing plan term for this reserved queue expires.

          - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the
          current pricing plan for this reserved queue.

          - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing
          plan is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

          - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS)
          for this queue. The number of RTS determines how many jobs the queue can process in
          parallel; each RTS can process one job at a time. When you increase this number, you
          extend your existing commitment with a new 12-month commitment for a larger number of RTS.
          The new commitment begins when you purchase the additional capacity. You can't decrease
          the number of RTS in your reserved queue.

          - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is
          ACTIVE or EXPIRED.

        - **Status** *(string) --* Queues can be ACTIVE or PAUSED. If you pause a queue, the service
        won't begin processing jobs in that queue. Jobs that are running when you pause the queue
        continue to run until they finish or result in an error.

        - **SubmittedJobsCount** *(integer) --* The estimated number of jobs with a SUBMITTED
        status.

        - **Type** *(string) --* Specifies whether this on-demand queue is system or custom. System
        queues are built in. You can't modify or delete system queues. You can create and modify
        custom queues.
    """


_ClientListTagsForResourceResponseResourceTagsTypeDef = TypedDict(
    "_ClientListTagsForResourceResponseResourceTagsTypeDef",
    {"Arn": str, "Tags": Dict[str, str]},
    total=False,
)


class ClientListTagsForResourceResponseResourceTagsTypeDef(
    _ClientListTagsForResourceResponseResourceTagsTypeDef
):
    """
    Type definition for `ClientListTagsForResourceResponse` `ResourceTags`

    - **Arn** *(string) --* The Amazon Resource Name (ARN) of the resource.

    - **Tags** *(dict) --* The tags for the resource.

      - *(string) --*

        - *(string) --*
    """


_ClientListTagsForResourceResponseTypeDef = TypedDict(
    "_ClientListTagsForResourceResponseTypeDef",
    {"ResourceTags": ClientListTagsForResourceResponseResourceTagsTypeDef},
    total=False,
)


class ClientListTagsForResourceResponseTypeDef(_ClientListTagsForResourceResponseTypeDef):
    """
    Type definition for `ClientListTagsForResource` `Response`

    - **ResourceTags** *(dict) --* The Amazon Resource Name (ARN) and tags for an AWS Elemental
    MediaConvert resource.

      - **Arn** *(string) --* The Amazon Resource Name (ARN) of the resource.

      - **Tags** *(dict) --* The tags for the resource.

        - *(string) --*

          - *(string) --*
    """


_ClientUpdateJobTemplateAccelerationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateAccelerationSettingsTypeDef", {"Mode": str}
)


class ClientUpdateJobTemplateAccelerationSettingsTypeDef(
    _ClientUpdateJobTemplateAccelerationSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplate` `AccelerationSettings`

    - **Mode** *(string) --* **[REQUIRED]** Specify the conditions when the service will run your
    job with accelerated transcoding.
    """


_ClientUpdateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef",
    {"Mode": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplate` `AccelerationSettings`

    - **Mode** *(string) --* Specify the conditions when the service will run your job with
    accelerated transcoding.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef",
    {"AvailBlankingImage": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsEsam`
    `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsEsam`
    `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsEsamTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ClientUpdateJobTemplateResponseJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ClientUpdateJobTemplateResponseJobTemplateSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsEsamTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsEsamTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputs`
    `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectors`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectors`
    `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputs`
    `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str, ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorGroupsTypeDef
        ],
        "AudioSelectors": Dict[
            str, ClientUpdateJobTemplateResponseJobTemplateSettingsInputsAudioSelectorsTypeDef
        ],
        "CaptionSelectors": Dict[
            str, ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCaptionSelectorsTypeDef
        ],
        "Crop": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DenoiseFilter": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsImageInserterTypeDef,
        "InputClippings": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsInputsInputClippingsTypeDef
        ],
        "Position": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ClientUpdateJobTemplateResponseJobTemplateSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsInputsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsInputsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserter`
    `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserter`
    `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroups`
    `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettings`
    `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputs`
    `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsOutputsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertion`
    `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplateSettings`
    `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ClientUpdateJobTemplateResponseJobTemplateSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ClientUpdateJobTemplateResponseJobTemplateSettingsAvailBlankingTypeDef,
        "Esam": ClientUpdateJobTemplateResponseJobTemplateSettingsEsamTypeDef,
        "Inputs": List[ClientUpdateJobTemplateResponseJobTemplateSettingsInputsTypeDef],
        "MotionImageInserter": ClientUpdateJobTemplateResponseJobTemplateSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ClientUpdateJobTemplateResponseJobTemplateSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ClientUpdateJobTemplateResponseJobTemplateSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ClientUpdateJobTemplateResponseJobTemplateSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ClientUpdateJobTemplateResponseJobTemplateSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateSettingsTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponseJobTemplate` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
    job. There can only be one input in a job template. Using the API, you can include multiple
    inputs when referencing a job template.

      - *(dict) --* Specified video input in a template.

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ClientUpdateJobTemplateResponseJobTemplateTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseJobTemplateTypeDef",
    {
        "AccelerationSettings": ClientUpdateJobTemplateResponseJobTemplateAccelerationSettingsTypeDef,
        "Arn": str,
        "Category": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "Priority": int,
        "Queue": str,
        "Settings": ClientUpdateJobTemplateResponseJobTemplateSettingsTypeDef,
        "StatusUpdateInterval": str,
        "Type": str,
    },
    total=False,
)


class ClientUpdateJobTemplateResponseJobTemplateTypeDef(
    _ClientUpdateJobTemplateResponseJobTemplateTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateResponse` `JobTemplate`

    - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
    with long, visually complex content.

      - **Mode** *(string) --* Specify the conditions when the service will run your job with
      accelerated transcoding.

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **Category** *(string) --* An optional category you create to organize your job templates.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for Job template creation.

    - **Description** *(string) --* An optional description you create for each job template.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the Job template was last
    updated.

    - **Name** *(string) --* A name you create for each job template. Each name must be unique
    within your account.

    - **Priority** *(integer) --* Relative priority on the job.

    - **Queue** *(string) --* Optional. The queue that jobs created from this template are assigned
    to. If you don't specify this, jobs will go to the default queue.

    - **Settings** *(dict) --* JobTemplateSettings contains all the transcode settings saved in the
    template that will be applied to jobs created from it.

      - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
      the input Ad Avail PTS time.

      - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
      overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

        - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
        black. Only bmp and png images are supported.

      - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

        - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
        ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
        uses the manifest conditioning instructions that you provide in the setting MCC XML
        (mccXml).

          - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
          document inside your JSON job settings. Form the XML document as per
          OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions
          in the message that you supply.

        - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
        between the SCTE 35 messages that the transcoder places and the splice points that they
        refer to. If the time between the start of the asset and the SCTE-35 message is less than
        this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

        - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
        SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
        signal processing instructions that you provide in the setting SCC XML (sccXml).

          - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
          inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
          transcoder will use the signal processing instructions in the message that you supply.
          Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
          For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
          insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
          (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
          passthrough. You can't do both.

      - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
      job. There can only be one input in a job template. Using the API, you can include multiple
      inputs when referencing a job template.

        - *(dict) --* Specified video input in a template.

          - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
          combine. An input may have multiple audio selector groups. See "Audio Selector
          Group":#inputs-audio_selector_group for more information.

            - *(string) --*

              - *(dict) --* Group of Audio Selectors

                - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
                to include in the group. Audio selector names are standardized, based on their order
                within the input (e.g., "Audio Selector 1"). The audio selector name parameter can
                be repeated to add any number of audio selectors to the group.

                  - *(string) --*

          - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
          or set of tracks from the input that you will use in your outputs. You can use mutiple
          Audio selectors per input.

            - *(string) --*

              - *(dict) --* Selector for Audio

                - **CustomLanguageCode** *(string) --* Selects a specific language code from within
                an audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                set it as the default for the job. The service uses this default for outputs where
                it can't find the specified input audio. If you don't set a default, those outputs
                have no audio.

                - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                file source.

                - **LanguageCode** *(string) --* Selects a specific language code from within an
                audio source.

                - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                audio from the input video.

                - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
                selects PID 0x101).

                  - *(integer) --*

                - **ProgramSelection** *(integer) --* Use this setting for input streams that
                contain Dolby E, to have the service extract specific program data from the track.
                To select multiple programs, create multiple selectors with the same Track and
                different Program numbers. In the console, this setting is visible when you set
                Selector type to Track. Choose the program number from the dropdown list. If you are
                sending a JSON file, provide the program ID, which is part of the audio metadata. If
                your input file has incorrect metadata, you can choose All channels instead of a
                program number to have the service ignore the program IDs and include all the
                programs in the track.

                - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
                one input to match those of another input. This allows you to combine the two files
                into a single output, one after the other.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **SelectorType** *(string) --* Specifies the type of the audio selector.

                - **Tracks** *(list) --* Identify a track from the input audio to include in this
                selector by entering the track index number. To include several tracks in a single
                audio selector, specify multiple tracks as follows. Using the console, enter a
                comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                Specifying directly in your JSON job file, provide the track numbers in an array.
                For example, "tracks": [1,2,3].

                  - *(integer) --*

          - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
          the captions data from the input that you will use in your outputs. You can use mutiple
          captions selectors per input.

            - *(string) --*

              - *(dict) --* Set up captions in your outputs by first selecting them from your input
              here.

                - **CustomLanguageCode** *(string) --* The specific language to extract from source,
                using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
                complete this field and/or PID to select the caption language to extract. If input
                is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
                select the caption language to extract. If input is DVB-Sub that is being passed
                through, omit this field (and PID field); there is no way to extract a specific
                language with pass-through captions.

                - **LanguageCode** *(string) --* The specific language to extract from source. If
                input is SCTE-27, complete this field and/or PID to select the caption language to
                extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
                and/or PID to select the caption language to extract. If input is DVB-Sub that is
                being passed through, omit this field (and PID field); there is no way to extract a
                specific language with pass-through captions.

                - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                    number in the ancillary data track from which to extract captions. Unused for
                    passthrough.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                    PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content
                    is passed through, regardless of selectors.

                  - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                    within the video track from which to extract captions. Unused for passthrough.

                    - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                    for extracting captions. The system only supports one input video track, so this
                    should always be set to '1'.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                  STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source
                  file. If your caption source is IMSC in an IMF package, use TrackSourceSettings
                  instead of FileSoureSettings.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceFile** *(string) --* External caption file used for loading captions.
                    Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                    'smi'.

                    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                    captions from the source file.

                  - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                  your input captions. The service cannot auto-detect caption format.

                  - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                  sources, including Page number.

                    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                    three-digit hexadecimal page number that will be used for Teletext captions. Do
                    not use this setting if you are passing through teletext from the input source
                    to output.

                  - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                  are specified by track number. Currently, this is only IMSC captions in an IMF
                  package. If your caption source is IMSC 1.1 in a separate xml file, use
                  FileSourceSettings instead of TrackSourceSettings.

                    - **TrackNumber** *(integer) --* Use this setting to select a single captions
                    track from a source. Track numbers correspond to the order in the captions
                    source file. For IMF sources, track numbering is based on the order that the
                    captions appear in the CPL. For example, use 1 to select the captions asset that
                    is listed first in the CPL. To include more than one captions track in your job
                    outputs, create multiple input captions selectors. Specify one track per
                    selector.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame. If you specify a value here, it will
          override any value that you specify in the output setting Cropping selection (crop).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
          motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
          uncompressed video inputs.

          - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
          the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
          video inputs.

          - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
          transcoding service applies the denoise and deblock filters. You must also enable the
          filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
          Auto - The transcoding service determines whether to apply filtering, depending on input
          type and quality. * Disable - The input is not filtered. This is true even if you use the
          API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put
          is filtered regardless of input type.

          - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
          magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
          is 0.

          - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
          overlay on your video. Enable or disable this feature for each input individually. This
          setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
          that together specify a portion of the input to be used in the outputs. If you provide
          only a start time, the clip will be the entire input from that point to the end. If you
          provide only an end time, it will be the entire input up to that point. When you specify
          more than one input clip, the transcoding service creates the job outputs by stringing the
          clips together in the order you specify them.

            - *(dict) --* To transcode only portions of your input (clips), include one Input
            clipping (one instance of InputClipping in the JSON job file) for each input clip. All
            input clips you specify will be included in every output of the job.

              - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
              portion of the input you are clipping. The frame corresponding to the End timecode
              value is included in the clip. Start timecode or End timecode may be left blank, but
              not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
              minute, SS is the second, and FF is the frame number. When choosing this value, take
              into account your setting for timecode source under input settings
              (InputTimecodeSource). For example, if you have embedded timecodes that start at
              01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

              - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning
              of the portion of the input you are clipping. The frame corresponding to the Start
              timecode value is included in the clip. Start timecode or End timecode may be left
              blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour,
              MM is the minute, SS is the second, and FF is the frame number. When choosing this
              value, take into account your setting for Input timecode source. For example, if you
              have embedded timecodes that start at 01:00:00:00 and you want your clip to begin five
              minutes into the video, use 01:05:00:00.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black. If
          you specify a value here, it will override any value that you specify in the output
          setting Selection placement (position). If you specify a value here, this will override
          any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
          (RESPOND). If you specify a value here, this will ignore anything that you specify for the
          setting Scaling Behavior (scalingBehavior).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
          program from within a multi-program transport stream. Note that Quad 4K is not currently
          supported. Default is the first program within the transport stream. If the program you
          specify doesn't exist, the transcoding service will use this default.

          - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
          inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for
          audio and video. * Use PSI - Scan only PSI data.

          - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
          input settings (InputTimecodeSource), to specify how the service counts input video
          frames. This input frame count affects only the behavior of features that apply to a
          single input at a time, such as input clipping and synchronizing some captions formats.
          Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at zero
          (ZEROBASED) to start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to
          start the first frame at the timecode that you specify in the setting Start timecode
          (timecodeStart). If you don't specify a value for Timecode source, the service will use
          Embedded by default. For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
          for this input's initial frame. To use this setting, you must set the Timecode source
          setting, located under the input settings (InputTimecodeSource), to Specified start
          (SPECIFIEDSTART). For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **VideoSelector** *(dict) --* Selector for video.

            - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
            animation. Specify which part of this input MediaConvert uses for your outputs. Leave
            this setting set to DISCARD in order to delete the alpha channel and preserve the video.
            Use REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the
            luma channel of your outputs.

            - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
            if you don't know about color space, leave this set to the default value Follow
            (FOLLOW). The service will automatically detect your input color space. If your input
            video has metadata indicating the wrong color space, specify the accurate color space
            here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume
            static metadata isn't present in your video stream, or if that metadata is present but
            not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the
            input HDR 10 metadata (Hdr10Metadata) settings. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
            file and the job input settings Color space (ColorSpace) and HDR master display
            information settings(Hdr10Metadata). The Color space usage setting determines which
            takes precedence. Choose Force (FORCE) to use color metadata from the input job
            settings. If you don't specify values for those settings, the service defaults to using
            metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata
            from the source when it is present. If there's no color metadata in your input file, the
            service defaults to using values you specify in the input settings.

            - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
            missing or inaccurate in your input video. Appropriate values vary depending on the
            input video and must be provided by a color grader. The color grader generates these
            values during the HDR 10 mastering process. The valid range for each of these settings
            is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
            settings - When you specify these values, you must also set Color space (ColorSpace) to
            HDR 10 (HDR10). To specify whether the the values you specify here take precedence over
            the values in the metadata of your input file, set Color space usage (ColorSpaceUsage).
            To specify whether color metadata is included in an output, set Color metadata
            (ColorMetadata). For more information about MediaConvert HDR jobs, see
            https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
            Specify this value as an integer; the system automatically converts it to the
            hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
            an identifier for a set of data in an MPEG-2 transport stream container.

            - **ProgramNumber** *(integer) --* Selects a specific program from within a
            multi-program transport stream. Note that Quad 4K is not currently supported.

            - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
            your video. You can choose automatic rotation or specify a rotation. You can specify a
            clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov
            or .mp4 and your input has rotation metadata, you can choose Automatic to have the
            service rotate your video according to the rotation specified in the metadata. The
            rotation must be within one degree of 90, 180, or 270 degrees. If the rotation metadata
            specifies any other rotation, the service will default to no rotation. By default, the
            service does no rotation, even if your input video has rotation metadata. The service
            doesn't pass through rotation metadata.

      - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
      graphics that you specify here appear on all outputs in all output groups.

        - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
        unspecified. If your motion graphic asset is a series of .png files, specify the frame rate
        of the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1.
        Make sure that the number of images in your series matches the frame rate and your intended
        overlay duration. For example, if you want a 30-second overlay at 30 fps, you should have
        900 .png images. This overlay frame rate doesn't need to match the frame rate of the
        underlying video.

          - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

          - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

        - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
        overlay on your video. For .png files, provide the file name of the first file in the
        series. Make sure that the names of the .png files end with sequential numbers that specify
        the order that they are played in. For example, overlay_000.png, overlay_001.png,
        overlay_002.png, and so on. The sequence must start at zero, and each image file name must
        have the same number of digits. Pad your initial file names with enough zeros to complete
        the sequence. For example, if the first image is overlay_0.png, there can be only 10 images
        in the sequence, with the last image being overlay_9.png. But if the first image is
        overlay_00.png, there can be 100 images in the sequence.

        - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
        providing for your overlay. You can choose either a .mov file or a series of .png files.

        - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay
        on the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
        specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
        the service inserts the overlay at its native resolution and scales the size up or down with
        any video scaling.

          - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
          edge of the video frame.

          - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
          edge of the video frame.

        - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
        or plays only once.

        - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
        (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
        account how you have set up your timecode configuration under both job settings and input
        settings. The simplest way to do that is to set both to start at 0. If you need to set up
        your job to follow timecodes embedded in your source that don't start at zero, make sure
        that you specify a start time that is after the first embedded timecode. For more
        information, see https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html
        Find job-wide and input timecode configuration settings in your JSON job settings
        specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

      - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
      do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
      configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs
      in the job. To enable Nielsen configuration programmatically, include an instance of
      nielsenConfiguration in your JSON job specification. Even if you don't include any children of
      nielsenConfiguration, you still enable the setting.

        - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
        functionality. If you must include this property, set the value to zero.

        - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
        distributor ID that is assigned to your organization by Neilsen.

      - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
      outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
      MXF, and no container) are grouped in a single output group as well. Required in
      (OutputGroups) is a group of settings that apply to the whole group. This required object
      depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
      settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
      HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
      MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

        - *(dict) --* Group of outputs

          - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
          the output group. This value is displayed on the console and can make your job settings
          JSON more human-readable. It does not affect your outputs. Use up to twelve characters
          that are either letters, numbers, spaces, or underscores.

          - **Name** *(string) --* Name of the output group

          - **OutputGroupSettings** *(dict) --* Output Group settings, including type

            - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
            Output Group may only contain a single video, audio, or caption output.

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
              your job. These default manifests reference every output in the output group. To
              create additional top-level manifests that reference a subset of the outputs in the
              output group, specify a list of them here. For each additional manifest that you
              specify, the service creates one HLS manifest and one DASH manifest.

                - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
                that you want the service to generate for this CMAF output group. Each pair of
                manifests can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
              at the top level BaseURL element. Can be used if streams are delivered from a
              different URL than the manifest file.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
                service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                (SAMPLE-AES) or AES_CTR (AES-CTR).

                - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                outputs, choose whether the service writes the 128-bit encryption initialization
                vector in the HLS and DASH manifests.

                - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                  signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                  package. The DASH manifest can currently signal up to three system IDs. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                  signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                  package. The HLS manifest can currently signal only one system ID. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
              of each individual CMAF segment. This value applies to the whole package; that is, to
              every output in the output group. Note that segments end on the first keyframe after
              this number of seconds, so the actual segment length might be slightly longer. If you
              set Segment control (CmafSegmentControl) to single file, the service puts the content
              of each output in a single file that has metadata that marks these segments. If you
              set it to segmented files, the service creates multiple files for each output, each
              with the content of one segment.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
              generated for this output.

              - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
              be generated for this output.

            - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
              manifest for each DASH ISO output group in your job. This default manifest references
              every output in the output group. To create additional DASH manifests that reference a
              subset of the outputs in the output group, specify a list of them here.

                - *(dict) --* Specify the details for each additional DASH manifest that you want
                the service to generate for this output group. Each manifest can reference a
                different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.mpd.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
              (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
              from a different URL than the manifest file.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                compatibility of your output with video players on obsolete devices. It applies only
                to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
                only to correct problems with playback on older devices. Otherwise, keep the default
                setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the
                service will exclude the access unit delimiter and will leave the SEI NAL units
                unencrypted.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
              that segments will end on the next keyframe after this number of seconds, so actual
              segment length may be longer. When Emit Single File is checked, the segmentation is
              internal to a single output file and it does not cause the creation of many output
              files as in other output types.

              - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
              the 400 range when you play back your DASH output, enable this setting and run your
              transcoding job again. When you enable this setting, the service writes precise
              segment durations in the DASH manifest. The segment duration information appears
              inside the SegmentTimeline element, inside SegmentTemplate at the Representation
              level. When you don't enable this setting, the service writes approximate segment
              durations in your DASH manifest.

            - **FileGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

            - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

              - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
              HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
              outputs themselves.

                - *(string) --*

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest for each HLS output group in your job. This default manifest
              references every output in the output group. To create additional top-level manifests
              that reference a subset of the outputs in the output group, specify a list of them
              here.

                - *(dict) --* Specify the details for each additional HLS manifest that you want the
                service to generate for this output group. Each manifest can reference a different
                subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
              in the media .m3u8 file. Can be used if base manifest is delivered from a different
              URL than the main .m3u8 file.

              - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                - *(dict) --* Caption Language Mapping

                  - **CaptionChannel** *(integer) --* Caption channel.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                  - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                  three-letter code listed at
                  https://www.loc.gov/standards/iso639-2/php/code_list.php.

                  - **LanguageDescription** *(string) --* Caption language description.

              - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
              captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one
              language in the CC1 Language Code field. One CLOSED-CAPTION line is added for each
              Language Code you specify. Make sure to specify the languages in the order in which
              they appear in the original source (if the source is embedded format) or the order of
              the caption selectors (if the source is other than embedded). Otherwise, languages in
              the manifest will not match up properly with the output captions. None: Include
              CLOSED-CAPTIONS=
                  NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from
              the manifest.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
              subdirectories.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
                scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
                disables encryption.

                - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                128-bit number used in conjunction with the key for encrypting blocks. If set to
                INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                Vector is not in the manifest.

                - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                HLS FairPlay content protection.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
              looking ahead and back within the specified range for a nearby avail and extending the
              segment size if needed.

              - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
              be generated for this HLS output group.

              - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
              in .m3u8 manifest files. The value is calculated as follows: either the program date
              and time are initialized using the input timecode source, or the time is initialized
              using the input timecode source and the date is initialized using the
              timestamp_offset.

              - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
              EXT-X-PROGRAM-DATE-TIME entry, in seconds.

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
              media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

              - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
              create (in seconds). Note that segments will end on the next keyframe after this
              number of seconds, so actual segment length may be longer.

              - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
              subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
              for this setting to have an effect.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

              - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

              - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
              offset to fine tune the timestamps.

            - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .ism
              Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
              in your job. This default manifest references every output in the output group. To
              create additional manifests that reference a subset of the outputs in the output
              group, specify a list of them here.

                - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                manifest that you want the service to generate for this output group. Each manifest
                can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                  "-no-premium" for this setting, then the file name the service generates for this
                  top-level manifest is film-name-no-premium.ismv.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
              audio encoding settings across a Microsoft Smooth output group into a single audio
              stream.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* If you are using DRM, set DRM System
              (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
              the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
              and frame rate.

              - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding)
              to specify the encoding format for the server and client manifest. Valid options are
              utf8 and utf16.

            - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
            Microsoft Smooth Streaming, CMAF)

          - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
          settings per output.

            - *(dict) --* An output object describes the settings for a single output file or stream
            in an output group.

              - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
              encoding settings organized by audio codec. Include one instance of
              (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
              encoding settings.

                - *(dict) --* Description of audio output

                  - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                  settings. Ignore these settings unless you need to comply with a loudness
                  standard.

                    - **Algorithm** *(string) --* Choose one of the following audio normalization
                    algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                    loudness for an entire piece of content, suitable for measurement of short-form
                    content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-2: Gated loudness. A measurement of gated average loudness compliant
                    with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
                    with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
                    Allows for more audio channels than the other algorithms, including
                    configurations such as 7.1.

                    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                    using the chosen algorithm. If disabled, the audio will be measured but not
                    adjusted.

                    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                    be corrected to the target level. Content measuring below this level will not be
                    corrected. Gating only applies when not using real_time_correction.

                    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                    loudness to a CSV file.

                    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                    TruePeak for each output's audio track loudness.

                    - **TargetLkfs** *(float) --* When you use Audio normalization
                    (AudioNormalizationSettings), optionally use this setting to specify a target
                    loudness. If you don't specify a value here, the encoder chooses a value for
                    you, based on the algorithm that you choose for Algorithm (algorithm). If you
                    choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                    encoder will choose -23 LKFS.

                  - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                  input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                  name based on its order within each input. For example if you specify "Audio
                  Selector 3", then the third audio selector will be used from each input. If an
                  input does not have an "Audio Selector 3", then the audio selector marked as
                  "default" in that input will be used. If there is no audio selector marked as
                  "default", silence will be inserted for the duration of that input. Alternatively,
                  an "Audio Selector Group":#inputs-audio_selector_group name may be specified, with
                  similar default/silence behavior. If no audio_source_name is specified, then
                  "Audio Selector 1" will be chosen automatically.

                  - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                  unchecked (false). A number between 0 and 255. The following are defined in
                  ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                       Hearing Impaired, 3 =
                  Visually Impaired Commentary, 4-255 = Reserved.

                  - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                  contains an ISO 639 audio_type, then that value is passed through to the output.
                  If the input contains no ISO 639 audio_type, the value in Audio Type is included
                  in the output. Otherwise the value in Audio Type is included in the output. Note
                  that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                  is set to BROADCASTER_MIXED_AD.

                  - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                  (AudioDescriptions) contains the group of settings related to audio encoding. The
                  settings in this group vary depending on the value that you choose for Audio codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * AAC,
                  AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                  Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                    - **AacSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                    two mutually exclusive groups of AAC settings--VBR and CBR. To select one of
                    these modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or
                    "CBR". In VBR mode, you control the audio quality with the setting VBR quality
                    (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                    valid values depend on the rate control mode.

                      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                      when the input contains pre-mixed main audio + audio description (AD) as a
                      stereo pair. The value for AudioType will be set to 3, which signals to
                      downstream systems that this stream contains "broadcaster mixed AD". Note that
                      the input received by the encoder must contain pre-mixed audio; the encoder
                      does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                      ignores any values you provide in AudioType and FollowInputAudioType. Choose
                      NORMAL when the input does not contain pre-mixed audio + audio description
                      (AD). In this case, the encoder will use any values you provide for AudioType
                      and FollowInputAudioType.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      The set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000,
                      16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000,
                      112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000,
                      448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you set is
                      also constrained by the values that you choose for Profile (codecProfile),
                      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
                      values depend on Bitrate control mode and Profile.

                      - **CodecProfile** *(string) --* AAC Profile.

                      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                      channel layout. Valid values depend on rate control mode and profile. "1.0 -
                      Audio Description (Receiver Mix)" setting receives a stereo description plus
                      control track and emits a mono AAC encode of the description track, with
                      control data emitted in the PES header as per ETSI TS 101 154 Annex E.

                      - **RateControlMode** *(string) --* Rate Control Mode.

                      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                      use LATM/LOAS AAC in an output, you must choose "No container" for the output
                      container.

                      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                      control mode and profile.

                      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                      for raw or MPEG-2 Transport Stream containers.

                      - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                      rate_control_mode is VBR.

                    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AC3.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                      stream that the encoder emits. For more information about the AC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital, dialnorm will be passed through.

                      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                      adds dynamic range compression signaling to the output bitstream as defined in
                      the Dolby Digital specification.

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                    - **AiffSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AIFF.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **Codec** *(string) --* Type of Audio codec.

                    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid values: 384k, 448k, 640k, 768k

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                      (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                      adjust loudness based on dialogue analysis.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                      this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix
                      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                      value -60 mutes the channel.

                      - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                      your audio.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                      that must be speech before the encoder uses the measured speech loudness as
                      the overall program loudness.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing.

                      - **SurroundExMode** *(string) --* Specify whether your input audio has an
                      additional center rear surround channel matrix encoded into your left and
                      right surround channels.

                    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3.

                      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                      dB attenuation to the surround channels. Only used for 3/2 coding mode.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                      number of channels.

                      - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital Plus, dialnorm will be passed through.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                      LFE channel is enabled

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left only/Right only center (loRoCenterMixLevel).

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                      channel. This setting applies only if you keep the default value of 3/2 - L,
                      R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                      If you choose a different value for Coding mode, the service ignores Left
                      only/Right only surround (loRoSurroundMixLevel).

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total center (ltRtCenterMixLevel).

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                      surround). MediaConvert uses this value for downmixing. How the service uses
                      this value depends on the value that you choose for Stereo downmix
                      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
                      -60 mutes the channel. This setting applies only if you keep the default value
                      of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total surround (ltRtSurroundMixLevel).

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                      audio will be passed through if it is present on the input. this detection is
                      dynamic over the life of the transcode. Inputs that alternate between DD+ and
                      non-DD+ content will have a consistent DD+ output as the system alternates
                      between passthrough and encoding.

                      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                      the surround channels. Only used for 3/2 coding mode.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing. This setting only applies if you keep the default value of 3/2 -
                      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Stereo downmix (Eac3StereoDownmix).

                      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                      extra center back surround channel is matrix encoded into the left and right
                      surround channels.

                      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                      Surround is matrix encoded into the two channels.

                    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value MP2.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                      - **Channels** *(integer) --* Set Channels to specify the number of channels
                      in this output audio track. Choosing Mono in the console will give you 1
                      output channel; choosing Stereo will give you 2. In the API, valid values are
                      1 and 2.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **WavSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value WAV.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                      If your output audio is likely to exceed 4 GB in file size, or if you
                      otherwise need the extended support of the RF64 format, set your output WAV
                      file format to RF64.

                      - **SampleRate** *(integer) --* Sample rate in Hz.

                  - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                  track. The service puts this language code into your output audio track when you
                  set Language code control (AudioLanguageCodeControl) to Use configured
                  (USE_CONFIGURED). The service also uses your specified custom language code when
                  you set Language code control (AudioLanguageCodeControl) to Follow input
                  (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                  outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                  can also use any other code in the full RFC-5646 specification. Streaming outputs
                  are those that are in one of the following output groups: CMAF, DASH ISO, Apple
                  HLS, or Microsoft Smooth Streaming.

                  - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                  The ISO 639 language specified in the 'Language Code' drop down will be used when
                  'Follow Input Language Code' is not selected or when 'Follow Input Language Code'
                  is selected but there is no ISO 639 language code specified by the input.

                  - **LanguageCodeControl** *(string) --* Specify which source for language code
                  takes precedence for this audio track. When you choose Follow input
                  (FOLLOW_INPUT), the service uses the language code from the input track if it's
                  present. If there's no languge code on the input track, the service uses the code
                  that you specify in the setting Language code (languageCode or
                  customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service
                  uses the language code that you specify.

                  - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **StreamName** *(string) --* Specify a label for this output audio stream. For
                  example, "English", "Director commentary", or "track_2". For streaming outputs,
                  MediaConvert passes this information into destination manifests for display on the
                  end-viewer's player device. For outputs in other output groups, the service
                  ignores this setting.

              - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
              captions settings. For each output that has captions, include one instance of
              (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
              settings.

                - *(dict) --* Description of Caption output

                  - **CaptionSelectorName** *(string) --* Specifies which "Caption
                  Selector":#inputs-caption_selector to use from each input when generating
                  captions. The name should be of the format "Caption Selector ", which denotes that
                  the Nth Caption Selector will be used from each input.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  output track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information when automatically
                  selecting the font script for rendering the captions text. For all outputs, you
                  can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
                  any other code in the full RFC-5646 specification. Streaming outputs are those
                  that are in one of the following output groups: CMAF, DASH ISO, Apple HLS, or
                  Microsoft Smooth Streaming.

                  - **DestinationSettings** *(dict) --* Specific settings required by destination
                  type. Note that burnin_destination_settings are not available if the source of the
                  caption data is Embedded or Teletext.

                    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering burn-in captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **DestinationType** *(string) --* Specify the format for this set of captions
                    on this output. The default format is embedded without SCTE-20. Other options
                    are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                    web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                    (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec.
                    To create a non-compliant output where the embedded captions come first, choose
                    Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering DVB-Sub captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                      standard or for hearing impaired. Choose hearing impaired if your subtitles
                      include audio descriptions and dialogue. Choose standard if your subtitles
                      include only dialogue.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                    embedded/ancillary caption outputs, including 608/708 Channel destination
                    number.

                      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and your output captions are embedded in
                      the video stream. Specify a CC number for each captions channel in this
                      output. If you have two channels, choose CC numbers that aren't in the same
                      field. For example, choose 1 and 3. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and you want both 608 and 708 captions
                      embedded in your output stream. Optionally, specify the 708 service number for
                      each output captions channel. Choose a different number for each channel. To
                      use this setting, also set Force 608 to 708 upconvert (Convert608To708) to
                      Upconvert (UPCONVERT) in your input captions selector settings. If you choose
                      to upconvert but don't specify a 708 service number, MediaConvert uses the
                      number that you specify for CC channel number (destination608ChannelNumber)
                      for the 708 service number. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                    outputs.

                      - **StylePassthrough** *(string) --* Keep this setting enabled to have
                      MediaConvert use the font style and position information from the captions
                      source in the output. This option is available only when your input captions
                      are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                      output captions.

                    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                      sure that the captions and the video are synchronized in the output. Specify a
                      frame rate that matches the frame rate of the associated video. If the video
                      frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only
                      if the video has video_insertion=
                          true and drop_frame_timecode=true; otherwise,
                      choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                    output

                      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                      the destination captions for this output. This value must be a three-digit
                      hexadecimal string; strings ending in -FF are invalid. If you are passing
                      through the entire set of Teletext data, do not use this field.

                      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                      you don't specify a value here, the service sets the page type to the default
                      value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                      Teletext data, don't use this field. When you pass through a set of Teletext
                      pages, your output has the same page types as your input.

                        - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                        Table 94

                    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                    outputs, including Pass style information (TtmlStylePassthrough).

                      - **StylePassthrough** *(string) --* Pass through style and position
                      information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                      CFF-TT output or TTML output.

                  - **LanguageCode** *(string) --* Specify the language of this captions output
                  track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information to choose the font
                  language for rendering the captions text.

                  - **LanguageDescription** *(string) --* Specify a label for this set of output
                  captions. For example, "English", "Director commentary", or "track_2". For
                  streaming outputs, MediaConvert passes this information into destination manifests
                  for display on the end-viewer's player device. For outputs in other output groups,
                  the service ignores this setting.

              - **ContainerSettings** *(dict) --* Container specific settings.

                - **Container** *(string) --* Container for this output. Some containers require a
                container settings object. If not specified, the default object will be created.

                - **F4vSettings** *(dict) --* Settings for F4v container

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs
                in a File output group when the output's container (ContainerType) is MPEG-2
                Transport Stream (M2TS). In these assets, data is organized by the program map table
                (PMT). Each transport stream program contains subsets of data, including audio,
                video, and metadata. Each of these subsets of data has a numerical label called a
                packet identifier (PID). Each transport stream program corresponds to one
                MediaConvert output. The PMT lists the types of data in a program along with their
                PID. Downstream systems and players use the program map table to look up the PID for
                each type of data it accesses and then uses the PIDs to locate specific data within
                the asset.

                  - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                  models for Dolby Digital audio.

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                  elementary audio streams you include in this output. Specify multiple PIDs as a
                  JSON array. Default is the range 482-492.

                    - *(integer) --*

                  - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                  bits per second. Setting to 0 lets the muxer automatically determine the
                  appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                  - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                  interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                  this can lead to lower latency, but low-memory devices may not be able to play
                  back the stream without interruptions.

                  - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                  the specified table repetition interval.

                    - **NetworkId** *(integer) --* The numeric value placed in the Network
                    Information Table (NIT).

                    - **NetworkName** *(string) --* The network name text placed in the
                    network_name_descriptor inside the Network Information Table. Maximum length is
                    256 characters.

                    - **NitInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                  the specified table repetition interval.

                    - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                    output stream. "Follow input SDT" copies SDT information from input stream to
                    output stream. "Follow input SDT if present" copies SDT information from input
                    stream to output stream if SDT information is present in the input, otherwise it
                    will fall back on the user-defined values. Enter "SDT Manually" means user will
                    enter the SDT information. "No SDT" means output stream will not contain SDT
                    information.

                    - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **ServiceName** *(string) --* The service name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                    - **ServiceProviderName** *(string) --* The service provider name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                  - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                  subtitle data included in this output. Specify multiple PIDs as a JSON array.
                  Default is the range 460-479.

                    - *(integer) --*

                  - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                  specified table repetition interval.

                    - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                  teletext data you include in this output. Default is 499.

                  - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                  EBP markers will be added to partitions 3 and 4. The interval between these
                  additional markers will be fixed, and will be slightly shorter than the video EBP
                  marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                  inserted. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                  can either be placed only on the video PID, or on both the video PID and all audio
                  PIDs. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                  the PES header.

                  - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                  you know that your audio EBP markers are incorrectly appearing before your video
                  EBP markers. To correct this problem, set this value to Force (FORCE).

                  - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                  used with EBP markers.

                  - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                  between Program Clock References (PCRs) inserted into the transport stream.

                  - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                  Points do not come within the specified time interval of each other by looking
                  ahead at input video. If another EBP is going to come in within the specified time
                  interval, the current EBP is not emitted, and the segment is "stretched" to the
                  next marker. The lookahead value does not add latency to the system. The Live
                  Event must be configured elsewhere to create sufficient latency to make the
                  lookahead accurate.

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                  packets to insert into the transport stream. This can be used if a downstream
                  encryption system requires periodic null packets.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This is effective only when the PCR PID is the same as the video or audio
                  elementary stream.

                  - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                  clock reference (PCR) in this output. If you do not specify a value, the service
                  will use the value for Video PID (VideoPid).

                  - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                  instances of the program map table (PMT) in the output transport stream.

                  - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                  map table (PMT) itself. Default is 480.

                  - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                  private metadata stream. Default is 503.

                  - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                  the program number used in the program map table (PMT) for this output. Default is
                  1. Program numbers and program map tables are parts of MPEG-2 transport stream
                  containers, used for organizing data.

                  - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                  stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                  maximum bitrate, but the output will not be padded up to that bitrate.

                  - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                  markers in your HLS and transport stream outputs at the insertion points that you
                  specify in an ESAM XML document. Provide the document in the setting SCC XML
                  (sccXml).

                    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                    in the transport stream generated by ESAM.

                  - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                  stream in the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None
                  (NONE). Also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml). Also enable ESAM SCTE-35 (include the property
                  scte35Esam).

                  - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                  segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                  adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                  private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                  segments. ebp adds Encoder Boundary Point information to the adaptation field as
                  per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary
                  Point information to the adaptation field using a legacy proprietary format.

                  - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                  how segmentation markers are inserted into the transport stream. With avails, it
                  is possible that segments may be truncated, which can influence where future
                  segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                  selected and a segment is truncated due to an avail, we will reset the
                  segmentation cadence. This means the subsequent segment will have a duration of of
                  $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                  selected and a segment is truncated due to an avail, we will not reset the
                  segmentation cadence. This means the subsequent segment will likely be truncated
                  as well. However, all segments after that will have a duration of
                  $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
                  rule.

                  - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                  segment. Required unless markers is set to _none_.

                  - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                  timed metadata in this output. Default is 502.

                  - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                  itself in the program map table for this output. Transport stream IDs and program
                  map tables are parts of MPEG-2 transport stream containers, used for organizing
                  data.

                  - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                  elementary video stream in the transport stream.

                - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                  stream(s) in the transport stream. Multiple values are accepted, and can be
                  entered in ranges and/or by comma separation.

                    - *(integer) --*

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This parameter is effective only when the PCR PID is the same as the video or
                  audio elementary stream.

                  - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                  (PCR) in the transport stream. When no value is given, the encoder will assign the
                  same value as the Video PID.

                  - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                  (PMT) in the transport stream.

                  - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                  metadata stream in the transport stream.

                  - **ProgramNumber** *(integer) --* The value of the program number field in the
                  Program Map Table.

                  - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                  the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE)
                  if you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and
                  choose Ad markers (adMarkers) if you do want manifest conditioning. In both cases,
                  also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml).

                  - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                  specify whether the service inserts the ID3 timed metadata from the input in this
                  output.

                  - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                  metadata stream in the transport stream.

                  - **TransportStreamId** *(integer) --* The value of the transport stream ID field
                  in the Program Map Table.

                  - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                  stream in the transport stream.

                - **MovSettings** *(dict) --* Settings for MOV Container.

                  - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                  the video output settings.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                  streams into the QuickTime file using XDCAM fourcc codes. This increases
                  compatibility with Apple editors and players, but may decrease compatibility with
                  other players. Only applicable when the video codec is MPEG2.

                  - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                  padding

                  - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                  this setting.

                - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
                AAC outputs with this container.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                  moov box.

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                  - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                  file. Usually not necessary to specify.

                - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                  - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                  groups that include sidecar TTML or IMSC captions. You specify sidecar captions in
                  a separate output from your audio and video. Choose Raw (RAW) for captions in a
                  single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for
                  captions in XML format contained within fragmented MP4 files. This set of
                  fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                  - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                  markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                  insertion points that you specify in an ESAM XML document. Provide the document in
                  the setting SCC XML (sccXml).

                  - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                  markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                  SCTE-35 markers that appear in your input to also appear in this output. Choose
                  None (NONE) if you don't want those SCTE-35 markers in this output.

              - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
              for outputs in File output groups. If you do not specify a value, the service will use
              default extensions by container type as follows * MPEG-2 transport stream, m2ts *
              Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the
              service will use codec extensions (e.g. AAC, H265, H265, AC3)

              - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
              add a string to the end of each output filename. You specify the base filename as part
              of your destination URI. When you create multiple outputs in the same output group,
              Name modifier (NameModifier) is required. Name modifier also accepts format
              identifiers. For DASH ISO outputs, if you use the format identifiers $Number$ or
              $Time$ in one output, you must use them in the same way in all outputs of the output
              group.

              - **OutputSettings** *(dict) --* Specific settings for this type of output.

                - **HlsSettings** *(dict) --* Settings for HLS output groups

                  - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                  belongs.

                  - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                  outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                  container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                  file in a raw container. Regardless of the value that you specify here, if this
                  output has video, the service will place the output into an MPEG2-TS container.

                  - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                  with the video output stream. Input all the audio GROUP-IDs that are associated to
                  the video, separate by ','.

                  - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                  Audio-Only Variant Stream The client can play back this audio-only stream instead
                  of video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                  manifest. Alternate Audio, Auto Select, Default Alternate rendition that the
                  client should try to play back by default. Represented as an EXT-X-MEDIA in the
                  HLS manifest with DEFAULT=YES, AUTOSELECT=
                      YES Alternate Audio, Auto Select, Not
                  Default Alternate rendition that the client may try to play back by default.
                  Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                      NO, AUTOSELECT=YES
                  Alternate Audio, not Auto Select Alternate rendition that the client will not try
                  to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
                  DEFAULT=NO, AUTOSELECT=NO

                  - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                  Manifest in addition to the HLS manifest

                  - **SegmentModifier** *(string) --* String concatenated to end of segment
                  filenames. Accepts "Format Identifiers":#format_identifier_parameters.

              - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
              transcoding settings. Provide the system or custom preset name. You can specify either
              Preset (Preset) or Container settings (ContainerSettings), but not both.

              - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
              encoding settings. The specific video settings depend on the video codec that you
              choose when you specify a value for Video codec (codec). Include one instance of
              (VideoDescription) per output.

                - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                service includes AFD values in the output video data and what those values are. *
                Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                input AFD values and instead encode the value specified in the job. * Choose Auto to
                calculate output AFD values based on the input AFD scaler data.

                - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
                outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
                specify that in your job, the service will ignore the setting.

                - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                (VideoDescription), contains the group of settings related to video encoding. The
                settings in this group vary depending on the value that you choose for Video codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * H_264,
                H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
                FRAME_CAPTURE, FrameCaptureSettings

                  - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                  the enum values defined by the object VideoCodec.

                  - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                    - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.n.jpg where n is the 0-based sequence number of each Capture.

                    - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
                    to 7 decimal places.

                    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                    files).

                    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                    quality.

                  - **H264Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value H_264.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                    your output video settings. If you aren't sure what level to specify, choose
                    Auto (AUTO).

                    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                    are only available with the AVC-I License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                    Main or High profile) or CAVLC.

                    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                    for interlaced outputs.

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job specification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* When you use the API for transcode
                    jobs that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateDenominator to specify the
                    denominator of this fraction. In this example, use 1001 for the value of
                    FramerateDenominator. When you use the console for transcode jobs that use frame
                    rate conversion, provide the value as a decimal number for Framerate. In this
                    example, specify 23.976.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type, as follows. - If the source is interlaced, the output will be interlaced
                    with the same polarity as the source (it will follow the source). The output
                    could therefore be a mix of "top field first" and "bottom field first". - If the
                    source is progressive, the output will be interlaced with "top field first" or
                    "bottom field first" polarity, depending on which of the Follow options you
                    chose.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even
                    if repeated.

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                  - **H265Settings** *(dict) --* Settings for H265 codec

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                    Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                    Transfer Function (EOTF).

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* H.265 Level.

                    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                    (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                    "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                    available with the HEVC 4:2:2 License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                    Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                    the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field
                    First (BOTTOM_FIELD) to create an output that's interlaced with the same field
                    polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow,
                    Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the
                    same field polarity as the source. If the source is interlaced, the output will
                    be interlaced with the same polarity as the source (it will follow the source).
                    The output could therefore be a mix of "top field first" and "bottom field
                    first". If the source is progressive, your output will be interlaced with "top
                    field first" or "bottom field first" polarity, depending on which of the Follow
                    options you chose. If you don't choose a value, the service will default to
                    Progressive (PROGRESSIVE).

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                    Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                    based on content

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                    encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                    and P-frames form one layer, reference B-frames can form a second layer and
                    non-reference b-frames can form a third layer. Decoders can optionally decode
                    only the lower temporal layers to generate a lower frame rate output. For
                    example, given a bitstream with temporal IDs and with b-frames =
                         1 (i.e. IbPbPb
                    display order), a decoder could decode all the frames for full frame rate output
                    or only the I and P frames (lowest temporal layer) for a half frame rate output.

                    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                    vertical subdivision of the encoded pictures.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                    units doesn't matter in your workflow, ignore this setting. Use this setting
                    only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                    container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                    your output compliant with the following specification: ISO IECJTC1 SC29 N13798
                    Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
                    parameter set NAL units in the sample headers but not in the samples directly.
                    For MP4 outputs, when you choose HVC1, your output video might not work properly
                    with some downstream systems and video players. The service defaults to marking
                    your output as HEV1. For these outputs, the service writes parameter set NAL
                    units directly into the samples.

                  - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value MPEG2.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                    level for the video output.

                    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                    MPEG-2 profile for the video output.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **IntraDcPrecision** *(string) --* Use Intra DC precision
                    (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                    coefficients. If you choose the value auto, the service will automatically
                    select the precision based on the per-frame compression ratio.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                    video encoding.

                    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                    to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                    356M-2001).

                    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                  - **ProresSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value PRORES.

                    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                    the type of Apple ProRes codec to use for this output.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                    that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateNumerator to specify the
                    numerator of this fraction. In this example, use 24000 for the value of
                    FramerateNumerator.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                    determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                    to use the pixel aspect ratio from the input. To specify a different pixel
                    aspect ratio: Using the console, choose it from the dropdown menu. Using the
                    API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                    (ParDenominator).

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
                color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
                this output. If you don't specify a value, the service sets this to Insert by
                default.

                - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
                the service will include in the output video frame.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                feature is enabled, the service will use drop-frame timecode on outputs. If it is
                not possible to use drop-frame timecode, the system will fall back to
                non-drop-frame. This setting is enabled by default when Timecode insertion
                (TimecodeInsertion) is enabled.

                - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
                Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                service will write on all frames of this video output.

                - **Height** *(integer) --* Use the Height (Height) setting to define the video
                resolution height for this output. Specify in pixels. If you don't provide a value
                here, the service will use the input height.

                - **Position** *(dict) --* Use Selection placement (position) to define the video
                area in your output frame. The area outside of the rectangle that you specify here
                is black.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                the service changes the video itself in response to AFD values in the input. *
                Choose Respond to clip the input video frame according to the AFD value, input
                display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                include the input AFD values. Do not choose this when AfdSignaling is set to (NONE).
                A preferred implementation of this workflow is to set RespondToAfd to (NONE) and set
                AfdSignaling to (AUTO). * Choose None to remove all input AFD values from this
                output.

                - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                have a different aspect ratio from the input aspect ratio. Choose Stretch to output
                (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
                setting Default (DEFAULT) to have the service letterbox your video instead. This
                setting overrides any value that you specify for the setting Selection placement
                (position) in this output.

                - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                strength of anti-aliasing. This setting changes the width of the anti-alias filter
                kernel used for scaling. Sharpness only applies if your output resolution is
                different from your input resolution. 0 is the softest setting, 100 the sharpest,
                and 50 recommended for most content.

                - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                ProRes outputs. Only enable Timecode insertion when the input frame rate is
                identical to the output frame rate. To include timecodes in this output, set
                Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                output, by default, it uses any embedded timecodes from the input. If none are
                present, the service will set the timecode for the first output frame to zero. To
                change this default behavior, adjust the settings under Timecode configuration
                (TimecodeConfig). In the console, these settings are located under Job > Job
                settings > Timecode configuration. Note - Timecode source under input settings
                (InputTimecodeSource) does not affect the timecodes that are inserted in the output.
                Source under Job settings > Timecode configuration (TimecodeSource) does.

                - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                Preprocessors (VideoPreprocessors). Enable the features at each output individually.
                These features are disabled by default.

                  - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                  feature if necessary. Enable or disable this feature for each output individually.
                  This setting is disabled by default.

                    - **Brightness** *(integer) --* Brightness level.

                    - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                    this output. The service supports conversion between HDR formats, between SDR
                    formats, and from SDR to HDR. The service doesn't support conversion from HDR to
                    SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                    video has an HDR format, but visually appears the same as an unconverted output.

                    - **Contrast** *(integer) --* Contrast level.

                    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                    10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                    metadata that you want signaled in the output. These values don't affect the
                    pixel values that are encoded in the video stream. They are intended to help the
                    downstream video player display content in a way that reflects the intentions of
                    the the content creator. When you set Color space conversion
                    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                    must set values for Max frame average light level (maxFrameAverageLightLevel)
                    and Max content light level (maxContentLightLevel); these settings don't have a
                    default value. The default values for the other HDR 10 metadata settings are
                    defined by the P3D65 color space. For more information about MediaConvert HDR
                    jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                      samples in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                      any frame in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance
                      in units of of 0.0001 candelas per square meter.

                      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance
                      in units of of 0.0001 candelas per square meter

                      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                    - **Hue** *(integer) --* Hue in degrees.

                    - **Saturation** *(integer) --* Saturation level.

                  - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                  motion and a clearer picture.

                    - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                    (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                    adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                    (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if
                    your source file includes a ticker, such as a scrolling headline at the bottom
                    of the frame.

                    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                    does not convert frames that are tagged in metadata as progressive. It will only
                    convert those that are tagged as some other type. - When set to
                    FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                    those that are already tagged as progressive. Turn Force mode on only if there
                    is a good chance that the metadata has tagged frames as progressive when they
                    are not progressive. Do not turn on otherwise; processing frames that are
                    already progressive into progressive will probably result in lower quality
                    video.

                    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                    service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                    interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                    progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                  - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                  compatible video output.

                    - **L6Metadata** *(dict) --* Use these settings when you set
                    DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                    your input with new values.

                      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                      that corresponds to the brightest pixel in the entire stream. Measured in
                      nits.

                      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                      metadata that corresponds to the highest frame-average brightness in the
                      entire stream. Measured in nits.

                    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                    handle Dolby Vision MaxCLL and MaxFALL properies.

                    - **Profile** *(string) --* In the current MediaConvert implementation, the
                    Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must
                    contain Dolby Vision frame interleaved data.

                  - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature
                  to include a graphic overlay on your video. Enable or disable this feature for
                  each output individually. This setting is disabled by default.

                    - **InsertableImages** *(list) --* Specify the images that you want to overlay
                    on your video. The images must be PNG or TGA files.

                      - *(dict) --* Settings that specify how your still graphic overlay appears.

                        - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                        image to remain on the output video. This duration includes fade-in time but
                        not fade-out time.

                        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                        between the Start time that you specify for the image insertion and the time
                        that the image appears at full opacity. Full opacity is the level that you
                        specify for the opacity setting. If you don't specify a value for Fade-in,
                        the image will appear abruptly at the overlay start time.

                        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                        between the end of the time that you have specified for the image overlay
                        Duration and when the overlaid image has faded to total transparency. If you
                        don't specify a value for Fade-out, the image will disappear abruptly at the
                        end of the inserted image duration.

                        - **Height** *(integer) --* Specify the height of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        height, the service will crop your overlaid image to fit. To use the native
                        height of the image, keep this setting blank.

                        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                        location of the image that you want to overlay on the video. Use a PNG or
                        TGA file.

                        - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                        inserted image and the left edge of the video frame. Required for any image
                        overlay that you specify.

                        - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                        overlaid image and the top edge of the video frame. Required for any image
                        overlay that you specify.

                        - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                        Images with higher values for Layer appear on top of images with lower
                        values for Layer.

                        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                        the underlying video shows through the inserted image. 0 is transparent and
                        100 is fully opaque. Default is 50.

                        - **StartTime** *(string) --* Specify the timecode of the frame that you
                        want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                        or HH:MM:SS;FF) format. Remember to take into account your timecode source
                        settings.

                        - **Width** *(integer) --* Specify the width of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        width, the service will crop your overlaid image to fit. To use the native
                        width of the image, keep this setting blank.

                  - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                  remove noise from your video output if necessary. Enable or disable this feature
                  for each output individually. This setting is disabled by default.

                    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                    select one of the following spatial image filtering functions. To use this
                    setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                    preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                    Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                    reduction. * Spatial does frequency-domain filtering based on JND principles. *
                    Temporal optimizes video quality for complex motion.

                    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                    spatial filter.

                      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                      reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                      maximum strength.

                      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                      (higher speed), with 0 being the nominal value.

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                    temporal filter.

                      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                      complex motion. Higher values produce stronger temporal filtering. This
                      filters highly complex scenes more aggressively and creates better VQ for low
                      bitrate outputs.

                      - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                      Low setting reduces bit rate at the cost of transcode time, high setting
                      improves transcode time at the cost of bit rate.

                      - **Strength** *(integer) --* Specify the strength of the noise reducing
                      filter on this output. Higher values produce stronger filtering. We recommend
                      the following value ranges, depending on the result that you want: * 0-2 for
                      complexity reduction with minimal sharpness loss * 2-8 for complexity
                      reduction with image preservation * 8-16 for a high level of complexity
                      reduction

                  - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                  output timecode and specified prefix into the output.

                    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                    any burned-in timecode. Valid values are 10, 16, 32, 48.

                    - **Position** *(string) --* Use Position (Position) under under Timecode
                    burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                    output video.

                    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                    any burned-in timecode. For example, a prefix of "EZ-" will result in the
                    timecode "EZ-00:00:00:00". Provide either the characters themselves or the ASCII
                    code equivalents. The supported range of characters is 0x20 through 0x7e. This
                    includes letters, numbers, and all special characters represented on a standard
                    English keyboard.

                - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                in pixels, for this output. If you don't provide a value here, the service will use
                the input width.

      - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
      information from inputs.

        - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
        use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
        the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or
        (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
        Timecode varies depending on your setting for Source (TimecodeSource). * If Source
        (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
        specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
        (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start at
        0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
        Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
        input.

        - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
        within this job. To make sure that your video, audio, captions, and markers are synchronized
        and that time-based features, such as image inserter, work correctly, choose the Timecode
        source option that matches your assets. All timecodes are in a 24-hour format with frame
        number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video.
        If no embedded timecode is in the source, the service will use Start at 0 (ZEROBASED)
        instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. *
        Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other
        than zero. You use Start timecode (Start) to provide this value.

        - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
        (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
        Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

        - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
        stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
        affecting the time and frame number. Provide the new date as a string in the format
        "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
        (InsertProgramDateTime) in the output settings. For example, if the date part of your
        timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
        (TimestampOffset) to 2003-1-25.

      - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
      (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
      enable it here, enable it in each output container, and specify tags and timecodes in ID3
      insertion (Id3Insertion) objects.

        - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

          - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
          specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when
          the tag should be inserted. To insert multiple ID3 tags in your output, create multiple
          instances of ID3 insertion (Id3Insertion).

            - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
            format.

            - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
            format.

    - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
    events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
    MediaConvert sends an update at this interval from the time the service begins processing your
    job to the time it completes the transcode or encounters an error.

    - **Type** *(string) --* A job template can be of two types: system or custom. System or
    built-in job templates can't be modified or deleted by the user.
    """


_ClientUpdateJobTemplateResponseTypeDef = TypedDict(
    "_ClientUpdateJobTemplateResponseTypeDef",
    {"JobTemplate": ClientUpdateJobTemplateResponseJobTemplateTypeDef},
    total=False,
)


class ClientUpdateJobTemplateResponseTypeDef(_ClientUpdateJobTemplateResponseTypeDef):
    """
    Type definition for `ClientUpdateJobTemplate` `Response`

    - **JobTemplate** *(dict) --* A job template is a pre-made set of encoding instructions that you
    can use to quickly create a job.

      - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
      with long, visually complex content.

        - **Mode** *(string) --* Specify the conditions when the service will run your job with
        accelerated transcoding.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **Category** *(string) --* An optional category you create to organize your job templates.

      - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for Job template creation.

      - **Description** *(string) --* An optional description you create for each job template.

      - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the Job template was
      last updated.

      - **Name** *(string) --* A name you create for each job template. Each name must be unique
      within your account.

      - **Priority** *(integer) --* Relative priority on the job.

      - **Queue** *(string) --* Optional. The queue that jobs created from this template are
      assigned to. If you don't specify this, jobs will go to the default queue.

      - **Settings** *(dict) --* JobTemplateSettings contains all the transcode settings saved in
      the template that will be applied to jobs created from it.

        - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
        the input Ad Avail PTS time.

        - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
        overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

          - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
          black. Only bmp and png images are supported.

        - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

          - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
          ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
          uses the manifest conditioning instructions that you provide in the setting MCC XML
          (mccXml).

            - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
            document inside your JSON job settings. Form the XML document as per
            OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning
            instructions in the message that you supply.

          - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
          between the SCTE 35 messages that the transcoder places and the splice points that they
          refer to. If the time between the start of the asset and the SCTE-35 message is less than
          this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

          - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
          SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
          signal processing instructions that you provide in the setting SCC XML (sccXml).

            - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
            inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025.
            The transcoder will use the signal processing instructions in the message that you
            supply. Provide your ESAM SignalProcessingNotification XML document inside your JSON job
            settings. For your MPEG2-TS file outputs, if you want the service to place SCTE-35
            markers at the insertion points you specify in the XML document, you must also enable
            SCTE-35 ESAM (scte35Esam). Note that you can either specify an ESAM XML document or
            enable SCTE-35 passthrough. You can't do both.

        - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
        job. There can only be one input in a job template. Using the API, you can include multiple
        inputs when referencing a job template.

          - *(dict) --* Specified video input in a template.

            - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input
            to combine. An input may have multiple audio selector groups. See "Audio Selector
            Group":#inputs-audio_selector_group for more information.

              - *(string) --*

                - *(dict) --* Group of Audio Selectors

                  - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same
                  input to include in the group. Audio selector names are standardized, based on
                  their order within the input (e.g., "Audio Selector 1"). The audio selector name
                  parameter can be repeated to add any number of audio selectors to the group.

                    - *(string) --*

            - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
            or set of tracks from the input that you will use in your outputs. You can use mutiple
            Audio selectors per input.

              - *(string) --*

                - *(dict) --* Selector for Audio

                  - **CustomLanguageCode** *(string) --* Selects a specific language code from
                  within an audio source, using the ISO 639-2 or ISO 639-3 three-letter language
                  code

                  - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                  set it as the default for the job. The service uses this default for outputs where
                  it can't find the specified input audio. If you don't set a default, those outputs
                  have no audio.

                  - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                  file source.

                  - **LanguageCode** *(string) --* Selects a specific language code from within an
                  audio source.

                  - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                  audio from the input video.

                  - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g.
                  257 selects PID 0x101).

                    - *(integer) --*

                  - **ProgramSelection** *(integer) --* Use this setting for input streams that
                  contain Dolby E, to have the service extract specific program data from the track.
                  To select multiple programs, create multiple selectors with the same Track and
                  different Program numbers. In the console, this setting is visible when you set
                  Selector type to Track. Choose the program number from the dropdown list. If you
                  are sending a JSON file, provide the program ID, which is part of the audio
                  metadata. If your input file has incorrect metadata, you can choose All channels
                  instead of a program number to have the service ignore the program IDs and include
                  all the programs in the track.

                  - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels
                  of one input to match those of another input. This allows you to combine the two
                  files into a single output, one after the other.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **SelectorType** *(string) --* Specifies the type of the audio selector.

                  - **Tracks** *(list) --* Identify a track from the input audio to include in this
                  selector by entering the track index number. To include several tracks in a single
                  audio selector, specify multiple tracks as follows. Using the console, enter a
                  comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                  Specifying directly in your JSON job file, provide the track numbers in an array.
                  For example, "tracks": [1,2,3].

                    - *(integer) --*

            - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
            the captions data from the input that you will use in your outputs. You can use mutiple
            captions selectors per input.

              - *(string) --*

                - *(dict) --* Set up captions in your outputs by first selecting them from your
                input here.

                  - **CustomLanguageCode** *(string) --* The specific language to extract from
                  source, using the ISO 639-2 or ISO 639-3 three-letter language code. If input is
                  SCTE-27, complete this field and/or PID to select the caption language to extract.
                  If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or
                  PID to select the caption language to extract. If input is DVB-Sub that is being
                  passed through, omit this field (and PID field); there is no way to extract a
                  specific language with pass-through captions.

                  - **LanguageCode** *(string) --* The specific language to extract from source. If
                  input is SCTE-27, complete this field and/or PID to select the caption language to
                  extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this
                  field and/or PID to select the caption language to extract. If input is DVB-Sub
                  that is being passed through, omit this field (and PID field); there is no way to
                  extract a specific language with pass-through captions.

                  - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                  SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                  your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                  FileSoureSettings.

                    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions
                    source.

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                      number in the ancillary data track from which to extract captions. Unused for
                      passthrough.

                      - **TerminateCaptions** *(string) --* By default, the service terminates any
                      unterminated captions at the end of each input. If you want the caption to
                      continue onto your next input, disable this setting.

                    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                      PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub
                      content is passed through, regardless of selectors.

                    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel
                      number within the video track from which to extract captions. Unused for
                      passthrough.

                      - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                      for extracting captions. The system only supports one input video track, so
                      this should always be set to '1'.

                      - **TerminateCaptions** *(string) --* By default, the service terminates any
                      unterminated captions at the end of each input. If you want the caption to
                      continue onto your next input, disable this setting.

                    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                    STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption
                    source file. If your caption source is IMSC in an IMF package, use
                    TrackSourceSettings instead of FileSoureSettings.

                      - **Convert608To708** *(string) --* Specify whether this set of input captions
                      appears in your outputs in both 608 and 708 format. If you choose Upconvert
                      (UPCONVERT), MediaConvert includes the captions data in two ways: it passes
                      the 608 data through using the 608 compatibility bytes fields of the 708
                      wrapper, and it also translates the 608 data into 708.

                      - **SourceFile** *(string) --* External caption file used for loading
                      captions. Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt',
                      'xml', and 'smi'.

                      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                      captions from the source file.

                    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                    your input captions. The service cannot auto-detect caption format.

                    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                    sources, including Page number.

                      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                      three-digit hexadecimal page number that will be used for Teletext captions.
                      Do not use this setting if you are passing through teletext from the input
                      source to output.

                    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                    are specified by track number. Currently, this is only IMSC captions in an IMF
                    package. If your caption source is IMSC 1.1 in a separate xml file, use
                    FileSourceSettings instead of TrackSourceSettings.

                      - **TrackNumber** *(integer) --* Use this setting to select a single captions
                      track from a source. Track numbers correspond to the order in the captions
                      source file. For IMF sources, track numbering is based on the order that the
                      captions appear in the CPL. For example, use 1 to select the captions asset
                      that is listed first in the CPL. To include more than one captions track in
                      your job outputs, create multiple input captions selectors. Specify one track
                      per selector.

            - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
            service will include in the output video frame. If you specify a value here, it will
            override any value that you specify in the output setting Cropping selection (crop).

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce
            smoother motion in the output. Default is disabled. Only manaully controllable for MPEG2
            and uncompressed video inputs.

            - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise
            from the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and
            uncompressed video inputs.

            - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how
            the transcoding service applies the denoise and deblock filters. You must also enable
            the filters separately, with Denoise (InputDenoiseFilter) and Deblock
            (InputDeblockFilter). * Auto - The transcoding service determines whether to apply
            filtering, depending on input type and quality. * Disable - The input is not filtered.
            This is true even if you use the API to enable them in (InputDeblockFilter) and
            (InputDeblockFilter). * Force - The in put is filtered regardless of input type.

            - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
            magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
            is 0.

            - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
            overlay on your video. Enable or disable this feature for each input individually. This
            setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
            that together specify a portion of the input to be used in the outputs. If you provide
            only a start time, the clip will be the entire input from that point to the end. If you
            provide only an end time, it will be the entire input up to that point. When you specify
            more than one input clip, the transcoding service creates the job outputs by stringing
            the clips together in the order you specify them.

              - *(dict) --* To transcode only portions of your input (clips), include one Input
              clipping (one instance of InputClipping in the JSON job file) for each input clip. All
              input clips you specify will be included in every output of the job.

                - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
                portion of the input you are clipping. The frame corresponding to the End timecode
                value is included in the clip. Start timecode or End timecode may be left blank, but
                not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
                minute, SS is the second, and FF is the frame number. When choosing this value, take
                into account your setting for timecode source under input settings
                (InputTimecodeSource). For example, if you have embedded timecodes that start at
                01:00:00:00 and you want your clip to end six minutes into the video, use
                01:06:00:00.

                - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the
                beginning of the portion of the input you are clipping. The frame corresponding to
                the Start timecode value is included in the clip. Start timecode or End timecode may
                be left blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is
                the hour, MM is the minute, SS is the second, and FF is the frame number. When
                choosing this value, take into account your setting for Input timecode source. For
                example, if you have embedded timecodes that start at 01:00:00:00 and you want your
                clip to begin five minutes into the video, use 01:05:00:00.

            - **Position** *(dict) --* Use Selection placement (position) to define the video area
            in your output frame. The area outside of the rectangle that you specify here is black.
            If you specify a value here, it will override any value that you specify in the output
            setting Selection placement (position). If you specify a value here, this will override
            any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
            (RESPOND). If you specify a value here, this will ignore anything that you specify for
            the setting Scaling Behavior (scalingBehavior).

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
            program from within a multi-program transport stream. Note that Quad 4K is not currently
            supported. Default is the first program within the transport stream. If the program you
            specify doesn't exist, the transcoding service will use this default.

            - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
            inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs
            for audio and video. * Use PSI - Scan only PSI data.

            - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
            input settings (InputTimecodeSource), to specify how the service counts input video
            frames. This input frame count affects only the behavior of features that apply to a
            single input at a time, such as input clipping and synchronizing some captions formats.
            Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at
            zero (ZEROBASED) to start the first frame at zero. Choose Specified start
            (SPECIFIEDSTART) to start the first frame at the timecode that you specify in the
            setting Start timecode (timecodeStart). If you don't specify a value for Timecode
            source, the service will use Embedded by default. For more information about timecodes,
            see https://docs.aws.amazon.com/console/mediaconvert/timecode.

            - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
            for this input's initial frame. To use this setting, you must set the Timecode source
            setting, located under the input settings (InputTimecodeSource), to Specified start
            (SPECIFIEDSTART). For more information about timecodes, see
            https://docs.aws.amazon.com/console/mediaconvert/timecode.

            - **VideoSelector** *(dict) --* Selector for video.

              - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
              animation. Specify which part of this input MediaConvert uses for your outputs. Leave
              this setting set to DISCARD in order to delete the alpha channel and preserve the
              video. Use REMAP_TO_LUMA for this setting to delete the video and map the alpha
              channel to the luma channel of your outputs.

              - **ColorSpace** *(string) --* If your input video has accurate color space metadata,
              or if you don't know about color space, leave this set to the default value Follow
              (FOLLOW). The service will automatically detect your input color space. If your input
              video has metadata indicating the wrong color space, specify the accurate color space
              here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color
              Volume static metadata isn't present in your video stream, or if that metadata is
              present but not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct
              values in the input HDR 10 metadata (Hdr10Metadata) settings. For more information
              about MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the
              input file and the job input settings Color space (ColorSpace) and HDR master display
              information settings(Hdr10Metadata). The Color space usage setting determines which
              takes precedence. Choose Force (FORCE) to use color metadata from the input job
              settings. If you don't specify values for those settings, the service defaults to
              using metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color
              metadata from the source when it is present. If there's no color metadata in your
              input file, the service defaults to using values you specify in the input settings.

              - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
              missing or inaccurate in your input video. Appropriate values vary depending on the
              input video and must be provided by a color grader. The color grader generates these
              values during the HDR 10 mastering process. The valid range for each of these settings
              is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
              settings - When you specify these values, you must also set Color space (ColorSpace)
              to HDR 10 (HDR10). To specify whether the the values you specify here take precedence
              over the values in the metadata of your input file, set Color space usage
              (ColorSpaceUsage). To specify whether color metadata is included in an output, set
              Color metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
              https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input
              file. Specify this value as an integer; the system automatically converts it to the
              hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
              an identifier for a set of data in an MPEG-2 transport stream container.

              - **ProgramNumber** *(integer) --* Selects a specific program from within a
              multi-program transport stream. Note that Quad 4K is not currently supported.

              - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
              your video. You can choose automatic rotation or specify a rotation. You can specify a
              clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is
              .mov or .mp4 and your input has rotation metadata, you can choose Automatic to have
              the service rotate your video according to the rotation specified in the metadata. The
              rotation must be within one degree of 90, 180, or 270 degrees. If the rotation
              metadata specifies any other rotation, the service will default to no rotation. By
              default, the service does no rotation, even if your input video has rotation metadata.
              The service doesn't pass through rotation metadata.

        - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The
        motion graphics that you specify here appear on all outputs in all output groups.

          - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
          unspecified. If your motion graphic asset is a series of .png files, specify the frame
          rate of the overlay in frames per second, as a fraction. For example, specify 24 fps as
          24/1. Make sure that the number of images in your series matches the frame rate and your
          intended overlay duration. For example, if you want a 30-second overlay at 30 fps, you
          should have 900 .png images. This overlay frame rate doesn't need to match the frame rate
          of the underlying video.

            - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
            overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

            - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
            overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

          - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
          overlay on your video. For .png files, provide the file name of the first file in the
          series. Make sure that the names of the .png files end with sequential numbers that
          specify the order that they are played in. For example, overlay_000.png, overlay_001.png,
          overlay_002.png, and so on. The sequence must start at zero, and each image file name must
          have the same number of digits. Pad your initial file names with enough zeros to complete
          the sequence. For example, if the first image is overlay_0.png, there can be only 10
          images in the sequence, with the last image being overlay_9.png. But if the first image is
          overlay_00.png, there can be 100 images in the sequence.

          - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
          providing for your overlay. You can choose either a .mov file or a series of .png files.

          - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic
          overlay on the video frame. Specify in pixels, from the upper-left corner of the frame. If
          you don't specify an offset, the service scales your overlay to the full size of the
          frame. Otherwise, the service inserts the overlay at its native resolution and scales the
          size up or down with any video scaling.

            - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the
            left edge of the video frame.

            - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
            edge of the video frame.

          - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
          or plays only once.

          - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
          (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
          account how you have set up your timecode configuration under both job settings and input
          settings. The simplest way to do that is to set both to start at 0. If you need to set up
          your job to follow timecodes embedded in your source that don't start at zero, make sure
          that you specify a start time that is after the first embedded timecode. For more
          information, see
          https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide
          and input timecode configuration settings in your JSON job settings specification at
          settings>timecodeConfig>source and settings>inputs>timecodeSource.

        - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
        do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
        configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all
        outputs in the job. To enable Nielsen configuration programmatically, include an instance of
        nielsenConfiguration in your JSON job specification. Even if you don't include any children
        of nielsenConfiguration, you still enable the setting.

          - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
          functionality. If you must include this property, set the value to zero.

          - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
          distributor ID that is assigned to your organization by Neilsen.

        - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
        outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS,
        Quicktime, MXF, and no container) are grouped in a single output group as well. Required in
        (OutputGroups) is a group of settings that apply to the whole group. This required object
        depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
        settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
        HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
        MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

          - *(dict) --* Group of outputs

            - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
            the output group. This value is displayed on the console and can make your job settings
            JSON more human-readable. It does not affect your outputs. Use up to twelve characters
            that are either letters, numbers, spaces, or underscores.

            - **Name** *(string) --* Name of the output group

            - **OutputGroupSettings** *(dict) --* Output Group settings, including type

              - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
              Output Group may only contain a single video, audio, or caption output.

                - **AdditionalManifests** *(list) --* By default, the service creates one top-level
                .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group
                in your job. These default manifests reference every output in the output group. To
                create additional top-level manifests that reference a subset of the outputs in the
                output group, specify a list of them here. For each additional manifest that you
                specify, the service creates one HLS manifest and one DASH manifest.

                  - *(dict) --* Specify the details for each pair of HLS and DASH additional
                  manifests that you want the service to generate for this CMAF output group. Each
                  pair of manifests can reference a different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your HLS group is film-name.m3u8. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                    specify a manifestNameModifier that is different from the nameModifier of the
                    output. The service uses the output name modifier to create unique names for the
                    individual variant manifests.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                file at the top level BaseURL element. Can be used if streams are delivered from a
                different URL than the manifest file.

                - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
                which prevents client from saving media segments for later replay.

                - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
                RFC-4281) during m3u8 playlist generation.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* DRM settings.

                  - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                  value represented by a 32-character text string. If this parameter is not set then
                  the Initialization Vector will follow the segment number by default.

                  - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want
                  the service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                  (SAMPLE-AES) or AES_CTR (AES-CTR).

                  - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                  outputs, choose whether the service writes the 128-bit encryption initialization
                  vector in the HLS and DASH manifests.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                  settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                  output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                  settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                    signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                    package. The DASH manifest can currently signal up to three system IDs. For more
                    information, see https://dashif.org/identifiers/content_protection/.

                      - *(string) --*

                    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                    signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                    package. The HLS manifest can currently signal only one system ID. For more
                    information, see https://dashif.org/identifiers/content_protection/.

                      - *(string) --*

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                  - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                  static key provider.

                    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                    the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                    omitted to indicate an implicit value of 'identity'.

                    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                    single positive integer version value or a slash delimited list of version
                    values (1/2/3).

                    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                    32-character hexidecimal string to specify Key Value (StaticKeyValue).

                    - **Url** *(string) --* Relates to DRM implementation. The location of the
                    license server used for protecting content.

                  - **Type** *(string) --* Specify whether your DRM encryption key is static or from
                  a key provider that follows the SPEKE standard. For more information about SPEKE,
                  see https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                Fragment length must be compatible with GOP size and Framerate. Note that fragments
                will end on the next keyframe after this number of seconds, so actual fragment
                length may be longer. When Emit Single File is checked, the fragmentation is
                internal to a single output file and it does not cause the creation of many output
                files as in other output types.

                - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                should use floating point values for segment duration.

                - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
                needed to ensure smooth playout.

                - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                0, unless you are troubleshooting a problem with how devices play back the end of
                your video asset. If you know that player devices are hanging on the final segment
                of your video because the length of your final segment is too short, use this
                setting to specify a minimum final segment length, in seconds. Choose a value that
                is greater than or equal to 1 and less than your segment length. When you specify a
                value for this setting, the encoder will combine any final segment that is shorter
                than the length that you specify with the previous segment. For example, your
                segment length is 3 seconds and your final segment is .5 seconds without a minimum
                final segment length; when you set the minimum final segment length to 1, your final
                segment is 3.5 seconds.

                - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                main. When you choose Main profile (MAIN_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                On-demand (ON_DEMAND_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
                you must also set the output group setting Segment control (SegmentControl) to
                Single file (SINGLE_FILE).

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
                generated, which is internally segmented using the Fragment Length and Segment
                Length. When set to SEGMENTED_FILES, separate segment files will be created.

                - **SegmentLength** *(integer) --* Use this setting to specify the length, in
                seconds, of each individual CMAF segment. This value applies to the whole package;
                that is, to every output in the output group. Note that segments end on the first
                keyframe after this number of seconds, so the actual segment length might be
                slightly longer. If you set Segment control (CmafSegmentControl) to single file, the
                service puts the content of each output in a single file that has metadata that
                marks these segments. If you set it to segmented files, the service creates multiple
                files for each output, each with the content of one segment.

                - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
                video in EXT-X-STREAM-INF tag of variant manifest.

                - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will
                be generated for this output.

                - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
                be generated for this output.

              - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

                - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
                manifest for each DASH ISO output group in your job. This default manifest
                references every output in the output group. To create additional DASH manifests
                that reference a subset of the outputs in the output group, specify a list of them
                here.

                  - *(dict) --* Specify the details for each additional DASH manifest that you want
                  the service to generate for this output group. Each manifest can reference a
                  different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your DASH group is film-name.mpd. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.mpd.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
                from a different URL than the manifest file.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* DRM settings.

                  - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                  compatibility of your output with video players on obsolete devices. It applies
                  only to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI
                  (UNENCRYPTED_SEI) only to correct problems with playback on older devices.
                  Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose Unencrypted
                  SEI, for that output, the service will exclude the access unit delimiter and will
                  leave the SEI NAL units unencrypted.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                Fragment length must be compatible with GOP size and Framerate. Note that fragments
                will end on the next keyframe after this number of seconds, so actual fragment
                length may be longer. When Emit Single File is checked, the fragmentation is
                internal to a single output file and it does not cause the creation of many output
                files as in other output types.

                - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

                - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
                needed to ensure smooth playout.

                - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                main. When you choose Main profile (MAIN_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                On-demand (ON_DEMAND_PROFILE), the service signals
                urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
                you must also set the output group setting Segment control (SegmentControl) to
                Single file (SINGLE_FILE).

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
                generated, which is internally segmented using the Fragment Length and Segment
                Length. When set to SEGMENTED_FILES, separate segment files will be created.

                - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds).
                Note that segments will end on the next keyframe after this number of seconds, so
                actual segment length may be longer. When Emit Single File is checked, the
                segmentation is internal to a single output file and it does not cause the creation
                of many output files as in other output types.

                - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
                the 400 range when you play back your DASH output, enable this setting and run your
                transcoding job again. When you enable this setting, the service writes precise
                segment durations in the DASH manifest. The segment duration information appears
                inside the SegmentTimeline element, inside SegmentTemplate at the Representation
                level. When you don't enable this setting, the service writes approximate segment
                durations in your DASH manifest.

              - **FileGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

              - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

                - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your
                Apple HLS manifest. This setting does not determine whether SCTE-35 markers appear
                in the outputs themselves.

                  - *(string) --*

                - **AdditionalManifests** *(list) --* By default, the service creates one top-level
                .m3u8 HLS manifest for each HLS output group in your job. This default manifest
                references every output in the output group. To create additional top-level
                manifests that reference a subset of the outputs in the output group, specify a list
                of them here.

                  - *(dict) --* Specify the details for each additional HLS manifest that you want
                  the service to generate for this output group. Each manifest can reference a
                  different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your HLS group is film-name.m3u8. If you enter
                    "-no-premium" for this setting, then the file name the service generates for
                    this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                    specify a manifestNameModifier that is different from the nameModifier of the
                    output. The service uses the output name modifier to create unique names for the
                    individual variant manifests.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each
                output in the media .m3u8 file. Can be used if base manifest is delivered from a
                different URL than the main .m3u8 file.

                - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                  - *(dict) --* Caption Language Mapping

                    - **CaptionChannel** *(integer) --* Caption channel.

                    - **CustomLanguageCode** *(string) --* Specify the language for this captions
                    channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                    three-letter code listed at
                    https://www.loc.gov/standards/iso639-2/php/code_list.php.

                    - **LanguageDescription** *(string) --* Caption language description.

                - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
                captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least
                one language in the CC1 Language Code field. One CLOSED-CAPTION line is added for
                each Language Code you specify. Make sure to specify the languages in the order in
                which they appear in the original source (if the source is embedded format) or the
                order of the caption selectors (if the source is other than embedded). Otherwise,
                languages in the manifest will not match up properly with the output captions. None:
                Include CLOSED-CAPTIONS=
                    NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS
                line from the manifest.

                - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
                which prevents client from saving media segments for later replay.

                - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
                RFC-4281) during m3u8 playlist generation.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **DirectoryStructure** *(string) --* Indicates whether segments should be placed
                in subdirectories.

                - **Encryption** *(dict) --* DRM settings.

                  - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                  value represented by a 32-character text string. If this parameter is not set then
                  the Initialization Vector will follow the segment number by default.

                  - **EncryptionMethod** *(string) --* Encrypts the segments with the given
                  encryption scheme. Leave blank to disable. Selecting 'Disabled' in the web
                  interface also disables encryption.

                  - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                  128-bit number used in conjunction with the key for encrypting blocks. If set to
                  INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                  Vector is not in the manifest.

                  - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                  EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                  HLS FairPlay content protection.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                  - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                  static key provider.

                    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                    the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                    omitted to indicate an implicit value of 'identity'.

                    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                    single positive integer version value or a slash delimited list of version
                    values (1/2/3).

                    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                    32-character hexidecimal string to specify Key Value (StaticKeyValue).

                    - **Url** *(string) --* Relates to DRM implementation. The location of the
                    license server used for protecting content.

                  - **Type** *(string) --* Specify whether your DRM encryption key is static or from
                  a key provider that follows the SPEKE standard. For more information about SPEKE,
                  see https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                should use floating point values for segment duration.

                - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                0, unless you are troubleshooting a problem with how devices play back the end of
                your video asset. If you know that player devices are hanging on the final segment
                of your video because the length of your final segment is too short, use this
                setting to specify a minimum final segment length, in seconds. Choose a value that
                is greater than or equal to 1 and less than your segment length. When you specify a
                value for this setting, the encoder will combine any final segment that is shorter
                than the length that you specify with the previous segment. For example, your
                segment length is 3 seconds and your final segment is .5 seconds without a minimum
                final segment length; when you set the minimum final segment length to 1, your final
                segment is 3.5 seconds.

                - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
                looking ahead and back within the specified range for a nearby avail and extending
                the segment size if needed.

                - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
                be generated for this HLS output group.

                - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
                in .m3u8 manifest files. The value is calculated as follows: either the program date
                and time are initialized using the input timecode source, or the time is initialized
                using the input timecode source and the date is initialized using the
                timestamp_offset.

                - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
                EXT-X-PROGRAM-DATE-TIME entry, in seconds.

                - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a
                single media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for
                playback.

                - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
                create (in seconds). Note that segments will end on the next keyframe after this
                number of seconds, so actual segment length may be longer.

                - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
                subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
                for this setting to have an effect.

                - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
                video in EXT-X-STREAM-INF tag of variant manifest.

                - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

                - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

                - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
                offset to fine tune the timestamps.

              - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
              (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

                - **AdditionalManifests** *(list) --* By default, the service creates one .ism
                Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
                in your job. This default manifest references every output in the output group. To
                create additional manifests that reference a subset of the outputs in the output
                group, specify a list of them here.

                  - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                  manifest that you want the service to generate for this output group. Each
                  manifest can reference a different subset of outputs in the group.

                    - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                    service adds to the name of this manifest to make it different from the file
                    names of the other main manifests in the output group. For example, say that the
                    default main manifest for your Microsoft Smooth group is film-name.ismv. If you
                    enter "-no-premium" for this setting, then the file name the service generates
                    for this top-level manifest is film-name-no-premium.ismv.

                    - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                    additional top-level manifest to reference.

                      - *(string) --*

                - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
                audio encoding settings across a Microsoft Smooth output group into a single audio
                stream.

                - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                output location and the output filename base. Destination accepts format
                identifiers. If you do not specify the base filename in the URI, the service will
                use the filename of the input file. If your job has multiple inputs, the service
                uses the filename of the first input file.

                - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
                vary based on the type of destination

                  - **S3Settings** *(dict) --* Settings associated with S3 destination

                    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                    Amazon S3 access control for the outputs in this output group. When you don't
                    use this setting, S3 automatically applies the default access control list
                    PRIVATE.

                      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert
                      to apply to this output.

                    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                    they are uploaded to Amazon S3.

                      - **EncryptionType** *(string) --* Specify how you want your data keys
                      managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                      data keys themselves, using a customer master key (CMK), and then stores the
                      encrypted data keys alongside your encrypted content. Use this setting to
                      specify which AWS service manages the CMK. For simplest set up, choose Amazon
                      S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
                      AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS).
                      By default, when you choose AWS KMS, KMS uses the AWS managed customer master
                      key (CMK) associated with Amazon S3 to encrypt your data keys. You can
                      optionally choose to specify a different, customer managed CMK. Do so by
                      specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
                      (kmsKeyArn).

                      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                      (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                      your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                      this setting, you must also set Server-side encryption
                      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                      set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                      the AWS managed CMK associated with Amazon S3.

                - **Encryption** *(dict) --* If you are using DRM, set DRM System
                (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                  - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                  Microsoft Smooth, use these settings when doing DRM encryption with a
                  SPEKE-compliant key provider. If your output group type is CMAF, use the
                  SpekeKeyProviderCmaf settings instead.

                    - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                    content keys that it provides to MediaConvert, set up a certificate with a
                    master key using AWS Certificate Manager. Specify the certificate's Amazon
                    Resource Name (ARN) here.

                    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                    key provider uses to identify this content.

                    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                    identifiers. DASH output groups support a max of two system ids. Other group
                    types support one system id. See
                    https://dashif.org/identifiers/content_protection/ for more details.

                      - *(string) --*

                    - **Url** *(string) --* Specify the URL to the key server that your
                    SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                    content.

                - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
                the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
                and frame rate.

                - **ManifestEncoding** *(string) --* Use Manifest encoding
                (MsSmoothManifestEncoding) to specify the encoding format for the server and client
                manifest. Valid options are utf8 and utf16.

              - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
              Microsoft Smooth Streaming, CMAF)

            - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
            settings per output.

              - *(dict) --* An output object describes the settings for a single output file or
              stream in an output group.

                - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
                encoding settings organized by audio codec. Include one instance of
                (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
                encoding settings.

                  - *(dict) --* Description of audio output

                    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                    settings. Ignore these settings unless you need to comply with a loudness
                    standard.

                      - **Algorithm** *(string) --* Choose one of the following audio normalization
                      algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated
                      average loudness for an entire piece of content, suitable for measurement of
                      short-form content under ATSC recommendation A/85. Supports up to 5.1 audio
                      channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
                      loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
                      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement
                      algorithm as 1770-2, with an updated true peak measurement. ITU-R BS.1770-4:
                      Higher channel count. Allows for more audio channels than the other
                      algorithms, including configurations such as 7.1.

                      - **AlgorithmControl** *(string) --* When enabled the output audio is
                      corrected using the chosen algorithm. If disabled, the audio will be measured
                      but not adjusted.

                      - **CorrectionGateLevel** *(integer) --* Content measuring above this level
                      will be corrected to the target level. Content measuring below this level will
                      not be corrected. Gating only applies when not using real_time_correction.

                      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio
                      track loudness to a CSV file.

                      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                      TruePeak for each output's audio track loudness.

                      - **TargetLkfs** *(float) --* When you use Audio normalization
                      (AudioNormalizationSettings), optionally use this setting to specify a target
                      loudness. If you don't specify a value here, the encoder chooses a value for
                      you, based on the algorithm that you choose for Algorithm (algorithm). If you
                      choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                      encoder will choose -23 LKFS.

                    - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                    input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector
                    by name based on its order within each input. For example if you specify "Audio
                    Selector 3", then the third audio selector will be used from each input. If an
                    input does not have an "Audio Selector 3", then the audio selector marked as
                    "default" in that input will be used. If there is no audio selector marked as
                    "default", silence will be inserted for the duration of that input.
                    Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may
                    be specified, with similar default/silence behavior. If no audio_source_name is
                    specified, then "Audio Selector 1" will be chosen automatically.

                    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                    unchecked (false). A number between 0 and 255. The following are defined in
                    ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                         Hearing Impaired, 3 =
                    Visually Impaired Commentary, 4-255 = Reserved.

                    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                    contains an ISO 639 audio_type, then that value is passed through to the output.
                    If the input contains no ISO 639 audio_type, the value in Audio Type is included
                    in the output. Otherwise the value in Audio Type is included in the output. Note
                    that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                    is set to BROADCASTER_MIXED_AD.

                    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                    (AudioDescriptions) contains the group of settings related to audio encoding.
                    The settings in this group vary depending on the value that you choose for Audio
                    codec (Codec). For each codec enum that you choose, define the corresponding
                    settings object. The following lists the codec enum, settings object pairs. *
                    AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
                    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                      - **AacSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one
                      of two mutually exclusive groups of AAC settings--VBR and CBR. To select one
                      of these modes, set the value of Bitrate control mode (rateControlMode) to
                      "VBR" or "CBR". In VBR mode, you control the audio quality with the setting
                      VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate).
                      Defaults and valid values depend on the rate control mode.

                        - **AudioDescriptionBroadcasterMix** *(string) --* Choose
                        BROADCASTER_MIXED_AD when the input contains pre-mixed main audio + audio
                        description (AD) as a stereo pair. The value for AudioType will be set to 3,
                        which signals to downstream systems that this stream contains "broadcaster
                        mixed AD". Note that the input received by the encoder must contain
                        pre-mixed audio; the encoder does not perform the mixing. When you choose
                        BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                        AudioType and FollowInputAudioType. Choose NORMAL when the input does not
                        contain pre-mixed audio + audio description (AD). In this case, the encoder
                        will use any values you provide for AudioType and FollowInputAudioType.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        The set of valid values for this setting is: 6000, 8000, 10000, 12000,
                        14000, 16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000,
                        96000, 112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000,
                        384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value
                        you set is also constrained by the values that you choose for Profile
                        (codecProfile), Bitrate control mode (codingMode), and Sample rate
                        (sampleRate). Default values depend on Bitrate control mode and Profile.

                        - **CodecProfile** *(string) --* AAC Profile.

                        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or
                        5.1 channel layout. Valid values depend on rate control mode and profile.
                        "1.0 - Audio Description (Receiver Mix)" setting receives a stereo
                        description plus control track and emits a mono AAC encode of the
                        description track, with control data emitted in the PES header as per ETSI
                        TS 101 154 Annex E.

                        - **RateControlMode** *(string) --* Rate Control Mode.

                        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                        use LATM/LOAS AAC in an output, you must choose "No container" for the
                        output container.

                        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on
                        rate control mode and profile.

                        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                        for raw or MPEG-2 Transport Stream containers.

                        - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                        rate_control_mode is VBR.

                      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AC3.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid bitrates depend on the coding mode.

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                        stream that the encoder emits. For more information about the AC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number
                        of channels.

                        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                        input audio is Dolby Digital, dialnorm will be passed through.

                        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                        adds dynamic range compression signaling to the output bitstream as defined
                        in the Dolby Digital specification.

                        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                        channel prior to encoding. Only valid with 3_2_LFE coding mode.

                        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                        metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                        this audio data. If audio was not supplied from one of these streams, then
                        the static metadata settings will be used.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                      - **AiffSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value AIFF.

                        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                        sample, to choose the encoding quality for this audio track.

                        - **Channels** *(integer) --* Specify the number of channels in this output
                        audio track. Valid values are 1 and even numbers up to 64. For example, 1,
                        2, 4, 6, and so on, up to 64.

                        - **SampleRate** *(integer) --* Sample rate in hz.

                      - **Codec** *(string) --* Type of Audio codec.

                      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid values: 384k, 448k, 640k, 768k

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                        stream that the encoder emits. For more information about the EAC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                        (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence
                        to adjust loudness based on dialogue analysis.

                        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                        level for a signal with dynamic range compression.

                        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                        the audio dynamic range when compressing the audio.

                        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left only/Right only center mix (Lo/Ro center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and
                        -6.0.

                        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert
                        uses this value for downmixing. How the service uses this value depends on
                        the value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                        values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left total/Right total center mix (Lt/Rt center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and
                        -6.0.

                        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix
                        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                        value -60 mutes the channel.

                        - **MeteringMode** *(string) --* Choose how the service meters the loudness
                        of your audio.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                        that must be speech before the encoder uses the measured speech loudness as
                        the overall program loudness.

                        - **StereoDownmix** *(string) --* Choose how the service does stereo
                        downmixing.

                        - **SurroundExMode** *(string) --* Specify whether your input audio has an
                        additional center rear surround channel matrix encoded into your left and
                        right surround channels.

                      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value EAC3.

                        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                        dB attenuation to the surround channels. Only used for 3/2 coding mode.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Valid bitrates depend on the coding mode.

                        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                        stream that the encoder emits. For more information about the EAC3 bitstream
                        mode, see ATSC A/52-2012 (Annex E).

                        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                        number of channels.

                        - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                        channels.

                        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                        input audio is Dolby Digital Plus, dialnorm will be passed through.

                        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                        level for a signal with dynamic range compression.

                        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                        the audio dynamic range when compressing the audio.

                        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                        LFE channel is enabled

                        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                        channel prior to encoding. Only valid with 3_2_LFE coding mode.

                        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                        Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                        mutes the channel. This setting applies only if you keep the default value
                        of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                        (Eac3CodingMode). If you choose a different value for Coding mode, the
                        service ignores Left only/Right only center (loRoCenterMixLevel).

                        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                        MediaConvert uses this value for downmixing. How the service uses this value
                        depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                        Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                        channel. This setting applies only if you keep the default value of 3/2 - L,
                        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                        If you choose a different value for Coding mode, the service ignores Left
                        only/Right only surround (loRoSurroundMixLevel).

                        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left total/Right total center mix (Lt/Rt
                        center). MediaConvert uses this value for downmixing. How the service uses
                        this value depends on the value that you choose for Stereo downmix
                        (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                        and -60. The value -60 mutes the channel. This setting applies only if you
                        keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                        setting Coding mode (Eac3CodingMode). If you choose a different value for
                        Coding mode, the service ignores Left total/Right total center
                        (ltRtCenterMixLevel).

                        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                        Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                        surround). MediaConvert uses this value for downmixing. How the service uses
                        this value depends on the value that you choose for Stereo downmix
                        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                        value -60 mutes the channel. This setting applies only if you keep the
                        default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                        Coding mode (Eac3CodingMode). If you choose a different value for Coding
                        mode, the service ignores Left total/Right total surround
                        (ltRtSurroundMixLevel).

                        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                        metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                        this audio data. If audio was not supplied from one of these streams, then
                        the static metadata settings will be used.

                        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                        audio will be passed through if it is present on the input. this detection
                        is dynamic over the life of the transcode. Inputs that alternate between DD+
                        and non-DD+ content will have a consistent DD+ output as the system
                        alternates between passthrough and encoding.

                        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied
                        to the surround channels. Only used for 3/2 coding mode.

                        - **SampleRate** *(integer) --* This value is always 48000. It represents
                        the sample rate in Hz.

                        - **StereoDownmix** *(string) --* Choose how the service does stereo
                        downmixing. This setting only applies if you keep the default value of 3/2 -
                        L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                        (Eac3CodingMode). If you choose a different value for Coding mode, the
                        service ignores Stereo downmix (Eac3StereoDownmix).

                        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                        extra center back surround channel is matrix encoded into the left and right
                        surround channels.

                        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                        Surround is matrix encoded into the two channels.

                      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value MP2.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                        - **Channels** *(integer) --* Set Channels to specify the number of channels
                        in this output audio track. Choosing Mono in the console will give you 1
                        output channel; choosing Stereo will give you 2. In the API, valid values
                        are 1 and 2.

                        - **SampleRate** *(integer) --* Sample rate in hz.

                      - **WavSettings** *(dict) --* Required when you set (Codec) under
                      (AudioDescriptions)>(CodecSettings) to the value WAV.

                        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                        sample, to choose the encoding quality for this audio track.

                        - **Channels** *(integer) --* Specify the number of channels in this output
                        audio track. Valid values are 1 and even numbers up to 64. For example, 1,
                        2, 4, 6, and so on, up to 64.

                        - **Format** *(string) --* The service defaults to using RIFF for WAV
                        outputs. If your output audio is likely to exceed 4 GB in file size, or if
                        you otherwise need the extended support of the RF64 format, set your output
                        WAV file format to RF64.

                        - **SampleRate** *(integer) --* Sample rate in Hz.

                    - **CustomLanguageCode** *(string) --* Specify the language for this audio
                    output track. The service puts this language code into your output audio track
                    when you set Language code control (AudioLanguageCodeControl) to Use configured
                    (USE_CONFIGURED). The service also uses your specified custom language code when
                    you set Language code control (AudioLanguageCodeControl) to Follow input
                    (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                    can also use any other code in the full RFC-5646 specification. Streaming
                    outputs are those that are in one of the following output groups: CMAF, DASH
                    ISO, Apple HLS, or Microsoft Smooth Streaming.

                    - **LanguageCode** *(string) --* Indicates the language of the audio output
                    track. The ISO 639 language specified in the 'Language Code' drop down will be
                    used when 'Follow Input Language Code' is not selected or when 'Follow Input
                    Language Code' is selected but there is no ISO 639 language code specified by
                    the input.

                    - **LanguageCodeControl** *(string) --* Specify which source for language code
                    takes precedence for this audio track. When you choose Follow input
                    (FOLLOW_INPUT), the service uses the language code from the input track if it's
                    present. If there's no languge code on the input track, the service uses the
                    code that you specify in the setting Language code (languageCode or
                    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
                    service uses the language code that you specify.

                    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                      group of fields that hold the remixing value for each channel. Units are in
                      dB. Acceptable values are within the range from -60 (mute) through 6. A
                      setting of 0 passes the input channel unchanged to the output channel (no
                      attenuation or amplification).

                        - **OutputChannels** *(list) --* List of output channels

                          - *(dict) --* OutputChannel mapping settings.

                            - **InputChannels** *(list) --* List of input channels

                              - *(integer) --*

                      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                      input that you want to use in your output. With remixing, you might combine or
                      split the data in these channels, so the number of channels in your final
                      output might be different.

                      - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                      after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                    - **StreamName** *(string) --* Specify a label for this output audio stream. For
                    example, "English", "Director commentary", or "track_2". For streaming outputs,
                    MediaConvert passes this information into destination manifests for display on
                    the end-viewer's player device. For outputs in other output groups, the service
                    ignores this setting.

                - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
                captions settings. For each output that has captions, include one instance of
                (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
                settings.

                  - *(dict) --* Description of Caption output

                    - **CaptionSelectorName** *(string) --* Specifies which "Caption
                    Selector":#inputs-caption_selector to use from each input when generating
                    captions. The name should be of the format "Caption Selector ", which denotes
                    that the Nth Caption Selector will be used from each input.

                    - **CustomLanguageCode** *(string) --* Specify the language for this captions
                    output track. For most captions output formats, the encoder puts this language
                    information in the output captions metadata. If your output captions format is
                    DVB-Sub or Burn in, the encoder uses this language information when
                    automatically selecting the font script for rendering the captions text. For all
                    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                    can also use any other code in the full RFC-5646 specification. Streaming
                    outputs are those that are in one of the following output groups: CMAF, DASH
                    ISO, Apple HLS, or Microsoft Smooth Streaming.

                    - **DestinationSettings** *(dict) --* Specific settings required by destination
                    type. Note that burnin_destination_settings are not available if the source of
                    the caption data is Embedded or Teletext.

                      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                        - **Alignment** *(string) --* If no explicit x_position or y_position is
                        provided, setting alignment to centered will place the captions at the
                        bottom center of the output. Similarly, setting a left alignment will align
                        captions to the bottom left of the output. If x and y positions are given in
                        conjunction with the alignment parameter, the font will be justified (either
                        left or centered) relative to those coordinates. This option is not valid
                        for source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                        behind the captions. All burn-in and DVB-Sub font settings must match.

                        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                        background rectangle. 255 is opaque; 0 is transparent. Leaving this
                        parameter blank is equivalent to setting it to 0 (transparent). All burn-in
                        and DVB-Sub font settings must match.

                        - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                        This option is not valid for source captions that are STL, 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                        captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                        settings must match.

                        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                        default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                        - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                        script code, if the LanguageCode is not sufficient for determining the
                        script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                        "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                        font for rendering burn-in captions.

                        - **FontSize** *(integer) --* A positive integer indicates the exact font
                        size in points. Set to 0 for automatic font size selection. All burn-in and
                        DVB-Sub font settings must match.

                        - **OutlineColor** *(string) --* Specifies font outline color. This option
                        is not valid for source captions that are either 608/embedded or teletext.
                        These source settings are already pre-defined by the caption stream. All
                        burn-in and DVB-Sub font settings must match.

                        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                        option is not valid for source captions that are either 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                        the captions. All burn-in and DVB-Sub font settings must match.

                        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255
                        is opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                        setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                        match.

                        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                        must match.

                        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels above the text. All burn-in and DVB-Sub font settings
                        must match.

                        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                        in Teletext or STL formats. Specify whether the spacing between letters in
                        your captions is set by the captions grid or varies depending on letter
                        width. Choose fixed grid to conform to the spacing specified in the captions
                        file more accurately. Choose proportional to make the text easier to read if
                        the captions are closed caption.

                        - **XPosition** *(integer) --* Specifies the horizontal position of the
                        caption relative to the left side of the output in pixels. A value of 10
                        would result in the captions starting 10 pixels from the left of the output.
                        If no explicit x_position is provided, the horizontal caption position will
                        be determined by the alignment parameter. This option is not valid for
                        source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **YPosition** *(integer) --* Specifies the vertical position of the
                        caption relative to the top of the output in pixels. A value of 10 would
                        result in the captions starting 10 pixels from the top of the output. If no
                        explicit y_position is provided, the caption will be positioned towards the
                        bottom of the output. This option is not valid for source captions that are
                        STL, 608/embedded or teletext. These source settings are already pre-defined
                        by the caption stream. All burn-in and DVB-Sub font settings must match.

                      - **DestinationType** *(string) --* Specify the format for this set of
                      captions on this output. The default format is embedded without SCTE-20. Other
                      options are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext,
                      TTML, and web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                      (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
                      spec. To create a non-compliant output where the embedded captions come first,
                      choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                        - **Alignment** *(string) --* If no explicit x_position or y_position is
                        provided, setting alignment to centered will place the captions at the
                        bottom center of the output. Similarly, setting a left alignment will align
                        captions to the bottom left of the output. If x and y positions are given in
                        conjunction with the alignment parameter, the font will be justified (either
                        left or centered) relative to those coordinates. This option is not valid
                        for source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                        behind the captions. All burn-in and DVB-Sub font settings must match.

                        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                        background rectangle. 255 is opaque; 0 is transparent. Leaving this
                        parameter blank is equivalent to setting it to 0 (transparent). All burn-in
                        and DVB-Sub font settings must match.

                        - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                        This option is not valid for source captions that are STL, 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                        captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                        settings must match.

                        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                        default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                        - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                        script code, if the LanguageCode is not sufficient for determining the
                        script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                        "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                        font for rendering DVB-Sub captions.

                        - **FontSize** *(integer) --* A positive integer indicates the exact font
                        size in points. Set to 0 for automatic font size selection. All burn-in and
                        DVB-Sub font settings must match.

                        - **OutlineColor** *(string) --* Specifies font outline color. This option
                        is not valid for source captions that are either 608/embedded or teletext.
                        These source settings are already pre-defined by the caption stream. All
                        burn-in and DVB-Sub font settings must match.

                        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                        option is not valid for source captions that are either 608/embedded or
                        teletext. These source settings are already pre-defined by the caption
                        stream. All burn-in and DVB-Sub font settings must match.

                        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                        the captions. All burn-in and DVB-Sub font settings must match.

                        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255
                        is opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                        setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                        match.

                        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                        must match.

                        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                        shadow relative to the captions in pixels. A value of -2 would result in a
                        shadow offset 2 pixels above the text. All burn-in and DVB-Sub font settings
                        must match.

                        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                        standard or for hearing impaired. Choose hearing impaired if your subtitles
                        include audio descriptions and dialogue. Choose standard if your subtitles
                        include only dialogue.

                        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                        in Teletext or STL formats. Specify whether the spacing between letters in
                        your captions is set by the captions grid or varies depending on letter
                        width. Choose fixed grid to conform to the spacing specified in the captions
                        file more accurately. Choose proportional to make the text easier to read if
                        the captions are closed caption.

                        - **XPosition** *(integer) --* Specifies the horizontal position of the
                        caption relative to the left side of the output in pixels. A value of 10
                        would result in the captions starting 10 pixels from the left of the output.
                        If no explicit x_position is provided, the horizontal caption position will
                        be determined by the alignment parameter. This option is not valid for
                        source captions that are STL, 608/embedded or teletext. These source
                        settings are already pre-defined by the caption stream. All burn-in and
                        DVB-Sub font settings must match.

                        - **YPosition** *(integer) --* Specifies the vertical position of the
                        caption relative to the top of the output in pixels. A value of 10 would
                        result in the captions starting 10 pixels from the top of the output. If no
                        explicit y_position is provided, the caption will be positioned towards the
                        bottom of the output. This option is not valid for source captions that are
                        STL, 608/embedded or teletext. These source settings are already pre-defined
                        by the caption stream. All burn-in and DVB-Sub font settings must match.

                      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                      embedded/ancillary caption outputs, including 608/708 Channel destination
                      number.

                        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                        your input captions are SCC format and your output captions are embedded in
                        the video stream. Specify a CC number for each captions channel in this
                        output. If you have two channels, choose CC numbers that aren't in the same
                        field. For example, choose 1 and 3. For more information, see
                        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                        your input captions are SCC format and you want both 608 and 708 captions
                        embedded in your output stream. Optionally, specify the 708 service number
                        for each output captions channel. Choose a different number for each
                        channel. To use this setting, also set Force 608 to 708 upconvert
                        (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
                        settings. If you choose to upconvert but don't specify a 708 service number,
                        MediaConvert uses the number that you specify for CC channel number
                        (destination608ChannelNumber) for the 708 service number. For more
                        information, see
                        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                      outputs.

                        - **StylePassthrough** *(string) --* Keep this setting enabled to have
                        MediaConvert use the font style and position information from the captions
                        source in the output. This option is available only when your input captions
                        are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                        output captions.

                      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to
                        make sure that the captions and the video are synchronized in the output.
                        Specify a frame rate that matches the frame rate of the associated video. If
                        the video frame rate is 29.97, choose 29.97 dropframe
                        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
                        drop_frame_timecode=
                            true; otherwise, choose 29.97 non-dropframe
                        (FRAMERATE_29_97_NON_DROPFRAME).

                      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                      output

                        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number
                        for the destination captions for this output. This value must be a
                        three-digit hexadecimal string; strings ending in -FF are invalid. If you
                        are passing through the entire set of Teletext data, do not use this field.

                        - **PageTypes** *(list) --* Specify the page types for this Teletext page.
                        If you don't specify a value here, the service sets the page type to the
                        default value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire
                        set of Teletext data, don't use this field. When you pass through a set of
                        Teletext pages, your output has the same page types as your input.

                          - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                          Table 94

                      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                      outputs, including Pass style information (TtmlStylePassthrough).

                        - **StylePassthrough** *(string) --* Pass through style and position
                        information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                        CFF-TT output or TTML output.

                    - **LanguageCode** *(string) --* Specify the language of this captions output
                    track. For most captions output formats, the encoder puts this language
                    information in the output captions metadata. If your output captions format is
                    DVB-Sub or Burn in, the encoder uses this language information to choose the
                    font language for rendering the captions text.

                    - **LanguageDescription** *(string) --* Specify a label for this set of output
                    captions. For example, "English", "Director commentary", or "track_2". For
                    streaming outputs, MediaConvert passes this information into destination
                    manifests for display on the end-viewer's player device. For outputs in other
                    output groups, the service ignores this setting.

                - **ContainerSettings** *(dict) --* Container specific settings.

                  - **Container** *(string) --* Container for this output. Some containers require a
                  container settings object. If not specified, the default object will be created.

                  - **F4vSettings** *(dict) --* Settings for F4v container

                    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom
                    is relocated to the beginning of the archive as required for progressive
                    downloading. Otherwise it is placed normally at the end.

                  - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to
                  outputs in a File output group when the output's container (ContainerType) is
                  MPEG-2 Transport Stream (M2TS). In these assets, data is organized by the program
                  map table (PMT). Each transport stream program contains subsets of data, including
                  audio, video, and metadata. Each of these subsets of data has a numerical label
                  called a packet identifier (PID). Each transport stream program corresponds to one
                  MediaConvert output. The PMT lists the types of data in a program along with their
                  PID. Downstream systems and players use the program map table to look up the PID
                  for each type of data it accesses and then uses the PIDs to locate specific data
                  within the asset.

                    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                    models for Dolby Digital audio.

                    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                    each PES packet.

                    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                    elementary audio streams you include in this output. Specify multiple PIDs as a
                    JSON array. Default is the range 482-492.

                      - *(integer) --*

                    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream
                    in bits per second. Setting to 0 lets the muxer automatically determine the
                    appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                    - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                    interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                    this can lead to lower latency, but low-memory devices may not be able to play
                    back the stream without interruptions.

                    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                    the specified table repetition interval.

                      - **NetworkId** *(integer) --* The numeric value placed in the Network
                      Information Table (NIT).

                      - **NetworkName** *(string) --* The network name text placed in the
                      network_name_descriptor inside the Network Information Table. Maximum length
                      is 256 characters.

                      - **NitInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                    the specified table repetition interval.

                      - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                      output stream. "Follow input SDT" copies SDT information from input stream to
                      output stream. "Follow input SDT if present" copies SDT information from input
                      stream to output stream if SDT information is present in the input, otherwise
                      it will fall back on the user-defined values. Enter "SDT Manually" means user
                      will enter the SDT information. "No SDT" means output stream will not contain
                      SDT information.

                      - **SdtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **ServiceName** *(string) --* The service name placed in the
                      service_descriptor in the Service Description Table. Maximum length is 256
                      characters.

                      - **ServiceProviderName** *(string) --* The service provider name placed in
                      the service_descriptor in the Service Description Table. Maximum length is 256
                      characters.

                    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                    subtitle data included in this output. Specify multiple PIDs as a JSON array.
                    Default is the range 460-479.

                      - *(integer) --*

                    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                    specified table repetition interval.

                      - **TdtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                    teletext data you include in this output. Default is 499.

                    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS,
                    audio EBP markers will be added to partitions 3 and 4. The interval between
                    these additional markers will be fixed, and will be slightly shorter than the
                    video EBP marker interval. When set to VIDEO_INTERVAL, these additional markers
                    will not be inserted. Only applicable when EBP segmentation markers are is
                    selected (segmentationMarkers is EBP or EBP_LEGACY).

                    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on.
                    They can either be placed only on the video PID, or on both the video PID and
                    all audio PIDs. Only applicable when EBP segmentation markers are is selected
                    (segmentationMarkers is EBP or EBP_LEGACY).

                    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                    the PES header.

                    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                    you know that your audio EBP markers are incorrectly appearing before your video
                    EBP markers. To correct this problem, set this value to Force (FORCE).

                    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                    used with EBP markers.

                    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                    between Program Clock References (PCRs) inserted into the transport stream.

                    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                    Points do not come within the specified time interval of each other by looking
                    ahead at input video. If another EBP is going to come in within the specified
                    time interval, the current EBP is not emitted, and the segment is "stretched" to
                    the next marker. The lookahead value does not add latency to the system. The
                    Live Event must be configured elsewhere to create sufficient latency to make the
                    lookahead accurate.

                    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                    tracking will be detected in the input audio and an equivalent ID3 tag will be
                    inserted in the output.

                    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                    packets to insert into the transport stream. This can be used if a downstream
                    encryption system requires periodic null packets.

                    - **PatInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                    Reference value is inserted for every Packetized Elementary Stream (PES) header.
                    This is effective only when the PCR PID is the same as the video or audio
                    elementary stream.

                    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                    clock reference (PCR) in this output. If you do not specify a value, the service
                    will use the value for Video PID (VideoPid).

                    - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                    instances of the program map table (PMT) in the output transport stream.

                    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                    map table (PMT) itself. Default is 480.

                    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of
                    the private metadata stream. Default is 503.

                    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                    the program number used in the program map table (PMT) for this output. Default
                    is 1. Program numbers and program map tables are parts of MPEG-2 transport
                    stream containers, used for organizing data.

                    - **RateMode** *(string) --* When set to CBR, inserts null packets into
                    transport stream to fill specified bitrate. When set to VBR, the bitrate setting
                    acts as the maximum bitrate, but the output will not be padded up to that
                    bitrate.

                    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                    markers in your HLS and transport stream outputs at the insertion points that
                    you specify in an ESAM XML document. Provide the document in the setting SCC XML
                    (sccXml).

                      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35
                      stream in the transport stream generated by ESAM.

                    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the
                    SCTE-35 stream in the transport stream.

                    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                    Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input
                    to also appear in this output. Choose None (NONE) if you don't want SCTE-35
                    markers in this output. For SCTE-35 markers from an ESAM XML document-- Choose
                    None (NONE). Also provide the ESAM XML as a string in the setting Signal
                    processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
                    property scte35Esam).

                    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                    segmentation_time period. rai_segstart sets the Random Access Indicator bit in
                    the adaptation field. rai_adapt sets the RAI bit and adds the current timecode
                    in the private data bytes. psi_segstart inserts PAT and PMT tables at the start
                    of segments. ebp adds Encoder Boundary Point information to the adaptation field
                    as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
                    Boundary Point information to the adaptation field using a legacy proprietary
                    format.

                    - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                    how segmentation markers are inserted into the transport stream. With avails, it
                    is possible that segments may be truncated, which can influence where future
                    segmentation markers are inserted. When a segmentation style of "reset_cadence"
                    is selected and a segment is truncated due to an avail, we will reset the
                    segmentation cadence. This means the subsequent segment will have a duration of
                    of $segmentation_time seconds. When a segmentation style of "maintain_cadence"
                    is selected and a segment is truncated due to an avail, we will not reset the
                    segmentation cadence. This means the subsequent segment will likely be truncated
                    as well. However, all segments after that will have a duration of
                    $segmentation_time seconds. Note that EBP lookahead is a slight exception to
                    this rule.

                    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                    segment. Required unless markers is set to _none_.

                    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                    timed metadata in this output. Default is 502.

                    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                    itself in the program map table for this output. Transport stream IDs and
                    program map tables are parts of MPEG-2 transport stream containers, used for
                    organizing data.

                    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                    elementary video stream in the transport stream.

                  - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                    each PES packet.

                    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                    stream(s) in the transport stream. Multiple values are accepted, and can be
                    entered in ranges and/or by comma separation.

                      - *(integer) --*

                    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                    tracking will be detected in the input audio and an equivalent ID3 tag will be
                    inserted in the output.

                    - **PatInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                    Reference value is inserted for every Packetized Elementary Stream (PES) header.
                    This parameter is effective only when the PCR PID is the same as the video or
                    audio elementary stream.

                    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock
                    Reference (PCR) in the transport stream. When no value is given, the encoder
                    will assign the same value as the Video PID.

                    - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                    (PMT) in the transport stream.

                    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                    metadata stream in the transport stream.

                    - **ProgramNumber** *(integer) --* The value of the program number field in the
                    Program Map Table.

                    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                    the transport stream.

                    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                    Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input
                    to also appear in this output. Choose None (NONE) if you don't want SCTE-35
                    markers in this output. For SCTE-35 markers from an ESAM XML document-- Choose
                    None (NONE) if you don't want manifest conditioning. Choose Passthrough
                    (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
                    conditioning. In both cases, also provide the ESAM XML as a string in the
                    setting Signal processing notification XML (sccXml).

                    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting
                    to specify whether the service inserts the ID3 timed metadata from the input in
                    this output.

                    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                    metadata stream in the transport stream.

                    - **TransportStreamId** *(integer) --* The value of the transport stream ID
                    field in the Program Map Table.

                    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                    stream in the transport stream.

                  - **MovSettings** *(dict) --* Settings for MOV Container.

                    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate
                    for the video output settings.

                    - **CslgAtom** *(string) --* When enabled, file composition times will start at
                    zero, composition times in the 'ctts' (composition time to sample) box for
                    B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                    will be included per 14496-1 amendment 1. This improves compatibility with Apple
                    players and tools.

                    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                    streams into the QuickTime file using XDCAM fourcc codes. This increases
                    compatibility with Apple editors and players, but may decrease compatibility
                    with other players. Only applicable when the video codec is MPEG2.

                    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                    padding

                    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                    this setting.

                  - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create
                  audio-only AAC outputs with this container.

                    - **CslgAtom** *(string) --* When enabled, file composition times will start at
                    zero, composition times in the 'ctts' (composition time to sample) box for
                    B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                    will be included per 14496-1 amendment 1. This improves compatibility with Apple
                    players and tools.

                    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                    moov box.

                    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom
                    is relocated to the beginning of the archive as required for progressive
                    downloading. Otherwise it is placed normally at the end.

                    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the
                    output file. Usually not necessary to specify.

                  - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                    - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                    groups that include sidecar TTML or IMSC captions. You specify sidecar captions
                    in a separate output from your audio and video. Choose Raw (RAW) for captions in
                    a single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4)
                    for captions in XML format contained within fragmented MP4 files. This set of
                    fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                    markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                    insertion points that you specify in an ESAM XML document. Provide the document
                    in the setting SCC XML (sccXml).

                    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                    markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                    SCTE-35 markers that appear in your input to also appear in this output. Choose
                    None (NONE) if you don't want those SCTE-35 markers in this output.

                - **Extension** *(string) --* Use Extension (Extension) to specify the file
                extension for outputs in File output groups. If you do not specify a value, the
                service will use default extensions by container type as follows * MPEG-2 transport
                stream, m2ts * Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No
                Container, the service will use codec extensions (e.g. AAC, H265, H265, AC3)

                - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the
                service add a string to the end of each output filename. You specify the base
                filename as part of your destination URI. When you create multiple outputs in the
                same output group, Name modifier (NameModifier) is required. Name modifier also
                accepts format identifiers. For DASH ISO outputs, if you use the format identifiers
                $Number$ or $Time$ in one output, you must use them in the same way in all outputs
                of the output group.

                - **OutputSettings** *(dict) --* Specific settings for this type of output.

                  - **HlsSettings** *(dict) --* Settings for HLS output groups

                    - **AudioGroupId** *(string) --* Specifies the group to which the audio
                    Rendition belongs.

                    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                    outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                    container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                    file in a raw container. Regardless of the value that you specify here, if this
                    output has video, the service will place the output into an MPEG2-TS container.

                    - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                    with the video output stream. Input all the audio GROUP-IDs that are associated
                    to the video, separate by ','.

                    - **AudioTrackType** *(string) --* Four types of audio-only tracks are
                    supported: Audio-Only Variant Stream The client can play back this audio-only
                    stream instead of video in low-bandwidth scenarios. Represented as an
                    EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select, Default
                    Alternate rendition that the client should try to play back by default.
                    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                        YES,
                    AUTOSELECT=
                        YES Alternate Audio, Auto Select, Not Default Alternate rendition
                    that the client may try to play back by default. Represented as an EXT-X-MEDIA
                    in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                        YES Alternate Audio, not Auto
                    Select Alternate rendition that the client will not try to play back by default.
                    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                        NO, AUTOSELECT=NO

                    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                    Manifest in addition to the HLS manifest

                    - **SegmentModifier** *(string) --* String concatenated to end of segment
                    filenames. Accepts "Format Identifiers":#format_identifier_parameters.

                - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
                transcoding settings. Provide the system or custom preset name. You can specify
                either Preset (Preset) or Container settings (ContainerSettings), but not both.

                - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
                encoding settings. The specific video settings depend on the video codec that you
                choose when you specify a value for Video codec (codec). Include one instance of
                (VideoDescription) per output.

                  - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                  MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                  service includes AFD values in the output video data and what those values are. *
                  Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                  input AFD values and instead encode the value specified in the job. * Choose Auto
                  to calculate output AFD values based on the input AFD scaler data.

                  - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to
                  all outputs. The service no longer accepts the value DISABLED for AntiAlias. If
                  you specify that in your job, the service will ignore the setting.

                  - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                  (VideoDescription), contains the group of settings related to video encoding. The
                  settings in this group vary depending on the value that you choose for Video codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * H_264,
                  H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings
                  * FRAME_CAPTURE, FrameCaptureSettings

                    - **Codec** *(string) --* Specifies the video codec. This must be equal to one
                    of the enum values defined by the object VideoCodec.

                    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                      - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                      frame of the output stream, then one frame every
                      framerateDenominator/framerateNumerator seconds. For example, settings of
                      framerateNumerator = 1 and framerateDenominator =
                           3 (a rate of 1/3 frame per
                      second) will capture the first frame, then 1 frame every 3s. Files will be
                      named as filename.n.jpg where n is the 0-based sequence number of each
                      Capture.

                      - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                      frame of the output stream, then one frame every
                      framerateDenominator/framerateNumerator seconds. For example, settings of
                      framerateNumerator = 1 and framerateDenominator =
                           3 (a rate of 1/3 frame per
                      second) will capture the first frame, then 1 frame every 3s. Files will be
                      named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number
                      zero padded to 7 decimal places.

                      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg
                      output files).

                      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                      quality.

                    - **H264Settings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value H_264.

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                      your output video settings. If you aren't sure what level to specify, choose
                      Auto (AUTO).

                      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                      are only available with the AVC-I License.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be
                      in Main or High profile) or CAVLC.

                      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                      for interlaced outputs.

                      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame to reduce flicker or 'pop' on I-frames.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job specification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* When you use the API for transcode
                      jobs that use frame rate conversion, specify the frame rate as a fraction. For
                      example, 24000 / 1001 =
                           23.976 fps. Use FramerateDenominator to specify the
                      denominator of this fraction. In this example, use 1001 for the value of
                      FramerateDenominator. When you use the console for transcode jobs that use
                      frame rate conversion, provide the value as a decimal number for Framerate. In
                      this example, specify 23.976.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                      structures that have B frames > 1.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type, as follows. - If the source is interlaced, the output will be
                      interlaced with the same polarity as the source (it will follow the source).
                      The output could therefore be a mix of "top field first" and "bottom field
                      first". - If the source is progressive, the output will be interlaced with
                      "top field first" or "bottom field first" polarity, depending on which of the
                      Follow options you chose.

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000. Required when Rate control mode is
                      QVBR.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                      The encoder may use more than requested if using B-frames and/or interlaced
                      encoding.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                      high-quality singlepass, or high-quality multipass video encoding.

                      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                      encoding with the H.264 codec. Required when you set Rate control mode to
                      QVBR. Not valid when you set Rate control mode to a value other than QVBR, or
                      when you don't define Rate control mode.

                        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                        control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                        average bitrate values suited to the complexity of your input video, the
                        service limits the average bitrate of the video part of this output to the
                        value that you choose. That is, the total size of the video element is less
                        than or equal to the value you set multiplied by the number of seconds of
                        encoded output.

                        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                        control mode. That is, when you specify qvbrSettings within h264Settings.
                        Specify the target quality level for this output, from 1 to 10. Use higher
                        numbers for greater quality. Level 10 results in nearly lossless
                        compression. The quality level for most broadcast-quality transcodes is
                        between 6 and 9.

                      - **RateControlMode** *(string) --* Use this setting to specify whether this
                      output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                      variable bitrate (QVBR).

                      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture,
                      even if repeated.

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default. If this output uses QVBR, choose Transition
                      detection (TRANSITION_DETECTION) for further video quality improvement. For
                      more information about QVBR, see
                      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                      - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                      equal to the number of macroblock rows for progressive pictures, and less than
                      or equal to half the number of macroblock rows for interlaced pictures.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                      values reduce high-frequency content in the encoded image.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                      - **Telecine** *(string) --* This field applies only if the Streams > Advanced
                      > Framerate (framerate) field is set to 29.970. This field works with the
                      Streams > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and
                      the Streams > Advanced > Interlaced Mode field (interlace_mode) to identify
                      the scan type for the output: Progressive, Interlaced, Hard Telecine or Soft
                      Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
                      23.976; the player converts this output to 29.97i.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as
                      4 bytes of an unregistered SEI message.

                    - **H265Settings** *(dict) --* Settings for H265 codec

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                      Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                      Transfer Function (EOTF).

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* H.265 Level.

                      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                      (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                      "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                      available with the HEVC 4:2:2 License.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame to reduce flicker or 'pop' on I-frames.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                      structures that have B frames > 1.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                      Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                      the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom
                      Field First (BOTTOM_FIELD) to create an output that's interlaced with the same
                      field polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or
                      Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output
                      with the same field polarity as the source. If the source is interlaced, the
                      output will be interlaced with the same polarity as the source (it will follow
                      the source). The output could therefore be a mix of "top field first" and
                      "bottom field first". If the source is progressive, your output will be
                      interlaced with "top field first" or "bottom field first" polarity, depending
                      on which of the Follow options you chose. If you don't choose a value, the
                      service will default to Progressive (PROGRESSIVE).

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000. Required when Rate control mode is
                      QVBR.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                      The encoder may use more than requested if using B-frames and/or interlaced
                      encoding.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                      high-quality singlepass, or high-quality multipass video encoding.

                      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                      encoding with the H.265 codec. Required when you set Rate control mode to
                      QVBR. Not valid when you set Rate control mode to a value other than QVBR, or
                      when you don't define Rate control mode.

                        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                        control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                        average bitrate values suited to the complexity of your input video, the
                        service limits the average bitrate of the video part of this output to the
                        value that you choose. That is, the total size of the video element is less
                        than or equal to the value you set multiplied by the number of seconds of
                        encoded output.

                        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                        control mode. That is, when you specify qvbrSettings within h265Settings.
                        Specify the target quality level for this output, from 1 to 10. Use higher
                        numbers for greater quality. Level 10 results in nearly lossless
                        compression. The quality level for most broadcast-quality transcodes is
                        between 6 and 9.

                      - **RateControlMode** *(string) --* Use this setting to specify whether this
                      output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                      variable bitrate (QVBR).

                      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                      Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                      based on content

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default. If this output uses QVBR, choose Transition
                      detection (TRANSITION_DETECTION) for further video quality improvement. For
                      more information about QVBR, see
                      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                      - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                      equal to the number of macroblock rows for progressive pictures, and less than
                      or equal to half the number of macroblock rows for interlaced pictures.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Telecine** *(string) --* This field applies only if the Streams > Advanced
                      > Framerate (framerate) field is set to 29.970. This field works with the
                      Streams > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and
                      the Streams > Advanced > Interlaced Mode field (interlace_mode) to identify
                      the scan type for the output: Progressive, Interlaced, Hard Telecine or Soft
                      Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
                      23.976; the player converts this output to 29.97i.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                      encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                      and P-frames form one layer, reference B-frames can form a second layer and
                      non-reference b-frames can form a third layer. Decoders can optionally decode
                      only the lower temporal layers to generate a lower frame rate output. For
                      example, given a bitstream with temporal IDs and with b-frames = 1 (i.e.
                      IbPbPb display order), a decoder could decode all the frames for full frame
                      rate output or only the I and P frames (lowest temporal layer) for a half
                      frame rate output.

                      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                      vertical subdivision of the encoded pictures.

                      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as
                      4 bytes of an unregistered SEI message.

                      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                      units doesn't matter in your workflow, ignore this setting. Use this setting
                      only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                      container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                      your output compliant with the following specification: ISO IECJTC1 SC29
                      N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service
                      stores parameter set NAL units in the sample headers but not in the samples
                      directly. For MP4 outputs, when you choose HVC1, your output video might not
                      work properly with some downstream systems and video players. The service
                      defaults to marking your output as HEV1. For these outputs, the service writes
                      parameter set NAL units directly into the samples.

                    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value MPEG2.

                      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                      intra-frame quantizers to vary to improve visual quality.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                      rounded down to the nearest multiple of 1000.

                      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                      level for the video output.

                      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                      MPEG-2 profile for the video output.

                      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                      quality for high-motion content. This will cause the service to use fewer
                      B-frames (which infer information based on other frames) for high-motion
                      portions of the video and more B-frames for low-motion portions. The maximum
                      number of B-frames is limited by the value you provide for the setting B
                      frames between reference frames (numberBFramesBetweenReferenceFrames).

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                      fraction, e.g. 24000 / 1001 = 23.976 fps.

                      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                      applications, it is recommended that this be set to 1 so a decoder joining
                      mid-stream will receive an IDR frame as quickly as possible. Setting this
                      value to 0 will break output segmenting.

                      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                      seconds. Must be greater than zero.

                      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is
                      specified in frames or seconds. If seconds the system will convert the GOP
                      Size into a frame count at run time.

                      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                      that should initially be filled (HRD buffer model).

                      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                      For example, enter five megabits as 5000000.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type. - If the source is interlaced, the output will be interlaced with
                      the same polarity as the source (it will follow the source). The output could
                      therefore be a mix of "top field first" and "bottom field first". - If the
                      source is progressive, the output will be interlaced with "top field first" or
                      "bottom field first" polarity, depending on which of the Follow options you
                      chose.

                      - **IntraDcPrecision** *(string) --* Use Intra DC precision
                      (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                      coefficients. If you choose the value auto, the service will automatically
                      select the precision based on the per-frame compression ratio.

                      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                      enter five megabits per second as 5000000.

                      - **MinIInterval** *(integer) --* Enforces separation between repeated
                      (cadence) I-frames and I-frames inserted by Scene Change Detection. If a scene
                      change I-frame is within I-interval frames of a cadence I-frame, the GOP is
                      shrunk and/or stretched to the scene change I-frame. GOP stretch requires
                      enabling lookahead as well as setting I-interval. The normal cadence resumes
                      for the next GOP. This setting is only used when Scene Change Detect is
                      enabled. Note: Maximum GOP stretch =
                           GOP size + Min-I-interval - 1

                      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                      between reference frames.

                      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                      want the service to use the pixel aspect ratio from the input. Using the
                      console, do this by choosing Follow source for Pixel aspect ratio.

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **QualityTuningLevel** *(string) --* Use Quality tuning level
                      (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                      video encoding.

                      - **RateControlMode** *(string) --* Use Rate control mode
                      (Mpeg2RateControlMode) to specifiy whether the bitrate is variable (vbr) or
                      constant (cbr).

                      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                      at scene changes that the service automatically detects. This improves video
                      quality and is enabled by default.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                      values reduce high-frequency content in the encoded image.

                      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on spatial variation of content complexity.

                      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                      356M-2001).

                      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                      Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard)
                      to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                      produce 23.976 output and leave converstion to the player.

                      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                      each frame based on temporal variation of content complexity.

                    - **ProresSettings** *(dict) --* Required when you set (Codec) under
                    (VideoDescription)>(CodecSettings) to the value PRORES.

                      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                      the type of Apple ProRes codec to use for this output.

                      - **FramerateControl** *(string) --* If you are using the console, use the
                      Framerate setting to specify the frame rate for this output. If you want to
                      keep the same frame rate as the input video, choose Follow source. If you want
                      to do frame rate conversion, choose a frame rate from the dropdown list or
                      choose Custom. The framerates shown in the dropdown list are decimal
                      approximations of fractions. If you choose Custom, specify your frame rate as
                      a fraction. If you are creating your transcoding job sepecification as a JSON
                      file without the console, use FramerateControl to specify which value the
                      service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE
                      if you want the service to use the frame rate from the input. Choose SPECIFIED
                      if you want the service to use the frame rate you specify in the settings
                      FramerateNumerator and FramerateDenominator.

                      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                      produces smoother motion during frame rate conversion.

                      - **FramerateDenominator** *(integer) --* Frame rate denominator.

                      - **FramerateNumerator** *(integer) --* When you use the API for transcode
                      jobs that use frame rate conversion, specify the frame rate as a fraction. For
                      example, 24000 / 1001 =
                           23.976 fps. Use FramerateNumerator to specify the
                      numerator of this fraction. In this example, use 24000 for the value of
                      FramerateNumerator.

                      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                      the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                      Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                      having the same field polarity (top or bottom first). * Follow, Default Top
                      (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
                      same field polarity as the source. Therefore, behavior depends on the input
                      scan type. - If the source is interlaced, the output will be interlaced with
                      the same polarity as the source (it will follow the source). The output could
                      therefore be a mix of "top field first" and "bottom field first". - If the
                      source is progressive, the output will be interlaced with "top field first" or
                      "bottom field first" polarity, depending on which of the Follow options you
                      chose.

                      - **ParControl** *(string) --* Use (ProresParControl) to specify how the
                      service determines the pixel aspect ratio. Set to Follow source
                      (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio from the input. To
                      specify a different pixel aspect ratio: Using the console, choose it from the
                      dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide
                      for (ParNumerator) and (ParDenominator).

                      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                      24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                      Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard)
                      to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                      produce 23.976 output and leave converstion to the player.

                  - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to
                  include color metadata in this output. Choose Ignore (IGNORE) to exclude color
                  metadata from this output. If you don't specify a value, the service sets this to
                  Insert by default.

                  - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area
                  that the service will include in the output video frame.

                    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                    numbers.

                    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                    numbers.

                    - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                    left edge of the video frame. Specify only even numbers.

                    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                    top edge of the video frame. Specify only even numbers.

                  - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                  feature is enabled, the service will use drop-frame timecode on outputs. If it is
                  not possible to use drop-frame timecode, the system will fall back to
                  non-drop-frame. This setting is enabled by default when Timecode insertion
                  (TimecodeInsertion) is enabled.

                  - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling)
                  to Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                  service will write on all frames of this video output.

                  - **Height** *(integer) --* Use the Height (Height) setting to define the video
                  resolution height for this output. Specify in pixels. If you don't provide a value
                  here, the service will use the input height.

                  - **Position** *(dict) --* Use Selection placement (position) to define the video
                  area in your output frame. The area outside of the rectangle that you specify here
                  is black.

                    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                    numbers.

                    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                    numbers.

                    - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                    left edge of the video frame. Specify only even numbers.

                    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                    top edge of the video frame. Specify only even numbers.

                  - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                  the service changes the video itself in response to AFD values in the input. *
                  Choose Respond to clip the input video frame according to the AFD value, input
                  display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                  include the input AFD values. Do not choose this when AfdSignaling is set to
                  (NONE). A preferred implementation of this workflow is to set RespondToAfd to
                  (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
                  values from this output.

                  - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                  have a different aspect ratio from the input aspect ratio. Choose Stretch to
                  output (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit.
                  Keep the setting Default (DEFAULT) to have the service letterbox your video
                  instead. This setting overrides any value that you specify for the setting
                  Selection placement (position) in this output.

                  - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                  strength of anti-aliasing. This setting changes the width of the anti-alias filter
                  kernel used for scaling. Sharpness only applies if your output resolution is
                  different from your input resolution. 0 is the softest setting, 100 the sharpest,
                  and 50 recommended for most content.

                  - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                  ProRes outputs. Only enable Timecode insertion when the input frame rate is
                  identical to the output frame rate. To include timecodes in this output, set
                  Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                  set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                  output, by default, it uses any embedded timecodes from the input. If none are
                  present, the service will set the timecode for the first output frame to zero. To
                  change this default behavior, adjust the settings under Timecode configuration
                  (TimecodeConfig). In the console, these settings are located under Job > Job
                  settings > Timecode configuration. Note - Timecode source under input settings
                  (InputTimecodeSource) does not affect the timecodes that are inserted in the
                  output. Source under Job settings > Timecode configuration (TimecodeSource) does.

                  - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                  Preprocessors (VideoPreprocessors). Enable the features at each output
                  individually. These features are disabled by default.

                    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                    feature if necessary. Enable or disable this feature for each output
                    individually. This setting is disabled by default.

                      - **Brightness** *(integer) --* Brightness level.

                      - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                      this output. The service supports conversion between HDR formats, between SDR
                      formats, and from SDR to HDR. The service doesn't support conversion from HDR
                      to SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                      video has an HDR format, but visually appears the same as an unconverted
                      output.

                      - **Contrast** *(integer) --* Contrast level.

                      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                      10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume
                      static metadata that you want signaled in the output. These values don't
                      affect the pixel values that are encoded in the video stream. They are
                      intended to help the downstream video player display content in a way that
                      reflects the intentions of the the content creator. When you set Color space
                      conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are
                      required. You must set values for Max frame average light level
                      (maxFrameAverageLightLevel) and Max content light level
                      (maxContentLightLevel); these settings don't have a default value. The default
                      values for the other HDR 10 metadata settings are defined by the P3D65 color
                      space. For more information about MediaConvert HDR jobs, see
                      https://docs.aws.amazon.com/console/mediaconvert/hdr.

                        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                        samples in the coded video sequence, in units of candelas per square meter.
                        This setting doesn't have a default value; you must specify a value that is
                        suitable for the content.

                        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level
                        of any frame in the coded video sequence, in units of candelas per square
                        meter. This setting doesn't have a default value; you must specify a value
                        that is suitable for the content.

                        - **MaxLuminance** *(integer) --* Nominal maximum mastering display
                        luminance in units of of 0.0001 candelas per square meter.

                        - **MinLuminance** *(integer) --* Nominal minimum mastering display
                        luminance in units of of 0.0001 candelas per square meter

                        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **WhitePointX** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                        - **WhitePointY** *(integer) --* HDR Master Display Information must be
                        provided by a color grader, using color grading tools. Range is 0 to 50,000,
                        each increment represents 0.00002 in CIE1931 color coordinate. Note that
                        this setting is not for color correction.

                      - **Hue** *(integer) --* Hue in degrees.

                      - **Saturation** *(integer) --* Saturation level.

                    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce
                    smoother motion and a clearer picture.

                      - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                      (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                      adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                      (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER)
                      if your source file includes a ticker, such as a scrolling headline at the
                      bottom of the frame.

                      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                      does not convert frames that are tagged in metadata as progressive. It will
                      only convert those that are tagged as some other type. - When set to
                      FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                      those that are already tagged as progressive. Turn Force mode on only if there
                      is a good chance that the metadata has tagged frames as progressive when they
                      are not progressive. Do not turn on otherwise; processing frames that are
                      already progressive into progressive will probably result in lower quality
                      video.

                      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                      service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                      interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                      progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby
                    Vision compatible video output.

                      - **L6Metadata** *(dict) --* Use these settings when you set
                      DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                      your input with new values.

                        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                        that corresponds to the brightest pixel in the entire stream. Measured in
                        nits.

                        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                        metadata that corresponds to the highest frame-average brightness in the
                        entire stream. Measured in nits.

                      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service
                      will handle Dolby Vision MaxCLL and MaxFALL properies.

                      - **Profile** *(string) --* In the current MediaConvert implementation, the
                      Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs
                      must contain Dolby Vision frame interleaved data.

                    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter)
                    feature to include a graphic overlay on your video. Enable or disable this
                    feature for each output individually. This setting is disabled by default.

                      - **InsertableImages** *(list) --* Specify the images that you want to overlay
                      on your video. The images must be PNG or TGA files.

                        - *(dict) --* Settings that specify how your still graphic overlay appears.

                          - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                          image to remain on the output video. This duration includes fade-in time
                          but not fade-out time.

                          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                          between the Start time that you specify for the image insertion and the
                          time that the image appears at full opacity. Full opacity is the level
                          that you specify for the opacity setting. If you don't specify a value for
                          Fade-in, the image will appear abruptly at the overlay start time.

                          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                          between the end of the time that you have specified for the image overlay
                          Duration and when the overlaid image has faded to total transparency. If
                          you don't specify a value for Fade-out, the image will disappear abruptly
                          at the end of the inserted image duration.

                          - **Height** *(integer) --* Specify the height of the inserted image in
                          pixels. If you specify a value that's larger than the video resolution
                          height, the service will crop your overlaid image to fit. To use the
                          native height of the image, keep this setting blank.

                          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon
                          S3 location of the image that you want to overlay on the video. Use a PNG
                          or TGA file.

                          - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                          inserted image and the left edge of the video frame. Required for any
                          image overlay that you specify.

                          - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                          overlaid image and the top edge of the video frame. Required for any image
                          overlay that you specify.

                          - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                          Images with higher values for Layer appear on top of images with lower
                          values for Layer.

                          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                          the underlying video shows through the inserted image. 0 is transparent
                          and 100 is fully opaque. Default is 50.

                          - **StartTime** *(string) --* Specify the timecode of the frame that you
                          want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                          or HH:MM:SS;FF) format. Remember to take into account your timecode source
                          settings.

                          - **Width** *(integer) --* Specify the width of the inserted image in
                          pixels. If you specify a value that's larger than the video resolution
                          width, the service will crop your overlaid image to fit. To use the native
                          width of the image, keep this setting blank.

                    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature
                    to remove noise from your video output if necessary. Enable or disable this
                    feature for each output individually. This setting is disabled by default.

                      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                      select one of the following spatial image filtering functions. To use this
                      setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                      preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                      Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                      reduction. * Spatial does frequency-domain filtering based on JND principles.
                      * Temporal optimizes video quality for complex motion.

                      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                        - **Strength** *(integer) --* Relative strength of noise reducing filter.
                        Higher values produce stronger filtering.

                      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                      spatial filter.

                        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post
                        noise reduction sharpening filter, with 0 disabling the filter and 3
                        enabling it at maximum strength.

                        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to
                        3 (higher speed), with 0 being the nominal value.

                        - **Strength** *(integer) --* Relative strength of noise reducing filter.
                        Higher values produce stronger filtering.

                      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                      temporal filter.

                        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                        complex motion. Higher values produce stronger temporal filtering. This
                        filters highly complex scenes more aggressively and creates better VQ for
                        low bitrate outputs.

                        - **Speed** *(integer) --* The speed of the filter (higher number is
                        faster). Low setting reduces bit rate at the cost of transcode time, high
                        setting improves transcode time at the cost of bit rate.

                        - **Strength** *(integer) --* Specify the strength of the noise reducing
                        filter on this output. Higher values produce stronger filtering. We
                        recommend the following value ranges, depending on the result that you want:
                        * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
                        complexity reduction with image preservation * 8-16 for a high level of
                        complexity reduction

                    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                    output timecode and specified prefix into the output.

                      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                      any burned-in timecode. Valid values are 10, 16, 32, 48.

                      - **Position** *(string) --* Use Position (Position) under under Timecode
                      burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                      output video.

                      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters
                      before any burned-in timecode. For example, a prefix of "EZ-" will result in
                      the timecode "EZ-00:00:00:00". Provide either the characters themselves or the
                      ASCII code equivalents. The supported range of characters is 0x20 through
                      0x7e. This includes letters, numbers, and all special characters represented
                      on a standard English keyboard.

                  - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                  in pixels, for this output. If you don't provide a value here, the service will
                  use the input width.

        - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
        information from inputs.

          - **Anchor** *(string) --* If you use an editing platform that relies on an anchor
          timecode, use Anchor Timecode (Anchor) to specify a timecode that will match the input
          video frame to the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF)
          or (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
          Timecode varies depending on your setting for Source (TimecodeSource). * If Source
          (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
          specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
          (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start
          at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
          Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
          input.

          - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
          within this job. To make sure that your video, audio, captions, and markers are
          synchronized and that time-based features, such as image inserter, work correctly, choose
          the Timecode source option that matches your assets. All timecodes are in a 24-hour format
          with frame number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the
          input video. If no embedded timecode is in the source, the service will use Start at 0
          (ZEROBASED) instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to
          00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to
          a value other than zero. You use Start timecode (Start) to provide this value.

          - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
          (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial
          frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

          - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
          stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
          affecting the time and frame number. Provide the new date as a string in the format
          "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
          (InsertProgramDateTime) in the output settings. For example, if the date part of your
          timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
          (TimestampOffset) to 2003-1-25.

        - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
        (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you
        must enable it here, enable it in each output container, and specify tags and timecodes in
        ID3 insertion (Id3Insertion) objects.

          - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion
          instances.

            - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3)
            to specify the base 64 encoded string and use Timecode (TimeCode) to specify the time
            when the tag should be inserted. To insert multiple ID3 tags in your output, create
            multiple instances of ID3 insertion (Id3Insertion).

              - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
              format.

              - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or
              HH:MM:SS;FF format.

      - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
      events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
      MediaConvert sends an update at this interval from the time the service begins processing your
      job to the time it completes the transcode or encounters an error.

      - **Type** *(string) --* A job template can be of two types: system or custom. System or
      built-in job templates can't be modified or deleted by the user.
    """


_ClientUpdateJobTemplateSettingsAvailBlankingTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsAvailBlankingTypeDef", {"AvailBlankingImage": str}, total=False
)


class ClientUpdateJobTemplateSettingsAvailBlankingTypeDef(
    _ClientUpdateJobTemplateSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ClientUpdateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ClientUpdateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsEsam` `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ClientUpdateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef(
    _ClientUpdateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsEsam` `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientUpdateJobTemplateSettingsEsamTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ClientUpdateJobTemplateSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ClientUpdateJobTemplateSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsEsamTypeDef(_ClientUpdateJobTemplateSettingsEsamTypeDef):
    """
    Type definition for `ClientUpdateJobTemplateSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ClientUpdateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputs` `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsAudioSelectors` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientUpdateJobTemplateSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ClientUpdateJobTemplateSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsAudioSelectorsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsCaptionSelectors` `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ClientUpdateJobTemplateSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsCaptionSelectorsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputs` `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ClientUpdateJobTemplateSettingsInputsCropTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsCropTypeDef(
    _ClientUpdateJobTemplateSettingsInputsCropTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef(
    _ClientUpdateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsImageInserter` `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdateJobTemplateSettingsInputsImageInserterTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientUpdateJobTemplateSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsImageInserterTypeDef(
    _ClientUpdateJobTemplateSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdateJobTemplateSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsInputClippingsTypeDef(
    _ClientUpdateJobTemplateSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ClientUpdateJobTemplateSettingsInputsPositionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsPositionTypeDef(
    _ClientUpdateJobTemplateSettingsInputsPositionTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ClientUpdateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputsVideoSelector` `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientUpdateJobTemplateSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ClientUpdateJobTemplateSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsVideoSelectorTypeDef(
    _ClientUpdateJobTemplateSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientUpdateJobTemplateSettingsInputsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str, ClientUpdateJobTemplateSettingsInputsAudioSelectorGroupsTypeDef
        ],
        "AudioSelectors": Dict[str, ClientUpdateJobTemplateSettingsInputsAudioSelectorsTypeDef],
        "CaptionSelectors": Dict[str, ClientUpdateJobTemplateSettingsInputsCaptionSelectorsTypeDef],
        "Crop": ClientUpdateJobTemplateSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DenoiseFilter": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ClientUpdateJobTemplateSettingsInputsImageInserterTypeDef,
        "InputClippings": List[ClientUpdateJobTemplateSettingsInputsInputClippingsTypeDef],
        "Position": ClientUpdateJobTemplateSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ClientUpdateJobTemplateSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsInputsTypeDef(_ClientUpdateJobTemplateSettingsInputsTypeDef):
    """
    Type definition for `ClientUpdateJobTemplateSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ClientUpdateJobTemplateSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsMotionImageInserterFramerateTypeDef(
    _ClientUpdateJobTemplateSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsMotionImageInserter` `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ClientUpdateJobTemplateSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsMotionImageInserterOffsetTypeDef(
    _ClientUpdateJobTemplateSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsMotionImageInserter` `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ClientUpdateJobTemplateSettingsMotionImageInserterTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ClientUpdateJobTemplateSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ClientUpdateJobTemplateSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsMotionImageInserterTypeDef(
    _ClientUpdateJobTemplateSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ClientUpdateJobTemplateSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsNielsenConfigurationTypeDef(
    _ClientUpdateJobTemplateSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings` `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings` `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroups` `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings` `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputs` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputs` `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettings` `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputs` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettings`
    `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputs` `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings` `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings` `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroupsOutputs` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ClientUpdateJobTemplateSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ClientUpdateJobTemplateSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ClientUpdateJobTemplateSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsOutputsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientUpdateJobTemplateSettingsOutputGroupsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ClientUpdateJobTemplateSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[ClientUpdateJobTemplateSettingsOutputGroupsOutputsTypeDef],
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsOutputGroupsTypeDef(
    _ClientUpdateJobTemplateSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ClientUpdateJobTemplateSettingsTimecodeConfigTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsTimecodeConfigTypeDef(
    _ClientUpdateJobTemplateSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ClientUpdateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ClientUpdateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ClientUpdateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettingsTimedMetadataInsertion` `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ClientUpdateJobTemplateSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ClientUpdateJobTemplateSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsTimedMetadataInsertionTypeDef(
    _ClientUpdateJobTemplateSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ClientUpdateJobTemplateSettings` `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ClientUpdateJobTemplateSettingsTypeDef = TypedDict(
    "_ClientUpdateJobTemplateSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ClientUpdateJobTemplateSettingsAvailBlankingTypeDef,
        "Esam": ClientUpdateJobTemplateSettingsEsamTypeDef,
        "Inputs": List[ClientUpdateJobTemplateSettingsInputsTypeDef],
        "MotionImageInserter": ClientUpdateJobTemplateSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ClientUpdateJobTemplateSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ClientUpdateJobTemplateSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ClientUpdateJobTemplateSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ClientUpdateJobTemplateSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ClientUpdateJobTemplateSettingsTypeDef(_ClientUpdateJobTemplateSettingsTypeDef):
    """
    Type definition for `ClientUpdateJobTemplate` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
    job. There can only be one input in a job template. Using the API, you can include multiple
    inputs when referencing a job template.

      - *(dict) --* Specified video input in a template.

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptions` `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsAudioDescriptions` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientUpdatePresetResponsePresetSettingsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsAudioDescriptionsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettings` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsTypeDef",
    {
        "CustomLanguageCode": str,
        "DestinationSettings": ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettings` `CaptionDescriptions`

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsContainerSettings` `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsContainerSettings` `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsContainerSettings` `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsContainerSettings` `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsContainerSettings` `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsContainerSettings` `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientUpdatePresetResponsePresetSettingsContainerSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientUpdatePresetResponsePresetSettingsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientUpdatePresetResponsePresetSettingsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientUpdatePresetResponsePresetSettingsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientUpdatePresetResponsePresetSettingsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientUpdatePresetResponsePresetSettingsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientUpdatePresetResponsePresetSettingsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsContainerSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsContainerSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettings` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescription` `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionCropTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescription` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettingsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientUpdatePresetResponsePresetSettingsVideoDescriptionTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientUpdatePresetResponsePresetSettingsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientUpdatePresetResponsePresetSettingsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientUpdatePresetResponsePresetSettingsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientUpdatePresetResponsePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsVideoDescriptionTypeDef(
    _ClientUpdatePresetResponsePresetSettingsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePresetSettings` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientUpdatePresetResponsePresetSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetSettingsTypeDef",
    {
        "AudioDescriptions": List[ClientUpdatePresetResponsePresetSettingsAudioDescriptionsTypeDef],
        "CaptionDescriptions": List[
            ClientUpdatePresetResponsePresetSettingsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ClientUpdatePresetResponsePresetSettingsContainerSettingsTypeDef,
        "VideoDescription": ClientUpdatePresetResponsePresetSettingsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetSettingsTypeDef(
    _ClientUpdatePresetResponsePresetSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetResponsePreset` `Settings`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
    caption settings in a single output.

      - *(dict) --* Caption Description for preset

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientUpdatePresetResponsePresetTypeDef = TypedDict(
    "_ClientUpdatePresetResponsePresetTypeDef",
    {
        "Arn": str,
        "Category": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "Settings": ClientUpdatePresetResponsePresetSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ClientUpdatePresetResponsePresetTypeDef(_ClientUpdatePresetResponsePresetTypeDef):
    """
    Type definition for `ClientUpdatePresetResponse` `Preset`

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **Category** *(string) --* An optional category you create to organize your presets.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for preset creation.

    - **Description** *(string) --* An optional description you create for each preset.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the preset was last
    updated.

    - **Name** *(string) --* A name you create for each preset. Each name must be unique within your
    account.

    - **Settings** *(dict) --* Settings for preset

      - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
      settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
      (AudioDescriptions) can contain multiple groups of encoding settings.

        - *(dict) --* Description of audio output

          - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
          these settings unless you need to comply with a loudness standard.

            - **Algorithm** *(string) --* Choose one of the following audio normalization
            algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness
            for an entire piece of content, suitable for measurement of short-form content under
            ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated
            loudness. A measurement of gated average loudness compliant with the requirements of
            EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified peak. The same
            loudness measurement algorithm as 1770-2, with an updated true peak measurement. ITU-R
            BS.1770-4: Higher channel count. Allows for more audio channels than the other
            algorithms, including configurations such as 7.1.

            - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
            the chosen algorithm. If disabled, the audio will be measured but not adjusted.

            - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
            corrected to the target level. Content measuring below this level will not be corrected.
            Gating only applies when not using real_time_correction.

            - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
            loudness to a CSV file.

            - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
            for each output's audio track loudness.

            - **TargetLkfs** *(float) --* When you use Audio normalization
            (AudioNormalizationSettings), optionally use this setting to specify a target loudness.
            If you don't specify a value here, the encoder chooses a value for you, based on the
            algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
            encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

          - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
          the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
          order within each input. For example if you specify "Audio Selector 3", then the third
          audio selector will be used from each input. If an input does not have an "Audio Selector
          3", then the audio selector marked as "default" in that input will be used. If there is no
          audio selector marked as "default", silence will be inserted for the duration of that
          input. Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be
          specified, with similar default/silence behavior. If no audio_source_name is specified,
          then "Audio Selector 1" will be chosen automatically.

          - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
          (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
          Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
               Visually Impaired Commentary,
          4-255 = Reserved.

          - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
          ISO 639 audio_type, then that value is passed through to the output. If the input contains
          no ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the
          value in Audio Type is included in the output. Note that this field and audioType are both
          ignored if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

          - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
          (AudioDescriptions) contains the group of settings related to audio encoding. The settings
          in this group vary depending on the value that you choose for Audio codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
          WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
          Eac3AtmosSettings

            - **AacSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
            mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
            set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode,
            you control the audio quality with the setting VBR quality (vbrQuality). In CBR mode,
            you use the setting Bitrate (bitrate). Defaults and valid values depend on the rate
            control mode.

              - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
              the input contains pre-mixed main audio + audio description (AD) as a stereo pair. The
              value for AudioType will be set to 3, which signals to downstream systems that this
              stream contains "broadcaster mixed AD". Note that the input received by the encoder
              must contain pre-mixed audio; the encoder does not perform the mixing. When you choose
              BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
              FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
              audio description (AD). In this case, the encoder will use any values you provide for
              AudioType and FollowInputAudioType.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
              of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
              24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000,
              192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000,
              768000, 896000, 1024000. The value you set is also constrained by the values that you
              choose for Profile (codecProfile), Bitrate control mode (codingMode), and Sample rate
              (sampleRate). Default values depend on Bitrate control mode and Profile.

              - **CodecProfile** *(string) --* AAC Profile.

              - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
              layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
              (Receiver Mix)" setting receives a stereo description plus control track and emits a
              mono AAC encode of the description track, with control data emitted in the PES header
              as per ETSI TS 101 154 Annex E.

              - **RateControlMode** *(string) --* Rate Control Mode.

              - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
              LATM/LOAS AAC in an output, you must choose "No container" for the output container.

              - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
              mode and profile.

              - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
              or MPEG-2 Transport Stream containers.

              - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
              VBR.

            - **Ac3Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AC3.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              bitrates depend on the coding mode.

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
              the encoder emits. For more information about the AC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
              channels.

              - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
              audio is Dolby Digital, dialnorm will be passed through.

              - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
              dynamic range compression signaling to the output bitstream as defined in the Dolby
              Digital specification.

              - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior
              to encoding. Only valid with 3_2_LFE coding mode.

              - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
              sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio
              was not supplied from one of these streams, then the static metadata settings will be
              used.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

            - **AiffSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AIFF.

              - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
              choose the encoding quality for this audio track.

              - **Channels** *(integer) --* Specify the number of channels in this output audio
              track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
              on, up to 64.

              - **SampleRate** *(integer) --* Sample rate in hz.

            - **Codec** *(string) --* Type of Audio codec.

            - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              values: 384k, 448k, 640k, 768k

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
              that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
              always 9.1.6 (CODING_MODE_9_1_6).

              - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
              loudness based on dialogue analysis.

              - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
              signal with dynamic range compression.

              - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
              dynamic range when compressing the audio.

              - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
              for downmixing. How the service uses this value depends on the value that you choose
              for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
              -4.5, and -6.0.

              - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
              downmixing. How the service uses this value depends on the value that you choose for
              Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
              -60. The value -60 mutes the channel.

              - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, and -6.0.

              - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
              -6.0, and -60. The value -60 mutes the channel.

              - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
              audio.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

              - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
              be speech before the encoder uses the measured speech loudness as the overall program
              loudness.

              - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

              - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
              center rear surround channel matrix encoded into your left and right surround
              channels.

            - **Eac3Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value EAC3.

              - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
              attenuation to the surround channels. Only used for 3/2 coding mode.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              bitrates depend on the coding mode.

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
              that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
              channels.

              - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

              - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
              audio is Dolby Digital Plus, dialnorm will be passed through.

              - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
              signal with dynamic range compression.

              - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
              dynamic range when compressing the audio.

              - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
              channel is enabled

              - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior
              to encoding. Only valid with 3_2_LFE coding mode.

              - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
              Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only
              if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left only/Right only center (loRoCenterMixLevel).

              - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
              Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
              and -60. The value -60 mutes the channel. This setting applies only if you keep the
              default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
              (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
              Left only/Right only surround (loRoSurroundMixLevel).

              - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
              Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only
              if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left total/Right total center (ltRtCenterMixLevel).

              - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
              Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
              MediaConvert uses this value for downmixing. How the service uses this value depends
              on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
              -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
              only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

              - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
              sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio
              was not supplied from one of these streams, then the static metadata settings will be
              used.

              - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
              be passed through if it is present on the input. this detection is dynamic over the
              life of the transcode. Inputs that alternate between DD+ and non-DD+ content will have
              a consistent DD+ output as the system alternates between passthrough and encoding.

              - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
              surround channels. Only used for 3/2 coding mode.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

              - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
              setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
              (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
              different value for Coding mode, the service ignores Stereo downmix
              (Eac3StereoDownmix).

              - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
              center back surround channel is matrix encoded into the left and right surround
              channels.

              - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround
              is matrix encoded into the two channels.

            - **Mp2Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value MP2.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

              - **Channels** *(integer) --* Set Channels to specify the number of channels in this
              output audio track. Choosing Mono in the console will give you 1 output channel;
              choosing Stereo will give you 2. In the API, valid values are 1 and 2.

              - **SampleRate** *(integer) --* Sample rate in hz.

            - **WavSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value WAV.

              - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
              choose the encoding quality for this audio track.

              - **Channels** *(integer) --* Specify the number of channels in this output audio
              track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
              on, up to 64.

              - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
              output audio is likely to exceed 4 GB in file size, or if you otherwise need the
              extended support of the RF64 format, set your output WAV file format to RF64.

              - **SampleRate** *(integer) --* Sample rate in Hz.

          - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
          The service puts this language code into your output audio track when you set Language
          code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
          also uses your specified custom language code when you set Language code control
          (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
          specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
          streaming outputs, you can also use any other code in the full RFC-5646 specification.
          Streaming outputs are those that are in one of the following output groups: CMAF, DASH
          ISO, Apple HLS, or Microsoft Smooth Streaming.

          - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
          639 language specified in the 'Language Code' drop down will be used when 'Follow Input
          Language Code' is not selected or when 'Follow Input Language Code' is selected but there
          is no ISO 639 language code specified by the input.

          - **LanguageCodeControl** *(string) --* Specify which source for language code takes
          precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
          uses the language code from the input track if it's present. If there's no languge code on
          the input track, the service uses the code that you specify in the setting Language code
          (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
          service uses the language code that you specify.

          - **RemixSettings** *(dict) --* Advanced audio remixing settings.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
          "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
          this information into destination manifests for display on the end-viewer's player device.
          For outputs in other output groups, the service ignores this setting.

      - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
      caption settings in a single output.

        - *(dict) --* Caption Description for preset

          - **CustomLanguageCode** *(string) --* Specify the language for this captions output
          track. For most captions output formats, the encoder puts this language information in the
          output captions metadata. If your output captions format is DVB-Sub or Burn in, the
          encoder uses this language information when automatically selecting the font script for
          rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
          For streaming outputs, you can also use any other code in the full RFC-5646 specification.
          Streaming outputs are those that are in one of the following output groups: CMAF, DASH
          ISO, Apple HLS, or Microsoft Smooth Streaming.

          - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
          that burnin_destination_settings are not available if the source of the caption data is
          Embedded or Teletext.

            - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

              - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
              setting alignment to centered will place the captions at the bottom center of the
              output. Similarly, setting a left alignment will align captions to the bottom left of
              the output. If x and y positions are given in conjunction with the alignment
              parameter, the font will be justified (either left or centered) relative to those
              coordinates. This option is not valid for source captions that are STL, 608/embedded
              or teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
              captions. All burn-in and DVB-Sub font settings must match.

              - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
              rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
              to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

              - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
              option is not valid for source captions that are STL, 608/embedded or teletext. These
              source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
              font settings must match.

              - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255
              is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

              - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
              96 dpi. All burn-in and DVB-Sub font settings must match.

              - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
              code, if the LanguageCode is not sufficient for determining the script type. Where
              LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
              is used to help determine the appropriate font for rendering burn-in captions.

              - **FontSize** *(integer) --* A positive integer indicates the exact font size in
              points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineColor** *(string) --* Specifies font outline color. This option is not
              valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
              not valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
              captions. All burn-in and DVB-Sub font settings must match.

              - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque;
              0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
              (transparent). All burn-in and DVB-Sub font settings must match.

              - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels to the left. All burn-in and DVB-Sub font settings must match.

              - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels above the text. All burn-in and DVB-Sub font settings must match.

              - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
              Teletext or STL formats. Specify whether the spacing between letters in your captions
              is set by the captions grid or varies depending on letter width. Choose fixed grid to
              conform to the spacing specified in the captions file more accurately. Choose
              proportional to make the text easier to read if the captions are closed caption.

              - **XPosition** *(integer) --* Specifies the horizontal position of the caption
              relative to the left side of the output in pixels. A value of 10 would result in the
              captions starting 10 pixels from the left of the output. If no explicit x_position is
              provided, the horizontal caption position will be determined by the alignment
              parameter. This option is not valid for source captions that are STL, 608/embedded or
              teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
              to the top of the output in pixels. A value of 10 would result in the captions
              starting 10 pixels from the top of the output. If no explicit y_position is provided,
              the caption will be positioned towards the bottom of the output. This option is not
              valid for source captions that are STL, 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

            - **DestinationType** *(string) --* Specify the format for this set of captions on this
            output. The default format is embedded without SCTE-20. Other options are embedded with
            SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
            SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
            complies with the SCTE-43 spec. To create a non-compliant output where the embedded
            captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

            - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

              - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
              setting alignment to centered will place the captions at the bottom center of the
              output. Similarly, setting a left alignment will align captions to the bottom left of
              the output. If x and y positions are given in conjunction with the alignment
              parameter, the font will be justified (either left or centered) relative to those
              coordinates. This option is not valid for source captions that are STL, 608/embedded
              or teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
              captions. All burn-in and DVB-Sub font settings must match.

              - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
              rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
              to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

              - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
              option is not valid for source captions that are STL, 608/embedded or teletext. These
              source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
              font settings must match.

              - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255
              is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

              - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
              96 dpi. All burn-in and DVB-Sub font settings must match.

              - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
              code, if the LanguageCode is not sufficient for determining the script type. Where
              LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
              is used to help determine the appropriate font for rendering DVB-Sub captions.

              - **FontSize** *(integer) --* A positive integer indicates the exact font size in
              points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineColor** *(string) --* Specifies font outline color. This option is not
              valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
              not valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
              captions. All burn-in and DVB-Sub font settings must match.

              - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque;
              0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
              (transparent). All burn-in and DVB-Sub font settings must match.

              - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels to the left. All burn-in and DVB-Sub font settings must match.

              - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels above the text. All burn-in and DVB-Sub font settings must match.

              - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
              for hearing impaired. Choose hearing impaired if your subtitles include audio
              descriptions and dialogue. Choose standard if your subtitles include only dialogue.

              - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
              Teletext or STL formats. Specify whether the spacing between letters in your captions
              is set by the captions grid or varies depending on letter width. Choose fixed grid to
              conform to the spacing specified in the captions file more accurately. Choose
              proportional to make the text easier to read if the captions are closed caption.

              - **XPosition** *(integer) --* Specifies the horizontal position of the caption
              relative to the left side of the output in pixels. A value of 10 would result in the
              captions starting 10 pixels from the left of the output. If no explicit x_position is
              provided, the horizontal caption position will be determined by the alignment
              parameter. This option is not valid for source captions that are STL, 608/embedded or
              teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
              to the top of the output in pixels. A value of 10 would result in the captions
              starting 10 pixels from the top of the output. If no explicit y_position is provided,
              the caption will be positioned towards the bottom of the output. This option is not
              valid for source captions that are STL, 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

            - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
            caption outputs, including 608/708 Channel destination number.

              - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
              captions are SCC format and your output captions are embedded in the video stream.
              Specify a CC number for each captions channel in this output. If you have two
              channels, choose CC numbers that aren't in the same field. For example, choose 1 and
              3. For more information, see
              https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
              captions are SCC format and you want both 608 and 708 captions embedded in your output
              stream. Optionally, specify the 708 service number for each output captions channel.
              Choose a different number for each channel. To use this setting, also set Force 608 to
              708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions
              selector settings. If you choose to upconvert but don't specify a 708 service number,
              MediaConvert uses the number that you specify for CC channel number
              (destination608ChannelNumber) for the 708 service number. For more information, see
              https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

              - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
              use the font style and position information from the captions source in the output.
              This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or
              TTML. Disable this setting for simplified output captions.

            - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

              - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
              that the captions and the video are synchronized in the output. Specify a frame rate
              that matches the frame rate of the associated video. If the video frame rate is 29.97,
              choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
              video_insertion=true and drop_frame_timecode=true; otherwise, choose 29.97
              non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

            - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

              - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
              destination captions for this output. This value must be a three-digit hexadecimal
              string; strings ending in -FF are invalid. If you are passing through the entire set
              of Teletext data, do not use this field.

              - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
              don't specify a value here, the service sets the page type to the default value
              Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
              don't use this field. When you pass through a set of Teletext pages, your output has
              the same page types as your input.

                - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

            - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
            including Pass style information (TtmlStylePassthrough).

              - **StylePassthrough** *(string) --* Pass through style and position information from
              a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

          - **LanguageCode** *(string) --* Specify the language of this captions output track. For
          most captions output formats, the encoder puts this language information in the output
          captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
          this language information to choose the font language for rendering the captions text.

          - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
          For example, "English", "Director commentary", or "track_2". For streaming outputs,
          MediaConvert passes this information into destination manifests for display on the
          end-viewer's player device. For outputs in other output groups, the service ignores this
          setting.

      - **ContainerSettings** *(dict) --* Container specific settings.

        - **Container** *(string) --* Container for this output. Some containers require a container
        settings object. If not specified, the default object will be created.

        - **F4vSettings** *(dict) --* Settings for F4v container

          - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
          relocated to the beginning of the archive as required for progressive downloading.
          Otherwise it is placed normally at the end.

        - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
        File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
        (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
        stream program contains subsets of data, including audio, video, and metadata. Each of these
        subsets of data has a numerical label called a packet identifier (PID). Each transport
        stream program corresponds to one MediaConvert output. The PMT lists the types of data in a
        program along with their PID. Downstream systems and players use the program map table to
        look up the PID for each type of data it accesses and then uses the PIDs to locate specific
        data within the asset.

          - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
          Dolby Digital audio.

          - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
          packet.

          - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
          streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
          range 482-492.

            - *(integer) --*

          - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
          per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
          Other common values are 3750000, 7500000, and 15000000.

          - **BufferModel** *(string) --* Controls what buffer model to use for accurate
          interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
          lead to lower latency, but low-memory devices may not be able to play back the stream
          without interruptions.

          - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
          specified table repetition interval.

            - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
            (NIT).

            - **NetworkName** *(string) --* The network name text placed in the
            network_name_descriptor inside the Network Information Table. Maximum length is 256
            characters.

            - **NitInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

          - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
          specified table repetition interval.

            - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
            stream. "Follow input SDT" copies SDT information from input stream to output stream.
            "Follow input SDT if present" copies SDT information from input stream to output stream
            if SDT information is present in the input, otherwise it will fall back on the
            user-defined values. Enter "SDT Manually" means user will enter the SDT information. "No
            SDT" means output stream will not contain SDT information.

            - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
            Service Description Table. Maximum length is 256 characters.

            - **ServiceProviderName** *(string) --* The service provider name placed in the
            service_descriptor in the Service Description Table. Maximum length is 256 characters.

          - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
          included in this output. Specify multiple PIDs as a JSON array. Default is the range
          460-479.

            - *(integer) --*

          - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
          table repetition interval.

            - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

          - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
          data you include in this output. Default is 499.

          - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
          markers will be added to partitions 3 and 4. The interval between these additional markers
          will be fixed, and will be slightly shorter than the video EBP marker interval. When set
          to VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
          segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

          - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
          either be placed only on the video PID, or on both the video PID and all audio PIDs. Only
          applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
          EBP_LEGACY).

          - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
          header.

          - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
          that your audio EBP markers are incorrectly appearing before your video EBP markers. To
          correct this problem, set this value to Force (FORCE).

          - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
          EBP markers.

          - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
          Program Clock References (PCRs) inserted into the transport stream.

          - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
          come within the specified time interval of each other by looking ahead at input video. If
          another EBP is going to come in within the specified time interval, the current EBP is not
          emitted, and the segment is "stretched" to the next marker. The lookahead value does not
          add latency to the system. The Live Event must be configured elsewhere to create
          sufficient latency to make the lookahead accurate.

          - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will
          be detected in the input audio and an equivalent ID3 tag will be inserted in the output.

          - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
          insert into the transport stream. This can be used if a downstream encryption system
          requires periodic null packets.

          - **PatInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
          value is inserted for every Packetized Elementary Stream (PES) header. This is effective
          only when the PCR PID is the same as the video or audio elementary stream.

          - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
          reference (PCR) in this output. If you do not specify a value, the service will use the
          value for Video PID (VideoPid).

          - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
          the program map table (PMT) in the output transport stream.

          - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
          (PMT) itself. Default is 480.

          - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
          metadata stream. Default is 503.

          - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
          program number used in the program map table (PMT) for this output. Default is 1. Program
          numbers and program map tables are parts of MPEG-2 transport stream containers, used for
          organizing data.

          - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
          to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
          bitrate, but the output will not be padded up to that bitrate.

          - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
          your HLS and transport stream outputs at the insertion points that you specify in an ESAM
          XML document. Provide the document in the setting SCC XML (sccXml).

            - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream generated by ESAM.

          - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
          in the transport stream.

          - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
          (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
          output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
          markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
          string in the setting Signal processing notification XML (sccXml). Also enable ESAM
          SCTE-35 (include the property scte35Esam).

          - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
          segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
          adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
          data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
          Encoder Boundary Point information to the adaptation field as per OpenCable specification
          OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
          field using a legacy proprietary format.

          - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
          segmentation markers are inserted into the transport stream. With avails, it is possible
          that segments may be truncated, which can influence where future segmentation markers are
          inserted. When a segmentation style of "reset_cadence" is selected and a segment is
          truncated due to an avail, we will reset the segmentation cadence. This means the
          subsequent segment will have a duration of of $segmentation_time seconds. When a
          segmentation style of "maintain_cadence" is selected and a segment is truncated due to an
          avail, we will not reset the segmentation cadence. This means the subsequent segment will
          likely be truncated as well. However, all segments after that will have a duration of
          $segmentation_time seconds. Note that EBP lookahead is a slight exception to this rule.

          - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
          Required unless markers is set to _none_.

          - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
          metadata in this output. Default is 502.

          - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
          the program map table for this output. Transport stream IDs and program map tables are
          parts of MPEG-2 transport stream containers, used for organizing data.

          - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
          stream in the transport stream.

        - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

          - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
          packet.

          - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
          the transport stream. Multiple values are accepted, and can be entered in ranges and/or by
          comma separation.

            - *(integer) --*

          - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will
          be detected in the input audio and an equivalent ID3 tag will be inserted in the output.

          - **PatInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
          value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
          effective only when the PCR PID is the same as the video or audio elementary stream.

          - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
          in the transport stream. When no value is given, the encoder will assign the same value as
          the Video PID.

          - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
          transport stream.

          - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
          stream in the transport stream.

          - **ProgramNumber** *(integer) --* The value of the program number field in the Program
          Map Table.

          - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream.

          - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
          (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
          output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
          markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
          conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
          want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
          setting Signal processing notification XML (sccXml).

          - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
          whether the service inserts the ID3 timed metadata from the input in this output.

          - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
          in the transport stream.

          - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
          Program Map Table.

          - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
          the transport stream.

        - **MovSettings** *(dict) --* Settings for MOV Container.

          - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
          video output settings.

          - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
          composition times in the 'ctts' (composition time to sample) box for B-frames will be
          negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
          amendment 1. This improves compatibility with Apple players and tools.

          - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
          the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple
          editors and players, but may decrease compatibility with other players. Only applicable
          when the video codec is MPEG2.

          - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

          - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
          setting.

        - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
        outputs with this container.

          - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
          composition times in the 'ctts' (composition time to sample) box for B-frames will be
          negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
          amendment 1. This improves compatibility with Apple players and tools.

          - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

          - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
          relocated to the beginning of the archive as required for progressive downloading.
          Otherwise it is placed normally at the end.

          - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
          Usually not necessary to specify.

        - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

          - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
          include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
          from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
          container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
          within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
          and audio fragmented MP4 files.

          - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
          ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
          specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
          your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
          appear in your input to also appear in this output. Choose None (NONE) if you don't want
          those SCTE-35 markers in this output.

      - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
      settings. The specific video settings depend on the video codec that you choose when you
      specify a value for Video codec (codec). Include one instance of (VideoDescription) per
      output.

        - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
        outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD
        values in the output video data and what those values are. * Choose None to remove all AFD
        values from this output. * Choose Fixed to ignore input AFD values and instead encode the
        value specified in the job. * Choose Auto to calculate output AFD values based on the input
        AFD scaler data.

        - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
        The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
        job, the service will ignore the setting.

        - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
        (VideoDescription), contains the group of settings related to video encoding. The settings
        in this group vary depending on the value that you choose for Video codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
        Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

          - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
          values defined by the object VideoCodec.

          - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

            - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
            the output stream, then one frame every framerateDenominator/framerateNumerator seconds.
            For example, settings of framerateNumerator = 1 and framerateDenominator =
                 3 (a rate of
            1/3 frame per second) will capture the first frame, then 1 frame every 3s. Files will be
            named as filename.n.jpg where n is the 0-based sequence number of each Capture.

            - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
            output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
            example, settings of framerateNumerator = 1 and framerateDenominator =
                 3 (a rate of 1/3
            frame per second) will capture the first frame, then 1 frame every 3s. Files will be
            named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
            to 7 decimal places.

            - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

            - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

          - **H264Settings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value H_264.

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
            output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

            - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
            available with the AVC-I License.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
            High profile) or CAVLC.

            - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
            interlaced outputs.

            - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
            reduce flicker or 'pop' on I-frames.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job specification as
            a JSON file without the console, use FramerateControl to specify which value the service
            uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
            service to use the frame rate from the input. Choose SPECIFIED if you want the service
            to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
            use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
            1001 =
                 23.976 fps. Use FramerateDenominator to specify the denominator of this fraction.
            In this example, use 1001 for the value of FramerateDenominator. When you use the
            console for transcode jobs that use frame rate conversion, provide the value as a
            decimal number for Framerate. In this example, specify 23.976.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
            that have B frames > 1.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type, as follows. - If the source is
            interlaced, the output will be interlaced with the same polarity as the source (it will
            follow the source). The output could therefore be a mix of "top field first" and "bottom
            field first". - If the source is progressive, the output will be interlaced with "top
            field first" or "bottom field first" polarity, depending on which of the Follow options
            you chose.

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000. Required when Rate control mode is QVBR.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
            encoder may use more than requested if using B-frames and/or interlaced encoding.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
            to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
            multipass video encoding.

            - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
            with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
            you set Rate control mode to a value other than QVBR, or when you don't define Rate
            control mode.

              - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
              QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited
              to the complexity of your input video, the service limits the average bitrate of the
              video part of this output to the value that you choose. That is, the total size of the
              video element is less than or equal to the value you set multiplied by the number of
              seconds of encoded output.

              - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
              That is, when you specify qvbrSettings within h264Settings. Specify the target quality
              level for this output, from 1 to 10. Use higher numbers for greater quality. Level 10
              results in nearly lossless compression. The quality level for most broadcast-quality
              transcodes is between 6 and 9.

            - **RateControlMode** *(string) --* Use this setting to specify whether this output has
            a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate
            (QVBR).

            - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
            repeated.

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default. If this output uses QVBR, choose Transition detection
            (TRANSITION_DETECTION) for further video quality improvement. For more information about
            QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

            - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
            the number of macroblock rows for progressive pictures, and less than or equal to half
            the number of macroblock rows for interlaced pictures.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
            high-frequency content in the encoded image.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

            - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
            Framerate (framerate) field is set to 29.970. This field works with the Streams >
            Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
            Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
            output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i
            output from 23.976 input. - Soft: produces 23.976; the player converts this output to
            29.97i.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

            - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
            of an unregistered SEI message.

          - **H265Settings** *(dict) --* Settings for H265 codec

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
            message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
            (EOTF).

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* H.265 Level.

            - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
            specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
            Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
            License.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
            reduce flicker or 'pop' on I-frames.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
            that have B frames > 1.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
            Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
            your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
            create an output that's interlaced with the same field polarity throughout. Choose
            Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
            to create an interlaced output with the same field polarity as the source. If the source
            is interlaced, the output will be interlaced with the same polarity as the source (it
            will follow the source). The output could therefore be a mix of "top field first" and
            "bottom field first". If the source is progressive, your output will be interlaced with
            "top field first" or "bottom field first" polarity, depending on which of the Follow
            options you chose. If you don't choose a value, the service will default to Progressive
            (PROGRESSIVE).

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000. Required when Rate control mode is QVBR.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
            encoder may use more than requested if using B-frames and/or interlaced encoding.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
            to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
            multipass video encoding.

            - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
            with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
            you set Rate control mode to a value other than QVBR, or when you don't define Rate
            control mode.

              - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
              QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited
              to the complexity of your input video, the service limits the average bitrate of the
              video part of this output to the value that you choose. That is, the total size of the
              video element is less than or equal to the value you set multiplied by the number of
              seconds of encoded output.

              - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
              That is, when you specify qvbrSettings within h265Settings. Specify the target quality
              level for this output, from 1 to 10. Use higher numbers for greater quality. Level 10
              results in nearly lossless compression. The quality level for most broadcast-quality
              transcodes is between 6 and 9.

            - **RateControlMode** *(string) --* Use this setting to specify whether this output has
            a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate
            (QVBR).

            - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
            filter strength. Adaptive mode dynamically selects best strength based on content

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default. If this output uses QVBR, choose Transition detection
            (TRANSITION_DETECTION) for further video quality improvement. For more information about
            QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

            - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
            the number of macroblock rows for progressive pictures, and less than or equal to half
            the number of macroblock rows for interlaced pictures.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
            Framerate (framerate) field is set to 29.970. This field works with the Streams >
            Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
            Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
            output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i
            output from 23.976 input. - Soft: produces 23.976; the player converts this output to
            29.97i.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

            - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
            bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
            one layer, reference B-frames can form a second layer and non-reference b-frames can
            form a third layer. Decoders can optionally decode only the lower temporal layers to
            generate a lower frame rate output. For example, given a bitstream with temporal IDs and
            with b-frames =
                 1 (i.e. IbPbPb display order), a decoder could decode all the frames for
            full frame rate output or only the I and P frames (lowest temporal layer) for a half
            frame rate output.

            - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
            subdivision of the encoded pictures.

            - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
            of an unregistered SEI message.

            - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
            doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
            DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
            Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
            following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition.
            For these outputs, the service stores parameter set NAL units in the sample headers but
            not in the samples directly. For MP4 outputs, when you choose HVC1, your output video
            might not work properly with some downstream systems and video players. The service
            defaults to marking your output as HEV1. For these outputs, the service writes parameter
            set NAL units directly into the samples.

          - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value MPEG2.

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
            the video output.

            - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
            profile for the video output.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type. - If the source is interlaced, the
            output will be interlaced with the same polarity as the source (it will follow the
            source). The output could therefore be a mix of "top field first" and "bottom field
            first". - If the source is progressive, the output will be interlaced with "top field
            first" or "bottom field first" polarity, depending on which of the Follow options you
            chose.

            - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
            set quantization precision for intra-block DC coefficients. If you choose the value
            auto, the service will automatically select the precision based on the per-frame
            compression ratio.

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level
            (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
            encoding.

            - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
            specifiy whether the bitrate is variable (vbr) or constant (cbr).

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
            high-frequency content in the encoded image.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

            - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
            (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
            output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
            converstion to the player.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

          - **ProresSettings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value PRORES.

            - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
            of Apple ProRes codec to use for this output.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
            frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
            23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
            example, use 24000 for the value of FramerateNumerator.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type. - If the source is interlaced, the
            output will be interlaced with the same polarity as the source (it will follow the
            source). The output could therefore be a mix of "top field first" and "bottom field
            first". - If the source is progressive, the output will be interlaced with "top field
            first" or "bottom field first" polarity, depending on which of the Follow options you
            chose.

            - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
            determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
            the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
            the console, choose it from the dropdown menu. Using the API, set ProresParControl to
            (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
            (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
            output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
            converstion to the player.

        - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
        metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output.
        If you don't specify a value, the service sets this to Insert by default.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame.

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
        is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
        use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
        enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

        - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
        (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
        on all frames of this video output.

        - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
        height for this output. Specify in pixels. If you don't provide a value here, the service
        will use the input height.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black.

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
        service changes the video itself in response to AFD values in the input. * Choose Respond to
        clip the input video frame according to the AFD value, input display aspect ratio, and
        output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
        choose this when AfdSignaling is set to (NONE). A preferred implementation of this workflow
        is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all
        input AFD values from this output.

        - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
        different aspect ratio from the input aspect ratio. Choose Stretch to output
        (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
        Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
        any value that you specify for the setting Selection placement (position) in this output.

        - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
        anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
        scaling. Sharpness only applies if your output resolution is different from your input
        resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

        - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
        outputs. Only enable Timecode insertion when the input frame rate is identical to the output
        frame rate. To include timecodes in this output, set Timecode insertion
        (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
        is DISABLED. When the service inserts timecodes in an output, by default, it uses any
        embedded timecodes from the input. If none are present, the service will set the timecode
        for the first output frame to zero. To change this default behavior, adjust the settings
        under Timecode configuration (TimecodeConfig). In the console, these settings are located
        under Job > Job settings > Timecode configuration. Note - Timecode source under input
        settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
        output. Source under Job settings > Timecode configuration (TimecodeSource) does.

        - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
        Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
        features are disabled by default.

          - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
          necessary. Enable or disable this feature for each output individually. This setting is
          disabled by default.

            - **Brightness** *(integer) --* Brightness level.

            - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
            output. The service supports conversion between HDR formats, between SDR formats, and
            from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
            conversion doesn't upgrade the dynamic range. The converted video has an HDR format, but
            visually appears the same as an unconverted output.

            - **Contrast** *(integer) --* Contrast level.

            - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
            space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
            want signaled in the output. These values don't affect the pixel values that are encoded
            in the video stream. They are intended to help the downstream video player display
            content in a way that reflects the intentions of the the content creator. When you set
            Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings
            are required. You must set values for Max frame average light level
            (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
            settings don't have a default value. The default values for the other HDR 10 metadata
            settings are defined by the P3D65 color space. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Hue** *(integer) --* Hue in degrees.

            - **Saturation** *(integer) --* Saturation level.

          - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
          and a clearer picture.

            - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
            to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
            (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
            Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
            as a scrolling headline at the bottom of the frame.

            - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
            convert frames that are tagged in metadata as progressive. It will only convert those
            that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
            converts every frame to progressive - even those that are already tagged as progressive.
            Turn Force mode on only if there is a good chance that the metadata has tagged frames as
            progressive when they are not progressive. Do not turn on otherwise; processing frames
            that are already progressive into progressive will probably result in lower quality
            video.

            - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
            will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
            progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
            Adaptive auto-detects and converts to progressive.

          - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
          compatible video output.

            - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
            SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

              - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
              corresponds to the brightest pixel in the entire stream. Measured in nits.

              - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
              that corresponds to the highest frame-average brightness in the entire stream.
              Measured in nits.

            - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
            Dolby Vision MaxCLL and MaxFALL properies.

            - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
            profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
            frame interleaved data.

          - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
          include a graphic overlay on your video. Enable or disable this feature for each output
          individually. This setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
          noise from your video output if necessary. Enable or disable this feature for each output
          individually. This setting is disabled by default.

            - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
            of the following spatial image filtering functions. To use this setting, you must also
            enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. *
            Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. *
            Conserve does min/max noise reduction. * Spatial does frequency-domain filtering based
            on JND principles. * Temporal optimizes video quality for complex motion.

            - **FilterSettings** *(dict) --* Settings for a noise reducer filter

              - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
              values produce stronger filtering.

            - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
            filter.

              - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
              reduction sharpening filter, with 0 disabling the filter and 3 enabling it at maximum
              strength.

              - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
              speed), with 0 being the nominal value.

              - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
              values produce stronger filtering.

            - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
            filter.

              - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
              motion. Higher values produce stronger temporal filtering. This filters highly complex
              scenes more aggressively and creates better VQ for low bitrate outputs.

              - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
              setting reduces bit rate at the cost of transcode time, high setting improves
              transcode time at the cost of bit rate.

              - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
              this output. Higher values produce stronger filtering. We recommend the following
              value ranges, depending on the result that you want: * 0-2 for complexity reduction
              with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
              8-16 for a high level of complexity reduction

          - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
          timecode and specified prefix into the output.

            - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
            burned-in timecode. Valid values are 10, 16, 32, 48.

            - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
            (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

            - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
            burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
            "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
            equivalents. The supported range of characters is 0x20 through 0x7e. This includes
            letters, numbers, and all special characters represented on a standard English keyboard.

        - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
        pixels, for this output. If you don't provide a value here, the service will use the input
        width.

    - **Type** *(string) --* A preset can be of two types: system or custom. System or built-in
    preset can't be modified or deleted by the user.
    """


_ClientUpdatePresetResponseTypeDef = TypedDict(
    "_ClientUpdatePresetResponseTypeDef",
    {"Preset": ClientUpdatePresetResponsePresetTypeDef},
    total=False,
)


class ClientUpdatePresetResponseTypeDef(_ClientUpdatePresetResponseTypeDef):
    """
    Type definition for `ClientUpdatePreset` `Response`

    - **Preset** *(dict) --* A preset is a collection of preconfigured media conversion settings
    that you want MediaConvert to apply to the output during the conversion process.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **Category** *(string) --* An optional category you create to organize your presets.

      - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for preset creation.

      - **Description** *(string) --* An optional description you create for each preset.

      - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the preset was last
      updated.

      - **Name** *(string) --* A name you create for each preset. Each name must be unique within
      your account.

      - **Settings** *(dict) --* Settings for preset

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be
        multiple caption settings in a single output.

          - *(dict) --* Caption Description for preset

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.

      - **Type** *(string) --* A preset can be of two types: system or custom. System or built-in
      preset can't be modified or deleted by the user.
    """


_ClientUpdatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptions` `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptionsCodecSettings` `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptionsCodecSettings` `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptionsCodecSettings` `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptionsCodecSettings` `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptionsCodecSettings` `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptionsCodecSettings` `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptions` `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptionsRemixSettings` `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsAudioDescriptions` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ClientUpdatePresetSettingsAudioDescriptionsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ClientUpdatePresetSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ClientUpdatePresetSettingsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ClientUpdatePresetSettingsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsAudioDescriptionsTypeDef(
    _ClientUpdatePresetSettingsAudioDescriptionsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettings` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef(
    _ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsCaptionDescriptions` `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ClientUpdatePresetSettingsCaptionDescriptionsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsCaptionDescriptionsTypeDef",
    {
        "CustomLanguageCode": str,
        "DestinationSettings": ClientUpdatePresetSettingsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsCaptionDescriptionsTypeDef(
    _ClientUpdatePresetSettingsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettings` `CaptionDescriptions`

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ClientUpdatePresetSettingsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsF4vSettingsTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsContainerSettings` `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsContainerSettingsM2tsSettings` `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsContainerSettingsM2tsSettings` `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsContainerSettingsM2tsSettings` `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ClientUpdatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsContainerSettingsM2tsSettings` `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ClientUpdatePresetSettingsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ClientUpdatePresetSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ClientUpdatePresetSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsM2tsSettingsTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsContainerSettings` `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ClientUpdatePresetSettingsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsM3u8SettingsTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsContainerSettings` `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ClientUpdatePresetSettingsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsMovSettingsTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsContainerSettings` `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ClientUpdatePresetSettingsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsMp4SettingsTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsContainerSettings` `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ClientUpdatePresetSettingsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsMpdSettingsTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsContainerSettings` `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ClientUpdatePresetSettingsContainerSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ClientUpdatePresetSettingsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ClientUpdatePresetSettingsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ClientUpdatePresetSettingsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ClientUpdatePresetSettingsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ClientUpdatePresetSettingsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ClientUpdatePresetSettingsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ClientUpdatePresetSettingsContainerSettingsTypeDef(
    _ClientUpdatePresetSettingsContainerSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettings` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionCodecSettings` `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionCodecSettings` `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionCodecSettings` `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionCodecSettings` `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ClientUpdatePresetSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ClientUpdatePresetSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ClientUpdatePresetSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ClientUpdatePresetSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionCodecSettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescription` `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ClientUpdatePresetSettingsVideoDescriptionCropTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionCropTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdatePresetSettingsVideoDescriptionPositionTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionPositionTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescription` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessors` `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettingsVideoDescription` `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ClientUpdatePresetSettingsVideoDescriptionTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ClientUpdatePresetSettingsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ClientUpdatePresetSettingsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ClientUpdatePresetSettingsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ClientUpdatePresetSettingsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ClientUpdatePresetSettingsVideoDescriptionTypeDef(
    _ClientUpdatePresetSettingsVideoDescriptionTypeDef
):
    """
    Type definition for `ClientUpdatePresetSettings` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientUpdatePresetSettingsTypeDef = TypedDict(
    "_ClientUpdatePresetSettingsTypeDef",
    {
        "AudioDescriptions": List[ClientUpdatePresetSettingsAudioDescriptionsTypeDef],
        "CaptionDescriptions": List[ClientUpdatePresetSettingsCaptionDescriptionsTypeDef],
        "ContainerSettings": ClientUpdatePresetSettingsContainerSettingsTypeDef,
        "VideoDescription": ClientUpdatePresetSettingsVideoDescriptionTypeDef,
    },
    total=False,
)


class ClientUpdatePresetSettingsTypeDef(_ClientUpdatePresetSettingsTypeDef):
    """
    Type definition for `ClientUpdatePreset` `Settings`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
    caption settings in a single output.

      - *(dict) --* Caption Description for preset

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ClientUpdateQueueReservationPlanSettingsTypeDef = TypedDict(
    "_ClientUpdateQueueReservationPlanSettingsTypeDef",
    {"Commitment": str, "RenewalType": str, "ReservedSlots": int},
)


class ClientUpdateQueueReservationPlanSettingsTypeDef(
    _ClientUpdateQueueReservationPlanSettingsTypeDef
):
    """
    Type definition for `ClientUpdateQueue` `ReservationPlanSettings`

    - **Commitment** *(string) --* **[REQUIRED]** The length of the term of your reserved queue
    pricing plan commitment.

    - **RenewalType** *(string) --* **[REQUIRED]** Specifies whether the term of your reserved queue
    pricing plan is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.
    When your term is auto renewed, you extend your commitment by 12 months from the auto renew
    date. You can cancel this commitment.

    - **ReservedSlots** *(integer) --* **[REQUIRED]** Specifies the number of reserved transcode
    slots (RTS) for this queue. The number of RTS determines how many jobs the queue can process in
    parallel; each RTS can process one job at a time. You can't decrease the number of RTS in your
    reserved queue. You can increase the number of RTS by extending your existing commitment with a
    new 12-month commitment for the larger number. The new commitment begins when you purchase the
    additional capacity. You can't cancel your commitment or revert to your original commitment
    after you increase the capacity.
    """


_ClientUpdateQueueResponseQueueReservationPlanTypeDef = TypedDict(
    "_ClientUpdateQueueResponseQueueReservationPlanTypeDef",
    {
        "Commitment": str,
        "ExpiresAt": datetime,
        "PurchasedAt": datetime,
        "RenewalType": str,
        "ReservedSlots": int,
        "Status": str,
    },
    total=False,
)


class ClientUpdateQueueResponseQueueReservationPlanTypeDef(
    _ClientUpdateQueueResponseQueueReservationPlanTypeDef
):
    """
    Type definition for `ClientUpdateQueueResponseQueue` `ReservationPlan`

    - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
    commitment.

    - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing plan
    term for this reserved queue expires.

    - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the current
    pricing plan for this reserved queue.

    - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing plan
    is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

    - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS) for
    this queue. The number of RTS determines how many jobs the queue can process in parallel; each
    RTS can process one job at a time. When you increase this number, you extend your existing
    commitment with a new 12-month commitment for a larger number of RTS. The new commitment begins
    when you purchase the additional capacity. You can't decrease the number of RTS in your reserved
    queue.

    - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is ACTIVE
    or EXPIRED.
    """


_ClientUpdateQueueResponseQueueTypeDef = TypedDict(
    "_ClientUpdateQueueResponseQueueTypeDef",
    {
        "Arn": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "PricingPlan": str,
        "ProgressingJobsCount": int,
        "ReservationPlan": ClientUpdateQueueResponseQueueReservationPlanTypeDef,
        "Status": str,
        "SubmittedJobsCount": int,
        "Type": str,
    },
    total=False,
)


class ClientUpdateQueueResponseQueueTypeDef(_ClientUpdateQueueResponseQueueTypeDef):
    """
    Type definition for `ClientUpdateQueueResponse` `Queue`

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for when you created the queue.

    - **Description** *(string) --* An optional description that you create for each queue.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds for when you most recently
    updated the queue.

    - **Name** *(string) --* A name that you create for each queue. Each name must be unique within
    your account.

    - **PricingPlan** *(string) --* Specifies whether the pricing plan for the queue is on-demand or
    reserved. For on-demand, you pay per minute, billed in increments of .01 minute. For reserved,
    you pay for the transcoding capacity of the entire queue, regardless of how much or how little
    you use it. Reserved pricing requires a 12-month commitment.

    - **ProgressingJobsCount** *(integer) --* The estimated number of jobs with a PROGRESSING
    status.

    - **ReservationPlan** *(dict) --* Details about the pricing plan for your reserved queue.
    Required for reserved queues and not applicable to on-demand queues.

      - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
      commitment.

      - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing
      plan term for this reserved queue expires.

      - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the
      current pricing plan for this reserved queue.

      - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing plan
      is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

      - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS) for
      this queue. The number of RTS determines how many jobs the queue can process in parallel; each
      RTS can process one job at a time. When you increase this number, you extend your existing
      commitment with a new 12-month commitment for a larger number of RTS. The new commitment
      begins when you purchase the additional capacity. You can't decrease the number of RTS in your
      reserved queue.

      - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is
      ACTIVE or EXPIRED.

    - **Status** *(string) --* Queues can be ACTIVE or PAUSED. If you pause a queue, the service
    won't begin processing jobs in that queue. Jobs that are running when you pause the queue
    continue to run until they finish or result in an error.

    - **SubmittedJobsCount** *(integer) --* The estimated number of jobs with a SUBMITTED status.

    - **Type** *(string) --* Specifies whether this on-demand queue is system or custom. System
    queues are built in. You can't modify or delete system queues. You can create and modify custom
    queues.
    """


_ClientUpdateQueueResponseTypeDef = TypedDict(
    "_ClientUpdateQueueResponseTypeDef",
    {"Queue": ClientUpdateQueueResponseQueueTypeDef},
    total=False,
)


class ClientUpdateQueueResponseTypeDef(_ClientUpdateQueueResponseTypeDef):
    """
    Type definition for `ClientUpdateQueue` `Response`

    - **Queue** *(dict) --* You can use queues to manage the resources that are available to your
    AWS account for running multiple transcoding jobs at the same time. If you don't specify a
    queue, the service sends all jobs through the default queue. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/working-with-queues.html.

      - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

      - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for when you created the queue.

      - **Description** *(string) --* An optional description that you create for each queue.

      - **LastUpdated** *(datetime) --* The timestamp in epoch seconds for when you most recently
      updated the queue.

      - **Name** *(string) --* A name that you create for each queue. Each name must be unique
      within your account.

      - **PricingPlan** *(string) --* Specifies whether the pricing plan for the queue is on-demand
      or reserved. For on-demand, you pay per minute, billed in increments of .01 minute. For
      reserved, you pay for the transcoding capacity of the entire queue, regardless of how much or
      how little you use it. Reserved pricing requires a 12-month commitment.

      - **ProgressingJobsCount** *(integer) --* The estimated number of jobs with a PROGRESSING
      status.

      - **ReservationPlan** *(dict) --* Details about the pricing plan for your reserved queue.
      Required for reserved queues and not applicable to on-demand queues.

        - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
        commitment.

        - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing
        plan term for this reserved queue expires.

        - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the
        current pricing plan for this reserved queue.

        - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing
        plan is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

        - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS)
        for this queue. The number of RTS determines how many jobs the queue can process in
        parallel; each RTS can process one job at a time. When you increase this number, you extend
        your existing commitment with a new 12-month commitment for a larger number of RTS. The new
        commitment begins when you purchase the additional capacity. You can't decrease the number
        of RTS in your reserved queue.

        - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is
        ACTIVE or EXPIRED.

      - **Status** *(string) --* Queues can be ACTIVE or PAUSED. If you pause a queue, the service
      won't begin processing jobs in that queue. Jobs that are running when you pause the queue
      continue to run until they finish or result in an error.

      - **SubmittedJobsCount** *(integer) --* The estimated number of jobs with a SUBMITTED status.

      - **Type** *(string) --* Specifies whether this on-demand queue is system or custom. System
      queues are built in. You can't modify or delete system queues. You can create and modify
      custom queues.
    """


_DescribeEndpointsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeEndpointsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeEndpointsPaginatePaginationConfigTypeDef(
    _DescribeEndpointsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `DescribeEndpointsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_DescribeEndpointsPaginateResponseEndpointsTypeDef = TypedDict(
    "_DescribeEndpointsPaginateResponseEndpointsTypeDef", {"Url": str}, total=False
)


class DescribeEndpointsPaginateResponseEndpointsTypeDef(
    _DescribeEndpointsPaginateResponseEndpointsTypeDef
):
    """
    Type definition for `DescribeEndpointsPaginateResponse` `Endpoints`

    - **Url** *(string) --* URL of endpoint
    """


_DescribeEndpointsPaginateResponseTypeDef = TypedDict(
    "_DescribeEndpointsPaginateResponseTypeDef",
    {"Endpoints": List[DescribeEndpointsPaginateResponseEndpointsTypeDef]},
    total=False,
)


class DescribeEndpointsPaginateResponseTypeDef(_DescribeEndpointsPaginateResponseTypeDef):
    """
    Type definition for `DescribeEndpointsPaginate` `Response`

    - **Endpoints** *(list) --* List of endpoints

      - *(dict) --* Describes an account-specific API endpoint.

        - **Url** *(string) --* URL of endpoint
    """


_ListJobTemplatesPaginatePaginationConfigTypeDef = TypedDict(
    "_ListJobTemplatesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListJobTemplatesPaginatePaginationConfigTypeDef(
    _ListJobTemplatesPaginatePaginationConfigTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_ListJobTemplatesPaginateResponseJobTemplatesAccelerationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesAccelerationSettingsTypeDef",
    {"Mode": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesAccelerationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesAccelerationSettingsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplates` `AccelerationSettings`

    - **Mode** *(string) --* Specify the conditions when the service will run your job with
    accelerated transcoding.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsAvailBlankingTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsAvailBlankingTypeDef",
    {"AvailBlankingImage": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsAvailBlankingTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsEsam`
    `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsEsam`
    `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputs`
    `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectors`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputs`
    `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectors`
    `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputs`
    `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCropTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCropTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCropTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsInputClippingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputs`
    `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsPositionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsPositionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsPositionTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str,
            ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorGroupsTypeDef,
        ],
        "AudioSelectors": Dict[
            str, ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsAudioSelectorsTypeDef
        ],
        "CaptionSelectors": Dict[
            str, ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCaptionSelectorsTypeDef
        ],
        "Crop": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DenoiseFilter": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsImageInserterTypeDef,
        "InputClippings": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsInputClippingsTypeDef
        ],
        "Position": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserter`
    `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserter`
    `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsNielsenConfigurationTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettings`
    `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroups`
    `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputs`
    `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputs`
    `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputs`
    `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettings`
    `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputs`
    `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescription`
    `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for
    `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputs`
    `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsOutputsTypeDef
        ],
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsTimecodeConfigTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsTimecodeConfigTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertion`
    `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplatesSettings`
    `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ListJobTemplatesPaginateResponseJobTemplatesSettingsTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ListJobTemplatesPaginateResponseJobTemplatesSettingsAvailBlankingTypeDef,
        "Esam": ListJobTemplatesPaginateResponseJobTemplatesSettingsEsamTypeDef,
        "Inputs": List[ListJobTemplatesPaginateResponseJobTemplatesSettingsInputsTypeDef],
        "MotionImageInserter": ListJobTemplatesPaginateResponseJobTemplatesSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ListJobTemplatesPaginateResponseJobTemplatesSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[
            ListJobTemplatesPaginateResponseJobTemplatesSettingsOutputGroupsTypeDef
        ],
        "TimecodeConfig": ListJobTemplatesPaginateResponseJobTemplatesSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ListJobTemplatesPaginateResponseJobTemplatesSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesSettingsTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesSettingsTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponseJobTemplates` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
    job. There can only be one input in a job template. Using the API, you can include multiple
    inputs when referencing a job template.

      - *(dict) --* Specified video input in a template.

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ListJobTemplatesPaginateResponseJobTemplatesTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseJobTemplatesTypeDef",
    {
        "AccelerationSettings": ListJobTemplatesPaginateResponseJobTemplatesAccelerationSettingsTypeDef,
        "Arn": str,
        "Category": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "Priority": int,
        "Queue": str,
        "Settings": ListJobTemplatesPaginateResponseJobTemplatesSettingsTypeDef,
        "StatusUpdateInterval": str,
        "Type": str,
    },
    total=False,
)


class ListJobTemplatesPaginateResponseJobTemplatesTypeDef(
    _ListJobTemplatesPaginateResponseJobTemplatesTypeDef
):
    """
    Type definition for `ListJobTemplatesPaginateResponse` `JobTemplates`

    - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
    with long, visually complex content.

      - **Mode** *(string) --* Specify the conditions when the service will run your job with
      accelerated transcoding.

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **Category** *(string) --* An optional category you create to organize your job templates.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for Job template creation.

    - **Description** *(string) --* An optional description you create for each job template.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the Job template was last
    updated.

    - **Name** *(string) --* A name you create for each job template. Each name must be unique
    within your account.

    - **Priority** *(integer) --* Relative priority on the job.

    - **Queue** *(string) --* Optional. The queue that jobs created from this template are assigned
    to. If you don't specify this, jobs will go to the default queue.

    - **Settings** *(dict) --* JobTemplateSettings contains all the transcode settings saved in the
    template that will be applied to jobs created from it.

      - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
      the input Ad Avail PTS time.

      - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
      overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

        - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
        black. Only bmp and png images are supported.

      - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

        - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
        ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
        uses the manifest conditioning instructions that you provide in the setting MCC XML
        (mccXml).

          - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
          document inside your JSON job settings. Form the XML document as per
          OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions
          in the message that you supply.

        - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
        between the SCTE 35 messages that the transcoder places and the splice points that they
        refer to. If the time between the start of the asset and the SCTE-35 message is less than
        this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

        - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
        SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
        signal processing instructions that you provide in the setting SCC XML (sccXml).

          - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
          inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
          transcoder will use the signal processing instructions in the message that you supply.
          Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
          For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
          insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
          (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
          passthrough. You can't do both.

      - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the transcode
      job. There can only be one input in a job template. Using the API, you can include multiple
      inputs when referencing a job template.

        - *(dict) --* Specified video input in a template.

          - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
          combine. An input may have multiple audio selector groups. See "Audio Selector
          Group":#inputs-audio_selector_group for more information.

            - *(string) --*

              - *(dict) --* Group of Audio Selectors

                - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
                to include in the group. Audio selector names are standardized, based on their order
                within the input (e.g., "Audio Selector 1"). The audio selector name parameter can
                be repeated to add any number of audio selectors to the group.

                  - *(string) --*

          - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
          or set of tracks from the input that you will use in your outputs. You can use mutiple
          Audio selectors per input.

            - *(string) --*

              - *(dict) --* Selector for Audio

                - **CustomLanguageCode** *(string) --* Selects a specific language code from within
                an audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                set it as the default for the job. The service uses this default for outputs where
                it can't find the specified input audio. If you don't set a default, those outputs
                have no audio.

                - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                file source.

                - **LanguageCode** *(string) --* Selects a specific language code from within an
                audio source.

                - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                audio from the input video.

                - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
                selects PID 0x101).

                  - *(integer) --*

                - **ProgramSelection** *(integer) --* Use this setting for input streams that
                contain Dolby E, to have the service extract specific program data from the track.
                To select multiple programs, create multiple selectors with the same Track and
                different Program numbers. In the console, this setting is visible when you set
                Selector type to Track. Choose the program number from the dropdown list. If you are
                sending a JSON file, provide the program ID, which is part of the audio metadata. If
                your input file has incorrect metadata, you can choose All channels instead of a
                program number to have the service ignore the program IDs and include all the
                programs in the track.

                - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
                one input to match those of another input. This allows you to combine the two files
                into a single output, one after the other.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **SelectorType** *(string) --* Specifies the type of the audio selector.

                - **Tracks** *(list) --* Identify a track from the input audio to include in this
                selector by entering the track index number. To include several tracks in a single
                audio selector, specify multiple tracks as follows. Using the console, enter a
                comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                Specifying directly in your JSON job file, provide the track numbers in an array.
                For example, "tracks": [1,2,3].

                  - *(integer) --*

          - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
          the captions data from the input that you will use in your outputs. You can use mutiple
          captions selectors per input.

            - *(string) --*

              - *(dict) --* Set up captions in your outputs by first selecting them from your input
              here.

                - **CustomLanguageCode** *(string) --* The specific language to extract from source,
                using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
                complete this field and/or PID to select the caption language to extract. If input
                is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
                select the caption language to extract. If input is DVB-Sub that is being passed
                through, omit this field (and PID field); there is no way to extract a specific
                language with pass-through captions.

                - **LanguageCode** *(string) --* The specific language to extract from source. If
                input is SCTE-27, complete this field and/or PID to select the caption language to
                extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
                and/or PID to select the caption language to extract. If input is DVB-Sub that is
                being passed through, omit this field (and PID field); there is no way to extract a
                specific language with pass-through captions.

                - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                    number in the ancillary data track from which to extract captions. Unused for
                    passthrough.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                    PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content
                    is passed through, regardless of selectors.

                  - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                    within the video track from which to extract captions. Unused for passthrough.

                    - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                    for extracting captions. The system only supports one input video track, so this
                    should always be set to '1'.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                  STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source
                  file. If your caption source is IMSC in an IMF package, use TrackSourceSettings
                  instead of FileSoureSettings.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceFile** *(string) --* External caption file used for loading captions.
                    Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                    'smi'.

                    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                    captions from the source file.

                  - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                  your input captions. The service cannot auto-detect caption format.

                  - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                  sources, including Page number.

                    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                    three-digit hexadecimal page number that will be used for Teletext captions. Do
                    not use this setting if you are passing through teletext from the input source
                    to output.

                  - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                  are specified by track number. Currently, this is only IMSC captions in an IMF
                  package. If your caption source is IMSC 1.1 in a separate xml file, use
                  FileSourceSettings instead of TrackSourceSettings.

                    - **TrackNumber** *(integer) --* Use this setting to select a single captions
                    track from a source. Track numbers correspond to the order in the captions
                    source file. For IMF sources, track numbering is based on the order that the
                    captions appear in the CPL. For example, use 1 to select the captions asset that
                    is listed first in the CPL. To include more than one captions track in your job
                    outputs, create multiple input captions selectors. Specify one track per
                    selector.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame. If you specify a value here, it will
          override any value that you specify in the output setting Cropping selection (crop).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
          motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
          uncompressed video inputs.

          - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
          the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
          video inputs.

          - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
          transcoding service applies the denoise and deblock filters. You must also enable the
          filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
          Auto - The transcoding service determines whether to apply filtering, depending on input
          type and quality. * Disable - The input is not filtered. This is true even if you use the
          API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put
          is filtered regardless of input type.

          - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
          magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
          is 0.

          - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
          overlay on your video. Enable or disable this feature for each input individually. This
          setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
          that together specify a portion of the input to be used in the outputs. If you provide
          only a start time, the clip will be the entire input from that point to the end. If you
          provide only an end time, it will be the entire input up to that point. When you specify
          more than one input clip, the transcoding service creates the job outputs by stringing the
          clips together in the order you specify them.

            - *(dict) --* To transcode only portions of your input (clips), include one Input
            clipping (one instance of InputClipping in the JSON job file) for each input clip. All
            input clips you specify will be included in every output of the job.

              - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
              portion of the input you are clipping. The frame corresponding to the End timecode
              value is included in the clip. Start timecode or End timecode may be left blank, but
              not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
              minute, SS is the second, and FF is the frame number. When choosing this value, take
              into account your setting for timecode source under input settings
              (InputTimecodeSource). For example, if you have embedded timecodes that start at
              01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

              - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning
              of the portion of the input you are clipping. The frame corresponding to the Start
              timecode value is included in the clip. Start timecode or End timecode may be left
              blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour,
              MM is the minute, SS is the second, and FF is the frame number. When choosing this
              value, take into account your setting for Input timecode source. For example, if you
              have embedded timecodes that start at 01:00:00:00 and you want your clip to begin five
              minutes into the video, use 01:05:00:00.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black. If
          you specify a value here, it will override any value that you specify in the output
          setting Selection placement (position). If you specify a value here, this will override
          any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
          (RESPOND). If you specify a value here, this will ignore anything that you specify for the
          setting Scaling Behavior (scalingBehavior).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
          program from within a multi-program transport stream. Note that Quad 4K is not currently
          supported. Default is the first program within the transport stream. If the program you
          specify doesn't exist, the transcoding service will use this default.

          - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
          inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for
          audio and video. * Use PSI - Scan only PSI data.

          - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
          input settings (InputTimecodeSource), to specify how the service counts input video
          frames. This input frame count affects only the behavior of features that apply to a
          single input at a time, such as input clipping and synchronizing some captions formats.
          Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at zero
          (ZEROBASED) to start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to
          start the first frame at the timecode that you specify in the setting Start timecode
          (timecodeStart). If you don't specify a value for Timecode source, the service will use
          Embedded by default. For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
          for this input's initial frame. To use this setting, you must set the Timecode source
          setting, located under the input settings (InputTimecodeSource), to Specified start
          (SPECIFIEDSTART). For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **VideoSelector** *(dict) --* Selector for video.

            - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
            animation. Specify which part of this input MediaConvert uses for your outputs. Leave
            this setting set to DISCARD in order to delete the alpha channel and preserve the video.
            Use REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the
            luma channel of your outputs.

            - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
            if you don't know about color space, leave this set to the default value Follow
            (FOLLOW). The service will automatically detect your input color space. If your input
            video has metadata indicating the wrong color space, specify the accurate color space
            here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume
            static metadata isn't present in your video stream, or if that metadata is present but
            not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the
            input HDR 10 metadata (Hdr10Metadata) settings. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
            file and the job input settings Color space (ColorSpace) and HDR master display
            information settings(Hdr10Metadata). The Color space usage setting determines which
            takes precedence. Choose Force (FORCE) to use color metadata from the input job
            settings. If you don't specify values for those settings, the service defaults to using
            metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata
            from the source when it is present. If there's no color metadata in your input file, the
            service defaults to using values you specify in the input settings.

            - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
            missing or inaccurate in your input video. Appropriate values vary depending on the
            input video and must be provided by a color grader. The color grader generates these
            values during the HDR 10 mastering process. The valid range for each of these settings
            is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
            settings - When you specify these values, you must also set Color space (ColorSpace) to
            HDR 10 (HDR10). To specify whether the the values you specify here take precedence over
            the values in the metadata of your input file, set Color space usage (ColorSpaceUsage).
            To specify whether color metadata is included in an output, set Color metadata
            (ColorMetadata). For more information about MediaConvert HDR jobs, see
            https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
            Specify this value as an integer; the system automatically converts it to the
            hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
            an identifier for a set of data in an MPEG-2 transport stream container.

            - **ProgramNumber** *(integer) --* Selects a specific program from within a
            multi-program transport stream. Note that Quad 4K is not currently supported.

            - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
            your video. You can choose automatic rotation or specify a rotation. You can specify a
            clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov
            or .mp4 and your input has rotation metadata, you can choose Automatic to have the
            service rotate your video according to the rotation specified in the metadata. The
            rotation must be within one degree of 90, 180, or 270 degrees. If the rotation metadata
            specifies any other rotation, the service will default to no rotation. By default, the
            service does no rotation, even if your input video has rotation metadata. The service
            doesn't pass through rotation metadata.

      - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
      graphics that you specify here appear on all outputs in all output groups.

        - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
        unspecified. If your motion graphic asset is a series of .png files, specify the frame rate
        of the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1.
        Make sure that the number of images in your series matches the frame rate and your intended
        overlay duration. For example, if you want a 30-second overlay at 30 fps, you should have
        900 .png images. This overlay frame rate doesn't need to match the frame rate of the
        underlying video.

          - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

          - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

        - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
        overlay on your video. For .png files, provide the file name of the first file in the
        series. Make sure that the names of the .png files end with sequential numbers that specify
        the order that they are played in. For example, overlay_000.png, overlay_001.png,
        overlay_002.png, and so on. The sequence must start at zero, and each image file name must
        have the same number of digits. Pad your initial file names with enough zeros to complete
        the sequence. For example, if the first image is overlay_0.png, there can be only 10 images
        in the sequence, with the last image being overlay_9.png. But if the first image is
        overlay_00.png, there can be 100 images in the sequence.

        - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
        providing for your overlay. You can choose either a .mov file or a series of .png files.

        - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay
        on the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
        specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
        the service inserts the overlay at its native resolution and scales the size up or down with
        any video scaling.

          - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
          edge of the video frame.

          - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
          edge of the video frame.

        - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
        or plays only once.

        - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
        (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
        account how you have set up your timecode configuration under both job settings and input
        settings. The simplest way to do that is to set both to start at 0. If you need to set up
        your job to follow timecodes embedded in your source that don't start at zero, make sure
        that you specify a start time that is after the first embedded timecode. For more
        information, see https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html
        Find job-wide and input timecode configuration settings in your JSON job settings
        specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

      - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
      do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
      configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs
      in the job. To enable Nielsen configuration programmatically, include an instance of
      nielsenConfiguration in your JSON job specification. Even if you don't include any children of
      nielsenConfiguration, you still enable the setting.

        - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
        functionality. If you must include this property, set the value to zero.

        - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
        distributor ID that is assigned to your organization by Neilsen.

      - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
      outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
      MXF, and no container) are grouped in a single output group as well. Required in
      (OutputGroups) is a group of settings that apply to the whole group. This required object
      depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
      settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
      HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
      MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

        - *(dict) --* Group of outputs

          - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
          the output group. This value is displayed on the console and can make your job settings
          JSON more human-readable. It does not affect your outputs. Use up to twelve characters
          that are either letters, numbers, spaces, or underscores.

          - **Name** *(string) --* Name of the output group

          - **OutputGroupSettings** *(dict) --* Output Group settings, including type

            - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
            Output Group may only contain a single video, audio, or caption output.

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
              your job. These default manifests reference every output in the output group. To
              create additional top-level manifests that reference a subset of the outputs in the
              output group, specify a list of them here. For each additional manifest that you
              specify, the service creates one HLS manifest and one DASH manifest.

                - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
                that you want the service to generate for this CMAF output group. Each pair of
                manifests can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
              at the top level BaseURL element. Can be used if streams are delivered from a
              different URL than the manifest file.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
                service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                (SAMPLE-AES) or AES_CTR (AES-CTR).

                - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                outputs, choose whether the service writes the 128-bit encryption initialization
                vector in the HLS and DASH manifests.

                - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                  signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                  package. The DASH manifest can currently signal up to three system IDs. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                  signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                  package. The HLS manifest can currently signal only one system ID. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
              of each individual CMAF segment. This value applies to the whole package; that is, to
              every output in the output group. Note that segments end on the first keyframe after
              this number of seconds, so the actual segment length might be slightly longer. If you
              set Segment control (CmafSegmentControl) to single file, the service puts the content
              of each output in a single file that has metadata that marks these segments. If you
              set it to segmented files, the service creates multiple files for each output, each
              with the content of one segment.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
              generated for this output.

              - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
              be generated for this output.

            - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
              manifest for each DASH ISO output group in your job. This default manifest references
              every output in the output group. To create additional DASH manifests that reference a
              subset of the outputs in the output group, specify a list of them here.

                - *(dict) --* Specify the details for each additional DASH manifest that you want
                the service to generate for this output group. Each manifest can reference a
                different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.mpd.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
              (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
              from a different URL than the manifest file.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                compatibility of your output with video players on obsolete devices. It applies only
                to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
                only to correct problems with playback on older devices. Otherwise, keep the default
                setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the
                service will exclude the access unit delimiter and will leave the SEI NAL units
                unencrypted.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
              that segments will end on the next keyframe after this number of seconds, so actual
              segment length may be longer. When Emit Single File is checked, the segmentation is
              internal to a single output file and it does not cause the creation of many output
              files as in other output types.

              - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
              the 400 range when you play back your DASH output, enable this setting and run your
              transcoding job again. When you enable this setting, the service writes precise
              segment durations in the DASH manifest. The segment duration information appears
              inside the SegmentTimeline element, inside SegmentTemplate at the Representation
              level. When you don't enable this setting, the service writes approximate segment
              durations in your DASH manifest.

            - **FileGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

            - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

              - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
              HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
              outputs themselves.

                - *(string) --*

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest for each HLS output group in your job. This default manifest
              references every output in the output group. To create additional top-level manifests
              that reference a subset of the outputs in the output group, specify a list of them
              here.

                - *(dict) --* Specify the details for each additional HLS manifest that you want the
                service to generate for this output group. Each manifest can reference a different
                subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
              in the media .m3u8 file. Can be used if base manifest is delivered from a different
              URL than the main .m3u8 file.

              - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                - *(dict) --* Caption Language Mapping

                  - **CaptionChannel** *(integer) --* Caption channel.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                  - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                  three-letter code listed at
                  https://www.loc.gov/standards/iso639-2/php/code_list.php.

                  - **LanguageDescription** *(string) --* Caption language description.

              - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
              captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one
              language in the CC1 Language Code field. One CLOSED-CAPTION line is added for each
              Language Code you specify. Make sure to specify the languages in the order in which
              they appear in the original source (if the source is embedded format) or the order of
              the caption selectors (if the source is other than embedded). Otherwise, languages in
              the manifest will not match up properly with the output captions. None: Include
              CLOSED-CAPTIONS=
                  NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from
              the manifest.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
              subdirectories.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
                scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
                disables encryption.

                - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                128-bit number used in conjunction with the key for encrypting blocks. If set to
                INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                Vector is not in the manifest.

                - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                HLS FairPlay content protection.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
              looking ahead and back within the specified range for a nearby avail and extending the
              segment size if needed.

              - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
              be generated for this HLS output group.

              - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
              in .m3u8 manifest files. The value is calculated as follows: either the program date
              and time are initialized using the input timecode source, or the time is initialized
              using the input timecode source and the date is initialized using the
              timestamp_offset.

              - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
              EXT-X-PROGRAM-DATE-TIME entry, in seconds.

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
              media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

              - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
              create (in seconds). Note that segments will end on the next keyframe after this
              number of seconds, so actual segment length may be longer.

              - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
              subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
              for this setting to have an effect.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

              - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

              - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
              offset to fine tune the timestamps.

            - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .ism
              Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
              in your job. This default manifest references every output in the output group. To
              create additional manifests that reference a subset of the outputs in the output
              group, specify a list of them here.

                - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                manifest that you want the service to generate for this output group. Each manifest
                can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                  "-no-premium" for this setting, then the file name the service generates for this
                  top-level manifest is film-name-no-premium.ismv.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
              audio encoding settings across a Microsoft Smooth output group into a single audio
              stream.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* If you are using DRM, set DRM System
              (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
              the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
              and frame rate.

              - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding)
              to specify the encoding format for the server and client manifest. Valid options are
              utf8 and utf16.

            - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
            Microsoft Smooth Streaming, CMAF)

          - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
          settings per output.

            - *(dict) --* An output object describes the settings for a single output file or stream
            in an output group.

              - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
              encoding settings organized by audio codec. Include one instance of
              (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
              encoding settings.

                - *(dict) --* Description of audio output

                  - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                  settings. Ignore these settings unless you need to comply with a loudness
                  standard.

                    - **Algorithm** *(string) --* Choose one of the following audio normalization
                    algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                    loudness for an entire piece of content, suitable for measurement of short-form
                    content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-2: Gated loudness. A measurement of gated average loudness compliant
                    with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
                    with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
                    Allows for more audio channels than the other algorithms, including
                    configurations such as 7.1.

                    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                    using the chosen algorithm. If disabled, the audio will be measured but not
                    adjusted.

                    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                    be corrected to the target level. Content measuring below this level will not be
                    corrected. Gating only applies when not using real_time_correction.

                    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                    loudness to a CSV file.

                    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                    TruePeak for each output's audio track loudness.

                    - **TargetLkfs** *(float) --* When you use Audio normalization
                    (AudioNormalizationSettings), optionally use this setting to specify a target
                    loudness. If you don't specify a value here, the encoder chooses a value for
                    you, based on the algorithm that you choose for Algorithm (algorithm). If you
                    choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                    encoder will choose -23 LKFS.

                  - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                  input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                  name based on its order within each input. For example if you specify "Audio
                  Selector 3", then the third audio selector will be used from each input. If an
                  input does not have an "Audio Selector 3", then the audio selector marked as
                  "default" in that input will be used. If there is no audio selector marked as
                  "default", silence will be inserted for the duration of that input. Alternatively,
                  an "Audio Selector Group":#inputs-audio_selector_group name may be specified, with
                  similar default/silence behavior. If no audio_source_name is specified, then
                  "Audio Selector 1" will be chosen automatically.

                  - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                  unchecked (false). A number between 0 and 255. The following are defined in
                  ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                       Hearing Impaired, 3 =
                  Visually Impaired Commentary, 4-255 = Reserved.

                  - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                  contains an ISO 639 audio_type, then that value is passed through to the output.
                  If the input contains no ISO 639 audio_type, the value in Audio Type is included
                  in the output. Otherwise the value in Audio Type is included in the output. Note
                  that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                  is set to BROADCASTER_MIXED_AD.

                  - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                  (AudioDescriptions) contains the group of settings related to audio encoding. The
                  settings in this group vary depending on the value that you choose for Audio codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * AAC,
                  AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                  Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                    - **AacSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                    two mutually exclusive groups of AAC settings--VBR and CBR. To select one of
                    these modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or
                    "CBR". In VBR mode, you control the audio quality with the setting VBR quality
                    (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                    valid values depend on the rate control mode.

                      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                      when the input contains pre-mixed main audio + audio description (AD) as a
                      stereo pair. The value for AudioType will be set to 3, which signals to
                      downstream systems that this stream contains "broadcaster mixed AD". Note that
                      the input received by the encoder must contain pre-mixed audio; the encoder
                      does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                      ignores any values you provide in AudioType and FollowInputAudioType. Choose
                      NORMAL when the input does not contain pre-mixed audio + audio description
                      (AD). In this case, the encoder will use any values you provide for AudioType
                      and FollowInputAudioType.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      The set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000,
                      16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000,
                      112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000,
                      448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you set is
                      also constrained by the values that you choose for Profile (codecProfile),
                      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
                      values depend on Bitrate control mode and Profile.

                      - **CodecProfile** *(string) --* AAC Profile.

                      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                      channel layout. Valid values depend on rate control mode and profile. "1.0 -
                      Audio Description (Receiver Mix)" setting receives a stereo description plus
                      control track and emits a mono AAC encode of the description track, with
                      control data emitted in the PES header as per ETSI TS 101 154 Annex E.

                      - **RateControlMode** *(string) --* Rate Control Mode.

                      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                      use LATM/LOAS AAC in an output, you must choose "No container" for the output
                      container.

                      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                      control mode and profile.

                      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                      for raw or MPEG-2 Transport Stream containers.

                      - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                      rate_control_mode is VBR.

                    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AC3.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                      stream that the encoder emits. For more information about the AC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital, dialnorm will be passed through.

                      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                      adds dynamic range compression signaling to the output bitstream as defined in
                      the Dolby Digital specification.

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                    - **AiffSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AIFF.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **Codec** *(string) --* Type of Audio codec.

                    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid values: 384k, 448k, 640k, 768k

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                      (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                      adjust loudness based on dialogue analysis.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                      this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix
                      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                      value -60 mutes the channel.

                      - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                      your audio.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                      that must be speech before the encoder uses the measured speech loudness as
                      the overall program loudness.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing.

                      - **SurroundExMode** *(string) --* Specify whether your input audio has an
                      additional center rear surround channel matrix encoded into your left and
                      right surround channels.

                    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3.

                      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                      dB attenuation to the surround channels. Only used for 3/2 coding mode.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                      number of channels.

                      - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital Plus, dialnorm will be passed through.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                      LFE channel is enabled

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left only/Right only center (loRoCenterMixLevel).

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                      channel. This setting applies only if you keep the default value of 3/2 - L,
                      R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                      If you choose a different value for Coding mode, the service ignores Left
                      only/Right only surround (loRoSurroundMixLevel).

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total center (ltRtCenterMixLevel).

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                      surround). MediaConvert uses this value for downmixing. How the service uses
                      this value depends on the value that you choose for Stereo downmix
                      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
                      -60 mutes the channel. This setting applies only if you keep the default value
                      of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total surround (ltRtSurroundMixLevel).

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                      audio will be passed through if it is present on the input. this detection is
                      dynamic over the life of the transcode. Inputs that alternate between DD+ and
                      non-DD+ content will have a consistent DD+ output as the system alternates
                      between passthrough and encoding.

                      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                      the surround channels. Only used for 3/2 coding mode.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing. This setting only applies if you keep the default value of 3/2 -
                      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Stereo downmix (Eac3StereoDownmix).

                      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                      extra center back surround channel is matrix encoded into the left and right
                      surround channels.

                      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                      Surround is matrix encoded into the two channels.

                    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value MP2.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                      - **Channels** *(integer) --* Set Channels to specify the number of channels
                      in this output audio track. Choosing Mono in the console will give you 1
                      output channel; choosing Stereo will give you 2. In the API, valid values are
                      1 and 2.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **WavSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value WAV.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                      If your output audio is likely to exceed 4 GB in file size, or if you
                      otherwise need the extended support of the RF64 format, set your output WAV
                      file format to RF64.

                      - **SampleRate** *(integer) --* Sample rate in Hz.

                  - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                  track. The service puts this language code into your output audio track when you
                  set Language code control (AudioLanguageCodeControl) to Use configured
                  (USE_CONFIGURED). The service also uses your specified custom language code when
                  you set Language code control (AudioLanguageCodeControl) to Follow input
                  (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                  outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                  can also use any other code in the full RFC-5646 specification. Streaming outputs
                  are those that are in one of the following output groups: CMAF, DASH ISO, Apple
                  HLS, or Microsoft Smooth Streaming.

                  - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                  The ISO 639 language specified in the 'Language Code' drop down will be used when
                  'Follow Input Language Code' is not selected or when 'Follow Input Language Code'
                  is selected but there is no ISO 639 language code specified by the input.

                  - **LanguageCodeControl** *(string) --* Specify which source for language code
                  takes precedence for this audio track. When you choose Follow input
                  (FOLLOW_INPUT), the service uses the language code from the input track if it's
                  present. If there's no languge code on the input track, the service uses the code
                  that you specify in the setting Language code (languageCode or
                  customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service
                  uses the language code that you specify.

                  - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **StreamName** *(string) --* Specify a label for this output audio stream. For
                  example, "English", "Director commentary", or "track_2". For streaming outputs,
                  MediaConvert passes this information into destination manifests for display on the
                  end-viewer's player device. For outputs in other output groups, the service
                  ignores this setting.

              - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
              captions settings. For each output that has captions, include one instance of
              (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
              settings.

                - *(dict) --* Description of Caption output

                  - **CaptionSelectorName** *(string) --* Specifies which "Caption
                  Selector":#inputs-caption_selector to use from each input when generating
                  captions. The name should be of the format "Caption Selector ", which denotes that
                  the Nth Caption Selector will be used from each input.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  output track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information when automatically
                  selecting the font script for rendering the captions text. For all outputs, you
                  can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
                  any other code in the full RFC-5646 specification. Streaming outputs are those
                  that are in one of the following output groups: CMAF, DASH ISO, Apple HLS, or
                  Microsoft Smooth Streaming.

                  - **DestinationSettings** *(dict) --* Specific settings required by destination
                  type. Note that burnin_destination_settings are not available if the source of the
                  caption data is Embedded or Teletext.

                    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering burn-in captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **DestinationType** *(string) --* Specify the format for this set of captions
                    on this output. The default format is embedded without SCTE-20. Other options
                    are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                    web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                    (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec.
                    To create a non-compliant output where the embedded captions come first, choose
                    Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering DVB-Sub captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                      standard or for hearing impaired. Choose hearing impaired if your subtitles
                      include audio descriptions and dialogue. Choose standard if your subtitles
                      include only dialogue.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                    embedded/ancillary caption outputs, including 608/708 Channel destination
                    number.

                      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and your output captions are embedded in
                      the video stream. Specify a CC number for each captions channel in this
                      output. If you have two channels, choose CC numbers that aren't in the same
                      field. For example, choose 1 and 3. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and you want both 608 and 708 captions
                      embedded in your output stream. Optionally, specify the 708 service number for
                      each output captions channel. Choose a different number for each channel. To
                      use this setting, also set Force 608 to 708 upconvert (Convert608To708) to
                      Upconvert (UPCONVERT) in your input captions selector settings. If you choose
                      to upconvert but don't specify a 708 service number, MediaConvert uses the
                      number that you specify for CC channel number (destination608ChannelNumber)
                      for the 708 service number. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                    outputs.

                      - **StylePassthrough** *(string) --* Keep this setting enabled to have
                      MediaConvert use the font style and position information from the captions
                      source in the output. This option is available only when your input captions
                      are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                      output captions.

                    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                      sure that the captions and the video are synchronized in the output. Specify a
                      frame rate that matches the frame rate of the associated video. If the video
                      frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only
                      if the video has video_insertion=
                          true and drop_frame_timecode=true; otherwise,
                      choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                    output

                      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                      the destination captions for this output. This value must be a three-digit
                      hexadecimal string; strings ending in -FF are invalid. If you are passing
                      through the entire set of Teletext data, do not use this field.

                      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                      you don't specify a value here, the service sets the page type to the default
                      value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                      Teletext data, don't use this field. When you pass through a set of Teletext
                      pages, your output has the same page types as your input.

                        - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                        Table 94

                    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                    outputs, including Pass style information (TtmlStylePassthrough).

                      - **StylePassthrough** *(string) --* Pass through style and position
                      information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                      CFF-TT output or TTML output.

                  - **LanguageCode** *(string) --* Specify the language of this captions output
                  track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information to choose the font
                  language for rendering the captions text.

                  - **LanguageDescription** *(string) --* Specify a label for this set of output
                  captions. For example, "English", "Director commentary", or "track_2". For
                  streaming outputs, MediaConvert passes this information into destination manifests
                  for display on the end-viewer's player device. For outputs in other output groups,
                  the service ignores this setting.

              - **ContainerSettings** *(dict) --* Container specific settings.

                - **Container** *(string) --* Container for this output. Some containers require a
                container settings object. If not specified, the default object will be created.

                - **F4vSettings** *(dict) --* Settings for F4v container

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs
                in a File output group when the output's container (ContainerType) is MPEG-2
                Transport Stream (M2TS). In these assets, data is organized by the program map table
                (PMT). Each transport stream program contains subsets of data, including audio,
                video, and metadata. Each of these subsets of data has a numerical label called a
                packet identifier (PID). Each transport stream program corresponds to one
                MediaConvert output. The PMT lists the types of data in a program along with their
                PID. Downstream systems and players use the program map table to look up the PID for
                each type of data it accesses and then uses the PIDs to locate specific data within
                the asset.

                  - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                  models for Dolby Digital audio.

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                  elementary audio streams you include in this output. Specify multiple PIDs as a
                  JSON array. Default is the range 482-492.

                    - *(integer) --*

                  - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                  bits per second. Setting to 0 lets the muxer automatically determine the
                  appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                  - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                  interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                  this can lead to lower latency, but low-memory devices may not be able to play
                  back the stream without interruptions.

                  - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                  the specified table repetition interval.

                    - **NetworkId** *(integer) --* The numeric value placed in the Network
                    Information Table (NIT).

                    - **NetworkName** *(string) --* The network name text placed in the
                    network_name_descriptor inside the Network Information Table. Maximum length is
                    256 characters.

                    - **NitInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                  the specified table repetition interval.

                    - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                    output stream. "Follow input SDT" copies SDT information from input stream to
                    output stream. "Follow input SDT if present" copies SDT information from input
                    stream to output stream if SDT information is present in the input, otherwise it
                    will fall back on the user-defined values. Enter "SDT Manually" means user will
                    enter the SDT information. "No SDT" means output stream will not contain SDT
                    information.

                    - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **ServiceName** *(string) --* The service name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                    - **ServiceProviderName** *(string) --* The service provider name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                  - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                  subtitle data included in this output. Specify multiple PIDs as a JSON array.
                  Default is the range 460-479.

                    - *(integer) --*

                  - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                  specified table repetition interval.

                    - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                  teletext data you include in this output. Default is 499.

                  - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                  EBP markers will be added to partitions 3 and 4. The interval between these
                  additional markers will be fixed, and will be slightly shorter than the video EBP
                  marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                  inserted. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                  can either be placed only on the video PID, or on both the video PID and all audio
                  PIDs. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                  the PES header.

                  - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                  you know that your audio EBP markers are incorrectly appearing before your video
                  EBP markers. To correct this problem, set this value to Force (FORCE).

                  - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                  used with EBP markers.

                  - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                  between Program Clock References (PCRs) inserted into the transport stream.

                  - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                  Points do not come within the specified time interval of each other by looking
                  ahead at input video. If another EBP is going to come in within the specified time
                  interval, the current EBP is not emitted, and the segment is "stretched" to the
                  next marker. The lookahead value does not add latency to the system. The Live
                  Event must be configured elsewhere to create sufficient latency to make the
                  lookahead accurate.

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                  packets to insert into the transport stream. This can be used if a downstream
                  encryption system requires periodic null packets.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This is effective only when the PCR PID is the same as the video or audio
                  elementary stream.

                  - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                  clock reference (PCR) in this output. If you do not specify a value, the service
                  will use the value for Video PID (VideoPid).

                  - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                  instances of the program map table (PMT) in the output transport stream.

                  - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                  map table (PMT) itself. Default is 480.

                  - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                  private metadata stream. Default is 503.

                  - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                  the program number used in the program map table (PMT) for this output. Default is
                  1. Program numbers and program map tables are parts of MPEG-2 transport stream
                  containers, used for organizing data.

                  - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                  stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                  maximum bitrate, but the output will not be padded up to that bitrate.

                  - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                  markers in your HLS and transport stream outputs at the insertion points that you
                  specify in an ESAM XML document. Provide the document in the setting SCC XML
                  (sccXml).

                    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                    in the transport stream generated by ESAM.

                  - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                  stream in the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None
                  (NONE). Also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml). Also enable ESAM SCTE-35 (include the property
                  scte35Esam).

                  - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                  segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                  adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                  private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                  segments. ebp adds Encoder Boundary Point information to the adaptation field as
                  per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary
                  Point information to the adaptation field using a legacy proprietary format.

                  - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                  how segmentation markers are inserted into the transport stream. With avails, it
                  is possible that segments may be truncated, which can influence where future
                  segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                  selected and a segment is truncated due to an avail, we will reset the
                  segmentation cadence. This means the subsequent segment will have a duration of of
                  $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                  selected and a segment is truncated due to an avail, we will not reset the
                  segmentation cadence. This means the subsequent segment will likely be truncated
                  as well. However, all segments after that will have a duration of
                  $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
                  rule.

                  - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                  segment. Required unless markers is set to _none_.

                  - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                  timed metadata in this output. Default is 502.

                  - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                  itself in the program map table for this output. Transport stream IDs and program
                  map tables are parts of MPEG-2 transport stream containers, used for organizing
                  data.

                  - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                  elementary video stream in the transport stream.

                - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                  stream(s) in the transport stream. Multiple values are accepted, and can be
                  entered in ranges and/or by comma separation.

                    - *(integer) --*

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This parameter is effective only when the PCR PID is the same as the video or
                  audio elementary stream.

                  - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                  (PCR) in the transport stream. When no value is given, the encoder will assign the
                  same value as the Video PID.

                  - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                  (PMT) in the transport stream.

                  - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                  metadata stream in the transport stream.

                  - **ProgramNumber** *(integer) --* The value of the program number field in the
                  Program Map Table.

                  - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                  the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE)
                  if you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and
                  choose Ad markers (adMarkers) if you do want manifest conditioning. In both cases,
                  also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml).

                  - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                  specify whether the service inserts the ID3 timed metadata from the input in this
                  output.

                  - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                  metadata stream in the transport stream.

                  - **TransportStreamId** *(integer) --* The value of the transport stream ID field
                  in the Program Map Table.

                  - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                  stream in the transport stream.

                - **MovSettings** *(dict) --* Settings for MOV Container.

                  - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                  the video output settings.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                  streams into the QuickTime file using XDCAM fourcc codes. This increases
                  compatibility with Apple editors and players, but may decrease compatibility with
                  other players. Only applicable when the video codec is MPEG2.

                  - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                  padding

                  - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                  this setting.

                - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
                AAC outputs with this container.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                  moov box.

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                  - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                  file. Usually not necessary to specify.

                - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                  - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                  groups that include sidecar TTML or IMSC captions. You specify sidecar captions in
                  a separate output from your audio and video. Choose Raw (RAW) for captions in a
                  single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for
                  captions in XML format contained within fragmented MP4 files. This set of
                  fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                  - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                  markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                  insertion points that you specify in an ESAM XML document. Provide the document in
                  the setting SCC XML (sccXml).

                  - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                  markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                  SCTE-35 markers that appear in your input to also appear in this output. Choose
                  None (NONE) if you don't want those SCTE-35 markers in this output.

              - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
              for outputs in File output groups. If you do not specify a value, the service will use
              default extensions by container type as follows * MPEG-2 transport stream, m2ts *
              Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the
              service will use codec extensions (e.g. AAC, H265, H265, AC3)

              - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
              add a string to the end of each output filename. You specify the base filename as part
              of your destination URI. When you create multiple outputs in the same output group,
              Name modifier (NameModifier) is required. Name modifier also accepts format
              identifiers. For DASH ISO outputs, if you use the format identifiers $Number$ or
              $Time$ in one output, you must use them in the same way in all outputs of the output
              group.

              - **OutputSettings** *(dict) --* Specific settings for this type of output.

                - **HlsSettings** *(dict) --* Settings for HLS output groups

                  - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                  belongs.

                  - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                  outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                  container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                  file in a raw container. Regardless of the value that you specify here, if this
                  output has video, the service will place the output into an MPEG2-TS container.

                  - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                  with the video output stream. Input all the audio GROUP-IDs that are associated to
                  the video, separate by ','.

                  - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                  Audio-Only Variant Stream The client can play back this audio-only stream instead
                  of video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                  manifest. Alternate Audio, Auto Select, Default Alternate rendition that the
                  client should try to play back by default. Represented as an EXT-X-MEDIA in the
                  HLS manifest with DEFAULT=YES, AUTOSELECT=
                      YES Alternate Audio, Auto Select, Not
                  Default Alternate rendition that the client may try to play back by default.
                  Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                      NO, AUTOSELECT=YES
                  Alternate Audio, not Auto Select Alternate rendition that the client will not try
                  to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
                  DEFAULT=NO, AUTOSELECT=NO

                  - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                  Manifest in addition to the HLS manifest

                  - **SegmentModifier** *(string) --* String concatenated to end of segment
                  filenames. Accepts "Format Identifiers":#format_identifier_parameters.

              - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
              transcoding settings. Provide the system or custom preset name. You can specify either
              Preset (Preset) or Container settings (ContainerSettings), but not both.

              - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
              encoding settings. The specific video settings depend on the video codec that you
              choose when you specify a value for Video codec (codec). Include one instance of
              (VideoDescription) per output.

                - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                service includes AFD values in the output video data and what those values are. *
                Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                input AFD values and instead encode the value specified in the job. * Choose Auto to
                calculate output AFD values based on the input AFD scaler data.

                - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
                outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
                specify that in your job, the service will ignore the setting.

                - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                (VideoDescription), contains the group of settings related to video encoding. The
                settings in this group vary depending on the value that you choose for Video codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * H_264,
                H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
                FRAME_CAPTURE, FrameCaptureSettings

                  - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                  the enum values defined by the object VideoCodec.

                  - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                    - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.n.jpg where n is the 0-based sequence number of each Capture.

                    - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
                    to 7 decimal places.

                    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                    files).

                    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                    quality.

                  - **H264Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value H_264.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                    your output video settings. If you aren't sure what level to specify, choose
                    Auto (AUTO).

                    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                    are only available with the AVC-I License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                    Main or High profile) or CAVLC.

                    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                    for interlaced outputs.

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job specification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* When you use the API for transcode
                    jobs that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateDenominator to specify the
                    denominator of this fraction. In this example, use 1001 for the value of
                    FramerateDenominator. When you use the console for transcode jobs that use frame
                    rate conversion, provide the value as a decimal number for Framerate. In this
                    example, specify 23.976.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type, as follows. - If the source is interlaced, the output will be interlaced
                    with the same polarity as the source (it will follow the source). The output
                    could therefore be a mix of "top field first" and "bottom field first". - If the
                    source is progressive, the output will be interlaced with "top field first" or
                    "bottom field first" polarity, depending on which of the Follow options you
                    chose.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even
                    if repeated.

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                  - **H265Settings** *(dict) --* Settings for H265 codec

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                    Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                    Transfer Function (EOTF).

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* H.265 Level.

                    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                    (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                    "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                    available with the HEVC 4:2:2 License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                    Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                    the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field
                    First (BOTTOM_FIELD) to create an output that's interlaced with the same field
                    polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow,
                    Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the
                    same field polarity as the source. If the source is interlaced, the output will
                    be interlaced with the same polarity as the source (it will follow the source).
                    The output could therefore be a mix of "top field first" and "bottom field
                    first". If the source is progressive, your output will be interlaced with "top
                    field first" or "bottom field first" polarity, depending on which of the Follow
                    options you chose. If you don't choose a value, the service will default to
                    Progressive (PROGRESSIVE).

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                    Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                    based on content

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                    encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                    and P-frames form one layer, reference B-frames can form a second layer and
                    non-reference b-frames can form a third layer. Decoders can optionally decode
                    only the lower temporal layers to generate a lower frame rate output. For
                    example, given a bitstream with temporal IDs and with b-frames =
                         1 (i.e. IbPbPb
                    display order), a decoder could decode all the frames for full frame rate output
                    or only the I and P frames (lowest temporal layer) for a half frame rate output.

                    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                    vertical subdivision of the encoded pictures.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                    units doesn't matter in your workflow, ignore this setting. Use this setting
                    only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                    container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                    your output compliant with the following specification: ISO IECJTC1 SC29 N13798
                    Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
                    parameter set NAL units in the sample headers but not in the samples directly.
                    For MP4 outputs, when you choose HVC1, your output video might not work properly
                    with some downstream systems and video players. The service defaults to marking
                    your output as HEV1. For these outputs, the service writes parameter set NAL
                    units directly into the samples.

                  - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value MPEG2.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                    level for the video output.

                    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                    MPEG-2 profile for the video output.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **IntraDcPrecision** *(string) --* Use Intra DC precision
                    (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                    coefficients. If you choose the value auto, the service will automatically
                    select the precision based on the per-frame compression ratio.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                    video encoding.

                    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                    to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                    356M-2001).

                    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                  - **ProresSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value PRORES.

                    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                    the type of Apple ProRes codec to use for this output.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                    that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateNumerator to specify the
                    numerator of this fraction. In this example, use 24000 for the value of
                    FramerateNumerator.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                    determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                    to use the pixel aspect ratio from the input. To specify a different pixel
                    aspect ratio: Using the console, choose it from the dropdown menu. Using the
                    API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                    (ParDenominator).

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
                color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
                this output. If you don't specify a value, the service sets this to Insert by
                default.

                - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
                the service will include in the output video frame.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                feature is enabled, the service will use drop-frame timecode on outputs. If it is
                not possible to use drop-frame timecode, the system will fall back to
                non-drop-frame. This setting is enabled by default when Timecode insertion
                (TimecodeInsertion) is enabled.

                - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
                Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                service will write on all frames of this video output.

                - **Height** *(integer) --* Use the Height (Height) setting to define the video
                resolution height for this output. Specify in pixels. If you don't provide a value
                here, the service will use the input height.

                - **Position** *(dict) --* Use Selection placement (position) to define the video
                area in your output frame. The area outside of the rectangle that you specify here
                is black.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                the service changes the video itself in response to AFD values in the input. *
                Choose Respond to clip the input video frame according to the AFD value, input
                display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                include the input AFD values. Do not choose this when AfdSignaling is set to (NONE).
                A preferred implementation of this workflow is to set RespondToAfd to (NONE) and set
                AfdSignaling to (AUTO). * Choose None to remove all input AFD values from this
                output.

                - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                have a different aspect ratio from the input aspect ratio. Choose Stretch to output
                (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
                setting Default (DEFAULT) to have the service letterbox your video instead. This
                setting overrides any value that you specify for the setting Selection placement
                (position) in this output.

                - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                strength of anti-aliasing. This setting changes the width of the anti-alias filter
                kernel used for scaling. Sharpness only applies if your output resolution is
                different from your input resolution. 0 is the softest setting, 100 the sharpest,
                and 50 recommended for most content.

                - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                ProRes outputs. Only enable Timecode insertion when the input frame rate is
                identical to the output frame rate. To include timecodes in this output, set
                Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                output, by default, it uses any embedded timecodes from the input. If none are
                present, the service will set the timecode for the first output frame to zero. To
                change this default behavior, adjust the settings under Timecode configuration
                (TimecodeConfig). In the console, these settings are located under Job > Job
                settings > Timecode configuration. Note - Timecode source under input settings
                (InputTimecodeSource) does not affect the timecodes that are inserted in the output.
                Source under Job settings > Timecode configuration (TimecodeSource) does.

                - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                Preprocessors (VideoPreprocessors). Enable the features at each output individually.
                These features are disabled by default.

                  - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                  feature if necessary. Enable or disable this feature for each output individually.
                  This setting is disabled by default.

                    - **Brightness** *(integer) --* Brightness level.

                    - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                    this output. The service supports conversion between HDR formats, between SDR
                    formats, and from SDR to HDR. The service doesn't support conversion from HDR to
                    SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                    video has an HDR format, but visually appears the same as an unconverted output.

                    - **Contrast** *(integer) --* Contrast level.

                    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                    10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                    metadata that you want signaled in the output. These values don't affect the
                    pixel values that are encoded in the video stream. They are intended to help the
                    downstream video player display content in a way that reflects the intentions of
                    the the content creator. When you set Color space conversion
                    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                    must set values for Max frame average light level (maxFrameAverageLightLevel)
                    and Max content light level (maxContentLightLevel); these settings don't have a
                    default value. The default values for the other HDR 10 metadata settings are
                    defined by the P3D65 color space. For more information about MediaConvert HDR
                    jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                      samples in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                      any frame in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance
                      in units of of 0.0001 candelas per square meter.

                      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance
                      in units of of 0.0001 candelas per square meter

                      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                    - **Hue** *(integer) --* Hue in degrees.

                    - **Saturation** *(integer) --* Saturation level.

                  - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                  motion and a clearer picture.

                    - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                    (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                    adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                    (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if
                    your source file includes a ticker, such as a scrolling headline at the bottom
                    of the frame.

                    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                    does not convert frames that are tagged in metadata as progressive. It will only
                    convert those that are tagged as some other type. - When set to
                    FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                    those that are already tagged as progressive. Turn Force mode on only if there
                    is a good chance that the metadata has tagged frames as progressive when they
                    are not progressive. Do not turn on otherwise; processing frames that are
                    already progressive into progressive will probably result in lower quality
                    video.

                    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                    service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                    interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                    progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                  - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                  compatible video output.

                    - **L6Metadata** *(dict) --* Use these settings when you set
                    DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                    your input with new values.

                      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                      that corresponds to the brightest pixel in the entire stream. Measured in
                      nits.

                      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                      metadata that corresponds to the highest frame-average brightness in the
                      entire stream. Measured in nits.

                    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                    handle Dolby Vision MaxCLL and MaxFALL properies.

                    - **Profile** *(string) --* In the current MediaConvert implementation, the
                    Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must
                    contain Dolby Vision frame interleaved data.

                  - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature
                  to include a graphic overlay on your video. Enable or disable this feature for
                  each output individually. This setting is disabled by default.

                    - **InsertableImages** *(list) --* Specify the images that you want to overlay
                    on your video. The images must be PNG or TGA files.

                      - *(dict) --* Settings that specify how your still graphic overlay appears.

                        - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                        image to remain on the output video. This duration includes fade-in time but
                        not fade-out time.

                        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                        between the Start time that you specify for the image insertion and the time
                        that the image appears at full opacity. Full opacity is the level that you
                        specify for the opacity setting. If you don't specify a value for Fade-in,
                        the image will appear abruptly at the overlay start time.

                        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                        between the end of the time that you have specified for the image overlay
                        Duration and when the overlaid image has faded to total transparency. If you
                        don't specify a value for Fade-out, the image will disappear abruptly at the
                        end of the inserted image duration.

                        - **Height** *(integer) --* Specify the height of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        height, the service will crop your overlaid image to fit. To use the native
                        height of the image, keep this setting blank.

                        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                        location of the image that you want to overlay on the video. Use a PNG or
                        TGA file.

                        - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                        inserted image and the left edge of the video frame. Required for any image
                        overlay that you specify.

                        - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                        overlaid image and the top edge of the video frame. Required for any image
                        overlay that you specify.

                        - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                        Images with higher values for Layer appear on top of images with lower
                        values for Layer.

                        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                        the underlying video shows through the inserted image. 0 is transparent and
                        100 is fully opaque. Default is 50.

                        - **StartTime** *(string) --* Specify the timecode of the frame that you
                        want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                        or HH:MM:SS;FF) format. Remember to take into account your timecode source
                        settings.

                        - **Width** *(integer) --* Specify the width of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        width, the service will crop your overlaid image to fit. To use the native
                        width of the image, keep this setting blank.

                  - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                  remove noise from your video output if necessary. Enable or disable this feature
                  for each output individually. This setting is disabled by default.

                    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                    select one of the following spatial image filtering functions. To use this
                    setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                    preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                    Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                    reduction. * Spatial does frequency-domain filtering based on JND principles. *
                    Temporal optimizes video quality for complex motion.

                    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                    spatial filter.

                      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                      reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                      maximum strength.

                      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                      (higher speed), with 0 being the nominal value.

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                    temporal filter.

                      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                      complex motion. Higher values produce stronger temporal filtering. This
                      filters highly complex scenes more aggressively and creates better VQ for low
                      bitrate outputs.

                      - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                      Low setting reduces bit rate at the cost of transcode time, high setting
                      improves transcode time at the cost of bit rate.

                      - **Strength** *(integer) --* Specify the strength of the noise reducing
                      filter on this output. Higher values produce stronger filtering. We recommend
                      the following value ranges, depending on the result that you want: * 0-2 for
                      complexity reduction with minimal sharpness loss * 2-8 for complexity
                      reduction with image preservation * 8-16 for a high level of complexity
                      reduction

                  - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                  output timecode and specified prefix into the output.

                    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                    any burned-in timecode. Valid values are 10, 16, 32, 48.

                    - **Position** *(string) --* Use Position (Position) under under Timecode
                    burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                    output video.

                    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                    any burned-in timecode. For example, a prefix of "EZ-" will result in the
                    timecode "EZ-00:00:00:00". Provide either the characters themselves or the ASCII
                    code equivalents. The supported range of characters is 0x20 through 0x7e. This
                    includes letters, numbers, and all special characters represented on a standard
                    English keyboard.

                - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                in pixels, for this output. If you don't provide a value here, the service will use
                the input width.

      - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
      information from inputs.

        - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
        use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
        the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or
        (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
        Timecode varies depending on your setting for Source (TimecodeSource). * If Source
        (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
        specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
        (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start at
        0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
        Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
        input.

        - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
        within this job. To make sure that your video, audio, captions, and markers are synchronized
        and that time-based features, such as image inserter, work correctly, choose the Timecode
        source option that matches your assets. All timecodes are in a 24-hour format with frame
        number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video.
        If no embedded timecode is in the source, the service will use Start at 0 (ZEROBASED)
        instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. *
        Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other
        than zero. You use Start timecode (Start) to provide this value.

        - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
        (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
        Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

        - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
        stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
        affecting the time and frame number. Provide the new date as a string in the format
        "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
        (InsertProgramDateTime) in the output settings. For example, if the date part of your
        timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
        (TimestampOffset) to 2003-1-25.

      - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
      (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
      enable it here, enable it in each output container, and specify tags and timecodes in ID3
      insertion (Id3Insertion) objects.

        - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

          - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
          specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when
          the tag should be inserted. To insert multiple ID3 tags in your output, create multiple
          instances of ID3 insertion (Id3Insertion).

            - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
            format.

            - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
            format.

    - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
    events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
    MediaConvert sends an update at this interval from the time the service begins processing your
    job to the time it completes the transcode or encounters an error.

    - **Type** *(string) --* A job template can be of two types: system or custom. System or
    built-in job templates can't be modified or deleted by the user.
    """


_ListJobTemplatesPaginateResponseTypeDef = TypedDict(
    "_ListJobTemplatesPaginateResponseTypeDef",
    {"JobTemplates": List[ListJobTemplatesPaginateResponseJobTemplatesTypeDef]},
    total=False,
)


class ListJobTemplatesPaginateResponseTypeDef(_ListJobTemplatesPaginateResponseTypeDef):
    """
    Type definition for `ListJobTemplatesPaginate` `Response`

    - **JobTemplates** *(list) --* List of Job templates.

      - *(dict) --* A job template is a pre-made set of encoding instructions that you can use to
      quickly create a job.

        - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up
        jobs with long, visually complex content.

          - **Mode** *(string) --* Specify the conditions when the service will run your job with
          accelerated transcoding.

        - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

        - **Category** *(string) --* An optional category you create to organize your job templates.

        - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for Job template creation.

        - **Description** *(string) --* An optional description you create for each job template.

        - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the Job template was
        last updated.

        - **Name** *(string) --* A name you create for each job template. Each name must be unique
        within your account.

        - **Priority** *(integer) --* Relative priority on the job.

        - **Queue** *(string) --* Optional. The queue that jobs created from this template are
        assigned to. If you don't specify this, jobs will go to the default queue.

        - **Settings** *(dict) --* JobTemplateSettings contains all the transcode settings saved in
        the template that will be applied to jobs created from it.

          - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added
          to the input Ad Avail PTS time.

          - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
          overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

            - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
            black. Only bmp and png images are supported.

          - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

            - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
            ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The
            transcoder uses the manifest conditioning instructions that you provide in the setting
            MCC XML (mccXml).

              - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
              document inside your JSON job settings. Form the XML document as per
              OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning
              instructions in the message that you supply.

            - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in
            milliseconds, between the SCTE 35 messages that the transcoder places and the splice
            points that they refer to. If the time between the start of the asset and the SCTE-35
            message is less than this value, then the transcoder places the SCTE-35 marker at the
            beginning of the stream.

            - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
            SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
            the signal processing instructions that you provide in the setting SCC XML (sccXml).

              - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
              inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025.
              The transcoder will use the signal processing instructions in the message that you
              supply. Provide your ESAM SignalProcessingNotification XML document inside your JSON
              job settings. For your MPEG2-TS file outputs, if you want the service to place SCTE-35
              markers at the insertion points you specify in the XML document, you must also enable
              SCTE-35 ESAM (scte35Esam). Note that you can either specify an ESAM XML document or
              enable SCTE-35 passthrough. You can't do both.

          - **Inputs** *(list) --* Use Inputs (inputs) to define the source file used in the
          transcode job. There can only be one input in a job template. Using the API, you can
          include multiple inputs when referencing a job template.

            - *(dict) --* Specified video input in a template.

              - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input
              to combine. An input may have multiple audio selector groups. See "Audio Selector
              Group":#inputs-audio_selector_group for more information.

                - *(string) --*

                  - *(dict) --* Group of Audio Selectors

                    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same
                    input to include in the group. Audio selector names are standardized, based on
                    their order within the input (e.g., "Audio Selector 1"). The audio selector name
                    parameter can be repeated to add any number of audio selectors to the group.

                      - *(string) --*

              - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a
              track or set of tracks from the input that you will use in your outputs. You can use
              mutiple Audio selectors per input.

                - *(string) --*

                  - *(dict) --* Selector for Audio

                    - **CustomLanguageCode** *(string) --* Selects a specific language code from
                    within an audio source, using the ISO 639-2 or ISO 639-3 three-letter language
                    code

                    - **DefaultSelection** *(string) --* Enable this setting on one audio selector
                    to set it as the default for the job. The service uses this default for outputs
                    where it can't find the specified input audio. If you don't set a default, those
                    outputs have no audio.

                    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                    file source.

                    - **LanguageCode** *(string) --* Selects a specific language code from within an
                    audio source.

                    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                    audio from the input video.

                    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g.
                    257 selects PID 0x101).

                      - *(integer) --*

                    - **ProgramSelection** *(integer) --* Use this setting for input streams that
                    contain Dolby E, to have the service extract specific program data from the
                    track. To select multiple programs, create multiple selectors with the same
                    Track and different Program numbers. In the console, this setting is visible
                    when you set Selector type to Track. Choose the program number from the dropdown
                    list. If you are sending a JSON file, provide the program ID, which is part of
                    the audio metadata. If your input file has incorrect metadata, you can choose
                    All channels instead of a program number to have the service ignore the program
                    IDs and include all the programs in the track.

                    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels
                    of one input to match those of another input. This allows you to combine the two
                    files into a single output, one after the other.

                      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                      group of fields that hold the remixing value for each channel. Units are in
                      dB. Acceptable values are within the range from -60 (mute) through 6. A
                      setting of 0 passes the input channel unchanged to the output channel (no
                      attenuation or amplification).

                        - **OutputChannels** *(list) --* List of output channels

                          - *(dict) --* OutputChannel mapping settings.

                            - **InputChannels** *(list) --* List of input channels

                              - *(integer) --*

                      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                      input that you want to use in your output. With remixing, you might combine or
                      split the data in these channels, so the number of channels in your final
                      output might be different.

                      - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                      after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                    - **SelectorType** *(string) --* Specifies the type of the audio selector.

                    - **Tracks** *(list) --* Identify a track from the input audio to include in
                    this selector by entering the track index number. To include several tracks in a
                    single audio selector, specify multiple tracks as follows. Using the console,
                    enter a comma-separated list. For examle, type "1,2,3" to include tracks 1
                    through 3. Specifying directly in your JSON job file, provide the track numbers
                    in an array. For example, "tracks": [1,2,3].

                      - *(integer) --*

              - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to
              specify the captions data from the input that you will use in your outputs. You can
              use mutiple captions selectors per input.

                - *(string) --*

                  - *(dict) --* Set up captions in your outputs by first selecting them from your
                  input here.

                    - **CustomLanguageCode** *(string) --* The specific language to extract from
                    source, using the ISO 639-2 or ISO 639-3 three-letter language code. If input is
                    SCTE-27, complete this field and/or PID to select the caption language to
                    extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this
                    field and/or PID to select the caption language to extract. If input is DVB-Sub
                    that is being passed through, omit this field (and PID field); there is no way
                    to extract a specific language with pass-through captions.

                    - **LanguageCode** *(string) --* The specific language to extract from source.
                    If input is SCTE-27, complete this field and/or PID to select the caption
                    language to extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT,
                    complete this field and/or PID to select the caption language to extract. If
                    input is DVB-Sub that is being passed through, omit this field (and PID field);
                    there is no way to extract a specific language with pass-through captions.

                    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                    SRT, or IMSC in an xml file, specify the URI of the input captions source file.
                    If your input captions are IMSC in an IMF package, use TrackSourceSettings
                    instead of FileSoureSettings.

                      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions
                      source.

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                        number in the ancillary data track from which to extract captions. Unused
                        for passthrough.

                        - **TerminateCaptions** *(string) --* By default, the service terminates any
                        unterminated captions at the end of each input. If you want the caption to
                        continue onto your next input, disable this setting.

                      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use
                        this PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub
                        content is passed through, regardless of selectors.

                      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel
                        number within the video track from which to extract captions. Unused for
                        passthrough.

                        - **Source608TrackNumber** *(integer) --* Specifies the video track index
                        used for extracting captions. The system only supports one input video
                        track, so this should always be set to '1'.

                        - **TerminateCaptions** *(string) --* By default, the service terminates any
                        unterminated captions at the end of each input. If you want the caption to
                        continue onto your next input, disable this setting.

                      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                      STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption
                      source file. If your caption source is IMSC in an IMF package, use
                      TrackSourceSettings instead of FileSoureSettings.

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **SourceFile** *(string) --* External caption file used for loading
                        captions. Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt',
                        'xml', and 'smi'.

                        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset
                        the captions from the source file.

                      - **SourceType** *(string) --* Use Source (SourceType) to identify the format
                      of your input captions. The service cannot auto-detect caption format.

                      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                      sources, including Page number.

                        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                        three-digit hexadecimal page number that will be used for Teletext captions.
                        Do not use this setting if you are passing through teletext from the input
                        source to output.

                      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources
                      that are specified by track number. Currently, this is only IMSC captions in
                      an IMF package. If your caption source is IMSC 1.1 in a separate xml file, use
                      FileSourceSettings instead of TrackSourceSettings.

                        - **TrackNumber** *(integer) --* Use this setting to select a single
                        captions track from a source. Track numbers correspond to the order in the
                        captions source file. For IMF sources, track numbering is based on the order
                        that the captions appear in the CPL. For example, use 1 to select the
                        captions asset that is listed first in the CPL. To include more than one
                        captions track in your job outputs, create multiple input captions
                        selectors. Specify one track per selector.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame. If you specify a value here, it
              will override any value that you specify in the output setting Cropping selection
              (crop).

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce
              smoother motion in the output. Default is disabled. Only manaully controllable for
              MPEG2 and uncompressed video inputs.

              - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise
              from the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and
              uncompressed video inputs.

              - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how
              the transcoding service applies the denoise and deblock filters. You must also enable
              the filters separately, with Denoise (InputDenoiseFilter) and Deblock
              (InputDeblockFilter). * Auto - The transcoding service determines whether to apply
              filtering, depending on input type and quality. * Disable - The input is not filtered.
              This is true even if you use the API to enable them in (InputDeblockFilter) and
              (InputDeblockFilter). * Force - The in put is filtered regardless of input type.

              - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
              magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5.
              Default is 0.

              - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
              overlay on your video. Enable or disable this feature for each input individually.
              This setting is disabled by default.

                - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                your video. The images must be PNG or TGA files.

                  - *(dict) --* Settings that specify how your still graphic overlay appears.

                    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                    to remain on the output video. This duration includes fade-in time but not
                    fade-out time.

                    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                    the Start time that you specify for the image insertion and the time that the
                    image appears at full opacity. Full opacity is the level that you specify for
                    the opacity setting. If you don't specify a value for Fade-in, the image will
                    appear abruptly at the overlay start time.

                    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                    between the end of the time that you have specified for the image overlay
                    Duration and when the overlaid image has faded to total transparency. If you
                    don't specify a value for Fade-out, the image will disappear abruptly at the end
                    of the inserted image duration.

                    - **Height** *(integer) --* Specify the height of the inserted image in pixels.
                    If you specify a value that's larger than the video resolution height, the
                    service will crop your overlaid image to fit. To use the native height of the
                    image, keep this setting blank.

                    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                    location of the image that you want to overlay on the video. Use a PNG or TGA
                    file.

                    - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                    inserted image and the left edge of the video frame. Required for any image
                    overlay that you specify.

                    - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                    overlaid image and the top edge of the video frame. Required for any image
                    overlay that you specify.

                    - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                    Images with higher values for Layer appear on top of images with lower values
                    for Layer.

                    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                    underlying video shows through the inserted image. 0 is transparent and 100 is
                    fully opaque. Default is 50.

                    - **StartTime** *(string) --* Specify the timecode of the frame that you want
                    the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                    HH:MM:SS;FF) format. Remember to take into account your timecode source
                    settings.

                    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                    you specify a value that's larger than the video resolution width, the service
                    will crop your overlaid image to fit. To use the native width of the image, keep
                    this setting blank.

              - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
              that together specify a portion of the input to be used in the outputs. If you provide
              only a start time, the clip will be the entire input from that point to the end. If
              you provide only an end time, it will be the entire input up to that point. When you
              specify more than one input clip, the transcoding service creates the job outputs by
              stringing the clips together in the order you specify them.

                - *(dict) --* To transcode only portions of your input (clips), include one Input
                clipping (one instance of InputClipping in the JSON job file) for each input clip.
                All input clips you specify will be included in every output of the job.

                  - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
                  portion of the input you are clipping. The frame corresponding to the End timecode
                  value is included in the clip. Start timecode or End timecode may be left blank,
                  but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM
                  is the minute, SS is the second, and FF is the frame number. When choosing this
                  value, take into account your setting for timecode source under input settings
                  (InputTimecodeSource). For example, if you have embedded timecodes that start at
                  01:00:00:00 and you want your clip to end six minutes into the video, use
                  01:06:00:00.

                  - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the
                  beginning of the portion of the input you are clipping. The frame corresponding to
                  the Start timecode value is included in the clip. Start timecode or End timecode
                  may be left blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where
                  HH is the hour, MM is the minute, SS is the second, and FF is the frame number.
                  When choosing this value, take into account your setting for Input timecode
                  source. For example, if you have embedded timecodes that start at 01:00:00:00 and
                  you want your clip to begin five minutes into the video, use 01:05:00:00.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black. If you specify a value here, it will override any value that you specify in the
              output setting Selection placement (position). If you specify a value here, this will
              override any AFD values in your input, even if you set Respond to AFD (RespondToAfd)
              to Respond (RESPOND). If you specify a value here, this will ignore anything that you
              specify for the setting Scaling Behavior (scalingBehavior).

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
              program from within a multi-program transport stream. Note that Quad 4K is not
              currently supported. Default is the first program within the transport stream. If the
              program you specify doesn't exist, the transcoding service will use this default.

              - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
              inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs
              for audio and video. * Use PSI - Scan only PSI data.

              - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
              input settings (InputTimecodeSource), to specify how the service counts input video
              frames. This input frame count affects only the behavior of features that apply to a
              single input at a time, such as input clipping and synchronizing some captions
              formats. Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose
              Start at zero (ZEROBASED) to start the first frame at zero. Choose Specified start
              (SPECIFIEDSTART) to start the first frame at the timecode that you specify in the
              setting Start timecode (timecodeStart). If you don't specify a value for Timecode
              source, the service will use Embedded by default. For more information about
              timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

              - **TimecodeStart** *(string) --* Specify the timecode that you want the service to
              use for this input's initial frame. To use this setting, you must set the Timecode
              source setting, located under the input settings (InputTimecodeSource), to Specified
              start (SPECIFIEDSTART). For more information about timecodes, see
              https://docs.aws.amazon.com/console/mediaconvert/timecode.

              - **VideoSelector** *(dict) --* Selector for video.

                - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a
                QuickTime animation. Specify which part of this input MediaConvert uses for your
                outputs. Leave this setting set to DISCARD in order to delete the alpha channel and
                preserve the video. Use REMAP_TO_LUMA for this setting to delete the video and map
                the alpha channel to the luma channel of your outputs.

                - **ColorSpace** *(string) --* If your input video has accurate color space
                metadata, or if you don't know about color space, leave this set to the default
                value Follow (FOLLOW). The service will automatically detect your input color space.
                If your input video has metadata indicating the wrong color space, specify the
                accurate color space here. If your input video is HDR 10 and the SMPTE ST 2086
                Mastering Display Color Volume static metadata isn't present in your video stream,
                or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10)
                here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
                settings. For more information about MediaConvert HDR jobs, see
                https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the
                input file and the job input settings Color space (ColorSpace) and HDR master
                display information settings(Hdr10Metadata). The Color space usage setting
                determines which takes precedence. Choose Force (FORCE) to use color metadata from
                the input job settings. If you don't specify values for those settings, the service
                defaults to using metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to
                use color metadata from the source when it is present. If there's no color metadata
                in your input file, the service defaults to using values you specify in the input
                settings.

                - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that
                is missing or inaccurate in your input video. Appropriate values vary depending on
                the input video and must be provided by a color grader. The color grader generates
                these values during the HDR 10 mastering process. The valid range for each of these
                settings is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color
                coordinate. Related settings - When you specify these values, you must also set
                Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
                specify here take precedence over the values in the metadata of your input file, set
                Color space usage (ColorSpaceUsage). To specify whether color metadata is included
                in an output, set Color metadata (ColorMetadata). For more information about
                MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                  - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                  the coded video sequence, in units of candelas per square meter. This setting
                  doesn't have a default value; you must specify a value that is suitable for the
                  content.

                  - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                  frame in the coded video sequence, in units of candelas per square meter. This
                  setting doesn't have a default value; you must specify a value that is suitable
                  for the content.

                  - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                  units of of 0.0001 candelas per square meter.

                  - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                  units of of 0.0001 candelas per square meter

                  - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input
                file. Specify this value as an integer; the system automatically converts it to the
                hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier,
                is an identifier for a set of data in an MPEG-2 transport stream container.

                - **ProgramNumber** *(integer) --* Selects a specific program from within a
                multi-program transport stream. Note that Quad 4K is not currently supported.

                - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service
                rotates your video. You can choose automatic rotation or specify a rotation. You can
                specify a clockwise rotation of 0, 90, 180, or 270 degrees. If your input video
                container is .mov or .mp4 and your input has rotation metadata, you can choose
                Automatic to have the service rotate your video according to the rotation specified
                in the metadata. The rotation must be within one degree of 90, 180, or 270 degrees.
                If the rotation metadata specifies any other rotation, the service will default to
                no rotation. By default, the service does no rotation, even if your input video has
                rotation metadata. The service doesn't pass through rotation metadata.

          - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The
          motion graphics that you specify here appear on all outputs in all output groups.

            - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this
            setting unspecified. If your motion graphic asset is a series of .png files, specify the
            frame rate of the overlay in frames per second, as a fraction. For example, specify 24
            fps as 24/1. Make sure that the number of images in your series matches the frame rate
            and your intended overlay duration. For example, if you want a 30-second overlay at 30
            fps, you should have 900 .png images. This overlay frame rate doesn't need to match the
            frame rate of the underlying video.

              - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses
              your overlay frame rate. For example, if your frame rate is 24 fps, set this value to
              1.

              - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
              overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

            - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
            overlay on your video. For .png files, provide the file name of the first file in the
            series. Make sure that the names of the .png files end with sequential numbers that
            specify the order that they are played in. For example, overlay_000.png,
            overlay_001.png, overlay_002.png, and so on. The sequence must start at zero, and each
            image file name must have the same number of digits. Pad your initial file names with
            enough zeros to complete the sequence. For example, if the first image is overlay_0.png,
            there can be only 10 images in the sequence, with the last image being overlay_9.png.
            But if the first image is overlay_00.png, there can be 100 images in the sequence.

            - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
            providing for your overlay. You can choose either a .mov file or a series of .png files.

            - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic
            overlay on the video frame. Specify in pixels, from the upper-left corner of the frame.
            If you don't specify an offset, the service scales your overlay to the full size of the
            frame. Otherwise, the service inserts the overlay at its native resolution and scales
            the size up or down with any video scaling.

              - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the
              left edge of the video frame.

              - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the
              top edge of the video frame.

            - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a
            loop or plays only once.

            - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode
            format (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes
            into account how you have set up your timecode configuration under both job settings and
            input settings. The simplest way to do that is to set both to start at 0. If you need to
            set up your job to follow timecodes embedded in your source that don't start at zero,
            make sure that you specify a start time that is after the first embedded timecode. For
            more information, see
            https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find
            job-wide and input timecode configuration settings in your JSON job settings
            specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

          - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you
          don't do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
          configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all
          outputs in the job. To enable Nielsen configuration programmatically, include an instance
          of nielsenConfiguration in your JSON job specification. Even if you don't include any
          children of nielsenConfiguration, you still enable the setting.

            - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
            functionality. If you must include this property, set the value to zero.

            - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
            distributor ID that is assigned to your organization by Neilsen.

          - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set
          of outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS,
          Quicktime, MXF, and no container) are grouped in a single output group as well. Required
          in (OutputGroups) is a group of settings that apply to the whole group. This required
          object depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings).
          Type, settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
          HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
          MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

            - *(dict) --* Group of outputs

              - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name
              for the output group. This value is displayed on the console and can make your job
              settings JSON more human-readable. It does not affect your outputs. Use up to twelve
              characters that are either letters, numbers, spaces, or underscores.

              - **Name** *(string) --* Name of the output group

              - **OutputGroupSettings** *(dict) --* Output Group settings, including type

                - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
                Output Group may only contain a single video, audio, or caption output.

                  - **AdditionalManifests** *(list) --* By default, the service creates one
                  top-level .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF
                  output group in your job. These default manifests reference every output in the
                  output group. To create additional top-level manifests that reference a subset of
                  the outputs in the output group, specify a list of them here. For each additional
                  manifest that you specify, the service creates one HLS manifest and one DASH
                  manifest.

                    - *(dict) --* Specify the details for each pair of HLS and DASH additional
                    manifests that you want the service to generate for this CMAF output group. Each
                    pair of manifests can reference a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your HLS group is film-name.m3u8. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                      specify a manifestNameModifier that is different from the nameModifier of the
                      output. The service uses the output name modifier to create unique names for
                      the individual variant manifests.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                  file at the top level BaseURL element. Can be used if streams are delivered from a
                  different URL than the manifest file.

                  - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no
                  tag, which prevents client from saving media segments for later replay.

                  - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the
                  default RFC-4281) during m3u8 playlist generation.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* DRM settings.

                    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                    value represented by a 32-character text string. If this parameter is not set
                    then the Initialization Vector will follow the segment number by default.

                    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want
                    the service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                    (SAMPLE-AES) or AES_CTR (AES-CTR).

                    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                    outputs, choose whether the service writes the 128-bit encryption initialization
                    vector in the HLS and DASH manifests.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                    settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                    output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                    settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you
                      want signaled in the DASH manifest that MediaConvert creates as part of this
                      CMAF package. The DASH manifest can currently signal up to three system IDs.
                      For more information, see https://dashif.org/identifiers/content_protection/.

                        - *(string) --*

                      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                      signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                      package. The HLS manifest can currently signal only one system ID. For more
                      information, see https://dashif.org/identifiers/content_protection/.

                        - *(string) --*

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with
                    a static key provider.

                      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                      the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                      omitted to indicate an implicit value of 'identity'.

                      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                      single positive integer version value or a slash delimited list of version
                      values (1/2/3).

                      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                      32-character hexidecimal string to specify Key Value (StaticKeyValue).

                      - **Url** *(string) --* Relates to DRM implementation. The location of the
                      license server used for protecting content.

                    - **Type** *(string) --* Specify whether your DRM encryption key is static or
                    from a key provider that follows the SPEKE standard. For more information about
                    SPEKE, see
                    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                  - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                  Fragment length must be compatible with GOP size and Framerate. Note that
                  fragments will end on the next keyframe after this number of seconds, so actual
                  fragment length may be longer. When Emit Single File is checked, the fragmentation
                  is internal to a single output file and it does not cause the creation of many
                  output files as in other output types.

                  - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                  - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                  should use floating point values for segment duration.

                  - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that
                  is needed to ensure smooth playout.

                  - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                  0, unless you are troubleshooting a problem with how devices play back the end of
                  your video asset. If you know that player devices are hanging on the final segment
                  of your video because the length of your final segment is too short, use this
                  setting to specify a minimum final segment length, in seconds. Choose a value that
                  is greater than or equal to 1 and less than your segment length. When you specify
                  a value for this setting, the encoder will combine any final segment that is
                  shorter than the length that you specify with the previous segment. For example,
                  your segment length is 3 seconds and your final segment is .5 seconds without a
                  minimum final segment length; when you set the minimum final segment length to 1,
                  your final segment is 3.5 seconds.

                  - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                  main. When you choose Main profile (MAIN_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                  On-demand (ON_DEMAND_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose
                  On-demand, you must also set the output group setting Segment control
                  (SegmentControl) to Single file (SINGLE_FILE).

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file
                  is generated, which is internally segmented using the Fragment Length and Segment
                  Length. When set to SEGMENTED_FILES, separate segment files will be created.

                  - **SegmentLength** *(integer) --* Use this setting to specify the length, in
                  seconds, of each individual CMAF segment. This value applies to the whole package;
                  that is, to every output in the output group. Note that segments end on the first
                  keyframe after this number of seconds, so the actual segment length might be
                  slightly longer. If you set Segment control (CmafSegmentControl) to single file,
                  the service puts the content of each output in a single file that has metadata
                  that marks these segments. If you set it to segmented files, the service creates
                  multiple files for each output, each with the content of one segment.

                  - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute
                  for video in EXT-X-STREAM-INF tag of variant manifest.

                  - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest
                  will be generated for this output.

                  - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest
                  will be generated for this output.

                - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

                  - **AdditionalManifests** *(list) --* By default, the service creates one .mpd
                  DASH manifest for each DASH ISO output group in your job. This default manifest
                  references every output in the output group. To create additional DASH manifests
                  that reference a subset of the outputs in the output group, specify a list of them
                  here.

                    - *(dict) --* Specify the details for each additional DASH manifest that you
                    want the service to generate for this output group. Each manifest can reference
                    a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your DASH group is film-name.mpd. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.mpd.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                  (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
                  from a different URL than the manifest file.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* DRM settings.

                    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                    compatibility of your output with video players on obsolete devices. It applies
                    only to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI
                    (UNENCRYPTED_SEI) only to correct problems with playback on older devices.
                    Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose Unencrypted
                    SEI, for that output, the service will exclude the access unit delimiter and
                    will leave the SEI NAL units unencrypted.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                  - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                  Fragment length must be compatible with GOP size and Framerate. Note that
                  fragments will end on the next keyframe after this number of seconds, so actual
                  fragment length may be longer. When Emit Single File is checked, the fragmentation
                  is internal to a single output file and it does not cause the creation of many
                  output files as in other output types.

                  - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

                  - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that
                  is needed to ensure smooth playout.

                  - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                  main. When you choose Main profile (MAIN_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                  On-demand (ON_DEMAND_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose
                  On-demand, you must also set the output group setting Segment control
                  (SegmentControl) to Single file (SINGLE_FILE).

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file
                  is generated, which is internally segmented using the Fragment Length and Segment
                  Length. When set to SEGMENTED_FILES, separate segment files will be created.

                  - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds).
                  Note that segments will end on the next keyframe after this number of seconds, so
                  actual segment length may be longer. When Emit Single File is checked, the
                  segmentation is internal to a single output file and it does not cause the
                  creation of many output files as in other output types.

                  - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error
                  in the 400 range when you play back your DASH output, enable this setting and run
                  your transcoding job again. When you enable this setting, the service writes
                  precise segment durations in the DASH manifest. The segment duration information
                  appears inside the SegmentTimeline element, inside SegmentTemplate at the
                  Representation level. When you don't enable this setting, the service writes
                  approximate segment durations in your DASH manifest.

                - **FileGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

                  - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your
                  Apple HLS manifest. This setting does not determine whether SCTE-35 markers appear
                  in the outputs themselves.

                    - *(string) --*

                  - **AdditionalManifests** *(list) --* By default, the service creates one
                  top-level .m3u8 HLS manifest for each HLS output group in your job. This default
                  manifest references every output in the output group. To create additional
                  top-level manifests that reference a subset of the outputs in the output group,
                  specify a list of them here.

                    - *(dict) --* Specify the details for each additional HLS manifest that you want
                    the service to generate for this output group. Each manifest can reference a
                    different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your HLS group is film-name.m3u8. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                      specify a manifestNameModifier that is different from the nameModifier of the
                      output. The service uses the output name modifier to create unique names for
                      the individual variant manifests.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each
                  output in the media .m3u8 file. Can be used if base manifest is delivered from a
                  different URL than the main .m3u8 file.

                  - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                    - *(dict) --* Caption Language Mapping

                      - **CaptionChannel** *(integer) --* Caption channel.

                      - **CustomLanguageCode** *(string) --* Specify the language for this captions
                      channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                      - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                      three-letter code listed at
                      https://www.loc.gov/standards/iso639-2/php/code_list.php.

                      - **LanguageDescription** *(string) --* Caption language description.

                  - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
                  captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least
                  one language in the CC1 Language Code field. One CLOSED-CAPTION line is added for
                  each Language Code you specify. Make sure to specify the languages in the order in
                  which they appear in the original source (if the source is embedded format) or the
                  order of the caption selectors (if the source is other than embedded). Otherwise,
                  languages in the manifest will not match up properly with the output captions.
                  None: Include CLOSED-CAPTIONS=
                      NONE line in the manifest. Omit: Omit any
                  CLOSED-CAPTIONS line from the manifest.

                  - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no
                  tag, which prevents client from saving media segments for later replay.

                  - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the
                  default RFC-4281) during m3u8 playlist generation.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **DirectoryStructure** *(string) --* Indicates whether segments should be placed
                  in subdirectories.

                  - **Encryption** *(dict) --* DRM settings.

                    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                    value represented by a 32-character text string. If this parameter is not set
                    then the Initialization Vector will follow the segment number by default.

                    - **EncryptionMethod** *(string) --* Encrypts the segments with the given
                    encryption scheme. Leave blank to disable. Selecting 'Disabled' in the web
                    interface also disables encryption.

                    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is
                    a 128-bit number used in conjunction with the key for encrypting blocks. If set
                    to INCLUDE, Initialization Vector is listed in the manifest. Otherwise
                    Initialization Vector is not in the manifest.

                    - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                    EXT-X-SESSION-KEY element into the master playlist. This allows for offline
                    Apple HLS FairPlay content protection.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with
                    a static key provider.

                      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                      the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                      omitted to indicate an implicit value of 'identity'.

                      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                      single positive integer version value or a slash delimited list of version
                      values (1/2/3).

                      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                      32-character hexidecimal string to specify Key Value (StaticKeyValue).

                      - **Url** *(string) --* Relates to DRM implementation. The location of the
                      license server used for protecting content.

                    - **Type** *(string) --* Specify whether your DRM encryption key is static or
                    from a key provider that follows the SPEKE standard. For more information about
                    SPEKE, see
                    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                  - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                  - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                  should use floating point values for segment duration.

                  - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                  0, unless you are troubleshooting a problem with how devices play back the end of
                  your video asset. If you know that player devices are hanging on the final segment
                  of your video because the length of your final segment is too short, use this
                  setting to specify a minimum final segment length, in seconds. Choose a value that
                  is greater than or equal to 1 and less than your segment length. When you specify
                  a value for this setting, the encoder will combine any final segment that is
                  shorter than the length that you specify with the previous segment. For example,
                  your segment length is 3 seconds and your final segment is .5 seconds without a
                  minimum final segment length; when you set the minimum final segment length to 1,
                  your final segment is 3.5 seconds.

                  - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced
                  by looking ahead and back within the specified range for a nearby avail and
                  extending the segment size if needed.

                  - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file
                  should be generated for this HLS output group.

                  - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME
                  tag in .m3u8 manifest files. The value is calculated as follows: either the
                  program date and time are initialized using the input timecode source, or the time
                  is initialized using the input timecode source and the date is initialized using
                  the timestamp_offset.

                  - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
                  EXT-X-PROGRAM-DATE-TIME entry, in seconds.

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a
                  single media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for
                  playback.

                  - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
                  create (in seconds). Note that segments will end on the next keyframe after this
                  number of seconds, so actual segment length may be longer.

                  - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
                  subdirectory before starting a new one. directoryStructure must be
                  SINGLE_DIRECTORY for this setting to have an effect.

                  - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute
                  for video in EXT-X-STREAM-INF tag of variant manifest.

                  - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the
                  timecode.

                  - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

                  - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond
                  delta offset to fine tune the timestamps.

                - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

                  - **AdditionalManifests** *(list) --* By default, the service creates one .ism
                  Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output
                  group in your job. This default manifest references every output in the output
                  group. To create additional manifests that reference a subset of the outputs in
                  the output group, specify a list of them here.

                    - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                    manifest that you want the service to generate for this output group. Each
                    manifest can reference a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your Microsoft Smooth group is film-name.ismv.
                      If you enter "-no-premium" for this setting, then the file name the service
                      generates for this top-level manifest is film-name-no-premium.ismv.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines
                  identical audio encoding settings across a Microsoft Smooth output group into a
                  single audio stream.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* If you are using DRM, set DRM System
                  (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                  - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to
                  specify the mp4 fragment sizes in seconds. Fragment length must be compatible with
                  GOP size and frame rate.

                  - **ManifestEncoding** *(string) --* Use Manifest encoding
                  (MsSmoothManifestEncoding) to specify the encoding format for the server and
                  client manifest. Valid options are utf8 and utf16.

                - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
                Microsoft Smooth Streaming, CMAF)

              - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
              settings per output.

                - *(dict) --* An output object describes the settings for a single output file or
                stream in an output group.

                  - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
                  encoding settings organized by audio codec. Include one instance of
                  (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
                  encoding settings.

                    - *(dict) --* Description of audio output

                      - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                      settings. Ignore these settings unless you need to comply with a loudness
                      standard.

                        - **Algorithm** *(string) --* Choose one of the following audio
                        normalization algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement
                        of ungated average loudness for an entire piece of content, suitable for
                        measurement of short-form content under ATSC recommendation A/85. Supports
                        up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
                        gated average loudness compliant with the requirements of EBU-R128. Supports
                        up to 5.1 audio channels. ITU-R BS.1770-3: Modified peak. The same loudness
                        measurement algorithm as 1770-2, with an updated true peak measurement.
                        ITU-R BS.1770-4: Higher channel count. Allows for more audio channels than
                        the other algorithms, including configurations such as 7.1.

                        - **AlgorithmControl** *(string) --* When enabled the output audio is
                        corrected using the chosen algorithm. If disabled, the audio will be
                        measured but not adjusted.

                        - **CorrectionGateLevel** *(integer) --* Content measuring above this level
                        will be corrected to the target level. Content measuring below this level
                        will not be corrected. Gating only applies when not using
                        real_time_correction.

                        - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio
                        track loudness to a CSV file.

                        - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log
                        the TruePeak for each output's audio track loudness.

                        - **TargetLkfs** *(float) --* When you use Audio normalization
                        (AudioNormalizationSettings), optionally use this setting to specify a
                        target loudness. If you don't specify a value here, the encoder chooses a
                        value for you, based on the algorithm that you choose for Algorithm
                        (algorithm). If you choose algorithm 1770-1, the encoder will choose -24
                        LKFS; otherwise, the encoder will choose -23 LKFS.

                      - **AudioSourceName** *(string) --* Specifies which audio data to use from
                      each input. In the simplest case, specify an "Audio
                      Selector":#inputs-audio_selector by name based on its order within each input.
                      For example if you specify "Audio Selector 3", then the third audio selector
                      will be used from each input. If an input does not have an "Audio Selector 3",
                      then the audio selector marked as "default" in that input will be used. If
                      there is no audio selector marked as "default", silence will be inserted for
                      the duration of that input. Alternatively, an "Audio Selector
                      Group":#inputs-audio_selector_group name may be specified, with similar
                      default/silence behavior. If no audio_source_name is specified, then "Audio
                      Selector 1" will be chosen automatically.

                      - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                      unchecked (false). A number between 0 and 255. The following are defined in
                      ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                           Hearing Impaired, 3 =
                      Visually Impaired Commentary, 4-255 = Reserved.

                      - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                      contains an ISO 639 audio_type, then that value is passed through to the
                      output. If the input contains no ISO 639 audio_type, the value in Audio Type
                      is included in the output. Otherwise the value in Audio Type is included in
                      the output. Note that this field and audioType are both ignored if
                      audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

                      - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                      (AudioDescriptions) contains the group of settings related to audio encoding.
                      The settings in this group vary depending on the value that you choose for
                      Audio codec (Codec). For each codec enum that you choose, define the
                      corresponding settings object. The following lists the codec enum, settings
                      object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF,
                      AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
                      Eac3AtmosSettings

                        - **AacSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts
                        one of two mutually exclusive groups of AAC settings--VBR and CBR. To select
                        one of these modes, set the value of Bitrate control mode (rateControlMode)
                        to "VBR" or "CBR". In VBR mode, you control the audio quality with the
                        setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
                        (bitrate). Defaults and valid values depend on the rate control mode.

                          - **AudioDescriptionBroadcasterMix** *(string) --* Choose
                          BROADCASTER_MIXED_AD when the input contains pre-mixed main audio + audio
                          description (AD) as a stereo pair. The value for AudioType will be set to
                          3, which signals to downstream systems that this stream contains
                          "broadcaster mixed AD". Note that the input received by the encoder must
                          contain pre-mixed audio; the encoder does not perform the mixing. When you
                          choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                          AudioType and FollowInputAudioType. Choose NORMAL when the input does not
                          contain pre-mixed audio + audio description (AD). In this case, the
                          encoder will use any values you provide for AudioType and
                          FollowInputAudioType.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. The set of valid values for this setting is: 6000, 8000, 10000,
                          12000, 14000, 16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000,
                          64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
                          288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
                          1024000. The value you set is also constrained by the values that you
                          choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                          Sample rate (sampleRate). Default values depend on Bitrate control mode
                          and Profile.

                          - **CodecProfile** *(string) --* AAC Profile.

                          - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or
                          5.1 channel layout. Valid values depend on rate control mode and profile.
                          "1.0 - Audio Description (Receiver Mix)" setting receives a stereo
                          description plus control track and emits a mono AAC encode of the
                          description track, with control data emitted in the PES header as per ETSI
                          TS 101 154 Annex E.

                          - **RateControlMode** *(string) --* Rate Control Mode.

                          - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if
                          you use LATM/LOAS AAC in an output, you must choose "No container" for the
                          output container.

                          - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on
                          rate control mode and profile.

                          - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC
                          audio for raw or MPEG-2 Transport Stream containers.

                          - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                          rate_control_mode is VBR.

                        - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AC3.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid bitrates depend on the coding mode.

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                          stream that the encoder emits. For more information about the AC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* Dolby Digital coding mode. Determines
                          number of channels.

                          - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank
                          and input audio is Dolby Digital, dialnorm will be passed through.

                          - **DynamicRangeCompressionProfile** *(string) --* If set to
                          FILM_STANDARD, adds dynamic range compression signaling to the output
                          bitstream as defined in the Dolby Digital specification.

                          - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                          channel prior to encoding. Only valid with 3_2_LFE coding mode.

                          - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                          metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                          this audio data. If audio was not supplied from one of these streams, then
                          the static metadata settings will be used.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                        - **AiffSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AIFF.

                          - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                          sample, to choose the encoding quality for this audio track.

                          - **Channels** *(integer) --* Specify the number of channels in this
                          output audio track. Valid values are 1 and even numbers up to 64. For
                          example, 1, 2, 4, 6, and so on, up to 64.

                          - **SampleRate** *(integer) --* Sample rate in hz.

                        - **Codec** *(string) --* Type of Audio codec.

                        - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid values: 384k, 448k, 640k, 768k

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the
                          E-AC-3 stream that the encoder emits. For more information about the EAC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                          (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                          - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue
                          Intelligence to adjust loudness based on dialogue analysis.

                          - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                          level for a signal with dynamic range compression.

                          - **DynamicRangeCompressionRf** *(string) --* Specify how the service
                          limits the audio dynamic range when compressing the audio.

                          - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left only/Right only center mix (Lo/Ro center).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
                          and -6.0.

                          - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert
                          uses this value for downmixing. How the service uses this value depends on
                          the value that you choose for Stereo downmix (Eac3AtmosStereoDownmix).
                          Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                          channel.

                          - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left total/Right total center mix (Lt/Rt center).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
                          and -6.0.

                          - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
                          The value -60 mutes the channel.

                          - **MeteringMode** *(string) --* Choose how the service meters the
                          loudness of your audio.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                          - **SpeechThreshold** *(integer) --* Specify the percentage of audio
                          content that must be speech before the encoder uses the measured speech
                          loudness as the overall program loudness.

                          - **StereoDownmix** *(string) --* Choose how the service does stereo
                          downmixing.

                          - **SurroundExMode** *(string) --* Specify whether your input audio has an
                          additional center rear surround channel matrix encoded into your left and
                          right surround channels.

                        - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value EAC3.

                          - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a
                          3 dB attenuation to the surround channels. Only used for 3/2 coding mode.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid bitrates depend on the coding mode.

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the
                          E-AC-3 stream that the encoder emits. For more information about the EAC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                          number of channels.

                          - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                          channels.

                          - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank
                          and input audio is Dolby Digital Plus, dialnorm will be passed through.

                          - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                          level for a signal with dynamic range compression.

                          - **DynamicRangeCompressionRf** *(string) --* Specify how the service
                          limits the audio dynamic range when compressing the audio.

                          - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether
                          the LFE channel is enabled

                          - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                          channel prior to encoding. Only valid with 3_2_LFE coding mode.

                          - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left only/Right only center mix (Lo/Ro
                          center). MediaConvert uses this value for downmixing. How the service uses
                          this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                          and -60. The value -60 mutes the channel. This setting applies only if you
                          keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                          setting Coding mode (Eac3CodingMode). If you choose a different value for
                          Coding mode, the service ignores Left only/Right only center
                          (loRoCenterMixLevel).

                          - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                          value -60 mutes the channel. This setting applies only if you keep the
                          default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                          Coding mode (Eac3CodingMode). If you choose a different value for Coding
                          mode, the service ignores Left only/Right only surround
                          (loRoSurroundMixLevel).

                          - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left total/Right total center mix (Lt/Rt
                          center). MediaConvert uses this value for downmixing. How the service uses
                          this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                          and -60. The value -60 mutes the channel. This setting applies only if you
                          keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                          setting Coding mode (Eac3CodingMode). If you choose a different value for
                          Coding mode, the service ignores Left total/Right total center
                          (ltRtCenterMixLevel).

                          - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                          surround). MediaConvert uses this value for downmixing. How the service
                          uses this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                          value -60 mutes the channel. This setting applies only if you keep the
                          default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                          Coding mode (Eac3CodingMode). If you choose a different value for Coding
                          mode, the service ignores Left total/Right total surround
                          (ltRtSurroundMixLevel).

                          - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                          metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                          this audio data. If audio was not supplied from one of these streams, then
                          the static metadata settings will be used.

                          - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input
                          DD+ audio will be passed through if it is present on the input. this
                          detection is dynamic over the life of the transcode. Inputs that alternate
                          between DD+ and non-DD+ content will have a consistent DD+ output as the
                          system alternates between passthrough and encoding.

                          - **PhaseControl** *(string) --* Controls the amount of phase-shift
                          applied to the surround channels. Only used for 3/2 coding mode.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                          - **StereoDownmix** *(string) --* Choose how the service does stereo
                          downmixing. This setting only applies if you keep the default value of 3/2
                          - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                          (Eac3CodingMode). If you choose a different value for Coding mode, the
                          service ignores Stereo downmix (Eac3StereoDownmix).

                          - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether
                          an extra center back surround channel is matrix encoded into the left and
                          right surround channels.

                          - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether
                          Dolby Surround is matrix encoded into the two channels.

                        - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value MP2.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second.

                          - **Channels** *(integer) --* Set Channels to specify the number of
                          channels in this output audio track. Choosing Mono in the console will
                          give you 1 output channel; choosing Stereo will give you 2. In the API,
                          valid values are 1 and 2.

                          - **SampleRate** *(integer) --* Sample rate in hz.

                        - **WavSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value WAV.

                          - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                          sample, to choose the encoding quality for this audio track.

                          - **Channels** *(integer) --* Specify the number of channels in this
                          output audio track. Valid values are 1 and even numbers up to 64. For
                          example, 1, 2, 4, 6, and so on, up to 64.

                          - **Format** *(string) --* The service defaults to using RIFF for WAV
                          outputs. If your output audio is likely to exceed 4 GB in file size, or if
                          you otherwise need the extended support of the RF64 format, set your
                          output WAV file format to RF64.

                          - **SampleRate** *(integer) --* Sample rate in Hz.

                      - **CustomLanguageCode** *(string) --* Specify the language for this audio
                      output track. The service puts this language code into your output audio track
                      when you set Language code control (AudioLanguageCodeControl) to Use
                      configured (USE_CONFIGURED). The service also uses your specified custom
                      language code when you set Language code control (AudioLanguageCodeControl) to
                      Follow input (FOLLOW_INPUT), but your input file doesn't specify a language
                      code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
                      streaming outputs, you can also use any other code in the full RFC-5646
                      specification. Streaming outputs are those that are in one of the following
                      output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                      - **LanguageCode** *(string) --* Indicates the language of the audio output
                      track. The ISO 639 language specified in the 'Language Code' drop down will be
                      used when 'Follow Input Language Code' is not selected or when 'Follow Input
                      Language Code' is selected but there is no ISO 639 language code specified by
                      the input.

                      - **LanguageCodeControl** *(string) --* Specify which source for language code
                      takes precedence for this audio track. When you choose Follow input
                      (FOLLOW_INPUT), the service uses the language code from the input track if
                      it's present. If there's no languge code on the input track, the service uses
                      the code that you specify in the setting Language code (languageCode or
                      customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
                      service uses the language code that you specify.

                      - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                        - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains
                        the group of fields that hold the remixing value for each channel. Units are
                        in dB. Acceptable values are within the range from -60 (mute) through 6. A
                        setting of 0 passes the input channel unchanged to the output channel (no
                        attenuation or amplification).

                          - **OutputChannels** *(list) --* List of output channels

                            - *(dict) --* OutputChannel mapping settings.

                              - **InputChannels** *(list) --* List of input channels

                                - *(integer) --*

                        - **ChannelsIn** *(integer) --* Specify the number of audio channels from
                        your input that you want to use in your output. With remixing, you might
                        combine or split the data in these channels, so the number of channels in
                        your final output might be different.

                        - **ChannelsOut** *(integer) --* Specify the number of channels in this
                        output after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even
                        numbers to 64.)

                      - **StreamName** *(string) --* Specify a label for this output audio stream.
                      For example, "English", "Director commentary", or "track_2". For streaming
                      outputs, MediaConvert passes this information into destination manifests for
                      display on the end-viewer's player device. For outputs in other output groups,
                      the service ignores this setting.

                  - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
                  captions settings. For each output that has captions, include one instance of
                  (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of
                  captions settings.

                    - *(dict) --* Description of Caption output

                      - **CaptionSelectorName** *(string) --* Specifies which "Caption
                      Selector":#inputs-caption_selector to use from each input when generating
                      captions. The name should be of the format "Caption Selector ", which denotes
                      that the Nth Caption Selector will be used from each input.

                      - **CustomLanguageCode** *(string) --* Specify the language for this captions
                      output track. For most captions output formats, the encoder puts this language
                      information in the output captions metadata. If your output captions format is
                      DVB-Sub or Burn in, the encoder uses this language information when
                      automatically selecting the font script for rendering the captions text. For
                      all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
                      outputs, you can also use any other code in the full RFC-5646 specification.
                      Streaming outputs are those that are in one of the following output groups:
                      CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                      - **DestinationSettings** *(dict) --* Specific settings required by
                      destination type. Note that burnin_destination_settings are not available if
                      the source of the caption data is Embedded or Teletext.

                        - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                          - **Alignment** *(string) --* If no explicit x_position or y_position is
                          provided, setting alignment to centered will place the captions at the
                          bottom center of the output. Similarly, setting a left alignment will
                          align captions to the bottom left of the output. If x and y positions are
                          given in conjunction with the alignment parameter, the font will be
                          justified (either left or centered) relative to those coordinates. This
                          option is not valid for source captions that are STL, 608/embedded or
                          teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                          behind the captions. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                          background rectangle. 255 is opaque; 0 is transparent. Leaving this
                          parameter blank is equivalent to setting it to 0 (transparent). All
                          burn-in and DVB-Sub font settings must match.

                          - **FontColor** *(string) --* Specifies the color of the burned-in
                          captions. This option is not valid for source captions that are STL,
                          608/embedded or teletext. These source settings are already pre-defined by
                          the caption stream. All burn-in and DVB-Sub font settings must match.

                          - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                          captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                          settings must match.

                          - **FontResolution** *(integer) --* Font resolution in DPI (dots per
                          inch); default is 96 dpi. All burn-in and DVB-Sub font settings must
                          match.

                          - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                          script code, if the LanguageCode is not sufficient for determining the
                          script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                          "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                          font for rendering burn-in captions.

                          - **FontSize** *(integer) --* A positive integer indicates the exact font
                          size in points. Set to 0 for automatic font size selection. All burn-in
                          and DVB-Sub font settings must match.

                          - **OutlineColor** *(string) --* Specifies font outline color. This option
                          is not valid for source captions that are either 608/embedded or teletext.
                          These source settings are already pre-defined by the caption stream. All
                          burn-in and DVB-Sub font settings must match.

                          - **OutlineSize** *(integer) --* Specifies font outline size in pixels.
                          This option is not valid for source captions that are either 608/embedded
                          or teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                          the captions. All burn-in and DVB-Sub font settings must match.

                          - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow.
                          255 is opaque; 0 is transparent. Leaving this parameter blank is
                          equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                          settings must match.

                          - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                          must match.

                          - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels above the text. All burn-in and DVB-Sub font
                          settings must match.

                          - **TeletextSpacing** *(string) --* Only applies to jobs with input
                          captions in Teletext or STL formats. Specify whether the spacing between
                          letters in your captions is set by the captions grid or varies depending
                          on letter width. Choose fixed grid to conform to the spacing specified in
                          the captions file more accurately. Choose proportional to make the text
                          easier to read if the captions are closed caption.

                          - **XPosition** *(integer) --* Specifies the horizontal position of the
                          caption relative to the left side of the output in pixels. A value of 10
                          would result in the captions starting 10 pixels from the left of the
                          output. If no explicit x_position is provided, the horizontal caption
                          position will be determined by the alignment parameter. This option is not
                          valid for source captions that are STL, 608/embedded or teletext. These
                          source settings are already pre-defined by the caption stream. All burn-in
                          and DVB-Sub font settings must match.

                          - **YPosition** *(integer) --* Specifies the vertical position of the
                          caption relative to the top of the output in pixels. A value of 10 would
                          result in the captions starting 10 pixels from the top of the output. If
                          no explicit y_position is provided, the caption will be positioned towards
                          the bottom of the output. This option is not valid for source captions
                          that are STL, 608/embedded or teletext. These source settings are already
                          pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                          must match.

                        - **DestinationType** *(string) --* Specify the format for this set of
                        captions on this output. The default format is embedded without SCTE-20.
                        Other options are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT,
                        teletext, TTML, and web-VTT. If you are using SCTE-20, choose SCTE-20 plus
                        embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the
                        SCTE-43 spec. To create a non-compliant output where the embedded captions
                        come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                        - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                          - **Alignment** *(string) --* If no explicit x_position or y_position is
                          provided, setting alignment to centered will place the captions at the
                          bottom center of the output. Similarly, setting a left alignment will
                          align captions to the bottom left of the output. If x and y positions are
                          given in conjunction with the alignment parameter, the font will be
                          justified (either left or centered) relative to those coordinates. This
                          option is not valid for source captions that are STL, 608/embedded or
                          teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                          behind the captions. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                          background rectangle. 255 is opaque; 0 is transparent. Leaving this
                          parameter blank is equivalent to setting it to 0 (transparent). All
                          burn-in and DVB-Sub font settings must match.

                          - **FontColor** *(string) --* Specifies the color of the burned-in
                          captions. This option is not valid for source captions that are STL,
                          608/embedded or teletext. These source settings are already pre-defined by
                          the caption stream. All burn-in and DVB-Sub font settings must match.

                          - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                          captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                          settings must match.

                          - **FontResolution** *(integer) --* Font resolution in DPI (dots per
                          inch); default is 96 dpi. All burn-in and DVB-Sub font settings must
                          match.

                          - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                          script code, if the LanguageCode is not sufficient for determining the
                          script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                          "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                          font for rendering DVB-Sub captions.

                          - **FontSize** *(integer) --* A positive integer indicates the exact font
                          size in points. Set to 0 for automatic font size selection. All burn-in
                          and DVB-Sub font settings must match.

                          - **OutlineColor** *(string) --* Specifies font outline color. This option
                          is not valid for source captions that are either 608/embedded or teletext.
                          These source settings are already pre-defined by the caption stream. All
                          burn-in and DVB-Sub font settings must match.

                          - **OutlineSize** *(integer) --* Specifies font outline size in pixels.
                          This option is not valid for source captions that are either 608/embedded
                          or teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                          the captions. All burn-in and DVB-Sub font settings must match.

                          - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow.
                          255 is opaque; 0 is transparent. Leaving this parameter blank is
                          equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                          settings must match.

                          - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                          must match.

                          - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels above the text. All burn-in and DVB-Sub font
                          settings must match.

                          - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                          standard or for hearing impaired. Choose hearing impaired if your
                          subtitles include audio descriptions and dialogue. Choose standard if your
                          subtitles include only dialogue.

                          - **TeletextSpacing** *(string) --* Only applies to jobs with input
                          captions in Teletext or STL formats. Specify whether the spacing between
                          letters in your captions is set by the captions grid or varies depending
                          on letter width. Choose fixed grid to conform to the spacing specified in
                          the captions file more accurately. Choose proportional to make the text
                          easier to read if the captions are closed caption.

                          - **XPosition** *(integer) --* Specifies the horizontal position of the
                          caption relative to the left side of the output in pixels. A value of 10
                          would result in the captions starting 10 pixels from the left of the
                          output. If no explicit x_position is provided, the horizontal caption
                          position will be determined by the alignment parameter. This option is not
                          valid for source captions that are STL, 608/embedded or teletext. These
                          source settings are already pre-defined by the caption stream. All burn-in
                          and DVB-Sub font settings must match.

                          - **YPosition** *(integer) --* Specifies the vertical position of the
                          caption relative to the top of the output in pixels. A value of 10 would
                          result in the captions starting 10 pixels from the top of the output. If
                          no explicit y_position is provided, the caption will be positioned towards
                          the bottom of the output. This option is not valid for source captions
                          that are STL, 608/embedded or teletext. These source settings are already
                          pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                          must match.

                        - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                        embedded/ancillary caption outputs, including 608/708 Channel destination
                        number.

                          - **Destination608ChannelNumber** *(integer) --* Ignore this setting
                          unless your input captions are SCC format and your output captions are
                          embedded in the video stream. Specify a CC number for each captions
                          channel in this output. If you have two channels, choose CC numbers that
                          aren't in the same field. For example, choose 1 and 3. For more
                          information, see
                          https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                          - **Destination708ServiceNumber** *(integer) --* Ignore this setting
                          unless your input captions are SCC format and you want both 608 and 708
                          captions embedded in your output stream. Optionally, specify the 708
                          service number for each output captions channel. Choose a different number
                          for each channel. To use this setting, also set Force 608 to 708 upconvert
                          (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
                          settings. If you choose to upconvert but don't specify a 708 service
                          number, MediaConvert uses the number that you specify for CC channel
                          number (destination608ChannelNumber) for the 708 service number. For more
                          information, see
                          https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                        - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                        outputs.

                          - **StylePassthrough** *(string) --* Keep this setting enabled to have
                          MediaConvert use the font style and position information from the captions
                          source in the output. This option is available only when your input
                          captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
                          simplified output captions.

                        - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                          - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to
                          make sure that the captions and the video are synchronized in the output.
                          Specify a frame rate that matches the frame rate of the associated video.
                          If the video frame rate is 29.97, choose 29.97 dropframe
                          (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
                          drop_frame_timecode=
                              true; otherwise, choose 29.97 non-dropframe
                          (FRAMERATE_29_97_NON_DROPFRAME).

                        - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                        output

                          - **PageNumber** *(string) --* Set pageNumber to the Teletext page number
                          for the destination captions for this output. This value must be a
                          three-digit hexadecimal string; strings ending in -FF are invalid. If you
                          are passing through the entire set of Teletext data, do not use this
                          field.

                          - **PageTypes** *(list) --* Specify the page types for this Teletext page.
                          If you don't specify a value here, the service sets the page type to the
                          default value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the
                          entire set of Teletext data, don't use this field. When you pass through a
                          set of Teletext pages, your output has the same page types as your input.

                            - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                            Table 94

                        - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                        outputs, including Pass style information (TtmlStylePassthrough).

                          - **StylePassthrough** *(string) --* Pass through style and position
                          information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                          CFF-TT output or TTML output.

                      - **LanguageCode** *(string) --* Specify the language of this captions output
                      track. For most captions output formats, the encoder puts this language
                      information in the output captions metadata. If your output captions format is
                      DVB-Sub or Burn in, the encoder uses this language information to choose the
                      font language for rendering the captions text.

                      - **LanguageDescription** *(string) --* Specify a label for this set of output
                      captions. For example, "English", "Director commentary", or "track_2". For
                      streaming outputs, MediaConvert passes this information into destination
                      manifests for display on the end-viewer's player device. For outputs in other
                      output groups, the service ignores this setting.

                  - **ContainerSettings** *(dict) --* Container specific settings.

                    - **Container** *(string) --* Container for this output. Some containers require
                    a container settings object. If not specified, the default object will be
                    created.

                    - **F4vSettings** *(dict) --* Settings for F4v container

                      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV
                      atom is relocated to the beginning of the archive as required for progressive
                      downloading. Otherwise it is placed normally at the end.

                    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to
                    outputs in a File output group when the output's container (ContainerType) is
                    MPEG-2 Transport Stream (M2TS). In these assets, data is organized by the
                    program map table (PMT). Each transport stream program contains subsets of data,
                    including audio, video, and metadata. Each of these subsets of data has a
                    numerical label called a packet identifier (PID). Each transport stream program
                    corresponds to one MediaConvert output. The PMT lists the types of data in a
                    program along with their PID. Downstream systems and players use the program map
                    table to look up the PID for each type of data it accesses and then uses the
                    PIDs to locate specific data within the asset.

                      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                      models for Dolby Digital audio.

                      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert
                      for each PES packet.

                      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                      elementary audio streams you include in this output. Specify multiple PIDs as
                      a JSON array. Default is the range 482-492.

                        - *(integer) --*

                      - **Bitrate** *(integer) --* Specify the output bitrate of the transport
                      stream in bits per second. Setting to 0 lets the muxer automatically determine
                      the appropriate bitrate. Other common values are 3750000, 7500000, and
                      15000000.

                      - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                      interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                      this can lead to lower latency, but low-memory devices may not be able to play
                      back the stream without interruptions.

                      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT)
                      at the specified table repetition interval.

                        - **NetworkId** *(integer) --* The numeric value placed in the Network
                        Information Table (NIT).

                        - **NetworkName** *(string) --* The network name text placed in the
                        network_name_descriptor inside the Network Information Table. Maximum length
                        is 256 characters.

                        - **NitInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT)
                      at the specified table repetition interval.

                        - **OutputSdt** *(string) --* Selects method of inserting SDT information
                        into output stream. "Follow input SDT" copies SDT information from input
                        stream to output stream. "Follow input SDT if present" copies SDT
                        information from input stream to output stream if SDT information is present
                        in the input, otherwise it will fall back on the user-defined values. Enter
                        "SDT Manually" means user will enter the SDT information. "No SDT" means
                        output stream will not contain SDT information.

                        - **SdtInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                        - **ServiceName** *(string) --* The service name placed in the
                        service_descriptor in the Service Description Table. Maximum length is 256
                        characters.

                        - **ServiceProviderName** *(string) --* The service provider name placed in
                        the service_descriptor in the Service Description Table. Maximum length is
                        256 characters.

                      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                      subtitle data included in this output. Specify multiple PIDs as a JSON array.
                      Default is the range 460-479.

                        - *(integer) --*

                      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                      specified table repetition interval.

                        - **TdtInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for
                      DVB teletext data you include in this output. Default is 499.

                      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS,
                      audio EBP markers will be added to partitions 3 and 4. The interval between
                      these additional markers will be fixed, and will be slightly shorter than the
                      video EBP marker interval. When set to VIDEO_INTERVAL, these additional
                      markers will not be inserted. Only applicable when EBP segmentation markers
                      are is selected (segmentationMarkers is EBP or EBP_LEGACY).

                      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on.
                      They can either be placed only on the video PID, or on both the video PID and
                      all audio PIDs. Only applicable when EBP segmentation markers are is selected
                      (segmentationMarkers is EBP or EBP_LEGACY).

                      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field
                      in the PES header.

                      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT)
                      unless you know that your audio EBP markers are incorrectly appearing before
                      your video EBP markers. To correct this problem, set this value to Force
                      (FORCE).

                      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                      used with EBP markers.

                      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                      between Program Clock References (PCRs) inserted into the transport stream.

                      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                      Points do not come within the specified time interval of each other by looking
                      ahead at input video. If another EBP is going to come in within the specified
                      time interval, the current EBP is not emitted, and the segment is "stretched"
                      to the next marker. The lookahead value does not add latency to the system.
                      The Live Event must be configured elsewhere to create sufficient latency to
                      make the lookahead accurate.

                      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                      tracking will be detected in the input audio and an equivalent ID3 tag will be
                      inserted in the output.

                      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                      packets to insert into the transport stream. This can be used if a downstream
                      encryption system requires periodic null packets.

                      - **PatInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program
                      Clock Reference value is inserted for every Packetized Elementary Stream (PES)
                      header. This is effective only when the PCR PID is the same as the video or
                      audio elementary stream.

                      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the
                      program clock reference (PCR) in this output. If you do not specify a value,
                      the service will use the value for Video PID (VideoPid).

                      - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                      instances of the program map table (PMT) in the output transport stream.

                      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the
                      program map table (PMT) itself. Default is 480.

                      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of
                      the private metadata stream. Default is 503.

                      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to
                      specify the program number used in the program map table (PMT) for this
                      output. Default is 1. Program numbers and program map tables are parts of
                      MPEG-2 transport stream containers, used for organizing data.

                      - **RateMode** *(string) --* When set to CBR, inserts null packets into
                      transport stream to fill specified bitrate. When set to VBR, the bitrate
                      setting acts as the maximum bitrate, but the output will not be padded up to
                      that bitrate.

                      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                      markers in your HLS and transport stream outputs at the insertion points that
                      you specify in an ESAM XML document. Provide the document in the setting SCC
                      XML (sccXml).

                        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35
                        stream in the transport stream generated by ESAM.

                      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the
                      SCTE-35 stream in the transport stream.

                      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                      Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your
                      input to also appear in this output. Choose None (NONE) if you don't want
                      SCTE-35 markers in this output. For SCTE-35 markers from an ESAM XML
                      document-- Choose None (NONE). Also provide the ESAM XML as a string in the
                      setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
                      (include the property scte35Esam).

                      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                      segmentation_time period. rai_segstart sets the Random Access Indicator bit in
                      the adaptation field. rai_adapt sets the RAI bit and adds the current timecode
                      in the private data bytes. psi_segstart inserts PAT and PMT tables at the
                      start of segments. ebp adds Encoder Boundary Point information to the
                      adaptation field as per OpenCable specification OC-SP-EBP-I01-130118.
                      ebp_legacy adds Encoder Boundary Point information to the adaptation field
                      using a legacy proprietary format.

                      - **SegmentationStyle** *(string) --* The segmentation style parameter
                      controls how segmentation markers are inserted into the transport stream. With
                      avails, it is possible that segments may be truncated, which can influence
                      where future segmentation markers are inserted. When a segmentation style of
                      "reset_cadence" is selected and a segment is truncated due to an avail, we
                      will reset the segmentation cadence. This means the subsequent segment will
                      have a duration of of $segmentation_time seconds. When a segmentation style of
                      "maintain_cadence" is selected and a segment is truncated due to an avail, we
                      will not reset the segmentation cadence. This means the subsequent segment
                      will likely be truncated as well. However, all segments after that will have a
                      duration of $segmentation_time seconds. Note that EBP lookahead is a slight
                      exception to this rule.

                      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                      segment. Required unless markers is set to _none_.

                      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                      timed metadata in this output. Default is 502.

                      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                      itself in the program map table for this output. Transport stream IDs and
                      program map tables are parts of MPEG-2 transport stream containers, used for
                      organizing data.

                      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                      elementary video stream in the transport stream.

                    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert
                      for each PES packet.

                      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                      stream(s) in the transport stream. Multiple values are accepted, and can be
                      entered in ranges and/or by comma separation.

                        - *(integer) --*

                      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                      tracking will be detected in the input audio and an equivalent ID3 tag will be
                      inserted in the output.

                      - **PatInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program
                      Clock Reference value is inserted for every Packetized Elementary Stream (PES)
                      header. This parameter is effective only when the PCR PID is the same as the
                      video or audio elementary stream.

                      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock
                      Reference (PCR) in the transport stream. When no value is given, the encoder
                      will assign the same value as the Video PID.

                      - **PmtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                      (PMT) in the transport stream.

                      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                      metadata stream in the transport stream.

                      - **ProgramNumber** *(integer) --* The value of the program number field in
                      the Program Map Table.

                      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                      in the transport stream.

                      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                      Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your
                      input to also appear in this output. Choose None (NONE) if you don't want
                      SCTE-35 markers in this output. For SCTE-35 markers from an ESAM XML
                      document-- Choose None (NONE) if you don't want manifest conditioning. Choose
                      Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want
                      manifest conditioning. In both cases, also provide the ESAM XML as a string in
                      the setting Signal processing notification XML (sccXml).

                      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this
                      setting to specify whether the service inserts the ID3 timed metadata from the
                      input in this output.

                      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                      metadata stream in the transport stream.

                      - **TransportStreamId** *(integer) --* The value of the transport stream ID
                      field in the Program Map Table.

                      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                      stream in the transport stream.

                    - **MovSettings** *(dict) --* Settings for MOV Container.

                      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate
                      for the video output settings.

                      - **CslgAtom** *(string) --* When enabled, file composition times will start
                      at zero, composition times in the 'ctts' (composition time to sample) box for
                      B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                      will be included per 14496-1 amendment 1. This improves compatibility with
                      Apple players and tools.

                      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                      streams into the QuickTime file using XDCAM fourcc codes. This increases
                      compatibility with Apple editors and players, but may decrease compatibility
                      with other players. Only applicable when the video codec is MPEG2.

                      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                      padding

                      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED)
                      for this setting.

                    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create
                    audio-only AAC outputs with this container.

                      - **CslgAtom** *(string) --* When enabled, file composition times will start
                      at zero, composition times in the 'ctts' (composition time to sample) box for
                      B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                      will be included per 14496-1 amendment 1. This improves compatibility with
                      Apple players and tools.

                      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after
                      the moov box.

                      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV
                      atom is relocated to the beginning of the archive as required for progressive
                      downloading. Otherwise it is placed normally at the end.

                      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the
                      output file. Usually not necessary to specify.

                    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                      - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                      groups that include sidecar TTML or IMSC captions. You specify sidecar
                      captions in a separate output from your audio and video. Choose Raw (RAW) for
                      captions in a single XML file in a raw container. Choose Fragmented MPEG-4
                      (FRAGMENTED_MP4) for captions in XML format contained within fragmented MP4
                      files. This set of fragmented MP4 files is separate from your video and audio
                      fragmented MP4 files.

                      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                      markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                      insertion points that you specify in an ESAM XML document. Provide the
                      document in the setting SCC XML (sccXml).

                      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                      markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                      SCTE-35 markers that appear in your input to also appear in this output.
                      Choose None (NONE) if you don't want those SCTE-35 markers in this output.

                  - **Extension** *(string) --* Use Extension (Extension) to specify the file
                  extension for outputs in File output groups. If you do not specify a value, the
                  service will use default extensions by container type as follows * MPEG-2
                  transport stream, m2ts * Quicktime, mov * MXF container, mxf * MPEG-4 container,
                  mp4 * No Container, the service will use codec extensions (e.g. AAC, H265, H265,
                  AC3)

                  - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the
                  service add a string to the end of each output filename. You specify the base
                  filename as part of your destination URI. When you create multiple outputs in the
                  same output group, Name modifier (NameModifier) is required. Name modifier also
                  accepts format identifiers. For DASH ISO outputs, if you use the format
                  identifiers $Number$ or $Time$ in one output, you must use them in the same way in
                  all outputs of the output group.

                  - **OutputSettings** *(dict) --* Specific settings for this type of output.

                    - **HlsSettings** *(dict) --* Settings for HLS output groups

                      - **AudioGroupId** *(string) --* Specifies the group to which the audio
                      Rendition belongs.

                      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                      outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                      container. Keep the default value Automatic (AUTOMATIC) to create an
                      audio-only file in a raw container. Regardless of the value that you specify
                      here, if this output has video, the service will place the output into an
                      MPEG2-TS container.

                      - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                      with the video output stream. Input all the audio GROUP-IDs that are
                      associated to the video, separate by ','.

                      - **AudioTrackType** *(string) --* Four types of audio-only tracks are
                      supported: Audio-Only Variant Stream The client can play back this audio-only
                      stream instead of video in low-bandwidth scenarios. Represented as an
                      EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select, Default
                      Alternate rendition that the client should try to play back by default.
                      Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES,
                      AUTOSELECT=
                          YES Alternate Audio, Auto Select, Not Default Alternate rendition
                      that the client may try to play back by default. Represented as an EXT-X-MEDIA
                      in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                          YES Alternate Audio, not Auto
                      Select Alternate rendition that the client will not try to play back by
                      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
                      AUTOSELECT=NO

                      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame
                      Only Manifest in addition to the HLS manifest

                      - **SegmentModifier** *(string) --* String concatenated to end of segment
                      filenames. Accepts "Format Identifiers":#format_identifier_parameters.

                  - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
                  transcoding settings. Provide the system or custom preset name. You can specify
                  either Preset (Preset) or Container settings (ContainerSettings), but not both.

                  - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
                  encoding settings. The specific video settings depend on the video codec that you
                  choose when you specify a value for Video codec (codec). Include one instance of
                  (VideoDescription) per output.

                    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                    MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                    service includes AFD values in the output video data and what those values are.
                    * Choose None to remove all AFD values from this output. * Choose Fixed to
                    ignore input AFD values and instead encode the value specified in the job. *
                    Choose Auto to calculate output AFD values based on the input AFD scaler data.

                    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to
                    all outputs. The service no longer accepts the value DISABLED for AntiAlias. If
                    you specify that in your job, the service will ignore the setting.

                    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                    (VideoDescription), contains the group of settings related to video encoding.
                    The settings in this group vary depending on the value that you choose for Video
                    codec (Codec). For each codec enum that you choose, define the corresponding
                    settings object. The following lists the codec enum, settings object pairs. *
                    H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
                    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

                      - **Codec** *(string) --* Specifies the video codec. This must be equal to one
                      of the enum values defined by the object VideoCodec.

                      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                        - **FramerateDenominator** *(integer) --* Frame capture will encode the
                        first frame of the output stream, then one frame every
                        framerateDenominator/framerateNumerator seconds. For example, settings of
                        framerateNumerator = 1 and framerateDenominator =
                             3 (a rate of 1/3 frame per
                        second) will capture the first frame, then 1 frame every 3s. Files will be
                        named as filename.n.jpg where n is the 0-based sequence number of each
                        Capture.

                        - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                        frame of the output stream, then one frame every
                        framerateDenominator/framerateNumerator seconds. For example, settings of
                        framerateNumerator = 1 and framerateDenominator =
                             3 (a rate of 1/3 frame per
                        second) will capture the first frame, then 1 frame every 3s. Files will be
                        named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number
                        zero padded to 7 decimal places.

                        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg
                        output files).

                        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                        quality.

                      - **H264Settings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value H_264.

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent
                        with your output video settings. If you aren't sure what level to specify,
                        choose Auto (AUTO).

                        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit
                        profiles are only available with the AVC-I License.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must
                        be in Main or High profile) or CAVLC.

                        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF
                        encoding for interlaced outputs.

                        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame to reduce flicker or 'pop' on I-frames.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job specification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* When you use the API for transcode
                        jobs that use frame rate conversion, specify the frame rate as a fraction.
                        For example, 24000 / 1001 =
                             23.976 fps. Use FramerateDenominator to specify
                        the denominator of this fraction. In this example, use 1001 for the value of
                        FramerateDenominator. When you use the console for transcode jobs that use
                        frame rate conversion, provide the value as a decimal number for Framerate.
                        In this example, specify 23.976.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                        structures that have B frames > 1.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type, as follows. - If the source is
                        interlaced, the output will be interlaced with the same polarity as the
                        source (it will follow the source). The output could therefore be a mix of
                        "top field first" and "bottom field first". - If the source is progressive,
                        the output will be interlaced with "top field first" or "bottom field first"
                        polarity, depending on which of the Follow options you chose.

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000. Required when Rate control mode
                        is QVBR.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **NumberReferenceFrames** *(integer) --* Number of reference frames to
                        use. The encoder may use more than requested if using B-frames and/or
                        interlaced encoding.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                        high-quality singlepass, or high-quality multipass video encoding.

                        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                        encoding with the H.264 codec. Required when you set Rate control mode to
                        QVBR. Not valid when you set Rate control mode to a value other than QVBR,
                        or when you don't define Rate control mode.

                          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                          control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                          average bitrate values suited to the complexity of your input video, the
                          service limits the average bitrate of the video part of this output to the
                          value that you choose. That is, the total size of the video element is
                          less than or equal to the value you set multiplied by the number of
                          seconds of encoded output.

                          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                          control mode. That is, when you specify qvbrSettings within h264Settings.
                          Specify the target quality level for this output, from 1 to 10. Use higher
                          numbers for greater quality. Level 10 results in nearly lossless
                          compression. The quality level for most broadcast-quality transcodes is
                          between 6 and 9.

                        - **RateControlMode** *(string) --* Use this setting to specify whether this
                        output has a variable bitrate (VBR), constant bitrate (CBR) or
                        quality-defined variable bitrate (QVBR).

                        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture,
                        even if repeated.

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default. If this output uses QVBR, choose
                        Transition detection (TRANSITION_DETECTION) for further video quality
                        improvement. For more information about QVBR, see
                        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                        - **Slices** *(integer) --* Number of slices per picture. Must be less than
                        or equal to the number of macroblock rows for progressive pictures, and less
                        than or equal to half the number of macroblock rows for interlaced pictures.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                        values reduce high-frequency content in the encoded image.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE
                        RP-2027.

                        - **Telecine** *(string) --* This field applies only if the Streams >
                        Advanced > Framerate (framerate) field is set to 29.970. This field works
                        with the Streams > Advanced > Preprocessors > Deinterlacer field
                        (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
                        (interlace_mode) to identify the scan type for the output: Progressive,
                        Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
                        from 23.976 input. - Soft: produces 23.976; the player converts this output
                        to 29.97i.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame
                        as 4 bytes of an unregistered SEI message.

                      - **H265Settings** *(dict) --* Settings for H265 codec

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                        Function SEI message for outputs using Hybrid Log Gamma (HLG)
                        Electro-Optical Transfer Function (EOTF).

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* H.265 Level.

                        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the
                        HEVC (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                        "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                        available with the HEVC 4:2:2 License.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame to reduce flicker or 'pop' on I-frames.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                        structures that have B frames > 1.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                        Choose Progressive (PROGRESSIVE) to create a progressive output, regardless
                        of the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom
                        Field First (BOTTOM_FIELD) to create an output that's interlaced with the
                        same field polarity throughout. Choose Follow, Default Top
                        (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
                        an interlaced output with the same field polarity as the source. If the
                        source is interlaced, the output will be interlaced with the same polarity
                        as the source (it will follow the source). The output could therefore be a
                        mix of "top field first" and "bottom field first". If the source is
                        progressive, your output will be interlaced with "top field first" or
                        "bottom field first" polarity, depending on which of the Follow options you
                        chose. If you don't choose a value, the service will default to Progressive
                        (PROGRESSIVE).

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000. Required when Rate control mode
                        is QVBR.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **NumberReferenceFrames** *(integer) --* Number of reference frames to
                        use. The encoder may use more than requested if using B-frames and/or
                        interlaced encoding.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                        high-quality singlepass, or high-quality multipass video encoding.

                        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                        encoding with the H.265 codec. Required when you set Rate control mode to
                        QVBR. Not valid when you set Rate control mode to a value other than QVBR,
                        or when you don't define Rate control mode.

                          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                          control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                          average bitrate values suited to the complexity of your input video, the
                          service limits the average bitrate of the video part of this output to the
                          value that you choose. That is, the total size of the video element is
                          less than or equal to the value you set multiplied by the number of
                          seconds of encoded output.

                          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                          control mode. That is, when you specify qvbrSettings within h265Settings.
                          Specify the target quality level for this output, from 1 to 10. Use higher
                          numbers for greater quality. Level 10 results in nearly lossless
                          compression. The quality level for most broadcast-quality transcodes is
                          between 6 and 9.

                        - **RateControlMode** *(string) --* Use this setting to specify whether this
                        output has a variable bitrate (VBR), constant bitrate (CBR) or
                        quality-defined variable bitrate (QVBR).

                        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                        Offset (SAO) filter strength. Adaptive mode dynamically selects best
                        strength based on content

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default. If this output uses QVBR, choose
                        Transition detection (TRANSITION_DETECTION) for further video quality
                        improvement. For more information about QVBR, see
                        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                        - **Slices** *(integer) --* Number of slices per picture. Must be less than
                        or equal to the number of macroblock rows for progressive pictures, and less
                        than or equal to half the number of macroblock rows for interlaced pictures.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Telecine** *(string) --* This field applies only if the Streams >
                        Advanced > Framerate (framerate) field is set to 29.970. This field works
                        with the Streams > Advanced > Preprocessors > Deinterlacer field
                        (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
                        (interlace_mode) to identify the scan type for the output: Progressive,
                        Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
                        from 23.976 input. - Soft: produces 23.976; the player converts this output
                        to 29.97i.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                        encoded bitstream. Up to 3 layers are supported depending on GOP structure:
                        I- and P-frames form one layer, reference B-frames can form a second layer
                        and non-reference b-frames can form a third layer. Decoders can optionally
                        decode only the lower temporal layers to generate a lower frame rate output.
                        For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e.
                        IbPbPb display order), a decoder could decode all the frames for full frame
                        rate output or only the I and P frames (lowest temporal layer) for a half
                        frame rate output.

                        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well
                        as vertical subdivision of the encoded pictures.

                        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame
                        as 4 bytes of an unregistered SEI message.

                        - **WriteMp4PackagingType** *(string) --* If the location of parameter set
                        NAL units doesn't matter in your workflow, ignore this setting. Use this
                        setting only with CMAF or DASH outputs, or with standalone file outputs in
                        an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your output as HVC1.
                        This makes your output compliant with the following specification: ISO
                        IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
                        outputs, the service stores parameter set NAL units in the sample headers
                        but not in the samples directly. For MP4 outputs, when you choose HVC1, your
                        output video might not work properly with some downstream systems and video
                        players. The service defaults to marking your output as HEV1. For these
                        outputs, the service writes parameter set NAL units directly into the
                        samples.

                      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value MPEG2.

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                        level for the video output.

                        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                        MPEG-2 profile for the video output.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type. - If the source is interlaced, the
                        output will be interlaced with the same polarity as the source (it will
                        follow the source). The output could therefore be a mix of "top field first"
                        and "bottom field first". - If the source is progressive, the output will be
                        interlaced with "top field first" or "bottom field first" polarity,
                        depending on which of the Follow options you chose.

                        - **IntraDcPrecision** *(string) --* Use Intra DC precision
                        (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                        coefficients. If you choose the value auto, the service will automatically
                        select the precision based on the per-frame compression ratio.

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or
                        multipass video encoding.

                        - **RateControlMode** *(string) --* Use Rate control mode
                        (Mpeg2RateControlMode) to specifiy whether the bitrate is variable (vbr) or
                        constant (cbr).

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                        values reduce high-frequency content in the encoded image.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                        356M-2001).

                        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                        Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard)
                        to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                        produce 23.976 output and leave converstion to the player.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                      - **ProresSettings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value PRORES.

                        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to
                        specifiy the type of Apple ProRes codec to use for this output.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* When you use the API for transcode
                        jobs that use frame rate conversion, specify the frame rate as a fraction.
                        For example, 24000 / 1001 =
                             23.976 fps. Use FramerateNumerator to specify
                        the numerator of this fraction. In this example, use 24000 for the value of
                        FramerateNumerator.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type. - If the source is interlaced, the
                        output will be interlaced with the same polarity as the source (it will
                        follow the source). The output could therefore be a mix of "top field first"
                        and "bottom field first". - If the source is progressive, the output will be
                        interlaced with "top field first" or "bottom field first" polarity,
                        depending on which of the Follow options you chose.

                        - **ParControl** *(string) --* Use (ProresParControl) to specify how the
                        service determines the pixel aspect ratio. Set to Follow source
                        (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio from the input. To
                        specify a different pixel aspect ratio: Using the console, choose it from
                        the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
                        provide for (ParNumerator) and (ParDenominator).

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                        Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard
                        (hard) to produce a 29.97i output from a 23.976 input. Set it to Soft (soft)
                        to produce 23.976 output and leave converstion to the player.

                    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to
                    include color metadata in this output. Choose Ignore (IGNORE) to exclude color
                    metadata from this output. If you don't specify a value, the service sets this
                    to Insert by default.

                    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area
                    that the service will include in the output video frame.

                      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                      numbers.

                      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                      numbers.

                      - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                      left edge of the video frame. Specify only even numbers.

                      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                      top edge of the video frame. Specify only even numbers.

                    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When
                    this feature is enabled, the service will use drop-frame timecode on outputs. If
                    it is not possible to use drop-frame timecode, the system will fall back to
                    non-drop-frame. This setting is enabled by default when Timecode insertion
                    (TimecodeInsertion) is enabled.

                    - **FixedAfd** *(integer) --* Applies only if you set AFD
                    Signaling(AfdSignaling) to Fixed (FIXED). Use Fixed (FixedAfd) to specify a
                    four-bit AFD value which the service will write on all frames of this video
                    output.

                    - **Height** *(integer) --* Use the Height (Height) setting to define the video
                    resolution height for this output. Specify in pixels. If you don't provide a
                    value here, the service will use the input height.

                    - **Position** *(dict) --* Use Selection placement (position) to define the
                    video area in your output frame. The area outside of the rectangle that you
                    specify here is black.

                      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                      numbers.

                      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                      numbers.

                      - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                      left edge of the video frame. Specify only even numbers.

                      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                      top edge of the video frame. Specify only even numbers.

                    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify
                    how the service changes the video itself in response to AFD values in the input.
                    * Choose Respond to clip the input video frame according to the AFD value, input
                    display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                    include the input AFD values. Do not choose this when AfdSignaling is set to
                    (NONE). A preferred implementation of this workflow is to set RespondToAfd to
                    (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
                    values from this output.

                    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                    have a different aspect ratio from the input aspect ratio. Choose Stretch to
                    output (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit.
                    Keep the setting Default (DEFAULT) to have the service letterbox your video
                    instead. This setting overrides any value that you specify for the setting
                    Selection placement (position) in this output.

                    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                    strength of anti-aliasing. This setting changes the width of the anti-alias
                    filter kernel used for scaling. Sharpness only applies if your output resolution
                    is different from your input resolution. 0 is the softest setting, 100 the
                    sharpest, and 50 recommended for most content.

                    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                    ProRes outputs. Only enable Timecode insertion when the input frame rate is
                    identical to the output frame rate. To include timecodes in this output, set
                    Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them
                    out, set it to DISABLED. Default is DISABLED. When the service inserts timecodes
                    in an output, by default, it uses any embedded timecodes from the input. If none
                    are present, the service will set the timecode for the first output frame to
                    zero. To change this default behavior, adjust the settings under Timecode
                    configuration (TimecodeConfig). In the console, these settings are located under
                    Job > Job settings > Timecode configuration. Note - Timecode source under input
                    settings (InputTimecodeSource) does not affect the timecodes that are inserted
                    in the output. Source under Job settings > Timecode configuration
                    (TimecodeSource) does.

                    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                    Preprocessors (VideoPreprocessors). Enable the features at each output
                    individually. These features are disabled by default.

                      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                      feature if necessary. Enable or disable this feature for each output
                      individually. This setting is disabled by default.

                        - **Brightness** *(integer) --* Brightness level.

                        - **ColorSpaceConversion** *(string) --* Specify the color space you want
                        for this output. The service supports conversion between HDR formats,
                        between SDR formats, and from SDR to HDR. The service doesn't support
                        conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
                        dynamic range. The converted video has an HDR format, but visually appears
                        the same as an unconverted output.

                        - **Contrast** *(integer) --* Contrast level.

                        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the
                        HDR 10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume
                        static metadata that you want signaled in the output. These values don't
                        affect the pixel values that are encoded in the video stream. They are
                        intended to help the downstream video player display content in a way that
                        reflects the intentions of the the content creator. When you set Color space
                        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings
                        are required. You must set values for Max frame average light level
                        (maxFrameAverageLightLevel) and Max content light level
                        (maxContentLightLevel); these settings don't have a default value. The
                        default values for the other HDR 10 metadata settings are defined by the
                        P3D65 color space. For more information about MediaConvert HDR jobs, see
                        https://docs.aws.amazon.com/console/mediaconvert/hdr.

                          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                          samples in the coded video sequence, in units of candelas per square
                          meter. This setting doesn't have a default value; you must specify a value
                          that is suitable for the content.

                          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level
                          of any frame in the coded video sequence, in units of candelas per square
                          meter. This setting doesn't have a default value; you must specify a value
                          that is suitable for the content.

                          - **MaxLuminance** *(integer) --* Nominal maximum mastering display
                          luminance in units of of 0.0001 candelas per square meter.

                          - **MinLuminance** *(integer) --* Nominal minimum mastering display
                          luminance in units of of 0.0001 candelas per square meter

                          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **WhitePointX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **WhitePointY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                        - **Hue** *(integer) --* Hue in degrees.

                        - **Saturation** *(integer) --* Saturation level.

                      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce
                      smoother motion and a clearer picture.

                        - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                        (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE).
                        Motion adaptive interpolate (INTERPOLATE) produces sharper pictures, while
                        blend (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR
                        (BLEND_TICKER) if your source file includes a ticker, such as a scrolling
                        headline at the bottom of the frame.

                        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                        does not convert frames that are tagged in metadata as progressive. It will
                        only convert those that are tagged as some other type. - When set to
                        FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive -
                        even those that are already tagged as progressive. Turn Force mode on only
                        if there is a good chance that the metadata has tagged frames as progressive
                        when they are not progressive. Do not turn on otherwise; processing frames
                        that are already progressive into progressive will probably result in lower
                        quality video.

                        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how
                        the service will do deinterlacing. Default is Deinterlace. - Deinterlace
                        converts interlaced to progressive. - Inverse telecine converts Hard
                        Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects and converts
                        to progressive.

                      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby
                      Vision compatible video output.

                        - **L6Metadata** *(dict) --* Use these settings when you set
                        DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values
                        in your input with new values.

                          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR
                          metadata that corresponds to the brightest pixel in the entire stream.
                          Measured in nits.

                          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                          metadata that corresponds to the highest frame-average brightness in the
                          entire stream. Measured in nits.

                        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service
                        will handle Dolby Vision MaxCLL and MaxFALL properies.

                        - **Profile** *(string) --* In the current MediaConvert implementation, the
                        Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs
                        must contain Dolby Vision frame interleaved data.

                      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter)
                      feature to include a graphic overlay on your video. Enable or disable this
                      feature for each output individually. This setting is disabled by default.

                        - **InsertableImages** *(list) --* Specify the images that you want to
                        overlay on your video. The images must be PNG or TGA files.

                          - *(dict) --* Settings that specify how your still graphic overlay
                          appears.

                            - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                            image to remain on the output video. This duration includes fade-in time
                            but not fade-out time.

                            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                            between the Start time that you specify for the image insertion and the
                            time that the image appears at full opacity. Full opacity is the level
                            that you specify for the opacity setting. If you don't specify a value
                            for Fade-in, the image will appear abruptly at the overlay start time.

                            - **FadeOut** *(integer) --* Specify the length of time, in
                            milliseconds, between the end of the time that you have specified for
                            the image overlay Duration and when the overlaid image has faded to
                            total transparency. If you don't specify a value for Fade-out, the image
                            will disappear abruptly at the end of the inserted image duration.

                            - **Height** *(integer) --* Specify the height of the inserted image in
                            pixels. If you specify a value that's larger than the video resolution
                            height, the service will crop your overlaid image to fit. To use the
                            native height of the image, keep this setting blank.

                            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or
                            Amazon S3 location of the image that you want to overlay on the video.
                            Use a PNG or TGA file.

                            - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                            inserted image and the left edge of the video frame. Required for any
                            image overlay that you specify.

                            - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                            overlaid image and the top edge of the video frame. Required for any
                            image overlay that you specify.

                            - **Layer** *(integer) --* Specify how overlapping inserted images
                            appear. Images with higher values for Layer appear on top of images with
                            lower values for Layer.

                            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much
                            of the underlying video shows through the inserted image. 0 is
                            transparent and 100 is fully opaque. Default is 50.

                            - **StartTime** *(string) --* Specify the timecode of the frame that you
                            want the overlay to first appear on. This must be in timecode
                            (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take into account your
                            timecode source settings.

                            - **Width** *(integer) --* Specify the width of the inserted image in
                            pixels. If you specify a value that's larger than the video resolution
                            width, the service will crop your overlaid image to fit. To use the
                            native width of the image, keep this setting blank.

                      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature
                      to remove noise from your video output if necessary. Enable or disable this
                      feature for each output individually. This setting is disabled by default.

                        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                        select one of the following spatial image filtering functions. To use this
                        setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                        preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos,
                        and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
                        noise reduction. * Spatial does frequency-domain filtering based on JND
                        principles. * Temporal optimizes video quality for complex motion.

                        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                          - **Strength** *(integer) --* Relative strength of noise reducing filter.
                          Higher values produce stronger filtering.

                        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                        spatial filter.

                          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post
                          noise reduction sharpening filter, with 0 disabling the filter and 3
                          enabling it at maximum strength.

                          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed)
                          to 3 (higher speed), with 0 being the nominal value.

                          - **Strength** *(integer) --* Relative strength of noise reducing filter.
                          Higher values produce stronger filtering.

                        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                        temporal filter.

                          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that
                          has complex motion. Higher values produce stronger temporal filtering.
                          This filters highly complex scenes more aggressively and creates better VQ
                          for low bitrate outputs.

                          - **Speed** *(integer) --* The speed of the filter (higher number is
                          faster). Low setting reduces bit rate at the cost of transcode time, high
                          setting improves transcode time at the cost of bit rate.

                          - **Strength** *(integer) --* Specify the strength of the noise reducing
                          filter on this output. Higher values produce stronger filtering. We
                          recommend the following value ranges, depending on the result that you
                          want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
                          complexity reduction with image preservation * 8-16 for a high level of
                          complexity reduction

                      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                      output timecode and specified prefix into the output.

                        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size
                        of any burned-in timecode. Valid values are 10, 16, 32, 48.

                        - **Position** *(string) --* Use Position (Position) under under Timecode
                        burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                        output video.

                        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters
                        before any burned-in timecode. For example, a prefix of "EZ-" will result in
                        the timecode "EZ-00:00:00:00". Provide either the characters themselves or
                        the ASCII code equivalents. The supported range of characters is 0x20
                        through 0x7e. This includes letters, numbers, and all special characters
                        represented on a standard English keyboard.

                    - **Width** *(integer) --* Use Width (Width) to define the video resolution
                    width, in pixels, for this output. If you don't provide a value here, the
                    service will use the input width.

          - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
          information from inputs.

            - **Anchor** *(string) --* If you use an editing platform that relies on an anchor
            timecode, use Anchor Timecode (Anchor) to specify a timecode that will match the input
            video frame to the output video frame. Use 24-hour format with frame number,
            (HH:MM:SS:FF) or (HH:MM:SS;FF). This setting ignores frame rate conversion. System
            behavior for Anchor Timecode varies depending on your setting for Source
            (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
            (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode
            (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate output
            timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
            is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first
            frame is the timecode value on the first input frame of the input.

            - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
            within this job. To make sure that your video, audio, captions, and markers are
            synchronized and that time-based features, such as image inserter, work correctly,
            choose the Timecode source option that matches your assets. All timecodes are in a
            24-hour format with frame number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode
            that is in the input video. If no embedded timecode is in the source, the service will
            use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) - Set the timecode of the
            initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set the timecode of
            the initial frame to a value other than zero. You use Start timecode (Start) to provide
            this value.

            - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified
            start (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the
            initial frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

            - **TimestampOffset** *(string) --* Only applies to outputs that support
            program-date-time stamp. Use Timestamp offset (TimestampOffset) to overwrite the
            timecode date without affecting the time and frame number. Provide the new date as a
            string in the format "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert
            program-date-time (InsertProgramDateTime) in the output settings. For example, if the
            date part of your timecodes is 2002-1-25 and you want to change it to one year later,
            set Timestamp offset (TimestampOffset) to 2003-1-25.

          - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
          (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you
          must enable it here, enable it in each output container, and specify tags and timecodes in
          ID3 insertion (Id3Insertion) objects.

            - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion
            instances.

              - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3)
              to specify the base 64 encoded string and use Timecode (TimeCode) to specify the time
              when the tag should be inserted. To insert multiple ID3 tags in your output, create
              multiple instances of ID3 insertion (Id3Insertion).

                - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
                format.

                - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or
                HH:MM:SS;FF format.

        - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
        events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
        MediaConvert sends an update at this interval from the time the service begins processing
        your job to the time it completes the transcode or encounters an error.

        - **Type** *(string) --* A job template can be of two types: system or custom. System or
        built-in job templates can't be modified or deleted by the user.
    """


_ListJobsPaginatePaginationConfigTypeDef = TypedDict(
    "_ListJobsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListJobsPaginatePaginationConfigTypeDef(_ListJobsPaginatePaginationConfigTypeDef):
    """
    Type definition for `ListJobsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_ListJobsPaginateResponseJobsAccelerationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsAccelerationSettingsTypeDef", {"Mode": str}, total=False
)


class ListJobsPaginateResponseJobsAccelerationSettingsTypeDef(
    _ListJobsPaginateResponseJobsAccelerationSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobs` `AccelerationSettings`

    - **Mode** *(string) --* Specify the conditions when the service will run your job with
    accelerated transcoding.
    """


_ListJobsPaginateResponseJobsMessagesTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsMessagesTypeDef",
    {"Info": List[str], "Warning": List[str]},
    total=False,
)


class ListJobsPaginateResponseJobsMessagesTypeDef(_ListJobsPaginateResponseJobsMessagesTypeDef):
    """
    Type definition for `ListJobsPaginateResponseJobs` `Messages`

    - **Info** *(list) --* List of messages that are informational only and don't indicate a problem
    with your job.

      - *(string) --*

    - **Warning** *(list) --* List of messages that warn about conditions that might cause your job
    not to run or to fail.

      - *(string) --*
    """


_ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef",
    {"HeightInPx": int, "WidthInPx": int},
    total=False,
)


class ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef(
    _ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetails` `VideoDetails`

    - **HeightInPx** *(integer) --* Height in pixels for the output

    - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsTypeDef",
    {
        "DurationInMs": int,
        "VideoDetails": ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsVideoDetailsTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsTypeDef(
    _ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsOutputGroupDetails` `OutputDetails`

    - **DurationInMs** *(integer) --* Duration in milliseconds

    - **VideoDetails** *(dict) --* Contains details about the output's video stream

      - **HeightInPx** *(integer) --* Height in pixels for the output

      - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ListJobsPaginateResponseJobsOutputGroupDetailsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsOutputGroupDetailsTypeDef",
    {"OutputDetails": List[ListJobsPaginateResponseJobsOutputGroupDetailsOutputDetailsTypeDef]},
    total=False,
)


class ListJobsPaginateResponseJobsOutputGroupDetailsTypeDef(
    _ListJobsPaginateResponseJobsOutputGroupDetailsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobs` `OutputGroupDetails`

    - **OutputDetails** *(list) --* Details about the output

      - *(dict) --* Details regarding output

        - **DurationInMs** *(integer) --* Duration in milliseconds

        - **VideoDetails** *(dict) --* Contains details about the output's video stream

          - **HeightInPx** *(integer) --* Height in pixels for the output

          - **WidthInPx** *(integer) --* Width in pixels for the output
    """


_ListJobsPaginateResponseJobsSettingsAvailBlankingTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsAvailBlankingTypeDef",
    {"AvailBlankingImage": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsAvailBlankingTypeDef(
    _ListJobsPaginateResponseJobsSettingsAvailBlankingTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettings` `AvailBlanking`

    - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
    Only bmp and png images are supported.
    """


_ListJobsPaginateResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef",
    {"MccXml": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef(
    _ListJobsPaginateResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsEsam`
    `ManifestConfirmConditionNotification`

    - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
    inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
    transcoder will use the Manifest Conditioning instructions in the message that you supply.
    """


_ListJobsPaginateResponseJobsSettingsEsamSignalProcessingNotificationTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsEsamSignalProcessingNotificationTypeDef",
    {"SccXml": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsEsamSignalProcessingNotificationTypeDef(
    _ListJobsPaginateResponseJobsSettingsEsamSignalProcessingNotificationTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsEsam` `SignalProcessingNotification`

    - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
    your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
    will use the signal processing instructions in the message that you supply. Provide your ESAM
    SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS file
    outputs, if you want the service to place SCTE-35 markers at the insertion points you specify in
    the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can either
    specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ListJobsPaginateResponseJobsSettingsEsamTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsEsamTypeDef",
    {
        "ManifestConfirmConditionNotification": ListJobsPaginateResponseJobsSettingsEsamManifestConfirmConditionNotificationTypeDef,
        "ResponseSignalPreroll": int,
        "SignalProcessingNotification": ListJobsPaginateResponseJobsSettingsEsamSignalProcessingNotificationTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsEsamTypeDef(
    _ListJobsPaginateResponseJobsSettingsEsamTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettings` `Esam`

    - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
    ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
    the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

      - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML document
      inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
      transcoder will use the Manifest Conditioning instructions in the message that you supply.

    - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
    between the SCTE 35 messages that the transcoder places and the splice points that they refer
    to. If the time between the start of the asset and the SCTE-35 message is less than this value,
    then the transcoder places the SCTE-35 marker at the beginning of the stream.

    - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
    XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
    that you provide in the setting SCC XML (sccXml).

      - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document inside
      your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The transcoder
      will use the signal processing instructions in the message that you supply. Provide your ESAM
      SignalProcessingNotification XML document inside your JSON job settings. For your MPEG2-TS
      file outputs, if you want the service to place SCTE-35 markers at the insertion points you
      specify in the XML document, you must also enable SCTE-35 ESAM (scte35Esam). Note that you can
      either specify an ESAM XML document or enable SCTE-35 passthrough. You can't do both.
    """


_ListJobsPaginateResponseJobsSettingsInputsAudioSelectorGroupsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsAudioSelectorGroupsTypeDef",
    {"AudioSelectorNames": List[str]},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsAudioSelectorGroupsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsAudioSelectorGroupsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputs` `AudioSelectorGroups`

    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to include
    in the group. Audio selector names are standardized, based on their order within the input
    (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to add any number
    of audio selectors to the group.

      - *(string) --*
    """


_ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef",
    {
        "ChannelMapping": ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsAudioSelectors` `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "DefaultSelection": str,
        "ExternalAudioFileInput": str,
        "LanguageCode": str,
        "Offset": int,
        "Pids": List[int],
        "ProgramSelection": int,
        "RemixSettings": ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsRemixSettingsTypeDef,
        "SelectorType": str,
        "Tracks": List[int],
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputs` `AudioSelectors`

    - **CustomLanguageCode** *(string) --* Selects a specific language code from within an audio
    source, using the ISO 639-2 or ISO 639-3 three-letter language code

    - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it as the
    default for the job. The service uses this default for outputs where it can't find the specified
    input audio. If you don't set a default, those outputs have no audio.

    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file source.

    - **LanguageCode** *(string) --* Selects a specific language code from within an audio source.

    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio from the
    input video.

    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257 selects PID
    0x101).

      - *(integer) --*

    - **ProgramSelection** *(integer) --* Use this setting for input streams that contain Dolby E,
    to have the service extract specific program data from the track. To select multiple programs,
    create multiple selectors with the same Track and different Program numbers. In the console,
    this setting is visible when you set Selector type to Track. Choose the program number from the
    dropdown list. If you are sending a JSON file, provide the program ID, which is part of the
    audio metadata. If your input file has incorrect metadata, you can choose All channels instead
    of a program number to have the service ignore the program IDs and include all the programs in
    the track.

    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one input to
    match those of another input. This allows you to combine the two files into a single output, one
    after the other.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **SelectorType** *(string) --* Specifies the type of the audio selector.

    - **Tracks** *(list) --* Identify a track from the input audio to include in this selector by
    entering the track index number. To include several tracks in a single audio selector, specify
    multiple tracks as follows. Using the console, enter a comma-separated list. For examle, type
    "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job file, provide the
    track numbers in an array. For example, "tracks": [1,2,3].

      - *(integer) --*
    """


_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef",
    {"Convert608To708": str, "SourceAncillaryChannelNumber": int, "TerminateCaptions": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `AncillarySourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
    ancillary data track from which to extract captions. Unused for passthrough.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef",
    {"Pid": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `DvbSubSourceSettings`

    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
    source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
    regardless of selectors.
    """


_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef",
    {
        "Convert608To708": str,
        "Source608ChannelNumber": int,
        "Source608TrackNumber": int,
        "TerminateCaptions": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `EmbeddedSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
    video track from which to extract captions. Unused for passthrough.

    - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
    captions. The system only supports one input video track, so this should always be set to '1'.

    - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
    captions at the end of each input. If you want the caption to continue onto your next input,
    disable this setting.
    """


_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef",
    {"Convert608To708": str, "SourceFile": str, "TimeDelta": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `FileSourceSettings`

    - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
    outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
    the captions data in two ways: it passes the 608 data through using the 608 compatibility bytes
    fields of the 708 wrapper, and it also translates the 608 data into 708.

    - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
    extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from the
    source file.
    """


_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef",
    {"PageNumber": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `TeletextSourceSettings`

    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
    hexadecimal page number that will be used for Teletext captions. Do not use this setting if you
    are passing through teletext from the input source to output.
    """


_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef",
    {"TrackNumber": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettings`
    `TrackSourceSettings`

    - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
    source. Track numbers correspond to the order in the captions source file. For IMF sources,
    track numbering is based on the order that the captions appear in the CPL. For example, use 1 to
    select the captions asset that is listed first in the CPL. To include more than one captions
    track in your job outputs, create multiple input captions selectors. Specify one track per
    selector.
    """


_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef",
    {
        "AncillarySourceSettings": ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsAncillarySourceSettingsTypeDef,
        "DvbSubSourceSettings": ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsDvbSubSourceSettingsTypeDef,
        "EmbeddedSourceSettings": ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsEmbeddedSourceSettingsTypeDef,
        "FileSourceSettings": ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsFileSourceSettingsTypeDef,
        "SourceType": str,
        "TeletextSourceSettings": ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTeletextSourceSettingsTypeDef,
        "TrackSourceSettings": ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTrackSourceSettingsTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsCaptionSelectors`
    `SourceSettings`

    - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
      ancillary data track from which to extract captions. Unused for passthrough.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

      - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
      source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
      regardless of selectors.

    - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
      video track from which to extract captions. Unused for passthrough.

      - **Source608TrackNumber** *(integer) --* Specifies the video track index used for extracting
      captions. The system only supports one input video track, so this should always be set to '1'.

      - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
      captions at the end of each input. If you want the caption to continue onto your next input,
      disable this setting.

    - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
    IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
    source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **Convert608To708** *(string) --* Specify whether this set of input captions appears in your
      outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert includes
      the captions data in two ways: it passes the 608 data through using the 608 compatibility
      bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

      - **SourceFile** *(string) --* External caption file used for loading captions. Accepted file
      extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

      - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
      the source file.

    - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
    captions. The service cannot auto-detect caption format.

    - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
    including Page number.

      - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
      hexadecimal page number that will be used for Teletext captions. Do not use this setting if
      you are passing through teletext from the input source to output.

    - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified by
    track number. Currently, this is only IMSC captions in an IMF package. If your caption source is
    IMSC 1.1 in a separate xml file, use FileSourceSettings instead of TrackSourceSettings.

      - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
      source. Track numbers correspond to the order in the captions source file. For IMF sources,
      track numbering is based on the order that the captions appear in the CPL. For example, use 1
      to select the captions asset that is listed first in the CPL. To include more than one
      captions track in your job outputs, create multiple input captions selectors. Specify one
      track per selector.
    """


_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsTypeDef",
    {
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "SourceSettings": ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsSourceSettingsTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputs` `CaptionSelectors`

    - **CustomLanguageCode** *(string) --* The specific language to extract from source, using the
    ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this field
    and/or PID to select the caption language to extract. If input is DVB-Sub and output is Burn-in
    or SMPTE-TT, complete this field and/or PID to select the caption language to extract. If input
    is DVB-Sub that is being passed through, omit this field (and PID field); there is no way to
    extract a specific language with pass-through captions.

    - **LanguageCode** *(string) --* The specific language to extract from source. If input is
    SCTE-27, complete this field and/or PID to select the caption language to extract. If input is
    DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption
    language to extract. If input is DVB-Sub that is being passed through, omit this field (and PID
    field); there is no way to extract a specific language with pass-through captions.

    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or IMSC in
    an xml file, specify the URI of the input captions source file. If your input captions are IMSC
    in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in the
        ancillary data track from which to extract captions. Unused for passthrough.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for the
        source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed through,
        regardless of selectors.

      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number within the
        video track from which to extract captions. Unused for passthrough.

        - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
        extracting captions. The system only supports one input video track, so this should always
        be set to '1'.

        - **TerminateCaptions** *(string) --* By default, the service terminates any unterminated
        captions at the end of each input. If you want the caption to continue onto your next input,
        disable this setting.

      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL, TTML, or
      IMSC 1.1 in an xml file, specify the URI of the input caption source file. If your caption
      source is IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

        - **Convert608To708** *(string) --* Specify whether this set of input captions appears in
        your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT), MediaConvert
        includes the captions data in two ways: it passes the 608 data through using the 608
        compatibility bytes fields of the 708 wrapper, and it also translates the 608 data into 708.

        - **SourceFile** *(string) --* External caption file used for loading captions. Accepted
        file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the captions from
        the source file.

      - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your input
      captions. The service cannot auto-detect caption format.

      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
      including Page number.

        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
        hexadecimal page number that will be used for Teletext captions. Do not use this setting if
        you are passing through teletext from the input source to output.

      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are specified
      by track number. Currently, this is only IMSC captions in an IMF package. If your caption
      source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead of
      TrackSourceSettings.

        - **TrackNumber** *(integer) --* Use this setting to select a single captions track from a
        source. Track numbers correspond to the order in the captions source file. For IMF sources,
        track numbering is based on the order that the captions appear in the CPL. For example, use
        1 to select the captions asset that is listed first in the CPL. To include more than one
        captions track in your job outputs, create multiple input captions selectors. Specify one
        track per selector.
    """


_ListJobsPaginateResponseJobsSettingsInputsCropTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsCropTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsCropTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputs` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ListJobsPaginateResponseJobsSettingsInputsDecryptionSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsDecryptionSettingsTypeDef",
    {
        "DecryptionMode": str,
        "EncryptedDecryptionKey": str,
        "InitializationVector": str,
        "KmsKeyRegion": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsDecryptionSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsDecryptionSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputs` `DecryptionSettings`

    - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt your
    input files.

    - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
    plaintext. Your job settings could be intercepted, making your encrypted content vulnerable.
    Specify the encrypted version of the data key that you used to encrypt your content. The data
    key must be encrypted by AWS Key Management Service (KMS). The key can be 128, 192, or 256 bits.

    - **InitializationVector** *(string) --* Specify the initialization vector that you used when
    you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
    initialization vector with any encryption mode. Or, you can use a 12-byte initialization vector
    with GCM or CTR. MediaConvert accepts only initialization vectors that are base64-encoded.

    - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service (KMS)
    that you used to encrypt your data key, if that Region is different from the one you are using
    for AWS Elemental MediaConvert.
    """


_ListJobsPaginateResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsImageInserter` `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ListJobsPaginateResponseJobsSettingsInputsImageInserterTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ListJobsPaginateResponseJobsSettingsInputsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsImageInserterTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsImageInserterTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputs` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ListJobsPaginateResponseJobsSettingsInputsInputClippingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsInputClippingsTypeDef",
    {"EndTimecode": str, "StartTimecode": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsInputClippingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsInputClippingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputs` `InputClippings`

    - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of the
    input you are clipping. The frame corresponding to the End timecode value is included in the
    clip. Start timecode or End timecode may be left blank, but not both. Use the format HH:MM:SS:FF
    or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF is the frame
    number. When choosing this value, take into account your setting for timecode source under input
    settings (InputTimecodeSource). For example, if you have embedded timecodes that start at
    01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

    - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
    portion of the input you are clipping. The frame corresponding to the Start timecode value is
    included in the clip. Start timecode or End timecode may be left blank, but not both. Use the
    format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and
    FF is the frame number. When choosing this value, take into account your setting for Input
    timecode source. For example, if you have embedded timecodes that start at 01:00:00:00 and you
    want your clip to begin five minutes into the video, use 01:05:00:00.
    """


_ListJobsPaginateResponseJobsSettingsInputsPositionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsPositionTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsPositionTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputs` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ListJobsPaginateResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputsVideoSelector` `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ListJobsPaginateResponseJobsSettingsInputsVideoSelectorTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsVideoSelectorTypeDef",
    {
        "AlphaBehavior": str,
        "ColorSpace": str,
        "ColorSpaceUsage": str,
        "Hdr10Metadata": ListJobsPaginateResponseJobsSettingsInputsVideoSelectorHdr10MetadataTypeDef,
        "Pid": int,
        "ProgramNumber": int,
        "Rotate": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsVideoSelectorTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsVideoSelectorTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsInputs` `VideoSelector`

    - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
    animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
    setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
    REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma channel
    of your outputs.

    - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if you
    don't know about color space, leave this set to the default value Follow (FOLLOW). The service
    will automatically detect your input color space. If your input video has metadata indicating
    the wrong color space, specify the accurate color space here. If your input video is HDR 10 and
    the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present in your video
    stream, or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10) here
    and specify correct values in the input HDR 10 metadata (Hdr10Metadata) settings. For more
    information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

    - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file and
    the job input settings Color space (ColorSpace) and HDR master display information
    settings(Hdr10Metadata). The Color space usage setting determines which takes precedence. Choose
    Force (FORCE) to use color metadata from the input job settings. If you don't specify values for
    those settings, the service defaults to using metadata from your input. FALLBACK - Choose
    Fallback (FALLBACK) to use color metadata from the source when it is present. If there's no
    color metadata in your input file, the service defaults to using values you specify in the input
    settings.

    - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing or
    inaccurate in your input video. Appropriate values vary depending on the input video and must be
    provided by a color grader. The color grader generates these values during the HDR 10 mastering
    process. The valid range for each of these settings is 0 to 50,000. Each increment represents
    0.00002 in CIE1931 color coordinate. Related settings - When you specify these values, you must
    also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
    specify here take precedence over the values in the metadata of your input file, set Color space
    usage (ColorSpaceUsage). To specify whether color metadata is included in an output, set Color
    metadata (ColorMetadata). For more information about MediaConvert HDR jobs, see
    https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file. Specify
    this value as an integer; the system automatically converts it to the hexidecimal value. For
    example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a set of data
    in an MPEG-2 transport stream container.

    - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
    transport stream. Note that Quad 4K is not currently supported.

    - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
    video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
    rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
    input has rotation metadata, you can choose Automatic to have the service rotate your video
    according to the rotation specified in the metadata. The rotation must be within one degree of
    90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service will
    default to no rotation. By default, the service does no rotation, even if your input video has
    rotation metadata. The service doesn't pass through rotation metadata.
    """


_ListJobsPaginateResponseJobsSettingsInputsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsInputsTypeDef",
    {
        "AudioSelectorGroups": Dict[
            str, ListJobsPaginateResponseJobsSettingsInputsAudioSelectorGroupsTypeDef
        ],
        "AudioSelectors": Dict[
            str, ListJobsPaginateResponseJobsSettingsInputsAudioSelectorsTypeDef
        ],
        "CaptionSelectors": Dict[
            str, ListJobsPaginateResponseJobsSettingsInputsCaptionSelectorsTypeDef
        ],
        "Crop": ListJobsPaginateResponseJobsSettingsInputsCropTypeDef,
        "DeblockFilter": str,
        "DecryptionSettings": ListJobsPaginateResponseJobsSettingsInputsDecryptionSettingsTypeDef,
        "DenoiseFilter": str,
        "FileInput": str,
        "FilterEnable": str,
        "FilterStrength": int,
        "ImageInserter": ListJobsPaginateResponseJobsSettingsInputsImageInserterTypeDef,
        "InputClippings": List[ListJobsPaginateResponseJobsSettingsInputsInputClippingsTypeDef],
        "Position": ListJobsPaginateResponseJobsSettingsInputsPositionTypeDef,
        "ProgramNumber": int,
        "PsiControl": str,
        "SupplementalImps": List[str],
        "TimecodeSource": str,
        "TimecodeStart": str,
        "VideoSelector": ListJobsPaginateResponseJobsSettingsInputsVideoSelectorTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsInputsTypeDef(
    _ListJobsPaginateResponseJobsSettingsInputsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettings` `Inputs`

    - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
    combine. An input may have multiple audio selector groups. See "Audio Selector
    Group":#inputs-audio_selector_group for more information.

      - *(string) --*

        - *(dict) --* Group of Audio Selectors

          - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input to
          include in the group. Audio selector names are standardized, based on their order within
          the input (e.g., "Audio Selector 1"). The audio selector name parameter can be repeated to
          add any number of audio selectors to the group.

            - *(string) --*

    - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or set
    of tracks from the input that you will use in your outputs. You can use mutiple Audio selectors
    per input.

      - *(string) --*

        - *(dict) --* Selector for Audio

          - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
          audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

          - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set it
          as the default for the job. The service uses this default for outputs where it can't find
          the specified input audio. If you don't set a default, those outputs have no audio.

          - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
          source.

          - **LanguageCode** *(string) --* Selects a specific language code from within an audio
          source.

          - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
          from the input video.

          - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
          selects PID 0x101).

            - *(integer) --*

          - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
          Dolby E, to have the service extract specific program data from the track. To select
          multiple programs, create multiple selectors with the same Track and different Program
          numbers. In the console, this setting is visible when you set Selector type to Track.
          Choose the program number from the dropdown list. If you are sending a JSON file, provide
          the program ID, which is part of the audio metadata. If your input file has incorrect
          metadata, you can choose All channels instead of a program number to have the service
          ignore the program IDs and include all the programs in the track.

          - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of one
          input to match those of another input. This allows you to combine the two files into a
          single output, one after the other.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **SelectorType** *(string) --* Specifies the type of the audio selector.

          - **Tracks** *(list) --* Identify a track from the input audio to include in this selector
          by entering the track index number. To include several tracks in a single audio selector,
          specify multiple tracks as follows. Using the console, enter a comma-separated list. For
          examle, type "1,2,3" to include tracks 1 through 3. Specifying directly in your JSON job
          file, provide the track numbers in an array. For example, "tracks": [1,2,3].

            - *(integer) --*

    - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
    captions data from the input that you will use in your outputs. You can use mutiple captions
    selectors per input.

      - *(string) --*

        - *(dict) --* Set up captions in your outputs by first selecting them from your input here.

          - **CustomLanguageCode** *(string) --* The specific language to extract from source, using
          the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27, complete this
          field and/or PID to select the caption language to extract. If input is DVB-Sub and output
          is Burn-in or SMPTE-TT, complete this field and/or PID to select the caption language to
          extract. If input is DVB-Sub that is being passed through, omit this field (and PID
          field); there is no way to extract a specific language with pass-through captions.

          - **LanguageCode** *(string) --* The specific language to extract from source. If input is
          SCTE-27, complete this field and/or PID to select the caption language to extract. If
          input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
          select the caption language to extract. If input is DVB-Sub that is being passed through,
          omit this field (and PID field); there is no way to extract a specific language with
          pass-through captions.

          - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT, or
          IMSC in an xml file, specify the URI of the input captions source file. If your input
          captions are IMSC in an IMF package, use TrackSourceSettings instead of FileSoureSettings.

            - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number in
              the ancillary data track from which to extract captions. Unused for passthrough.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

              - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID for
              the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is passed
              through, regardless of selectors.

            - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
              within the video track from which to extract captions. Unused for passthrough.

              - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
              extracting captions. The system only supports one input video track, so this should
              always be set to '1'.

              - **TerminateCaptions** *(string) --* By default, the service terminates any
              unterminated captions at the end of each input. If you want the caption to continue
              onto your next input, disable this setting.

            - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
            TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file. If
            your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
            FileSoureSettings.

              - **Convert608To708** *(string) --* Specify whether this set of input captions appears
              in your outputs in both 608 and 708 format. If you choose Upconvert (UPCONVERT),
              MediaConvert includes the captions data in two ways: it passes the 608 data through
              using the 608 compatibility bytes fields of the 708 wrapper, and it also translates
              the 608 data into 708.

              - **SourceFile** *(string) --* External caption file used for loading captions.
              Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and 'smi'.

              - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
              captions from the source file.

            - **SourceType** *(string) --* Use Source (SourceType) to identify the format of your
            input captions. The service cannot auto-detect caption format.

            - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption sources,
            including Page number.

              - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the three-digit
              hexadecimal page number that will be used for Teletext captions. Do not use this
              setting if you are passing through teletext from the input source to output.

            - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
            specified by track number. Currently, this is only IMSC captions in an IMF package. If
            your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings instead
            of TrackSourceSettings.

              - **TrackNumber** *(integer) --* Use this setting to select a single captions track
              from a source. Track numbers correspond to the order in the captions source file. For
              IMF sources, track numbering is based on the order that the captions appear in the
              CPL. For example, use 1 to select the captions asset that is listed first in the CPL.
              To include more than one captions track in your job outputs, create multiple input
              captions selectors. Specify one track per selector.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame. If you specify a value here, it will override any value
    that you specify in the output setting Cropping selection (crop).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother motion
    in the output. Default is disabled. Only manaully controllable for MPEG2 and uncompressed video
    inputs.

    - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you encrypt
    before you upload them to Amazon S3. MediaConvert can decrypt files only when you use AWS Key
    Management Service (KMS) to encrypt the data key that you use to encrypt your content.

      - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt your
      input files.

      - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
      plaintext. Your job settings could be intercepted, making your encrypted content vulnerable.
      Specify the encrypted version of the data key that you used to encrypt your content. The data
      key must be encrypted by AWS Key Management Service (KMS). The key can be 128, 192, or 256
      bits.

      - **InitializationVector** *(string) --* Specify the initialization vector that you used when
      you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
      initialization vector with any encryption mode. Or, you can use a 12-byte initialization
      vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
      base64-encoded.

      - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service (KMS)
      that you used to encrypt your data key, if that Region is different from the one you are using
      for AWS Elemental MediaConvert.

    - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from the
    input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed video
    inputs.

    - **FileInput** *(string) --* Specify the source file for your transcoding job. You can use
    multiple inputs in a single job. The service concatenates these inputs, in the order that you
    specify them in the job, to create the outputs. If your input format is IMF, specify your input
    by providing the path to your CPL. For example, "s3://bucket/vf/cpl.xml". If the CPL is in an
    incomplete IMP, make sure to use *Supplemental IMPs* (SupplementalImps) to specify any
    supplemental IMPs that contain assets referenced by the CPL.

    - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
    transcoding service applies the denoise and deblock filters. You must also enable the filters
    separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). * Auto - The
    transcoding service determines whether to apply filtering, depending on input type and quality.
    * Disable - The input is not filtered. This is true even if you use the API to enable them in
    (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is filtered regardless of
    input type.

    - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the magnitude
    the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is 0.

    - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic overlay
    on your video. Enable or disable this feature for each input individually. This setting is
    disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
    together specify a portion of the input to be used in the outputs. If you provide only a start
    time, the clip will be the entire input from that point to the end. If you provide only an end
    time, it will be the entire input up to that point. When you specify more than one input clip,
    the transcoding service creates the job outputs by stringing the clips together in the order you
    specify them.

      - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
      (one instance of InputClipping in the JSON job file) for each input clip. All input clips you
      specify will be included in every output of the job.

        - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion of
        the input you are clipping. The frame corresponding to the End timecode value is included in
        the clip. Start timecode or End timecode may be left blank, but not both. Use the format
        HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the second, and FF
        is the frame number. When choosing this value, take into account your setting for timecode
        source under input settings (InputTimecodeSource). For example, if you have embedded
        timecodes that start at 01:00:00:00 and you want your clip to end six minutes into the
        video, use 01:06:00:00.

        - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of the
        portion of the input you are clipping. The frame corresponding to the Start timecode value
        is included in the clip. Start timecode or End timecode may be left blank, but not both. Use
        the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is the
        second, and FF is the frame number. When choosing this value, take into account your setting
        for Input timecode source. For example, if you have embedded timecodes that start at
        01:00:00:00 and you want your clip to begin five minutes into the video, use 01:05:00:00.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black. If you specify a
    value here, it will override any value that you specify in the output setting Selection
    placement (position). If you specify a value here, this will override any AFD values in your
    input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If you specify a
    value here, this will ignore anything that you specify for the setting Scaling Behavior
    (scalingBehavior).

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program from
    within a multi-program transport stream. Note that Quad 4K is not currently supported. Default
    is the first program within the transport stream. If the program you specify doesn't exist, the
    transcoding service will use this default.

    - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs to
    specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and video.
    * Use PSI - Scan only PSI data.

    - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You need
    supplemental IMPs if the CPL that you're using for your input is in an incomplete IMP. Specify
    either the supplemental IMP directories with a trailing slash or the ASSETMAP.xml files. For
    example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to specify the IMP
    that contains your input CPL, because the service automatically detects it.

      - *(string) --*

    - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
    settings (InputTimecodeSource), to specify how the service counts input video frames. This input
    frame count affects only the behavior of features that apply to a single input at a time, such
    as input clipping and synchronizing some captions formats. Choose Embedded (EMBEDDED) to use the
    timecodes in your input video. Choose Start at zero (ZEROBASED) to start the first frame at
    zero. Choose Specified start (SPECIFIEDSTART) to start the first frame at the timecode that you
    specify in the setting Start timecode (timecodeStart). If you don't specify a value for Timecode
    source, the service will use Embedded by default. For more information about timecodes, see
    https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for this
    input's initial frame. To use this setting, you must set the Timecode source setting, located
    under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART). For more
    information about timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

    - **VideoSelector** *(dict) --* Selector for video.

      - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
      animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
      setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
      REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
      channel of your outputs.

      - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or if
      you don't know about color space, leave this set to the default value Follow (FOLLOW). The
      service will automatically detect your input color space. If your input video has metadata
      indicating the wrong color space, specify the accurate color space here. If your input video
      is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata isn't present
      in your video stream, or if that metadata is present but not accurate, choose Force HDR 10
      (FORCE_HDR10) here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
      settings. For more information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input file
      and the job input settings Color space (ColorSpace) and HDR master display information
      settings(Hdr10Metadata). The Color space usage setting determines which takes precedence.
      Choose Force (FORCE) to use color metadata from the input job settings. If you don't specify
      values for those settings, the service defaults to using metadata from your input. FALLBACK -
      Choose Fallback (FALLBACK) to use color metadata from the source when it is present. If
      there's no color metadata in your input file, the service defaults to using values you specify
      in the input settings.

      - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is missing
      or inaccurate in your input video. Appropriate values vary depending on the input video and
      must be provided by a color grader. The color grader generates these values during the HDR 10
      mastering process. The valid range for each of these settings is 0 to 50,000. Each increment
      represents 0.00002 in CIE1931 color coordinate. Related settings - When you specify these
      values, you must also set Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the
      the values you specify here take precedence over the values in the metadata of your input
      file, set Color space usage (ColorSpaceUsage). To specify whether color metadata is included
      in an output, set Color metadata (ColorMetadata). For more information about MediaConvert HDR
      jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
      Specify this value as an integer; the system automatically converts it to the hexidecimal
      value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier for a
      set of data in an MPEG-2 transport stream container.

      - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
      transport stream. Note that Quad 4K is not currently supported.

      - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates your
      video. You can choose automatic rotation or specify a rotation. You can specify a clockwise
      rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or .mp4 and your
      input has rotation metadata, you can choose Automatic to have the service rotate your video
      according to the rotation specified in the metadata. The rotation must be within one degree of
      90, 180, or 270 degrees. If the rotation metadata specifies any other rotation, the service
      will default to no rotation. By default, the service does no rotation, even if your input
      video has rotation metadata. The service doesn't pass through rotation metadata.
    """


_ListJobsPaginateResponseJobsSettingsMotionImageInserterFramerateTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsMotionImageInserterFramerateTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsMotionImageInserterFramerateTypeDef(
    _ListJobsPaginateResponseJobsSettingsMotionImageInserterFramerateTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsMotionImageInserter` `Framerate`

    - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 1.

    - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
    frame rate. For example, if your frame rate is 24 fps, set this value to 24.
    """


_ListJobsPaginateResponseJobsSettingsMotionImageInserterOffsetTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsMotionImageInserterOffsetTypeDef",
    {"ImageX": int, "ImageY": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsMotionImageInserterOffsetTypeDef(
    _ListJobsPaginateResponseJobsSettingsMotionImageInserterOffsetTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsMotionImageInserter` `Offset`

    - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
    of the video frame.

    - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge of
    the video frame.
    """


_ListJobsPaginateResponseJobsSettingsMotionImageInserterTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsMotionImageInserterTypeDef",
    {
        "Framerate": ListJobsPaginateResponseJobsSettingsMotionImageInserterFramerateTypeDef,
        "Input": str,
        "InsertionMode": str,
        "Offset": ListJobsPaginateResponseJobsSettingsMotionImageInserterOffsetTypeDef,
        "Playback": str,
        "StartTime": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsMotionImageInserterTypeDef(
    _ListJobsPaginateResponseJobsSettingsMotionImageInserterTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettings` `MotionImageInserter`

    - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
    unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
    the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make sure
    that the number of images in your series matches the frame rate and your intended overlay
    duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
    images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

      - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
      overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

      - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
      frame rate. For example, if your frame rate is 24 fps, set this value to 24.

    - **Input** *(string) --* Specify the .mov file or series of .png files that you want to overlay
    on your video. For .png files, provide the file name of the first file in the series. Make sure
    that the names of the .png files end with sequential numbers that specify the order that they
    are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and so on. The
    sequence must start at zero, and each image file name must have the same number of digits. Pad
    your initial file names with enough zeros to complete the sequence. For example, if the first
    image is overlay_0.png, there can be only 10 images in the sequence, with the last image being
    overlay_9.png. But if the first image is overlay_00.png, there can be 100 images in the
    sequence.

    - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are providing
    for your overlay. You can choose either a .mov file or a series of .png files.

    - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
    the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
    specify an offset, the service scales your overlay to the full size of the frame. Otherwise, the
    service inserts the overlay at its native resolution and scales the size up or down with any
    video scaling.

      - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left edge
      of the video frame.

      - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top edge
      of the video frame.

    - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
    plays only once.

    - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
    (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
    how you have set up your timecode configuration under both job settings and input settings. The
    simplest way to do that is to set both to start at 0. If you need to set up your job to follow
    timecodes embedded in your source that don't start at zero, make sure that you specify a start
    time that is after the first embedded timecode. For more information, see
    https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
    input timecode configuration settings in your JSON job settings specification at
    settings>timecodeConfig>source and settings>inputs>timecodeSource.
    """


_ListJobsPaginateResponseJobsSettingsNielsenConfigurationTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsNielsenConfigurationTypeDef",
    {"BreakoutCode": int, "DistributorId": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsNielsenConfigurationTypeDef(
    _ListJobsPaginateResponseJobsSettingsNielsenConfigurationTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettings` `NielsenConfiguration`

    - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
    functionality. If you must include this property, set the value to zero.

    - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the distributor
    ID that is assigned to your organization by Neilsen.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {
        "CertificateArn": str,
        "DashSignaledSystemIds": List[str],
        "HlsSignaledSystemIds": List[str],
        "ResourceId": str,
        "Url": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in the
    DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest can
    currently signal up to three system IDs. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
    HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
    currently signal only one system ID. For more information, see
    https://dashif.org/identifiers/content_protection/.

      - *(string) --*

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "SpekeKeyProvider": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service to
    use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
    (AES-CTR).

    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
    whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
    manifests.

    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
    doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
    DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
      the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
      can currently signal up to three system IDs. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in the
      HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest can
      currently signal only one system ID. For more information, see
      https://dashif.org/identifiers/content_protection/.

        - *(string) --*

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinBufferTime": int,
        "MinFinalSegmentLength": float,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "StreamInfResolution": str,
        "WriteDashManifest": str,
        "WriteHlsManifest": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettings`
    `CmafGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
    default manifests reference every output in the output group. To create additional top-level
    manifests that reference a subset of the outputs in the output group, specify a list of them
    here. For each additional manifest that you specify, the service creates one HLS manifest and
    one DASH manifest.

      - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that you
      want the service to generate for this CMAF output group. Each pair of manifests can reference
      a different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
    top level BaseURL element. Can be used if streams are delivered from a different URL than the
    manifest file.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
      to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
      (AES-CTR).

      - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs, choose
      whether the service writes the 128-bit encryption initialization vector in the HLS and DASH
      manifests.

      - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings when
      doing DRM encryption with a SPEKE-compliant key provider. If your output group type is HLS,
      DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled in
        the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH manifest
        can currently signal up to three system IDs. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
        the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
        can currently signal only one system ID. For more information, see
        https://dashif.org/identifiers/content_protection/.

          - *(string) --*

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
    individual CMAF segment. This value applies to the whole package; that is, to every output in
    the output group. Note that segments end on the first keyframe after this number of seconds, so
    the actual segment length might be slightly longer. If you set Segment control
    (CmafSegmentControl) to single file, the service puts the content of each output in a single
    file that has metadata that marks these segments. If you set it to segmented files, the service
    creates multiple files for each output, each with the content of one segment.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be generated
    for this output.

    - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
    generated for this output.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your DASH group is
    film-name.mpd. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.mpd.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef",
    {
        "PlaybackDeviceCompatibility": str,
        "SpekeKeyProvider": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionSpekeKeyProviderTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettings`
    `Encryption`

    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
    your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
    DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with playback
    on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose
    Unencrypted SEI, for that output, the service will exclude the access unit delimiter and will
    leave the SEI NAL units unencrypted.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "Destination": str,
        "DestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "HbbtvCompliance": str,
        "MinBufferTime": int,
        "MpdProfile": str,
        "SegmentControl": str,
        "SegmentLength": int,
        "WriteSegmentTimelineInRepresentation": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettings`
    `DashIsoGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest for
    each DASH ISO output group in your job. This default manifest references every output in the
    output group. To create additional DASH manifests that reference a subset of the outputs in the
    output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional DASH manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your DASH
        group is film-name.mpd. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.mpd.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file at
    the top level BaseURL element. Can be used if streams are delivered from a different URL than
    the manifest file.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* DRM settings.

      - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility of
      your output with video players on obsolete devices. It applies only to DASH H.264 outputs with
      DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
      playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
      choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
      and will leave the SEI NAL units unencrypted.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
    length must be compatible with GOP size and Framerate. Note that fragments will end on the next
    keyframe after this number of seconds, so actual fragment length may be longer. When Emit Single
    File is checked, the fragmentation is internal to a single output file and it does not cause the
    creation of many output files as in other output types.

    - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

    - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
    ensure smooth playout.

    - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When you
    choose Main profile (MAIN_PROFILE), the service signals urn:mpeg:dash:profile:isoff-main:2011 in
    your .mpd DASH manifest. When you choose On-demand (ON_DEMAND_PROFILE), the service signals
    urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you must
    also set the output group setting Segment control (SegmentControl) to Single file (SINGLE_FILE).

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
    which is internally segmented using the Fragment Length and Segment Length. When set to
    SEGMENTED_FILES, separate segment files will be created.

    - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
    segments will end on the next keyframe after this number of seconds, so actual segment length
    may be longer. When Emit Single File is checked, the segmentation is internal to a single output
    file and it does not cause the creation of many output files as in other output types.

    - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
    range when you play back your DASH output, enable this setting and run your transcoding job
    again. When you enable this setting, the service writes precise segment durations in the DASH
    manifest. The segment duration information appears inside the SegmentTimeline element, inside
    SegmentTemplate at the Representation level. When you don't enable this setting, the service
    writes approximate segment durations in your DASH manifest.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef",
    {
        "Destination": str,
        "DestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsDestinationSettingsTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettings`
    `FileGroupSettings`

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your HLS group is
    film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the service
    generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
    specify a manifestNameModifier that is different from the nameModifier of the output. The
    service uses the output name modifier to create unique names for the individual variant
    manifests.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef",
    {
        "CaptionChannel": int,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `CaptionLanguageMappings`

    - **CaptionChannel** *(integer) --* Caption channel.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using the
    ISO 639-2 or ISO 639-3 three-letter language code

    - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
    listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

    - **LanguageDescription** *(string) --* Caption language description.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef",
    {"KeyFormat": str, "KeyFormatVersions": str, "StaticKeyValue": str, "Url": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryption`
    `StaticKeyProvider`

    - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
    attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
    value of 'identity'.

    - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
    integer version value or a slash delimited list of version values (1/2/3).

    - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character hexidecimal
    string to specify Key Value (StaticKeyValue).

    - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
    for protecting content.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef",
    {
        "ConstantInitializationVector": str,
        "EncryptionMethod": str,
        "InitializationVectorInManifest": str,
        "OfflineEncrypted": str,
        "SpekeKeyProvider": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionSpekeKeyProviderTypeDef,
        "StaticKeyProvider": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionStaticKeyProviderTypeDef,
        "Type": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettings`
    `Encryption`

    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
    represented by a 32-character text string. If this parameter is not set then the Initialization
    Vector will follow the segment number by default.

    - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
    Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit number
    used in conjunction with the key for encrypting blocks. If set to INCLUDE, Initialization Vector
    is listed in the manifest. Otherwise Initialization Vector is not in the manifest.

    - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY element
    into the master playlist. This allows for offline Apple HLS FairPlay content protection.

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.

    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
    provider.

      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
      attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an implicit
      value of 'identity'.

      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single positive
      integer version value or a slash delimited list of version values (1/2/3).

      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
      hexidecimal string to specify Key Value (StaticKeyValue).

      - **Url** *(string) --* Relates to DRM implementation. The location of the license server used
      for protecting content.

    - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
    provider that follows the SPEKE standard. For more information about SPEKE, see
    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef",
    {
        "AdMarkers": List[str],
        "AdditionalManifests": List[
            ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsAdditionalManifestsTypeDef
        ],
        "BaseUrl": str,
        "CaptionLanguageMappings": List[
            ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsCaptionLanguageMappingsTypeDef
        ],
        "CaptionLanguageSetting": str,
        "ClientCache": str,
        "CodecSpecification": str,
        "Destination": str,
        "DestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsDestinationSettingsTypeDef,
        "DirectoryStructure": str,
        "Encryption": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsEncryptionTypeDef,
        "ManifestCompression": str,
        "ManifestDurationFormat": str,
        "MinFinalSegmentLength": float,
        "MinSegmentLength": int,
        "OutputSelection": str,
        "ProgramDateTime": str,
        "ProgramDateTimePeriod": int,
        "SegmentControl": str,
        "SegmentLength": int,
        "SegmentsPerSubdirectory": int,
        "StreamInfResolution": str,
        "TimedMetadataId3Frame": str,
        "TimedMetadataId3Period": int,
        "TimestampDeltaMilliseconds": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettings`
    `HlsGroupSettings`

    - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
    manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
    themselves.

      - *(string) --*

    - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
    manifest for each HLS output group in your job. This default manifest references every output in
    the output group. To create additional top-level manifests that reference a subset of the
    outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional HLS manifest that you want the service
      to generate for this output group. Each manifest can reference a different subset of outputs
      in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your HLS
        group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file name the
        service generates for this top-level manifest is film-name-no-premium.m3u8. For HLS output
        groups, specify a manifestNameModifier that is different from the nameModifier of the
        output. The service uses the output name modifier to create unique names for the individual
        variant manifests.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
    media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
    .m3u8 file.

    - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

      - *(dict) --* Caption Language Mapping

        - **CaptionChannel** *(integer) --* Caption channel.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions channel, using
        the ISO 639-2 or ISO 639-3 three-letter language code

        - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter code
        listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

        - **LanguageDescription** *(string) --* Caption language description.

    - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions. Insert:
    Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the CC1 Language
    Code field. One CLOSED-CAPTION line is added for each Language Code you specify. Make sure to
    specify the languages in the order in which they appear in the original source (if the source is
    embedded format) or the order of the caption selectors (if the source is other than embedded).
    Otherwise, languages in the manifest will not match up properly with the output captions. None:
    Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from the
    manifest.

    - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
    prevents client from saving media segments for later replay.

    - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
    during m3u8 playlist generation.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
    subdirectories.

    - **Encryption** *(dict) --* DRM settings.

      - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
      represented by a 32-character text string. If this parameter is not set then the
      Initialization Vector will follow the segment number by default.

      - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
      Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

      - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
      number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
      Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in the
      manifest.

      - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
      element into the master playlist. This allows for offline Apple HLS FairPlay content
      protection.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

      - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static key
      provider.

        - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the KEYFORMAT
        attribute. Must be 'identity' or a reverse DNS string. May be omitted to indicate an
        implicit value of 'identity'.

        - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
        positive integer version value or a slash delimited list of version values (1/2/3).

        - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
        hexidecimal string to specify Key Value (StaticKeyValue).

        - **Url** *(string) --* Relates to DRM implementation. The location of the license server
        used for protecting content.

      - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
      provider that follows the SPEKE standard. For more information about SPEKE, see
      https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

    - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

    - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
    floating point values for segment duration.

    - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless you
    are troubleshooting a problem with how devices play back the end of your video asset. If you
    know that player devices are hanging on the final segment of your video because the length of
    your final segment is too short, use this setting to specify a minimum final segment length, in
    seconds. Choose a value that is greater than or equal to 1 and less than your segment length.
    When you specify a value for this setting, the encoder will combine any final segment that is
    shorter than the length that you specify with the previous segment. For example, your segment
    length is 3 seconds and your final segment is .5 seconds without a minimum final segment length;
    when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

    - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
    ahead and back within the specified range for a nearby avail and extending the segment size if
    needed.

    - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
    generated for this HLS output group.

    - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
    manifest files. The value is calculated as follows: either the program date and time are
    initialized using the input timecode source, or the time is initialized using the input timecode
    source and the date is initialized using the timestamp_offset.

    - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME entry,
    in seconds.

    - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
    resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

    - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
    seconds). Note that segments will end on the next keyframe after this number of seconds, so
    actual segment length may be longer.

    - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
    before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to have
    an effect.

    - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
    EXT-X-STREAM-INF tag of variant manifest.

    - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

    - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

    - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
    fine tune the timestamps.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef",
    {"ManifestNameModifier": str, "SelectedOutputs": List[str]},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `AdditionalManifests`

    - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to the
    name of this manifest to make it different from the file names of the other main manifests in
    the output group. For example, say that the default main manifest for your Microsoft Smooth
    group is film-name.ismv. If you enter "-no-premium" for this setting, then the file name the
    service generates for this top-level manifest is film-name-no-premium.ismv.

    - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional top-level
    manifest to reference.

      - *(string) --*
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef",
    {"CannedAcl": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `AccessControl`

    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
    output.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef",
    {"EncryptionType": str, "KmsKeyArn": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3Settings`
    `Encryption`

    - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
    keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
    master key (CMK), and then stores the encrypted data keys alongside your encrypted content. Use
    this setting to specify which AWS service manages the CMK. For simplest set up, choose Amazon S3
    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key Management
    Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS,
    KMS uses the AWS managed customer master key (CMK) associated with Amazon S3 to encrypt your
    data keys. You can optionally choose to specify a different, customer managed CMK. Do so by
    specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want to
    use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
    Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
    (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
    encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated with
    Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef",
    {
        "AccessControl": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsAccessControlTypeDef,
        "Encryption": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsEncryptionTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettings`
    `S3Settings`

    - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3 access
    control for the outputs in this output group. When you don't use this setting, S3 automatically
    applies the default access control list PRIVATE.

      - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to this
      output.

    - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
    uploaded to Amazon S3.

      - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses data
      keys to encrypt your content. AWS also encrypts the data keys themselves, using a customer
      master key (CMK), and then stores the encrypted data keys alongside your encrypted content.
      Use this setting to specify which AWS service manages the CMK. For simplest set up, choose
      Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
      Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default, when you
      choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with Amazon S3
      to encrypt your data keys. You can optionally choose to specify a different, customer managed
      CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
      (kmsKeyArn).

      - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you want
      to use to encrypt the data key that AWS uses to encrypt your output content. Enter the Amazon
      Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side encryption
      (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side
      encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
      with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef",
    {
        "S3Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsS3SettingsTypeDef
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `DestinationSettings`

    - **S3Settings** *(dict) --* Settings associated with S3 destination

      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
      access control for the outputs in this output group. When you don't use this setting, S3
      automatically applies the default access control list PRIVATE.

        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
        this output.

      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
      uploaded to Amazon S3.

        - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
        data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
        customer master key (CMK), and then stores the encrypted data keys alongside your encrypted
        content. Use this setting to specify which AWS service manages the CMK. For simplest set up,
        choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by
        AWS Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
        when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK) associated with
        Amazon S3 to encrypt your data keys. You can optionally choose to specify a different,
        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of the key for the
        setting KMS ARN (kmsKeyArn).

        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
        want to use to encrypt the data key that AWS uses to encrypt your output content. Enter the
        Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set Server-side
        encryption (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set
        Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK
        associated with Amazon S3.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef",
    {"CertificateArn": str, "ResourceId": str, "SystemIds": List[str], "Url": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryption`
    `SpekeKeyProvider`

    - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
    that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
    Manager. Specify the certificate's Amazon Resource Name (ARN) here.

    - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
    uses to identify this content.

    - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH output
    groups support a max of two system ids. Other group types support one system id. See
    https://dashif.org/identifiers/content_protection/ for more details.

      - *(string) --*

    - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
    provider uses to provide keys for encrypting your content.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef",
    {
        "SpekeKeyProvider": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionSpekeKeyProviderTypeDef
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettings`
    `Encryption`

    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft Smooth,
    use these settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
    group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

      - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
      that it provides to MediaConvert, set up a certificate with a master key using AWS Certificate
      Manager. Specify the certificate's Amazon Resource Name (ARN) here.

      - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key provider
      uses to identify this content.

      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
      output groups support a max of two system ids. Other group types support one system id. See
      https://dashif.org/identifiers/content_protection/ for more details.

        - *(string) --*

      - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
      provider uses to provide keys for encrypting your content.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef",
    {
        "AdditionalManifests": List[
            ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsAdditionalManifestsTypeDef
        ],
        "AudioDeduplication": str,
        "Destination": str,
        "DestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsDestinationSettingsTypeDef,
        "Encryption": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsEncryptionTypeDef,
        "FragmentLength": int,
        "ManifestEncoding": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettings`
    `MsSmoothGroupSettings`

    - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft Smooth
    Streaming manifest for each Microsoft Smooth Streaming output group in your job. This default
    manifest references every output in the output group. To create additional manifests that
    reference a subset of the outputs in the output group, specify a list of them here.

      - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest that
      you want the service to generate for this output group. Each manifest can reference a
      different subset of outputs in the group.

        - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
        the name of this manifest to make it different from the file names of the other main
        manifests in the output group. For example, say that the default main manifest for your
        Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting, then
        the file name the service generates for this top-level manifest is
        film-name-no-premium.ismv.

        - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
        top-level manifest to reference.

          - *(string) --*

    - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
    encoding settings across a Microsoft Smooth output group into a single audio stream.

    - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output location
    and the output filename base. Destination accepts format identifiers. If you do not specify the
    base filename in the URI, the service will use the filename of the input file. If your job has
    multiple inputs, the service uses the filename of the first input file.

    - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary based
    on the type of destination

      - **S3Settings** *(dict) --* Settings associated with S3 destination

        - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
        access control for the outputs in this output group. When you don't use this setting, S3
        automatically applies the default access control list PRIVATE.

          - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply to
          this output.

        - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
        uploaded to Amazon S3.

          - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
          data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
          customer master key (CMK), and then stores the encrypted data keys alongside your
          encrypted content. Use this setting to specify which AWS service manages the CMK. For
          simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key
          to be managed by AWS Key Management Service (KMS), choose AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
          managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys. You
          can optionally choose to specify a different, customer managed CMK. Do so by specifying
          the Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

          - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
          want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
          the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
          Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
          (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
          specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
    to specify the value SpekeKeyProvider.

      - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
      Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
      your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

        - **CertificateArn** *(string) --* If you want your key provider to encrypt the content keys
        that it provides to MediaConvert, set up a certificate with a master key using AWS
        Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

        - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
        provider uses to identify this content.

        - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
        output groups support a max of two system ids. Other group types support one system id. See
        https://dashif.org/identifiers/content_protection/ for more details.

          - *(string) --*

        - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM key
        provider uses to provide keys for encrypting your content.

    - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
    fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

    - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to specify
    the encoding format for the server and client manifest. Valid options are utf8 and utf16.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef",
    {
        "CmafGroupSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsCmafGroupSettingsTypeDef,
        "DashIsoGroupSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsDashIsoGroupSettingsTypeDef,
        "FileGroupSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsFileGroupSettingsTypeDef,
        "HlsGroupSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsHlsGroupSettingsTypeDef,
        "MsSmoothGroupSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsMsSmoothGroupSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroups` `OutputGroupSettings`

    - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output Group
    may only contain a single video, audio, or caption output.

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest and one top -level .mpd DASH manifest for each CMAF output group in your job. These
      default manifests reference every output in the output group. To create additional top-level
      manifests that reference a subset of the outputs in the output group, specify a list of them
      here. For each additional manifest that you specify, the service creates one HLS manifest and
      one DASH manifest.

        - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
        you want the service to generate for this CMAF output group. Each pair of manifests can
        reference a different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at the
      top level BaseURL element. Can be used if streams are delivered from a different URL than the
      manifest file.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the service
        to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES) or AES_CTR
        (AES-CTR).

        - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
        choose whether the service writes the 128-bit encryption initialization vector in the HLS
        and DASH manifests.

        - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
        when doing DRM encryption with a SPEKE-compliant key provider. If your output group type is
        HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want signaled
          in the DASH manifest that MediaConvert creates as part of this CMAF package. The DASH
          manifest can currently signal up to three system IDs. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled in
          the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS manifest
          can currently signal only one system ID. For more information, see
          https://dashif.org/identifiers/content_protection/.

            - *(string) --*

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of each
      individual CMAF segment. This value applies to the whole package; that is, to every output in
      the output group. Note that segments end on the first keyframe after this number of seconds,
      so the actual segment length might be slightly longer. If you set Segment control
      (CmafSegmentControl) to single file, the service puts the content of each output in a single
      file that has metadata that marks these segments. If you set it to segmented files, the
      service creates multiple files for each output, each with the content of one segment.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
      generated for this output.

      - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
      generated for this output.

    - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
      for each DASH ISO output group in your job. This default manifest references every output in
      the output group. To create additional DASH manifests that reference a subset of the outputs
      in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional DASH manifest that you want the
        service to generate for this output group. Each manifest can reference a different subset of
        outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.mpd.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd) file
      at the top level BaseURL element. Can be used if streams are delivered from a different URL
      than the manifest file.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* DRM settings.

        - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
        of your output with video players on obsolete devices. It applies only to DASH H.264 outputs
        with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct problems with
        playback on older devices. Otherwise, keep the default setting CENC v1 (CENC_V1). If you
        choose Unencrypted SEI, for that output, the service will exclude the access unit delimiter
        and will leave the SEI NAL units unencrypted.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
      length must be compatible with GOP size and Framerate. Note that fragments will end on the
      next keyframe after this number of seconds, so actual fragment length may be longer. When Emit
      Single File is checked, the fragmentation is internal to a single output file and it does not
      cause the creation of many output files as in other output types.

      - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

      - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed to
      ensure smooth playout.

      - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
      you choose Main profile (MAIN_PROFILE), the service signals
      urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
      (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
      .mpd. When you choose On-demand, you must also set the output group setting Segment control
      (SegmentControl) to Single file (SINGLE_FILE).

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is generated,
      which is internally segmented using the Fragment Length and Segment Length. When set to
      SEGMENTED_FILES, separate segment files will be created.

      - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
      segments will end on the next keyframe after this number of seconds, so actual segment length
      may be longer. When Emit Single File is checked, the segmentation is internal to a single
      output file and it does not cause the creation of many output files as in other output types.

      - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
      range when you play back your DASH output, enable this setting and run your transcoding job
      again. When you enable this setting, the service writes precise segment durations in the DASH
      manifest. The segment duration information appears inside the SegmentTimeline element, inside
      SegmentTemplate at the Representation level. When you don't enable this setting, the service
      writes approximate segment durations in your DASH manifest.

    - **FileGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

    - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

      - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
      manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
      themselves.

        - *(string) --*

      - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8 HLS
      manifest for each HLS output group in your job. This default manifest references every output
      in the output group. To create additional top-level manifests that reference a subset of the
      outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional HLS manifest that you want the service
        to generate for this output group. Each manifest can reference a different subset of outputs
        in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
          name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
          HLS output groups, specify a manifestNameModifier that is different from the nameModifier
          of the output. The service uses the output name modifier to create unique names for the
          individual variant manifests.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in the
      media .m3u8 file. Can be used if base manifest is delivered from a different URL than the main
      .m3u8 file.

      - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

        - *(dict) --* Caption Language Mapping

          - **CaptionChannel** *(integer) --* Caption channel.

          - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
          using the ISO 639-2 or ISO 639-3 three-letter language code

          - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
          code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

          - **LanguageDescription** *(string) --* Caption language description.

      - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
      Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
      CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you specify.
      Make sure to specify the languages in the order in which they appear in the original source
      (if the source is embedded format) or the order of the caption selectors (if the source is
      other than embedded). Otherwise, languages in the manifest will not match up properly with the
      output captions. None: Include CLOSED-CAPTIONS=NONE line in the manifest. Omit: Omit any
      CLOSED-CAPTIONS line from the manifest.

      - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
      prevents client from saving media segments for later replay.

      - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default RFC-4281)
      during m3u8 playlist generation.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
      subdirectories.

      - **Encryption** *(dict) --* DRM settings.

        - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
        represented by a 32-character text string. If this parameter is not set then the
        Initialization Vector will follow the segment number by default.

        - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption scheme.
        Leave blank to disable. Selecting 'Disabled' in the web interface also disables encryption.

        - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
        number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
        Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
        the manifest.

        - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
        element into the master playlist. This allows for offline Apple HLS FairPlay content
        protection.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

        - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
        key provider.

          - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
          KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
          indicate an implicit value of 'identity'.

          - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
          positive integer version value or a slash delimited list of version values (1/2/3).

          - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
          hexidecimal string to specify Key Value (StaticKeyValue).

          - **Url** *(string) --* Relates to DRM implementation. The location of the license server
          used for protecting content.

        - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
        provider that follows the SPEKE standard. For more information about SPEKE, see
        https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

      - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

      - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
      floating point values for segment duration.

      - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
      you are troubleshooting a problem with how devices play back the end of your video asset. If
      you know that player devices are hanging on the final segment of your video because the length
      of your final segment is too short, use this setting to specify a minimum final segment
      length, in seconds. Choose a value that is greater than or equal to 1 and less than your
      segment length. When you specify a value for this setting, the encoder will combine any final
      segment that is shorter than the length that you specify with the previous segment. For
      example, your segment length is 3 seconds and your final segment is .5 seconds without a
      minimum final segment length; when you set the minimum final segment length to 1, your final
      segment is 3.5 seconds.

      - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
      ahead and back within the specified range for a nearby avail and extending the segment size if
      needed.

      - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
      generated for this HLS output group.

      - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in .m3u8
      manifest files. The value is calculated as follows: either the program date and time are
      initialized using the input timecode source, or the time is initialized using the input
      timecode source and the date is initialized using the timestamp_offset.

      - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
      entry, in seconds.

      - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
      resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

      - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
      seconds). Note that segments will end on the next keyframe after this number of seconds, so
      actual segment length may be longer.

      - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
      before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
      have an effect.

      - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
      EXT-X-STREAM-INF tag of variant manifest.

      - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

      - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

      - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset to
      fine tune the timestamps.

    - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
    (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

      - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
      Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
      default manifest references every output in the output group. To create additional manifests
      that reference a subset of the outputs in the output group, specify a list of them here.

        - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
        that you want the service to generate for this output group. Each manifest can reference a
        different subset of outputs in the group.

          - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds to
          the name of this manifest to make it different from the file names of the other main
          manifests in the output group. For example, say that the default main manifest for your
          Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
          then the file name the service generates for this top-level manifest is
          film-name-no-premium.ismv.

          - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
          top-level manifest to reference.

            - *(string) --*

      - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
      encoding settings across a Microsoft Smooth output group into a single audio stream.

      - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
      location and the output filename base. Destination accepts format identifiers. If you do not
      specify the base filename in the URI, the service will use the filename of the input file. If
      your job has multiple inputs, the service uses the filename of the first input file.

      - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
      based on the type of destination

        - **S3Settings** *(dict) --* Settings associated with S3 destination

          - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon S3
          access control for the outputs in this output group. When you don't use this setting, S3
          automatically applies the default access control list PRIVATE.

            - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
            to this output.

          - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
          uploaded to Amazon S3.

            - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS uses
            data keys to encrypt your content. AWS also encrypts the data keys themselves, using a
            customer master key (CMK), and then stores the encrypted data keys alongside your
            encrypted content. Use this setting to specify which AWS service manages the CMK. For
            simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master
            key to be managed by AWS Key Management Service (KMS), choose AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
            managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
            You can optionally choose to specify a different, customer managed CMK. Do so by
            specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
            (kmsKeyArn).

            - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that you
            want to use to encrypt the data key that AWS uses to encrypt your output content. Enter
            the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also set
            Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
            (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
            specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **Encryption** *(dict) --* If you are using DRM, set DRM System (MsSmoothEncryptionSettings)
      to specify the value SpekeKeyProvider.

        - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
        Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider. If
        your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

          - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
          keys that it provides to MediaConvert, set up a certificate with a master key using AWS
          Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

          - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
          provider uses to identify this content.

          - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers. DASH
          output groups support a max of two system ids. Other group types support one system id.
          See https://dashif.org/identifiers/content_protection/ for more details.

            - *(string) --*

          - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
          key provider uses to provide keys for encrypting your content.

      - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
      fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

      - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
      specify the encoding format for the server and client manifest. Valid options are utf8 and
      utf16.

    - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft Smooth
    Streaming, CMAF)
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputs`
    `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef",
    {
        "CaptionSelectorName": str,
        "CustomLanguageCode": str,
        "DestinationSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputs`
    `CaptionDescriptions`

    - **CaptionSelectorName** *(string) --* Specifies which "Caption
    Selector":#inputs-caption_selector to use from each input when generating captions. The name
    should be of the format "Caption Selector ", which denotes that the Nth Caption Selector will be
    used from each input.

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettings`
    `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputs`
    `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef",
    {
        "AudioGroupId": str,
        "AudioOnlyContainer": str,
        "AudioRenditionSets": str,
        "AudioTrackType": str,
        "IFrameOnlyManifest": str,
        "SegmentModifier": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettings`
    `HlsSettings`

    - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

    - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
    MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default value
    Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the value
    that you specify here, if this output has video, the service will place the output into an
    MPEG2-TS container.

    - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
    output stream. Input all the audio GROUP-IDs that are associated to the video, separate by ','.

    - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
    Variant Stream The client can play back this audio-only stream instead of video in low-bandwidth
    scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select,
    Default Alternate rendition that the client should try to play back by default. Represented as
    an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES Alternate Audio, Auto
    Select, Not Default Alternate rendition that the client may try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=YES Alternate
    Audio, not Auto Select Alternate rendition that the client will not try to play back by default.
    Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

    - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
    addition to the HLS manifest

    - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
    "Format Identifiers":#format_identifier_parameters.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef",
    {
        "HlsSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsHlsSettingsTypeDef
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputs` `OutputSettings`

    - **HlsSettings** *(dict) --* Settings for HLS output groups

      - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
      MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
      value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of the
      value that you specify here, if this output has video, the service will place the output into
      an MPEG2-TS container.

      - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the video
      output stream. Input all the audio GROUP-IDs that are associated to the video, separate by
      ','.

      - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
      Variant Stream The client can play back this audio-only stream instead of video in
      low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
      Audio, Auto Select, Default Alternate rendition that the client should try to play back by
      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=YES
      Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to play
      back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
      AUTOSELECT=YES Alternate Audio, not Auto Select Alternate rendition that the client will not
      try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
      DEFAULT=NO, AUTOSELECT=NO

      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
      addition to the HLS manifest

      - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
      "Format Identifiers":#format_identifier_parameters.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescription`
    `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescription`
    `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescription`
    `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessors`
    `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroupsOutputs` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsTypeDef",
    {
        "AudioDescriptions": List[
            ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsContainerSettingsTypeDef,
        "Extension": str,
        "NameModifier": str,
        "OutputSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsOutputSettingsTypeDef,
        "Preset": str,
        "VideoDescription": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsVideoDescriptionTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsOutputGroups` `Outputs`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
    settings. For each output that has captions, include one instance of (CaptionDescriptions).
    (CaptionDescriptions) can contain multiple groups of captions settings.

      - *(dict) --* Description of Caption output

        - **CaptionSelectorName** *(string) --* Specifies which "Caption
        Selector":#inputs-caption_selector to use from each input when generating captions. The name
        should be of the format "Caption Selector ", which denotes that the Nth Caption Selector
        will be used from each input.

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
    outputs in File output groups. If you do not specify a value, the service will use default
    extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov * MXF
    container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec extensions
    (e.g. AAC, H265, H265, AC3)

    - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
    string to the end of each output filename. You specify the base filename as part of your
    destination URI. When you create multiple outputs in the same output group, Name modifier
    (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO outputs,
    if you use the format identifiers $Number$ or $Time$ in one output, you must use them in the
    same way in all outputs of the output group.

    - **OutputSettings** *(dict) --* Specific settings for this type of output.

      - **HlsSettings** *(dict) --* Settings for HLS output groups

        - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition belongs.

        - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs. Choose
        MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep the default
        value Automatic (AUTOMATIC) to create an audio-only file in a raw container. Regardless of
        the value that you specify here, if this output has video, the service will place the output
        into an MPEG2-TS container.

        - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
        video output stream. Input all the audio GROUP-IDs that are associated to the video,
        separate by ','.

        - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported: Audio-Only
        Variant Stream The client can play back this audio-only stream instead of video in
        low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS manifest. Alternate
        Audio, Auto Select, Default Alternate rendition that the client should try to play back by
        default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES, AUTOSELECT=
            YES
        Alternate Audio, Auto Select, Not Default Alternate rendition that the client may try to
        play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
        AUTOSELECT=
            YES Alternate Audio, not Auto Select Alternate rendition that the client will not
        try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
        DEFAULT=NO, AUTOSELECT=NO

        - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest in
        addition to the HLS manifest

        - **SegmentModifier** *(string) --* String concatenated to end of segment filenames. Accepts
        "Format Identifiers":#format_identifier_parameters.

    - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
    settings. Provide the system or custom preset name. You can specify either Preset (Preset) or
    Container settings (ContainerSettings), but not both.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ListJobsPaginateResponseJobsSettingsOutputGroupsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsOutputGroupsTypeDef",
    {
        "CustomName": str,
        "Name": str,
        "OutputGroupSettings": ListJobsPaginateResponseJobsSettingsOutputGroupsOutputGroupSettingsTypeDef,
        "Outputs": List[ListJobsPaginateResponseJobsSettingsOutputGroupsOutputsTypeDef],
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsOutputGroupsTypeDef(
    _ListJobsPaginateResponseJobsSettingsOutputGroupsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettings` `OutputGroups`

    - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
    output group. This value is displayed on the console and can make your job settings JSON more
    human-readable. It does not affect your outputs. Use up to twelve characters that are either
    letters, numbers, spaces, or underscores.

    - **Name** *(string) --* Name of the output group

    - **OutputGroupSettings** *(dict) --* Output Group settings, including type

      - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
      Group may only contain a single video, audio, or caption output.

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in your job.
        These default manifests reference every output in the output group. To create additional
        top-level manifests that reference a subset of the outputs in the output group, specify a
        list of them here. For each additional manifest that you specify, the service creates one
        HLS manifest and one DASH manifest.

          - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests that
          you want the service to generate for this CMAF output group. Each pair of manifests can
          reference a different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file at
        the top level BaseURL element. Can be used if streams are delivered from a different URL
        than the manifest file.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
          service to use when encrypting your CMAF segments. Choose AES-CBC subsample (SAMPLE-AES)
          or AES_CTR (AES-CTR).

          - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
          choose whether the service writes the 128-bit encryption initialization vector in the HLS
          and DASH manifests.

          - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these settings
          when doing DRM encryption with a SPEKE-compliant key provider. If your output group type
          is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
            signaled in the DASH manifest that MediaConvert creates as part of this CMAF package.
            The DASH manifest can currently signal up to three system IDs. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want signaled
            in the HLS manifest that MediaConvert creates as part of this CMAF package. The HLS
            manifest can currently signal only one system ID. For more information, see
            https://dashif.org/identifiers/content_protection/.

              - *(string) --*

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds, of
        each individual CMAF segment. This value applies to the whole package; that is, to every
        output in the output group. Note that segments end on the first keyframe after this number
        of seconds, so the actual segment length might be slightly longer. If you set Segment
        control (CmafSegmentControl) to single file, the service puts the content of each output in
        a single file that has metadata that marks these segments. If you set it to segmented files,
        the service creates multiple files for each output, each with the content of one segment.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
        generated for this output.

        - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
        generated for this output.

      - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH manifest
        for each DASH ISO output group in your job. This default manifest references every output in
        the output group. To create additional DASH manifests that reference a subset of the outputs
        in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional DASH manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            DASH group is film-name.mpd. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.mpd.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
        file at the top level BaseURL element. Can be used if streams are delivered from a different
        URL than the manifest file.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* DRM settings.

          - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the compatibility
          of your output with video players on obsolete devices. It applies only to DASH H.264
          outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI) only to correct
          problems with playback on older devices. Otherwise, keep the default setting CENC v1
          (CENC_V1). If you choose Unencrypted SEI, for that output, the service will exclude the
          access unit delimiter and will leave the SEI NAL units unencrypted.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds). Fragment
        length must be compatible with GOP size and Framerate. Note that fragments will end on the
        next keyframe after this number of seconds, so actual fragment length may be longer. When
        Emit Single File is checked, the fragmentation is internal to a single output file and it
        does not cause the creation of many output files as in other output types.

        - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

        - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is needed
        to ensure smooth playout.

        - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main. When
        you choose Main profile (MAIN_PROFILE), the service signals
        urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose On-demand
        (ON_DEMAND_PROFILE), the service signals urn:mpeg:dash:profile:isoff-on-demand:2011 in your
        .mpd. When you choose On-demand, you must also set the output group setting Segment control
        (SegmentControl) to Single file (SINGLE_FILE).

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
        generated, which is internally segmented using the Fragment Length and Segment Length. When
        set to SEGMENTED_FILES, separate segment files will be created.

        - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note that
        segments will end on the next keyframe after this number of seconds, so actual segment
        length may be longer. When Emit Single File is checked, the segmentation is internal to a
        single output file and it does not cause the creation of many output files as in other
        output types.

        - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the 400
        range when you play back your DASH output, enable this setting and run your transcoding job
        again. When you enable this setting, the service writes precise segment durations in the
        DASH manifest. The segment duration information appears inside the SegmentTimeline element,
        inside SegmentTemplate at the Representation level. When you don't enable this setting, the
        service writes approximate segment durations in your DASH manifest.

      - **FileGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

      - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

        - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple HLS
        manifest. This setting does not determine whether SCTE-35 markers appear in the outputs
        themselves.

          - *(string) --*

        - **AdditionalManifests** *(list) --* By default, the service creates one top-level .m3u8
        HLS manifest for each HLS output group in your job. This default manifest references every
        output in the output group. To create additional top-level manifests that reference a subset
        of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional HLS manifest that you want the
          service to generate for this output group. Each manifest can reference a different subset
          of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            HLS group is film-name.m3u8. If you enter "-no-premium" for this setting, then the file
            name the service generates for this top-level manifest is film-name-no-premium.m3u8. For
            HLS output groups, specify a manifestNameModifier that is different from the
            nameModifier of the output. The service uses the output name modifier to create unique
            names for the individual variant manifests.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output in
        the media .m3u8 file. Can be used if base manifest is delivered from a different URL than
        the main .m3u8 file.

        - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

          - *(dict) --* Caption Language Mapping

            - **CaptionChannel** *(integer) --* Caption channel.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions channel,
            using the ISO 639-2 or ISO 639-3 three-letter language code

            - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2 three-letter
            code listed at https://www.loc.gov/standards/iso639-2/php/code_list.php.

            - **LanguageDescription** *(string) --* Caption language description.

        - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
        Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in the
        CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
        specify. Make sure to specify the languages in the order in which they appear in the
        original source (if the source is embedded format) or the order of the caption selectors (if
        the source is other than embedded). Otherwise, languages in the manifest will not match up
        properly with the output captions. None: Include CLOSED-CAPTIONS=
            NONE line in the manifest.
        Omit: Omit any CLOSED-CAPTIONS line from the manifest.

        - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag, which
        prevents client from saving media segments for later replay.

        - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
        RFC-4281) during m3u8 playlist generation.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
        subdirectories.

        - **Encryption** *(dict) --* DRM settings.

          - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
          represented by a 32-character text string. If this parameter is not set then the
          Initialization Vector will follow the segment number by default.

          - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
          scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also disables
          encryption.

          - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a 128-bit
          number used in conjunction with the key for encrypting blocks. If set to INCLUDE,
          Initialization Vector is listed in the manifest. Otherwise Initialization Vector is not in
          the manifest.

          - **OfflineEncrypted** *(string) --* Enable this setting to insert the EXT-X-SESSION-KEY
          element into the master playlist. This allows for offline Apple HLS FairPlay content
          protection.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

          - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a static
          key provider.

            - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
            KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
            indicate an implicit value of 'identity'.

            - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
            positive integer version value or a slash delimited list of version values (1/2/3).

            - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
            hexidecimal string to specify Key Value (StaticKeyValue).

            - **Url** *(string) --* Relates to DRM implementation. The location of the license
            server used for protecting content.

          - **Type** *(string) --* Specify whether your DRM encryption key is static or from a key
          provider that follows the SPEKE standard. For more information about SPEKE, see
          https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

        - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

        - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should use
        floating point values for segment duration.

        - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0, unless
        you are troubleshooting a problem with how devices play back the end of your video asset. If
        you know that player devices are hanging on the final segment of your video because the
        length of your final segment is too short, use this setting to specify a minimum final
        segment length, in seconds. Choose a value that is greater than or equal to 1 and less than
        your segment length. When you specify a value for this setting, the encoder will combine any
        final segment that is shorter than the length that you specify with the previous segment.
        For example, your segment length is 3 seconds and your final segment is .5 seconds without a
        minimum final segment length; when you set the minimum final segment length to 1, your final
        segment is 3.5 seconds.

        - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by looking
        ahead and back within the specified range for a nearby avail and extending the segment size
        if needed.

        - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
        generated for this HLS output group.

        - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
        .m3u8 manifest files. The value is calculated as follows: either the program date and time
        are initialized using the input timecode source, or the time is initialized using the input
        timecode source and the date is initialized using the timestamp_offset.

        - **ProgramDateTimePeriod** *(integer) --* Period of insertion of EXT-X-PROGRAM-DATE-TIME
        entry, in seconds.

        - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single media
        resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

        - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create (in
        seconds). Note that segments will end on the next keyframe after this number of seconds, so
        actual segment length may be longer.

        - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a subdirectory
        before starting a new one. directoryStructure must be SINGLE_DIRECTORY for this setting to
        have an effect.

        - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for video in
        EXT-X-STREAM-INF tag of variant manifest.

        - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

        - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

        - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta offset
        to fine tune the timestamps.

      - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
      (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

        - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
        Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job. This
        default manifest references every output in the output group. To create additional manifests
        that reference a subset of the outputs in the output group, specify a list of them here.

          - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming manifest
          that you want the service to generate for this output group. Each manifest can reference a
          different subset of outputs in the group.

            - **ManifestNameModifier** *(string) --* Specify a name modifier that the service adds
            to the name of this manifest to make it different from the file names of the other main
            manifests in the output group. For example, say that the default main manifest for your
            Microsoft Smooth group is film-name.ismv. If you enter "-no-premium" for this setting,
            then the file name the service generates for this top-level manifest is
            film-name-no-premium.ismv.

            - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
            top-level manifest to reference.

              - *(string) --*

        - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical audio
        encoding settings across a Microsoft Smooth output group into a single audio stream.

        - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
        location and the output filename base. Destination accepts format identifiers. If you do not
        specify the base filename in the URI, the service will use the filename of the input file.
        If your job has multiple inputs, the service uses the filename of the first input file.

        - **DestinationSettings** *(dict) --* Settings associated with the destination. Will vary
        based on the type of destination

          - **S3Settings** *(dict) --* Settings associated with S3 destination

            - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply Amazon
            S3 access control for the outputs in this output group. When you don't use this setting,
            S3 automatically applies the default access control list PRIVATE.

              - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to apply
              to this output.

            - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they are
            uploaded to Amazon S3.

              - **EncryptionType** *(string) --* Specify how you want your data keys managed. AWS
              uses data keys to encrypt your content. AWS also encrypts the data keys themselves,
              using a customer master key (CMK), and then stores the encrypted data keys alongside
              your encrypted content. Use this setting to specify which AWS service manages the CMK.
              For simplest set up, choose Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your
              master key to be managed by AWS Key Management Service (KMS), choose AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses the AWS
              managed customer master key (CMK) associated with Amazon S3 to encrypt your data keys.
              You can optionally choose to specify a different, customer managed CMK. Do so by
              specifying the Amazon Resource Name (ARN) of the key for the setting KMS ARN
              (kmsKeyArn).

              - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK) that
              you want to use to encrypt the data key that AWS uses to encrypt your output content.
              Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you must also
              set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
              (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but don't
              specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

        - **Encryption** *(dict) --* If you are using DRM, set DRM System
        (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

          - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or Microsoft
          Smooth, use these settings when doing DRM encryption with a SPEKE-compliant key provider.
          If your output group type is CMAF, use the SpekeKeyProviderCmaf settings instead.

            - **CertificateArn** *(string) --* If you want your key provider to encrypt the content
            keys that it provides to MediaConvert, set up a certificate with a master key using AWS
            Certificate Manager. Specify the certificate's Amazon Resource Name (ARN) here.

            - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
            provider uses to identify this content.

            - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
            DASH output groups support a max of two system ids. Other group types support one system
            id. See https://dashif.org/identifiers/content_protection/ for more details.

              - *(string) --*

            - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant DRM
            key provider uses to provide keys for encrypting your content.

        - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the mp4
        fragment sizes in seconds. Fragment length must be compatible with GOP size and frame rate.

        - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
        specify the encoding format for the server and client manifest. Valid options are utf8 and
        utf16.

      - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
      Smooth Streaming, CMAF)

    - **Outputs** *(list) --* This object holds groups of encoding settings, one group of settings
    per output.

      - *(dict) --* An output object describes the settings for a single output file or stream in an
      output group.

        - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
        settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
        (AudioDescriptions) can contain multiple groups of encoding settings.

          - *(dict) --* Description of audio output

            - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
            Ignore these settings unless you need to comply with a loudness standard.

              - **Algorithm** *(string) --* Choose one of the following audio normalization
              algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
              loudness for an entire piece of content, suitable for measurement of short-form
              content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
              BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with the
              requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified
              peak. The same loudness measurement algorithm as 1770-2, with an updated true peak
              measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
              than the other algorithms, including configurations such as 7.1.

              - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
              the chosen algorithm. If disabled, the audio will be measured but not adjusted.

              - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
              corrected to the target level. Content measuring below this level will not be
              corrected. Gating only applies when not using real_time_correction.

              - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
              loudness to a CSV file.

              - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
              TruePeak for each output's audio track loudness.

              - **TargetLkfs** *(float) --* When you use Audio normalization
              (AudioNormalizationSettings), optionally use this setting to specify a target
              loudness. If you don't specify a value here, the encoder chooses a value for you,
              based on the algorithm that you choose for Algorithm (algorithm). If you choose
              algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will choose
              -23 LKFS.

            - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
            In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
            on its order within each input. For example if you specify "Audio Selector 3", then the
            third audio selector will be used from each input. If an input does not have an "Audio
            Selector 3", then the audio selector marked as "default" in that input will be used. If
            there is no audio selector marked as "default", silence will be inserted for the
            duration of that input. Alternatively, an "Audio Selector
            Group":#inputs-audio_selector_group name may be specified, with similar default/silence
            behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
            automatically.

            - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
            (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
            Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                 Visually Impaired Commentary,
            4-255 = Reserved.

            - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
            ISO 639 audio_type, then that value is passed through to the output. If the input
            contains no ISO 639 audio_type, the value in Audio Type is included in the output.
            Otherwise the value in Audio Type is included in the output. Note that this field and
            audioType are both ignored if audioDescriptionBroadcasterMix is set to
            BROADCASTER_MIXED_AD.

            - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
            (AudioDescriptions) contains the group of settings related to audio encoding. The
            settings in this group vary depending on the value that you choose for Audio codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * AAC, AacSettings * MP2,
            Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
            Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

              - **AacSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
              mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
              set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR
              mode, you control the audio quality with the setting VBR quality (vbrQuality). In CBR
              mode, you use the setting Bitrate (bitrate). Defaults and valid values depend on the
              rate control mode.

                - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
                the input contains pre-mixed main audio + audio description (AD) as a stereo pair.
                The value for AudioType will be set to 3, which signals to downstream systems that
                this stream contains "broadcaster mixed AD". Note that the input received by the
                encoder must contain pre-mixed audio; the encoder does not perform the mixing. When
                you choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                AudioType and FollowInputAudioType. Choose NORMAL when the input does not contain
                pre-mixed audio + audio description (AD). In this case, the encoder will use any
                values you provide for AudioType and FollowInputAudioType.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
                of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
                24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000,
                160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000,
                640000, 768000, 896000, 1024000. The value you set is also constrained by the values
                that you choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                Sample rate (sampleRate). Default values depend on Bitrate control mode and Profile.

                - **CodecProfile** *(string) --* AAC Profile.

                - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                Description (Receiver Mix)" setting receives a stereo description plus control track
                and emits a mono AAC encode of the description track, with control data emitted in
                the PES header as per ETSI TS 101 154 Annex E.

                - **RateControlMode** *(string) --* Rate Control Mode.

                - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                LATM/LOAS AAC in an output, you must choose "No container" for the output container.

                - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                control mode and profile.

                - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
                or MPEG-2 Transport Stream containers.

                - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
                VBR.

              - **Ac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AC3.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                that the encoder emits. For more information about the AC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital, dialnorm will be passed through.

                - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                dynamic range compression signaling to the output bitstream as defined in the Dolby
                Digital specification.

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

              - **AiffSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value AIFF.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **Codec** *(string) --* Type of Audio codec.

              - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                values: 384k, 448k, 640k, 768k

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
                always 9.1.6 (CODING_MODE_9_1_6).

                - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                adjust loudness based on dialogue analysis.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                for downmixing. How the service uses this value depends on the value that you choose
                for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel.

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
                setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, and -6.0.

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
                audio.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                must be speech before the encoder uses the measured speech loudness as the overall
                program loudness.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                - **SurroundExMode** *(string) --* Specify whether your input audio has an
                additional center rear surround channel matrix encoded into your left and right
                surround channels.

              - **Eac3Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value EAC3.

                - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                attenuation to the surround channels. Only used for 3/2 coding mode.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                bitrates depend on the coding mode.

                - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
                A/52-2012 (Annex E).

                - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
                channels.

                - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

                - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                audio is Dolby Digital Plus, dialnorm will be passed through.

                - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for
                a signal with dynamic range compression.

                - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                audio dynamic range when compressing the audio.

                - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                channel is enabled

                - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                prior to encoding. Only valid with 3_2_LFE coding mode.

                - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left only/Right only center
                (loRoCenterMixLevel).

                - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                value for downmixing. How the service uses this value depends on the value that you
                choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
                and -60. The value -60 mutes the channel. This setting applies only if you keep the
                default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                (Eac3CodingMode). If you choose a different value for Coding mode, the service
                ignores Left only/Right only surround (loRoSurroundMixLevel).

                - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                uses this value for downmixing. How the service uses this value depends on the value
                that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0,
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total center
                (ltRtCenterMixLevel).

                - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                MediaConvert uses this value for downmixing. How the service uses this value depends
                on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
                -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting
                applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Left total/Right total surround
                (ltRtSurroundMixLevel).

                - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will
                be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If
                audio was not supplied from one of these streams, then the static metadata settings
                will be used.

                - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                will be passed through if it is present on the input. this detection is dynamic over
                the life of the transcode. Inputs that alternate between DD+ and non-DD+ content
                will have a consistent DD+ output as the system alternates between passthrough and
                encoding.

                - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                surround channels. Only used for 3/2 coding mode.

                - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
                rate in Hz.

                - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                different value for Coding mode, the service ignores Stereo downmix
                (Eac3StereoDownmix).

                - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                center back surround channel is matrix encoded into the left and right surround
                channels.

                - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                Surround is matrix encoded into the two channels.

              - **Mp2Settings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value MP2.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                - **Channels** *(integer) --* Set Channels to specify the number of channels in this
                output audio track. Choosing Mono in the console will give you 1 output channel;
                choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                - **SampleRate** *(integer) --* Sample rate in hz.

              - **WavSettings** *(dict) --* Required when you set (Codec) under
              (AudioDescriptions)>(CodecSettings) to the value WAV.

                - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                choose the encoding quality for this audio track.

                - **Channels** *(integer) --* Specify the number of channels in this output audio
                track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
                on, up to 64.

                - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                the extended support of the RF64 format, set your output WAV file format to RF64.

                - **SampleRate** *(integer) --* Sample rate in Hz.

            - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
            The service puts this language code into your output audio track when you set Language
            code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
            also uses your specified custom language code when you set Language code control
            (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
            specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
            For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
            ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
            Input Language Code' is not selected or when 'Follow Input Language Code' is selected
            but there is no ISO 639 language code specified by the input.

            - **LanguageCodeControl** *(string) --* Specify which source for language code takes
            precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
            service uses the language code from the input track if it's present. If there's no
            languge code on the input track, the service uses the code that you specify in the
            setting Language code (languageCode or customLanguageCode). When you choose Use
            configured (USE_CONFIGURED), the service uses the language code that you specify.

            - **RemixSettings** *(dict) --* Advanced audio remixing settings.

              - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
              of fields that hold the remixing value for each channel. Units are in dB. Acceptable
              values are within the range from -60 (mute) through 6. A setting of 0 passes the input
              channel unchanged to the output channel (no attenuation or amplification).

                - **OutputChannels** *(list) --* List of output channels

                  - *(dict) --* OutputChannel mapping settings.

                    - **InputChannels** *(list) --* List of input channels

                      - *(integer) --*

              - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
              that you want to use in your output. With remixing, you might combine or split the
              data in these channels, so the number of channels in your final output might be
              different.

              - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
              remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

            - **StreamName** *(string) --* Specify a label for this output audio stream. For
            example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
        settings. For each output that has captions, include one instance of (CaptionDescriptions).
        (CaptionDescriptions) can contain multiple groups of captions settings.

          - *(dict) --* Description of Caption output

            - **CaptionSelectorName** *(string) --* Specifies which "Caption
            Selector":#inputs-caption_selector to use from each input when generating captions. The
            name should be of the format "Caption Selector ", which denotes that the Nth Caption
            Selector will be used from each input.

            - **CustomLanguageCode** *(string) --* Specify the language for this captions output
            track. For most captions output formats, the encoder puts this language information in
            the output captions metadata. If your output captions format is DVB-Sub or Burn in, the
            encoder uses this language information when automatically selecting the font script for
            rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3
            code. For streaming outputs, you can also use any other code in the full RFC-5646
            specification. Streaming outputs are those that are in one of the following output
            groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

            - **DestinationSettings** *(dict) --* Specific settings required by destination type.
            Note that burnin_destination_settings are not available if the source of the caption
            data is Embedded or Teletext.

              - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering burn-in captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **DestinationType** *(string) --* Specify the format for this set of captions on
              this output. The default format is embedded without SCTE-20. Other options are
              embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT.
              If you are using SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to
              create an output that complies with the SCTE-43 spec. To create a non-compliant output
              where the embedded captions come first, choose Embedded plus SCTE-20
              (EMBEDDED_PLUS_SCTE20).

              - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                setting alignment to centered will place the captions at the bottom center of the
                output. Similarly, setting a left alignment will align captions to the bottom left
                of the output. If x and y positions are given in conjunction with the alignment
                parameter, the font will be justified (either left or centered) relative to those
                coordinates. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
                captions. All burn-in and DVB-Sub font settings must match.

                - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                must match.

                - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default
                is 96 dpi. All burn-in and DVB-Sub font settings must match.

                - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                code, if the LanguageCode is not sufficient for determining the script type. Where
                LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                This is used to help determine the appropriate font for rendering DVB-Sub captions.

                - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                valid for source captions that are either 608/embedded or teletext. These source
                settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                settings must match.

                - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option
                is not valid for source captions that are either 608/embedded or teletext. These
                source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

                - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                captions. All burn-in and DVB-Sub font settings must match.

                - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels to the left. All burn-in and DVB-Sub font settings must match.

                - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                relative to the captions in pixels. A value of -2 would result in a shadow offset 2
                pixels above the text. All burn-in and DVB-Sub font settings must match.

                - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                or for hearing impaired. Choose hearing impaired if your subtitles include audio
                descriptions and dialogue. Choose standard if your subtitles include only dialogue.

                - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                Teletext or STL formats. Specify whether the spacing between letters in your
                captions is set by the captions grid or varies depending on letter width. Choose
                fixed grid to conform to the spacing specified in the captions file more accurately.
                Choose proportional to make the text easier to read if the captions are closed
                caption.

                - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                relative to the left side of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the left of the output. If no explicit x_position
                is provided, the horizontal caption position will be determined by the alignment
                parameter. This option is not valid for source captions that are STL, 608/embedded
                or teletext. These source settings are already pre-defined by the caption stream.
                All burn-in and DVB-Sub font settings must match.

                - **YPosition** *(integer) --* Specifies the vertical position of the caption
                relative to the top of the output in pixels. A value of 10 would result in the
                captions starting 10 pixels from the top of the output. If no explicit y_position is
                provided, the caption will be positioned towards the bottom of the output. This
                option is not valid for source captions that are STL, 608/embedded or teletext.
                These source settings are already pre-defined by the caption stream. All burn-in and
                DVB-Sub font settings must match.

              - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
              caption outputs, including 608/708 Channel destination number.

                - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and your output captions are embedded in the video
                stream. Specify a CC number for each captions channel in this output. If you have
                two channels, choose CC numbers that aren't in the same field. For example, choose 1
                and 3. For more information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                input captions are SCC format and you want both 608 and 708 captions embedded in
                your output stream. Optionally, specify the 708 service number for each output
                captions channel. Choose a different number for each channel. To use this setting,
                also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                your input captions selector settings. If you choose to upconvert but don't specify
                a 708 service number, MediaConvert uses the number that you specify for CC channel
                number (destination608ChannelNumber) for the 708 service number. For more
                information, see
                https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
                use the font style and position information from the captions source in the output.
                This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT,
                or TTML. Disable this setting for simplified output captions.

              - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                that the captions and the video are synchronized in the output. Specify a frame rate
                that matches the frame rate of the associated video. If the video frame rate is
                29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                video_insertion=true and drop_frame_timecode=
                    true; otherwise, choose 29.97
                non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

              - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                destination captions for this output. This value must be a three-digit hexadecimal
                string; strings ending in -FF are invalid. If you are passing through the entire set
                of Teletext data, do not use this field.

                - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                don't specify a value here, the service sets the page type to the default value
                Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
                don't use this field. When you pass through a set of Teletext pages, your output has
                the same page types as your input.

                  - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

              - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
              including Pass style information (TtmlStylePassthrough).

                - **StylePassthrough** *(string) --* Pass through style and position information
                from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML
                output.

            - **LanguageCode** *(string) --* Specify the language of this captions output track. For
            most captions output formats, the encoder puts this language information in the output
            captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder
            uses this language information to choose the font language for rendering the captions
            text.

            - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
            For example, "English", "Director commentary", or "track_2". For streaming outputs,
            MediaConvert passes this information into destination manifests for display on the
            end-viewer's player device. For outputs in other output groups, the service ignores this
            setting.

        - **ContainerSettings** *(dict) --* Container specific settings.

          - **Container** *(string) --* Container for this output. Some containers require a
          container settings object. If not specified, the default object will be created.

          - **F4vSettings** *(dict) --* Settings for F4v container

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

          - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
          File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
          (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
          stream program contains subsets of data, including audio, video, and metadata. Each of
          these subsets of data has a numerical label called a packet identifier (PID). Each
          transport stream program corresponds to one MediaConvert output. The PMT lists the types
          of data in a program along with their PID. Downstream systems and players use the program
          map table to look up the PID for each type of data it accesses and then uses the PIDs to
          locate specific data within the asset.

            - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
            Dolby Digital audio.

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
            audio streams you include in this output. Specify multiple PIDs as a JSON array. Default
            is the range 482-492.

              - *(integer) --*

            - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
            per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
            Other common values are 3750000, 7500000, and 15000000.

            - **BufferModel** *(string) --* Controls what buffer model to use for accurate
            interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
            lead to lower latency, but low-memory devices may not be able to play back the stream
            without interruptions.

            - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
            specified table repetition interval.

              - **NetworkId** *(integer) --* The numeric value placed in the Network Information
              Table (NIT).

              - **NetworkName** *(string) --* The network name text placed in the
              network_name_descriptor inside the Network Information Table. Maximum length is 256
              characters.

              - **NitInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
            specified table repetition interval.

              - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
              stream. "Follow input SDT" copies SDT information from input stream to output stream.
              "Follow input SDT if present" copies SDT information from input stream to output
              stream if SDT information is present in the input, otherwise it will fall back on the
              user-defined values. Enter "SDT Manually" means user will enter the SDT information.
              "No SDT" means output stream will not contain SDT information.

              - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **ServiceName** *(string) --* The service name placed in the service_descriptor in
              the Service Description Table. Maximum length is 256 characters.

              - **ServiceProviderName** *(string) --* The service provider name placed in the
              service_descriptor in the Service Description Table. Maximum length is 256 characters.

            - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
            included in this output. Specify multiple PIDs as a JSON array. Default is the range
            460-479.

              - *(integer) --*

            - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
            table repetition interval.

              - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

            - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
            data you include in this output. Default is 499.

            - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
            markers will be added to partitions 3 and 4. The interval between these additional
            markers will be fixed, and will be slightly shorter than the video EBP marker interval.
            When set to VIDEO_INTERVAL, these additional markers will not be inserted. Only
            applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
            EBP_LEGACY).

            - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
            either be placed only on the video PID, or on both the video PID and all audio PIDs.
            Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
            EBP or EBP_LEGACY).

            - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
            header.

            - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
            know that your audio EBP markers are incorrectly appearing before your video EBP
            markers. To correct this problem, set this value to Force (FORCE).

            - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
            EBP markers.

            - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
            Program Clock References (PCRs) inserted into the transport stream.

            - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
            not come within the specified time interval of each other by looking ahead at input
            video. If another EBP is going to come in within the specified time interval, the
            current EBP is not emitted, and the segment is "stretched" to the next marker. The
            lookahead value does not add latency to the system. The Live Event must be configured
            elsewhere to create sufficient latency to make the lookahead accurate.

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
            insert into the transport stream. This can be used if a downstream encryption system
            requires periodic null packets.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This is
            effective only when the PCR PID is the same as the video or audio elementary stream.

            - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
            reference (PCR) in this output. If you do not specify a value, the service will use the
            value for Video PID (VideoPid).

            - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
            the program map table (PMT) in the output transport stream.

            - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
            table (PMT) itself. Default is 480.

            - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
            private metadata stream. Default is 503.

            - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
            program number used in the program map table (PMT) for this output. Default is 1.
            Program numbers and program map tables are parts of MPEG-2 transport stream containers,
            used for organizing data.

            - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
            to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
            bitrate, but the output will not be padded up to that bitrate.

            - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
            your HLS and transport stream outputs at the insertion points that you specify in an
            ESAM XML document. Provide the document in the setting SCC XML (sccXml).

              - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
              the transport stream generated by ESAM.

            - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
            in the transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also provide
            the ESAM XML as a string in the setting Signal processing notification XML (sccXml).
            Also enable ESAM SCTE-35 (include the property scte35Esam).

            - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
            segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
            adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
            private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
            ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
            specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
            to the adaptation field using a legacy proprietary format.

            - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
            segmentation markers are inserted into the transport stream. With avails, it is possible
            that segments may be truncated, which can influence where future segmentation markers
            are inserted. When a segmentation style of "reset_cadence" is selected and a segment is
            truncated due to an avail, we will reset the segmentation cadence. This means the
            subsequent segment will have a duration of of $segmentation_time seconds. When a
            segmentation style of "maintain_cadence" is selected and a segment is truncated due to
            an avail, we will not reset the segmentation cadence. This means the subsequent segment
            will likely be truncated as well. However, all segments after that will have a duration
            of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
            rule.

            - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
            Required unless markers is set to _none_.

            - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
            metadata in this output. Default is 502.

            - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
            the program map table for this output. Transport stream IDs and program map tables are
            parts of MPEG-2 transport stream containers, used for organizing data.

            - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
            video stream in the transport stream.

          - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

            - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
            packet.

            - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
            the transport stream. Multiple values are accepted, and can be entered in ranges and/or
            by comma separation.

              - *(integer) --*

            - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
            will be detected in the input audio and an equivalent ID3 tag will be inserted in the
            output.

            - **PatInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
            Reference value is inserted for every Packetized Elementary Stream (PES) header. This
            parameter is effective only when the PCR PID is the same as the video or audio
            elementary stream.

            - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
            in the transport stream. When no value is given, the encoder will assign the same value
            as the Video PID.

            - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
            the transport stream.

            - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
            stream in the transport stream.

            - **ProgramNumber** *(integer) --* The value of the program number field in the Program
            Map Table.

            - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream.

            - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
            Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also
            appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in this
            output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you don't
            want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers
            (adMarkers) if you do want manifest conditioning. In both cases, also provide the ESAM
            XML as a string in the setting Signal processing notification XML (sccXml).

            - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
            specify whether the service inserts the ID3 timed metadata from the input in this
            output.

            - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
            stream in the transport stream.

            - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
            Program Map Table.

            - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
            the transport stream.

          - **MovSettings** *(dict) --* Settings for MOV Container.

            - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
            video output settings.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
            into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
            Apple editors and players, but may decrease compatibility with other players. Only
            applicable when the video codec is MPEG2.

            - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

            - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
            setting.

          - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
          outputs with this container.

            - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
            composition times in the 'ctts' (composition time to sample) box for B-frames will be
            negative, and a 'cslg' (composition shift least greatest) box will be included per
            14496-1 amendment 1. This improves compatibility with Apple players and tools.

            - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
            box.

            - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
            relocated to the beginning of the archive as required for progressive downloading.
            Otherwise it is placed normally at the end.

            - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
            Usually not necessary to specify.

          - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

            - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
            that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
            output from your audio and video. Choose Raw (RAW) for captions in a single XML file in
            a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format
            contained within fragmented MP4 files. This set of fragmented MP4 files is separate from
            your video and audio fragmented MP4 files.

            - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
            from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
            that you specify in an ESAM XML document. Provide the document in the setting SCC XML
            (sccXml).

            - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
            your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
            appear in your input to also appear in this output. Choose None (NONE) if you don't want
            those SCTE-35 markers in this output.

        - **Extension** *(string) --* Use Extension (Extension) to specify the file extension for
        outputs in File output groups. If you do not specify a value, the service will use default
        extensions by container type as follows * MPEG-2 transport stream, m2ts * Quicktime, mov *
        MXF container, mxf * MPEG-4 container, mp4 * No Container, the service will use codec
        extensions (e.g. AAC, H265, H265, AC3)

        - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service add a
        string to the end of each output filename. You specify the base filename as part of your
        destination URI. When you create multiple outputs in the same output group, Name modifier
        (NameModifier) is required. Name modifier also accepts format identifiers. For DASH ISO
        outputs, if you use the format identifiers $Number$ or $Time$ in one output, you must use
        them in the same way in all outputs of the output group.

        - **OutputSettings** *(dict) --* Specific settings for this type of output.

          - **HlsSettings** *(dict) --* Settings for HLS output groups

            - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
            belongs.

            - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
            Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container. Keep
            the default value Automatic (AUTOMATIC) to create an audio-only file in a raw container.
            Regardless of the value that you specify here, if this output has video, the service
            will place the output into an MPEG2-TS container.

            - **AudioRenditionSets** *(string) --* List all the audio groups that are used with the
            video output stream. Input all the audio GROUP-IDs that are associated to the video,
            separate by ','.

            - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
            Audio-Only Variant Stream The client can play back this audio-only stream instead of
            video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
            manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
            should try to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest
            with DEFAULT=YES, AUTOSELECT=
                YES Alternate Audio, Auto Select, Not Default Alternate
            rendition that the client may try to play back by default. Represented as an EXT-X-MEDIA
            in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                YES Alternate Audio, not Auto Select
            Alternate rendition that the client will not try to play back by default. Represented as
            an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=NO

            - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only Manifest
            in addition to the HLS manifest

            - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
            Accepts "Format Identifiers":#format_identifier_parameters.

        - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
        settings. Provide the system or custom preset name. You can specify either Preset (Preset)
        or Container settings (ContainerSettings), but not both.

        - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
        settings. The specific video settings depend on the video codec that you choose when you
        specify a value for Video codec (codec). Include one instance of (VideoDescription) per
        output.

          - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
          outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
          AFD values in the output video data and what those values are. * Choose None to remove all
          AFD values from this output. * Choose Fixed to ignore input AFD values and instead encode
          the value specified in the job. * Choose Auto to calculate output AFD values based on the
          input AFD scaler data.

          - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
          outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
          that in your job, the service will ignore the setting.

          - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
          (VideoDescription), contains the group of settings related to video encoding. The settings
          in this group vary depending on the value that you choose for Video codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings *
          MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

            - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
            enum values defined by the object VideoCodec.

            - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

              - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.n.jpg where n is the 0-based sequence number of each
              Capture.

              - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
              the output stream, then one frame every framerateDenominator/framerateNumerator
              seconds. For example, settings of framerateNumerator =
                   1 and framerateDenominator = 3
              (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every 3s.
              Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame sequence
              number zero padded to 7 decimal places.

              - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
              files).

              - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

            - **H264Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value H_264.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
              output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

              - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
              only available with the AVC-I License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main
              or High profile) or CAVLC.

              - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
              interlaced outputs.

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job specification as a JSON file without the console, use FramerateControl
              to specify which value the service uses for the frame rate for this output. Choose
              INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
              Choose SPECIFIED if you want the service to use the frame rate you specify in the
              settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateDenominator to specify the denominator of this
              fraction. In this example, use 1001 for the value of FramerateDenominator. When you
              use the console for transcode jobs that use frame rate conversion, provide the value
              as a decimal number for Framerate. In this example, specify 23.976.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type, as follows. - If the source is
              interlaced, the output will be interlaced with the same polarity as the source (it
              will follow the source). The output could therefore be a mix of "top field first" and
              "bottom field first". - If the source is progressive, the output will be interlaced
              with "top field first" or "bottom field first" polarity, depending on which of the
              Follow options you chose.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h264Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
              repeated.

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

            - **H265Settings** *(dict) --* Settings for H265 codec

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
              SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
              (EOTF).

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* H.265 Level.

              - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
              specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
              Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
              License.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              to reduce flicker or 'pop' on I-frames.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
              that have B frames > 1.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
              Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type
              of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD)
              to create an output that's interlaced with the same field polarity throughout. Choose
              Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
              to create an interlaced output with the same field polarity as the source. If the
              source is interlaced, the output will be interlaced with the same polarity as the
              source (it will follow the source). The output could therefore be a mix of "top field
              first" and "bottom field first". If the source is progressive, your output will be
              interlaced with "top field first" or "bottom field first" polarity, depending on which
              of the Follow options you chose. If you don't choose a value, the service will default
              to Progressive (PROGRESSIVE).

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000. Required when Rate control mode is QVBR.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
              encoder may use more than requested if using B-frames and/or interlaced encoding.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
              singlepass, or high-quality multipass video encoding.

              - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
              with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
              you set Rate control mode to a value other than QVBR, or when you don't define Rate
              control mode.

                - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode
                is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values
                suited to the complexity of your input video, the service limits the average bitrate
                of the video part of this output to the value that you choose. That is, the total
                size of the video element is less than or equal to the value you set multiplied by
                the number of seconds of encoded output.

                - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
                That is, when you specify qvbrSettings within h265Settings. Specify the target
                quality level for this output, from 1 to 10. Use higher numbers for greater quality.
                Level 10 results in nearly lossless compression. The quality level for most
                broadcast-quality transcodes is between 6 and 9.

              - **RateControlMode** *(string) --* Use this setting to specify whether this output
              has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
              bitrate (QVBR).

              - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
              (SAO) filter strength. Adaptive mode dynamically selects best strength based on
              content

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default. If this output uses QVBR, choose Transition detection
              (TRANSITION_DETECTION) for further video quality improvement. For more information
              about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

              - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
              to the number of macroblock rows for progressive pictures, and less than or equal to
              half the number of macroblock rows for interlaced pictures.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
              Framerate (framerate) field is set to 29.970. This field works with the Streams >
              Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
              Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
              output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
              29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
              output to 29.97i.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

              - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
              bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
              form one layer, reference B-frames can form a second layer and non-reference b-frames
              can form a third layer. Decoders can optionally decode only the lower temporal layers
              to generate a lower frame rate output. For example, given a bitstream with temporal
              IDs and with b-frames =
                   1 (i.e. IbPbPb display order), a decoder could decode all the
              frames for full frame rate output or only the I and P frames (lowest temporal layer)
              for a half frame rate output.

              - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
              subdivision of the encoded pictures.

              - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
              of an unregistered SEI message.

              - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
              doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF
              or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
              Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
              following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd
              Edition. For these outputs, the service stores parameter set NAL units in the sample
              headers but not in the samples directly. For MP4 outputs, when you choose HVC1, your
              output video might not work properly with some downstream systems and video players.
              The service defaults to marking your output as HEV1. For these outputs, the service
              writes parameter set NAL units directly into the samples.

            - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value MPEG2.

              - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
              quantizers to vary to improve visual quality.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
              for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to
              the nearest multiple of 1000.

              - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
              the video output.

              - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
              profile for the video output.

              - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
              for high-motion content. This will cause the service to use fewer B-frames (which
              infer information based on other frames) for high-motion portions of the video and
              more B-frames for low-motion portions. The maximum number of B-frames is limited by
              the value you provide for the setting B frames between reference frames
              (numberBFramesBetweenReferenceFrames).

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
              fraction, e.g. 24000 / 1001 = 23.976 fps.

              - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
              applications, it is recommended that this be set to 1 so a decoder joining mid-stream
              will receive an IDR frame as quickly as possible. Setting this value to 0 will break
              output segmenting.

              - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
              be greater than zero.

              - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
              frames or seconds. If seconds the system will convert the GOP Size into a frame count
              at run time.

              - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
              should initially be filled (HRD buffer model).

              - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
              example, enter five megabits as 5000000.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
              set quantization precision for intra-block DC coefficients. If you choose the value
              auto, the service will automatically select the precision based on the per-frame
              compression ratio.

              - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
              five megabits per second as 5000000.

              - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
              I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
              within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to
              the scene change I-frame. GOP stretch requires enabling lookahead as well as setting
              I-interval. The normal cadence resumes for the next GOP. This setting is only used
              when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size +
              Min-I-interval - 1

              - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
              reference frames.

              - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
              service to use the pixel aspect ratio from the input. Using the console, do this by
              choosing Follow source for Pixel aspect ratio.

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **QualityTuningLevel** *(string) --* Use Quality tuning level
              (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
              encoding.

              - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
              specifiy whether the bitrate is variable (vbr) or constant (cbr).

              - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
              changes that the service automatically detects. This improves video quality and is
              enabled by default.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
              high-frequency content in the encoded image.

              - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on spatial variation of content complexity.

              - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
              356M-2001).

              - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
              output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
              converstion to the player.

              - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
              based on temporal variation of content complexity.

            - **ProresSettings** *(dict) --* Required when you set (Codec) under
            (VideoDescription)>(CodecSettings) to the value PRORES.

              - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
              of Apple ProRes codec to use for this output.

              - **FramerateControl** *(string) --* If you are using the console, use the Framerate
              setting to specify the frame rate for this output. If you want to keep the same frame
              rate as the input video, choose Follow source. If you want to do frame rate
              conversion, choose a frame rate from the dropdown list or choose Custom. The
              framerates shown in the dropdown list are decimal approximations of fractions. If you
              choose Custom, specify your frame rate as a fraction. If you are creating your
              transcoding job sepecification as a JSON file without the console, use
              FramerateControl to specify which value the service uses for the frame rate for this
              output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
              from the input. Choose SPECIFIED if you want the service to use the frame rate you
              specify in the settings FramerateNumerator and FramerateDenominator.

              - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
              smoother motion during frame rate conversion.

              - **FramerateDenominator** *(integer) --* Frame rate denominator.

              - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
              use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
              1001 =
                   23.976 fps. Use FramerateNumerator to specify the numerator of this fraction.
              In this example, use 24000 for the value of FramerateNumerator.

              - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
              scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
              (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
              polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
              Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
              Therefore, behavior depends on the input scan type. - If the source is interlaced, the
              output will be interlaced with the same polarity as the source (it will follow the
              source). The output could therefore be a mix of "top field first" and "bottom field
              first". - If the source is progressive, the output will be interlaced with "top field
              first" or "bottom field first" polarity, depending on which of the Follow options you
              chose.

              - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
              determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
              use the pixel aspect ratio from the input. To specify a different pixel aspect ratio:
              Using the console, choose it from the dropdown menu. Using the API, set
              ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

              - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

              - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

              - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
              input is relabeled as 25fps, and audio is sped up correspondingly.

              - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
              (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a
              29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and
              leave converstion to the player.

          - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
          metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this
          output. If you don't specify a value, the service sets this to Insert by default.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
          is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
          use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
          enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

          - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
          (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
          on all frames of this video output.

          - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
          height for this output. Specify in pixels. If you don't provide a value here, the service
          will use the input height.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black.

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
          service changes the video itself in response to AFD values in the input. * Choose Respond
          to clip the input video frame according to the AFD value, input display aspect ratio, and
          output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
          choose this when AfdSignaling is set to (NONE). A preferred implementation of this
          workflow is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to
          remove all input AFD values from this output.

          - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
          different aspect ratio from the input aspect ratio. Choose Stretch to output
          (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
          Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
          any value that you specify for the setting Selection placement (position) in this output.

          - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
          of anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
          scaling. Sharpness only applies if your output resolution is different from your input
          resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most
          content.

          - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
          outputs. Only enable Timecode insertion when the input frame rate is identical to the
          output frame rate. To include timecodes in this output, set Timecode insertion
          (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
          is DISABLED. When the service inserts timecodes in an output, by default, it uses any
          embedded timecodes from the input. If none are present, the service will set the timecode
          for the first output frame to zero. To change this default behavior, adjust the settings
          under Timecode configuration (TimecodeConfig). In the console, these settings are located
          under Job > Job settings > Timecode configuration. Note - Timecode source under input
          settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
          output. Source under Job settings > Timecode configuration (TimecodeSource) does.

          - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
          Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
          features are disabled by default.

            - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
            necessary. Enable or disable this feature for each output individually. This setting is
            disabled by default.

              - **Brightness** *(integer) --* Brightness level.

              - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
              output. The service supports conversion between HDR formats, between SDR formats, and
              from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
              conversion doesn't upgrade the dynamic range. The converted video has an HDR format,
              but visually appears the same as an unconverted output.

              - **Contrast** *(integer) --* Contrast level.

              - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
              color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata
              that you want signaled in the output. These values don't affect the pixel values that
              are encoded in the video stream. They are intended to help the downstream video player
              display content in a way that reflects the intentions of the the content creator. When
              you set Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these
              settings are required. You must set values for Max frame average light level
              (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
              settings don't have a default value. The default values for the other HDR 10 metadata
              settings are defined by the P3D65 color space. For more information about MediaConvert
              HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                the coded video sequence, in units of candelas per square meter. This setting
                doesn't have a default value; you must specify a value that is suitable for the
                content.

                - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                frame in the coded video sequence, in units of candelas per square meter. This
                setting doesn't have a default value; you must specify a value that is suitable for
                the content.

                - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                units of of 0.0001 candelas per square meter.

                - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                units of of 0.0001 candelas per square meter

                - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

                - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by
                a color grader, using color grading tools. Range is 0 to 50,000, each increment
                represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                color correction.

              - **Hue** *(integer) --* Hue in degrees.

              - **Saturation** *(integer) --* Saturation level.

            - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
            motion and a clearer picture.

              - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
              to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
              (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
              Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
              as a scrolling headline at the bottom of the frame.

              - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
              convert frames that are tagged in metadata as progressive. It will only convert those
              that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
              converts every frame to progressive - even those that are already tagged as
              progressive. Turn Force mode on only if there is a good chance that the metadata has
              tagged frames as progressive when they are not progressive. Do not turn on otherwise;
              processing frames that are already progressive into progressive will probably result
              in lower quality video.

              - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
              will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
              progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p.
              - Adaptive auto-detects and converts to progressive.

            - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
            compatible video output.

              - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
              SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                corresponds to the brightest pixel in the entire stream. Measured in nits.

                - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
                that corresponds to the highest frame-average brightness in the entire stream.
                Measured in nits.

              - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
              Dolby Vision MaxCLL and MaxFALL properies.

              - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
              Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
              Dolby Vision frame interleaved data.

            - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
            include a graphic overlay on your video. Enable or disable this feature for each output
            individually. This setting is disabled by default.

              - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
              video. The images must be PNG or TGA files.

                - *(dict) --* Settings that specify how your still graphic overlay appears.

                  - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                  remain on the output video. This duration includes fade-in time but not fade-out
                  time.

                  - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                  the Start time that you specify for the image insertion and the time that the
                  image appears at full opacity. Full opacity is the level that you specify for the
                  opacity setting. If you don't specify a value for Fade-in, the image will appear
                  abruptly at the overlay start time.

                  - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                  the end of the time that you have specified for the image overlay Duration and
                  when the overlaid image has faded to total transparency. If you don't specify a
                  value for Fade-out, the image will disappear abruptly at the end of the inserted
                  image duration.

                  - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution height, the service
                  will crop your overlaid image to fit. To use the native height of the image, keep
                  this setting blank.

                  - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                  location of the image that you want to overlay on the video. Use a PNG or TGA
                  file.

                  - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                  image and the left edge of the video frame. Required for any image overlay that
                  you specify.

                  - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                  image and the top edge of the video frame. Required for any image overlay that you
                  specify.

                  - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                  with higher values for Layer appear on top of images with lower values for Layer.

                  - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                  underlying video shows through the inserted image. 0 is transparent and 100 is
                  fully opaque. Default is 50.

                  - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                  overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                  format. Remember to take into account your timecode source settings.

                  - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                  you specify a value that's larger than the video resolution width, the service
                  will crop your overlaid image to fit. To use the native width of the image, keep
                  this setting blank.

            - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
            noise from your video output if necessary. Enable or disable this feature for each
            output individually. This setting is disabled by default.

              - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
              of the following spatial image filtering functions. To use this setting, you must also
              enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise.
              * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering.
              * Conserve does min/max noise reduction. * Spatial does frequency-domain filtering
              based on JND principles. * Temporal optimizes video quality for complex motion.

              - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
              filter.

                - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                maximum strength.

                - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                (higher speed), with 0 being the nominal value.

                - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                values produce stronger filtering.

              - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
              filter.

                - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
                motion. Higher values produce stronger temporal filtering. This filters highly
                complex scenes more aggressively and creates better VQ for low bitrate outputs.

                - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                setting reduces bit rate at the cost of transcode time, high setting improves
                transcode time at the cost of bit rate.

                - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                this output. Higher values produce stronger filtering. We recommend the following
                value ranges, depending on the result that you want: * 0-2 for complexity reduction
                with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
                8-16 for a high level of complexity reduction

            - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
            timecode and specified prefix into the output.

              - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
              burned-in timecode. Valid values are 10, 16, 32, 48.

              - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
              (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

              - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
              burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
              "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
              equivalents. The supported range of characters is 0x20 through 0x7e. This includes
              letters, numbers, and all special characters represented on a standard English
              keyboard.

          - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
          pixels, for this output. If you don't provide a value here, the service will use the input
          width.
    """


_ListJobsPaginateResponseJobsSettingsTimecodeConfigTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsTimecodeConfigTypeDef",
    {"Anchor": str, "Source": str, "Start": str, "TimestampOffset": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsTimecodeConfigTypeDef(
    _ListJobsPaginateResponseJobsSettingsTimecodeConfigTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettings` `TimecodeConfig`

    - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode, use
    Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to the
    output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF). This
    setting ignores frame rate conversion. System behavior for Anchor Timecode varies depending on
    your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
    (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode (Start). Anchor
    Timecode (Anchor) and Start Timecode (Start) are used calculate output timecode. * If Source
    (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame is 00:00:00:00. * If Source
    (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is the timecode value on the
    first input frame of the input.

    - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
    this job. To make sure that your video, audio, captions, and markers are synchronized and that
    time-based features, such as image inserter, work correctly, choose the Timecode source option
    that matches your assets. All timecodes are in a 24-hour format with frame number (HH:MM:SS:FF).
    * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no embedded timecode is
    in the source, the service will use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) -
    Set the timecode of the initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set
    the timecode of the initial frame to a value other than zero. You use Start timecode (Start) to
    provide this value.

    - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
    (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame. Use
    24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

    - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
    stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
    the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
    Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in the
    output settings. For example, if the date part of your timecodes is 2002-1-25 and you want to
    change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.
    """


_ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef",
    {"Id3": str, "Timecode": str},
    total=False,
)


class ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef(
    _ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettingsTimedMetadataInsertion` `Id3Insertions`

    - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

    - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF format.
    """


_ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionTypeDef",
    {
        "Id3Insertions": List[
            ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionId3InsertionsTypeDef
        ]
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionTypeDef(
    _ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionTypeDef
):
    """
    Type definition for `ListJobsPaginateResponseJobsSettings` `TimedMetadataInsertion`

    - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

      - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
      specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
      tag should be inserted. To insert multiple ID3 tags in your output, create multiple instances
      of ID3 insertion (Id3Insertion).

        - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

        - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
        format.
    """


_ListJobsPaginateResponseJobsSettingsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsSettingsTypeDef",
    {
        "AdAvailOffset": int,
        "AvailBlanking": ListJobsPaginateResponseJobsSettingsAvailBlankingTypeDef,
        "Esam": ListJobsPaginateResponseJobsSettingsEsamTypeDef,
        "Inputs": List[ListJobsPaginateResponseJobsSettingsInputsTypeDef],
        "MotionImageInserter": ListJobsPaginateResponseJobsSettingsMotionImageInserterTypeDef,
        "NielsenConfiguration": ListJobsPaginateResponseJobsSettingsNielsenConfigurationTypeDef,
        "OutputGroups": List[ListJobsPaginateResponseJobsSettingsOutputGroupsTypeDef],
        "TimecodeConfig": ListJobsPaginateResponseJobsSettingsTimecodeConfigTypeDef,
        "TimedMetadataInsertion": ListJobsPaginateResponseJobsSettingsTimedMetadataInsertionTypeDef,
    },
    total=False,
)


class ListJobsPaginateResponseJobsSettingsTypeDef(_ListJobsPaginateResponseJobsSettingsTypeDef):
    """
    Type definition for `ListJobsPaginateResponseJobs` `Settings`

    - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to the
    input Ad Avail PTS time.

    - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or overlaid
    with an image, and audio muted during SCTE-35 triggered ad avails.

      - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid black.
      Only bmp and png images are supported.

    - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

      - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
      ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
      the manifest conditioning instructions that you provide in the setting MCC XML (mccXml).

        - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
        document inside your JSON job settings. Form the XML document as per
        OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions in
        the message that you supply.

      - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
      between the SCTE 35 messages that the transcoder places and the splice points that they refer
      to. If the time between the start of the asset and the SCTE-35 message is less than this
      value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

      - **SignalProcessingNotification** *(dict) --* Specifies an ESAM SignalProcessingNotification
      XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the signal processing instructions
      that you provide in the setting SCC XML (sccXml).

        - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
        inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
        transcoder will use the signal processing instructions in the message that you supply.
        Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
        For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
        insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
        (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
        passthrough. You can't do both.

    - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode job.
    There can be multiple inputs add in a job. These inputs will be concantenated together to create
    the output.

      - *(dict) --* Specifies media input

        - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
        combine. An input may have multiple audio selector groups. See "Audio Selector
        Group":#inputs-audio_selector_group for more information.

          - *(string) --*

            - *(dict) --* Group of Audio Selectors

              - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
              to include in the group. Audio selector names are standardized, based on their order
              within the input (e.g., "Audio Selector 1"). The audio selector name parameter can be
              repeated to add any number of audio selectors to the group.

                - *(string) --*

        - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track or
        set of tracks from the input that you will use in your outputs. You can use mutiple Audio
        selectors per input.

          - *(string) --*

            - *(dict) --* Selector for Audio

              - **CustomLanguageCode** *(string) --* Selects a specific language code from within an
              audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

              - **DefaultSelection** *(string) --* Enable this setting on one audio selector to set
              it as the default for the job. The service uses this default for outputs where it
              can't find the specified input audio. If you don't set a default, those outputs have
              no audio.

              - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external file
              source.

              - **LanguageCode** *(string) --* Selects a specific language code from within an audio
              source.

              - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the audio
              from the input video.

              - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
              selects PID 0x101).

                - *(integer) --*

              - **ProgramSelection** *(integer) --* Use this setting for input streams that contain
              Dolby E, to have the service extract specific program data from the track. To select
              multiple programs, create multiple selectors with the same Track and different Program
              numbers. In the console, this setting is visible when you set Selector type to Track.
              Choose the program number from the dropdown list. If you are sending a JSON file,
              provide the program ID, which is part of the audio metadata. If your input file has
              incorrect metadata, you can choose All channels instead of a program number to have
              the service ignore the program IDs and include all the programs in the track.

              - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
              one input to match those of another input. This allows you to combine the two files
              into a single output, one after the other.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **SelectorType** *(string) --* Specifies the type of the audio selector.

              - **Tracks** *(list) --* Identify a track from the input audio to include in this
              selector by entering the track index number. To include several tracks in a single
              audio selector, specify multiple tracks as follows. Using the console, enter a
              comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
              Specifying directly in your JSON job file, provide the track numbers in an array. For
              example, "tracks": [1,2,3].

                - *(integer) --*

        - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify the
        captions data from the input that you will use in your outputs. You can use mutiple captions
        selectors per input.

          - *(string) --*

            - *(dict) --* Set up captions in your outputs by first selecting them from your input
            here.

              - **CustomLanguageCode** *(string) --* The specific language to extract from source,
              using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
              complete this field and/or PID to select the caption language to extract. If input is
              DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to select
              the caption language to extract. If input is DVB-Sub that is being passed through,
              omit this field (and PID field); there is no way to extract a specific language with
              pass-through captions.

              - **LanguageCode** *(string) --* The specific language to extract from source. If
              input is SCTE-27, complete this field and/or PID to select the caption language to
              extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
              and/or PID to select the caption language to extract. If input is DVB-Sub that is
              being passed through, omit this field (and PID field); there is no way to extract a
              specific language with pass-through captions.

              - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI, SRT,
              or IMSC in an xml file, specify the URI of the input captions source file. If your
              input captions are IMSC in an IMF package, use TrackSourceSettings instead of
              FileSoureSettings.

                - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel number
                  in the ancillary data track from which to extract captions. Unused for
                  passthrough.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                  - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this PID
                  for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content is
                  passed through, regardless of selectors.

                - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                  within the video track from which to extract captions. Unused for passthrough.

                  - **Source608TrackNumber** *(integer) --* Specifies the video track index used for
                  extracting captions. The system only supports one input video track, so this
                  should always be set to '1'.

                  - **TerminateCaptions** *(string) --* By default, the service terminates any
                  unterminated captions at the end of each input. If you want the caption to
                  continue onto your next input, disable this setting.

                - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT, STL,
                TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source file.
                If your caption source is IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **Convert608To708** *(string) --* Specify whether this set of input captions
                  appears in your outputs in both 608 and 708 format. If you choose Upconvert
                  (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                  608 data through using the 608 compatibility bytes fields of the 708 wrapper, and
                  it also translates the 608 data into 708.

                  - **SourceFile** *(string) --* External caption file used for loading captions.
                  Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                  'smi'.

                  - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                  captions from the source file.

                - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                your input captions. The service cannot auto-detect caption format.

                - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                sources, including Page number.

                  - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                  three-digit hexadecimal page number that will be used for Teletext captions. Do
                  not use this setting if you are passing through teletext from the input source to
                  output.

                - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that are
                specified by track number. Currently, this is only IMSC captions in an IMF package.
                If your caption source is IMSC 1.1 in a separate xml file, use FileSourceSettings
                instead of TrackSourceSettings.

                  - **TrackNumber** *(integer) --* Use this setting to select a single captions
                  track from a source. Track numbers correspond to the order in the captions source
                  file. For IMF sources, track numbering is based on the order that the captions
                  appear in the CPL. For example, use 1 to select the captions asset that is listed
                  first in the CPL. To include more than one captions track in your job outputs,
                  create multiple input captions selectors. Specify one track per selector.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame. If you specify a value here, it will
        override any value that you specify in the output setting Cropping selection (crop).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
        motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
        uncompressed video inputs.

        - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
        encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when you
        use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt your
        content.

          - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt
          your input files.

          - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
          plaintext. Your job settings could be intercepted, making your encrypted content
          vulnerable. Specify the encrypted version of the data key that you used to encrypt your
          content. The data key must be encrypted by AWS Key Management Service (KMS). The key can
          be 128, 192, or 256 bits.

          - **InitializationVector** *(string) --* Specify the initialization vector that you used
          when you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
          initialization vector with any encryption mode. Or, you can use a 12-byte initialization
          vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
          base64-encoded.

          - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
          (KMS) that you used to encrypt your data key, if that Region is different from the one you
          are using for AWS Elemental MediaConvert.

        - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
        the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
        video inputs.

        - **FileInput** *(string) --* Specify the source file for your transcoding job. You can use
        multiple inputs in a single job. The service concatenates these inputs, in the order that
        you specify them in the job, to create the outputs. If your input format is IMF, specify
        your input by providing the path to your CPL. For example, "s3://bucket/vf/cpl.xml". If the
        CPL is in an incomplete IMP, make sure to use *Supplemental IMPs* (SupplementalImps) to
        specify any supplemental IMPs that contain assets referenced by the CPL.

        - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
        transcoding service applies the denoise and deblock filters. You must also enable the
        filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
        Auto - The transcoding service determines whether to apply filtering, depending on input
        type and quality. * Disable - The input is not filtered. This is true even if you use the
        API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put is
        filtered regardless of input type.

        - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
        magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default is
        0.

        - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
        overlay on your video. Enable or disable this feature for each input individually. This
        setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times that
        together specify a portion of the input to be used in the outputs. If you provide only a
        start time, the clip will be the entire input from that point to the end. If you provide
        only an end time, it will be the entire input up to that point. When you specify more than
        one input clip, the transcoding service creates the job outputs by stringing the clips
        together in the order you specify them.

          - *(dict) --* To transcode only portions of your input (clips), include one Input clipping
          (one instance of InputClipping in the JSON job file) for each input clip. All input clips
          you specify will be included in every output of the job.

            - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the portion
            of the input you are clipping. The frame corresponding to the End timecode value is
            included in the clip. Start timecode or End timecode may be left blank, but not both.
            Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute, SS is
            the second, and FF is the frame number. When choosing this value, take into account your
            setting for timecode source under input settings (InputTimecodeSource). For example, if
            you have embedded timecodes that start at 01:00:00:00 and you want your clip to end six
            minutes into the video, use 01:06:00:00.

            - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning of
            the portion of the input you are clipping. The frame corresponding to the Start timecode
            value is included in the clip. Start timecode or End timecode may be left blank, but not
            both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the minute,
            SS is the second, and FF is the frame number. When choosing this value, take into
            account your setting for Input timecode source. For example, if you have embedded
            timecodes that start at 01:00:00:00 and you want your clip to begin five minutes into
            the video, use 01:05:00:00.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black. If you
        specify a value here, it will override any value that you specify in the output setting
        Selection placement (position). If you specify a value here, this will override any AFD
        values in your input, even if you set Respond to AFD (RespondToAfd) to Respond (RESPOND). If
        you specify a value here, this will ignore anything that you specify for the setting Scaling
        Behavior (scalingBehavior).

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific program
        from within a multi-program transport stream. Note that Quad 4K is not currently supported.
        Default is the first program within the transport stream. If the program you specify doesn't
        exist, the transcoding service will use this default.

        - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream inputs
        to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for audio and
        video. * Use PSI - Scan only PSI data.

        - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You
        need supplemental IMPs if the CPL that you're using for your input is in an incomplete IMP.
        Specify either the supplemental IMP directories with a trailing slash or the ASSETMAP.xml
        files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to
        specify the IMP that contains your input CPL, because the service automatically detects it.

          - *(string) --*

        - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the input
        settings (InputTimecodeSource), to specify how the service counts input video frames. This
        input frame count affects only the behavior of features that apply to a single input at a
        time, such as input clipping and synchronizing some captions formats. Choose Embedded
        (EMBEDDED) to use the timecodes in your input video. Choose Start at zero (ZEROBASED) to
        start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to start the first
        frame at the timecode that you specify in the setting Start timecode (timecodeStart). If you
        don't specify a value for Timecode source, the service will use Embedded by default. For
        more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use for
        this input's initial frame. To use this setting, you must set the Timecode source setting,
        located under the input settings (InputTimecodeSource), to Specified start (SPECIFIEDSTART).
        For more information about timecodes, see
        https://docs.aws.amazon.com/console/mediaconvert/timecode.

        - **VideoSelector** *(dict) --* Selector for video.

          - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
          animation. Specify which part of this input MediaConvert uses for your outputs. Leave this
          setting set to DISCARD in order to delete the alpha channel and preserve the video. Use
          REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the luma
          channel of your outputs.

          - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
          if you don't know about color space, leave this set to the default value Follow (FOLLOW).
          The service will automatically detect your input color space. If your input video has
          metadata indicating the wrong color space, specify the accurate color space here. If your
          input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume static metadata
          isn't present in your video stream, or if that metadata is present but not accurate,
          choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the input HDR 10
          metadata (Hdr10Metadata) settings. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
          file and the job input settings Color space (ColorSpace) and HDR master display
          information settings(Hdr10Metadata). The Color space usage setting determines which takes
          precedence. Choose Force (FORCE) to use color metadata from the input job settings. If you
          don't specify values for those settings, the service defaults to using metadata from your
          input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata from the source when it
          is present. If there's no color metadata in your input file, the service defaults to using
          values you specify in the input settings.

          - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
          missing or inaccurate in your input video. Appropriate values vary depending on the input
          video and must be provided by a color grader. The color grader generates these values
          during the HDR 10 mastering process. The valid range for each of these settings is 0 to
          50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related settings -
          When you specify these values, you must also set Color space (ColorSpace) to HDR 10
          (HDR10). To specify whether the the values you specify here take precedence over the
          values in the metadata of your input file, set Color space usage (ColorSpaceUsage). To
          specify whether color metadata is included in an output, set Color metadata
          (ColorMetadata). For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
          Specify this value as an integer; the system automatically converts it to the hexidecimal
          value. For example, 257 selects PID 0x101. A PID, or packet identifier, is an identifier
          for a set of data in an MPEG-2 transport stream container.

          - **ProgramNumber** *(integer) --* Selects a specific program from within a multi-program
          transport stream. Note that Quad 4K is not currently supported.

          - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
          your video. You can choose automatic rotation or specify a rotation. You can specify a
          clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov or
          .mp4 and your input has rotation metadata, you can choose Automatic to have the service
          rotate your video according to the rotation specified in the metadata. The rotation must
          be within one degree of 90, 180, or 270 degrees. If the rotation metadata specifies any
          other rotation, the service will default to no rotation. By default, the service does no
          rotation, even if your input video has rotation metadata. The service doesn't pass through
          rotation metadata.

    - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
    graphics that you specify here appear on all outputs in all output groups.

      - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
      unspecified. If your motion graphic asset is a series of .png files, specify the frame rate of
      the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1. Make
      sure that the number of images in your series matches the frame rate and your intended overlay
      duration. For example, if you want a 30-second overlay at 30 fps, you should have 900 .png
      images. This overlay frame rate doesn't need to match the frame rate of the underlying video.

        - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
        overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

        - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your overlay
        frame rate. For example, if your frame rate is 24 fps, set this value to 24.

      - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
      overlay on your video. For .png files, provide the file name of the first file in the series.
      Make sure that the names of the .png files end with sequential numbers that specify the order
      that they are played in. For example, overlay_000.png, overlay_001.png, overlay_002.png, and
      so on. The sequence must start at zero, and each image file name must have the same number of
      digits. Pad your initial file names with enough zeros to complete the sequence. For example,
      if the first image is overlay_0.png, there can be only 10 images in the sequence, with the
      last image being overlay_9.png. But if the first image is overlay_00.png, there can be 100
      images in the sequence.

      - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
      providing for your overlay. You can choose either a .mov file or a series of .png files.

      - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay on
      the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
      specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
      the service inserts the overlay at its native resolution and scales the size up or down with
      any video scaling.

        - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
        edge of the video frame.

        - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
        edge of the video frame.

      - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop or
      plays only once.

      - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
      (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into account
      how you have set up your timecode configuration under both job settings and input settings.
      The simplest way to do that is to set both to start at 0. If you need to set up your job to
      follow timecodes embedded in your source that don't start at zero, make sure that you specify
      a start time that is after the first embedded timecode. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find job-wide and
      input timecode configuration settings in your JSON job settings specification at
      settings>timecodeConfig>source and settings>inputs>timecodeSource.

    - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't do
    Nielsen measurement and analytics, ignore these settings. When you enable Nielsen configuration
    (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs in the job. To
    enable Nielsen configuration programmatically, include an instance of nielsenConfiguration in
    your JSON job specification. Even if you don't include any children of nielsenConfiguration, you
    still enable the setting.

      - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
      functionality. If you must include this property, set the value to zero.

      - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
      distributor ID that is assigned to your organization by Neilsen.

    - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
    outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
    MXF, and no container) are grouped in a single output group as well. Required in (OutputGroups)
    is a group of settings that apply to the whole group. This required object depends on the value
    you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type, settings object pairs are
    as follows. * FILE_GROUP_SETTINGS, FileGroupSettings * HLS_GROUP_SETTINGS, HlsGroupSettings *
    DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings * MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings
    * CMAF_GROUP_SETTINGS, CmafGroupSettings

      - *(dict) --* Group of outputs

        - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for the
        output group. This value is displayed on the console and can make your job settings JSON
        more human-readable. It does not affect your outputs. Use up to twelve characters that are
        either letters, numbers, spaces, or underscores.

        - **Name** *(string) --* Name of the output group

        - **OutputGroupSettings** *(dict) --* Output Group settings, including type

          - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF Output
          Group may only contain a single video, audio, or caption output.

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
            your job. These default manifests reference every output in the output group. To create
            additional top-level manifests that reference a subset of the outputs in the output
            group, specify a list of them here. For each additional manifest that you specify, the
            service creates one HLS manifest and one DASH manifest.

              - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
              that you want the service to generate for this CMAF output group. Each pair of
              manifests can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
            at the top level BaseURL element. Can be used if streams are delivered from a different
            URL than the manifest file.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
              service to use when encrypting your CMAF segments. Choose AES-CBC subsample
              (SAMPLE-AES) or AES_CTR (AES-CTR).

              - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF outputs,
              choose whether the service writes the 128-bit encryption initialization vector in the
              HLS and DASH manifests.

              - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
              settings when doing DRM encryption with a SPEKE-compliant key provider. If your output
              group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                package. The DASH manifest can currently signal up to three system IDs. For more
                information, see https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                signaled in the HLS manifest that MediaConvert creates as part of this CMAF package.
                The HLS manifest can currently signal only one system ID. For more information, see
                https://dashif.org/identifiers/content_protection/.

                  - *(string) --*

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
            of each individual CMAF segment. This value applies to the whole package; that is, to
            every output in the output group. Note that segments end on the first keyframe after
            this number of seconds, so the actual segment length might be slightly longer. If you
            set Segment control (CmafSegmentControl) to single file, the service puts the content of
            each output in a single file that has metadata that marks these segments. If you set it
            to segmented files, the service creates multiple files for each output, each with the
            content of one segment.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
            generated for this output.

            - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will be
            generated for this output.

          - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
            manifest for each DASH ISO output group in your job. This default manifest references
            every output in the output group. To create additional DASH manifests that reference a
            subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional DASH manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.mpd.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest (.mpd)
            file at the top level BaseURL element. Can be used if streams are delivered from a
            different URL than the manifest file.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* DRM settings.

              - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
              compatibility of your output with video players on obsolete devices. It applies only
              to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
              only to correct problems with playback on older devices. Otherwise, keep the default
              setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the service
              will exclude the access unit delimiter and will leave the SEI NAL units unencrypted.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
            Fragment length must be compatible with GOP size and Framerate. Note that fragments will
            end on the next keyframe after this number of seconds, so actual fragment length may be
            longer. When Emit Single File is checked, the fragmentation is internal to a single
            output file and it does not cause the creation of many output files as in other output
            types.

            - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

            - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
            needed to ensure smooth playout.

            - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
            When you choose Main profile (MAIN_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
            On-demand (ON_DEMAND_PROFILE), the service signals
            urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand, you
            must also set the output group setting Segment control (SegmentControl) to Single file
            (SINGLE_FILE).

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
            generated, which is internally segmented using the Fragment Length and Segment Length.
            When set to SEGMENTED_FILES, separate segment files will be created.

            - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
            that segments will end on the next keyframe after this number of seconds, so actual
            segment length may be longer. When Emit Single File is checked, the segmentation is
            internal to a single output file and it does not cause the creation of many output files
            as in other output types.

            - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in the
            400 range when you play back your DASH output, enable this setting and run your
            transcoding job again. When you enable this setting, the service writes precise segment
            durations in the DASH manifest. The segment duration information appears inside the
            SegmentTimeline element, inside SegmentTemplate at the Representation level. When you
            don't enable this setting, the service writes approximate segment durations in your DASH
            manifest.

          - **FileGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

          - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

            - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
            HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
            outputs themselves.

              - *(string) --*

            - **AdditionalManifests** *(list) --* By default, the service creates one top-level
            .m3u8 HLS manifest for each HLS output group in your job. This default manifest
            references every output in the output group. To create additional top-level manifests
            that reference a subset of the outputs in the output group, specify a list of them here.

              - *(dict) --* Specify the details for each additional HLS manifest that you want the
              service to generate for this output group. Each manifest can reference a different
              subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                setting, then the file name the service generates for this top-level manifest is
                film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                that is different from the nameModifier of the output. The service uses the output
                name modifier to create unique names for the individual variant manifests.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
            in the media .m3u8 file. Can be used if base manifest is delivered from a different URL
            than the main .m3u8 file.

            - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

              - *(dict) --* Caption Language Mapping

                - **CaptionChannel** *(integer) --* Caption channel.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions
                channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                three-letter code listed at
                https://www.loc.gov/standards/iso639-2/php/code_list.php.

                - **LanguageDescription** *(string) --* Caption language description.

            - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output captions.
            Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one language in
            the CC1 Language Code field. One CLOSED-CAPTION line is added for each Language Code you
            specify. Make sure to specify the languages in the order in which they appear in the
            original source (if the source is embedded format) or the order of the caption selectors
            (if the source is other than embedded). Otherwise, languages in the manifest will not
            match up properly with the output captions. None: Include CLOSED-CAPTIONS=
                NONE line in
            the manifest. Omit: Omit any CLOSED-CAPTIONS line from the manifest.

            - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
            which prevents client from saving media segments for later replay.

            - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
            RFC-4281) during m3u8 playlist generation.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
            subdirectories.

            - **Encryption** *(dict) --* DRM settings.

              - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex value
              represented by a 32-character text string. If this parameter is not set then the
              Initialization Vector will follow the segment number by default.

              - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
              scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
              disables encryption.

              - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
              128-bit number used in conjunction with the key for encrypting blocks. If set to
              INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
              Vector is not in the manifest.

              - **OfflineEncrypted** *(string) --* Enable this setting to insert the
              EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple HLS
              FairPlay content protection.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

              - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
              static key provider.

                - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                indicate an implicit value of 'identity'.

                - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a single
                positive integer version value or a slash delimited list of version values (1/2/3).

                - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a 32-character
                hexidecimal string to specify Key Value (StaticKeyValue).

                - **Url** *(string) --* Relates to DRM implementation. The location of the license
                server used for protecting content.

              - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
              key provider that follows the SPEKE standard. For more information about SPEKE, see
              https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

            - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

            - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest should
            use floating point values for segment duration.

            - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
            unless you are troubleshooting a problem with how devices play back the end of your
            video asset. If you know that player devices are hanging on the final segment of your
            video because the length of your final segment is too short, use this setting to specify
            a minimum final segment length, in seconds. Choose a value that is greater than or equal
            to 1 and less than your segment length. When you specify a value for this setting, the
            encoder will combine any final segment that is shorter than the length that you specify
            with the previous segment. For example, your segment length is 3 seconds and your final
            segment is .5 seconds without a minimum final segment length; when you set the minimum
            final segment length to 1, your final segment is 3.5 seconds.

            - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
            looking ahead and back within the specified range for a nearby avail and extending the
            segment size if needed.

            - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should be
            generated for this HLS output group.

            - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag in
            .m3u8 manifest files. The value is calculated as follows: either the program date and
            time are initialized using the input timecode source, or the time is initialized using
            the input timecode source and the date is initialized using the timestamp_offset.

            - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
            EXT-X-PROGRAM-DATE-TIME entry, in seconds.

            - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
            media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

            - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to create
            (in seconds). Note that segments will end on the next keyframe after this number of
            seconds, so actual segment length may be longer.

            - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
            subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY for
            this setting to have an effect.

            - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
            video in EXT-X-STREAM-INF tag of variant manifest.

            - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

            - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

            - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
            offset to fine tune the timestamps.

          - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
          (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

            - **AdditionalManifests** *(list) --* By default, the service creates one .ism Microsoft
            Smooth Streaming manifest for each Microsoft Smooth Streaming output group in your job.
            This default manifest references every output in the output group. To create additional
            manifests that reference a subset of the outputs in the output group, specify a list of
            them here.

              - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
              manifest that you want the service to generate for this output group. Each manifest
              can reference a different subset of outputs in the group.

                - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                adds to the name of this manifest to make it different from the file names of the
                other main manifests in the output group. For example, say that the default main
                manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                "-no-premium" for this setting, then the file name the service generates for this
                top-level manifest is film-name-no-premium.ismv.

                - **SelectedOutputs** *(list) --* Specify the outputs that you want this additional
                top-level manifest to reference.

                  - *(string) --*

            - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
            audio encoding settings across a Microsoft Smooth output group into a single audio
            stream.

            - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
            location and the output filename base. Destination accepts format identifiers. If you do
            not specify the base filename in the URI, the service will use the filename of the input
            file. If your job has multiple inputs, the service uses the filename of the first input
            file.

            - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
            vary based on the type of destination

              - **S3Settings** *(dict) --* Settings associated with S3 destination

                - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                Amazon S3 access control for the outputs in this output group. When you don't use
                this setting, S3 automatically applies the default access control list PRIVATE.

                  - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                  apply to this output.

                - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as they
                are uploaded to Amazon S3.

                  - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                  AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                  themselves, using a customer master key (CMK), and then stores the encrypted data
                  keys alongside your encrypted content. Use this setting to specify which AWS
                  service manages the CMK. For simplest set up, choose Amazon S3
                  (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS Key
                  Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By default,
                  when you choose AWS KMS, KMS uses the AWS managed customer master key (CMK)
                  associated with Amazon S3 to encrypt your data keys. You can optionally choose to
                  specify a different, customer managed CMK. Do so by specifying the Amazon Resource
                  Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                  - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                  that you want to use to encrypt the data key that AWS uses to encrypt your output
                  content. Enter the Amazon Resource Name (ARN) of the CMK. To use this setting, you
                  must also set Server-side encryption (S3ServerSideEncryptionType) to AWS KMS
                  (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to AWS KMS but
                  don't specify a CMK here, AWS uses the AWS managed CMK associated with Amazon S3.

            - **Encryption** *(dict) --* If you are using DRM, set DRM System
            (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

              - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
              Microsoft Smooth, use these settings when doing DRM encryption with a SPEKE-compliant
              key provider. If your output group type is CMAF, use the SpekeKeyProviderCmaf settings
              instead.

                - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                content keys that it provides to MediaConvert, set up a certificate with a master
                key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                (ARN) here.

                - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant key
                provider uses to identify this content.

                - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system identifiers.
                DASH output groups support a max of two system ids. Other group types support one
                system id. See https://dashif.org/identifiers/content_protection/ for more details.

                  - *(string) --*

                - **Url** *(string) --* Specify the URL to the key server that your SPEKE-compliant
                DRM key provider uses to provide keys for encrypting your content.

            - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify the
            mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size and
            frame rate.

            - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding) to
            specify the encoding format for the server and client manifest. Valid options are utf8
            and utf16.

          - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO, Microsoft
          Smooth Streaming, CMAF)

        - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
        settings per output.

          - *(dict) --* An output object describes the settings for a single output file or stream
          in an output group.

            - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
            encoding settings organized by audio codec. Include one instance of (AudioDescriptions)
            per output. (AudioDescriptions) can contain multiple groups of encoding settings.

              - *(dict) --* Description of audio output

                - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
                Ignore these settings unless you need to comply with a loudness standard.

                  - **Algorithm** *(string) --* Choose one of the following audio normalization
                  algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                  loudness for an entire piece of content, suitable for measurement of short-form
                  content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                  BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                  the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                  Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                  true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
                  audio channels than the other algorithms, including configurations such as 7.1.

                  - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                  using the chosen algorithm. If disabled, the audio will be measured but not
                  adjusted.

                  - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                  be corrected to the target level. Content measuring below this level will not be
                  corrected. Gating only applies when not using real_time_correction.

                  - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                  loudness to a CSV file.

                  - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                  TruePeak for each output's audio track loudness.

                  - **TargetLkfs** *(float) --* When you use Audio normalization
                  (AudioNormalizationSettings), optionally use this setting to specify a target
                  loudness. If you don't specify a value here, the encoder chooses a value for you,
                  based on the algorithm that you choose for Algorithm (algorithm). If you choose
                  algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                  choose -23 LKFS.

                - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                name based on its order within each input. For example if you specify "Audio
                Selector 3", then the third audio selector will be used from each input. If an input
                does not have an "Audio Selector 3", then the audio selector marked as "default" in
                that input will be used. If there is no audio selector marked as "default", silence
                will be inserted for the duration of that input. Alternatively, an "Audio Selector
                Group":#inputs-audio_selector_group name may be specified, with similar
                default/silence behavior. If no audio_source_name is specified, then "Audio Selector
                1" will be chosen automatically.

                - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
                (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0
                = Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                     Visually Impaired
                Commentary, 4-255 = Reserved.

                - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
                an ISO 639 audio_type, then that value is passed through to the output. If the input
                contains no ISO 639 audio_type, the value in Audio Type is included in the output.
                Otherwise the value in Audio Type is included in the output. Note that this field
                and audioType are both ignored if audioDescriptionBroadcasterMix is set to
                BROADCASTER_MIXED_AD.

                - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                (AudioDescriptions) contains the group of settings related to audio encoding. The
                settings in this group vary depending on the value that you choose for Audio codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * AAC,
                AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                  - **AacSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                  two mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                  modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR".
                  In VBR mode, you control the audio quality with the setting VBR quality
                  (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                  valid values depend on the rate control mode.

                    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                    when the input contains pre-mixed main audio + audio description (AD) as a
                    stereo pair. The value for AudioType will be set to 3, which signals to
                    downstream systems that this stream contains "broadcaster mixed AD". Note that
                    the input received by the encoder must contain pre-mixed audio; the encoder does
                    not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                    ignores any values you provide in AudioType and FollowInputAudioType. Choose
                    NORMAL when the input does not contain pre-mixed audio + audio description (AD).
                    In this case, the encoder will use any values you provide for AudioType and
                    FollowInputAudioType.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                    set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                    20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                    128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                    576000, 640000, 768000, 896000, 1024000. The value you set is also constrained
                    by the values that you choose for Profile (codecProfile), Bitrate control mode
                    (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                    control mode and Profile.

                    - **CodecProfile** *(string) --* AAC Profile.

                    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                    channel layout. Valid values depend on rate control mode and profile. "1.0 -
                    Audio Description (Receiver Mix)" setting receives a stereo description plus
                    control track and emits a mono AAC encode of the description track, with control
                    data emitted in the PES header as per ETSI TS 101 154 Annex E.

                    - **RateControlMode** *(string) --* Rate Control Mode.

                    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                    LATM/LOAS AAC in an output, you must choose "No container" for the output
                    container.

                    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                    control mode and profile.

                    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                    raw or MPEG-2 Transport Stream containers.

                    - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                    rate_control_mode is VBR.

                  - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AC3.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                    that the encoder emits. For more information about the AC3 bitstream mode, see
                    ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital, dialnorm will be passed through.

                    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                    dynamic range compression signaling to the output bitstream as defined in the
                    Dolby Digital specification.

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                  - **AiffSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value AIFF.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **Codec** *(string) --* Type of Audio codec.

                  - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid values: 384k, 448k, 640k, 768k

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                    (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                    adjust loudness based on dialogue analysis.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                    1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
                    value for downmixing. How the service uses this value depends on the value that
                    you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                    uses this value for downmixing. How the service uses this value depends on the
                    value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                    3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix
                    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                    value -60 mutes the channel.

                    - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                    your audio.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                    that must be speech before the encoder uses the measured speech loudness as the
                    overall program loudness.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                    - **SurroundExMode** *(string) --* Specify whether your input audio has an
                    additional center rear surround channel matrix encoded into your left and right
                    surround channels.

                  - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value EAC3.

                    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                    attenuation to the surround channels. Only used for 3/2 coding mode.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Valid bitrates depend on the coding mode.

                    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                    stream that the encoder emits. For more information about the EAC3 bitstream
                    mode, see ATSC A/52-2012 (Annex E).

                    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                    of channels.

                    - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                    channels.

                    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                    input audio is Dolby Digital Plus, dialnorm will be passed through.

                    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                    for a signal with dynamic range compression.

                    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                    audio dynamic range when compressing the audio.

                    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                    channel is enabled

                    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                    prior to encoding. Only valid with 3_2_LFE coding mode.

                    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left only/Right only center (loRoCenterMixLevel).

                    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                    this value for downmixing. How the service uses this value depends on the value
                    that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5,
                    -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
                    only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2)
                    for the setting Coding mode (Eac3CodingMode). If you choose a different value
                    for Coding mode, the service ignores Left only/Right only surround
                    (loRoSurroundMixLevel).

                    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                    mutes the channel. This setting applies only if you keep the default value of
                    3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                    (Eac3CodingMode). If you choose a different value for Coding mode, the service
                    ignores Left total/Right total center (ltRtCenterMixLevel).

                    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                    Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                    MediaConvert uses this value for downmixing. How the service uses this value
                    depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                    Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.
                    This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Left total/Right total
                    surround (ltRtSurroundMixLevel).

                    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                    will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                    data. If audio was not supplied from one of these streams, then the static
                    metadata settings will be used.

                    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                    audio will be passed through if it is present on the input. this detection is
                    dynamic over the life of the transcode. Inputs that alternate between DD+ and
                    non-DD+ content will have a consistent DD+ output as the system alternates
                    between passthrough and encoding.

                    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                    the surround channels. Only used for 3/2 coding mode.

                    - **SampleRate** *(integer) --* This value is always 48000. It represents the
                    sample rate in Hz.

                    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                    This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                    different value for Coding mode, the service ignores Stereo downmix
                    (Eac3StereoDownmix).

                    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                    extra center back surround channel is matrix encoded into the left and right
                    surround channels.

                    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                    Surround is matrix encoded into the two channels.

                  - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value MP2.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                    - **Channels** *(integer) --* Set Channels to specify the number of channels in
                    this output audio track. Choosing Mono in the console will give you 1 output
                    channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                    - **SampleRate** *(integer) --* Sample rate in hz.

                  - **WavSettings** *(dict) --* Required when you set (Codec) under
                  (AudioDescriptions)>(CodecSettings) to the value WAV.

                    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample,
                    to choose the encoding quality for this audio track.

                    - **Channels** *(integer) --* Specify the number of channels in this output
                    audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4,
                    6, and so on, up to 64.

                    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                    If your output audio is likely to exceed 4 GB in file size, or if you otherwise
                    need the extended support of the RF64 format, set your output WAV file format to
                    RF64.

                    - **SampleRate** *(integer) --* Sample rate in Hz.

                - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                track. The service puts this language code into your output audio track when you set
                Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
                The service also uses your specified custom language code when you set Language code
                control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input
                file doesn't specify a language code. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                The ISO 639 language specified in the 'Language Code' drop down will be used when
                'Follow Input Language Code' is not selected or when 'Follow Input Language Code' is
                selected but there is no ISO 639 language code specified by the input.

                - **LanguageCodeControl** *(string) --* Specify which source for language code takes
                precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
                service uses the language code from the input track if it's present. If there's no
                languge code on the input track, the service uses the code that you specify in the
                setting Language code (languageCode or customLanguageCode). When you choose Use
                configured (USE_CONFIGURED), the service uses the language code that you specify.

                - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **StreamName** *(string) --* Specify a label for this output audio stream. For
                example, "English", "Director commentary", or "track_2". For streaming outputs,
                MediaConvert passes this information into destination manifests for display on the
                end-viewer's player device. For outputs in other output groups, the service ignores
                this setting.

            - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of captions
            settings. For each output that has captions, include one instance of
            (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
            settings.

              - *(dict) --* Description of Caption output

                - **CaptionSelectorName** *(string) --* Specifies which "Caption
                Selector":#inputs-caption_selector to use from each input when generating captions.
                The name should be of the format "Caption Selector ", which denotes that the Nth
                Caption Selector will be used from each input.

                - **CustomLanguageCode** *(string) --* Specify the language for this captions output
                track. For most captions output formats, the encoder puts this language information
                in the output captions metadata. If your output captions format is DVB-Sub or Burn
                in, the encoder uses this language information when automatically selecting the font
                script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
                ISO 639-3 code. For streaming outputs, you can also use any other code in the full
                RFC-5646 specification. Streaming outputs are those that are in one of the following
                output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                - **DestinationSettings** *(dict) --* Specific settings required by destination
                type. Note that burnin_destination_settings are not available if the source of the
                caption data is Embedded or Teletext.

                  - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    burn-in captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **DestinationType** *(string) --* Specify the format for this set of captions on
                  this output. The default format is embedded without SCTE-20. Other options are
                  embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                  web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                  (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                  create a non-compliant output where the embedded captions come first, choose
                  Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                  - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                    - **Alignment** *(string) --* If no explicit x_position or y_position is
                    provided, setting alignment to centered will place the captions at the bottom
                    center of the output. Similarly, setting a left alignment will align captions to
                    the bottom left of the output. If x and y positions are given in conjunction
                    with the alignment parameter, the font will be justified (either left or
                    centered) relative to those coordinates. This option is not valid for source
                    captions that are STL, 608/embedded or teletext. These source settings are
                    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                    must match.

                    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                    the captions. All burn-in and DVB-Sub font settings must match.

                    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                    rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                    equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                    settings must match.

                    - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                    This option is not valid for source captions that are STL, 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                    captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings
                    must match.

                    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                    default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                    - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                    script code, if the LanguageCode is not sufficient for determining the script
                    type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or
                    leave unset. This is used to help determine the appropriate font for rendering
                    DVB-Sub captions.

                    - **FontSize** *(integer) --* A positive integer indicates the exact font size
                    in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                    font settings must match.

                    - **OutlineColor** *(string) --* Specifies font outline color. This option is
                    not valid for source captions that are either 608/embedded or teletext. These
                    source settings are already pre-defined by the caption stream. All burn-in and
                    DVB-Sub font settings must match.

                    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                    option is not valid for source captions that are either 608/embedded or
                    teletext. These source settings are already pre-defined by the caption stream.
                    All burn-in and DVB-Sub font settings must match.

                    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                    captions. All burn-in and DVB-Sub font settings must match.

                    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting
                    it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                    relative to the captions in pixels. A value of -2 would result in a shadow
                    offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                    match.

                    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                    standard or for hearing impaired. Choose hearing impaired if your subtitles
                    include audio descriptions and dialogue. Choose standard if your subtitles
                    include only dialogue.

                    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                    Teletext or STL formats. Specify whether the spacing between letters in your
                    captions is set by the captions grid or varies depending on letter width. Choose
                    fixed grid to conform to the spacing specified in the captions file more
                    accurately. Choose proportional to make the text easier to read if the captions
                    are closed caption.

                    - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                    relative to the left side of the output in pixels. A value of 10 would result in
                    the captions starting 10 pixels from the left of the output. If no explicit
                    x_position is provided, the horizontal caption position will be determined by
                    the alignment parameter. This option is not valid for source captions that are
                    STL, 608/embedded or teletext. These source settings are already pre-defined by
                    the caption stream. All burn-in and DVB-Sub font settings must match.

                    - **YPosition** *(integer) --* Specifies the vertical position of the caption
                    relative to the top of the output in pixels. A value of 10 would result in the
                    captions starting 10 pixels from the top of the output. If no explicit
                    y_position is provided, the caption will be positioned towards the bottom of the
                    output. This option is not valid for source captions that are STL, 608/embedded
                    or teletext. These source settings are already pre-defined by the caption
                    stream. All burn-in and DVB-Sub font settings must match.

                  - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                  embedded/ancillary caption outputs, including 608/708 Channel destination number.

                    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and your output captions are embedded in the video
                    stream. Specify a CC number for each captions channel in this output. If you
                    have two channels, choose CC numbers that aren't in the same field. For example,
                    choose 1 and 3. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                    input captions are SCC format and you want both 608 and 708 captions embedded in
                    your output stream. Optionally, specify the 708 service number for each output
                    captions channel. Choose a different number for each channel. To use this
                    setting, also set Force 608 to 708 upconvert (Convert608To708) to Upconvert
                    (UPCONVERT) in your input captions selector settings. If you choose to upconvert
                    but don't specify a 708 service number, MediaConvert uses the number that you
                    specify for CC channel number (destination608ChannelNumber) for the 708 service
                    number. For more information, see
                    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                  outputs.

                    - **StylePassthrough** *(string) --* Keep this setting enabled to have
                    MediaConvert use the font style and position information from the captions
                    source in the output. This option is available only when your input captions are
                    CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output
                    captions.

                  - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                    sure that the captions and the video are synchronized in the output. Specify a
                    frame rate that matches the frame rate of the associated video. If the video
                    frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if
                    the video has video_insertion=true and drop_frame_timecode=
                        true; otherwise,
                    choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                  - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                    the destination captions for this output. This value must be a three-digit
                    hexadecimal string; strings ending in -FF are invalid. If you are passing
                    through the entire set of Teletext data, do not use this field.

                    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                    you don't specify a value here, the service sets the page type to the default
                    value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                    Teletext data, don't use this field. When you pass through a set of Teletext
                    pages, your output has the same page types as your input.

                      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table
                      94

                  - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                  outputs, including Pass style information (TtmlStylePassthrough).

                    - **StylePassthrough** *(string) --* Pass through style and position information
                    from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                    TTML output.

                - **LanguageCode** *(string) --* Specify the language of this captions output track.
                For most captions output formats, the encoder puts this language information in the
                output captions metadata. If your output captions format is DVB-Sub or Burn in, the
                encoder uses this language information to choose the font language for rendering the
                captions text.

                - **LanguageDescription** *(string) --* Specify a label for this set of output
                captions. For example, "English", "Director commentary", or "track_2". For streaming
                outputs, MediaConvert passes this information into destination manifests for display
                on the end-viewer's player device. For outputs in other output groups, the service
                ignores this setting.

            - **ContainerSettings** *(dict) --* Container specific settings.

              - **Container** *(string) --* Container for this output. Some containers require a
              container settings object. If not specified, the default object will be created.

              - **F4vSettings** *(dict) --* Settings for F4v container

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

              - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in
              a File output group when the output's container (ContainerType) is MPEG-2 Transport
              Stream (M2TS). In these assets, data is organized by the program map table (PMT). Each
              transport stream program contains subsets of data, including audio, video, and
              metadata. Each of these subsets of data has a numerical label called a packet
              identifier (PID). Each transport stream program corresponds to one MediaConvert
              output. The PMT lists the types of data in a program along with their PID. Downstream
              systems and players use the program map table to look up the PID for each type of data
              it accesses and then uses the PIDs to locate specific data within the asset.

                - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
                for Dolby Digital audio.

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
                audio streams you include in this output. Specify multiple PIDs as a JSON array.
                Default is the range 482-492.

                  - *(integer) --*

                - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                bits per second. Setting to 0 lets the muxer automatically determine the appropriate
                bitrate. Other common values are 3750000, 7500000, and 15000000.

                - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
                can lead to lower latency, but low-memory devices may not be able to play back the
                stream without interruptions.

                - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
                specified table repetition interval.

                  - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                  Table (NIT).

                  - **NetworkName** *(string) --* The network name text placed in the
                  network_name_descriptor inside the Network Information Table. Maximum length is
                  256 characters.

                  - **NitInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
                specified table repetition interval.

                  - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                  output stream. "Follow input SDT" copies SDT information from input stream to
                  output stream. "Follow input SDT if present" copies SDT information from input
                  stream to output stream if SDT information is present in the input, otherwise it
                  will fall back on the user-defined values. Enter "SDT Manually" means user will
                  enter the SDT information. "No SDT" means output stream will not contain SDT
                  information.

                  - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **ServiceName** *(string) --* The service name placed in the service_descriptor
                  in the Service Description Table. Maximum length is 256 characters.

                  - **ServiceProviderName** *(string) --* The service provider name placed in the
                  service_descriptor in the Service Description Table. Maximum length is 256
                  characters.

                - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
                data included in this output. Specify multiple PIDs as a JSON array. Default is the
                range 460-479.

                  - *(integer) --*

                - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                specified table repetition interval.

                  - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                teletext data you include in this output. Default is 499.

                - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                EBP markers will be added to partitions 3 and 4. The interval between these
                additional markers will be fixed, and will be slightly shorter than the video EBP
                marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                inserted. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                can either be placed only on the video PID, or on both the video PID and all audio
                PIDs. Only applicable when EBP segmentation markers are is selected
                (segmentationMarkers is EBP or EBP_LEGACY).

                - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
                PES header.

                - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
                know that your audio EBP markers are incorrectly appearing before your video EBP
                markers. To correct this problem, set this value to Force (FORCE).

                - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
                with EBP markers.

                - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                between Program Clock References (PCRs) inserted into the transport stream.

                - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points
                do not come within the specified time interval of each other by looking ahead at
                input video. If another EBP is going to come in within the specified time interval,
                the current EBP is not emitted, and the segment is "stretched" to the next marker.
                The lookahead value does not add latency to the system. The Live Event must be
                configured elsewhere to create sufficient latency to make the lookahead accurate.

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets
                to insert into the transport stream. This can be used if a downstream encryption
                system requires periodic null packets.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This is effective only when the PCR PID is the same as the video or audio elementary
                stream.

                - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                clock reference (PCR) in this output. If you do not specify a value, the service
                will use the value for Video PID (VideoPid).

                - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                instances of the program map table (PMT) in the output transport stream.

                - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
                table (PMT) itself. Default is 480.

                - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                private metadata stream. Default is 503.

                - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
                program number used in the program map table (PMT) for this output. Default is 1.
                Program numbers and program map tables are parts of MPEG-2 transport stream
                containers, used for organizing data.

                - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                maximum bitrate, but the output will not be padded up to that bitrate.

                - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                markers in your HLS and transport stream outputs at the insertion points that you
                specify in an ESAM XML document. Provide the document in the setting SCC XML
                (sccXml).

                  - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                  in the transport stream generated by ESAM.

                - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                stream in the transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE).
                Also provide the ESAM XML as a string in the setting Signal processing notification
                XML (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

                - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                segments. ebp adds Encoder Boundary Point information to the adaptation field as per
                OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point
                information to the adaptation field using a legacy proprietary format.

                - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
                segmentation markers are inserted into the transport stream. With avails, it is
                possible that segments may be truncated, which can influence where future
                segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                selected and a segment is truncated due to an avail, we will reset the segmentation
                cadence. This means the subsequent segment will have a duration of of
                $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                selected and a segment is truncated due to an avail, we will not reset the
                segmentation cadence. This means the subsequent segment will likely be truncated as
                well. However, all segments after that will have a duration of $segmentation_time
                seconds. Note that EBP lookahead is a slight exception to this rule.

                - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
                Required unless markers is set to _none_.

                - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
                metadata in this output. Default is 502.

                - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                itself in the program map table for this output. Transport stream IDs and program
                map tables are parts of MPEG-2 transport stream containers, used for organizing
                data.

                - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
                video stream in the transport stream.

              - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
                PES packet.

                - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                stream(s) in the transport stream. Multiple values are accepted, and can be entered
                in ranges and/or by comma separation.

                  - *(integer) --*

                - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
                will be detected in the input audio and an equivalent ID3 tag will be inserted in
                the output.

                - **PatInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                Reference value is inserted for every Packetized Elementary Stream (PES) header.
                This parameter is effective only when the PCR PID is the same as the video or audio
                elementary stream.

                - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                (PCR) in the transport stream. When no value is given, the encoder will assign the
                same value as the Video PID.

                - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT)
                in the transport stream.

                - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                metadata stream in the transport stream.

                - **ProgramNumber** *(integer) --* The value of the program number field in the
                Program Map Table.

                - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
                transport stream.

                - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
                this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if
                you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
                markers (adMarkers) if you do want manifest conditioning. In both cases, also
                provide the ESAM XML as a string in the setting Signal processing notification XML
                (sccXml).

                - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                specify whether the service inserts the ID3 timed metadata from the input in this
                output.

                - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
                stream in the transport stream.

                - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
                the Program Map Table.

                - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
                in the transport stream.

              - **MovSettings** *(dict) --* Settings for MOV Container.

                - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                the video output settings.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
                into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
                Apple editors and players, but may decrease compatibility with other players. Only
                applicable when the video codec is MPEG2.

                - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                padding

                - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                this setting.

              - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
              AAC outputs with this container.

                - **CslgAtom** *(string) --* When enabled, file composition times will start at
                zero, composition times in the 'ctts' (composition time to sample) box for B-frames
                will be negative, and a 'cslg' (composition shift least greatest) box will be
                included per 14496-1 amendment 1. This improves compatibility with Apple players and
                tools.

                - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
                box.

                - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                relocated to the beginning of the archive as required for progressive downloading.
                Otherwise it is placed normally at the end.

                - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                file. Usually not necessary to specify.

              - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
                that include sidecar TTML or IMSC captions. You specify sidecar captions in a
                separate output from your audio and video. Choose Raw (RAW) for captions in a single
                XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions
                in XML format contained within fragmented MP4 files. This set of fragmented MP4
                files is separate from your video and audio fragmented MP4 files.

                - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                insertion points that you specify in an ESAM XML document. Provide the document in
                the setting SCC XML (sccXml).

                - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
                in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35
                markers that appear in your input to also appear in this output. Choose None (NONE)
                if you don't want those SCTE-35 markers in this output.

            - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
            for outputs in File output groups. If you do not specify a value, the service will use
            default extensions by container type as follows * MPEG-2 transport stream, m2ts *
            Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the service
            will use codec extensions (e.g. AAC, H265, H265, AC3)

            - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
            add a string to the end of each output filename. You specify the base filename as part
            of your destination URI. When you create multiple outputs in the same output group, Name
            modifier (NameModifier) is required. Name modifier also accepts format identifiers. For
            DASH ISO outputs, if you use the format identifiers $Number$ or $Time$ in one output,
            you must use them in the same way in all outputs of the output group.

            - **OutputSettings** *(dict) --* Specific settings for this type of output.

              - **HlsSettings** *(dict) --* Settings for HLS output groups

                - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                belongs.

                - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only outputs.
                Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS container.
                Keep the default value Automatic (AUTOMATIC) to create an audio-only file in a raw
                container. Regardless of the value that you specify here, if this output has video,
                the service will place the output into an MPEG2-TS container.

                - **AudioRenditionSets** *(string) --* List all the audio groups that are used with
                the video output stream. Input all the audio GROUP-IDs that are associated to the
                video, separate by ','.

                - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                Audio-Only Variant Stream The client can play back this audio-only stream instead of
                video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                manifest. Alternate Audio, Auto Select, Default Alternate rendition that the client
                should try to play back by default. Represented as an EXT-X-MEDIA in the HLS
                manifest with DEFAULT=YES, AUTOSELECT=
                    YES Alternate Audio, Auto Select, Not Default
                Alternate rendition that the client may try to play back by default. Represented as
                an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                    YES Alternate Audio,
                not Auto Select Alternate rendition that the client will not try to play back by
                default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                    NO,
                AUTOSELECT=NO

                - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                Manifest in addition to the HLS manifest

                - **SegmentModifier** *(string) --* String concatenated to end of segment filenames.
                Accepts "Format Identifiers":#format_identifier_parameters.

            - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your transcoding
            settings. Provide the system or custom preset name. You can specify either Preset
            (Preset) or Container settings (ContainerSettings), but not both.

            - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
            settings. The specific video settings depend on the video codec that you choose when you
            specify a value for Video codec (codec). Include one instance of (VideoDescription) per
            output.

              - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
              outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service
              includes AFD values in the output video data and what those values are. * Choose None
              to remove all AFD values from this output. * Choose Fixed to ignore input AFD values
              and instead encode the value specified in the job. * Choose Auto to calculate output
              AFD values based on the input AFD scaler data.

              - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
              outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
              specify that in your job, the service will ignore the setting.

              - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
              (VideoDescription), contains the group of settings related to video encoding. The
              settings in this group vary depending on the value that you choose for Video codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * H_264,
              H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
              FRAME_CAPTURE, FrameCaptureSettings

                - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                the enum values defined by the object VideoCodec.

                - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                  - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                  frame of the output stream, then one frame every
                  framerateDenominator/framerateNumerator seconds. For example, settings of
                  framerateNumerator = 1 and framerateDenominator =
                       3 (a rate of 1/3 frame per
                  second) will capture the first frame, then 1 frame every 3s. Files will be named
                  as filename.n.jpg where n is the 0-based sequence number of each Capture.

                  - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame
                  of the output stream, then one frame every framerateDenominator/framerateNumerator
                  seconds. For example, settings of framerateNumerator =
                       1 and framerateDenominator
                  =
                       3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame
                  every 3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                  sequence number zero padded to 7 decimal places.

                  - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                  files).

                  - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

                - **H264Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value H_264.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                  output video settings. If you aren't sure what level to specify, choose Auto
                  (AUTO).

                  - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                  only available with the AVC-I License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                  Main or High profile) or CAVLC.

                  - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                  interlaced outputs.

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job specification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateDenominator to specify the denominator of
                  this fraction. In this example, use 1001 for the value of FramerateDenominator.
                  When you use the console for transcode jobs that use frame rate conversion,
                  provide the value as a decimal number for Framerate. In this example, specify
                  23.976.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type,
                  as follows. - If the source is interlaced, the output will be interlaced with the
                  same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". - If the source
                  is progressive, the output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                  repeated.

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                - **H265Settings** *(dict) --* Settings for H265 codec

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                  Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                  Transfer Function (EOTF).

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* H.265 Level.

                  - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                  (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                  "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                  available with the HEVC 4:2:2 License.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame to reduce flicker or 'pop' on I-frames.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                  structures that have B frames > 1.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                  frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                  Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                  type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                  (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                  throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default
                  Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field
                  polarity as the source. If the source is interlaced, the output will be interlaced
                  with the same polarity as the source (it will follow the source). The output could
                  therefore be a mix of "top field first" and "bottom field first". If the source is
                  progressive, your output will be interlaced with "top field first" or "bottom
                  field first" polarity, depending on which of the Follow options you chose. If you
                  don't choose a value, the service will default to Progressive (PROGRESSIVE).

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000. Required when Rate control mode is QVBR.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                  encoder may use more than requested if using B-frames and/or interlaced encoding.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                  singlepass, or high-quality multipass video encoding.

                  - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                  encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                  Not valid when you set Rate control mode to a value other than QVBR, or when you
                  don't define Rate control mode.

                    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                    mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                    values suited to the complexity of your input video, the service limits the
                    average bitrate of the video part of this output to the value that you choose.
                    That is, the total size of the video element is less than or equal to the value
                    you set multiplied by the number of seconds of encoded output.

                    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                    mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                    target quality level for this output, from 1 to 10. Use higher numbers for
                    greater quality. Level 10 results in nearly lossless compression. The quality
                    level for most broadcast-quality transcodes is between 6 and 9.

                  - **RateControlMode** *(string) --* Use this setting to specify whether this
                  output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                  variable bitrate (QVBR).

                  - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                  (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                  content

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default. If this output uses QVBR, choose Transition detection
                  (TRANSITION_DETECTION) for further video quality improvement. For more information
                  about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                  - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                  equal to the number of macroblock rows for progressive pictures, and less than or
                  equal to half the number of macroblock rows for interlaced pictures.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                  Framerate (framerate) field is set to 29.970. This field works with the Streams >
                  Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                  Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for
                  the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard:
                  produces 29.97i output from 23.976 input. - Soft: produces 23.976; the player
                  converts this output to 29.97i.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                  - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                  bitstream. Up to 3 layers are supported depending on GOP structure: I- and
                  P-frames form one layer, reference B-frames can form a second layer and
                  non-reference b-frames can form a third layer. Decoders can optionally decode only
                  the lower temporal layers to generate a lower frame rate output. For example,
                  given a bitstream with temporal IDs and with b-frames =
                       1 (i.e. IbPbPb display
                  order), a decoder could decode all the frames for full frame rate output or only
                  the I and P frames (lowest temporal layer) for a half frame rate output.

                  - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                  vertical subdivision of the encoded pictures.

                  - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                  bytes of an unregistered SEI message.

                  - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                  units doesn't matter in your workflow, ignore this setting. Use this setting only
                  with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container
                  (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes your output
                  compliant with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC
                  FDIS 14496-15 3rd Edition. For these outputs, the service stores parameter set NAL
                  units in the sample headers but not in the samples directly. For MP4 outputs, when
                  you choose HVC1, your output video might not work properly with some downstream
                  systems and video players. The service defaults to marking your output as HEV1.
                  For these outputs, the service writes parameter set NAL units directly into the
                  samples.

                - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value MPEG2.

                  - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                  quantizers to vary to improve visual quality.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                  Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                  rounded down to the nearest multiple of 1000.

                  - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                  for the video output.

                  - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                  profile for the video output.

                  - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                  quality for high-motion content. This will cause the service to use fewer B-frames
                  (which infer information based on other frames) for high-motion portions of the
                  video and more B-frames for low-motion portions. The maximum number of B-frames is
                  limited by the value you provide for the setting B frames between reference frames
                  (numberBFramesBetweenReferenceFrames).

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                  fraction, e.g. 24000 / 1001 = 23.976 fps.

                  - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                  applications, it is recommended that this be set to 1 so a decoder joining
                  mid-stream will receive an IDR frame as quickly as possible. Setting this value to
                  0 will break output segmenting.

                  - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                  Must be greater than zero.

                  - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                  in frames or seconds. If seconds the system will convert the GOP Size into a frame
                  count at run time.

                  - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                  should initially be filled (HRD buffer model).

                  - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                  example, enter five megabits as 5000000.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **IntraDcPrecision** *(string) --* Use Intra DC precision
                  (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                  coefficients. If you choose the value auto, the service will automatically select
                  the precision based on the per-frame compression ratio.

                  - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                  five megabits per second as 5000000.

                  - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                  I-frames and I-frames inserted by Scene Change Detection. If a scene change
                  I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or
                  stretched to the scene change I-frame. GOP stretch requires enabling lookahead as
                  well as setting I-interval. The normal cadence resumes for the next GOP. This
                  setting is only used when Scene Change Detect is enabled. Note: Maximum GOP
                  stretch = GOP size + Min-I-interval - 1

                  - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                  between reference frames.

                  - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                  the service to use the pixel aspect ratio from the input. Using the console, do
                  this by choosing Follow source for Pixel aspect ratio.

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **QualityTuningLevel** *(string) --* Use Quality tuning level
                  (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                  video encoding.

                  - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                  to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                  - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                  scene changes that the service automatically detects. This improves video quality
                  and is enabled by default.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                  reduce high-frequency content in the encoded image.

                  - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on spatial variation of content complexity.

                  - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                  356M-2001).

                  - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

                  - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                  frame based on temporal variation of content complexity.

                - **ProresSettings** *(dict) --* Required when you set (Codec) under
                (VideoDescription)>(CodecSettings) to the value PRORES.

                  - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                  type of Apple ProRes codec to use for this output.

                  - **FramerateControl** *(string) --* If you are using the console, use the
                  Framerate setting to specify the frame rate for this output. If you want to keep
                  the same frame rate as the input video, choose Follow source. If you want to do
                  frame rate conversion, choose a frame rate from the dropdown list or choose
                  Custom. The framerates shown in the dropdown list are decimal approximations of
                  fractions. If you choose Custom, specify your frame rate as a fraction. If you are
                  creating your transcoding job sepecification as a JSON file without the console,
                  use FramerateControl to specify which value the service uses for the frame rate
                  for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the
                  frame rate from the input. Choose SPECIFIED if you want the service to use the
                  frame rate you specify in the settings FramerateNumerator and
                  FramerateDenominator.

                  - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                  smoother motion during frame rate conversion.

                  - **FramerateDenominator** *(integer) --* Frame rate denominator.

                  - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                  that use frame rate conversion, specify the frame rate as a fraction. For example,
                  24000 / 1001 =
                       23.976 fps. Use FramerateNumerator to specify the numerator of this
                  fraction. In this example, use 24000 for the value of FramerateNumerator.

                  - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                  scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field
                  First (BOTTOM_FIELD) produce interlaced output with the entire output having the
                  same field polarity (top or bottom first). * Follow, Default Top
                  (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                  field polarity as the source. Therefore, behavior depends on the input scan type.
                  - If the source is interlaced, the output will be interlaced with the same
                  polarity as the source (it will follow the source). The output could therefore be
                  a mix of "top field first" and "bottom field first". - If the source is
                  progressive, the output will be interlaced with "top field first" or "bottom field
                  first" polarity, depending on which of the Follow options you chose.

                  - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                  determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                  to use the pixel aspect ratio from the input. To specify a different pixel aspect
                  ratio: Using the console, choose it from the dropdown menu. Using the API, set
                  ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                  (ParDenominator).

                  - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                  - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                  - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                  input is relabeled as 25fps, and audio is sped up correspondingly.

                  - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                  Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                  produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                  23.976 output and leave converstion to the player.

              - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
              color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
              this output. If you don't specify a value, the service sets this to Insert by default.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
              feature is enabled, the service will use drop-frame timecode on outputs. If it is not
              possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
              setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

              - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
              Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
              will write on all frames of this video output.

              - **Height** *(integer) --* Use the Height (Height) setting to define the video
              resolution height for this output. Specify in pixels. If you don't provide a value
              here, the service will use the input height.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black.

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
              service changes the video itself in response to AFD values in the input. * Choose
              Respond to clip the input video frame according to the AFD value, input display aspect
              ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
              values. Do not choose this when AfdSignaling is set to (NONE). A preferred
              implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling
              to (AUTO). * Choose None to remove all input AFD values from this output.

              - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have
              a different aspect ratio from the input aspect ratio. Choose Stretch to output
              (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
              setting Default (DEFAULT) to have the service letterbox your video instead. This
              setting overrides any value that you specify for the setting Selection placement
              (position) in this output.

              - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
              strength of anti-aliasing. This setting changes the width of the anti-alias filter
              kernel used for scaling. Sharpness only applies if your output resolution is different
              from your input resolution. 0 is the softest setting, 100 the sharpest, and 50
              recommended for most content.

              - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
              outputs. Only enable Timecode insertion when the input frame rate is identical to the
              output frame rate. To include timecodes in this output, set Timecode insertion
              (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
              Default is DISABLED. When the service inserts timecodes in an output, by default, it
              uses any embedded timecodes from the input. If none are present, the service will set
              the timecode for the first output frame to zero. To change this default behavior,
              adjust the settings under Timecode configuration (TimecodeConfig). In the console,
              these settings are located under Job > Job settings > Timecode configuration. Note -
              Timecode source under input settings (InputTimecodeSource) does not affect the
              timecodes that are inserted in the output. Source under Job settings > Timecode
              configuration (TimecodeSource) does.

              - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
              Preprocessors (VideoPreprocessors). Enable the features at each output individually.
              These features are disabled by default.

                - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
                if necessary. Enable or disable this feature for each output individually. This
                setting is disabled by default.

                  - **Brightness** *(integer) --* Brightness level.

                  - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                  output. The service supports conversion between HDR formats, between SDR formats,
                  and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR
                  to HDR conversion doesn't upgrade the dynamic range. The converted video has an
                  HDR format, but visually appears the same as an unconverted output.

                  - **Contrast** *(integer) --* Contrast level.

                  - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                  color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                  metadata that you want signaled in the output. These values don't affect the pixel
                  values that are encoded in the video stream. They are intended to help the
                  downstream video player display content in a way that reflects the intentions of
                  the the content creator. When you set Color space conversion
                  (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                  must set values for Max frame average light level (maxFrameAverageLightLevel) and
                  Max content light level (maxContentLightLevel); these settings don't have a
                  default value. The default values for the other HDR 10 metadata settings are
                  defined by the P3D65 color space. For more information about MediaConvert HDR
                  jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                    provided by a color grader, using color grading tools. Range is 0 to 50,000,
                    each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                    setting is not for color correction.

                    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples
                    in the coded video sequence, in units of candelas per square meter. This setting
                    doesn't have a default value; you must specify a value that is suitable for the
                    content.

                    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                    any frame in the coded video sequence, in units of candelas per square meter.
                    This setting doesn't have a default value; you must specify a value that is
                    suitable for the content.

                    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                    units of of 0.0001 candelas per square meter.

                    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                    units of of 0.0001 candelas per square meter

                    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                    by a color grader, using color grading tools. Range is 0 to 50,000, each
                    increment represents 0.00002 in CIE1931 color coordinate. Note that this setting
                    is not for color correction.

                  - **Hue** *(integer) --* Hue in degrees.

                  - **Saturation** *(integer) --* Saturation level.

                - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                motion and a clearer picture.

                  - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                  (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                  adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                  produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your
                  source file includes a ticker, such as a scrolling headline at the bottom of the
                  frame.

                  - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                  not convert frames that are tagged in metadata as progressive. It will only
                  convert those that are tagged as some other type. - When set to FORCE_ALL_FRAMES,
                  the deinterlacer converts every frame to progressive - even those that are already
                  tagged as progressive. Turn Force mode on only if there is a good chance that the
                  metadata has tagged frames as progressive when they are not progressive. Do not
                  turn on otherwise; processing frames that are already progressive into progressive
                  will probably result in lower quality video.

                  - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                  service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                  interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                  progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                compatible video output.

                  - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                  to SPECIFY to override the MaxCLL and MaxFALL values in your input with new
                  values.

                    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                    that corresponds to the brightest pixel in the entire stream. Measured in nits.

                    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                    metadata that corresponds to the highest frame-average brightness in the entire
                    stream. Measured in nits.

                  - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                  handle Dolby Vision MaxCLL and MaxFALL properies.

                  - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                  Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                  Dolby Vision frame interleaved data.

                - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
                include a graphic overlay on your video. Enable or disable this feature for each
                output individually. This setting is disabled by default.

                  - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                  your video. The images must be PNG or TGA files.

                    - *(dict) --* Settings that specify how your still graphic overlay appears.

                      - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                      to remain on the output video. This duration includes fade-in time but not
                      fade-out time.

                      - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                      between the Start time that you specify for the image insertion and the time
                      that the image appears at full opacity. Full opacity is the level that you
                      specify for the opacity setting. If you don't specify a value for Fade-in, the
                      image will appear abruptly at the overlay start time.

                      - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                      between the end of the time that you have specified for the image overlay
                      Duration and when the overlaid image has faded to total transparency. If you
                      don't specify a value for Fade-out, the image will disappear abruptly at the
                      end of the inserted image duration.

                      - **Height** *(integer) --* Specify the height of the inserted image in
                      pixels. If you specify a value that's larger than the video resolution height,
                      the service will crop your overlaid image to fit. To use the native height of
                      the image, keep this setting blank.

                      - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                      location of the image that you want to overlay on the video. Use a PNG or TGA
                      file.

                      - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                      inserted image and the left edge of the video frame. Required for any image
                      overlay that you specify.

                      - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                      overlaid image and the top edge of the video frame. Required for any image
                      overlay that you specify.

                      - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                      Images with higher values for Layer appear on top of images with lower values
                      for Layer.

                      - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                      underlying video shows through the inserted image. 0 is transparent and 100 is
                      fully opaque. Default is 50.

                      - **StartTime** *(string) --* Specify the timecode of the frame that you want
                      the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                      HH:MM:SS;FF) format. Remember to take into account your timecode source
                      settings.

                      - **Width** *(integer) --* Specify the width of the inserted image in pixels.
                      If you specify a value that's larger than the video resolution width, the
                      service will crop your overlaid image to fit. To use the native width of the
                      image, keep this setting blank.

                - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                remove noise from your video output if necessary. Enable or disable this feature for
                each output individually. This setting is disabled by default.

                  - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                  one of the following spatial image filtering functions. To use this setting, you
                  must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                  reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                  convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                  frequency-domain filtering based on JND principles. * Temporal optimizes video
                  quality for complex motion.

                  - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                  filter.

                    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                    reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                    maximum strength.

                    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                    (higher speed), with 0 being the nominal value.

                    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                    values produce stronger filtering.

                  - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                  temporal filter.

                    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                    complex motion. Higher values produce stronger temporal filtering. This filters
                    highly complex scenes more aggressively and creates better VQ for low bitrate
                    outputs.

                    - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                    Low setting reduces bit rate at the cost of transcode time, high setting
                    improves transcode time at the cost of bit rate.

                    - **Strength** *(integer) --* Specify the strength of the noise reducing filter
                    on this output. Higher values produce stronger filtering. We recommend the
                    following value ranges, depending on the result that you want: * 0-2 for
                    complexity reduction with minimal sharpness loss * 2-8 for complexity reduction
                    with image preservation * 8-16 for a high level of complexity reduction

                - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
                timecode and specified prefix into the output.

                  - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                  burned-in timecode. Valid values are 10, 16, 32, 48.

                  - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                  (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                  - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                  any burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                  "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                  equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                  letters, numbers, and all special characters represented on a standard English
                  keyboard.

              - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
              pixels, for this output. If you don't provide a value here, the service will use the
              input width.

    - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
    information from inputs.

      - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
      use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
      the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).
      This setting ignores frame rate conversion. System behavior for Anchor Timecode varies
      depending on your setting for Source (TimecodeSource). * If Source (TimecodeSource) is set to
      Specified Start (SPECIFIEDSTART), the first input frame is the specified value in Start
      Timecode (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate
      output timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
      is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first frame is
      the timecode value on the first input frame of the input.

      - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled within
      this job. To make sure that your video, audio, captions, and markers are synchronized and that
      time-based features, such as image inserter, work correctly, choose the Timecode source option
      that matches your assets. All timecodes are in a 24-hour format with frame number
      (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video. If no
      embedded timecode is in the source, the service will use Start at 0 (ZEROBASED) instead. *
      Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. * Specified
      Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other than zero. You
      use Start timecode (Start) to provide this value.

      - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
      (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
      Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

      - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
      stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without affecting
      the time and frame number. Provide the new date as a string in the format "yyyy-mm-dd". To use
      Time stamp offset, you must also enable Insert program-date-time (InsertProgramDateTime) in
      the output settings. For example, if the date part of your timecodes is 2002-1-25 and you want
      to change it to one year later, set Timestamp offset (TimestampOffset) to 2003-1-25.

    - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
    (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
    enable it here, enable it in each output container, and specify tags and timecodes in ID3
    insertion (Id3Insertion) objects.

      - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

        - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
        specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when the
        tag should be inserted. To insert multiple ID3 tags in your output, create multiple
        instances of ID3 insertion (Id3Insertion).

          - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode format.

          - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
          format.
    """


_ListJobsPaginateResponseJobsTimingTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsTimingTypeDef",
    {"FinishTime": datetime, "StartTime": datetime, "SubmitTime": datetime},
    total=False,
)


class ListJobsPaginateResponseJobsTimingTypeDef(_ListJobsPaginateResponseJobsTimingTypeDef):
    """
    Type definition for `ListJobsPaginateResponseJobs` `Timing`

    - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
    finished

    - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the job
    began.

    - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the job.
    """


_ListJobsPaginateResponseJobsTypeDef = TypedDict(
    "_ListJobsPaginateResponseJobsTypeDef",
    {
        "AccelerationSettings": ListJobsPaginateResponseJobsAccelerationSettingsTypeDef,
        "AccelerationStatus": str,
        "Arn": str,
        "BillingTagsSource": str,
        "CreatedAt": datetime,
        "CurrentPhase": str,
        "ErrorCode": int,
        "ErrorMessage": str,
        "Id": str,
        "JobPercentComplete": int,
        "JobTemplate": str,
        "Messages": ListJobsPaginateResponseJobsMessagesTypeDef,
        "OutputGroupDetails": List[ListJobsPaginateResponseJobsOutputGroupDetailsTypeDef],
        "Priority": int,
        "Queue": str,
        "RetryCount": int,
        "Role": str,
        "Settings": ListJobsPaginateResponseJobsSettingsTypeDef,
        "SimulateReservedQueue": str,
        "Status": str,
        "StatusUpdateInterval": str,
        "Timing": ListJobsPaginateResponseJobsTimingTypeDef,
        "UserMetadata": Dict[str, str],
    },
    total=False,
)


class ListJobsPaginateResponseJobsTypeDef(_ListJobsPaginateResponseJobsTypeDef):
    """
    Type definition for `ListJobsPaginateResponse` `Jobs`

    - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up jobs
    with long, visually complex content.

      - **Mode** *(string) --* Specify the conditions when the service will run your job with
      accelerated transcoding.

    - **AccelerationStatus** *(string) --* Describes whether the current job is running with
    accelerated transcoding. For jobs that have Acceleration (AccelerationMode) set to DISABLED,
    AccelerationStatus is always NOT_APPLICABLE. For jobs that have Acceleration (AccelerationMode)
    set to ENABLED or PREFERRED, AccelerationStatus is one of the other states. AccelerationStatus
    is IN_PROGRESS initially, while the service determines whether the input files and job settings
    are compatible with accelerated transcoding. If they are, AcclerationStatus is ACCELERATED. If
    your input files and job settings aren't compatible with accelerated transcoding, the service
    either fails your job or runs it without accelerated transcoding, depending on how you set
    Acceleration (AccelerationMode). When the service runs your job without accelerated transcoding,
    AccelerationStatus is NOT_ACCELERATED.

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **BillingTagsSource** *(string) --* Optional. Choose a tag type that AWS Billing and Cost
    Management will use to sort your AWS Elemental MediaConvert costs on any billing report that you
    set up. Any transcoding outputs that don't have an associated tag will appear in your billing
    report unsorted. If you don't choose a valid value for this field, your job outputs will appear
    on the billing report unsorted.

    - **CreatedAt** *(datetime) --* The time, in Unix epoch format in seconds, when the job got
    created.

    - **CurrentPhase** *(string) --* A job's phase can be PROBING, TRANSCODING OR UPLOADING

    - **ErrorCode** *(integer) --* Error code for the job

    - **ErrorMessage** *(string) --* Error message of Job

    - **Id** *(string) --* A portion of the job's ARN, unique within your AWS Elemental MediaConvert
    resources

    - **JobPercentComplete** *(integer) --* An estimate of how far your job has progressed. This
    estimate is shown as a percentage of the total time from when your job leaves its queue to when
    your output files appear in your output Amazon S3 bucket. AWS Elemental MediaConvert provides
    jobPercentComplete in CloudWatch STATUS_UPDATE events and in the response to GetJob and ListJobs
    requests. The jobPercentComplete estimate is reliable for the following input containers:
    Quicktime, Transport Stream, MP4, and MXF. For some jobs, the service can't provide information
    about job progress. In those cases, jobPercentComplete returns a null value.

    - **JobTemplate** *(string) --* The job template that the job is created from, if it is created
    from a job template.

    - **Messages** *(dict) --* Provides messages from the service about jobs that you have already
    successfully submitted.

      - **Info** *(list) --* List of messages that are informational only and don't indicate a
      problem with your job.

        - *(string) --*

      - **Warning** *(list) --* List of messages that warn about conditions that might cause your
      job not to run or to fail.

        - *(string) --*

    - **OutputGroupDetails** *(list) --* List of output group details

      - *(dict) --* Contains details about the output groups specified in the job settings.

        - **OutputDetails** *(list) --* Details about the output

          - *(dict) --* Details regarding output

            - **DurationInMs** *(integer) --* Duration in milliseconds

            - **VideoDetails** *(dict) --* Contains details about the output's video stream

              - **HeightInPx** *(integer) --* Height in pixels for the output

              - **WidthInPx** *(integer) --* Width in pixels for the output

    - **Priority** *(integer) --* Relative priority on the job.

    - **Queue** *(string) --* Optional. When you create a job, you can specify a queue to send it
    to. If you don't specify, the job will go to the default queue. For more about queues, see the
    User Guide topic at http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

    - **RetryCount** *(integer) --* The number of times that the service automatically attempted to
    process your job after encountering an error.

    - **Role** *(string) --* The IAM role you use for creating this job. For details about
    permissions, see the User Guide topic at the User Guide at
    http://docs.aws.amazon.com/mediaconvert/latest/ug/iam-role.html

    - **Settings** *(dict) --* JobSettings contains all the transcode settings for a job.

      - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added to
      the input Ad Avail PTS time.

      - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
      overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

        - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
        black. Only bmp and png images are supported.

      - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

        - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
        ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder
        uses the manifest conditioning instructions that you provide in the setting MCC XML
        (mccXml).

          - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
          document inside your JSON job settings. Form the XML document as per
          OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning instructions
          in the message that you supply.

        - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in milliseconds,
        between the SCTE 35 messages that the transcoder places and the splice points that they
        refer to. If the time between the start of the asset and the SCTE-35 message is less than
        this value, then the transcoder places the SCTE-35 marker at the beginning of the stream.

        - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
        SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses the
        signal processing instructions that you provide in the setting SCC XML (sccXml).

          - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
          inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025. The
          transcoder will use the signal processing instructions in the message that you supply.
          Provide your ESAM SignalProcessingNotification XML document inside your JSON job settings.
          For your MPEG2-TS file outputs, if you want the service to place SCTE-35 markers at the
          insertion points you specify in the XML document, you must also enable SCTE-35 ESAM
          (scte35Esam). Note that you can either specify an ESAM XML document or enable SCTE-35
          passthrough. You can't do both.

      - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode job.
      There can be multiple inputs add in a job. These inputs will be concantenated together to
      create the output.

        - *(dict) --* Specifies media input

          - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input to
          combine. An input may have multiple audio selector groups. See "Audio Selector
          Group":#inputs-audio_selector_group for more information.

            - *(string) --*

              - *(dict) --* Group of Audio Selectors

                - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same input
                to include in the group. Audio selector names are standardized, based on their order
                within the input (e.g., "Audio Selector 1"). The audio selector name parameter can
                be repeated to add any number of audio selectors to the group.

                  - *(string) --*

          - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a track
          or set of tracks from the input that you will use in your outputs. You can use mutiple
          Audio selectors per input.

            - *(string) --*

              - *(dict) --* Selector for Audio

                - **CustomLanguageCode** *(string) --* Selects a specific language code from within
                an audio source, using the ISO 639-2 or ISO 639-3 three-letter language code

                - **DefaultSelection** *(string) --* Enable this setting on one audio selector to
                set it as the default for the job. The service uses this default for outputs where
                it can't find the specified input audio. If you don't set a default, those outputs
                have no audio.

                - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                file source.

                - **LanguageCode** *(string) --* Selects a specific language code from within an
                audio source.

                - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                audio from the input video.

                - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g. 257
                selects PID 0x101).

                  - *(integer) --*

                - **ProgramSelection** *(integer) --* Use this setting for input streams that
                contain Dolby E, to have the service extract specific program data from the track.
                To select multiple programs, create multiple selectors with the same Track and
                different Program numbers. In the console, this setting is visible when you set
                Selector type to Track. Choose the program number from the dropdown list. If you are
                sending a JSON file, provide the program ID, which is part of the audio metadata. If
                your input file has incorrect metadata, you can choose All channels instead of a
                program number to have the service ignore the program IDs and include all the
                programs in the track.

                - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels of
                one input to match those of another input. This allows you to combine the two files
                into a single output, one after the other.

                  - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                  group of fields that hold the remixing value for each channel. Units are in dB.
                  Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                  passes the input channel unchanged to the output channel (no attenuation or
                  amplification).

                    - **OutputChannels** *(list) --* List of output channels

                      - *(dict) --* OutputChannel mapping settings.

                        - **InputChannels** *(list) --* List of input channels

                          - *(integer) --*

                  - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                  input that you want to use in your output. With remixing, you might combine or
                  split the data in these channels, so the number of channels in your final output
                  might be different.

                  - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                  after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                - **SelectorType** *(string) --* Specifies the type of the audio selector.

                - **Tracks** *(list) --* Identify a track from the input audio to include in this
                selector by entering the track index number. To include several tracks in a single
                audio selector, specify multiple tracks as follows. Using the console, enter a
                comma-separated list. For examle, type "1,2,3" to include tracks 1 through 3.
                Specifying directly in your JSON job file, provide the track numbers in an array.
                For example, "tracks": [1,2,3].

                  - *(integer) --*

          - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to specify
          the captions data from the input that you will use in your outputs. You can use mutiple
          captions selectors per input.

            - *(string) --*

              - *(dict) --* Set up captions in your outputs by first selecting them from your input
              here.

                - **CustomLanguageCode** *(string) --* The specific language to extract from source,
                using the ISO 639-2 or ISO 639-3 three-letter language code. If input is SCTE-27,
                complete this field and/or PID to select the caption language to extract. If input
                is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field and/or PID to
                select the caption language to extract. If input is DVB-Sub that is being passed
                through, omit this field (and PID field); there is no way to extract a specific
                language with pass-through captions.

                - **LanguageCode** *(string) --* The specific language to extract from source. If
                input is SCTE-27, complete this field and/or PID to select the caption language to
                extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this field
                and/or PID to select the caption language to extract. If input is DVB-Sub that is
                being passed through, omit this field (and PID field); there is no way to extract a
                specific language with pass-through captions.

                - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                SRT, or IMSC in an xml file, specify the URI of the input captions source file. If
                your input captions are IMSC in an IMF package, use TrackSourceSettings instead of
                FileSoureSettings.

                  - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions source.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                    number in the ancillary data track from which to extract captions. Unused for
                    passthrough.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                    - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use this
                    PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub content
                    is passed through, regardless of selectors.

                  - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel number
                    within the video track from which to extract captions. Unused for passthrough.

                    - **Source608TrackNumber** *(integer) --* Specifies the video track index used
                    for extracting captions. The system only supports one input video track, so this
                    should always be set to '1'.

                    - **TerminateCaptions** *(string) --* By default, the service terminates any
                    unterminated captions at the end of each input. If you want the caption to
                    continue onto your next input, disable this setting.

                  - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                  STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption source
                  file. If your caption source is IMSC in an IMF package, use TrackSourceSettings
                  instead of FileSoureSettings.

                    - **Convert608To708** *(string) --* Specify whether this set of input captions
                    appears in your outputs in both 608 and 708 format. If you choose Upconvert
                    (UPCONVERT), MediaConvert includes the captions data in two ways: it passes the
                    608 data through using the 608 compatibility bytes fields of the 708 wrapper,
                    and it also translates the 608 data into 708.

                    - **SourceFile** *(string) --* External caption file used for loading captions.
                    Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt', 'xml', and
                    'smi'.

                    - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset the
                    captions from the source file.

                  - **SourceType** *(string) --* Use Source (SourceType) to identify the format of
                  your input captions. The service cannot auto-detect caption format.

                  - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                  sources, including Page number.

                    - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                    three-digit hexadecimal page number that will be used for Teletext captions. Do
                    not use this setting if you are passing through teletext from the input source
                    to output.

                  - **TrackSourceSettings** *(dict) --* Settings specific to caption sources that
                  are specified by track number. Currently, this is only IMSC captions in an IMF
                  package. If your caption source is IMSC 1.1 in a separate xml file, use
                  FileSourceSettings instead of TrackSourceSettings.

                    - **TrackNumber** *(integer) --* Use this setting to select a single captions
                    track from a source. Track numbers correspond to the order in the captions
                    source file. For IMF sources, track numbering is based on the order that the
                    captions appear in the CPL. For example, use 1 to select the captions asset that
                    is listed first in the CPL. To include more than one captions track in your job
                    outputs, create multiple input captions selectors. Specify one track per
                    selector.

          - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
          service will include in the output video frame. If you specify a value here, it will
          override any value that you specify in the output setting Cropping selection (crop).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce smoother
          motion in the output. Default is disabled. Only manaully controllable for MPEG2 and
          uncompressed video inputs.

          - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
          encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when you
          use AWS Key Management Service (KMS) to encrypt the data key that you use to encrypt your
          content.

            - **DecryptionMode** *(string) --* Specify the encryption mode that you used to encrypt
            your input files.

            - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption key in
            plaintext. Your job settings could be intercepted, making your encrypted content
            vulnerable. Specify the encrypted version of the data key that you used to encrypt your
            content. The data key must be encrypted by AWS Key Management Service (KMS). The key can
            be 128, 192, or 256 bits.

            - **InitializationVector** *(string) --* Specify the initialization vector that you used
            when you encrypted your content before uploading it to Amazon S3. You can use a 16-byte
            initialization vector with any encryption mode. Or, you can use a 12-byte initialization
            vector with GCM or CTR. MediaConvert accepts only initialization vectors that are
            base64-encoded.

            - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management Service
            (KMS) that you used to encrypt your data key, if that Region is different from the one
            you are using for AWS Elemental MediaConvert.

          - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise from
          the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and uncompressed
          video inputs.

          - **FileInput** *(string) --* Specify the source file for your transcoding job. You can
          use multiple inputs in a single job. The service concatenates these inputs, in the order
          that you specify them in the job, to create the outputs. If your input format is IMF,
          specify your input by providing the path to your CPL. For example,
          "s3://bucket/vf/cpl.xml". If the CPL is in an incomplete IMP, make sure to use
          *Supplemental IMPs* (SupplementalImps) to specify any supplemental IMPs that contain
          assets referenced by the CPL.

          - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how the
          transcoding service applies the denoise and deblock filters. You must also enable the
          filters separately, with Denoise (InputDenoiseFilter) and Deblock (InputDeblockFilter). *
          Auto - The transcoding service determines whether to apply filtering, depending on input
          type and quality. * Disable - The input is not filtered. This is true even if you use the
          API to enable them in (InputDeblockFilter) and (InputDeblockFilter). * Force - The in put
          is filtered regardless of input type.

          - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
          magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5. Default
          is 0.

          - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
          overlay on your video. Enable or disable this feature for each input individually. This
          setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
          that together specify a portion of the input to be used in the outputs. If you provide
          only a start time, the clip will be the entire input from that point to the end. If you
          provide only an end time, it will be the entire input up to that point. When you specify
          more than one input clip, the transcoding service creates the job outputs by stringing the
          clips together in the order you specify them.

            - *(dict) --* To transcode only portions of your input (clips), include one Input
            clipping (one instance of InputClipping in the JSON job file) for each input clip. All
            input clips you specify will be included in every output of the job.

              - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
              portion of the input you are clipping. The frame corresponding to the End timecode
              value is included in the clip. Start timecode or End timecode may be left blank, but
              not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM is the
              minute, SS is the second, and FF is the frame number. When choosing this value, take
              into account your setting for timecode source under input settings
              (InputTimecodeSource). For example, if you have embedded timecodes that start at
              01:00:00:00 and you want your clip to end six minutes into the video, use 01:06:00:00.

              - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the beginning
              of the portion of the input you are clipping. The frame corresponding to the Start
              timecode value is included in the clip. Start timecode or End timecode may be left
              blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour,
              MM is the minute, SS is the second, and FF is the frame number. When choosing this
              value, take into account your setting for Input timecode source. For example, if you
              have embedded timecodes that start at 01:00:00:00 and you want your clip to begin five
              minutes into the video, use 01:05:00:00.

          - **Position** *(dict) --* Use Selection placement (position) to define the video area in
          your output frame. The area outside of the rectangle that you specify here is black. If
          you specify a value here, it will override any value that you specify in the output
          setting Selection placement (position). If you specify a value here, this will override
          any AFD values in your input, even if you set Respond to AFD (RespondToAfd) to Respond
          (RESPOND). If you specify a value here, this will ignore anything that you specify for the
          setting Scaling Behavior (scalingBehavior).

            - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

            - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

            - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge
            of the video frame. Specify only even numbers.

            - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
            of the video frame. Specify only even numbers.

          - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
          program from within a multi-program transport stream. Note that Quad 4K is not currently
          supported. Default is the first program within the transport stream. If the program you
          specify doesn't exist, the transcoding service will use this default.

          - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
          inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs for
          audio and video. * Use PSI - Scan only PSI data.

          - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs. You
          need supplemental IMPs if the CPL that you're using for your input is in an incomplete
          IMP. Specify either the supplemental IMP directories with a trailing slash or the
          ASSETMAP.xml files. For example ["s3://bucket/ov/", "s3://bucket/vf2/ASSETMAP.xml"]. You
          don't need to specify the IMP that contains your input CPL, because the service
          automatically detects it.

            - *(string) --*

          - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
          input settings (InputTimecodeSource), to specify how the service counts input video
          frames. This input frame count affects only the behavior of features that apply to a
          single input at a time, such as input clipping and synchronizing some captions formats.
          Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose Start at zero
          (ZEROBASED) to start the first frame at zero. Choose Specified start (SPECIFIEDSTART) to
          start the first frame at the timecode that you specify in the setting Start timecode
          (timecodeStart). If you don't specify a value for Timecode source, the service will use
          Embedded by default. For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **TimecodeStart** *(string) --* Specify the timecode that you want the service to use
          for this input's initial frame. To use this setting, you must set the Timecode source
          setting, located under the input settings (InputTimecodeSource), to Specified start
          (SPECIFIEDSTART). For more information about timecodes, see
          https://docs.aws.amazon.com/console/mediaconvert/timecode.

          - **VideoSelector** *(dict) --* Selector for video.

            - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a QuickTime
            animation. Specify which part of this input MediaConvert uses for your outputs. Leave
            this setting set to DISCARD in order to delete the alpha channel and preserve the video.
            Use REMAP_TO_LUMA for this setting to delete the video and map the alpha channel to the
            luma channel of your outputs.

            - **ColorSpace** *(string) --* If your input video has accurate color space metadata, or
            if you don't know about color space, leave this set to the default value Follow
            (FOLLOW). The service will automatically detect your input color space. If your input
            video has metadata indicating the wrong color space, specify the accurate color space
            here. If your input video is HDR 10 and the SMPTE ST 2086 Mastering Display Color Volume
            static metadata isn't present in your video stream, or if that metadata is present but
            not accurate, choose Force HDR 10 (FORCE_HDR10) here and specify correct values in the
            input HDR 10 metadata (Hdr10Metadata) settings. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the input
            file and the job input settings Color space (ColorSpace) and HDR master display
            information settings(Hdr10Metadata). The Color space usage setting determines which
            takes precedence. Choose Force (FORCE) to use color metadata from the input job
            settings. If you don't specify values for those settings, the service defaults to using
            metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to use color metadata
            from the source when it is present. If there's no color metadata in your input file, the
            service defaults to using values you specify in the input settings.

            - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that is
            missing or inaccurate in your input video. Appropriate values vary depending on the
            input video and must be provided by a color grader. The color grader generates these
            values during the HDR 10 mastering process. The valid range for each of these settings
            is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color coordinate. Related
            settings - When you specify these values, you must also set Color space (ColorSpace) to
            HDR 10 (HDR10). To specify whether the the values you specify here take precedence over
            the values in the metadata of your input file, set Color space usage (ColorSpaceUsage).
            To specify whether color metadata is included in an output, set Color metadata
            (ColorMetadata). For more information about MediaConvert HDR jobs, see
            https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input file.
            Specify this value as an integer; the system automatically converts it to the
            hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier, is
            an identifier for a set of data in an MPEG-2 transport stream container.

            - **ProgramNumber** *(integer) --* Selects a specific program from within a
            multi-program transport stream. Note that Quad 4K is not currently supported.

            - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service rotates
            your video. You can choose automatic rotation or specify a rotation. You can specify a
            clockwise rotation of 0, 90, 180, or 270 degrees. If your input video container is .mov
            or .mp4 and your input has rotation metadata, you can choose Automatic to have the
            service rotate your video according to the rotation specified in the metadata. The
            rotation must be within one degree of 90, 180, or 270 degrees. If the rotation metadata
            specifies any other rotation, the service will default to no rotation. By default, the
            service does no rotation, even if your input video has rotation metadata. The service
            doesn't pass through rotation metadata.

      - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The motion
      graphics that you specify here appear on all outputs in all output groups.

        - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this setting
        unspecified. If your motion graphic asset is a series of .png files, specify the frame rate
        of the overlay in frames per second, as a fraction. For example, specify 24 fps as 24/1.
        Make sure that the number of images in your series matches the frame rate and your intended
        overlay duration. For example, if you want a 30-second overlay at 30 fps, you should have
        900 .png images. This overlay frame rate doesn't need to match the frame rate of the
        underlying video.

          - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 1.

          - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
          overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

        - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
        overlay on your video. For .png files, provide the file name of the first file in the
        series. Make sure that the names of the .png files end with sequential numbers that specify
        the order that they are played in. For example, overlay_000.png, overlay_001.png,
        overlay_002.png, and so on. The sequence must start at zero, and each image file name must
        have the same number of digits. Pad your initial file names with enough zeros to complete
        the sequence. For example, if the first image is overlay_0.png, there can be only 10 images
        in the sequence, with the last image being overlay_9.png. But if the first image is
        overlay_00.png, there can be 100 images in the sequence.

        - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
        providing for your overlay. You can choose either a .mov file or a series of .png files.

        - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic overlay
        on the video frame. Specify in pixels, from the upper-left corner of the frame. If you don't
        specify an offset, the service scales your overlay to the full size of the frame. Otherwise,
        the service inserts the overlay at its native resolution and scales the size up or down with
        any video scaling.

          - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the left
          edge of the video frame.

          - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the top
          edge of the video frame.

        - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a loop
        or plays only once.

        - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode format
        (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes into
        account how you have set up your timecode configuration under both job settings and input
        settings. The simplest way to do that is to set both to start at 0. If you need to set up
        your job to follow timecodes embedded in your source that don't start at zero, make sure
        that you specify a start time that is after the first embedded timecode. For more
        information, see https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html
        Find job-wide and input timecode configuration settings in your JSON job settings
        specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

      - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you don't
      do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
      configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all outputs
      in the job. To enable Nielsen configuration programmatically, include an instance of
      nielsenConfiguration in your JSON job specification. Even if you don't include any children of
      nielsenConfiguration, you still enable the setting.

        - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
        functionality. If you must include this property, set the value to zero.

        - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
        distributor ID that is assigned to your organization by Neilsen.

      - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set of
      outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS, Quicktime,
      MXF, and no container) are grouped in a single output group as well. Required in
      (OutputGroups) is a group of settings that apply to the whole group. This required object
      depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings). Type,
      settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
      HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
      MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

        - *(dict) --* Group of outputs

          - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name for
          the output group. This value is displayed on the console and can make your job settings
          JSON more human-readable. It does not affect your outputs. Use up to twelve characters
          that are either letters, numbers, spaces, or underscores.

          - **Name** *(string) --* Name of the output group

          - **OutputGroupSettings** *(dict) --* Output Group settings, including type

            - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
            Output Group may only contain a single video, audio, or caption output.

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF output group in
              your job. These default manifests reference every output in the output group. To
              create additional top-level manifests that reference a subset of the outputs in the
              output group, specify a list of them here. For each additional manifest that you
              specify, the service creates one HLS manifest and one DASH manifest.

                - *(dict) --* Specify the details for each pair of HLS and DASH additional manifests
                that you want the service to generate for this CMAF output group. Each pair of
                manifests can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest file
              at the top level BaseURL element. Can be used if streams are delivered from a
              different URL than the manifest file.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want the
                service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                (SAMPLE-AES) or AES_CTR (AES-CTR).

                - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                outputs, choose whether the service writes the 128-bit encryption initialization
                vector in the HLS and DASH manifests.

                - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you want
                  signaled in the DASH manifest that MediaConvert creates as part of this CMAF
                  package. The DASH manifest can currently signal up to three system IDs. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                  signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                  package. The HLS manifest can currently signal only one system ID. For more
                  information, see https://dashif.org/identifiers/content_protection/.

                    - *(string) --*

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Use this setting to specify the length, in seconds,
              of each individual CMAF segment. This value applies to the whole package; that is, to
              every output in the output group. Note that segments end on the first keyframe after
              this number of seconds, so the actual segment length might be slightly longer. If you
              set Segment control (CmafSegmentControl) to single file, the service puts the content
              of each output in a single file that has metadata that marks these segments. If you
              set it to segmented files, the service creates multiple files for each output, each
              with the content of one segment.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest will be
              generated for this output.

              - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest will
              be generated for this output.

            - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .mpd DASH
              manifest for each DASH ISO output group in your job. This default manifest references
              every output in the output group. To create additional DASH manifests that reference a
              subset of the outputs in the output group, specify a list of them here.

                - *(dict) --* Specify the details for each additional DASH manifest that you want
                the service to generate for this output group. Each manifest can reference a
                different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your DASH group is film-name.mpd. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.mpd.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
              (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
              from a different URL than the manifest file.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* DRM settings.

                - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                compatibility of your output with video players on obsolete devices. It applies only
                to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI (UNENCRYPTED_SEI)
                only to correct problems with playback on older devices. Otherwise, keep the default
                setting CENC v1 (CENC_V1). If you choose Unencrypted SEI, for that output, the
                service will exclude the access unit delimiter and will leave the SEI NAL units
                unencrypted.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
              Fragment length must be compatible with GOP size and Framerate. Note that fragments
              will end on the next keyframe after this number of seconds, so actual fragment length
              may be longer. When Emit Single File is checked, the fragmentation is internal to a
              single output file and it does not cause the creation of many output files as in other
              output types.

              - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

              - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that is
              needed to ensure smooth playout.

              - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or main.
              When you choose Main profile (MAIN_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
              On-demand (ON_DEMAND_PROFILE), the service signals
              urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose On-demand,
              you must also set the output group setting Segment control (SegmentControl) to Single
              file (SINGLE_FILE).

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file is
              generated, which is internally segmented using the Fragment Length and Segment Length.
              When set to SEGMENTED_FILES, separate segment files will be created.

              - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds). Note
              that segments will end on the next keyframe after this number of seconds, so actual
              segment length may be longer. When Emit Single File is checked, the segmentation is
              internal to a single output file and it does not cause the creation of many output
              files as in other output types.

              - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error in
              the 400 range when you play back your DASH output, enable this setting and run your
              transcoding job again. When you enable this setting, the service writes precise
              segment durations in the DASH manifest. The segment duration information appears
              inside the SegmentTimeline element, inside SegmentTemplate at the Representation
              level. When you don't enable this setting, the service writes approximate segment
              durations in your DASH manifest.

            - **FileGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

            - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

              - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your Apple
              HLS manifest. This setting does not determine whether SCTE-35 markers appear in the
              outputs themselves.

                - *(string) --*

              - **AdditionalManifests** *(list) --* By default, the service creates one top-level
              .m3u8 HLS manifest for each HLS output group in your job. This default manifest
              references every output in the output group. To create additional top-level manifests
              that reference a subset of the outputs in the output group, specify a list of them
              here.

                - *(dict) --* Specify the details for each additional HLS manifest that you want the
                service to generate for this output group. Each manifest can reference a different
                subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your HLS group is film-name.m3u8. If you enter "-no-premium" for this
                  setting, then the file name the service generates for this top-level manifest is
                  film-name-no-premium.m3u8. For HLS output groups, specify a manifestNameModifier
                  that is different from the nameModifier of the output. The service uses the output
                  name modifier to create unique names for the individual variant manifests.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each output
              in the media .m3u8 file. Can be used if base manifest is delivered from a different
              URL than the main .m3u8 file.

              - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                - *(dict) --* Caption Language Mapping

                  - **CaptionChannel** *(integer) --* Caption channel.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                  - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                  three-letter code listed at
                  https://www.loc.gov/standards/iso639-2/php/code_list.php.

                  - **LanguageDescription** *(string) --* Caption language description.

              - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
              captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least one
              language in the CC1 Language Code field. One CLOSED-CAPTION line is added for each
              Language Code you specify. Make sure to specify the languages in the order in which
              they appear in the original source (if the source is embedded format) or the order of
              the caption selectors (if the source is other than embedded). Otherwise, languages in
              the manifest will not match up properly with the output captions. None: Include
              CLOSED-CAPTIONS=
                  NONE line in the manifest. Omit: Omit any CLOSED-CAPTIONS line from
              the manifest.

              - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no tag,
              which prevents client from saving media segments for later replay.

              - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the default
              RFC-4281) during m3u8 playlist generation.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **DirectoryStructure** *(string) --* Indicates whether segments should be placed in
              subdirectories.

              - **Encryption** *(dict) --* DRM settings.

                - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                value represented by a 32-character text string. If this parameter is not set then
                the Initialization Vector will follow the segment number by default.

                - **EncryptionMethod** *(string) --* Encrypts the segments with the given encryption
                scheme. Leave blank to disable. Selecting 'Disabled' in the web interface also
                disables encryption.

                - **InitializationVectorInManifest** *(string) --* The Initialization Vector is a
                128-bit number used in conjunction with the key for encrypting blocks. If set to
                INCLUDE, Initialization Vector is listed in the manifest. Otherwise Initialization
                Vector is not in the manifest.

                - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                EXT-X-SESSION-KEY element into the master playlist. This allows for offline Apple
                HLS FairPlay content protection.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

                - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with a
                static key provider.

                  - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of the
                  KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be omitted to
                  indicate an implicit value of 'identity'.

                  - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                  single positive integer version value or a slash delimited list of version values
                  (1/2/3).

                  - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                  32-character hexidecimal string to specify Key Value (StaticKeyValue).

                  - **Url** *(string) --* Relates to DRM implementation. The location of the license
                  server used for protecting content.

                - **Type** *(string) --* Specify whether your DRM encryption key is static or from a
                key provider that follows the SPEKE standard. For more information about SPEKE, see
                https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

              - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

              - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
              should use floating point values for segment duration.

              - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of 0,
              unless you are troubleshooting a problem with how devices play back the end of your
              video asset. If you know that player devices are hanging on the final segment of your
              video because the length of your final segment is too short, use this setting to
              specify a minimum final segment length, in seconds. Choose a value that is greater
              than or equal to 1 and less than your segment length. When you specify a value for
              this setting, the encoder will combine any final segment that is shorter than the
              length that you specify with the previous segment. For example, your segment length is
              3 seconds and your final segment is .5 seconds without a minimum final segment length;
              when you set the minimum final segment length to 1, your final segment is 3.5 seconds.

              - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced by
              looking ahead and back within the specified range for a nearby avail and extending the
              segment size if needed.

              - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file should
              be generated for this HLS output group.

              - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME tag
              in .m3u8 manifest files. The value is calculated as follows: either the program date
              and time are initialized using the input timecode source, or the time is initialized
              using the input timecode source and the date is initialized using the
              timestamp_offset.

              - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
              EXT-X-PROGRAM-DATE-TIME entry, in seconds.

              - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a single
              media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for playback.

              - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
              create (in seconds). Note that segments will end on the next keyframe after this
              number of seconds, so actual segment length may be longer.

              - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
              subdirectory before starting a new one. directoryStructure must be SINGLE_DIRECTORY
              for this setting to have an effect.

              - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute for
              video in EXT-X-STREAM-INF tag of variant manifest.

              - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the timecode.

              - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

              - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond delta
              offset to fine tune the timestamps.

            - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
            (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

              - **AdditionalManifests** *(list) --* By default, the service creates one .ism
              Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output group
              in your job. This default manifest references every output in the output group. To
              create additional manifests that reference a subset of the outputs in the output
              group, specify a list of them here.

                - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                manifest that you want the service to generate for this output group. Each manifest
                can reference a different subset of outputs in the group.

                  - **ManifestNameModifier** *(string) --* Specify a name modifier that the service
                  adds to the name of this manifest to make it different from the file names of the
                  other main manifests in the output group. For example, say that the default main
                  manifest for your Microsoft Smooth group is film-name.ismv. If you enter
                  "-no-premium" for this setting, then the file name the service generates for this
                  top-level manifest is film-name-no-premium.ismv.

                  - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                  additional top-level manifest to reference.

                    - *(string) --*

              - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines identical
              audio encoding settings across a Microsoft Smooth output group into a single audio
              stream.

              - **Destination** *(string) --* Use Destination (Destination) to specify the S3 output
              location and the output filename base. Destination accepts format identifiers. If you
              do not specify the base filename in the URI, the service will use the filename of the
              input file. If your job has multiple inputs, the service uses the filename of the
              first input file.

              - **DestinationSettings** *(dict) --* Settings associated with the destination. Will
              vary based on the type of destination

                - **S3Settings** *(dict) --* Settings associated with S3 destination

                  - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically apply
                  Amazon S3 access control for the outputs in this output group. When you don't use
                  this setting, S3 automatically applies the default access control list PRIVATE.

                    - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for MediaConvert to
                    apply to this output.

                  - **Encryption** *(dict) --* Settings for how your job outputs are encrypted as
                  they are uploaded to Amazon S3.

                    - **EncryptionType** *(string) --* Specify how you want your data keys managed.
                    AWS uses data keys to encrypt your content. AWS also encrypts the data keys
                    themselves, using a customer master key (CMK), and then stores the encrypted
                    data keys alongside your encrypted content. Use this setting to specify which
                    AWS service manages the CMK. For simplest set up, choose Amazon S3
                    (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be managed by AWS
                    Key Management Service (KMS), choose AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). By
                    default, when you choose AWS KMS, KMS uses the AWS managed customer master key
                    (CMK) associated with Amazon S3 to encrypt your data keys. You can optionally
                    choose to specify a different, customer managed CMK. Do so by specifying the
                    Amazon Resource Name (ARN) of the key for the setting KMS ARN (kmsKeyArn).

                    - **KmsKeyArn** *(string) --* Optionally, specify the customer master key (CMK)
                    that you want to use to encrypt the data key that AWS uses to encrypt your
                    output content. Enter the Amazon Resource Name (ARN) of the CMK. To use this
                    setting, you must also set Server-side encryption (S3ServerSideEncryptionType)
                    to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you set Server-side encryption to
                    AWS KMS but don't specify a CMK here, AWS uses the AWS managed CMK associated
                    with Amazon S3.

              - **Encryption** *(dict) --* If you are using DRM, set DRM System
              (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                Microsoft Smooth, use these settings when doing DRM encryption with a
                SPEKE-compliant key provider. If your output group type is CMAF, use the
                SpekeKeyProviderCmaf settings instead.

                  - **CertificateArn** *(string) --* If you want your key provider to encrypt the
                  content keys that it provides to MediaConvert, set up a certificate with a master
                  key using AWS Certificate Manager. Specify the certificate's Amazon Resource Name
                  (ARN) here.

                  - **ResourceId** *(string) --* Specify the resource ID that your SPEKE-compliant
                  key provider uses to identify this content.

                  - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                  identifiers. DASH output groups support a max of two system ids. Other group types
                  support one system id. See https://dashif.org/identifiers/content_protection/ for
                  more details.

                    - *(string) --*

                  - **Url** *(string) --* Specify the URL to the key server that your
                  SPEKE-compliant DRM key provider uses to provide keys for encrypting your content.

              - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to specify
              the mp4 fragment sizes in seconds. Fragment length must be compatible with GOP size
              and frame rate.

              - **ManifestEncoding** *(string) --* Use Manifest encoding (MsSmoothManifestEncoding)
              to specify the encoding format for the server and client manifest. Valid options are
              utf8 and utf16.

            - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
            Microsoft Smooth Streaming, CMAF)

          - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
          settings per output.

            - *(dict) --* An output object describes the settings for a single output file or stream
            in an output group.

              - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
              encoding settings organized by audio codec. Include one instance of
              (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
              encoding settings.

                - *(dict) --* Description of audio output

                  - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                  settings. Ignore these settings unless you need to comply with a loudness
                  standard.

                    - **Algorithm** *(string) --* Choose one of the following audio normalization
                    algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                    loudness for an entire piece of content, suitable for measurement of short-form
                    content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-2: Gated loudness. A measurement of gated average loudness compliant
                    with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
                    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
                    with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
                    Allows for more audio channels than the other algorithms, including
                    configurations such as 7.1.

                    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                    using the chosen algorithm. If disabled, the audio will be measured but not
                    adjusted.

                    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will
                    be corrected to the target level. Content measuring below this level will not be
                    corrected. Gating only applies when not using real_time_correction.

                    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                    loudness to a CSV file.

                    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                    TruePeak for each output's audio track loudness.

                    - **TargetLkfs** *(float) --* When you use Audio normalization
                    (AudioNormalizationSettings), optionally use this setting to specify a target
                    loudness. If you don't specify a value here, the encoder chooses a value for
                    you, based on the algorithm that you choose for Algorithm (algorithm). If you
                    choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
                    encoder will choose -23 LKFS.

                  - **AudioSourceName** *(string) --* Specifies which audio data to use from each
                  input. In the simplest case, specify an "Audio Selector":#inputs-audio_selector by
                  name based on its order within each input. For example if you specify "Audio
                  Selector 3", then the third audio selector will be used from each input. If an
                  input does not have an "Audio Selector 3", then the audio selector marked as
                  "default" in that input will be used. If there is no audio selector marked as
                  "default", silence will be inserted for the duration of that input. Alternatively,
                  an "Audio Selector Group":#inputs-audio_selector_group name may be specified, with
                  similar default/silence behavior. If no audio_source_name is specified, then
                  "Audio Selector 1" will be chosen automatically.

                  - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                  unchecked (false). A number between 0 and 255. The following are defined in
                  ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                       Hearing Impaired, 3 =
                  Visually Impaired Commentary, 4-255 = Reserved.

                  - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                  contains an ISO 639 audio_type, then that value is passed through to the output.
                  If the input contains no ISO 639 audio_type, the value in Audio Type is included
                  in the output. Otherwise the value in Audio Type is included in the output. Note
                  that this field and audioType are both ignored if audioDescriptionBroadcasterMix
                  is set to BROADCASTER_MIXED_AD.

                  - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                  (AudioDescriptions) contains the group of settings related to audio encoding. The
                  settings in this group vary depending on the value that you choose for Audio codec
                  (Codec). For each codec enum that you choose, define the corresponding settings
                  object. The following lists the codec enum, settings object pairs. * AAC,
                  AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3,
                  Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                    - **AacSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of
                    two mutually exclusive groups of AAC settings--VBR and CBR. To select one of
                    these modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or
                    "CBR". In VBR mode, you control the audio quality with the setting VBR quality
                    (vbrQuality). In CBR mode, you use the setting Bitrate (bitrate). Defaults and
                    valid values depend on the rate control mode.

                      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                      when the input contains pre-mixed main audio + audio description (AD) as a
                      stereo pair. The value for AudioType will be set to 3, which signals to
                      downstream systems that this stream contains "broadcaster mixed AD". Note that
                      the input received by the encoder must contain pre-mixed audio; the encoder
                      does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder
                      ignores any values you provide in AudioType and FollowInputAudioType. Choose
                      NORMAL when the input does not contain pre-mixed audio + audio description
                      (AD). In this case, the encoder will use any values you provide for AudioType
                      and FollowInputAudioType.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      The set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000,
                      16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000,
                      112000, 128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000,
                      448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you set is
                      also constrained by the values that you choose for Profile (codecProfile),
                      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
                      values depend on Bitrate control mode and Profile.

                      - **CodecProfile** *(string) --* AAC Profile.

                      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                      channel layout. Valid values depend on rate control mode and profile. "1.0 -
                      Audio Description (Receiver Mix)" setting receives a stereo description plus
                      control track and emits a mono AAC encode of the description track, with
                      control data emitted in the PES header as per ETSI TS 101 154 Annex E.

                      - **RateControlMode** *(string) --* Rate Control Mode.

                      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you
                      use LATM/LOAS AAC in an output, you must choose "No container" for the output
                      container.

                      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                      control mode and profile.

                      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio
                      for raw or MPEG-2 Transport Stream containers.

                      - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                      rate_control_mode is VBR.

                    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AC3.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                      stream that the encoder emits. For more information about the AC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital, dialnorm will be passed through.

                      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD,
                      adds dynamic range compression signaling to the output bitstream as defined in
                      the Dolby Digital specification.

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                    - **AiffSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value AIFF.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **Codec** *(string) --* Type of Audio codec.

                    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid values: 384k, 448k, 640k, 768k

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                      (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                      adjust loudness based on dialogue analysis.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                      this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert
                      uses this value for downmixing. How the service uses this value depends on the
                      value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid
                      values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix
                      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                      value -60 mutes the channel.

                      - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                      your audio.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content
                      that must be speech before the encoder uses the measured speech loudness as
                      the overall program loudness.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing.

                      - **SurroundExMode** *(string) --* Specify whether your input audio has an
                      additional center rear surround channel matrix encoded into your left and
                      right surround channels.

                    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value EAC3.

                      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3
                      dB attenuation to the surround channels. Only used for 3/2 coding mode.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                      Valid bitrates depend on the coding mode.

                      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3
                      stream that the encoder emits. For more information about the EAC3 bitstream
                      mode, see ATSC A/52-2012 (Annex E).

                      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                      number of channels.

                      - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                      channels.

                      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and
                      input audio is Dolby Digital Plus, dialnorm will be passed through.

                      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                      level for a signal with dynamic range compression.

                      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits
                      the audio dynamic range when compressing the audio.

                      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the
                      LFE channel is enabled

                      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                      channel prior to encoding. Only valid with 3_2_LFE coding mode.

                      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left only/Right only center mix (Lo/Ro center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left only/Right only center (loRoCenterMixLevel).

                      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                      channel. This setting applies only if you keep the default value of 3/2 - L,
                      R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode).
                      If you choose a different value for Coding mode, the service ignores Left
                      only/Right only surround (loRoSurroundMixLevel).

                      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                      Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                      MediaConvert uses this value for downmixing. How the service uses this value
                      depends on the value that you choose for Stereo downmix (Eac3StereoDownmix).
                      Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60
                      mutes the channel. This setting applies only if you keep the default value of
                      3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total center (ltRtCenterMixLevel).

                      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                      Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                      surround). MediaConvert uses this value for downmixing. How the service uses
                      this value depends on the value that you choose for Stereo downmix
                      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
                      -60 mutes the channel. This setting applies only if you keep the default value
                      of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Left total/Right total surround (ltRtSurroundMixLevel).

                      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                      will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio
                      data. If audio was not supplied from one of these streams, then the static
                      metadata settings will be used.

                      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+
                      audio will be passed through if it is present on the input. this detection is
                      dynamic over the life of the transcode. Inputs that alternate between DD+ and
                      non-DD+ content will have a consistent DD+ output as the system alternates
                      between passthrough and encoding.

                      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to
                      the surround channels. Only used for 3/2 coding mode.

                      - **SampleRate** *(integer) --* This value is always 48000. It represents the
                      sample rate in Hz.

                      - **StereoDownmix** *(string) --* Choose how the service does stereo
                      downmixing. This setting only applies if you keep the default value of 3/2 -
                      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                      (Eac3CodingMode). If you choose a different value for Coding mode, the service
                      ignores Stereo downmix (Eac3StereoDownmix).

                      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an
                      extra center back surround channel is matrix encoded into the left and right
                      surround channels.

                      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                      Surround is matrix encoded into the two channels.

                    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value MP2.

                      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                      - **Channels** *(integer) --* Set Channels to specify the number of channels
                      in this output audio track. Choosing Mono in the console will give you 1
                      output channel; choosing Stereo will give you 2. In the API, valid values are
                      1 and 2.

                      - **SampleRate** *(integer) --* Sample rate in hz.

                    - **WavSettings** *(dict) --* Required when you set (Codec) under
                    (AudioDescriptions)>(CodecSettings) to the value WAV.

                      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                      sample, to choose the encoding quality for this audio track.

                      - **Channels** *(integer) --* Specify the number of channels in this output
                      audio track. Valid values are 1 and even numbers up to 64. For example, 1, 2,
                      4, 6, and so on, up to 64.

                      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs.
                      If your output audio is likely to exceed 4 GB in file size, or if you
                      otherwise need the extended support of the RF64 format, set your output WAV
                      file format to RF64.

                      - **SampleRate** *(integer) --* Sample rate in Hz.

                  - **CustomLanguageCode** *(string) --* Specify the language for this audio output
                  track. The service puts this language code into your output audio track when you
                  set Language code control (AudioLanguageCodeControl) to Use configured
                  (USE_CONFIGURED). The service also uses your specified custom language code when
                  you set Language code control (AudioLanguageCodeControl) to Follow input
                  (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
                  outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you
                  can also use any other code in the full RFC-5646 specification. Streaming outputs
                  are those that are in one of the following output groups: CMAF, DASH ISO, Apple
                  HLS, or Microsoft Smooth Streaming.

                  - **LanguageCode** *(string) --* Indicates the language of the audio output track.
                  The ISO 639 language specified in the 'Language Code' drop down will be used when
                  'Follow Input Language Code' is not selected or when 'Follow Input Language Code'
                  is selected but there is no ISO 639 language code specified by the input.

                  - **LanguageCodeControl** *(string) --* Specify which source for language code
                  takes precedence for this audio track. When you choose Follow input
                  (FOLLOW_INPUT), the service uses the language code from the input track if it's
                  present. If there's no languge code on the input track, the service uses the code
                  that you specify in the setting Language code (languageCode or
                  customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service
                  uses the language code that you specify.

                  - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                    group of fields that hold the remixing value for each channel. Units are in dB.
                    Acceptable values are within the range from -60 (mute) through 6. A setting of 0
                    passes the input channel unchanged to the output channel (no attenuation or
                    amplification).

                      - **OutputChannels** *(list) --* List of output channels

                        - *(dict) --* OutputChannel mapping settings.

                          - **InputChannels** *(list) --* List of input channels

                            - *(integer) --*

                    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                    input that you want to use in your output. With remixing, you might combine or
                    split the data in these channels, so the number of channels in your final output
                    might be different.

                    - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                    after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                  - **StreamName** *(string) --* Specify a label for this output audio stream. For
                  example, "English", "Director commentary", or "track_2". For streaming outputs,
                  MediaConvert passes this information into destination manifests for display on the
                  end-viewer's player device. For outputs in other output groups, the service
                  ignores this setting.

              - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
              captions settings. For each output that has captions, include one instance of
              (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of captions
              settings.

                - *(dict) --* Description of Caption output

                  - **CaptionSelectorName** *(string) --* Specifies which "Caption
                  Selector":#inputs-caption_selector to use from each input when generating
                  captions. The name should be of the format "Caption Selector ", which denotes that
                  the Nth Caption Selector will be used from each input.

                  - **CustomLanguageCode** *(string) --* Specify the language for this captions
                  output track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information when automatically
                  selecting the font script for rendering the captions text. For all outputs, you
                  can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
                  any other code in the full RFC-5646 specification. Streaming outputs are those
                  that are in one of the following output groups: CMAF, DASH ISO, Apple HLS, or
                  Microsoft Smooth Streaming.

                  - **DestinationSettings** *(dict) --* Specific settings required by destination
                  type. Note that burnin_destination_settings are not available if the source of the
                  caption data is Embedded or Teletext.

                    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering burn-in captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **DestinationType** *(string) --* Specify the format for this set of captions
                    on this output. The default format is embedded without SCTE-20. Other options
                    are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                    web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                    (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec.
                    To create a non-compliant output where the embedded captions come first, choose
                    Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                      - **Alignment** *(string) --* If no explicit x_position or y_position is
                      provided, setting alignment to centered will place the captions at the bottom
                      center of the output. Similarly, setting a left alignment will align captions
                      to the bottom left of the output. If x and y positions are given in
                      conjunction with the alignment parameter, the font will be justified (either
                      left or centered) relative to those coordinates. This option is not valid for
                      source captions that are STL, 608/embedded or teletext. These source settings
                      are already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                      behind the captions. All burn-in and DVB-Sub font settings must match.

                      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                      rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                      equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                      settings must match.

                      - **FontColor** *(string) --* Specifies the color of the burned-in captions.
                      This option is not valid for source captions that are STL, 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                      captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                      settings must match.

                      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                      default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                      - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                      script code, if the LanguageCode is not sufficient for determining the script
                      type. Where LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC"
                      or leave unset. This is used to help determine the appropriate font for
                      rendering DVB-Sub captions.

                      - **FontSize** *(integer) --* A positive integer indicates the exact font size
                      in points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub
                      font settings must match.

                      - **OutlineColor** *(string) --* Specifies font outline color. This option is
                      not valid for source captions that are either 608/embedded or teletext. These
                      source settings are already pre-defined by the caption stream. All burn-in and
                      DVB-Sub font settings must match.

                      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                      option is not valid for source captions that are either 608/embedded or
                      teletext. These source settings are already pre-defined by the caption stream.
                      All burn-in and DVB-Sub font settings must match.

                      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                      captions. All burn-in and DVB-Sub font settings must match.

                      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                      opaque; 0 is transparent. Leaving this parameter blank is equivalent to
                      setting it to 0 (transparent). All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                      shadow relative to the captions in pixels. A value of -2 would result in a
                      shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings must
                      match.

                      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                      relative to the captions in pixels. A value of -2 would result in a shadow
                      offset 2 pixels above the text. All burn-in and DVB-Sub font settings must
                      match.

                      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                      standard or for hearing impaired. Choose hearing impaired if your subtitles
                      include audio descriptions and dialogue. Choose standard if your subtitles
                      include only dialogue.

                      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions
                      in Teletext or STL formats. Specify whether the spacing between letters in
                      your captions is set by the captions grid or varies depending on letter width.
                      Choose fixed grid to conform to the spacing specified in the captions file
                      more accurately. Choose proportional to make the text easier to read if the
                      captions are closed caption.

                      - **XPosition** *(integer) --* Specifies the horizontal position of the
                      caption relative to the left side of the output in pixels. A value of 10 would
                      result in the captions starting 10 pixels from the left of the output. If no
                      explicit x_position is provided, the horizontal caption position will be
                      determined by the alignment parameter. This option is not valid for source
                      captions that are STL, 608/embedded or teletext. These source settings are
                      already pre-defined by the caption stream. All burn-in and DVB-Sub font
                      settings must match.

                      - **YPosition** *(integer) --* Specifies the vertical position of the caption
                      relative to the top of the output in pixels. A value of 10 would result in the
                      captions starting 10 pixels from the top of the output. If no explicit
                      y_position is provided, the caption will be positioned towards the bottom of
                      the output. This option is not valid for source captions that are STL,
                      608/embedded or teletext. These source settings are already pre-defined by the
                      caption stream. All burn-in and DVB-Sub font settings must match.

                    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                    embedded/ancillary caption outputs, including 608/708 Channel destination
                    number.

                      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and your output captions are embedded in
                      the video stream. Specify a CC number for each captions channel in this
                      output. If you have two channels, choose CC numbers that aren't in the same
                      field. For example, choose 1 and 3. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless
                      your input captions are SCC format and you want both 608 and 708 captions
                      embedded in your output stream. Optionally, specify the 708 service number for
                      each output captions channel. Choose a different number for each channel. To
                      use this setting, also set Force 608 to 708 upconvert (Convert608To708) to
                      Upconvert (UPCONVERT) in your input captions selector settings. If you choose
                      to upconvert but don't specify a 708 service number, MediaConvert uses the
                      number that you specify for CC channel number (destination608ChannelNumber)
                      for the 708 service number. For more information, see
                      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                    outputs.

                      - **StylePassthrough** *(string) --* Keep this setting enabled to have
                      MediaConvert use the font style and position information from the captions
                      source in the output. This option is available only when your input captions
                      are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for simplified
                      output captions.

                    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make
                      sure that the captions and the video are synchronized in the output. Specify a
                      frame rate that matches the frame rate of the associated video. If the video
                      frame rate is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only
                      if the video has video_insertion=
                          true and drop_frame_timecode=true; otherwise,
                      choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                    output

                      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for
                      the destination captions for this output. This value must be a three-digit
                      hexadecimal string; strings ending in -FF are invalid. If you are passing
                      through the entire set of Teletext data, do not use this field.

                      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If
                      you don't specify a value here, the service sets the page type to the default
                      value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of
                      Teletext data, don't use this field. When you pass through a set of Teletext
                      pages, your output has the same page types as your input.

                        - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                        Table 94

                    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                    outputs, including Pass style information (TtmlStylePassthrough).

                      - **StylePassthrough** *(string) --* Pass through style and position
                      information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                      CFF-TT output or TTML output.

                  - **LanguageCode** *(string) --* Specify the language of this captions output
                  track. For most captions output formats, the encoder puts this language
                  information in the output captions metadata. If your output captions format is
                  DVB-Sub or Burn in, the encoder uses this language information to choose the font
                  language for rendering the captions text.

                  - **LanguageDescription** *(string) --* Specify a label for this set of output
                  captions. For example, "English", "Director commentary", or "track_2". For
                  streaming outputs, MediaConvert passes this information into destination manifests
                  for display on the end-viewer's player device. For outputs in other output groups,
                  the service ignores this setting.

              - **ContainerSettings** *(dict) --* Container specific settings.

                - **Container** *(string) --* Container for this output. Some containers require a
                container settings object. If not specified, the default object will be created.

                - **F4vSettings** *(dict) --* Settings for F4v container

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs
                in a File output group when the output's container (ContainerType) is MPEG-2
                Transport Stream (M2TS). In these assets, data is organized by the program map table
                (PMT). Each transport stream program contains subsets of data, including audio,
                video, and metadata. Each of these subsets of data has a numerical label called a
                packet identifier (PID). Each transport stream program corresponds to one
                MediaConvert output. The PMT lists the types of data in a program along with their
                PID. Downstream systems and players use the program map table to look up the PID for
                each type of data it accesses and then uses the PIDs to locate specific data within
                the asset.

                  - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                  models for Dolby Digital audio.

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                  elementary audio streams you include in this output. Specify multiple PIDs as a
                  JSON array. Default is the range 482-492.

                    - *(integer) --*

                  - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
                  bits per second. Setting to 0 lets the muxer automatically determine the
                  appropriate bitrate. Other common values are 3750000, 7500000, and 15000000.

                  - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                  interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                  this can lead to lower latency, but low-memory devices may not be able to play
                  back the stream without interruptions.

                  - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at
                  the specified table repetition interval.

                    - **NetworkId** *(integer) --* The numeric value placed in the Network
                    Information Table (NIT).

                    - **NetworkName** *(string) --* The network name text placed in the
                    network_name_descriptor inside the Network Information Table. Maximum length is
                    256 characters.

                    - **NitInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at
                  the specified table repetition interval.

                    - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                    output stream. "Follow input SDT" copies SDT information from input stream to
                    output stream. "Follow input SDT if present" copies SDT information from input
                    stream to output stream if SDT information is present in the input, otherwise it
                    will fall back on the user-defined values. Enter "SDT Manually" means user will
                    enter the SDT information. "No SDT" means output stream will not contain SDT
                    information.

                    - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                    - **ServiceName** *(string) --* The service name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                    - **ServiceProviderName** *(string) --* The service provider name placed in the
                    service_descriptor in the Service Description Table. Maximum length is 256
                    characters.

                  - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                  subtitle data included in this output. Specify multiple PIDs as a JSON array.
                  Default is the range 460-479.

                    - *(integer) --*

                  - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                  specified table repetition interval.

                    - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                    this table in the output transport stream.

                  - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
                  teletext data you include in this output. Default is 499.

                  - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio
                  EBP markers will be added to partitions 3 and 4. The interval between these
                  additional markers will be fixed, and will be slightly shorter than the video EBP
                  marker interval. When set to VIDEO_INTERVAL, these additional markers will not be
                  inserted. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They
                  can either be placed only on the video PID, or on both the video PID and all audio
                  PIDs. Only applicable when EBP segmentation markers are is selected
                  (segmentationMarkers is EBP or EBP_LEGACY).

                  - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in
                  the PES header.

                  - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless
                  you know that your audio EBP markers are incorrectly appearing before your video
                  EBP markers. To correct this problem, set this value to Force (FORCE).

                  - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                  used with EBP markers.

                  - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                  between Program Clock References (PCRs) inserted into the transport stream.

                  - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                  Points do not come within the specified time interval of each other by looking
                  ahead at input video. If another EBP is going to come in within the specified time
                  interval, the current EBP is not emitted, and the segment is "stretched" to the
                  next marker. The lookahead value does not add latency to the system. The Live
                  Event must be configured elsewhere to create sufficient latency to make the
                  lookahead accurate.

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                  packets to insert into the transport stream. This can be used if a downstream
                  encryption system requires periodic null packets.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This is effective only when the PCR PID is the same as the video or audio
                  elementary stream.

                  - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program
                  clock reference (PCR) in this output. If you do not specify a value, the service
                  will use the value for Video PID (VideoPid).

                  - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                  instances of the program map table (PMT) in the output transport stream.

                  - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program
                  map table (PMT) itself. Default is 480.

                  - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
                  private metadata stream. Default is 503.

                  - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify
                  the program number used in the program map table (PMT) for this output. Default is
                  1. Program numbers and program map tables are parts of MPEG-2 transport stream
                  containers, used for organizing data.

                  - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
                  stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
                  maximum bitrate, but the output will not be padded up to that bitrate.

                  - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                  markers in your HLS and transport stream outputs at the insertion points that you
                  specify in an ESAM XML document. Provide the document in the setting SCC XML
                  (sccXml).

                    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                    in the transport stream generated by ESAM.

                  - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
                  stream in the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None
                  (NONE). Also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml). Also enable ESAM SCTE-35 (include the property
                  scte35Esam).

                  - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                  segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
                  adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
                  private data bytes. psi_segstart inserts PAT and PMT tables at the start of
                  segments. ebp adds Encoder Boundary Point information to the adaptation field as
                  per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary
                  Point information to the adaptation field using a legacy proprietary format.

                  - **SegmentationStyle** *(string) --* The segmentation style parameter controls
                  how segmentation markers are inserted into the transport stream. With avails, it
                  is possible that segments may be truncated, which can influence where future
                  segmentation markers are inserted. When a segmentation style of "reset_cadence" is
                  selected and a segment is truncated due to an avail, we will reset the
                  segmentation cadence. This means the subsequent segment will have a duration of of
                  $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
                  selected and a segment is truncated due to an avail, we will not reset the
                  segmentation cadence. This means the subsequent segment will likely be truncated
                  as well. However, all segments after that will have a duration of
                  $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
                  rule.

                  - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                  segment. Required unless markers is set to _none_.

                  - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                  timed metadata in this output. Default is 502.

                  - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                  itself in the program map table for this output. Transport stream IDs and program
                  map tables are parts of MPEG-2 transport stream containers, used for organizing
                  data.

                  - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                  elementary video stream in the transport stream.

                - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                  - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for
                  each PES packet.

                  - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                  stream(s) in the transport stream. Multiple values are accepted, and can be
                  entered in ranges and/or by comma separation.

                    - *(integer) --*

                  - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                  tracking will be detected in the input audio and an equivalent ID3 tag will be
                  inserted in the output.

                  - **PatInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
                  Reference value is inserted for every Packetized Elementary Stream (PES) header.
                  This parameter is effective only when the PCR PID is the same as the video or
                  audio elementary stream.

                  - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
                  (PCR) in the transport stream. When no value is given, the encoder will assign the
                  same value as the Video PID.

                  - **PmtInterval** *(integer) --* The number of milliseconds between instances of
                  this table in the output transport stream.

                  - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                  (PMT) in the transport stream.

                  - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                  metadata stream in the transport stream.

                  - **ProgramNumber** *(integer) --* The value of the program number field in the
                  Program Map Table.

                  - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                  the transport stream.

                  - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                  Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
                  also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers
                  in this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE)
                  if you don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and
                  choose Ad markers (adMarkers) if you do want manifest conditioning. In both cases,
                  also provide the ESAM XML as a string in the setting Signal processing
                  notification XML (sccXml).

                  - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
                  specify whether the service inserts the ID3 timed metadata from the input in this
                  output.

                  - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                  metadata stream in the transport stream.

                  - **TransportStreamId** *(integer) --* The value of the transport stream ID field
                  in the Program Map Table.

                  - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                  stream in the transport stream.

                - **MovSettings** *(dict) --* Settings for MOV Container.

                  - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for
                  the video output settings.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                  streams into the QuickTime file using XDCAM fourcc codes. This increases
                  compatibility with Apple editors and players, but may decrease compatibility with
                  other players. Only applicable when the video codec is MPEG2.

                  - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                  padding

                  - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for
                  this setting.

                - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only
                AAC outputs with this container.

                  - **CslgAtom** *(string) --* When enabled, file composition times will start at
                  zero, composition times in the 'ctts' (composition time to sample) box for
                  B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                  will be included per 14496-1 amendment 1. This improves compatibility with Apple
                  players and tools.

                  - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the
                  moov box.

                  - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
                  relocated to the beginning of the archive as required for progressive downloading.
                  Otherwise it is placed normally at the end.

                  - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
                  file. Usually not necessary to specify.

                - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                  - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                  groups that include sidecar TTML or IMSC captions. You specify sidecar captions in
                  a separate output from your audio and video. Choose Raw (RAW) for captions in a
                  single XML file in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for
                  captions in XML format contained within fragmented MP4 files. This set of
                  fragmented MP4 files is separate from your video and audio fragmented MP4 files.

                  - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                  markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                  insertion points that you specify in an ESAM XML document. Provide the document in
                  the setting SCC XML (sccXml).

                  - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                  markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                  SCTE-35 markers that appear in your input to also appear in this output. Choose
                  None (NONE) if you don't want those SCTE-35 markers in this output.

              - **Extension** *(string) --* Use Extension (Extension) to specify the file extension
              for outputs in File output groups. If you do not specify a value, the service will use
              default extensions by container type as follows * MPEG-2 transport stream, m2ts *
              Quicktime, mov * MXF container, mxf * MPEG-4 container, mp4 * No Container, the
              service will use codec extensions (e.g. AAC, H265, H265, AC3)

              - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the service
              add a string to the end of each output filename. You specify the base filename as part
              of your destination URI. When you create multiple outputs in the same output group,
              Name modifier (NameModifier) is required. Name modifier also accepts format
              identifiers. For DASH ISO outputs, if you use the format identifiers $Number$ or
              $Time$ in one output, you must use them in the same way in all outputs of the output
              group.

              - **OutputSettings** *(dict) --* Specific settings for this type of output.

                - **HlsSettings** *(dict) --* Settings for HLS output groups

                  - **AudioGroupId** *(string) --* Specifies the group to which the audio Rendition
                  belongs.

                  - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                  outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                  container. Keep the default value Automatic (AUTOMATIC) to create an audio-only
                  file in a raw container. Regardless of the value that you specify here, if this
                  output has video, the service will place the output into an MPEG2-TS container.

                  - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                  with the video output stream. Input all the audio GROUP-IDs that are associated to
                  the video, separate by ','.

                  - **AudioTrackType** *(string) --* Four types of audio-only tracks are supported:
                  Audio-Only Variant Stream The client can play back this audio-only stream instead
                  of video in low-bandwidth scenarios. Represented as an EXT-X-STREAM-INF in the HLS
                  manifest. Alternate Audio, Auto Select, Default Alternate rendition that the
                  client should try to play back by default. Represented as an EXT-X-MEDIA in the
                  HLS manifest with DEFAULT=YES, AUTOSELECT=
                      YES Alternate Audio, Auto Select, Not
                  Default Alternate rendition that the client may try to play back by default.
                  Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=
                      NO, AUTOSELECT=YES
                  Alternate Audio, not Auto Select Alternate rendition that the client will not try
                  to play back by default. Represented as an EXT-X-MEDIA in the HLS manifest with
                  DEFAULT=NO, AUTOSELECT=NO

                  - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame Only
                  Manifest in addition to the HLS manifest

                  - **SegmentModifier** *(string) --* String concatenated to end of segment
                  filenames. Accepts "Format Identifiers":#format_identifier_parameters.

              - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
              transcoding settings. Provide the system or custom preset name. You can specify either
              Preset (Preset) or Container settings (ContainerSettings), but not both.

              - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
              encoding settings. The specific video settings depend on the video codec that you
              choose when you specify a value for Video codec (codec). Include one instance of
              (VideoDescription) per output.

                - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                service includes AFD values in the output video data and what those values are. *
                Choose None to remove all AFD values from this output. * Choose Fixed to ignore
                input AFD values and instead encode the value specified in the job. * Choose Auto to
                calculate output AFD values based on the input AFD scaler data.

                - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
                outputs. The service no longer accepts the value DISABLED for AntiAlias. If you
                specify that in your job, the service will ignore the setting.

                - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                (VideoDescription), contains the group of settings related to video encoding. The
                settings in this group vary depending on the value that you choose for Video codec
                (Codec). For each codec enum that you choose, define the corresponding settings
                object. The following lists the codec enum, settings object pairs. * H_264,
                H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings *
                FRAME_CAPTURE, FrameCaptureSettings

                  - **Codec** *(string) --* Specifies the video codec. This must be equal to one of
                  the enum values defined by the object VideoCodec.

                  - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                    - **FramerateDenominator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.n.jpg where n is the 0-based sequence number of each Capture.

                    - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                    frame of the output stream, then one frame every
                    framerateDenominator/framerateNumerator seconds. For example, settings of
                    framerateNumerator = 1 and framerateDenominator =
                         3 (a rate of 1/3 frame per
                    second) will capture the first frame, then 1 frame every 3s. Files will be named
                    as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
                    to 7 decimal places.

                    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                    files).

                    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                    quality.

                  - **H264Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value H_264.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with
                    your output video settings. If you aren't sure what level to specify, choose
                    Auto (AUTO).

                    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles
                    are only available with the AVC-I License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                    Main or High profile) or CAVLC.

                    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding
                    for interlaced outputs.

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job specification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* When you use the API for transcode
                    jobs that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateDenominator to specify the
                    denominator of this fraction. In this example, use 1001 for the value of
                    FramerateDenominator. When you use the console for transcode jobs that use frame
                    rate conversion, provide the value as a decimal number for Framerate. In this
                    example, specify 23.976.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type, as follows. - If the source is interlaced, the output will be interlaced
                    with the same polarity as the source (it will follow the source). The output
                    could therefore be a mix of "top field first" and "bottom field first". - If the
                    source is progressive, the output will be interlaced with "top field first" or
                    "bottom field first" polarity, depending on which of the Follow options you
                    chose.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.264 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even
                    if repeated.

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                  - **H265Settings** *(dict) --* Settings for H265 codec

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                    Function SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical
                    Transfer Function (EOTF).

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* H.265 Level.

                    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                    (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                    "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                    available with the HEVC 4:2:2 License.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame to reduce flicker or 'pop' on I-frames.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                    structures that have B frames > 1.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                    Choose Progressive (PROGRESSIVE) to create a progressive output, regardless of
                    the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field
                    First (BOTTOM_FIELD) to create an output that's interlaced with the same field
                    polarity throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow,
                    Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the
                    same field polarity as the source. If the source is interlaced, the output will
                    be interlaced with the same polarity as the source (it will follow the source).
                    The output could therefore be a mix of "top field first" and "bottom field
                    first". If the source is progressive, your output will be interlaced with "top
                    field first" or "bottom field first" polarity, depending on which of the Follow
                    options you chose. If you don't choose a value, the service will default to
                    Progressive (PROGRESSIVE).

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000. Required when Rate control mode is
                    QVBR.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use.
                    The encoder may use more than requested if using B-frames and/or interlaced
                    encoding.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                    high-quality singlepass, or high-quality multipass video encoding.

                    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                    encoding with the H.265 codec. Required when you set Rate control mode to QVBR.
                    Not valid when you set Rate control mode to a value other than QVBR, or when you
                    don't define Rate control mode.

                      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                      mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average
                      bitrate values suited to the complexity of your input video, the service
                      limits the average bitrate of the video part of this output to the value that
                      you choose. That is, the total size of the video element is less than or equal
                      to the value you set multiplied by the number of seconds of encoded output.

                      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                      mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                      target quality level for this output, from 1 to 10. Use higher numbers for
                      greater quality. Level 10 results in nearly lossless compression. The quality
                      level for most broadcast-quality transcodes is between 6 and 9.

                    - **RateControlMode** *(string) --* Use this setting to specify whether this
                    output has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined
                    variable bitrate (QVBR).

                    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                    Offset (SAO) filter strength. Adaptive mode dynamically selects best strength
                    based on content

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default. If this output uses QVBR, choose Transition
                    detection (TRANSITION_DETECTION) for further video quality improvement. For more
                    information about QVBR, see
                    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                    - **Slices** *(integer) --* Number of slices per picture. Must be less than or
                    equal to the number of macroblock rows for progressive pictures, and less than
                    or equal to half the number of macroblock rows for interlaced pictures.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                    Framerate (framerate) field is set to 29.970. This field works with the Streams
                    > Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the
                    Streams > Advanced > Interlaced Mode field (interlace_mode) to identify the scan
                    type for the output: Progressive, Interlaced, Hard Telecine or Soft Telecine. -
                    Hard: produces 29.97i output from 23.976 input. - Soft: produces 23.976; the
                    player converts this output to 29.97i.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                    encoded bitstream. Up to 3 layers are supported depending on GOP structure: I-
                    and P-frames form one layer, reference B-frames can form a second layer and
                    non-reference b-frames can form a third layer. Decoders can optionally decode
                    only the lower temporal layers to generate a lower frame rate output. For
                    example, given a bitstream with temporal IDs and with b-frames =
                         1 (i.e. IbPbPb
                    display order), a decoder could decode all the frames for full frame rate output
                    or only the I and P frames (lowest temporal layer) for a half frame rate output.

                    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                    vertical subdivision of the encoded pictures.

                    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                    bytes of an unregistered SEI message.

                    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL
                    units doesn't matter in your workflow, ignore this setting. Use this setting
                    only with CMAF or DASH outputs, or with standalone file outputs in an MPEG-4
                    container (MP4 outputs). Choose HVC1 to mark your output as HVC1. This makes
                    your output compliant with the following specification: ISO IECJTC1 SC29 N13798
                    Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
                    parameter set NAL units in the sample headers but not in the samples directly.
                    For MP4 outputs, when you choose HVC1, your output video might not work properly
                    with some downstream systems and video players. The service defaults to marking
                    your output as HEV1. For these outputs, the service writes parameter set NAL
                    units directly into the samples.

                  - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value MPEG2.

                    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                    intra-frame quantizers to vary to improve visual quality.

                    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                    Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                    rounded down to the nearest multiple of 1000.

                    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                    level for the video output.

                    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                    MPEG-2 profile for the video output.

                    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                    quality for high-motion content. This will cause the service to use fewer
                    B-frames (which infer information based on other frames) for high-motion
                    portions of the video and more B-frames for low-motion portions. The maximum
                    number of B-frames is limited by the value you provide for the setting B frames
                    between reference frames (numberBFramesBetweenReferenceFrames).

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                    fraction, e.g. 24000 / 1001 = 23.976 fps.

                    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                    applications, it is recommended that this be set to 1 so a decoder joining
                    mid-stream will receive an IDR frame as quickly as possible. Setting this value
                    to 0 will break output segmenting.

                    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds.
                    Must be greater than zero.

                    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified
                    in frames or seconds. If seconds the system will convert the GOP Size into a
                    frame count at run time.

                    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                    that should initially be filled (HRD buffer model).

                    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits.
                    For example, enter five megabits as 5000000.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **IntraDcPrecision** *(string) --* Use Intra DC precision
                    (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                    coefficients. If you choose the value auto, the service will automatically
                    select the precision based on the per-frame compression ratio.

                    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                    enter five megabits per second as 5000000.

                    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                    I-frames and I-frames inserted by Scene Change Detection. If a scene change
                    I-frame is within I-interval frames of a cadence I-frame, the GOP is shrunk
                    and/or stretched to the scene change I-frame. GOP stretch requires enabling
                    lookahead as well as setting I-interval. The normal cadence resumes for the next
                    GOP. This setting is only used when Scene Change Detect is enabled. Note:
                    Maximum GOP stretch = GOP size + Min-I-interval - 1

                    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                    between reference frames.

                    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want
                    the service to use the pixel aspect ratio from the input. Using the console, do
                    this by choosing Follow source for Pixel aspect ratio.

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **QualityTuningLevel** *(string) --* Use Quality tuning level
                    (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass
                    video encoding.

                    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode)
                    to specifiy whether the bitrate is variable (vbr) or constant (cbr).

                    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                    scene changes that the service automatically detects. This improves video
                    quality and is enabled by default.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                    reduce high-frequency content in the encoded image.

                    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on spatial variation of content complexity.

                    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                    356M-2001).

                    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                    frame based on temporal variation of content complexity.

                  - **ProresSettings** *(dict) --* Required when you set (Codec) under
                  (VideoDescription)>(CodecSettings) to the value PRORES.

                    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy
                    the type of Apple ProRes codec to use for this output.

                    - **FramerateControl** *(string) --* If you are using the console, use the
                    Framerate setting to specify the frame rate for this output. If you want to keep
                    the same frame rate as the input video, choose Follow source. If you want to do
                    frame rate conversion, choose a frame rate from the dropdown list or choose
                    Custom. The framerates shown in the dropdown list are decimal approximations of
                    fractions. If you choose Custom, specify your frame rate as a fraction. If you
                    are creating your transcoding job sepecification as a JSON file without the
                    console, use FramerateControl to specify which value the service uses for the
                    frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
                    service to use the frame rate from the input. Choose SPECIFIED if you want the
                    service to use the frame rate you specify in the settings FramerateNumerator and
                    FramerateDenominator.

                    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                    produces smoother motion during frame rate conversion.

                    - **FramerateDenominator** *(integer) --* Frame rate denominator.

                    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs
                    that use frame rate conversion, specify the frame rate as a fraction. For
                    example, 24000 / 1001 =
                         23.976 fps. Use FramerateNumerator to specify the
                    numerator of this fraction. In this example, use 24000 for the value of
                    FramerateNumerator.

                    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose
                    the scan line type for the output. * Top Field First (TOP_FIELD) and Bottom
                    Field First (BOTTOM_FIELD) produce interlaced output with the entire output
                    having the same field polarity (top or bottom first). * Follow, Default Top
                    (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same
                    field polarity as the source. Therefore, behavior depends on the input scan
                    type. - If the source is interlaced, the output will be interlaced with the same
                    polarity as the source (it will follow the source). The output could therefore
                    be a mix of "top field first" and "bottom field first". - If the source is
                    progressive, the output will be interlaced with "top field first" or "bottom
                    field first" polarity, depending on which of the Follow options you chose.

                    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                    determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE)
                    to use the pixel aspect ratio from the input. To specify a different pixel
                    aspect ratio: Using the console, choose it from the dropdown menu. Using the
                    API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator) and
                    (ParDenominator).

                    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                    24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                    Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                    produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce
                    23.976 output and leave converstion to the player.

                - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
                color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
                this output. If you don't specify a value, the service sets this to Insert by
                default.

                - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
                the service will include in the output video frame.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
                feature is enabled, the service will use drop-frame timecode on outputs. If it is
                not possible to use drop-frame timecode, the system will fall back to
                non-drop-frame. This setting is enabled by default when Timecode insertion
                (TimecodeInsertion) is enabled.

                - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
                Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the
                service will write on all frames of this video output.

                - **Height** *(integer) --* Use the Height (Height) setting to define the video
                resolution height for this output. Specify in pixels. If you don't provide a value
                here, the service will use the input height.

                - **Position** *(dict) --* Use Selection placement (position) to define the video
                area in your output frame. The area outside of the rectangle that you specify here
                is black.

                  - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                  numbers.

                  - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                  numbers.

                  - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                  edge of the video frame. Specify only even numbers.

                  - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                  edge of the video frame. Specify only even numbers.

                - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how
                the service changes the video itself in response to AFD values in the input. *
                Choose Respond to clip the input video frame according to the AFD value, input
                display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                include the input AFD values. Do not choose this when AfdSignaling is set to (NONE).
                A preferred implementation of this workflow is to set RespondToAfd to (NONE) and set
                AfdSignaling to (AUTO). * Choose None to remove all input AFD values from this
                output.

                - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                have a different aspect ratio from the input aspect ratio. Choose Stretch to output
                (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
                setting Default (DEFAULT) to have the service letterbox your video instead. This
                setting overrides any value that you specify for the setting Selection placement
                (position) in this output.

                - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                strength of anti-aliasing. This setting changes the width of the anti-alias filter
                kernel used for scaling. Sharpness only applies if your output resolution is
                different from your input resolution. 0 is the softest setting, 100 the sharpest,
                and 50 recommended for most content.

                - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                ProRes outputs. Only enable Timecode insertion when the input frame rate is
                identical to the output frame rate. To include timecodes in this output, set
                Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out,
                set it to DISABLED. Default is DISABLED. When the service inserts timecodes in an
                output, by default, it uses any embedded timecodes from the input. If none are
                present, the service will set the timecode for the first output frame to zero. To
                change this default behavior, adjust the settings under Timecode configuration
                (TimecodeConfig). In the console, these settings are located under Job > Job
                settings > Timecode configuration. Note - Timecode source under input settings
                (InputTimecodeSource) does not affect the timecodes that are inserted in the output.
                Source under Job settings > Timecode configuration (TimecodeSource) does.

                - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                Preprocessors (VideoPreprocessors). Enable the features at each output individually.
                These features are disabled by default.

                  - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                  feature if necessary. Enable or disable this feature for each output individually.
                  This setting is disabled by default.

                    - **Brightness** *(integer) --* Brightness level.

                    - **ColorSpaceConversion** *(string) --* Specify the color space you want for
                    this output. The service supports conversion between HDR formats, between SDR
                    formats, and from SDR to HDR. The service doesn't support conversion from HDR to
                    SDR. SDR to HDR conversion doesn't upgrade the dynamic range. The converted
                    video has an HDR format, but visually appears the same as an unconverted output.

                    - **Contrast** *(integer) --* Contrast level.

                    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR
                    10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                    metadata that you want signaled in the output. These values don't affect the
                    pixel values that are encoded in the video stream. They are intended to help the
                    downstream video player display content in a way that reflects the intentions of
                    the the content creator. When you set Color space conversion
                    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
                    must set values for Max frame average light level (maxFrameAverageLightLevel)
                    and Max content light level (maxContentLightLevel); these settings don't have a
                    default value. The default values for the other HDR 10 metadata settings are
                    defined by the P3D65 color space. For more information about MediaConvert HDR
                    jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                      samples in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of
                      any frame in the coded video sequence, in units of candelas per square meter.
                      This setting doesn't have a default value; you must specify a value that is
                      suitable for the content.

                      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance
                      in units of of 0.0001 candelas per square meter.

                      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance
                      in units of of 0.0001 candelas per square meter

                      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointX** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                      - **WhitePointY** *(integer) --* HDR Master Display Information must be
                      provided by a color grader, using color grading tools. Range is 0 to 50,000,
                      each increment represents 0.00002 in CIE1931 color coordinate. Note that this
                      setting is not for color correction.

                    - **Hue** *(integer) --* Hue in degrees.

                    - **Saturation** *(integer) --* Saturation level.

                  - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
                  motion and a clearer picture.

                    - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                    (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                    adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend
                    (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if
                    your source file includes a ticker, such as a scrolling headline at the bottom
                    of the frame.

                    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                    does not convert frames that are tagged in metadata as progressive. It will only
                    convert those that are tagged as some other type. - When set to
                    FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive - even
                    those that are already tagged as progressive. Turn Force mode on only if there
                    is a good chance that the metadata has tagged frames as progressive when they
                    are not progressive. Do not turn on otherwise; processing frames that are
                    already progressive into progressive will probably result in lower quality
                    video.

                    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                    service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                    interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                    progressive 23.976p. - Adaptive auto-detects and converts to progressive.

                  - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
                  compatible video output.

                    - **L6Metadata** *(dict) --* Use these settings when you set
                    DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values in
                    your input with new values.

                      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata
                      that corresponds to the brightest pixel in the entire stream. Measured in
                      nits.

                      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                      metadata that corresponds to the highest frame-average brightness in the
                      entire stream. Measured in nits.

                    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                    handle Dolby Vision MaxCLL and MaxFALL properies.

                    - **Profile** *(string) --* In the current MediaConvert implementation, the
                    Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must
                    contain Dolby Vision frame interleaved data.

                  - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature
                  to include a graphic overlay on your video. Enable or disable this feature for
                  each output individually. This setting is disabled by default.

                    - **InsertableImages** *(list) --* Specify the images that you want to overlay
                    on your video. The images must be PNG or TGA files.

                      - *(dict) --* Settings that specify how your still graphic overlay appears.

                        - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                        image to remain on the output video. This duration includes fade-in time but
                        not fade-out time.

                        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                        between the Start time that you specify for the image insertion and the time
                        that the image appears at full opacity. Full opacity is the level that you
                        specify for the opacity setting. If you don't specify a value for Fade-in,
                        the image will appear abruptly at the overlay start time.

                        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                        between the end of the time that you have specified for the image overlay
                        Duration and when the overlaid image has faded to total transparency. If you
                        don't specify a value for Fade-out, the image will disappear abruptly at the
                        end of the inserted image duration.

                        - **Height** *(integer) --* Specify the height of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        height, the service will crop your overlaid image to fit. To use the native
                        height of the image, keep this setting blank.

                        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                        location of the image that you want to overlay on the video. Use a PNG or
                        TGA file.

                        - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                        inserted image and the left edge of the video frame. Required for any image
                        overlay that you specify.

                        - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                        overlaid image and the top edge of the video frame. Required for any image
                        overlay that you specify.

                        - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                        Images with higher values for Layer appear on top of images with lower
                        values for Layer.

                        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of
                        the underlying video shows through the inserted image. 0 is transparent and
                        100 is fully opaque. Default is 50.

                        - **StartTime** *(string) --* Specify the timecode of the frame that you
                        want the overlay to first appear on. This must be in timecode (HH:MM:SS:FF
                        or HH:MM:SS;FF) format. Remember to take into account your timecode source
                        settings.

                        - **Width** *(integer) --* Specify the width of the inserted image in
                        pixels. If you specify a value that's larger than the video resolution
                        width, the service will crop your overlaid image to fit. To use the native
                        width of the image, keep this setting blank.

                  - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
                  remove noise from your video output if necessary. Enable or disable this feature
                  for each output individually. This setting is disabled by default.

                    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                    select one of the following spatial image filtering functions. To use this
                    setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                    preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos, and
                    Sharpen (sharpest) do convolution filtering. * Conserve does min/max noise
                    reduction. * Spatial does frequency-domain filtering based on JND principles. *
                    Temporal optimizes video quality for complex motion.

                    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                    spatial filter.

                      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                      reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                      maximum strength.

                      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                      (higher speed), with 0 being the nominal value.

                      - **Strength** *(integer) --* Relative strength of noise reducing filter.
                      Higher values produce stronger filtering.

                    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                    temporal filter.

                      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                      complex motion. Higher values produce stronger temporal filtering. This
                      filters highly complex scenes more aggressively and creates better VQ for low
                      bitrate outputs.

                      - **Speed** *(integer) --* The speed of the filter (higher number is faster).
                      Low setting reduces bit rate at the cost of transcode time, high setting
                      improves transcode time at the cost of bit rate.

                      - **Strength** *(integer) --* Specify the strength of the noise reducing
                      filter on this output. Higher values produce stronger filtering. We recommend
                      the following value ranges, depending on the result that you want: * 0-2 for
                      complexity reduction with minimal sharpness loss * 2-8 for complexity
                      reduction with image preservation * 8-16 for a high level of complexity
                      reduction

                  - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                  output timecode and specified prefix into the output.

                    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of
                    any burned-in timecode. Valid values are 10, 16, 32, 48.

                    - **Position** *(string) --* Use Position (Position) under under Timecode
                    burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                    output video.

                    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before
                    any burned-in timecode. For example, a prefix of "EZ-" will result in the
                    timecode "EZ-00:00:00:00". Provide either the characters themselves or the ASCII
                    code equivalents. The supported range of characters is 0x20 through 0x7e. This
                    includes letters, numbers, and all special characters represented on a standard
                    English keyboard.

                - **Width** *(integer) --* Use Width (Width) to define the video resolution width,
                in pixels, for this output. If you don't provide a value here, the service will use
                the input width.

      - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
      information from inputs.

        - **Anchor** *(string) --* If you use an editing platform that relies on an anchor timecode,
        use Anchor Timecode (Anchor) to specify a timecode that will match the input video frame to
        the output video frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or
        (HH:MM:SS;FF). This setting ignores frame rate conversion. System behavior for Anchor
        Timecode varies depending on your setting for Source (TimecodeSource). * If Source
        (TimecodeSource) is set to Specified Start (SPECIFIEDSTART), the first input frame is the
        specified value in Start Timecode (Start). Anchor Timecode (Anchor) and Start Timecode
        (Start) are used calculate output timecode. * If Source (TimecodeSource) is set to Start at
        0 (ZEROBASED) the first frame is 00:00:00:00. * If Source (TimecodeSource) is set to
        Embedded (EMBEDDED), the first frame is the timecode value on the first input frame of the
        input.

        - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
        within this job. To make sure that your video, audio, captions, and markers are synchronized
        and that time-based features, such as image inserter, work correctly, choose the Timecode
        source option that matches your assets. All timecodes are in a 24-hour format with frame
        number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode that is in the input video.
        If no embedded timecode is in the source, the service will use Start at 0 (ZEROBASED)
        instead. * Start at 0 (ZEROBASED) - Set the timecode of the initial frame to 00:00:00:00. *
        Specified Start (SPECIFIEDSTART) - Set the timecode of the initial frame to a value other
        than zero. You use Start timecode (Start) to provide this value.

        - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified start
        (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the initial frame.
        Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

        - **TimestampOffset** *(string) --* Only applies to outputs that support program-date-time
        stamp. Use Timestamp offset (TimestampOffset) to overwrite the timecode date without
        affecting the time and frame number. Provide the new date as a string in the format
        "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert program-date-time
        (InsertProgramDateTime) in the output settings. For example, if the date part of your
        timecodes is 2002-1-25 and you want to change it to one year later, set Timestamp offset
        (TimestampOffset) to 2003-1-25.

      - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
      (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you must
      enable it here, enable it in each output container, and specify tags and timecodes in ID3
      insertion (Id3Insertion) objects.

        - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion instances.

          - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3) to
          specify the base 64 encoded string and use Timecode (TimeCode) to specify the time when
          the tag should be inserted. To insert multiple ID3 tags in your output, create multiple
          instances of ID3 insertion (Id3Insertion).

            - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
            format.

            - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or HH:MM:SS;FF
            format.

    - **SimulateReservedQueue** *(string) --* Enable this setting when you run a test job to
    estimate how many reserved transcoding slots (RTS) you need. When this is enabled, MediaConvert
    runs your job from an on-demand queue with similar performance to what you will see with one RTS
    in a reserved queue. This setting is disabled by default.

    - **Status** *(string) --* A job's status can be SUBMITTED, PROGRESSING, COMPLETE, CANCELED, or
    ERROR.

    - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
    events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
    MediaConvert sends an update at this interval from the time the service begins processing your
    job to the time it completes the transcode or encounters an error.

    - **Timing** *(dict) --* Information about when jobs are submitted, started, and finished is
    specified in Unix epoch format in seconds.

      - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
      finished

      - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the job
      began.

      - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the job.

    - **UserMetadata** *(dict) --* User-defined metadata that you want to associate with an
    MediaConvert job. You specify metadata in key/value pairs.

      - *(string) --*

        - *(string) --*
    """


_ListJobsPaginateResponseTypeDef = TypedDict(
    "_ListJobsPaginateResponseTypeDef",
    {"Jobs": List[ListJobsPaginateResponseJobsTypeDef]},
    total=False,
)


class ListJobsPaginateResponseTypeDef(_ListJobsPaginateResponseTypeDef):
    """
    Type definition for `ListJobsPaginate` `Response`

    - **Jobs** *(list) --* List of jobs

      - *(dict) --* Each job converts an input file into an output file or files. For more
      information, see the User Guide at
      http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

        - **AccelerationSettings** *(dict) --* Accelerated transcoding can significantly speed up
        jobs with long, visually complex content.

          - **Mode** *(string) --* Specify the conditions when the service will run your job with
          accelerated transcoding.

        - **AccelerationStatus** *(string) --* Describes whether the current job is running with
        accelerated transcoding. For jobs that have Acceleration (AccelerationMode) set to DISABLED,
        AccelerationStatus is always NOT_APPLICABLE. For jobs that have Acceleration
        (AccelerationMode) set to ENABLED or PREFERRED, AccelerationStatus is one of the other
        states. AccelerationStatus is IN_PROGRESS initially, while the service determines whether
        the input files and job settings are compatible with accelerated transcoding. If they are,
        AcclerationStatus is ACCELERATED. If your input files and job settings aren't compatible
        with accelerated transcoding, the service either fails your job or runs it without
        accelerated transcoding, depending on how you set Acceleration (AccelerationMode). When the
        service runs your job without accelerated transcoding, AccelerationStatus is
        NOT_ACCELERATED.

        - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

        - **BillingTagsSource** *(string) --* Optional. Choose a tag type that AWS Billing and Cost
        Management will use to sort your AWS Elemental MediaConvert costs on any billing report that
        you set up. Any transcoding outputs that don't have an associated tag will appear in your
        billing report unsorted. If you don't choose a valid value for this field, your job outputs
        will appear on the billing report unsorted.

        - **CreatedAt** *(datetime) --* The time, in Unix epoch format in seconds, when the job got
        created.

        - **CurrentPhase** *(string) --* A job's phase can be PROBING, TRANSCODING OR UPLOADING

        - **ErrorCode** *(integer) --* Error code for the job

        - **ErrorMessage** *(string) --* Error message of Job

        - **Id** *(string) --* A portion of the job's ARN, unique within your AWS Elemental
        MediaConvert resources

        - **JobPercentComplete** *(integer) --* An estimate of how far your job has progressed. This
        estimate is shown as a percentage of the total time from when your job leaves its queue to
        when your output files appear in your output Amazon S3 bucket. AWS Elemental MediaConvert
        provides jobPercentComplete in CloudWatch STATUS_UPDATE events and in the response to GetJob
        and ListJobs requests. The jobPercentComplete estimate is reliable for the following input
        containers: Quicktime, Transport Stream, MP4, and MXF. For some jobs, the service can't
        provide information about job progress. In those cases, jobPercentComplete returns a null
        value.

        - **JobTemplate** *(string) --* The job template that the job is created from, if it is
        created from a job template.

        - **Messages** *(dict) --* Provides messages from the service about jobs that you have
        already successfully submitted.

          - **Info** *(list) --* List of messages that are informational only and don't indicate a
          problem with your job.

            - *(string) --*

          - **Warning** *(list) --* List of messages that warn about conditions that might cause
          your job not to run or to fail.

            - *(string) --*

        - **OutputGroupDetails** *(list) --* List of output group details

          - *(dict) --* Contains details about the output groups specified in the job settings.

            - **OutputDetails** *(list) --* Details about the output

              - *(dict) --* Details regarding output

                - **DurationInMs** *(integer) --* Duration in milliseconds

                - **VideoDetails** *(dict) --* Contains details about the output's video stream

                  - **HeightInPx** *(integer) --* Height in pixels for the output

                  - **WidthInPx** *(integer) --* Width in pixels for the output

        - **Priority** *(integer) --* Relative priority on the job.

        - **Queue** *(string) --* Optional. When you create a job, you can specify a queue to send
        it to. If you don't specify, the job will go to the default queue. For more about queues,
        see the User Guide topic at http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

        - **RetryCount** *(integer) --* The number of times that the service automatically attempted
        to process your job after encountering an error.

        - **Role** *(string) --* The IAM role you use for creating this job. For details about
        permissions, see the User Guide topic at the User Guide at
        http://docs.aws.amazon.com/mediaconvert/latest/ug/iam-role.html

        - **Settings** *(dict) --* JobSettings contains all the transcode settings for a job.

          - **AdAvailOffset** *(integer) --* When specified, this offset (in milliseconds) is added
          to the input Ad Avail PTS time.

          - **AvailBlanking** *(dict) --* Settings for ad avail blanking. Video can be blanked or
          overlaid with an image, and audio muted during SCTE-35 triggered ad avails.

            - **AvailBlankingImage** *(string) --* Blanking image to be used. Leave empty for solid
            black. Only bmp and png images are supported.

          - **Esam** *(dict) --* Settings for Event Signaling And Messaging (ESAM).

            - **ManifestConfirmConditionNotification** *(dict) --* Specifies an ESAM
            ManifestConfirmConditionNotification XML as per OC-SP-ESAM-API-I03-131025. The
            transcoder uses the manifest conditioning instructions that you provide in the setting
            MCC XML (mccXml).

              - **MccXml** *(string) --* Provide your ESAM ManifestConfirmConditionNotification XML
              document inside your JSON job settings. Form the XML document as per
              OC-SP-ESAM-API-I03-131025. The transcoder will use the Manifest Conditioning
              instructions in the message that you supply.

            - **ResponseSignalPreroll** *(integer) --* Specifies the stream distance, in
            milliseconds, between the SCTE 35 messages that the transcoder places and the splice
            points that they refer to. If the time between the start of the asset and the SCTE-35
            message is less than this value, then the transcoder places the SCTE-35 marker at the
            beginning of the stream.

            - **SignalProcessingNotification** *(dict) --* Specifies an ESAM
            SignalProcessingNotification XML as per OC-SP-ESAM-API-I03-131025. The transcoder uses
            the signal processing instructions that you provide in the setting SCC XML (sccXml).

              - **SccXml** *(string) --* Provide your ESAM SignalProcessingNotification XML document
              inside your JSON job settings. Form the XML document as per OC-SP-ESAM-API-I03-131025.
              The transcoder will use the signal processing instructions in the message that you
              supply. Provide your ESAM SignalProcessingNotification XML document inside your JSON
              job settings. For your MPEG2-TS file outputs, if you want the service to place SCTE-35
              markers at the insertion points you specify in the XML document, you must also enable
              SCTE-35 ESAM (scte35Esam). Note that you can either specify an ESAM XML document or
              enable SCTE-35 passthrough. You can't do both.

          - **Inputs** *(list) --* Use Inputs (inputs) to define source file used in the transcode
          job. There can be multiple inputs add in a job. These inputs will be concantenated
          together to create the output.

            - *(dict) --* Specifies media input

              - **AudioSelectorGroups** *(dict) --* Specifies set of audio selectors within an input
              to combine. An input may have multiple audio selector groups. See "Audio Selector
              Group":#inputs-audio_selector_group for more information.

                - *(string) --*

                  - *(dict) --* Group of Audio Selectors

                    - **AudioSelectorNames** *(list) --* Name of an Audio Selector within the same
                    input to include in the group. Audio selector names are standardized, based on
                    their order within the input (e.g., "Audio Selector 1"). The audio selector name
                    parameter can be repeated to add any number of audio selectors to the group.

                      - *(string) --*

              - **AudioSelectors** *(dict) --* Use Audio selectors (AudioSelectors) to specify a
              track or set of tracks from the input that you will use in your outputs. You can use
              mutiple Audio selectors per input.

                - *(string) --*

                  - *(dict) --* Selector for Audio

                    - **CustomLanguageCode** *(string) --* Selects a specific language code from
                    within an audio source, using the ISO 639-2 or ISO 639-3 three-letter language
                    code

                    - **DefaultSelection** *(string) --* Enable this setting on one audio selector
                    to set it as the default for the job. The service uses this default for outputs
                    where it can't find the specified input audio. If you don't set a default, those
                    outputs have no audio.

                    - **ExternalAudioFileInput** *(string) --* Specifies audio data from an external
                    file source.

                    - **LanguageCode** *(string) --* Selects a specific language code from within an
                    audio source.

                    - **Offset** *(integer) --* Specifies a time delta in milliseconds to offset the
                    audio from the input video.

                    - **Pids** *(list) --* Selects a specific PID from within an audio source (e.g.
                    257 selects PID 0x101).

                      - *(integer) --*

                    - **ProgramSelection** *(integer) --* Use this setting for input streams that
                    contain Dolby E, to have the service extract specific program data from the
                    track. To select multiple programs, create multiple selectors with the same
                    Track and different Program numbers. In the console, this setting is visible
                    when you set Selector type to Track. Choose the program number from the dropdown
                    list. If you are sending a JSON file, provide the program ID, which is part of
                    the audio metadata. If your input file has incorrect metadata, you can choose
                    All channels instead of a program number to have the service ignore the program
                    IDs and include all the programs in the track.

                    - **RemixSettings** *(dict) --* Use these settings to reorder the audio channels
                    of one input to match those of another input. This allows you to combine the two
                    files into a single output, one after the other.

                      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the
                      group of fields that hold the remixing value for each channel. Units are in
                      dB. Acceptable values are within the range from -60 (mute) through 6. A
                      setting of 0 passes the input channel unchanged to the output channel (no
                      attenuation or amplification).

                        - **OutputChannels** *(list) --* List of output channels

                          - *(dict) --* OutputChannel mapping settings.

                            - **InputChannels** *(list) --* List of input channels

                              - *(integer) --*

                      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your
                      input that you want to use in your output. With remixing, you might combine or
                      split the data in these channels, so the number of channels in your final
                      output might be different.

                      - **ChannelsOut** *(integer) --* Specify the number of channels in this output
                      after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

                    - **SelectorType** *(string) --* Specifies the type of the audio selector.

                    - **Tracks** *(list) --* Identify a track from the input audio to include in
                    this selector by entering the track index number. To include several tracks in a
                    single audio selector, specify multiple tracks as follows. Using the console,
                    enter a comma-separated list. For examle, type "1,2,3" to include tracks 1
                    through 3. Specifying directly in your JSON job file, provide the track numbers
                    in an array. For example, "tracks": [1,2,3].

                      - *(integer) --*

              - **CaptionSelectors** *(dict) --* Use Captions selectors (CaptionSelectors) to
              specify the captions data from the input that you will use in your outputs. You can
              use mutiple captions selectors per input.

                - *(string) --*

                  - *(dict) --* Set up captions in your outputs by first selecting them from your
                  input here.

                    - **CustomLanguageCode** *(string) --* The specific language to extract from
                    source, using the ISO 639-2 or ISO 639-3 three-letter language code. If input is
                    SCTE-27, complete this field and/or PID to select the caption language to
                    extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT, complete this
                    field and/or PID to select the caption language to extract. If input is DVB-Sub
                    that is being passed through, omit this field (and PID field); there is no way
                    to extract a specific language with pass-through captions.

                    - **LanguageCode** *(string) --* The specific language to extract from source.
                    If input is SCTE-27, complete this field and/or PID to select the caption
                    language to extract. If input is DVB-Sub and output is Burn-in or SMPTE-TT,
                    complete this field and/or PID to select the caption language to extract. If
                    input is DVB-Sub that is being passed through, omit this field (and PID field);
                    there is no way to extract a specific language with pass-through captions.

                    - **SourceSettings** *(dict) --* If your input captions are SCC, TTML, STL, SMI,
                    SRT, or IMSC in an xml file, specify the URI of the input captions source file.
                    If your input captions are IMSC in an IMF package, use TrackSourceSettings
                    instead of FileSoureSettings.

                      - **AncillarySourceSettings** *(dict) --* Settings for ancillary captions
                      source.

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **SourceAncillaryChannelNumber** *(integer) --* Specifies the 608 channel
                        number in the ancillary data track from which to extract captions. Unused
                        for passthrough.

                        - **TerminateCaptions** *(string) --* By default, the service terminates any
                        unterminated captions at the end of each input. If you want the caption to
                        continue onto your next input, disable this setting.

                      - **DvbSubSourceSettings** *(dict) --* DVB Sub Source Settings

                        - **Pid** *(integer) --* When using DVB-Sub with Burn-In or SMPTE-TT, use
                        this PID for the source content. Unused for DVB-Sub passthrough. All DVB-Sub
                        content is passed through, regardless of selectors.

                      - **EmbeddedSourceSettings** *(dict) --* Settings for embedded captions Source

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **Source608ChannelNumber** *(integer) --* Specifies the 608/708 channel
                        number within the video track from which to extract captions. Unused for
                        passthrough.

                        - **Source608TrackNumber** *(integer) --* Specifies the video track index
                        used for extracting captions. The system only supports one input video
                        track, so this should always be set to '1'.

                        - **TerminateCaptions** *(string) --* By default, the service terminates any
                        unterminated captions at the end of each input. If you want the caption to
                        continue onto your next input, disable this setting.

                      - **FileSourceSettings** *(dict) --* If your input captions are SCC, SMI, SRT,
                      STL, TTML, or IMSC 1.1 in an xml file, specify the URI of the input caption
                      source file. If your caption source is IMSC in an IMF package, use
                      TrackSourceSettings instead of FileSoureSettings.

                        - **Convert608To708** *(string) --* Specify whether this set of input
                        captions appears in your outputs in both 608 and 708 format. If you choose
                        Upconvert (UPCONVERT), MediaConvert includes the captions data in two ways:
                        it passes the 608 data through using the 608 compatibility bytes fields of
                        the 708 wrapper, and it also translates the 608 data into 708.

                        - **SourceFile** *(string) --* External caption file used for loading
                        captions. Accepted file extensions are 'scc', 'ttml', 'dfxp', 'stl', 'srt',
                        'xml', and 'smi'.

                        - **TimeDelta** *(integer) --* Specifies a time delta in seconds to offset
                        the captions from the source file.

                      - **SourceType** *(string) --* Use Source (SourceType) to identify the format
                      of your input captions. The service cannot auto-detect caption format.

                      - **TeletextSourceSettings** *(dict) --* Settings specific to Teletext caption
                      sources, including Page number.

                        - **PageNumber** *(string) --* Use Page Number (PageNumber) to specify the
                        three-digit hexadecimal page number that will be used for Teletext captions.
                        Do not use this setting if you are passing through teletext from the input
                        source to output.

                      - **TrackSourceSettings** *(dict) --* Settings specific to caption sources
                      that are specified by track number. Currently, this is only IMSC captions in
                      an IMF package. If your caption source is IMSC 1.1 in a separate xml file, use
                      FileSourceSettings instead of TrackSourceSettings.

                        - **TrackNumber** *(integer) --* Use this setting to select a single
                        captions track from a source. Track numbers correspond to the order in the
                        captions source file. For IMF sources, track numbering is based on the order
                        that the captions appear in the CPL. For example, use 1 to select the
                        captions asset that is listed first in the CPL. To include more than one
                        captions track in your job outputs, create multiple input captions
                        selectors. Specify one track per selector.

              - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that
              the service will include in the output video frame. If you specify a value here, it
              will override any value that you specify in the output setting Cropping selection
              (crop).

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **DeblockFilter** *(string) --* Enable Deblock (InputDeblockFilter) to produce
              smoother motion in the output. Default is disabled. Only manaully controllable for
              MPEG2 and uncompressed video inputs.

              - **DecryptionSettings** *(dict) --* Settings for decrypting any input files that you
              encrypt before you upload them to Amazon S3. MediaConvert can decrypt files only when
              you use AWS Key Management Service (KMS) to encrypt the data key that you use to
              encrypt your content.

                - **DecryptionMode** *(string) --* Specify the encryption mode that you used to
                encrypt your input files.

                - **EncryptedDecryptionKey** *(string) --* Warning! Don't provide your encryption
                key in plaintext. Your job settings could be intercepted, making your encrypted
                content vulnerable. Specify the encrypted version of the data key that you used to
                encrypt your content. The data key must be encrypted by AWS Key Management Service
                (KMS). The key can be 128, 192, or 256 bits.

                - **InitializationVector** *(string) --* Specify the initialization vector that you
                used when you encrypted your content before uploading it to Amazon S3. You can use a
                16-byte initialization vector with any encryption mode. Or, you can use a 12-byte
                initialization vector with GCM or CTR. MediaConvert accepts only initialization
                vectors that are base64-encoded.

                - **KmsKeyRegion** *(string) --* Specify the AWS Region for AWS Key Management
                Service (KMS) that you used to encrypt your data key, if that Region is different
                from the one you are using for AWS Elemental MediaConvert.

              - **DenoiseFilter** *(string) --* Enable Denoise (InputDenoiseFilter) to filter noise
              from the input. Default is disabled. Only applicable to MPEG2, H.264, H.265, and
              uncompressed video inputs.

              - **FileInput** *(string) --* Specify the source file for your transcoding job. You
              can use multiple inputs in a single job. The service concatenates these inputs, in the
              order that you specify them in the job, to create the outputs. If your input format is
              IMF, specify your input by providing the path to your CPL. For example,
              "s3://bucket/vf/cpl.xml". If the CPL is in an incomplete IMP, make sure to use
              *Supplemental IMPs* (SupplementalImps) to specify any supplemental IMPs that contain
              assets referenced by the CPL.

              - **FilterEnable** *(string) --* Use Filter enable (InputFilterEnable) to specify how
              the transcoding service applies the denoise and deblock filters. You must also enable
              the filters separately, with Denoise (InputDenoiseFilter) and Deblock
              (InputDeblockFilter). * Auto - The transcoding service determines whether to apply
              filtering, depending on input type and quality. * Disable - The input is not filtered.
              This is true even if you use the API to enable them in (InputDeblockFilter) and
              (InputDeblockFilter). * Force - The in put is filtered regardless of input type.

              - **FilterStrength** *(integer) --* Use Filter strength (FilterStrength) to adjust the
              magnitude the input filter settings (Deblock and Denoise). The range is -5 to 5.
              Default is 0.

              - **ImageInserter** *(dict) --* Enable the image inserter feature to include a graphic
              overlay on your video. Enable or disable this feature for each input individually.
              This setting is disabled by default.

                - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                your video. The images must be PNG or TGA files.

                  - *(dict) --* Settings that specify how your still graphic overlay appears.

                    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                    to remain on the output video. This duration includes fade-in time but not
                    fade-out time.

                    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                    the Start time that you specify for the image insertion and the time that the
                    image appears at full opacity. Full opacity is the level that you specify for
                    the opacity setting. If you don't specify a value for Fade-in, the image will
                    appear abruptly at the overlay start time.

                    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                    between the end of the time that you have specified for the image overlay
                    Duration and when the overlaid image has faded to total transparency. If you
                    don't specify a value for Fade-out, the image will disappear abruptly at the end
                    of the inserted image duration.

                    - **Height** *(integer) --* Specify the height of the inserted image in pixels.
                    If you specify a value that's larger than the video resolution height, the
                    service will crop your overlaid image to fit. To use the native height of the
                    image, keep this setting blank.

                    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                    location of the image that you want to overlay on the video. Use a PNG or TGA
                    file.

                    - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                    inserted image and the left edge of the video frame. Required for any image
                    overlay that you specify.

                    - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                    overlaid image and the top edge of the video frame. Required for any image
                    overlay that you specify.

                    - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                    Images with higher values for Layer appear on top of images with lower values
                    for Layer.

                    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                    underlying video shows through the inserted image. 0 is transparent and 100 is
                    fully opaque. Default is 50.

                    - **StartTime** *(string) --* Specify the timecode of the frame that you want
                    the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                    HH:MM:SS;FF) format. Remember to take into account your timecode source
                    settings.

                    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                    you specify a value that's larger than the video resolution width, the service
                    will crop your overlaid image to fit. To use the native width of the image, keep
                    this setting blank.

              - **InputClippings** *(list) --* (InputClippings) contains sets of start and end times
              that together specify a portion of the input to be used in the outputs. If you provide
              only a start time, the clip will be the entire input from that point to the end. If
              you provide only an end time, it will be the entire input up to that point. When you
              specify more than one input clip, the transcoding service creates the job outputs by
              stringing the clips together in the order you specify them.

                - *(dict) --* To transcode only portions of your input (clips), include one Input
                clipping (one instance of InputClipping in the JSON job file) for each input clip.
                All input clips you specify will be included in every output of the job.

                  - **EndTimecode** *(string) --* Set End timecode (EndTimecode) to the end of the
                  portion of the input you are clipping. The frame corresponding to the End timecode
                  value is included in the clip. Start timecode or End timecode may be left blank,
                  but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where HH is the hour, MM
                  is the minute, SS is the second, and FF is the frame number. When choosing this
                  value, take into account your setting for timecode source under input settings
                  (InputTimecodeSource). For example, if you have embedded timecodes that start at
                  01:00:00:00 and you want your clip to end six minutes into the video, use
                  01:06:00:00.

                  - **StartTimecode** *(string) --* Set Start timecode (StartTimecode) to the
                  beginning of the portion of the input you are clipping. The frame corresponding to
                  the Start timecode value is included in the clip. Start timecode or End timecode
                  may be left blank, but not both. Use the format HH:MM:SS:FF or HH:MM:SS;FF, where
                  HH is the hour, MM is the minute, SS is the second, and FF is the frame number.
                  When choosing this value, take into account your setting for Input timecode
                  source. For example, if you have embedded timecodes that start at 01:00:00:00 and
                  you want your clip to begin five minutes into the video, use 01:05:00:00.

              - **Position** *(dict) --* Use Selection placement (position) to define the video area
              in your output frame. The area outside of the rectangle that you specify here is
              black. If you specify a value here, it will override any value that you specify in the
              output setting Selection placement (position). If you specify a value here, this will
              override any AFD values in your input, even if you set Respond to AFD (RespondToAfd)
              to Respond (RESPOND). If you specify a value here, this will ignore anything that you
              specify for the setting Scaling Behavior (scalingBehavior).

                - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                numbers.

                - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

                - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
                edge of the video frame. Specify only even numbers.

                - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top
                edge of the video frame. Specify only even numbers.

              - **ProgramNumber** *(integer) --* Use Program (programNumber) to select a specific
              program from within a multi-program transport stream. Note that Quad 4K is not
              currently supported. Default is the first program within the transport stream. If the
              program you specify doesn't exist, the transcoding service will use this default.

              - **PsiControl** *(string) --* Set PSI control (InputPsiControl) for transport stream
              inputs to specify which data the demux process to scans. * Ignore PSI - Scan all PIDs
              for audio and video. * Use PSI - Scan only PSI data.

              - **SupplementalImps** *(list) --* Provide a list of any necessary supplemental IMPs.
              You need supplemental IMPs if the CPL that you're using for your input is in an
              incomplete IMP. Specify either the supplemental IMP directories with a trailing slash
              or the ASSETMAP.xml files. For example ["s3://bucket/ov/",
              "s3://bucket/vf2/ASSETMAP.xml"]. You don't need to specify the IMP that contains your
              input CPL, because the service automatically detects it.

                - *(string) --*

              - **TimecodeSource** *(string) --* Use this Timecode source setting, located under the
              input settings (InputTimecodeSource), to specify how the service counts input video
              frames. This input frame count affects only the behavior of features that apply to a
              single input at a time, such as input clipping and synchronizing some captions
              formats. Choose Embedded (EMBEDDED) to use the timecodes in your input video. Choose
              Start at zero (ZEROBASED) to start the first frame at zero. Choose Specified start
              (SPECIFIEDSTART) to start the first frame at the timecode that you specify in the
              setting Start timecode (timecodeStart). If you don't specify a value for Timecode
              source, the service will use Embedded by default. For more information about
              timecodes, see https://docs.aws.amazon.com/console/mediaconvert/timecode.

              - **TimecodeStart** *(string) --* Specify the timecode that you want the service to
              use for this input's initial frame. To use this setting, you must set the Timecode
              source setting, located under the input settings (InputTimecodeSource), to Specified
              start (SPECIFIEDSTART). For more information about timecodes, see
              https://docs.aws.amazon.com/console/mediaconvert/timecode.

              - **VideoSelector** *(dict) --* Selector for video.

                - **AlphaBehavior** *(string) --* Ignore this setting unless this input is a
                QuickTime animation. Specify which part of this input MediaConvert uses for your
                outputs. Leave this setting set to DISCARD in order to delete the alpha channel and
                preserve the video. Use REMAP_TO_LUMA for this setting to delete the video and map
                the alpha channel to the luma channel of your outputs.

                - **ColorSpace** *(string) --* If your input video has accurate color space
                metadata, or if you don't know about color space, leave this set to the default
                value Follow (FOLLOW). The service will automatically detect your input color space.
                If your input video has metadata indicating the wrong color space, specify the
                accurate color space here. If your input video is HDR 10 and the SMPTE ST 2086
                Mastering Display Color Volume static metadata isn't present in your video stream,
                or if that metadata is present but not accurate, choose Force HDR 10 (FORCE_HDR10)
                here and specify correct values in the input HDR 10 metadata (Hdr10Metadata)
                settings. For more information about MediaConvert HDR jobs, see
                https://docs.aws.amazon.com/console/mediaconvert/hdr.

                - **ColorSpaceUsage** *(string) --* There are two sources for color metadata, the
                input file and the job input settings Color space (ColorSpace) and HDR master
                display information settings(Hdr10Metadata). The Color space usage setting
                determines which takes precedence. Choose Force (FORCE) to use color metadata from
                the input job settings. If you don't specify values for those settings, the service
                defaults to using metadata from your input. FALLBACK - Choose Fallback (FALLBACK) to
                use color metadata from the source when it is present. If there's no color metadata
                in your input file, the service defaults to using values you specify in the input
                settings.

                - **Hdr10Metadata** *(dict) --* Use these settings to provide HDR 10 metadata that
                is missing or inaccurate in your input video. Appropriate values vary depending on
                the input video and must be provided by a color grader. The color grader generates
                these values during the HDR 10 mastering process. The valid range for each of these
                settings is 0 to 50,000. Each increment represents 0.00002 in CIE1931 color
                coordinate. Related settings - When you specify these values, you must also set
                Color space (ColorSpace) to HDR 10 (HDR10). To specify whether the the values you
                specify here take precedence over the values in the metadata of your input file, set
                Color space usage (ColorSpaceUsage). To specify whether color metadata is included
                in an output, set Color metadata (ColorMetadata). For more information about
                MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

                  - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                  the coded video sequence, in units of candelas per square meter. This setting
                  doesn't have a default value; you must specify a value that is suitable for the
                  content.

                  - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                  frame in the coded video sequence, in units of candelas per square meter. This
                  setting doesn't have a default value; you must specify a value that is suitable
                  for the content.

                  - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                  units of of 0.0001 candelas per square meter.

                  - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                  units of of 0.0001 candelas per square meter

                  - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                - **Pid** *(integer) --* Use PID (Pid) to select specific video data from an input
                file. Specify this value as an integer; the system automatically converts it to the
                hexidecimal value. For example, 257 selects PID 0x101. A PID, or packet identifier,
                is an identifier for a set of data in an MPEG-2 transport stream container.

                - **ProgramNumber** *(integer) --* Selects a specific program from within a
                multi-program transport stream. Note that Quad 4K is not currently supported.

                - **Rotate** *(string) --* Use Rotate (InputRotate) to specify how the service
                rotates your video. You can choose automatic rotation or specify a rotation. You can
                specify a clockwise rotation of 0, 90, 180, or 270 degrees. If your input video
                container is .mov or .mp4 and your input has rotation metadata, you can choose
                Automatic to have the service rotate your video according to the rotation specified
                in the metadata. The rotation must be within one degree of 90, 180, or 270 degrees.
                If the rotation metadata specifies any other rotation, the service will default to
                no rotation. By default, the service does no rotation, even if your input video has
                rotation metadata. The service doesn't pass through rotation metadata.

          - **MotionImageInserter** *(dict) --* Overlay motion graphics on top of your video. The
          motion graphics that you specify here appear on all outputs in all output groups.

            - **Framerate** *(dict) --* If your motion graphic asset is a .mov file, keep this
            setting unspecified. If your motion graphic asset is a series of .png files, specify the
            frame rate of the overlay in frames per second, as a fraction. For example, specify 24
            fps as 24/1. Make sure that the number of images in your series matches the frame rate
            and your intended overlay duration. For example, if you want a 30-second overlay at 30
            fps, you should have 900 .png images. This overlay frame rate doesn't need to match the
            frame rate of the underlying video.

              - **FramerateDenominator** *(integer) --* The bottom of the fraction that expresses
              your overlay frame rate. For example, if your frame rate is 24 fps, set this value to
              1.

              - **FramerateNumerator** *(integer) --* The top of the fraction that expresses your
              overlay frame rate. For example, if your frame rate is 24 fps, set this value to 24.

            - **Input** *(string) --* Specify the .mov file or series of .png files that you want to
            overlay on your video. For .png files, provide the file name of the first file in the
            series. Make sure that the names of the .png files end with sequential numbers that
            specify the order that they are played in. For example, overlay_000.png,
            overlay_001.png, overlay_002.png, and so on. The sequence must start at zero, and each
            image file name must have the same number of digits. Pad your initial file names with
            enough zeros to complete the sequence. For example, if the first image is overlay_0.png,
            there can be only 10 images in the sequence, with the last image being overlay_9.png.
            But if the first image is overlay_00.png, there can be 100 images in the sequence.

            - **InsertionMode** *(string) --* Choose the type of motion graphic asset that you are
            providing for your overlay. You can choose either a .mov file or a series of .png files.

            - **Offset** *(dict) --* Use Offset to specify the placement of your motion graphic
            overlay on the video frame. Specify in pixels, from the upper-left corner of the frame.
            If you don't specify an offset, the service scales your overlay to the full size of the
            frame. Otherwise, the service inserts the overlay at its native resolution and scales
            the size up or down with any video scaling.

              - **ImageX** *(integer) --* Set the distance, in pixels, between the overlay and the
              left edge of the video frame.

              - **ImageY** *(integer) --* Set the distance, in pixels, between the overlay and the
              top edge of the video frame.

            - **Playback** *(string) --* Specify whether your motion graphic overlay repeats on a
            loop or plays only once.

            - **StartTime** *(string) --* Specify when the motion overlay begins. Use timecode
            format (HH:MM:SS:FF or HH:MM:SS;FF). Make sure that the timecode you provide here takes
            into account how you have set up your timecode configuration under both job settings and
            input settings. The simplest way to do that is to set both to start at 0. If you need to
            set up your job to follow timecodes embedded in your source that don't start at zero,
            make sure that you specify a start time that is after the first embedded timecode. For
            more information, see
            https://docs.aws.amazon.com/mediaconvert/latest/ug/setting-up-timecode.html Find
            job-wide and input timecode configuration settings in your JSON job settings
            specification at settings>timecodeConfig>source and settings>inputs>timecodeSource.

          - **NielsenConfiguration** *(dict) --* Settings for your Nielsen configuration. If you
          don't do Nielsen measurement and analytics, ignore these settings. When you enable Nielsen
          configuration (nielsenConfiguration), MediaConvert enables PCM to ID3 tagging for all
          outputs in the job. To enable Nielsen configuration programmatically, include an instance
          of nielsenConfiguration in your JSON job specification. Even if you don't include any
          children of nielsenConfiguration, you still enable the setting.

            - **BreakoutCode** *(integer) --* Nielsen has discontinued the use of breakout code
            functionality. If you must include this property, set the value to zero.

            - **DistributorId** *(string) --* Use Distributor ID (DistributorID) to specify the
            distributor ID that is assigned to your organization by Neilsen.

          - **OutputGroups** *(list) --* (OutputGroups) contains one group of settings for each set
          of outputs that share a common package type. All unpackaged files (MPEG-4, MPEG-2 TS,
          Quicktime, MXF, and no container) are grouped in a single output group as well. Required
          in (OutputGroups) is a group of settings that apply to the whole group. This required
          object depends on the value you set for (Type) under (OutputGroups)>(OutputGroupSettings).
          Type, settings object pairs are as follows. * FILE_GROUP_SETTINGS, FileGroupSettings *
          HLS_GROUP_SETTINGS, HlsGroupSettings * DASH_ISO_GROUP_SETTINGS, DashIsoGroupSettings *
          MS_SMOOTH_GROUP_SETTINGS, MsSmoothGroupSettings * CMAF_GROUP_SETTINGS, CmafGroupSettings

            - *(dict) --* Group of outputs

              - **CustomName** *(string) --* Use Custom Group Name (CustomName) to specify a name
              for the output group. This value is displayed on the console and can make your job
              settings JSON more human-readable. It does not affect your outputs. Use up to twelve
              characters that are either letters, numbers, spaces, or underscores.

              - **Name** *(string) --* Name of the output group

              - **OutputGroupSettings** *(dict) --* Output Group settings, including type

                - **CmafGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to CMAF_GROUP_SETTINGS. Each output in a CMAF
                Output Group may only contain a single video, audio, or caption output.

                  - **AdditionalManifests** *(list) --* By default, the service creates one
                  top-level .m3u8 HLS manifest and one top -level .mpd DASH manifest for each CMAF
                  output group in your job. These default manifests reference every output in the
                  output group. To create additional top-level manifests that reference a subset of
                  the outputs in the output group, specify a list of them here. For each additional
                  manifest that you specify, the service creates one HLS manifest and one DASH
                  manifest.

                    - *(dict) --* Specify the details for each pair of HLS and DASH additional
                    manifests that you want the service to generate for this CMAF output group. Each
                    pair of manifests can reference a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your HLS group is film-name.m3u8. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                      specify a manifestNameModifier that is different from the nameModifier of the
                      output. The service uses the output name modifier to create unique names for
                      the individual variant manifests.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                  file at the top level BaseURL element. Can be used if streams are delivered from a
                  different URL than the manifest file.

                  - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no
                  tag, which prevents client from saving media segments for later replay.

                  - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the
                  default RFC-4281) during m3u8 playlist generation.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* DRM settings.

                    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                    value represented by a 32-character text string. If this parameter is not set
                    then the Initialization Vector will follow the segment number by default.

                    - **EncryptionMethod** *(string) --* Specify the encryption scheme that you want
                    the service to use when encrypting your CMAF segments. Choose AES-CBC subsample
                    (SAMPLE-AES) or AES_CTR (AES-CTR).

                    - **InitializationVectorInManifest** *(string) --* When you use DRM with CMAF
                    outputs, choose whether the service writes the 128-bit encryption initialization
                    vector in the HLS and DASH manifests.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is CMAF, use these
                    settings when doing DRM encryption with a SPEKE-compliant key provider. If your
                    output group type is HLS, DASH, or Microsoft Smooth, use the SpekeKeyProvider
                    settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **DashSignaledSystemIds** *(list) --* Specify the DRM system IDs that you
                      want signaled in the DASH manifest that MediaConvert creates as part of this
                      CMAF package. The DASH manifest can currently signal up to three system IDs.
                      For more information, see https://dashif.org/identifiers/content_protection/.

                        - *(string) --*

                      - **HlsSignaledSystemIds** *(list) --* Specify the DRM system ID that you want
                      signaled in the HLS manifest that MediaConvert creates as part of this CMAF
                      package. The HLS manifest can currently signal only one system ID. For more
                      information, see https://dashif.org/identifiers/content_protection/.

                        - *(string) --*

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with
                    a static key provider.

                      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                      the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                      omitted to indicate an implicit value of 'identity'.

                      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                      single positive integer version value or a slash delimited list of version
                      values (1/2/3).

                      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                      32-character hexidecimal string to specify Key Value (StaticKeyValue).

                      - **Url** *(string) --* Relates to DRM implementation. The location of the
                      license server used for protecting content.

                    - **Type** *(string) --* Specify whether your DRM encryption key is static or
                    from a key provider that follows the SPEKE standard. For more information about
                    SPEKE, see
                    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                  - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                  Fragment length must be compatible with GOP size and Framerate. Note that
                  fragments will end on the next keyframe after this number of seconds, so actual
                  fragment length may be longer. When Emit Single File is checked, the fragmentation
                  is internal to a single output file and it does not cause the creation of many
                  output files as in other output types.

                  - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                  - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                  should use floating point values for segment duration.

                  - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that
                  is needed to ensure smooth playout.

                  - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                  0, unless you are troubleshooting a problem with how devices play back the end of
                  your video asset. If you know that player devices are hanging on the final segment
                  of your video because the length of your final segment is too short, use this
                  setting to specify a minimum final segment length, in seconds. Choose a value that
                  is greater than or equal to 1 and less than your segment length. When you specify
                  a value for this setting, the encoder will combine any final segment that is
                  shorter than the length that you specify with the previous segment. For example,
                  your segment length is 3 seconds and your final segment is .5 seconds without a
                  minimum final segment length; when you set the minimum final segment length to 1,
                  your final segment is 3.5 seconds.

                  - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                  main. When you choose Main profile (MAIN_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                  On-demand (ON_DEMAND_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose
                  On-demand, you must also set the output group setting Segment control
                  (SegmentControl) to Single file (SINGLE_FILE).

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file
                  is generated, which is internally segmented using the Fragment Length and Segment
                  Length. When set to SEGMENTED_FILES, separate segment files will be created.

                  - **SegmentLength** *(integer) --* Use this setting to specify the length, in
                  seconds, of each individual CMAF segment. This value applies to the whole package;
                  that is, to every output in the output group. Note that segments end on the first
                  keyframe after this number of seconds, so the actual segment length might be
                  slightly longer. If you set Segment control (CmafSegmentControl) to single file,
                  the service puts the content of each output in a single file that has metadata
                  that marks these segments. If you set it to segmented files, the service creates
                  multiple files for each output, each with the content of one segment.

                  - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute
                  for video in EXT-X-STREAM-INF tag of variant manifest.

                  - **WriteDashManifest** *(string) --* When set to ENABLED, a DASH MPD manifest
                  will be generated for this output.

                  - **WriteHlsManifest** *(string) --* When set to ENABLED, an Apple HLS manifest
                  will be generated for this output.

                - **DashIsoGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to DASH_ISO_GROUP_SETTINGS.

                  - **AdditionalManifests** *(list) --* By default, the service creates one .mpd
                  DASH manifest for each DASH ISO output group in your job. This default manifest
                  references every output in the output group. To create additional DASH manifests
                  that reference a subset of the outputs in the output group, specify a list of them
                  here.

                    - *(dict) --* Specify the details for each additional DASH manifest that you
                    want the service to generate for this output group. Each manifest can reference
                    a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your DASH group is film-name.mpd. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.mpd.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be put in the manifest
                  (.mpd) file at the top level BaseURL element. Can be used if streams are delivered
                  from a different URL than the manifest file.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* DRM settings.

                    - **PlaybackDeviceCompatibility** *(string) --* This setting can improve the
                    compatibility of your output with video players on obsolete devices. It applies
                    only to DASH H.264 outputs with DRM encryption. Choose Unencrypted SEI
                    (UNENCRYPTED_SEI) only to correct problems with playback on older devices.
                    Otherwise, keep the default setting CENC v1 (CENC_V1). If you choose Unencrypted
                    SEI, for that output, the service will exclude the access unit delimiter and
                    will leave the SEI NAL units unencrypted.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                  - **FragmentLength** *(integer) --* Length of fragments to generate (in seconds).
                  Fragment length must be compatible with GOP size and Framerate. Note that
                  fragments will end on the next keyframe after this number of seconds, so actual
                  fragment length may be longer. When Emit Single File is checked, the fragmentation
                  is internal to a single output file and it does not cause the creation of many
                  output files as in other output types.

                  - **HbbtvCompliance** *(string) --* Supports HbbTV specification as indicated

                  - **MinBufferTime** *(integer) --* Minimum time of initially buffered media that
                  is needed to ensure smooth playout.

                  - **MpdProfile** *(string) --* Specify whether your DASH profile is on-demand or
                  main. When you choose Main profile (MAIN_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-main:2011 in your .mpd DASH manifest. When you choose
                  On-demand (ON_DEMAND_PROFILE), the service signals
                  urn:mpeg:dash:profile:isoff-on-demand:2011 in your .mpd. When you choose
                  On-demand, you must also set the output group setting Segment control
                  (SegmentControl) to Single file (SINGLE_FILE).

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, a single output file
                  is generated, which is internally segmented using the Fragment Length and Segment
                  Length. When set to SEGMENTED_FILES, separate segment files will be created.

                  - **SegmentLength** *(integer) --* Length of mpd segments to create (in seconds).
                  Note that segments will end on the next keyframe after this number of seconds, so
                  actual segment length may be longer. When Emit Single File is checked, the
                  segmentation is internal to a single output file and it does not cause the
                  creation of many output files as in other output types.

                  - **WriteSegmentTimelineInRepresentation** *(string) --* If you get an HTTP error
                  in the 400 range when you play back your DASH output, enable this setting and run
                  your transcoding job again. When you enable this setting, the service writes
                  precise segment durations in the DASH manifest. The segment duration information
                  appears inside the SegmentTimeline element, inside SegmentTemplate at the
                  Representation level. When you don't enable this setting, the service writes
                  approximate segment durations in your DASH manifest.

                - **FileGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to FILE_GROUP_SETTINGS.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                - **HlsGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to HLS_GROUP_SETTINGS.

                  - **AdMarkers** *(list) --* Choose one or more ad marker types to decorate your
                  Apple HLS manifest. This setting does not determine whether SCTE-35 markers appear
                  in the outputs themselves.

                    - *(string) --*

                  - **AdditionalManifests** *(list) --* By default, the service creates one
                  top-level .m3u8 HLS manifest for each HLS output group in your job. This default
                  manifest references every output in the output group. To create additional
                  top-level manifests that reference a subset of the outputs in the output group,
                  specify a list of them here.

                    - *(dict) --* Specify the details for each additional HLS manifest that you want
                    the service to generate for this output group. Each manifest can reference a
                    different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your HLS group is film-name.m3u8. If you enter
                      "-no-premium" for this setting, then the file name the service generates for
                      this top-level manifest is film-name-no-premium.m3u8. For HLS output groups,
                      specify a manifestNameModifier that is different from the nameModifier of the
                      output. The service uses the output name modifier to create unique names for
                      the individual variant manifests.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **BaseUrl** *(string) --* A partial URI prefix that will be prepended to each
                  output in the media .m3u8 file. Can be used if base manifest is delivered from a
                  different URL than the main .m3u8 file.

                  - **CaptionLanguageMappings** *(list) --* Language to be used on Caption outputs

                    - *(dict) --* Caption Language Mapping

                      - **CaptionChannel** *(integer) --* Caption channel.

                      - **CustomLanguageCode** *(string) --* Specify the language for this captions
                      channel, using the ISO 639-2 or ISO 639-3 three-letter language code

                      - **LanguageCode** *(string) --* Specify the language, using the ISO 639-2
                      three-letter code listed at
                      https://www.loc.gov/standards/iso639-2/php/code_list.php.

                      - **LanguageDescription** *(string) --* Caption language description.

                  - **CaptionLanguageSetting** *(string) --* Applies only to 608 Embedded output
                  captions. Insert: Include CLOSED-CAPTIONS lines in the manifest. Specify at least
                  one language in the CC1 Language Code field. One CLOSED-CAPTION line is added for
                  each Language Code you specify. Make sure to specify the languages in the order in
                  which they appear in the original source (if the source is embedded format) or the
                  order of the caption selectors (if the source is other than embedded). Otherwise,
                  languages in the manifest will not match up properly with the output captions.
                  None: Include CLOSED-CAPTIONS=
                      NONE line in the manifest. Omit: Omit any
                  CLOSED-CAPTIONS line from the manifest.

                  - **ClientCache** *(string) --* When set to ENABLED, sets #EXT-X-ALLOW-CACHE:no
                  tag, which prevents client from saving media segments for later replay.

                  - **CodecSpecification** *(string) --* Specification to use (RFC-6381 or the
                  default RFC-4281) during m3u8 playlist generation.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **DirectoryStructure** *(string) --* Indicates whether segments should be placed
                  in subdirectories.

                  - **Encryption** *(dict) --* DRM settings.

                    - **ConstantInitializationVector** *(string) --* This is a 128-bit, 16-byte hex
                    value represented by a 32-character text string. If this parameter is not set
                    then the Initialization Vector will follow the segment number by default.

                    - **EncryptionMethod** *(string) --* Encrypts the segments with the given
                    encryption scheme. Leave blank to disable. Selecting 'Disabled' in the web
                    interface also disables encryption.

                    - **InitializationVectorInManifest** *(string) --* The Initialization Vector is
                    a 128-bit number used in conjunction with the key for encrypting blocks. If set
                    to INCLUDE, Initialization Vector is listed in the manifest. Otherwise
                    Initialization Vector is not in the manifest.

                    - **OfflineEncrypted** *(string) --* Enable this setting to insert the
                    EXT-X-SESSION-KEY element into the master playlist. This allows for offline
                    Apple HLS FairPlay content protection.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                    - **StaticKeyProvider** *(dict) --* Use these settings to set up encryption with
                    a static key provider.

                      - **KeyFormat** *(string) --* Relates to DRM implementation. Sets the value of
                      the KEYFORMAT attribute. Must be 'identity' or a reverse DNS string. May be
                      omitted to indicate an implicit value of 'identity'.

                      - **KeyFormatVersions** *(string) --* Relates to DRM implementation. Either a
                      single positive integer version value or a slash delimited list of version
                      values (1/2/3).

                      - **StaticKeyValue** *(string) --* Relates to DRM implementation. Use a
                      32-character hexidecimal string to specify Key Value (StaticKeyValue).

                      - **Url** *(string) --* Relates to DRM implementation. The location of the
                      license server used for protecting content.

                    - **Type** *(string) --* Specify whether your DRM encryption key is static or
                    from a key provider that follows the SPEKE standard. For more information about
                    SPEKE, see
                    https://docs.aws.amazon.com/speke/latest/documentation/what-is-speke.html.

                  - **ManifestCompression** *(string) --* When set to GZIP, compresses HLS playlist.

                  - **ManifestDurationFormat** *(string) --* Indicates whether the output manifest
                  should use floating point values for segment duration.

                  - **MinFinalSegmentLength** *(float) --* Keep this setting at the default value of
                  0, unless you are troubleshooting a problem with how devices play back the end of
                  your video asset. If you know that player devices are hanging on the final segment
                  of your video because the length of your final segment is too short, use this
                  setting to specify a minimum final segment length, in seconds. Choose a value that
                  is greater than or equal to 1 and less than your segment length. When you specify
                  a value for this setting, the encoder will combine any final segment that is
                  shorter than the length that you specify with the previous segment. For example,
                  your segment length is 3 seconds and your final segment is .5 seconds without a
                  minimum final segment length; when you set the minimum final segment length to 1,
                  your final segment is 3.5 seconds.

                  - **MinSegmentLength** *(integer) --* When set, Minimum Segment Size is enforced
                  by looking ahead and back within the specified range for a nearby avail and
                  extending the segment size if needed.

                  - **OutputSelection** *(string) --* Indicates whether the .m3u8 manifest file
                  should be generated for this HLS output group.

                  - **ProgramDateTime** *(string) --* Includes or excludes EXT-X-PROGRAM-DATE-TIME
                  tag in .m3u8 manifest files. The value is calculated as follows: either the
                  program date and time are initialized using the input timecode source, or the time
                  is initialized using the input timecode source and the date is initialized using
                  the timestamp_offset.

                  - **ProgramDateTimePeriod** *(integer) --* Period of insertion of
                  EXT-X-PROGRAM-DATE-TIME entry, in seconds.

                  - **SegmentControl** *(string) --* When set to SINGLE_FILE, emits program as a
                  single media resource (.ts) file, uses #EXT-X-BYTERANGE tags to index segment for
                  playback.

                  - **SegmentLength** *(integer) --* Length of MPEG-2 Transport Stream segments to
                  create (in seconds). Note that segments will end on the next keyframe after this
                  number of seconds, so actual segment length may be longer.

                  - **SegmentsPerSubdirectory** *(integer) --* Number of segments to write to a
                  subdirectory before starting a new one. directoryStructure must be
                  SINGLE_DIRECTORY for this setting to have an effect.

                  - **StreamInfResolution** *(string) --* Include or exclude RESOLUTION attribute
                  for video in EXT-X-STREAM-INF tag of variant manifest.

                  - **TimedMetadataId3Frame** *(string) --* Indicates ID3 frame that has the
                  timecode.

                  - **TimedMetadataId3Period** *(integer) --* Timed Metadata interval in seconds.

                  - **TimestampDeltaMilliseconds** *(integer) --* Provides an extra millisecond
                  delta offset to fine tune the timestamps.

                - **MsSmoothGroupSettings** *(dict) --* Required when you set (Type) under
                (OutputGroups)>(OutputGroupSettings) to MS_SMOOTH_GROUP_SETTINGS.

                  - **AdditionalManifests** *(list) --* By default, the service creates one .ism
                  Microsoft Smooth Streaming manifest for each Microsoft Smooth Streaming output
                  group in your job. This default manifest references every output in the output
                  group. To create additional manifests that reference a subset of the outputs in
                  the output group, specify a list of them here.

                    - *(dict) --* Specify the details for each additional Microsoft Smooth Streaming
                    manifest that you want the service to generate for this output group. Each
                    manifest can reference a different subset of outputs in the group.

                      - **ManifestNameModifier** *(string) --* Specify a name modifier that the
                      service adds to the name of this manifest to make it different from the file
                      names of the other main manifests in the output group. For example, say that
                      the default main manifest for your Microsoft Smooth group is film-name.ismv.
                      If you enter "-no-premium" for this setting, then the file name the service
                      generates for this top-level manifest is film-name-no-premium.ismv.

                      - **SelectedOutputs** *(list) --* Specify the outputs that you want this
                      additional top-level manifest to reference.

                        - *(string) --*

                  - **AudioDeduplication** *(string) --* COMBINE_DUPLICATE_STREAMS combines
                  identical audio encoding settings across a Microsoft Smooth output group into a
                  single audio stream.

                  - **Destination** *(string) --* Use Destination (Destination) to specify the S3
                  output location and the output filename base. Destination accepts format
                  identifiers. If you do not specify the base filename in the URI, the service will
                  use the filename of the input file. If your job has multiple inputs, the service
                  uses the filename of the first input file.

                  - **DestinationSettings** *(dict) --* Settings associated with the destination.
                  Will vary based on the type of destination

                    - **S3Settings** *(dict) --* Settings associated with S3 destination

                      - **AccessControl** *(dict) --* Optional. Have MediaConvert automatically
                      apply Amazon S3 access control for the outputs in this output group. When you
                      don't use this setting, S3 automatically applies the default access control
                      list PRIVATE.

                        - **CannedAcl** *(string) --* Choose an Amazon S3 canned ACL for
                        MediaConvert to apply to this output.

                      - **Encryption** *(dict) --* Settings for how your job outputs are encrypted
                      as they are uploaded to Amazon S3.

                        - **EncryptionType** *(string) --* Specify how you want your data keys
                        managed. AWS uses data keys to encrypt your content. AWS also encrypts the
                        data keys themselves, using a customer master key (CMK), and then stores the
                        encrypted data keys alongside your encrypted content. Use this setting to
                        specify which AWS service manages the CMK. For simplest set up, choose
                        Amazon S3 (SERVER_SIDE_ENCRYPTION_S3). If you want your master key to be
                        managed by AWS Key Management Service (KMS), choose AWS KMS
                        (SERVER_SIDE_ENCRYPTION_KMS). By default, when you choose AWS KMS, KMS uses
                        the AWS managed customer master key (CMK) associated with Amazon S3 to
                        encrypt your data keys. You can optionally choose to specify a different,
                        customer managed CMK. Do so by specifying the Amazon Resource Name (ARN) of
                        the key for the setting KMS ARN (kmsKeyArn).

                        - **KmsKeyArn** *(string) --* Optionally, specify the customer master key
                        (CMK) that you want to use to encrypt the data key that AWS uses to encrypt
                        your output content. Enter the Amazon Resource Name (ARN) of the CMK. To use
                        this setting, you must also set Server-side encryption
                        (S3ServerSideEncryptionType) to AWS KMS (SERVER_SIDE_ENCRYPTION_KMS). If you
                        set Server-side encryption to AWS KMS but don't specify a CMK here, AWS uses
                        the AWS managed CMK associated with Amazon S3.

                  - **Encryption** *(dict) --* If you are using DRM, set DRM System
                  (MsSmoothEncryptionSettings) to specify the value SpekeKeyProvider.

                    - **SpekeKeyProvider** *(dict) --* If your output group type is HLS, DASH, or
                    Microsoft Smooth, use these settings when doing DRM encryption with a
                    SPEKE-compliant key provider. If your output group type is CMAF, use the
                    SpekeKeyProviderCmaf settings instead.

                      - **CertificateArn** *(string) --* If you want your key provider to encrypt
                      the content keys that it provides to MediaConvert, set up a certificate with a
                      master key using AWS Certificate Manager. Specify the certificate's Amazon
                      Resource Name (ARN) here.

                      - **ResourceId** *(string) --* Specify the resource ID that your
                      SPEKE-compliant key provider uses to identify this content.

                      - **SystemIds** *(list) --* Relates to SPEKE implementation. DRM system
                      identifiers. DASH output groups support a max of two system ids. Other group
                      types support one system id. See
                      https://dashif.org/identifiers/content_protection/ for more details.

                        - *(string) --*

                      - **Url** *(string) --* Specify the URL to the key server that your
                      SPEKE-compliant DRM key provider uses to provide keys for encrypting your
                      content.

                  - **FragmentLength** *(integer) --* Use Fragment length (FragmentLength) to
                  specify the mp4 fragment sizes in seconds. Fragment length must be compatible with
                  GOP size and frame rate.

                  - **ManifestEncoding** *(string) --* Use Manifest encoding
                  (MsSmoothManifestEncoding) to specify the encoding format for the server and
                  client manifest. Valid options are utf8 and utf16.

                - **Type** *(string) --* Type of output group (File group, Apple HLS, DASH ISO,
                Microsoft Smooth Streaming, CMAF)

              - **Outputs** *(list) --* This object holds groups of encoding settings, one group of
              settings per output.

                - *(dict) --* An output object describes the settings for a single output file or
                stream in an output group.

                  - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio
                  encoding settings organized by audio codec. Include one instance of
                  (AudioDescriptions) per output. (AudioDescriptions) can contain multiple groups of
                  encoding settings.

                    - *(dict) --* Description of audio output

                      - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization
                      settings. Ignore these settings unless you need to comply with a loudness
                      standard.

                        - **Algorithm** *(string) --* Choose one of the following audio
                        normalization algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement
                        of ungated average loudness for an entire piece of content, suitable for
                        measurement of short-form content under ATSC recommendation A/85. Supports
                        up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
                        gated average loudness compliant with the requirements of EBU-R128. Supports
                        up to 5.1 audio channels. ITU-R BS.1770-3: Modified peak. The same loudness
                        measurement algorithm as 1770-2, with an updated true peak measurement.
                        ITU-R BS.1770-4: Higher channel count. Allows for more audio channels than
                        the other algorithms, including configurations such as 7.1.

                        - **AlgorithmControl** *(string) --* When enabled the output audio is
                        corrected using the chosen algorithm. If disabled, the audio will be
                        measured but not adjusted.

                        - **CorrectionGateLevel** *(integer) --* Content measuring above this level
                        will be corrected to the target level. Content measuring below this level
                        will not be corrected. Gating only applies when not using
                        real_time_correction.

                        - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio
                        track loudness to a CSV file.

                        - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log
                        the TruePeak for each output's audio track loudness.

                        - **TargetLkfs** *(float) --* When you use Audio normalization
                        (AudioNormalizationSettings), optionally use this setting to specify a
                        target loudness. If you don't specify a value here, the encoder chooses a
                        value for you, based on the algorithm that you choose for Algorithm
                        (algorithm). If you choose algorithm 1770-1, the encoder will choose -24
                        LKFS; otherwise, the encoder will choose -23 LKFS.

                      - **AudioSourceName** *(string) --* Specifies which audio data to use from
                      each input. In the simplest case, specify an "Audio
                      Selector":#inputs-audio_selector by name based on its order within each input.
                      For example if you specify "Audio Selector 3", then the third audio selector
                      will be used from each input. If an input does not have an "Audio Selector 3",
                      then the audio selector marked as "default" in that input will be used. If
                      there is no audio selector marked as "default", silence will be inserted for
                      the duration of that input. Alternatively, an "Audio Selector
                      Group":#inputs-audio_selector_group name may be specified, with similar
                      default/silence behavior. If no audio_source_name is specified, then "Audio
                      Selector 1" will be chosen automatically.

                      - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is
                      unchecked (false). A number between 0 and 255. The following are defined in
                      ISO-IEC 13818-1: 0 = Undefined, 1 = Clean Effects, 2 =
                           Hearing Impaired, 3 =
                      Visually Impaired Commentary, 4-255 = Reserved.

                      - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input
                      contains an ISO 639 audio_type, then that value is passed through to the
                      output. If the input contains no ISO 639 audio_type, the value in Audio Type
                      is included in the output. Otherwise the value in Audio Type is included in
                      the output. Note that this field and audioType are both ignored if
                      audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

                      - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
                      (AudioDescriptions) contains the group of settings related to audio encoding.
                      The settings in this group vary depending on the value that you choose for
                      Audio codec (Codec). For each codec enum that you choose, define the
                      corresponding settings object. The following lists the codec enum, settings
                      object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF,
                      AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
                      Eac3AtmosSettings

                        - **AacSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts
                        one of two mutually exclusive groups of AAC settings--VBR and CBR. To select
                        one of these modes, set the value of Bitrate control mode (rateControlMode)
                        to "VBR" or "CBR". In VBR mode, you control the audio quality with the
                        setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
                        (bitrate). Defaults and valid values depend on the rate control mode.

                          - **AudioDescriptionBroadcasterMix** *(string) --* Choose
                          BROADCASTER_MIXED_AD when the input contains pre-mixed main audio + audio
                          description (AD) as a stereo pair. The value for AudioType will be set to
                          3, which signals to downstream systems that this stream contains
                          "broadcaster mixed AD". Note that the input received by the encoder must
                          contain pre-mixed audio; the encoder does not perform the mixing. When you
                          choose BROADCASTER_MIXED_AD, the encoder ignores any values you provide in
                          AudioType and FollowInputAudioType. Choose NORMAL when the input does not
                          contain pre-mixed audio + audio description (AD). In this case, the
                          encoder will use any values you provide for AudioType and
                          FollowInputAudioType.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. The set of valid values for this setting is: 6000, 8000, 10000,
                          12000, 14000, 16000, 20000, 24000, 28000, 32000, 40000, 48000, 56000,
                          64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
                          288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
                          1024000. The value you set is also constrained by the values that you
                          choose for Profile (codecProfile), Bitrate control mode (codingMode), and
                          Sample rate (sampleRate). Default values depend on Bitrate control mode
                          and Profile.

                          - **CodecProfile** *(string) --* AAC Profile.

                          - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or
                          5.1 channel layout. Valid values depend on rate control mode and profile.
                          "1.0 - Audio Description (Receiver Mix)" setting receives a stereo
                          description plus control track and emits a mono AAC encode of the
                          description track, with control data emitted in the PES header as per ETSI
                          TS 101 154 Annex E.

                          - **RateControlMode** *(string) --* Rate Control Mode.

                          - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if
                          you use LATM/LOAS AAC in an output, you must choose "No container" for the
                          output container.

                          - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on
                          rate control mode and profile.

                          - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC
                          audio for raw or MPEG-2 Transport Stream containers.

                          - **VbrQuality** *(string) --* VBR Quality Level - Only used if
                          rate_control_mode is VBR.

                        - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AC3.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid bitrates depend on the coding mode.

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3
                          stream that the encoder emits. For more information about the AC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* Dolby Digital coding mode. Determines
                          number of channels.

                          - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank
                          and input audio is Dolby Digital, dialnorm will be passed through.

                          - **DynamicRangeCompressionProfile** *(string) --* If set to
                          FILM_STANDARD, adds dynamic range compression signaling to the output
                          bitstream as defined in the Dolby Digital specification.

                          - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                          channel prior to encoding. Only valid with 3_2_LFE coding mode.

                          - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                          metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                          this audio data. If audio was not supplied from one of these streams, then
                          the static metadata settings will be used.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                        - **AiffSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value AIFF.

                          - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                          sample, to choose the encoding quality for this audio track.

                          - **Channels** *(integer) --* Specify the number of channels in this
                          output audio track. Valid values are 1 and even numbers up to 64. For
                          example, 1, 2, 4, 6, and so on, up to 64.

                          - **SampleRate** *(integer) --* Sample rate in hz.

                        - **Codec** *(string) --* Type of Audio codec.

                        - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid values: 384k, 448k, 640k, 768k

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the
                          E-AC-3 stream that the encoder emits. For more information about the EAC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC
                          (Atmos) is always 9.1.6 (CODING_MODE_9_1_6).

                          - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue
                          Intelligence to adjust loudness based on dialogue analysis.

                          - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                          level for a signal with dynamic range compression.

                          - **DynamicRangeCompressionRf** *(string) --* Specify how the service
                          limits the audio dynamic range when compressing the audio.

                          - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left only/Right only center mix (Lo/Ro center).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
                          and -6.0.

                          - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert
                          uses this value for downmixing. How the service uses this value depends on
                          the value that you choose for Stereo downmix (Eac3AtmosStereoDownmix).
                          Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                          channel.

                          - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left total/Right total center mix (Lt/Rt center).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
                          and -6.0.

                          - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Atmos setting: Left total/Right total surround mix (Lt/Rt surround).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
                          The value -60 mutes the channel.

                          - **MeteringMode** *(string) --* Choose how the service meters the
                          loudness of your audio.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                          - **SpeechThreshold** *(integer) --* Specify the percentage of audio
                          content that must be speech before the encoder uses the measured speech
                          loudness as the overall program loudness.

                          - **StereoDownmix** *(string) --* Choose how the service does stereo
                          downmixing.

                          - **SurroundExMode** *(string) --* Specify whether your input audio has an
                          additional center rear surround channel matrix encoded into your left and
                          right surround channels.

                        - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value EAC3.

                          - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a
                          3 dB attenuation to the surround channels. Only used for 3/2 coding mode.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second. Valid bitrates depend on the coding mode.

                          - **BitstreamMode** *(string) --* Specify the bitstream mode for the
                          E-AC-3 stream that the encoder emits. For more information about the EAC3
                          bitstream mode, see ATSC A/52-2012 (Annex E).

                          - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines
                          number of channels.

                          - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                          channels.

                          - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank
                          and input audio is Dolby Digital Plus, dialnorm will be passed through.

                          - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak
                          level for a signal with dynamic range compression.

                          - **DynamicRangeCompressionRf** *(string) --* Specify how the service
                          limits the audio dynamic range when compressing the audio.

                          - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether
                          the LFE channel is enabled

                          - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE
                          channel prior to encoding. Only valid with 3_2_LFE coding mode.

                          - **LoRoCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left only/Right only center mix (Lo/Ro
                          center). MediaConvert uses this value for downmixing. How the service uses
                          this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                          and -60. The value -60 mutes the channel. This setting applies only if you
                          keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                          setting Coding mode (Eac3CodingMode). If you choose a different value for
                          Coding mode, the service ignores Left only/Right only center
                          (loRoCenterMixLevel).

                          - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left only/Right only (Lo/Ro surround).
                          MediaConvert uses this value for downmixing. How the service uses this
                          value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                          value -60 mutes the channel. This setting applies only if you keep the
                          default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                          Coding mode (Eac3CodingMode). If you choose a different value for Coding
                          mode, the service ignores Left only/Right only surround
                          (loRoSurroundMixLevel).

                          - **LtRtCenterMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left total/Right total center mix (Lt/Rt
                          center). MediaConvert uses this value for downmixing. How the service uses
                          this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0,
                          and -60. The value -60 mutes the channel. This setting applies only if you
                          keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                          setting Coding mode (Eac3CodingMode). If you choose a different value for
                          Coding mode, the service ignores Left total/Right total center
                          (ltRtCenterMixLevel).

                          - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following
                          Dolby Digital Plus setting: Left total/Right total surround mix (Lt/Rt
                          surround). MediaConvert uses this value for downmixing. How the service
                          uses this value depends on the value that you choose for Stereo downmix
                          (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
                          value -60 mutes the channel. This setting applies only if you keep the
                          default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting
                          Coding mode (Eac3CodingMode). If you choose a different value for Coding
                          mode, the service ignores Left total/Right total surround
                          (ltRtSurroundMixLevel).

                          - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder
                          metadata will be sourced from the DD, DD+, or DolbyE decoder that supplied
                          this audio data. If audio was not supplied from one of these streams, then
                          the static metadata settings will be used.

                          - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input
                          DD+ audio will be passed through if it is present on the input. this
                          detection is dynamic over the life of the transcode. Inputs that alternate
                          between DD+ and non-DD+ content will have a consistent DD+ output as the
                          system alternates between passthrough and encoding.

                          - **PhaseControl** *(string) --* Controls the amount of phase-shift
                          applied to the surround channels. Only used for 3/2 coding mode.

                          - **SampleRate** *(integer) --* This value is always 48000. It represents
                          the sample rate in Hz.

                          - **StereoDownmix** *(string) --* Choose how the service does stereo
                          downmixing. This setting only applies if you keep the default value of 3/2
                          - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
                          (Eac3CodingMode). If you choose a different value for Coding mode, the
                          service ignores Stereo downmix (Eac3StereoDownmix).

                          - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether
                          an extra center back surround channel is matrix encoded into the left and
                          right surround channels.

                          - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether
                          Dolby Surround is matrix encoded into the two channels.

                        - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value MP2.

                          - **Bitrate** *(integer) --* Specify the average bitrate in bits per
                          second.

                          - **Channels** *(integer) --* Set Channels to specify the number of
                          channels in this output audio track. Choosing Mono in the console will
                          give you 1 output channel; choosing Stereo will give you 2. In the API,
                          valid values are 1 and 2.

                          - **SampleRate** *(integer) --* Sample rate in hz.

                        - **WavSettings** *(dict) --* Required when you set (Codec) under
                        (AudioDescriptions)>(CodecSettings) to the value WAV.

                          - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per
                          sample, to choose the encoding quality for this audio track.

                          - **Channels** *(integer) --* Specify the number of channels in this
                          output audio track. Valid values are 1 and even numbers up to 64. For
                          example, 1, 2, 4, 6, and so on, up to 64.

                          - **Format** *(string) --* The service defaults to using RIFF for WAV
                          outputs. If your output audio is likely to exceed 4 GB in file size, or if
                          you otherwise need the extended support of the RF64 format, set your
                          output WAV file format to RF64.

                          - **SampleRate** *(integer) --* Sample rate in Hz.

                      - **CustomLanguageCode** *(string) --* Specify the language for this audio
                      output track. The service puts this language code into your output audio track
                      when you set Language code control (AudioLanguageCodeControl) to Use
                      configured (USE_CONFIGURED). The service also uses your specified custom
                      language code when you set Language code control (AudioLanguageCodeControl) to
                      Follow input (FOLLOW_INPUT), but your input file doesn't specify a language
                      code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
                      streaming outputs, you can also use any other code in the full RFC-5646
                      specification. Streaming outputs are those that are in one of the following
                      output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                      - **LanguageCode** *(string) --* Indicates the language of the audio output
                      track. The ISO 639 language specified in the 'Language Code' drop down will be
                      used when 'Follow Input Language Code' is not selected or when 'Follow Input
                      Language Code' is selected but there is no ISO 639 language code specified by
                      the input.

                      - **LanguageCodeControl** *(string) --* Specify which source for language code
                      takes precedence for this audio track. When you choose Follow input
                      (FOLLOW_INPUT), the service uses the language code from the input track if
                      it's present. If there's no languge code on the input track, the service uses
                      the code that you specify in the setting Language code (languageCode or
                      customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
                      service uses the language code that you specify.

                      - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                        - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains
                        the group of fields that hold the remixing value for each channel. Units are
                        in dB. Acceptable values are within the range from -60 (mute) through 6. A
                        setting of 0 passes the input channel unchanged to the output channel (no
                        attenuation or amplification).

                          - **OutputChannels** *(list) --* List of output channels

                            - *(dict) --* OutputChannel mapping settings.

                              - **InputChannels** *(list) --* List of input channels

                                - *(integer) --*

                        - **ChannelsIn** *(integer) --* Specify the number of audio channels from
                        your input that you want to use in your output. With remixing, you might
                        combine or split the data in these channels, so the number of channels in
                        your final output might be different.

                        - **ChannelsOut** *(integer) --* Specify the number of channels in this
                        output after remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even
                        numbers to 64.)

                      - **StreamName** *(string) --* Specify a label for this output audio stream.
                      For example, "English", "Director commentary", or "track_2". For streaming
                      outputs, MediaConvert passes this information into destination manifests for
                      display on the end-viewer's player device. For outputs in other output groups,
                      the service ignores this setting.

                  - **CaptionDescriptions** *(list) --* (CaptionDescriptions) contains groups of
                  captions settings. For each output that has captions, include one instance of
                  (CaptionDescriptions). (CaptionDescriptions) can contain multiple groups of
                  captions settings.

                    - *(dict) --* Description of Caption output

                      - **CaptionSelectorName** *(string) --* Specifies which "Caption
                      Selector":#inputs-caption_selector to use from each input when generating
                      captions. The name should be of the format "Caption Selector ", which denotes
                      that the Nth Caption Selector will be used from each input.

                      - **CustomLanguageCode** *(string) --* Specify the language for this captions
                      output track. For most captions output formats, the encoder puts this language
                      information in the output captions metadata. If your output captions format is
                      DVB-Sub or Burn in, the encoder uses this language information when
                      automatically selecting the font script for rendering the captions text. For
                      all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
                      outputs, you can also use any other code in the full RFC-5646 specification.
                      Streaming outputs are those that are in one of the following output groups:
                      CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

                      - **DestinationSettings** *(dict) --* Specific settings required by
                      destination type. Note that burnin_destination_settings are not available if
                      the source of the caption data is Embedded or Teletext.

                        - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                          - **Alignment** *(string) --* If no explicit x_position or y_position is
                          provided, setting alignment to centered will place the captions at the
                          bottom center of the output. Similarly, setting a left alignment will
                          align captions to the bottom left of the output. If x and y positions are
                          given in conjunction with the alignment parameter, the font will be
                          justified (either left or centered) relative to those coordinates. This
                          option is not valid for source captions that are STL, 608/embedded or
                          teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                          behind the captions. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                          background rectangle. 255 is opaque; 0 is transparent. Leaving this
                          parameter blank is equivalent to setting it to 0 (transparent). All
                          burn-in and DVB-Sub font settings must match.

                          - **FontColor** *(string) --* Specifies the color of the burned-in
                          captions. This option is not valid for source captions that are STL,
                          608/embedded or teletext. These source settings are already pre-defined by
                          the caption stream. All burn-in and DVB-Sub font settings must match.

                          - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                          captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                          settings must match.

                          - **FontResolution** *(integer) --* Font resolution in DPI (dots per
                          inch); default is 96 dpi. All burn-in and DVB-Sub font settings must
                          match.

                          - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                          script code, if the LanguageCode is not sufficient for determining the
                          script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                          "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                          font for rendering burn-in captions.

                          - **FontSize** *(integer) --* A positive integer indicates the exact font
                          size in points. Set to 0 for automatic font size selection. All burn-in
                          and DVB-Sub font settings must match.

                          - **OutlineColor** *(string) --* Specifies font outline color. This option
                          is not valid for source captions that are either 608/embedded or teletext.
                          These source settings are already pre-defined by the caption stream. All
                          burn-in and DVB-Sub font settings must match.

                          - **OutlineSize** *(integer) --* Specifies font outline size in pixels.
                          This option is not valid for source captions that are either 608/embedded
                          or teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                          the captions. All burn-in and DVB-Sub font settings must match.

                          - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow.
                          255 is opaque; 0 is transparent. Leaving this parameter blank is
                          equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                          settings must match.

                          - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                          must match.

                          - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels above the text. All burn-in and DVB-Sub font
                          settings must match.

                          - **TeletextSpacing** *(string) --* Only applies to jobs with input
                          captions in Teletext or STL formats. Specify whether the spacing between
                          letters in your captions is set by the captions grid or varies depending
                          on letter width. Choose fixed grid to conform to the spacing specified in
                          the captions file more accurately. Choose proportional to make the text
                          easier to read if the captions are closed caption.

                          - **XPosition** *(integer) --* Specifies the horizontal position of the
                          caption relative to the left side of the output in pixels. A value of 10
                          would result in the captions starting 10 pixels from the left of the
                          output. If no explicit x_position is provided, the horizontal caption
                          position will be determined by the alignment parameter. This option is not
                          valid for source captions that are STL, 608/embedded or teletext. These
                          source settings are already pre-defined by the caption stream. All burn-in
                          and DVB-Sub font settings must match.

                          - **YPosition** *(integer) --* Specifies the vertical position of the
                          caption relative to the top of the output in pixels. A value of 10 would
                          result in the captions starting 10 pixels from the top of the output. If
                          no explicit y_position is provided, the caption will be positioned towards
                          the bottom of the output. This option is not valid for source captions
                          that are STL, 608/embedded or teletext. These source settings are already
                          pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                          must match.

                        - **DestinationType** *(string) --* Specify the format for this set of
                        captions on this output. The default format is embedded without SCTE-20.
                        Other options are embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT,
                        teletext, TTML, and web-VTT. If you are using SCTE-20, choose SCTE-20 plus
                        embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the
                        SCTE-43 spec. To create a non-compliant output where the embedded captions
                        come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                        - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                          - **Alignment** *(string) --* If no explicit x_position or y_position is
                          provided, setting alignment to centered will place the captions at the
                          bottom center of the output. Similarly, setting a left alignment will
                          align captions to the bottom left of the output. If x and y positions are
                          given in conjunction with the alignment parameter, the font will be
                          justified (either left or centered) relative to those coordinates. This
                          option is not valid for source captions that are STL, 608/embedded or
                          teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundColor** *(string) --* Specifies the color of the rectangle
                          behind the captions. All burn-in and DVB-Sub font settings must match.

                          - **BackgroundOpacity** *(integer) --* Specifies the opacity of the
                          background rectangle. 255 is opaque; 0 is transparent. Leaving this
                          parameter blank is equivalent to setting it to 0 (transparent). All
                          burn-in and DVB-Sub font settings must match.

                          - **FontColor** *(string) --* Specifies the color of the burned-in
                          captions. This option is not valid for source captions that are STL,
                          608/embedded or teletext. These source settings are already pre-defined by
                          the caption stream. All burn-in and DVB-Sub font settings must match.

                          - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in
                          captions. 255 is opaque; 0 is transparent. All burn-in and DVB-Sub font
                          settings must match.

                          - **FontResolution** *(integer) --* Font resolution in DPI (dots per
                          inch); default is 96 dpi. All burn-in and DVB-Sub font settings must
                          match.

                          - **FontScript** *(string) --* Provide the font script, using an ISO 15924
                          script code, if the LanguageCode is not sufficient for determining the
                          script type. Where LanguageCode or CustomLanguageCode is sufficient, use
                          "AUTOMATIC" or leave unset. This is used to help determine the appropriate
                          font for rendering DVB-Sub captions.

                          - **FontSize** *(integer) --* A positive integer indicates the exact font
                          size in points. Set to 0 for automatic font size selection. All burn-in
                          and DVB-Sub font settings must match.

                          - **OutlineColor** *(string) --* Specifies font outline color. This option
                          is not valid for source captions that are either 608/embedded or teletext.
                          These source settings are already pre-defined by the caption stream. All
                          burn-in and DVB-Sub font settings must match.

                          - **OutlineSize** *(integer) --* Specifies font outline size in pixels.
                          This option is not valid for source captions that are either 608/embedded
                          or teletext. These source settings are already pre-defined by the caption
                          stream. All burn-in and DVB-Sub font settings must match.

                          - **ShadowColor** *(string) --* Specifies the color of the shadow cast by
                          the captions. All burn-in and DVB-Sub font settings must match.

                          - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow.
                          255 is opaque; 0 is transparent. Leaving this parameter blank is
                          equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font
                          settings must match.

                          - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels to the left. All burn-in and DVB-Sub font settings
                          must match.

                          - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the
                          shadow relative to the captions in pixels. A value of -2 would result in a
                          shadow offset 2 pixels above the text. All burn-in and DVB-Sub font
                          settings must match.

                          - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are
                          standard or for hearing impaired. Choose hearing impaired if your
                          subtitles include audio descriptions and dialogue. Choose standard if your
                          subtitles include only dialogue.

                          - **TeletextSpacing** *(string) --* Only applies to jobs with input
                          captions in Teletext or STL formats. Specify whether the spacing between
                          letters in your captions is set by the captions grid or varies depending
                          on letter width. Choose fixed grid to conform to the spacing specified in
                          the captions file more accurately. Choose proportional to make the text
                          easier to read if the captions are closed caption.

                          - **XPosition** *(integer) --* Specifies the horizontal position of the
                          caption relative to the left side of the output in pixels. A value of 10
                          would result in the captions starting 10 pixels from the left of the
                          output. If no explicit x_position is provided, the horizontal caption
                          position will be determined by the alignment parameter. This option is not
                          valid for source captions that are STL, 608/embedded or teletext. These
                          source settings are already pre-defined by the caption stream. All burn-in
                          and DVB-Sub font settings must match.

                          - **YPosition** *(integer) --* Specifies the vertical position of the
                          caption relative to the top of the output in pixels. A value of 10 would
                          result in the captions starting 10 pixels from the top of the output. If
                          no explicit y_position is provided, the caption will be positioned towards
                          the bottom of the output. This option is not valid for source captions
                          that are STL, 608/embedded or teletext. These source settings are already
                          pre-defined by the caption stream. All burn-in and DVB-Sub font settings
                          must match.

                        - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                        embedded/ancillary caption outputs, including 608/708 Channel destination
                        number.

                          - **Destination608ChannelNumber** *(integer) --* Ignore this setting
                          unless your input captions are SCC format and your output captions are
                          embedded in the video stream. Specify a CC number for each captions
                          channel in this output. If you have two channels, choose CC numbers that
                          aren't in the same field. For example, choose 1 and 3. For more
                          information, see
                          https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                          - **Destination708ServiceNumber** *(integer) --* Ignore this setting
                          unless your input captions are SCC format and you want both 608 and 708
                          captions embedded in your output stream. Optionally, specify the 708
                          service number for each output captions channel. Choose a different number
                          for each channel. To use this setting, also set Force 608 to 708 upconvert
                          (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
                          settings. If you choose to upconvert but don't specify a 708 service
                          number, MediaConvert uses the number that you specify for CC channel
                          number (destination608ChannelNumber) for the 708 service number. For more
                          information, see
                          https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                        - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption
                        outputs.

                          - **StylePassthrough** *(string) --* Keep this setting enabled to have
                          MediaConvert use the font style and position information from the captions
                          source in the output. This option is available only when your input
                          captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
                          simplified output captions.

                        - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                          - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to
                          make sure that the captions and the video are synchronized in the output.
                          Specify a frame rate that matches the frame rate of the associated video.
                          If the video frame rate is 29.97, choose 29.97 dropframe
                          (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
                          drop_frame_timecode=
                              true; otherwise, choose 29.97 non-dropframe
                          (FRAMERATE_29_97_NON_DROPFRAME).

                        - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption
                        output

                          - **PageNumber** *(string) --* Set pageNumber to the Teletext page number
                          for the destination captions for this output. This value must be a
                          three-digit hexadecimal string; strings ending in -FF are invalid. If you
                          are passing through the entire set of Teletext data, do not use this
                          field.

                          - **PageTypes** *(list) --* Specify the page types for this Teletext page.
                          If you don't specify a value here, the service sets the page type to the
                          default value Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the
                          entire set of Teletext data, don't use this field. When you pass through a
                          set of Teletext pages, your output has the same page types as your input.

                            - *(string) --* A page type as defined in the standard ETSI EN 300 468,
                            Table 94

                        - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption
                        outputs, including Pass style information (TtmlStylePassthrough).

                          - **StylePassthrough** *(string) --* Pass through style and position
                          information from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the
                          CFF-TT output or TTML output.

                      - **LanguageCode** *(string) --* Specify the language of this captions output
                      track. For most captions output formats, the encoder puts this language
                      information in the output captions metadata. If your output captions format is
                      DVB-Sub or Burn in, the encoder uses this language information to choose the
                      font language for rendering the captions text.

                      - **LanguageDescription** *(string) --* Specify a label for this set of output
                      captions. For example, "English", "Director commentary", or "track_2". For
                      streaming outputs, MediaConvert passes this information into destination
                      manifests for display on the end-viewer's player device. For outputs in other
                      output groups, the service ignores this setting.

                  - **ContainerSettings** *(dict) --* Container specific settings.

                    - **Container** *(string) --* Container for this output. Some containers require
                    a container settings object. If not specified, the default object will be
                    created.

                    - **F4vSettings** *(dict) --* Settings for F4v container

                      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV
                      atom is relocated to the beginning of the archive as required for progressive
                      downloading. Otherwise it is placed normally at the end.

                    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to
                    outputs in a File output group when the output's container (ContainerType) is
                    MPEG-2 Transport Stream (M2TS). In these assets, data is organized by the
                    program map table (PMT). Each transport stream program contains subsets of data,
                    including audio, video, and metadata. Each of these subsets of data has a
                    numerical label called a packet identifier (PID). Each transport stream program
                    corresponds to one MediaConvert output. The PMT lists the types of data in a
                    program along with their PID. Downstream systems and players use the program map
                    table to look up the PID for each type of data it accesses and then uses the
                    PIDs to locate specific data within the asset.

                      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer
                      models for Dolby Digital audio.

                      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert
                      for each PES packet.

                      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any
                      elementary audio streams you include in this output. Specify multiple PIDs as
                      a JSON array. Default is the range 482-492.

                        - *(integer) --*

                      - **Bitrate** *(integer) --* Specify the output bitrate of the transport
                      stream in bits per second. Setting to 0 lets the muxer automatically determine
                      the appropriate bitrate. Other common values are 3750000, 7500000, and
                      15000000.

                      - **BufferModel** *(string) --* Controls what buffer model to use for accurate
                      interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE,
                      this can lead to lower latency, but low-memory devices may not be able to play
                      back the stream without interruptions.

                      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT)
                      at the specified table repetition interval.

                        - **NetworkId** *(integer) --* The numeric value placed in the Network
                        Information Table (NIT).

                        - **NetworkName** *(string) --* The network name text placed in the
                        network_name_descriptor inside the Network Information Table. Maximum length
                        is 256 characters.

                        - **NitInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT)
                      at the specified table repetition interval.

                        - **OutputSdt** *(string) --* Selects method of inserting SDT information
                        into output stream. "Follow input SDT" copies SDT information from input
                        stream to output stream. "Follow input SDT if present" copies SDT
                        information from input stream to output stream if SDT information is present
                        in the input, otherwise it will fall back on the user-defined values. Enter
                        "SDT Manually" means user will enter the SDT information. "No SDT" means
                        output stream will not contain SDT information.

                        - **SdtInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                        - **ServiceName** *(string) --* The service name placed in the
                        service_descriptor in the Service Description Table. Maximum length is 256
                        characters.

                        - **ServiceProviderName** *(string) --* The service provider name placed in
                        the service_descriptor in the Service Description Table. Maximum length is
                        256 characters.

                      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB
                      subtitle data included in this output. Specify multiple PIDs as a JSON array.
                      Default is the range 460-479.

                        - *(integer) --*

                      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
                      specified table repetition interval.

                        - **TdtInterval** *(integer) --* The number of milliseconds between
                        instances of this table in the output transport stream.

                      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for
                      DVB teletext data you include in this output. Default is 499.

                      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS,
                      audio EBP markers will be added to partitions 3 and 4. The interval between
                      these additional markers will be fixed, and will be slightly shorter than the
                      video EBP marker interval. When set to VIDEO_INTERVAL, these additional
                      markers will not be inserted. Only applicable when EBP segmentation markers
                      are is selected (segmentationMarkers is EBP or EBP_LEGACY).

                      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on.
                      They can either be placed only on the video PID, or on both the video PID and
                      all audio PIDs. Only applicable when EBP segmentation markers are is selected
                      (segmentationMarkers is EBP or EBP_LEGACY).

                      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field
                      in the PES header.

                      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT)
                      unless you know that your audio EBP markers are incorrectly appearing before
                      your video EBP markers. To correct this problem, set this value to Force
                      (FORCE).

                      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only
                      used with EBP markers.

                      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds,
                      between Program Clock References (PCRs) inserted into the transport stream.

                      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary
                      Points do not come within the specified time interval of each other by looking
                      ahead at input video. If another EBP is going to come in within the specified
                      time interval, the current EBP is not emitted, and the segment is "stretched"
                      to the next marker. The lookahead value does not add latency to the system.
                      The Live Event must be configured elsewhere to create sufficient latency to
                      make the lookahead accurate.

                      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                      tracking will be detected in the input audio and an equivalent ID3 tag will be
                      inserted in the output.

                      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null
                      packets to insert into the transport stream. This can be used if a downstream
                      encryption system requires periodic null packets.

                      - **PatInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program
                      Clock Reference value is inserted for every Packetized Elementary Stream (PES)
                      header. This is effective only when the PCR PID is the same as the video or
                      audio elementary stream.

                      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the
                      program clock reference (PCR) in this output. If you do not specify a value,
                      the service will use the value for Video PID (VideoPid).

                      - **PmtInterval** *(integer) --* Specify the number of milliseconds between
                      instances of the program map table (PMT) in the output transport stream.

                      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the
                      program map table (PMT) itself. Default is 480.

                      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of
                      the private metadata stream. Default is 503.

                      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to
                      specify the program number used in the program map table (PMT) for this
                      output. Default is 1. Program numbers and program map tables are parts of
                      MPEG-2 transport stream containers, used for organizing data.

                      - **RateMode** *(string) --* When set to CBR, inserts null packets into
                      transport stream to fill specified bitrate. When set to VBR, the bitrate
                      setting acts as the maximum bitrate, but the output will not be padded up to
                      that bitrate.

                      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35
                      markers in your HLS and transport stream outputs at the insertion points that
                      you specify in an ESAM XML document. Provide the document in the setting SCC
                      XML (sccXml).

                        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35
                        stream in the transport stream generated by ESAM.

                      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the
                      SCTE-35 stream in the transport stream.

                      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                      Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your
                      input to also appear in this output. Choose None (NONE) if you don't want
                      SCTE-35 markers in this output. For SCTE-35 markers from an ESAM XML
                      document-- Choose None (NONE). Also provide the ESAM XML as a string in the
                      setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
                      (include the property scte35Esam).

                      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
                      segmentation_time period. rai_segstart sets the Random Access Indicator bit in
                      the adaptation field. rai_adapt sets the RAI bit and adds the current timecode
                      in the private data bytes. psi_segstart inserts PAT and PMT tables at the
                      start of segments. ebp adds Encoder Boundary Point information to the
                      adaptation field as per OpenCable specification OC-SP-EBP-I01-130118.
                      ebp_legacy adds Encoder Boundary Point information to the adaptation field
                      using a legacy proprietary format.

                      - **SegmentationStyle** *(string) --* The segmentation style parameter
                      controls how segmentation markers are inserted into the transport stream. With
                      avails, it is possible that segments may be truncated, which can influence
                      where future segmentation markers are inserted. When a segmentation style of
                      "reset_cadence" is selected and a segment is truncated due to an avail, we
                      will reset the segmentation cadence. This means the subsequent segment will
                      have a duration of of $segmentation_time seconds. When a segmentation style of
                      "maintain_cadence" is selected and a segment is truncated due to an avail, we
                      will not reset the segmentation cadence. This means the subsequent segment
                      will likely be truncated as well. However, all segments after that will have a
                      duration of $segmentation_time seconds. Note that EBP lookahead is a slight
                      exception to this rule.

                      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each
                      segment. Required unless markers is set to _none_.

                      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for
                      timed metadata in this output. Default is 502.

                      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream
                      itself in the program map table for this output. Transport stream IDs and
                      program map tables are parts of MPEG-2 transport stream containers, used for
                      organizing data.

                      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the
                      elementary video stream in the transport stream.

                    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

                      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert
                      for each PES packet.

                      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio
                      stream(s) in the transport stream. Multiple values are accepted, and can be
                      entered in ranges and/or by comma separation.

                        - *(integer) --*

                      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media
                      tracking will be detected in the input audio and an equivalent ID3 tag will be
                      inserted in the output.

                      - **PatInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program
                      Clock Reference value is inserted for every Packetized Elementary Stream (PES)
                      header. This parameter is effective only when the PCR PID is the same as the
                      video or audio elementary stream.

                      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock
                      Reference (PCR) in the transport stream. When no value is given, the encoder
                      will assign the same value as the Video PID.

                      - **PmtInterval** *(integer) --* The number of milliseconds between instances
                      of this table in the output transport stream.

                      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table
                      (PMT) in the transport stream.

                      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
                      metadata stream in the transport stream.

                      - **ProgramNumber** *(integer) --* The value of the program number field in
                      the Program Map Table.

                      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream
                      in the transport stream.

                      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
                      Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your
                      input to also appear in this output. Choose None (NONE) if you don't want
                      SCTE-35 markers in this output. For SCTE-35 markers from an ESAM XML
                      document-- Choose None (NONE) if you don't want manifest conditioning. Choose
                      Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want
                      manifest conditioning. In both cases, also provide the ESAM XML as a string in
                      the setting Signal processing notification XML (sccXml).

                      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this
                      setting to specify whether the service inserts the ID3 timed metadata from the
                      input in this output.

                      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed
                      metadata stream in the transport stream.

                      - **TransportStreamId** *(integer) --* The value of the transport stream ID
                      field in the Program Map Table.

                      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video
                      stream in the transport stream.

                    - **MovSettings** *(dict) --* Settings for MOV Container.

                      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate
                      for the video output settings.

                      - **CslgAtom** *(string) --* When enabled, file composition times will start
                      at zero, composition times in the 'ctts' (composition time to sample) box for
                      B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                      will be included per 14496-1 amendment 1. This improves compatibility with
                      Apple players and tools.

                      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video
                      streams into the QuickTime file using XDCAM fourcc codes. This increases
                      compatibility with Apple editors and players, but may decrease compatibility
                      with other players. Only applicable when the video codec is MPEG2.

                      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible
                      padding

                      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED)
                      for this setting.

                    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create
                    audio-only AAC outputs with this container.

                      - **CslgAtom** *(string) --* When enabled, file composition times will start
                      at zero, composition times in the 'ctts' (composition time to sample) box for
                      B-frames will be negative, and a 'cslg' (composition shift least greatest) box
                      will be included per 14496-1 amendment 1. This improves compatibility with
                      Apple players and tools.

                      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after
                      the moov box.

                      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV
                      atom is relocated to the beginning of the archive as required for progressive
                      downloading. Otherwise it is placed normally at the end.

                      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the
                      output file. Usually not necessary to specify.

                    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

                      - **CaptionContainerType** *(string) --* Use this setting only in DASH output
                      groups that include sidecar TTML or IMSC captions. You specify sidecar
                      captions in a separate output from your audio and video. Choose Raw (RAW) for
                      captions in a single XML file in a raw container. Choose Fragmented MPEG-4
                      (FRAGMENTED_MP4) for captions in XML format contained within fragmented MP4
                      files. This set of fragmented MP4 files is separate from your video and audio
                      fragmented MP4 files.

                      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35
                      markers from ESAM. Choose INSERT to put SCTE-35 markers in this output at the
                      insertion points that you specify in an ESAM XML document. Provide the
                      document in the setting SCC XML (sccXml).

                      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35
                      markers in your input video file. Choose Passthrough (PASSTHROUGH) if you want
                      SCTE-35 markers that appear in your input to also appear in this output.
                      Choose None (NONE) if you don't want those SCTE-35 markers in this output.

                  - **Extension** *(string) --* Use Extension (Extension) to specify the file
                  extension for outputs in File output groups. If you do not specify a value, the
                  service will use default extensions by container type as follows * MPEG-2
                  transport stream, m2ts * Quicktime, mov * MXF container, mxf * MPEG-4 container,
                  mp4 * No Container, the service will use codec extensions (e.g. AAC, H265, H265,
                  AC3)

                  - **NameModifier** *(string) --* Use Name modifier (NameModifier) to have the
                  service add a string to the end of each output filename. You specify the base
                  filename as part of your destination URI. When you create multiple outputs in the
                  same output group, Name modifier (NameModifier) is required. Name modifier also
                  accepts format identifiers. For DASH ISO outputs, if you use the format
                  identifiers $Number$ or $Time$ in one output, you must use them in the same way in
                  all outputs of the output group.

                  - **OutputSettings** *(dict) --* Specific settings for this type of output.

                    - **HlsSettings** *(dict) --* Settings for HLS output groups

                      - **AudioGroupId** *(string) --* Specifies the group to which the audio
                      Rendition belongs.

                      - **AudioOnlyContainer** *(string) --* Use this setting only in audio-only
                      outputs. Choose MPEG-2 Transport Stream (M2TS) to create a file in an MPEG2-TS
                      container. Keep the default value Automatic (AUTOMATIC) to create an
                      audio-only file in a raw container. Regardless of the value that you specify
                      here, if this output has video, the service will place the output into an
                      MPEG2-TS container.

                      - **AudioRenditionSets** *(string) --* List all the audio groups that are used
                      with the video output stream. Input all the audio GROUP-IDs that are
                      associated to the video, separate by ','.

                      - **AudioTrackType** *(string) --* Four types of audio-only tracks are
                      supported: Audio-Only Variant Stream The client can play back this audio-only
                      stream instead of video in low-bandwidth scenarios. Represented as an
                      EXT-X-STREAM-INF in the HLS manifest. Alternate Audio, Auto Select, Default
                      Alternate rendition that the client should try to play back by default.
                      Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=YES,
                      AUTOSELECT=
                          YES Alternate Audio, Auto Select, Not Default Alternate rendition
                      that the client may try to play back by default. Represented as an EXT-X-MEDIA
                      in the HLS manifest with DEFAULT=NO, AUTOSELECT=
                          YES Alternate Audio, not Auto
                      Select Alternate rendition that the client will not try to play back by
                      default. Represented as an EXT-X-MEDIA in the HLS manifest with DEFAULT=NO,
                      AUTOSELECT=NO

                      - **IFrameOnlyManifest** *(string) --* When set to INCLUDE, writes I-Frame
                      Only Manifest in addition to the HLS manifest

                      - **SegmentModifier** *(string) --* String concatenated to end of segment
                      filenames. Accepts "Format Identifiers":#format_identifier_parameters.

                  - **Preset** *(string) --* Use Preset (Preset) to specifiy a preset for your
                  transcoding settings. Provide the system or custom preset name. You can specify
                  either Preset (Preset) or Container settings (ContainerSettings), but not both.

                  - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video
                  encoding settings. The specific video settings depend on the video codec that you
                  choose when you specify a value for Video codec (codec). Include one instance of
                  (VideoDescription) per output.

                    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and
                    MPEG2 outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the
                    service includes AFD values in the output video data and what those values are.
                    * Choose None to remove all AFD values from this output. * Choose Fixed to
                    ignore input AFD values and instead encode the value specified in the job. *
                    Choose Auto to calculate output AFD values based on the input AFD scaler data.

                    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to
                    all outputs. The service no longer accepts the value DISABLED for AntiAlias. If
                    you specify that in your job, the service will ignore the setting.

                    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
                    (VideoDescription), contains the group of settings related to video encoding.
                    The settings in this group vary depending on the value that you choose for Video
                    codec (Codec). For each codec enum that you choose, define the corresponding
                    settings object. The following lists the codec enum, settings object pairs. *
                    H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
                    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

                      - **Codec** *(string) --* Specifies the video codec. This must be equal to one
                      of the enum values defined by the object VideoCodec.

                      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                        - **FramerateDenominator** *(integer) --* Frame capture will encode the
                        first frame of the output stream, then one frame every
                        framerateDenominator/framerateNumerator seconds. For example, settings of
                        framerateNumerator = 1 and framerateDenominator =
                             3 (a rate of 1/3 frame per
                        second) will capture the first frame, then 1 frame every 3s. Files will be
                        named as filename.n.jpg where n is the 0-based sequence number of each
                        Capture.

                        - **FramerateNumerator** *(integer) --* Frame capture will encode the first
                        frame of the output stream, then one frame every
                        framerateDenominator/framerateNumerator seconds. For example, settings of
                        framerateNumerator = 1 and framerateDenominator =
                             3 (a rate of 1/3 frame per
                        second) will capture the first frame, then 1 frame every 3s. Files will be
                        named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number
                        zero padded to 7 decimal places.

                        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg
                        output files).

                        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher
                        quality.

                      - **H264Settings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value H_264.

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent
                        with your output video settings. If you aren't sure what level to specify,
                        choose Auto (AUTO).

                        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit
                        profiles are only available with the AVC-I License.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must
                        be in Main or High profile) or CAVLC.

                        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF
                        encoding for interlaced outputs.

                        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame to reduce flicker or 'pop' on I-frames.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job specification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* When you use the API for transcode
                        jobs that use frame rate conversion, specify the frame rate as a fraction.
                        For example, 24000 / 1001 =
                             23.976 fps. Use FramerateDenominator to specify
                        the denominator of this fraction. In this example, use 1001 for the value of
                        FramerateDenominator. When you use the console for transcode jobs that use
                        frame rate conversion, provide the value as a decimal number for Framerate.
                        In this example, specify 23.976.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                        structures that have B frames > 1.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type, as follows. - If the source is
                        interlaced, the output will be interlaced with the same polarity as the
                        source (it will follow the source). The output could therefore be a mix of
                        "top field first" and "bottom field first". - If the source is progressive,
                        the output will be interlaced with "top field first" or "bottom field first"
                        polarity, depending on which of the Follow options you chose.

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000. Required when Rate control mode
                        is QVBR.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **NumberReferenceFrames** *(integer) --* Number of reference frames to
                        use. The encoder may use more than requested if using B-frames and/or
                        interlaced encoding.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (H264QualityTuningLevel) to specifiy whether to use fast single-pass,
                        high-quality singlepass, or high-quality multipass video encoding.

                        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                        encoding with the H.264 codec. Required when you set Rate control mode to
                        QVBR. Not valid when you set Rate control mode to a value other than QVBR,
                        or when you don't define Rate control mode.

                          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                          control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                          average bitrate values suited to the complexity of your input video, the
                          service limits the average bitrate of the video part of this output to the
                          value that you choose. That is, the total size of the video element is
                          less than or equal to the value you set multiplied by the number of
                          seconds of encoded output.

                          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                          control mode. That is, when you specify qvbrSettings within h264Settings.
                          Specify the target quality level for this output, from 1 to 10. Use higher
                          numbers for greater quality. Level 10 results in nearly lossless
                          compression. The quality level for most broadcast-quality transcodes is
                          between 6 and 9.

                        - **RateControlMode** *(string) --* Use this setting to specify whether this
                        output has a variable bitrate (VBR), constant bitrate (CBR) or
                        quality-defined variable bitrate (QVBR).

                        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture,
                        even if repeated.

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default. If this output uses QVBR, choose
                        Transition detection (TRANSITION_DETECTION) for further video quality
                        improvement. For more information about QVBR, see
                        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                        - **Slices** *(integer) --* Number of slices per picture. Must be less than
                        or equal to the number of macroblock rows for progressive pictures, and less
                        than or equal to half the number of macroblock rows for interlaced pictures.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                        values reduce high-frequency content in the encoded image.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE
                        RP-2027.

                        - **Telecine** *(string) --* This field applies only if the Streams >
                        Advanced > Framerate (framerate) field is set to 29.970. This field works
                        with the Streams > Advanced > Preprocessors > Deinterlacer field
                        (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
                        (interlace_mode) to identify the scan type for the output: Progressive,
                        Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
                        from 23.976 input. - Soft: produces 23.976; the player converts this output
                        to 29.97i.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame
                        as 4 bytes of an unregistered SEI message.

                      - **H265Settings** *(dict) --* Settings for H265 codec

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer
                        Function SEI message for outputs using Hybrid Log Gamma (HLG)
                        Electro-Optical Transfer Function (EOTF).

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* H.265 Level.

                        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the
                        HEVC (H.265) specification. Selections are grouped as [Profile] / [Tier], so
                        "Main/High" represents Main Profile with High Tier. 4:2:2 profiles are only
                        available with the HEVC 4:2:2 License.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame to reduce flicker or 'pop' on I-frames.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                        structures that have B frames > 1.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Choose the scan line type for the output.
                        Choose Progressive (PROGRESSIVE) to create a progressive output, regardless
                        of the scan type of your input. Choose Top Field First (TOP_FIELD) or Bottom
                        Field First (BOTTOM_FIELD) to create an output that's interlaced with the
                        same field polarity throughout. Choose Follow, Default Top
                        (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
                        an interlaced output with the same field polarity as the source. If the
                        source is interlaced, the output will be interlaced with the same polarity
                        as the source (it will follow the source). The output could therefore be a
                        mix of "top field first" and "bottom field first". If the source is
                        progressive, your output will be interlaced with "top field first" or
                        "bottom field first" polarity, depending on which of the Follow options you
                        chose. If you don't choose a value, the service will default to Progressive
                        (PROGRESSIVE).

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000. Required when Rate control mode
                        is QVBR.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **NumberReferenceFrames** *(integer) --* Number of reference frames to
                        use. The encoder may use more than requested if using B-frames and/or
                        interlaced encoding.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (H265QualityTuningLevel) to specifiy whether to use fast single-pass,
                        high-quality singlepass, or high-quality multipass video encoding.

                        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                        encoding with the H.265 codec. Required when you set Rate control mode to
                        QVBR. Not valid when you set Rate control mode to a value other than QVBR,
                        or when you don't define Rate control mode.

                          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate
                          control mode is QVBR and Quality tuning level is Multi-pass HQ. For Max
                          average bitrate values suited to the complexity of your input video, the
                          service limits the average bitrate of the video part of this output to the
                          value that you choose. That is, the total size of the video element is
                          less than or equal to the value you set multiplied by the number of
                          seconds of encoded output.

                          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate
                          control mode. That is, when you specify qvbrSettings within h265Settings.
                          Specify the target quality level for this output, from 1 to 10. Use higher
                          numbers for greater quality. Level 10 results in nearly lossless
                          compression. The quality level for most broadcast-quality transcodes is
                          between 6 and 9.

                        - **RateControlMode** *(string) --* Use this setting to specify whether this
                        output has a variable bitrate (VBR), constant bitrate (CBR) or
                        quality-defined variable bitrate (QVBR).

                        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive
                        Offset (SAO) filter strength. Adaptive mode dynamically selects best
                        strength based on content

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default. If this output uses QVBR, choose
                        Transition detection (TRANSITION_DETECTION) for further video quality
                        improvement. For more information about QVBR, see
                        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                        - **Slices** *(integer) --* Number of slices per picture. Must be less than
                        or equal to the number of macroblock rows for progressive pictures, and less
                        than or equal to half the number of macroblock rows for interlaced pictures.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Telecine** *(string) --* This field applies only if the Streams >
                        Advanced > Framerate (framerate) field is set to 29.970. This field works
                        with the Streams > Advanced > Preprocessors > Deinterlacer field
                        (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
                        (interlace_mode) to identify the scan type for the output: Progressive,
                        Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
                        from 23.976 input. - Soft: produces 23.976; the player converts this output
                        to 29.97i.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the
                        encoded bitstream. Up to 3 layers are supported depending on GOP structure:
                        I- and P-frames form one layer, reference B-frames can form a second layer
                        and non-reference b-frames can form a third layer. Decoders can optionally
                        decode only the lower temporal layers to generate a lower frame rate output.
                        For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e.
                        IbPbPb display order), a decoder could decode all the frames for full frame
                        rate output or only the I and P frames (lowest temporal layer) for a half
                        frame rate output.

                        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well
                        as vertical subdivision of the encoded pictures.

                        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame
                        as 4 bytes of an unregistered SEI message.

                        - **WriteMp4PackagingType** *(string) --* If the location of parameter set
                        NAL units doesn't matter in your workflow, ignore this setting. Use this
                        setting only with CMAF or DASH outputs, or with standalone file outputs in
                        an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your output as HVC1.
                        This makes your output compliant with the following specification: ISO
                        IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
                        outputs, the service stores parameter set NAL units in the sample headers
                        but not in the samples directly. For MP4 outputs, when you choose HVC1, your
                        output video might not work properly with some downstream systems and video
                        players. The service defaults to marking your output as HEV1. For these
                        outputs, the service writes parameter set NAL units directly into the
                        samples.

                      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value MPEG2.

                        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows
                        intra-frame quantizers to vary to improve visual quality.

                        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                        Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique
                        when rounded down to the nearest multiple of 1000.

                        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2
                        level for the video output.

                        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the
                        MPEG-2 profile for the video output.

                        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective
                        video quality for high-motion content. This will cause the service to use
                        fewer B-frames (which infer information based on other frames) for
                        high-motion portions of the video and more B-frames for low-motion portions.
                        The maximum number of B-frames is limited by the value you provide for the
                        setting B frames between reference frames
                        (numberBFramesBetweenReferenceFrames).

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is
                        a fraction, e.g. 24000 / 1001 = 23.976 fps.

                        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                        applications, it is recommended that this be set to 1 so a decoder joining
                        mid-stream will receive an IDR frame as quickly as possible. Setting this
                        value to 0 will break output segmenting.

                        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or
                        seconds. Must be greater than zero.

                        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is
                        specified in frames or seconds. If seconds the system will convert the GOP
                        Size into a frame count at run time.

                        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer
                        that should initially be filled (HRD buffer model).

                        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in
                        bits. For example, enter five megabits as 5000000.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type. - If the source is interlaced, the
                        output will be interlaced with the same polarity as the source (it will
                        follow the source). The output could therefore be a mix of "top field first"
                        and "bottom field first". - If the source is progressive, the output will be
                        interlaced with "top field first" or "bottom field first" polarity,
                        depending on which of the Follow options you chose.

                        - **IntraDcPrecision** *(string) --* Use Intra DC precision
                        (Mpeg2IntraDcPrecision) to set quantization precision for intra-block DC
                        coefficients. If you choose the value auto, the service will automatically
                        select the precision based on the per-frame compression ratio.

                        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example,
                        enter five megabits per second as 5000000.

                        - **MinIInterval** *(integer) --* Enforces separation between repeated
                        (cadence) I-frames and I-frames inserted by Scene Change Detection. If a
                        scene change I-frame is within I-interval frames of a cadence I-frame, the
                        GOP is shrunk and/or stretched to the scene change I-frame. GOP stretch
                        requires enabling lookahead as well as setting I-interval. The normal
                        cadence resumes for the next GOP. This setting is only used when Scene
                        Change Detect is enabled. Note: Maximum GOP stretch =
                             GOP size +
                        Min-I-interval - 1

                        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames
                        between reference frames.

                        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you
                        want the service to use the pixel aspect ratio from the input. Using the
                        console, do this by choosing Follow source for Pixel aspect ratio.

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **QualityTuningLevel** *(string) --* Use Quality tuning level
                        (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or
                        multipass video encoding.

                        - **RateControlMode** *(string) --* Use Rate control mode
                        (Mpeg2RateControlMode) to specifiy whether the bitrate is variable (vbr) or
                        constant (cbr).

                        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames
                        at scene changes that the service automatically detects. This improves video
                        quality and is enabled by default.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger
                        values reduce high-frequency content in the encoded image.

                        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on spatial variation of content complexity.

                        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                        356M-2001).

                        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                        Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard)
                        to produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to
                        produce 23.976 output and leave converstion to the player.

                        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within
                        each frame based on temporal variation of content complexity.

                      - **ProresSettings** *(dict) --* Required when you set (Codec) under
                      (VideoDescription)>(CodecSettings) to the value PRORES.

                        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to
                        specifiy the type of Apple ProRes codec to use for this output.

                        - **FramerateControl** *(string) --* If you are using the console, use the
                        Framerate setting to specify the frame rate for this output. If you want to
                        keep the same frame rate as the input video, choose Follow source. If you
                        want to do frame rate conversion, choose a frame rate from the dropdown list
                        or choose Custom. The framerates shown in the dropdown list are decimal
                        approximations of fractions. If you choose Custom, specify your frame rate
                        as a fraction. If you are creating your transcoding job sepecification as a
                        JSON file without the console, use FramerateControl to specify which value
                        the service uses for the frame rate for this output. Choose
                        INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
                        the input. Choose SPECIFIED if you want the service to use the frame rate
                        you specify in the settings FramerateNumerator and FramerateDenominator.

                        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE,
                        produces smoother motion during frame rate conversion.

                        - **FramerateDenominator** *(integer) --* Frame rate denominator.

                        - **FramerateNumerator** *(integer) --* When you use the API for transcode
                        jobs that use frame rate conversion, specify the frame rate as a fraction.
                        For example, 24000 / 1001 =
                             23.976 fps. Use FramerateNumerator to specify
                        the numerator of this fraction. In this example, use 24000 for the value of
                        FramerateNumerator.

                        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to
                        choose the scan line type for the output. * Top Field First (TOP_FIELD) and
                        Bottom Field First (BOTTOM_FIELD) produce interlaced output with the entire
                        output having the same field polarity (top or bottom first). * Follow,
                        Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
                        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
                        behavior depends on the input scan type. - If the source is interlaced, the
                        output will be interlaced with the same polarity as the source (it will
                        follow the source). The output could therefore be a mix of "top field first"
                        and "bottom field first". - If the source is progressive, the output will be
                        interlaced with "top field first" or "bottom field first" polarity,
                        depending on which of the Follow options you chose.

                        - **ParControl** *(string) --* Use (ProresParControl) to specify how the
                        service determines the pixel aspect ratio. Set to Follow source
                        (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio from the input. To
                        specify a different pixel aspect ratio: Using the console, choose it from
                        the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
                        provide for (ParNumerator) and (ParDenominator).

                        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and
                        24fps input is relabeled as 25fps, and audio is sped up correspondingly.

                        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                        Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard
                        (hard) to produce a 29.97i output from a 23.976 input. Set it to Soft (soft)
                        to produce 23.976 output and leave converstion to the player.

                    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to
                    include color metadata in this output. Choose Ignore (IGNORE) to exclude color
                    metadata from this output. If you don't specify a value, the service sets this
                    to Insert by default.

                    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area
                    that the service will include in the output video frame.

                      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                      numbers.

                      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                      numbers.

                      - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                      left edge of the video frame. Specify only even numbers.

                      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                      top edge of the video frame. Specify only even numbers.

                    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When
                    this feature is enabled, the service will use drop-frame timecode on outputs. If
                    it is not possible to use drop-frame timecode, the system will fall back to
                    non-drop-frame. This setting is enabled by default when Timecode insertion
                    (TimecodeInsertion) is enabled.

                    - **FixedAfd** *(integer) --* Applies only if you set AFD
                    Signaling(AfdSignaling) to Fixed (FIXED). Use Fixed (FixedAfd) to specify a
                    four-bit AFD value which the service will write on all frames of this video
                    output.

                    - **Height** *(integer) --* Use the Height (Height) setting to define the video
                    resolution height for this output. Specify in pixels. If you don't provide a
                    value here, the service will use the input height.

                    - **Position** *(dict) --* Use Selection placement (position) to define the
                    video area in your output frame. The area outside of the rectangle that you
                    specify here is black.

                      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even
                      numbers.

                      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even
                      numbers.

                      - **X** *(integer) --* The distance, in pixels, between the rectangle and the
                      left edge of the video frame. Specify only even numbers.

                      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the
                      top edge of the video frame. Specify only even numbers.

                    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify
                    how the service changes the video itself in response to AFD values in the input.
                    * Choose Respond to clip the input video frame according to the AFD value, input
                    display aspect ratio, and output display aspect ratio. * Choose Passthrough to
                    include the input AFD values. Do not choose this when AfdSignaling is set to
                    (NONE). A preferred implementation of this workflow is to set RespondToAfd to
                    (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
                    values from this output.

                    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that
                    have a different aspect ratio from the input aspect ratio. Choose Stretch to
                    output (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit.
                    Keep the setting Default (DEFAULT) to have the service letterbox your video
                    instead. This setting overrides any value that you specify for the setting
                    Selection placement (position) in this output.

                    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the
                    strength of anti-aliasing. This setting changes the width of the anti-alias
                    filter kernel used for scaling. Sharpness only applies if your output resolution
                    is different from your input resolution. 0 is the softest setting, 100 the
                    sharpest, and 50 recommended for most content.

                    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and
                    ProRes outputs. Only enable Timecode insertion when the input frame rate is
                    identical to the output frame rate. To include timecodes in this output, set
                    Timecode insertion (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them
                    out, set it to DISABLED. Default is DISABLED. When the service inserts timecodes
                    in an output, by default, it uses any embedded timecodes from the input. If none
                    are present, the service will set the timecode for the first output frame to
                    zero. To change this default behavior, adjust the settings under Timecode
                    configuration (TimecodeConfig). In the console, these settings are located under
                    Job > Job settings > Timecode configuration. Note - Timecode source under input
                    settings (InputTimecodeSource) does not affect the timecodes that are inserted
                    in the output. Source under Job settings > Timecode configuration
                    (TimecodeSource) does.

                    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
                    Preprocessors (VideoPreprocessors). Enable the features at each output
                    individually. These features are disabled by default.

                      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector)
                      feature if necessary. Enable or disable this feature for each output
                      individually. This setting is disabled by default.

                        - **Brightness** *(integer) --* Brightness level.

                        - **ColorSpaceConversion** *(string) --* Specify the color space you want
                        for this output. The service supports conversion between HDR formats,
                        between SDR formats, and from SDR to HDR. The service doesn't support
                        conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
                        dynamic range. The converted video has an HDR format, but visually appears
                        the same as an unconverted output.

                        - **Contrast** *(integer) --* Contrast level.

                        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the
                        HDR 10 color space. Specify the SMPTE ST 2086 Mastering Display Color Volume
                        static metadata that you want signaled in the output. These values don't
                        affect the pixel values that are encoded in the video stream. They are
                        intended to help the downstream video player display content in a way that
                        reflects the intentions of the the content creator. When you set Color space
                        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings
                        are required. You must set values for Max frame average light level
                        (maxFrameAverageLightLevel) and Max content light level
                        (maxContentLightLevel); these settings don't have a default value. The
                        default values for the other HDR 10 metadata settings are defined by the
                        P3D65 color space. For more information about MediaConvert HDR jobs, see
                        https://docs.aws.amazon.com/console/mediaconvert/hdr.

                          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **MaxContentLightLevel** *(integer) --* Maximum light level among all
                          samples in the coded video sequence, in units of candelas per square
                          meter. This setting doesn't have a default value; you must specify a value
                          that is suitable for the content.

                          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level
                          of any frame in the coded video sequence, in units of candelas per square
                          meter. This setting doesn't have a default value; you must specify a value
                          that is suitable for the content.

                          - **MaxLuminance** *(integer) --* Nominal maximum mastering display
                          luminance in units of of 0.0001 candelas per square meter.

                          - **MinLuminance** *(integer) --* Nominal minimum mastering display
                          luminance in units of of 0.0001 candelas per square meter

                          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **WhitePointX** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                          - **WhitePointY** *(integer) --* HDR Master Display Information must be
                          provided by a color grader, using color grading tools. Range is 0 to
                          50,000, each increment represents 0.00002 in CIE1931 color coordinate.
                          Note that this setting is not for color correction.

                        - **Hue** *(integer) --* Hue in degrees.

                        - **Saturation** *(integer) --* Saturation level.

                      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce
                      smoother motion and a clearer picture.

                        - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                        (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE).
                        Motion adaptive interpolate (INTERPOLATE) produces sharper pictures, while
                        blend (BLEND) produces smoother motion. Use (INTERPOLATE_TICKER) OR
                        (BLEND_TICKER) if your source file includes a ticker, such as a scrolling
                        headline at the bottom of the frame.

                        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer
                        does not convert frames that are tagged in metadata as progressive. It will
                        only convert those that are tagged as some other type. - When set to
                        FORCE_ALL_FRAMES, the deinterlacer converts every frame to progressive -
                        even those that are already tagged as progressive. Turn Force mode on only
                        if there is a good chance that the metadata has tagged frames as progressive
                        when they are not progressive. Do not turn on otherwise; processing frames
                        that are already progressive into progressive will probably result in lower
                        quality video.

                        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how
                        the service will do deinterlacing. Default is Deinterlace. - Deinterlace
                        converts interlaced to progressive. - Inverse telecine converts Hard
                        Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects and converts
                        to progressive.

                      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby
                      Vision compatible video output.

                        - **L6Metadata** *(dict) --* Use these settings when you set
                        DolbyVisionLevel6Mode to SPECIFY to override the MaxCLL and MaxFALL values
                        in your input with new values.

                          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR
                          metadata that corresponds to the brightest pixel in the entire stream.
                          Measured in nits.

                          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                          metadata that corresponds to the highest frame-average brightness in the
                          entire stream. Measured in nits.

                        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service
                        will handle Dolby Vision MaxCLL and MaxFALL properies.

                        - **Profile** *(string) --* In the current MediaConvert implementation, the
                        Dolby Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs
                        must contain Dolby Vision frame interleaved data.

                      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter)
                      feature to include a graphic overlay on your video. Enable or disable this
                      feature for each output individually. This setting is disabled by default.

                        - **InsertableImages** *(list) --* Specify the images that you want to
                        overlay on your video. The images must be PNG or TGA files.

                          - *(dict) --* Settings that specify how your still graphic overlay
                          appears.

                            - **Duration** *(integer) --* Specify the time, in milliseconds, for the
                            image to remain on the output video. This duration includes fade-in time
                            but not fade-out time.

                            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds,
                            between the Start time that you specify for the image insertion and the
                            time that the image appears at full opacity. Full opacity is the level
                            that you specify for the opacity setting. If you don't specify a value
                            for Fade-in, the image will appear abruptly at the overlay start time.

                            - **FadeOut** *(integer) --* Specify the length of time, in
                            milliseconds, between the end of the time that you have specified for
                            the image overlay Duration and when the overlaid image has faded to
                            total transparency. If you don't specify a value for Fade-out, the image
                            will disappear abruptly at the end of the inserted image duration.

                            - **Height** *(integer) --* Specify the height of the inserted image in
                            pixels. If you specify a value that's larger than the video resolution
                            height, the service will crop your overlaid image to fit. To use the
                            native height of the image, keep this setting blank.

                            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or
                            Amazon S3 location of the image that you want to overlay on the video.
                            Use a PNG or TGA file.

                            - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                            inserted image and the left edge of the video frame. Required for any
                            image overlay that you specify.

                            - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                            overlaid image and the top edge of the video frame. Required for any
                            image overlay that you specify.

                            - **Layer** *(integer) --* Specify how overlapping inserted images
                            appear. Images with higher values for Layer appear on top of images with
                            lower values for Layer.

                            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much
                            of the underlying video shows through the inserted image. 0 is
                            transparent and 100 is fully opaque. Default is 50.

                            - **StartTime** *(string) --* Specify the timecode of the frame that you
                            want the overlay to first appear on. This must be in timecode
                            (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take into account your
                            timecode source settings.

                            - **Width** *(integer) --* Specify the width of the inserted image in
                            pixels. If you specify a value that's larger than the video resolution
                            width, the service will crop your overlaid image to fit. To use the
                            native width of the image, keep this setting blank.

                      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature
                      to remove noise from your video output if necessary. Enable or disable this
                      feature for each output individually. This setting is disabled by default.

                        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to
                        select one of the following spatial image filtering functions. To use this
                        setting, you must also enable Noise reducer (NoiseReducer). * Bilateral
                        preserves edges while reducing noise. * Mean (softest), Gaussian, Lanczos,
                        and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
                        noise reduction. * Spatial does frequency-domain filtering based on JND
                        principles. * Temporal optimizes video quality for complex motion.

                        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                          - **Strength** *(integer) --* Relative strength of noise reducing filter.
                          Higher values produce stronger filtering.

                        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for
                        spatial filter.

                          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post
                          noise reduction sharpening filter, with 0 disabling the filter and 3
                          enabling it at maximum strength.

                          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed)
                          to 3 (higher speed), with 0 being the nominal value.

                          - **Strength** *(integer) --* Relative strength of noise reducing filter.
                          Higher values produce stronger filtering.

                        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for
                        temporal filter.

                          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that
                          has complex motion. Higher values produce stronger temporal filtering.
                          This filters highly complex scenes more aggressively and creates better VQ
                          for low bitrate outputs.

                          - **Speed** *(integer) --* The speed of the filter (higher number is
                          faster). Low setting reduces bit rate at the cost of transcode time, high
                          setting improves transcode time at the cost of bit rate.

                          - **Strength** *(integer) --* Specify the strength of the noise reducing
                          filter on this output. Higher values produce stronger filtering. We
                          recommend the following value ranges, depending on the result that you
                          want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
                          complexity reduction with image preservation * 8-16 for a high level of
                          complexity reduction

                      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the
                      output timecode and specified prefix into the output.

                        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size
                        of any burned-in timecode. Valid values are 10, 16, 32, 48.

                        - **Position** *(string) --* Use Position (Position) under under Timecode
                        burn-in (TimecodeBurnIn) to specify the location the burned-in timecode on
                        output video.

                        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters
                        before any burned-in timecode. For example, a prefix of "EZ-" will result in
                        the timecode "EZ-00:00:00:00". Provide either the characters themselves or
                        the ASCII code equivalents. The supported range of characters is 0x20
                        through 0x7e. This includes letters, numbers, and all special characters
                        represented on a standard English keyboard.

                    - **Width** *(integer) --* Use Width (Width) to define the video resolution
                    width, in pixels, for this output. If you don't provide a value here, the
                    service will use the input width.

          - **TimecodeConfig** *(dict) --* Contains settings used to acquire and adjust timecode
          information from inputs.

            - **Anchor** *(string) --* If you use an editing platform that relies on an anchor
            timecode, use Anchor Timecode (Anchor) to specify a timecode that will match the input
            video frame to the output video frame. Use 24-hour format with frame number,
            (HH:MM:SS:FF) or (HH:MM:SS;FF). This setting ignores frame rate conversion. System
            behavior for Anchor Timecode varies depending on your setting for Source
            (TimecodeSource). * If Source (TimecodeSource) is set to Specified Start
            (SPECIFIEDSTART), the first input frame is the specified value in Start Timecode
            (Start). Anchor Timecode (Anchor) and Start Timecode (Start) are used calculate output
            timecode. * If Source (TimecodeSource) is set to Start at 0 (ZEROBASED) the first frame
            is 00:00:00:00. * If Source (TimecodeSource) is set to Embedded (EMBEDDED), the first
            frame is the timecode value on the first input frame of the input.

            - **Source** *(string) --* Use Source (TimecodeSource) to set how timecodes are handled
            within this job. To make sure that your video, audio, captions, and markers are
            synchronized and that time-based features, such as image inserter, work correctly,
            choose the Timecode source option that matches your assets. All timecodes are in a
            24-hour format with frame number (HH:MM:SS:FF). * Embedded (EMBEDDED) - Use the timecode
            that is in the input video. If no embedded timecode is in the source, the service will
            use Start at 0 (ZEROBASED) instead. * Start at 0 (ZEROBASED) - Set the timecode of the
            initial frame to 00:00:00:00. * Specified Start (SPECIFIEDSTART) - Set the timecode of
            the initial frame to a value other than zero. You use Start timecode (Start) to provide
            this value.

            - **Start** *(string) --* Only use when you set Source (TimecodeSource) to Specified
            start (SPECIFIEDSTART). Use Start timecode (Start) to specify the timecode for the
            initial frame. Use 24-hour format with frame number, (HH:MM:SS:FF) or (HH:MM:SS;FF).

            - **TimestampOffset** *(string) --* Only applies to outputs that support
            program-date-time stamp. Use Timestamp offset (TimestampOffset) to overwrite the
            timecode date without affecting the time and frame number. Provide the new date as a
            string in the format "yyyy-mm-dd". To use Time stamp offset, you must also enable Insert
            program-date-time (InsertProgramDateTime) in the output settings. For example, if the
            date part of your timecodes is 2002-1-25 and you want to change it to one year later,
            set Timestamp offset (TimestampOffset) to 2003-1-25.

          - **TimedMetadataInsertion** *(dict) --* Enable Timed metadata insertion
          (TimedMetadataInsertion) to include ID3 tags in your job. To include timed metadata, you
          must enable it here, enable it in each output container, and specify tags and timecodes in
          ID3 insertion (Id3Insertion) objects.

            - **Id3Insertions** *(list) --* Id3Insertions contains the array of Id3Insertion
            instances.

              - *(dict) --* To insert ID3 tags in your output, specify two values. Use ID3 tag (Id3)
              to specify the base 64 encoded string and use Timecode (TimeCode) to specify the time
              when the tag should be inserted. To insert multiple ID3 tags in your output, create
              multiple instances of ID3 insertion (Id3Insertion).

                - **Id3** *(string) --* Use ID3 tag (Id3) to provide a tag value in base64-encode
                format.

                - **Timecode** *(string) --* Provide a Timecode (TimeCode) in HH:MM:SS:FF or
                HH:MM:SS;FF format.

        - **SimulateReservedQueue** *(string) --* Enable this setting when you run a test job to
        estimate how many reserved transcoding slots (RTS) you need. When this is enabled,
        MediaConvert runs your job from an on-demand queue with similar performance to what you will
        see with one RTS in a reserved queue. This setting is disabled by default.

        - **Status** *(string) --* A job's status can be SUBMITTED, PROGRESSING, COMPLETE, CANCELED,
        or ERROR.

        - **StatusUpdateInterval** *(string) --* Specify how often MediaConvert sends STATUS_UPDATE
        events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
        MediaConvert sends an update at this interval from the time the service begins processing
        your job to the time it completes the transcode or encounters an error.

        - **Timing** *(dict) --* Information about when jobs are submitted, started, and finished is
        specified in Unix epoch format in seconds.

          - **FinishTime** *(datetime) --* The time, in Unix epoch format, that the transcoding job
          finished

          - **StartTime** *(datetime) --* The time, in Unix epoch format, that transcoding for the
          job began.

          - **SubmitTime** *(datetime) --* The time, in Unix epoch format, that you submitted the
          job.

        - **UserMetadata** *(dict) --* User-defined metadata that you want to associate with an
        MediaConvert job. You specify metadata in key/value pairs.

          - *(string) --*

            - *(string) --*
    """


_ListPresetsPaginatePaginationConfigTypeDef = TypedDict(
    "_ListPresetsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListPresetsPaginatePaginationConfigTypeDef(_ListPresetsPaginatePaginationConfigTypeDef):
    """
    Type definition for `ListPresetsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef",
    {
        "Algorithm": str,
        "AlgorithmControl": str,
        "CorrectionGateLevel": int,
        "LoudnessLogging": str,
        "PeakCalculation": str,
        "TargetLkfs": float,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptions`
    `AudioNormalizationSettings`

    - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms: ITU-R
    BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire piece of
    content, suitable for measurement of short-form content under ATSC recommendation A/85. Supports
    up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of gated average
    loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R
    BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
    true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio channels
    than the other algorithms, including configurations such as 7.1.

    - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the chosen
    algorithm. If disabled, the audio will be measured but not adjusted.

    - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected to
    the target level. Content measuring below this level will not be corrected. Gating only applies
    when not using real_time_correction.

    - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
    CSV file.

    - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for each
    output's audio track loudness.

    - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
    optionally use this setting to specify a target loudness. If you don't specify a value here, the
    encoder chooses a value for you, based on the algorithm that you choose for Algorithm
    (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
    encoder will choose -23 LKFS.
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef",
    {
        "AudioDescriptionBroadcasterMix": str,
        "Bitrate": int,
        "CodecProfile": str,
        "CodingMode": str,
        "RateControlMode": str,
        "RawFormat": str,
        "SampleRate": int,
        "Specification": str,
        "VbrQuality": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `AacSettings`

    - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
    contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for AudioType
    will be set to 3, which signals to downstream systems that this stream contains "broadcaster
    mixed AD". Note that the input received by the encoder must contain pre-mixed audio; the encoder
    does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any
    values you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input does not
    contain pre-mixed audio + audio description (AD). In this case, the encoder will use any values
    you provide for AudioType and FollowInputAudioType.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
    values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000, 32000,
    40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000, 256000,
    288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The value you
    set is also constrained by the values that you choose for Profile (codecProfile), Bitrate
    control mode (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
    control mode and Profile.

    - **CodecProfile** *(string) --* AAC Profile.

    - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
    Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
    setting receives a stereo description plus control track and emits a mono AAC encode of the
    description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

    - **RateControlMode** *(string) --* Rate Control Mode.

    - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
    in an output, you must choose "No container" for the output container.

    - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode and
    profile.

    - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
    Transport Stream containers.

    - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "Dialnorm": int,
        "DynamicRangeCompressionProfile": str,
        "LfeFilter": str,
        "MetadataControl": str,
        "SampleRate": int,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `Ac3Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
    encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital, dialnorm will be passed through.

    - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
    compression signaling to the output bitstream as defined in the Dolby Digital specification.

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `AiffSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef",
    {
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DialogueIntelligence": str,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MeteringMode": str,
        "SampleRate": int,
        "SpeechThreshold": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `Eac3AtmosSettings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values: 384k,
    448k, 640k, 768k

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
    9.1.6 (CODING_MODE_9_1_6).

    - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
    based on dialogue analysis.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
    service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel.

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
    How the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
    Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
    mutes the channel.

    - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be speech
    before the encoder uses the measured speech loudness as the overall program loudness.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

    - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
    rear surround channel matrix encoded into your left and right surround channels.
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef",
    {
        "AttenuationControl": str,
        "Bitrate": int,
        "BitstreamMode": str,
        "CodingMode": str,
        "DcFilter": str,
        "Dialnorm": int,
        "DynamicRangeCompressionLine": str,
        "DynamicRangeCompressionRf": str,
        "LfeControl": str,
        "LfeFilter": str,
        "LoRoCenterMixLevel": float,
        "LoRoSurroundMixLevel": float,
        "LtRtCenterMixLevel": float,
        "LtRtSurroundMixLevel": float,
        "MetadataControl": str,
        "PassthroughControl": str,
        "PhaseControl": str,
        "SampleRate": int,
        "StereoDownmix": str,
        "SurroundExMode": str,
        "SurroundMode": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `Eac3Settings`

    - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
    the surround channels. Only used for 3/2 coding mode.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
    depend on the coding mode.

    - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
    encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex E).

    - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

    - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

    - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
    Dolby Digital Plus, dialnorm will be passed through.

    - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
    with dynamic range compression.

    - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
    range when compressing the audio.

    - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
    enabled

    - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
    encoding. Only valid with 3_2_LFE coding mode.

    - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left only/Right only center
    (loRoCenterMixLevel).

    - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How
    the service uses this value depends on the value that you choose for Stereo downmix
    (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
    channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

    - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
    value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
    R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
    different value for Coding mode, the service ignores Left total/Right total center
    (ltRtCenterMixLevel).

    - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
    setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
    downmixing. How the service uses this value depends on the value that you choose for Stereo
    downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
    the channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
    (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different value
    for Coding mode, the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

    - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
    from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
    from one of these streams, then the static metadata settings will be used.

    - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be passed
    through if it is present on the input. this detection is dynamic over the life of the transcode.
    Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+ output as the
    system alternates between passthrough and encoding.

    - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
    channels. Only used for 3/2 coding mode.

    - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in Hz.

    - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
    only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
    setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
    service ignores Stereo downmix (Eac3StereoDownmix).

    - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
    surround channel is matrix encoded into the left and right surround channels.

    - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is matrix
    encoded into the two channels.
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef",
    {"Bitrate": int, "Channels": int, "SampleRate": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `Mp2Settings`

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

    - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
    audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
    give you 2. In the API, valid values are 1 and 2.

    - **SampleRate** *(integer) --* Sample rate in hz.
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef",
    {"BitDepth": int, "Channels": int, "Format": str, "SampleRate": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettings`
    `WavSettings`

    - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
    encoding quality for this audio track.

    - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
    values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

    - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
    audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
    the RF64 format, set your output WAV file format to RF64.

    - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef",
    {
        "AacSettings": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAacSettingsTypeDef,
        "Ac3Settings": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAc3SettingsTypeDef,
        "AiffSettings": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsAiffSettingsTypeDef,
        "Codec": str,
        "Eac3AtmosSettings": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3AtmosSettingsTypeDef,
        "Eac3Settings": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsEac3SettingsTypeDef,
        "Mp2Settings": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsMp2SettingsTypeDef,
        "WavSettings": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsWavSettingsTypeDef,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptions`
    `CodecSettings`

    - **AacSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
    exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
    Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
    quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
    (bitrate). Defaults and valid values depend on the rate control mode.

      - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the input
      contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
      AudioType will be set to 3, which signals to downstream systems that this stream contains
      "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
      audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
      encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
      when the input does not contain pre-mixed audio + audio description (AD). In this case, the
      encoder will use any values you provide for AudioType and FollowInputAudioType.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of valid
      values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000, 28000,
      32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000, 224000,
      256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000, 1024000. The
      value you set is also constrained by the values that you choose for Profile (codecProfile),
      Bitrate control mode (codingMode), and Sample rate (sampleRate). Default values depend on
      Bitrate control mode and Profile.

      - **CodecProfile** *(string) --* AAC Profile.

      - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel layout.
      Valid values depend on rate control mode and profile. "1.0 - Audio Description (Receiver Mix)"
      setting receives a stereo description plus control track and emits a mono AAC encode of the
      description track, with control data emitted in the PES header as per ETSI TS 101 154 Annex E.

      - **RateControlMode** *(string) --* Rate Control Mode.

      - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS AAC
      in an output, you must choose "No container" for the output container.

      - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
      and profile.

      - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or MPEG-2
      Transport Stream containers.

      - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

    - **Ac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AC3.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
      encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital, dialnorm will be passed through.

      - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic range
      compression signaling to the output bitstream as defined in the Dolby Digital specification.

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

    - **AiffSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value AIFF.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **Codec** *(string) --* Type of Audio codec.

    - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
      384k, 448k, 640k, 768k

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
      9.1.6 (CODING_MODE_9_1_6).

      - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust loudness
      based on dialogue analysis.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing. How the
      service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
      the channel.

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
      Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60
      mutes the channel.

      - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
      speech before the encoder uses the measured speech loudness as the overall program loudness.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

      - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
      rear surround channel matrix encoded into your left and right surround channels.

    - **Eac3Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value EAC3.

      - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation to
      the surround channels. Only used for 3/2 coding mode.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
      depend on the coding mode.

      - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
      encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
      E).

      - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of channels.

      - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

      - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
      Dolby Digital Plus, dialnorm will be passed through.

      - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
      with dynamic range compression.

      - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio dynamic
      range when compressing the audio.

      - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
      enabled

      - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
      encoding. Only valid with 3_2_LFE coding mode.

      - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left only/Right only center
      (loRoCenterMixLevel).

      - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
      How the service uses this value depends on the value that you choose for Stereo downmix
      (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
      channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
      (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
      value for Coding mode, the service ignores Left only/Right only surround
      (loRoSurroundMixLevel).

      - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
      downmixing. How the service uses this value depends on the value that you choose for Stereo
      downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The
      value -60 mutes the channel. This setting applies only if you keep the default value of 3/2 -
      L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose
      a different value for Coding mode, the service ignores Left total/Right total center
      (ltRtCenterMixLevel).

      - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
      setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
      for downmixing. How the service uses this value depends on the value that you choose for
      Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
      -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L, R,
      C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
      different value for Coding mode, the service ignores Left total/Right total surround
      (ltRtSurroundMixLevel).

      - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be sourced
      from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not supplied
      from one of these streams, then the static metadata settings will be used.

      - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
      passed through if it is present on the input. this detection is dynamic over the life of the
      transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
      output as the system alternates between passthrough and encoding.

      - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
      channels. Only used for 3/2 coding mode.

      - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
      Hz.

      - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This setting
      only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
      setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode, the
      service ignores Stereo downmix (Eac3StereoDownmix).

      - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center back
      surround channel is matrix encoded into the left and right surround channels.

      - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
      matrix encoded into the two channels.

    - **Mp2Settings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value MP2.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

      - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
      audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo will
      give you 2. In the API, valid values are 1 and 2.

      - **SampleRate** *(integer) --* Sample rate in hz.

    - **WavSettings** *(dict) --* Required when you set (Codec) under
    (AudioDescriptions)>(CodecSettings) to the value WAV.

      - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose the
      encoding quality for this audio track.

      - **Channels** *(integer) --* Specify the number of channels in this output audio track. Valid
      values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

      - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your output
      audio is likely to exceed 4 GB in file size, or if you otherwise need the extended support of
      the RF64 format, set your output WAV file format to RF64.

      - **SampleRate** *(integer) --* Sample rate in Hz.
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef",
    {"InputChannels": List[int]},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMapping`
    `OutputChannels`

    - **InputChannels** *(list) --* List of input channels

      - *(integer) --*
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef",
    {
        "OutputChannels": List[
            ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingOutputChannelsTypeDef
        ]
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettings`
    `ChannelMapping`

    - **OutputChannels** *(list) --* List of output channels

      - *(dict) --* OutputChannel mapping settings.

        - **InputChannels** *(list) --* List of input channels

          - *(integer) --*
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef",
    {
        "ChannelMapping": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsChannelMappingTypeDef,
        "ChannelsIn": int,
        "ChannelsOut": int,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsAudioDescriptions`
    `RemixSettings`

    - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
    that hold the remixing value for each channel. Units are in dB. Acceptable values are within the
    range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the output
    channel (no attenuation or amplification).

      - **OutputChannels** *(list) --* List of output channels

        - *(dict) --* OutputChannel mapping settings.

          - **InputChannels** *(list) --* List of input channels

            - *(integer) --*

    - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
    want to use in your output. With remixing, you might combine or split the data in these
    channels, so the number of channels in your final output might be different.

    - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
    Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)
    """


_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsTypeDef",
    {
        "AudioNormalizationSettings": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsAudioNormalizationSettingsTypeDef,
        "AudioSourceName": str,
        "AudioType": int,
        "AudioTypeControl": str,
        "CodecSettings": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsCodecSettingsTypeDef,
        "CustomLanguageCode": str,
        "LanguageCode": str,
        "LanguageCodeControl": str,
        "RemixSettings": ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsRemixSettingsTypeDef,
        "StreamName": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettings` `AudioDescriptions`

    - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore these
    settings unless you need to comply with a loudness standard.

      - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
      ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
      piece of content, suitable for measurement of short-form content under ATSC recommendation
      A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
      gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1 audio
      channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as 1770-2,
      with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more
      audio channels than the other algorithms, including configurations such as 7.1.

      - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
      chosen algorithm. If disabled, the audio will be measured but not adjusted.

      - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be corrected
      to the target level. Content measuring below this level will not be corrected. Gating only
      applies when not using real_time_correction.

      - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness to a
      CSV file.

      - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak for
      each output's audio track loudness.

      - **TargetLkfs** *(float) --* When you use Audio normalization (AudioNormalizationSettings),
      optionally use this setting to specify a target loudness. If you don't specify a value here,
      the encoder chooses a value for you, based on the algorithm that you choose for Algorithm
      (algorithm). If you choose algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the
      encoder will choose -23 LKFS.

    - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In the
    simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its order
    within each input. For example if you specify "Audio Selector 3", then the third audio selector
    will be used from each input. If an input does not have an "Audio Selector 3", then the audio
    selector marked as "default" in that input will be used. If there is no audio selector marked as
    "default", silence will be inserted for the duration of that input. Alternatively, an "Audio
    Selector Group":#inputs-audio_selector_group name may be specified, with similar default/silence
    behavior. If no audio_source_name is specified, then "Audio Selector 1" will be chosen
    automatically.

    - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false). A
    number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 = Undefined, 1 = Clean
    Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

    - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO 639
    audio_type, then that value is passed through to the output. If the input contains no ISO 639
    audio_type, the value in Audio Type is included in the output. Otherwise the value in Audio Type
    is included in the output. Note that this field and audioType are both ignored if
    audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

    - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under (AudioDescriptions)
    contains the group of settings related to audio encoding. The settings in this group vary
    depending on the value that you choose for Audio codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings *
    AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

      - **AacSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two mutually
      exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set the value of
      Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you control the audio
      quality with the setting VBR quality (vbrQuality). In CBR mode, you use the setting Bitrate
      (bitrate). Defaults and valid values depend on the rate control mode.

        - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
        input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value for
        AudioType will be set to 3, which signals to downstream systems that this stream contains
        "broadcaster mixed AD". Note that the input received by the encoder must contain pre-mixed
        audio; the encoder does not perform the mixing. When you choose BROADCASTER_MIXED_AD, the
        encoder ignores any values you provide in AudioType and FollowInputAudioType. Choose NORMAL
        when the input does not contain pre-mixed audio + audio description (AD). In this case, the
        encoder will use any values you provide for AudioType and FollowInputAudioType.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
        valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
        28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
        224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
        1024000. The value you set is also constrained by the values that you choose for Profile
        (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
        values depend on Bitrate control mode and Profile.

        - **CodecProfile** *(string) --* AAC Profile.

        - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
        layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
        (Receiver Mix)" setting receives a stereo description plus control track and emits a mono
        AAC encode of the description track, with control data emitted in the PES header as per ETSI
        TS 101 154 Annex E.

        - **RateControlMode** *(string) --* Rate Control Mode.

        - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use LATM/LOAS
        AAC in an output, you must choose "No container" for the output container.

        - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control mode
        and profile.

        - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
        MPEG-2 Transport Stream containers.

        - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is VBR.

      - **Ac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AC3.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that the
        encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital, dialnorm will be passed through.

        - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
        range compression signaling to the output bitstream as defined in the Dolby Digital
        specification.

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

      - **AiffSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value AIFF.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **Codec** *(string) --* Type of Audio codec.

      - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid values:
        384k, 448k, 640k, 768k

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is always
        9.1.6 (CODING_MODE_9_1_6).

        - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
        loudness based on dialogue analysis.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes
        the channel.

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos setting:
        Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
        value -60 mutes the channel.

        - **MeteringMode** *(string) --* Choose how the service meters the loudness of your audio.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must be
        speech before the encoder uses the measured speech loudness as the overall program loudness.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

        - **SurroundExMode** *(string) --* Specify whether your input audio has an additional center
        rear surround channel matrix encoded into your left and right surround channels.

      - **Eac3Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value EAC3.

        - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB attenuation
        to the surround channels. Only used for 3/2 coding mode.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid bitrates
        depend on the coding mode.

        - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that the
        encoder emits. For more information about the EAC3 bitstream mode, see ATSC A/52-2012 (Annex
        E).

        - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
        channels.

        - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

        - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio is
        Dolby Digital Plus, dialnorm will be passed through.

        - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a signal
        with dynamic range compression.

        - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
        dynamic range when compressing the audio.

        - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel is
        enabled

        - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
        encoding. Only valid with 3_2_LFE coding mode.

        - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left only/Right only center
        (loRoCenterMixLevel).

        - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for downmixing.
        How the service uses this value depends on the value that you choose for Stereo downmix
        (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
        channel. This setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Left only/Right only surround
        (loRoSurroundMixLevel).

        - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value for
        downmixing. How the service uses this value depends on the value that you choose for Stereo
        downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60.
        The value -60 mutes the channel. This setting applies only if you keep the default value of
        3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
        choose a different value for Coding mode, the service ignores Left total/Right total center
        (ltRtCenterMixLevel).

        - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital Plus
        setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this value
        for downmixing. How the service uses this value depends on the value that you choose for
        Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The value
        -60 mutes the channel. This setting applies only if you keep the default value of 3/2 - L,
        R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
        different value for Coding mode, the service ignores Left total/Right total surround
        (ltRtSurroundMixLevel).

        - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
        sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was not
        supplied from one of these streams, then the static metadata settings will be used.

        - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will be
        passed through if it is present on the input. this detection is dynamic over the life of the
        transcode. Inputs that alternate between DD+ and non-DD+ content will have a consistent DD+
        output as the system alternates between passthrough and encoding.

        - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the surround
        channels. Only used for 3/2 coding mode.

        - **SampleRate** *(integer) --* This value is always 48000. It represents the sample rate in
        Hz.

        - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
        setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
        (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a different
        value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

        - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
        back surround channel is matrix encoded into the left and right surround channels.

        - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
        matrix encoded into the two channels.

      - **Mp2Settings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value MP2.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

        - **Channels** *(integer) --* Set Channels to specify the number of channels in this output
        audio track. Choosing Mono in the console will give you 1 output channel; choosing Stereo
        will give you 2. In the API, valid values are 1 and 2.

        - **SampleRate** *(integer) --* Sample rate in hz.

      - **WavSettings** *(dict) --* Required when you set (Codec) under
      (AudioDescriptions)>(CodecSettings) to the value WAV.

        - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to choose
        the encoding quality for this audio track.

        - **Channels** *(integer) --* Specify the number of channels in this output audio track.
        Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to 64.

        - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
        output audio is likely to exceed 4 GB in file size, or if you otherwise need the extended
        support of the RF64 format, set your output WAV file format to RF64.

        - **SampleRate** *(integer) --* Sample rate in Hz.

    - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
    service puts this language code into your output audio track when you set Language code control
    (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses your
    specified custom language code when you set Language code control (AudioLanguageCodeControl) to
    Follow input (FOLLOW_INPUT), but your input file doesn't specify a language code. For all
    outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use any
    other code in the full RFC-5646 specification. Streaming outputs are those that are in one of
    the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO 639
    language specified in the 'Language Code' drop down will be used when 'Follow Input Language
    Code' is not selected or when 'Follow Input Language Code' is selected but there is no ISO 639
    language code specified by the input.

    - **LanguageCodeControl** *(string) --* Specify which source for language code takes precedence
    for this audio track. When you choose Follow input (FOLLOW_INPUT), the service uses the language
    code from the input track if it's present. If there's no languge code on the input track, the
    service uses the code that you specify in the setting Language code (languageCode or
    customLanguageCode). When you choose Use configured (USE_CONFIGURED), the service uses the
    language code that you specify.

    - **RemixSettings** *(dict) --* Advanced audio remixing settings.

      - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of fields
      that hold the remixing value for each channel. Units are in dB. Acceptable values are within
      the range from -60 (mute) through 6. A setting of 0 passes the input channel unchanged to the
      output channel (no attenuation or amplification).

        - **OutputChannels** *(list) --* List of output channels

          - *(dict) --* OutputChannel mapping settings.

            - **InputChannels** *(list) --* List of input channels

              - *(integer) --*

      - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that you
      want to use in your output. With remixing, you might combine or split the data in these
      channels, so the number of channels in your final output might be different.

      - **ChannelsOut** *(integer) --* Specify the number of channels in this output after remixing.
      Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

    - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
    "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes this
    information into destination manifests for display on the end-viewer's player device. For
    outputs in other output groups, the service ignores this setting.
    """


_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `BurninDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering burn-in captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef",
    {
        "Alignment": str,
        "BackgroundColor": str,
        "BackgroundOpacity": int,
        "FontColor": str,
        "FontOpacity": int,
        "FontResolution": int,
        "FontScript": str,
        "FontSize": int,
        "OutlineColor": str,
        "OutlineSize": int,
        "ShadowColor": str,
        "ShadowOpacity": int,
        "ShadowXOffset": int,
        "ShadowYOffset": int,
        "SubtitlingType": str,
        "TeletextSpacing": str,
        "XPosition": int,
        "YPosition": int,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `DvbSubDestinationSettings`

    - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
    alignment to centered will place the captions at the bottom center of the output. Similarly,
    setting a left alignment will align captions to the bottom left of the output. If x and y
    positions are given in conjunction with the alignment parameter, the font will be justified
    (either left or centered) relative to those coordinates. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
    All burn-in and DVB-Sub font settings must match.

    - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255 is
    opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
    (transparent). All burn-in and DVB-Sub font settings must match.

    - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is not
    valid for source captions that are STL, 608/embedded or teletext. These source settings are
    already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is opaque;
    0 is transparent. All burn-in and DVB-Sub font settings must match.

    - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
    All burn-in and DVB-Sub font settings must match.

    - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
    LanguageCode is not sufficient for determining the script type. Where LanguageCode or
    CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help determine
    the appropriate font for rendering DVB-Sub captions.

    - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set to
    0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

    - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
    source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not valid
    for source captions that are either 608/embedded or teletext. These source settings are already
    pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
    transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
    burn-in and DVB-Sub font settings must match.

    - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left. All
    burn-in and DVB-Sub font settings must match.

    - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
    captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
    burn-in and DVB-Sub font settings must match.

    - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
    hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
    dialogue. Choose standard if your subtitles include only dialogue.

    - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or STL
    formats. Specify whether the spacing between letters in your captions is set by the captions
    grid or varies depending on letter width. Choose fixed grid to conform to the spacing specified
    in the captions file more accurately. Choose proportional to make the text easier to read if the
    captions are closed caption.

    - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to the
    left side of the output in pixels. A value of 10 would result in the captions starting 10 pixels
    from the left of the output. If no explicit x_position is provided, the horizontal caption
    position will be determined by the alignment parameter. This option is not valid for source
    captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
    by the caption stream. All burn-in and DVB-Sub font settings must match.

    - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
    top of the output in pixels. A value of 10 would result in the captions starting 10 pixels from
    the top of the output. If no explicit y_position is provided, the caption will be positioned
    towards the bottom of the output. This option is not valid for source captions that are STL,
    608/embedded or teletext. These source settings are already pre-defined by the caption stream.
    All burn-in and DVB-Sub font settings must match.
    """


_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef",
    {"Destination608ChannelNumber": int, "Destination708ServiceNumber": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `EmbeddedDestinationSettings`

    - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and your output captions are embedded in the video stream. Specify a CC number
    for each captions channel in this output. If you have two channels, choose CC numbers that
    aren't in the same field. For example, choose 1 and 3. For more information, see
    https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input captions
    are SCC format and you want both 608 and 708 captions embedded in your output stream.
    Optionally, specify the 708 service number for each output captions channel. Choose a different
    number for each channel. To use this setting, also set Force 608 to 708 upconvert
    (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
    choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
    you specify for CC channel number (destination608ChannelNumber) for the 708 service number. For
    more information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.
    """


_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `ImscDestinationSettings`

    - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the font
    style and position information from the captions source in the output. This option is available
    only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this setting for
    simplified output captions.
    """


_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef",
    {"Framerate": str},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `SccDestinationSettings`

    - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
    captions and the video are synchronized in the output. Specify a frame rate that matches the
    frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
    (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
    drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).
    """


_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef",
    {"PageNumber": str, "PageTypes": List[str]},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `TeletextDestinationSettings`

    - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
    captions for this output. This value must be a three-digit hexadecimal string; strings ending in
    -FF are invalid. If you are passing through the entire set of Teletext data, do not use this
    field.

    - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't specify
    a value here, the service sets the page type to the default value Subtitle (PAGE_TYPE_SUBTITLE).
    If you pass through the entire set of Teletext data, don't use this field. When you pass through
    a set of Teletext pages, your output has the same page types as your input.

      - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94
    """


_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef",
    {"StylePassthrough": str},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettings`
    `TtmlDestinationSettings`

    - **StylePassthrough** *(string) --* Pass through style and position information from a
    TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef",
    {
        "BurninDestinationSettings": ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsBurninDestinationSettingsTypeDef,
        "DestinationType": str,
        "DvbSubDestinationSettings": ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsDvbSubDestinationSettingsTypeDef,
        "EmbeddedDestinationSettings": ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsEmbeddedDestinationSettingsTypeDef,
        "ImscDestinationSettings": ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsImscDestinationSettingsTypeDef,
        "SccDestinationSettings": ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsSccDestinationSettingsTypeDef,
        "TeletextDestinationSettings": ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTeletextDestinationSettingsTypeDef,
        "TtmlDestinationSettings": ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTtmlDestinationSettingsTypeDef,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsCaptionDescriptions`
    `DestinationSettings`

    - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering burn-in captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **DestinationType** *(string) --* Specify the format for this set of captions on this output.
    The default format is embedded without SCTE-20. Other options are embedded with SCTE-20,
    burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using SCTE-20, choose
    SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43
    spec. To create a non-compliant output where the embedded captions come first, choose Embedded
    plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

    - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

      - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
      alignment to centered will place the captions at the bottom center of the output. Similarly,
      setting a left alignment will align captions to the bottom left of the output. If x and y
      positions are given in conjunction with the alignment parameter, the font will be justified
      (either left or centered) relative to those coordinates. This option is not valid for source
      captions that are STL, 608/embedded or teletext. These source settings are already pre-defined
      by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the captions.
      All burn-in and DVB-Sub font settings must match.

      - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle. 255
      is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
      (transparent). All burn-in and DVB-Sub font settings must match.

      - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
      not valid for source captions that are STL, 608/embedded or teletext. These source settings
      are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
      match.

      - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
      opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

      - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96 dpi.
      All burn-in and DVB-Sub font settings must match.

      - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if the
      LanguageCode is not sufficient for determining the script type. Where LanguageCode or
      CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
      determine the appropriate font for rendering DVB-Sub captions.

      - **FontSize** *(integer) --* A positive integer indicates the exact font size in points. Set
      to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must match.

      - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
      source captions that are either 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
      valid for source captions that are either 608/embedded or teletext. These source settings are
      already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
      burn-in and DVB-Sub font settings must match.

      - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
      transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent). All
      burn-in and DVB-Sub font settings must match.

      - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
      the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
      All burn-in and DVB-Sub font settings must match.

      - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to the
      captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the text. All
      burn-in and DVB-Sub font settings must match.

      - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
      hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
      dialogue. Choose standard if your subtitles include only dialogue.

      - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
      STL formats. Specify whether the spacing between letters in your captions is set by the
      captions grid or varies depending on letter width. Choose fixed grid to conform to the spacing
      specified in the captions file more accurately. Choose proportional to make the text easier to
      read if the captions are closed caption.

      - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
      the left side of the output in pixels. A value of 10 would result in the captions starting 10
      pixels from the left of the output. If no explicit x_position is provided, the horizontal
      caption position will be determined by the alignment parameter. This option is not valid for
      source captions that are STL, 608/embedded or teletext. These source settings are already
      pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

      - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to the
      top of the output in pixels. A value of 10 would result in the captions starting 10 pixels
      from the top of the output. If no explicit y_position is provided, the caption will be
      positioned towards the bottom of the output. This option is not valid for source captions that
      are STL, 608/embedded or teletext. These source settings are already pre-defined by the
      caption stream. All burn-in and DVB-Sub font settings must match.

    - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
    outputs, including 608/708 Channel destination number.

      - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and your output captions are embedded in the video stream. Specify a
      CC number for each captions channel in this output. If you have two channels, choose CC
      numbers that aren't in the same field. For example, choose 1 and 3. For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
      captions are SCC format and you want both 608 and 708 captions embedded in your output stream.
      Optionally, specify the 708 service number for each output captions channel. Choose a
      different number for each channel. To use this setting, also set Force 608 to 708 upconvert
      (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector settings. If you
      choose to upconvert but don't specify a 708 service number, MediaConvert uses the number that
      you specify for CC channel number (destination608ChannelNumber) for the 708 service number.
      For more information, see
      https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

    - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

      - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
      font style and position information from the captions source in the output. This option is
      available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
      setting for simplified output captions.

    - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

      - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
      captions and the video are synchronized in the output. Specify a frame rate that matches the
      frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
      (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
      drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
      (FRAMERATE_29_97_NON_DROPFRAME).

    - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

      - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the destination
      captions for this output. This value must be a three-digit hexadecimal string; strings ending
      in -FF are invalid. If you are passing through the entire set of Teletext data, do not use
      this field.

      - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
      specify a value here, the service sets the page type to the default value Subtitle
      (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
      field. When you pass through a set of Teletext pages, your output has the same page types as
      your input.

        - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

    - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
    Pass style information (TtmlStylePassthrough).

      - **StylePassthrough** *(string) --* Pass through style and position information from a
      TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.
    """


_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsTypeDef",
    {
        "CustomLanguageCode": str,
        "DestinationSettings": ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsDestinationSettingsTypeDef,
        "LanguageCode": str,
        "LanguageDescription": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettings` `CaptionDescriptions`

    - **CustomLanguageCode** *(string) --* Specify the language for this captions output track. For
    most captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information when automatically selecting the font script for rendering the captions text. For
    all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming outputs, you can also use
    any other code in the full RFC-5646 specification. Streaming outputs are those that are in one
    of the following output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

    - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note that
    burnin_destination_settings are not available if the source of the caption data is Embedded or
    Teletext.

      - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering burn-in captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **DestinationType** *(string) --* Specify the format for this set of captions on this
      output. The default format is embedded without SCTE-20. Other options are embedded with
      SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
      SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that complies
      with the SCTE-43 spec. To create a non-compliant output where the embedded captions come
      first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

      - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

        - **Alignment** *(string) --* If no explicit x_position or y_position is provided, setting
        alignment to centered will place the captions at the bottom center of the output. Similarly,
        setting a left alignment will align captions to the bottom left of the output. If x and y
        positions are given in conjunction with the alignment parameter, the font will be justified
        (either left or centered) relative to those coordinates. This option is not valid for source
        captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
        captions. All burn-in and DVB-Sub font settings must match.

        - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background rectangle.
        255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it to
        0 (transparent). All burn-in and DVB-Sub font settings must match.

        - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option is
        not valid for source captions that are STL, 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
        opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

        - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is 96
        dpi. All burn-in and DVB-Sub font settings must match.

        - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code, if
        the LanguageCode is not sufficient for determining the script type. Where LanguageCode or
        CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This is used to help
        determine the appropriate font for rendering DVB-Sub captions.

        - **FontSize** *(integer) --* A positive integer indicates the exact font size in points.
        Set to 0 for automatic font size selection. All burn-in and DVB-Sub font settings must
        match.

        - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid for
        source captions that are either 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is not
        valid for source captions that are either 608/embedded or teletext. These source settings
        are already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
        match.

        - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions. All
        burn-in and DVB-Sub font settings must match.

        - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0 is
        transparent. Leaving this parameter blank is equivalent to setting it to 0 (transparent).
        All burn-in and DVB-Sub font settings must match.

        - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels to the left.
        All burn-in and DVB-Sub font settings must match.

        - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative to
        the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above the
        text. All burn-in and DVB-Sub font settings must match.

        - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or for
        hearing impaired. Choose hearing impaired if your subtitles include audio descriptions and
        dialogue. Choose standard if your subtitles include only dialogue.

        - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext or
        STL formats. Specify whether the spacing between letters in your captions is set by the
        captions grid or varies depending on letter width. Choose fixed grid to conform to the
        spacing specified in the captions file more accurately. Choose proportional to make the text
        easier to read if the captions are closed caption.

        - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative to
        the left side of the output in pixels. A value of 10 would result in the captions starting
        10 pixels from the left of the output. If no explicit x_position is provided, the horizontal
        caption position will be determined by the alignment parameter. This option is not valid for
        source captions that are STL, 608/embedded or teletext. These source settings are already
        pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

        - **YPosition** *(integer) --* Specifies the vertical position of the caption relative to
        the top of the output in pixels. A value of 10 would result in the captions starting 10
        pixels from the top of the output. If no explicit y_position is provided, the caption will
        be positioned towards the bottom of the output. This option is not valid for source captions
        that are STL, 608/embedded or teletext. These source settings are already pre-defined by the
        caption stream. All burn-in and DVB-Sub font settings must match.

      - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary caption
      outputs, including 608/708 Channel destination number.

        - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and your output captions are embedded in the video stream. Specify a
        CC number for each captions channel in this output. If you have two channels, choose CC
        numbers that aren't in the same field. For example, choose 1 and 3. For more information,
        see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

        - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
        captions are SCC format and you want both 608 and 708 captions embedded in your output
        stream. Optionally, specify the 708 service number for each output captions channel. Choose
        a different number for each channel. To use this setting, also set Force 608 to 708
        upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
        settings. If you choose to upconvert but don't specify a 708 service number, MediaConvert
        uses the number that you specify for CC channel number (destination608ChannelNumber) for the
        708 service number. For more information, see
        https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

      - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

        - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use the
        font style and position information from the captions source in the output. This option is
        available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML. Disable this
        setting for simplified output captions.

      - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

        - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that the
        captions and the video are synchronized in the output. Specify a frame rate that matches the
        frame rate of the associated video. If the video frame rate is 29.97, choose 29.97 dropframe
        (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true and
        drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
        (FRAMERATE_29_97_NON_DROPFRAME).

      - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

        - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
        destination captions for this output. This value must be a three-digit hexadecimal string;
        strings ending in -FF are invalid. If you are passing through the entire set of Teletext
        data, do not use this field.

        - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
        specify a value here, the service sets the page type to the default value Subtitle
        (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use this
        field. When you pass through a set of Teletext pages, your output has the same page types as
        your input.

          - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

      - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs, including
      Pass style information (TtmlStylePassthrough).

        - **StylePassthrough** *(string) --* Pass through style and position information from a
        TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

    - **LanguageCode** *(string) --* Specify the language of this captions output track. For most
    captions output formats, the encoder puts this language information in the output captions
    metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses this language
    information to choose the font language for rendering the captions text.

    - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
    example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
    passes this information into destination manifests for display on the end-viewer's player
    device. For outputs in other output groups, the service ignores this setting.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef",
    {"MoovPlacement": str},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsContainerSettings` `F4vSettings`

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef",
    {"NetworkId": int, "NetworkName": str, "NitInterval": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettings`
    `DvbNitSettings`

    - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table (NIT).

    - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
    inside the Network Information Table. Maximum length is 256 characters.

    - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef",
    {"OutputSdt": str, "SdtInterval": int, "ServiceName": str, "ServiceProviderName": str},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettings`
    `DvbSdtSettings`

    - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
    "Follow input SDT" copies SDT information from input stream to output stream. "Follow input SDT
    if present" copies SDT information from input stream to output stream if SDT information is
    present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
    Manually" means user will enter the SDT information. "No SDT" means output stream will not
    contain SDT information.

    - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **ServiceName** *(string) --* The service name placed in the service_descriptor in the Service
    Description Table. Maximum length is 256 characters.

    - **ServiceProviderName** *(string) --* The service provider name placed in the
    service_descriptor in the Service Description Table. Maximum length is 256 characters.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef",
    {"TdtInterval": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettings`
    `DvbTdtSettings`

    - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef",
    {"Scte35EsamPid": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettings`
    `Scte35Esam`

    - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
    transport stream generated by ESAM.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef",
    {
        "AudioBufferModel": str,
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "Bitrate": int,
        "BufferModel": str,
        "DvbNitSettings": ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbNitSettingsTypeDef,
        "DvbSdtSettings": ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbSdtSettingsTypeDef,
        "DvbSubPids": List[int],
        "DvbTdtSettings": ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsDvbTdtSettingsTypeDef,
        "DvbTeletextPid": int,
        "EbpAudioInterval": str,
        "EbpPlacement": str,
        "EsRateInPes": str,
        "ForceTsVideoEbpOrder": str,
        "FragmentTime": float,
        "MaxPcrInterval": int,
        "MinEbpInterval": int,
        "NielsenId3": str,
        "NullPacketBitrate": float,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "RateMode": str,
        "Scte35Esam": ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsScte35EsamTypeDef,
        "Scte35Pid": int,
        "Scte35Source": str,
        "SegmentationMarkers": str,
        "SegmentationStyle": str,
        "SegmentationTime": float,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsContainerSettings` `M2tsSettings`

    - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
    Digital audio.

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
    streams you include in this output. Specify multiple PIDs as a JSON array. Default is the range
    482-492.

      - *(integer) --*

    - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
    second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
    common values are 3750000, 7500000, and 15000000.

    - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving. If
    set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower latency,
    but low-memory devices may not be able to play back the stream without interruptions.

    - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
    table repetition interval.

      - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
      (NIT).

      - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
      inside the Network Information Table. Maximum length is 256 characters.

      - **NitInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
    table repetition interval.

      - **OutputSdt** *(string) --* Selects method of inserting SDT information into output stream.
      "Follow input SDT" copies SDT information from input stream to output stream. "Follow input
      SDT if present" copies SDT information from input stream to output stream if SDT information
      is present in the input, otherwise it will fall back on the user-defined values. Enter "SDT
      Manually" means user will enter the SDT information. "No SDT" means output stream will not
      contain SDT information.

      - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
      Service Description Table. Maximum length is 256 characters.

      - **ServiceProviderName** *(string) --* The service provider name placed in the
      service_descriptor in the Service Description Table. Maximum length is 256 characters.

    - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
    included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

      - *(integer) --*

    - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
    repetition interval.

      - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

    - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
    you include in this output. Default is 499.

    - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
    will be added to partitions 3 and 4. The interval between these additional markers will be
    fixed, and will be slightly shorter than the video EBP marker interval. When set to
    VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
    segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either be
    placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable when
    EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

    - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES header.

    - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
    your audio EBP markers are incorrectly appearing before your video EBP markers. To correct this
    problem, set this value to Force (FORCE).

    - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
    markers.

    - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
    Clock References (PCRs) inserted into the transport stream.

    - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not come
    within the specified time interval of each other by looking ahead at input video. If another EBP
    is going to come in within the specified time interval, the current EBP is not emitted, and the
    segment is "stretched" to the next marker. The lookahead value does not add latency to the
    system. The Live Event must be configured elsewhere to create sufficient latency to make the
    lookahead accurate.

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
    into the transport stream. This can be used if a downstream encryption system requires periodic
    null packets.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This is effective only when the
    PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock reference
    (PCR) in this output. If you do not specify a value, the service will use the value for Video
    PID (VideoPid).

    - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
    program map table (PMT) in the output transport stream.

    - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table (PMT)
    itself. Default is 480.

    - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
    metadata stream. Default is 503.

    - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
    number used in the program map table (PMT) for this output. Default is 1. Program numbers and
    program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

    - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to fill
    specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but the
    output will not be padded up to that bitrate.

    - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
    HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
    document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
      transport stream generated by ESAM.

    - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in the
    transport stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string in the
    setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include the
    property scte35Esam).

    - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
    period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
    sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
    PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to the
    adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder
    Boundary Point information to the adaptation field using a legacy proprietary format.

    - **SegmentationStyle** *(string) --* The segmentation style parameter controls how segmentation
    markers are inserted into the transport stream. With avails, it is possible that segments may be
    truncated, which can influence where future segmentation markers are inserted. When a
    segmentation style of "reset_cadence" is selected and a segment is truncated due to an avail, we
    will reset the segmentation cadence. This means the subsequent segment will have a duration of
    of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is selected and a
    segment is truncated due to an avail, we will not reset the segmentation cadence. This means the
    subsequent segment will likely be truncated as well. However, all segments after that will have
    a duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception to this
    rule.

    - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
    unless markers is set to _none_.

    - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata in
    this output. Default is 502.

    - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
    program map table for this output. Transport stream IDs and program map tables are parts of
    MPEG-2 transport stream containers, used for organizing data.

    - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video stream
    in the transport stream.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef",
    {
        "AudioFramesPerPes": int,
        "AudioPids": List[int],
        "NielsenId3": str,
        "PatInterval": int,
        "PcrControl": str,
        "PcrPid": int,
        "PmtInterval": int,
        "PmtPid": int,
        "PrivateMetadataPid": int,
        "ProgramNumber": int,
        "Scte35Pid": int,
        "Scte35Source": str,
        "TimedMetadata": str,
        "TimedMetadataPid": int,
        "TransportStreamId": int,
        "VideoPid": int,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsContainerSettings` `M3u8Settings`

    - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES packet.

    - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
    transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
    separation.

      - *(integer) --*

    - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
    detected in the input audio and an equivalent ID3 tag will be inserted in the output.

    - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference value
    is inserted for every Packetized Elementary Stream (PES) header. This parameter is effective
    only when the PCR PID is the same as the video or audio elementary stream.

    - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in the
    transport stream. When no value is given, the encoder will assign the same value as the Video
    PID.

    - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
    the output transport stream.

    - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
    transport stream.

    - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
    in the transport stream.

    - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
    Table.

    - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
    stream.

    - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
    (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
    output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35 markers
    from an ESAM XML document-- Choose None (NONE) if you don't want manifest conditioning. Choose
    Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do want manifest
    conditioning. In both cases, also provide the ESAM XML as a string in the setting Signal
    processing notification XML (sccXml).

    - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
    whether the service inserts the ID3 timed metadata from the input in this output.

    - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
    the transport stream.

    - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the Program
    Map Table.

    - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
    transport stream.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsMovSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsMovSettingsTypeDef",
    {
        "ClapAtom": str,
        "CslgAtom": str,
        "Mpeg2FourCCControl": str,
        "PaddingControl": str,
        "Reference": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsMovSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsMovSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsContainerSettings` `MovSettings`

    - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
    output settings.

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
    QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
    players, but may decrease compatibility with other players. Only applicable when the video codec
    is MPEG2.

    - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

    - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef",
    {"CslgAtom": str, "FreeSpaceBox": str, "MoovPlacement": str, "Mp4MajorBrand": str},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsContainerSettings` `Mp4Settings`

    - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
    composition times in the 'ctts' (composition time to sample) box for B-frames will be negative,
    and a 'cslg' (composition shift least greatest) box will be included per 14496-1 amendment 1.
    This improves compatibility with Apple players and tools.

    - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

    - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated to
    the beginning of the archive as required for progressive downloading. Otherwise it is placed
    normally at the end.

    - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file. Usually
    not necessary to specify.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef",
    {"CaptionContainerType": str, "Scte35Esam": str, "Scte35Source": str},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsContainerSettings` `MpdSettings`

    - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
    include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
    your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
    Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within fragmented
    MP4 files. This set of fragmented MP4 files is separate from your video and audio fragmented MP4
    files.

    - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from ESAM.
    Choose INSERT to put SCTE-35 markers in this output at the insertion points that you specify in
    an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

    - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
    input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
    your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
    markers in this output.
    """


_ListPresetsPaginateResponsePresetsSettingsContainerSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsContainerSettingsTypeDef",
    {
        "Container": str,
        "F4vSettings": ListPresetsPaginateResponsePresetsSettingsContainerSettingsF4vSettingsTypeDef,
        "M2tsSettings": ListPresetsPaginateResponsePresetsSettingsContainerSettingsM2tsSettingsTypeDef,
        "M3u8Settings": ListPresetsPaginateResponsePresetsSettingsContainerSettingsM3u8SettingsTypeDef,
        "MovSettings": ListPresetsPaginateResponsePresetsSettingsContainerSettingsMovSettingsTypeDef,
        "Mp4Settings": ListPresetsPaginateResponsePresetsSettingsContainerSettingsMp4SettingsTypeDef,
        "MpdSettings": ListPresetsPaginateResponsePresetsSettingsContainerSettingsMpdSettingsTypeDef,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsContainerSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsContainerSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettings` `ContainerSettings`

    - **Container** *(string) --* Container for this output. Some containers require a container
    settings object. If not specified, the default object will be created.

    - **F4vSettings** *(dict) --* Settings for F4v container

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

    - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
    output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
    these assets, data is organized by the program map table (PMT). Each transport stream program
    contains subsets of data, including audio, video, and metadata. Each of these subsets of data
    has a numerical label called a packet identifier (PID). Each transport stream program
    corresponds to one MediaConvert output. The PMT lists the types of data in a program along with
    their PID. Downstream systems and players use the program map table to look up the PID for each
    type of data it accesses and then uses the PIDs to locate specific data within the asset.

      - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for Dolby
      Digital audio.

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
      streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
      range 482-492.

        - *(integer) --*

      - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
      second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
      common values are 3750000, 7500000, and 15000000.

      - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
      If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
      latency, but low-memory devices may not be able to play back the stream without interruptions.

      - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the specified
      table repetition interval.

        - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
        (NIT).

        - **NetworkName** *(string) --* The network name text placed in the network_name_descriptor
        inside the Network Information Table. Maximum length is 256 characters.

        - **NitInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the specified
      table repetition interval.

        - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
        stream. "Follow input SDT" copies SDT information from input stream to output stream.
        "Follow input SDT if present" copies SDT information from input stream to output stream if
        SDT information is present in the input, otherwise it will fall back on the user-defined
        values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
        output stream will not contain SDT information.

        - **SdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
        Service Description Table. Maximum length is 256 characters.

        - **ServiceProviderName** *(string) --* The service provider name placed in the
        service_descriptor in the Service Description Table. Maximum length is 256 characters.

      - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
      included in this output. Specify multiple PIDs as a JSON array. Default is the range 460-479.

        - *(integer) --*

      - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified table
      repetition interval.

        - **TdtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

      - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext data
      you include in this output. Default is 499.

      - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP markers
      will be added to partitions 3 and 4. The interval between these additional markers will be
      fixed, and will be slightly shorter than the video EBP marker interval. When set to
      VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
      segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
      be placed only on the video PID, or on both the video PID and all audio PIDs. Only applicable
      when EBP segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

      - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
      header.

      - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know that
      your audio EBP markers are incorrectly appearing before your video EBP markers. To correct
      this problem, set this value to Force (FORCE).

      - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
      markers.

      - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between Program
      Clock References (PCRs) inserted into the transport stream.

      - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
      come within the specified time interval of each other by looking ahead at input video. If
      another EBP is going to come in within the specified time interval, the current EBP is not
      emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
      latency to the system. The Live Event must be configured elsewhere to create sufficient
      latency to make the lookahead accurate.

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to insert
      into the transport stream. This can be used if a downstream encryption system requires
      periodic null packets.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This is effective only
      when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
      reference (PCR) in this output. If you do not specify a value, the service will use the value
      for Video PID (VideoPid).

      - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
      program map table (PMT) in the output transport stream.

      - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
      (PMT) itself. Default is 480.

      - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
      metadata stream. Default is 503.

      - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
      number used in the program map table (PMT) for this output. Default is 1. Program numbers and
      program map tables are parts of MPEG-2 transport stream containers, used for organizing data.

      - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
      fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate, but
      the output will not be padded up to that bitrate.

      - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in your
      HLS and transport stream outputs at the insertion points that you specify in an ESAM XML
      document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream generated by ESAM.

      - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
      the transport stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a string
      in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35 (include
      the property scte35Esam).

      - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each segmentation_time
      period. rai_segstart sets the Random Access Indicator bit in the adaptation field. rai_adapt
      sets the RAI bit and adds the current timecode in the private data bytes. psi_segstart inserts
      PAT and PMT tables at the start of segments. ebp adds Encoder Boundary Point information to
      the adaptation field as per OpenCable specification OC-SP-EBP-I01-130118. ebp_legacy adds
      Encoder Boundary Point information to the adaptation field using a legacy proprietary format.

      - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
      segmentation markers are inserted into the transport stream. With avails, it is possible that
      segments may be truncated, which can influence where future segmentation markers are inserted.
      When a segmentation style of "reset_cadence" is selected and a segment is truncated due to an
      avail, we will reset the segmentation cadence. This means the subsequent segment will have a
      duration of of $segmentation_time seconds. When a segmentation style of "maintain_cadence" is
      selected and a segment is truncated due to an avail, we will not reset the segmentation
      cadence. This means the subsequent segment will likely be truncated as well. However, all
      segments after that will have a duration of $segmentation_time seconds. Note that EBP
      lookahead is a slight exception to this rule.

      - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment. Required
      unless markers is set to _none_.

      - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
      in this output. Default is 502.

      - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
      program map table for this output. Transport stream IDs and program map tables are parts of
      MPEG-2 transport stream containers, used for organizing data.

      - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
      stream in the transport stream.

    - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

      - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
      packet.

      - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
      transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
      separation.

        - *(integer) --*

      - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
      detected in the input audio and an equivalent ID3 tag will be inserted in the output.

      - **PatInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
      value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
      effective only when the PCR PID is the same as the video or audio elementary stream.

      - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
      the transport stream. When no value is given, the encoder will assign the same value as the
      Video PID.

      - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table in
      the output transport stream.

      - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
      transport stream.

      - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata stream
      in the transport stream.

      - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
      Table.

      - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the transport
      stream.

      - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
      (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
      output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
      markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
      conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
      want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
      setting Signal processing notification XML (sccXml).

      - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
      whether the service inserts the ID3 timed metadata from the input in this output.

      - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream in
      the transport stream.

      - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
      Program Map Table.

      - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
      transport stream.

    - **MovSettings** *(dict) --* Settings for MOV Container.

      - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
      output settings.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into the
      QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors and
      players, but may decrease compatibility with other players. Only applicable when the video
      codec is MPEG2.

      - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

      - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this setting.

    - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC outputs
    with this container.

      - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
      composition times in the 'ctts' (composition time to sample) box for B-frames will be
      negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
      amendment 1. This improves compatibility with Apple players and tools.

      - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

      - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
      to the beginning of the archive as required for progressive downloading. Otherwise it is
      placed normally at the end.

      - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
      Usually not necessary to specify.

    - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

      - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
      include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output from
      your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw container.
      Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained within
      fragmented MP4 files. This set of fragmented MP4 files is separate from your video and audio
      fragmented MP4 files.

      - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
      ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
      specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

      - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
      input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in
      your input to also appear in this output. Choose None (NONE) if you don't want those SCTE-35
      markers in this output.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef",
    {"FramerateDenominator": int, "FramerateNumerator": int, "MaxCaptures": int, "Quality": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettings`
    `FrameCaptureSettings`

    - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
    output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
    example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame
    per second) will capture the first frame, then 1 frame every 3s. Files will be named as
    filename.n.jpg where n is the 0-based sequence number of each Capture.

    - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the output
    stream, then one frame every framerateDenominator/framerateNumerator seconds. For example,
    settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3 frame per second)
    will capture the first frame, then 1 frame every 3s. Files will be named as filename.NNNNNNN.jpg
    where N is the 0-based frame sequence number zero padded to 7 decimal places.

    - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

    - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h264Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "EntropyEncoding": str,
        "FieldEncoding": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "RepeatPps": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "UnregisteredSeiTimecode": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettings`
    `H264Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output video
    settings. If you aren't sure what level to specify, choose Auto (AUTO).

    - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
    available with the AVC-I License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
    profile) or CAVLC.

    - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
    outputs.

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job specification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateDenominator to specify the denominator of this fraction. In this example, use 1001
    for the value of FramerateDenominator. When you use the console for transcode jobs that use
    frame rate conversion, provide the value as a decimal number for Framerate. In this example,
    specify 23.976.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type, as
    follows. - If the source is interlaced, the output will be interlaced with the same polarity as
    the source (it will follow the source). The output could therefore be a mix of "top field first"
    and "bottom field first". - If the source is progressive, the output will be interlaced with
    "top field first" or "bottom field first" polarity, depending on which of the Follow options you
    chose.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h264Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef",
    {"MaxAverageBitrate": int, "QvbrQualityLevel": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265Settings`
    `QvbrSettings`

    - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR and
    Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the complexity
    of your input video, the service limits the average bitrate of the video part of this output to
    the value that you choose. That is, the total size of the video element is less than or equal to
    the value you set multiplied by the number of seconds of encoded output.

    - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
    when you specify qvbrSettings within h265Settings. Specify the target quality level for this
    output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
    lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
    9.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "AlternateTransferFunctionSei": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FlickerAdaptiveQuantization": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopBReference": str,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "NumberReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "QvbrSettings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsQvbrSettingsTypeDef,
        "RateControlMode": str,
        "SampleAdaptiveOffsetFilterMode": str,
        "SceneChangeDetect": str,
        "Slices": int,
        "SlowPal": str,
        "SpatialAdaptiveQuantization": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
        "TemporalIds": str,
        "Tiles": str,
        "UnregisteredSeiTimecode": str,
        "WriteMp4PackagingType": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettings`
    `H265Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI message
    for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* H.265 Level.

    - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
    specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
    Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to reduce
    flicker or 'pop' on I-frames.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that have
    B frames > 1.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
    (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input. Choose
    Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output that's
    interlaced with the same field polarity throughout. Choose Follow, Default Top
    (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
    output with the same field polarity as the source. If the source is interlaced, the output will
    be interlaced with the same polarity as the source (it will follow the source). The output could
    therefore be a mix of "top field first" and "bottom field first". If the source is progressive,
    your output will be interlaced with "top field first" or "bottom field first" polarity,
    depending on which of the Follow options you chose. If you don't choose a value, the service
    will default to Progressive (PROGRESSIVE).

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000. Required when Rate control mode is QVBR.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
    use more than requested if using B-frames and/or interlaced encoding.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
    specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
    video encoding.

    - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
    H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
    control mode to a value other than QVBR, or when you don't define Rate control mode.

      - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
      and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
      complexity of your input video, the service limits the average bitrate of the video part of
      this output to the value that you choose. That is, the total size of the video element is less
      than or equal to the value you set multiplied by the number of seconds of encoded output.

      - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
      when you specify qvbrSettings within h265Settings. Specify the target quality level for this
      output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
      lossless compression. The quality level for most broadcast-quality transcodes is between 6 and
      9.

    - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
    variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

    - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
    strength. Adaptive mode dynamically selects best strength based on content

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.
    If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
    quality improvement. For more information about QVBR, see
    https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

    - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
    number of macroblock rows for progressive pictures, and less than or equal to half the number of
    macroblock rows for interlaced pictures.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
    (framerate) field is set to 29.970. This field works with the Streams > Advanced > Preprocessors
    > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced Mode field
    (interlace_mode) to identify the scan type for the output: Progressive, Interlaced, Hard
    Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft: produces
    23.976; the player converts this output to 29.97i.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.

    - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream. Up
    to 3 layers are supported depending on GOP structure: I- and P-frames form one layer, reference
    B-frames can form a second layer and non-reference b-frames can form a third layer. Decoders can
    optionally decode only the lower temporal layers to generate a lower frame rate output. For
    example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb display order),
    a decoder could decode all the frames for full frame rate output or only the I and P frames
    (lowest temporal layer) for a half frame rate output.

    - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
    subdivision of the encoded pictures.

    - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
    unregistered SEI message.

    - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
    matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
    or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
    output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
    SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
    parameter set NAL units in the sample headers but not in the samples directly. For MP4 outputs,
    when you choose HVC1, your output video might not work properly with some downstream systems and
    video players. The service defaults to marking your output as HEV1. For these outputs, the
    service writes parameter set NAL units directly into the samples.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef",
    {
        "AdaptiveQuantization": str,
        "Bitrate": int,
        "CodecLevel": str,
        "CodecProfile": str,
        "DynamicSubGop": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "GopClosedCadence": int,
        "GopSize": float,
        "GopSizeUnits": str,
        "HrdBufferInitialFillPercentage": int,
        "HrdBufferSize": int,
        "InterlaceMode": str,
        "IntraDcPrecision": str,
        "MaxBitrate": int,
        "MinIInterval": int,
        "NumberBFramesBetweenReferenceFrames": int,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "QualityTuningLevel": str,
        "RateControlMode": str,
        "SceneChangeDetect": str,
        "SlowPal": str,
        "Softness": int,
        "SpatialAdaptiveQuantization": str,
        "Syntax": str,
        "Telecine": str,
        "TemporalAdaptiveQuantization": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettings`
    `Mpeg2Settings`

    - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers to
    vary to improve visual quality.

    - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
    and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
    multiple of 1000.

    - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the video
    output.

    - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
    the video output.

    - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
    high-motion content. This will cause the service to use fewer B-frames (which infer information
    based on other frames) for high-motion portions of the video and more B-frames for low-motion
    portions. The maximum number of B-frames is limited by the value you provide for the setting B
    frames between reference frames (numberBFramesBetweenReferenceFrames).

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
    24000 / 1001 = 23.976 fps.

    - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it is
    recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame as
    quickly as possible. Setting this value to 0 will break output segmenting.

    - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be greater
    than zero.

    - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
    seconds. If seconds the system will convert the GOP Size into a frame count at run time.

    - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
    initially be filled (HRD buffer model).

    - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example, enter
    five megabits as 5000000.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
    quantization precision for intra-block DC coefficients. If you choose the value auto, the
    service will automatically select the precision based on the per-frame compression ratio.

    - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five megabits
    per second as 5000000.

    - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
    I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
    frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame. GOP
    stretch requires enabling lookahead as well as setting I-interval. The normal cadence resumes
    for the next GOP. This setting is only used when Scene Change Detect is enabled. Note: Maximum
    GOP stretch = GOP size + Min-I-interval - 1

    - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
    frames.

    - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service to
    use the pixel aspect ratio from the input. Using the console, do this by choosing Follow source
    for Pixel aspect ratio.

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
    specifiy whether to use single-pass or multipass video encoding.

    - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
    whether the bitrate is variable (vbr) or constant (cbr).

    - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
    that the service automatically detects. This improves video quality and is enabled by default.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
    high-frequency content in the encoded image.

    - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    spatial variation of content complexity.

    - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

    - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.

    - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
    temporal variation of content complexity.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef",
    {
        "CodecProfile": str,
        "FramerateControl": str,
        "FramerateConversionAlgorithm": str,
        "FramerateDenominator": int,
        "FramerateNumerator": int,
        "InterlaceMode": str,
        "ParControl": str,
        "ParDenominator": int,
        "ParNumerator": int,
        "SlowPal": str,
        "Telecine": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettings`
    `ProresSettings`

    - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of Apple
    ProRes codec to use for this output.

    - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting to
    specify the frame rate for this output. If you want to keep the same frame rate as the input
    video, choose Follow source. If you want to do frame rate conversion, choose a frame rate from
    the dropdown list or choose Custom. The framerates shown in the dropdown list are decimal
    approximations of fractions. If you choose Custom, specify your frame rate as a fraction. If you
    are creating your transcoding job sepecification as a JSON file without the console, use
    FramerateControl to specify which value the service uses for the frame rate for this output.
    Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from the input.
    Choose SPECIFIED if you want the service to use the frame rate you specify in the settings
    FramerateNumerator and FramerateDenominator.

    - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
    motion during frame rate conversion.

    - **FramerateDenominator** *(integer) --* Frame rate denominator.

    - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
    rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 = 23.976 fps.
    Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000 for
    the value of FramerateNumerator.

    - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
    type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD) produce
    interlaced output with the entire output having the same field polarity (top or bottom first). *
    Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the
    same field polarity as the source. Therefore, behavior depends on the input scan type. - If the
    source is interlaced, the output will be interlaced with the same polarity as the source (it
    will follow the source). The output could therefore be a mix of "top field first" and "bottom
    field first". - If the source is progressive, the output will be interlaced with "top field
    first" or "bottom field first" polarity, depending on which of the Follow options you chose.

    - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines the
    pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect ratio
    from the input. To specify a different pixel aspect ratio: Using the console, choose it from the
    dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for (ParNumerator)
    and (ParDenominator).

    - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

    - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

    - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
    relabeled as 25fps, and audio is sped up correspondingly.

    - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
    (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
    from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to the
    player.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef",
    {
        "Codec": str,
        "FrameCaptureSettings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsFrameCaptureSettingsTypeDef,
        "H264Settings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH264SettingsTypeDef,
        "H265Settings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsH265SettingsTypeDef,
        "Mpeg2Settings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsMpeg2SettingsTypeDef,
        "ProresSettings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsProresSettingsTypeDef,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsVideoDescription` `CodecSettings`

    - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
    values defined by the object VideoCodec.

    - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

      - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.n.jpg where n is the 0-based sequence number of each Capture.

      - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
      output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
      example, settings of framerateNumerator = 1 and framerateDenominator =
           3 (a rate of 1/3 frame
      per second) will capture the first frame, then 1 frame every 3s. Files will be named as
      filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7 decimal
      places.

      - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

      - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

    - **H264Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value H_264.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
      video settings. If you aren't sure what level to specify, choose Auto (AUTO).

      - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
      available with the AVC-I License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or High
      profile) or CAVLC.

      - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
      outputs.

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job specification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
      frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
      23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
      example, use 1001 for the value of FramerateDenominator. When you use the console for
      transcode jobs that use frame rate conversion, provide the value as a decimal number for
      Framerate. In this example, specify 23.976.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type, as follows. - If the source is interlaced, the output will be
      interlaced with the same polarity as the source (it will follow the source). The output could
      therefore be a mix of "top field first" and "bottom field first". - If the source is
      progressive, the output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h264Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

    - **H265Settings** *(dict) --* Settings for H265 codec

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
      message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* H.265 Level.

      - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
      specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
      Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
      reduce flicker or 'pop' on I-frames.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
      have B frames > 1.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose Progressive
      (PROGRESSIVE) to create a progressive output, regardless of the scan type of your input.
      Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to create an output
      that's interlaced with the same field polarity throughout. Choose Follow, Default Top
      (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an interlaced
      output with the same field polarity as the source. If the source is interlaced, the output
      will be interlaced with the same polarity as the source (it will follow the source). The
      output could therefore be a mix of "top field first" and "bottom field first". If the source
      is progressive, your output will be interlaced with "top field first" or "bottom field first"
      polarity, depending on which of the Follow options you chose. If you don't choose a value, the
      service will default to Progressive (PROGRESSIVE).

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000. Required when Rate control mode is QVBR.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder may
      use more than requested if using B-frames and/or interlaced encoding.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
      specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
      video encoding.

      - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with the
      H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set Rate
      control mode to a value other than QVBR, or when you don't define Rate control mode.

        - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is QVBR
        and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to the
        complexity of your input video, the service limits the average bitrate of the video part of
        this output to the value that you choose. That is, the total size of the video element is
        less than or equal to the value you set multiplied by the number of seconds of encoded
        output.

        - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That is,
        when you specify qvbrSettings within h265Settings. Specify the target quality level for this
        output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in nearly
        lossless compression. The quality level for most broadcast-quality transcodes is between 6
        and 9.

      - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
      variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

      - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO) filter
      strength. Adaptive mode dynamically selects best strength based on content

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.
      If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for further video
      quality improvement. For more information about QVBR, see
      https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

      - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
      number of macroblock rows for progressive pictures, and less than or equal to half the number
      of macroblock rows for interlaced pictures.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
      (framerate) field is set to 29.970. This field works with the Streams > Advanced >
      Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced > Interlaced
      Mode field (interlace_mode) to identify the scan type for the output: Progressive, Interlaced,
      Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from 23.976 input. - Soft:
      produces 23.976; the player converts this output to 29.97i.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

      - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
      Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
      reference B-frames can form a second layer and non-reference b-frames can form a third layer.
      Decoders can optionally decode only the lower temporal layers to generate a lower frame rate
      output. For example, given a bitstream with temporal IDs and with b-frames = 1 (i.e. IbPbPb
      display order), a decoder could decode all the frames for full frame rate output or only the I
      and P frames (lowest temporal layer) for a half frame rate output.

      - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
      subdivision of the encoded pictures.

      - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
      unregistered SEI message.

      - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
      matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH outputs,
      or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1 to mark your
      output as HVC1. This makes your output compliant with the following specification: ISO IECJTC1
      SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these outputs, the service stores
      parameter set NAL units in the sample headers but not in the samples directly. For MP4
      outputs, when you choose HVC1, your output video might not work properly with some downstream
      systems and video players. The service defaults to marking your output as HEV1. For these
      outputs, the service writes parameter set NAL units directly into the samples.

    - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value MPEG2.

      - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame quantizers
      to vary to improve visual quality.

      - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for VBR
      and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
      multiple of 1000.

      - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
      video output.

      - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile for
      the video output.

      - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
      high-motion content. This will cause the service to use fewer B-frames (which infer
      information based on other frames) for high-motion portions of the video and more B-frames for
      low-motion portions. The maximum number of B-frames is limited by the value you provide for
      the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction, e.g.
      24000 / 1001 = 23.976 fps.

      - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications, it
      is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR frame
      as quickly as possible. Setting this value to 0 will break output segmenting.

      - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
      greater than zero.

      - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames or
      seconds. If seconds the system will convert the GOP Size into a frame count at run time.

      - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
      initially be filled (HRD buffer model).

      - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
      enter five megabits as 5000000.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
      quantization precision for intra-block DC coefficients. If you choose the value auto, the
      service will automatically select the precision based on the per-frame compression ratio.

      - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
      megabits per second as 5000000.

      - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames and
      I-frames inserted by Scene Change Detection. If a scene change I-frame is within I-interval
      frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene change I-frame.
      GOP stretch requires enabling lookahead as well as setting I-interval. The normal cadence
      resumes for the next GOP. This setting is only used when Scene Change Detect is enabled. Note:
      Maximum GOP stretch = GOP size + Min-I-interval - 1

      - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between reference
      frames.

      - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
      to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
      source for Pixel aspect ratio.

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
      specifiy whether to use single-pass or multipass video encoding.

      - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
      whether the bitrate is variable (vbr) or constant (cbr).

      - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene changes
      that the service automatically detects. This improves video quality and is enabled by default.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
      high-frequency content in the encoded image.

      - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based on
      spatial variation of content complexity.

      - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

      - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.

      - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
      on temporal variation of content complexity.

    - **ProresSettings** *(dict) --* Required when you set (Codec) under
    (VideoDescription)>(CodecSettings) to the value PRORES.

      - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
      Apple ProRes codec to use for this output.

      - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
      to specify the frame rate for this output. If you want to keep the same frame rate as the
      input video, choose Follow source. If you want to do frame rate conversion, choose a frame
      rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
      decimal approximations of fractions. If you choose Custom, specify your frame rate as a
      fraction. If you are creating your transcoding job sepecification as a JSON file without the
      console, use FramerateControl to specify which value the service uses for the frame rate for
      this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate from
      the input. Choose SPECIFIED if you want the service to use the frame rate you specify in the
      settings FramerateNumerator and FramerateDenominator.

      - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
      motion during frame rate conversion.

      - **FramerateDenominator** *(integer) --* Frame rate denominator.

      - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use frame
      rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
           23.976 fps.
      Use FramerateNumerator to specify the numerator of this fraction. In this example, use 24000
      for the value of FramerateNumerator.

      - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
      type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
      produce interlaced output with the entire output having the same field polarity (top or bottom
      first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
      (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
      on the input scan type. - If the source is interlaced, the output will be interlaced with the
      same polarity as the source (it will follow the source). The output could therefore be a mix
      of "top field first" and "bottom field first". - If the source is progressive, the output will
      be interlaced with "top field first" or "bottom field first" polarity, depending on which of
      the Follow options you chose.

      - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
      the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel aspect
      ratio from the input. To specify a different pixel aspect ratio: Using the console, choose it
      from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and provide for
      (ParNumerator) and (ParDenominator).

      - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

      - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

      - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
      relabeled as 25fps, and audio is sped up correspondingly.

      - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
      (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i output
      from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave converstion to
      the player.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCropTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCropTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCropTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCropTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsVideoDescription` `Crop`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionPositionTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionPositionTypeDef",
    {"Height": int, "Width": int, "X": int, "Y": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionPositionTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionPositionTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsVideoDescription` `Position`

    - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

    - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

    - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
    video frame. Specify only even numbers.

    - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
    video frame. Specify only even numbers.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef",
    {
        "BluePrimaryX": int,
        "BluePrimaryY": int,
        "GreenPrimaryX": int,
        "GreenPrimaryY": int,
        "MaxContentLightLevel": int,
        "MaxFrameAverageLightLevel": int,
        "MaxLuminance": int,
        "MinLuminance": int,
        "RedPrimaryX": int,
        "RedPrimaryY": int,
        "WhitePointX": int,
        "WhitePointY": int,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrector`
    `Hdr10Metadata`

    - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
    video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
    coded video sequence, in units of candelas per square meter. This setting doesn't have a default
    value; you must specify a value that is suitable for the content.

    - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
    0.0001 candelas per square meter.

    - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
    0.0001 candelas per square meter

    - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.

    - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
    grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
    CIE1931 color coordinate. Note that this setting is not for color correction.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef",
    {
        "Brightness": int,
        "ColorSpaceConversion": str,
        "Contrast": int,
        "Hdr10Metadata": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorHdr10MetadataTypeDef,
        "Hue": int,
        "Saturation": int,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessors` `ColorCorrector`

    - **Brightness** *(integer) --* Brightness level.

    - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
    service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
    service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
    dynamic range. The converted video has an HDR format, but visually appears the same as an
    unconverted output.

    - **Contrast** *(integer) --* Contrast level.

    - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
    Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want signaled
    in the output. These values don't affect the pixel values that are encoded in the video stream.
    They are intended to help the downstream video player display content in a way that reflects the
    intentions of the the content creator. When you set Color space conversion
    (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set values
    for Max frame average light level (maxFrameAverageLightLevel) and Max content light level
    (maxContentLightLevel); these settings don't have a default value. The default values for the
    other HDR 10 metadata settings are defined by the P3D65 color space. For more information about
    MediaConvert HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

      - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
      video sequence, in units of candelas per square meter. This setting doesn't have a default
      value; you must specify a value that is suitable for the content.

      - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in the
      coded video sequence, in units of candelas per square meter. This setting doesn't have a
      default value; you must specify a value that is suitable for the content.

      - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
      0.0001 candelas per square meter.

      - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
      0.0001 candelas per square meter

      - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

      - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
      grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002 in
      CIE1931 color coordinate. Note that this setting is not for color correction.

    - **Hue** *(integer) --* Hue in degrees.

    - **Saturation** *(integer) --* Saturation level.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef",
    {"Algorithm": str, "Control": str, "Mode": str},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessors` `Deinterlacer`

    - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
    Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
    produces sharper pictures, while blend (BLEND) produces smoother motion. Use
    (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
    scrolling headline at the bottom of the frame.

    - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
    frames that are tagged in metadata as progressive. It will only convert those that are tagged as
    some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
    progressive - even those that are already tagged as progressive. Turn Force mode on only if
    there is a good chance that the metadata has tagged frames as progressive when they are not
    progressive. Do not turn on otherwise; processing frames that are already progressive into
    progressive will probably result in lower quality video.

    - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
    deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
    Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
    and converts to progressive.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef",
    {"MaxCll": int, "MaxFall": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVision`
    `L6Metadata`

    - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds to
    the brightest pixel in the entire stream. Measured in nits.

    - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
    corresponds to the highest frame-average brightness in the entire stream. Measured in nits.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef",
    {
        "L6Metadata": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionL6MetadataTypeDef,
        "L6Mode": str,
        "Profile": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessors` `DolbyVision`

    - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY to
    override the MaxCLL and MaxFALL values in your input with new values.

      - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that corresponds
      to the brightest pixel in the entire stream. Measured in nits.

      - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
      corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

    - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
    Vision MaxCLL and MaxFALL properies.

    - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision profile
    is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
    interleaved data.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef",
    {
        "Duration": int,
        "FadeIn": int,
        "FadeOut": int,
        "Height": int,
        "ImageInserterInput": str,
        "ImageX": int,
        "ImageY": int,
        "Layer": int,
        "Opacity": int,
        "StartTime": str,
        "Width": int,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserter`
    `InsertableImages`

    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on the
    output video. This duration includes fade-in time but not fade-out time.

    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start time
    that you specify for the image insertion and the time that the image appears at full opacity.
    Full opacity is the level that you specify for the opacity setting. If you don't specify a value
    for Fade-in, the image will appear abruptly at the overlay start time.

    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of the
    time that you have specified for the image overlay Duration and when the overlaid image has
    faded to total transparency. If you don't specify a value for Fade-out, the image will disappear
    abruptly at the end of the inserted image duration.

    - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you specify a
    value that's larger than the video resolution height, the service will crop your overlaid image
    to fit. To use the native height of the image, keep this setting blank.

    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
    image that you want to overlay on the video. Use a PNG or TGA file.

    - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and the
    left edge of the video frame. Required for any image overlay that you specify.

    - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and the
    top edge of the video frame. Required for any image overlay that you specify.

    - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with higher
    values for Layer appear on top of images with lower values for Layer.

    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying video
    shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is 50.

    - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
    first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to take
    into account your timecode source settings.

    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify a
    value that's larger than the video resolution width, the service will crop your overlaid image
    to fit. To use the native width of the image, keep this setting blank.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef",
    {
        "InsertableImages": List[
            ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterInsertableImagesTypeDef
        ]
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessors` `ImageInserter`

    - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
    The images must be PNG or TGA files.

      - *(dict) --* Settings that specify how your still graphic overlay appears.

        - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain on
        the output video. This duration includes fade-in time but not fade-out time.

        - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
        time that you specify for the image insertion and the time that the image appears at full
        opacity. Full opacity is the level that you specify for the opacity setting. If you don't
        specify a value for Fade-in, the image will appear abruptly at the overlay start time.

        - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end of
        the time that you have specified for the image overlay Duration and when the overlaid image
        has faded to total transparency. If you don't specify a value for Fade-out, the image will
        disappear abruptly at the end of the inserted image duration.

        - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
        specify a value that's larger than the video resolution height, the service will crop your
        overlaid image to fit. To use the native height of the image, keep this setting blank.

        - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of the
        image that you want to overlay on the video. Use a PNG or TGA file.

        - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image and
        the left edge of the video frame. Required for any image overlay that you specify.

        - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image and
        the top edge of the video frame. Required for any image overlay that you specify.

        - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
        higher values for Layer appear on top of images with lower values for Layer.

        - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
        video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default is
        50.

        - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay to
        first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember to
        take into account your timecode source settings.

        - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you specify
        a value that's larger than the video resolution width, the service will crop your overlaid
        image to fit. To use the native width of the image, keep this setting blank.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef",
    {"Strength": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `FilterSettings`

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef",
    {"PostFilterSharpenStrength": int, "Speed": int, "Strength": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `SpatialFilterSettings`

    - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
    sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

    - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
    with 0 being the nominal value.

    - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values produce
    stronger filtering.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef",
    {"AggressiveMode": int, "Speed": int, "Strength": int},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducer`
    `TemporalFilterSettings`

    - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
    Higher values produce stronger temporal filtering. This filters highly complex scenes more
    aggressively and creates better VQ for low bitrate outputs.

    - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
    reduces bit rate at the cost of transcode time, high setting improves transcode time at the cost
    of bit rate.

    - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this output.
    Higher values produce stronger filtering. We recommend the following value ranges, depending on
    the result that you want: * 0-2 for complexity reduction with minimal sharpness loss * 2-8 for
    complexity reduction with image preservation * 8-16 for a high level of complexity reduction
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef",
    {
        "Filter": str,
        "FilterSettings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerFilterSettingsTypeDef,
        "SpatialFilterSettings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerSpatialFilterSettingsTypeDef,
        "TemporalFilterSettings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTemporalFilterSettingsTypeDef,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessors` `NoiseReducer`

    - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
    following spatial image filtering functions. To use this setting, you must also enable Noise
    reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
    Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
    noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
    optimizes video quality for complex motion.

    - **FilterSettings** *(dict) --* Settings for a noise reducer filter

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

      - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
      sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

      - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher speed),
      with 0 being the nominal value.

      - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
      produce stronger filtering.

    - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

      - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
      Higher values produce stronger temporal filtering. This filters highly complex scenes more
      aggressively and creates better VQ for low bitrate outputs.

      - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
      reduces bit rate at the cost of transcode time, high setting improves transcode time at the
      cost of bit rate.

      - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
      output. Higher values produce stronger filtering. We recommend the following value ranges,
      depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
      loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
      complexity reduction
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef",
    {"FontSize": int, "Position": str, "Prefix": str},
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef
):
    """
    Type definition for
    `ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessors` `TimecodeBurnin`

    - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
    timecode. Valid values are 10, 16, 32, 48.

    - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
    (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

    - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
    timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
    either the characters themselves or the ASCII code equivalents. The supported range of
    characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
    represented on a standard English keyboard.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef",
    {
        "ColorCorrector": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsColorCorrectorTypeDef,
        "Deinterlacer": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDeinterlacerTypeDef,
        "DolbyVision": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsDolbyVisionTypeDef,
        "ImageInserter": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsImageInserterTypeDef,
        "NoiseReducer": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsNoiseReducerTypeDef,
        "TimecodeBurnin": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTimecodeBurninTypeDef,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettingsVideoDescription`
    `VideoPreprocessors`

    - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
    necessary. Enable or disable this feature for each output individually. This setting is disabled
    by default.

      - **Brightness** *(integer) --* Brightness level.

      - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output. The
      service supports conversion between HDR formats, between SDR formats, and from SDR to HDR. The
      service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't upgrade the
      dynamic range. The converted video has an HDR format, but visually appears the same as an
      unconverted output.

      - **Contrast** *(integer) --* Contrast level.

      - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color space.
      Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you want
      signaled in the output. These values don't affect the pixel values that are encoded in the
      video stream. They are intended to help the downstream video player display content in a way
      that reflects the intentions of the the content creator. When you set Color space conversion
      (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You must set
      values for Max frame average light level (maxFrameAverageLightLevel) and Max content light
      level (maxContentLightLevel); these settings don't have a default value. The default values
      for the other HDR 10 metadata settings are defined by the P3D65 color space. For more
      information about MediaConvert HDR jobs, see
      https://docs.aws.amazon.com/console/mediaconvert/hdr.

        - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
        color grader, using color grading tools. Range is 0 to 50,000, each increment represents
        0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the coded
        video sequence, in units of candelas per square meter. This setting doesn't have a default
        value; you must specify a value that is suitable for the content.

        - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
        the coded video sequence, in units of candelas per square meter. This setting doesn't have a
        default value; you must specify a value that is suitable for the content.

        - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of of
        0.0001 candelas per square meter.

        - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of of
        0.0001 candelas per square meter

        - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a color
        grader, using color grading tools. Range is 0 to 50,000, each increment represents 0.00002
        in CIE1931 color coordinate. Note that this setting is not for color correction.

      - **Hue** *(integer) --* Hue in degrees.

      - **Saturation** *(integer) --* Saturation level.

    - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and a
    clearer picture.

      - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
      Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
      produces sharper pictures, while blend (BLEND) produces smoother motion. Use
      (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
      scrolling headline at the bottom of the frame.

      - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not convert
      frames that are tagged in metadata as progressive. It will only convert those that are tagged
      as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts every frame to
      progressive - even those that are already tagged as progressive. Turn Force mode on only if
      there is a good chance that the metadata has tagged frames as progressive when they are not
      progressive. Do not turn on otherwise; processing frames that are already progressive into
      progressive will probably result in lower quality video.

      - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will do
      deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive. -
      Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive auto-detects
      and converts to progressive.

    - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
    video output.

      - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to SPECIFY
      to override the MaxCLL and MaxFALL values in your input with new values.

        - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
        corresponds to the brightest pixel in the entire stream. Measured in nits.

        - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
        corresponds to the highest frame-average brightness in the entire stream. Measured in nits.

      - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
      Vision MaxCLL and MaxFALL properies.

      - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
      profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision frame
      interleaved data.

    - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
    graphic overlay on your video. Enable or disable this feature for each output individually. This
    setting is disabled by default.

      - **InsertableImages** *(list) --* Specify the images that you want to overlay on your video.
      The images must be PNG or TGA files.

        - *(dict) --* Settings that specify how your still graphic overlay appears.

          - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
          on the output video. This duration includes fade-in time but not fade-out time.

          - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the Start
          time that you specify for the image insertion and the time that the image appears at full
          opacity. Full opacity is the level that you specify for the opacity setting. If you don't
          specify a value for Fade-in, the image will appear abruptly at the overlay start time.

          - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the end
          of the time that you have specified for the image overlay Duration and when the overlaid
          image has faded to total transparency. If you don't specify a value for Fade-out, the
          image will disappear abruptly at the end of the inserted image duration.

          - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
          specify a value that's larger than the video resolution height, the service will crop your
          overlaid image to fit. To use the native height of the image, keep this setting blank.

          - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
          the image that you want to overlay on the video. Use a PNG or TGA file.

          - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
          and the left edge of the video frame. Required for any image overlay that you specify.

          - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
          and the top edge of the video frame. Required for any image overlay that you specify.

          - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
          higher values for Layer appear on top of images with lower values for Layer.

          - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
          video shows through the inserted image. 0 is transparent and 100 is fully opaque. Default
          is 50.

          - **StartTime** *(string) --* Specify the timecode of the frame that you want the overlay
          to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF) format. Remember
          to take into account your timecode source settings.

          - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
          specify a value that's larger than the video resolution width, the service will crop your
          overlaid image to fit. To use the native width of the image, keep this setting blank.

    - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
    from your video output if necessary. Enable or disable this feature for each output
    individually. This setting is disabled by default.

      - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of the
      following spatial image filtering functions. To use this setting, you must also enable Noise
      reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean (softest),
      Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve does min/max
      noise reduction. * Spatial does frequency-domain filtering based on JND principles. * Temporal
      optimizes video quality for complex motion.

      - **FilterSettings** *(dict) --* Settings for a noise reducer filter

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

        - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
        sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

        - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
        speed), with 0 being the nominal value.

        - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
        produce stronger filtering.

      - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

        - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex motion.
        Higher values produce stronger temporal filtering. This filters highly complex scenes more
        aggressively and creates better VQ for low bitrate outputs.

        - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
        reduces bit rate at the cost of transcode time, high setting improves transcode time at the
        cost of bit rate.

        - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
        output. Higher values produce stronger filtering. We recommend the following value ranges,
        depending on the result that you want: * 0-2 for complexity reduction with minimal sharpness
        loss * 2-8 for complexity reduction with image preservation * 8-16 for a high level of
        complexity reduction

    - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
    and specified prefix into the output.

      - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
      timecode. Valid values are 10, 16, 32, 48.

      - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
      (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

      - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any burned-in
      timecode. For example, a prefix of "EZ-" will result in the timecode "EZ-00:00:00:00". Provide
      either the characters themselves or the ASCII code equivalents. The supported range of
      characters is 0x20 through 0x7e. This includes letters, numbers, and all special characters
      represented on a standard English keyboard.
    """


_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsVideoDescriptionTypeDef",
    {
        "AfdSignaling": str,
        "AntiAlias": str,
        "CodecSettings": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCodecSettingsTypeDef,
        "ColorMetadata": str,
        "Crop": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionCropTypeDef,
        "DropFrameTimecode": str,
        "FixedAfd": int,
        "Height": int,
        "Position": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionPositionTypeDef,
        "RespondToAfd": str,
        "ScalingBehavior": str,
        "Sharpness": int,
        "TimecodeInsertion": str,
        "VideoPreprocessors": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionVideoPreprocessorsTypeDef,
        "Width": int,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsVideoDescriptionTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsVideoDescriptionTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresetsSettings` `VideoDescription`

    - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
    Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
    the output video data and what those values are. * Choose None to remove all AFD values from
    this output. * Choose Fixed to ignore input AFD values and instead encode the value specified in
    the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

    - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs. The
    service no longer accepts the value DISABLED for AntiAlias. If you specify that in your job, the
    service will ignore the setting.

    - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under (VideoDescription),
    contains the group of settings related to video encoding. The settings in this group vary
    depending on the value that you choose for Video codec (Codec). For each codec enum that you
    choose, define the corresponding settings object. The following lists the codec enum, settings
    object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES,
    ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

      - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
      values defined by the object VideoCodec.

      - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

        - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.n.jpg where n is the 0-based sequence number of each Capture.

        - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
        output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
        example, settings of framerateNumerator = 1 and framerateDenominator = 3 (a rate of 1/3
        frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
        as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
        decimal places.

        - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

        - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

      - **H264Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value H_264.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
        video settings. If you aren't sure what level to specify, choose Auto (AUTO).

        - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
        available with the AVC-I License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
        High profile) or CAVLC.

        - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for interlaced
        outputs.

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job specification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
        example, use 1001 for the value of FramerateDenominator. When you use the console for
        transcode jobs that use frame rate conversion, provide the value as a decimal number for
        Framerate. In this example, specify 23.976.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type, as follows. - If the source is interlaced, the output will be
        interlaced with the same polarity as the source (it will follow the source). The output
        could therefore be a mix of "top field first" and "bottom field first". - If the source is
        progressive, the output will be interlaced with "top field first" or "bottom field first"
        polarity, depending on which of the Follow options you chose.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h264Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if repeated.

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

      - **H265Settings** *(dict) --* Settings for H265 codec

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
        message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* H.265 Level.

        - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
        specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents Main
        Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2 License.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
        reduce flicker or 'pop' on I-frames.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures that
        have B frames > 1.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames or
        seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
        Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
        your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
        create an output that's interlaced with the same field polarity throughout. Choose Follow,
        Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create an
        interlaced output with the same field polarity as the source. If the source is interlaced,
        the output will be interlaced with the same polarity as the source (it will follow the
        source). The output could therefore be a mix of "top field first" and "bottom field first".
        If the source is progressive, your output will be interlaced with "top field first" or
        "bottom field first" polarity, depending on which of the Follow options you chose. If you
        don't choose a value, the service will default to Progressive (PROGRESSIVE).

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000. Required when Rate control mode is QVBR.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
        may use more than requested if using B-frames and/or interlaced encoding.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel) to
        specifiy whether to use fast single-pass, high-quality singlepass, or high-quality multipass
        video encoding.

        - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
        the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
        Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

          - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
          QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
          the complexity of your input video, the service limits the average bitrate of the video
          part of this output to the value that you choose. That is, the total size of the video
          element is less than or equal to the value you set multiplied by the number of seconds of
          encoded output.

          - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
          is, when you specify qvbrSettings within h265Settings. Specify the target quality level
          for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results in
          nearly lossless compression. The quality level for most broadcast-quality transcodes is
          between 6 and 9.

        - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
        variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

        - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
        filter strength. Adaptive mode dynamically selects best strength based on content

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION) for
        further video quality improvement. For more information about QVBR, see
        https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

        - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to the
        number of macroblock rows for progressive pictures, and less than or equal to half the
        number of macroblock rows for interlaced pictures.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
        (framerate) field is set to 29.970. This field works with the Streams > Advanced >
        Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
        Interlaced Mode field (interlace_mode) to identify the scan type for the output:
        Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output from
        23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

        - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded bitstream.
        Up to 3 layers are supported depending on GOP structure: I- and P-frames form one layer,
        reference B-frames can form a second layer and non-reference b-frames can form a third
        layer. Decoders can optionally decode only the lower temporal layers to generate a lower
        frame rate output. For example, given a bitstream with temporal IDs and with b-frames =
             1
        (i.e. IbPbPb display order), a decoder could decode all the frames for full frame rate
        output or only the I and P frames (lowest temporal layer) for a half frame rate output.

        - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
        subdivision of the encoded pictures.

        - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of an
        unregistered SEI message.

        - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units doesn't
        matter in your workflow, ignore this setting. Use this setting only with CMAF or DASH
        outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose HVC1
        to mark your output as HVC1. This makes your output compliant with the following
        specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
        outputs, the service stores parameter set NAL units in the sample headers but not in the
        samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
        properly with some downstream systems and video players. The service defaults to marking
        your output as HEV1. For these outputs, the service writes parameter set NAL units directly
        into the samples.

      - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value MPEG2.

        - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
        quantizers to vary to improve visual quality.

        - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
        VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the nearest
        multiple of 1000.

        - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
        video output.

        - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
        for the video output.

        - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
        high-motion content. This will cause the service to use fewer B-frames (which infer
        information based on other frames) for high-motion portions of the video and more B-frames
        for low-motion portions. The maximum number of B-frames is limited by the value you provide
        for the setting B frames between reference frames (numberBFramesBetweenReferenceFrames).

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
        e.g. 24000 / 1001 = 23.976 fps.

        - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
        it is recommended that this be set to 1 so a decoder joining mid-stream will receive an IDR
        frame as quickly as possible. Setting this value to 0 will break output segmenting.

        - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
        greater than zero.

        - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
        or seconds. If seconds the system will convert the GOP Size into a frame count at run time.

        - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
        initially be filled (HRD buffer model).

        - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
        enter five megabits as 5000000.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
        quantization precision for intra-block DC coefficients. If you choose the value auto, the
        service will automatically select the precision based on the per-frame compression ratio.

        - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
        megabits per second as 5000000.

        - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
        and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
        I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
        change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
        normal cadence resumes for the next GOP. This setting is only used when Scene Change Detect
        is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

        - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
        reference frames.

        - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the service
        to use the pixel aspect ratio from the input. Using the console, do this by choosing Follow
        source for Pixel aspect ratio.

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel) to
        specifiy whether to use single-pass or multipass video encoding.

        - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to specifiy
        whether the bitrate is variable (vbr) or constant (cbr).

        - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
        changes that the service automatically detects. This improves video quality and is enabled
        by default.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
        high-frequency content in the encoded image.

        - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on spatial variation of content complexity.

        - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

        - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

        - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame based
        on temporal variation of content complexity.

      - **ProresSettings** *(dict) --* Required when you set (Codec) under
      (VideoDescription)>(CodecSettings) to the value PRORES.

        - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
        Apple ProRes codec to use for this output.

        - **FramerateControl** *(string) --* If you are using the console, use the Framerate setting
        to specify the frame rate for this output. If you want to keep the same frame rate as the
        input video, choose Follow source. If you want to do frame rate conversion, choose a frame
        rate from the dropdown list or choose Custom. The framerates shown in the dropdown list are
        decimal approximations of fractions. If you choose Custom, specify your frame rate as a
        fraction. If you are creating your transcoding job sepecification as a JSON file without the
        console, use FramerateControl to specify which value the service uses for the frame rate for
        this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
        from the input. Choose SPECIFIED if you want the service to use the frame rate you specify
        in the settings FramerateNumerator and FramerateDenominator.

        - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces smoother
        motion during frame rate conversion.

        - **FramerateDenominator** *(integer) --* Frame rate denominator.

        - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
        frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
        23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
        example, use 24000 for the value of FramerateNumerator.

        - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan line
        type for the output. * Top Field First (TOP_FIELD) and Bottom Field First (BOTTOM_FIELD)
        produce interlaced output with the entire output having the same field polarity (top or
        bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow, Default Bottom
        (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore, behavior depends
        on the input scan type. - If the source is interlaced, the output will be interlaced with
        the same polarity as the source (it will follow the source). The output could therefore be a
        mix of "top field first" and "bottom field first". - If the source is progressive, the
        output will be interlaced with "top field first" or "bottom field first" polarity, depending
        on which of the Follow options you chose.

        - **ParControl** *(string) --* Use (ProresParControl) to specify how the service determines
        the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use the pixel
        aspect ratio from the input. To specify a different pixel aspect ratio: Using the console,
        choose it from the dropdown menu. Using the API, set ProresParControl to (SPECIFIED) and
        provide for (ParNumerator) and (ParDenominator).

        - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

        - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

        - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
        relabeled as 25fps, and audio is sped up correspondingly.

        - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
        (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
        output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
        converstion to the player.

    - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
    metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
    you don't specify a value, the service sets this to Insert by default.

    - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the service
    will include in the output video frame.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
    enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
    drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
    default when Timecode insertion (TimecodeInsertion) is enabled.

    - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
    (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
    all frames of this video output.

    - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
    height for this output. Specify in pixels. If you don't provide a value here, the service will
    use the input height.

    - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
    output frame. The area outside of the rectangle that you specify here is black.

      - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

      - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

      - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of the
      video frame. Specify only even numbers.

      - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of the
      video frame. Specify only even numbers.

    - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
    changes the video itself in response to AFD values in the input. * Choose Respond to clip the
    input video frame according to the AFD value, input display aspect ratio, and output display
    aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
    AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
    RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
    values from this output.

    - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
    different aspect ratio from the input aspect ratio. Choose Stretch to output (STRETCH_TO_OUTPUT)
    to have the service stretch your video image to fit. Keep the setting Default (DEFAULT) to have
    the service letterbox your video instead. This setting overrides any value that you specify for
    the setting Selection placement (position) in this output.

    - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
    anti-aliasing. This setting changes the width of the anti-alias filter kernel used for scaling.
    Sharpness only applies if your output resolution is different from your input resolution. 0 is
    the softest setting, 100 the sharpest, and 50 recommended for most content.

    - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
    Only enable Timecode insertion when the input frame rate is identical to the output frame rate.
    To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
    PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
    inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
    none are present, the service will set the timecode for the first output frame to zero. To
    change this default behavior, adjust the settings under Timecode configuration (TimecodeConfig).
    In the console, these settings are located under Job > Job settings > Timecode configuration.
    Note - Timecode source under input settings (InputTimecodeSource) does not affect the timecodes
    that are inserted in the output. Source under Job settings > Timecode configuration
    (TimecodeSource) does.

    - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
    (VideoPreprocessors). Enable the features at each output individually. These features are
    disabled by default.

      - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
      necessary. Enable or disable this feature for each output individually. This setting is
      disabled by default.

        - **Brightness** *(integer) --* Brightness level.

        - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
        The service supports conversion between HDR formats, between SDR formats, and from SDR to
        HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
        upgrade the dynamic range. The converted video has an HDR format, but visually appears the
        same as an unconverted output.

        - **Contrast** *(integer) --* Contrast level.

        - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
        space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
        want signaled in the output. These values don't affect the pixel values that are encoded in
        the video stream. They are intended to help the downstream video player display content in a
        way that reflects the intentions of the the content creator. When you set Color space
        conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required. You
        must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
        content light level (maxContentLightLevel); these settings don't have a default value. The
        default values for the other HDR 10 metadata settings are defined by the P3D65 color space.
        For more information about MediaConvert HDR jobs, see
        https://docs.aws.amazon.com/console/mediaconvert/hdr.

          - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
          coded video sequence, in units of candelas per square meter. This setting doesn't have a
          default value; you must specify a value that is suitable for the content.

          - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame in
          the coded video sequence, in units of candelas per square meter. This setting doesn't have
          a default value; you must specify a value that is suitable for the content.

          - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units of
          of 0.0001 candelas per square meter.

          - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units of
          of 0.0001 candelas per square meter

          - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
          color grader, using color grading tools. Range is 0 to 50,000, each increment represents
          0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

        - **Hue** *(integer) --* Hue in degrees.

        - **Saturation** *(integer) --* Saturation level.

      - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion and
      a clearer picture.

        - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
        Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate (INTERPOLATE)
        produces sharper pictures, while blend (BLEND) produces smoother motion. Use
        (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
        scrolling headline at the bottom of the frame.

        - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
        convert frames that are tagged in metadata as progressive. It will only convert those that
        are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
        every frame to progressive - even those that are already tagged as progressive. Turn Force
        mode on only if there is a good chance that the metadata has tagged frames as progressive
        when they are not progressive. Do not turn on otherwise; processing frames that are already
        progressive into progressive will probably result in lower quality video.

        - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
        do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to progressive.
        - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. - Adaptive
        auto-detects and converts to progressive.

      - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
      video output.

        - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
        SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

          - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
          corresponds to the brightest pixel in the entire stream. Measured in nits.

          - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
          corresponds to the highest frame-average brightness in the entire stream. Measured in
          nits.

        - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle Dolby
        Vision MaxCLL and MaxFALL properies.

        - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
        profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
        frame interleaved data.

      - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include a
      graphic overlay on your video. Enable or disable this feature for each output individually.
      This setting is disabled by default.

        - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
        video. The images must be PNG or TGA files.

          - *(dict) --* Settings that specify how your still graphic overlay appears.

            - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to remain
            on the output video. This duration includes fade-in time but not fade-out time.

            - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
            Start time that you specify for the image insertion and the time that the image appears
            at full opacity. Full opacity is the level that you specify for the opacity setting. If
            you don't specify a value for Fade-in, the image will appear abruptly at the overlay
            start time.

            - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
            end of the time that you have specified for the image overlay Duration and when the
            overlaid image has faded to total transparency. If you don't specify a value for
            Fade-out, the image will disappear abruptly at the end of the inserted image duration.

            - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
            specify a value that's larger than the video resolution height, the service will crop
            your overlaid image to fit. To use the native height of the image, keep this setting
            blank.

            - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location of
            the image that you want to overlay on the video. Use a PNG or TGA file.

            - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted image
            and the left edge of the video frame. Required for any image overlay that you specify.

            - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid image
            and the top edge of the video frame. Required for any image overlay that you specify.

            - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
            higher values for Layer appear on top of images with lower values for Layer.

            - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the underlying
            video shows through the inserted image. 0 is transparent and 100 is fully opaque.
            Default is 50.

            - **StartTime** *(string) --* Specify the timecode of the frame that you want the
            overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
            format. Remember to take into account your timecode source settings.

            - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
            specify a value that's larger than the video resolution width, the service will crop
            your overlaid image to fit. To use the native width of the image, keep this setting
            blank.

      - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove noise
      from your video output if necessary. Enable or disable this feature for each output
      individually. This setting is disabled by default.

        - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
        the following spatial image filtering functions. To use this setting, you must also enable
        Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
        (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
        does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
        principles. * Temporal optimizes video quality for complex motion.

        - **FilterSettings** *(dict) --* Settings for a noise reducer filter

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

          - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
          sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

          - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
          speed), with 0 being the nominal value.

          - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
          produce stronger filtering.

        - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal filter.

          - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
          motion. Higher values produce stronger temporal filtering. This filters highly complex
          scenes more aggressively and creates better VQ for low bitrate outputs.

          - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low setting
          reduces bit rate at the cost of transcode time, high setting improves transcode time at
          the cost of bit rate.

          - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
          output. Higher values produce stronger filtering. We recommend the following value ranges,
          depending on the result that you want: * 0-2 for complexity reduction with minimal
          sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for a high
          level of complexity reduction

      - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output timecode
      and specified prefix into the output.

        - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any burned-in
        timecode. Valid values are 10, 16, 32, 48.

        - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
        (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

        - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
        burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
        "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
        The supported range of characters is 0x20 through 0x7e. This includes letters, numbers, and
        all special characters represented on a standard English keyboard.

    - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
    for this output. If you don't provide a value here, the service will use the input width.
    """


_ListPresetsPaginateResponsePresetsSettingsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsSettingsTypeDef",
    {
        "AudioDescriptions": List[
            ListPresetsPaginateResponsePresetsSettingsAudioDescriptionsTypeDef
        ],
        "CaptionDescriptions": List[
            ListPresetsPaginateResponsePresetsSettingsCaptionDescriptionsTypeDef
        ],
        "ContainerSettings": ListPresetsPaginateResponsePresetsSettingsContainerSettingsTypeDef,
        "VideoDescription": ListPresetsPaginateResponsePresetsSettingsVideoDescriptionTypeDef,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsSettingsTypeDef(
    _ListPresetsPaginateResponsePresetsSettingsTypeDef
):
    """
    Type definition for `ListPresetsPaginateResponsePresets` `Settings`

    - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
    settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
    (AudioDescriptions) can contain multiple groups of encoding settings.

      - *(dict) --* Description of audio output

        - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
        these settings unless you need to comply with a loudness standard.

          - **Algorithm** *(string) --* Choose one of the following audio normalization algorithms:
          ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness for an entire
          piece of content, suitable for measurement of short-form content under ATSC recommendation
          A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated loudness. A measurement of
          gated average loudness compliant with the requirements of EBU-R128. Supports up to 5.1
          audio channels. ITU-R BS.1770-3: Modified peak. The same loudness measurement algorithm as
          1770-2, with an updated true peak measurement. ITU-R BS.1770-4: Higher channel count.
          Allows for more audio channels than the other algorithms, including configurations such as
          7.1.

          - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using the
          chosen algorithm. If disabled, the audio will be measured but not adjusted.

          - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
          corrected to the target level. Content measuring below this level will not be corrected.
          Gating only applies when not using real_time_correction.

          - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track loudness
          to a CSV file.

          - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
          for each output's audio track loudness.

          - **TargetLkfs** *(float) --* When you use Audio normalization
          (AudioNormalizationSettings), optionally use this setting to specify a target loudness. If
          you don't specify a value here, the encoder chooses a value for you, based on the
          algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
          encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

        - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
        the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
        order within each input. For example if you specify "Audio Selector 3", then the third audio
        selector will be used from each input. If an input does not have an "Audio Selector 3", then
        the audio selector marked as "default" in that input will be used. If there is no audio
        selector marked as "default", silence will be inserted for the duration of that input.
        Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be specified,
        with similar default/silence behavior. If no audio_source_name is specified, then "Audio
        Selector 1" will be chosen automatically.

        - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked (false).
        A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
             Undefined, 1 =
        Clean Effects, 2 = Hearing Impaired, 3 = Visually Impaired Commentary, 4-255 = Reserved.

        - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an ISO
        639 audio_type, then that value is passed through to the output. If the input contains no
        ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the value
        in Audio Type is included in the output. Note that this field and audioType are both ignored
        if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

        - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
        (AudioDescriptions) contains the group of settings related to audio encoding. The settings
        in this group vary depending on the value that you choose for Audio codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
        WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
        Eac3AtmosSettings

          - **AacSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
          mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes, set
          the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode, you
          control the audio quality with the setting VBR quality (vbrQuality). In CBR mode, you use
          the setting Bitrate (bitrate). Defaults and valid values depend on the rate control mode.

            - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when the
            input contains pre-mixed main audio + audio description (AD) as a stereo pair. The value
            for AudioType will be set to 3, which signals to downstream systems that this stream
            contains "broadcaster mixed AD". Note that the input received by the encoder must
            contain pre-mixed audio; the encoder does not perform the mixing. When you choose
            BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
            FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
            audio description (AD). In this case, the encoder will use any values you provide for
            AudioType and FollowInputAudioType.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set of
            valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000, 24000,
            28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000, 192000,
            224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000, 768000, 896000,
            1024000. The value you set is also constrained by the values that you choose for Profile
            (codecProfile), Bitrate control mode (codingMode), and Sample rate (sampleRate). Default
            values depend on Bitrate control mode and Profile.

            - **CodecProfile** *(string) --* AAC Profile.

            - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
            layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
            (Receiver Mix)" setting receives a stereo description plus control track and emits a
            mono AAC encode of the description track, with control data emitted in the PES header as
            per ETSI TS 101 154 Annex E.

            - **RateControlMode** *(string) --* Rate Control Mode.

            - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
            LATM/LOAS AAC in an output, you must choose "No container" for the output container.

            - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
            mode and profile.

            - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw or
            MPEG-2 Transport Stream containers.

            - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
            VBR.

          - **Ac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AC3.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
            the encoder emits. For more information about the AC3 bitstream mode, see ATSC A/52-2012
            (Annex E).

            - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital, dialnorm will be passed through.

            - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds dynamic
            range compression signaling to the output bitstream as defined in the Dolby Digital
            specification.

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

          - **AiffSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value AIFF.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **Codec** *(string) --* Type of Audio codec.

          - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            values: 384k, 448k, 640k, 768k

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
            always 9.1.6 (CODING_MODE_9_1_6).

            - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
            loudness based on dialogue analysis.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60.
            The value -60 mutes the channel.

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this value
            for downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5,
            and -6.0.

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
            setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
            -6.0, and -60. The value -60 mutes the channel.

            - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
            audio.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
            be speech before the encoder uses the measured speech loudness as the overall program
            loudness.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

            - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
            center rear surround channel matrix encoded into your left and right surround channels.

          - **Eac3Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value EAC3.

            - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
            attenuation to the surround channels. Only used for 3/2 coding mode.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
            bitrates depend on the coding mode.

            - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream that
            the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
            A/52-2012 (Annex E).

            - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
            channels.

            - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

            - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input audio
            is Dolby Digital Plus, dialnorm will be passed through.

            - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
            signal with dynamic range compression.

            - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
            dynamic range when compressing the audio.

            - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE channel
            is enabled

            - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior to
            encoding. Only valid with 3_2_LFE coding mode.

            - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left only/Right only center (loRoCenterMixLevel).

            - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
            downmixing. How the service uses this value depends on the value that you choose for
            Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and -60. The
            value -60 mutes the channel. This setting applies only if you keep the default value of
            3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If
            you choose a different value for Coding mode, the service ignores Left only/Right only
            surround (loRoSurroundMixLevel).

            - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
            value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
            -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if you
            keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding
            mode (Eac3CodingMode). If you choose a different value for Coding mode, the service
            ignores Left total/Right total center (ltRtCenterMixLevel).

            - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Digital
            Plus setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses
            this value for downmixing. How the service uses this value depends on the value that you
            choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
            -60. The value -60 mutes the channel. This setting applies only if you keep the default
            value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
            (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
            Left total/Right total surround (ltRtSurroundMixLevel).

            - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
            sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio was
            not supplied from one of these streams, then the static metadata settings will be used.

            - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
            be passed through if it is present on the input. this detection is dynamic over the life
            of the transcode. Inputs that alternate between DD+ and non-DD+ content will have a
            consistent DD+ output as the system alternates between passthrough and encoding.

            - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
            surround channels. Only used for 3/2 coding mode.

            - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
            rate in Hz.

            - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
            setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
            (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
            different value for Coding mode, the service ignores Stereo downmix (Eac3StereoDownmix).

            - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra center
            back surround channel is matrix encoded into the left and right surround channels.

            - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround is
            matrix encoded into the two channels.

          - **Mp2Settings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value MP2.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

            - **Channels** *(integer) --* Set Channels to specify the number of channels in this
            output audio track. Choosing Mono in the console will give you 1 output channel;
            choosing Stereo will give you 2. In the API, valid values are 1 and 2.

            - **SampleRate** *(integer) --* Sample rate in hz.

          - **WavSettings** *(dict) --* Required when you set (Codec) under
          (AudioDescriptions)>(CodecSettings) to the value WAV.

            - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
            choose the encoding quality for this audio track.

            - **Channels** *(integer) --* Specify the number of channels in this output audio track.
            Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so on, up to
            64.

            - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
            output audio is likely to exceed 4 GB in file size, or if you otherwise need the
            extended support of the RF64 format, set your output WAV file format to RF64.

            - **SampleRate** *(integer) --* Sample rate in Hz.

        - **CustomLanguageCode** *(string) --* Specify the language for this audio output track. The
        service puts this language code into your output audio track when you set Language code
        control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service also uses
        your specified custom language code when you set Language code control
        (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
        specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
        streaming outputs, you can also use any other code in the full RFC-5646 specification.
        Streaming outputs are those that are in one of the following output groups: CMAF, DASH ISO,
        Apple HLS, or Microsoft Smooth Streaming.

        - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
        639 language specified in the 'Language Code' drop down will be used when 'Follow Input
        Language Code' is not selected or when 'Follow Input Language Code' is selected but there is
        no ISO 639 language code specified by the input.

        - **LanguageCodeControl** *(string) --* Specify which source for language code takes
        precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
        uses the language code from the input track if it's present. If there's no languge code on
        the input track, the service uses the code that you specify in the setting Language code
        (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
        service uses the language code that you specify.

        - **RemixSettings** *(dict) --* Advanced audio remixing settings.

          - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
          fields that hold the remixing value for each channel. Units are in dB. Acceptable values
          are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
          unchanged to the output channel (no attenuation or amplification).

            - **OutputChannels** *(list) --* List of output channels

              - *(dict) --* OutputChannel mapping settings.

                - **InputChannels** *(list) --* List of input channels

                  - *(integer) --*

          - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input that
          you want to use in your output. With remixing, you might combine or split the data in
          these channels, so the number of channels in your final output might be different.

          - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
          remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

        - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
        "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
        this information into destination manifests for display on the end-viewer's player device.
        For outputs in other output groups, the service ignores this setting.

    - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
    caption settings in a single output.

      - *(dict) --* Caption Description for preset

        - **CustomLanguageCode** *(string) --* Specify the language for this captions output track.
        For most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information when automatically selecting the font script for rendering the
        captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For streaming
        outputs, you can also use any other code in the full RFC-5646 specification. Streaming
        outputs are those that are in one of the following output groups: CMAF, DASH ISO, Apple HLS,
        or Microsoft Smooth Streaming.

        - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
        that burnin_destination_settings are not available if the source of the caption data is
        Embedded or Teletext.

          - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering burn-in captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **DestinationType** *(string) --* Specify the format for this set of captions on this
          output. The default format is embedded without SCTE-20. Other options are embedded with
          SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
          SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
          complies with the SCTE-43 spec. To create a non-compliant output where the embedded
          captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

          - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

            - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
            setting alignment to centered will place the captions at the bottom center of the
            output. Similarly, setting a left alignment will align captions to the bottom left of
            the output. If x and y positions are given in conjunction with the alignment parameter,
            the font will be justified (either left or centered) relative to those coordinates. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
            captions. All burn-in and DVB-Sub font settings must match.

            - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
            rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
            to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

            - **FontColor** *(string) --* Specifies the color of the burned-in captions. This option
            is not valid for source captions that are STL, 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255 is
            opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

            - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
            96 dpi. All burn-in and DVB-Sub font settings must match.

            - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script code,
            if the LanguageCode is not sufficient for determining the script type. Where
            LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
            is used to help determine the appropriate font for rendering DVB-Sub captions.

            - **FontSize** *(integer) --* A positive integer indicates the exact font size in
            points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
            settings must match.

            - **OutlineColor** *(string) --* Specifies font outline color. This option is not valid
            for source captions that are either 608/embedded or teletext. These source settings are
            already pre-defined by the caption stream. All burn-in and DVB-Sub font settings must
            match.

            - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
            not valid for source captions that are either 608/embedded or teletext. These source
            settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
            settings must match.

            - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the captions.
            All burn-in and DVB-Sub font settings must match.

            - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque; 0
            is transparent. Leaving this parameter blank is equivalent to setting it to 0
            (transparent). All burn-in and DVB-Sub font settings must match.

            - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
            relative to the captions in pixels. A value of -2 would result in a shadow offset 2
            pixels to the left. All burn-in and DVB-Sub font settings must match.

            - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow relative
            to the captions in pixels. A value of -2 would result in a shadow offset 2 pixels above
            the text. All burn-in and DVB-Sub font settings must match.

            - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
            for hearing impaired. Choose hearing impaired if your subtitles include audio
            descriptions and dialogue. Choose standard if your subtitles include only dialogue.

            - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in Teletext
            or STL formats. Specify whether the spacing between letters in your captions is set by
            the captions grid or varies depending on letter width. Choose fixed grid to conform to
            the spacing specified in the captions file more accurately. Choose proportional to make
            the text easier to read if the captions are closed caption.

            - **XPosition** *(integer) --* Specifies the horizontal position of the caption relative
            to the left side of the output in pixels. A value of 10 would result in the captions
            starting 10 pixels from the left of the output. If no explicit x_position is provided,
            the horizontal caption position will be determined by the alignment parameter. This
            option is not valid for source captions that are STL, 608/embedded or teletext. These
            source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
            font settings must match.

            - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
            to the top of the output in pixels. A value of 10 would result in the captions starting
            10 pixels from the top of the output. If no explicit y_position is provided, the caption
            will be positioned towards the bottom of the output. This option is not valid for source
            captions that are STL, 608/embedded or teletext. These source settings are already
            pre-defined by the caption stream. All burn-in and DVB-Sub font settings must match.

          - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
          caption outputs, including 608/708 Channel destination number.

            - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and your output captions are embedded in the video stream.
            Specify a CC number for each captions channel in this output. If you have two channels,
            choose CC numbers that aren't in the same field. For example, choose 1 and 3. For more
            information, see https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
            captions are SCC format and you want both 608 and 708 captions embedded in your output
            stream. Optionally, specify the 708 service number for each output captions channel.
            Choose a different number for each channel. To use this setting, also set Force 608 to
            708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions selector
            settings. If you choose to upconvert but don't specify a 708 service number,
            MediaConvert uses the number that you specify for CC channel number
            (destination608ChannelNumber) for the 708 service number. For more information, see
            https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

          - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

            - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert use
            the font style and position information from the captions source in the output. This
            option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or TTML.
            Disable this setting for simplified output captions.

          - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

            - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure that
            the captions and the video are synchronized in the output. Specify a frame rate that
            matches the frame rate of the associated video. If the video frame rate is 29.97, choose
            29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has video_insertion=true
            and drop_frame_timecode=true; otherwise, choose 29.97 non-dropframe
            (FRAMERATE_29_97_NON_DROPFRAME).

          - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

            - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
            destination captions for this output. This value must be a three-digit hexadecimal
            string; strings ending in -FF are invalid. If you are passing through the entire set of
            Teletext data, do not use this field.

            - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you don't
            specify a value here, the service sets the page type to the default value Subtitle
            (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data, don't use
            this field. When you pass through a set of Teletext pages, your output has the same page
            types as your input.

              - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

          - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
          including Pass style information (TtmlStylePassthrough).

            - **StylePassthrough** *(string) --* Pass through style and position information from a
            TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

        - **LanguageCode** *(string) --* Specify the language of this captions output track. For
        most captions output formats, the encoder puts this language information in the output
        captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
        this language information to choose the font language for rendering the captions text.

        - **LanguageDescription** *(string) --* Specify a label for this set of output captions. For
        example, "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert
        passes this information into destination manifests for display on the end-viewer's player
        device. For outputs in other output groups, the service ignores this setting.

    - **ContainerSettings** *(dict) --* Container specific settings.

      - **Container** *(string) --* Container for this output. Some containers require a container
      settings object. If not specified, the default object will be created.

      - **F4vSettings** *(dict) --* Settings for F4v container

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

      - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a File
      output group when the output's container (ContainerType) is MPEG-2 Transport Stream (M2TS). In
      these assets, data is organized by the program map table (PMT). Each transport stream program
      contains subsets of data, including audio, video, and metadata. Each of these subsets of data
      has a numerical label called a packet identifier (PID). Each transport stream program
      corresponds to one MediaConvert output. The PMT lists the types of data in a program along
      with their PID. Downstream systems and players use the program map table to look up the PID
      for each type of data it accesses and then uses the PIDs to locate specific data within the
      asset.

        - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
        Dolby Digital audio.

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
        streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
        range 482-492.

          - *(integer) --*

        - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits per
        second. Setting to 0 lets the muxer automatically determine the appropriate bitrate. Other
        common values are 3750000, 7500000, and 15000000.

        - **BufferModel** *(string) --* Controls what buffer model to use for accurate interleaving.
        If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can lead to lower
        latency, but low-memory devices may not be able to play back the stream without
        interruptions.

        - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
        specified table repetition interval.

          - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
          (NIT).

          - **NetworkName** *(string) --* The network name text placed in the
          network_name_descriptor inside the Network Information Table. Maximum length is 256
          characters.

          - **NitInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
        specified table repetition interval.

          - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
          stream. "Follow input SDT" copies SDT information from input stream to output stream.
          "Follow input SDT if present" copies SDT information from input stream to output stream if
          SDT information is present in the input, otherwise it will fall back on the user-defined
          values. Enter "SDT Manually" means user will enter the SDT information. "No SDT" means
          output stream will not contain SDT information.

          - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
          Service Description Table. Maximum length is 256 characters.

          - **ServiceProviderName** *(string) --* The service provider name placed in the
          service_descriptor in the Service Description Table. Maximum length is 256 characters.

        - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
        included in this output. Specify multiple PIDs as a JSON array. Default is the range
        460-479.

          - *(integer) --*

        - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
        table repetition interval.

          - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

        - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
        data you include in this output. Default is 499.

        - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
        markers will be added to partitions 3 and 4. The interval between these additional markers
        will be fixed, and will be slightly shorter than the video EBP marker interval. When set to
        VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
        segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

        - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can either
        be placed only on the video PID, or on both the video PID and all audio PIDs. Only
        applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
        EBP_LEGACY).

        - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
        header.

        - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
        that your audio EBP markers are incorrectly appearing before your video EBP markers. To
        correct this problem, set this value to Force (FORCE).

        - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with EBP
        markers.

        - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
        Program Clock References (PCRs) inserted into the transport stream.

        - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
        come within the specified time interval of each other by looking ahead at input video. If
        another EBP is going to come in within the specified time interval, the current EBP is not
        emitted, and the segment is "stretched" to the next marker. The lookahead value does not add
        latency to the system. The Live Event must be configured elsewhere to create sufficient
        latency to make the lookahead accurate.

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
        insert into the transport stream. This can be used if a downstream encryption system
        requires periodic null packets.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This is effective
        only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
        reference (PCR) in this output. If you do not specify a value, the service will use the
        value for Video PID (VideoPid).

        - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of the
        program map table (PMT) in the output transport stream.

        - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
        (PMT) itself. Default is 480.

        - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
        metadata stream. Default is 503.

        - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the program
        number used in the program map table (PMT) for this output. Default is 1. Program numbers
        and program map tables are parts of MPEG-2 transport stream containers, used for organizing
        data.

        - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream to
        fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum bitrate,
        but the output will not be padded up to that bitrate.

        - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
        your HLS and transport stream outputs at the insertion points that you specify in an ESAM
        XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream generated by ESAM.

        - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream in
        the transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
        string in the setting Signal processing notification XML (sccXml). Also enable ESAM SCTE-35
        (include the property scte35Esam).

        - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
        segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
        adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
        data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
        Encoder Boundary Point information to the adaptation field as per OpenCable specification
        OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
        field using a legacy proprietary format.

        - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
        segmentation markers are inserted into the transport stream. With avails, it is possible
        that segments may be truncated, which can influence where future segmentation markers are
        inserted. When a segmentation style of "reset_cadence" is selected and a segment is
        truncated due to an avail, we will reset the segmentation cadence. This means the subsequent
        segment will have a duration of of $segmentation_time seconds. When a segmentation style of
        "maintain_cadence" is selected and a segment is truncated due to an avail, we will not reset
        the segmentation cadence. This means the subsequent segment will likely be truncated as
        well. However, all segments after that will have a duration of $segmentation_time seconds.
        Note that EBP lookahead is a slight exception to this rule.

        - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
        Required unless markers is set to _none_.

        - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed metadata
        in this output. Default is 502.

        - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in the
        program map table for this output. Transport stream IDs and program map tables are parts of
        MPEG-2 transport stream containers, used for organizing data.

        - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
        stream in the transport stream.

      - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

        - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
        packet.

        - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in the
        transport stream. Multiple values are accepted, and can be entered in ranges and/or by comma
        separation.

          - *(integer) --*

        - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will be
        detected in the input audio and an equivalent ID3 tag will be inserted in the output.

        - **PatInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
        value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
        effective only when the PCR PID is the same as the video or audio elementary stream.

        - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR) in
        the transport stream. When no value is given, the encoder will assign the same value as the
        Video PID.

        - **PmtInterval** *(integer) --* The number of milliseconds between instances of this table
        in the output transport stream.

        - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
        transport stream.

        - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
        stream in the transport stream.

        - **ProgramNumber** *(integer) --* The value of the program number field in the Program Map
        Table.

        - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
        transport stream.

        - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
        (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
        output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
        markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
        conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
        want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
        setting Signal processing notification XML (sccXml).

        - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
        whether the service inserts the ID3 timed metadata from the input in this output.

        - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
        in the transport stream.

        - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
        Program Map Table.

        - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in the
        transport stream.

      - **MovSettings** *(dict) --* Settings for MOV Container.

        - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the video
        output settings.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
        the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple editors
        and players, but may decrease compatibility with other players. Only applicable when the
        video codec is MPEG2.

        - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

        - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
        setting.

      - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
      outputs with this container.

        - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
        composition times in the 'ctts' (composition time to sample) box for B-frames will be
        negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
        amendment 1. This improves compatibility with Apple players and tools.

        - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

        - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is relocated
        to the beginning of the archive as required for progressive downloading. Otherwise it is
        placed normally at the end.

        - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
        Usually not necessary to specify.

      - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

        - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
        include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
        from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
        container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
        within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
        and audio fragmented MP4 files.

        - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
        ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
        specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

        - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in your
        input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear
        in your input to also appear in this output. Choose None (NONE) if you don't want those
        SCTE-35 markers in this output.

    - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
    settings. The specific video settings depend on the video codec that you choose when you specify
    a value for Video codec (codec). Include one instance of (VideoDescription) per output.

      - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2 outputs.
      Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD values in
      the output video data and what those values are. * Choose None to remove all AFD values from
      this output. * Choose Fixed to ignore input AFD values and instead encode the value specified
      in the job. * Choose Auto to calculate output AFD values based on the input AFD scaler data.

      - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
      The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
      job, the service will ignore the setting.

      - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
      (VideoDescription), contains the group of settings related to video encoding. The settings in
      this group vary depending on the value that you choose for Video codec (Codec). For each codec
      enum that you choose, define the corresponding settings object. The following lists the codec
      enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
      Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

        - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
        values defined by the object VideoCodec.

        - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

          - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.n.jpg where n is the 0-based sequence number of each Capture.

          - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
          output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
          example, settings of framerateNumerator = 1 and framerateDenominator =
               3 (a rate of 1/3
          frame per second) will capture the first frame, then 1 frame every 3s. Files will be named
          as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded to 7
          decimal places.

          - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

          - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

        - **H264Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value H_264.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your output
          video settings. If you aren't sure what level to specify, choose Auto (AUTO).

          - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
          available with the AVC-I License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
          High profile) or CAVLC.

          - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
          interlaced outputs.

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job specification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateDenominator to specify the denominator of this fraction. In this
          example, use 1001 for the value of FramerateDenominator. When you use the console for
          transcode jobs that use frame rate conversion, provide the value as a decimal number for
          Framerate. In this example, specify 23.976.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type, as follows. - If the source is interlaced, the
          output will be interlaced with the same polarity as the source (it will follow the
          source). The output could therefore be a mix of "top field first" and "bottom field
          first". - If the source is progressive, the output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h264Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
          repeated.

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

        - **H265Settings** *(dict) --* Settings for H265 codec

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
          message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function (EOTF).

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* H.265 Level.

          - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
          specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
          Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
          License.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
          reduce flicker or 'pop' on I-frames.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
          that have B frames > 1.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
          Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
          your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
          create an output that's interlaced with the same field polarity throughout. Choose Follow,
          Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) to create
          an interlaced output with the same field polarity as the source. If the source is
          interlaced, the output will be interlaced with the same polarity as the source (it will
          follow the source). The output could therefore be a mix of "top field first" and "bottom
          field first". If the source is progressive, your output will be interlaced with "top field
          first" or "bottom field first" polarity, depending on which of the Follow options you
          chose. If you don't choose a value, the service will default to Progressive (PROGRESSIVE).

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000. Required when Rate control mode is QVBR.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The encoder
          may use more than requested if using B-frames and/or interlaced encoding.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
          to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
          multipass video encoding.

          - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding with
          the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when you set
          Rate control mode to a value other than QVBR, or when you don't define Rate control mode.

            - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
            QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited to
            the complexity of your input video, the service limits the average bitrate of the video
            part of this output to the value that you choose. That is, the total size of the video
            element is less than or equal to the value you set multiplied by the number of seconds
            of encoded output.

            - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode. That
            is, when you specify qvbrSettings within h265Settings. Specify the target quality level
            for this output, from 1 to 10. Use higher numbers for greater quality. Level 10 results
            in nearly lossless compression. The quality level for most broadcast-quality transcodes
            is between 6 and 9.

          - **RateControlMode** *(string) --* Use this setting to specify whether this output has a
          variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate (QVBR).

          - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
          filter strength. Adaptive mode dynamically selects best strength based on content

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default. If this output uses QVBR, choose Transition detection (TRANSITION_DETECTION)
          for further video quality improvement. For more information about QVBR, see
          https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

          - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
          the number of macroblock rows for progressive pictures, and less than or equal to half the
          number of macroblock rows for interlaced pictures.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Telecine** *(string) --* This field applies only if the Streams > Advanced > Framerate
          (framerate) field is set to 29.970. This field works with the Streams > Advanced >
          Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams > Advanced >
          Interlaced Mode field (interlace_mode) to identify the scan type for the output:
          Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i output
          from 23.976 input. - Soft: produces 23.976; the player converts this output to 29.97i.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

          - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
          bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
          one layer, reference B-frames can form a second layer and non-reference b-frames can form
          a third layer. Decoders can optionally decode only the lower temporal layers to generate a
          lower frame rate output. For example, given a bitstream with temporal IDs and with
          b-frames =
               1 (i.e. IbPbPb display order), a decoder could decode all the frames for full
          frame rate output or only the I and P frames (lowest temporal layer) for a half frame rate
          output.

          - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
          subdivision of the encoded pictures.

          - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes of
          an unregistered SEI message.

          - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
          doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
          DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs). Choose
          HVC1 to mark your output as HVC1. This makes your output compliant with the following
          specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition. For these
          outputs, the service stores parameter set NAL units in the sample headers but not in the
          samples directly. For MP4 outputs, when you choose HVC1, your output video might not work
          properly with some downstream systems and video players. The service defaults to marking
          your output as HEV1. For these outputs, the service writes parameter set NAL units
          directly into the samples.

        - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value MPEG2.

          - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
          quantizers to vary to improve visual quality.

          - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required for
          VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
          nearest multiple of 1000.

          - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for the
          video output.

          - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2 profile
          for the video output.

          - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality for
          high-motion content. This will cause the service to use fewer B-frames (which infer
          information based on other frames) for high-motion portions of the video and more B-frames
          for low-motion portions. The maximum number of B-frames is limited by the value you
          provide for the setting B frames between reference frames
          (numberBFramesBetweenReferenceFrames).

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
          e.g. 24000 / 1001 = 23.976 fps.

          - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming applications,
          it is recommended that this be set to 1 so a decoder joining mid-stream will receive an
          IDR frame as quickly as possible. Setting this value to 0 will break output segmenting.

          - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
          greater than zero.

          - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in frames
          or seconds. If seconds the system will convert the GOP Size into a frame count at run
          time.

          - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
          initially be filled (HRD buffer model).

          - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For example,
          enter five megabits as 5000000.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to set
          quantization precision for intra-block DC coefficients. If you choose the value auto, the
          service will automatically select the precision based on the per-frame compression ratio.

          - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
          megabits per second as 5000000.

          - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence) I-frames
          and I-frames inserted by Scene Change Detection. If a scene change I-frame is within
          I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the scene
          change I-frame. GOP stretch requires enabling lookahead as well as setting I-interval. The
          normal cadence resumes for the next GOP. This setting is only used when Scene Change
          Detect is enabled. Note: Maximum GOP stretch = GOP size + Min-I-interval - 1

          - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
          reference frames.

          - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
          service to use the pixel aspect ratio from the input. Using the console, do this by
          choosing Follow source for Pixel aspect ratio.

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **QualityTuningLevel** *(string) --* Use Quality tuning level (Mpeg2QualityTuningLevel)
          to specifiy whether to use single-pass or multipass video encoding.

          - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
          specifiy whether the bitrate is variable (vbr) or constant (cbr).

          - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
          changes that the service automatically detects. This improves video quality and is enabled
          by default.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
          high-frequency content in the encoded image.

          - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on spatial variation of content complexity.

          - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

          - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

          - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
          based on temporal variation of content complexity.

        - **ProresSettings** *(dict) --* Required when you set (Codec) under
        (VideoDescription)>(CodecSettings) to the value PRORES.

          - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type of
          Apple ProRes codec to use for this output.

          - **FramerateControl** *(string) --* If you are using the console, use the Framerate
          setting to specify the frame rate for this output. If you want to keep the same frame rate
          as the input video, choose Follow source. If you want to do frame rate conversion, choose
          a frame rate from the dropdown list or choose Custom. The framerates shown in the dropdown
          list are decimal approximations of fractions. If you choose Custom, specify your frame
          rate as a fraction. If you are creating your transcoding job sepecification as a JSON file
          without the console, use FramerateControl to specify which value the service uses for the
          frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the service to use
          the frame rate from the input. Choose SPECIFIED if you want the service to use the frame
          rate you specify in the settings FramerateNumerator and FramerateDenominator.

          - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
          smoother motion during frame rate conversion.

          - **FramerateDenominator** *(integer) --* Frame rate denominator.

          - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
          frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
          23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
          example, use 24000 for the value of FramerateNumerator.

          - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
          line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
          (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
          polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
          Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source. Therefore,
          behavior depends on the input scan type. - If the source is interlaced, the output will be
          interlaced with the same polarity as the source (it will follow the source). The output
          could therefore be a mix of "top field first" and "bottom field first". - If the source is
          progressive, the output will be interlaced with "top field first" or "bottom field first"
          polarity, depending on which of the Follow options you chose.

          - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
          determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
          the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
          the console, choose it from the dropdown menu. Using the API, set ProresParControl to
          (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

          - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

          - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

          - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input is
          relabeled as 25fps, and audio is sped up correspondingly.

          - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
          (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
          output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
          converstion to the player.

      - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
      metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output. If
      you don't specify a value, the service sets this to Insert by default.

      - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
      service will include in the output video frame.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature is
      enabled, the service will use drop-frame timecode on outputs. If it is not possible to use
      drop-frame timecode, the system will fall back to non-drop-frame. This setting is enabled by
      default when Timecode insertion (TimecodeInsertion) is enabled.

      - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
      (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write on
      all frames of this video output.

      - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
      height for this output. Specify in pixels. If you don't provide a value here, the service will
      use the input height.

      - **Position** *(dict) --* Use Selection placement (position) to define the video area in your
      output frame. The area outside of the rectangle that you specify here is black.

        - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

        - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

        - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
        the video frame. Specify only even numbers.

        - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
        the video frame. Specify only even numbers.

      - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the service
      changes the video itself in response to AFD values in the input. * Choose Respond to clip the
      input video frame according to the AFD value, input display aspect ratio, and output display
      aspect ratio. * Choose Passthrough to include the input AFD values. Do not choose this when
      AfdSignaling is set to (NONE). A preferred implementation of this workflow is to set
      RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all input AFD
      values from this output.

      - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
      different aspect ratio from the input aspect ratio. Choose Stretch to output
      (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
      Default (DEFAULT) to have the service letterbox your video instead. This setting overrides any
      value that you specify for the setting Selection placement (position) in this output.

      - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
      anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
      scaling. Sharpness only applies if your output resolution is different from your input
      resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

      - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes outputs.
      Only enable Timecode insertion when the input frame rate is identical to the output frame
      rate. To include timecodes in this output, set Timecode insertion (VideoTimecodeInsertion) to
      PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default is DISABLED. When the service
      inserts timecodes in an output, by default, it uses any embedded timecodes from the input. If
      none are present, the service will set the timecode for the first output frame to zero. To
      change this default behavior, adjust the settings under Timecode configuration
      (TimecodeConfig). In the console, these settings are located under Job > Job settings >
      Timecode configuration. Note - Timecode source under input settings (InputTimecodeSource) does
      not affect the timecodes that are inserted in the output. Source under Job settings > Timecode
      configuration (TimecodeSource) does.

      - **VideoPreprocessors** *(dict) --* Find additional transcoding features under Preprocessors
      (VideoPreprocessors). Enable the features at each output individually. These features are
      disabled by default.

        - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
        necessary. Enable or disable this feature for each output individually. This setting is
        disabled by default.

          - **Brightness** *(integer) --* Brightness level.

          - **ColorSpaceConversion** *(string) --* Specify the color space you want for this output.
          The service supports conversion between HDR formats, between SDR formats, and from SDR to
          HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR conversion doesn't
          upgrade the dynamic range. The converted video has an HDR format, but visually appears the
          same as an unconverted output.

          - **Contrast** *(integer) --* Contrast level.

          - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
          space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
          want signaled in the output. These values don't affect the pixel values that are encoded
          in the video stream. They are intended to help the downstream video player display content
          in a way that reflects the intentions of the the content creator. When you set Color space
          conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings are required.
          You must set values for Max frame average light level (maxFrameAverageLightLevel) and Max
          content light level (maxContentLightLevel); these settings don't have a default value. The
          default values for the other HDR 10 metadata settings are defined by the P3D65 color
          space. For more information about MediaConvert HDR jobs, see
          https://docs.aws.amazon.com/console/mediaconvert/hdr.

            - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
            coded video sequence, in units of candelas per square meter. This setting doesn't have a
            default value; you must specify a value that is suitable for the content.

            - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any frame
            in the coded video sequence, in units of candelas per square meter. This setting doesn't
            have a default value; you must specify a value that is suitable for the content.

            - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
            of of 0.0001 candelas per square meter.

            - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
            of of 0.0001 candelas per square meter

            - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

            - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
            color grader, using color grading tools. Range is 0 to 50,000, each increment represents
            0.00002 in CIE1931 color coordinate. Note that this setting is not for color correction.

          - **Hue** *(integer) --* Hue in degrees.

          - **Saturation** *(integer) --* Saturation level.

        - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
        and a clearer picture.

          - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode) to
          Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
          (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion. Use
          (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such as a
          scrolling headline at the bottom of the frame.

          - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
          convert frames that are tagged in metadata as progressive. It will only convert those that
          are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer converts
          every frame to progressive - even those that are already tagged as progressive. Turn Force
          mode on only if there is a good chance that the metadata has tagged frames as progressive
          when they are not progressive. Do not turn on otherwise; processing frames that are
          already progressive into progressive will probably result in lower quality video.

          - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service will
          do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
          progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
          Adaptive auto-detects and converts to progressive.

        - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision compatible
        video output.

          - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
          SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

            - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
            corresponds to the brightest pixel in the entire stream. Measured in nits.

            - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata that
            corresponds to the highest frame-average brightness in the entire stream. Measured in
            nits.

          - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
          Dolby Vision MaxCLL and MaxFALL properies.

          - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
          profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
          frame interleaved data.

        - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to include
        a graphic overlay on your video. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
          video. The images must be PNG or TGA files.

            - *(dict) --* Settings that specify how your still graphic overlay appears.

              - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
              remain on the output video. This duration includes fade-in time but not fade-out time.

              - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
              Start time that you specify for the image insertion and the time that the image
              appears at full opacity. Full opacity is the level that you specify for the opacity
              setting. If you don't specify a value for Fade-in, the image will appear abruptly at
              the overlay start time.

              - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between the
              end of the time that you have specified for the image overlay Duration and when the
              overlaid image has faded to total transparency. If you don't specify a value for
              Fade-out, the image will disappear abruptly at the end of the inserted image duration.

              - **Height** *(integer) --* Specify the height of the inserted image in pixels. If you
              specify a value that's larger than the video resolution height, the service will crop
              your overlaid image to fit. To use the native height of the image, keep this setting
              blank.

              - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3 location
              of the image that you want to overlay on the video. Use a PNG or TGA file.

              - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
              image and the left edge of the video frame. Required for any image overlay that you
              specify.

              - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
              image and the top edge of the video frame. Required for any image overlay that you
              specify.

              - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images with
              higher values for Layer appear on top of images with lower values for Layer.

              - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
              underlying video shows through the inserted image. 0 is transparent and 100 is fully
              opaque. Default is 50.

              - **StartTime** *(string) --* Specify the timecode of the frame that you want the
              overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
              format. Remember to take into account your timecode source settings.

              - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
              specify a value that's larger than the video resolution width, the service will crop
              your overlaid image to fit. To use the native width of the image, keep this setting
              blank.

        - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
        noise from your video output if necessary. Enable or disable this feature for each output
        individually. This setting is disabled by default.

          - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one of
          the following spatial image filtering functions. To use this setting, you must also enable
          Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. * Mean
          (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. * Conserve
          does min/max noise reduction. * Spatial does frequency-domain filtering based on JND
          principles. * Temporal optimizes video quality for complex motion.

          - **FilterSettings** *(dict) --* Settings for a noise reducer filter

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial filter.

            - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise reduction
            sharpening filter, with 0 disabling the filter and 3 enabling it at maximum strength.

            - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
            speed), with 0 being the nominal value.

            - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher values
            produce stronger filtering.

          - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
          filter.

            - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
            motion. Higher values produce stronger temporal filtering. This filters highly complex
            scenes more aggressively and creates better VQ for low bitrate outputs.

            - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
            setting reduces bit rate at the cost of transcode time, high setting improves transcode
            time at the cost of bit rate.

            - **Strength** *(integer) --* Specify the strength of the noise reducing filter on this
            output. Higher values produce stronger filtering. We recommend the following value
            ranges, depending on the result that you want: * 0-2 for complexity reduction with
            minimal sharpness loss * 2-8 for complexity reduction with image preservation * 8-16 for
            a high level of complexity reduction

        - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
        timecode and specified prefix into the output.

          - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
          burned-in timecode. Valid values are 10, 16, 32, 48.

          - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
          (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

          - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
          burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
          "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code equivalents.
          The supported range of characters is 0x20 through 0x7e. This includes letters, numbers,
          and all special characters represented on a standard English keyboard.

      - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in pixels,
      for this output. If you don't provide a value here, the service will use the input width.
    """


_ListPresetsPaginateResponsePresetsTypeDef = TypedDict(
    "_ListPresetsPaginateResponsePresetsTypeDef",
    {
        "Arn": str,
        "Category": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "Settings": ListPresetsPaginateResponsePresetsSettingsTypeDef,
        "Type": str,
    },
    total=False,
)


class ListPresetsPaginateResponsePresetsTypeDef(_ListPresetsPaginateResponsePresetsTypeDef):
    """
    Type definition for `ListPresetsPaginateResponse` `Presets`

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **Category** *(string) --* An optional category you create to organize your presets.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for preset creation.

    - **Description** *(string) --* An optional description you create for each preset.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the preset was last
    updated.

    - **Name** *(string) --* A name you create for each preset. Each name must be unique within your
    account.

    - **Settings** *(dict) --* Settings for preset

      - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
      settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
      (AudioDescriptions) can contain multiple groups of encoding settings.

        - *(dict) --* Description of audio output

          - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings. Ignore
          these settings unless you need to comply with a loudness standard.

            - **Algorithm** *(string) --* Choose one of the following audio normalization
            algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average loudness
            for an entire piece of content, suitable for measurement of short-form content under
            ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R BS.1770-2: Gated
            loudness. A measurement of gated average loudness compliant with the requirements of
            EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3: Modified peak. The same
            loudness measurement algorithm as 1770-2, with an updated true peak measurement. ITU-R
            BS.1770-4: Higher channel count. Allows for more audio channels than the other
            algorithms, including configurations such as 7.1.

            - **AlgorithmControl** *(string) --* When enabled the output audio is corrected using
            the chosen algorithm. If disabled, the audio will be measured but not adjusted.

            - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
            corrected to the target level. Content measuring below this level will not be corrected.
            Gating only applies when not using real_time_correction.

            - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
            loudness to a CSV file.

            - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the TruePeak
            for each output's audio track loudness.

            - **TargetLkfs** *(float) --* When you use Audio normalization
            (AudioNormalizationSettings), optionally use this setting to specify a target loudness.
            If you don't specify a value here, the encoder chooses a value for you, based on the
            algorithm that you choose for Algorithm (algorithm). If you choose algorithm 1770-1, the
            encoder will choose -24 LKFS; otherwise, the encoder will choose -23 LKFS.

          - **AudioSourceName** *(string) --* Specifies which audio data to use from each input. In
          the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based on its
          order within each input. For example if you specify "Audio Selector 3", then the third
          audio selector will be used from each input. If an input does not have an "Audio Selector
          3", then the audio selector marked as "default" in that input will be used. If there is no
          audio selector marked as "default", silence will be inserted for the duration of that
          input. Alternatively, an "Audio Selector Group":#inputs-audio_selector_group name may be
          specified, with similar default/silence behavior. If no audio_source_name is specified,
          then "Audio Selector 1" will be chosen automatically.

          - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
          (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
          Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
               Visually Impaired Commentary,
          4-255 = Reserved.

          - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains an
          ISO 639 audio_type, then that value is passed through to the output. If the input contains
          no ISO 639 audio_type, the value in Audio Type is included in the output. Otherwise the
          value in Audio Type is included in the output. Note that this field and audioType are both
          ignored if audioDescriptionBroadcasterMix is set to BROADCASTER_MIXED_AD.

          - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
          (AudioDescriptions) contains the group of settings related to audio encoding. The settings
          in this group vary depending on the value that you choose for Audio codec (Codec). For
          each codec enum that you choose, define the corresponding settings object. The following
          lists the codec enum, settings object pairs. * AAC, AacSettings * MP2, Mp2Settings * WAV,
          WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3, Eac3Settings * EAC3_ATMOS,
          Eac3AtmosSettings

            - **AacSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
            mutually exclusive groups of AAC settings--VBR and CBR. To select one of these modes,
            set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In VBR mode,
            you control the audio quality with the setting VBR quality (vbrQuality). In CBR mode,
            you use the setting Bitrate (bitrate). Defaults and valid values depend on the rate
            control mode.

              - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD when
              the input contains pre-mixed main audio + audio description (AD) as a stereo pair. The
              value for AudioType will be set to 3, which signals to downstream systems that this
              stream contains "broadcaster mixed AD". Note that the input received by the encoder
              must contain pre-mixed audio; the encoder does not perform the mixing. When you choose
              BROADCASTER_MIXED_AD, the encoder ignores any values you provide in AudioType and
              FollowInputAudioType. Choose NORMAL when the input does not contain pre-mixed audio +
              audio description (AD). In this case, the encoder will use any values you provide for
              AudioType and FollowInputAudioType.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The set
              of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000, 20000,
              24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000, 128000, 160000,
              192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000, 576000, 640000,
              768000, 896000, 1024000. The value you set is also constrained by the values that you
              choose for Profile (codecProfile), Bitrate control mode (codingMode), and Sample rate
              (sampleRate). Default values depend on Bitrate control mode and Profile.

              - **CodecProfile** *(string) --* AAC Profile.

              - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1 channel
              layout. Valid values depend on rate control mode and profile. "1.0 - Audio Description
              (Receiver Mix)" setting receives a stereo description plus control track and emits a
              mono AAC encode of the description track, with control data emitted in the PES header
              as per ETSI TS 101 154 Annex E.

              - **RateControlMode** *(string) --* Rate Control Mode.

              - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
              LATM/LOAS AAC in an output, you must choose "No container" for the output container.

              - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate control
              mode and profile.

              - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for raw
              or MPEG-2 Transport Stream containers.

              - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode is
              VBR.

            - **Ac3Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AC3.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              bitrates depend on the coding mode.

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream that
              the encoder emits. For more information about the AC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
              channels.

              - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
              audio is Dolby Digital, dialnorm will be passed through.

              - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
              dynamic range compression signaling to the output bitstream as defined in the Dolby
              Digital specification.

              - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior
              to encoding. Only valid with 3_2_LFE coding mode.

              - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
              sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio
              was not supplied from one of these streams, then the static metadata settings will be
              used.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

            - **AiffSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value AIFF.

              - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
              choose the encoding quality for this audio track.

              - **Channels** *(integer) --* Specify the number of channels in this output audio
              track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
              on, up to 64.

              - **SampleRate** *(integer) --* Sample rate in hz.

            - **Codec** *(string) --* Type of Audio codec.

            - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              values: 384k, 448k, 640k, 768k

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
              that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos) is
              always 9.1.6 (CODING_MODE_9_1_6).

              - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to adjust
              loudness based on dialogue analysis.

              - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
              signal with dynamic range compression.

              - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
              dynamic range when compressing the audio.

              - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this value
              for downmixing. How the service uses this value depends on the value that you choose
              for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5, -3.0,
              -4.5, and -6.0.

              - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value for
              downmixing. How the service uses this value depends on the value that you choose for
              Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0, and
              -60. The value -60 mutes the channel.

              - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, and -6.0.

              - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby Atmos
              setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0, -4.5,
              -6.0, and -60. The value -60 mutes the channel.

              - **MeteringMode** *(string) --* Choose how the service meters the loudness of your
              audio.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

              - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that must
              be speech before the encoder uses the measured speech loudness as the overall program
              loudness.

              - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

              - **SurroundExMode** *(string) --* Specify whether your input audio has an additional
              center rear surround channel matrix encoded into your left and right surround
              channels.

            - **Eac3Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value EAC3.

              - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
              attenuation to the surround channels. Only used for 3/2 coding mode.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
              bitrates depend on the coding mode.

              - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
              that the encoder emits. For more information about the EAC3 bitstream mode, see ATSC
              A/52-2012 (Annex E).

              - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number of
              channels.

              - **DcFilter** *(string) --* Activates a DC highpass filter for all input channels.

              - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
              audio is Dolby Digital Plus, dialnorm will be passed through.

              - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level for a
              signal with dynamic range compression.

              - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the audio
              dynamic range when compressing the audio.

              - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
              channel is enabled

              - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel prior
              to encoding. Only valid with 3_2_LFE coding mode.

              - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
              Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only
              if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left only/Right only center (loRoCenterMixLevel).

              - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
              Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0, -4.5, -6.0,
              and -60. The value -60 mutes the channel. This setting applies only if you keep the
              default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the setting Coding mode
              (Eac3CodingMode). If you choose a different value for Coding mode, the service ignores
              Left only/Right only surround (loRoSurroundMixLevel).

              - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby Digital
              Plus setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses this
              value for downmixing. How the service uses this value depends on the value that you
              choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0, 1.5, 0.0, -1.5,
              -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only
              if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left total/Right total center (ltRtCenterMixLevel).

              - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
              Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
              MediaConvert uses this value for downmixing. How the service uses this value depends
              on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values:
              -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies
              only if you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
              setting Coding mode (Eac3CodingMode). If you choose a different value for Coding mode,
              the service ignores Left total/Right total surround (ltRtSurroundMixLevel).

              - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata will be
              sourced from the DD, DD+, or DolbyE decoder that supplied this audio data. If audio
              was not supplied from one of these streams, then the static metadata settings will be
              used.

              - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio will
              be passed through if it is present on the input. this detection is dynamic over the
              life of the transcode. Inputs that alternate between DD+ and non-DD+ content will have
              a consistent DD+ output as the system alternates between passthrough and encoding.

              - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
              surround channels. Only used for 3/2 coding mode.

              - **SampleRate** *(integer) --* This value is always 48000. It represents the sample
              rate in Hz.

              - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing. This
              setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
              (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
              different value for Coding mode, the service ignores Stereo downmix
              (Eac3StereoDownmix).

              - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
              center back surround channel is matrix encoded into the left and right surround
              channels.

              - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby Surround
              is matrix encoded into the two channels.

            - **Mp2Settings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value MP2.

              - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

              - **Channels** *(integer) --* Set Channels to specify the number of channels in this
              output audio track. Choosing Mono in the console will give you 1 output channel;
              choosing Stereo will give you 2. In the API, valid values are 1 and 2.

              - **SampleRate** *(integer) --* Sample rate in hz.

            - **WavSettings** *(dict) --* Required when you set (Codec) under
            (AudioDescriptions)>(CodecSettings) to the value WAV.

              - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
              choose the encoding quality for this audio track.

              - **Channels** *(integer) --* Specify the number of channels in this output audio
              track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and so
              on, up to 64.

              - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If your
              output audio is likely to exceed 4 GB in file size, or if you otherwise need the
              extended support of the RF64 format, set your output WAV file format to RF64.

              - **SampleRate** *(integer) --* Sample rate in Hz.

          - **CustomLanguageCode** *(string) --* Specify the language for this audio output track.
          The service puts this language code into your output audio track when you set Language
          code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED). The service
          also uses your specified custom language code when you set Language code control
          (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file doesn't
          specify a language code. For all outputs, you can use an ISO 639-2 or ISO 639-3 code. For
          streaming outputs, you can also use any other code in the full RFC-5646 specification.
          Streaming outputs are those that are in one of the following output groups: CMAF, DASH
          ISO, Apple HLS, or Microsoft Smooth Streaming.

          - **LanguageCode** *(string) --* Indicates the language of the audio output track. The ISO
          639 language specified in the 'Language Code' drop down will be used when 'Follow Input
          Language Code' is not selected or when 'Follow Input Language Code' is selected but there
          is no ISO 639 language code specified by the input.

          - **LanguageCodeControl** *(string) --* Specify which source for language code takes
          precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the service
          uses the language code from the input track if it's present. If there's no languge code on
          the input track, the service uses the code that you specify in the setting Language code
          (languageCode or customLanguageCode). When you choose Use configured (USE_CONFIGURED), the
          service uses the language code that you specify.

          - **RemixSettings** *(dict) --* Advanced audio remixing settings.

            - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group of
            fields that hold the remixing value for each channel. Units are in dB. Acceptable values
            are within the range from -60 (mute) through 6. A setting of 0 passes the input channel
            unchanged to the output channel (no attenuation or amplification).

              - **OutputChannels** *(list) --* List of output channels

                - *(dict) --* OutputChannel mapping settings.

                  - **InputChannels** *(list) --* List of input channels

                    - *(integer) --*

            - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
            that you want to use in your output. With remixing, you might combine or split the data
            in these channels, so the number of channels in your final output might be different.

            - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
            remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

          - **StreamName** *(string) --* Specify a label for this output audio stream. For example,
          "English", "Director commentary", or "track_2". For streaming outputs, MediaConvert passes
          this information into destination manifests for display on the end-viewer's player device.
          For outputs in other output groups, the service ignores this setting.

      - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be multiple
      caption settings in a single output.

        - *(dict) --* Caption Description for preset

          - **CustomLanguageCode** *(string) --* Specify the language for this captions output
          track. For most captions output formats, the encoder puts this language information in the
          output captions metadata. If your output captions format is DVB-Sub or Burn in, the
          encoder uses this language information when automatically selecting the font script for
          rendering the captions text. For all outputs, you can use an ISO 639-2 or ISO 639-3 code.
          For streaming outputs, you can also use any other code in the full RFC-5646 specification.
          Streaming outputs are those that are in one of the following output groups: CMAF, DASH
          ISO, Apple HLS, or Microsoft Smooth Streaming.

          - **DestinationSettings** *(dict) --* Specific settings required by destination type. Note
          that burnin_destination_settings are not available if the source of the caption data is
          Embedded or Teletext.

            - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

              - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
              setting alignment to centered will place the captions at the bottom center of the
              output. Similarly, setting a left alignment will align captions to the bottom left of
              the output. If x and y positions are given in conjunction with the alignment
              parameter, the font will be justified (either left or centered) relative to those
              coordinates. This option is not valid for source captions that are STL, 608/embedded
              or teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
              captions. All burn-in and DVB-Sub font settings must match.

              - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
              rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
              to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

              - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
              option is not valid for source captions that are STL, 608/embedded or teletext. These
              source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
              font settings must match.

              - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255
              is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

              - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
              96 dpi. All burn-in and DVB-Sub font settings must match.

              - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
              code, if the LanguageCode is not sufficient for determining the script type. Where
              LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
              is used to help determine the appropriate font for rendering burn-in captions.

              - **FontSize** *(integer) --* A positive integer indicates the exact font size in
              points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineColor** *(string) --* Specifies font outline color. This option is not
              valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
              not valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
              captions. All burn-in and DVB-Sub font settings must match.

              - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque;
              0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
              (transparent). All burn-in and DVB-Sub font settings must match.

              - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels to the left. All burn-in and DVB-Sub font settings must match.

              - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels above the text. All burn-in and DVB-Sub font settings must match.

              - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
              Teletext or STL formats. Specify whether the spacing between letters in your captions
              is set by the captions grid or varies depending on letter width. Choose fixed grid to
              conform to the spacing specified in the captions file more accurately. Choose
              proportional to make the text easier to read if the captions are closed caption.

              - **XPosition** *(integer) --* Specifies the horizontal position of the caption
              relative to the left side of the output in pixels. A value of 10 would result in the
              captions starting 10 pixels from the left of the output. If no explicit x_position is
              provided, the horizontal caption position will be determined by the alignment
              parameter. This option is not valid for source captions that are STL, 608/embedded or
              teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
              to the top of the output in pixels. A value of 10 would result in the captions
              starting 10 pixels from the top of the output. If no explicit y_position is provided,
              the caption will be positioned towards the bottom of the output. This option is not
              valid for source captions that are STL, 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

            - **DestinationType** *(string) --* Specify the format for this set of captions on this
            output. The default format is embedded without SCTE-20. Other options are embedded with
            SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and web-VTT. If you are using
            SCTE-20, choose SCTE-20 plus embedded (SCTE20_PLUS_EMBEDDED) to create an output that
            complies with the SCTE-43 spec. To create a non-compliant output where the embedded
            captions come first, choose Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

            - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

              - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
              setting alignment to centered will place the captions at the bottom center of the
              output. Similarly, setting a left alignment will align captions to the bottom left of
              the output. If x and y positions are given in conjunction with the alignment
              parameter, the font will be justified (either left or centered) relative to those
              coordinates. This option is not valid for source captions that are STL, 608/embedded
              or teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind the
              captions. All burn-in and DVB-Sub font settings must match.

              - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
              rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is equivalent
              to setting it to 0 (transparent). All burn-in and DVB-Sub font settings must match.

              - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
              option is not valid for source captions that are STL, 608/embedded or teletext. These
              source settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
              font settings must match.

              - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions. 255
              is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

              - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch); default is
              96 dpi. All burn-in and DVB-Sub font settings must match.

              - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
              code, if the LanguageCode is not sufficient for determining the script type. Where
              LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset. This
              is used to help determine the appropriate font for rendering DVB-Sub captions.

              - **FontSize** *(integer) --* A positive integer indicates the exact font size in
              points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineColor** *(string) --* Specifies font outline color. This option is not
              valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This option is
              not valid for source captions that are either 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

              - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
              captions. All burn-in and DVB-Sub font settings must match.

              - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is opaque;
              0 is transparent. Leaving this parameter blank is equivalent to setting it to 0
              (transparent). All burn-in and DVB-Sub font settings must match.

              - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels to the left. All burn-in and DVB-Sub font settings must match.

              - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
              relative to the captions in pixels. A value of -2 would result in a shadow offset 2
              pixels above the text. All burn-in and DVB-Sub font settings must match.

              - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard or
              for hearing impaired. Choose hearing impaired if your subtitles include audio
              descriptions and dialogue. Choose standard if your subtitles include only dialogue.

              - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
              Teletext or STL formats. Specify whether the spacing between letters in your captions
              is set by the captions grid or varies depending on letter width. Choose fixed grid to
              conform to the spacing specified in the captions file more accurately. Choose
              proportional to make the text easier to read if the captions are closed caption.

              - **XPosition** *(integer) --* Specifies the horizontal position of the caption
              relative to the left side of the output in pixels. A value of 10 would result in the
              captions starting 10 pixels from the left of the output. If no explicit x_position is
              provided, the horizontal caption position will be determined by the alignment
              parameter. This option is not valid for source captions that are STL, 608/embedded or
              teletext. These source settings are already pre-defined by the caption stream. All
              burn-in and DVB-Sub font settings must match.

              - **YPosition** *(integer) --* Specifies the vertical position of the caption relative
              to the top of the output in pixels. A value of 10 would result in the captions
              starting 10 pixels from the top of the output. If no explicit y_position is provided,
              the caption will be positioned towards the bottom of the output. This option is not
              valid for source captions that are STL, 608/embedded or teletext. These source
              settings are already pre-defined by the caption stream. All burn-in and DVB-Sub font
              settings must match.

            - **EmbeddedDestinationSettings** *(dict) --* Settings specific to embedded/ancillary
            caption outputs, including 608/708 Channel destination number.

              - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your input
              captions are SCC format and your output captions are embedded in the video stream.
              Specify a CC number for each captions channel in this output. If you have two
              channels, choose CC numbers that aren't in the same field. For example, choose 1 and
              3. For more information, see
              https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

              - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your input
              captions are SCC format and you want both 608 and 708 captions embedded in your output
              stream. Optionally, specify the 708 service number for each output captions channel.
              Choose a different number for each channel. To use this setting, also set Force 608 to
              708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in your input captions
              selector settings. If you choose to upconvert but don't specify a 708 service number,
              MediaConvert uses the number that you specify for CC channel number
              (destination608ChannelNumber) for the 708 service number. For more information, see
              https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

            - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

              - **StylePassthrough** *(string) --* Keep this setting enabled to have MediaConvert
              use the font style and position information from the captions source in the output.
              This option is available only when your input captions are CFF-TT, IMSC, SMPTE-TT, or
              TTML. Disable this setting for simplified output captions.

            - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

              - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
              that the captions and the video are synchronized in the output. Specify a frame rate
              that matches the frame rate of the associated video. If the video frame rate is 29.97,
              choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
              video_insertion=true and drop_frame_timecode=true; otherwise, choose 29.97
              non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

            - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

              - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
              destination captions for this output. This value must be a three-digit hexadecimal
              string; strings ending in -FF are invalid. If you are passing through the entire set
              of Teletext data, do not use this field.

              - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
              don't specify a value here, the service sets the page type to the default value
              Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext data,
              don't use this field. When you pass through a set of Teletext pages, your output has
              the same page types as your input.

                - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

            - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
            including Pass style information (TtmlStylePassthrough).

              - **StylePassthrough** *(string) --* Pass through style and position information from
              a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or TTML output.

          - **LanguageCode** *(string) --* Specify the language of this captions output track. For
          most captions output formats, the encoder puts this language information in the output
          captions metadata. If your output captions format is DVB-Sub or Burn in, the encoder uses
          this language information to choose the font language for rendering the captions text.

          - **LanguageDescription** *(string) --* Specify a label for this set of output captions.
          For example, "English", "Director commentary", or "track_2". For streaming outputs,
          MediaConvert passes this information into destination manifests for display on the
          end-viewer's player device. For outputs in other output groups, the service ignores this
          setting.

      - **ContainerSettings** *(dict) --* Container specific settings.

        - **Container** *(string) --* Container for this output. Some containers require a container
        settings object. If not specified, the default object will be created.

        - **F4vSettings** *(dict) --* Settings for F4v container

          - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
          relocated to the beginning of the archive as required for progressive downloading.
          Otherwise it is placed normally at the end.

        - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
        File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
        (M2TS). In these assets, data is organized by the program map table (PMT). Each transport
        stream program contains subsets of data, including audio, video, and metadata. Each of these
        subsets of data has a numerical label called a packet identifier (PID). Each transport
        stream program corresponds to one MediaConvert output. The PMT lists the types of data in a
        program along with their PID. Downstream systems and players use the program map table to
        look up the PID for each type of data it accesses and then uses the PIDs to locate specific
        data within the asset.

          - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models for
          Dolby Digital audio.

          - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
          packet.

          - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary audio
          streams you include in this output. Specify multiple PIDs as a JSON array. Default is the
          range 482-492.

            - *(integer) --*

          - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in bits
          per second. Setting to 0 lets the muxer automatically determine the appropriate bitrate.
          Other common values are 3750000, 7500000, and 15000000.

          - **BufferModel** *(string) --* Controls what buffer model to use for accurate
          interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this can
          lead to lower latency, but low-memory devices may not be able to play back the stream
          without interruptions.

          - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
          specified table repetition interval.

            - **NetworkId** *(integer) --* The numeric value placed in the Network Information Table
            (NIT).

            - **NetworkName** *(string) --* The network name text placed in the
            network_name_descriptor inside the Network Information Table. Maximum length is 256
            characters.

            - **NitInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

          - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
          specified table repetition interval.

            - **OutputSdt** *(string) --* Selects method of inserting SDT information into output
            stream. "Follow input SDT" copies SDT information from input stream to output stream.
            "Follow input SDT if present" copies SDT information from input stream to output stream
            if SDT information is present in the input, otherwise it will fall back on the
            user-defined values. Enter "SDT Manually" means user will enter the SDT information. "No
            SDT" means output stream will not contain SDT information.

            - **SdtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

            - **ServiceName** *(string) --* The service name placed in the service_descriptor in the
            Service Description Table. Maximum length is 256 characters.

            - **ServiceProviderName** *(string) --* The service provider name placed in the
            service_descriptor in the Service Description Table. Maximum length is 256 characters.

          - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle data
          included in this output. Specify multiple PIDs as a JSON array. Default is the range
          460-479.

            - *(integer) --*

          - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the specified
          table repetition interval.

            - **TdtInterval** *(integer) --* The number of milliseconds between instances of this
            table in the output transport stream.

          - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB teletext
          data you include in this output. Default is 499.

          - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
          markers will be added to partitions 3 and 4. The interval between these additional markers
          will be fixed, and will be slightly shorter than the video EBP marker interval. When set
          to VIDEO_INTERVAL, these additional markers will not be inserted. Only applicable when EBP
          segmentation markers are is selected (segmentationMarkers is EBP or EBP_LEGACY).

          - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
          either be placed only on the video PID, or on both the video PID and all audio PIDs. Only
          applicable when EBP segmentation markers are is selected (segmentationMarkers is EBP or
          EBP_LEGACY).

          - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the PES
          header.

          - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you know
          that your audio EBP markers are incorrectly appearing before your video EBP markers. To
          correct this problem, set this value to Force (FORCE).

          - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used with
          EBP markers.

          - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
          Program Clock References (PCRs) inserted into the transport stream.

          - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do not
          come within the specified time interval of each other by looking ahead at input video. If
          another EBP is going to come in within the specified time interval, the current EBP is not
          emitted, and the segment is "stretched" to the next marker. The lookahead value does not
          add latency to the system. The Live Event must be configured elsewhere to create
          sufficient latency to make the lookahead accurate.

          - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will
          be detected in the input audio and an equivalent ID3 tag will be inserted in the output.

          - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
          insert into the transport stream. This can be used if a downstream encryption system
          requires periodic null packets.

          - **PatInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock Reference
          value is inserted for every Packetized Elementary Stream (PES) header. This is effective
          only when the PCR PID is the same as the video or audio elementary stream.

          - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
          reference (PCR) in this output. If you do not specify a value, the service will use the
          value for Video PID (VideoPid).

          - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances of
          the program map table (PMT) in the output transport stream.

          - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map table
          (PMT) itself. Default is 480.

          - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the private
          metadata stream. Default is 503.

          - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
          program number used in the program map table (PMT) for this output. Default is 1. Program
          numbers and program map tables are parts of MPEG-2 transport stream containers, used for
          organizing data.

          - **RateMode** *(string) --* When set to CBR, inserts null packets into transport stream
          to fill specified bitrate. When set to VBR, the bitrate setting acts as the maximum
          bitrate, but the output will not be padded up to that bitrate.

          - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers in
          your HLS and transport stream outputs at the insertion points that you specify in an ESAM
          XML document. Provide the document in the setting SCC XML (sccXml).

            - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
            transport stream generated by ESAM.

          - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35 stream
          in the transport stream.

          - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
          (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
          output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
          markers from an ESAM XML document-- Choose None (NONE). Also provide the ESAM XML as a
          string in the setting Signal processing notification XML (sccXml). Also enable ESAM
          SCTE-35 (include the property scte35Esam).

          - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
          segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
          adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the private
          data bytes. psi_segstart inserts PAT and PMT tables at the start of segments. ebp adds
          Encoder Boundary Point information to the adaptation field as per OpenCable specification
          OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information to the adaptation
          field using a legacy proprietary format.

          - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
          segmentation markers are inserted into the transport stream. With avails, it is possible
          that segments may be truncated, which can influence where future segmentation markers are
          inserted. When a segmentation style of "reset_cadence" is selected and a segment is
          truncated due to an avail, we will reset the segmentation cadence. This means the
          subsequent segment will have a duration of of $segmentation_time seconds. When a
          segmentation style of "maintain_cadence" is selected and a segment is truncated due to an
          avail, we will not reset the segmentation cadence. This means the subsequent segment will
          likely be truncated as well. However, all segments after that will have a duration of
          $segmentation_time seconds. Note that EBP lookahead is a slight exception to this rule.

          - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
          Required unless markers is set to _none_.

          - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
          metadata in this output. Default is 502.

          - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself in
          the program map table for this output. Transport stream IDs and program map tables are
          parts of MPEG-2 transport stream containers, used for organizing data.

          - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary video
          stream in the transport stream.

        - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

          - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each PES
          packet.

          - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s) in
          the transport stream. Multiple values are accepted, and can be entered in ranges and/or by
          comma separation.

            - *(integer) --*

          - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking will
          be detected in the input audio and an equivalent ID3 tag will be inserted in the output.

          - **PatInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock Reference
          value is inserted for every Packetized Elementary Stream (PES) header. This parameter is
          effective only when the PCR PID is the same as the video or audio elementary stream.

          - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference (PCR)
          in the transport stream. When no value is given, the encoder will assign the same value as
          the Video PID.

          - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
          table in the output transport stream.

          - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in the
          transport stream.

          - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private metadata
          stream in the transport stream.

          - **ProgramNumber** *(integer) --* The value of the program number field in the Program
          Map Table.

          - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
          transport stream.

          - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose Passthrough
          (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to also appear in this
          output. Choose None (NONE) if you don't want SCTE-35 markers in this output. For SCTE-35
          markers from an ESAM XML document-- Choose None (NONE) if you don't want manifest
          conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad markers (adMarkers) if you do
          want manifest conditioning. In both cases, also provide the ESAM XML as a string in the
          setting Signal processing notification XML (sccXml).

          - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to specify
          whether the service inserts the ID3 timed metadata from the input in this output.

          - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata stream
          in the transport stream.

          - **TransportStreamId** *(integer) --* The value of the transport stream ID field in the
          Program Map Table.

          - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream in
          the transport stream.

        - **MovSettings** *(dict) --* Settings for MOV Container.

          - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
          video output settings.

          - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
          composition times in the 'ctts' (composition time to sample) box for B-frames will be
          negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
          amendment 1. This improves compatibility with Apple players and tools.

          - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams into
          the QuickTime file using XDCAM fourcc codes. This increases compatibility with Apple
          editors and players, but may decrease compatibility with other players. Only applicable
          when the video codec is MPEG2.

          - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

          - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
          setting.

        - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
        outputs with this container.

          - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
          composition times in the 'ctts' (composition time to sample) box for B-frames will be
          negative, and a 'cslg' (composition shift least greatest) box will be included per 14496-1
          amendment 1. This improves compatibility with Apple players and tools.

          - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov box.

          - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
          relocated to the beginning of the archive as required for progressive downloading.
          Otherwise it is placed normally at the end.

          - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output file.
          Usually not necessary to specify.

        - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

          - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups that
          include sidecar TTML or IMSC captions. You specify sidecar captions in a separate output
          from your audio and video. Choose Raw (RAW) for captions in a single XML file in a raw
          container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML format contained
          within fragmented MP4 files. This set of fragmented MP4 files is separate from your video
          and audio fragmented MP4 files.

          - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers from
          ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points that you
          specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

          - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers in
          your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers that
          appear in your input to also appear in this output. Choose None (NONE) if you don't want
          those SCTE-35 markers in this output.

      - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
      settings. The specific video settings depend on the video codec that you choose when you
      specify a value for Video codec (codec). Include one instance of (VideoDescription) per
      output.

        - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
        outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes AFD
        values in the output video data and what those values are. * Choose None to remove all AFD
        values from this output. * Choose Fixed to ignore input AFD values and instead encode the
        value specified in the job. * Choose Auto to calculate output AFD values based on the input
        AFD scaler data.

        - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all outputs.
        The service no longer accepts the value DISABLED for AntiAlias. If you specify that in your
        job, the service will ignore the setting.

        - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
        (VideoDescription), contains the group of settings related to video encoding. The settings
        in this group vary depending on the value that you choose for Video codec (Codec). For each
        codec enum that you choose, define the corresponding settings object. The following lists
        the codec enum, settings object pairs. * H_264, H264Settings * H_265, H265Settings * MPEG2,
        Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE, FrameCaptureSettings

          - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the enum
          values defined by the object VideoCodec.

          - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

            - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame of
            the output stream, then one frame every framerateDenominator/framerateNumerator seconds.
            For example, settings of framerateNumerator = 1 and framerateDenominator =
                 3 (a rate of
            1/3 frame per second) will capture the first frame, then 1 frame every 3s. Files will be
            named as filename.n.jpg where n is the 0-based sequence number of each Capture.

            - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of the
            output stream, then one frame every framerateDenominator/framerateNumerator seconds. For
            example, settings of framerateNumerator = 1 and framerateDenominator =
                 3 (a rate of 1/3
            frame per second) will capture the first frame, then 1 frame every 3s. Files will be
            named as filename.NNNNNNN.jpg where N is the 0-based frame sequence number zero padded
            to 7 decimal places.

            - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output files).

            - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

          - **H264Settings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value H_264.

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
            output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

            - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are only
            available with the AVC-I License.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in Main or
            High profile) or CAVLC.

            - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
            interlaced outputs.

            - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
            reduce flicker or 'pop' on I-frames.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job specification as
            a JSON file without the console, use FramerateControl to specify which value the service
            uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you want the
            service to use the frame rate from the input. Choose SPECIFIED if you want the service
            to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs that
            use frame rate conversion, specify the frame rate as a fraction. For example, 24000 /
            1001 =
                 23.976 fps. Use FramerateDenominator to specify the denominator of this fraction.
            In this example, use 1001 for the value of FramerateDenominator. When you use the
            console for transcode jobs that use frame rate conversion, provide the value as a
            decimal number for Framerate. In this example, specify 23.976.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
            that have B frames > 1.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type, as follows. - If the source is
            interlaced, the output will be interlaced with the same polarity as the source (it will
            follow the source). The output could therefore be a mix of "top field first" and "bottom
            field first". - If the source is progressive, the output will be interlaced with "top
            field first" or "bottom field first" polarity, depending on which of the Follow options
            you chose.

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000. Required when Rate control mode is QVBR.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
            encoder may use more than requested if using B-frames and/or interlaced encoding.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level (H264QualityTuningLevel)
            to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
            multipass video encoding.

            - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
            with the H.264 codec. Required when you set Rate control mode to QVBR. Not valid when
            you set Rate control mode to a value other than QVBR, or when you don't define Rate
            control mode.

              - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
              QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited
              to the complexity of your input video, the service limits the average bitrate of the
              video part of this output to the value that you choose. That is, the total size of the
              video element is less than or equal to the value you set multiplied by the number of
              seconds of encoded output.

              - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
              That is, when you specify qvbrSettings within h264Settings. Specify the target quality
              level for this output, from 1 to 10. Use higher numbers for greater quality. Level 10
              results in nearly lossless compression. The quality level for most broadcast-quality
              transcodes is between 6 and 9.

            - **RateControlMode** *(string) --* Use this setting to specify whether this output has
            a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate
            (QVBR).

            - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
            repeated.

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default. If this output uses QVBR, choose Transition detection
            (TRANSITION_DETECTION) for further video quality improvement. For more information about
            QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

            - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
            the number of macroblock rows for progressive pictures, and less than or equal to half
            the number of macroblock rows for interlaced pictures.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
            high-frequency content in the encoded image.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

            - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
            Framerate (framerate) field is set to 29.970. This field works with the Streams >
            Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
            Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
            output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i
            output from 23.976 input. - Soft: produces 23.976; the player converts this output to
            29.97i.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

            - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
            of an unregistered SEI message.

          - **H265Settings** *(dict) --* Settings for H265 codec

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function SEI
            message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer Function
            (EOTF).

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* H.265 Level.

            - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC (H.265)
            specification. Selections are grouped as [Profile] / [Tier], so "Main/High" represents
            Main Profile with High Tier. 4:2:2 profiles are only available with the HEVC 4:2:2
            License.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each frame to
            reduce flicker or 'pop' on I-frames.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopBReference** *(string) --* If enable, use reference B frames for GOP structures
            that have B frames > 1.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
            Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan type of
            your input. Choose Top Field First (TOP_FIELD) or Bottom Field First (BOTTOM_FIELD) to
            create an output that's interlaced with the same field polarity throughout. Choose
            Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom (FOLLOW_BOTTOM_FIELD)
            to create an interlaced output with the same field polarity as the source. If the source
            is interlaced, the output will be interlaced with the same polarity as the source (it
            will follow the source). The output could therefore be a mix of "top field first" and
            "bottom field first". If the source is progressive, your output will be interlaced with
            "top field first" or "bottom field first" polarity, depending on which of the Follow
            options you chose. If you don't choose a value, the service will default to Progressive
            (PROGRESSIVE).

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000. Required when Rate control mode is QVBR.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
            encoder may use more than requested if using B-frames and/or interlaced encoding.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level (H265QualityTuningLevel)
            to specifiy whether to use fast single-pass, high-quality singlepass, or high-quality
            multipass video encoding.

            - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate encoding
            with the H.265 codec. Required when you set Rate control mode to QVBR. Not valid when
            you set Rate control mode to a value other than QVBR, or when you don't define Rate
            control mode.

              - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control mode is
              QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate values suited
              to the complexity of your input video, the service limits the average bitrate of the
              video part of this output to the value that you choose. That is, the total size of the
              video element is less than or equal to the value you set multiplied by the number of
              seconds of encoded output.

              - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control mode.
              That is, when you specify qvbrSettings within h265Settings. Specify the target quality
              level for this output, from 1 to 10. Use higher numbers for greater quality. Level 10
              results in nearly lossless compression. The quality level for most broadcast-quality
              transcodes is between 6 and 9.

            - **RateControlMode** *(string) --* Use this setting to specify whether this output has
            a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable bitrate
            (QVBR).

            - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset (SAO)
            filter strength. Adaptive mode dynamically selects best strength based on content

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default. If this output uses QVBR, choose Transition detection
            (TRANSITION_DETECTION) for further video quality improvement. For more information about
            QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

            - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal to
            the number of macroblock rows for progressive pictures, and less than or equal to half
            the number of macroblock rows for interlaced pictures.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
            Framerate (framerate) field is set to 29.970. This field works with the Streams >
            Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
            Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
            output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces 29.97i
            output from 23.976 input. - Soft: produces 23.976; the player converts this output to
            29.97i.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

            - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
            bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames form
            one layer, reference B-frames can form a second layer and non-reference b-frames can
            form a third layer. Decoders can optionally decode only the lower temporal layers to
            generate a lower frame rate output. For example, given a bitstream with temporal IDs and
            with b-frames =
                 1 (i.e. IbPbPb display order), a decoder could decode all the frames for
            full frame rate output or only the I and P frames (lowest temporal layer) for a half
            frame rate output.

            - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as vertical
            subdivision of the encoded pictures.

            - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4 bytes
            of an unregistered SEI message.

            - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
            doesn't matter in your workflow, ignore this setting. Use this setting only with CMAF or
            DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4 outputs).
            Choose HVC1 to mark your output as HVC1. This makes your output compliant with the
            following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15 3rd Edition.
            For these outputs, the service stores parameter set NAL units in the sample headers but
            not in the samples directly. For MP4 outputs, when you choose HVC1, your output video
            might not work properly with some downstream systems and video players. The service
            defaults to marking your output as HEV1. For these outputs, the service writes parameter
            set NAL units directly into the samples.

          - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value MPEG2.

            - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
            quantizers to vary to improve visual quality.

            - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Required
            for VBR and CBR. For MS Smooth outputs, bitrates must be unique when rounded down to the
            nearest multiple of 1000.

            - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level for
            the video output.

            - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
            profile for the video output.

            - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video quality
            for high-motion content. This will cause the service to use fewer B-frames (which infer
            information based on other frames) for high-motion portions of the video and more
            B-frames for low-motion portions. The maximum number of B-frames is limited by the value
            you provide for the setting B frames between reference frames
            (numberBFramesBetweenReferenceFrames).

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a fraction,
            e.g. 24000 / 1001 = 23.976 fps.

            - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
            applications, it is recommended that this be set to 1 so a decoder joining mid-stream
            will receive an IDR frame as quickly as possible. Setting this value to 0 will break
            output segmenting.

            - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must be
            greater than zero.

            - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
            frames or seconds. If seconds the system will convert the GOP Size into a frame count at
            run time.

            - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that should
            initially be filled (HRD buffer model).

            - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
            example, enter five megabits as 5000000.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type. - If the source is interlaced, the
            output will be interlaced with the same polarity as the source (it will follow the
            source). The output could therefore be a mix of "top field first" and "bottom field
            first". - If the source is progressive, the output will be interlaced with "top field
            first" or "bottom field first" polarity, depending on which of the Follow options you
            chose.

            - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision) to
            set quantization precision for intra-block DC coefficients. If you choose the value
            auto, the service will automatically select the precision based on the per-frame
            compression ratio.

            - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter five
            megabits per second as 5000000.

            - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
            I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame is
            within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched to the
            scene change I-frame. GOP stretch requires enabling lookahead as well as setting
            I-interval. The normal cadence resumes for the next GOP. This setting is only used when
            Scene Change Detect is enabled. Note: Maximum GOP stretch =
                 GOP size + Min-I-interval -
            1

            - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
            reference frames.

            - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
            service to use the pixel aspect ratio from the input. Using the console, do this by
            choosing Follow source for Pixel aspect ratio.

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **QualityTuningLevel** *(string) --* Use Quality tuning level
            (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
            encoding.

            - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
            specifiy whether the bitrate is variable (vbr) or constant (cbr).

            - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at scene
            changes that the service automatically detects. This improves video quality and is
            enabled by default.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values reduce
            high-frequency content in the encoded image.

            - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on spatial variation of content complexity.

            - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE 356M-2001).

            - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set Framerate
            (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to produce a 29.97i
            output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
            converstion to the player.

            - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each frame
            based on temporal variation of content complexity.

          - **ProresSettings** *(dict) --* Required when you set (Codec) under
          (VideoDescription)>(CodecSettings) to the value PRORES.

            - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the type
            of Apple ProRes codec to use for this output.

            - **FramerateControl** *(string) --* If you are using the console, use the Framerate
            setting to specify the frame rate for this output. If you want to keep the same frame
            rate as the input video, choose Follow source. If you want to do frame rate conversion,
            choose a frame rate from the dropdown list or choose Custom. The framerates shown in the
            dropdown list are decimal approximations of fractions. If you choose Custom, specify
            your frame rate as a fraction. If you are creating your transcoding job sepecification
            as a JSON file without the console, use FramerateControl to specify which value the
            service uses for the frame rate for this output. Choose INITIALIZE_FROM_SOURCE if you
            want the service to use the frame rate from the input. Choose SPECIFIED if you want the
            service to use the frame rate you specify in the settings FramerateNumerator and
            FramerateDenominator.

            - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
            smoother motion during frame rate conversion.

            - **FramerateDenominator** *(integer) --* Frame rate denominator.

            - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that use
            frame rate conversion, specify the frame rate as a fraction. For example, 24000 / 1001 =
            23.976 fps. Use FramerateNumerator to specify the numerator of this fraction. In this
            example, use 24000 for the value of FramerateNumerator.

            - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the scan
            line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
            (BOTTOM_FIELD) produce interlaced output with the entire output having the same field
            polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and Follow,
            Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the source.
            Therefore, behavior depends on the input scan type. - If the source is interlaced, the
            output will be interlaced with the same polarity as the source (it will follow the
            source). The output could therefore be a mix of "top field first" and "bottom field
            first". - If the source is progressive, the output will be interlaced with "top field
            first" or "bottom field first" polarity, depending on which of the Follow options you
            chose.

            - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
            determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to use
            the pixel aspect ratio from the input. To specify a different pixel aspect ratio: Using
            the console, choose it from the dropdown menu. Using the API, set ProresParControl to
            (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

            - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

            - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

            - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps input
            is relabeled as 25fps, and audio is sped up correspondingly.

            - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set Framerate
            (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to produce a 29.97i
            output from a 23.976 input. Set it to Soft (soft) to produce 23.976 output and leave
            converstion to the player.

        - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include color
        metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from this output.
        If you don't specify a value, the service sets this to Insert by default.

        - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
        service will include in the output video frame.

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this feature
        is enabled, the service will use drop-frame timecode on outputs. If it is not possible to
        use drop-frame timecode, the system will fall back to non-drop-frame. This setting is
        enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

        - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to Fixed
        (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service will write
        on all frames of this video output.

        - **Height** *(integer) --* Use the Height (Height) setting to define the video resolution
        height for this output. Specify in pixels. If you don't provide a value here, the service
        will use the input height.

        - **Position** *(dict) --* Use Selection placement (position) to define the video area in
        your output frame. The area outside of the rectangle that you specify here is black.

          - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

          - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

          - **X** *(integer) --* The distance, in pixels, between the rectangle and the left edge of
          the video frame. Specify only even numbers.

          - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge of
          the video frame. Specify only even numbers.

        - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
        service changes the video itself in response to AFD values in the input. * Choose Respond to
        clip the input video frame according to the AFD value, input display aspect ratio, and
        output display aspect ratio. * Choose Passthrough to include the input AFD values. Do not
        choose this when AfdSignaling is set to (NONE). A preferred implementation of this workflow
        is to set RespondToAfd to (NONE) and set AfdSignaling to (AUTO). * Choose None to remove all
        input AFD values from this output.

        - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
        different aspect ratio from the input aspect ratio. Choose Stretch to output
        (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the setting
        Default (DEFAULT) to have the service letterbox your video instead. This setting overrides
        any value that you specify for the setting Selection placement (position) in this output.

        - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength of
        anti-aliasing. This setting changes the width of the anti-alias filter kernel used for
        scaling. Sharpness only applies if your output resolution is different from your input
        resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for most content.

        - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
        outputs. Only enable Timecode insertion when the input frame rate is identical to the output
        frame rate. To include timecodes in this output, set Timecode insertion
        (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED. Default
        is DISABLED. When the service inserts timecodes in an output, by default, it uses any
        embedded timecodes from the input. If none are present, the service will set the timecode
        for the first output frame to zero. To change this default behavior, adjust the settings
        under Timecode configuration (TimecodeConfig). In the console, these settings are located
        under Job > Job settings > Timecode configuration. Note - Timecode source under input
        settings (InputTimecodeSource) does not affect the timecodes that are inserted in the
        output. Source under Job settings > Timecode configuration (TimecodeSource) does.

        - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
        Preprocessors (VideoPreprocessors). Enable the features at each output individually. These
        features are disabled by default.

          - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature if
          necessary. Enable or disable this feature for each output individually. This setting is
          disabled by default.

            - **Brightness** *(integer) --* Brightness level.

            - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
            output. The service supports conversion between HDR formats, between SDR formats, and
            from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to HDR
            conversion doesn't upgrade the dynamic range. The converted video has an HDR format, but
            visually appears the same as an unconverted output.

            - **Contrast** *(integer) --* Contrast level.

            - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10 color
            space. Specify the SMPTE ST 2086 Mastering Display Color Volume static metadata that you
            want signaled in the output. These values don't affect the pixel values that are encoded
            in the video stream. They are intended to help the downstream video player display
            content in a way that reflects the intentions of the the content creator. When you set
            Color space conversion (ColorSpaceConversion) to HDR 10 (FORCE_HDR10), these settings
            are required. You must set values for Max frame average light level
            (maxFrameAverageLightLevel) and Max content light level (maxContentLightLevel); these
            settings don't have a default value. The default values for the other HDR 10 metadata
            settings are defined by the P3D65 color space. For more information about MediaConvert
            HDR jobs, see https://docs.aws.amazon.com/console/mediaconvert/hdr.

              - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided by
              a color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in the
              coded video sequence, in units of candelas per square meter. This setting doesn't have
              a default value; you must specify a value that is suitable for the content.

              - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
              frame in the coded video sequence, in units of candelas per square meter. This setting
              doesn't have a default value; you must specify a value that is suitable for the
              content.

              - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in units
              of of 0.0001 candelas per square meter.

              - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in units
              of of 0.0001 candelas per square meter

              - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointX** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

              - **WhitePointY** *(integer) --* HDR Master Display Information must be provided by a
              color grader, using color grading tools. Range is 0 to 50,000, each increment
              represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
              color correction.

            - **Hue** *(integer) --* Hue in degrees.

            - **Saturation** *(integer) --* Saturation level.

          - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother motion
          and a clearer picture.

            - **Algorithm** *(string) --* Only applies when you set Deinterlacer (DeinterlaceMode)
            to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion adaptive interpolate
            (INTERPOLATE) produces sharper pictures, while blend (BLEND) produces smoother motion.
            Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source file includes a ticker, such
            as a scrolling headline at the bottom of the frame.

            - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does not
            convert frames that are tagged in metadata as progressive. It will only convert those
            that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the deinterlacer
            converts every frame to progressive - even those that are already tagged as progressive.
            Turn Force mode on only if there is a good chance that the metadata has tagged frames as
            progressive when they are not progressive. Do not turn on otherwise; processing frames
            that are already progressive into progressive will probably result in lower quality
            video.

            - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the service
            will do deinterlacing. Default is Deinterlace. - Deinterlace converts interlaced to
            progressive. - Inverse telecine converts Hard Telecine 29.97i to progressive 23.976p. -
            Adaptive auto-detects and converts to progressive.

          - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
          compatible video output.

            - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode to
            SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

              - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
              corresponds to the brightest pixel in the entire stream. Measured in nits.

              - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR metadata
              that corresponds to the highest frame-average brightness in the entire stream.
              Measured in nits.

            - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will handle
            Dolby Vision MaxCLL and MaxFALL properies.

            - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby Vision
            profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain Dolby Vision
            frame interleaved data.

          - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
          include a graphic overlay on your video. Enable or disable this feature for each output
          individually. This setting is disabled by default.

            - **InsertableImages** *(list) --* Specify the images that you want to overlay on your
            video. The images must be PNG or TGA files.

              - *(dict) --* Settings that specify how your still graphic overlay appears.

                - **Duration** *(integer) --* Specify the time, in milliseconds, for the image to
                remain on the output video. This duration includes fade-in time but not fade-out
                time.

                - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between the
                Start time that you specify for the image insertion and the time that the image
                appears at full opacity. Full opacity is the level that you specify for the opacity
                setting. If you don't specify a value for Fade-in, the image will appear abruptly at
                the overlay start time.

                - **FadeOut** *(integer) --* Specify the length of time, in milliseconds, between
                the end of the time that you have specified for the image overlay Duration and when
                the overlaid image has faded to total transparency. If you don't specify a value for
                Fade-out, the image will disappear abruptly at the end of the inserted image
                duration.

                - **Height** *(integer) --* Specify the height of the inserted image in pixels. If
                you specify a value that's larger than the video resolution height, the service will
                crop your overlaid image to fit. To use the native height of the image, keep this
                setting blank.

                - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                location of the image that you want to overlay on the video. Use a PNG or TGA file.

                - **ImageX** *(integer) --* Specify the distance, in pixels, between the inserted
                image and the left edge of the video frame. Required for any image overlay that you
                specify.

                - **ImageY** *(integer) --* Specify the distance, in pixels, between the overlaid
                image and the top edge of the video frame. Required for any image overlay that you
                specify.

                - **Layer** *(integer) --* Specify how overlapping inserted images appear. Images
                with higher values for Layer appear on top of images with lower values for Layer.

                - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                underlying video shows through the inserted image. 0 is transparent and 100 is fully
                opaque. Default is 50.

                - **StartTime** *(string) --* Specify the timecode of the frame that you want the
                overlay to first appear on. This must be in timecode (HH:MM:SS:FF or HH:MM:SS;FF)
                format. Remember to take into account your timecode source settings.

                - **Width** *(integer) --* Specify the width of the inserted image in pixels. If you
                specify a value that's larger than the video resolution width, the service will crop
                your overlaid image to fit. To use the native width of the image, keep this setting
                blank.

          - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to remove
          noise from your video output if necessary. Enable or disable this feature for each output
          individually. This setting is disabled by default.

            - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select one
            of the following spatial image filtering functions. To use this setting, you must also
            enable Noise reducer (NoiseReducer). * Bilateral preserves edges while reducing noise. *
            Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do convolution filtering. *
            Conserve does min/max noise reduction. * Spatial does frequency-domain filtering based
            on JND principles. * Temporal optimizes video quality for complex motion.

            - **FilterSettings** *(dict) --* Settings for a noise reducer filter

              - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
              values produce stronger filtering.

            - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
            filter.

              - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
              reduction sharpening filter, with 0 disabling the filter and 3 enabling it at maximum
              strength.

              - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3 (higher
              speed), with 0 being the nominal value.

              - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
              values produce stronger filtering.

            - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
            filter.

              - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has complex
              motion. Higher values produce stronger temporal filtering. This filters highly complex
              scenes more aggressively and creates better VQ for low bitrate outputs.

              - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
              setting reduces bit rate at the cost of transcode time, high setting improves
              transcode time at the cost of bit rate.

              - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
              this output. Higher values produce stronger filtering. We recommend the following
              value ranges, depending on the result that you want: * 0-2 for complexity reduction
              with minimal sharpness loss * 2-8 for complexity reduction with image preservation *
              8-16 for a high level of complexity reduction

          - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
          timecode and specified prefix into the output.

            - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
            burned-in timecode. Valid values are 10, 16, 32, 48.

            - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
            (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

            - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
            burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
            "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
            equivalents. The supported range of characters is 0x20 through 0x7e. This includes
            letters, numbers, and all special characters represented on a standard English keyboard.

        - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
        pixels, for this output. If you don't provide a value here, the service will use the input
        width.

    - **Type** *(string) --* A preset can be of two types: system or custom. System or built-in
    preset can't be modified or deleted by the user.
    """


_ListPresetsPaginateResponseTypeDef = TypedDict(
    "_ListPresetsPaginateResponseTypeDef",
    {"Presets": List[ListPresetsPaginateResponsePresetsTypeDef]},
    total=False,
)


class ListPresetsPaginateResponseTypeDef(_ListPresetsPaginateResponseTypeDef):
    """
    Type definition for `ListPresetsPaginate` `Response`

    - **Presets** *(list) --* List of presets

      - *(dict) --* A preset is a collection of preconfigured media conversion settings that you
      want MediaConvert to apply to the output during the conversion process.

        - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

        - **Category** *(string) --* An optional category you create to organize your presets.

        - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for preset creation.

        - **Description** *(string) --* An optional description you create for each preset.

        - **LastUpdated** *(datetime) --* The timestamp in epoch seconds when the preset was last
        updated.

        - **Name** *(string) --* A name you create for each preset. Each name must be unique within
        your account.

        - **Settings** *(dict) --* Settings for preset

          - **AudioDescriptions** *(list) --* (AudioDescriptions) contains groups of audio encoding
          settings organized by audio codec. Include one instance of (AudioDescriptions) per output.
          (AudioDescriptions) can contain multiple groups of encoding settings.

            - *(dict) --* Description of audio output

              - **AudioNormalizationSettings** *(dict) --* Advanced audio normalization settings.
              Ignore these settings unless you need to comply with a loudness standard.

                - **Algorithm** *(string) --* Choose one of the following audio normalization
                algorithms: ITU-R BS.1770-1: Ungated loudness. A measurement of ungated average
                loudness for an entire piece of content, suitable for measurement of short-form
                content under ATSC recommendation A/85. Supports up to 5.1 audio channels. ITU-R
                BS.1770-2: Gated loudness. A measurement of gated average loudness compliant with
                the requirements of EBU-R128. Supports up to 5.1 audio channels. ITU-R BS.1770-3:
                Modified peak. The same loudness measurement algorithm as 1770-2, with an updated
                true peak measurement. ITU-R BS.1770-4: Higher channel count. Allows for more audio
                channels than the other algorithms, including configurations such as 7.1.

                - **AlgorithmControl** *(string) --* When enabled the output audio is corrected
                using the chosen algorithm. If disabled, the audio will be measured but not
                adjusted.

                - **CorrectionGateLevel** *(integer) --* Content measuring above this level will be
                corrected to the target level. Content measuring below this level will not be
                corrected. Gating only applies when not using real_time_correction.

                - **LoudnessLogging** *(string) --* If set to LOG, log each output's audio track
                loudness to a CSV file.

                - **PeakCalculation** *(string) --* If set to TRUE_PEAK, calculate and log the
                TruePeak for each output's audio track loudness.

                - **TargetLkfs** *(float) --* When you use Audio normalization
                (AudioNormalizationSettings), optionally use this setting to specify a target
                loudness. If you don't specify a value here, the encoder chooses a value for you,
                based on the algorithm that you choose for Algorithm (algorithm). If you choose
                algorithm 1770-1, the encoder will choose -24 LKFS; otherwise, the encoder will
                choose -23 LKFS.

              - **AudioSourceName** *(string) --* Specifies which audio data to use from each input.
              In the simplest case, specify an "Audio Selector":#inputs-audio_selector by name based
              on its order within each input. For example if you specify "Audio Selector 3", then
              the third audio selector will be used from each input. If an input does not have an
              "Audio Selector 3", then the audio selector marked as "default" in that input will be
              used. If there is no audio selector marked as "default", silence will be inserted for
              the duration of that input. Alternatively, an "Audio Selector
              Group":#inputs-audio_selector_group name may be specified, with similar
              default/silence behavior. If no audio_source_name is specified, then "Audio Selector
              1" will be chosen automatically.

              - **AudioType** *(integer) --* Applies only if Follow Input Audio Type is unchecked
              (false). A number between 0 and 255. The following are defined in ISO-IEC 13818-1: 0 =
              Undefined, 1 = Clean Effects, 2 = Hearing Impaired, 3 =
                   Visually Impaired Commentary,
              4-255 = Reserved.

              - **AudioTypeControl** *(string) --* When set to FOLLOW_INPUT, if the input contains
              an ISO 639 audio_type, then that value is passed through to the output. If the input
              contains no ISO 639 audio_type, the value in Audio Type is included in the output.
              Otherwise the value in Audio Type is included in the output. Note that this field and
              audioType are both ignored if audioDescriptionBroadcasterMix is set to
              BROADCASTER_MIXED_AD.

              - **CodecSettings** *(dict) --* Audio codec settings (CodecSettings) under
              (AudioDescriptions) contains the group of settings related to audio encoding. The
              settings in this group vary depending on the value that you choose for Audio codec
              (Codec). For each codec enum that you choose, define the corresponding settings
              object. The following lists the codec enum, settings object pairs. * AAC, AacSettings
              * MP2, Mp2Settings * WAV, WavSettings * AIFF, AiffSettings * AC3, Ac3Settings * EAC3,
              Eac3Settings * EAC3_ATMOS, Eac3AtmosSettings

                - **AacSettings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value AAC. The service accepts one of two
                mutually exclusive groups of AAC settings--VBR and CBR. To select one of these
                modes, set the value of Bitrate control mode (rateControlMode) to "VBR" or "CBR". In
                VBR mode, you control the audio quality with the setting VBR quality (vbrQuality).
                In CBR mode, you use the setting Bitrate (bitrate). Defaults and valid values depend
                on the rate control mode.

                  - **AudioDescriptionBroadcasterMix** *(string) --* Choose BROADCASTER_MIXED_AD
                  when the input contains pre-mixed main audio + audio description (AD) as a stereo
                  pair. The value for AudioType will be set to 3, which signals to downstream
                  systems that this stream contains "broadcaster mixed AD". Note that the input
                  received by the encoder must contain pre-mixed audio; the encoder does not perform
                  the mixing. When you choose BROADCASTER_MIXED_AD, the encoder ignores any values
                  you provide in AudioType and FollowInputAudioType. Choose NORMAL when the input
                  does not contain pre-mixed audio + audio description (AD). In this case, the
                  encoder will use any values you provide for AudioType and FollowInputAudioType.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. The
                  set of valid values for this setting is: 6000, 8000, 10000, 12000, 14000, 16000,
                  20000, 24000, 28000, 32000, 40000, 48000, 56000, 64000, 80000, 96000, 112000,
                  128000, 160000, 192000, 224000, 256000, 288000, 320000, 384000, 448000, 512000,
                  576000, 640000, 768000, 896000, 1024000. The value you set is also constrained by
                  the values that you choose for Profile (codecProfile), Bitrate control mode
                  (codingMode), and Sample rate (sampleRate). Default values depend on Bitrate
                  control mode and Profile.

                  - **CodecProfile** *(string) --* AAC Profile.

                  - **CodingMode** *(string) --* Mono (Audio Description), Mono, Stereo, or 5.1
                  channel layout. Valid values depend on rate control mode and profile. "1.0 - Audio
                  Description (Receiver Mix)" setting receives a stereo description plus control
                  track and emits a mono AAC encode of the description track, with control data
                  emitted in the PES header as per ETSI TS 101 154 Annex E.

                  - **RateControlMode** *(string) --* Rate Control Mode.

                  - **RawFormat** *(string) --* Enables LATM/LOAS AAC output. Note that if you use
                  LATM/LOAS AAC in an output, you must choose "No container" for the output
                  container.

                  - **SampleRate** *(integer) --* Sample rate in Hz. Valid values depend on rate
                  control mode and profile.

                  - **Specification** *(string) --* Use MPEG-2 AAC instead of MPEG-4 AAC audio for
                  raw or MPEG-2 Transport Stream containers.

                  - **VbrQuality** *(string) --* VBR Quality Level - Only used if rate_control_mode
                  is VBR.

                - **Ac3Settings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value AC3.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                  bitrates depend on the coding mode.

                  - **BitstreamMode** *(string) --* Specify the bitstream mode for the AC-3 stream
                  that the encoder emits. For more information about the AC3 bitstream mode, see
                  ATSC A/52-2012 (Annex E).

                  - **CodingMode** *(string) --* Dolby Digital coding mode. Determines number of
                  channels.

                  - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                  audio is Dolby Digital, dialnorm will be passed through.

                  - **DynamicRangeCompressionProfile** *(string) --* If set to FILM_STANDARD, adds
                  dynamic range compression signaling to the output bitstream as defined in the
                  Dolby Digital specification.

                  - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                  prior to encoding. Only valid with 3_2_LFE coding mode.

                  - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                  will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data.
                  If audio was not supplied from one of these streams, then the static metadata
                  settings will be used.

                  - **SampleRate** *(integer) --* This value is always 48000. It represents the
                  sample rate in Hz.

                - **AiffSettings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value AIFF.

                  - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                  choose the encoding quality for this audio track.

                  - **Channels** *(integer) --* Specify the number of channels in this output audio
                  track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and
                  so on, up to 64.

                  - **SampleRate** *(integer) --* Sample rate in hz.

                - **Codec** *(string) --* Type of Audio codec.

                - **Eac3AtmosSettings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value EAC3_ATMOS.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                  values: 384k, 448k, 640k, 768k

                  - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                  that the encoder emits. For more information about the EAC3 bitstream mode, see
                  ATSC A/52-2012 (Annex E).

                  - **CodingMode** *(string) --* The coding mode for Dolby Digital Plus JOC (Atmos)
                  is always 9.1.6 (CODING_MODE_9_1_6).

                  - **DialogueIntelligence** *(string) --* Enable Dolby Dialogue Intelligence to
                  adjust loudness based on dialogue analysis.

                  - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                  for a signal with dynamic range compression.

                  - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                  audio dynamic range when compressing the audio.

                  - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                  Atmos setting: Left only/Right only center mix (Lo/Ro center). MediaConvert uses
                  this value for downmixing. How the service uses this value depends on the value
                  that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                  1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                  - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                  Atmos setting: Left only/Right only (Lo/Ro surround). MediaConvert uses this value
                  for downmixing. How the service uses this value depends on the value that you
                  choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: -1.5, -3.0,
                  -4.5, -6.0, and -60. The value -60 mutes the channel.

                  - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                  Atmos setting: Left total/Right total center mix (Lt/Rt center). MediaConvert uses
                  this value for downmixing. How the service uses this value depends on the value
                  that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values: 3.0,
                  1.5, 0.0, -1.5, -3.0, -4.5, and -6.0.

                  - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                  Atmos setting: Left total/Right total surround mix (Lt/Rt surround). MediaConvert
                  uses this value for downmixing. How the service uses this value depends on the
                  value that you choose for Stereo downmix (Eac3AtmosStereoDownmix). Valid values:
                  -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel.

                  - **MeteringMode** *(string) --* Choose how the service meters the loudness of
                  your audio.

                  - **SampleRate** *(integer) --* This value is always 48000. It represents the
                  sample rate in Hz.

                  - **SpeechThreshold** *(integer) --* Specify the percentage of audio content that
                  must be speech before the encoder uses the measured speech loudness as the overall
                  program loudness.

                  - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.

                  - **SurroundExMode** *(string) --* Specify whether your input audio has an
                  additional center rear surround channel matrix encoded into your left and right
                  surround channels.

                - **Eac3Settings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value EAC3.

                  - **AttenuationControl** *(string) --* If set to ATTENUATE_3_DB, applies a 3 dB
                  attenuation to the surround channels. Only used for 3/2 coding mode.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second. Valid
                  bitrates depend on the coding mode.

                  - **BitstreamMode** *(string) --* Specify the bitstream mode for the E-AC-3 stream
                  that the encoder emits. For more information about the EAC3 bitstream mode, see
                  ATSC A/52-2012 (Annex E).

                  - **CodingMode** *(string) --* Dolby Digital Plus coding mode. Determines number
                  of channels.

                  - **DcFilter** *(string) --* Activates a DC highpass filter for all input
                  channels.

                  - **Dialnorm** *(integer) --* Sets the dialnorm for the output. If blank and input
                  audio is Dolby Digital Plus, dialnorm will be passed through.

                  - **DynamicRangeCompressionLine** *(string) --* Specify the absolute peak level
                  for a signal with dynamic range compression.

                  - **DynamicRangeCompressionRf** *(string) --* Specify how the service limits the
                  audio dynamic range when compressing the audio.

                  - **LfeControl** *(string) --* When encoding 3/2 audio, controls whether the LFE
                  channel is enabled

                  - **LfeFilter** *(string) --* Applies a 120Hz lowpass filter to the LFE channel
                  prior to encoding. Only valid with 3_2_LFE coding mode.

                  - **LoRoCenterMixLevel** *(float) --* Specify a value for the following Dolby
                  Digital Plus setting: Left only/Right only center mix (Lo/Ro center). MediaConvert
                  uses this value for downmixing. How the service uses this value depends on the
                  value that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: 3.0,
                  1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This
                  setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                  (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                  different value for Coding mode, the service ignores Left only/Right only center
                  (loRoCenterMixLevel).

                  - **LoRoSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                  Digital Plus setting: Left only/Right only (Lo/Ro surround). MediaConvert uses
                  this value for downmixing. How the service uses this value depends on the value
                  that you choose for Stereo downmix (Eac3StereoDownmix). Valid values: -1.5, -3.0,
                  -4.5, -6.0, and -60. The value -60 mutes the channel. This setting applies only if
                  you keep the default value of 3/2 - L, R, C, Ls, Rs (CODING_MODE_3_2) for the
                  setting Coding mode (Eac3CodingMode). If you choose a different value for Coding
                  mode, the service ignores Left only/Right only surround (loRoSurroundMixLevel).

                  - **LtRtCenterMixLevel** *(float) --* Specify a value for the following Dolby
                  Digital Plus setting: Left total/Right total center mix (Lt/Rt center).
                  MediaConvert uses this value for downmixing. How the service uses this value
                  depends on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid
                  values: 3.0, 1.5, 0.0, -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the
                  channel. This setting applies only if you keep the default value of 3/2 - L, R, C,
                  Ls, Rs (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you
                  choose a different value for Coding mode, the service ignores Left total/Right
                  total center (ltRtCenterMixLevel).

                  - **LtRtSurroundMixLevel** *(float) --* Specify a value for the following Dolby
                  Digital Plus setting: Left total/Right total surround mix (Lt/Rt surround).
                  MediaConvert uses this value for downmixing. How the service uses this value
                  depends on the value that you choose for Stereo downmix (Eac3StereoDownmix). Valid
                  values: -1.5, -3.0, -4.5, -6.0, and -60. The value -60 mutes the channel. This
                  setting applies only if you keep the default value of 3/2 - L, R, C, Ls, Rs
                  (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                  different value for Coding mode, the service ignores Left total/Right total
                  surround (ltRtSurroundMixLevel).

                  - **MetadataControl** *(string) --* When set to FOLLOW_INPUT, encoder metadata
                  will be sourced from the DD, DD+, or DolbyE decoder that supplied this audio data.
                  If audio was not supplied from one of these streams, then the static metadata
                  settings will be used.

                  - **PassthroughControl** *(string) --* When set to WHEN_POSSIBLE, input DD+ audio
                  will be passed through if it is present on the input. this detection is dynamic
                  over the life of the transcode. Inputs that alternate between DD+ and non-DD+
                  content will have a consistent DD+ output as the system alternates between
                  passthrough and encoding.

                  - **PhaseControl** *(string) --* Controls the amount of phase-shift applied to the
                  surround channels. Only used for 3/2 coding mode.

                  - **SampleRate** *(integer) --* This value is always 48000. It represents the
                  sample rate in Hz.

                  - **StereoDownmix** *(string) --* Choose how the service does stereo downmixing.
                  This setting only applies if you keep the default value of 3/2 - L, R, C, Ls, Rs
                  (CODING_MODE_3_2) for the setting Coding mode (Eac3CodingMode). If you choose a
                  different value for Coding mode, the service ignores Stereo downmix
                  (Eac3StereoDownmix).

                  - **SurroundExMode** *(string) --* When encoding 3/2 audio, sets whether an extra
                  center back surround channel is matrix encoded into the left and right surround
                  channels.

                  - **SurroundMode** *(string) --* When encoding 2/0 audio, sets whether Dolby
                  Surround is matrix encoded into the two channels.

                - **Mp2Settings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value MP2.

                  - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.

                  - **Channels** *(integer) --* Set Channels to specify the number of channels in
                  this output audio track. Choosing Mono in the console will give you 1 output
                  channel; choosing Stereo will give you 2. In the API, valid values are 1 and 2.

                  - **SampleRate** *(integer) --* Sample rate in hz.

                - **WavSettings** *(dict) --* Required when you set (Codec) under
                (AudioDescriptions)>(CodecSettings) to the value WAV.

                  - **BitDepth** *(integer) --* Specify Bit depth (BitDepth), in bits per sample, to
                  choose the encoding quality for this audio track.

                  - **Channels** *(integer) --* Specify the number of channels in this output audio
                  track. Valid values are 1 and even numbers up to 64. For example, 1, 2, 4, 6, and
                  so on, up to 64.

                  - **Format** *(string) --* The service defaults to using RIFF for WAV outputs. If
                  your output audio is likely to exceed 4 GB in file size, or if you otherwise need
                  the extended support of the RF64 format, set your output WAV file format to RF64.

                  - **SampleRate** *(integer) --* Sample rate in Hz.

              - **CustomLanguageCode** *(string) --* Specify the language for this audio output
              track. The service puts this language code into your output audio track when you set
              Language code control (AudioLanguageCodeControl) to Use configured (USE_CONFIGURED).
              The service also uses your specified custom language code when you set Language code
              control (AudioLanguageCodeControl) to Follow input (FOLLOW_INPUT), but your input file
              doesn't specify a language code. For all outputs, you can use an ISO 639-2 or ISO
              639-3 code. For streaming outputs, you can also use any other code in the full
              RFC-5646 specification. Streaming outputs are those that are in one of the following
              output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

              - **LanguageCode** *(string) --* Indicates the language of the audio output track. The
              ISO 639 language specified in the 'Language Code' drop down will be used when 'Follow
              Input Language Code' is not selected or when 'Follow Input Language Code' is selected
              but there is no ISO 639 language code specified by the input.

              - **LanguageCodeControl** *(string) --* Specify which source for language code takes
              precedence for this audio track. When you choose Follow input (FOLLOW_INPUT), the
              service uses the language code from the input track if it's present. If there's no
              languge code on the input track, the service uses the code that you specify in the
              setting Language code (languageCode or customLanguageCode). When you choose Use
              configured (USE_CONFIGURED), the service uses the language code that you specify.

              - **RemixSettings** *(dict) --* Advanced audio remixing settings.

                - **ChannelMapping** *(dict) --* Channel mapping (ChannelMapping) contains the group
                of fields that hold the remixing value for each channel. Units are in dB. Acceptable
                values are within the range from -60 (mute) through 6. A setting of 0 passes the
                input channel unchanged to the output channel (no attenuation or amplification).

                  - **OutputChannels** *(list) --* List of output channels

                    - *(dict) --* OutputChannel mapping settings.

                      - **InputChannels** *(list) --* List of input channels

                        - *(integer) --*

                - **ChannelsIn** *(integer) --* Specify the number of audio channels from your input
                that you want to use in your output. With remixing, you might combine or split the
                data in these channels, so the number of channels in your final output might be
                different.

                - **ChannelsOut** *(integer) --* Specify the number of channels in this output after
                remixing. Valid values: 1, 2, 4, 6, 8... 64. (1 and even numbers to 64.)

              - **StreamName** *(string) --* Specify a label for this output audio stream. For
              example, "English", "Director commentary", or "track_2". For streaming outputs,
              MediaConvert passes this information into destination manifests for display on the
              end-viewer's player device. For outputs in other output groups, the service ignores
              this setting.

          - **CaptionDescriptions** *(list) --* Caption settings for this preset. There can be
          multiple caption settings in a single output.

            - *(dict) --* Caption Description for preset

              - **CustomLanguageCode** *(string) --* Specify the language for this captions output
              track. For most captions output formats, the encoder puts this language information in
              the output captions metadata. If your output captions format is DVB-Sub or Burn in,
              the encoder uses this language information when automatically selecting the font
              script for rendering the captions text. For all outputs, you can use an ISO 639-2 or
              ISO 639-3 code. For streaming outputs, you can also use any other code in the full
              RFC-5646 specification. Streaming outputs are those that are in one of the following
              output groups: CMAF, DASH ISO, Apple HLS, or Microsoft Smooth Streaming.

              - **DestinationSettings** *(dict) --* Specific settings required by destination type.
              Note that burnin_destination_settings are not available if the source of the caption
              data is Embedded or Teletext.

                - **BurninDestinationSettings** *(dict) --* Burn-In Destination Settings.

                  - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                  setting alignment to centered will place the captions at the bottom center of the
                  output. Similarly, setting a left alignment will align captions to the bottom left
                  of the output. If x and y positions are given in conjunction with the alignment
                  parameter, the font will be justified (either left or centered) relative to those
                  coordinates. This option is not valid for source captions that are STL,
                  608/embedded or teletext. These source settings are already pre-defined by the
                  caption stream. All burn-in and DVB-Sub font settings must match.

                  - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                  the captions. All burn-in and DVB-Sub font settings must match.

                  - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                  rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                  equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                  must match.

                  - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                  option is not valid for source captions that are STL, 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                  - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                  255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                  - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                  default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                  - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                  code, if the LanguageCode is not sufficient for determining the script type. Where
                  LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                  This is used to help determine the appropriate font for rendering burn-in
                  captions.

                  - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                  points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                  settings must match.

                  - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                  valid for source captions that are either 608/embedded or teletext. These source
                  settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
                  font settings must match.

                  - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                  option is not valid for source captions that are either 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                  - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                  captions. All burn-in and DVB-Sub font settings must match.

                  - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                  opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                  to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                  - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                  relative to the captions in pixels. A value of -2 would result in a shadow offset
                  2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                  - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                  relative to the captions in pixels. A value of -2 would result in a shadow offset
                  2 pixels above the text. All burn-in and DVB-Sub font settings must match.

                  - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                  Teletext or STL formats. Specify whether the spacing between letters in your
                  captions is set by the captions grid or varies depending on letter width. Choose
                  fixed grid to conform to the spacing specified in the captions file more
                  accurately. Choose proportional to make the text easier to read if the captions
                  are closed caption.

                  - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                  relative to the left side of the output in pixels. A value of 10 would result in
                  the captions starting 10 pixels from the left of the output. If no explicit
                  x_position is provided, the horizontal caption position will be determined by the
                  alignment parameter. This option is not valid for source captions that are STL,
                  608/embedded or teletext. These source settings are already pre-defined by the
                  caption stream. All burn-in and DVB-Sub font settings must match.

                  - **YPosition** *(integer) --* Specifies the vertical position of the caption
                  relative to the top of the output in pixels. A value of 10 would result in the
                  captions starting 10 pixels from the top of the output. If no explicit y_position
                  is provided, the caption will be positioned towards the bottom of the output. This
                  option is not valid for source captions that are STL, 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                - **DestinationType** *(string) --* Specify the format for this set of captions on
                this output. The default format is embedded without SCTE-20. Other options are
                embedded with SCTE-20, burn-in, DVB-sub, IMSC, SCC, SRT, teletext, TTML, and
                web-VTT. If you are using SCTE-20, choose SCTE-20 plus embedded
                (SCTE20_PLUS_EMBEDDED) to create an output that complies with the SCTE-43 spec. To
                create a non-compliant output where the embedded captions come first, choose
                Embedded plus SCTE-20 (EMBEDDED_PLUS_SCTE20).

                - **DvbSubDestinationSettings** *(dict) --* DVB-Sub Destination Settings

                  - **Alignment** *(string) --* If no explicit x_position or y_position is provided,
                  setting alignment to centered will place the captions at the bottom center of the
                  output. Similarly, setting a left alignment will align captions to the bottom left
                  of the output. If x and y positions are given in conjunction with the alignment
                  parameter, the font will be justified (either left or centered) relative to those
                  coordinates. This option is not valid for source captions that are STL,
                  608/embedded or teletext. These source settings are already pre-defined by the
                  caption stream. All burn-in and DVB-Sub font settings must match.

                  - **BackgroundColor** *(string) --* Specifies the color of the rectangle behind
                  the captions. All burn-in and DVB-Sub font settings must match.

                  - **BackgroundOpacity** *(integer) --* Specifies the opacity of the background
                  rectangle. 255 is opaque; 0 is transparent. Leaving this parameter blank is
                  equivalent to setting it to 0 (transparent). All burn-in and DVB-Sub font settings
                  must match.

                  - **FontColor** *(string) --* Specifies the color of the burned-in captions. This
                  option is not valid for source captions that are STL, 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                  - **FontOpacity** *(integer) --* Specifies the opacity of the burned-in captions.
                  255 is opaque; 0 is transparent. All burn-in and DVB-Sub font settings must match.

                  - **FontResolution** *(integer) --* Font resolution in DPI (dots per inch);
                  default is 96 dpi. All burn-in and DVB-Sub font settings must match.

                  - **FontScript** *(string) --* Provide the font script, using an ISO 15924 script
                  code, if the LanguageCode is not sufficient for determining the script type. Where
                  LanguageCode or CustomLanguageCode is sufficient, use "AUTOMATIC" or leave unset.
                  This is used to help determine the appropriate font for rendering DVB-Sub
                  captions.

                  - **FontSize** *(integer) --* A positive integer indicates the exact font size in
                  points. Set to 0 for automatic font size selection. All burn-in and DVB-Sub font
                  settings must match.

                  - **OutlineColor** *(string) --* Specifies font outline color. This option is not
                  valid for source captions that are either 608/embedded or teletext. These source
                  settings are already pre-defined by the caption stream. All burn-in and DVB-Sub
                  font settings must match.

                  - **OutlineSize** *(integer) --* Specifies font outline size in pixels. This
                  option is not valid for source captions that are either 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                  - **ShadowColor** *(string) --* Specifies the color of the shadow cast by the
                  captions. All burn-in and DVB-Sub font settings must match.

                  - **ShadowOpacity** *(integer) --* Specifies the opacity of the shadow. 255 is
                  opaque; 0 is transparent. Leaving this parameter blank is equivalent to setting it
                  to 0 (transparent). All burn-in and DVB-Sub font settings must match.

                  - **ShadowXOffset** *(integer) --* Specifies the horizontal offset of the shadow
                  relative to the captions in pixels. A value of -2 would result in a shadow offset
                  2 pixels to the left. All burn-in and DVB-Sub font settings must match.

                  - **ShadowYOffset** *(integer) --* Specifies the vertical offset of the shadow
                  relative to the captions in pixels. A value of -2 would result in a shadow offset
                  2 pixels above the text. All burn-in and DVB-Sub font settings must match.

                  - **SubtitlingType** *(string) --* Specify whether your DVB subtitles are standard
                  or for hearing impaired. Choose hearing impaired if your subtitles include audio
                  descriptions and dialogue. Choose standard if your subtitles include only
                  dialogue.

                  - **TeletextSpacing** *(string) --* Only applies to jobs with input captions in
                  Teletext or STL formats. Specify whether the spacing between letters in your
                  captions is set by the captions grid or varies depending on letter width. Choose
                  fixed grid to conform to the spacing specified in the captions file more
                  accurately. Choose proportional to make the text easier to read if the captions
                  are closed caption.

                  - **XPosition** *(integer) --* Specifies the horizontal position of the caption
                  relative to the left side of the output in pixels. A value of 10 would result in
                  the captions starting 10 pixels from the left of the output. If no explicit
                  x_position is provided, the horizontal caption position will be determined by the
                  alignment parameter. This option is not valid for source captions that are STL,
                  608/embedded or teletext. These source settings are already pre-defined by the
                  caption stream. All burn-in and DVB-Sub font settings must match.

                  - **YPosition** *(integer) --* Specifies the vertical position of the caption
                  relative to the top of the output in pixels. A value of 10 would result in the
                  captions starting 10 pixels from the top of the output. If no explicit y_position
                  is provided, the caption will be positioned towards the bottom of the output. This
                  option is not valid for source captions that are STL, 608/embedded or teletext.
                  These source settings are already pre-defined by the caption stream. All burn-in
                  and DVB-Sub font settings must match.

                - **EmbeddedDestinationSettings** *(dict) --* Settings specific to
                embedded/ancillary caption outputs, including 608/708 Channel destination number.

                  - **Destination608ChannelNumber** *(integer) --* Ignore this setting unless your
                  input captions are SCC format and your output captions are embedded in the video
                  stream. Specify a CC number for each captions channel in this output. If you have
                  two channels, choose CC numbers that aren't in the same field. For example, choose
                  1 and 3. For more information, see
                  https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                  - **Destination708ServiceNumber** *(integer) --* Ignore this setting unless your
                  input captions are SCC format and you want both 608 and 708 captions embedded in
                  your output stream. Optionally, specify the 708 service number for each output
                  captions channel. Choose a different number for each channel. To use this setting,
                  also set Force 608 to 708 upconvert (Convert608To708) to Upconvert (UPCONVERT) in
                  your input captions selector settings. If you choose to upconvert but don't
                  specify a 708 service number, MediaConvert uses the number that you specify for CC
                  channel number (destination608ChannelNumber) for the 708 service number. For more
                  information, see
                  https://docs.aws.amazon.com/console/mediaconvert/dual-scc-to-embedded.

                - **ImscDestinationSettings** *(dict) --* Settings specific to IMSC caption outputs.

                  - **StylePassthrough** *(string) --* Keep this setting enabled to have
                  MediaConvert use the font style and position information from the captions source
                  in the output. This option is available only when your input captions are CFF-TT,
                  IMSC, SMPTE-TT, or TTML. Disable this setting for simplified output captions.

                - **SccDestinationSettings** *(dict) --* Settings for SCC caption output.

                  - **Framerate** *(string) --* Set Framerate (SccDestinationFramerate) to make sure
                  that the captions and the video are synchronized in the output. Specify a frame
                  rate that matches the frame rate of the associated video. If the video frame rate
                  is 29.97, choose 29.97 dropframe (FRAMERATE_29_97_DROPFRAME) only if the video has
                  video_insertion=true and drop_frame_timecode=
                      true; otherwise, choose 29.97
                  non-dropframe (FRAMERATE_29_97_NON_DROPFRAME).

                - **TeletextDestinationSettings** *(dict) --* Settings for Teletext caption output

                  - **PageNumber** *(string) --* Set pageNumber to the Teletext page number for the
                  destination captions for this output. This value must be a three-digit hexadecimal
                  string; strings ending in -FF are invalid. If you are passing through the entire
                  set of Teletext data, do not use this field.

                  - **PageTypes** *(list) --* Specify the page types for this Teletext page. If you
                  don't specify a value here, the service sets the page type to the default value
                  Subtitle (PAGE_TYPE_SUBTITLE). If you pass through the entire set of Teletext
                  data, don't use this field. When you pass through a set of Teletext pages, your
                  output has the same page types as your input.

                    - *(string) --* A page type as defined in the standard ETSI EN 300 468, Table 94

                - **TtmlDestinationSettings** *(dict) --* Settings specific to TTML caption outputs,
                including Pass style information (TtmlStylePassthrough).

                  - **StylePassthrough** *(string) --* Pass through style and position information
                  from a TTML-like input source (TTML, SMPTE-TT, CFF-TT) to the CFF-TT output or
                  TTML output.

              - **LanguageCode** *(string) --* Specify the language of this captions output track.
              For most captions output formats, the encoder puts this language information in the
              output captions metadata. If your output captions format is DVB-Sub or Burn in, the
              encoder uses this language information to choose the font language for rendering the
              captions text.

              - **LanguageDescription** *(string) --* Specify a label for this set of output
              captions. For example, "English", "Director commentary", or "track_2". For streaming
              outputs, MediaConvert passes this information into destination manifests for display
              on the end-viewer's player device. For outputs in other output groups, the service
              ignores this setting.

          - **ContainerSettings** *(dict) --* Container specific settings.

            - **Container** *(string) --* Container for this output. Some containers require a
            container settings object. If not specified, the default object will be created.

            - **F4vSettings** *(dict) --* Settings for F4v container

              - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
              relocated to the beginning of the archive as required for progressive downloading.
              Otherwise it is placed normally at the end.

            - **M2tsSettings** *(dict) --* MPEG-2 TS container settings. These apply to outputs in a
            File output group when the output's container (ContainerType) is MPEG-2 Transport Stream
            (M2TS). In these assets, data is organized by the program map table (PMT). Each
            transport stream program contains subsets of data, including audio, video, and metadata.
            Each of these subsets of data has a numerical label called a packet identifier (PID).
            Each transport stream program corresponds to one MediaConvert output. The PMT lists the
            types of data in a program along with their PID. Downstream systems and players use the
            program map table to look up the PID for each type of data it accesses and then uses the
            PIDs to locate specific data within the asset.

              - **AudioBufferModel** *(string) --* Selects between the DVB and ATSC buffer models
              for Dolby Digital audio.

              - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
              PES packet.

              - **AudioPids** *(list) --* Specify the packet identifiers (PIDs) for any elementary
              audio streams you include in this output. Specify multiple PIDs as a JSON array.
              Default is the range 482-492.

                - *(integer) --*

              - **Bitrate** *(integer) --* Specify the output bitrate of the transport stream in
              bits per second. Setting to 0 lets the muxer automatically determine the appropriate
              bitrate. Other common values are 3750000, 7500000, and 15000000.

              - **BufferModel** *(string) --* Controls what buffer model to use for accurate
              interleaving. If set to MULTIPLEX, use multiplex buffer model. If set to NONE, this
              can lead to lower latency, but low-memory devices may not be able to play back the
              stream without interruptions.

              - **DvbNitSettings** *(dict) --* Inserts DVB Network Information Table (NIT) at the
              specified table repetition interval.

                - **NetworkId** *(integer) --* The numeric value placed in the Network Information
                Table (NIT).

                - **NetworkName** *(string) --* The network name text placed in the
                network_name_descriptor inside the Network Information Table. Maximum length is 256
                characters.

                - **NitInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

              - **DvbSdtSettings** *(dict) --* Inserts DVB Service Description Table (NIT) at the
              specified table repetition interval.

                - **OutputSdt** *(string) --* Selects method of inserting SDT information into
                output stream. "Follow input SDT" copies SDT information from input stream to output
                stream. "Follow input SDT if present" copies SDT information from input stream to
                output stream if SDT information is present in the input, otherwise it will fall
                back on the user-defined values. Enter "SDT Manually" means user will enter the SDT
                information. "No SDT" means output stream will not contain SDT information.

                - **SdtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

                - **ServiceName** *(string) --* The service name placed in the service_descriptor in
                the Service Description Table. Maximum length is 256 characters.

                - **ServiceProviderName** *(string) --* The service provider name placed in the
                service_descriptor in the Service Description Table. Maximum length is 256
                characters.

              - **DvbSubPids** *(list) --* Specify the packet identifiers (PIDs) for DVB subtitle
              data included in this output. Specify multiple PIDs as a JSON array. Default is the
              range 460-479.

                - *(integer) --*

              - **DvbTdtSettings** *(dict) --* Inserts DVB Time and Date Table (TDT) at the
              specified table repetition interval.

                - **TdtInterval** *(integer) --* The number of milliseconds between instances of
                this table in the output transport stream.

              - **DvbTeletextPid** *(integer) --* Specify the packet identifier (PID) for DVB
              teletext data you include in this output. Default is 499.

              - **EbpAudioInterval** *(string) --* When set to VIDEO_AND_FIXED_INTERVALS, audio EBP
              markers will be added to partitions 3 and 4. The interval between these additional
              markers will be fixed, and will be slightly shorter than the video EBP marker
              interval. When set to VIDEO_INTERVAL, these additional markers will not be inserted.
              Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
              EBP or EBP_LEGACY).

              - **EbpPlacement** *(string) --* Selects which PIDs to place EBP markers on. They can
              either be placed only on the video PID, or on both the video PID and all audio PIDs.
              Only applicable when EBP segmentation markers are is selected (segmentationMarkers is
              EBP or EBP_LEGACY).

              - **EsRateInPes** *(string) --* Controls whether to include the ES Rate field in the
              PES header.

              - **ForceTsVideoEbpOrder** *(string) --* Keep the default value (DEFAULT) unless you
              know that your audio EBP markers are incorrectly appearing before your video EBP
              markers. To correct this problem, set this value to Force (FORCE).

              - **FragmentTime** *(float) --* The length, in seconds, of each fragment. Only used
              with EBP markers.

              - **MaxPcrInterval** *(integer) --* Specify the maximum time, in milliseconds, between
              Program Clock References (PCRs) inserted into the transport stream.

              - **MinEbpInterval** *(integer) --* When set, enforces that Encoder Boundary Points do
              not come within the specified time interval of each other by looking ahead at input
              video. If another EBP is going to come in within the specified time interval, the
              current EBP is not emitted, and the segment is "stretched" to the next marker. The
              lookahead value does not add latency to the system. The Live Event must be configured
              elsewhere to create sufficient latency to make the lookahead accurate.

              - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
              will be detected in the input audio and an equivalent ID3 tag will be inserted in the
              output.

              - **NullPacketBitrate** *(float) --* Value in bits per second of extra null packets to
              insert into the transport stream. This can be used if a downstream encryption system
              requires periodic null packets.

              - **PatInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET, a Program Clock
              Reference value is inserted for every Packetized Elementary Stream (PES) header. This
              is effective only when the PCR PID is the same as the video or audio elementary
              stream.

              - **PcrPid** *(integer) --* Specify the packet identifier (PID) for the program clock
              reference (PCR) in this output. If you do not specify a value, the service will use
              the value for Video PID (VideoPid).

              - **PmtInterval** *(integer) --* Specify the number of milliseconds between instances
              of the program map table (PMT) in the output transport stream.

              - **PmtPid** *(integer) --* Specify the packet identifier (PID) for the program map
              table (PMT) itself. Default is 480.

              - **PrivateMetadataPid** *(integer) --* Specify the packet identifier (PID) of the
              private metadata stream. Default is 503.

              - **ProgramNumber** *(integer) --* Use Program number (programNumber) to specify the
              program number used in the program map table (PMT) for this output. Default is 1.
              Program numbers and program map tables are parts of MPEG-2 transport stream
              containers, used for organizing data.

              - **RateMode** *(string) --* When set to CBR, inserts null packets into transport
              stream to fill specified bitrate. When set to VBR, the bitrate setting acts as the
              maximum bitrate, but the output will not be padded up to that bitrate.

              - **Scte35Esam** *(dict) --* Include this in your job settings to put SCTE-35 markers
              in your HLS and transport stream outputs at the insertion points that you specify in
              an ESAM XML document. Provide the document in the setting SCC XML (sccXml).

                - **Scte35EsamPid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in
                the transport stream generated by ESAM.

              - **Scte35Pid** *(integer) --* Specify the packet identifier (PID) of the SCTE-35
              stream in the transport stream.

              - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
              Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
              also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
              this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE). Also
              provide the ESAM XML as a string in the setting Signal processing notification XML
              (sccXml). Also enable ESAM SCTE-35 (include the property scte35Esam).

              - **SegmentationMarkers** *(string) --* Inserts segmentation markers at each
              segmentation_time period. rai_segstart sets the Random Access Indicator bit in the
              adaptation field. rai_adapt sets the RAI bit and adds the current timecode in the
              private data bytes. psi_segstart inserts PAT and PMT tables at the start of segments.
              ebp adds Encoder Boundary Point information to the adaptation field as per OpenCable
              specification OC-SP-EBP-I01-130118. ebp_legacy adds Encoder Boundary Point information
              to the adaptation field using a legacy proprietary format.

              - **SegmentationStyle** *(string) --* The segmentation style parameter controls how
              segmentation markers are inserted into the transport stream. With avails, it is
              possible that segments may be truncated, which can influence where future segmentation
              markers are inserted. When a segmentation style of "reset_cadence" is selected and a
              segment is truncated due to an avail, we will reset the segmentation cadence. This
              means the subsequent segment will have a duration of of $segmentation_time seconds.
              When a segmentation style of "maintain_cadence" is selected and a segment is truncated
              due to an avail, we will not reset the segmentation cadence. This means the subsequent
              segment will likely be truncated as well. However, all segments after that will have a
              duration of $segmentation_time seconds. Note that EBP lookahead is a slight exception
              to this rule.

              - **SegmentationTime** *(float) --* Specify the length, in seconds, of each segment.
              Required unless markers is set to _none_.

              - **TimedMetadataPid** *(integer) --* Specify the packet identifier (PID) for timed
              metadata in this output. Default is 502.

              - **TransportStreamId** *(integer) --* Specify the ID for the transport stream itself
              in the program map table for this output. Transport stream IDs and program map tables
              are parts of MPEG-2 transport stream containers, used for organizing data.

              - **VideoPid** *(integer) --* Specify the packet identifier (PID) of the elementary
              video stream in the transport stream.

            - **M3u8Settings** *(dict) --* Settings for TS segments in HLS

              - **AudioFramesPerPes** *(integer) --* The number of audio frames to insert for each
              PES packet.

              - **AudioPids** *(list) --* Packet Identifier (PID) of the elementary audio stream(s)
              in the transport stream. Multiple values are accepted, and can be entered in ranges
              and/or by comma separation.

                - *(integer) --*

              - **NielsenId3** *(string) --* If INSERT, Nielsen inaudible tones for media tracking
              will be detected in the input audio and an equivalent ID3 tag will be inserted in the
              output.

              - **PatInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **PcrControl** *(string) --* When set to PCR_EVERY_PES_PACKET a Program Clock
              Reference value is inserted for every Packetized Elementary Stream (PES) header. This
              parameter is effective only when the PCR PID is the same as the video or audio
              elementary stream.

              - **PcrPid** *(integer) --* Packet Identifier (PID) of the Program Clock Reference
              (PCR) in the transport stream. When no value is given, the encoder will assign the
              same value as the Video PID.

              - **PmtInterval** *(integer) --* The number of milliseconds between instances of this
              table in the output transport stream.

              - **PmtPid** *(integer) --* Packet Identifier (PID) for the Program Map Table (PMT) in
              the transport stream.

              - **PrivateMetadataPid** *(integer) --* Packet Identifier (PID) of the private
              metadata stream in the transport stream.

              - **ProgramNumber** *(integer) --* The value of the program number field in the
              Program Map Table.

              - **Scte35Pid** *(integer) --* Packet Identifier (PID) of the SCTE-35 stream in the
              transport stream.

              - **Scte35Source** *(string) --* For SCTE-35 markers from your input-- Choose
              Passthrough (PASSTHROUGH) if you want SCTE-35 markers that appear in your input to
              also appear in this output. Choose None (NONE) if you don't want SCTE-35 markers in
              this output. For SCTE-35 markers from an ESAM XML document-- Choose None (NONE) if you
              don't want manifest conditioning. Choose Passthrough (PASSTHROUGH) and choose Ad
              markers (adMarkers) if you do want manifest conditioning. In both cases, also provide
              the ESAM XML as a string in the setting Signal processing notification XML (sccXml).

              - **TimedMetadata** *(string) --* Applies only to HLS outputs. Use this setting to
              specify whether the service inserts the ID3 timed metadata from the input in this
              output.

              - **TimedMetadataPid** *(integer) --* Packet Identifier (PID) of the timed metadata
              stream in the transport stream.

              - **TransportStreamId** *(integer) --* The value of the transport stream ID field in
              the Program Map Table.

              - **VideoPid** *(integer) --* Packet Identifier (PID) of the elementary video stream
              in the transport stream.

            - **MovSettings** *(dict) --* Settings for MOV Container.

              - **ClapAtom** *(string) --* When enabled, include 'clap' atom if appropriate for the
              video output settings.

              - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
              composition times in the 'ctts' (composition time to sample) box for B-frames will be
              negative, and a 'cslg' (composition shift least greatest) box will be included per
              14496-1 amendment 1. This improves compatibility with Apple players and tools.

              - **Mpeg2FourCCControl** *(string) --* When set to XDCAM, writes MPEG2 video streams
              into the QuickTime file using XDCAM fourcc codes. This increases compatibility with
              Apple editors and players, but may decrease compatibility with other players. Only
              applicable when the video codec is MPEG2.

              - **PaddingControl** *(string) --* If set to OMNEON, inserts Omneon-compatible padding

              - **Reference** *(string) --* Always keep the default value (SELF_CONTAINED) for this
              setting.

            - **Mp4Settings** *(dict) --* Settings for MP4 container. You can create audio-only AAC
            outputs with this container.

              - **CslgAtom** *(string) --* When enabled, file composition times will start at zero,
              composition times in the 'ctts' (composition time to sample) box for B-frames will be
              negative, and a 'cslg' (composition shift least greatest) box will be included per
              14496-1 amendment 1. This improves compatibility with Apple players and tools.

              - **FreeSpaceBox** *(string) --* Inserts a free-space box immediately after the moov
              box.

              - **MoovPlacement** *(string) --* If set to PROGRESSIVE_DOWNLOAD, the MOOV atom is
              relocated to the beginning of the archive as required for progressive downloading.
              Otherwise it is placed normally at the end.

              - **Mp4MajorBrand** *(string) --* Overrides the "Major Brand" field in the output
              file. Usually not necessary to specify.

            - **MpdSettings** *(dict) --* Settings for MP4 segments in DASH

              - **CaptionContainerType** *(string) --* Use this setting only in DASH output groups
              that include sidecar TTML or IMSC captions. You specify sidecar captions in a separate
              output from your audio and video. Choose Raw (RAW) for captions in a single XML file
              in a raw container. Choose Fragmented MPEG-4 (FRAGMENTED_MP4) for captions in XML
              format contained within fragmented MP4 files. This set of fragmented MP4 files is
              separate from your video and audio fragmented MP4 files.

              - **Scte35Esam** *(string) --* Use this setting only when you specify SCTE-35 markers
              from ESAM. Choose INSERT to put SCTE-35 markers in this output at the insertion points
              that you specify in an ESAM XML document. Provide the document in the setting SCC XML
              (sccXml).

              - **Scte35Source** *(string) --* Ignore this setting unless you have SCTE-35 markers
              in your input video file. Choose Passthrough (PASSTHROUGH) if you want SCTE-35 markers
              that appear in your input to also appear in this output. Choose None (NONE) if you
              don't want those SCTE-35 markers in this output.

          - **VideoDescription** *(dict) --* (VideoDescription) contains a group of video encoding
          settings. The specific video settings depend on the video codec that you choose when you
          specify a value for Video codec (codec). Include one instance of (VideoDescription) per
          output.

            - **AfdSignaling** *(string) --* This setting only applies to H.264, H.265, and MPEG2
            outputs. Use Insert AFD signaling (AfdSignaling) to specify whether the service includes
            AFD values in the output video data and what those values are. * Choose None to remove
            all AFD values from this output. * Choose Fixed to ignore input AFD values and instead
            encode the value specified in the job. * Choose Auto to calculate output AFD values
            based on the input AFD scaler data.

            - **AntiAlias** *(string) --* The anti-alias filter is automatically applied to all
            outputs. The service no longer accepts the value DISABLED for AntiAlias. If you specify
            that in your job, the service will ignore the setting.

            - **CodecSettings** *(dict) --* Video codec settings, (CodecSettings) under
            (VideoDescription), contains the group of settings related to video encoding. The
            settings in this group vary depending on the value that you choose for Video codec
            (Codec). For each codec enum that you choose, define the corresponding settings object.
            The following lists the codec enum, settings object pairs. * H_264, H264Settings *
            H_265, H265Settings * MPEG2, Mpeg2Settings * PRORES, ProresSettings * FRAME_CAPTURE,
            FrameCaptureSettings

              - **Codec** *(string) --* Specifies the video codec. This must be equal to one of the
              enum values defined by the object VideoCodec.

              - **FrameCaptureSettings** *(dict) --* Required when you set (Codec) under
              (VideoDescription)>(CodecSettings) to the value FRAME_CAPTURE.

                - **FramerateDenominator** *(integer) --* Frame capture will encode the first frame
                of the output stream, then one frame every framerateDenominator/framerateNumerator
                seconds. For example, settings of framerateNumerator =
                     1 and framerateDenominator =
                3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every
                3s. Files will be named as filename.n.jpg where n is the 0-based sequence number of
                each Capture.

                - **FramerateNumerator** *(integer) --* Frame capture will encode the first frame of
                the output stream, then one frame every framerateDenominator/framerateNumerator
                seconds. For example, settings of framerateNumerator =
                     1 and framerateDenominator =
                3 (a rate of 1/3 frame per second) will capture the first frame, then 1 frame every
                3s. Files will be named as filename.NNNNNNN.jpg where N is the 0-based frame
                sequence number zero padded to 7 decimal places.

                - **MaxCaptures** *(integer) --* Maximum number of captures (encoded jpg output
                files).

                - **Quality** *(integer) --* JPEG Quality - a higher value equals higher quality.

              - **H264Settings** *(dict) --* Required when you set (Codec) under
              (VideoDescription)>(CodecSettings) to the value H_264.

                - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                quantizers to vary to improve visual quality.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                rounded down to the nearest multiple of 1000.

                - **CodecLevel** *(string) --* Specify an H.264 level that is consistent with your
                output video settings. If you aren't sure what level to specify, choose Auto (AUTO).

                - **CodecProfile** *(string) --* H.264 Profile. High 4:2:2 and 10-bit profiles are
                only available with the AVC-I License.

                - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                quality for high-motion content. This will cause the service to use fewer B-frames
                (which infer information based on other frames) for high-motion portions of the
                video and more B-frames for low-motion portions. The maximum number of B-frames is
                limited by the value you provide for the setting B frames between reference frames
                (numberBFramesBetweenReferenceFrames).

                - **EntropyEncoding** *(string) --* Entropy encoding mode. Use CABAC (must be in
                Main or High profile) or CAVLC.

                - **FieldEncoding** *(string) --* Choosing FORCE_FIELD disables PAFF encoding for
                interlaced outputs.

                - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame to reduce flicker or 'pop' on I-frames.

                - **FramerateControl** *(string) --* If you are using the console, use the Framerate
                setting to specify the frame rate for this output. If you want to keep the same
                frame rate as the input video, choose Follow source. If you want to do frame rate
                conversion, choose a frame rate from the dropdown list or choose Custom. The
                framerates shown in the dropdown list are decimal approximations of fractions. If
                you choose Custom, specify your frame rate as a fraction. If you are creating your
                transcoding job specification as a JSON file without the console, use
                FramerateControl to specify which value the service uses for the frame rate for this
                output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
                from the input. Choose SPECIFIED if you want the service to use the frame rate you
                specify in the settings FramerateNumerator and FramerateDenominator.

                - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                smoother motion during frame rate conversion.

                - **FramerateDenominator** *(integer) --* When you use the API for transcode jobs
                that use frame rate conversion, specify the frame rate as a fraction. For example,
                24000 / 1001 =
                     23.976 fps. Use FramerateDenominator to specify the denominator of
                this fraction. In this example, use 1001 for the value of FramerateDenominator. When
                you use the console for transcode jobs that use frame rate conversion, provide the
                value as a decimal number for Framerate. In this example, specify 23.976.

                - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                fraction, e.g. 24000 / 1001 = 23.976 fps.

                - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                structures that have B frames > 1.

                - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                applications, it is recommended that this be set to 1 so a decoder joining
                mid-stream will receive an IDR frame as quickly as possible. Setting this value to 0
                will break output segmenting.

                - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
                be greater than zero.

                - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H264 is specified in
                frames or seconds. If seconds the system will convert the GOP Size into a frame
                count at run time.

                - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                should initially be filled (HRD buffer model).

                - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                example, enter five megabits as 5000000.

                - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
                (BOTTOM_FIELD) produce interlaced output with the entire output having the same
                field polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and
                Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the
                source. Therefore, behavior depends on the input scan type, as follows. - If the
                source is interlaced, the output will be interlaced with the same polarity as the
                source (it will follow the source). The output could therefore be a mix of "top
                field first" and "bottom field first". - If the source is progressive, the output
                will be interlaced with "top field first" or "bottom field first" polarity,
                depending on which of the Follow options you chose.

                - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                five megabits per second as 5000000. Required when Rate control mode is QVBR.

                - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame
                is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched
                to the scene change I-frame. GOP stretch requires enabling lookahead as well as
                setting I-interval. The normal cadence resumes for the next GOP. This setting is
                only used when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size
                + Min-I-interval - 1

                - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
                reference frames.

                - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                encoder may use more than requested if using B-frames and/or interlaced encoding.

                - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
                service to use the pixel aspect ratio from the input. Using the console, do this by
                choosing Follow source for Pixel aspect ratio.

                - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                - **QualityTuningLevel** *(string) --* Use Quality tuning level
                (H264QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                singlepass, or high-quality multipass video encoding.

                - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                encoding with the H.264 codec. Required when you set Rate control mode to QVBR. Not
                valid when you set Rate control mode to a value other than QVBR, or when you don't
                define Rate control mode.

                  - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                  mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                  values suited to the complexity of your input video, the service limits the
                  average bitrate of the video part of this output to the value that you choose.
                  That is, the total size of the video element is less than or equal to the value
                  you set multiplied by the number of seconds of encoded output.

                  - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                  mode. That is, when you specify qvbrSettings within h264Settings. Specify the
                  target quality level for this output, from 1 to 10. Use higher numbers for greater
                  quality. Level 10 results in nearly lossless compression. The quality level for
                  most broadcast-quality transcodes is between 6 and 9.

                - **RateControlMode** *(string) --* Use this setting to specify whether this output
                has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
                bitrate (QVBR).

                - **RepeatPps** *(string) --* Places a PPS header on each encoded picture, even if
                repeated.

                - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                scene changes that the service automatically detects. This improves video quality
                and is enabled by default. If this output uses QVBR, choose Transition detection
                (TRANSITION_DETECTION) for further video quality improvement. For more information
                about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
                to the number of macroblock rows for progressive pictures, and less than or equal to
                half the number of macroblock rows for interlaced pictures.

                - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                input is relabeled as 25fps, and audio is sped up correspondingly.

                - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                reduce high-frequency content in the encoded image.

                - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on spatial variation of content complexity.

                - **Syntax** *(string) --* Produces a bitstream compliant with SMPTE RP-2027.

                - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                Framerate (framerate) field is set to 29.970. This field works with the Streams >
                Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
                output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
                29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
                output to 29.97i.

                - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on temporal variation of content complexity.

                - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                bytes of an unregistered SEI message.

              - **H265Settings** *(dict) --* Settings for H265 codec

                - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                quantizers to vary to improve visual quality.

                - **AlternateTransferFunctionSei** *(string) --* Enables Alternate Transfer Function
                SEI message for outputs using Hybrid Log Gamma (HLG) Electro-Optical Transfer
                Function (EOTF).

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                rounded down to the nearest multiple of 1000.

                - **CodecLevel** *(string) --* H.265 Level.

                - **CodecProfile** *(string) --* Represents the Profile and Tier, per the HEVC
                (H.265) specification. Selections are grouped as [Profile] / [Tier], so "Main/High"
                represents Main Profile with High Tier. 4:2:2 profiles are only available with the
                HEVC 4:2:2 License.

                - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                quality for high-motion content. This will cause the service to use fewer B-frames
                (which infer information based on other frames) for high-motion portions of the
                video and more B-frames for low-motion portions. The maximum number of B-frames is
                limited by the value you provide for the setting B frames between reference frames
                (numberBFramesBetweenReferenceFrames).

                - **FlickerAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame to reduce flicker or 'pop' on I-frames.

                - **FramerateControl** *(string) --* If you are using the console, use the Framerate
                setting to specify the frame rate for this output. If you want to keep the same
                frame rate as the input video, choose Follow source. If you want to do frame rate
                conversion, choose a frame rate from the dropdown list or choose Custom. The
                framerates shown in the dropdown list are decimal approximations of fractions. If
                you choose Custom, specify your frame rate as a fraction. If you are creating your
                transcoding job sepecification as a JSON file without the console, use
                FramerateControl to specify which value the service uses for the frame rate for this
                output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
                from the input. Choose SPECIFIED if you want the service to use the frame rate you
                specify in the settings FramerateNumerator and FramerateDenominator.

                - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                smoother motion during frame rate conversion.

                - **FramerateDenominator** *(integer) --* Frame rate denominator.

                - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                fraction, e.g. 24000 / 1001 = 23.976 fps.

                - **GopBReference** *(string) --* If enable, use reference B frames for GOP
                structures that have B frames > 1.

                - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                applications, it is recommended that this be set to 1 so a decoder joining
                mid-stream will receive an IDR frame as quickly as possible. Setting this value to 0
                will break output segmenting.

                - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
                be greater than zero.

                - **GopSizeUnits** *(string) --* Indicates if the GOP Size in H265 is specified in
                frames or seconds. If seconds the system will convert the GOP Size into a frame
                count at run time.

                - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                should initially be filled (HRD buffer model).

                - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                example, enter five megabits as 5000000.

                - **InterlaceMode** *(string) --* Choose the scan line type for the output. Choose
                Progressive (PROGRESSIVE) to create a progressive output, regardless of the scan
                type of your input. Choose Top Field First (TOP_FIELD) or Bottom Field First
                (BOTTOM_FIELD) to create an output that's interlaced with the same field polarity
                throughout. Choose Follow, Default Top (FOLLOW_TOP_FIELD) or Follow, Default Bottom
                (FOLLOW_BOTTOM_FIELD) to create an interlaced output with the same field polarity as
                the source. If the source is interlaced, the output will be interlaced with the same
                polarity as the source (it will follow the source). The output could therefore be a
                mix of "top field first" and "bottom field first". If the source is progressive,
                your output will be interlaced with "top field first" or "bottom field first"
                polarity, depending on which of the Follow options you chose. If you don't choose a
                value, the service will default to Progressive (PROGRESSIVE).

                - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                five megabits per second as 5000000. Required when Rate control mode is QVBR.

                - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame
                is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched
                to the scene change I-frame. GOP stretch requires enabling lookahead as well as
                setting I-interval. The normal cadence resumes for the next GOP. This setting is
                only used when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size
                + Min-I-interval - 1

                - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
                reference frames.

                - **NumberReferenceFrames** *(integer) --* Number of reference frames to use. The
                encoder may use more than requested if using B-frames and/or interlaced encoding.

                - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
                service to use the pixel aspect ratio from the input. Using the console, do this by
                choosing Follow source for Pixel aspect ratio.

                - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                - **QualityTuningLevel** *(string) --* Use Quality tuning level
                (H265QualityTuningLevel) to specifiy whether to use fast single-pass, high-quality
                singlepass, or high-quality multipass video encoding.

                - **QvbrSettings** *(dict) --* Settings for quality-defined variable bitrate
                encoding with the H.265 codec. Required when you set Rate control mode to QVBR. Not
                valid when you set Rate control mode to a value other than QVBR, or when you don't
                define Rate control mode.

                  - **MaxAverageBitrate** *(integer) --* Use this setting only when Rate control
                  mode is QVBR and Quality tuning level is Multi-pass HQ. For Max average bitrate
                  values suited to the complexity of your input video, the service limits the
                  average bitrate of the video part of this output to the value that you choose.
                  That is, the total size of the video element is less than or equal to the value
                  you set multiplied by the number of seconds of encoded output.

                  - **QvbrQualityLevel** *(integer) --* Required when you use QVBR rate control
                  mode. That is, when you specify qvbrSettings within h265Settings. Specify the
                  target quality level for this output, from 1 to 10. Use higher numbers for greater
                  quality. Level 10 results in nearly lossless compression. The quality level for
                  most broadcast-quality transcodes is between 6 and 9.

                - **RateControlMode** *(string) --* Use this setting to specify whether this output
                has a variable bitrate (VBR), constant bitrate (CBR) or quality-defined variable
                bitrate (QVBR).

                - **SampleAdaptiveOffsetFilterMode** *(string) --* Specify Sample Adaptive Offset
                (SAO) filter strength. Adaptive mode dynamically selects best strength based on
                content

                - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                scene changes that the service automatically detects. This improves video quality
                and is enabled by default. If this output uses QVBR, choose Transition detection
                (TRANSITION_DETECTION) for further video quality improvement. For more information
                about QVBR, see https://docs.aws.amazon.com/console/mediaconvert/cbr-vbr-qvbr.

                - **Slices** *(integer) --* Number of slices per picture. Must be less than or equal
                to the number of macroblock rows for progressive pictures, and less than or equal to
                half the number of macroblock rows for interlaced pictures.

                - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                input is relabeled as 25fps, and audio is sped up correspondingly.

                - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on spatial variation of content complexity.

                - **Telecine** *(string) --* This field applies only if the Streams > Advanced >
                Framerate (framerate) field is set to 29.970. This field works with the Streams >
                Advanced > Preprocessors > Deinterlacer field (deinterlace_mode) and the Streams >
                Advanced > Interlaced Mode field (interlace_mode) to identify the scan type for the
                output: Progressive, Interlaced, Hard Telecine or Soft Telecine. - Hard: produces
                29.97i output from 23.976 input. - Soft: produces 23.976; the player converts this
                output to 29.97i.

                - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on temporal variation of content complexity.

                - **TemporalIds** *(string) --* Enables temporal layer identifiers in the encoded
                bitstream. Up to 3 layers are supported depending on GOP structure: I- and P-frames
                form one layer, reference B-frames can form a second layer and non-reference
                b-frames can form a third layer. Decoders can optionally decode only the lower
                temporal layers to generate a lower frame rate output. For example, given a
                bitstream with temporal IDs and with b-frames =
                     1 (i.e. IbPbPb display order), a
                decoder could decode all the frames for full frame rate output or only the I and P
                frames (lowest temporal layer) for a half frame rate output.

                - **Tiles** *(string) --* Enable use of tiles, allowing horizontal as well as
                vertical subdivision of the encoded pictures.

                - **UnregisteredSeiTimecode** *(string) --* Inserts timecode for each frame as 4
                bytes of an unregistered SEI message.

                - **WriteMp4PackagingType** *(string) --* If the location of parameter set NAL units
                doesn't matter in your workflow, ignore this setting. Use this setting only with
                CMAF or DASH outputs, or with standalone file outputs in an MPEG-4 container (MP4
                outputs). Choose HVC1 to mark your output as HVC1. This makes your output compliant
                with the following specification: ISO IECJTC1 SC29 N13798 Text ISO/IEC FDIS 14496-15
                3rd Edition. For these outputs, the service stores parameter set NAL units in the
                sample headers but not in the samples directly. For MP4 outputs, when you choose
                HVC1, your output video might not work properly with some downstream systems and
                video players. The service defaults to marking your output as HEV1. For these
                outputs, the service writes parameter set NAL units directly into the samples.

              - **Mpeg2Settings** *(dict) --* Required when you set (Codec) under
              (VideoDescription)>(CodecSettings) to the value MPEG2.

                - **AdaptiveQuantization** *(string) --* Adaptive quantization. Allows intra-frame
                quantizers to vary to improve visual quality.

                - **Bitrate** *(integer) --* Specify the average bitrate in bits per second.
                Required for VBR and CBR. For MS Smooth outputs, bitrates must be unique when
                rounded down to the nearest multiple of 1000.

                - **CodecLevel** *(string) --* Use Level (Mpeg2CodecLevel) to set the MPEG-2 level
                for the video output.

                - **CodecProfile** *(string) --* Use Profile (Mpeg2CodecProfile) to set the MPEG-2
                profile for the video output.

                - **DynamicSubGop** *(string) --* Choose Adaptive to improve subjective video
                quality for high-motion content. This will cause the service to use fewer B-frames
                (which infer information based on other frames) for high-motion portions of the
                video and more B-frames for low-motion portions. The maximum number of B-frames is
                limited by the value you provide for the setting B frames between reference frames
                (numberBFramesBetweenReferenceFrames).

                - **FramerateControl** *(string) --* If you are using the console, use the Framerate
                setting to specify the frame rate for this output. If you want to keep the same
                frame rate as the input video, choose Follow source. If you want to do frame rate
                conversion, choose a frame rate from the dropdown list or choose Custom. The
                framerates shown in the dropdown list are decimal approximations of fractions. If
                you choose Custom, specify your frame rate as a fraction. If you are creating your
                transcoding job sepecification as a JSON file without the console, use
                FramerateControl to specify which value the service uses for the frame rate for this
                output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
                from the input. Choose SPECIFIED if you want the service to use the frame rate you
                specify in the settings FramerateNumerator and FramerateDenominator.

                - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                smoother motion during frame rate conversion.

                - **FramerateDenominator** *(integer) --* Frame rate denominator.

                - **FramerateNumerator** *(integer) --* Frame rate numerator - frame rate is a
                fraction, e.g. 24000 / 1001 = 23.976 fps.

                - **GopClosedCadence** *(integer) --* Frequency of closed GOPs. In streaming
                applications, it is recommended that this be set to 1 so a decoder joining
                mid-stream will receive an IDR frame as quickly as possible. Setting this value to 0
                will break output segmenting.

                - **GopSize** *(float) --* GOP Length (keyframe interval) in frames or seconds. Must
                be greater than zero.

                - **GopSizeUnits** *(string) --* Indicates if the GOP Size in MPEG2 is specified in
                frames or seconds. If seconds the system will convert the GOP Size into a frame
                count at run time.

                - **HrdBufferInitialFillPercentage** *(integer) --* Percentage of the buffer that
                should initially be filled (HRD buffer model).

                - **HrdBufferSize** *(integer) --* Size of buffer (HRD buffer model) in bits. For
                example, enter five megabits as 5000000.

                - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
                (BOTTOM_FIELD) produce interlaced output with the entire output having the same
                field polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and
                Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the
                source. Therefore, behavior depends on the input scan type. - If the source is
                interlaced, the output will be interlaced with the same polarity as the source (it
                will follow the source). The output could therefore be a mix of "top field first"
                and "bottom field first". - If the source is progressive, the output will be
                interlaced with "top field first" or "bottom field first" polarity, depending on
                which of the Follow options you chose.

                - **IntraDcPrecision** *(string) --* Use Intra DC precision (Mpeg2IntraDcPrecision)
                to set quantization precision for intra-block DC coefficients. If you choose the
                value auto, the service will automatically select the precision based on the
                per-frame compression ratio.

                - **MaxBitrate** *(integer) --* Maximum bitrate in bits/second. For example, enter
                five megabits per second as 5000000.

                - **MinIInterval** *(integer) --* Enforces separation between repeated (cadence)
                I-frames and I-frames inserted by Scene Change Detection. If a scene change I-frame
                is within I-interval frames of a cadence I-frame, the GOP is shrunk and/or stretched
                to the scene change I-frame. GOP stretch requires enabling lookahead as well as
                setting I-interval. The normal cadence resumes for the next GOP. This setting is
                only used when Scene Change Detect is enabled. Note: Maximum GOP stretch = GOP size
                + Min-I-interval - 1

                - **NumberBFramesBetweenReferenceFrames** *(integer) --* Number of B-frames between
                reference frames.

                - **ParControl** *(string) --* Using the API, enable ParFollowSource if you want the
                service to use the pixel aspect ratio from the input. Using the console, do this by
                choosing Follow source for Pixel aspect ratio.

                - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                - **QualityTuningLevel** *(string) --* Use Quality tuning level
                (Mpeg2QualityTuningLevel) to specifiy whether to use single-pass or multipass video
                encoding.

                - **RateControlMode** *(string) --* Use Rate control mode (Mpeg2RateControlMode) to
                specifiy whether the bitrate is variable (vbr) or constant (cbr).

                - **SceneChangeDetect** *(string) --* Enable this setting to insert I-frames at
                scene changes that the service automatically detects. This improves video quality
                and is enabled by default.

                - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                input is relabeled as 25fps, and audio is sped up correspondingly.

                - **Softness** *(integer) --* Softness. Selects quantizer matrix, larger values
                reduce high-frequency content in the encoded image.

                - **SpatialAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on spatial variation of content complexity.

                - **Syntax** *(string) --* Produces a Type D-10 compatible bitstream (SMPTE
                356M-2001).

                - **Telecine** *(string) --* Only use Telecine (Mpeg2Telecine) when you set
                Framerate (Framerate) to 29.970. Set Telecine (Mpeg2Telecine) to Hard (hard) to
                produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976
                output and leave converstion to the player.

                - **TemporalAdaptiveQuantization** *(string) --* Adjust quantization within each
                frame based on temporal variation of content complexity.

              - **ProresSettings** *(dict) --* Required when you set (Codec) under
              (VideoDescription)>(CodecSettings) to the value PRORES.

                - **CodecProfile** *(string) --* Use Profile (ProResCodecProfile) to specifiy the
                type of Apple ProRes codec to use for this output.

                - **FramerateControl** *(string) --* If you are using the console, use the Framerate
                setting to specify the frame rate for this output. If you want to keep the same
                frame rate as the input video, choose Follow source. If you want to do frame rate
                conversion, choose a frame rate from the dropdown list or choose Custom. The
                framerates shown in the dropdown list are decimal approximations of fractions. If
                you choose Custom, specify your frame rate as a fraction. If you are creating your
                transcoding job sepecification as a JSON file without the console, use
                FramerateControl to specify which value the service uses for the frame rate for this
                output. Choose INITIALIZE_FROM_SOURCE if you want the service to use the frame rate
                from the input. Choose SPECIFIED if you want the service to use the frame rate you
                specify in the settings FramerateNumerator and FramerateDenominator.

                - **FramerateConversionAlgorithm** *(string) --* When set to INTERPOLATE, produces
                smoother motion during frame rate conversion.

                - **FramerateDenominator** *(integer) --* Frame rate denominator.

                - **FramerateNumerator** *(integer) --* When you use the API for transcode jobs that
                use frame rate conversion, specify the frame rate as a fraction. For example, 24000
                / 1001 =
                     23.976 fps. Use FramerateNumerator to specify the numerator of this
                fraction. In this example, use 24000 for the value of FramerateNumerator.

                - **InterlaceMode** *(string) --* Use Interlace mode (InterlaceMode) to choose the
                scan line type for the output. * Top Field First (TOP_FIELD) and Bottom Field First
                (BOTTOM_FIELD) produce interlaced output with the entire output having the same
                field polarity (top or bottom first). * Follow, Default Top (FOLLOW_TOP_FIELD) and
                Follow, Default Bottom (FOLLOW_BOTTOM_FIELD) use the same field polarity as the
                source. Therefore, behavior depends on the input scan type. - If the source is
                interlaced, the output will be interlaced with the same polarity as the source (it
                will follow the source). The output could therefore be a mix of "top field first"
                and "bottom field first". - If the source is progressive, the output will be
                interlaced with "top field first" or "bottom field first" polarity, depending on
                which of the Follow options you chose.

                - **ParControl** *(string) --* Use (ProresParControl) to specify how the service
                determines the pixel aspect ratio. Set to Follow source (INITIALIZE_FROM_SOURCE) to
                use the pixel aspect ratio from the input. To specify a different pixel aspect
                ratio: Using the console, choose it from the dropdown menu. Using the API, set
                ProresParControl to (SPECIFIED) and provide for (ParNumerator) and (ParDenominator).

                - **ParDenominator** *(integer) --* Pixel Aspect Ratio denominator.

                - **ParNumerator** *(integer) --* Pixel Aspect Ratio numerator.

                - **SlowPal** *(string) --* Enables Slow PAL rate conversion. 23.976fps and 24fps
                input is relabeled as 25fps, and audio is sped up correspondingly.

                - **Telecine** *(string) --* Only use Telecine (ProresTelecine) when you set
                Framerate (Framerate) to 29.970. Set Telecine (ProresTelecine) to Hard (hard) to
                produce a 29.97i output from a 23.976 input. Set it to Soft (soft) to produce 23.976
                output and leave converstion to the player.

            - **ColorMetadata** *(string) --* Choose Insert (INSERT) for this setting to include
            color metadata in this output. Choose Ignore (IGNORE) to exclude color metadata from
            this output. If you don't specify a value, the service sets this to Insert by default.

            - **Crop** *(dict) --* Use Cropping selection (crop) to specify the video area that the
            service will include in the output video frame.

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **DropFrameTimecode** *(string) --* Applies only to 29.97 fps outputs. When this
            feature is enabled, the service will use drop-frame timecode on outputs. If it is not
            possible to use drop-frame timecode, the system will fall back to non-drop-frame. This
            setting is enabled by default when Timecode insertion (TimecodeInsertion) is enabled.

            - **FixedAfd** *(integer) --* Applies only if you set AFD Signaling(AfdSignaling) to
            Fixed (FIXED). Use Fixed (FixedAfd) to specify a four-bit AFD value which the service
            will write on all frames of this video output.

            - **Height** *(integer) --* Use the Height (Height) setting to define the video
            resolution height for this output. Specify in pixels. If you don't provide a value here,
            the service will use the input height.

            - **Position** *(dict) --* Use Selection placement (position) to define the video area
            in your output frame. The area outside of the rectangle that you specify here is black.

              - **Height** *(integer) --* Height of rectangle in pixels. Specify only even numbers.

              - **Width** *(integer) --* Width of rectangle in pixels. Specify only even numbers.

              - **X** *(integer) --* The distance, in pixels, between the rectangle and the left
              edge of the video frame. Specify only even numbers.

              - **Y** *(integer) --* The distance, in pixels, between the rectangle and the top edge
              of the video frame. Specify only even numbers.

            - **RespondToAfd** *(string) --* Use Respond to AFD (RespondToAfd) to specify how the
            service changes the video itself in response to AFD values in the input. * Choose
            Respond to clip the input video frame according to the AFD value, input display aspect
            ratio, and output display aspect ratio. * Choose Passthrough to include the input AFD
            values. Do not choose this when AfdSignaling is set to (NONE). A preferred
            implementation of this workflow is to set RespondToAfd to (NONE) and set AfdSignaling to
            (AUTO). * Choose None to remove all input AFD values from this output.

            - **ScalingBehavior** *(string) --* Specify how the service handles outputs that have a
            different aspect ratio from the input aspect ratio. Choose Stretch to output
            (STRETCH_TO_OUTPUT) to have the service stretch your video image to fit. Keep the
            setting Default (DEFAULT) to have the service letterbox your video instead. This setting
            overrides any value that you specify for the setting Selection placement (position) in
            this output.

            - **Sharpness** *(integer) --* Use Sharpness (Sharpness) setting to specify the strength
            of anti-aliasing. This setting changes the width of the anti-alias filter kernel used
            for scaling. Sharpness only applies if your output resolution is different from your
            input resolution. 0 is the softest setting, 100 the sharpest, and 50 recommended for
            most content.

            - **TimecodeInsertion** *(string) --* Applies only to H.264, H.265, MPEG2, and ProRes
            outputs. Only enable Timecode insertion when the input frame rate is identical to the
            output frame rate. To include timecodes in this output, set Timecode insertion
            (VideoTimecodeInsertion) to PIC_TIMING_SEI. To leave them out, set it to DISABLED.
            Default is DISABLED. When the service inserts timecodes in an output, by default, it
            uses any embedded timecodes from the input. If none are present, the service will set
            the timecode for the first output frame to zero. To change this default behavior, adjust
            the settings under Timecode configuration (TimecodeConfig). In the console, these
            settings are located under Job > Job settings > Timecode configuration. Note - Timecode
            source under input settings (InputTimecodeSource) does not affect the timecodes that are
            inserted in the output. Source under Job settings > Timecode configuration
            (TimecodeSource) does.

            - **VideoPreprocessors** *(dict) --* Find additional transcoding features under
            Preprocessors (VideoPreprocessors). Enable the features at each output individually.
            These features are disabled by default.

              - **ColorCorrector** *(dict) --* Enable the Color corrector (ColorCorrector) feature
              if necessary. Enable or disable this feature for each output individually. This
              setting is disabled by default.

                - **Brightness** *(integer) --* Brightness level.

                - **ColorSpaceConversion** *(string) --* Specify the color space you want for this
                output. The service supports conversion between HDR formats, between SDR formats,
                and from SDR to HDR. The service doesn't support conversion from HDR to SDR. SDR to
                HDR conversion doesn't upgrade the dynamic range. The converted video has an HDR
                format, but visually appears the same as an unconverted output.

                - **Contrast** *(integer) --* Contrast level.

                - **Hdr10Metadata** *(dict) --* Use these settings when you convert to the HDR 10
                color space. Specify the SMPTE ST 2086 Mastering Display Color Volume static
                metadata that you want signaled in the output. These values don't affect the pixel
                values that are encoded in the video stream. They are intended to help the
                downstream video player display content in a way that reflects the intentions of the
                the content creator. When you set Color space conversion (ColorSpaceConversion) to
                HDR 10 (FORCE_HDR10), these settings are required. You must set values for Max frame
                average light level (maxFrameAverageLightLevel) and Max content light level
                (maxContentLightLevel); these settings don't have a default value. The default
                values for the other HDR 10 metadata settings are defined by the P3D65 color space.
                For more information about MediaConvert HDR jobs, see
                https://docs.aws.amazon.com/console/mediaconvert/hdr.

                  - **BluePrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **BluePrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **GreenPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **MaxContentLightLevel** *(integer) --* Maximum light level among all samples in
                  the coded video sequence, in units of candelas per square meter. This setting
                  doesn't have a default value; you must specify a value that is suitable for the
                  content.

                  - **MaxFrameAverageLightLevel** *(integer) --* Maximum average light level of any
                  frame in the coded video sequence, in units of candelas per square meter. This
                  setting doesn't have a default value; you must specify a value that is suitable
                  for the content.

                  - **MaxLuminance** *(integer) --* Nominal maximum mastering display luminance in
                  units of of 0.0001 candelas per square meter.

                  - **MinLuminance** *(integer) --* Nominal minimum mastering display luminance in
                  units of of 0.0001 candelas per square meter

                  - **RedPrimaryX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **RedPrimaryY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointX** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                  - **WhitePointY** *(integer) --* HDR Master Display Information must be provided
                  by a color grader, using color grading tools. Range is 0 to 50,000, each increment
                  represents 0.00002 in CIE1931 color coordinate. Note that this setting is not for
                  color correction.

                - **Hue** *(integer) --* Hue in degrees.

                - **Saturation** *(integer) --* Saturation level.

              - **Deinterlacer** *(dict) --* Use Deinterlacer (Deinterlacer) to produce smoother
              motion and a clearer picture.

                - **Algorithm** *(string) --* Only applies when you set Deinterlacer
                (DeinterlaceMode) to Deinterlace (DEINTERLACE) or Adaptive (ADAPTIVE). Motion
                adaptive interpolate (INTERPOLATE) produces sharper pictures, while blend (BLEND)
                produces smoother motion. Use (INTERPOLATE_TICKER) OR (BLEND_TICKER) if your source
                file includes a ticker, such as a scrolling headline at the bottom of the frame.

                - **Control** *(string) --* - When set to NORMAL (default), the deinterlacer does
                not convert frames that are tagged in metadata as progressive. It will only convert
                those that are tagged as some other type. - When set to FORCE_ALL_FRAMES, the
                deinterlacer converts every frame to progressive - even those that are already
                tagged as progressive. Turn Force mode on only if there is a good chance that the
                metadata has tagged frames as progressive when they are not progressive. Do not turn
                on otherwise; processing frames that are already progressive into progressive will
                probably result in lower quality video.

                - **Mode** *(string) --* Use Deinterlacer (DeinterlaceMode) to choose how the
                service will do deinterlacing. Default is Deinterlace. - Deinterlace converts
                interlaced to progressive. - Inverse telecine converts Hard Telecine 29.97i to
                progressive 23.976p. - Adaptive auto-detects and converts to progressive.

              - **DolbyVision** *(dict) --* Enable Dolby Vision feature to produce Dolby Vision
              compatible video output.

                - **L6Metadata** *(dict) --* Use these settings when you set DolbyVisionLevel6Mode
                to SPECIFY to override the MaxCLL and MaxFALL values in your input with new values.

                  - **MaxCll** *(integer) --* Maximum Content Light Level. Static HDR metadata that
                  corresponds to the brightest pixel in the entire stream. Measured in nits.

                  - **MaxFall** *(integer) --* Maximum Frame-Average Light Level. Static HDR
                  metadata that corresponds to the highest frame-average brightness in the entire
                  stream. Measured in nits.

                - **L6Mode** *(string) --* Use Dolby Vision Mode to choose how the service will
                handle Dolby Vision MaxCLL and MaxFALL properies.

                - **Profile** *(string) --* In the current MediaConvert implementation, the Dolby
                Vision profile is always 5 (PROFILE_5). Therefore, all of your inputs must contain
                Dolby Vision frame interleaved data.

              - **ImageInserter** *(dict) --* Enable the Image inserter (ImageInserter) feature to
              include a graphic overlay on your video. Enable or disable this feature for each
              output individually. This setting is disabled by default.

                - **InsertableImages** *(list) --* Specify the images that you want to overlay on
                your video. The images must be PNG or TGA files.

                  - *(dict) --* Settings that specify how your still graphic overlay appears.

                    - **Duration** *(integer) --* Specify the time, in milliseconds, for the image
                    to remain on the output video. This duration includes fade-in time but not
                    fade-out time.

                    - **FadeIn** *(integer) --* Specify the length of time, in milliseconds, between
                    the Start time that you specify for the image insertion and the time that the
                    image appears at full opacity. Full opacity is the level that you specify for
                    the opacity setting. If you don't specify a value for Fade-in, the image will
                    appear abruptly at the overlay start time.

                    - **FadeOut** *(integer) --* Specify the length of time, in milliseconds,
                    between the end of the time that you have specified for the image overlay
                    Duration and when the overlaid image has faded to total transparency. If you
                    don't specify a value for Fade-out, the image will disappear abruptly at the end
                    of the inserted image duration.

                    - **Height** *(integer) --* Specify the height of the inserted image in pixels.
                    If you specify a value that's larger than the video resolution height, the
                    service will crop your overlaid image to fit. To use the native height of the
                    image, keep this setting blank.

                    - **ImageInserterInput** *(string) --* Specify the HTTP, HTTPS, or Amazon S3
                    location of the image that you want to overlay on the video. Use a PNG or TGA
                    file.

                    - **ImageX** *(integer) --* Specify the distance, in pixels, between the
                    inserted image and the left edge of the video frame. Required for any image
                    overlay that you specify.

                    - **ImageY** *(integer) --* Specify the distance, in pixels, between the
                    overlaid image and the top edge of the video frame. Required for any image
                    overlay that you specify.

                    - **Layer** *(integer) --* Specify how overlapping inserted images appear.
                    Images with higher values for Layer appear on top of images with lower values
                    for Layer.

                    - **Opacity** *(integer) --* Use Opacity (Opacity) to specify how much of the
                    underlying video shows through the inserted image. 0 is transparent and 100 is
                    fully opaque. Default is 50.

                    - **StartTime** *(string) --* Specify the timecode of the frame that you want
                    the overlay to first appear on. This must be in timecode (HH:MM:SS:FF or
                    HH:MM:SS;FF) format. Remember to take into account your timecode source
                    settings.

                    - **Width** *(integer) --* Specify the width of the inserted image in pixels. If
                    you specify a value that's larger than the video resolution width, the service
                    will crop your overlaid image to fit. To use the native width of the image, keep
                    this setting blank.

              - **NoiseReducer** *(dict) --* Enable the Noise reducer (NoiseReducer) feature to
              remove noise from your video output if necessary. Enable or disable this feature for
              each output individually. This setting is disabled by default.

                - **Filter** *(string) --* Use Noise reducer filter (NoiseReducerFilter) to select
                one of the following spatial image filtering functions. To use this setting, you
                must also enable Noise reducer (NoiseReducer). * Bilateral preserves edges while
                reducing noise. * Mean (softest), Gaussian, Lanczos, and Sharpen (sharpest) do
                convolution filtering. * Conserve does min/max noise reduction. * Spatial does
                frequency-domain filtering based on JND principles. * Temporal optimizes video
                quality for complex motion.

                - **FilterSettings** *(dict) --* Settings for a noise reducer filter

                  - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                  values produce stronger filtering.

                - **SpatialFilterSettings** *(dict) --* Noise reducer filter settings for spatial
                filter.

                  - **PostFilterSharpenStrength** *(integer) --* Specify strength of post noise
                  reduction sharpening filter, with 0 disabling the filter and 3 enabling it at
                  maximum strength.

                  - **Speed** *(integer) --* The speed of the filter, from -2 (lower speed) to 3
                  (higher speed), with 0 being the nominal value.

                  - **Strength** *(integer) --* Relative strength of noise reducing filter. Higher
                  values produce stronger filtering.

                - **TemporalFilterSettings** *(dict) --* Noise reducer filter settings for temporal
                filter.

                  - **AggressiveMode** *(integer) --* Use Aggressive mode for content that has
                  complex motion. Higher values produce stronger temporal filtering. This filters
                  highly complex scenes more aggressively and creates better VQ for low bitrate
                  outputs.

                  - **Speed** *(integer) --* The speed of the filter (higher number is faster). Low
                  setting reduces bit rate at the cost of transcode time, high setting improves
                  transcode time at the cost of bit rate.

                  - **Strength** *(integer) --* Specify the strength of the noise reducing filter on
                  this output. Higher values produce stronger filtering. We recommend the following
                  value ranges, depending on the result that you want: * 0-2 for complexity
                  reduction with minimal sharpness loss * 2-8 for complexity reduction with image
                  preservation * 8-16 for a high level of complexity reduction

              - **TimecodeBurnin** *(dict) --* Timecode burn-in (TimecodeBurnIn)--Burns the output
              timecode and specified prefix into the output.

                - **FontSize** *(integer) --* Use Font Size (FontSize) to set the font size of any
                burned-in timecode. Valid values are 10, 16, 32, 48.

                - **Position** *(string) --* Use Position (Position) under under Timecode burn-in
                (TimecodeBurnIn) to specify the location the burned-in timecode on output video.

                - **Prefix** *(string) --* Use Prefix (Prefix) to place ASCII characters before any
                burned-in timecode. For example, a prefix of "EZ-" will result in the timecode
                "EZ-00:00:00:00". Provide either the characters themselves or the ASCII code
                equivalents. The supported range of characters is 0x20 through 0x7e. This includes
                letters, numbers, and all special characters represented on a standard English
                keyboard.

            - **Width** *(integer) --* Use Width (Width) to define the video resolution width, in
            pixels, for this output. If you don't provide a value here, the service will use the
            input width.

        - **Type** *(string) --* A preset can be of two types: system or custom. System or built-in
        preset can't be modified or deleted by the user.
    """


_ListQueuesPaginatePaginationConfigTypeDef = TypedDict(
    "_ListQueuesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListQueuesPaginatePaginationConfigTypeDef(_ListQueuesPaginatePaginationConfigTypeDef):
    """
    Type definition for `ListQueuesPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_ListQueuesPaginateResponseQueuesReservationPlanTypeDef = TypedDict(
    "_ListQueuesPaginateResponseQueuesReservationPlanTypeDef",
    {
        "Commitment": str,
        "ExpiresAt": datetime,
        "PurchasedAt": datetime,
        "RenewalType": str,
        "ReservedSlots": int,
        "Status": str,
    },
    total=False,
)


class ListQueuesPaginateResponseQueuesReservationPlanTypeDef(
    _ListQueuesPaginateResponseQueuesReservationPlanTypeDef
):
    """
    Type definition for `ListQueuesPaginateResponseQueues` `ReservationPlan`

    - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
    commitment.

    - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing plan
    term for this reserved queue expires.

    - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the current
    pricing plan for this reserved queue.

    - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing plan
    is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

    - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS) for
    this queue. The number of RTS determines how many jobs the queue can process in parallel; each
    RTS can process one job at a time. When you increase this number, you extend your existing
    commitment with a new 12-month commitment for a larger number of RTS. The new commitment begins
    when you purchase the additional capacity. You can't decrease the number of RTS in your reserved
    queue.

    - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is ACTIVE
    or EXPIRED.
    """


_ListQueuesPaginateResponseQueuesTypeDef = TypedDict(
    "_ListQueuesPaginateResponseQueuesTypeDef",
    {
        "Arn": str,
        "CreatedAt": datetime,
        "Description": str,
        "LastUpdated": datetime,
        "Name": str,
        "PricingPlan": str,
        "ProgressingJobsCount": int,
        "ReservationPlan": ListQueuesPaginateResponseQueuesReservationPlanTypeDef,
        "Status": str,
        "SubmittedJobsCount": int,
        "Type": str,
    },
    total=False,
)


class ListQueuesPaginateResponseQueuesTypeDef(_ListQueuesPaginateResponseQueuesTypeDef):
    """
    Type definition for `ListQueuesPaginateResponse` `Queues`

    - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

    - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for when you created the queue.

    - **Description** *(string) --* An optional description that you create for each queue.

    - **LastUpdated** *(datetime) --* The timestamp in epoch seconds for when you most recently
    updated the queue.

    - **Name** *(string) --* A name that you create for each queue. Each name must be unique within
    your account.

    - **PricingPlan** *(string) --* Specifies whether the pricing plan for the queue is on-demand or
    reserved. For on-demand, you pay per minute, billed in increments of .01 minute. For reserved,
    you pay for the transcoding capacity of the entire queue, regardless of how much or how little
    you use it. Reserved pricing requires a 12-month commitment.

    - **ProgressingJobsCount** *(integer) --* The estimated number of jobs with a PROGRESSING
    status.

    - **ReservationPlan** *(dict) --* Details about the pricing plan for your reserved queue.
    Required for reserved queues and not applicable to on-demand queues.

      - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
      commitment.

      - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current pricing
      plan term for this reserved queue expires.

      - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the
      current pricing plan for this reserved queue.

      - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing plan
      is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

      - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS) for
      this queue. The number of RTS determines how many jobs the queue can process in parallel; each
      RTS can process one job at a time. When you increase this number, you extend your existing
      commitment with a new 12-month commitment for a larger number of RTS. The new commitment
      begins when you purchase the additional capacity. You can't decrease the number of RTS in your
      reserved queue.

      - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is
      ACTIVE or EXPIRED.

    - **Status** *(string) --* Queues can be ACTIVE or PAUSED. If you pause a queue, the service
    won't begin processing jobs in that queue. Jobs that are running when you pause the queue
    continue to run until they finish or result in an error.

    - **SubmittedJobsCount** *(integer) --* The estimated number of jobs with a SUBMITTED status.

    - **Type** *(string) --* Specifies whether this on-demand queue is system or custom. System
    queues are built in. You can't modify or delete system queues. You can create and modify custom
    queues.
    """


_ListQueuesPaginateResponseTypeDef = TypedDict(
    "_ListQueuesPaginateResponseTypeDef",
    {"Queues": List[ListQueuesPaginateResponseQueuesTypeDef]},
    total=False,
)


class ListQueuesPaginateResponseTypeDef(_ListQueuesPaginateResponseTypeDef):
    """
    Type definition for `ListQueuesPaginate` `Response`

    - **Queues** *(list) --* List of queues.

      - *(dict) --* You can use queues to manage the resources that are available to your AWS
      account for running multiple transcoding jobs at the same time. If you don't specify a queue,
      the service sends all jobs through the default queue. For more information, see
      https://docs.aws.amazon.com/mediaconvert/latest/ug/working-with-queues.html.

        - **Arn** *(string) --* An identifier for this resource that is unique within all of AWS.

        - **CreatedAt** *(datetime) --* The timestamp in epoch seconds for when you created the
        queue.

        - **Description** *(string) --* An optional description that you create for each queue.

        - **LastUpdated** *(datetime) --* The timestamp in epoch seconds for when you most recently
        updated the queue.

        - **Name** *(string) --* A name that you create for each queue. Each name must be unique
        within your account.

        - **PricingPlan** *(string) --* Specifies whether the pricing plan for the queue is
        on-demand or reserved. For on-demand, you pay per minute, billed in increments of .01
        minute. For reserved, you pay for the transcoding capacity of the entire queue, regardless
        of how much or how little you use it. Reserved pricing requires a 12-month commitment.

        - **ProgressingJobsCount** *(integer) --* The estimated number of jobs with a PROGRESSING
        status.

        - **ReservationPlan** *(dict) --* Details about the pricing plan for your reserved queue.
        Required for reserved queues and not applicable to on-demand queues.

          - **Commitment** *(string) --* The length of the term of your reserved queue pricing plan
          commitment.

          - **ExpiresAt** *(datetime) --* The timestamp in epoch seconds for when the current
          pricing plan term for this reserved queue expires.

          - **PurchasedAt** *(datetime) --* The timestamp in epoch seconds for when you set up the
          current pricing plan for this reserved queue.

          - **RenewalType** *(string) --* Specifies whether the term of your reserved queue pricing
          plan is automatically extended (AUTO_RENEW) or expires (EXPIRE) at the end of the term.

          - **ReservedSlots** *(integer) --* Specifies the number of reserved transcode slots (RTS)
          for this queue. The number of RTS determines how many jobs the queue can process in
          parallel; each RTS can process one job at a time. When you increase this number, you
          extend your existing commitment with a new 12-month commitment for a larger number of RTS.
          The new commitment begins when you purchase the additional capacity. You can't decrease
          the number of RTS in your reserved queue.

          - **Status** *(string) --* Specifies whether the pricing plan for your reserved queue is
          ACTIVE or EXPIRED.

        - **Status** *(string) --* Queues can be ACTIVE or PAUSED. If you pause a queue, the service
        won't begin processing jobs in that queue. Jobs that are running when you pause the queue
        continue to run until they finish or result in an error.

        - **SubmittedJobsCount** *(integer) --* The estimated number of jobs with a SUBMITTED
        status.

        - **Type** *(string) --* Specifies whether this on-demand queue is system or custom. System
        queues are built in. You can't modify or delete system queues. You can create and modify
        custom queues.
    """
